define(["exports"], function (_exports) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.debounce = debounce;
  var timeouts = new Map();
  /**
   * Debounces a callback.
   * @param cb
   * @param ms
   * @param id
   */

  function debounce(cb, ms, id) {
    // Clear current timeout for id
    var timeout = timeouts.get(id);

    if (timeout != null) {
      window.clearTimeout(timeout);
    } // Set new timeout


    timeouts.set(id, window.setTimeout(function () {
      cb();
      timeouts.delete(id);
    }, ms));
  }
});