define(["exports", "require", "../../../lit-element/lit-element.js", "../../simple-icon/lib/simple-icon-lite.js", "../../simple-icon/lib/simple-icons.js"], function (_exports, _require, _litElement, _simpleIconLite, _simpleIcons) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.A11yMediaButton = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function _templateObject4_8e432020625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        #button {\n          margin: 0;\n          border: none;\n        }\n        .sr-only {\n          position: absolute;\n          left: -99999;\n          top: 0;\n          height: 0;\n          width: 0;\n          overflow: hidden;\n        }\n        simple-tooltip {\n          z-index: 100;\n        }\n        simple-tooltip:not(:defined) {\n          display: none;\n        }\n      "]);

    _templateObject4_8e432020625811eb9a9521b3fdb3953c = function _templateObject4_8e432020625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject3_8e432020625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          margin: 0;\n          padding: 0;\n        }\n        #button {\n          margin: 0;\n          padding: 8px;\n          line-height: 1;\n          border: none;\n          transition: color 0.25s;\n          color: var(--a11y-media-button-color);\n          background-color: var(--a11y-media-button-bg-color);\n        }\n        :host([toggle]) #button {\n          color: var(--a11y-media-button-toggle-color);\n          background-color: var(--a11y-media-button-toggle-bg-color);\n        }\n        :host([toggle]:active) #button,\n        :host([toggle]:focus) #button,\n        :host([toggle]:hover) #button,\n        :host(:active) #button,\n        :host(:focus) #button,\n        :host(:hover) #button {\n          color: var(--a11y-media-button-hover-color);\n          background-color: var(--a11y-media-button-hover-bg-color);\n        }\n        :host([disabled]) #button {\n          color: var(--a11y-media-button-disabled-color);\n          cursor: not-allowed;\n        }\n        .sr-only {\n          position: absolute;\n          left: -99999;\n          top: 0;\n          height: 0;\n          width: 0;\n          overflow: hidden;\n        }\n        simple-tooltip {\n          z-index: 100;\n        }\n        simple-tooltip:not(:defined) {\n          display: none;\n        }\n        simple-icon-lite {\n          display: inline-block;\n        }\n      "]);

    _templateObject3_8e432020625811eb9a9521b3fdb3953c = function _templateObject3_8e432020625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject2_8e432020625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n            <simple-tooltip for=\"button\" position=\"", "\"\n              >", "</simple-tooltip\n            >\n          "]);

    _templateObject2_8e432020625811eb9a9521b3fdb3953c = function _templateObject2_8e432020625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject_8e432020625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <button\n        id=\"button\"\n        aria-label=\"", "\"\n        aria-pressed=\"", "\"\n        controls=\"", "\"\n        tabindex=\"0\"\n        @click=\"", "\"\n        ?disabled=\"", "\"\n        ?toggle=\"", "\"\n      >\n        <simple-icon-lite icon=\"", "\"></simple-icon-lite>\n      </button>\n      ", "\n    "]);

    _templateObject_8e432020625811eb9a9521b3fdb3953c = function _templateObject_8e432020625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   * `a11y-media-button`
   * a button used in a11y-media-controls and a11y-media-transcript-controls.
   *
   * @element a11y-media-button
   */
  var A11yMediaButton = /*#__PURE__*/function (_LitElement) {
    babelHelpers.inherits(A11yMediaButton, _LitElement);

    var _super = _createSuper(A11yMediaButton);

    babelHelpers.createClass(A11yMediaButton, null, [{
      key: "properties",
      // properties available to the custom element for data binding
      get: function get() {
        return {
          accentColor: {
            attribute: "accent-color",
            type: String
          },
          dark: {
            type: Boolean
          },

          /**
           * is button action to send as an event
           */
          action: {
            attribute: "action",
            reflect: true,
            type: String
          },

          /*
           * id of element button controls
           */
          controls: {
            attribute: "controls",
            reflect: true,
            type: String
          },

          /*
           * simple-icon type
           */
          icon: {
            attribute: "icon",
            type: String
          },

          /*
           * button label
           */
          label: {
            attribute: "label",
            type: String
          },

          /*
           * Is it toggled on?
           */
          toggle: {
            attribute: "toggle",
            type: Boolean,
            reflect: true
          },

          /*
           * Is it disabled?
           */
          disabled: {
            attribute: "disabled",
            type: Boolean
          },

          /*
           * Is it disabled?
           */
          tooltipPosition: {
            attribute: "tooltip-position",
            type: String
          }
        };
      }
      /**
       * Store the tag name to make it easier to obtain directly.
        */

    }, {
      key: "tag",
      get: function get() {
        return "a11y-media-button";
      } //inherit styles from a11y-media-player or a11y-media-transcript

    }]);

    function A11yMediaButton() {
      var _this;

      babelHelpers.classCallCheck(this, A11yMediaButton);
      _this = _super.call(this);
      _this.accentColor = "red";
      _this.dark = false;
      _this.controls = "video";
      _this.disabled = false;
      _this.toggle = false;
      _this.tooltipPosition = "bottom";
      new Promise(function (res, rej) {
        return _require.default(["../../simple-tooltip/simple-tooltip.js"], res, rej);
      });
      return _this;
    }

    babelHelpers.createClass(A11yMediaButton, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject_8e432020625811eb9a9521b3fdb3953c(), this.label, this.toggle ? "true" : "false", this.controls, this._buttonClick, this.disabled, this.toggle, this.icon, this.label ? (0, _litElement.html)(_templateObject2_8e432020625811eb9a9521b3fdb3953c(), this.tooltipPosition, this.label) : "");
      }
      /**
       * lets player know this button was clicked
       */

    }, {
      key: "_buttonClick",
      value: function _buttonClick(e) {
        /**
         * Fires when button is clicked
         * @event click-details
         */
        this.dispatchEvent(new CustomEvent("button-click", {
          detail: this
        }));
      }
    }], [{
      key: "styles",
      get: function get() {
        return [this.buttonStyles, (0, _litElement.css)(_templateObject3_8e432020625811eb9a9521b3fdb3953c())];
      }
    }, {
      key: "buttonStyles",
      get: function get() {
        return [(0, _litElement.css)(_templateObject4_8e432020625811eb9a9521b3fdb3953c())];
      }
    }]);
    return A11yMediaButton;
  }(_litElement.LitElement);

  _exports.A11yMediaButton = A11yMediaButton;
  window.customElements.define(A11yMediaButton.tag, A11yMediaButton);
});