define(["exports", "../../../@polymer/polymer/polymer-element.js", "../../../@polymer/polymer/lib/utils/flattened-nodes-observer.js", "../../../@polymer/polymer/lib/utils/async.js", "../../utils/utils.js", "../../../@polymer/iron-ajax/iron-ajax.js", "../../../@polymer/paper-spinner/paper-spinner.js"], function (_exports, _polymerElement, _flattenedNodesObserver, _async, _utils, _ironAjax, _paperSpinner) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.CMSViews = void 0;

  function _templateObject_8edcef20625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style>\n        :host {\n          display: block;\n          min-width: 112px;\n          min-height: 112px;\n          transition: 0.6s all ease;\n          background-color: transparent;\n        }\n        paper-spinner {\n          visibility: hidden;\n          opacity: 0;\n          height: 80px;\n          width: 80px;\n          padding: 16px;\n        }\n        #replacementcontent {\n          visibility: visible;\n          opacity: 1;\n        }\n        :host([loading]) {\n          text-align: center;\n        }\n        :host([loading]) paper-spinner {\n          visibility: visible;\n          opacity: 1;\n        }\n        :host([loading]) #replacementcontent {\n          opacity: 0;\n          visibility: hidden;\n        }\n      </style>\n      <iron-ajax\n        id=\"viewsrequest\"\n        method=\"GET\"\n        params=\"[[bodyData]]\"\n        url=\"[[viewsEndPoint]]\"\n        handle-as=\"json\"\n        last-response=\"{{viewsData}}\"\n      ></iron-ajax>\n      <paper-spinner active=\"[[loading]]\"></paper-spinner>\n      <span id=\"replacementcontent\"><slot></slot></span>\n    "]);

    _templateObject_8edcef20625811eb9a9521b3fdb3953c = function _templateObject_8edcef20625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   * `cms-views`
   * @element cms-views
   * `Render and process a  / views from a content management system.`
   */
  var CMSViews = /*#__PURE__*/function (_PolymerElement) {
    babelHelpers.inherits(CMSViews, _PolymerElement);

    var _super = _createSuper(CMSViews);

    function CMSViews() {
      babelHelpers.classCallCheck(this, CMSViews);
      return _super.apply(this, arguments);
    }

    babelHelpers.createClass(CMSViews, [{
      key: "_generateBodyData",

      /**
       * Generate body data.
       */
      value: function _generateBodyData(name, display) {
        if (name !== null && name !== "") {
          return {
            name: "".concat(name),
            display: "".concat(display)
          };
        }
      }
      /**
       * Handle the response from the views processing endpoint
       */

    }, {
      key: "_handleviewsResponse",
      value: function _handleviewsResponse(newValue, oldValue) {
        var _this = this;

        if (newValue !== null && babelHelpers.typeof(newValue.content) !== (typeof undefined === "undefined" ? "undefined" : babelHelpers.typeof(undefined))) {
          // store the text and url callbacks
          if (document.getElementById("cmstokenidtolockonto") != null) {
            document.getElementById("cmstokenidtolockonto").setAttribute("href", newValue.editEndpoint);
            document.getElementById("cmstokenidtolockonto").innerHTML = newValue.editText;
          } // wipe our own slot here


          (0, _utils.wipeSlot)(this); // now inject the content we got

          _async.microTask.run(function () {
            var frag = document.createElement("span");
            frag.innerHTML = newValue.content;
            var newNode = frag.cloneNode(true);

            _this.appendChild(newNode);

            setTimeout(function () {
              _this.loading = false;

              if (window.WCAutoload) {
                window.WCAutoload.process();
              }
            }, 600);
          });
        }
      }
      /**
       * views end point changed
       */

    }, {
      key: "_viewsChanged",
      value: function _viewsChanged(newValue, oldValue) {
        var _this2 = this;

        // ensure we have something and are not loading currently
        if (babelHelpers.typeof(newValue) !== (typeof undefined === "undefined" ? "undefined" : babelHelpers.typeof(undefined)) && newValue !== "" && !this.loading) {
          // support going from a null element to a real one
          if (babelHelpers.typeof(this.viewsEndPoint) === (typeof undefined === "undefined" ? "undefined" : babelHelpers.typeof(undefined)) && babelHelpers.typeof(window.cmsviewsEndPoint) !== (typeof undefined === "undefined" ? "undefined" : babelHelpers.typeof(undefined))) {
            this.viewsEndPoint = window.cmsviewsEndPoint;
          }

          if (this.viewsEndPoint) {
            this.loading = true;

            _async.microTask.run(function () {
              _this2.shadowRoot.querySelector("#viewsrequest").generateRequest();
            });
          }
        }
      }
      /**
       * Attached to the DOM, now fire.
       */

    }, {
      key: "connectedCallback",
      value: function connectedCallback() {
        var _this3 = this;

        babelHelpers.get(babelHelpers.getPrototypeOf(CMSViews.prototype), "connectedCallback", this).call(this);

        if (babelHelpers.typeof(this.viewsName) !== (typeof undefined === "undefined" ? "undefined" : babelHelpers.typeof(undefined)) && this.viewsName !== null && this.viewsName !== "") {
          var slot = _flattenedNodesObserver.FlattenedNodesObserver.getFlattenedNodes(this); // only kick off request if there's nothing in it
          // if it has something in it that means we did some
          // remote rendering ahead of time


          if (slot.length === 0 && !this.loading) {
            // support for autoloading the views data needed for the request from globals
            if (babelHelpers.typeof(this.viewsEndPoint) === (typeof undefined === "undefined" ? "undefined" : babelHelpers.typeof(undefined)) && babelHelpers.typeof(window.cmsviewsEndPoint) !== (typeof undefined === "undefined" ? "undefined" : babelHelpers.typeof(undefined))) {
              this.viewsEndPoint = window.cmsviewsEndPoint;
            }

            if (this.viewsEndPoint) {
              this.loading = true;

              _async.microTask.run(function () {
                _this3.shadowRoot.querySelector("#viewsrequest").generateRequest();
              });
            }
          }
        }
      }
    }, {
      key: "postProcessgetHaxJSONSchema",

      /**
       * Implements getHaxJSONSchema post processing callback.
       */
      value: function postProcessgetHaxJSONSchema(schema) {
        schema.properties["__editThis"] = {
          type: "string",
          component: {
            name: "a",
            properties: {
              id: "cmstokenidtolockonto",
              href: "",
              target: "_blank"
            },
            slot: "Edit this view"
          }
        };
        return schema;
      }
    }], [{
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_8edcef20625811eb9a9521b3fdb3953c());
      }
    }, {
      key: "tag",
      get: function get() {
        return "cms-views";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * Loading state
           */
          loading: {
            type: Boolean,
            reflectToAttribute: true,
            value: false
          },

          /**
           * Name of the views to render
           */
          viewsName: {
            type: String,
            reflectToAttribute: true
          },

          /**
           * Display from the views
           */
          viewsDisplay: {
            type: String,
            reflectToAttribute: true
          },

          /**
           * views end point updated, change the way we do processing.
           */
          viewsEndPoint: {
            type: String
          },

          /**
           * Body data which is just views with some encapsulation.
           */
          bodyData: {
            type: Object,
            computed: "_generateBodyData(viewsName, viewsDisplay)",
            observer: "_viewsChanged"
          },

          /**
           * views data from the end point.
           */
          viewsData: {
            type: String,
            observer: "_handleviewsResponse"
          },

          /**
           * Prefix for the views to be processed
           */
          viewsPrefix: {
            type: String,
            observer: "["
          },

          /**
           * Suffix for the views to be processed
           */
          viewsSuffix: {
            type: String,
            observer: "]"
          }
        };
      }
    }, {
      key: "haxProperties",
      get: function get() {
        return {
          canScale: true,
          canPosition: true,
          canEditSource: true,
          gizmo: {
            title: "CMS View",
            description: "CMS views rendered on the backend",
            icon: "icons:view-module",
            color: "light-blue",
            groups: ["CMS"],
            handles: [{
              type: "cmsviews",
              views: "views"
            }],
            meta: {
              author: "ELMS:LN"
            }
          },
          settings: {
            configure: [{
              property: "viewsName",
              title: "Name",
              description: "Name of the view from our CMS",
              inputMethod: "textfield",
              icon: "editor:title"
            }, {
              property: "viewsDisplay",
              title: "Display",
              description: "Display within that view from our CMS",
              inputMethod: "textfield",
              icon: "editor:title"
            }],
            advanced: []
          },
          saveOptions: {
            wipeSlot: true,
            unsetAttributes: ["loading", "views-data", "body-data", "views-end-point"]
          }
        };
      }
    }]);
    return CMSViews;
  }(_polymerElement.PolymerElement);

  _exports.CMSViews = CMSViews;
  window.customElements.define(CMSViews.tag, CMSViews);
});