define(["../../../lit-element/lit-element.js", "../../haxcms-elements/lib/core/haxcms-site-store.js", "../../../mobx/dist/mobx.esm.js"], function (_litElement, _haxcmsSiteStore, _mobxEsm) {
  "use strict";

  function _templateObject4_8efc36f0625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n          width: 100%;\n          position: relative;\n          overflow: hidden;\n        }\n        #edit {\n          display: inline-block;\n          position: absolute;\n          left: 0;\n          top: 0;\n          transform: translateY(-100%);\n          transition: transform 0.2s ease-in-out;\n          background: #2196f3;\n          color: white;\n          text-decoration: none;\n          text-transform: uppercase;\n          padding: 0.5em 1em;\n        }\n        #container:focus #edit,\n        #container:hover #edit {\n          transform: translateY(0);\n        }\n      "]);

    _templateObject4_8efc36f0625811eb9a9521b3fdb3953c = function _templateObject4_8efc36f0625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject3_8efc36f0625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["<div id=\"container\">\n      <slot></slot>\n    </div>"]);

    _templateObject3_8efc36f0625811eb9a9521b3fdb3953c = function _templateObject3_8efc36f0625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject2_8efc36f0625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["<a\n                id=\"edit\"\n                target=\"_blank\"\n                rel=\"noopener noreferrer\"\n                href=\"", "\"\n                >edit</a\n              >"]);

    _templateObject2_8efc36f0625811eb9a9521b3fdb3953c = function _templateObject2_8efc36f0625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject_8efc36f0625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        <div id=\"container\">\n          ", "\n          <slot></slot>\n        </div>\n      "]);

    _templateObject_8efc36f0625811eb9a9521b3fdb3953c = function _templateObject_8efc36f0625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  var LrnH5p = /*#__PURE__*/function (_LitElement) {
    babelHelpers.inherits(LrnH5p, _LitElement);

    var _super = _createSuper(LrnH5p);

    babelHelpers.createClass(LrnH5p, null, [{
      key: "properties",
      get: function get() {
        return {
          _editing: {
            type: Boolean
          }
        };
      }
    }]);

    function LrnH5p() {
      var _this;

      babelHelpers.classCallCheck(this, LrnH5p);
      _this = _super.call(this);
      _this._editing = false;
      _this._disposer = (0, _mobxEsm.autorun)(function () {
        _this._editing = (0, _mobxEsm.toJS)(_haxcmsSiteStore.store.editMode);
      }); // remove script tags and work against light dom if there

      if (_this.querySelector("span")) {
        _this.querySelector("span").childNodes.forEach(function (el, index) {
          if (el.nodeName === "#text" && el.textContent.includes("<script>")) {
            el.remove();
          }
        });
      }

      return _this;
    }

    babelHelpers.createClass(LrnH5p, [{
      key: "render",
      value: function render() {
        if (this.querySelector("iframe")) {
          var matches = /(https?:\/\/[^\/]*).*embed\/([0-9]*)/g.exec(this.querySelector("iframe").src);
          var editUrl = "".concat(matches[1], "/node/").concat(matches[2], "/edit");
          return (0, _litElement.html)(_templateObject_8efc36f0625811eb9a9521b3fdb3953c(), this._editing ? (0, _litElement.html)(_templateObject2_8efc36f0625811eb9a9521b3fdb3953c(), editUrl) : "");
        }

        return (0, _litElement.html)(_templateObject3_8efc36f0625811eb9a9521b3fdb3953c());
      }
      /**
       * Implements getHaxJSONSchema post processing callback.
       */

    }, {
      key: "postProcessgetHaxJSONSchema",
      value: function postProcessgetHaxJSONSchema(schema) {
        var href = "";
        var slot = "Edit"; // if we have values populate them

        if (babelHelpers.typeof(this.tokenData) !== (typeof undefined === "undefined" ? "undefined" : babelHelpers.typeof(undefined))) {
          href = this.tokenData.editEndpoint;
          slot = this.tokenData.editText;

          for (var i in this.tokenData.schema) {
            schema.properties[i] = this.tokenData.schema[i];
          }
        }

        schema.properties["__editThis"] = {
          type: "string",
          component: {
            name: "a",
            properties: {
              id: "cmstokenidtolockonto",
              href: href,
              target: "_blank"
            },
            slot: slot
          }
        };
        return schema;
      }
    }], [{
      key: "tag",
      get: function get() {
        return "lrn-h5p";
      }
    }, {
      key: "haxProperties",
      get: function get() {
        return {
          canScale: false,
          canPosition: true,
          canEditSource: true,
          gizmo: {
            title: "H5P Element",
            description: "LRN H5P",
            icon: "editor:format-quote",
            color: "blue",
            meta: {
              author: "LRNWebComponents"
            }
          },
          settings: {
            configure: [{
              slot: "",
              title: "Text",
              description: "Content of the sidenote",
              inputMethod: "code-editor",
              required: true
            }],
            advanced: []
          }
        };
      }
    }, {
      key: "styles",
      get: function get() {
        return [(0, _litElement.css)(_templateObject4_8efc36f0625811eb9a9521b3fdb3953c())];
      }
    }]);
    return LrnH5p;
  }(_litElement.LitElement);

  customElements.define(LrnH5p.tag, LrnH5p);
});