define(["exports", "../../../@polymer/polymer/polymer-element.js", "../../../@polymer/app-localize-behavior/app-localize-behavior.js", "../../../@polymer/polymer/lib/legacy/class.js", "../../utils/utils.js", "../../../@polymer/marked-element/marked-element.js"], function (_exports, _polymerElement, _appLocalizeBehavior, _class, _utils, _markedElement) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.EcoJsonSchemaMarkup = void 0;

  function _templateObject_8f28c530625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style include=\"iron-flex iron-flex-alignment\">\n        :host {\n          color: var(--eco-json-form-color);\n          background-color: var(--eco-json-form-bg);\n          font-family: var(--eco-json-form-font-family);\n        }\n        :host ([hidden]) {\n          display: none;\n        }\n      </style>\n      <div class=\"markup\">\n        <slot></slot>\n      </div>\n    "]);

    _templateObject_8f28c530625811eb9a9521b3fdb3953c = function _templateObject_8f28c530625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
  `eco-json-schema-tabs` takes in a JSON schema of type array and builds a form,
  exposing a `value` property that represents an array described by the schema.
  
  Please see the `eco-json-schema-object` documentation for further information.
  
  @group eco Elements
  @element eco-json-schema-tabs
  * @demo demo/index.html
  */
  var EcoJsonSchemaMarkup = /*#__PURE__*/function (_mixinBehaviors) {
    babelHelpers.inherits(EcoJsonSchemaMarkup, _mixinBehaviors);

    var _super = _createSuper(EcoJsonSchemaMarkup);

    function EcoJsonSchemaMarkup() {
      babelHelpers.classCallCheck(this, EcoJsonSchemaMarkup);
      return _super.apply(this, arguments);
    }

    babelHelpers.createClass(EcoJsonSchemaMarkup, [{
      key: "_valueChanged",

      /**
       * render the markup requested
       */
      value: function _valueChanged(newValue) {
        // clear self
        (0, _utils.wipeSlot)(this); // sanity check to ditch scripts

        var html = (0, _utils.encapScript)(newValue);
        var frag = document.createRange().createContextualFragment(html); // self apend to flow into slot and show up

        this.appendChild(frag);
      }
    }], [{
      key: "tag",
      get: function get() {
        return "eco-json-schema-markup";
      }
    }, {
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_8f28c530625811eb9a9521b3fdb3953c());
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          value: {
            type: String,
            notify: true,
            value: ""
          }
        };
      }
    }]);
    return EcoJsonSchemaMarkup;
  }((0, _class.mixinBehaviors)([_appLocalizeBehavior.AppLocalizeBehavior], _polymerElement.PolymerElement));

  _exports.EcoJsonSchemaMarkup = EcoJsonSchemaMarkup;
  window.customElements.define(EcoJsonSchemaMarkup.tag, EcoJsonSchemaMarkup);
});