define(["exports", "../../../lit-element/lit-element.js", "./hax-store.js"], function (_exports, _litElement, _haxStore) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.HaxAppSearchResult = void 0;

  function _templateObject2_901743e0625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: inline-block;\n          width: 47%;\n          margin: 1%;\n          background-color: var(\n            --hax-color-bg-accent,\n            var(--simple-colors-default-theme-cyan-7, #009dc7)\n          );\n          color: var(--hax-color-text, #000000);\n        }\n        button {\n          margin: 0;\n          padding: 0;\n          display: block;\n          border-radius: 0;\n          border: none;\n          width: 100%;\n          outline: 1px solid black;\n          text-align: unset;\n          opacity: 0.8;\n          transition: 0.2s opacity ease-in-out, 0.2s outline-color ease-in-out;\n        }\n        button:hover,\n        button:focus,\n        button:active {\n          background-color: #eeeeee;\n          outline-color: var(--simple-colors-default-theme-purple-8, #8a009b);\n          outline-width: 4px;\n          outline-style: solid;\n          opacity: 1;\n        }\n        .detail-wrapper {\n          padding: 0px;\n          overflow: hidden;\n          font-family: \"Noto Serif\", serif;\n        }\n        .title {\n          font-size: 12px;\n          overflow: hidden;\n          font-weight: bold;\n          text-transform: none;\n          padding: 0;\n          height: 30px;\n          text-align: center;\n        }\n        .image {\n          height: 150px;\n          width: 100%;\n          background-color: var(--simple-colors-default-theme-cyan-7, #009dc7);\n        }\n        @media screen and (max-width: 1000px) {\n          :host {\n            width: 100%;\n          }\n          .title {\n            font-size: 12px;\n          }\n        }\n      "]);

    _templateObject2_901743e0625811eb9a9521b3fdb3953c = function _templateObject2_901743e0625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject_901743e0625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <button\n        draggable=\"true\"\n        @click=\"", "\"\n        @dragstart=\"", "\"\n        @dragend=\"", "\"\n        title=\"", "\"\n      >\n        <img loading=\"lazy\" class=\"image\" src=\"", "\" />\n        <div class=\"detail-wrapper\">\n          <div class=\"title\">", "</div>\n        </div>\n      </button>\n    "]);

    _templateObject_901743e0625811eb9a9521b3fdb3953c = function _templateObject_901743e0625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   * `hax-source`
   * @element hax-source
   * `An element that brokers the visual display of a listing of material from an end point. The goal is to normalize data from some location which is media centric. This expects to get at least enough data in order to form a grid of items which are selectable. It's also generically implemented so that anything can be hooked up as a potential source for input (example: youtube API or custom in-house solution). The goal is to return enough info via fired event so that we can tell hax-body that the user selected a tag, properties, slot combination so that hax-body can turn the selection into a custom element / element injected into the hax-body slot.`
   */
  var HaxAppSearchResult = /*#__PURE__*/function (_LitElement) {
    babelHelpers.inherits(HaxAppSearchResult, _LitElement);

    var _super = _createSuper(HaxAppSearchResult);

    function HaxAppSearchResult() {
      babelHelpers.classCallCheck(this, HaxAppSearchResult);
      return _super.call(this);
    }

    babelHelpers.createClass(HaxAppSearchResult, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject_901743e0625811eb9a9521b3fdb3953c(), this._itemSelected, this._dragStart, this._dragEnd, this.details, this.image, this.title.substr(0, 40));
      }
    }, {
      key: "_dragStart",

      /**
       * Drag start so we know what target to set
       */
      value: function _dragStart(e) {
        // create the tag
        var target = this.cloneNode(true);
        _haxStore.HAXStore.__dragTarget = target;

        if (e.dataTransfer) {
          this.crt = target;
          this.crt.style.position = "absolute";
          this.crt.style.top = "-1000px";
          this.crt.style.right = "-1000px";
          this.crt.style.transform = "scale(0.25)";
          this.crt.style.opacity = ".8";
          e.dataTransfer.effectAllowed = "move";
          e.dataTransfer.dropEffect = "move";
          document.body.appendChild(this.crt);
          e.dataTransfer.setDragImage(this.crt, 0, 0);
        }

        e.stopPropagation();
        e.stopImmediatePropagation();
      }
      /**
       * When we end dragging ensure we remove the mover class.
       */

    }, {
      key: "_dragEnd",
      value: function _dragEnd(e) {
        var _this = this;

        this.crt.remove();
        setTimeout(function () {
          _this._itemSelected(e);
        }, 0);
      }
      /**
       * Handle media item selected.
       */

    }, {
      key: "_itemSelected",
      value: function _itemSelected(e) {
        var map = this.map;
        var gizmoType = this.type; // sanity check as well as guessing based on type if we absolutely have to

        if ((!gizmoType || gizmoType == null || gizmoType == "" || gizmoType == "undefined") && map.source) {
          gizmoType = _haxStore.HAXStore.guessGizmoType(map);
        }

        var haxElements = _haxStore.HAXStore.guessGizmo(gizmoType, map, false, true); // see if we got anything


        if (haxElements.length > 0) {
          if (haxElements.length === 1) {
            if (babelHelpers.typeof(haxElements[0].tag) !== (typeof undefined === "undefined" ? "undefined" : babelHelpers.typeof(undefined))) {
              haxElements[0].nextToActive = true;
              this.dispatchEvent(new CustomEvent("hax-insert-content", {
                bubbles: true,
                cancelable: true,
                composed: true,
                detail: haxElements[0]
              }));
            }
          } else {
            // hand off to hax-app-picker to deal with the rest of this
            _haxStore.HAXStore.haxAppPicker.presentOptions(haxElements, gizmoType, "How would you like to display this " + gizmoType + "?", "gizmo");
          }
        } else {
          _haxStore.HAXStore.toast("Sorry, HAX can't handle that link yet.");
        }
      }
    }], [{
      key: "styles",
      get: function get() {
        return [(0, _litElement.css)(_templateObject2_901743e0625811eb9a9521b3fdb3953c())];
      }
    }, {
      key: "tag",
      get: function get() {
        return "hax-app-search-result";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          image: {
            type: String
          },
          title: {
            type: String
          },
          details: {
            type: String
          },
          map: {
            type: Object
          },
          type: {
            type: String
          }
        };
      }
    }]);
    return HaxAppSearchResult;
  }(_litElement.LitElement);

  _exports.HaxAppSearchResult = HaxAppSearchResult;
  window.customElements.define(HaxAppSearchResult.tag, HaxAppSearchResult);
});