define(["exports", "../../../lit-element/lit-element.js", "../../simple-modal/lib/simple-modal-template.js", "./hax-view-source.js"], function (_exports, _litElement, _simpleModalTemplate, _haxViewSource) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.HaxExportDialog = void 0;

  function _templateObject2_904a3ac0625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: none;\n        }\n        simple-modal-template {\n          display: none;\n          --simple-modal-z-index: 100000001;\n          --simple-modal-width: auto;\n          --simple-modal-height: auto;\n          --simple-modal-min-width: 80vw;\n          --simple-modal-min-height: 70vh;\n          --simple-modal-max-width: unset;\n          --simple-modal-max-height: unset;\n          --simple-modal-titlebar-color: black;\n          --simple-modal-titlebar-background: #ddd;\n          --simple-modal-header-color: black;\n          --simple-modal-header-background: #ccc;\n          --simple-modal-content-container-color: black;\n          --simple-modal-content-container-background: #ffffff;\n          --simple-modal-buttons-color: blue;\n          --simple-modal-buttons-background: #fff;\n          --simple-modal-button-color: var(--simple-modal-buttons-color);\n          --simple-modal-button-background: var(\n            --simple-modal-buttons-background-color\n          );\n        }\n      "]);

    _templateObject2_904a3ac0625811eb9a9521b3fdb3953c = function _templateObject2_904a3ac0625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject_904a3ac0625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <simple-modal-template\n        modal-id=\"hax-export\"\n        id=\"dialog\"\n        .title=\"", "\"\n      >\n        <hax-view-source slot=\"content\"></hax-view-source>\n      </simple-modal-template>\n    "]);

    _templateObject_904a3ac0625811eb9a9521b3fdb3953c = function _templateObject_904a3ac0625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   * `hax-export-dialog`
   * @element hax-export-dialog
   * `Export dialog with all export options and settings provided.`
   */
  var HaxExportDialog = /*#__PURE__*/function (_LitElement) {
    babelHelpers.inherits(HaxExportDialog, _LitElement);

    var _super = _createSuper(HaxExportDialog);

    babelHelpers.createClass(HaxExportDialog, [{
      key: "connectedCallback",
      value: function connectedCallback() {
        babelHelpers.get(babelHelpers.getPrototypeOf(HaxExportDialog.prototype), "connectedCallback", this).call(this);
        window.addEventListener("simple-modal-show", this.modalToggle.bind(this));
      }
    }, {
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        window.removeEventListener("simple-modal-show", this.modalToggle.bind(this));
        babelHelpers.get(babelHelpers.getPrototypeOf(HaxExportDialog.prototype), "disconnectedCallback", this).call(this);
      }
      /**
       * a bit hacky but gets around the cloning element and events issue
       */

    }, {
      key: "modalToggle",
      value: function modalToggle(e) {
        if (e.detail.id == "hax-export") {
          e.detail.elements.content.children[0].openSource();
        }
      }
    }, {
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject_904a3ac0625811eb9a9521b3fdb3953c(), this.title);
      }
    }, {
      key: "firstUpdated",

      /**
       * Attached to the DOM, now fire that we exist.
       */
      value: function firstUpdated() {
        // fire an event that this is a core piece of the system
        this.dispatchEvent(new CustomEvent("hax-register-core-piece", {
          bubbles: true,
          cancelable: true,
          composed: true,
          detail: {
            piece: "haxExport",
            object: this
          }
        }));
      }
    }], [{
      key: "styles",
      get: function get() {
        return [(0, _litElement.css)(_templateObject2_904a3ac0625811eb9a9521b3fdb3953c())];
      }
    }, {
      key: "tag",
      get: function get() {
        return "hax-export-dialog";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * Title
           */
          title: {
            type: String
          }
        };
      }
    }]);

    function HaxExportDialog() {
      var _this;

      babelHelpers.classCallCheck(this, HaxExportDialog);
      _this = _super.call(this);
      _this.title = "View page source";
      return _this;
    }

    return HaxExportDialog;
  }(_litElement.LitElement);

  _exports.HaxExportDialog = HaxExportDialog;
  window.customElements.define(HaxExportDialog.tag, HaxExportDialog);
});