define(["exports", "../../../lit-element/lit-element.js", "../../hax-body-behaviors/lib/HAXFields.js", "../../simple-icon/lib/simple-icon-lite.js", "../../simple-icon/lib/simple-icon-button.js", "../../simple-fields/simple-fields.js", "./hax-store.js", "../../../mobx/dist/mobx.esm.js"], function (_exports, _litElement, _HAXFields, _simpleIconLite, _simpleIconButton, _simpleFields, _haxStore, _mobxEsm) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.HaxPreferencesDialog = void 0;

  function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

  function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { babelHelpers.defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

  function _templateObject3_90642b60625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["<a\n            href=\"https://haxtheweb.org/\"\n            rel=\"noopener\"\n            id=\"link\"\n            target=\"_blank\"\n            >Learn more about HAX</a\n          >"]);

    _templateObject3_90642b60625811eb9a9521b3fdb3953c = function _templateObject3_90642b60625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject2_90642b60625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <h3 class=\"title\">\n        <simple-icon-lite icon=\"hax:settings\"></simple-icon-lite>\n        ", "\n        <simple-icon-button\n          icon=\"close\"\n          @click=\"", "\"\n        ></simple-icon-button>\n      </h3>\n      <div style=\"height: 100%; overflow: auto;\" class=\"pref-container\">\n        <simple-fields\n          id=\"settingsform\"\n          .schematizer=\"", "\"\n          .elementizer=\"", "\"\n        >\n        </simple-fields>\n      </div>\n      ", "\n    "]);

    _templateObject2_90642b60625811eb9a9521b3fdb3953c = function _templateObject2_90642b60625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject_90642b60625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n        }\n        .title {\n          position: relative;\n          padding: 16px;\n          outline: 0;\n          font-weight: 600;\n          text-align: left;\n          margin: 0;\n          background-color: var(--hax-color-menu-heading-bg, #eeeeee);\n          color: var(--hax-color-menu-heading-color, black);\n          font-size: 18px;\n          line-height: 18px;\n          font-family: \"Noto Serif\", serif;\n        }\n        .pref-container {\n          text-align: left;\n          padding: 16px;\n        }\n        #link {\n          color: #81a3a9;\n          font-size: 18px;\n          padding: 16px;\n          font-style: italic;\n        }\n        simple-icon-button {\n          float: right;\n        }\n      "]);

    _templateObject_90642b60625811eb9a9521b3fdb3953c = function _templateObject_90642b60625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   * `hax-preferences-dialog`
   * @element hax-preferences-dialog
   * `Export dialog with all export options and settings provided.`
   */
  var HaxPreferencesDialog = /*#__PURE__*/function (_LitElement) {
    babelHelpers.inherits(HaxPreferencesDialog, _LitElement);

    var _super = _createSuper(HaxPreferencesDialog);

    babelHelpers.createClass(HaxPreferencesDialog, null, [{
      key: "styles",

      /**
       * LitElement constructable styles enhancement
       */
      get: function get() {
        return [(0, _litElement.css)(_templateObject_90642b60625811eb9a9521b3fdb3953c())];
      }
    }]);

    function HaxPreferencesDialog() {
      var _this;

      babelHelpers.classCallCheck(this, HaxPreferencesDialog);
      _this = _super.call(this);
      _this.hideLink = false;
      _this.title = "Advanced settings"; // JSON schema object needs delayed to ensure page repaints the form

      _this.schema = [{
        property: "haxVoiceCommands",
        title: "Voice commands",
        description: "Experimental: Voice based control system",
        inputMethod: "boolean",
        value: false
      }];
      _this.schemaValues = {
        haxVoiceCommands: false
      };
      (0, _mobxEsm.autorun)(function () {
        _this.globalPreferences = (0, _mobxEsm.toJS)(_haxStore.HAXStore.globalPreferences);
        _this.schemaValues = (0, _mobxEsm.toJS)(_haxStore.HAXStore.globalPreferences);
      });
      return _this;
    }

    babelHelpers.createClass(HaxPreferencesDialog, [{
      key: "closeBtn",
      value: function closeBtn(e) {
        this.dispatchEvent(new CustomEvent("hax-tray-button-click", {
          bubbles: true,
          cancelable: true,
          composed: true,
          detail: {
            eventName: "open-preferences",
            index: 0,
            value: true
          }
        }));
      }
    }, {
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject2_90642b60625811eb9a9521b3fdb3953c(), this.title, this.closeBtn, _HAXFields.HaxSchematizer, _HAXFields.HaxElementizer, !this.hideLink ? (0, _litElement.html)(_templateObject3_90642b60625811eb9a9521b3fdb3953c()) : "");
      }
    }, {
      key: "firstUpdated",
      value: function firstUpdated(changedProperties) {
        this.shadowRoot.querySelector("#settingsform").fields = babelHelpers.toConsumableArray(this.schema);
        this.shadowRoot.querySelector("#settingsform").value = _objectSpread({}, this.schemaValues);
        this.shadowRoot.querySelector("#settingsform").addEventListener("value-changed", this.__valueChangedEvent.bind(this));
      }
    }, {
      key: "__valueChangedEvent",
      value: function __valueChangedEvent(e) {
        if (e.detail.value) {
          _haxStore.HAXStore.globalPreferences = _objectSpread({}, e.detail.value);
        }
      }
      /**
       * force an update of settings
       */

    }, {
      key: "reloadPreferencesForm",
      value: function reloadPreferencesForm() {
        this.shadowRoot.querySelector("#settingsform").fields = babelHelpers.toConsumableArray(this.schema);
        this.shadowRoot.querySelector("#settingsform").value = _objectSpread({}, this.schemaValues);
      }
    }], [{
      key: "tag",
      get: function get() {
        return "hax-preferences-dialog";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * Developer prop to hide the link
           */
          hideLink: {
            type: Boolean
          },

          /**
           * Title.
           */
          title: {
            type: String
          },

          /**
           * Schema that has all of inputs / manages state
           */
          schema: {
            type: Object
          },

          /**
           * Preferences managed for everything global about HAX.
           */
          globalPreferences: {
            type: Object
          }
        };
      }
    }]);
    return HaxPreferencesDialog;
  }(_litElement.LitElement);

  _exports.HaxPreferencesDialog = HaxPreferencesDialog;
  window.customElements.define(HaxPreferencesDialog.tag, HaxPreferencesDialog);
});