define(["exports", "../../../@polymer/polymer/polymer-element.js", "../../rich-text-editor/lib/buttons/rich-text-editor-prompt-button.js", "../../lrn-vocab/lrn-vocab.js"], function (_exports, _polymerElement, _richTextEditorPromptButton, _lrnVocab) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.HaxTextEditorVocab = void 0;

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   * `hax-text-editor-vocab`
   * @element hax-text-editor-vocab
   * `a lrn-vocab button for hax text editor (custom buttons can extend this)`
   *
   * @microcopy - language worth noting:
   *  -
   *
  
   * @polymer
   */
  var HaxTextEditorVocab = /*#__PURE__*/function (_RichTextEditorPrompt) {
    babelHelpers.inherits(HaxTextEditorVocab, _RichTextEditorPrompt);

    var _super = _createSuper(HaxTextEditorVocab);

    function HaxTextEditorVocab() {
      var _this;

      babelHelpers.classCallCheck(this, HaxTextEditorVocab);
      _this = _super.call(this);
      _this.inlineWidget = true;
      var element = _lrnVocab.LrnVocab;
      _this.tag = element.tag;
      _this.icon = element.haxProperties.gizmo.icon;
      _this.label = element.haxProperties.gizmo.title;
      _this.fields = element.haxProperties.settings.configure;
      _this.toggles = true;
      _this.value = {
        "": null
      };
      return _this;
    } // properties available to the custom element for data binding


    babelHelpers.createClass(HaxTextEditorVocab, null, [{
      key: "properties",
      get: function get() {
        return {};
      }
      /**
       * Store the tag name to make it easier to obtain directly.
       */

    }, {
      key: "tag",
      get: function get() {
        return "hax-text-editor-vocab";
      }
    }]);
    return HaxTextEditorVocab;
  }(_richTextEditorPromptButton.RichTextEditorPromptButton);

  _exports.HaxTextEditorVocab = HaxTextEditorVocab;
  window.customElements.define(HaxTextEditorVocab.tag, HaxTextEditorVocab);
});