define(["exports", "require", "../../../../../lit-element/lit-element.js", "../haxcms-site-store.js", "../../../../../mobx/dist/mobx.esm.js", "../../../../jwt-login/jwt-login.js"], function (_exports, _require, _litElement, _haxcmsSiteStore, _mobxEsm, _jwtLogin) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.HAXCMSBackendDemo = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function _templateObject_9eed5490625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <jwt-login\n        auto\n        id=\"jwt\"\n        jwt=\"", "\"\n        @jwt-changed=\"", "\"\n      ></jwt-login>\n    "]);

    _templateObject_9eed5490625811eb9a9521b3fdb3953c = function _templateObject_9eed5490625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   * `haxcms-backend-demo`
   * `a simple element to check for and fetch JWTs`
   *
   * @demo demo/index.html
   *
   * @microcopy - the mental model for this element
   * - jwt - a json web token which is an encrypted security token to talk
   */
  var HAXCMSBackendDemo = /*#__PURE__*/function (_LitElement) {
    babelHelpers.inherits(HAXCMSBackendDemo, _LitElement);

    var _super = _createSuper(HAXCMSBackendDemo);

    babelHelpers.createClass(HAXCMSBackendDemo, [{
      key: "render",
      // render function
      value: function render() {
        return (0, _litElement.html)(_templateObject_9eed5490625811eb9a9521b3fdb3953c(), this.jwt, this.jwtChanged);
      }
    }, {
      key: "jwtChanged",
      value: function jwtChanged(e) {
        this.jwt = e.detail.value;
        _haxcmsSiteStore.store.jwt = this.jwt;

        if (_haxcmsSiteStore.store.cmsSiteEditor && _haxcmsSiteStore.store.cmsSiteEditor.instance) {
          _haxcmsSiteStore.store.cmsSiteEditor.instance.jwt = this.jwt;
        }
      }
      /**
       * Detatched life cycle
       */

    }, {
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        for (var i in this.__disposer) {
          this.__disposer[i].dispose();
        }

        babelHelpers.get(babelHelpers.getPrototypeOf(HAXCMSBackendDemo.prototype), "disconnectedCallback", this).call(this);
      }
    }], [{
      key: "tag",

      /**
       * Store the tag name to make it easier to obtain directly.
       */
      get: function get() {
        return "haxcms-backend-demo";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * JSON Web token, it'll come from a global call if it's available
           */
          jwt: {
            type: String
          }
        };
      }
      /**
       * created life cycle
       */

    }]);

    function HAXCMSBackendDemo() {
      var _this;

      babelHelpers.classCallCheck(this, HAXCMSBackendDemo);
      _this = _super.call(this);
      _this.jwt = false;
      _this.__disposer = []; // see up a tag to place RIGHT next to the site-builder itself

      (0, _mobxEsm.autorun)(function (reaction) {
        _this.jwt = (0, _mobxEsm.toJS)(_haxcmsSiteStore.store.jwt);

        _this.__disposer.push(reaction);
      });
      return _this;
    }

    babelHelpers.createClass(HAXCMSBackendDemo, [{
      key: "_jwtChanged",
      value: function _jwtChanged(newValue) {
        console.warn("JWT now set to: " + newValue);
      }
      /**
       * LitElement life cycle - properties changed
       */

    }, {
      key: "updated",
      value: function updated(changedProperties) {
        var _this2 = this;

        changedProperties.forEach(function (oldValue, propName) {
          if (propName == "jwt" && _this2.jwt) {
            _this2._jwtChanged(_this2[propName], oldValue);
          }
        });
      }
      /**
       * LitElement life cycle - element ready
       */

    }, {
      key: "firstUpdated",
      value: function firstUpdated(changedProperties) {
        var _this3 = this;

        setTimeout(function () {
          if (window.appSettings) {
            var jwtlogin = _this3.shadowRoot.querySelector("#jwt");

            jwtlogin.url = window.appSettings.login;
            jwtlogin.refreshUrl = window.appSettings.refreshUrl;
            jwtlogin.logoutUrl = window.appSettings.logout;
            jwtlogin.redirectUrl = window.appSettings.redirectUrl; // allow setting in session driven environments
            // its not a real JWT but it drives the environment to operate correctly

            if (window.appSettings.jwt) {
              _this3.jwt = window.appSettings.jwt;
            }
          }

          try {
            // prettier-ignore
            new Promise(function (res, rej) {
              return _require.default(["../haxcms-site-editor.js"], res, rej);
            }).then(function (e) {
              // validate availability
              _haxcmsSiteStore.store.cmsSiteEditorAvailability();

              _haxcmsSiteStore.store.cmsSiteEditor.instance.jwt = _this3.jwt;
              _haxcmsSiteStore.store.jwt = _this3.jwt;
              _haxcmsSiteStore.store.cmsSiteEditor.instance.method = "GET";
              _haxcmsSiteStore.store.cmsSiteEditor.instance.saveNodePath = window.appSettings.saveNodePath;
              _haxcmsSiteStore.store.cmsSiteEditor.instance.saveManifestPath = window.appSettings.saveManifestPath;
              _haxcmsSiteStore.store.cmsSiteEditor.instance.saveOutlinePath = window.appSettings.saveOutlinePath;
              _haxcmsSiteStore.store.cmsSiteEditor.instance.getNodeFieldsPath = window.appSettings.getNodeFieldsPath;
              _haxcmsSiteStore.store.cmsSiteEditor.instance.getSiteFieldsPath = window.appSettings.getSiteFieldsPath;
              _haxcmsSiteStore.store.cmsSiteEditor.instance.createNodePath = window.appSettings.createNodePath;
              _haxcmsSiteStore.store.cmsSiteEditor.instance.deleteNodePath = window.appSettings.deleteNodePath;
              _haxcmsSiteStore.store.cmsSiteEditor.instance.publishSitePath = window.appSettings.publishSitePath;
              _haxcmsSiteStore.store.cmsSiteEditor.instance.syncSitePath = window.appSettings.syncSitePath;
              _haxcmsSiteStore.store.cmsSiteEditor.instance.revertSitePath = window.appSettings.revertSitePath;
              _haxcmsSiteStore.store.cmsSiteEditor.instance.getUserDataPath = window.appSettings.getUserDataPath;
              _haxcmsSiteStore.store.cmsSiteEditor.instance.appStore = window.appSettings.appStore;
            }, function (e) {
              //import failed
              console.warn(e);
            });
          } catch (err) {// error in the event this is a double registration
          }
        }, 500);
      }
    }]);
    return HAXCMSBackendDemo;
  }(_litElement.LitElement);

  _exports.HAXCMSBackendDemo = HAXCMSBackendDemo;
  window.customElements.define(HAXCMSBackendDemo.tag, HAXCMSBackendDemo);
});