define(["exports", "../../lit-element/lit-element.js", "../schema-behaviors/schema-behaviors.js", "../a11y-compare-image/a11y-compare-image.js", "../simple-colors/simple-colors.js"], function (_exports, _litElement, _schemaBehaviors, _a11yCompareImage, _simpleColors) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.ImageCompareSlider = void 0;

  function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

  function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { babelHelpers.defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

  function _templateObject3_7ee25ba0625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral([" <h2>", "</h2> "]);

    _templateObject3_7ee25ba0625811eb9a9521b3fdb3953c = function _templateObject3_7ee25ba0625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject2_7ee25ba0625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <a11y-compare-image\n        accent-color=\"", "\"\n        ?dark=\"", "\"\n        ?opacity=\"", "\"\n        position=\"", "\"\n      >\n        <div slot=\"heading\">\n          ", "\n          <slot name=\"heading\"></slot>\n        </div>\n        <div slot=\"description\"><slot name=\"description\"></slot></div>\n        <img\n          slot=\"bottom\"\n          src=\"", "\"\n          alt=\"", "\"\n          aria-describedby=\"", "\"\n        />\n        <img\n          slot=\"top\"\n          src=\"", "\"\n          alt=\"", "\"\n          aria-describedby=\"", "\"\n        />\n      </a11y-compare-image>\n    "]);

    _templateObject2_7ee25ba0625811eb9a9521b3fdb3953c = function _templateObject2_7ee25ba0625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject_7ee25ba0625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: inline-flex;\n        }\n        :host([hidden]) {\n          display: none !important;\n        }\n      "]);

    _templateObject_7ee25ba0625811eb9a9521b3fdb3953c = function _templateObject_7ee25ba0625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   * `image-compare-slider`
   * hax-wired a11y-compare-image
   * @demo demo/index.html
   * @element image-compare-slider
   */
  var ImageCompareSlider = /*#__PURE__*/function (_SchemaBehaviors) {
    babelHelpers.inherits(ImageCompareSlider, _SchemaBehaviors);

    var _super = _createSuper(ImageCompareSlider);

    babelHelpers.createClass(ImageCompareSlider, null, [{
      key: "styles",

      /**
       * LitElement constructable styles enhancement
       */
      get: function get() {
        return [(0, _litElement.css)(_templateObject_7ee25ba0625811eb9a9521b3fdb3953c())];
      }
    }]);

    function ImageCompareSlider() {
      var _this;

      babelHelpers.classCallCheck(this, ImageCompareSlider);
      _this = _super.call(this);
      _this.opacity = false;
      _this.position = 50;
      _this.accentColor = "blue";
      return _this;
    }

    babelHelpers.createClass(ImageCompareSlider, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject2_7ee25ba0625811eb9a9521b3fdb3953c(), this.accentColor, this.dark, this.opacity, this.position, this.title ? (0, _litElement.html)(_templateObject3_7ee25ba0625811eb9a9521b3fdb3953c(), this.title) : "", this.bottomSrc, this.bottomAlt, this.bottomDescriptionId || "description", this.topSrc, this.topAlt, this.topDescriptionId || "description");
      }
    }], [{
      key: "tag",
      get: function get() {
        return "image-compare-slider";
      }
    }, {
      key: "properties",
      get: function get() {
        return _objectSpread(_objectSpread({}, babelHelpers.get(babelHelpers.getPrototypeOf(ImageCompareSlider), "properties", this)), {}, {
          /**
           * src for top image
           */
          bottomAlt: {
            type: String,
            attribute: "bottom-alt"
          },

          /**
           * aria-describedby for top image
           */
          bottomDescriptionId: {
            type: String,
            attribute: "bottom-description-id"
          },

          /**
           * src for top image
           */
          bottomSrc: {
            type: String,
            attribute: "bottom-src"
          },

          /**
           * mode for the slider: wipe
           */
          opacity: {
            type: Boolean
          },

          /**
           * mode for the slider: wipe
           */
          position: {
            type: Number
          },

          /**
           * @deprecated Use `slot=heading`
           */
          title: {
            type: String
          },

          /**
           * src for top image
           */
          topAlt: {
            type: String,
            attribute: "top-alt"
          },

          /**
           * aria-describedby for top image
           */
          topDescriptionId: {
            type: String,
            attribute: "top-description-id"
          },

          /**
           * src for top image
           */
          topSrc: {
            type: String,
            attribute: "top-src"
          }
        });
      }
    }, {
      key: "haxProperties",
      get: function get() {
        return {
          canScale: true,
          canPosition: true,
          canEditSource: true,
          gizmo: {
            title: "Image comparison",
            description: "Simple element to allow one image to swipe over top of the other.",
            icon: "image:compare",
            color: "orange",
            groups: ["Image", "Media"],
            handles: [{
              type: "image",
              source: "bottomSrc",
              source2: "topSrc",
              title: "title"
            }],
            meta: {
              author: "ELMS:LN"
            }
          },
          settings: {
            configure: [{
              property: "opacity",
              title: "Slider Behavior",
              description: "Do you want the slider to wipe the top image across the bottom one (default), or to adjust the opacity of the top image?",
              inputMethod: "boolean",
              icon: "image:compare"
            }, {
              property: "accentColor",
              title: "Slider Accent Color",
              inputMethod: "colorpicker"
            }, {
              property: "dark",
              title: "Slider Accent Color, Dark",
              inputMethod: "boolean"
            }, {
              slot: "heading",
              title: "Title",
              inputMethod: "textfield"
            }, {
              slot: "description",
              title: "Description",
              description: "Recommended description for accessibility.",
              inputMethod: "code-editor"
            }, {
              property: "topSrc",
              title: "Top image",
              description: "The base image to swipe over",
              inputMethod: "haxupload",
              validationType: "url",
              required: true
            }, {
              property: "topAlt",
              title: "Top image alt text",
              description: "Required alternate text for accessibility",
              inputMethod: "alt",
              required: true
            }, {
              property: "bottomSrc",
              title: "Bottom image",
              description: "The base image to swipe over",
              inputMethod: "haxupload",
              validationType: "url",
              required: true
            }, {
              property: "bottomAlt",
              title: "Bottom image alt text",
              description: "Required alternate text for accessibility",
              inputMethod: "alt",
              required: true
            }, {
              property: "position",
              title: "Slider's Initial Position",
              description: "Number from 0 to 100",
              inputMethod: "Number",
              min: 0,
              max: 100
            }],
            advanced: [{
              property: "title",
              title: "Title (Deprecated)",
              description: "Use heading instead",
              inputMethod: "textfield"
            }, {
              property: "topDescriptionId",
              title: "Top aria-decsribedby",
              description: "Space-separated id list for long descriptions that appear elsewhere",
              inputMethod: "textfield"
            }, {
              property: "bottomDescriptionId",
              title: "Bottom aria-decsribedby",
              description: "Space-separated id list for long descriptions that appear elsewhere",
              inputMethod: "textfield"
            }]
          },
          demoSchema: [{
            tag: "image-compare-slider",
            properties: {
              accentColor: "blue",
              dark: false,
              opacity: false,
              topSrc: "./demo/images/Matterhorn02.png",
              topAlt: "Matterhorn no snow.",
              topDescription: "cloudy",
              bottomSrc: "./demo/images/Matterhorn01.png",
              bottomAlt: "Matterhorn with snow.",
              bottomDescription: "snowy",
              style: "width:100%;max-width:400px"
            },
            content: "<h2 slot=\"heading\">Image Compare Slider Default</h2><p slot=\"description\">The image on the top or when slider is moved all the way to the right is the <span id=\"cloudy\">Matterhorn on a cloudy day without snow</span>. As you move the slider to the left, the image below it reveals the <span id=\"snowy\">Matterhorn on a clear day with snow</span>.</p>"
          }, {
            tag: "image-compare-slider",
            properties: {
              accentColor: "indigo",
              dark: true,
              opacity: true,
              topSrc: "./demo/images/Matterhorn02.png",
              topAlt: "Matterhorn no snow.",
              topDescriptionId: "cloudy",
              bottomSrc: "./demo/images/Matterhorn01.png",
              bottomAlt: "Matterhorn with snow.",
              bottomDescriptionId: "snowy",
              style: "width:100%;max-width:400px"
            },
            content: "<h2 slot=\"heading\">Image Compare Slider Opacity</h2>\n            <div slot=\"description\">\n              The slider will fade away the top image\n              <span id=\"cloudy\">(Matterhorn on a cloudy day without snow)</span> \n              to reveal the bottom image\n              <span id=\"snowy\">(Matterhorn on a clear day with snow)</span>.\n            </div>"
          }]
        };
      }
    }]);
    return ImageCompareSlider;
  }((0, _schemaBehaviors.SchemaBehaviors)(_simpleColors.SimpleColors));

  _exports.ImageCompareSlider = ImageCompareSlider;
  window.customElements.define(ImageCompareSlider.tag, ImageCompareSlider);
});