define(["exports", "../../lit-element/lit-element.js", "../exif-data/exif-data.js", "../simple-icon/simple-icon.js", "../simple-icon/lib/simple-icons.js", "../simple-icon/lib/simple-icon-button.js", "../img-pan-zoom/img-pan-zoom.js"], function (_exports, _litElement, _exifData, _simpleIcon, _simpleIcons, _simpleIconButton, _imgPanZoom) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.ImageInspector = void 0;

  function _templateObject2_7ef3e7d0625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <div class=\"wrap\">\n        <simple-icon-button\n          title=\"Zoom in\"\n          icon=\"zoom-in\"\n          @click=\"", "\"\n        ></simple-icon-button>\n        <simple-icon-button\n          title=\"Zoom out\"\n          icon=\"zoom-out\"\n          @click=\"", "\"\n        ></simple-icon-button>\n        <simple-icon-button\n          title=\"Rotate right\"\n          icon=\"image:rotate-right\"\n          @click=\"", "\"\n        ></simple-icon-button>\n        <simple-icon-button\n          title=\"Rotate left\"\n          icon=\"image:rotate-left\"\n          @click=\"", "\"\n        ></simple-icon-button>\n        <simple-icon-button\n          title=\"Mirror image\"\n          icon=\"image:flip\"\n          @click=\"", "\"\n        ></simple-icon-button>\n        <simple-icon-button\n          title=\"Open in new window\"\n          icon=\"launch\"\n          href=\"", "\"\n          target=\"_blank\"\n        ></simple-icon-button>\n        <simple-icon-button\n          title=\"EXIF Data\"\n          icon=\"image:camera-roll\"\n          @click=\"", "\"\n        ></simple-icon-button>\n        <slot name=\"toolbar\"></slot>\n      </div>\n      <exif-data\n        id=\"exif\"\n        @click=", "\n        no-events\n        ?no-left=\"", "\"\n        ><img src=\"", "\" />\n      </exif-data>\n      <img-pan-zoom id=\"img\" src=\"", "\"></img-pan-zoom>\n      <slot></slot>\n    "]);

    _templateObject2_7ef3e7d0625811eb9a9521b3fdb3953c = function _templateObject2_7ef3e7d0625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject_7ef3e7d0625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n          overflow: hidden;\n          background-color: var(--image-inspector-background-color, #fdfdfd);\n        }\n\n        simple-icon-button {\n          display: inline-flex;\n          --simple-icon-width: 36px;\n          --simple-icon-height: 36px;\n          margin: 0 8px;\n          background-color: var(--image-inspector-background-color, #fdfdfd);\n          transition: 0.2s all ease-in-out;\n        }\n        simple-icon-button:hover,\n        simple-icon-button:focus,\n        simple-icon-button:active {\n          background-color: var(\n            --image-inspector-background-color-active,\n            #eeeeee\n          );\n        }\n\n        .top-rotated {\n          top: 150px;\n          pointer-events: none; /** disable pointer events when rotated bc of HTML canvas issue */\n        }\n        .showData {\n          display: block;\n          z-index: 2;\n        }\n        exif-data {\n          margin: 0 auto;\n          justify-content: space-evenly;\n          position: absolute;\n          display: none;\n          margin: 0;\n          padding: 0;\n        }\n        exif-data img {\n          margin: 0;\n          opacity: 0;\n          padding: 0;\n          height: 500px;\n          pointer-events: none;\n        }\n        .wrap {\n          border-bottom: 1px solid black;\n          justify-content: center;\n          display: flex;\n        }\n      "]);

    _templateObject_7ef3e7d0625811eb9a9521b3fdb3953c = function _templateObject_7ef3e7d0625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   * `image-inspector`
   * `Zoom, Rotate, Mirror, Download, and View image`
   * @demo demo/index.html
   * @element image-inspector
   */
  var ImageInspector = /*#__PURE__*/function (_LitElement) {
    babelHelpers.inherits(ImageInspector, _LitElement);

    var _super = _createSuper(ImageInspector);

    babelHelpers.createClass(ImageInspector, null, [{
      key: "styles",

      /**
       * LitElement constructable styles enhancement
       */
      get: function get() {
        return [(0, _litElement.css)(_templateObject_7ef3e7d0625811eb9a9521b3fdb3953c())];
      }
    }]);

    function ImageInspector() {
      var _this;

      babelHelpers.classCallCheck(this, ImageInspector);
      _this = _super.call(this);
      _this.noLeft = false;
      _this.degrees = 0;
      _this.src = "";
      return _this;
    }

    babelHelpers.createClass(ImageInspector, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject2_7ef3e7d0625811eb9a9521b3fdb3953c(), this.zoomIn, this.zoomOut, this.rotateRight, this.rotateLeft, this.mirrorImage, this.src, this.exifDataEvent, this.hideData, this.noLeft, this.src, this.src);
      }
    }, {
      key: "exifDataEvent",
      value: function exifDataEvent(e) {
        if (this.shadowRoot.querySelector("#exif").classList.contains("showData")) {
          this.shadowRoot.querySelector("#exif").classList.remove("showData");
        } else {
          this.shadowRoot.querySelector("#exif").classList.add("showData");
          this.shadowRoot.querySelector("#exif").updateExif(true);
        }
      }
    }, {
      key: "hideData",
      value: function hideData(e) {
        this.shadowRoot.querySelector("#exif").classList.remove("showData");
      }
    }, {
      key: "firstUpdated",
      value: function firstUpdated(changedProperties) {
        if (babelHelpers.get(babelHelpers.getPrototypeOf(ImageInspector.prototype), "firstUpdated", this)) {
          babelHelpers.get(babelHelpers.getPrototypeOf(ImageInspector.prototype), "firstUpdated", this).call(this, changedProperties);
        }

        this.__img = this.shadowRoot.querySelector("#img");
        this.shadowRoot.querySelector("#exif").alignTarget = this.__img;
        this.shadowRoot.querySelector("#exif").alignTargetTop = "0px";
        this.shadowRoot.querySelector("#exif").updateExif();
      }
      /**
       * Rotate the image to the right.
       */

    }, {
      key: "rotateRight",
      value: function rotateRight() {
        // spin 90
        this.degrees += 90;
        this.__img.style.transform = "rotate(" + this.degrees + "deg)";

        if (this.__img.classList.contains("top-rotated")) {
          this.__img.classList.remove("top-rotated");
        } else {
          this.__img.classList.add("top-rotated");
        }
      }
      /**
       * Rotate the image to the left.
       */

    }, {
      key: "rotateLeft",
      value: function rotateLeft() {
        // go back 90
        this.degrees += -90;
        this.__img.style.transform = "rotate(" + this.degrees + "deg)";

        if (this.__img.classList.contains("top-rotated")) {
          this.__img.classList.remove("top-rotated");
        } else {
          this.__img.classList.add("top-rotated");
        }
      }
      /**
       * Flip the image.
       */

    }, {
      key: "mirrorImage",
      value: function mirrorImage() {
        if (this.__img.style.transform === "scaleX(1)") {
          this.__img.style.transform = "scaleX(-1)";
        } else {
          this.__img.style.transform = "scaleX(1)";
        }
      }
      /**
       * Zoom in by calling  downstream function.
       */

    }, {
      key: "zoomIn",
      value: function zoomIn() {
        this.__img.zoomIn();
      }
      /**
       * Zoom out by calling downstream function.
       */

    }, {
      key: "zoomOut",
      value: function zoomOut() {
        this.__img.zoomOut();
      }
    }], [{
      key: "tag",
      get: function get() {
        return "image-inspector";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          noLeft: {
            type: Boolean,
            attribute: "no-left"
          },

          /**
           * Image rotation
           */
          degrees: {
            type: Number,
            reflect: true
          },

          /**
           * Image source.
           */
          src: {
            type: String
          },

          /**
           * Hover class for button styling
           */
          hoverClass: {
            type: String,
            attribute: "hover-class"
          }
        };
      }
    }]);
    return ImageInspector;
  }(_litElement.LitElement);

  _exports.ImageInspector = ImageInspector;
  window.customElements.define(ImageInspector.tag, ImageInspector);
});