define(["exports", "../../lit-element/lit-element.js", "../schema-behaviors/schema-behaviors.js", "../simple-modal/simple-modal.js"], function (_exports, _litElement, _schemaBehaviors, _simpleModal) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrnVocab = void 0;

  function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

  function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { babelHelpers.defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

  function _templateObject2_82a249d0625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral([" <button>", "</button> "]);

    _templateObject2_82a249d0625811eb9a9521b3fdb3953c = function _templateObject2_82a249d0625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject_82a249d0625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: inline;\n          --lrn-vocab-border: 1px dashed #ccc;\n        }\n        button {\n          text-transform: none;\n          min-width: unset;\n          margin: 0;\n          position: relative;\n          top: 0px;\n          border-radius: 0;\n          border-bottom: var(--lrn-vocab-border);\n          background: #f5f5f5;\n          font-size: 1.1em;\n          padding: 2px;\n        }\n        button:hover {\n          background: #bbdefb;\n          border-bottom: 1px dashed #2196f3;\n        }\n      "]);

    _templateObject_82a249d0625811eb9a9521b3fdb3953c = function _templateObject_82a249d0625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
  `lrn-vocab`
  Vocabulary term with visual treatment and semantic meaning.
  
  * @demo demo/index.html
  */
  var LrnVocab = /*#__PURE__*/function (_SchemaBehaviors) {
    babelHelpers.inherits(LrnVocab, _SchemaBehaviors);

    var _super = _createSuper(LrnVocab);

    babelHelpers.createClass(LrnVocab, null, [{
      key: "styles",

      /**
       * LitElement constructable styles enhancement
       */
      get: function get() {
        return [(0, _litElement.css)(_templateObject_82a249d0625811eb9a9521b3fdb3953c())];
      }
    }]);

    function LrnVocab() {
      var _this;

      babelHelpers.classCallCheck(this, LrnVocab);
      _this = _super.call(this);
      setTimeout(function () {
        _this.addEventListener("click", _this.openDialog.bind(babelHelpers.assertThisInitialized(_this)));
      }, 0);
      return _this;
    }

    babelHelpers.createClass(LrnVocab, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject2_82a249d0625811eb9a9521b3fdb3953c(), this.term);
      }
    }, {
      key: "haxHooks",

      /**
       * Implements haxHooks to tie into life-cycle if hax exists.
       */
      value: function haxHooks() {
        return {
          editModeChanged: "haxeditModeChanged",
          activeElementChanged: "haxactiveElementChanged"
        };
      }
      /**
       * double-check that we are set to inactivate click handlers
       * this is for when activated in a duplicate / adding new content state
       */

    }, {
      key: "haxactiveElementChanged",
      value: function haxactiveElementChanged(el, val) {
        if (val) {
          this._haxstate = val;
        }
      }
      /**
       * Set a flag to test if we should block link clicking on the entire card
       * otherwise when editing in hax you can't actually edit it bc its all clickable.
       * if editMode goes off this helps ensure we also become clickable again
       */

    }, {
      key: "haxeditModeChanged",
      value: function haxeditModeChanged(val) {
        this._haxstate = val;
      }
      /**
       * Request the singleton dialog open
       */

    }, {
      key: "openDialog",
      value: function openDialog(e) {
        if (this._haxstate) {
          // do not do default
          e.preventDefault();
          e.stopPropagation();
          e.stopImmediatePropagation();
          return false;
        }

        var c = document.createElement("div");

        for (var id in this.children) {
          if (this.children[id].cloneNode) {
            c.appendChild(this.children[id].cloneNode(true));
          }
        }

        var evt = new CustomEvent("simple-modal-show", {
          bubbles: true,
          cancelable: true,
          composed: true,
          detail: {
            title: this.term,
            elements: {
              content: c
            },
            styles: {
              "--simple-modal-width": "50vw",
              "--simple-modal-max-width": "50vw",
              "--simple-modal-min-height": "50vh"
            },
            invokedBy: this
          }
        });
        this.dispatchEvent(evt);
      }
      /**
       * Attached life cycle
       */

    }, {
      key: "firstUpdated",
      value: function firstUpdated(changedProperties) {
        if (babelHelpers.get(babelHelpers.getPrototypeOf(LrnVocab.prototype), "firstUpdated", this)) {
          babelHelpers.get(babelHelpers.getPrototypeOf(LrnVocab.prototype), "firstUpdated", this).call(this, changedProperties);
        }

        window.SimpleModal.requestAvailability();
      }
    }], [{
      key: "tag",
      get: function get() {
        return "lrn-vocab";
      }
    }, {
      key: "properties",
      get: function get() {
        return _objectSpread(_objectSpread({}, babelHelpers.get(babelHelpers.getPrototypeOf(LrnVocab), "properties", this)), {}, {
          term: {
            type: String,
            reflect: true
          }
        });
      }
    }, {
      key: "haxProperties",
      get: function get() {
        return {
          canScale: false,
          canPosition: false,
          canEditSource: true,
          gizmo: {
            title: "Vocab",
            description: "Vocabulary term",
            icon: "hax:vocab",
            color: "red",
            groups: ["Vocab"],
            handles: [{
              type: "inline",
              text: "term"
            }],
            meta: {
              author: "ELMS:LN",
              inlineOnly: true
            }
          },
          settings: {
            configure: [{
              property: "term",
              title: "Term",
              inputMethod: "textfield",
              icon: "editor:title",
              required: true
            }, {
              slot: "",
              title: "Contents",
              description: "The definitition to display when the term is clicked.",
              inputMethod: "code-editor",
              required: true
            }],
            advanced: []
          }
        };
      }
    }]);
    return LrnVocab;
  }((0, _schemaBehaviors.SchemaBehaviors)(_litElement.LitElement));

  _exports.LrnVocab = LrnVocab;
  window.customElements.define(LrnVocab.tag, LrnVocab);
});