define(["exports", "../../../lit-element/lit-element.js", "../../../@polymer/iron-flex-layout/iron-flex-layout-classes.js", "../../simple-icon/simple-icon.js", "../../simple-icon/lib/simple-icons.js", "../../simple-icon/lib/simple-icon-button.js", "../../materializecss-styles/lib/colors.js"], function (_exports, _litElement, _ironFlexLayoutClasses, _simpleIcon, _simpleIcons, _simpleIconButton, _colors) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrnappFabSpeedDialAction = void 0;

  function _templateObject2_915a9950625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <div class=\"flex\">\n        <span class=\"label\"><slot></slot></span>\n      </div>\n      <simple-icon-button\n        class=\"fab ", "\"\n        accent-color=\"", "\"\n        icon=\"", "\"\n        mini\n      ></simple-icon-button>\n    "]);

    _templateObject2_915a9950625811eb9a9521b3fdb3953c = function _templateObject2_915a9950625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject_915a9950625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          align-items: center;\n          justify-content: flex-end;\n          display: flex;\n          margin-top: 15px;\n          margin-right: 8px;\n          min-width: 270px;\n        }\n        .label {\n          color: black;\n          background: white;\n          padding: 0 16px;\n          border-radius: 4px;\n          margin-right: 24px;\n        }\n        .flex {\n          display: inline-flex;\n        }\n        .label,\n        .fab {\n          display: flex;\n        }\n      "]);

    _templateObject_915a9950625811eb9a9521b3fdb3953c = function _templateObject_915a9950625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /*
  An action within a material design [Floating Action Button with Speed Dial](https://www.google.com/design/spec/components/buttons-floating-action-button.html#buttons-floating-action-button-transitions)
  
  ### Styling
  
  Style                                                   | Description
  ------------------------------------------------------- | ------------
  --lrnapp-fab-speed-dial-action-background                | The background color of the Floating Action Button
  --lrnapp-fab-speed-dial-action-keyboard-focus-background | The background color of the Floating Action Button when focused
  
  ### Example
  
  ```html
  <lrnapp-fab-speed-dial-action icon="icons:content-copy">Copy</lrnapp-fab-speed-dial-action>
  ```
  
  * @demo demo/index.html
  */
  var LrnappFabSpeedDialAction = /*#__PURE__*/function (_LitElement) {
    babelHelpers.inherits(LrnappFabSpeedDialAction, _LitElement);

    var _super = _createSuper(LrnappFabSpeedDialAction);

    babelHelpers.createClass(LrnappFabSpeedDialAction, null, [{
      key: "styles",

      /**
       * LitElement constructable styles enhancement
       */
      get: function get() {
        return [_colors.materialCssStyles, (0, _litElement.css)(_templateObject_915a9950625811eb9a9521b3fdb3953c())];
      }
    }, {
      key: "tag",
      get: function get() {
        return "lrnapp-fab-speed-dial-action";
      }
      /**
       * HTMLElement
       */

    }]);

    function LrnappFabSpeedDialAction() {
      var _this;

      babelHelpers.classCallCheck(this, LrnappFabSpeedDialAction);
      _this = _super.call(this);
      _this.color = "blue";
      return _this;
    }
    /**
     * LitElement render
     */


    babelHelpers.createClass(LrnappFabSpeedDialAction, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject2_915a9950625811eb9a9521b3fdb3953c(), this.color, this.color, this.icon);
      }
    }], [{
      key: "properties",
      get: function get() {
        return {
          /**
           * Icon that is shown next to the content
           */
          icon: {
            type: String
          },

          /**
           * Color class work to apply
           */
          color: {
            type: String
          }
        };
      }
    }]);
    return LrnappFabSpeedDialAction;
  }(_litElement.LitElement);

  _exports.LrnappFabSpeedDialAction = LrnappFabSpeedDialAction;
  window.customElements.define(LrnappFabSpeedDialAction.tag, LrnappFabSpeedDialAction);
});