define(["exports", "../../../lit-element/lit-element.js"], function (_exports, _litElement) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrndesignGalleryDetails = void 0;

  function _templateObject2_9177be40625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n        }\n        :host([hidden]) {\n          display: none;\n        }\n        ::slotted(*:first-child) {\n          margin-top: 0;\n        }\n        ::slotted(*:last-child) {\n          margin-bottom: 0;\n        }\n      "]);

    _templateObject2_9177be40625811eb9a9521b3fdb3953c = function _templateObject2_9177be40625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject_9177be40625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral([" <slot></slot> "]);

    _templateObject_9177be40625811eb9a9521b3fdb3953c = function _templateObject_9177be40625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   * `lrndesign-gallery-details`
   * An element that renders the print view of a gallery item.
   *
   * @element lrndesign-gallery-details
   * 
   * @microcopy - language worth noting:```
  <lrndesign-gallery-details 
    details="<strong>HTML MARKUP HERE</strong>"       //required, an array of item data
  </lrndesign-gallery-details>```
   *
   */
  var LrndesignGalleryDetails = /*#__PURE__*/function (_LitElement) {
    babelHelpers.inherits(LrndesignGalleryDetails, _LitElement);

    var _super = _createSuper(LrndesignGalleryDetails);

    babelHelpers.createClass(LrndesignGalleryDetails, [{
      key: "render",
      // render function
      value: function render() {
        return (0, _litElement.html)(_templateObject_9177be40625811eb9a9521b3fdb3953c());
      }
    }], [{
      key: "styles",

      /**
       * LitElement constructable styles enhancement
       */
      get: function get() {
        return [(0, _litElement.css)(_templateObject2_9177be40625811eb9a9521b3fdb3953c())];
      }
      /**
       * Store the tag name to make it easier to obtain directly.
       */

    }, {
      key: "tag",
      get: function get() {
        return "lrndesign-gallery-details";
      }
    }]);

    function LrndesignGalleryDetails() {
      babelHelpers.classCallCheck(this, LrndesignGalleryDetails);
      return _super.call(this);
    }

    babelHelpers.createClass(LrndesignGalleryDetails, [{
      key: "updated",
      value: function updated(changedProperties) {
        var _this = this;

        changedProperties.forEach(function (oldValue, propName) {
          if (propName == "details") {
            _this._detailsChanged(_this[propName]);
          }
        });
      } // properties available to the custom element for data binding

    }, {
      key: "_detailsChanged",

      /**
       * updates the details
       */
      value: function _detailsChanged(newValue) {
        this.innerHTML = newValue;
      }
    }], [{
      key: "properties",
      get: function get() {
        return {
          /**
           * image's details in as a string of HTML
           */
          details: {
            type: String
          }
        };
      }
    }]);
    return LrndesignGalleryDetails;
  }(_litElement.LitElement);

  _exports.LrndesignGalleryDetails = LrndesignGalleryDetails;
  window.customElements.define(LrndesignGalleryDetails.tag, LrndesignGalleryDetails);
});