define(["exports", "../../../lit-element/lit-element.js", "./lrndesign-gallery-behaviors.js", "./lrndesign-gallery-zoom.js", "./lrndesign-gallery-details.js"], function (_exports, _litElement, _lrndesignGalleryBehaviors, _lrndesignGalleryZoom, _lrndesignGalleryDetails) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrndesignGalleryGrid = void 0;

  function _templateObject3_917af290625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n              <lrndesign-gallery-zoom\n                .id=\"", "\"\n                .details=\"", "\"\n                .heading=\"", "\"\n                .src=\"", "\"\n                .tooltip=\"", "\"\n                .zoom-alt=\"", "\"\n              >\n                <span class=\"sr-only\">", "</span>\n                <div class=\"imgbg\" .style=\"", "\"></div>\n                <div class=\"zoombg\"></div>\n                <simple-icon-lite\n                  icon=\"zoom-in\"\n                  class=\"zoomicon\"\n                ></simple-icon-lite>\n              </lrndesign-gallery-zoom>\n            "]);

    _templateObject3_917af290625811eb9a9521b3fdb3953c = function _templateObject3_917af290625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject2_917af290625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <div id=\"grid\">\n        <p class=\"sr-only\">A list of columns buttons items:</p>\n        <div id=\"galleryscreen\">\n          ", "\n        </div>\n      </div>\n    "]);

    _templateObject2_917af290625811eb9a9521b3fdb3953c = function _templateObject2_917af290625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

  function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { babelHelpers.defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

  function _templateObject_917af290625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          margin: 15px 0;\n          padding: 0;\n          max-width: 100%;\n          display: block;\n        }\n        #galleryscreen {\n          display: grid;\n          grid-gap: 7.5px;\n          grid-template-columns: repeat(2, 1fr);\n        }\n        :host([responsive-size=\"sm\"]) #galleryscreen {\n          grid-template-columns: repeat(3, 1fr);\n        }\n        :host([responsive-size=\"md\"]) #galleryscreen {\n          grid-template-columns: repeat(4, 1fr);\n        }\n        :host([responsive-size=\"lg\"]) #galleryscreen {\n          grid-template-columns: repeat(5, 1fr);\n        }\n        :host([responsive-size=\"xl\"]) #galleryscreen {\n          grid-template-columns: repeat(6, 1fr);\n        }\n        lrndesign-gallery-zoom {\n          position: relative;\n          overflow: hidden;\n          transition: outline 0.25s ease-in-out;\n          outline: 1px solid var(--lrndesign-gallery-color);\n        }\n        lrndesign-gallery-zoom:hover,\n        lrndesign-gallery-zoom:focus,\n        lrndesign-gallery-zoom:focus-within {\n          transition: outline 0.25s ease-in-out;\n          outline: 2px solid var(--lrndesign-gallery-focus-color);\n        }\n        lrndesign-gallery-zoom img {\n          position: absolute;\n          opacity: 0 !important;\n        }\n        .imgbg {\n          width: 100%;\n          padding-top: var(--lrndesign-gallery-grid-paddingTop, 75%);\n          background-image: var(--lrndesign-gallery-grid-backgroundImage, none);\n          background-position: var(\n            --lrndesign-gallery-grid-backgroundPosition,\n            center\n          );\n          background-size: var(--lrndesign-gallery-grid-backgroundSize, cover);\n        }\n        .zoombg,\n        .zoomicon {\n          top: unset;\n          bottom: 5px;\n          left: 5px;\n        }\n      "]);

    _templateObject_917af290625811eb9a9521b3fdb3953c = function _templateObject_917af290625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   * `lrndesign-gallery-grid`
   * An element that renders a collection of gallery items into a grid or a single media item into a layout.
   *
   * @element lrndesign-gallery-grid
   * @extends LrndesignGalleryBehaviors
   * @demo ./demo/grid.html demo
   *
   */
  var LrndesignGalleryGrid = /*#__PURE__*/function (_LrndesignGalleryBeha) {
    babelHelpers.inherits(LrndesignGalleryGrid, _LrndesignGalleryBeha);

    var _super = _createSuper(LrndesignGalleryGrid);

    babelHelpers.createClass(LrndesignGalleryGrid, null, [{
      key: "tag",

      /**
       * Store the tag name to make it easier to obtain directly.
       */
      get: function get() {
        return "lrndesign-gallery-grid";
      }
    }, {
      key: "styles",
      get: function get() {
        return [].concat(babelHelpers.toConsumableArray(babelHelpers.get(babelHelpers.getPrototypeOf(LrndesignGalleryGrid), "styles", this)), [(0, _litElement.css)(_templateObject_917af290625811eb9a9521b3fdb3953c())]);
      } // properties available to the custom element for data binding

    }, {
      key: "properties",
      get: function get() {
        return _objectSpread({}, babelHelpers.get(babelHelpers.getPrototypeOf(LrndesignGalleryGrid), "properties", this));
      }
      /**
       * life cycle, element is ready
       */

    }]);

    function LrndesignGalleryGrid() {
      var _this;

      babelHelpers.classCallCheck(this, LrndesignGalleryGrid);
      _this = _super.call(this);

      var target = _this.shadowRoot.querySelector("#carouselitem");

      if (_this.selected.scroll && target) {
        _this._scrollIntoView([_this._getParentOffset(target)]);

        if (!_this.selected.zoomed) target.focus();
      }

      return _this;
    } // render function


    babelHelpers.createClass(LrndesignGalleryGrid, [{
      key: "render",
      value: function render() {
        var _this2 = this;

        return (0, _litElement.html)(_templateObject2_917af290625811eb9a9521b3fdb3953c(), this.sources.map(function (item) {
          return (0, _litElement.html)(_templateObject3_917af290625811eb9a9521b3fdb3953c(), item.id, item.details, item.heading, item.large, item.tooltip, item.zoomAlt, item.zoomAlt, _this2._getStyle(item));
        }));
      }
    }, {
      key: "_getStyle",
      value: function _getStyle(item) {
        return ["--lrndesign-gallery-grid-paddingTop: ".concat(100 / this.aspectRatio, "%;"), "--lrndesign-gallery-grid-backgroundImage: url(".concat(item.src, ");"), "--lrndesign-gallery-grid-backgroundPosition: ".concat(item.gravity || "center", ";"), "--lrndesign-gallery-grid-backgroundSize: ".concat(item.sizing || this.sizing === "cover" || "contain")].join("");
      }
      /**
       * handles gallery-scroll event
       * /
      _handleScroll(item) {
        this._scrollIntoView([this._getParentOffset(this), item.offsetTop]);
      }*/

    }]);
    return LrndesignGalleryGrid;
  }(_lrndesignGalleryBehaviors.LrndesignGalleryBehaviors);

  _exports.LrndesignGalleryGrid = LrndesignGalleryGrid;
  window.customElements.define(LrndesignGalleryGrid.tag, LrndesignGalleryGrid);
});