define(["exports", "../../../@polymer/polymer/polymer-element.js", "../../simple-icon/simple-icon.js", "../../simple-icon/lib/simple-icons.js", "../../simple-icon/lib/simple-icon-button.js", "../../../@polymer/polymer/lib/elements/dom-if.js", "../../a11y-collapse/a11y-collapse.js"], function (_exports, _polymerElement, _simpleIcon, _simpleIcons, _simpleIconButton, _domIf, _a11yCollapse) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrndesignStepperButton = void 0;

  function _templateObject_9195cd90625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style>\n        :host {\n          display: block;\n          --lrndesign-icon-button-color: #abacae;\n          --lrndesign-stepper-btn-title-color: #000;\n          --lrndesign-stepper-btn-active: #f6f7f7;\n          --lrndesign-border-color: #abacae;\n        }\n\n        .top-line,\n        .bottom-line {\n          background-color: transparent;\n        }\n\n        :host([location=\"start\"]) .bottom-line {\n          background-color: var(--lrndesign-icon-button-color);\n        }\n\n        :host([location=\"middle\"]) .top-line,\n        :host([location=\"middle\"]) .bottom-line {\n          background-color: var(--lrndesign-icon-button-color);\n        }\n\n        :host([location=\"end\"]) .top-line {\n          background-color: var(--lrndesign-icon-button-color);\n        }\n\n        .top-line {\n          width: 2px;\n          height: 24px;\n          margin: auto;\n        }\n\n        .bottom-line {\n          width: 2px;\n          height: 24px;\n          margin: auto;\n        }\n\n        .stepper-btn {\n          background-color: transparent;\n          display: flex;\n          width: 100%;\n          justify-content: center;\n        }\n\n        .node-title {\n          color: var(--lrndesign-stepper-btn-title-color);\n          text-transform: none;\n          line-height: 32px;\n          font-weight: bold;\n          font-size: 16px;\n        }\n\n        .btn-icon {\n          background-color: transparent;\n          color: var(--lrndesign-icon-button-color);\n          border-radius: 50%;\n          --simple-icon-height: 35px;\n          --simple-icon-width: 35px;\n        }\n\n        .url-style {\n          text-decoration: none;\n        }\n\n        .title-container {\n          padding: 10px;\n          width: 70%;\n          position: relative;\n          right: 19.2px;\n        }\n\n        .title-container:hover {\n          text-decoration: underline;\n        }\n\n        .box-container {\n          display: flex;\n          flex-direction: column;\n          justify-content: center;\n          align-items: flex-start;\n          position: relative;\n          width: 30%;\n        }\n\n        button {\n          width: 100%;\n          background-color: transparent;\n          position: relative;\n        }\n\n        button:after {\n          content: \"\";\n          display: block;\n          position: absolute;\n          width: 100%;\n          height: 100%;\n          top: 0;\n          left: 0;\n          border-top: 1px solid transparent;\n          border-bottom: 1px solid transparent;\n        }\n\n        button:active,\n        button:focus {\n          background-color: var(--lrndesign-stepper-btn-active);\n        }\n        button:focus simple-icon {\n          color: black;\n        }\n\n        button:active:after,\n        button:focus:after {\n          border-color: var(--lrndesign-border-color);\n        }\n\n        button {\n          border-radius: 0;\n          padding: 0;\n        }\n      </style>\n\n      <template is=\"dom-if\" if=\"{{hasCollapse(collapsible, 1)}}\">\n        <a11y-collapse>\n          <div class=\"box-container\" slot=\"heading\">\n            <div class=\"top-line\"></div>\n            <div class=\"stepper-btn\">\n              <simple-icon icon=\"[[icon]]\" class=\"btn-icon\"></simple-icon>\n            </div>\n            <div class=\"bottom-line\"></div>\n          </div>\n          <div class=\"title-container\">\n            <div class=\"node-title\">[[title]]</div>\n          </div>\n          <div><slot></slot></div>\n        </a11y-collapse>\n      </template>\n      <template is=\"dom-if\" if=\"{{hasCollapse(collapsible, 0)}}\">\n        <a tabindex=\"-1\" href=\"[[url]]\" class=\"url-style\">\n          <button class=\"btn\">\n            <div class=\"box-container\">\n              <div class=\"top-line\"></div>\n              <div class=\"stepper-btn\">\n                <simple-icon icon=\"[[icon]]\" class=\"btn-icon\"></simple-icon>\n              </div>\n              <div class=\"bottom-line\"></div>\n            </div>\n            <div class=\"title-container\">\n              <div class=\"node-title\">[[title]]</div>\n            </div>\n          </button>\n        </a>\n        <slot></slot>\n      </template>\n    "]);

    _templateObject_9195cd90625811eb9a9521b3fdb3953c = function _templateObject_9195cd90625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
  `lrndesign-stepper-button`
  visualization of steps
  
  * @demo demo/index.html
  */
  var LrndesignStepperButton = /*#__PURE__*/function (_PolymerElement) {
    babelHelpers.inherits(LrndesignStepperButton, _PolymerElement);

    var _super = _createSuper(LrndesignStepperButton);

    function LrndesignStepperButton() {
      babelHelpers.classCallCheck(this, LrndesignStepperButton);
      return _super.apply(this, arguments);
    }

    babelHelpers.createClass(LrndesignStepperButton, [{
      key: "hasCollapse",

      /**
       * If it is in a collapsed state or not.
       */
      value: function hasCollapse(bool, test) {
        if (bool == test) {
          return true;
        } else {
          return false;
        }
      }
    }], [{
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_9195cd90625811eb9a9521b3fdb3953c());
      }
    }, {
      key: "tag",
      get: function get() {
        return "lrndesign-stepper-button";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * The button title.
           */
          title: {
            type: String,
            reflectToAttribute: true,
            notify: true
          },

          /**
           * The button icon.
           */
          icon: {
            type: String,
            reflectToAttribute: true,
            notify: true
          },

          /**
           * The url for button.
           */
          url: {
            type: String,
            reflectToAttribute: true,
            notify: true
          },

          /**
           * The tab location position (start / middle / end).
           */
          location: {
            type: String,
            reflectToAttribute: true,
            notify: true
          },

          /**
           * Allow for collapsible content with the items inside
           */
          collapsible: {
            type: Boolean,
            reflectToAttribute: true,
            notify: true,
            value: false
          },
          opened: {
            type: Boolean,
            value: false
          }
        };
      }
    }]);
    return LrndesignStepperButton;
  }(_polymerElement.PolymerElement);

  _exports.LrndesignStepperButton = LrndesignStepperButton;
  window.customElements.define(LrndesignStepperButton.tag, LrndesignStepperButton);
});