define(["exports", "../../../@polymer/polymer/polymer-element.js", "../../../@polymer/iron-a11y-keys/iron-a11y-keys.js", "../../simple-icon/simple-icon.js", "../../simple-icon/lib/simple-icons.js", "../../simple-icon/lib/simple-icon-button.js", "./mtz-marked-control-behavior.js"], function (_exports, _polymerElement, _ironA11yKeys, _simpleIcon, _simpleIcons, _simpleIconButton, _mtzMarkedControlBehavior) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.MtzMarkedControlLink = void 0;

  function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

  function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { babelHelpers.defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

  function _templateObject_9257be00625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style>\n        :host {\n          display: inline-block;\n        }\n      </style>\n\n      <simple-icon-button\n        icon=\"[[icon]]\"\n        noink=\"[[noink]]\"\n        on-click=\"_handleCommand\"\n        alt=\"[[title]]\"\n      ></simple-icon-button>\n\n      <iron-a11y-keys\n        keys=\"[[keys]]\"\n        on-keys-pressed=\"_handleCommand\"\n        target=\"[[__editor]]\"\n      ></iron-a11y-keys>\n    "]);

    _templateObject_9257be00625811eb9a9521b3fdb3953c = function _templateObject_9257be00625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  var MtzMarkedControlLink = /*#__PURE__*/function (_mtzMarkedControlBeha) {
    babelHelpers.inherits(MtzMarkedControlLink, _mtzMarkedControlBeha);

    var _super = _createSuper(MtzMarkedControlLink);

    function MtzMarkedControlLink() {
      babelHelpers.classCallCheck(this, MtzMarkedControlLink);
      return _super.apply(this, arguments);
    }

    babelHelpers.createClass(MtzMarkedControlLink, [{
      key: "_handleCommand",

      /**
       * Toggles a syntax prefix at the start of selected lines
       *
       * @param {MouseEvent|KeyboardEvent} event
       * @protected
       */
      value: function _handleCommand(event) {
        event.preventDefault();
        event.stopPropagation();
        var editor = this.__editor;
        var selection = editor.getSelection();
        var regex = new RegExp("\\[(.*)\\]\\((.*)\\)"); // Check if syntax is present (regex)

        var matches = selection.text.match(regex);
        var text;
        var link;

        if (matches) {
          text = matches[1];
          link = matches[2];
          var match = link || text;
          editor.replaceSelection(match);
          editor.setSelection(selection.start, selection.end - (selection.length - match.length));
        } else {
          if (this._isLink(selection)) {
            text = prompt("What text would you like to display?");
            if (!text) return;
            link = selection.text;
          } else {
            link = prompt("What link would you like to use?");
            if (!link) return;
            text = selection.text;
          }

          if (link.startsWith("http://")) {
            alert("Links must be https://");
            return;
          }

          var newLink = regex[Symbol.replace]("[]()", "[".concat(text, "](").concat(link, ")"));
          editor.replaceSelection(newLink);
          editor.setSelection(selection.start, selection.end + (newLink.length - selection.length));
        }
      }
      /**
       * Determines if the selection is a link, may override for more complex checks
       *
       * @param {Object} selection - the selection from the editor
       * @return {Boolean}
       * @protected
       */

    }, {
      key: "_isLink",
      value: function _isLink(selection) {
        return selection.text.startsWith("https://");
      }
    }], [{
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_9257be00625811eb9a9521b3fdb3953c());
      }
    }, {
      key: "tag",
      get: function get() {
        return "mtz-marked-control-link";
      }
    }, {
      key: "properties",
      get: function get() {
        return _objectSpread(_objectSpread({}, babelHelpers.get(babelHelpers.getPrototypeOf(MtzMarkedControlLink), "properties", this)), {}, {
          title: String,
          icon: String,
          keys: String,
          noink: Boolean // Pass-through

        });
      }
    }]);
    return MtzMarkedControlLink;
  }((0, _mtzMarkedControlBehavior.mtzMarkedControlBehavior)(_polymerElement.PolymerElement));

  _exports.MtzMarkedControlLink = MtzMarkedControlLink;
  window.customElements.define(MtzMarkedControlLink.tag, MtzMarkedControlLink);
});