define(["exports", "../../lit-element/lit-element.js", "../simple-colors/simple-colors.js"], function (_exports, _litElement, _simpleColors) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.PersonTestimonial = void 0;

  function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

  function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { babelHelpers.defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

  function _templateObject2_890f56a0625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n          --person-testimonial-font-family: sans-serif;\n          --person-testimonial-bg: var(--simple-colors-default-theme-grey-1);\n          --person-testimonial-color: var(\n            --simple-colors-default-theme-accent-7\n          );\n          --person-testimonial-text: var(--simple-colors-default-theme-grey-12);\n        }\n\n        div.card {\n          display: inline-flex;\n          background-color: var(--person-testimonial-bg);\n          color: var(--person-testimonial-text);\n          font-family: var(--person-testimonial-font-family);\n          box-shadow: 0 2px 2px rgba(59, 43, 91, 0.7);\n        }\n\n        .image img {\n          display: block;\n          width: 150px;\n          height: 100%;\n        }\n        .image img {\n          max-width: 200px;\n        }\n        .image {\n          padding-right: 5px;\n          background-color: var(--person-testimonial-color);\n        }\n\n        svg {\n          fill: var(--person-testimonial-color);\n          height: 24px;\n          width: 24px;\n        }\n\n        .wrap {\n          margin: 15px;\n        }\n\n        .testimonial {\n          line-height: 24px;\n          font-size: 16px;\n          font-style: italic;\n        }\n\n        .name {\n          font-size: 21px;\n          text-transform: uppercase;\n          font-weight: bold;\n          margin-top: 20px;\n        }\n\n        .position {\n          font-size: 14px;\n          margin-top: 5px;\n        }\n\n        .arrow_right {\n          width: 0;\n          height: 0;\n          border-top: 15px solid var(--person-testimonial-bg);\n          border-bottom: 15px solid var(--person-testimonial-bg);\n          border-left: solid 15px transparent;\n          background-color: var(--person-testimonial-color);\n          position: relative;\n          top: 55px;\n        }\n\n        #quotestart {\n          display: inline-flex;\n          transform: rotateY(180deg);\n        }\n\n        #quoteend {\n          display: inline-flex;\n        }\n        @media screen and (max-width: 850px) {\n          div.card {\n            display: flex;\n            flex-wrap: wrap;\n          }\n          .image img {\n            display: block;\n            border-radius: 50%;\n            width: 200px;\n            height: 200px;\n          }\n          .image {\n            margin-top: 25px;\n            border-radius: 50%;\n            padding: 5px;\n            margin-left: auto;\n            margin-right: auto;\n          }\n          .arrow_right {\n            display: none;\n          }\n          .name,\n          .position {\n            text-align: center;\n          }\n        }\n        @media screen and (max-width: 600px) {\n          .image img {\n            width: 150px;\n            height: 150px;\n          }\n        }\n      "]);

    _templateObject2_890f56a0625811eb9a9521b3fdb3953c = function _templateObject2_890f56a0625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject_890f56a0625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <div class=\"card\">\n        <div class=\"image\">\n          <img\n            src=\"", "\"\n            loading=\"lazy\"\n            aria-describedby=\"", "\"\n          />\n        </div>\n        <div class=\"arrow_right\"></div>\n        <div class=\"wrap\">\n          <div class=\"testimonial\">\n            <svg id=\"quotestart\">\n              <path d=\"M6 17h3l2-4V7H5v6h3zm8 0h3l2-4V7h-6v6h3z\"></path>\n            </svg>\n            <slot></slot>\n            <svg id=\"quoteend\">\n              <path d=\"M6 17h3l2-4V7H5v6h3zm8 0h3l2-4V7h-6v6h3z\"></path>\n            </svg>\n          </div>\n          <div class=\"name\">", "</div>\n          <div class=\"position\">", "</div>\n        </div>\n      </div>\n    "]);

    _templateObject_890f56a0625811eb9a9521b3fdb3953c = function _templateObject_890f56a0625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   * `person-testimonial`
   * @element person-testimonial
   * `Leaving a testimonial from a person to say your company rocks!`
   * @demo demo/index.html
   */
  var PersonTestimonial = /*#__PURE__*/function (_SimpleColors) {
    babelHelpers.inherits(PersonTestimonial, _SimpleColors);

    var _super = _createSuper(PersonTestimonial);

    function PersonTestimonial() {
      babelHelpers.classCallCheck(this, PersonTestimonial);
      return _super.apply(this, arguments);
    }

    babelHelpers.createClass(PersonTestimonial, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject_890f56a0625811eb9a9521b3fdb3953c(), this.image, this.describedBy, this.name, this.position);
      }
    }], [{
      key: "styles",
      get: function get() {
        return [].concat(babelHelpers.toConsumableArray(babelHelpers.get(babelHelpers.getPrototypeOf(PersonTestimonial), "styles", this)), [(0, _litElement.css)(_templateObject2_890f56a0625811eb9a9521b3fdb3953c())]);
      }
    }, {
      key: "tag",
      get: function get() {
        return "person-testimonial";
      }
    }, {
      key: "properties",
      get: function get() {
        return _objectSpread(_objectSpread({}, babelHelpers.get(babelHelpers.getPrototypeOf(PersonTestimonial), "properties", this)), {}, {
          /**
           * Aria-describedby data passed down to appropriate tag
           */
          describedBy: {
            type: String,
            attribute: "described-by"
          },

          /**
           * The profile image to display to the left of the quote.
           */
          image: {
            type: String
          },

          /**
           * Name of the person making the quote.
           */
          name: {
            type: String
          },

          /**
           * The title / position of the person in question.
           */
          position: {
            type: String
          }
        });
      }
    }, {
      key: "haxProperties",
      get: function get() {
        return {
          canScale: true,
          canPosition: true,
          canEditSource: true,
          gizmo: {
            title: "Testimonial",
            description: "A person saying a nice thing about us",
            icon: "editor:format-quote",
            color: "orange",
            groups: ["Content", "Presentation"],
            handles: [{
              type: "image",
              source: "image",
              title: "name",
              caption: "position",
              ariaDescribedby: "describedBy"
            }],
            meta: {
              author: "EberlyODL / LRNWebComponents"
            }
          },
          settings: {
            configure: [{
              property: "image",
              title: "Image",
              description: "Adds image to testimonial",
              inputMethod: "haxupload",
              icon: "editor:insert-photo"
            }, {
              property: "accentColor",
              title: "Accent color",
              description: "Select the accent color use",
              inputMethod: "colorpicker",
              icon: "editor:format-color-fill"
            }, {
              property: "dark",
              title: "Dark",
              description: "Use dark theme",
              inputMethod: "boolean",
              icon: "invert-colors"
            }, {
              property: "name",
              title: "Full Name",
              description: "Credit the person making the testimonial",
              inputMethod: "textfield",
              icon: "account-circle"
            }, {
              property: "position",
              title: "Position or Job Title",
              description: "List the position and job title",
              inputMethod: "textfield",
              icon: "icons:work"
            }, {
              slot: "",
              title: "User's testimonial:",
              description: "This is where you enter your testimonial.",
              inputMethod: "code-editor",
              required: true
            }],
            advanced: [{
              property: "describedBy",
              title: "aria-describedby",
              description: "Space-separated list of IDs for elements that describe the image.",
              inputMethod: "textfield"
            }]
          }
        };
      }
    }]);
    return PersonTestimonial;
  }(_simpleColors.SimpleColors);

  _exports.PersonTestimonial = PersonTestimonial;
  window.customElements.define(PersonTestimonial.tag, PersonTestimonial);
});