define(["exports", "../../../lit-element/lit-element.js", "./responsive-utility-behaviors.js"], function (_exports, _litElement, _responsiveUtilityBehaviors) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.ResponsiveUtilityElement = void 0;

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   * `responsive-utility-element`
   * A simpler way to use responsive utility.
   *
   * @element responsive-utility-element
   * @extends ResponsiveUtilityBehaviors
   * @see ResponsiveUtility
   * @demo ../demo/index.html
   */
  var ResponsiveUtilityElement = /*#__PURE__*/function (_ResponsiveUtilityBeh) {
    babelHelpers.inherits(ResponsiveUtilityElement, _ResponsiveUtilityBeh);

    var _super = _createSuper(ResponsiveUtilityElement);

    function ResponsiveUtilityElement() {
      babelHelpers.classCallCheck(this, ResponsiveUtilityElement);
      return _super.apply(this, arguments);
    }

    babelHelpers.createClass(ResponsiveUtilityElement, null, [{
      key: "tag",
      get: function get() {
        return "responsive-utility-element";
      }
    }]);
    return ResponsiveUtilityElement;
  }((0, _responsiveUtilityBehaviors.ResponsiveUtilityBehaviors)(_litElement.LitElement));

  _exports.ResponsiveUtilityElement = ResponsiveUtilityElement;
  window.customElements.define(ResponsiveUtilityElement.tag, ResponsiveUtilityElement);
});