define(["exports", "../../../../lit-element/lit-element.js", "../rich-text-editor-styles.js", "../buttons/rich-text-editor-button-styles.js", "../../../simple-popover/simple-popover.js", "../../../simple-fields/simple-fields.js", "./rich-text-editor-selection.js"], function (_exports, _litElement, _richTextEditorStyles, _richTextEditorButtonStyles, _simplePopover, _simpleFields, _richTextEditorSelection) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.RichTextEditorPrompt = void 0;

  function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

  function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { babelHelpers.defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

  function _templateObject2_9c266c60625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          --simple-fields-color: var(--rich-text-editor-focus-color, #000);\n          --simple-fields-invalid-color: var(\n            --rich-text-editor-error-color,\n            #800\n          );\n        }\n        #prompt {\n          display: block;\n          width: 300px;\n          max-width: 300px;\n          --simple-popover-padding: 0px;\n          z-index: 2;\n        }\n        #prompt[hidden] {\n          display: none;\n        }\n        #prompt #form {\n          display: flex;\n          flex-direction: column;\n          align-items: center;\n          justify-content: space-between;\n          z-index: 2;\n        }\n        #formfields {\n          width: calc(100% - 20px);\n          padding: 10px 10px 0;\n          overflow: visible;\n        }\n        #prompt simple-fields-field {\n          padding: 0;\n        }\n        #confirm,\n        #cancel {\n          min-width: unset;\n        }\n        #cancel {\n          color: var(--rich-text-editor-button-color);\n          background-color: var(--rich-text-editor-button-bg);\n        }\n        #cancel:focus,\n        #cancel:hover {\n          color: var(--rich-text-editor-button-hover-color);\n          background-color: var(--rich-text-editor-button-hover-bg);\n        }\n        #confirm {\n          color: var(--rich-text-editor-button-color);\n          background-color: var(--rich-text-editor-button-bg);\n        }\n        #confirm:focus,\n        #confirm:hover {\n          color: var(--rich-text-editor-button-hover-color);\n          background-color: var(--rich-text-editor-button-hover-bg);\n        }\n        .actions {\n          width: 100%;\n          padding-bottom: 3px;\n          display: flex;\n          align-items: center;\n          justify-content: flex-end;\n        }\n        .confirm-or-cancel {\n          min-width: 40px;\n        }\n      "]);

    _templateObject2_9c266c60625811eb9a9521b3fdb3953c = function _templateObject2_9c266c60625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject_9c266c60625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <simple-popover id=\"prompt\" auto for=\"", "\" ?hidden=\"", "\">\n        <form id=\"form\">\n          <simple-fields\n            id=\"formfields\"\n            autofocus\n            hide-line-numbers\n            .fields=\"", "\"\n            .value=\"", "\"\n          ></simple-fields>\n          <div class=\"actions\">\n            <button\n              id=\"cancel\"\n              class=\"rtebutton\"\n              controls=\"", "\"\n              @click=\"", "\"\n              tabindex=\"0\"\n            >\n              <simple-icon-lite id=\"icon\" aria-hidden=\"true\" icon=\"clear\">\n              </simple-icon-lite>\n              <span id=\"label\" class=\"offscreen\">Cancel</span>\n            </button>\n            <simple-tooltip id=\"tooltip\" for=\"cancel\">Cancel</simple-tooltip>\n            <button\n              id=\"confirm\"\n              class=\"rtebutton\"\n              controls=\"", "\"\n              @click=\"", "\"\n              tabindex=\"0\"\n            >\n              <simple-icon-lite id=\"icon\" aria-hidden=\"true\" icon=\"check\">\n              </simple-icon-lite>\n              <span id=\"label\" class=\"offscreen\">OK</span>\n            </button>\n            <simple-tooltip id=\"tooltip\" for=\"confirm\">OK</simple-tooltip>\n          </div>\n        </form>\n      </simple-popover>\n    "]);

    _templateObject_9c266c60625811eb9a9521b3fdb3953c = function _templateObject_9c266c60625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   * `rich-text-editor-prompt`
   * `A utility that manages state of multiple rich-text-prompts on one page.`
   *
   * @element rich-text-editor-prompt
   */
  var RichTextEditorPrompt = /*#__PURE__*/function (_RichTextEditorButton) {
    babelHelpers.inherits(RichTextEditorPrompt, _RichTextEditorButton);

    var _super = _createSuper(RichTextEditorPrompt);

    babelHelpers.createClass(RichTextEditorPrompt, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject_9c266c60625811eb9a9521b3fdb3953c(), this.for, !this.for, this.fields, this.value, this.for, this._cancel, this.for, this._confirm);
      }
      /**
       * Store tag name to make it easier to obtain directly.
       */

    }], [{
      key: "styles",
      get: function get() {
        return [].concat(babelHelpers.toConsumableArray(babelHelpers.get(babelHelpers.getPrototypeOf(RichTextEditorPrompt), "styles", this)), [(0, _litElement.css)(_templateObject2_9c266c60625811eb9a9521b3fdb3953c())]);
      }
    }, {
      key: "tag",
      get: function get() {
        return "rich-text-editor-prompt";
      } // properties available to custom element for data binding

    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * fields for prompt popover.
           */
          fields: {
            type: Array
          },

          /**
           * Is  target id.
           */
          for: {
            type: String
          },

          /**
           * selected text.
           */
          range: {
            type: Object
          },

          /**
           * selected node withing range
           * /
          selectedNode: {
            type: Object
          },
          /**
           * prefilled value of prompt
           */
          value: {
            type: Object
          }
        };
      }
      /**
       * Makes sure there is a utility ready and listening for elements.
       */

    }]);

    function RichTextEditorPrompt() {
      var _this;

      babelHelpers.classCallCheck(this, RichTextEditorPrompt);
      _this = _super.call(this);
      _this.__selection = window.RichTextEditorSelection.requestAvailability();
      window.addEventListener("rich-text-editor-prompt-open", _this.open.bind(babelHelpers.assertThisInitialized(_this))); // sets instance to current instance

      if (!window.RichTextEditorPrompt.instance) {
        window.RichTextEditorPrompt.instance = babelHelpers.assertThisInitialized(_this);
        return babelHelpers.possibleConstructorReturn(_this, babelHelpers.assertThisInitialized(_this));
      }

      return _this;
    }
    /**
     * life cycle, element is afixed to DOM
     * Makes sure there is a utility ready and listening for elements.
     */


    babelHelpers.createClass(RichTextEditorPrompt, [{
      key: "connectedCallback",
      value: function connectedCallback() {
        babelHelpers.get(babelHelpers.getPrototypeOf(RichTextEditorPrompt.prototype), "connectedCallback", this).call(this);
      }
    }, {
      key: "open",
      value: function open(e) {
        if (e) {
          this.for = this.__selection.id;
          this.button = e.detail;
          this.editor = this.button.editor;
          this.fields = babelHelpers.toConsumableArray(e.detail.fields);
          this.value = _objectSpread({}, e.detail.value);
        }
      }
    }, {
      key: "close",
      value: function close() {
        this.for = undefined;
        this.button = undefined;
        this.editor = undefined;
        this.fields = [];
        this.value = {};
      }
      /**
       * Handles cancel button
       * @param {event} e event
       * @returns {void}
       */

    }, {
      key: "_cancel",
      value: function _cancel(e) {
        e.preventDefault();
        this.button.cancel();
        this.close();
      }
      /**
       * Handles confirm button
       * @param {event} e event
       * @returns {void}
       */

    }, {
      key: "_confirm",
      value: function _confirm(e) {
        e.preventDefault();
        this.button.confirm(this.value);
        this.close();
      }
    }]);
    return RichTextEditorPrompt;
  }((0, _richTextEditorButtonStyles.RichTextEditorButtonStyles)((0, _richTextEditorStyles.RichTextEditorStyles)(_litElement.LitElement)));

  _exports.RichTextEditorPrompt = RichTextEditorPrompt;
  window.customElements.define(RichTextEditorPrompt.tag, RichTextEditorPrompt);
  // register globally so we can make sure there is only one
  window.RichTextEditorPrompt = window.RichTextEditorPrompt || {}; // request if this exists. This helps invoke element existing in dom
  // as well as that there is only one of them. That way we can ensure everything
  // is rendered through same modal

  window.RichTextEditorPrompt.requestAvailability = function () {
    if (!window.RichTextEditorPrompt.instance) {
      window.RichTextEditorPrompt.instance = document.createElement("rich-text-editor-prompt");
      document.body.appendChild(window.RichTextEditorPrompt.instance);
    }

    return window.RichTextEditorPrompt.instance;
  };
});