define(["exports", "../../../../lit-element/lit-element.js", "../rich-text-editor-styles.js", "../singletons/rich-text-editor-selection.js", "./rich-text-editor-breadcrumb.js"], function (_exports, _litElement, _richTextEditorStyles, _richTextEditorSelection, _richTextEditorBreadcrumb) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.RichTextEditorBreadcrumbs = void 0;

  function _templateObject4_9c4035f0625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n          background-color: var(--rich-text-editor-bg);\n          color: var(--rich-text-editor-button-color);\n          border: var(--rich-text-editor-border);\n          padding: 3px 10px;\n        }\n        :host([sticky]) {\n          position: sticky;\n          bottom: 0;\n        }\n        .selectednode {\n          background-color: var(--rich-text-editor-bg);\n        }\n\xA0\xA0\xA0\xA0\xA0\xA0"]);

    _templateObject4_9c4035f0625811eb9a9521b3fdb3953c = function _templateObject4_9c4035f0625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject3_9c4035f0625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral([" <span class=\"divider\"> &gt; </span> "]);

    _templateObject3_9c4035f0625811eb9a9521b3fdb3953c = function _templateObject3_9c4035f0625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject2_9c4035f0625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n              <rich-text-editor-breadcrumb\n                controls=\"", "\"\n                tag=\"", "\"\n                .target=\"", "\"\n                @breadcrumb-tap=\"", "\"\n              >\n              </rich-text-editor-breadcrumb>\n              ", "\n            "]);

    _templateObject2_9c4035f0625811eb9a9521b3fdb3953c = function _templateObject2_9c4035f0625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject_9c4035f0625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      ", "\n      ", "\n    "]);

    _templateObject_9c4035f0625811eb9a9521b3fdb3953c = function _templateObject_9c4035f0625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   * `rich-text-editor-breadcrumbs`
   * `A utility that manages state of multiple rich-text-prompts on one page.`
   *
   *  @element rich-text-editor-breadcrumbs
   */
  var RichTextEditorBreadcrumbs = /*#__PURE__*/function (_RichTextEditorStyles) {
    babelHelpers.inherits(RichTextEditorBreadcrumbs, _RichTextEditorStyles);

    var _super = _createSuper(RichTextEditorBreadcrumbs);

    babelHelpers.createClass(RichTextEditorBreadcrumbs, [{
      key: "render",
      value: function render() {
        var _this2 = this;

        return (0, _litElement.html)(_templateObject_9c4035f0625811eb9a9521b3fdb3953c(), this.label, !this.selectionAncestors ? "" : (this.selectionAncestors || []).map(function (ancestor, i) {
          return (0, _litElement.html)(_templateObject2_9c4035f0625811eb9a9521b3fdb3953c(), _this2.controls, ancestor.nodeName.toLowerCase(), ancestor, _this2._handleBreadcrumb, i + 1 >= (_this2.selectionAncestors || []).length ? "" : (0, _litElement.html)(_templateObject3_9c4035f0625811eb9a9521b3fdb3953c()));
        }));
      }
    }], [{
      key: "tag",

      /**
       * Store tag name to make it easier to obtain directly.
       */
      get: function get() {
        return "rich-text-editor-breadcrumbs";
      }
    }, {
      key: "styles",
      get: function get() {
        return [].concat(babelHelpers.toConsumableArray(babelHelpers.get(babelHelpers.getPrototypeOf(RichTextEditorBreadcrumbs), "styles", this)), [(0, _litElement.css)(_templateObject4_9c4035f0625811eb9a9521b3fdb3953c())]);
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * active rict-text-editor.
           */
          controls: {
            type: String
          },

          /**
           * Hide breadcrumbs
           */
          hidden: {
            type: Boolean,
            attribute: "hidden",
            reflect: true
          },

          /**
           * breadcrumb labels.
           */
          label: {
            type: String
          },

          /**
           * Should breadcrumbs stick to top so that it is always visible?
           */
          sticky: {
            type: Boolean,
            reflect: true
          },

          /**
           * array of ancestors of currently selected node
           */
          selectionAncestors: {
            type: Array
          }
        };
      }
    }]);

    function RichTextEditorBreadcrumbs() {
      var _this;

      babelHelpers.classCallCheck(this, RichTextEditorBreadcrumbs);
      _this = _super.call(this);
      _this.hidden = true;
      _this.sticky = false;
      _this.label = "Expand selection: ";
      return _this;
    }

    babelHelpers.createClass(RichTextEditorBreadcrumbs, [{
      key: "selectNode",
      value: function selectNode(node) {
        this.dispatchEvent(new CustomEvent("selectnode", {
          bubbles: true,
          composed: true,
          cancelable: true,
          detail: node
        }));
      }
      /**
       * handle a breadcrumb tap by updating the selected text
       *
       * @param {object} e the breadcrumb tap event
       * @returns {void}
       */

    }, {
      key: "_handleBreadcrumb",
      value: function _handleBreadcrumb(e) {
        console.log("_handleBreadcrumbs", e.detail.target);

        if (e.detail.target) {
          this.selectNode(e.detail.target);
          console.log("_handleBreadcrumbs 2", e.detail.target, this.range);
        }
      }
    }]);
    return RichTextEditorBreadcrumbs;
  }((0, _richTextEditorStyles.RichTextEditorStyles)(_litElement.LitElement));

  _exports.RichTextEditorBreadcrumbs = RichTextEditorBreadcrumbs;
  window.customElements.define(RichTextEditorBreadcrumbs.tag, RichTextEditorBreadcrumbs);
});