define(["exports", "../../../lit-element/lit-element.js"], function (_exports, _litElement) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.SimpleFieldsFieldset = void 0;

  function _templateObject5_974b7140625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        fieldset {\n          padding: var(--simple-fields-margin-small, 8px)\n            var(--simple-fields-margin, 16px);\n          margin: var(--simple-fields-margin-small, 8px) 0\n            var(--simple-fields-margin, 16px);\n          border: 1px solid var(--simple-fields-border-color-light, #ccc);\n          border-radius: var(--simple-fields-border-radius, 2px);\n          transition: all 0.3s ease-in-out;\n        }\n        :host(:last-of-type) {\n          margin-bottom: 0;\n        }\n        #label {\n          font-family: var(--simple-fields-font-family, sans-serif);\n          font-size: var(--simple-fields-font-size, 16px);\n          line-height: var(--simple-fields-line-height, 22px);\n        }\n        :host([error]) #label {\n          color: var(--simple-fields-error-color, #dd2c00);\n          transition: all 0.3s ease-in-out;\n        }\n        #description {\n          font-family: var(--simple-fields-detail-font-family, sans-serif);\n          font-size: var(--simple-fields-detail-font-size, 12px);\n          line-height: var(--simple-fields-detail-line-height, 22px);\n        }\n      "]);

    _templateObject5_974b7140625811eb9a9521b3fdb3953c = function _templateObject5_974b7140625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject4_974b7140625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <div id=\"item-fields\">\n        <slot></slot>\n      </div>\n    "]);

    _templateObject4_974b7140625811eb9a9521b3fdb3953c = function _templateObject4_974b7140625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject3_974b7140625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <div id=\"description\" ?hidden=\"", "\">\n        ", "\n      </div>\n    "]);

    _templateObject3_974b7140625811eb9a9521b3fdb3953c = function _templateObject3_974b7140625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject2_974b7140625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <legend id=\"label\" ?hidden=\"", "\">\n        ", "", "\n      </legend>\n    "]);

    _templateObject2_974b7140625811eb9a9521b3fdb3953c = function _templateObject2_974b7140625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject_974b7140625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <fieldset>", " ", " ", "</fieldset>\n    "]);

    _templateObject_974b7140625811eb9a9521b3fdb3953c = function _templateObject_974b7140625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   *`simple-fields-fieldset` takes in a JSON schema of type fieldset and builds a form,
   * exposing a `value` property that represents an array described by the schema.
   *
   * @group simple-fields
   * @element simple-fields-fieldset
   */
  var SimpleFieldsFieldset = /*#__PURE__*/function (_LitElement) {
    babelHelpers.inherits(SimpleFieldsFieldset, _LitElement);

    var _super = _createSuper(SimpleFieldsFieldset);

    function SimpleFieldsFieldset() {
      babelHelpers.classCallCheck(this, SimpleFieldsFieldset);
      return _super.apply(this, arguments);
    }

    babelHelpers.createClass(SimpleFieldsFieldset, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject_974b7140625811eb9a9521b3fdb3953c(), this.legend, this.desc, this.fields);
      }
    }, {
      key: "legend",
      get: function get() {
        return (0, _litElement.html)(_templateObject2_974b7140625811eb9a9521b3fdb3953c(), !this.label, this.label, this.error ? "*" : "");
      }
    }, {
      key: "desc",
      get: function get() {
        return (0, _litElement.html)(_templateObject3_974b7140625811eb9a9521b3fdb3953c(), !this.description, this.description);
      }
    }, {
      key: "fields",
      get: function get() {
        return (0, _litElement.html)(_templateObject4_974b7140625811eb9a9521b3fdb3953c());
      }
    }], [{
      key: "tag",
      get: function get() {
        return "simple-fields-fieldset";
      }
    }, {
      key: "styles",
      get: function get() {
        return [(0, _litElement.css)(_templateObject5_974b7140625811eb9a9521b3fdb3953c())];
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * whether the tabbed interface is disabled
           */
          disabled: {
            type: Boolean,
            reflect: true
          },

          /**
           * whether fieldset has fields with errors
           */
          error: {
            type: Boolean,
            reflect: true
          },

          /**
           * whether the tabbed interface is hidden
           */
          hidden: {
            type: Boolean,
            reflect: true
          },

          /**
           * whether the tabbed interface is hidden
           */
          readonly: {
            type: Boolean,
            reflect: true
          },

          /**
           * fieldset legend
           */
          label: {
            type: String,
            reflect: true
          },

          /**
           * unique name
           */
          name: {
            type: String,
            reflect: true,
            attribute: "name"
          },

          /**
           * optional description
           */
          description: {
            type: String
          }
        };
      }
    }]);
    return SimpleFieldsFieldset;
  }(_litElement.LitElement);

  _exports.SimpleFieldsFieldset = SimpleFieldsFieldset;
  window.customElements.define(SimpleFieldsFieldset.tag, SimpleFieldsFieldset);
});