define(["exports", "../../lit-element/lit-element.js", "../a11y-tabs/a11y-tabs.js", "../a11y-tabs/lib/a11y-tab.js"], function (_exports, _litElement, _a11yTabs, _a11yTab) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.TabList = void 0;

  function _templateObject3_8d8ffcc0625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n            <a11y-tab label=\"", "\">\n              <a\n                target=\"_blank\"\n                href=\"", "\"\n                tabindex=\"-1\"\n                rel=\"noopener noreferrer\"\n              >\n                <button raised>", "</button>\n              </a>\n            </a11y-tab>\n          "]);

    _templateObject3_8d8ffcc0625811eb9a9521b3fdb3953c = function _templateObject3_8d8ffcc0625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject2_8d8ffcc0625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <a11y-tabs>\n        ", "\n      </a11y-tabs>\n    "]);

    _templateObject2_8d8ffcc0625811eb9a9521b3fdb3953c = function _templateObject2_8d8ffcc0625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject_8d8ffcc0625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n          margin: 0 auto;\n          list-style: none;\n          display: block;\n          padding: 16px;\n          border-bottom: 1px solid black;\n        }\n        a11y-tabs {\n          align-items: center;\n          justify-items: center;\n        }\n        a11y-tab a {\n          text-decoration: none;\n          flex: unset;\n          height: unset;\n          width: 100%;\n          text-align: center;\n        }\n        button {\n          text-transform: unset;\n          width: 100%;\n          display: block;\n          min-width: unset;\n          margin: 0;\n          text-overflow: ellipsis;\n          overflow: hidden;\n        }\n        @media screen and (max-width: 600px) {\n          a11y-tab {\n            display: block;\n          }\n        }\n      "]);

    _templateObject_8d8ffcc0625811eb9a9521b3fdb3953c = function _templateObject_8d8ffcc0625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   * `tab-list`
   * @element tab-list
   * `A simple listing of tabed links / items`
   * @demo demo/index.html
   */
  var TabList = /*#__PURE__*/function (_LitElement) {
    babelHelpers.inherits(TabList, _LitElement);

    var _super = _createSuper(TabList);

    babelHelpers.createClass(TabList, null, [{
      key: "styles",
      get: function get() {
        return [(0, _litElement.css)(_templateObject_8d8ffcc0625811eb9a9521b3fdb3953c())];
      }
    }]);

    function TabList() {
      var _this;

      babelHelpers.classCallCheck(this, TabList);
      _this = _super.call(this);
      _this.tabs = [];
      return _this;
    }

    babelHelpers.createClass(TabList, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject2_8d8ffcc0625811eb9a9521b3fdb3953c(), this.tabs.map(function (tab) {
          return (0, _litElement.html)(_templateObject3_8d8ffcc0625811eb9a9521b3fdb3953c(), tab.label, tab.link, tab.label);
        }));
      }
    }, {
      key: "updated",
      value: function updated(changedProperties) {
        var _this2 = this;

        changedProperties.forEach(function (oldValue, propName) {
          if (propName == "tabs") {
            // fire an event that this is a core piece of the system
            _this2.dispatchEvent(new CustomEvent("tabs-changed", {
              bubbles: true,
              cancelable: true,
              composed: true,
              detail: _this2[propName]
            }));
          }
        });
      }
    }], [{
      key: "tag",
      get: function get() {
        return "tab-list";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * List of tabs
           */
          tabs: {
            type: Array
          }
        };
      }
    }, {
      key: "haxProperties",
      get: function get() {
        return {
          canScale: false,
          canPosition: false,
          canEditSource: true,
          gizmo: {
            title: "Tabs",
            description: "A list of links as tabs.",
            icon: "icons:tab",
            color: "grey",
            groups: ["Presentation", "Links"],
            handles: [],
            meta: {
              author: "ELMS:LN"
            }
          },
          settings: {
            configure: [{
              property: "tabs",
              title: "Tabs",
              description: "Listing of tabs",
              inputMethod: "array",
              itemLabel: "label",
              properties: [{
                property: "link",
                title: "Link",
                description: "link to go to",
                inputMethod: "textfield",
                required: true
              }, {
                property: "label",
                title: "Label",
                description: "text to place on the tab",
                inputMethod: "textfield",
                required: true
              }]
            }],
            advanced: []
          }
        };
      }
    }]);
    return TabList;
  }(_litElement.LitElement);

  _exports.TabList = TabList;
  window.customElements.define(TabList.tag, TabList);
});