define(["exports", "require", "../../lit-element/lit-element.js"], function (_exports, _require, _litElement) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.TopicHeading = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

  function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { babelHelpers.defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

  function _templateObject4_8dc40510625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n        }\n\n        :host([hidden]) {\n          display: none;\n        }\n\n        relative-heading {\n          color: var(--topic-heading-text-color);\n          display: inline-flex;\n        }\n\n        simple-icon {\n          color: var(--topic-heading-icon-color);\n          display: inline-flex;\n          font-size: 16px;\n          --simple-icon-height: 32px;\n          --simple-icon-width: 32px;\n          padding: 16px;\n          line-height: 16px;\n          vertical-align: bottom;\n        }\n      "]);

    _templateObject4_8dc40510625811eb9a9521b3fdb3953c = function _templateObject4_8dc40510625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject3_8dc40510625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n          <relative-heading text=\"", "\"\n            >", "</relative-heading\n          >\n        "]);

    _templateObject3_8dc40510625811eb9a9521b3fdb3953c = function _templateObject3_8dc40510625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject2_8dc40510625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral([" <simple-icon icon=\"", "\"></simple-icon> "]);

    _templateObject2_8dc40510625811eb9a9521b3fdb3953c = function _templateObject2_8dc40510625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject_8dc40510625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral([" ", "\n    ", ""]);

    _templateObject_8dc40510625811eb9a9521b3fdb3953c = function _templateObject_8dc40510625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   * `topic-heading`
   * `Semantic and visual meaning behind a heading break`
   * @demo demo/index.html
   * @element topic-heading
   */
  var TopicHeading = /*#__PURE__*/function (_LitElement) {
    babelHelpers.inherits(TopicHeading, _LitElement);

    var _super = _createSuper(TopicHeading);

    babelHelpers.createClass(TopicHeading, [{
      key: "render",
      // render function
      value: function render() {
        return (0, _litElement.html)(_templateObject_8dc40510625811eb9a9521b3fdb3953c(), this.icon ? (0, _litElement.html)(_templateObject2_8dc40510625811eb9a9521b3fdb3953c(), this.icon) : "", this.title ? (0, _litElement.html)(_templateObject3_8dc40510625811eb9a9521b3fdb3953c(), this.title, this.title) : "");
      } // haxProperty definition

    }], [{
      key: "styles",
      //styles function
      get: function get() {
        return [(0, _litElement.css)(_templateObject4_8dc40510625811eb9a9521b3fdb3953c())];
      }
    }, {
      key: "haxProperties",
      get: function get() {
        return {
          canScale: true,
          canPosition: true,
          canEditSource: true,
          gizmo: {
            title: "Topic heading",
            description: "Semantic and visual meaning behind a heading break",
            icon: "icons:android",
            color: "green",
            groups: ["Heading"],
            handles: [{
              type: "todo:read-the-docs-for-usage"
            }],
            meta: {
              author: "btopro",
              owner: "The Pennsylvania State University"
            }
          },
          settings: {
            configure: [{
              property: "icon",
              description: "",
              inputMethod: "iconpicker",
              required: false,
              icon: "icons:code"
            }, {
              property: "title",
              description: "",
              inputMethod: "textfield",
              required: false,
              icon: "icons:heading"
            }],
            advanced: []
          }
        };
      } // properties available to the custom element for data binding

    }, {
      key: "properties",
      get: function get() {
        return _objectSpread(_objectSpread({}, babelHelpers.get(babelHelpers.getPrototypeOf(TopicHeading), "properties", this)), {}, {
          icon: {
            type: String
          },
          title: {
            type: String
          }
        });
      }
    }]);

    function TopicHeading() {
      var _this;

      babelHelpers.classCallCheck(this, TopicHeading);
      _this = _super.call(this);
      _this.icon = "";
      _this.title = "";
      new Promise(function (res, rej) {
        return _require.default(["../relative-heading/relative-heading.js"], res, rej);
      });
      return _this;
    }

    babelHelpers.createClass(TopicHeading, [{
      key: "firstUpdated",
      value: function firstUpdated() {
        if (this.icon) {
          new Promise(function (res, rej) {
            return _require.default(["../simple-icon/simple-icon.js"], res, rej);
          });
          new Promise(function (res, rej) {
            return _require.default(["../simple-icon/lib/simple-icons.js"], res, rej);
          });
          new Promise(function (res, rej) {
            return _require.default(["../simple-icon/lib/simple-icon-button.js"], res, rej);
          });
        }
      }
      /**
       * Store the tag name to make it easier to obtain directly.
       * @notice function name must be here for tooling to operate correctly
       */

    }], [{
      key: "tag",
      get: function get() {
        return "topic-heading";
      }
    }]);
    return TopicHeading;
  }(_litElement.LitElement);

  _exports.TopicHeading = TopicHeading;
  window.customElements.define(TopicHeading.tag, TopicHeading);
});