define(["exports", "meta", "../../lit-element/lit-element.js", "./lib/vmsg-fork.js", "../simple-icon/simple-icon.js", "../simple-icon/lib/simple-icons.js"], function (_exports, meta, _litElement, _vmsgFork, _simpleIcon, _simpleIcons) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.VoiceRecorder = void 0;
  meta = babelHelpers.interopRequireWildcard(meta);

  function _templateObject2_8e0db840625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: inline-flex;\n        }\n      "]);

    _templateObject2_8e0db840625811eb9a9521b3fdb3953c = function _templateObject2_8e0db840625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject_8e0db840625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <button @click=\"", "\">\n        <simple-icon icon=\"", "\"></simple-icon>", "\n      </button>\n      <slot></slot>\n    "]);

    _templateObject_8e0db840625811eb9a9521b3fdb3953c = function _templateObject_8e0db840625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   * `voice-recorder`
   * `LAME bridge`
   *
   * @demo demo/index.html
   * @element voice-recorder
   */
  var VoiceRecorder = /*#__PURE__*/function (_LitElement) {
    babelHelpers.inherits(VoiceRecorder, _LitElement);

    var _super = _createSuper(VoiceRecorder);

    babelHelpers.createClass(VoiceRecorder, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject_8e0db840625811eb9a9521b3fdb3953c(), this.recordState, this.iconState, this.textState);
      }
    }], [{
      key: "styles",
      get: function get() {
        return [(0, _litElement.css)(_templateObject2_8e0db840625811eb9a9521b3fdb3953c())];
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          iconState: {
            type: String
          },
          textState: {
            type: String
          },
          recording: {
            type: Boolean
          }
        };
      }
      /**
       * Convention we use
       */

    }, {
      key: "tag",
      get: function get() {
        return "voice-recorder";
      }
      /**
       * HTMLElement
       */

    }]);

    function VoiceRecorder() {
      var _this;

      babelHelpers.classCallCheck(this, VoiceRecorder);
      _this = _super.call(this);
      _this.recording = false;
      setTimeout(function () {
        _this.addEventListener("vmsg-ready", _this.vmsgReady.bind(babelHelpers.assertThisInitialized(_this)));
      }, 0);
      return _this;
    }

    babelHelpers.createClass(VoiceRecorder, [{
      key: "recordState",
      value: function recordState(e) {
        this.recording = !this.recording;
      }
      /**
       * LitElement life cycle - property changed
       */

    }, {
      key: "updated",
      value: function updated(changedProperties) {
        var _this2 = this;

        changedProperties.forEach(function (oldValue, propName) {
          if (propName == "recording") {
            if (_this2[propName]) {
              _this2.textState = "stop";
              _this2.iconState = "av:stop";
            } else {
              _this2.textState = "Record";
              _this2.iconState = "av:play-arrow";
            } // observer to act on the recording piece


            _this2.toggleRecording(_this2[propName], oldValue);
          }
        });
      }
    }, {
      key: "vmsgReady",
      value: function vmsgReady(e) {
        console.warn(e.detail.value);
      }
      /**
       * Toggle the LAME bridge
       */

    }, {
      key: "toggleRecording",
      value: function toggleRecording(newValue, oldValue) {
        var _this3 = this;

        if (newValue) {
          // need to start...
          (0, _vmsgFork.record)({
            wasmURL: this.pathFromUrl(decodeURIComponent(meta.url)) + "../../node_modules/vmsg/vmsg.wasm"
          }, this).then(function (blob) {
            _this3.dispatchEvent(new CustomEvent("voice-recorder-recording", {
              value: blob
            }));
          });
        }
      }
    }, {
      key: "pathFromUrl",
      value: function pathFromUrl(url) {
        return url.substring(0, url.lastIndexOf("/") + 1);
      }
    }]);
    return VoiceRecorder;
  }(_litElement.LitElement);

  _exports.VoiceRecorder = VoiceRecorder;
  customElements.define(VoiceRecorder.tag, VoiceRecorder);
});