define(["exports", "../../lit-element/lit-element.js", "../cms-hax/cms-hax.js", "../hax-body/lib/hax-store.js"], function (_exports, _litElement, _cmsHax, _haxStore) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.WysiwygHax = void 0;

  function _templateObject2_8e31e210625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n        }\n      "]);

    _templateObject2_8e31e210625811eb9a9521b3fdb3953c = function _templateObject2_8e31e210625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _templateObject_8e31e210625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <textarea\n        class=\"", "\"\n        id=\"", "\"\n        name=\"", "\"\n        hidden=\"\"\n      >\n      ", "\n      </textarea\n      >\n      <cms-hax\n        hide-message=\"\"\n        redirect-location=\"", "\"\n        update-page-data=\"", "\"\n        .end-point=\"", "\"\n        app-store-connection=\"", "\"\n        offset-margin=\"", "\"\n        .allowed-tags=\"", "\"\n        ?open-default=\"", "\"\n        ?sync-body=\"", "\"\n        ?hide-panel-ops=\"", "\"\n        ?hide-preferences-button=\"", "\"\n        element-align=\"", "\"\n      >\n      </cms-hax>\n    "]);

    _templateObject_8e31e210625811eb9a9521b3fdb3953c = function _templateObject_8e31e210625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   * `wysiwyg-hax`
   * `Integration of wysiwyg edit form for a page with HAX.`
   * @demo demo/index.html
   * @element wysiwyg-hax
   */
  var WysiwygHax = /*#__PURE__*/function (_LitElement) {
    babelHelpers.inherits(WysiwygHax, _LitElement);

    var _super = _createSuper(WysiwygHax);

    babelHelpers.createClass(WysiwygHax, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject_8e31e210625811eb9a9521b3fdb3953c(), this.fieldClass, this.fieldId, this.fieldName, this.bodyValue, this.redirectLocation, this.updatePageData, this.endPoint, this.appStoreConnection, this.offsetMargin, this.allowedTags, this.openDefault, this.syncBody, this.hidePanelOps, this.hidePreferencesButton, this.elementAlign);
      }
    }], [{
      key: "styles",

      /**
       * LitElement constructable styles enhancement
       */
      get: function get() {
        return [(0, _litElement.css)(_templateObject2_8e31e210625811eb9a9521b3fdb3953c())];
      }
    }, {
      key: "tag",
      get: function get() {
        return "wysiwyg-hax";
      }
    }]);

    function WysiwygHax() {
      var _this;

      babelHelpers.classCallCheck(this, WysiwygHax);
      _this = _super.call(this); // import child nodes before things start deleting whats in there

      var template = _this.querySelector("template");

      if (template) {
        _this.__importContent = template.cloneNode(true);
      }

      _this.openDefault = false;
      _this.elementAlign = "right";
      _this.fieldId = "textarea-input-field";
      _this.fieldName = "data[content]";
      _this.endPoint = null;
      _this.allowedTags = [];
      _this.redirectLocation = "";
      _this.updatePageData = "";
      return _this;
    }

    babelHelpers.createClass(WysiwygHax, [{
      key: "updated",
      value: function updated(changedProperties) {
        var _this2 = this;

        changedProperties.forEach(function (oldValue, propName) {
          if (propName == "saveButtonSelector" && _this2[propName].tagName) {
            _this2.saveButtonSelector.addEventListener("click", _this2.__saveClicked.bind(_this2));
          }
        });
      }
    }, {
      key: "createRenderRoot",

      /**
       * forces the creation of a light dom node
       */
      value: function createRenderRoot() {
        return this;
      }
    }, {
      key: "firstUpdated",
      value: function firstUpdated() {
        this.querySelector("cms-hax").appendChild(this.__importContent);
      }
      /**
       * HTMLElement
       */

    }, {
      key: "connectedCallback",
      value: function connectedCallback() {
        babelHelpers.get(babelHelpers.getPrototypeOf(WysiwygHax.prototype), "connectedCallback", this).call(this);
        window.addEventListener("hax-save", this._bodyContentUpdated.bind(this));
      }
      /**
       * HTMLElement
       */

    }, {
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        window.removeEventListener("hax-save", this._bodyContentUpdated.bind(this));

        if (this.saveButtonSelector && this.saveButtonSelector.tagName) {
          this.saveButtonSelector.removeEventListener("click", this.__saveClicked.bind(this));
        }

        babelHelpers.get(babelHelpers.getPrototypeOf(WysiwygHax.prototype), "disconnectedCallback", this).call(this);
      }
    }, {
      key: "__saveClicked",
      value: function __saveClicked(e) {
        _haxStore.HAXStore.skipExitTrap = true;

        if (_haxStore.HAXStore.editMode) {
          _haxStore.HAXStore.editMode = false;
        } // will attempt to set this right before save goes out the door


        this.bodyValue = _haxStore.HAXStore.activeHaxBody.haxToContent();
      }
      /**
       * Set the bubbled up event to the body value that just got changed
       */

    }, {
      key: "_bodyContentUpdated",
      value: function _bodyContentUpdated(e) {
        var _this3 = this;

        this.bodyValue = _haxStore.HAXStore.activeHaxBody.haxToContent();
        setTimeout(function () {
          if (_this3.saveButtonSelector) {
            _this3.saveButtonSelector.click();
          }
        }, 100);
      }
    }], [{
      key: "properties",
      get: function get() {
        return {
          /**
           * Default the panel to open
           */
          openDefault: {
            type: Boolean,
            attribute: "open-default"
          },
          redirectLocation: {
            type: String,
            attribute: "redirect-location"
          },

          /**
           * Hide the panel operations (save and cancel),
           */
          hidePanelOps: {
            type: Boolean,
            attribute: "hide-panel-ops"
          },

          /**
           * Hide preferences button
           */
          hidePreferencesButton: {
            type: Boolean,
            attribute: "hide-preferences-button"
          },

          /**
           * Direction to align the hax edit panel
           */
          elementAlign: {
            type: String,
            attribute: "element-align"
          },
          offsetMargin: {
            type: String,
            attribute: "offset-margin"
          },

          /**
           * Data binding of a hidden text area with the value from the hax-body tag
           */
          bodyValue: {
            type: String,
            attribute: "body-value"
          },

          /**
           * allowed Tags, usually as dictated by the input filtering
           * layer of the backend system that HAX is riding on.
           * While not fullproof, this at least will enforce front-end
           * filtering to match what actually is going to be allowed
           * to be saved in the first place.
           */
          allowedTags: {
            type: Array,
            attribute: "allowed-tags"
          },

          /**
           * Connection object for talking to an app store.
           */
          appStoreConnection: {
            type: String,
            attribute: "app-store-connection"
          },

          /**
           * Object reference that will get clicked on
           */
          saveButtonSelector: {
            type: Object
          },

          /**
           * class on the field
           */
          fieldClass: {
            type: String,
            attribute: "field-class"
          },

          /**
           * fieldId, id value on the input field.
           */
          fieldId: {
            type: String,
            attribute: "field-id"
          },

          /**
           * fieldName, internal to the form in whatever system it's in.
           */
          fieldName: {
            type: String,
            attribute: "field-name"
          },
          syncBody: {
            type: Boolean,
            attribute: "sync-body",
            reflect: true
          },

          /**
           * Location to save content to.
           */
          endPoint: {
            type: String,
            attribute: "end-point"
          },

          /**
           * Page data, body of text as a string.
           */
          updatePageData: {
            type: String,
            attribute: "update-page-data"
          }
        };
      }
    }]);
    return WysiwygHax;
  }(_litElement.LitElement);

  _exports.WysiwygHax = WysiwygHax;
  window.customElements.define(WysiwygHax.tag, WysiwygHax);
});