define(["../../polymer/polymer-legacy.js", "../../iron-flex-layout/iron-flex-layout.js", "../../polymer/lib/legacy/polymer-fn.js", "../../polymer/lib/utils/html-tag.js"], function (_polymerLegacy, _ironFlexLayout, _polymerFn, _htmlTag) {
  "use strict";

  function _templateObject_a53b8ec0625811eb9a9521b3fdb3953c() {
    var data = babelHelpers.taggedTemplateLiteral(["\n    <style>\n\n      :host {\n        @apply --layout-horizontal;\n        @apply --layout-center;\n        position: relative;\n        height: 64px;\n        padding: 0 16px;\n        pointer-events: none;\n        font-size: var(--app-toolbar-font-size, 20px);\n      }\n\n      :host ::slotted(*) {\n        pointer-events: auto;\n      }\n\n      :host ::slotted(paper-icon-button) {\n        /* paper-icon-button/issues/33 */\n        font-size: 0;\n      }\n\n      :host ::slotted([main-title]),\n      :host ::slotted([condensed-title]) {\n        pointer-events: none;\n        @apply --layout-flex;\n      }\n\n      :host ::slotted([bottom-item]) {\n        position: absolute;\n        right: 0;\n        bottom: 0;\n        left: 0;\n      }\n\n      :host ::slotted([top-item]) {\n        position: absolute;\n        top: 0;\n        right: 0;\n        left: 0;\n      }\n\n      :host ::slotted([spacer]) {\n        margin-left: 64px;\n      }\n    </style>\n\n    <slot></slot>\n"]);

    _templateObject_a53b8ec0625811eb9a9521b3fdb3953c = function _templateObject_a53b8ec0625811eb9a9521b3fdb3953c() {
      return data;
    };

    return data;
  }

  /**
  app-toolbar is a horizontal toolbar containing items that can be used for
  label, navigation, search and actions.
  
  ### Example
  
  Add a title to the toolbar.
  
  ```html
  <app-toolbar>
    <div main-title>App name</div>
  </app-toolbar>
  ```
  
  Add a button to the left and right side of the toolbar.
  
  ```html
  <app-toolbar>
    <paper-icon-button icon="menu"></paper-icon-button>
    <div main-title>App name</div>
    <paper-icon-button icon="search"></paper-icon-button>
  </app-toolbar>
  ```
  
  You can use the attributes `top-item` or `bottom-item` to completely fit an
  element to the top or bottom of the toolbar respectively.
  
  ### Content attributes
  
  Attribute            | Description
  ---------------------|---------------------------------------------------------
  `main-title`         | The main title element.
  `condensed-title`    | The title element if used inside a condensed app-header.
  `spacer`             | Adds a left margin of `64px`.
  `bottom-item`        | Sticks the element to the bottom of the toolbar.
  `top-item`           | Sticks the element to the top of the toolbar.
  
  ### Styling
  
  Custom property              | Description                  | Default
  -----------------------------|------------------------------|-----------------------
  `--app-toolbar-font-size`    | Toolbar font size            | 20px
  
  @element app-toolbar
  @demo app-toolbar/demo/index.html
  */
  (0, _polymerFn.Polymer)({
    /** @override */
    _template: (0, _htmlTag.html)(_templateObject_a53b8ec0625811eb9a9521b3fdb3953c()),
    is: 'app-toolbar'
  });
});