define(["exports"], function (_exports) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.stripExtraTrailingSlash = stripExtraTrailingSlash;
  _exports.parseQuery = parseQuery;
  _exports.parseParams = parseParams;
  _exports.patternToRegExp = patternToRegExp;
  _exports.testRoute = testRoute;

  function stripExtraTrailingSlash(str) {
    while (str.length !== 1 && str.substr(-1) === '/') {
      str = str.substr(0, str.length - 1);
    }

    return str;
  }

  function parseQuery(querystring) {
    return querystring ? JSON.parse('{"' + querystring.substring(1).replace(/&/g, '","').replace(/=/g, '":"') + '"}') : {};
  }

  function parseParams(pattern, uri) {
    var params = {};
    var patternArray = pattern.split('/').filter(function (path) {
      return path != '';
    });
    var uriArray = uri.split('/').filter(function (path) {
      return path != '';
    });
    patternArray.map(function (pattern, i) {
      if (/^:/.test(pattern)) {
        params[pattern.substring(1)] = uriArray[i];
      }
    });
    return params;
  }

  function patternToRegExp(pattern) {
    if (pattern) {
      return new RegExp('^(|/)' + pattern.replace(/:[^\s/]+/g, "([\\w\xC0-\xD6\xD8-\xF6\xF8-\xFF-]+)") + '(|/)$');
    } else {
      return new RegExp('(^$|^/$)');
    }
  }

  function testRoute(uri, pattern) {
    if (patternToRegExp(pattern).test(uri)) {
      return true;
    }
  }
});