define(["exports", "../@a11y/focus-trap/index.js", "./web-dialog.js", "./util.js"], function (_exports, _index, _webDialog, _util) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.openDialog = openDialog;

  /**
   * Opens a dialog and appends it to the container.
   * @param $content
   * @param $container
   * @param center
   * @param initialize
   */
  function openDialog() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        $content = _ref.$content,
        _ref$$container = _ref.$container,
        $container = _ref$$container === void 0 ? document.body : _ref$$container,
        _ref$center = _ref.center,
        center = _ref$center === void 0 ? false : _ref$center,
        _ref$initialize = _ref.initialize,
        initialize = _ref$initialize === void 0 ? function () {
      return new _webDialog.WebDialog();
    } : _ref$initialize;

    // Construct the dialog.
    var $dialog = initialize(); // Set the relevant properties of the dialog.

    if (center != null) {
      $dialog.center = center;
    } // Attach the content to the dialog.


    if ($content != null) {
      if (typeof $content === "function") {
        $content($dialog);
      } else {
        $dialog.appendChild($content);
      }
    } // Create a resolver that resolves when the dialog closes.


    var resolver = new Promise(function (res) {
      $dialog.addEventListener("close", function (e) {
        $dialog.remove();
        res(e.detail);
      }, {
        once: true
      });
    }); // Append the dialog to the container and open it.

    $container.appendChild($dialog);
    $dialog.show();
    return {
      $dialog: $dialog,
      resolver: resolver
    };
  }
});