import{LitElement as e,html as t,css as o}from"../../lit-element/lit-element.js";import"../simple-icon/lib/simple-icon-button-lite.js";import"../simple-icon/lib/simple-icon-lite.js";import"../simple-icon/lib/simple-icons.js";import"../simple-tooltip/simple-tooltip.js";class A11yCollapse extends e{static get styles(){return[o`
        :host {
          display: block;
          margin: var(--a11y-collapse-margin, 15px 0);
          border: var(--a11y-collapse-border, 1px solid);
          border-color: var(--a11y-collapse-border-color, inherit);
          transition: all 0.5s cubic-bezier(0.075, 0.82, 0.165, 1);
        }
        :host(:not(:first-of-type)) {
          border-top: var(
            --a11y-collapse-border-between,
            var(--a11y-collapse-border, 1px solid)
          );
        }
        :host([disabled]) {
          opacity: 0.5;
        }
        *[aria-controls="content"][disabled] {
          cursor: not-allowed;
        }
        #heading {
          display: flex;
          justify-content: stretch;
          align-items: center;
          padding: 0
            var(
              --a11y-collapse-padding-right,
              var(--a11y-collapse-horizontal-padding, 16px)
            )
            0
            var(
              --a11y-collapse-padding-left,
              var(--a11y-collapse-horizontal-padding, 16px)
            );
          font-weight: var(--a11y-collapse-heading-font-weight, bold);
          margin: var(--a11y-collapse-margin, unset);
          color: var(--a11y-collapse-heading-color, unset);
          background-color: var(
            --a11y-collapse-heading-background-color,
            unset
          );
        }
        :host([disabled]) #heading {
          color: var(--a11y-collapse-disabled-heading-color, unset);
          background-color: var(
            --a11y-collapse-heading-disabled-background-color,
            unset
          );
        }
        #text {
          flex-grow: 1;
          overflow: hidden;
        }
        #expand {
          transform: rotate(0deg);
          transition: transform 0.75s ease;
          padding: (--a11y-collapse-icon-padding, unset);
        }
        #expand.rotated {
          transform: rotate(-90deg);
          transition: transform 0.75s ease;
        }
        #content {
          padding: 0
            var(
              --a11y-collapse-padding-right,
              var(--a11y-collapse-horizontal-padding, 16px)
            )
            0
            var(
              --a11y-collapse-padding-left,
              var(--a11y-collapse-horizontal-padding, 16px)
            );
          border-top: 0px solid;
          border-color: var(--a11y-collapse-border-color, inherit);
          max-height: 0;
          transition: all 0.75s ease;
          overflow-y: hidden;
        }
        :host #content-inner {
          max-height: 0;
          overflow-y: var(--a11y-collapse-overflow-y, hidden);
        }
        :host([expanded]) #content {
          padding: var(
              --a11y-collapse-padding-top,
              var(--a11y-collapse-vertical-padding, 16px)
            )
            var(
              --a11y-collapse-padding-right,
              var(--a11y-collapse-horizontal-padding, 16px)
            )
            var(
              --a11y-collapse-padding-bottom,
              var(--a11y-collapse-vertical-padding, 16px)
            )
            var(
              --a11y-collapse-padding-left,
              var(--a11y-collapse-horizontal-padding, 16px)
            );
          border-top: var(--a11y-collapse-border, 1px solid);
          border-color: var(--a11y-collapse-border-color, inherit);
          max-height: 200000000000vh;
        }
        :host([expanded]) #content-inner {
          max-height: var(--a11y-collapse-max-height, 200000000000vh);
          transition: max-height 0.75s ease;
        }
      `]}render(){return t`
      ${this.headingButton||this.accordion?this._makeHeadingButton():this._makeIconButton()}
      <div
        id="content"
        aria-hidden="${this.expanded?"false":"true"}"
        aria-labelledby="heading"
        aria-live="polite"
      >
        <div id="content-inner">
          <slot name="content"></slot>
          <slot></slot>
        </div>
      </div>
    `}static get tag(){return"a11y-collapse"}static get properties(){return{headingButton:{type:Boolean,reflect:!0,attribute:"heading-button"},disabled:{type:Boolean,reflect:!0,attribute:"disabled"},hidden:{type:Boolean,reflect:!0,attribute:"hidden"},expanded:{type:Boolean,reflect:!0},icon:{type:String},iconExpanded:{type:String,attribute:"icon-expanded"},label:{type:String},labelExpanded:{type:String,attribute:"label-expanded"},tooltip:{type:String},tooltipExpanded:{type:String,attribute:"tooltip-expanded"},accordion:{type:Boolean,reflect:!0,attribute:"accordion"}}}constructor(){super(),this.headingButton=!1,this.accordion=!1,this.disabled=!1,this.hidden=!1,this.expanded=!1,this.icon="icons:expand-more",this.label="expand / collapse",this.tooltip="toggle expand / collapse"}static get haxProperties(){return{canScale:!1,canPosition:!0,canEditSource:!0,gizmo:{title:"Single Expand Collapse",description:"A single instance of an expand collapse.",icon:"view-day",color:"grey",groups:["Content","Presentation","Collapse"]},settings:{configure:[{slot:"heading",title:"Heading",description:"The heading for the collapse.",inputMethod:"textfield"},{slot:"content",title:"Content",description:"The content for the collapse.",inputMethod:"code-editor"},{property:"headingButton",title:"Heading Button",description:"Make entire heading clickble instead of just the icon.",inputMethod:"boolean"},{property:"expanded",title:"Expanded",description:"Expand by default",inputMethod:"boolean"},{property:"disabled",title:"Disabled",inputMethod:"boolean"},{property:"icon",title:"Icon",description:"The icon for the toggle expand/collapse button.",inputMethod:"iconpicker",options:[]},{property:"iconExpanded",title:"Icon (when expanded)",description:"Optional: The icon for the toggle expand/collapse button when expanded",inputMethod:"iconpicker",options:[]},{property:"label",title:"Label",description:"The label of the toggle expand/collapse button",inputMethod:"textfield"},{property:"labelExpanded",title:"Label (when expanded)",description:"The label of the toggle expand/collapse button when expanded.",inputMethod:"textfield"},{property:"tooltip",title:"Tooltip",description:"The tooltip for the toggle expand/collapse button",inputMethod:"textfield"},{property:"tooltipExpanded",title:"Tooltip (when expanded)",description:"The tooltip for the toggle expand/collapse button when expanded",inputMethod:"textfield"}],advanced:[{property:"hidden",title:"Hidden",inputMethod:"boolean"}]}}}connectedCallback(){super.connectedCallback(),setTimeout(()=>{this.dispatchEvent(new CustomEvent("a11y-collapse-attached",{bubbles:!0,cancelable:!0,composed:!0,detail:this}))},0)}disconnectedCallback(){this.dispatchEvent(new CustomEvent("a11y-collapse-detached",{bubbles:!0,cancelable:!0,composed:!0,detail:this})),super.disconnectedCallback()}collapse(){this.toggle(!1)}expand(){this.toggle(!0)}toggle(e=!this.expanded){this.expanded=e}updated(e){e.forEach((e,t)=>{"expanded"===t&&this._fireToggleEvents()})}_fireToggleEvents(){this.dispatchEvent(new CustomEvent("toggle",{bubbles:!0,cancelable:!0,composed:!0,detail:this})),this.dispatchEvent(new CustomEvent("a11y-collapse-toggle",{bubbles:!0,cancelable:!0,composed:!0,detail:this})),this.expanded?this.dispatchEvent(new CustomEvent("expand",{bubbles:!0,cancelable:!0,composed:!0,detail:this})):this.dispatchEvent(new CustomEvent("collapse",{bubbles:!0,cancelable:!0,composed:!0,detail:this}))}_getExpanded(e,t,o){return o&&t?t:e}_makeHeadingButton(){return t`
      <div
        id="heading"
        aria-controls="content"
        aria-expanded="${this.expanded?"true":"false"}"
        role="button"
        @click="${this._onClick}"
        ?disabled="${this.disabled}"
        .label="${this._getExpanded(this.label,this.labelExpanded,this.expanded)}"
      >
        <div id="text"><slot name="heading"></slot></div>
        <simple-icon-lite
          id="expand"
          class="${this.expanded||this.iconExpanded?"":"rotated"}"
          .icon="${this._getExpanded(this.icon||"icons:expand-more",this.iconExpanded,this.expanded)}"
          aria-hidden="true"
        >
        </simple-icon-lite>
      </div>
      <simple-tooltip for="heading"
        >${this._getExpanded(this.tooltip,this.tooltipExpanded,this.expanded)}</simple-tooltip
      >
    `}_makeIconButton(){return t`
      <div id="heading">
        <div id="text"><slot name="heading"></slot></div>
        <simple-icon-button-lite
          id="expand"
          class="${this.expanded||this.iconExpanded?"":"rotated"}"
          @click="${this._onClick}"
          ?disabled="${this.disabled}"
          .label="${this._getExpanded(this.label,this.labelExpanded,this.expanded)}"
          .icon="${this._getExpanded(this.icon||"icons:expand-more",this.iconExpanded,this.expanded)}"
          aria-controls="content"
          aria-expanded="${this.expanded?"true":"false"}"
        >
        </simple-icon-button-lite>
        <simple-tooltip for="expand"
          >${this._getExpanded(this.tooltip,this.tooltipExpanded,this.expanded)}</simple-tooltip
        >
      </div>
    `}_onClick(){this.disabled||(this.toggle(),this.dispatchEvent(new CustomEvent("a11y-collapse-click",{bubbles:!0,cancelable:!0,composed:!0,detail:this})))}_makeAccordionButton(){this._makeHeadingButton()}}window.customElements.define(A11yCollapse.tag,A11yCollapse);export{A11yCollapse};