/**
 * Copyright 2020 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as t,html as e,css as o}from"../../../lit-element/lit-element.js";import{navigator as n}from"../../../lit-element-router/lit-element-router.js";import"../../simple-icon/lib/simple-icon-lite.js";class ElmslnStudioButton extends(n(t)){static get tag(){return"elmsln-studio-button"}static get properties(){return{path:{type:String},icon:{type:String}}}static get styles(){return o`
      :host {
        display: block;
      }
      :host([hidden]) {
        display: none;
      }
      button {
        border: none;
        background-color: transparent;
        display: flex;
        align-items: center;
        height: 26px;
        color: var(--elmsln-studio-button-icon-color);
      }
      button:focus,
      button:hover {
        outline: none;
      }
    `}constructor(){super(),this.path="",this.icon=""}render(){return e`
      <button @click="${this.buttonClick}">
        <slot name="before"></slot>
        ${this.icon?e`
              <simple-icon-lite
                aria-hidden="true"
                icon="${this.icon}"
              ></simple-icon-lite>
            `:""}
        <slot></slot>
      </button>
    `}buttonClick(t){this.navigate(`${window.ElmslnStudioPath||""}${this.path}`)}}customElements.define("elmsln-studio-button",ElmslnStudioButton);export{ElmslnStudioButton};