/**
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{html as t,css as e}from"../../lit-element/lit-element.js";import{SimpleColors as i}from"../simple-colors/simple-colors.js";class FilteredImage extends i{static get styles(){return[...super.styles,e`
        :host {
          display: block;
        }

        :host([hidden]) {
          display: none;
        }
      `]}render(){return t` <svg id="svg" viewBox="0 0 ${this.width} ${this.height}">
      <rect id="rect" x="0" y="0"></rect>
      <filter id="${this.__id}">
        <feColorMatrix
          id="matrix"
          type="matrix"
          values=" 1   0   0   0   0
               0   1   0   0   0
               0   0   1   0   0
               0   0   0   1   0 "
        />
      </filter>
      <image id="image" filter="url(#${this.__id})" x="0" y="0"></image>
    </svg>`}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!0,gizmo:{title:"Filtered image",description:"An image using an SVG filter. Can be used to make background images have more contrast with text.",icon:"icons:android",color:"green",groups:["Image"],handles:[{type:"todo:read-the-docs-for-usage"}],meta:{author:"nikkimk",owner:"The Pennsylvania State University"}},settings:{configure:[{property:"src",description:"",inputMethod:"textfield",required:!0,icon:"icons:link",validationType:"url"},{property:"alt",description:"",inputMethod:"alt",required:!0,icon:"icons:accessibility"}],advanced:[]},saveOptions:{unsetAttributes:["colors"]}}}static get properties(){return{...super.properties,src:{type:String},__id:{type:String},alt:{type:String},height:{type:String},width:{type:String},color:{type:String},strength:{type:Number},contrast:{type:Number},__matrix:{type:Array}}}static get tag(){return"filtered-image"}constructor(){super(),this.src="",this.alt="",this.height="",this.width="",this.color="#ffffff",this.strength=1,this.contrast=0}updated(t){t.forEach((t,e)=>{"src"==e&&this._srcChanged(this[e]),"height"==e&&this._heightChanged(this[e]),"width"==e&&this._widthChanged(this[e]),["src","matrix"].includes(e)&&(this.__id=this._getID(this.src,this.matrix)),["color","contrast","strength"].includes(e)&&(this.__matrix=this._getMatrix(this.color,this.contrast,this.strength))})}_heightChanged(){let t=this.shadowRoot.querySelector("#svg"),e=t.querySelector("#image"),i=t.querySelector("#rect");t.setAttribute("height",this.height),e.setAttribute("height",this.height),i.setAttribute("height",this.height)}_widthChanged(){let t=this.shadowRoot.querySelector("#svg"),e=t.querySelector("#image"),i=t.querySelector("#rect");t.setAttribute("width",this.width),e.setAttribute("width",this.width),i.setAttribute("width",this.width)}_srcChanged(){let t=this.shadowRoot.querySelector("#svg").querySelector("#image");t.setAttribute("href",this.src),t.setAttribute("xlink:href",this.src)}_getMatrix(t,e,i){let r=[[1,0,0,0,0],[0,1,0,0,0],[0,0,1,0,0],[0,0,0,1,0]],s=this.shadowRoot.querySelector("#svg").querySelector("#matrix"),h=null;if(t.startsWith("#")&&t.length>6)7===t.length&&(t+="ff"),r[0][0]=parseInt(t.substring(1,3),16)/255,r[1][1]=parseInt(t.substring(3,5),16)/255,r[2][2]=parseInt(t.substring(5,7),16)/255,r[3][3]=parseInt(t.substring(7,9),16)/255;else if(t.startsWith("#"))4===t.length&&(t+="f"),r[0][0]=parseInt(t.substring(1,2)+t.substring(1,2),16)/255,r[1][1]=parseInt(t.substring(2,3)+t.substring(2,3),16)/255,r[2][2]=parseInt(t.substring(3,4)+t.substring(3,4),16)/255,r[3][3]=parseInt(t.substring(4,5)+t.substring(4,5),16)/255;else if(t.startsWith("rgb")){h=t.replace(/rgba?\(/g,"").replace(/\)/g,"").split(","),r[0][0]=parseInt(h[0]/255),r[1][1]=parseInt(h[1]/255),r[2][2]=parseInt(h[2]/255),r[3][3]=r[3][3]||"1"}return 0!==e&&(r[0][3]=r[0][0]*e/100,r[1][3]=r[1][1]*e/100,r[2][3]=r[2][2]*e/100),1!==i&&(r[0][0]=r[0][0]+(1-i)*(1-r[0][0]),r[1][1]=r[1][1]+(1-i)*(1-r[1][1]),r[2][2]=r[2][2]+(1-i)*(1-r[2][2])),s.setAttribute("values",JSON.stringify(r).replace(/[,\[\]]/g," ")),r}_getID(t,e){return("svg"+Math.random()).replace(/0./g,"-")}}window.customElements.define(FilteredImage.tag,FilteredImage);export{FilteredImage};