import{LitElement as t,html as o,css as e}from"../../../lit-element/lit-element.js";import"../../simple-tooltip/simple-tooltip.js";import"../../simple-icon/lib/simple-icon-lite.js";import"../../hax-iconset/lib/simple-hax-iconset.js";class HaxToolbarItem extends t{static get styles(){return[e`
        :host {
          display: flex;
          box-sizing: border-box;
          height: 36px;
          width: 36px;
          transition: 0.2s opacity ease-in-out;
          --hax-contextual-action-text-color: white;
        }
        :host([large]),
        :host([mini]) {
          height: unset;
          width: unset;
        }
        :host([disabled]) {
          pointer-events: none;
          background-color: grey;
          opacity: 0.5;
        }
        :host([danger]) {
          --hax-contextual-action-hover-color: var(
            --simple-colors-default-theme-red-8,
            #ff7777
          );
        }
        :host([menu]) {
          width: 100%;
          position: relative;
          display: -ms-flexbox;
          display: -webkit-flex;
          display: flex;
          -ms-flex-direction: row;
          -webkit-flex-direction: row;
          flex-direction: row;
          -webkit-justify-content: flex-start;
          justify-content: flex-start;
          -webkit-font-smoothing: antialiased;
          font-size: 16px;
          font-weight: 400;
          line-height: 24px;
        }
        :host([menu]) button {
          -webkit-justify-content: flex-start;
          justify-content: flex-start;
        }
        #label {
          padding-left: 5px;
        }
        button {
          display: flex;
          align-items: center;
          min-width: 0;
          margin: 0;
          border: 0px;
          text-transform: none;
          padding: 0;
          border-radius: 0;
          font-size: 12px;
          transition: 0.2s all, 0 height;
          height: 36px;
          width: 36px;
          min-width: unset;
          background-color: var(
            --hax-contextual-action-color,
            var(--simple-colors-default-theme-grey-12, #007999)
          );

          color: var(
            --hax-contextual-action-text-color,
            var(--simple-colors-default-theme-grey-1, #fff)
          );
        }
        :host(:not([disabled])) button:active,
        :host(:not([disabled])) button:hover,
        :host(:not([disabled])) button:focus {
          background-color: var(
            --hax-contextual-action-hover-color,
            var(--simple-colors-default-theme-grey-8, #009dc7)
          );
          color: var(
            --hax-contextual-action-text-color,
            var(--simple-colors-default-theme-grey-1, #fff)
          );
          outline: 1px solid
            var(
              --hax-contextual-action-color,
              var(--simple-colors-default-theme-grey-8, #007999)
            );
          z-index: 2;
        }
        :host([default]) button {
          background: black;
        }
        :host([dark]:not([disabled])) button {
          background-color: var(--hax-color-text, #000000);
          color: var(--hax-color-bg-accent);
        }
        :host([dark]:not([disabled])) button:hover {
          background-color: var(--hax-color-bg-accent);
          color: var(--hax-color-text, #000000);
        }
        :host([dark]) button:active {
          background: var(--hax-color-bg-accent);
          color: var(--hax-color-text, #000000);
        }
        simple-icon-lite {
          --simple-icon-height: 20px;
          --simple-icon-width: 20px;
          padding: 0;
          margin: 0;
        }
        :host([mini]) button {
          width: 28px;
          height: 28px;
          padding: 1px;
          border: 0px;
        }
        :host([light]) button {
          background-color: #aaaaaa;
          color: #ffffff;
        }
        :host([circle]) button {
          border-radius: 50%;
          display: block;
        }
        :host([large]) button {
          border-radius: 0;
          width: unset;
          padding: 0px;
          border: 0px;
        }
        button:active,
        button:hover,
        button:focus {
          cursor: pointer;
        }
        :host([mini]:not([disabled])) button:active,
        :host([mini]:not([disabled])) button:hover,
        :host([mini]:not([disabled])) button:focus {
          outline: unset;
          border: 1px solid
            var(--hax-color-accent1, --simple-colors-default-theme-light-blue-7);
        }
        :host([menu]) button {
          padding: 0 8px;
          width: 100%;
          height: 36px;
        }
        :host([menu]:not([disabled])) button:hover {
          color: white;
        }
        .flip-icon {
          transform: rotateY(180deg);
        }
        simple-tooltip {
          --simple-tooltip-background: #000000;
          --simple-tooltip-opacity: 1;
          --simple-tooltip-text-color: #ffffff;
          --simple-tooltip-delay-in: 0;
          --simple-tooltip-duration-in: 100ms;
          --simple-tooltip-duration-out: 0;
          --simple-tooltip-border-radius: 0;
          --simple-tooltip-font-size: 14px;
        }
        simple-icon-lite {
          --simple-colors-default-theme-accent-8: white;
        }
        :host([disabled]) simple-icon-lite {
          --simple-colors-default-theme-accent-8: unset;
        }
      `]}render(){return o`
      <button
        .disabled="${this.disabled}"
        id="btn"
        tabindex="0"
        .title="${this.tooltip}"
      >
        <simple-icon-lite
          icon="${this.icon}"
          ?hidden="${""==this.icon}"
        ></simple-icon-lite>

        <span id="label" ?hidden="${""==this.label}"
          >${this.label}</span
        >
        <slot></slot>
      </button>
      <simple-tooltip
        for="btn"
        ?hidden="${""==this.tooltip}"
        id="tooltip"
        offset="10"
        position="${this.tooltipDirection}"
      >
        ${this.tooltip}
      </simple-tooltip>
    `}static get tag(){return"hax-toolbar-item"}constructor(){super(),this.simple=!1,this.circle=!1,this.corner="",this.large=!1,this.disabled=!1,this.dark=!1,this.danger=!1,this.menu=!1,this.mini=!1,this.icon="",this.label="",this.tooltip="",this.tooltipDirection="top",this.default=!1}updated(t){t.forEach((t,o)=>{"height"==o&&this.shadowRoot&&(this.shadowRoot.querySelector("#btn").style.height=this[o])})}static get properties(){return{corner:{type:String,reflect:!0},circle:{type:Boolean,reflect:!0},height:{type:String},disabled:{type:Boolean,reflect:!0},dark:{type:Boolean,reflect:!0},danger:{type:Boolean,reflect:!0},menu:{type:Boolean,reflect:!0},mini:{type:Boolean,reflect:!0},large:{type:Boolean,reflect:!0},icon:{type:String},label:{type:String},tooltip:{type:String},tooltipDirection:{type:String,attribute:"tooltip-direction"},default:{type:Boolean,reflect:!0}}}}window.customElements.define(HaxToolbarItem.tag,HaxToolbarItem);export{HaxToolbarItem};