import{LitElement as t,html as e,css as o}from"../../../lit-element/lit-element.js";import{MtzFileDownloadBehaviors as a}from"../../dl-behavior/dl-behavior.js";import{stripMSWord as n,formatHTML as i}from"../../utils/utils.js";import{HAXStore as d}from"./hax-store.js";class HaxViewSource extends(a(t)){static get styles(){return[o`
        :host {
          display: block;
          text-align: left;
        }
        #textarea {
          margin: 0;
          padding: 0;
          font-size: 10px;
          resize: none;
          width: 100%;
          height: 50vh;
          width: -webkit-fill-available;
          background-color: transparent;
          color: #eeeeee;
          font-family: monospace;
        }
        .buttons {
          margin-top: 20px;
          display: flex;
          justify-content: space-evenly;
          width: 100%;
        }
      `]}render(){return e`
      <div id="wrapper">
        <textarea id="hiddentextarea" hidden></textarea>
        <code-editor
          id="textarea"
          title=""
          theme="vs"
          language="html"
          font-size="12"
          word-wrap
        ></code-editor>
      </div>
      <div class="buttons">
        <hax-tray-button
          label="Update source"
          icon="icons:code"
          @click="${this.importContent.bind(this)}"
        >
        </hax-tray-button>
        <hax-tray-button
          @click="${this.scrubContent.bind(this)}"
          icon="editor:format-clear"
          label="Word / GDoc clean up"
        >
        </hax-tray-button>
        <hax-tray-button
          @click="${this.selectBody.bind(this)}"
          icon="icons:content-copy"
          label="Copy source"
        >
        </hax-tray-button>
        <hax-tray-button
          label="Download"
          icon="icons:file-download"
          @click="${this.download.bind(this)}"
        >
        </hax-tray-button>
        <hax-tray-button
          @click="${this.htmlToHaxElements.bind(this)}"
          label="HAXSchema"
          icon="hax:code-json"
        >
        </hax-tray-button>
      </div>
    `}static get tag(){return"hax-view-source"}download(t){const e=this.contentToFile(!1);this.downloadFromData(e,"html","my-new-code"),d.toast("HTML content downloaded"),this.close()}downloadfull(t){const e=this.contentToFile(!0);this.downloadFromData(e,"html","my-new-webpage"),d.toast("Working offline copy downloaded"),this.close()}importContent(t){const e=this.shadowRoot.querySelector("#textarea").value;d.toast("Content updated"),d.activeHaxBody.importContent(e),this.close()}scrubContent(t){const e=this.shadowRoot.querySelector("#textarea").value;d.toast("Scrubbed, Content updated"),d.activeHaxBody.importContent(n(e)),this.close()}close(){window.dispatchEvent(new CustomEvent("simple-modal-hide",{bubbles:!0,cancelable:!0,detail:{}}))}openSource(){import("../../code-editor/code-editor.js")}selectBody(t){let e=this.shadowRoot.querySelector("#hiddentextarea");e.value=this.shadowRoot.querySelector("#textarea").value,e.removeAttribute("hidden"),e.focus(),e.select(),document.execCommand("copy"),e.setAttribute("hidden","hidden"),d.toast("Copied HTML content"),this.close()}htmlToHaxElements(t){let e=d.htmlToHaxElements(this.shadowRoot.querySelector("#textarea").value);var o=JSON.stringify(e,null,2);let a=this.shadowRoot.querySelector("#textarea").value,n=this.shadowRoot.querySelector("#hiddentextarea");n.removeAttribute("hidden"),n.value=o,n.focus(),n.select(),document.execCommand("copy"),n.value=a,n.setAttribute("hidden","hidden"),d.toast("Copied hax elements to clipboard")}firstUpdated(t){super.firstUpdated&&super.firstUpdated(t),d.activeHaxBody&&(this.shadowRoot.querySelector("#textarea").editorValue=i(d.activeHaxBody.haxToContent()))}contentToFile(t){let e=d.activeHaxBody.haxToContent();var o=e;return t&&(o=`\n        <!DOCTYPE html>\n        <html lang="en">\n          <head>\n            <meta charset="utf-8" />\n            <meta\n              name="viewport"\n              content="width=device-width, minimum-scale=1, initial-scale=1, user-scalable=yes"\n            />\n            <title>hax-body demo</title>\n            <script>window.WCGlobalCDNPath="https://cdn.webcomponents.psu.edu/cdn/"; <\/script> <script src="https://cdn.webcomponents.psu.edu/cdn/build.js"><\/script> \n            <style>\n              body {\n                padding: 32px;\n              }\n            </style>\n          </head>\n          <body>\n          ${e}\n          </body>\n        </html>\n      `),o}constructor(){super(),this.fileTypes={CSV:"text/csv",JSON:"text/json",PDF:"application/pdf",TXT:"text/plain",HTML:"text/html"}}}window.customElements.define(HaxViewSource.tag,HaxViewSource);export{HaxViewSource};