import{LitElement as e,html as t,css as i}from"../../../../lit-element/lit-element.js";import{encapScript as a,findTagsInHTML as s,wipeSlot as o,varExists as d}from"../../../utils/utils.js";import{autorun as n,toJS as h}from"../../../../mobx/dist/mobx.esm.js";import{store as r}from"./haxcms-site-store.js";import{HAXStore as m}from"../../../hax-body/lib/hax-store.js";import"../../../simple-toast/simple-toast.js";import"../../../simple-progress/simple-progress.js";class HAXCMSSiteBuilder extends e{static get styles(){return[i`
        :host {
          display: block;
        }
        :host #slot {
          background-color: var(--haxcms-color, white);
          opacity: 0.2;
          visibility: hidden;
        }
        :host([dashboard-opened]) {
          display: inline-block !important;
          margin-left: 50vw;
          height: 100vh;
          pointer-events: none;
          opacity: 0.5;
          width: 100vw;
        }
        :host([theme-loaded]) #slot {
          opacity: 1;
          visibility: visible;
        }
        simple-progress {
          display: block;
          width: 100%;
          position: fixed;
          top: 0;
          left: 0;
          right: 0;
          background-color: transparent;
          z-index: 1000;
          --simple-progress-active-color: var(
            --haxcms-color,
            rgba(255, 255, 255, 0.5)
          );
        }
        simple-progress[disabled] {
          display: none;
        }
      `]}static get tag(){return"haxcms-site-builder"}render(){return t`
      <haxcms-site-router base-uri="${this.baseURI}"></haxcms-site-router>
      <simple-progress .disabled="${!this.loading}"></simple-progress>
      <div id="slot"><slot></slot></div>
      <slot name="haxcms-site-editor-ui-prefix-avatar"></slot>
      <slot name="haxcms-site-editor-ui-prefix-buttons"></slot>
      <slot name="haxcms-site-editor-ui-suffix-buttons"></slot>
      <simple-colors-polymer></simple-colors-polymer>
    `}_updateManifest(e){this.manifest={...e}}_updateLoading(e){this.loading=e.detail.value}_updateActiveItemContent(e){this.activeItemContent=e}async loadPageData(){if(this.activeItemLocation){this.loading=!0;let e=`${this.outlineLocation}${this.activeItemLocation}`;""!=this._timeStamp&&(-1!=e.indexOf("?")?e+="&"+this._timeStamp:e+="?"+this._timeStamp),await fetch(e).then(e=>e.text()).then(e=>{this._updateActiveItemContent(e),this.loading=!1}).catch(e=>{this.lastErrorChanged(e)})}}async loadJOSData(){if(this.file){this.loading=!0;let e=`${this.outlineLocation}${this.file}`;""!=this._timeStamp&&(-1!=e.indexOf("?")?e+="&"+this._timeStamp:e+="?"+this._timeStamp),await fetch(e).then(e=>e.json()).then(e=>{this._updateManifest(e),this.loading=!1}).catch(e=>{this.lastErrorChanged(e)})}}updated(e){let t=!1,i=!1;e.forEach((e,a)=>{["outlineLocation","activeItemLocation"].includes(a)&&""!=this[a]&&(i=!0),["outlineLocation","file"].includes(a)&&""!=this[a]&&(t=!0),"_timeStamp"==a&&(t=!0,i=!0),"dashboardOpened"==a?this._dashboardOpenedChanged(this[a],e):"themeData"==a?this._themeChanged(this[a],e):"themeName"==a?this._themeNameChanged(this[a],e):"outlineLocation"==a?this.dispatchEvent(new CustomEvent("outline-location-changed",{bubbles:!0,cancelable:!0,composed:!0,detail:this[a]})):"manifest"==a?(this.dispatchEvent(new CustomEvent("manifest-changed",{bubbles:!0,cancelable:!0,composed:!0,detail:this[a]})),this._manifestChanged(this[a],e)):"activeItem"==a?(this.dispatchEvent(new CustomEvent("active-item-changed",{bubbles:!0,cancelable:!0,composed:!0,detail:this[a]})),this._activeItemChanged(this[a],e)):"activeItemContent"==a&&(this.dispatchEvent(new CustomEvent("active-item-content-changed",{bubbles:!0,cancelable:!0,composed:!0,detail:this[a]})),this._activeItemContentChanged(this[a],e))}),t&&this.__ready&&this.loadJOSData(),i&&this.__ready&&this.loadPageData()}static get properties(){return{activeItemLocation:{type:String,attribute:"active-item-location"},_timeStamp:{type:String},dashboardOpened:{type:Boolean,reflect:!0,attribute:"dashboard-opened"},queryParams:{type:Object},loading:{type:Boolean,reflect:!0},outlineLocation:{type:String,attribute:"outline-location"},manifest:{type:Object},themeData:{type:Object},themeName:{type:String},__imported:{type:Object},themeLoaded:{type:Boolean,reflect:!0,attribute:"theme-loaded"},activeItem:{type:Object},activeItemContent:{type:String},file:{type:String},baseURI:{type:String,attribute:"base-uri"}}}_themeNameChanged(e){e&&(r.themeElement&&r.themeElement.remove(),o(this,"*"),r.themeElement=document.createElement(e),this.appendChild(r.themeElement))}lastErrorChanged(e){if(e)if(console.error(e),e.detail.value){window&&window.location&&window.appSettings&&window.appSettings.reloadOnError&&window.location.reload();const t=new CustomEvent("simple-toast-show",{bubbles:!0,composed:!0,cancelable:!1,detail:{text:e.detail.value.status+" "+e.detail.value.statusText}});window.dispatchEvent(t)}else window&&window.location&&window.appSettings&&window.appSettings.reloadOnError&&window.location.reload()}constructor(){super(),this.__disposer=[],this.queryParams={},this.loading=!1,this.__imported={},this.themeLoaded=!1,this.outlineLocation="",this.activeItemLocation="",import("./haxcms-site-router.js"),window.HAXCMS.requestAvailability().storePieces.siteBuilder=this,window.addEventListener("hax-store-ready",this.storeReady.bind(this)),window.addEventListener("haxcms-trigger-update",this._triggerUpdatedData.bind(this)),window.addEventListener("haxcms-trigger-update-node",this._triggerUpdatedNode.bind(this))}firstUpdated(e){for(var t in super.firstUpdated&&super.firstUpdated(e),this.__ready=!0,this.dispatchEvent(new CustomEvent("haxcms-ready",{bubbles:!0,composed:!0,cancelable:!1,detail:this})),this.children)if(this.children[t].tagName&&this.children[t].getAttribute("slot")){const e=this.children[t].cloneNode(!0);let i=e.getAttribute("slot");switch(i){case"haxcms-site-editor-ui-prefix-avatar":case"haxcms-site-editor-ui-prefix-buttons":case"haxcms-site-editor-ui-suffix-buttons":r.setupSlots[i]=e}}import("./haxcms-editor-builder.js").then(e=>{this.editorBuilder=document.createElement("haxcms-editor-builder"),document.body.appendChild(this.editorBuilder),"published"!==window.HAXCMS.requestAvailability().getApplicationContext()?this._timeStamp=Math.floor(Date.now()/1e3):this._timeStamp=""}).catch(e=>{console.warn(e)});var i=document.createEvent("UIEvents");i.initUIEvent("resize",!0,!1,window,0),window.dispatchEvent(i),setTimeout(()=>{n(e=>{this.dashboardOpened=h(r.dashboardOpened),this.__disposer.push(e)}),n(e=>{this.themeData=h(r.themeData),this.themeData&&this.themeData.element!==this.themeName&&(this.themeName=this.themeData.element),this.__disposer.push(e)}),n(e=>{this.activeItem=h(r.activeItem),this.activeItem&&this.activeItem.location&&(this.activeItemLocation=this.activeItem.location),this.__disposer.push(e)})},0)}_dashboardOpenedChanged(e,t){e?(this.setAttribute("aria-hidden","aria-hidden"),this.setAttribute("tabindex","-1")):!e&&t&&(this.removeAttribute("aria-hidden"),this.removeAttribute("tabindex"))}disconnectedCallback(){for(var e in this.__disposer)this.__disposer[e].dispose();window.removeEventListener("hax-store-ready",this.storeReady.bind(this)),window.removeEventListener("haxcms-trigger-update",this._triggerUpdatedData.bind(this)),window.removeEventListener("haxcms-trigger-update-node",this._triggerUpdatedNode.bind(this)),super.disconnectedCallback()}storeReady(e){r.cmsSiteEditor&&r.cmsSiteEditor.instance&&m.activeHaxBody&&r.activeItemContent&&m.activeHaxBody.importContent(r.activeItemContent)}_activeItemContentChanged(e,t){if(e){var i=e;null!==i&&(o(r.themeElement,"*"),i=a(e),r.activeItemContent=i,setTimeout(()=>{if(0===r.themeElement.childNodes.length){let e=document.createRange().createContextualFragment(i);r.themeElement.appendChild(e),this.dispatchEvent(new CustomEvent("json-outline-schema-active-body-changed",{bubbles:!0,composed:!0,cancelable:!1,detail:i}))}if(!window.WCAutoload&&d(this.manifest,"metadata.node.dynamicElementLoader")){let t=s(i);const a=this.pathFromUrl(decodeURIComponent(import.meta.url));for(var e in t){const i=t[e];this.manifest.metadata.node.dynamicElementLoader[i]&&!window.customElements.get(i)&&import(`${a}../../../../${this.manifest.metadata.node.dynamicElementLoader[i]}`).then(e=>{}).catch(e=>{console.warn(e)})}}else window.WCAutoload&&setTimeout(()=>{window.WCAutoload.process()},0)},5))}}_activeItemChanged(e,t){this.shadowRoot&&e&&void 0!==e.id?this.queryParams.nodeId=e.id:t&&!e&&this.dispatchEvent(new CustomEvent("json-outline-schema-active-body-changed",{bubbles:!0,composed:!0,cancelable:!1,detail:null}))}_triggerUpdatedData(e){this.editorBuilder?this._timeStamp=Math.floor(Date.now()/1e3):this._timeStamp=""}_triggerUpdatedNode(e){this.activeItem.location&&this.loadPageData()}_manifestChanged(e,t){e&&e.metadata&&e.items&&r.loadManifest(e,this)}pathFromUrl(e){return e.substring(0,e.lastIndexOf("/")+1)}_themeChanged(e,t){if(e){this.themeLoaded=!1;let t=e;if(void 0!==this.__imported[t.element])this.themeLoaded=!0;else if(window.WCAutoload)this.__imported[t.element]=t.element,this.themeLoaded=!0,setTimeout(()=>{window.WCAutoload.process()},5);else try{import(this.pathFromUrl(decodeURIComponent(import.meta.url))+"../../../../"+e.path).then(e=>{this.__imported[t.element]=t.element,this.themeLoaded=!0})}catch(e){this.themeLoaded=!0}}}}window.HAXme=function(e=null){null==e&&(e="demo",window.appSettings={login:"dist/dev/login.json",logout:"dist/dev/logout.json",saveNodePath:"dist/dev/saveNode.json",saveManifestPath:"dist/dev/saveManifestPath.json",createNodePath:"dist/dev/saveNode.json",deleteNodePath:"dist/dev/saveNode.json",saveOutlinePath:"dist/dev/saveNode.json",publishSitePath:"dist/dev/saveNode.json",syncSitePath:"dist/dev/saveNode.json",getNodeFieldsPath:"dist/dev/getNodeFieldsPath.json",getSiteFieldsPath:"dist/dev/getSiteFieldsPath.json",revertSitePath:"dist/dev/saveNode.json",getFormToken:"adskjadshjudfu823u823u8fu8fij",appStore:{url:"dist/dev/appstore.json"},themes:{"haxcms-dev-theme":{element:"haxcms-dev-theme",path:"@lrnwebcomponents/haxcms-elements/lib/haxcms-dev-theme.js",name:"Developer theme"}}}),"demo"==e&&(window.HAXCMSContext=!0),document.body&&(document.body.getElementsByTagName("haxcms-editor-builder")[0].__appliedContext=!1,document.body.getElementsByTagName("haxcms-editor-builder")[0].applyContext(e))},window.customElements.define(HAXCMSSiteBuilder.tag,HAXCMSSiteBuilder);export{HAXCMSSiteBuilder};