import{LitElement as t,html as e,css as i}from"../../../../lit-element/lit-element.js";import{store as o}from"./haxcms-site-store.js";import{autorun as s,toJS as a}from"../../../../mobx/dist/mobx.esm.js";import"../../../simple-icon/simple-icon.js";import"../../../simple-icon/lib/simple-icons.js";import"../../../simple-icon/lib/simple-icon-button.js";class HAXCMSSiteEditorUI extends t{static get styles(){return[i`
        :host *:not(:defined) {
          display: none;
        }
        :host {
          display: block;
          position: fixed;
          left: 0;
          top: 0;
          bottom: 0;
          background-color: var(--haxcms-system-bg, #37474f);
          z-index: 10000;
          border-right: 2px solid black;
          visibility: visible;
        }
        :host([edit-mode]) {
          z-index: 9999;
        }
        :host([dashboard-opened]) {
          left: 50vw;
        }
        @media screen and (max-width: 800px) {
          :host([dashboard-opened]) {
            left: 90vw;
          }
          :host([edit-mode]) {
            bottom: unset;
          }
        }
        /**
         * Dashboard open trumps all contextual settings
         */
        :host([dashboard-opened]) #editbutton,
        :host([dashboard-opened]) #editdetails,
        :host([dashboard-opened]) #deletebutton,
        :host([dashboard-opened]) #addbutton,
        :host([dashboard-opened]) #outlinebutton {
          display: none !important;
        }
        :host *[hidden] {
          display: none;
        }
        simple-tooltip:not(:defined) {
          display: none !important;
        }
        paper-avatar {
          width: 48px;
          height: 48px;
          line-height: 20px;
          padding: 12px;
        }
        :host([painting]) {
          opacity: 0;
          visibility: hidden;
        }
        simple-icon-button {
          display: block;
          --simple-icon-width: 24px;
          --simple-icon-height: 24px;
          border-radius: 50%;
          border: none;
          background-color: black;
          color: white;
          text-align: center;
          line-height: 40px;
          min-width: unset;
          padding: 0;
          margin: 4px 2px;
          width: 40px;
          height: 40px;
          transition: 0.2s all ease-in-out;
          position: relative;
          box-shadow: 0 8px 10px 1px rgba(0, 0, 0, 0.14),
            0 3px 14px 2px rgba(0, 0, 0, 0.12),
            0 5px 5px -3px rgba(0, 0, 0, 0.4);
        }
        paper-avatar:hover,
        paper-avatar:focus,
        paper-avatar:active {
          cursor: pointer;
        }
        simple-icon-button:hover,
        simple-icon-button:focus,
        simple-icon-button:active {
          background-color: var(--haxcms-color, blue);
          color: #ffffff;
        }
        #cancelbutton {
          background-color: var(--haxcms-system-danger-color);
        }
        #editbutton,
        #editdetails,
        #deletebutton {
          visibility: hidden;
          opacity: 0;
        }
        :host([page-allowed]) #editbutton,
        :host([page-allowed]) #editdetails,
        :host([page-allowed]) #deletebutton {
          visibility: visible;
          opacity: 1;
        }
        :host([edit-mode]) #editbutton {
          color: white;
          background-color: var(--haxcms-system-action-color, blue) !important;
        }
        :host([edit-mode]) #manifestbutton,
        :host([edit-mode]) #editdetails,
        :host([edit-mode]) #deletebutton,
        :host([edit-mode]) #addbutton,
        :host([edit-mode]) #outlinebutton {
          display: none !important;
        }

        :host(:hover),
        :host(:active),
        :host(:focus) {
          opacity: 1;
        }
        simple-tooltip {
          --simple-tooltip-background: #000000;
          --simple-tooltip-opacity: 1;
          --simple-tooltip-text-color: #ffffff;
          --simple-tooltip-delay-in: 0;
          --simple-tooltip-duration-in: 200ms;
          --simple-tooltip-duration-out: 0;
          --simple-tooltip-border-radius: 0;
          --simple-tooltip-font-size: 14px;
          --simple-tooltip-width: 145px;
        }
      `]}static get tag(){return"haxcms-site-editor-ui"}constructor(){super(),this.__disposer=[],this.backText="Back to site list",this.painting=!0,this.pageAllowed=!1,this.editMode=!1,this.__editIcon="hax:page-edit",this.icon="hax:site-settings",this.manifestEditMode=!1,setTimeout(()=>{import("./haxcms-outline-editor-dialog.js"),import("./haxcms-site-dashboard.js"),import("../../../simple-tooltip/simple-tooltip.js"),import("../../../simple-modal/simple-modal.js"),import("../../../simple-fields/lib/simple-fields-form.js"),import("../../../paper-avatar/paper-avatar.js")},0)}render(){return e`
      <slot name="haxcms-site-editor-ui-prefix-avatar"></slot>
      <paper-avatar
        @click=${this.redirectToSites}
        id="username"
        label="${this.userName}"
        two-chars
        src="${this.userPicture}"
      ></paper-avatar>
      <slot name="haxcms-site-editor-ui-prefix-buttons"></slot>
      <simple-icon-button
        hidden
        dark
        id="editbutton"
        icon="${this.__editIcon}"
        @click="${this._editButtonTap}"
        title="${this.__editText}"
        voice-command="edit (this) page"
      ></simple-icon-button>
      <simple-icon-button
        id="cancelbutton"
        dark
        icon="icons:cancel"
        @click="${this._cancelButtonTap}"
        .hidden="${!this.editMode}"
        title="Cancel editing"
        voice-command="cancel (editing)"
      ></simple-icon-button>
      <simple-icon-button
        hidden
        dark
        id="editdetails"
        icon="hax:page-details"
        @click="${this._editDetailsButtonTap}"
        title="Edit details"
        voice-command="edit (page) details"
      ></simple-icon-button>
      <simple-icon-button
        hidden
        dark
        id="addbutton"
        icon="hax:add-page"
        @click="${this._addButtonTap}"
        title="Add page"
        voice-command="add page"
      ></simple-icon-button>
      <simple-icon-button
        hidden
        dark
        id="deletebutton"
        icon="icons:delete"
        @click="${this._deleteButtonTap}"
        title="Delete page"
        voice-command="delete page"
      ></simple-icon-button>
      <simple-icon-button
        hidden
        dark
        id="outlinebutton"
        icon="hax:site-map"
        @click="${this._outlineButtonTap}"
        title="Edit site outline"
        voice-command="edit site outline"
      ></simple-icon-button>
      <simple-icon-button
        hidden
        dark
        id="manifestbutton"
        icon="${this.icon}"
        @click="${this._manifestButtonTap}"
        title="${this.__settingsText}"
        voice-command="edit site settings"
      ></simple-icon-button>
      <simple-tooltip for="username" position="right" offset="14"
        >${this.backText}</simple-tooltip
      >
      <simple-tooltip for="cancelbutton" position="right" offset="14"
        >Cancel editing</simple-tooltip
      >
      <simple-tooltip for="editbutton" position="right" offset="14"
        >${this.__editText}</simple-tooltip
      >
      <simple-tooltip for="editdetails" position="right" offset="14"
        >Edit details</simple-tooltip
      >
      <simple-tooltip for="deletebutton" position="right" offset="14"
        >Delete page</simple-tooltip
      >
      <simple-tooltip for="addbutton" position="right" offset="14"
        >Add page</simple-tooltip
      >
      <simple-tooltip for="outlinebutton" position="right" offset="14"
        >Edit site outline</simple-tooltip
      >
      <simple-tooltip for="manifestbutton" position="right" offset="14"
        >${this.__settingsText}</simple-tooltip
      >
      <slot name="haxcms-site-editor-ui-suffix-buttons"></slot>
    `}redirectToSites(){let t="";if(window.appSettings&&window.appSettings.backLink)t=window.appSettings.backLink;else{let e=/^http/,i=document.createElement("a");i.href=window.location.href,t=e.test(i.href)?"http://"+i.host:"https://"+i.host}window.location.replace(t)}updateAvailableButtons(){this.shadowRoot&&setTimeout(()=>{window.appSettings&&window.appSettings.backText&&(this.backText=window.appSettings.backText);[{varPath:"getNodeFieldsPath",selector:"#editdetails"},{varPath:"deleteNodePath",selector:"#deletebutton"},{varPath:"saveNodePath",selector:"#editbutton"},{varPath:"createNodePath",selector:"#addbutton"},{varPath:"saveOutlinePath",selector:"#outlinebutton"},{varPath:"saveManifestPath",selector:"#manifestbutton",dep:"getSiteFieldsPath"},{varPath:"getSiteFieldsPath",selector:"#manifestbutton",dep:"saveManifestPath"}].forEach(t=>{window.appSettings&&window.appSettings[t.varPath]&&null!=window.appSettings[t.varPath]&&""!=window.appSettings[t.varPath]&&"null"!=window.appSettings[t.varPath]&&(t.dep?null!=window.appSettings[t.dep]&&""!=window.appSettings[t.dep]&&"null"!=window.appSettings[t.dep]&&this.shadowRoot.querySelector(t.selector).removeAttribute("hidden"):this.shadowRoot.querySelector(t.selector).removeAttribute("hidden"))})},100)}firstUpdated(t){super.firstUpdated&&super.firstUpdated(t),this.updateAvailableButtons(),this.dispatchEvent(new CustomEvent("haxcms-load-user-data",{bubbles:!0,composed:!0,cancelable:!1,detail:!0})),this.shadowRoot.querySelectorAll("[voice-command]").forEach(t=>{"editbutton"==t.getAttribute("id")?this.dispatchEvent(new CustomEvent("hax-add-voice-command",{bubbles:!0,composed:!0,cancelable:!1,detail:{command:":name: save (this) page",context:t,callback:"click"}})):"manifestbutton"==t.getAttribute("id")&&this.dispatchEvent(new CustomEvent("hax-add-voice-command",{bubbles:!0,composed:!0,cancelable:!1,detail:{command:":name: cancel site settings",context:t,callback:"click"}})),this.dispatchEvent(new CustomEvent("hax-add-voice-command",{bubbles:!0,composed:!0,cancelable:!1,detail:{command:":name: "+t.getAttribute("voice-command"),context:t,callback:"click"}}))})}updated(t){t.forEach((t,e)=>{"editMode"==e&&(this._editModeChanged(this[e],t),this.dispatchEvent(new CustomEvent("edit-mode-changed",{detail:this[e]}))),"manifestEditMode"==e&&(this._manifestEditModeChanged(this[e],t),this.dispatchEvent(new CustomEvent("manifest-edit-mode-changed",{detail:this[e]}))),"dashboardOpened"==e&&this._dashboardOpenedChanged(this[e],t)})}static get properties(){return{userName:{type:String,attribute:"user-name"},userPicture:{type:String,attribute:"user-picture"},backLink:{type:String},backText:{type:String},__editIcon:{type:String},__editText:{type:String},__settingsText:{type:String},painting:{type:Boolean,reflect:!0},pageAllowed:{type:Boolean,attribute:"page-allowed",reflect:!0},editMode:{type:Boolean,reflect:!0,attribute:"edit-mode"},manifestEditMode:{type:Boolean,attribute:"manifest-edit-mode",reflect:!0},activeTitle:{type:String,attribute:"active-title"},manifest:{type:Object},icon:{type:String},dashboardOpened:{type:Boolean,reflect:!0,attribute:"dashboard-opened"}}}connectedCallback(){super.connectedCallback(),s(t=>{o.userData&&(this.userName=a(o.userData.userName),this.userPicture=a(o.userData.userPicture),this.updateAvailableButtons()),this.__disposer.push(t)}),s(t=>{this.editMode=a(o.editMode),this.__disposer.push(t)}),s(t=>{this.manifest=a(o.manifest),this.icon="hax:site-settings",this.__disposer.push(t)}),s(t=>{this.dashboardOpened=a(o.dashboardOpened),this.__disposer.push(t)}),s(t=>{const e=a(o.activeItem);this.updateAvailableButtons(),e&&e.id?(this.activeTitle=e.title,this.pageAllowed=!0):this.pageAllowed=!1,this.__disposer.push(t)})}disconnectedCallback(){for(var t in this.__disposer)this.__disposer[t].dispose();super.disconnectedCallback()}_dashboardOpenedChanged(t,e){t?(this.__settingsText="Close site settings",this.icon="icons:cancel"):t||(this.__settingsText="Edit site settings",this.icon="hax:site-settings")}_editButtonTap(t){this.editMode=!this.editMode,this.editMode||this.dispatchEvent(new CustomEvent("haxcms-save-node",{bubbles:!0,composed:!0,cancelable:!1,detail:o.activeItem})),window.dispatchEvent(new CustomEvent("simple-modal-hide",{bubbles:!0,cancelable:!0,detail:{}}))}_editDetailsButtonTap(t){const e=new CustomEvent("haxcms-load-node-fields",{bubbles:!0,composed:!0,cancelable:!1,detail:t.target});window.dispatchEvent(e)}_cancelButtonTap(t){this.editMode=!1,this.dispatchEvent(new CustomEvent("hax-cancel",{bubbles:!0,composed:!0,cancelable:!1,detail:t.detail})),window.dispatchEvent(new CustomEvent("simple-modal-hide",{bubbles:!0,cancelable:!0,detail:{}}))}_addButtonTap(t){this.__newForm=document.createElement("simple-fields-form"),this.__newForm.fields=[{property:"title",title:"Title",description:"Main title for this page in menus",inputMethod:"textfield",required:!0},{property:"location",title:"Location",description:"What is displayed in the bnowser bar after your site name / URL",inputMethod:"textfield",required:!0},{property:"parentId",title:"Parent ID",description:"Parent id",inputMethod:"textfield",hidden:!0,required:!0}],this.__newForm.value={title:"New page",location:"",parentId:o.activeItem&&o.activeItem.id?o.activeItem.id:o.manifest.id};let e=document.createElement("button"),i=document.createElement("simple-icon");i.icon="icons:add",i.dark=!0,e.appendChild(i),e.appendChild(document.createTextNode("Create page")),e.style.color="white",e.style.backgroundColor="#2196f3",e.addEventListener("click",this._createNewItem.bind(this));let s=document.createElement("button"),a=document.createElement("simple-icon");a.icon="icons:cancel",s.appendChild(a),s.appendChild(document.createTextNode("cancel")),s.setAttribute("dialog-dismiss","dialog-dismiss");let n=document.createElement("span");n.appendChild(e),n.appendChild(s);const d=new CustomEvent("simple-modal-show",{bubbles:!0,composed:!0,cancelable:!1,detail:{title:"Add a new page",styles:{"--simple-modal-width":"50vw","--simple-modal-max-width":"50vw","--simple-modal-height":"40vh","--simple-modal-max-height":"40vh"},elements:{content:this.__newForm,buttons:n},invokedBy:this.shadowRoot.querySelector("#addbutton"),clone:!1,modal:!0}});window.dispatchEvent(d)}_createNewItem(t){const e=new CustomEvent("haxcms-create-node",{bubbles:!0,composed:!0,cancelable:!1,detail:{values:this.__newForm.value}});this.dispatchEvent(e)}_updateItem(t){var e,i=t.target;e=i.__form?i.__form.value:i.parentNode.__form.value,window.dispatchEvent(new CustomEvent("haxcms-save-node-details",{bubbles:!0,composed:!0,cancelable:!0,detail:e})),window.dispatchEvent(new CustomEvent("simple-modal-hide",{bubbles:!0,composed:!0,cancelable:!0,detail:{}}))}_deleteButtonTap(t){let e=document.createElement("span");e.innerHTML=`"${o.activeItem.title}" will be removed from the outline but its content stays on the file system.`;let i=document.createElement("button"),s=document.createElement("simple-icon");s.icon="icons:delete",i.appendChild(s),i.appendChild(document.createTextNode("Confirm")),i.style.color="white",i.style.backgroundColor="#ee0000",i.addEventListener("click",this._deleteActive.bind(this));let a=document.createElement("button"),n=document.createElement("simple-icon");n.icon="icons:cancel",a.appendChild(n),a.appendChild(document.createTextNode("cancel")),a.setAttribute("dialog-dismiss","dialog-dismiss");let d=document.createElement("span");d.appendChild(i),d.appendChild(a);const l=new CustomEvent("simple-modal-show",{bubbles:!0,composed:!0,cancelable:!1,detail:{title:"Are you sure you want to delete this page?",styles:{"--simple-modal-min-width":"30vw","--simple-modal-min-height":"30vh"},elements:{content:e,buttons:d},invokedBy:this.shadowRoot.querySelector("#deletebutton"),clone:!1,modal:!0}});window.dispatchEvent(l)}_deleteActive(t){const e=new CustomEvent("haxcms-delete-node",{bubbles:!0,composed:!0,cancelable:!1,detail:{item:o.activeItem}});this.dispatchEvent(e)}_outlineButtonTap(t){const e=new CustomEvent("simple-modal-show",{bubbles:!0,composed:!0,cancelable:!1,detail:{title:"Edit site outline",styles:{"--simple-modal-width":"70vw","--simple-modal-max-width":"70vw","--simple-modal-height":"70vh","--simple-modal-max-height":"70vh"},elements:{content:document.createElement("haxcms-outline-editor-dialog")},invokedBy:this.shadowRoot.querySelector("#outlinebutton"),clone:!1,modal:!0}});window.dispatchEvent(e)}_manifestButtonTap(t){window.dispatchEvent(new CustomEvent("simple-modal-hide",{bubbles:!0,cancelable:!0,detail:{}})),window.dispatchEvent(new CustomEvent("haxcms-load-site-dashboard",{bubbles:!0,composed:!0,cancelable:!1,detail:t.target}))}_editModeChanged(t,e){t?(this.__editIcon="icons:save",this.__editText="Save page content"):(this.__editIcon="hax:page-edit",this.__editText="Edit page content"),void 0!==e&&(o.editMode=t)}_outlineEditModeChanged(t,e){this.dispatchEvent(new CustomEvent("haxcms-outline-edit-mode-changed",{bubbles:!0,composed:!0,cancelable:!1,detail:t}))}_manifestEditModeChanged(t,e){this.dispatchEvent(new CustomEvent("haxcms-manifest-edit-mode-changed",{bubbles:!0,composed:!0,cancelable:!1,detail:t}))}}window.customElements.define(HAXCMSSiteEditorUI.tag,HAXCMSSiteEditorUI);export{HAXCMSSiteEditorUI};