/**
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as t,html as e,css as i}from"../../../../../lit-element/lit-element.js";import{store as o}from"../../core/haxcms-site-store.js";import{autorun as s,toJS as n}from"../../../../../mobx/dist/mobx.esm.js";import{HAXCMSThemeParts as r}from"../../core/utils/HAXCMSThemeParts.js";import"../../../../simple-icon/lib/simple-icon-lite.js";import"../../../../simple-icon/lib/simple-icons.js";class SiteMenuButton extends(r(t)){static get styles(){return[...super.styles,i`
        :host {
          display: block;
          font-size: 16px;
        }
        :host([disabled]) {
          pointer-events: none;
          opacity: 0.3;
        }
        a {
          display: block;
          height: 100%;
          width: 100%;
          color: var(--site-menu-button-link-color);
          text-decoration: var(--site-menu-button-link-decoration, underline);
        }
        button {
          display: flex;
          cursor: pointer;
          transition: 0.2s color linear;
          min-width: unset;
          background-color: transparent;
          border: 0;
          border-radius: 0;
          height: 100%;
          width: 100%;
          justify-content: center;
          align-items: center;
        }
        button:hover,
        button:focus,
        button:active {
          color: var(--site-menu-button-button-hover-color, inherit);
          outline: 2px solid var(--site-menu-button-button-hover-color, inherit);
          outline-offset: 2px;
          background-color: var(
            --site-menu-button-button-hover-background-color,
            inherit
          );
        }
        button:hover simple-icon-lite,
        button:focus simple-icon-lite,
        button:active simple-icon-lite {
          --simple-icon-fill-color: var(
            --site-menu-button-button-hover-color,
            black
          );
        }
        simple-icon-lite {
          display: block;
          margin-top: 25px;
          font-size: 16px;
          --simple-icon-width: var(--site-menu-button-icon-width, 32px);
          --simple-icon-height: var(--site-menu-button-icon-height, 32px);
          --simple-icon-fill-color: var(
            --site-menu-button-icon-fill-color,
            black
          );
        }
        simple-tooltip {
          --simple-tooltip-background: var(
            --haxcms-tooltip-background-color,
            #000000
          );
          --simple-tooltip-opacity: 1;
          --simple-tooltip-text-color: var(--haxcms-tooltip-color, #ffffff);
          --simple-tooltip-delay-in: 0;
          --simple-tooltip-border-radius: 0;
        }
      `]}static get tag(){return"site-menu-button"}constructor(){super(),this.hideLabel=!1,this.__disposer=this.__disposer?this.__disposer:[],s(t=>{this.activeRouterManifestIndex=n(o.activeRouterManifestIndex),this.__disposer.push(t)}),s(t=>{this.routerManifest=n(o.routerManifest),this.__disposer.push(t)}),s(t=>{this.editMode=n(o.editMode),this.__disposer.push(t)}),import("../../../../simple-tooltip/simple-tooltip.js")}render(){return e`
      <a
        tabindex="-1"
        ?disabled="${this.disabled}"
        aria-label="${this.label}"
        .part="${this.editMode?"edit-mode-active":""}"
      >
        <button
          id="menulink"
          noink
          ?disabled="${this.disabled}"
          ?raised="${this.raised}"
          aria-label="${this.label}"
          .part="${this.editMode?"edit-mode-active":""}"
        >
          <slot name="prefix"></slot>
          <simple-icon-lite icon="${this.icon}"></simple-icon-lite>
          <slot name="suffix"></slot>
        </button>
      </a>
      ${this.hideLabel?"":e`
            <simple-tooltip
              for="menulink"
              offset="8"
              .position="${this.position}"
            >
              ${this.label}
            </simple-tooltip>
          `}
    `}static get properties(){return{...super.properties,type:{type:String,reflect:!0},activeRouterManifestIndex:{type:String},routerManifest:{type:Object},link:{type:String},editMode:{type:Boolean,reflect:!0,attribute:"edit-mode"},disabled:{type:Boolean,reflect:!0,attribute:"disabled"},label:{type:String},hideLabel:{type:Boolean,attribute:"hide-label"},icon:{type:String},position:{type:String},raised:{type:Boolean}}}updated(t){super.updated&&super.updated(t),t.forEach((t,e)=>{"type"==e&&this._typeChanged(this[e],t),"link"==e&&this._linkChanged(this[e]),"label"==e&&this.dispatchEvent(new CustomEvent(e+"-changed",{detail:{value:this[e]}})),["type","activeRouterManifestIndex","routerManifest"].includes(e)&&this.routerManifest&&(this.link=this.pageLink(this.type,this.activeRouterManifestIndex,this.routerManifest.items),this.label=this.pageLinkLabel(this.type,this.activeRouterManifestIndex,this.routerManifest.items)),["type","activeRouterManifestIndex","routerManifest","editMode","link"].includes(e)&&this.routerManifest&&(this.disabled=this.pageLinkStatus(this.type,this.activeRouterManifestIndex,this.routerManifest.items,this.editMode,this.link))})}_linkChanged(t){null==t?this.shadowRoot.querySelector("a").removeAttribute("href"):this.shadowRoot.querySelector("a").setAttribute("href",t)}_typeChanged(t){"prev"===t?(this.icon||(this.icon="icons:chevron-left"),this.position||(this.position="right")):"next"===t?(this.icon||(this.icon="icons:chevron-right"),this.position||(this.position="left")):(this.icon="",this.direction="")}pageLink(t,e,i){return"prev"===t&&i?e>0&&i[e-1]?i[e-1].slug:null:"next"===t&&i&&e<i.length-1&&i[e+1]?i[e+1].slug:null}pageLinkStatus(t,e,i,o,s){if(o||null==s)return!0;if("prev"===t){if(0===e||-1===e)return!0}else if("next"===t&&i&&e>=i.length-1)return!0;return!1}pageLinkLabel(t,e,i){return"prev"===t&&i?0!==e&&-1!==e&&i[e-1]?i[e-1].title:"":"next"===t&&i?e>=i.length-1||!i[e+1]?"":i[e+1].title:void 0}disconnectedCallback(){for(var t in this.__disposer)this.__disposer[t].dispose();super.disconnectedCallback()}}window.customElements.define(SiteMenuButton.tag,SiteMenuButton);export{SiteMenuButton};