/**
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as t,html as e,css as i}from"../../../../../lit-element/lit-element.js";import{store as o}from"../../core/haxcms-site-store.js";import{HAXCMSThemeParts as n}from"../../core/utils/HAXCMSThemeParts.js";import"../../../../simple-icon/lib/simple-icons.js";import"../../../../simple-icon/lib/simple-icon-button-lite.js";import"../../../../simple-tooltip/simple-tooltip.js";class SitePrintButton extends(n(t)){static get styles(){return[...super.styles,i`
        :host {
          display: inline-flex;
          text-rendering: optimizelegibility;
          position: relative;
          color: var(--site-print-button-color, inherit);
        }
        simple-icon-button {
          color: var(--site-print-button-color, inherit);
        }
        simple-tooltip {
          --simple-tooltip-background: var(
            --haxcms-tooltip-background-color,
            #000000
          );
          --simple-tooltip-opacity: 1;
          --simple-tooltip-text-color: var(--haxcms-tooltip-color, #ffffff);
          --simple-tooltip-delay-in: 0;
          --simple-tooltip-border-radius: 0;
        }
      `]}static get tag(){return"site-print-button"}constructor(){super(),this.icon="icons:print",this.position="bottom",this.type="page"}render(){return e`
      <simple-icon-button-lite
        .id="btn${this.type}"
        icon="${this.icon}"
        @click="${this.print}"
        aria-label="${this.label}"
        ?disabled="${this.disabled}"
        .part="${this.editMode?"edit-mode-active":""}"
      ></simple-icon-button-lite>
      <simple-tooltip
        .for="btn${this.type}"
        position="${this.position}"
        offset="14"
      >
        ${this.label}
      </simple-tooltip>
    `}updated(t){super.updated&&super.updated(t),t.forEach((t,e)=>{"type"==e&&this._typeChanged(this[e],t),"editMode"===e&&(this[e]?this.setAttribute("part","edit-mode-active"):this.removeAttribute("part"))})}static get properties(){return{...super.properties,icon:{type:String},disabled:{type:Boolean,reflect:!0},label:{type:String},position:{type:String},type:{type:String}}}_typeChanged(t){void 0===this.label&&(this.label="page"===t||"site"===t?"Print "+t:"Print outline")}async print(t){import("../layout/site-footer.js");const e=this.type;let i="";if("page"===e)i=`\n      <h1>${o.activeItem.title}</h1>\n      <div>${o.activeItemContent}</div>`;else if("parent"===e){const t=o.computeItems(1,100,o.activeId,"parent",o.routerManifest,!0);for(var n in t)i+=await fetch(t[n].location).then((function(t){return t.text()})).then((function(e){let i=t[n].indent+1;return i>6&&(i=6),`<h${i}>${t[n].title}</h${i}>\n              ${e}`}))}else if("ancestor"===e){const t=o.computeItems(1,100,o.activeId,"ancestor",o.routerManifest,!0);for(var n in t)i+=await fetch(t[n].location).then((function(t){return t.text()})).then((function(e){let i=t[n].indent+1;return i>6&&(i=6),`<h${i}>${t[n].title}</h${i}>\n              ${e}`}))}else if("site"===e){const t=o.routerManifest.items;for(var n in t)i+=await fetch(t[n].location).then((function(t){return t.text()})).then((function(e){let i=t[n].indent+1;return i>6&&(i=6),`<h${i}>${t[n].title}</h${i}>\n              ${e}`}))}var r=new Date,s="Printed on: "+r.getDate()+"/"+(r.getMonth()+1)+"/"+r.getFullYear()+" at "+r.getHours()+":"+r.getMinutes()+":"+r.getSeconds();let l=document.createElement("div");l.innerHTML=`\n<style>\n  @media print {\n    body {\n      padding: 0 15px 5px;\n      color: #000;\n      background-color: #ffffff;\n      border-top: 1px solid #aaa;\n    }\n  }\n</style>\n<h1>${o.siteTitle}</h1>\n<site-footer></site-footer>\n<p>${s}</p>\n${i}`;let p=window.open("","","left=0,top=0,width=800,height=800,toolbar=0,scrollbars=0,status =0");if(document.head.getElementsByTagName("base")){let t=document.createElement("base");t.href=document.head.getElementsByTagName("base")[0].getAttribute("href"),p.document.head.appendChild(t)}p.document.body.appendChild(l),p.document.close(),p.focus(),p.print(),p.close()}}window.customElements.define(SitePrintButton.tag,SitePrintButton);export{SitePrintButton};