/**
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as t,html as e,css as i}from"../../../../../lit-element/lit-element.js";import{HAXCMSThemeParts as o}from"../../core/utils/HAXCMSThemeParts.js";import"../../../../simple-icon/lib/simple-icons.js";import"../../../../simple-icon/lib/simple-icon-button.js";import"../../../../simple-tooltip/simple-tooltip.js";class SiteRSSButton extends(o(t)){static get styles(){return[...super.styles,i`
        :host {
          display: inline-flex;
          color: var(--site-rss-button-color, inherit);
        }
        a {
          text-decoration: var(--site-rss-text-decoration);
          outline: none;
          color: var(--site-rss-button-color, inherit);
        }
        simple-icon-button-lite {
          color: var(--site-rss-button-color, inherit);
        }
        simple-tooltip {
          --simple-tooltip-background: var(
            --haxcms-tooltip-background-color,
            #000000
          );
          --simple-tooltip-opacity: 1;
          --simple-tooltip-text-color: var(--haxcms-tooltip-color, #ffffff);
          --simple-tooltip-delay-in: 0;
          --simple-tooltip-border-radius: 0;
        }
      `]}static get tag(){return"site-rss-button"}constructor(){super(),this.type="rss",this.raised=!1,this.position="bottom"}render(){return e`
      <a
        ?disabled="${this.disabled}"
        tabindex="-1"
        href="${this.href}"
        .id="btn${this.type}"
        target="_blank"
        rel="noopener noreferrer"
        aria-label="${this.label}"
        .part="${this.editMode?"edit-mode-active":""}"
      >
        <simple-icon-button-lite
          icon="${this.icon}"
          @click="${this.print}"
          aria-labelledby="btn${this.type}"
          ?disabled="${this.disabled}"
          .part="${this.editMode?"edit-mode-active":""}"
        ></simple-icon-button-lite>
      </a>
      <simple-tooltip
        .for="btn${this.type}"
        position="${this.position}"
        offset="14"
      >
        ${this.label}
      </simple-tooltip>
    `}static get properties(){return{...super.properties,disabled:{type:Boolean,reflect:!0},label:{type:String},href:{type:String},icon:{type:String},type:{type:String},position:{type:String}}}updated(t){super.updated&&super.updated(t),t.forEach((t,e)=>{"type"==e&&this._generateLink(this[e],t)})}_generateLink(t,e){if(this._link&&document.head.removeChild(this._link),t){let e=document.createElement("link");e.rel="alternate","rss"===t?(e.href="rss.xml",e.title="RSS feed",e.type="application/rss+xml",this.icon="communication:rss-feed"):"atom"===t&&(e.href="atom.xml",e.title="Atom feed",e.type="application/atom+xml",this.icon="communication:rss-feed"),this.label=e.title,this.href=e.href,document.head.appendChild(e),this._link=e}}}window.customElements.define(SiteRSSButton.tag,SiteRSSButton);export{SiteRSSButton};