/**
 * Copyright 2018 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as e,html as t,css as a}from"../../lit-element/lit-element.js";import"../a11y-tabs/a11y-tabs.js";import"../a11y-tabs/lib/a11y-tab.js";import"../../@polymer/marked-element/marked-element.js";import"./lib/lrn-markdown-editor-editor.js";class LrnMarkdownEditor extends e{static get styles(){return[a`
        :host {
          display: block;
        }

        #split-pane {
          display: flex;
          width: 100%;
        }

        .split-pane > * {
          flex: 1 1 auto;
          min-height: 160px;
          width: calc(50% - 16px);
        }

        .preview-pane {
          background: lightblue;
        }

        div.pane {
          padding: 16px;
          width: calc(100% - 32px);
        }

        a11y-tabs {
          background: #f5f5f5;
          border-style: solid;
          border-color: #dcdcdc;
          border-width: 1px;
          min-width: 500px;
        }

        marked-element.lrn-markdown-editor {
          width: 100%;
          word-wrap: break-word;
        }

        .container-flex {
          display: flex;
          flex-wrap: nowrap;
        }

        .split-pane .container-flex > * {
          width: 50%;
        }

        .split-pane marked-element {
          width: calc(100% - 32px);
          min-width: 150px;
          margin: 0 16px;
          padding: 0 16px;
          background: #fff;
          border-left: solid #dcdcdc 1px;
        }
      `]}render(){return t`
      <div class="mtz-toolbar">
        <a11y-tabs>
          <a11y-tab id="tab-0" label="Write">
            <div class="pane">
              <lrn-markdown-editor-editor
                content="${this.content}"
                @content-changed="${this.__contentChanged}"
              ></lrn-markdown-editor-editor>
            </div>
          </a11y-tab>
          <a11y-tab id="tab-1" label="Preview">
            <div class="pane">
              <marked-element
                markdown="${this.content}"
                @markdown-changed="${this.__contentChanged}"
              ></marked-element>
            </div>
          </a11y-tab>
          <a11y-tab id="tab-2" label="Split View">
            <div class="split-pane">
              <div class="pane">
                <div class="container-flex">
                  <lrn-markdown-editor-editor
                    content="${this.content}"
                    @content-changed="${this.__contentChanged}"
                  ></lrn-markdown-editor-editor>
                  <marked-element
                    class="preview-pane"
                    markdown="${this.content}"
                    @markdown-changed="${this.__contentChanged}"
                  ></marked-element>
                </div>
              </div>
            </div>
          </a11y-tab>
        </a11y-tabs>
      </div>
    `}__contentChanged(e){this.content=e.detail.value}constructor(){super(),this.layout="0",this.content="",this.cookies=!0,this.elReady=!1}static get tag(){return"lrn-markdown-editor"}static get properties(){return{content:{type:String},layout:{type:String},cookies:{type:Boolean},elReady:{type:Boolean,attribute:"el-ready"}}}updated(e){e.forEach((e,t)=>{"content"===t&&this.dispatchEvent(new CustomEvent("content-changed",{detail:{value:this[t]}}))})}_selectedChanged(e){var t=this._getCookieName();2===e?this._createCookie(t,"true","30"):2!==e&&!0===this.elReady&&this._eraseCookie(t)}_createCookie(e,t,a){var n="";if(a){var i=new Date;i.setTime(i.getTime()+24*a*60*60*1e3),n="; expires="+i.toUTCString()}document.cookie=e+"="+t+n+"; path=/"}_readCookie(e){for(var t=e+"=",a=document.cookie.split(";"),n=0;n<a.length;n++){for(var i=a[n];" "==i.charAt(0);)i=i.substring(1,i.length);if(0==i.indexOf(t))return i.substring(t.length,i.length)}return null}_eraseCookie(e){this._createCookie(e,"",-1)}_getCookieName(){return"lrnmarkdowneditorsplitview"}firstUpdated(e){this.elReady=!0;var t=this._getCookieName(),a=this._readCookie(t);a&&"true"===a&&(this.selected=2)}}window.customElements.define(LrnMarkdownEditor.tag,LrnMarkdownEditor);export{LrnMarkdownEditor};