/**
 * Copyright 2018 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as e,html as s,css as t}from"../../../lit-element/lit-element.js";import{LrndesignGalleryBehaviors as i}from"./lrndesign-gallery-behaviors.js";import"./lrndesign-gallery-zoom.js";import"./lrndesign-gallery-details.js";import{normalizeEventPath as l}from"../../utils/utils.js";class LrndesignGalleryMasonry extends i{static get tag(){return"lrndesign-gallery-masonry"}static get styles(){return[...super.styles,t`
        :host {
          margin: 15px 0;
          padding: 0;
          max-width: 100%;
          display: block;
        }
        #galleryscreen > div {
          display: flex;
          align-items: stretch;
          justify-content: center;
          margin: 20px 0;
        }
        lrndesign-gallery-zoom {
          position: relative;
          margin: 0 10px;
          flex: 0 1 var(--lrndesign-gallery-image-width, 200px);
          max-width: 35%;
        }
        lrndesign-gallery-zoom,
        lrndesign-gallery-zoom:hover,
        lrndesign-gallery-zoom:focus,
        lrndesign-gallery-zoom:focus-within {
          border: 0px solid transparent;
        }
        lrndesign-gallery-zoom img {
          width: 100%;
          transition: outline 0.25s ease-in-out;
          outline: 1px solid var(--lrndesign-gallery-color);
        }
        lrndesign-gallery-zoom:hover img,
        lrndesign-gallery-zoom:focus img,
        lrndesign-gallery-zoom:focus-within img {
          transition: outline 0.25s ease-in-out;
          outline: 2px solid var(--lrndesign-gallery-focus-color);
        }
        .zoombg,
        .zoomicon {
          top: unset;
          bottom: 5px;
          left: 5px;
        }
      `]}static get properties(){return{...super.properties,__aspects:{type:Object},__columns:{type:Array},__items:{type:Array}}}constructor(){super(),this.__aspects={},this.__items=[];let e=this.shadowRoot.querySelector("#carouselitem");this.selected.scroll&&e&&(this._scrollIntoView([this._getParentOffset(e)]),this.selected.zoomed||e.focus())}render(){return s`
      <div id="grid">
        <p class="sr-only">A list of columns buttons items:</p>
        <div id="galleryscreen">
          ${(this.__items||[]).map((e,t)=>s`
              <div>
                ${(e.cols||[]).map((t,i)=>s`
                    <lrndesign-gallery-zoom
                      .id="${t.id}"
                      .details="${t.details}"
                      .heading="${t.heading}"
                      .src="${t.large}"
                      .tooltip="${t.tooltip}"
                      .zoom-alt="${t.zoomAlt}"
                      style="${this._getStyle(t.aspect,e.aspect)}"
                    >
                      <img
                        .alt="${t.alt}"
                        fade
                        .src="${t.src}"
                        @load="${e=>this._handleImgLoad(e)}"
                      />
                      <div class="zoombg"></div>
                      <simple-icon-lite
                        icon="zoom-in"
                        class="zoomicon"
                      ></simple-icon-lite>
                    </lrndesign-gallery-zoom>
                  `)}
              </div>
            `)}
        </div>
      </div>
    `}updated(e){super.updated(e),e.forEach((e,s)=>{"sources"===s&&this._updateItems(),"responsiveSize"===s&&this._updateItems()})}_getStyle(e,s){return[`--lrndesign-gallery-image-aspect:${e||100/75};`,`--lrndesign-gallery-image-height:${100/e||75}%;`,`--lrndesign-gallery-image-width:${100*e/s||.75}%`].join("")}_handleImgLoad(e){l(e)[0].naturalWidth>0&&this._updateItems()}_updateItems(){let e=[],s={xs:2,sm:3,md:4,lg:5,xl:6}[this.responsiveSize||"xs"],t=Math.ceil(this.sources.length/s);for(let i=0;i<t;i++){let t={aspect:0,cols:[]};console.log("row",i);for(let e=i*s;e<Math.min(this.sources.length,(i+1)*s);e++){let s=JSON.parse(JSON.stringify(this.sources[e])),i=this.shadowRoot.querySelector(`img[src="${s.src}"]`);s.aspect=i&&i.naturalWidth>0?i.naturalWidth/i.naturalHeight:100/75,t.aspect+=s.aspect,t.cols.push(s)}e.push(t)}this.__items=e,console.log("this.__items",this.__items)}}window.customElements.define(LrndesignGalleryMasonry.tag,LrndesignGalleryMasonry);export{LrndesignGalleryMasonry};