/**
 * Copyright 2018 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as o,html as t,css as e}from"../../../lit-element/lit-element.js";import"../../simple-tooltip/simple-tooltip.js";import"../../img-view-modal/img-view-modal.js";import"./lrndesign-gallery-details.js";class LrndesignGalleryZoom extends o{static get tag(){return"lrndesign-gallery-zoom"}static get styles(){return[e`
        :host {
          display: block;
          background-color: none;
        }
        :host([hidden]) {
          display: none;
        }
        #zoombtn {
          display: block;
          width: 100%;
          padding: 0;
          margin: 0;
          border-width: 0;
          background-color: transparent;
        }
        simple-modal-template[modal-id="zoomdialog"] {
          --img-view-modal-backgroundColor: var(
            --lrndesign-gallery-dialog-background-color
          );
          --img-view-modal-color: var(--lrndesign-gallery-dialog-color);
          --img-view-modal-borderColor: var(
            --lrndesign-gallery-dialog-border-color
          );
          --img-view-modal-toggled-backgroundColor: var(
            --lrndesign-gallery-dialog-toggled-background-color
          );
        }
      `]}render(){return t`
      <img-view-modal
        .figures="${this.figures}"
        .toolbars="${this.toolbars}"
        title="${this.heading||""}"
        max-zoom-pixel-ratio="1.5"
        min-zoom-image-ratio="0.5"
        zoom-per-click="1.2"
        zoom-per-scroll="0.6"
      >
        <button id="zoombtn" aria-label="${this.tooltip}">
          <slot></slot>
        </button>
      </img-view-modal>
      <simple-tooltip for="zoombtn" position="right" controls="zoomtpl"
        >${this.tooltip}</simple-tooltip
      >
    `}static get properties(){return{heading:{type:String},details:{type:String},src:{type:String,reflect:!0,attribute:"src"},tooltip:{type:String},zoomAlt:{type:String,attribute:"zoom-alt"}}}constructor(){super(),this.heading="Image Zoom",this.details="",this.src="",this.tooltip="Zoom In",this.zoomAlt="Full-sized Image"}get figures(){return[{src:this.src,info:t`
          <lrndesign-gallery-details
            id="details"
            ?hidden="${!this.details||!this.zoomAlt}"
            details="${this.details||this.zoomAlt}"
          >
          </lrndesign-gallery-details>
        `}]}get toolbars(){return{bottom:{id:"bottom",type:"toolbar-group",contents:["homebutton","zoomgroup","pangroup","fullscreenbutton","kbdbutton","infobutton"]}}}get button(){return!(!this.shadowRoot||!this.shadowRoot.querySelector("#zoombtn"))&&this.shadowRoot.querySelector("#zoombtn")}get modal(){return!(!this.shadowRoot||!this.shadowRoot.querySelector("#zoomtpl"))&&this.shadowRoot.querySelector("#zoomtpl")}zoom(){if(this.button&&this.modal){this.modal.openModal(this.button);let o=new CustomEvent("gallery-zoom",{detail:this});this.button.dispatchEvent(o)}}}window.customElements.define(LrndesignGalleryZoom.tag,LrndesignGalleryZoom);export{LrndesignGalleryZoom};