/**
 * Copyright 2018 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{html as e,PolymerElement as t}from"../../../@polymer/polymer/polymer-element.js";import"../../circle-progress/circle-progress.js";import"../../simple-tooltip/simple-tooltip.js";import"../../../@polymer/paper-styles/paper-styles.js";import"../../../@polymer/paper-spinner/paper-spinner.js";import"../../simple-icon/simple-icon.js";import"../../simple-icon/lib/simple-icons.js";class LrnsysProgressCircle extends t{static get template(){return e`
      <custom-style>
        <style is="custom-style" include="paper-material-styles">
          :host {
            display: block;
            transition: box-shadow
                var(--lrnsys-progress-circle-transition, 0.5s) linear,
              color var(--lrnsys-progress-circle-transition, 0.5s) ease-in-out,
              background-color var(--lrnsys-progress-circle-transition, 0.5s)
                ease-in-out;
          }
          :host([status="complete"]) .circle-wrapper {
            box-shadow: 0px 0px 0px 0.16px
              var(--lrnsys-progress-complete-color, var(--paper-green-900));
          }
          :host([status="disabled"]) .circle-wrapper {
            box-shadow: none;
          }
          :host([status="available"]) .circle-wrapper {
            box-shadow: none;
          }
          :host([active]) .circle-wrapper {
            box-shadow: 0px 0px 0px 0.16px var(--google-grey-500, #555555);
          }
          .circle-wrapper {
            border-radius: 100%;
          }
          .button {
            margin: 0;
            padding: 0;
            display: flex;
            min-width: 40px;
            border-radius: 100%;
          }
          button {
            width: var(--lrnsys-progress-circle-size, 40px);
            height: var(--lrnsys-progress-circle-size, 40px);
          }
          circle-progress {
            margin: 0;
            --circle-progress-width: var(--lrnsys-progress-circle-size, 40px);
            --circle-progress-height: var(--lrnsys-progress-circle-size, 40px);
            --circle-progress-stroke-color: var(
              --lrnsys-progress-color,
              var(--paper-green-500)
            );
            --circle-progress-bg-stroke-color: var(
              --lrnsys-progress-container-color,
              var(--google-grey-300)
            );
            --circle-progress-transition: 0.5s;
            --circle-progress-stroke-linecap: square;
            transition: color 0.5s ease-in-out,
              background-color 0.5s ease-in-out;
          }
          paper-spinner {
            display: block;
            font-size: 16px;
            width: var(--lrnsys-progress-spinner-size, 32px);
            height: var(--lrnsys-progress-spinner-size, 32px);
            position: absolute;
            z-index: 1;
            margin: 4px;
            padding: 0;
            visibility: visible;
            opacity: 1;
            transition: visibility 0.4s, opacity 0.4s ease;
          }
          paper-spinner.multi {
            --paper-spinner-layer-1-color: var(--paper-purple-500);
            --paper-spinner-layer-2-color: var(--paper-cyan-500);
            --paper-spinner-layer-3-color: var(--paper-blue-grey-500);
            --paper-spinner-layer-4-color: var(--paper-amber-500);
          }
          .transition {
            opacity: 0.4;
            width: calc(var(--lrnsys-progress-icon-size, 24px) - 8px);
            height: calc(var(--lrnsys-progress-icon-size, 24px) - 8px);
          }
          simple-icon {
            visibility: visible;
            opacity: 1;
            transition: width 0.1s linear, height 0.1s linear,
              visibility 0.4s ease, opacity 0.4s ease;
            --simple-icon-width: var(--lrnsys-progress-icon-size, 24px);
            --simple-icon-height: var(--lrnsys-progress-icon-size, 24px);
          }
          .disabled {
            background-color: var(
              --lrnsys-progress-disabled-color,
              var(--google-grey-500)
            );
            color: white;
          }
          .loading {
            background-color: white;
            color: black;
          }
          .finished simple-icon:not(.activeIcon) {
            --simple-icon-width: calc(
              var(--lrnsys-progress-icon-size, 24px) - 8px
            );
            --simple-icon-height: calc(
              var(--lrnsys-progress-icon-size, 24px) - 8px
            );
          }
          .available {
            background-color: var(
              --lrnsys-progress-active-color,
              var(--google-grey-300)
            );
            color: var(
              --lrnsys-progress-active-text-color,
              var(--google-grey-500)
            );
          }
          .activeIcon {
            color: black;
          }
          .complete .activeIcon {
            color: white;
          }
          :host([active]) .complete .activeIcon,
          :host([active]) .finished .activeIcon {
            color: black;
          }
          .complete,
          .finished {
            background-color: var(
              --lrnsys-progress-container-color,
              var(--paper-green-500)
            );
            color: white;
          }
          :host([active]) circle-progress {
            background-color: white;
            color: black;
          }
          .listview-title {
            font-size: 16px;
            padding: 0;
            margin: 0;
          }
          .description-content {
            font-size: 8px;
            font-style: italic;
          }
          .circle-wrapper {
            display: inline-block;
          }
          .listview {
            height: 32px;
            padding: 4px 0;
            margin: 0;
            vertical-align: top;
          }
          .link {
            height: 40px;
            width: 100%;
          }
          :host([list-view]) .button {
            margin: 0;
            padding: 0;
            display: block;
            min-width: 40px;
            border-radius: 0;
          }
        </style>
      </custom-style>
      <simple-tooltip
        hidden$="[[!toolTip]]"
        for="button"
        position="bottom"
        offset="8"
        animation-delay="0"
      >
        [[label]]
      </simple-tooltip>
      <button
        id="button"
        class="button"
        disabled$="[[disabled]]"
        title="[[label]]"
      >
        <span class="circle-wrapper">
          <paper-spinner
            active$="[[loading]]"
            hidden$="[[!loading]]"
            class="multi"
            alt$="Loading content for [[label]]"
          ></paper-spinner>
          <circle-progress
            class$="[[status]]"
            value="[[value]]"
            max="[[max]]"
            stroke-width="[[strokeWidth]]"
            angle="180"
          >
            <simple-icon
              id="icon"
              icon="[[activeIcon]]"
              hidden$="[[!activeIcon]]"
            ></simple-icon>
            <slot name="image"></slot>
          </circle-progress>
        </span>
        <span hidden$="[[!listView]]" id="listview" class="listview">
          <h3 class="listview-title">[[label]]</h3>
          <div class="description-content">
            <slot name="description"></slot> <slot></slot>
          </div>
        </span>
      </button>
    `}static get tag(){return"lrnsys-progress-circle"}static get properties(){return{value:{type:Number,value:0,notify:!0,reflectToAttribute:!0,observer:"_testValueComplete"},toolTip:{type:Boolean,value:!0,reflectToAttribute:!0},listView:{type:Boolean,value:!0,reflectToAttribute:!0},icon:{type:String,value:"icons:description",reflectToAttribute:!0},iconComplete:{type:String,value:"icons:description",reflectToAttribute:!0},loadingIcon:{type:String,value:"hourglass-full",reflectToAttribute:!0},finishedIcon:{type:String,value:"thumb-up",reflectToAttribute:!0},activeIcon:{type:String,notify:!0,computed:"_getActiveIcon(icon, iconComplete, status)"},step:{type:Number,value:0,reflectToAttribute:!0},active:{type:Boolean,value:!1,reflectToAttribute:!0,notify:!0},status:{type:String,value:"available",reflectToAttribute:!0,notify:!0,observer:"_statusChange"},disabled:{type:Boolean,computed:"_disableStatus(status)"},loading:{type:Boolean,computed:"_loadingStatus(status)"},finished:{type:Boolean,computed:"_finishedStatus(status)"},max:{type:String,reflectToAttribute:!0},__chimed:{type:Boolean,value:!1},__finishchimed:{type:Boolean,value:!1},url:{type:String,value:"#",reflectToAttribute:!0},dataUrl:{type:String,value:!1,reflectToAttribute:!0},strokeWidth:{type:Number,value:4},focusState:{type:Boolean,value:!1},playSound:{type:Boolean,value:!1,reflectToAttribute:!0},playFinishSound:{type:Boolean,value:!1,reflectToAttribute:!0},completeSound:{type:String,reflectToAttribute:!0},finishedSound:{type:String,reflectToAttribute:!0},_bubbleProgress:{type:Object,value:{25:!1,50:!1,75:!1}}}}pathFromUrl(e){return e.substring(0,e.lastIndexOf("/")+1)}ready(){super.ready(),this._bubbleProgress={25:!1,50:!1,75:!1}}_testValueComplete(e,t){e>=this.max&&"available"==this.status?this.status="complete":e/this.max>=.75&&!this._bubbleProgress[75]?(this.dispatchEvent(new CustomEvent("node-percent-milestone",{bubbles:!0,cancelable:!0,composed:!0,detail:{percentage:75}})),this._bubbleProgress[75]=!0):e/this.max>=.5&&!this._bubbleProgress[50]?(this.dispatchEvent(new CustomEvent("node-percent-milestone",{bubbles:!0,cancelable:!0,composed:!0,detail:{percentage:50}})),this._bubbleProgress[50]=!0):e/this.max>=.25&&!this._bubbleProgress[25]&&(this.dispatchEvent(new CustomEvent("node-percent-milestone",{bubbles:!0,cancelable:!0,composed:!0,detail:{percentage:25}})),this._bubbleProgress[25]=!0)}constructor(){super(),this.completeSound=this.pathFromUrl(decodeURIComponent(import.meta.url))+"lib/assets/complete.mp3",this.finishedSound=this.pathFromUrl(decodeURIComponent(import.meta.url))+"lib/assets/finished.mp3",setTimeout(()=>{this.addEventListener("click",this.tapEventOn.bind(this)),this.addEventListener("mouseover",this.focusOn.bind(this)),this.addEventListener("mouseout",this.focusOff.bind(this)),this.addEventListener("focused-changed",this.focusEvent.bind(this))},0)}focusEvent(e){this.disabled||"loading"==this.status||(this.focusState?(this.shadowRoot.querySelector("#icon").icon=this.icon,this.shadowRoot.querySelector("#icon").classList.add("activeIcon")):("complete"!=this.status&&"finished"!=this.status||(this.shadowRoot.querySelector("#icon").icon=this.activeIcon),this.shadowRoot.querySelector("#icon").classList.remove("activeIcon")),this.focusState=!this.focusState)}focusOn(e){this.disabled||"loading"==this.status||(this.shadowRoot.querySelector("#icon").icon=this.icon,this.shadowRoot.querySelector("#icon").classList.add("activeIcon"))}focusOff(e){this.disabled||"loading"==this.status||("complete"!=this.status&&"finished"!=this.status||(this.shadowRoot.querySelector("#icon").icon=this.activeIcon),this.shadowRoot.querySelector("#icon").classList.remove("activeIcon"))}tapEventOn(e){let t=e.target;this.dispatchEvent(new CustomEvent("node-is-active",{bubbles:!0,cancelable:!0,composed:!0,detail:{target:t}}))}_getActiveIcon(e,t,s){if(void 0!==e){var i=e;return"loading"==s?(i=this.loadingIcon,this.shadowRoot.querySelector("#icon").classList.add("transition")):"finished"==s?i=this.finishedIcon:"complete"==s&&void 0!==t?(this.playSound&&!this.__chimed&&this._playSound(),i=t):this.shadowRoot.querySelector("#icon").classList.remove("transition"),i}return!1}_playSound(){"complete"==this.status?(window.audio=new Audio(this.completeSound),this.__chimed=!0):"finished"==this.status?(window.audio=new Audio(this.finishedSound),this.__finishchimed=!0):window.audio=new Audio,window.audio.play()}_loadingStatus(e){return"loading"==e}_finishedStatus(e){return"finished"==e&&(this.playFinishSound&&!this.__finishchimed&&this._playSound(),!0)}_statusChange(e,t){void 0!==t&&e!==t&&this.dispatchEvent(new CustomEvent("node-status-change",{bubbles:!0,cancelable:!0,composed:!0,detail:{status:e}}))}_disableStatus(e){return"disabled"==e}}window.customElements.define(LrnsysProgressCircle.tag,LrnsysProgressCircle);export{LrnsysProgressCircle};