/**
 * Copyright 2018 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as e,html as t,css as i}from"../../lit-element/lit-element.js";import"../simple-icon/simple-icon.js";import"../simple-icon/lib/simple-icons.js";class MagazineCover extends e{static get styles(){return[i`
        :host {
          display: block;
          background-color: #222222;
          overflow: hidden;
          --magazine-cover-text-color: #eeeeee;
        }
        .overlay {
          left: 0;
          right: 0;
          min-height: 30vh;
          margin: -38vh 0 0 0;
          background-color: rgba(0, 0, 0, 0.8);
          padding: 32px;
          position: relative;
        }
        #image {
          opacity: 0.5;
          filter: alpha(opacity=50);
          transition: opacity 0.3s linear;
          width: 100%;
          height: 80vh;
          background-color: #222222;
        }
        #image:hover {
          opacity: 0.9;
          filter: alpha(opacity=90);
        }
        #header {
          color: var(--magazine-cover-text-color);
          font-size: 48px;
          padding: 0;
          margin: 0;
          font-weight: bold;
        }
        #subheader {
          color: var(--magazine-cover-text-color);
          font-size: 22.4px;
          padding: 0;
          margin: 3.2px 0 16px 0;
          font-style: italic;
          font-weight: normal;
        }
        #body {
          color: var(--magazine-cover-text-color);
          padding: 0;
          margin: 0;
          font-size: 19.2px;
          padding: 0 0 0 3.2px;
          margin: 0 0 32px 0;
        }
        #body p {
          color: var(--magazine-cover-text-color);
        }
        #action {
          color: var(--magazine-cover-text-color);
          text-transform: none;
          font-size: 24px;
          font-style: italic;
          font-weight: bold;
          background-color: #000000;
          border: 1px solid var(--magazine-cover-text-color);
          border-radius: 8px;
          transition: background 0.3s linear;
          width: 100%;
          margin: 0;
        }
        #action:hover,
        #action:focus {
          border-color: #ffffff;
          color: #ffffff;
          background-color: rgba(255, 255, 255, 0.2);
        }
        #actionlink {
          color: var(--magazine-cover-text-color);
          display: flex;
          text-decoration: none;
          border-radius: 8px;
        }
        #icon {
          display: inline-block;
          width: 19.2px;
          height: 19.2px;
          font-size: 19.2px;
          margin-left: 8px;
        }
        #label {
          text-shadow: -1px 1px 2px #000000;
        }
        @media screen and (max-width: 900px) {
          #header {
            font-size: 32px;
          }
          #subheader {
            font-size: 16px;
          }
          #body {
            font-size: 16px;
          }
          #action {
            font-size: 19.2px;
          }
        }
        @media screen and (max-width: 650px) {
          #body {
            font-size: 12.8px;
          }
          #action {
            font-size: 16px;
          }
          .overlay {
            margin: -50vh 0 0 0;
            padding: 16px;
          }
        }
      `]}constructor(){super(),this.action="Touch to learn more",this.icon="trending-flat",this.link="",this.eventName="",this.eventData={}}render(){return t`
      <img
        src="${this.image}"
        loading="lazy"
        id="image"
        aria-describedby="${this.describedBy||""}"
      />
      <div class="overlay">
        <h2 id="header" ?hidden="${!this.header}">${this.header}</h2>
        <div id="subheader" ?hidden="${!this.subheader}">${this.subheader}</div>
        <div id="body">
          <p ?hidden="${!this.text}">${this.text}</p>
          <slot></slot>
        </div>
        <a
          tabindex="-1"
          href="${this.link}"
          id="actionlink"
          @click="${this._linkTapped}"
        >
          <button raised="" id="action">
            <span id="label"
              >${this.action}<simple-icon
                accent-color="grey"
                dark
                id="icon"
                icon="${this.icon}"
                ?hidden="${!this.icon}"
              ></simple-icon
            ></span>
          </button>
        </a>
      </div>
    `}static get tag(){return"magazine-cover"}static get properties(){return{header:{type:String},subheader:{type:String},text:{type:String},image:{type:String},action:{type:String},describedBy:{type:String,attribute:"described-by"},icon:{type:String},link:{type:String},eventName:{type:String,attribute:"event-name"},eventData:{type:Object,attribute:"event-data"}}}_linkTapped(e){""!==this.eventName&&(e.preventDefault(),e.stopPropagation(),this.dispatchEvent(new CustomEvent(this.eventName,{bubbles:!0,cancelable:!0,composed:!0,detail:this.eventData})))}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!0,gizmo:{title:"Cover image",description:"Present a full screen cover image with a call to action. Good for starting off a series of content",icon:"flip-to-front",color:"teal",groups:["Image","Presentation"],handles:[{type:"image",source:"image",title:"header",caption:"subheader",citation:"subheader",description:"text",ariaDescribedby:"describedBy"}],meta:{author:"ELMS:LN"}},settings:{configure:[{property:"image",title:"Image",description:"The URL for the image.",inputMethod:"haxupload",icon:"link",required:!0,validationType:"url"},{property:"header",title:"Header",description:"Primary header",inputMethod:"textfield",icon:"editor:title",required:!0},{property:"subheader",title:"Sub-header",description:"Secondary header",inputMethod:"textfield",icon:"editor:text-fields"},{property:"text",title:"Text",description:"Secondary header",inputMethod:"textfield",icon:"editor:text-fields"},{property:"action",title:"Call to action",description:"Text that lives on the button",inputMethod:"textfield",icon:"trending-flat"},{property:"link",title:"URL",description:"Enter URL for your action link",inputMethod:"haxupload",icon:"send"},{property:"icon",title:"Action icon",description:"Icon used for the call to action",inputMethod:"iconpicker",options:["icons:trending-flat","icons:launch","icons:pan-tool","icons:link","icons:check","icons:favorite","icons:thumb-up","icons:send"]}],advanced:[{property:"describedBy",title:"aria-describedby",description:"Space-separated list of IDs for elements that describe the image.",inputMethod:"textfield"},{property:"event-name",title:"Event name",description:"Name of the event to fire",inputMethod:"textfield"},{property:"event-data",title:"Event data (JSON)",description:"JSON blob of data to send along",inputMethod:"code-editor"}]}}}}window.customElements.define(MagazineCover.tag,MagazineCover);export{MagazineCover};