/**
 * Copyright 2018 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as t,html as e,css as i}from"../../lit-element/lit-element.js";class MemeMaker extends t{static get styles(){return[i`
        :host {
          display: block;
        }
        * {
          box-sizing: border-box;
        }
        figure {
          position: relative;
          width: 100%;
          margin: 0;
          padding: 0;
          font-size: 20px;
        }
        img {
          width: 100%;
          height: auto;
        }
        .top-text,
        .bottom-text {
          position: absolute;
          left: 0;
          width: 100%;
          padding: 3% 2%;
          text-align: center;
          text-transform: uppercase;
          font-weight: 900;
          font-family: "Impact", "Arial Black", "sans serif";
          line-height: 1.2;
          font-size: var(--meme-maker-font-size, 36px);
          color: white;
          text-shadow: -1px -1px 0 #000, 1px -1px 0 #000, -1px 1px 0 #000,
            1px 1px 0 #000;
          letter-spacing: 2px;
        }
        .top-text {
          top: 0;
        }
        .bottom-text {
          bottom: 0;
        }
        @media (max-width: 800px) {
          .top-text,
          .bottom-text {
            font-size: var(--meme-maker-font-size-medium, 20px);
          }
        }
        @media (max-width: 600px) {
          .top-text,
          .bottom-text {
            font-size: var(--meme-maker-font-size-small, 20px);
          }
        }
      `]}render(){return e`
      <figure>
        <img
          loading="lazy"
          src="${this.imageUrl}"
          .alt="${this.alt}"
          aria-describedby="${this.describedBy||""}"
        />
        <figcaption class="top-text">${this.topText}</figcaption>
        <figcaption class="bottom-text">${this.bottomText}</figcaption>
      </figure>
    `}static get tag(){return"meme-maker"}constructor(){super(),this.alt=""}static get properties(){return{alt:{type:String},describedBy:{type:String,attribute:"described-by"},imageUrl:{type:String,attribute:"image-url",reflect:!0},topText:{type:String,attribute:"top-text",reflect:!0},bottomText:{type:String,attribute:"bottom-text",reflect:!0}}}haxHooks(){return{activeElementChanged:"haxactiveElementChanged",progressiveEnhancement:"haxprogressiveEnhancement"}}haxactiveElementChanged(t,e){let i=this.shadowRoot.querySelectorAll("figcaption");if(e)for(var o=0;o<i.length;o++)i[o].setAttribute("contenteditable",!0);else{for(o=0;o<i.length;o++)i[o].removeAttribute("contenteditable");this.topText=this.shadowRoot.querySelector(".top-text").innerText,this.bottomText=this.shadowRoot.querySelector(".bottom-text").innerText}return!1}haxprogressiveEnhancement(t){return`\n    ${this.topText?`<div>${this.topText}</div>`:""}\n      <img src="${this.imageUrl}" alt="${this.alt}" preload="lazy" aria-describedby="${this.describedBy||""}"/>\n    ${this.bottomText?`<div>${this.bottomText}</div>`:""}`}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!0,gizmo:{title:"Meme",description:"Make a meme out of an image",icon:"hax:meme",color:"orange",groups:["Media","Funny"],handles:[{type:"image",source:"imageUrl",title:"topText",author:"bottomText",alt:"alt",ariaDescribedby:"describedBy"}],meta:{author:"ELMS:LN"}},settings:{configure:[{property:"imageUrl",title:"Source",description:"The source url for the element this is citing.",inputMethod:"haxupload",icon:"link"},{property:"topText",title:"Top text",description:"Top text of the meme.",inputMethod:"textfield",icon:"editor:title"},{property:"bottomText",title:"Bottom text",description:"The date this was accessed.",inputMethod:"textfield",icon:"editor:title"}],advanced:[{property:"describedBy",title:"aria-describedby",description:"Space-separated list of IDs for elements that describe the image.",inputMethod:"textfield"}]},saveOptions:{wipeSlot:!0},demoSchema:[{tag:"meme-maker",content:"",properties:{alt:"Cat stalking a small toy",imageUrl:"https://cdn2.thecatapi.com/images/9j5.jpg",topText:"I bring you",bottomText:"the death"}}]}}}window.customElements.define(MemeMaker.tag,MemeMaker);export{MemeMaker};