/**
 * Copyright 2020 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as e,html as i,css as t}from"../../lit-element/lit-element.js";class MusicPlayer extends e{static get tag(){return"music-player"}constructor(){super(),this.noWaterfall=!1,this.noVisual=!1,this.visualizer="staff"}static get styles(){return[t`
        :host {
          display: block;
        }

        :host([hidden]) {
          display: none;
        }
        midi-player {
          display: block;
          width: var(--music-player-midi-player-width, unset);
          margin: var(--music-player-midi-player-margin, 4px);
        }
        :host([no-visual]) midi-visualizer {
          display: none;
        }

        :host([no-waterfall]) midi-visualizer .waterfall-notes-container {
          display: none;
        }
        midi-visualizer .waterfall-visualizer {
          overflow: auto;
        }
      `]}render(){return i`
      <midi-visualizer
        type="${this.visualizer}"
        src="${this.source}"
      ></midi-visualizer>
      <midi-player src="${this.source}" sound-font></midi-player>
    `}static get properties(){return{source:{type:String},visualizer:{type:String},noWaterfall:{type:Boolean,attribute:"no-waterfall",reflect:!0},noVisual:{type:Boolean,attribute:"no-visual",reflect:!0}}}firstUpdated(){this.visualizerElement=this.shadowRoot.querySelector("midi-visualizer"),setTimeout(()=>{import("./lib/html-midi-player.js").then(e=>{this.shadowRoot.querySelector("midi-player").addVisualizer(this.visualizerElement)})},0)}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!0,gizmo:{title:"Music player",description:"Play music in context with a data visualization",icon:"image:music-note",color:"blue",groups:["Media","Music"],handles:[{type:"audio",source:"source"}],meta:{author:"ELMS:LN"}},settings:{configure:[{property:"source",title:"Source",description:"Source of the file to play",inputMethod:"haxupload"},{property:"visualizer",title:"Visualization",description:"How to visualize the music file",inputMethod:"select",options:{staff:"Staff","piano-roll":"Piano roll",waterfall:"Piano + waterfall"}},{property:"noWaterfall",title:"Hide waterfall",description:"Disable the waterfall of notes when visualized as a piano",inputMethod:"boolean"}],advanced:[]},demoSchema:[{tag:"music-player",content:"",properties:{source:"https://magenta.github.io/magenta-js/music/demos/melody.mid"}}]}}}customElements.define(MusicPlayer.tag,MusicPlayer);export{MusicPlayer};