/**
 * Copyright 2020 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as t,html as e,css as i}from"../../lit-element/lit-element.js";import{AccentCard as o}from"../accent-card/accent-card.js";import"../simple-icon/simple-icon.js";import"../simple-icon/lib/simple-icons.js";import"./lib/nav-card-item.js";class NavCard extends o{static get styles(){return[...super.styles,i`
        :host {
          display: block;
          --accent-card-content-padding-bottom: 0px;
        }

        ::slotted([slot="linklist"]) {
          --nav-card-item-color: var(--accent-card-color);
          --nav-card-item-background-color: var(--accent-card-background-color);
          margin-top: var(--nav-card-linklist-margin-top, 20px);
          margin-bottom: var(--nav-card-linklist-margin-bottom, 20px);
        }
      `]}render(){return e` <article id="card">
      <div class="image-outer" ?hidden="${!this.imageSrc}">
        <div
          class="image"
          .style="${this.imageSrc?`background-image: url(${this.imageSrc});`:"display: none;"}"
        ></div>
      </div>
      <div class="body">
        <h1 id="heading"><slot name="heading"></slot></h1>
        <div id="subheading"><slot name="subheading"></slot></div>
        <div id="content">
          <slot name="body"></slot>
          <div id="linklist">
            <slot name="linklist"></slot>
          </div>
        </div>
        <div id="footer"><slot name="footer"></slot></div>
      </div>
    </article>`}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!0,gizmo:{title:"Nav card",description:"an accent card of link lists",icon:"av:playlist-play",color:"pink",groups:["Card","Nav","List"],handles:[{type:"todo:read-the-docs-for-usage"}],meta:{author:"nikkimk",owner:"The Pennsylvania State University"}},settings:{configure:[{property:"accentColor",title:"Accent Color",description:"Select an accent color.",inputMethod:"colorpicker",required:!1},{property:"dark",title:"Dark",description:"Display the card as dark theme?",inputMethod:"boolean",required:!1},{property:"imageSrc",title:"Image",description:"Optional image",inputMethod:"haxupload"},{slot:"heading",title:"Heading",inputMethod:"code-editor",required:!1},{slot:"subheading",title:"Subheading",inputMethod:"code-editor",required:!1},{slot:"body",title:"Body",inputMethod:"code-editor",required:!1},{property:"linkIcon",title:"Link Icon",description:"Select an icon.",inputMethod:"iconpicker",required:!1},{slot:"linklist",title:"Link List",inputMethod:"code-editor",required:!1},{slot:"footer",title:"Footer",inputMethod:"code-editor",required:!1}],advanced:[]}}}static get properties(){return{...super.properties}}static get tag(){return"nav-card"}constructor(){super(),this.tag=NavCard.tag}}customElements.define("nav-card",NavCard);export{NavCard};