/**
 * Copyright 2019 Penn State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as t,html as e,css as i}from"../../../../lit-element/lit-element.js";import{RichTextEditorButtonStyles as n}from"./rich-text-editor-button-styles.js";import"../singletons/rich-text-editor-selection.js";import"../../../simple-icon/lib/simple-icon-lite.js";import"../../../simple-icon/lib/simple-icons.js";import"../../../simple-icon/lib/simple-icon-button-lite.js";import"../../../hax-iconset/lib/simple-hax-iconset.js";const RichTextEditorButtonBehaviors=function(t){return class extends(n(t)){firstUpdated(t){super.firstUpdated&&super.firstUpdated(t),this.__a11y=this.shadowRoot.querySelector("#button"),this.__a11y.addEventListener("keypress",t=>{switch(t.key){case"Enter":this._buttonTap(t)}})}static get tag(){return"rich-text-editor-button"}static get styles(){return[...super.styles,i`
          .rtebutton {
            min-width: var(--rich-text-editor-button-min-width);
            height: var(--rich-text-editor-button-height);
            margin: var(--rich-text-editor-button-margin);
            padding: var(--rich-text-editor-button-padding);
          }
        `]}render(){return e`
        <button
          id="button"
          class="rtebutton"
          ?disabled="${this.disabled}"
          ?controls="${this.controls}"
          @click="${this._buttonTap}"
          tabindex="0"
          ?toggled="${this.isToggled}"
        >
          <simple-icon-lite
            id="icon"
            aria-hidden="true"
            icon="${this.currentIcon}"
          >
          </simple-icon-lite>
          <span id="label" class="${this.labelStyle}"
            >${this.currentLabel}</span
          >
        </button>
        <simple-tooltip id="tooltip" for="button"
          >${this.currentLabel}</simple-tooltip
        >
      `}static get properties(){return{controls:{type:String},command:{type:String},commandVal:{attribute:"command-val",type:Object},disabled:{type:Boolean},icon:{type:String},label:{type:String},range:{type:Object},shortcutKeys:{attribute:"shortcut-keys",type:String},showTextLabel:{attribute:"show-text-label",type:Boolean},tag:{type:String},target:{type:Object},toggledCommand:{attribute:"toggled-command",type:String},toggledCommandVal:{attribute:"toggled-command-val",type:Object},toggledIcon:{attribute:"toggled-icon",type:String},toggledLabel:{attribute:"toggled-label",type:String},selectedNode:{type:Object},selectionAncestors:{type:Array},toggles:{type:Boolean},__selection:{type:Object}}}constructor(){super(),this.__selection=window.RichTextEditorSelection.requestAvailability(),this.disabled=!1,this.showTextLabel=!1,this.toggles=!1,import("../../../simple-tooltip/simple-tooltip.js")}get blockSelectors(){return"p,h1,h2,h3,h4,h5,h6,div,address,blockquote,pre"}get currentLabel(){return this._regOrToggled(this.label,this.toggledLabel,this.isToggled)}get currentIcon(){return this._regOrToggled(this.icon,this.toggledIcon,this.isToggled)}get labelStyle(){return this.icon&&""!==this.icon&&!1===this.showTextLabel?"offscreen":null}get isToggled(){let t=!(!this.range||!this.command)&&document.queryCommandState(this.command),e="underline"===this.command?!!this.rangeQuery("u"):t;return!(!this.toggles||!e)}get validCommands(){return["backColor","bold","createLink","copy","cut","defaultParagraphSeparator","delete","fontName","fontSize","foreColor","formatBlock","forwardDelete","insertHorizontalRule","insertHTML","insertImage","insertLineBreak","insertOrderedList","insertParagraph","insertText","insertUnorderedList","justifyCenter","justifyFull","justifyLeft","justifyRight","outdent","paste","redo","selectAll","strikethrough","styleWithCss","superscript","undo","unlink","useCSS"]}updated(t){super.updated(t),t.forEach((t,e)=>{"controls"===e&&this._editorChanged(this.controls,t),"range"===e&&this._rangeChanged(this.range,t)})}disconnectedCallback(){super.disconnectedCallback()}get operationCommand(){return this.isToggled&&this.toggledCommand?this.toggledCommand:this.command}get operationCommandVal(){return this.isToggled&&this.toggledCommand?this.toggledCommandVal||"":this.commandVal}highlight(t=!0){this.dispatchEvent(new CustomEvent("highlight",{bubbles:!0,composed:!0,cancelable:!0,detail:t}))}highlightNode(t){this.dispatchEvent(new CustomEvent("highlightnode",{bubbles:!0,composed:!0,cancelable:!0,detail:t}))}selectRange(t){this.dispatchEvent(new CustomEvent("selectrange",{bubbles:!0,composed:!0,cancelable:!0,detail:t}))}selectNode(t){this.dispatchEvent(new CustomEvent("selectnode",{bubbles:!0,composed:!0,cancelable:!0,detail:t}))}selectNodeContents(t){this.dispatchEvent(new CustomEvent("selectnodeccontents",{bubbles:!0,composed:!0,cancelable:!0,detail:t}))}wrapSelection(t){this.dispatchEvent(new CustomEvent("wrapselection",{bubbles:!0,composed:!0,cancelable:!0,detail:t}))}startNode(){let t=this.range?this.range.startContainer:void 0,e=this.range?this.range.startOffset:void 0;return t?t.children?t.children[e-1]:t.childNodes?t.childNodes[e-1]:void 0:void 0}rangeElement(){return this.rangeIsElement()?this.startNode():this.rangeParent()}rangeIsElement(){let t=this.range?this.range.startContainer:void 0,e=this.range?this.range.startOffset:void 0,i=this.range?this.range.endContainer:void 0,n=this.range?this.range.endOffset:void 0;return t===i&&n-e==1}rangeParent(){let t=this.range?this.range.commonAncestorContainer:void 0;return t?1==t.nodeType?t:t.parentElement:void 0}rangeQuery(t=this.blockSelectors||this.tag){t=t.toLowerCase().replace(/\s*/g,"");let e=this.rangeElement(),i=e&&e.tagName?e.tagName.toLowerCase():void 0,n=t.split(",");return e?i&&n.includes(i)?e:e.closest(t):void 0}sendCommand(t=this.operationCommand,e=this.operationCommandVal){this.dispatchEvent(new CustomEvent("command",{bubbles:!0,cancelable:!0,composed:!0,detail:{command:t,commandVal:e,range:this.range}}))}setRange(){let t=this.rangeQuery();t&&this.selectNode(t)}_buttonTap(t){console.log("_buttonTap",this.range),t.preventDefault(),this.sendCommand()}_editorChanged(t,e){}_getSelection(){return"formatBlock"===this.command?this.rangeQuery():this._getSelectedHtml()}_getSelectedHtml(){if(this.range){let t,e=document.createElement("div"),i=this.range.cloneContents();return e.appendChild(i),t=e.innerHTML,e.remove(),t?t.trim():void 0}}_getSelectedTag(){let t=this.rangeQuery();return!(!t||!t.tagName)&&t.tagName.toLowerCase()}_getSelectionType(){return"formatBlock"===this.command?this._getSelectedTag():this._getSelectedHtml()}_keysPressed(t){t.preventDefault(),this._buttonTap(t)}_rangeChanged(t,e){}_regOrToggled(t,e,i){return e&&i?e:t}}};class RichTextEditorButton extends(RichTextEditorButtonBehaviors(t)){}window.customElements.define(RichTextEditorButton.tag,RichTextEditorButton);export{RichTextEditorButton,RichTextEditorButtonBehaviors};