/**
 * Copyright 2019 Penn State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as t,html as e,css as o}from"../../../../lit-element/lit-element.js";import{RichTextEditorStyles as i}from"../rich-text-editor-styles.js";import"../../../responsive-utility/responsive-utility.js";import"../singletons/rich-text-editor-selection.js";import"../../../simple-icon/lib/simple-icon-lite.js";import"../../../simple-icon/lib/simple-icons.js";import"../../../simple-icon/lib/simple-icon-button-lite.js";import"../../../hax-iconset/lib/simple-hax-iconset.js";const RichTextEditorToolbarBehaviors=function(t){return class extends(i(t)){static get tag(){return"rich-text-editor-toolbar"}static get stickyStyles(){return[o`
          :host([sticky]) {
            position: sticky;
            top: 0;
          }
        `]}static get baseStyles(){return[...super.styles,o`
          :host([hidden]) {
            display: none;
          }
          #toolbar {
            display: flex;
            opacity: 1;
            z-index: 1;
            margin: 0;
            align-items: stretch;
            flex-wrap: wrap;
            justify-content: flex-start;
            background-color: var(--rich-text-editor-bg);
            border: var(--rich-text-editor-border);
            font-size: 12px;
            transition: all 0.5s;
          }
          #toolbar[aria-hidden="true"] {
            visibility: hidden;
            opacity: 0;
            height: 0;
          }
          #toolbar .group {
            display: flex;
            flex-wrap: nowrap;
            justify-content: space-evenly;
            align-items: stretch;
            padding: 0 3px;
          }
          #toolbar .group:not(:last-of-type) {
            margin-right: 3px;
            border-right: var(--rich-text-editor-border);
          }
          #toolbar .button {
            display: flex;
            flex: 0 0 auto;
            align-items: stretch;
          }
          #toolbar #morebutton {
            flex: 1 0 auto;
            justify-content: flex-end;
          }
          /* hide more button if all buttons are displayed */
          #toolbar[responsive-size="xs"] #morebutton[collapse-max="xs"],
          #toolbar[responsive-size="sm"] #morebutton[collapse-max*="s"],
          #toolbar[responsive-size="md"] #morebutton:not([collapse-max*="l"]),
          #toolbar[responsive-size="lg"] #morebutton:not([collapse-max="xl"]),
          #toolbar[responsive-size="xl"] #morebutton,
          /* hide buttons if they should be collaped until */
          #toolbar[responsive-size="xs"][collapsed] *[collapsed-until*="m"],
          #toolbar[responsive-size="xs"][collapsed] *[collapsed-until*="l"],
          #toolbar[responsive-size="sm"][collapsed] *[collapsed-until="md"],
          #toolbar[responsive-size="sm"][collapsed] *[collapsed-until*="l"],
          #toolbar[responsive-size="md"][collapsed] *[collapsed-until*="l"],
          #toolbar[responsive-size="lg"][collapsed] *[collapsed-until="xl"] {
            display: none;
          }
        `]}static get styles(){return[...this.baseStyles,...this.stickyStyles]}get toolbarTemplate(){return e`
        <div
          id="toolbar"
          aria-live="polite"
          aria-hidden="${this.controls||this.alwaysVisible?"false":"true"}"
          ?collapsed="${this.collapsed}"
          @selectnode="${t=>this.selectNode(t.detail)}"
          @selectnodecontents="${t=>this.selectNodeContents(t.detail)}"
          @selectrange="${t=>this.selectRange(t.detail)}"
        >
          <rich-text-editor-more-button
            id="morebutton"
            class="button"
            aria-controls="toolbar"
            icon="${this.moreIcon}"
            label="${this.moreLabel}"
            ?show-text-label="${this.moreShowTextLabel}"
            ?label-toggled="${this.moreLabelToggled}"
            ?toggled="${!this.collapsed}"
            @click="${this._toggleMore}"
          >
          </rich-text-editor-more-button>
        </div>
      `}render(){return e` ${this.toolbarTemplate} `}static get properties(){return{alwaysVisible:{type:Boolean,attribute:"always-visible",reflect:!0},buttons:{name:"buttons",type:Array},collapsed:{name:"collapsed",type:Boolean,attribute:"collapsed"},config:{name:"config",type:Object,attribute:"config"},editor:{name:"editor",type:Object,attribute:"editor"},id:{name:"id",type:String,attribute:"id",reflect:!0},moreIcon:{name:"moreIcon",type:String,attribute:"more-icon"},moreLabel:{name:"moreLabel",type:String,attribute:"more-label"},moreLabelToggled:{name:"moreLabelToggled",type:String,attribute:"more-label-toggled",value:"Fewer Buttons"},moreShowTextLabel:{name:"moreShowTextLabel",type:Boolean,attribute:"more-show-text-label"},responsiveSize:{name:"responsiveSize",type:String,attribute:"responsive-size",reflect:!0},savedSelection:{name:"savedSelection",type:Object},range:{name:"range",type:Object},registered:{type:Boolean},selectedNode:{type:Object},selectionAncestors:{type:Array},shortcutKeys:{name:"shortcutKeys",type:Array},sticky:{name:"sticky",type:Boolean,attribute:"sticky",reflect:!0},__clickableElement:{name:"__clickableElement",type:Array},__selection:{type:Object}}}constructor(){super(),import("../buttons/rich-text-editor-button.js"),import("../buttons/rich-text-editor-more-button.js"),import("../buttons/rich-text-editor-heading-picker.js"),import("../buttons/rich-text-editor-symbol-picker.js"),import("../buttons/rich-text-editor-underline.js"),import("../buttons/rich-text-editor-image.js"),import("../buttons/rich-text-editor-link.js"),import("../buttons/rich-text-editor-button-styles.js"),import("../../../../@polymer/iron-icons/iron-icons.js"),import("../../../../@polymer/iron-icons/editor-icons.js"),import("../../../../@polymer/iron-icons/image-icons.js"),import("../../../md-extra-icons/md-extra-icons.js"),window.ResponsiveUtility.requestAvailability(),this.alwaysVisible=!1,this.collapsed=!0,this.config=[{label:"History",type:"button-group",buttons:[{command:"undo",icon:"undo",label:"Undo",shortcutKeys:"ctrl+z",type:"rich-text-editor-button"},{command:"redo",icon:"redo",label:"Redo",shortcutKeys:"ctrl+shift+z",type:"rich-text-editor-button"}]},{label:"Basic Inline Operations",type:"button-group",buttons:[{label:"Format",type:"rich-text-editor-heading-picker"},{command:"bold",icon:"editor:format-bold",label:"Bold",shortcutKeys:"ctrl+b",toggles:!0,type:"rich-text-editor-button"},{command:"italic",icon:"editor:format-italic",label:"Italics",shortcutKeys:"ctrl+i",toggles:!0,type:"rich-text-editor-button"},{command:"removeFormat",icon:"editor:format-clear",label:"Erase Format",type:"rich-text-editor-button"}]},{label:"Links",type:"button-group",buttons:[{icon:"link",label:"Link",shortcutKeys:"ctrl+k",type:"rich-text-editor-link"}]},{label:"Clipboard Operations",type:"button-group",buttons:[{command:"cut",icon:"content-cut",label:"Cut",shortcutKeys:"ctrl+x",type:"rich-text-editor-button"},{command:"copy",icon:"content-copy",label:"Copy",shortcutKeys:"ctrl+c",type:"rich-text-editor-button"},{command:"paste",icon:"content-paste",label:"Paste",shortcutKeys:"ctrl+v",type:"rich-text-editor-button"}]},{collapsedUntil:"md",label:"Subscript and Superscript",type:"button-group",buttons:[{command:"subscript",icon:"mdextra:subscript",label:"Subscript",toggles:!0,type:"rich-text-editor-button"},{command:"superscript",icon:"mdextra:superscript",label:"Superscript",toggles:!0,type:"rich-text-editor-button"}]},{collapsedUntil:"sm",icon:"editor:functions",label:"Insert Symbol",symbolTypes:["symbols"],type:"rich-text-editor-symbol-picker"},{collapsedUntil:"sm",label:"Lists and Indents",type:"button-group",buttons:[{command:"insertOrderedList",icon:"editor:format-list-numbered",label:"Ordered List",toggles:!0,type:"rich-text-editor-button"},{command:"insertUnorderedList",icon:"editor:format-list-bulleted",label:"Unordered List",toggles:!0,type:"rich-text-editor-button"},{collapsedUntil:"lg",command:"formatBlock",commandVal:"blockquote",label:"Blockquote",icon:"editor:format-quote",shortcutKeys:"ctrl+'",type:"rich-text-editor-button"},{command:"indent",icon:"editor:format-indent-increase",event:"text-indent",label:"Increase Indent",shortcutKeys:"ctrl+]",type:"rich-text-editor-button"},{command:"outdent",event:"text-outdent",icon:"editor:format-indent-decrease",label:"Decrease Indent",shortcutKeys:"ctrl+[",type:"rich-text-editor-button"}]}],this.moreIcon="more-vert",this.moreLabel="More Buttons",this.moreLabelToggled="Fewer Buttons",this.moreShowTextLabel=!1,this.responsiveSize="xs",this.sticky=!1,this.__clickableElement=[],this.shortcutKeys=[]}firstUpdated(t){super.firstUpdated(t),this.buttons=this._getButtons(),window.dispatchEvent(new CustomEvent("responsive-element",{detail:{element:this.shadowRoot.querySelector("#toolbar")}})),this.__selection=window.RichTextEditorSelection.requestAvailability(),this.register()}updated(t){super.updated(t),t.forEach((t,e)=>{"range"===e&&this._rangeChange(),"editor"===e&&this._editorChange()})}connectedCallback(){super.connectedCallback(),this.register()}disconnectedCallback(){super.disconnectedCallback(),this.register(!0)}get controls(){return this.editor?this.editor.getAttribute("id"):void 0}cancel(){this.dispatchEvent(new c("cancel",{bubbles:!0,cancelable:!0,composed:!0,detail:this}))}highlight(t=!0){this.dispatchEvent(new CustomEvent("highlight",{bubbles:!0,cancelable:!0,composed:!0,detail:t}))}register(t=!1){window.dispatchEvent(new CustomEvent("register",{bubbles:!0,cancelable:!0,composed:!0,detail:{remove:t,toolbar:this}}))}selectNode(t){this.dispatchEvent(new CustomEvent("selectnode",{bubbles:!0,cancelable:!0,composed:!0,detail:t}))}selectNodeContents(t){this.dispatchEvent(new CustomEvent("selectnodecontents",{bubbles:!0,cancelable:!0,composed:!0,detail:t}))}selectRange(t){this.dispatchEvent(new CustomEvent("selectrange",{bubbles:!0,cancelable:!0,composed:!0,detail:t}))}newEditor(t){let e=document.createElement("rich-text-editor");t.parentNode.insertBefore(e,t),e.appendChild(t)}pasteFromClipboard(){this.dispatchEvent(new CustomEvent("pastefromclipboard",{bubbles:!0,cancelable:!0,composed:!0,detail:this.editor}))}_addButton(t,e){let o=document.createElement(t.type),i=o.shortcutKeys?o.shortcutKeys.replace(/ctrl\+[xcv]/g,""):"";for(var s in this.shortcutKeys[i]=o,t)o[s]=t[s];return o.setAttribute("class","button"),o.addEventListener("button-command",this._handleButton),o.inlineWidget&&this.push("__clickableElement",o.tag),e.appendChild(o),o}_getButtons(){let t=this.shadowRoot&&this.shadowRoot.querySelector("#toolbar")?this.shadowRoot.querySelector("#toolbar"):void 0;if(t){let e=t.querySelector("#morebutton"),o=0,i=["xs","sm","md","lg","xl"],s=[];return t.innerHTML="",this.shortcutKeys=[],this.config.forEach(r=>{if("button-group"===r.type){let e=document.createElement("div");e.setAttribute("class","group"),void 0!==r.collapsedUntil&&null!==r.collapsedUntil&&e.setAttribute("collapsed-until",r.collapsedUntil),o=Math.max(o,i.indexOf(r.collapsedUntil)),r.buttons.forEach(t=>{o=Math.max(o,i.indexOf(t.collapsedUntil)),(navigator.clipboard||"paste"!==t.command)&&s.push(this._addButton(t,e))}),t.appendChild(e)}else o=Math.max(o,i.indexOf(r.collapsedUntil)),(navigator.clipboard||"paste"!==r.command)&&s.push(this._addButton(r,t));t.appendChild(e),e.collapseMax=i[o]}),s}return[]}_editorChange(){this.range=void 0,this.c&&(this.breadcrumbs.controls=this.controls,this.breadcrumbs.sticky=this.sticky,this.breadcrumbs.controls=this.controls,this.breadcrumbs.hidden=!this.controls&&!this.alwaysVisible,this.editor&&this.editor.parentNode.insertBefore(this.breadcrumbs,this.editor.nextSibling))}_rangeChange(){this.range&&this.range.commonAncestorContainer&&this.editor&&this.editor.contains(this.range.commonAncestorContainer)&&(this.buttons.forEach(t=>{t.range=void 0,t.range=this.range,t.selectedNode=this.selectedNode,t.selectionAncestors=this.selectionAncestors}),this.breadcrumbs&&(this.breadcrumbs.controls=this.controls,this.breadcrumbs.selectionAncestors=this.selectionAncestors,this.breadcrumbs.hidden=!this.controls&&!this.alwaysVisible))}_toggleMore(t){this.collapsed=!this.collapsed}}};class RichTextEditorToolbar extends(RichTextEditorToolbarBehaviors(t)){}window.customElements.define(RichTextEditorToolbar.tag,RichTextEditorToolbar);export{RichTextEditorToolbar,RichTextEditorToolbarBehaviors};