/**
 * Copyright 2018 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as t,html as e,css as i}from"../../lit-element/lit-element.js";import"./lib/singletons/rich-text-editor-selection.js";import{RichTextEditorStyles as r}from"./lib/rich-text-editor-styles.js";import"./lib/toolbars/rich-text-editor-toolbar.js";import"./lib/toolbars/rich-text-editor-toolbar-mini.js";import"./lib/toolbars/rich-text-editor-toolbar-full.js";import*as o from"../../shadow-selection-polyfill/shadow.js";class RichTextEditor extends(r(t)){static get styles(){return[...super.styles,i`
        :host([hidden]) {
          display: none;
        }

        :host {
          display: block;
          cursor: pointer;
          min-height: 40px;
        }

        :host([contenteditable="true"]) {
          border: var(--rich-text-editor-border);
          overflow: auto;
        }

        :host([contenteditable="true"]):focus-within,
        :host([contenteditable="true"]):focus {
          padding: 2px;
          margin-bottom: 2px;
        }

        :host(.heightmax[contenteditable="true"]) {
          max-height: calc(100vh - 200px);
          overflow-y: scroll;
        }

        :host(:empty) {
          border: 1px dashed var(--rich-text-editor-border-color);
          outline: 1px dashed var(--rich-text-editor-border-color);
        }

        :host(:empty):before {
          content: attr(placeholder);
          padding: 0 5px;
          display: block;
          z-index: -1;
          color: var(--rich-text-editor-button-disabled-color);
        }

        *::selection .rich-text-editor-selection {
          background-color: var(--rich-text-editor-selection-bg);
        }

        ::slotted(*:first-child) {
          margin-top: 0;
        }

        ::slotted(*:last-child) {
          margin-bottom: 0;
        }
      `]}render(){return e` <slot></slot>`}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!0,gizmo:{title:"Rich text-editor",description:"a standalone rich text editor",icon:"icons:android",color:"green",groups:["Text"],handles:[{type:"todo:read-the-docs-for-usage"}],meta:{author:"nikkimk",owner:"Penn State University"}},settings:{configure:[{property:"title",description:"",inputMethod:"textfield",required:!1,icon:"icons:android"}],advanced:[]}}}static get properties(){return{...super.properties,id:{name:"id",type:String,reflect:!0,attribute:"id"},contenteditable:{name:"contenteditable",type:Boolean,reflect:!0,attribute:"contenteditable"},placeholder:{name:"placeholder",type:String,reflect:!0,attribute:"placeholder"},toolbar:{name:"toolbar",type:String,reflect:!0,attribute:"toolbar"},range:{name:"range",type:Object,attribute:"range"},type:{name:"type",type:String,reflect:!0,attribute:"type"},updateRange:{type:Boolean},__canceledEdits:{type:Object},__connectedToolbar:{type:Object},__selection:{type:Object}}}static get tag(){return"rich-text-editor"}constructor(){super(),this.haxUIElement=!0,window.RichTextEditorStyleManager.requestAvailability(),this.placeholder="Click to edit",this.toolbar="",this.type="rich-text-editor-toolbar",this.id="",this.range=void 0,this.__selection=window.RichTextEditorSelection.requestAvailability(),document.addEventListener(o.eventName,this._getRange.bind(this))}_getRange(){let shadowRoot=t=>{let e=t.parentNode;return e?shadowRoot(e):t};this.range=o.getRange(shadowRoot(this)),this.updateRange()}get observer(){let t=this;return new MutationObserver(e=>t._getRange(e))}connectedCallback(){super.connectedCallback(),this.register()}disconnectedCallback(){super.disconnectedCallback(),this.register(!0)}firstUpdated(){super.firstUpdated&&super.firstUpdated(),this.isEmpty()&&(this.innerHTML=""),this._editableChange()}updated(t){super.updated(t),t.forEach((t,e)=>{"contenteditable"===e&&this._editableChange(),"range"===e&&this._rangeChange()})}haxHooks(){return{activeElementChanged:"haxactiveElementChanged"}}haxactiveElementChanged(t,e){return!e&&t&&(t.innerHTML=this.getValue()),t}getValue(){return this.isEmpty||this.trimmerHTML(this)===`<p>${editor.placeholder}</p>`?"":this.innerHTML}isEmpty(){return!this.innerHTML||""==this.trimmerHTML(this)}makeSticky(t=!0){t?this.classList.remove("heightmax"):this.classList.add("heightmax")}observeChanges(t=!0){if(t){let t=this;this.observer.observe(t,{attributes:!1,childList:!0,subtree:!0,characterData:!1})}else this.observer&&this.observer.disconnect}paste(t,e=!0){this._handlePaste(t)}register(t=!1){window.dispatchEvent(new CustomEvent("register",{bubbles:!0,cancelable:!0,composed:!0,detail:{remove:t,editor:this}}))}revert(){this.innerHTML=this.__canceledEdits}rootNode(){return this.__selection?this.__selection.getRoot(this):document}setCancelHTML(t=this.innerHTML){this.__canceledEdits=t}trimmerHTML(t){return t.innerHTML.replace(/[\s\t\r\n]/gim,"")}updateRange(t){this.dispatchEvent(new CustomEvent("getrange",{bubbles:!0,cancelable:!0,composed:!0,detail:this}))}_editableChange(){let t=`<p>${this.placeholder}</p>`;this.contenteditable?(this.setCancelHTML(),this.isEmpty()&&(this.innerHTML=t)):this.trimmerHTML(this)===t&&this.setCancelHTML("")}_handlePaste(t){let e="";t&&(t.clipboardData||t.originalEvent.clipboardData)?e=(t.originalEvent||t).clipboardData.getData("text/html"):window.clipboardData&&(e=window.clipboardData.getData("Text")),this.dispatchEvent(new CustomEvent("pastefromclipboard",{bubbles:!0,cancelable:!0,composed:!0,detail:this})),t.preventDefault()}_rangeChange(t){}}window.customElements.define(RichTextEditor.tag,RichTextEditor);export{RichTextEditor};