/**
 * Copyright 2020 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{html as e,css as t}from"../../lit-element/lit-element.js";import{remoteLinkBehavior as i}from"../utils/lib/remoteLinkBehavior.js";import{activeStateBehavior as o}from"../utils/lib/activeStateBehavior.js";import{SimpleColors as r}from"../simple-colors/simple-colors.js";class SimpleCta extends(o(i(r))){static get styles(){return[...super.styles,t`
        :host {
          display: inline-block;
          --simple-cta-color: var(
            --simple-colors-default-theme-accent-1,
            white
          );
          --simple-cta-outline: var(
            --simple-colors-default-theme-accent-12,
            black
          );
          --simple-cta-bg-color-is-user-selected: var(
            --simple-colors-default-theme-accent-10,
            darkgreen
          );
          --simple-cta-bg-color: var(
            --simple-colors-default-theme-accent-7,
            green
          );
          margin: 60px 0 0;
        }

        :host([hidden]) {
          display: none;
        }

        :host([contenteditable]) a {
          pointer-events: none;
        }

        :host([is-user-selected]) a {
          background-color: var(--simple-cta-bg-color-is-user-selected);
          outline: 1px solid var(--simple-cta-outline);
        }

        a {
          display: block;
          color: var(--simple-cta-color);
          background-color: var(--simple-cta-bg-color);
          transition: background 0.3s linear, border 0.3s linear,
            border-radius 0.3s linear, box-shadow 0.3s linear;
          text-decoration: none;
          font-size: 1em;
          text-transform: uppercase;
          border-radius: 100px 100px 100px 100px;
          box-shadow: 0 6px 26px 0 rgba(0, 0, 0, 0.16);
          padding: 16px 40px;
          font-family: Sans-serif;
          font-weight: 500;
        }

        a span {
          display: flex;
          justify-content: center;
        }
      `]}render(){return e` <a
      href="${this.link}"
      role="button"
      part="simple-cta-link"
      @click="${this._clickCard}"
      ?contenteditable="${this.editMode}"
    >
      <span><span id="title">${this.title}</span><slot></slot></span>
    </a>`}static get haxProperties(){return{type:"element",canScale:!0,canPosition:!0,canEditSource:!0,gizmo:{title:"Call to action",description:"A simple button with a link to take action.",icon:"image:crop-16-9",color:"orange",groups:["Marketing","Content"],handles:[{type:"link",source:"link",title:"title"}],meta:{author:"ELMS:LN"}},settings:{configure:[{property:"title",title:"Title",description:"Enter title for stop-note.",inputMethod:"textfield",required:!0},{property:"link",title:"Link",description:"Enter a link to any resource",inputMethod:"haxupload",required:!0},{property:"accentColor",title:"Accent Color",description:"An optional accent color.",inputMethod:"colorpicker",icon:"editor:format-color-fill"},{property:"dark",title:"Dark Theme",description:"Enable Dark Theme",inputMethod:"boolean",icon:"icons:invert-colors"}],advanced:[]},demoSchema:[{tag:"simple-cta",properties:{title:"Click to learn more",link:"https://haxtheweb.org/"},content:""}]}}static get properties(){return{...super.properties,link:{type:String},title:{type:String},editMode:{type:Boolean}}}static get tag(){return"simple-cta"}constructor(){super(),this.link="#",this.title=null,this.accentColor="green",this.querySelector("a")&&(this.link=this.querySelector("a").getAttribute("href"),this.title=this.querySelector("a").innerText,this.innerHTML=null)}haxHooks(){return{editModeChanged:"haxeditModeChanged",activeElementChanged:"haxactiveElementChanged"}}haxeditModeChanged(e){this.editMode=e}_clickCard(e){this.editMode&&(e.preventDefault(),e.stopPropagation(),e.stopImmediatePropagation())}haxactiveElementChanged(e,t){return this.alignState(),this.editMode=t,!1}alignState(){this.title=this.shadowRoot.querySelector("#title").innerText}firstUpdated(e){super.firstUpdated&&super.firstUpdated(e),this.remoteLinkTarget=this.shadowRoot.querySelector("a")}updated(e){super.updated&&super.updated(e),e.forEach((e,t)=>{"link"==t&&(this.remoteLinkURL=this[t])})}}customElements.define(SimpleCta.tag,SimpleCta);export{SimpleCta};