import{LitElement as t,html as e,css as o}from"../../lit-element/lit-element.js";import{SchemaBehaviors as i}from"../schema-behaviors/schema-behaviors.js";import{remoteLinkBehavior as n}from"../utils/lib/remoteLinkBehavior.js";import{pathResolver as s,SimpleIconsetStore as r}from"../simple-icon/lib/simple-iconset.js";import"../simple-icon/simple-icon.js";r.registerIconset("stopnoteicons",s(import.meta.url)+"lib/svgs/stopnoteicons/");const c={"stopnoteicons:stop-icon":"Stop","stopnoteicons:warning-icon":"Warning","stopnoteicons:confirm-icon":"Confirmation","stopnoteicons:book-icon":"Notice"};class StopNote extends(n(i(t))){static get styles(){return[o`
        :host {
          display: block;
          width: auto;
          --background-color: #f7f7f7;
          --accent-color: #d32f2f;
          margin-bottom: 20px;
        }

        simple-icon {
          --simple-icon-height: 100px;
          --simple-icon-width: 100px;
        }

        :host([icon="stopnoteicons:stop-icon"]) {
          --accent-color: #d8261c;
        }

        :host([icon="stopnoteicons:warning-icon"]) {
          --accent-color: #ffeb3b;
        }

        :host([icon="stopnoteicons:confirm-icon"]) {
          --accent-color: #81c784;
        }

        :host([icon="stopnoteicons:book-icon"]) {
          --accent-color: #21a3db;
        }

        .container {
          display: flex;
          width: auto;
        }

        .message_wrap {
          border-right: 7px solid var(--accent-color);
          padding: 10px 25px;
          flex: 1 1 auto;
          background-color: var(--background-color);
        }

        .main_message {
          font-size: 32px;
          margin-top: 10px;
        }

        .secondary_message {
          margin-top: 5px;
          font-size: 19.2px;
          float: left;
        }

        .link a {
          margin-top: 5px;
          font-size: 19.2px;
          float: left;
          clear: left;
          text-decoration: none;
          color: #2196f3;
        }

        .link a:hover {
          color: #1976d2;
        }

        .svg {
          display: flex;
          justify-content: center;
        }

        .svg_wrap {
          background-color: var(--accent-color);
          padding: 5px;
          width: auto;
        }
      `]}render(){return e`
      <div class="container">
        <div class="svg_wrap">
          <div class="svg">
            <simple-icon icon="${this.icon}" no-colorize></simple-icon>
          </div>
        </div>
        <div class="message_wrap">
          <div class="main_message" id="title">${this.title}</div>
          <div class="secondary_message"><slot name="message"></slot></div>
          ${this.url?e`
                <div class="link">
                  <a href="${this.url}" id="link"> More Information &gt; </a>
                </div>
              `:""}
        </div>
      </div>
    `}static get tag(){return"stop-note"}constructor(){super(),this.url=null,this.title="",this.icon="stopnoteicons:stop-icon"}static get properties(){return{title:{type:String,reflect:!0},url:{type:String},icon:{type:String,reflect:!0}}}updated(t){super.updated&&super.updated(t),t.forEach((t,e)=>{"url"==e&&(this.remoteLinkURL=this[e])})}firstUpdated(t){super.firstUpdated&&super.firstUpdated(t),this.remoteLinkTarget=this.shadowRoot.querySelector("#link")}haxHooks(){return{activeElementChanged:"haxactiveElementChanged",inlineContextMenu:"haxinlineContextMenu"}}haxactiveElementChanged(t,e){let o=this.shadowRoot.querySelector("#title"),i=this.shadowRoot.querySelector(".svg_wrap");return e?(i.addEventListener("click",this.haxtoggleIcon.bind(this)),o.setAttribute("contenteditable",!0)):(i.removeEventListener("click",this.haxtoggleIcon.bind(this)),o.removeAttribute("contenteditable"),this.title=o.innerText),!1}haxinlineContextMenu(t){t.ceButtons=[{icon:"image:style",callback:"haxtoggleIcon",label:"Toggle icon"}]}haxtoggleIcon(t){const e=Object.keys(c);let o=e[0];return e.lastIndexOf(this.icon)!=e.length-1&&(o=e[e.lastIndexOf(this.icon)+1]),this.icon=o,!0}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!0,contentEditable:!0,gizmo:{title:"Stop Note",description:"A message to alert readers to specific directions.",icon:"icons:report",color:"orange",groups:["Education","Content"],handles:[{type:"text",title:"label"}],meta:{author:"ELMS:LN"}},settings:{configure:[{property:"title",title:"Title",description:"Enter title for stop-note.",inputMethod:"textfield",required:!0},{property:"url",title:"URL",description:"Enter an external url.",inputMethod:"haxupload",required:!0},{property:"icon",title:"Action Icon",description:"Icon used for stop-note",inputMethod:"select",options:c}],advanced:[]},saveOptions:{unsetAttributes:["colors"]},demoSchema:[{tag:"stop-note",properties:{title:"Hold up there"},content:'<p slot="message"><strong>Read these important things!</strong>\n</p>\n'},{tag:"stop-note",properties:{title:"Warning",icon:"stopnoteicons:warning-icon"},content:'<p slot="message">You can write any warning message you want here.</p>\n'}]}}}window.customElements.define(StopNote.tag,StopNote);export{StopNote};