/**
 * Copyright 2018 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as e,html as t,css as i}from"../../lit-element/lit-element.js";import{SimpleColors as r}from"../simple-colors/simple-colors.js";import{SchemaBehaviors as o}from"../schema-behaviors/schema-behaviors.js";import{MediaBehaviorsVideo as s}from"../media-behaviors/media-behaviors.js";import{IntersectionObserverMixin as a}from"../intersection-element/lib/IntersectionObserverMixin.js";import"../a11y-media-player/a11y-media-player.js";class VideoPlayer extends(a(s(o(r)))){static get styles(){return[...super.styles,i`
        :host {
          display: block;
          margin: 0 0 15px;
        }

        .video-caption {
          font-style: italic;
          margin: 0;
          padding: 8px;
        }
      `]}render(){return t` ${this.elementVisible?t`${this.isA11yMedia?t` <a11y-media-player
              accent-color="${this.accentColor}"
              ?audio-only="${this.audioOnly}"
              ?dark="${this.dark}"
              ?dark-transcript="${this.darkTranscript}"
              ?disable-interactive="${this.disableInteractive}"
              ?hide-timestamps="${this.hideTimestamps}"
              ?hide-transcript="${this.hideTranscript}"
              id="${this.playerId}"
              lang="${this.lang||"en"}"
              ?linkable="${this.linkable}"
              preload="${this.preload||"metadata"}"
              media-title="${this.mediaTitle||""}"
              .sources="${this.sourceProperties}"
              ?stand-alone="${this.standAlone}"
              sticky-corner="${this.stickyCorner||"top-right"}"
              .thumbnail-src="${this.thumbnailSrc}"
              .tracks="${this.trackProperties}"
              .crossorigin="${this.crossorigin||"anonymous"}"
              .width="${this.width}"
              .height="${this.height}"
              .youtubeId="${this.youtubeId||void 0}"
            >
              <slot></slot>
            </a11y-media-player>`:t` <div
                class="responsive-video-container"
                .lang="${this.lang||void 0}"
              >
                ${this.sandboxed?t``:t` <webview
                      resource="${this.schemaResourceID}-video"
                      .src="${this.sourceData&&this.sourceData[0]&&this.sourceData[0].src||void 0}"
                      .width="${this.width||void 0}"
                      .height="${this.height||void 0}"
                      frameborder="0"
                    >
                    </webview>`}
                ${this.sandboxed||!this.iframed?t``:t`
                      <iframe
                        loading="lazy"
                        resource="${this.schemaResourceID}-video"
                        .src="${this.sourceData&&this.sourceData[0]&&this.sourceData[0].src||void 0}"
                        width="${this.width}"
                        height="${this.height}"
                        frameborder="0"
                        webkitallowfullscreen=""
                        mozallowfullscreen=""
                        allowfullscreen=""
                      ></iframe>
                    `}
              </div>
              <div id="videocaption" class="video-caption">
                <p>
                  ${this.mediaTitle}
                  <span class="media-type print-only">(embedded media)</span>
                </p>
                <slot name="caption"></slot>
              </div>`}`:""}`}static get haxProperties(){return{canScale:{min:25,step:12.5},canPosition:!0,canEditSource:!0,gizmo:{title:"Video player",description:"This can present video in a highly accessible manner regardless of source.",icon:"av:play-circle-filled",color:"red",groups:["Video","Media"],handles:[{type:"video",type_exclusive:!0,source:"source",title:"caption",caption:"caption",description:"caption",color:"primaryColor"}],meta:{author:"LRNWebComponents"}},settings:{configure:[{property:"source",title:"Source",description:"The URL for this media.",inputMethod:"haxupload",noCamera:!0,noVoiceRecord:!0,validationType:"url"},{property:"track",title:"Closed captions",description:"The URL for the captions file.",inputMethod:"haxupload",noCamera:!0,noVoiceRecord:!0,validationType:"url"},{property:"thumbnailSrc",title:"Thumbnail image",description:"Optional. The URL for a thumbnail/poster image.",inputMethod:"haxupload",noVoiceRecord:!0,validationType:"url"},{property:"mediaTitle",title:"Title",description:"Simple title for under video",inputMethod:"textfield",validationType:"text"},{property:"accentColor",title:"Accent color",description:"Select the accent color for the player.",inputMethod:"colorpicker"},{attribute:"dark",title:"Dark theme",description:"Enable dark theme for the player.",inputMethod:"boolean"}],advanced:[{property:"crossorigin",title:"Crossorigin",description:"Indicates whether to use CORS.",inputMethod:"select",options:{"":"",anonymous:"anonymous","use-credentials":"use-credentials"}},{property:"darkTranscript",title:"Dark theme for transcript",description:"Enable dark theme for the transcript.",inputMethod:"boolean"},{property:"disableInteractive",title:"Disable Interactive",description:"Disable interactive mode that makes transcript clickable.",inputMethod:"boolean"},{property:"height",title:"Height",inputMethod:"textfield",required:!1,validationType:"text"},{property:"hideTimestamps",title:"Hide timestamps",description:"Hide the time stamps on the transcript.",inputMethod:"boolean"},{property:"hideTranscript",title:"Hide Transcript",description:"Hide transcript by default.",inputMethod:"boolean"},{property:"lang",title:"Language",description:"Language of the media.",inputMethod:"textfield",validationType:"text"},{property:"linkable",title:"Include a share link?",description:"Provides a link to share the video.",inputMethod:"boolean"},{property:"preload",title:"Preload source(s).",description:"How the sources should be preloaded, i.e. auto, metadata (default), or none.",inputMethod:"select",options:{preload:"Preload all media",metadata:"Preload media metadata only",none:"Don't preload anything"}},{property:"stickyCorner",title:"Sticky Corner",description:"Set the corner where a video plays when scrolled out of range, or choose none to disable sticky video.",inputMethod:"select",options:{none:"none","top-left":"top-left","top-right":"top-right","bottom-left":"bottom-left","bottom-right":"bottom-right"}},{property:"sources",title:"Other sources",description:"List of other sources",inputMethod:"array",properties:[{property:"src",title:"Source",description:"The URL for this source.",inputMethod:"haxupload",required:!0,noCamera:!0,noVoiceRecord:!0,validationType:"url"},{property:"type",title:"Type",description:"Media type data",inputMethod:"select",options:{"audio/aac":"acc audio","audio/flac":"flac audio","audio/mp3":"mp3 audio","video/mp4":"mp4 video","video/mov":"mov video","audio/ogg":"ogg audio","video/ogg":"ogg video","audio/wav":"wav audio","audio/webm":"webm audio","video/webm":"webm video"}}]},{property:"tracks",title:"Track list",description:"Tracks of different languages of closed captions",inputMethod:"array",properties:[{property:"kind",title:"Kind",description:"Kind of track",inputMethod:"select",options:{subtitles:"subtitles"}},{property:"label",title:"Label",description:'The human-readable name for this track, eg. "English Subtitles"',inputMethod:"textfield"},{property:"src",title:"Source",description:"The source for the captions file.",inputMethod:"haxupload",required:!1,noCamera:!0,noVoiceRecord:!0,validationType:"url"},{property:"srclang",title:'Two letter, language code, eg. \'en\' for English, "de" for German, "es" for Spanish, etc.',description:"Label",inputMethod:"textfield"}]},{property:"width",title:"width",inputMethod:"textfield",required:!1,validationType:"text"}]},saveOptions:{unsetAttributes:["__utils","__stand-alone","colors"]},demoSchema:[{tag:"video-player",properties:{style:"width: 100%; margin: 0px auto; display: block;",accentColor:"orange",dark:!0,crossorigin:"anonymous",lang:"en",mediaTitle:"Why do I need to go anywhere?",preload:"metadata",source:"https://www.youtube.com/watch?v=LrS7dqokTLE",stickyCorner:"top-right",track:"https://haxtheweb.org/files/HAXshort.vtt",youtubeId:"LrS7dqokTLE?undefined",sourceType:"youtube"},content:'    <track src="https://haxtheweb.org/files/HAXshort.vtt" kind="subtitles" label="English" slot="track">\n\n'}]}}static get properties(){return{...super.properties,accentColor:{type:String,attribute:"accent-color",reflect:!0},crossorigin:{type:String,attribute:"crossorigin",reflect:!0},dark:{type:Boolean,attribute:"dark",reflect:!0},darkTranscript:{type:Boolean},disableInteractive:{type:Boolean},height:{type:String},hideTimestamps:{type:Boolean},hideTranscript:{type:Boolean},id:{type:String,attribute:"id",reflect:!0},lang:{type:String},linkable:{type:Boolean},mediaTitle:{type:String,attribute:"media-title",reflect:!0},preload:{type:String},source:{type:String,attribute:"source",reflect:!0},sources:{type:Array},stickyCorner:{type:String,attribute:"sticky-corner",reflect:!0},track:{type:String},tracks:{type:Array},thumbnailSrc:{type:String,attribute:"thumbnail-src",reflect:!0},width:{type:String}}}static get tag(){return"video-player"}constructor(){super(),this.crossorigin="anonymous",this.dark=!1,this.darkTranscript=!1,this.disableInteractive=!1,this.hideTimestamps=!1,this.hideTranscript=!1,this.lang="en",this.linkable=!1,this.preload="metadata",this.sources=[],this.stickyCorner="top-right",this.tracks=[],this.setSourceData(),this.observer.observe(this,{childList:!0,subtree:!1})}disconnectedCallback(){this.observer&&this.observer.disconnect&&this.observer.disconnect(),super.disconnectedCallback()}get html5(){return t`
      ${this.sourceData.filter(e=>"youtube"!==e.type).map(e=>{t`
            <source
              .src="${e.src||void 0}"
              .type="${e.type||void 0}"
            />
          `})}
      ${this.trackData.map(e=>{e.src,e.kind,e.label,e.lang})}
    `}get iframed(){return!(!(this.sourceData&&this.sourceData.length>0&&void 0!==this.sourceData[0]&&window.MediaBehaviors.Video._sourceIsIframe(this.sourceData[0].src))||this.sandboxed)}get isA11yMedia(){return!this.sandboxed&&("youtube"==this.sourceType||"local"==this.sourceType||this.sourceData.length<1)}get observer(){return new MutationObserver(()=>this.setSourceData())}get sandboxed(){if(this.sourceData&&this.sourceData.length>0&&void 0!==typeof this.sourceData[0]&&window.MediaBehaviors.Video._sourceIsIframe(this.sourceData[0].src)){if("function"==typeof document.createElement("webview").reload)return!0}return!1}get sourceProperties(){let e="string"==typeof this.sources?JSON.parse(this.sources):this.sources.slice();return this.source&&e.unshift({src:this.source}),e&&e.length>0&&e.forEach(e=>{e.type=e.type||this._computeMediaType(e.src),e.src=this._computeSRC(e.src,e.type)}),e}get trackProperties(){let e="string"==typeof this.tracks?JSON.parse(this.tracks):this.tracks.slice();return this.track&&e.unshift({src:this.track}),e&&e.length>0&&e.forEach(e=>{e.srclang=e.srclang||this.lang,e.kind=e.kind||"subtitles",e.label=e.label||e.kind||e.lang}),e}get sourceData(){let e=this.sourceProperties.slice();return this.querySelectorAll("video source, audio source, iframe").forEach(e=>{this.sources.unshift({src:e.src,type:e.type||this._computeMediaType(e.src)})}),e}get audioOnly(){return this.sourceData.filter(e=>e.type.indexOf("audio")>-1).length>1}get standAlone(){return void 0===this.trackData||null===this.trackData||this.trackData.length<1}get sourceType(){return this.sourceData&&this.sourceData.length>0&&void 0!==this.sourceData[0]&&void 0!==this.sourceData[0].src?window.MediaBehaviors.Video.getVideoType(this.sourceData[0].src):null}get trackData(){let e="string"==typeof this.tracks?JSON.parse(this.tracks).slice():this.tracks.slice();return this.querySelectorAll("video track, audio track").forEach(e=>{let t={src:e.src};e.lang&&(t.lang=e.lang),e.srclang&&(t.srclang=e.srclang),e.label&&(t.label=e.label),e.kind&&(t.kind=e.kind),this.tracks.unshift(t),e.remove()}),void 0!==this.track&&null!==this.track&&""!==this.track&&e.push({src:this.track,srclang:this.lang,label:"en"===this.lang?"English":this.lang,kind:"subtitles"}),e}get youtubeId(){if(this.sourceData&&this.sourceData[0]&&"youtube"===this.sourceType)return this._computeSRC(this.sourceData[0].src).replace(/.*\/embed\//,"")}get playerId(){return(this.id||this.schemaResourceID)+"-media"}_computeMediaType(e){let t="",findType=(i,r)=>{r.forEach(r=>{""===t&&void 0!==typeof e&&null!==e&&e.toLowerCase().indexOf("."+r)>-1&&(t=i+"/"+r)})};return findType("audio",["aac","flac","mp3","oga","wav"]),findType("video",["mov","mp4","ogv","webm"]),t}_computeSRC(e,t){return null!==e&&void 0!==typeof e&&(t=t||window.MediaBehaviors.Video.getVideoType(e),e=window.MediaBehaviors.Video.cleanVideoSource(e,t),"vimeo"==t?(this.vimeoTitle?e+="?title=1":e+="?title=0",this.vimeoByline?e+="&byline=1":e+="&byline=0",this.vimeoPortrait?e+="&portrait=1":e+="&portrait=0"):"dailymotion"==t&&(e+="&ui-start-screen-info=false",e+="&ui-logo=false",e+="&sharing-enable=false",e+="&endscreen-enable=false")),e}haxHooks(){return{postProcessNodeToContent:"haxpostProcessNodeToContent"}}haxpostProcessNodeToContent(e){return e=(e=e.replace(' sources="[]",',"")).replace(' tracks="[]",',"")}setSourceData(){let e=this.source;this.source="",this.source=e}}window.customElements.define(VideoPlayer.tag,VideoPlayer);export{VideoPlayer};