import{__decorate as e}from"../../tslib/tslib.es6.js";
/**
@license
Copyright 2019 Google Inc. All Rights Reserved.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/import"../mwc-icon/mwc-icon.js";import"../mwc-ripple/mwc-ripple.js";import{RippleHandlers as t}from"../mwc-ripple/ripple-handlers.js";import{eventOptions as i,html as s,internalProperty as o,LitElement as n,property as l,query as p,queryAsync as a}from"../../lit-element/lit-element.js";import{classMap as r}from"../../lit-html/directives/class-map.js";export class ButtonBase extends n{constructor(){super(...arguments),this.raised=!1,this.unelevated=!1,this.outlined=!1,this.dense=!1,this.disabled=!1,this.trailingIcon=!1,this.fullwidth=!1,this.icon="",this.label="",this.shouldRenderRipple=!1,this.rippleHandlers=new t(()=>(this.shouldRenderRipple=!0,this.ripple))}renderRipple(){const e=this.raised||this.unelevated;return s`${this.shouldRenderRipple?s`<mwc-ripple .primary="${!e}" .disabled="${this.disabled}"></mwc-ripple>`:""}`}createRenderRoot(){return this.attachShadow({mode:"open",delegatesFocus:!0})}focus(){const e=this.buttonElement;e&&(this.rippleHandlers.startFocus(),e.focus())}blur(){const e=this.buttonElement;e&&(this.rippleHandlers.endFocus(),e.blur())}render(){const e={"mdc-button--raised":this.raised,"mdc-button--unelevated":this.unelevated,"mdc-button--outlined":this.outlined,"mdc-button--dense":this.dense};return s`
      <button
          id="button"
          class="mdc-button ${r(e)}"
          ?disabled="${this.disabled}"
          aria-label="${this.label||this.icon}"
          @focus="${this.handleRippleFocus}"
          @blur="${this.handleRippleBlur}"
          @mousedown="${this.handleRippleActivate}"
          @mouseenter="${this.handleRippleMouseEnter}"
          @mouseleave="${this.handleRippleMouseLeave}"
          @touchstart="${this.handleRippleActivate}"
          @touchend="${this.handleRippleDeactivate}"
          @touchcancel="${this.handleRippleDeactivate}">
        ${this.renderRipple()}
        <span class="leading-icon">
          <slot name="icon">
            ${this.icon&&!this.trailingIcon?this.renderIcon():""}
          </slot>
        </span>
        <span class="mdc-button__label">${this.label}</span>
        <slot></slot>
        <span class="trailing-icon">
          <slot name="trailingIcon">
            ${this.icon&&this.trailingIcon?this.renderIcon():""}
          </slot>
        </span>
      </button>`}renderIcon(){return s`
    <mwc-icon class="mdc-button__icon">
      ${this.icon}
    </mwc-icon>`}handleRippleActivate(e){const onUp=()=>{window.removeEventListener("mouseup",onUp),this.handleRippleDeactivate()};window.addEventListener("mouseup",onUp),this.rippleHandlers.startPress(e)}handleRippleDeactivate(){this.rippleHandlers.endPress()}handleRippleMouseEnter(){this.rippleHandlers.startHover()}handleRippleMouseLeave(){this.rippleHandlers.endHover()}handleRippleFocus(){this.rippleHandlers.startFocus()}handleRippleBlur(){this.rippleHandlers.endFocus()}}e([l({type:Boolean})],ButtonBase.prototype,"raised",void 0),e([l({type:Boolean})],ButtonBase.prototype,"unelevated",void 0),e([l({type:Boolean})],ButtonBase.prototype,"outlined",void 0),e([l({type:Boolean})],ButtonBase.prototype,"dense",void 0),e([l({type:Boolean,reflect:!0})],ButtonBase.prototype,"disabled",void 0),e([l({type:Boolean,attribute:"trailingicon"})],ButtonBase.prototype,"trailingIcon",void 0),e([l({type:Boolean,reflect:!0})],ButtonBase.prototype,"fullwidth",void 0),e([l({type:String})],ButtonBase.prototype,"icon",void 0),e([l({type:String})],ButtonBase.prototype,"label",void 0),e([p("#button")],ButtonBase.prototype,"buttonElement",void 0),e([a("mwc-ripple")],ButtonBase.prototype,"ripple",void 0),e([o()],ButtonBase.prototype,"shouldRenderRipple",void 0),e([i({passive:!0})],ButtonBase.prototype,"handleRippleActivate",null);