/**
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as e,html as t,css as i}from"../../lit-element/lit-element.js";import"../es-global-bridge/es-global-bridge.js";window.__H5PBridgeTimeOut=function(){setTimeout((function(){window.H5P.init()}),500)};class H5PElement extends e{static get styles(){return[i`
        :host {
          display: block;
        }
      `]}render(){return t` ${this.source?t`<div
          class="h5p-container"
          data-content-id="wrapper-${this.contentId}"
        ></div>`:t`<h5p-wrapped-element><slot></slot></h5p-wrapped-element>`}`}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!0,gizmo:{title:"H5P element",description:"h5p wrapper for loading and presenting .h5p files",icon:"icons:android",color:"green",groups:["Interactive"],meta:{author:"btopro",owner:"The Pennsylvania State University"}},settings:{configure:[{attribute:"source",description:"Location the H5P file was unpacked to",inputMethod:"textfield",required:!0,icon:"icons:link"}],advanced:[]},saveOptions:{wipeSlot:!0,unsetAttributes:["content-id"]}}}static get properties(){return{...super.properties,source:{name:"source",type:String}}}static get tag(){return"h5p-element"}constructor(){super(),this.contentId=this.generateUUID(),this.H5PDepsLoader()}createRenderRoot(){return this.source?this:super.createRenderRoot()}pathFromUrl(e){return e.substring(0,e.lastIndexOf("/")+1)}async H5PDepsLoader(){window.ESGlobalBridge.requestAvailability();const e=this.pathFromUrl(decodeURIComponent(import.meta.url))+"lib/";this.h5pJSDeps=[e+"h5p-resizer.js",e+"h5p/js/jquery.js",e+"h5p/js/h5p.js",e+"h5p/js/h5p-event-dispatcher.js",e+"h5p/js/h5p-content-type.js",e+"h5p/js/h5p-action-bar.js",e+"h5p/js/h5p-confirmation-dialog.js",e+"h5p/js/h5p-x-api-event.js",e+"h5p/js/h5p-x-api.js"],this.__h5pDepsLength=this.h5pJSDeps.length-1,await window.ESGlobalBridge.instance.load("h5p-jquery",e+"h5p/js/jquery.js"),window.addEventListener("es-bridge-h5p-jquery-loaded",this.h5pJqueryReady.bind(this)),window.addEventListener("es-bridge-h5p-"+this.__h5pDepsLength+"-loaded",this.h5pReadyCallback.bind(this))}generateUUID(){return"item-sss-ss-ss".replace(/s/g,this._uuidPart)}_uuidPart(){return Math.floor(65536*(1+Math.random())).toString(16).substring(1)}firstUpdated(){this.source&&!0===window.ESGlobalBridge.imports["h5p-"+this.__h5pDepsLength]&&this.contentId&&this.setupH5P(this.contentId),this.source||import("./lib/h5p-wrapped-element.js")}async h5pJqueryReady(e){for(var t in this.h5pJSDeps)await window.ESGlobalBridge.instance.load("h5p-"+t,this.h5pJSDeps[t])}h5pReadyCallback(e){this.contentId&&this.setupH5P(this.contentId)}async setupH5P(e=1,t={}){t=Object.assign(t,{frame:t.frame=!1,copyright:t.copyright=!1,embed:t.embed=!1,download:t.download=!1,icon:t.icon=!1,export:t.export=!1});const i=this.pathFromUrl(decodeURIComponent(import.meta.url))+"lib/";H5PIntegration.core={styles:[i+"h5p/styles/h5p.css",i+"h5p/styles/h5p-confirmation-dialog.css",i+"h5p/styles/h5p-core-button.css"],scripts:this.h5pJSDeps};let n=document.createRange().createContextualFragment(`\n    <div class="h5p-iframe-wrapper" style="background-color:#DDD;">\n      <iframe id="h5p-iframe-${e}" class="h5p-iframe" data-content-id="${e}" style="width: 100%; height: 100%; border: none; display: block;" src="about:blank" frameBorder="0"></iframe>\n    </div>\n    `);if(this.querySelector('[data-content-id="wrapper-'+this.contentId+'"')&&this.querySelector('[data-content-id="wrapper-'+this.contentId+'"').appendChild(n),this.source){let i=new H5PStandalone(e,this.source,t);await i.init(),window.__H5PBridgeTimeOut&&(clearTimeout(window.__H5PBridgeTimeOut),window.__H5PBridgeTimeOut())}return!0}disconnectedCallback(){window.removeEventListener("es-bridge-h5p-"+this.__h5pDepsLength+"-loaded",this.h5pReadyCallback.bind(this)),window.removeEventListener("es-bridge-h5p-jquery-loaded",this.h5pJqueryReady.bind(this)),super.disconnectedCallback()}updated(e){e.forEach((e,t)=>{})}}customElements.define("h5p-element",H5PElement),window.H5P=window.H5P||{},window.H5PIntegration=window.H5PIntegration||{},H5PIntegration.l10n={H5P:{advancedHelp:"Include this script on your website if you want dynamic sizing of the embedded content:",author:"Author",by:"by",close:"Close",contentChanged:"This content has changed since you last used it.",copyrightInformation:"Rights of use",copyrights:"Rights of use",copyrightsDescription:"View copyright information for this content.",disableFullscreen:"Disable fullscreen",download:"Download",downloadDescription:"Download this content as a H5P file.",embed:"Embed",embedDescription:"View the embed code for this content.",fullscreen:"Fullscreen",h5pDescription:"Visit H5P.org to check out more cool content.",hideAdvanced:"Hide advanced",license:"License",noCopyrights:"No copyright information available for this content.",showAdvanced:"Show advanced",showLess:"Show less",showMore:"Show more",size:"Size",source:"Source",startingOver:"You'll be starting over.",subLevel:"Sublevel",thumbnail:"Thumbnail",title:"Title",year:"Year"}};class H5PStandalone{constructor(e=1,t,i){return this.id=e,this.path=t,this.displayOptions=i,!0}getJSONPromise(e){return fetch(e).then((function(e){return e.json()}))}async init(){this.h5p=await this.getJSONPromise(this.path+"/h5p.json"),this.content=JSON.stringify(await this.getJSONPromise(this.path+"/content/content.json")),window.H5PIntegration.pathIncludesVersion=this.pathIncludesVersion=await this.checkIfPathIncludesVersion(),this.mainLibrary=await this.findMainLibrary();const e=await this.findAllDependencies(),{styles:t,scripts:i}=await this.sortDependencies(e);return H5PIntegration.url=this.path,H5PIntegration.contents=H5PIntegration.contents?H5PIntegration.contents:{},H5PIntegration.contents["cid-"+this.id]={library:`${this.mainLibrary.machineName} ${this.mainLibrary.majorVersion}.${this.mainLibrary.minorVersion}`,jsonContent:this.content,styles:t,scripts:i,displayOptions:this.displayOptions},!0}async checkIfPathIncludesVersion(){let e,t=this.h5p.preloadedDependencies[0],i=t.machineName+"-"+t.majorVersion+"."+t.minorVersion;try{await this.getJSONPromise(`${this.path}/${i}/library.json`),e=!0}catch(t){e=!1}return e}libraryPath(e){return e.machineName+(this.pathIncludesVersion?"-"+e.majorVersion+"."+e.minorVersion:"")}findMainLibrary(){const e=this.h5p.preloadedDependencies.find(e=>e.machineName===this.h5p.mainLibrary);return this.mainLibraryPath=this.h5p.mainLibrary+(this.pathIncludesVersion?"-"+e.majorVersion+"."+e.minorVersion:""),this.getJSONPromise(`${this.path}/${this.mainLibraryPath}/library.json`)}findAllDependencies(){const e=this.h5p.preloadedDependencies.map(e=>this.libraryPath(e));return this.loadDependencies(e,[])}async loadDependencies(e,t){let i=t,n=[],s=await Promise.all(e.map(e=>this.findLibraryDependencies(e)));return s.forEach(e=>{i.push(e),e.dependencies.forEach(e=>{i.find(t=>t.libraryPath===e)||s.find(t=>t.libraryPath===e)||n.push(e)})}),n.length>0?this.loadDependencies(n,i):i}async findLibraryDependencies(e){const t=await this.getJSONPromise(`${this.path}/${e}/library.json`),i=this.libraryPath(t);let n=[];return t.preloadedDependencies&&(n=t.preloadedDependencies.map(e=>this.libraryPath(e))),{libraryPath:i,dependencies:n,preloadedCss:t.preloadedCss,preloadedJs:t.preloadedJs}}async sortDependencies(e){const t=new Toposort;let i={},n={};e.forEach(e=>{t.add(e.libraryPath,e.dependencies),e.preloadedCss&&(i[e.libraryPath]=i[e.libraryPath]?i[e.libraryPath]:[],e.preloadedCss.forEach(t=>{i[e.libraryPath].push(`${this.path}/${e.libraryPath}/${t.path}`)})),e.preloadedJs&&(n[e.libraryPath]=n[e.libraryPath]?n[e.libraryPath]:[],e.preloadedJs.forEach(t=>{n[e.libraryPath].push(`${this.path}/${e.libraryPath}/${t.path}`)}))});let s=[],r=[];return t.sort().reverse().forEach((function(e){Array.prototype.push.apply(s,i[e]),Array.prototype.push.apply(r,n[e])})),Array.prototype.push.apply(s,this.mainLibrary.preloadedCss.map(e=>`${this.path}/${this.mainLibraryPath}/${e.path}`)),Array.prototype.push.apply(r,this.mainLibrary.preloadedJs.map(e=>`${this.path}/${this.mainLibraryPath}/${e.path}`)),{styles:s,scripts:r}}}class Toposort{constructor(){this.edges=[]}add(e,t){if("string"!=typeof e||!e)throw new TypeError("Dependent name must be given as a not empty string");if((t=Array.isArray(t)?t:[t]).length>0)for(let i of t){if("string"!=typeof i||!i)throw new TypeError("Dependency name must be given as a not empty string");this.edges.push([e,i])}else this.edges.push([e]);return this}sort(){let e=[];for(let t of this.edges)for(let i of t)-1===e.indexOf(i)&&e.push(i);let t=e.length,i=new Array(e.length);var visit=(n,s)=>{if(0!==s.length&&-1!==s.indexOf(n))throw new Error(`Cyclic dependency found. ${n} is dependent of itself.\nDependency chain: ${s.join(" -> ")} => ${n}`);let r=e.indexOf(n);if(-1!==r){let a=!1;e[r]=!1;for(let e of this.edges)e[0]===n&&(a=a||s.concat([n]),visit(e[1],a));i[--t]=n}};for(let n=0;n<e.length;n++){let s=e[n];if(!1!==s){e[n]=!1;for(let e of this.edges)e[0]===s&&visit(e[1],[s]);i[--t]=s}}return i}clear(){return this.edges=[],this}}export{H5PElement,H5PStandalone,Toposort};