/**
 * Copyright 2019 Penn State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as e,html as t,css as o}from"../../../../lit-element/lit-element.js";import{RichTextEditorStyles as i}from"../rich-text-editor-styles.js";import{normalizeEventPath as n}from"../../../utils/utils.js";class RichTextEditorSelection extends(i(e)){static get tag(){return"rich-text-editor-selection"}static get styles(){return[...super.styles,o`
        :host {
          background-color: var(--rich-text-editor-selection-bg);
          margin: 0;
          padding: 0;
          display: inline;
        }
        :host([hidden]) {
          display: none;
        }
        :host([collapsed]):after {
          content: '|';
          color: var(--rich-text-editor-selection-bg);
          background-color: transparent;
        }
      `]}render(){return t` <slot></slot> `}static get properties(){return{editor:{type:Object},collapsed:{type:Boolean,reflect:!0,attribute:"collapsed"},hidden:{type:Boolean,reflect:!0,attribute:"hidden"},id:{type:String,reflect:!0,attribute:"id"},observer:{type:Object},range:{type:Object},toolbar:{type:Object},__toolbars:{type:Array}}}constructor(){super();this.hidden=!0,this.__toolbars=[],this.__clipboard=document.createElement("textarea"),this.__clipboard.setAttribute("aria-hidden",!0),this.__clipboard.style.position="absolute",this.__clipboard.style.left="-9999px",this.__clipboard.style.top="0px",this.__clipboard.style.width="0px",this.__clipboard.style.height="0px",this.id=this._generateUUID(),document.body.appendChild(this.__clipboard),window.addEventListener("paste",e=>console.log("paste",e)),window.addEventListener("register",this._handleRegistration.bind(this))}updated(e){super.updated(e),e.forEach((e,t)=>{})}disconnectedCallback(){super.disconnectedCallback()}cancelEdits(e){e.revert(),this.edit(e,!1)}disableEditing(e){e&&(this.getRoot(e).onselectionchange=void 0,e.contenteditable=!1,e.makeSticky(!1))}execCommand(e,t,o,i){console.log(">>>>>>>> execCommand",e,t,o,i,!o||o.cloneContents());let n=i.editor;if(o){if(this.range=n.range,this.updateRange(n,o),this.selectRange(o,n),"replaceHTML"===e){this.getRangeNode().innerHTML=t}else"paste"!==e?(console.log("command",o,this.getRangeNode()),document.execCommand(e,!1,t)):navigator.clipboard&&this.pasteFromClipboard(n);this.highlight(i,!1)}}edit(e,t=!0){let o=e?this.getConnectedToolbar(e):void 0,i=t?o.editor:void 0;this.highlight(e,!1),o&&i!==e&&(this.disableEditing(i),o.editor=e,this.enableEditing(e,o))}enableEditing(e,t=this.getConnectedToolbar(e)){e&&(e.makeSticky(t.sticky),e.parentNode.insertBefore(t,e),e.contenteditable=!0,this.updateRange(e),this.getRoot(e).onselectionchange=t=>this.updateRange(e))}expandRangeTo(e="",t){let o=t?this.getRangeNode(t):void 0,i=o&&o.tagName?o.tagName.toLowerCase():void 0;return e.toLowerCase().replace(/\s*/g,"").split(",").includes(i)?o:o.closest(e)?(t.selectNode(o.closest(e)),t):void 0}getRangeNode(e){let t=e?e.commonAncestorContainer:void 0,o=e?e.startContainer:void 0,i=e?e.startOffset:void 0,n=e?e.endContainer:void 0,r=e?e.endOffset:void 0,a=o&&o.children?o.children[i-1]:void 0;return o===n&&r-i==1?a:t}getRoot(e){return e&&e!==document?e.parentNode?this.getRoot(e.parentNode):e:document}getSanitizeClipboard(e){let t="<body(.*\n)*>(.*\n)*</body>";return e.match(t)&&e.match(t).length>0&&(e=e.match(t)[0].replace(/<\?body(.*\n)*\>/i)),e}getConnectedToolbar(e){if(e.id||(e.id=this._generateUUID()),!e.__connectedToolbar){let t,o=e.toolbar?(this.__toolbars||[]).filter(t=>t.id===e.toolbar):[];0===o.length&&(o=e.type?(this.__toolbars||[]).filter(t=>t.type===e.type):[]),o[0]?t=o[0]:0===o.length&&(t=document.createElement(e.type||"rich-text-editor-toolbar"),e.parentNode.insertBefore(t,e)),t.id=e.toolbar||this._generateUUID(),e.toolbar=t.id,e.__connectedToolbar=t}return e.__connectedToolbar}highlightNode(e,t){this.selectNode(e,t.range),this.highlight(t)}highlight(e,t=!0){this.toolbar=e;e.editor;!1!==t?e.range&&(this.hidden=!1,e.range.insertNode(this),e.range.setStartAfter(this),this.range=e.range):(this.updateRange(e.editor,e.range),this.hidden=!0,this.toolbar=void 0,this.range=void 0,document.body.appendChild(this))}pasteFromClipboard(e){console.log("pasteFromClipboard",e),setTimeout(async()=>{let t=window.getSelection(),o=e.range,i=await navigator.clipboard.readText();this.__clipboard.value=i,this.__clipboard.focus(),this.__clipboard.select(),document.execCommand("paste"),t.removeAllRanges(),t.addRange(o),this.pasteIntoEditor(e,this.__clipboard.value)},2e3)}pasteIntoEditor(e,t,o=!0){console.log("pasteIntoEditor",e),e&&this.pasteIntoRange(e,e.range,o?this.getSanitizeClipboard(t):t)}pasteIntoRange(e,t,o){console.log("pasteIntoRange",e);let i=document.createElement("div");if(e=t.commonAncestorContainer.parentNode.closest("[contenteditable=true]:not([disabled]),input:not([disabled]),textarea:not([disabled])")){for(i.innerHTML=o,t&&t.extractContents&&t.extractContents(),t.insertNode(i);i.firstChild;)i.parentNode.insertBefore(i.firstChild,i);i.parentNode.removeChild(i)}}registerEditor(e,t=!1){let o=e?this.getConnectedToolbar(e):void 0,i={focus:t=>this.edit(e),blur:t=>this._handleBlur(e,t),keydown:t=>this._handleShortcutKeys(e,t),click:t=>this._handleEditorClick(e,t),getrange:t=>{this.toolbar=o,this.updateRange(e,e.range)},pastefromclipboard:e=>this.pasteFromClipboard(e.detail),pastecontent:e=>this._handlePaste(e)};return t?(e.removeEventListener("mousedown",i.focus),e.removeEventListener("focus",i.focus),e.removeEventListener("keydown",i.keydown),e.removeEventListener("blur",i.blur),e.removeEventListener("getrange",i.getrange),e.removeEventListener("pastefromclipboard",i.pastefromclipboard),e.removeEventListener("pastecontent",i.pastecontent)):(e.addEventListener("mousedown",i.focus),e.addEventListener("focus",i.focus),e.addEventListener("keydown",i.keydown),e.addEventListener("blur",i.blur),e.addEventListener("getrange",i.getrange),e.addEventListener("pastefromclipboard",i.pastefromclipboard),e.addEventListener("pastecontent",i.pastecontent)),e.__connectedToolbar}registerToolbar(e,t=!1){let o={exec:t=>{t.stopImmediatePropagation(),this.execCommand(t.detail.command,t.detail.commandVal,t.detail.range,e)},highlight:t=>{t.stopImmediatePropagation(),this.highlight(e.editor,t.detail)},highlightnode:t=>{t.stopImmediatePropagation(),this.highlightNode(t.detail,e)},selectnode:t=>{t.stopImmediatePropagation(),this.selectNode(t.detail,e.range)},selectnodecontents:t=>{t.stopImmediatePropagation(),this.selectNode(t.detail,e.range)},selectrange:t=>{t.stopImmediatePropagation(),this.selectRange(t.detail,e.editor)},pastefromclipboard:e=>{e.stopImmediatePropagation(),this.pasteFromClipboard(e.detail)},wrapselection:t=>{t.stopImmediatePropagation(),this.surroundRange(t.detail,e.range)}};t||e.registered?(e.registered=!1,e.removeEventListener("command",o.exec),e.removeEventListener("highlight",o.highlight),e.removeEventListener("highlightnode",o.highlightnode),e.removeEventListener("selectnode",o.selectnode),e.removeEventListener("selectnodecontents",o.selectnodecontents),e.removeEventListener("selectrange",o.selectrange),e.removeEventListener("pastefromclipboard ",o.pastefromclipboard),this.__toolbars=this.__toolbars.filter(t=>t!==e)):(this.__toolbars.push(e),e.addEventListener("command",o.exec),e.addEventListener("highlight",o.highlight),e.addEventListener("highlightnode",o.highlightnode),e.addEventListener("selectnode",o.selectnode),e.addEventListener("selectnodecontents",o.selectnodecontents),e.addEventListener("selectrange",o.selectrange),e.addEventListener("pastefromclipboard ",o.pastefromclipboard),e.addEventListener("wrapselection ",o.wrapselection),e.registered=!0)}selectNode(e,t,o=this.toolbar.editor){t&&(t.selectNode(e),o&&this.updateRange(o,t))}selectNodeContents(e,t,o=this.toolbar.editor){if(e){if(!t){let e=window.getSelection();t=document.createRange(),e.removeAllRanges(),e.addRange(t)}o&&this.updateRange(o)}}selectRange(e,t=!0,o){if(e){if(t){let t=window.getSelection();t.removeAllRanges(),t.addRange(e)}else e.isCollapsed||e.collapse();o&&this.updateRange(o)}return e}surroundRange(e,t){return t&&(t.surroundContents(e),editor&&this.updateRange(editor)),t}updateRange(e,t){if(e){let o=this.getConnectedToolbar(e);this.toolbar=o,t||(t=e.range),e.range=t,o&&(o.selectedNode=e.selectedNode,o.selectionAncestors=e.selectionAncestors,o.range=t)}}_generateUUID(){let e=Math.floor(65536*(1+Math.random())).toString(16).substring(1);return"rte-"+"ss-s-s-s-sss".replace(/s/g,e)}_handleBlur(e,t){null===t.relatedTarget||"rich-text-editor"===!t.relatedTarget.startsWith?this.edit(e,!0):e&&this.highlight(e)}_handleEditorClick(e,t){e&&this.getConnectedToolbar(e),n(t)[0]}_handleRegistration(e){e.detail&&(e.detail.toolbar&&this.registerToolbar(e.detail.toolbar,e.detail.remove),e.detail.editor&&this.registerEditor(e.detail.editor,e.detail.remove))}_handleShortcutKeys(e,t){let o=e?this.getConnectedToolbar(e):void 0;if(e.contenteditable){let e=t.key;t.shiftKey&&(e="shift+"+e),t.altKey&&(e="alt+"+e),("MacIntel"===window.navigator.platform&&t.metaKey||t.ctrlKey)&&(e="ctrl+"+e),o.shortcutKeys[e]&&o.shortcutKeys[e]._keysPressed(t)}}}window.customElements.define(RichTextEditorSelection.tag,RichTextEditorSelection);export{RichTextEditorSelection};window.RichTextEditorSelection={},window.RichTextEditorSelection.instance=null,window.RichTextEditorSelection.requestAvailability=function(){return null==window.RichTextEditorSelection.instance&&(window.RichTextEditorSelection.instance=document.createElement(RichTextEditorSelection.tag),document.body.appendChild(window.RichTextEditorSelection.instance)),window.RichTextEditorSelection.instance};