/**
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as e,html as t,css as r}from"../../../lit-element/lit-element.js";import"./simple-fields-container.js";import"./simple-fields-fieldset.js";import"./simple-fields-array.js";class SimpleFieldsLite extends e{static get styles(){return[r`
        :host {
          display: block;
          font-family: var(--simple-fields-font-family, sans-serif);
          font-family: var(--simple-fields-detail-font-family, sans-serif);
          font-size: var(--simple-fields-font-size, 16px);
          font-size: var(--simple-fields-detail-font-size, 12px);
          background: var(--simple-fields-background-color, white);
        }
        :host([hidden]) {
          display: none;
        }
      `]}render(){return t`
      <div id="schema-fields" aria-live="polite">
        <slot></slot>
      </div>
    `}static get properties(){return{...super.properties,disableAutofocus:{type:Boolean},error:{type:Object},language:{type:String,attribute:"lang",reflect:!0},resources:{type:Object},schema:{type:Object},elementizer:{type:Object,attribute:"elementizer",reflect:!0},value:{type:Object},__formElements:{type:Object},__formElementsArray:{type:Array}}}static get tag(){return"simple-fields-lite"}constructor(){super(),window.WCGlobalBasePath?this.basePath=window.WCGlobalBasePath:this.basePath=this.pathFromUrl(decodeURIComponent(import.meta.url))+"../../../",this.disableAutofocus=!1,this.language="en",this.resources={},this.schemaConversion,this.__formElements={},this.__formElementsArray=[],this.schema={},this.value={}}disconnectedCallback(){this._clearForm(),super.disconnectedCallback()}updated(e){super.updated&&super.updated(e),e.forEach((e,t)=>{"error"===t&&this.error!==e&&this._errorChanged(),["schema","schemaConversion"].includes(t)&&this._schemaChanged(this.schema,e),"value"===t&&this._valueChanged(this.value,e)})}get formElements(){return this.__formElements}get formElementsArray(){return this.__formElementsArray}get schemaConversion(){return this.elementizer||{defaultSettings:{element:"input",attributes:{type:"text"},properties:{minLength:"minlength",maxLength:"maxlength"}},type:{array:{defaultSettings:{element:"simple-fields-array",invalidProperty:"invalid",noWrap:!0,descriptionProperty:"description",child:{element:"simple-fields-array-item",noWrap:!0,descriptionProperty:"description",properties:{previewBy:"previewBy"}}}},boolean:{defaultSettings:{element:"input",valueProperty:"checked",valueChangedProperty:"click",attributes:{type:"checkbox",value:!1}}},file:{defaultSettings:{element:"input",attributes:{type:"url"}}},integer:{defaultSettings:{element:"input",attributes:{autofocus:!0,step:1,type:"number"},properties:{minimum:"min",maximum:"max",multipleOf:"step"}}},markup:{defaultSettings:{element:"textarea"}},number:{defaultSettings:{element:"input",attributes:{autofocus:!0,type:"number"},properties:{minimum:"min",maximum:"max",multipleOf:"step"}}},object:{defaultSettings:{element:"simple-fields-fieldset",noWrap:!0,descriptionProperty:"description"}},string:{format:{"date-time":{defaultSettings:{element:"input",attributes:{autofocus:!0,type:"datetime-local"}}},time:{defaultSettings:{element:"input",attributes:{autofocus:!0,type:"time"}}},date:{defaultSettings:{element:"input",attributes:{autofocus:!0,type:"date"}}},email:{defaultSettings:{element:"input",attributes:{autofocus:!0,type:"email"}}},uri:{defaultSettings:{element:"input",attributes:{autofocus:!0,type:"url"}}}}}}}}get valid(){return!this.error||0===Object.keys(this.error==={}).length}updateSchema(){this._formFieldsChanged()}rebuildForm(){this._clearForm(),this._addToForm();let e=!!(this.__formElementsArray&&this.__formElementsArray[0]&&this.__formElementsArray[0].field)&&this.__formElementsArray[0].field;e&&(e.autofocus=!this.disableAutofocus)}pathFromUrl(e){return e.substring(0,e.lastIndexOf("/")+1)}_addToForm(e=this.schema,t=this,r="",i){let s=e.properties,a=e.required;Object.keys(s||{}).forEach(l=>{let o=s[l],n=i||this._convertSchema(o);if(n&&n.element){let i=`${r}${l}`,s=document.createElement(n.element),d=o.properties||o.items||o.noWrap||n.noWrap?s:document.createElement("simple-fields-container"),p=this._getValue(`${r}${l}`);!window.customElements.get(n.element)&&n.import?import(`${this.basePath}${n.import}`):window.customElements.get(n.element)||console.warn("missing field: "+n.element);let m=o.label||o.title||o.description||l,u=o.description&&(o.label||o.title)?o.description:void 0,h=(o.onValueChanged,o.onErrorChanged);n.labelSlot=e.labelSlot||n.labelSlot,n.descriptionSlot=e.descriptionSlot||n.descriptionSlot,n.errorMessageSlot=e.errorMessageSlot||n.errorMessageSlot,n.valueSlot=e.valueSlot||n.valueSlot,n.labelProperty=e.labelProperty||n.labelProperty||"label",n.descriptionProperty=e.descriptionProperty||n.descriptionProperty||"description",n.valueProperty=e.valueProperty||n.valueProperty||"value",n.setValueProperty=e.setValueProperty||n.setValueProperty||n.valueProperty,n.valueChangedProperty=e.valueChangedProperty||n.valueChangedProperty||n.valueProperty+"-changed",n.errorProperty=e.errorProperty||n.errorProperty||"error",n.errorChangedProperty=e.errorChangedProperty||n.errorChangedProperty||n.errorProperty+"-changed",n.errorMessageProperty=e.errorMessageProperty||n.errorMessageProperty||"errorMessage",s.resources=this.resources,s.id=i,s.setAttribute("name",i),s.setAttribute("language",this.language),o.options&&(s.options=o.options),o.itemsList&&(s.itemsList=o.itemsList),a&&a.includes(l)&&s.setAttribute("required",!0),o.disabled&&(s.disabled=!0,d.disabled=!0),o.hidden&&(s.hidden=!0,d.hidden=!0),o.readonly&&(s.hidden=!0,d.hidden=!0),this._configElement(d,m,n.labelProperty,n.labelSlot),this._configElement(d,u,n.descriptionProperty,n.descriptionSlot),Object.keys(n.attributes||{}).forEach(e=>{void 0!==typeof n.attributes[e]&&null!==n.attributes[e]&&s.setAttribute(e,n.attributes[e])}),Object.keys(n.properties||{}).forEach(e=>{n.properties[e]&&o[e]&&(s[n.properties[e]]=o[e])}),Object.keys(n.slots||{}).forEach(e=>{n.slots[e]&&o[n.slots[e]]&&n.slots[e].split(/[\s,]/).forEach(t=>{let r=document.createElement("span");r.slot=e,r.innerHTML=o[t],s.appendChild(r)})}),t.slots&&t.slots[l]&&(d.slot=t.slots[l]),t.appendChild(d),"array"===o.type?this._addArrayItems(p||[],n.child,o,s):o.properties?this._addToForm(o,s,s.id+".",n.child):(s!==d&&(s.slot="field",d.appendChild(s)),void 0===p&&"boolean"!==o.type||this._configElement(s,p,n.setValueProperty,n.valueSlot),s.addEventListener(n.valueChangedProperty,e=>this._handleChange(s,n.valueProperty,e)),d.addEventListener(n.errorChangedProperty,e=>{let t=this._deepClone(this.error||{});d[n.errorProperty]?t[i]=d[n.errorMessageProperty]||"":t&&t[i]&&delete t[i],this.error=t,h&&h(e)})),this.__formElementsArray.push({id:i,field:d,data:n}),this.__formElements[i]={element:s,field:d}}})}_configElement(e,t,r,i=!1){if(i){let r=document.createElement("span");r.slot=i,t&&(r.innerHTML=t),e&&e.querySelectorAll(`[slot=${i}]`).forEach(e=>e.remove()),e.appendChild(r)}else e[r]=t}_insertArrayItem(e,t,r,i,s,a){let l=this._getValue(i.name),o=l?l.length:0;l||this._setValue(i.name,[]),a=a||0===a?a:o;let n={properties:{}};n.properties[a]=this._addArrayItem(a,e,t),this._setValue(`${i.name}.${a}`,s),this._addToForm(n,i,i.id+".",r)}_addArrayItems(e,t,r,i){let s=Object.keys(r.items.properties||{}),a=r.previewBy||(s.length>0?[s[0]]:void 0);(e||[]).forEach((e,s)=>{this._insertArrayItem(r,a,t,i,e,s)}),i.addEventListener("add",e=>{this._insertArrayItem(r,a,t,i,{})}),i.addEventListener("remove",e=>{let s=e.detail.id,l=this._getValue(i.name)||[],o=s.replace(i.name+".","");l.splice(parseInt(o),1),this.__formElementsArray=this.__formElementsArray.filter(e=>0===e.id.indexOf(i.name)),i.innerHTML="",l.forEach((e,s)=>this._insertArrayItem(r,a,t,i,e,s)),this._setValue(""+i.name,l),i.focus(parseInt(o)-1)})}_addArrayItem(e,t,r){let i=this._deepClone(t.items);return i.label=""+(parseInt(e)+1),i.previewBy=r,i}_clearForm(){this.innerHTML="",this.__formElementsArray=[]}_convertSchema(e,t=this.schemaConversion,r){let i=Object.keys(e||{}),s=Object.keys(t).filter(e=>i.includes(e));return t.defaultSettings&&(r=this._deepClone(t.defaultSettings)),s.forEach(i=>{let s=e[i],a=t?t[i]:void 0,l=a?Array.isArray(s)?a[s[0]]:a[s]:void 0;l&&(r=this._convertSchema(e,l,r))}),r}_deepClone(e){return JSON.parse(JSON.stringify(e))}_errorChanged(){this.formElementsArray.forEach(e=>{let t=e.data||{},r=e.field;if(e.id&&r&&this.error){let r=this.error[e.id]||!1,i=!!this.error[e.id];i||Object.keys(this.error||{}).forEach(t=>{t.match(e.id)&&(i=!0)}),this._configElement(e.field,r,t.errorMessageProperty,t.errorMessageSlot),e.field[t.errorProperty]=i,e.field.setAttribute("aria-invalid",i)}})}_fireValueChanged(){this.dispatchEvent(new CustomEvent("value-changed",{bubbles:!0,cancelable:!0,composed:!0,detail:this}))}_formFieldsChanged(e){this.dispatchEvent(new CustomEvent("fields-changed",{bubbles:!0,cancelable:!0,composed:!0,detail:this}))}_getValue(e){let t=e.split("."),r=this.value;return t.forEach(e=>{r=r&&r[e]?r[e]:void 0}),r}_handleChange(e,t,r){r&&r.stopPropagation&&r.stopPropagation();let i=e.id||e.getAttribute("id"),s=e[t];this._setValue(i,s),this.dispatchEvent(new CustomEvent(i+"-value-changed",{bubbles:!0,cancelable:!0,composed:!0,detail:{id:i,element:e,value:s}})),this._fireValueChanged()}_schemaChanged(e,t){e&&e!==t&&(setTimeout(()=>{this.rebuildForm()},10),this.dispatchEvent(new CustomEvent("schema-changed",{bubbles:!0,cancelable:!0,composed:!0,detail:this})))}_setValue(e,t){let r=this._deepClone(this.value),i=this.value,s=e?e.split("."):[],a=s.length;for(var l=0;l<a-1;l++){let e=s[l];i[e]||(i[e]={}),i=i[e]}i[s[a-1]]=t,this._valueChanged(this.value,r)}_valueChanged(e,t){e&&e!==t&&this._fireValueChanged()}}window.customElements.define(SimpleFieldsLite.tag,SimpleFieldsLite);export{SimpleFieldsLite};