/**
@license
Copyright (c) 2019 Vaadin Ltd.
This program is available under Apache License Version 2.0, available at https://vaadin.com/license/
*/
export const DragAndDropMixin=t=>class DragAndDropMixin extends t{static get properties(){return{dropMode:String,rowsDraggable:Boolean,dragFilter:Function,dropFilter:Function,__dndAutoScrollThreshold:{value:50}}}static get observers(){return["_dragDropAccessChanged(rowsDraggable, dropMode, dragFilter, dropFilter)"]}ready(){super.ready(),this.$.table.addEventListener("dragstart",this._onDragStart.bind(this)),this.$.table.addEventListener("dragend",this._onDragEnd.bind(this)),this.$.table.addEventListener("dragover",this._onDragOver.bind(this)),this.$.table.addEventListener("dragleave",this._onDragLeave.bind(this)),this.$.table.addEventListener("drop",this._onDrop.bind(this)),this.$.table.addEventListener("dragenter",t=>{this.dropMode&&(t.preventDefault(),t.stopPropagation())})}_onDragStart(t){if(this.rowsDraggable){let e=t.target;if("vaadin-grid-cell-content"===e.localName&&(e=e.assignedSlot.parentNode.parentNode),e.parentNode!==this.$.items)return;if(t.stopPropagation(),this._toggleAttribute("dragging-rows",!0,this),this._safari){const t=e.style.transform;e.style.top=/translateY\((.*)\)/.exec(t)[1],e.style.transform="none",requestAnimationFrame(()=>{e.style.top="",e.style.transform=t})}const r=e.getBoundingClientRect();window.ShadyDOM||(this._ios?t.dataTransfer.setDragImage(e):t.dataTransfer.setDragImage(e,t.clientX-r.left,t.clientY-r.top));let o=[e];this._isSelected(e._item)&&(o=this.__getViewportRows().filter(t=>this._isSelected(t._item)).filter(t=>!this.dragFilter||this.dragFilter(this.__getRowModel(t)))),t.dataTransfer.setData("text",this.__formatDefaultTransferData(o)),e.setAttribute("dragstart",o.length>1?o.length:""),this.updateStyles({"--_grid-drag-start-x":t.clientX-r.left+20+"px","--_grid-drag-start-y":t.clientY-r.top+10+"px"}),requestAnimationFrame(()=>{e.removeAttribute("dragstart"),this.updateStyles({"--_grid-drag-start-x":"","--_grid-drag-start-y":""})});const i=new CustomEvent("grid-dragstart",{detail:{draggedItems:o.map(t=>t._item),setDragData:(e,r)=>t.dataTransfer.setData(e,r),setDraggedItemsCount:t=>e.setAttribute("dragstart",t)}});i.originalEvent=t,this.dispatchEvent(i)}}_onDragEnd(t){this._toggleAttribute("dragging-rows",!1,this),t.stopPropagation();const e=new CustomEvent("grid-dragend");e.originalEvent=t,this.dispatchEvent(e)}_onDragLeave(t){t.stopPropagation(),this._clearDragStyles()}_onDragOver(t){if(this.dropMode){if(this._dropLocation=void 0,this._dragOverItem=void 0,this.__dndAutoScroll(t.clientY))return void this._clearDragStyles();let e=t.composedPath().filter(t=>"tr"===t.localName)[0];if(this._effectiveSize&&this.dropMode!==DropMode.ON_GRID)if(e&&e.parentNode===this.$.items){const r=e.getBoundingClientRect();if(this._dropLocation=DropLocation.ON_TOP,this.dropMode===DropMode.BETWEEN){const e=t.clientY-r.top<r.bottom-t.clientY;this._dropLocation=e?DropLocation.ABOVE:DropLocation.BELOW}else this.dropMode===DropMode.ON_TOP_OR_BETWEEN&&(t.clientY-r.top<r.height/3?this._dropLocation=DropLocation.ABOVE:t.clientY-r.top>r.height/3*2&&(this._dropLocation=DropLocation.BELOW))}else{if(e)return;if(this.dropMode!==DropMode.BETWEEN&&this.dropMode!==DropMode.ON_TOP_OR_BETWEEN)return;e=Array.from(this.$.items.children).filter(t=>!t.hidden).pop(),this._dropLocation=DropLocation.BELOW}else this._dropLocation=DropLocation.EMPTY;if(e&&e.hasAttribute("drop-disabled"))return void(this._dropLocation=void 0);t.stopPropagation(),t.preventDefault(),this._dropLocation===DropLocation.EMPTY?this._toggleAttribute("dragover",!0,this):e?(this._dragOverItem=e._item,e.getAttribute("dragover")!==this._dropLocation&&e.setAttribute("dragover",this._dropLocation)):this._clearDragStyles()}}__dndAutoScroll(t){if(this.__dndAutoScrolling)return!0;const e=this.$.header.getBoundingClientRect().bottom,r=this.$.footer.getBoundingClientRect().top,o=e-t+this.__dndAutoScrollThreshold,i=t-r+this.__dndAutoScrollThreshold;let a=0;if(i>0?a=2*i:o>0&&(a=2*-o),a){const t=this.$.table.scrollTop;this.$.table.scrollTop+=a;if(t!==this.$.table.scrollTop)return this.__dndAutoScrolling=!0,setTimeout(()=>this.__dndAutoScrolling=!1,20),this._scrollHandler(),!0}}__getViewportRows(){const t=this.$.header.getBoundingClientRect().bottom,e=this.$.footer.getBoundingClientRect().top;return Array.from(this.$.items.children).filter(r=>{const o=r.getBoundingClientRect();return o.bottom>t&&o.top<e})}_clearDragStyles(){this.removeAttribute("dragover"),Array.from(this.$.items.children).forEach(t=>t.removeAttribute("dragover"))}_onDrop(t){if(this.dropMode){t.stopPropagation(),t.preventDefault();const e=t.dataTransfer.types&&Array.from(t.dataTransfer.types).map(e=>({type:e,data:t.dataTransfer.getData(e)}));this._clearDragStyles();const r=new CustomEvent("grid-drop",{bubbles:t.bubbles,cancelable:t.cancelable,detail:{dropTargetItem:this._dragOverItem,dropLocation:this._dropLocation,dragData:e}});r.originalEvent=t,this.dispatchEvent(r)}}__formatDefaultTransferData(t){return t.map(t=>Array.from(t.children).filter(t=>!t.hidden&&-1===t.getAttribute("part").indexOf("details-cell")).sort((t,e)=>t._column._order>e._column._order?1:-1).map(t=>t._content.textContent.trim()).filter(t=>t).join("\t")).join("\n")}_dragDropAccessChanged(t,e,r,o){this.filterDragAndDrop()}filterDragAndDrop(){Array.from(this.$.items.children).filter(t=>!t.hidden).forEach(t=>{this._filterDragAndDrop(t,this.__getRowModel(t))})}_filterDragAndDrop(t,e){const r=!this.rowsDraggable||this.dragFilter&&!this.dragFilter(e),o=!this.dropMode||this.dropFilter&&!this.dropFilter(e);(window.ShadyDOM?[t]:Array.from(t.children).map(t=>t._content)).forEach(t=>{r?t.removeAttribute("draggable"):t.setAttribute("draggable",!0)}),this._toggleAttribute("drag-disabled",r,t),this._toggleAttribute("drop-disabled",o,t)}};