/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.15.5(3d42593a5844407ab71d47b348ea3a8de5fec848)
 * Released under the MIT license
 * https://github.com/Microsoft/vscode/blob/master/LICENSE.txt
 *-----------------------------------------------------------*/
(function(){var X,$,Q=["require","exports","vs/base/common/lifecycle","vs/editor/common/core/range","vs/nls!vs/editor/editor.main","vs/nls","vs/base/common/event","vs/base/browser/dom","vs/base/common/strings","vs/css!vs/editor/editor.main","vs/editor/browser/editorExtensions","vs/base/common/errors","vs/editor/common/core/position","vs/platform/theme/common/themeService","vs/editor/common/modes","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/platform","vs/platform/contextkey/common/contextkey","vs/editor/common/editorContextKeys","vs/platform/theme/common/colorRegistry","vs/editor/common/core/selection","vs/base/common/arrays","vs/base/browser/fastDomNode","vs/base/common/cancellation","vs/base/common/uri","vs/editor/common/model/textModel","vs/base/common/objects","vs/base/common/color","vs/base/browser/browser","vs/editor/browser/services/codeEditorService","vs/platform/commands/common/commands","vs/base/common/types","vs/editor/browser/view/viewPart","vs/editor/common/view/editorColorRegistry","vs/platform/notification/common/notification","vs/base/common/keyCodes","vs/platform/actions/common/actions","vs/editor/common/controller/cursorCommon","vs/editor/common/modes/languageConfigurationRegistry","vs/base/browser/mouseEvent","vs/platform/registry/common/platform","vs/editor/common/services/modelService","vs/base/browser/ui/aria/aria","vs/editor/common/model","vs/platform/configuration/common/configuration","vs/base/browser/ui/widget","vs/platform/keybinding/common/keybinding","vs/editor/common/config/editorOptions","vs/editor/common/core/editOperation","vs/base/common/network","vs/editor/common/modes/nullMode","vs/base/browser/keyboardEvent","vs/base/common/winjs.base","vs/editor/common/editorCommon","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/common/actions","vs/editor/browser/config/configuration","vs/base/common/paths","vs/editor/common/viewModel/viewModel","vs/platform/contextview/browser/contextView","vs/editor/browser/view/dynamicViewOverlay","vs/platform/opener/common/opener","vs/editor/common/services/modeService","vs/editor/common/services/editorWorkerService","vs/base/common/map","vs/editor/browser/core/editorState","vs/base/browser/ui/actionbar/actionbar","vs/base/common/htmlContent","vs/editor/common/view/viewEvents","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/base/browser/event","vs/base/browser/globalMouseMoveMonitor","vs/editor/common/modes/languageConfiguration","vs/base/browser/touch","vs/platform/markers/common/markers","vs/editor/common/commands/replaceCommand","vs/editor/standalone/common/standaloneThemeService","vs/editor/common/viewModel/viewEventHandler","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/characterClassifier","vs/platform/configuration/common/configurationRegistry","vs/editor/common/view/renderingContext","vs/base/common/resources","vs/editor/contrib/suggest/suggest","vs/platform/theme/common/styler","vs/base/common/iterator","vs/base/parts/tree/browser/treeDefaults","vs/platform/progress/common/progress","vs/editor/common/model/wordHelper","vs/editor/common/core/token","vs/editor/common/services/resolverService","vs/editor/common/core/lineTokens","vs/editor/common/modes/supports","vs/platform/keybinding/common/keybindingsRegistry","vs/editor/common/modes/supports/richEditBrackets","vs/editor/common/config/editorZoom","vs/platform/instantiation/common/serviceCollection","vs/editor/browser/widget/codeEditorWidget","vs/base/common/filters","vs/editor/common/core/uint","vs/base/browser/ui/sash/sash","vs/editor/common/viewLayout/viewLineRenderer","vs/editor/common/modes/modesRegistry","vs/editor/browser/editorBrowser","vs/editor/common/services/resourceConfiguration","vs/editor/common/view/minimapCharRenderer","vs/editor/contrib/codeAction/codeActionTrigger","vs/editor/contrib/folding/foldingRanges","vs/base/common/idGenerator","vs/editor/contrib/snippet/snippetParser","vs/editor/common/model/textModelSearch","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/common/severity","vs/base/common/range","vs/platform/log/common/log","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/iconLabel/iconLabel","vs/base/parts/quickopen/browser/quickOpenModel","vs/editor/contrib/markdown/markdownRenderer","vs/editor/common/core/stringBuilder","vs/editor/common/config/fontInfo","vs/editor/contrib/referenceSearch/referencesModel","vs/editor/common/standalone/standaloneEnums","vs/editor/common/config/commonEditorConfig","vs/editor/browser/services/bulkEditService","vs/editor/browser/view/viewLayer","vs/base/common/decorators","vs/editor/common/viewLayout/lineDecorations","vs/base/common/diff/diff","vs/editor/common/viewModel/prefixSumComputer","vs/editor/browser/controller/coreCommands","vs/base/browser/htmlContentRenderer","vs/editor/browser/editorDom","vs/base/common/assert","vs/editor/browser/viewParts/glyphMargin/glyphMargin","vs/editor/common/controller/cursorTypeOperations","vs/editor/common/controller/cursorWordOperations","vs/editor/browser/widget/embeddedCodeEditorWidget","vs/editor/contrib/find/findModel","vs/editor/contrib/message/messageController","vs/editor/contrib/referenceSearch/peekViewWidget","vs/editor/contrib/snippet/snippetController2","vs/editor/standalone/browser/quickOpen/editorQuickOpen","vs/platform/list/browser/listService","vs/editor/contrib/referenceSearch/referencesController","vs/editor/standalone/browser/simpleServices","vs/base/common/worker/simpleWorker","vs/base/browser/ui/scrollbar/scrollbarState","vs/editor/browser/controller/textAreaInput","vs/editor/standalone/browser/standaloneServices","vs/base/browser/ui/findinput/findInputCheckboxes","vs/editor/common/standalone/standaloneBase","vs/base/common/keybindingLabels","vs/platform/keybinding/common/keybindingResolver","vs/platform/label/common/label","vs/editor/common/view/overviewZoneManager","vs/base/common/labels","vs/base/browser/ui/highlightedlabel/highlightedLabel","vs/base/common/linkedList","vs/base/parts/tree/browser/treeImpl","vs/platform/files/common/files","vs/css!vs/editor/contrib/goToDefinition/goToDefinitionMouse","vs/base/browser/iframe","vs/editor/common/editorAction","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/common/glob","vs/editor/browser/viewParts/margin/margin","vs/base/common/scrollable","vs/base/common/winjs.polyfill.promise","vs/editor/contrib/comment/blockCommentCommand","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/browser/controller/textAreaState","vs/editor/contrib/colorPicker/color","vs/editor/contrib/colorPicker/colorDetector","vs/editor/contrib/goToDefinition/goToDefinition","vs/editor/contrib/parameterHints/provideSignatureHelp","vs/editor/common/commands/shiftCommand","vs/editor/contrib/toggleTabFocusMode/toggleTabFocusMode","vs/editor/contrib/wordOperations/wordOperations","vs/editor/common/controller/cursorMoveOperations","vs/editor/common/controller/cursorDeleteOperations","vs/editor/contrib/goToDefinition/clickLinkGesture","vs/editor/browser/viewParts/lines/viewLine","vs/editor/browser/controller/mouseTarget","vs/editor/contrib/hover/hoverOperation","vs/editor/browser/viewParts/lineNumbers/lineNumbers","vs/editor/common/controller/cursorMoveCommands","vs/editor/browser/widget/diffEditorWidget","vs/editor/common/modes/textToHtmlTokenizer","vs/editor/contrib/hover/hoverWidgets","vs/editor/contrib/smartSelect/tokenTree","vs/editor/common/services/editorWorkerServiceImpl","vs/editor/browser/widget/diffNavigator","vs/editor/common/viewModel/splitLinesCollection","vs/editor/contrib/zoneWidget/zoneWidget","vs/editor/contrib/referenceSearch/referencesWidget","vs/editor/standalone/common/monarch/monarchCommon","vs/editor/contrib/goToDefinition/goToDefinitionCommands","vs/editor/contrib/find/findController","vs/platform/workspace/common/workspace","vs/platform/clipboard/common/clipboardService","vs/editor/contrib/folding/syntaxRangeProvider","vs/css!vs/base/browser/ui/iconLabel/iconlabel","vs/base/common/stopwatch","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/editor/browser/viewParts/lines/rangeUtil","vs/editor/common/view/viewContext","vs/editor/common/view/viewEventDispatcher","vs/css!vs/base/browser/ui/keybindingLabel/keybindingLabel","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/menu/menu","vs/editor/common/viewLayout/viewLinesViewportData","vs/editor/common/viewLayout/whitespaceComputer","vs/editor/common/viewLayout/linesLayout","vs/css!vs/base/browser/ui/progressbar/progressbar","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/editorSimpleWorker","vs/base/browser/ui/progressbar/progressbar","vs/css!vs/base/browser/ui/sash/sash","vs/editor/editor.api","vs/editor/browser/viewParts/contentWidgets/contentWidgets","vs/editor/browser/viewParts/decorations/decorations","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/editor/browser/viewParts/linesDecorations/linesDecorations","vs/base/common/collections","vs/editor/browser/viewParts/marginDecorations/marginDecorations","vs/editor/browser/viewParts/overlayWidgets/overlayWidgets","vs/editor/browser/viewParts/overviewRuler/overviewRuler","vs/editor/browser/viewParts/viewZones/viewZones","vs/base/browser/ui/list/listView","vs/editor/common/viewLayout/viewLayout","vs/editor/common/viewModel/viewModelDecorations","vs/editor/contrib/caretOperations/moveCaretCommand","vs/base/parts/tree/browser/treeView","vs/editor/contrib/codeAction/codeActionWidget","vs/editor/contrib/colorPicker/colorPickerModel","vs/css!vs/base/parts/quickopen/browser/quickopen","vs/editor/contrib/comment/lineCommentCommand","vs/editor/contrib/dnd/dragAndDropCommand","vs/editor/contrib/find/findState","vs/editor/contrib/find/replaceAllCommand","vs/editor/contrib/find/replacePattern","vs/css!vs/base/parts/tree/browser/tree","vs/editor/contrib/folding/foldingModel","vs/editor/contrib/folding/hiddenRangeModel","vs/base/browser/ui/octiconLabel/octiconLabel","vs/editor/contrib/folding/intializingRangeProvider","vs/editor/contrib/format/formattingEdit","vs/css!vs/editor/browser/controller/textAreaHandler","vs/css!vs/editor/browser/viewParts/currentLineHighlight/currentLineHighlight","vs/css!vs/editor/browser/viewParts/currentLineMarginHighlight/currentLineMarginHighlight","vs/editor/contrib/hover/modesGlyphHover","vs/editor/contrib/inPlaceReplace/inPlaceReplaceCommand","vs/editor/contrib/indentation/indentUtils","vs/editor/contrib/linesOperations/copyLinesCommand","vs/editor/contrib/linesOperations/deleteLinesCommand","vs/editor/contrib/linesOperations/sortLinesCommand","vs/css!vs/editor/browser/viewParts/decorations/decorations","vs/css!vs/editor/browser/viewParts/glyphMargin/glyphMargin","vs/editor/contrib/suggest/wordDistance","vs/css!vs/editor/browser/viewParts/indentGuides/indentGuides","vs/editor/standalone/common/monarch/monarchCompile","vs/nls!vs/base/browser/ui/actionbar/actionbar","vs/css!vs/editor/browser/viewParts/lineNumbers/lineNumbers","vs/css!vs/editor/browser/viewParts/lines/viewLines","vs/css!vs/editor/browser/viewParts/linesDecorations/linesDecorations","vs/nls!vs/base/browser/ui/aria/aria","vs/css!vs/editor/browser/viewParts/marginDecorations/marginDecorations","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputCheckboxes","vs/css!vs/editor/browser/viewParts/minimap/minimap","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/editor/browser/viewParts/overlayWidgets/overlayWidgets","vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/list/listWidget","vs/base/browser/ui/list/listWidget","vs/nls!vs/base/browser/ui/menu/menu","vs/base/browser/ui/menu/menu","vs/nls!vs/base/common/keybindingLabels","vs/css!vs/editor/browser/viewParts/rulers/rulers","vs/base/browser/ui/keybindingLabel/keybindingLabel","vs/nls!vs/base/common/severity","vs/css!vs/editor/browser/viewParts/scrollDecoration/scrollDecoration","vs/nls!vs/base/parts/quickopen/browser/quickOpenModel","vs/css!vs/editor/browser/viewParts/selections/selections","vs/nls!vs/base/parts/quickopen/browser/quickOpenWidget","vs/base/parts/quickopen/browser/quickOpenWidget","vs/nls!vs/editor/browser/controller/coreCommands","vs/nls!vs/editor/browser/widget/codeEditorWidget","vs/nls!vs/editor/browser/widget/diffEditorWidget","vs/nls!vs/editor/browser/widget/diffReview","vs/nls!vs/editor/common/config/commonEditorConfig","vs/nls!vs/editor/common/config/editorOptions","vs/css!vs/editor/browser/viewParts/viewCursors/viewCursors","vs/css!vs/editor/browser/widget/media/diffEditor","vs/nls!vs/editor/common/controller/cursor","vs/nls!vs/editor/common/modes/modesRegistry","vs/nls!vs/editor/common/services/modelServiceImpl","vs/nls!vs/editor/common/view/editorColorRegistry","vs/nls!vs/editor/contrib/bracketMatching/bracketMatching","vs/nls!vs/editor/contrib/caretOperations/caretOperations","vs/nls!vs/editor/contrib/caretOperations/transpose","vs/nls!vs/editor/contrib/clipboard/clipboard","vs/nls!vs/editor/contrib/codeAction/codeActionCommands","vs/nls!vs/editor/contrib/comment/comment","vs/nls!vs/editor/contrib/contextmenu/contextmenu","vs/nls!vs/editor/contrib/cursorUndo/cursorUndo","vs/nls!vs/editor/contrib/find/findController","vs/nls!vs/editor/contrib/find/findWidget","vs/nls!vs/editor/contrib/folding/folding","vs/nls!vs/editor/contrib/fontZoom/fontZoom","vs/nls!vs/editor/contrib/format/formatActions","vs/nls!vs/editor/contrib/goToDefinition/goToDefinitionCommands","vs/nls!vs/editor/contrib/goToDefinition/goToDefinitionMouse","vs/nls!vs/editor/contrib/gotoError/gotoError","vs/nls!vs/editor/contrib/gotoError/gotoErrorWidget","vs/nls!vs/editor/contrib/hover/hover","vs/nls!vs/editor/contrib/hover/modesContentHover","vs/nls!vs/editor/contrib/inPlaceReplace/inPlaceReplace","vs/nls!vs/editor/contrib/linesOperations/linesOperations","vs/nls!vs/editor/contrib/links/links","vs/nls!vs/editor/contrib/message/messageController","vs/nls!vs/editor/contrib/multicursor/multicursor","vs/nls!vs/editor/contrib/parameterHints/parameterHints","vs/nls!vs/editor/contrib/parameterHints/parameterHintsWidget","vs/nls!vs/editor/contrib/referenceSearch/peekViewWidget","vs/nls!vs/editor/contrib/referenceSearch/referenceSearch","vs/nls!vs/editor/contrib/referenceSearch/referencesController","vs/nls!vs/editor/contrib/referenceSearch/referencesModel","vs/css!vs/editor/browser/widget/media/diffReview","vs/nls!vs/editor/contrib/referenceSearch/referencesWidget","vs/nls!vs/editor/contrib/rename/rename","vs/nls!vs/editor/contrib/rename/renameInputField","vs/nls!vs/editor/contrib/smartSelect/smartSelect","vs/nls!vs/editor/contrib/snippet/snippetVariables","vs/editor/contrib/snippet/snippetVariables","vs/nls!vs/editor/contrib/suggest/suggestController","vs/nls!vs/editor/contrib/suggest/suggestWidget","vs/nls!vs/editor/contrib/toggleTabFocusMode/toggleTabFocusMode","vs/nls!vs/editor/contrib/wordHighlighter/wordHighlighter","vs/nls!vs/editor/standalone/browser/accessibilityHelp/accessibilityHelp","vs/nls!vs/editor/standalone/browser/inspectTokens/inspectTokens","vs/nls!vs/editor/standalone/browser/quickOpen/gotoLine","vs/nls!vs/editor/standalone/browser/quickOpen/quickCommand","vs/nls!vs/editor/standalone/browser/quickOpen/quickOutline","vs/nls!vs/editor/standalone/browser/simpleServices","vs/nls!vs/editor/standalone/browser/standaloneCodeEditor","vs/nls!vs/editor/standalone/browser/toggleHighContrast/toggleHighContrast","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/keybinding/common/abstractKeybindingService","vs/nls!vs/platform/list/browser/listService","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/colorRegistry","vs/css!vs/editor/browser/widget/media/editor","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/graph","vs/css!vs/editor/browser/widget/media/tokens","vs/css!vs/editor/contrib/bracketMatching/bracketMatching","vs/css!vs/editor/contrib/clipboard/clipboard","vs/css!vs/editor/contrib/codeAction/lightBulbWidget","vs/css!vs/editor/contrib/codelens/codelensWidget","vs/css!vs/editor/contrib/colorPicker/colorPicker","vs/editor/common/modes/languageFeatureRegistry","vs/css!vs/editor/contrib/dnd/dnd","vs/css!vs/editor/contrib/find/findWidget","vs/css!vs/editor/contrib/folding/folding","vs/editor/common/model/textModelTokens","vs/base/browser/ui/list/rowCache","vs/css!vs/editor/contrib/gotoError/gotoErrorWidget","vs/css!vs/editor/contrib/hover/hover","vs/editor/common/controller/cursorColumnSelection","vs/css!vs/editor/contrib/links/links","vs/css!vs/editor/contrib/message/messageController","vs/css!vs/editor/contrib/parameterHints/parameterHints","vs/css!vs/editor/contrib/referenceSearch/media/peekViewWidget","vs/css!vs/editor/contrib/referenceSearch/media/referencesWidget","vs/editor/common/controller/oneCursor","vs/editor/common/controller/cursorCollection","vs/editor/common/controller/cursor","vs/css!vs/editor/contrib/rename/renameInputField","vs/css!vs/editor/contrib/snippet/snippetSession","vs/css!vs/editor/contrib/suggest/media/suggest","vs/css!vs/editor/contrib/zoneWidget/zoneWidget","vs/editor/common/services/webWorker","vs/css!vs/editor/standalone/browser/accessibilityHelp/accessibilityHelp","vs/editor/common/view/runtimeMinimapCharRenderer","vs/css!vs/editor/standalone/browser/iPadShowKeyboard/iPadShowKeyboard","vs/editor/common/viewModel/characterHardWrappingLineMapper","vs/editor/common/viewModel/viewModelImpl","vs/editor/contrib/codeAction/lightBulbWidget","vs/editor/contrib/folding/foldingDecorations","vs/editor/contrib/folding/indentRangeProvider","vs/editor/contrib/linesOperations/moveLinesCommand","vs/editor/contrib/smartSelect/tokenSelectionSupport","vs/css!vs/editor/standalone/browser/inspectTokens/inspectTokens","vs/editor/standalone/browser/colorizer","vs/editor/standalone/common/monarch/monarchLexer","vs/css!vs/editor/standalone/browser/quickOpen/editorQuickOpen","vs/css!vs/editor/standalone/browser/quickOpen/gotoLine","vs/css!vs/editor/standalone/browser/quickOpen/quickOutline","vs/editor/contrib/links/getLinks","vs/css!vs/editor/standalone/browser/standalone-tokens","vs/css!vs/platform/contextview/browser/contextMenuHandler","vs/editor/contrib/suggest/suggestAlternatives","vs/editor/contrib/suggest/wordContextKey","vs/editor/browser/config/charWidthReader","vs/platform/actions/common/menu","vs/editor/browser/config/elementSizeObserver","vs/platform/dialogs/common/dialogs","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/abstractKeybindingService","vs/base/common/functional","vs/editor/browser/services/abstractCodeEditorService","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/base/common/hash","vs/base/browser/ui/list/splice","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/platform/markers/common/markerService","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/dnd","vs/base/common/mime","vs/editor/common/commands/trimTrailingWhitespaceCommand","vs/editor/common/core/rgba","vs/base/common/numbers","vs/editor/common/services/getIconClasses","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/marshalling","vs/base/common/diff/diffChange","vs/editor/common/commands/surroundSelectionCommand","vs/editor/browser/view/viewOverlays","vs/editor/browser/viewParts/viewCursors/viewCursor","vs/editor/common/services/languagesRegistry","vs/editor/common/services/modeServiceImpl","vs/base/parts/quickopen/browser/quickOpenViewer","vs/platform/configuration/common/configurationModels","vs/platform/contextkey/browser/contextKeyService","vs/base/parts/tree/browser/tree","vs/base/common/history","vs/editor/contrib/suggest/suggestMemory","vs/base/parts/tree/browser/treeDnd","vs/base/parts/tree/browser/treeModel","vs/base/parts/tree/browser/treeViewModel","vs/editor/browser/view/viewController","vs/editor/contrib/caretOperations/caretOperations","vs/editor/contrib/caretOperations/transpose","vs/editor/contrib/clipboard/clipboard","vs/editor/contrib/codeAction/codeAction","vs/editor/contrib/codeAction/codeActionModel","vs/editor/contrib/codelens/codelens","vs/editor/common/diff/diffComputer","vs/base/worker/defaultWorkerFactory","vs/editor/contrib/comment/comment","vs/editor/contrib/contextmenu/contextmenu","vs/editor/contrib/cursorUndo/cursorUndo","vs/editor/contrib/dnd/dnd","vs/editor/contrib/folding/folding","vs/editor/contrib/fontZoom/fontZoom","vs/editor/contrib/format/format","vs/editor/contrib/format/formatActions","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/editor/contrib/hover/getHover","vs/editor/contrib/linesOperations/linesOperations","vs/base/browser/ui/list/rangeMap","vs/editor/contrib/quickOpen/quickOpen","vs/editor/contrib/smartSelect/smartSelect","vs/css!vs/base/browser/ui/aria/aria","vs/editor/contrib/suggest/completionModel","vs/editor/common/model/editStack","vs/editor/common/model/indentationGuesser","vs/editor/contrib/wordPartOperations/wordPartOperations","vs/editor/standalone/browser/iPadShowKeyboard/iPadShowKeyboard","vs/editor/standalone/browser/toggleHighContrast/toggleHighContrast","vs/platform/contextview/browser/contextViewService","vs/platform/telemetry/common/telemetryUtils","vs/editor/browser/services/openerService","vs/editor/common/model/intervalTree","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/standalone/browser/quickOpen/quickOpenEditorWidget","vs/platform/contextview/browser/contextMenuHandler","vs/editor/common/model/textModelEvents","vs/editor/browser/services/codeEditorServiceImpl","vs/editor/browser/viewParts/editorScrollbar/editorScrollbar","vs/css!vs/base/browser/ui/checkbox/checkbox","vs/base/browser/ui/checkbox/checkbox","vs/editor/browser/controller/mouseHandler","vs/editor/browser/controller/pointerHandler","vs/editor/browser/view/viewOutgoingEvents","vs/editor/browser/viewParts/lines/viewLines","vs/editor/browser/viewParts/minimap/minimap","vs/editor/browser/viewParts/scrollDecoration/scrollDecoration","vs/editor/browser/viewParts/selections/selections","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/browser/viewParts/currentLineHighlight/currentLineHighlight","vs/editor/browser/viewParts/currentLineMarginHighlight/currentLineMarginHighlight","vs/editor/browser/viewParts/indentGuides/indentGuides","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/browser/controller/textAreaHandler","vs/editor/browser/viewParts/overviewRuler/decorationsOverviewRuler","vs/editor/browser/viewParts/rulers/rulers","vs/editor/browser/viewParts/viewCursors/viewCursors","vs/editor/browser/view/viewImpl","vs/css!vs/base/browser/ui/contextview/contextview","vs/editor/browser/widget/diffReview","vs/editor/common/modes/abstractMode","vs/base/browser/ui/contextview/contextview","vs/editor/common/services/modelServiceImpl","vs/editor/contrib/bracketMatching/bracketMatching","vs/editor/contrib/codelens/codelensWidget","vs/editor/contrib/codelens/codelensController","vs/editor/contrib/colorPicker/colorPickerWidget","vs/editor/contrib/find/findDecorations","vs/editor/common/modes/languageSelector","vs/editor/contrib/find/findOptionsWidget","vs/editor/contrib/gotoError/gotoErrorWidget","vs/editor/contrib/gotoError/gotoError","vs/editor/contrib/hover/modesContentHover","vs/editor/contrib/hover/hover","vs/editor/contrib/inPlaceReplace/inPlaceReplace","vs/editor/contrib/links/links","vs/editor/common/modes/linkComputer","vs/editor/contrib/codeAction/codeActionCommands","vs/editor/contrib/codeAction/codeActionContributions","vs/editor/contrib/parameterHints/parameterHintsWidget","vs/editor/contrib/parameterHints/parameterHints","vs/css!vs/base/browser/ui/countBadge/countBadge","vs/editor/contrib/rename/renameInputField","vs/editor/contrib/rename/rename","vs/editor/contrib/snippet/snippetSession","vs/editor/common/modes/supports/characterPair","vs/editor/contrib/suggest/suggestModel","vs/editor/contrib/suggest/suggestWidget","vs/editor/contrib/suggest/suggestController","vs/editor/contrib/wordHighlighter/wordHighlighter","vs/editor/standalone/browser/accessibilityHelp/accessibilityHelp","vs/editor/standalone/browser/inspectTokens/inspectTokens","vs/editor/common/modes/supports/indentRules","vs/editor/standalone/browser/quickOpen/gotoLine","vs/editor/standalone/browser/quickOpen/quickCommand","vs/editor/standalone/browser/quickOpen/quickOutline","vs/editor/standalone/browser/standaloneCodeServiceImpl","vs/editor/standalone/common/themes","vs/editor/standalone/browser/standaloneThemeServiceImpl","vs/platform/contextview/browser/contextMenuService","vs/editor/common/modes/supports/inplaceReplaceSupport","vs/editor/common/modes/supports/onEnter","vs/base/browser/ui/countBadge/countBadge","vs/editor/common/modes/supports/electricCharacter","vs/editor/contrib/goToDefinition/goToDefinitionMouse","vs/editor/contrib/referenceSearch/referenceSearch","vs/editor/standalone/browser/referenceSearch/standaloneReferenceSearch","vs/platform/widget/common/contextScopedWidget","vs/platform/widget/browser/contextScopedHistoryWidget","vs/editor/contrib/find/findWidget","vs/css!vs/base/browser/ui/findinput/findInput","vs/editor/contrib/multicursor/multicursor","vs/editor/editor.all","vs/editor/common/modes/supports/tokenization","vs/editor/common/modes/tokenizationRegistry","vs/editor/standalone/browser/standaloneCodeEditor","vs/css!vs/base/browser/ui/findinput/findInputCheckboxes","vs/editor/standalone/browser/standaloneEditor","vs/editor/standalone/browser/standaloneLanguages","vs/base/common/marked/marked","vs/editor/edcore.main"],n=function(X){for(var $=[],J=0,ee=X.length;J<ee;J++)$[J]=Q[X[J]];return $};!function(X){var $=function(){function e(){this._pendingLoads=0}return e.prototype.attachListeners=function(X,$,Q,J){var o=function(){$.removeEventListener("load",r),$.removeEventListener("error",s)},r=function(X){o(),Q()},s=function(X){o(),J(X)};$.addEventListener("load",r),$.addEventListener("error",s)},e.prototype._onLoad=function(X,$){this._pendingLoads--,$()},e.prototype._onLoadError=function(X,$,Q){this._pendingLoads--,$(Q)},e.prototype._insertLinkNode=function(X){this._pendingLoads++;var $=document.head||document.getElementsByTagName("head")[0],Q=$.getElementsByTagName("link")||document.head.getElementsByTagName("script");Q.length>0?$.insertBefore(X,Q[Q.length-1]):$.appendChild(X)},e.prototype.createLinkTag=function(X,$,Q,J){var ee=this,te=document.createElement("link");return te.setAttribute("rel","stylesheet"),te.setAttribute("type","text/css"),te.setAttribute("data-name",X),this.attachListeners(X,te,(function(){return ee._onLoad(X,Q)}),(function($){return ee._onLoadError(X,J,$)})),te.setAttribute("href",$),te},e.prototype._linkTagExists=function(X,$){var Q,J,ee,te,ne=document.getElementsByTagName("link");for(Q=0,J=ne.length;Q<J;Q++)if(ee=ne[Q].getAttribute("data-name"),te=ne[Q].getAttribute("href"),ee===X||te===$)return!0;return!1},e.prototype.load=function(X,$,Q,J){if(this._linkTagExists(X,$))Q();else{var ee=this.createLinkTag(X,$,Q,J);this._insertLinkNode(ee)}},e}(),Q=function(){function e(){this._cssLoader=new $}return e.prototype.load=function(X,$,Q){var J=$.toUrl(X+".css");this._cssLoader.load(X,J,(function(X){Q({})}),(function(X){"function"==typeof Q.error&&Q.error("Could not find "+J+" or it was empty")}))},e}();X.CSSPlugin=Q,define("vs/css",new Q)}(X||(X={})),function(X){function t(X,$,Q){var J;return J=0===$.length?X:X.replace(/\{(\d+)\}/g,(function(X,Q){var J=Q[0],ee=$[J],te=X;return"string"==typeof ee?te=ee:"number"!=typeof ee&&"boolean"!=typeof ee&&null!=ee||(te=String(ee)),te})),Q.isPseudo&&(J="［"+J.replace(/[aouei]/g,"$&$&")+"］"),J}function n(X,$){return function(Q,J){var ee=Array.prototype.slice.call(arguments,2);return t(X[Q],ee,$)}}var $=function(){function e(){this._detected=!1,this._isPseudo=!1}return Object.defineProperty(e.prototype,"isPseudo",{get:function(){return this._detect(),this._isPseudo},enumerable:!0,configurable:!0}),e.prototype._detect=function(){this._detected||(this._detected=!0,this._isPseudo="undefined"!=typeof document&&document.location&&document.location.hash.indexOf("pseudo=true")>=0)},e}(),Q=function(){function e(X){var $=this;this._env=X,this.localize=function(X,Q){for(var J=[],ee=2;ee<arguments.length;ee++)J[ee-2]=arguments[ee];return function(X,$,Q){for(var J=[],ee=3;ee<arguments.length;ee++)J[ee-3]=arguments[ee];return t(Q,J,X)}.apply(void 0,[$._env,X,Q].concat(J))}}return e.prototype.setPseudoTranslation=function(X){this._env._isPseudo=X},e.prototype.create=function(X,$){return{localize:n($[X],this._env)}},e.prototype.load=function(X,$,Q,J){var ee=this;if(J=J||{},X&&0!==X.length){var te=J["vs/nls"]||{},ne=te.availableLanguages?function(X,$){var Q=X[$];return Q||(Q=X["*"])||null}(te.availableLanguages,X):null,ie=".nls";null!==ne&&ne!==e.DEFAULT_TAG&&(ie=ie+"."+ne);var d=function($){Array.isArray($)?$.localize=n($,ee._env):$.localize=n($[X],ee._env),Q($)};"function"==typeof te.loadBundle?te.loadBundle(X,ne,(function(Q,J){Q?$([X+".nls"],d):d(J)})):$([X+ie],d)}else Q({localize:this.localize})},e.DEFAULT_TAG="i-default",e}();X.NLSPlugin=Q,define("vs/nls",new Q(new $))}($||($={})),define(Q[423],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0}),$.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:"text/plain"}})),define(Q[164],n([0,1]),(function(X,$){function n(X){if(!X.parent||X.parent===X)return null;try{var $=X.location,J=X.parent.location;if($.protocol!==J.protocol||$.hostname!==J.hostname||$.port!==J.port)return Q=!0,null}catch(X){return Q=!0,null}return X.parent}function i(X,$){for(var Q,J=X.document.getElementsByTagName("iframe"),ee=0,te=J.length;ee<te;ee++)if((Q=J[ee]).contentWindow===$)return Q;return null}Object.defineProperty($,"__esModule",{value:!0});var Q=!1,J=null,ee=function(){function e(){}return e.getSameOriginWindowChain=function(){if(!J){J=[];var X,$=window;do{(X=n($))?J.push({window:$,iframeElement:i(X,$)}):J.push({window:$,iframeElement:null}),$=X}while($)}return J.slice(0)},e.hasDifferentOriginAncestor=function(){return J||this.getSameOriginWindowChain(),Q},e.getPositionOfChildWindowRelativeToAncestorWindow=function(X,$){if(!$||X===$)return{top:0,left:0};for(var Q=0,J=0,ee=this.getSameOriginWindowChain(),te=0;te<ee.length;te++){var ne=ee[te];if(ne.window===$)break;if(!ne.iframeElement)break;var ie=ne.iframeElement.getBoundingClientRect();Q+=ie.top,J+=ie.left}return{top:Q,left:J}},e}();$.IframeUtils=ee})),define(Q[419],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q=function(){function e(X){this.spliceables=X}return e.prototype.splice=function(X,$,Q){this.spliceables.forEach((function(J){return J.splice(X,$,Q)}))},e}();$.CombinedSpliceable=Q})),define(Q[149],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q=function(){function e(X,$,Q){this._scrollbarSize=Math.round($),this._oppositeScrollbarSize=Math.round(Q),this._arrowSize=Math.round(X),this._visibleSize=0,this._scrollSize=0,this._scrollPosition=0,this._computedAvailableSize=0,this._computedIsNeeded=!1,this._computedSliderSize=0,this._computedSliderRatio=0,this._computedSliderPosition=0,this._refreshComputedValues()}return e.prototype.clone=function(){var X=new e(this._arrowSize,this._scrollbarSize,this._oppositeScrollbarSize);return X.setVisibleSize(this._visibleSize),X.setScrollSize(this._scrollSize),X.setScrollPosition(this._scrollPosition),X},e.prototype.setVisibleSize=function(X){var $=Math.round(X);return this._visibleSize!==$&&(this._visibleSize=$,this._refreshComputedValues(),!0)},e.prototype.setScrollSize=function(X){var $=Math.round(X);return this._scrollSize!==$&&(this._scrollSize=$,this._refreshComputedValues(),!0)},e.prototype.setScrollPosition=function(X){var $=Math.round(X);return this._scrollPosition!==$&&(this._scrollPosition=$,this._refreshComputedValues(),!0)},e._computeValues=function(X,$,Q,J,ee){var te=Math.max(0,Q-X),ne=Math.max(0,te-2*$),ie=J>0&&J>Q;if(!ie)return{computedAvailableSize:Math.round(te),computedIsNeeded:ie,computedSliderSize:Math.round(ne),computedSliderRatio:0,computedSliderPosition:0};var oe=Math.round(Math.max(20,Math.floor(Q*ne/J))),re=(ne-oe)/(J-Q),se=ee*re;return{computedAvailableSize:Math.round(te),computedIsNeeded:ie,computedSliderSize:Math.round(oe),computedSliderRatio:re,computedSliderPosition:Math.round(se)}},e.prototype._refreshComputedValues=function(){var X=e._computeValues(this._oppositeScrollbarSize,this._arrowSize,this._visibleSize,this._scrollSize,this._scrollPosition);this._computedAvailableSize=X.computedAvailableSize,this._computedIsNeeded=X.computedIsNeeded,this._computedSliderSize=X.computedSliderSize,this._computedSliderRatio=X.computedSliderRatio,this._computedSliderPosition=X.computedSliderPosition},e.prototype.getArrowSize=function(){return this._arrowSize},e.prototype.getScrollPosition=function(){return this._scrollPosition},e.prototype.getRectangleLargeSize=function(){return this._computedAvailableSize},e.prototype.getRectangleSmallSize=function(){return this._scrollbarSize},e.prototype.isNeeded=function(){return this._computedIsNeeded},e.prototype.getSliderSize=function(){return this._computedSliderSize},e.prototype.getSliderPosition=function(){return this._computedSliderPosition},e.prototype.getDesiredScrollPositionFromOffset=function(X){if(!this._computedIsNeeded)return 0;var $=X-this._arrowSize-this._computedSliderSize/2;return Math.round($/this._computedSliderRatio)},e.prototype.getDesiredScrollPositionFromDelta=function(X){if(!this._computedIsNeeded)return 0;var $=this._computedSliderPosition+X;return Math.round($/this._computedSliderRatio)},e}();$.ScrollbarState=Q})),define(Q[22],n([0,1]),(function(X,$){function n(X,$){return i(X,$,0,X.length-1,[]),X}function i(X,$,Q,J,ee){if(!(J<=Q)){var te=Q+(J-Q)/2|0;i(X,$,Q,te,ee),i(X,$,te+1,J,ee),$(X[te],X[te+1])<=0||function(X,$,Q,J,ee,te){for(var ne=Q,ie=J+1,oe=Q;oe<=ee;oe++)te[oe]=X[oe];for(oe=Q;oe<=ee;oe++)ne>J?X[oe]=te[ie++]:ie>ee?X[oe]=te[ne++]:$(te[ie],te[ne])<0?X[oe]=te[ie++]:X[oe]=te[ne++]}(X,$,Q,te,J,ee)}}function o(X,$){for(var Q=0;Q<X.length;Q++)if($(X[Q]))return Q;return-1}Object.defineProperty($,"__esModule",{value:!0}),$.tail=function(X,$){return void 0===$&&($=0),X[X.length-(1+$)]},$.tail2=function(X){if(0===X.length)throw new Error("Invalid tail call");return[X.slice(0,X.length-1),X[X.length-1]]},$.equals=function(X,$,Q){if(void 0===Q&&(Q=function(X,$){return X===$}),X===$)return!0;if(!X||!$)return!1;if(X.length!==$.length)return!1;for(var J=0,ee=X.length;J<ee;J++)if(!Q(X[J],$[J]))return!1;return!0},$.binarySearch=function(X,$,Q){for(var J=0,ee=X.length-1;J<=ee;){var te=(J+ee)/2|0,ne=Q(X[te],$);if(ne<0)J=te+1;else{if(!(ne>0))return te;ee=te-1}}return-(J+1)},$.findFirstInSorted=function(X,$){var Q=0,J=X.length;if(0===J)return 0;for(;Q<J;){var ee=Math.floor((Q+J)/2);$(X[ee])?J=ee:Q=ee+1}return Q},$.mergeSort=n,$.groupBy=function(X,$){for(var Q=[],J=void 0,ee=0,te=n(X.slice(0),$);ee<te.length;ee++){var ne=te[ee];J&&0===$(J[0],ne)?J.push(ne):(J=[ne],Q.push(J))}return Q},$.coalesce=function(X){return X?X.filter((function(X){return!!X})):X},$.isFalsyOrEmpty=function(X){return!Array.isArray(X)||0===X.length},$.distinct=function(X,$){if(!$)return X.filter((function($,Q){return X.indexOf($)===Q}));var Q=Object.create(null);return X.filter((function(X){var J=$(X);return!Q[J]&&(Q[J]=!0,!0)}))},$.firstIndex=o,$.first=function(X,$,Q){void 0===Q&&(Q=null);var J=o(X,$);return J<0?Q:X[J]},$.flatten=function(X){var $;return($=[]).concat.apply($,X)},$.range=function(X,$){var Q="number"==typeof $?X:0;"number"==typeof $?Q=X:(Q=0,$=X);var J=[];if(Q<=$)for(ee=Q;ee<$;ee++)J.push(ee);else for(var ee=Q;ee>$;ee--)J.push(ee);return J},$.arrayInsert=function(X,$,Q){var J=X.slice(0,$),ee=X.slice($);return J.concat(Q,ee)}})),define(Q[135],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0}),$.ok=function(X,$){if(!X||null===X)throw new Error($?"Assertion failed ("+$+")":"Assertion Failed")}})),define(Q[226],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q=Object.prototype.hasOwnProperty;$.forEach=function(X,$){var i=function(J){if(Q.call(X,J)&&!1===$({key:J,value:X[J]},(function(){delete X[J]})))return{value:void 0}};for(var J in X){var ee=i(J);if("object"==typeof ee)return ee.value}}})),define(Q[28],n([0,1]),(function(X,$){function n(X,$){var Q=Math.pow(10,$);return Math.round(X*Q)/Q}Object.defineProperty($,"__esModule",{value:!0});var Q=function(){function e(X,$,Q,J){void 0===J&&(J=1),this.r=0|Math.min(255,Math.max(0,X)),this.g=0|Math.min(255,Math.max(0,$)),this.b=0|Math.min(255,Math.max(0,Q)),this.a=n(Math.max(Math.min(1,J),0),3)}return e.equals=function(X,$){return X.r===$.r&&X.g===$.g&&X.b===$.b&&X.a===$.a},e}();$.RGBA=Q;var J=function(){function e(X,$,Q,J){this.h=0|Math.max(Math.min(360,X),0),this.s=n(Math.max(Math.min(1,$),0),3),this.l=n(Math.max(Math.min(1,Q),0),3),this.a=n(Math.max(Math.min(1,J),0),3)}return e.equals=function(X,$){return X.h===$.h&&X.s===$.s&&X.l===$.l&&X.a===$.a},e.fromRGBA=function(X){var $=X.r/255,Q=X.g/255,J=X.b/255,ee=X.a,te=Math.max($,Q,J),ne=Math.min($,Q,J),ie=0,oe=0,re=(ne+te)/2,se=te-ne;if(se>0){switch(oe=Math.min(re<=.5?se/(2*re):se/(2-2*re),1),te){case $:ie=(Q-J)/se+(Q<J?6:0);break;case Q:ie=(J-$)/se+2;break;case J:ie=($-Q)/se+4}ie*=60,ie=Math.round(ie)}return new e(ie,oe,re,ee)},e._hue2rgb=function(X,$,Q){return Q<0&&(Q+=1),Q>1&&(Q-=1),Q<1/6?X+6*($-X)*Q:Q<.5?$:Q<2/3?X+($-X)*(2/3-Q)*6:X},e.toRGBA=function(X){var $,J,ee,te=X.h/360,ne=X.s,ie=X.l,oe=X.a;if(0===ne)$=J=ee=ie;else{var re=ie<.5?ie*(1+ne):ie+ne-ie*ne,se=2*ie-re;$=e._hue2rgb(se,re,te+1/3),J=e._hue2rgb(se,re,te),ee=e._hue2rgb(se,re,te-1/3)}return new Q(Math.round(255*$),Math.round(255*J),Math.round(255*ee),oe)},e}();$.HSLA=J;var ee=function(){function e(X,$,Q,J){this.h=0|Math.max(Math.min(360,X),0),this.s=n(Math.max(Math.min(1,$),0),3),this.v=n(Math.max(Math.min(1,Q),0),3),this.a=n(Math.max(Math.min(1,J),0),3)}return e.equals=function(X,$){return X.h===$.h&&X.s===$.s&&X.v===$.v&&X.a===$.a},e.fromRGBA=function(X){var $,Q=X.r/255,J=X.g/255,ee=X.b/255,te=Math.max(Q,J,ee),ne=te-Math.min(Q,J,ee),ie=0===te?0:ne/te;return $=0===ne?0:te===Q?((J-ee)/ne%6+6)%6:te===J?(ee-Q)/ne+2:(Q-J)/ne+4,new e(Math.round(60*$),ie,te,X.a)},e.toRGBA=function(X){var $=X.h,J=X.s,ee=X.v,te=X.a,ne=ee*J,ie=ne*(1-Math.abs($/60%2-1)),oe=ee-ne,re=[0,0,0],se=re[0],ae=re[1],le=re[2];return $<60?(se=ne,ae=ie):$<120?(se=ie,ae=ne):$<180?(ae=ne,le=ie):$<240?(ae=ie,le=ne):$<300?(se=ie,le=ne):$<360&&(se=ne,le=ie),se=Math.round(255*(se+oe)),ae=Math.round(255*(ae+oe)),le=Math.round(255*(le+oe)),new Q(se,ae,le,te)},e}();$.HSVA=ee;var te=function(){function e(X){if(!X)throw new Error("Color needs a value");if(X instanceof Q)this.rgba=X;else if(X instanceof J)this._hsla=X,this.rgba=J.toRGBA(X);else{if(!(X instanceof ee))throw new Error("Invalid color ctor argument");this._hsva=X,this.rgba=ee.toRGBA(X)}}return e.fromHex=function(X){return e.Format.CSS.parseHex(X)||e.red},Object.defineProperty(e.prototype,"hsla",{get:function(){return this._hsla?this._hsla:J.fromRGBA(this.rgba)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"hsva",{get:function(){return this._hsva?this._hsva:ee.fromRGBA(this.rgba)},enumerable:!0,configurable:!0}),e.prototype.equals=function(X){return!!X&&Q.equals(this.rgba,X.rgba)&&J.equals(this.hsla,X.hsla)&&ee.equals(this.hsva,X.hsva)},e.prototype.getRelativeLuminance=function(){return n(.2126*e._relativeLuminanceForComponent(this.rgba.r)+.7152*e._relativeLuminanceForComponent(this.rgba.g)+.0722*e._relativeLuminanceForComponent(this.rgba.b),4)},e._relativeLuminanceForComponent=function(X){var $=X/255;return $<=.03928?$/12.92:Math.pow(($+.055)/1.055,2.4)},e.prototype.isLighter=function(){return(299*this.rgba.r+587*this.rgba.g+114*this.rgba.b)/1e3>=128},e.prototype.isLighterThan=function(X){return this.getRelativeLuminance()>X.getRelativeLuminance()},e.prototype.isDarkerThan=function(X){return this.getRelativeLuminance()<X.getRelativeLuminance()},e.prototype.lighten=function(X){return new e(new J(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*X,this.hsla.a))},e.prototype.darken=function(X){return new e(new J(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*X,this.hsla.a))},e.prototype.transparent=function(X){var $=this.rgba,J=$.r,ee=$.g,te=$.b,ne=$.a;return new e(new Q(J,ee,te,ne*X))},e.prototype.isTransparent=function(){return 0===this.rgba.a},e.prototype.isOpaque=function(){return 1===this.rgba.a},e.prototype.opposite=function(){return new e(new Q(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))},e.prototype.toString=function(){return""+e.Format.CSS.format(this)},e.getLighterColor=function(X,$,Q){if(X.isLighterThan($))return X;Q=Q||.5;var J=X.getRelativeLuminance(),ee=$.getRelativeLuminance();return Q=Q*(ee-J)/ee,X.lighten(Q)},e.getDarkerColor=function(X,$,Q){if(X.isDarkerThan($))return X;Q=Q||.5;var J=X.getRelativeLuminance();return Q=Q*(J-$.getRelativeLuminance())/J,X.darken(Q)},e.white=new e(new Q(255,255,255,1)),e.black=new e(new Q(0,0,0,1)),e.red=new e(new Q(255,0,0,1)),e.blue=new e(new Q(0,0,255,1)),e.cyan=new e(new Q(0,255,255,1)),e.lightgrey=new e(new Q(211,211,211,1)),e.transparent=new e(new Q(0,0,0,0)),e}();$.Color=te,function(X){!function($){!function($){function n(X){var $=X.toString(16);return 2!==$.length?"0"+$:$}function o(X){switch(X){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:case 65:return 10;case 98:case 66:return 11;case 99:case 67:return 12;case 100:case 68:return 13;case 101:case 69:return 14;case 102:case 70:return 15}return 0}$.formatRGB=function($){return 1===$.rgba.a?"rgb("+$.rgba.r+", "+$.rgba.g+", "+$.rgba.b+")":X.Format.CSS.formatRGBA($)},$.formatRGBA=function(X){return"rgba("+X.rgba.r+", "+X.rgba.g+", "+X.rgba.b+", "+ +X.rgba.a.toFixed(2)+")"},$.formatHSL=function($){return 1===$.hsla.a?"hsl("+$.hsla.h+", "+(100*$.hsla.s).toFixed(2)+"%, "+(100*$.hsla.l).toFixed(2)+"%)":X.Format.CSS.formatHSLA($)},$.formatHSLA=function(X){return"hsla("+X.hsla.h+", "+(100*X.hsla.s).toFixed(2)+"%, "+(100*X.hsla.l).toFixed(2)+"%, "+X.hsla.a.toFixed(2)+")"},$.formatHex=function(X){return"#"+n(X.rgba.r)+n(X.rgba.g)+n(X.rgba.b)},$.formatHexA=function($,Q){return void 0===Q&&(Q=!1),Q&&1===$.rgba.a?X.Format.CSS.formatHex($):"#"+n($.rgba.r)+n($.rgba.g)+n($.rgba.b)+n(Math.round(255*$.rgba.a))},$.format=function($){return $?$.isOpaque()?X.Format.CSS.formatHex($):X.Format.CSS.formatRGBA($):null},$.parseHex=function($){if(!$)return null;var J=$.length;if(0===J)return null;if(35!==$.charCodeAt(0))return null;if(7===J){var ee=16*o($.charCodeAt(1))+o($.charCodeAt(2)),te=16*o($.charCodeAt(3))+o($.charCodeAt(4)),ne=16*o($.charCodeAt(5))+o($.charCodeAt(6));return new X(new Q(ee,te,ne,1))}if(9===J){ee=16*o($.charCodeAt(1))+o($.charCodeAt(2)),te=16*o($.charCodeAt(3))+o($.charCodeAt(4)),ne=16*o($.charCodeAt(5))+o($.charCodeAt(6));var ie=16*o($.charCodeAt(7))+o($.charCodeAt(8));return new X(new Q(ee,te,ne,ie/255))}if(4===J){ee=o($.charCodeAt(1)),te=o($.charCodeAt(2)),ne=o($.charCodeAt(3));return new X(new Q(16*ee+ee,16*te+te,16*ne+ne))}if(5===J){ee=o($.charCodeAt(1)),te=o($.charCodeAt(2)),ne=o($.charCodeAt(3)),ie=o($.charCodeAt(4));return new X(new Q(16*ee+ee,16*te+te,16*ne+ne,(16*ie+ie)/255))}return null}}($.CSS||($.CSS={}))}(X.Format||(X.Format={}))}(te=$.Color||($.Color={})),$.Color=te})),define(Q[128],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0}),$.memoize=function(X,$,Q){var J=null,ee=null;if("function"==typeof Q.value?(J="value",0!==(ee=Q.value).length&&console.warn("Memoize should only be used in functions with zero parameters")):"function"==typeof Q.get&&(J="get",ee=Q.get),!ee)throw new Error("not supported");var te="$memoize$"+$;Q[J]=function(){for(var X=[],$=0;$<arguments.length;$++)X[$]=arguments[$];return this.hasOwnProperty(te)||Object.defineProperty(this,te,{configurable:!1,enumerable:!1,writable:!1,value:ee.apply(this,X)}),this[te]}}})),define(Q[431],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q=function(){function e(X,$,Q,J){this.originalStart=X,this.originalLength=$,this.modifiedStart=Q,this.modifiedLength=J}return e.prototype.getOriginalEnd=function(){return this.originalStart+this.originalLength},e.prototype.getModifiedEnd=function(){return this.modifiedStart+this.modifiedLength},e}();$.DiffChange=Q})),define(Q[130],n([0,1,431]),(function(X,$,Q){function i(X){return{getLength:function(){return X.length},getElementAtIndex:function($){return X.charCodeAt($)}}}Object.defineProperty($,"__esModule",{value:!0}),$.stringDiff=function(X,$,Q){return new ne(i(X),i($)).ComputeDiff(Q)};var J=function(){function e(){}return e.Assert=function(X,$){if(!X)throw new Error($)},e}();$.Debug=J;var ee=function(){function e(){}return e.Copy=function(X,$,Q,J,ee){for(var te=0;te<ee;te++)Q[J+te]=X[$+te]},e}();$.MyArray=ee;var te=function(){function e(){this.m_changes=[],this.m_originalStart=Number.MAX_VALUE,this.m_modifiedStart=Number.MAX_VALUE,this.m_originalCount=0,this.m_modifiedCount=0}return e.prototype.MarkNextChange=function(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new Q.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=Number.MAX_VALUE,this.m_modifiedStart=Number.MAX_VALUE},e.prototype.AddOriginalElement=function(X,$){this.m_originalStart=Math.min(this.m_originalStart,X),this.m_modifiedStart=Math.min(this.m_modifiedStart,$),this.m_originalCount++},e.prototype.AddModifiedElement=function(X,$){this.m_originalStart=Math.min(this.m_originalStart,X),this.m_modifiedStart=Math.min(this.m_modifiedStart,$),this.m_modifiedCount++},e.prototype.getChanges=function(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes},e.prototype.getReverseChanges=function(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes},e}(),ne=function(){function e(X,$,Q){void 0===Q&&(Q=null),this.OriginalSequence=X,this.ModifiedSequence=$,this.ContinueProcessingPredicate=Q,this.m_forwardHistory=[],this.m_reverseHistory=[]}return e.prototype.ElementsAreEqual=function(X,$){return this.OriginalSequence.getElementAtIndex(X)===this.ModifiedSequence.getElementAtIndex($)},e.prototype.OriginalElementsAreEqual=function(X,$){return this.OriginalSequence.getElementAtIndex(X)===this.OriginalSequence.getElementAtIndex($)},e.prototype.ModifiedElementsAreEqual=function(X,$){return this.ModifiedSequence.getElementAtIndex(X)===this.ModifiedSequence.getElementAtIndex($)},e.prototype.ComputeDiff=function(X){return this._ComputeDiff(0,this.OriginalSequence.getLength()-1,0,this.ModifiedSequence.getLength()-1,X)},e.prototype._ComputeDiff=function(X,$,Q,J,ee){var te=this.ComputeDiffRecursive(X,$,Q,J,[!1]);return ee?this.PrettifyChanges(te):te},e.prototype.ComputeDiffRecursive=function(X,$,ee,te,ne){for(ne[0]=!1;X<=$&&ee<=te&&this.ElementsAreEqual(X,ee);)X++,ee++;for(;$>=X&&te>=ee&&this.ElementsAreEqual($,te);)$--,te--;if(X>$||ee>te){var ie=void 0;return ee<=te?(J.Assert(X===$+1,"originalStart should only be one more than originalEnd"),ie=[new Q.DiffChange(X,0,ee,te-ee+1)]):X<=$?(J.Assert(ee===te+1,"modifiedStart should only be one more than modifiedEnd"),ie=[new Q.DiffChange(X,$-X+1,ee,0)]):(J.Assert(X===$+1,"originalStart should only be one more than originalEnd"),J.Assert(ee===te+1,"modifiedStart should only be one more than modifiedEnd"),ie=[]),ie}var oe=[0],re=[0],se=this.ComputeRecursionPoint(X,$,ee,te,oe,re,ne),ae=oe[0],le=re[0];if(null!==se)return se;if(!ne[0]){var ue,de=this.ComputeDiffRecursive(X,ae,ee,le,ne);return ue=ne[0]?[new Q.DiffChange(ae+1,$-(ae+1)+1,le+1,te-(le+1)+1)]:this.ComputeDiffRecursive(ae+1,$,le+1,te,ne),this.ConcatenateChanges(de,ue)}return[new Q.DiffChange(X,$-X+1,ee,te-ee+1)]},e.prototype.WALKTRACE=function(X,$,J,ee,ne,ie,oe,re,se,ae,le,ue,de,ce,he,pe,fe,ge){var me,ve,_e=null,ye=new te,be=$,Ce=J,we=de[0]-pe[0]-ee,Se=Number.MIN_VALUE,Ee=this.m_forwardHistory.length-1;do{(me=we+X)===be||me<Ce&&se[me-1]<se[me+1]?(ce=(le=se[me+1])-we-ee,le<Se&&ye.MarkNextChange(),Se=le,ye.AddModifiedElement(le+1,ce),we=me+1-X):(ce=(le=se[me-1]+1)-we-ee,le<Se&&ye.MarkNextChange(),Se=le-1,ye.AddOriginalElement(le,ce+1),we=me-1-X),Ee>=0&&(X=(se=this.m_forwardHistory[Ee])[0],be=1,Ce=se.length-1)}while(--Ee>=-1);if(ve=ye.getReverseChanges(),ge[0]){var Le=de[0]+1,xe=pe[0]+1;if(null!==ve&&ve.length>0){var Ie=ve[ve.length-1];Le=Math.max(Le,Ie.getOriginalEnd()),xe=Math.max(xe,Ie.getModifiedEnd())}_e=[new Q.DiffChange(Le,ue-Le+1,xe,he-xe+1)]}else{ye=new te,be=ie,Ce=oe,we=de[0]-pe[0]-re,Se=Number.MAX_VALUE,Ee=fe?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{(me=we+ne)===be||me<Ce&&ae[me-1]>=ae[me+1]?(ce=(le=ae[me+1]-1)-we-re,le>Se&&ye.MarkNextChange(),Se=le+1,ye.AddOriginalElement(le+1,ce+1),we=me+1-ne):(ce=(le=ae[me-1])-we-re,le>Se&&ye.MarkNextChange(),Se=le,ye.AddModifiedElement(le+1,ce+1),we=me-1-ne),Ee>=0&&(ne=(ae=this.m_reverseHistory[Ee])[0],be=1,Ce=ae.length-1)}while(--Ee>=-1);_e=ye.getChanges()}return this.ConcatenateChanges(ve,_e)},e.prototype.ComputeRecursionPoint=function(X,$,J,te,ne,ie,oe){var re,se=0,ae=0,le=0,ue=0,de=0,ce=0;X--,J--,ne[0]=0,ie[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];var he,pe,fe=$-X+(te-J),ge=fe+1,me=new Array(ge),ve=new Array(ge),_e=te-J,ye=$-X,be=X-J,Ce=$-te,we=(ye-_e)%2==0;for(me[_e]=X,ve[ye]=$,oe[0]=!1,re=1;re<=fe/2+1;re++){var Se=0,Ee=0;for(le=this.ClipDiagonalBound(_e-re,re,_e,ge),ue=this.ClipDiagonalBound(_e+re,re,_e,ge),he=le;he<=ue;he+=2){for(ae=(se=he===le||he<ue&&me[he-1]<me[he+1]?me[he+1]:me[he-1]+1)-(he-_e)-be,pe=se;se<$&&ae<te&&this.ElementsAreEqual(se+1,ae+1);)se++,ae++;if(me[he]=se,se+ae>Se+Ee&&(Se=se,Ee=ae),!we&&Math.abs(he-ye)<=re-1&&se>=ve[he])return ne[0]=se,ie[0]=ae,pe<=ve[he]&&re<=1448?this.WALKTRACE(_e,le,ue,be,ye,de,ce,Ce,me,ve,se,$,ne,ae,te,ie,we,oe):null}var Le=(Se-X+(Ee-J)-re)/2;if(null!==this.ContinueProcessingPredicate&&!this.ContinueProcessingPredicate(Se,this.OriginalSequence,Le))return oe[0]=!0,ne[0]=Se,ie[0]=Ee,Le>0&&re<=1448?this.WALKTRACE(_e,le,ue,be,ye,de,ce,Ce,me,ve,se,$,ne,ae,te,ie,we,oe):(X++,J++,[new Q.DiffChange(X,$-X+1,J,te-J+1)]);for(de=this.ClipDiagonalBound(ye-re,re,ye,ge),ce=this.ClipDiagonalBound(ye+re,re,ye,ge),he=de;he<=ce;he+=2){for(ae=(se=he===de||he<ce&&ve[he-1]>=ve[he+1]?ve[he+1]-1:ve[he-1])-(he-ye)-Ce,pe=se;se>X&&ae>J&&this.ElementsAreEqual(se,ae);)se--,ae--;if(ve[he]=se,we&&Math.abs(he-_e)<=re&&se<=me[he])return ne[0]=se,ie[0]=ae,pe>=me[he]&&re<=1448?this.WALKTRACE(_e,le,ue,be,ye,de,ce,Ce,me,ve,se,$,ne,ae,te,ie,we,oe):null}if(re<=1447){var xe=new Array(ue-le+2);xe[0]=_e-le+1,ee.Copy(me,le,xe,1,ue-le+1),this.m_forwardHistory.push(xe),(xe=new Array(ce-de+2))[0]=ye-de+1,ee.Copy(ve,de,xe,1,ce-de+1),this.m_reverseHistory.push(xe)}}return this.WALKTRACE(_e,le,ue,be,ye,de,ce,Ce,me,ve,se,$,ne,ae,te,ie,we,oe)},e.prototype.PrettifyChanges=function(X){for(ie=0;ie<X.length;ie++){for(var $=X[ie],Q=ie<X.length-1?X[ie+1].originalStart:this.OriginalSequence.getLength(),J=ie<X.length-1?X[ie+1].modifiedStart:this.ModifiedSequence.getLength(),ee=$.originalLength>0,te=$.modifiedLength>0;$.originalStart+$.originalLength<Q&&$.modifiedStart+$.modifiedLength<J&&(!ee||this.OriginalElementsAreEqual($.originalStart,$.originalStart+$.originalLength))&&(!te||this.ModifiedElementsAreEqual($.modifiedStart,$.modifiedStart+$.modifiedLength));)$.originalStart++,$.modifiedStart++;var ne=[null];ie<X.length-1&&this.ChangesOverlap(X[ie],X[ie+1],ne)&&(X[ie]=ne[0],X.splice(ie+1,1),ie--)}for(var ie=X.length-1;ie>=0;ie--){$=X[ie],Q=0,J=0;if(ie>0){var oe=X[ie-1];oe.originalLength>0&&(Q=oe.originalStart+oe.originalLength),oe.modifiedLength>0&&(J=oe.modifiedStart+oe.modifiedLength)}ee=$.originalLength>0,te=$.modifiedLength>0;for(var re=0,se=this._boundaryScore($.originalStart,$.originalLength,$.modifiedStart,$.modifiedLength),ae=1;;ae++){var le=$.originalStart-ae,ue=$.modifiedStart-ae;if(le<Q||ue<J)break;if(ee&&!this.OriginalElementsAreEqual(le,le+$.originalLength))break;if(te&&!this.ModifiedElementsAreEqual(ue,ue+$.modifiedLength))break;var de=this._boundaryScore(le,$.originalLength,ue,$.modifiedLength);de>se&&(se=de,re=ae)}$.originalStart-=re,$.modifiedStart-=re}return X},e.prototype._OriginalIsBoundary=function(X){if(X<=0||X>=this.OriginalSequence.getLength()-1)return!0;var $=this.OriginalSequence.getElementAtIndex(X);return"string"==typeof $&&/^\s*$/.test($)},e.prototype._OriginalRegionIsBoundary=function(X,$){if(this._OriginalIsBoundary(X)||this._OriginalIsBoundary(X-1))return!0;if($>0){var Q=X+$;if(this._OriginalIsBoundary(Q-1)||this._OriginalIsBoundary(Q))return!0}return!1},e.prototype._ModifiedIsBoundary=function(X){if(X<=0||X>=this.ModifiedSequence.getLength()-1)return!0;var $=this.ModifiedSequence.getElementAtIndex(X);return"string"==typeof $&&/^\s*$/.test($)},e.prototype._ModifiedRegionIsBoundary=function(X,$){if(this._ModifiedIsBoundary(X)||this._ModifiedIsBoundary(X-1))return!0;if($>0){var Q=X+$;if(this._ModifiedIsBoundary(Q-1)||this._ModifiedIsBoundary(Q))return!0}return!1},e.prototype._boundaryScore=function(X,$,Q,J){return(this._OriginalRegionIsBoundary(X,$)?1:0)+(this._ModifiedRegionIsBoundary(Q,J)?1:0)},e.prototype.ConcatenateChanges=function(X,$){var Q=[];if(0===X.length||0===$.length)return $.length>0?$:X;if(this.ChangesOverlap(X[X.length-1],$[0],Q))return J=new Array(X.length+$.length-1),ee.Copy(X,0,J,0,X.length-1),J[X.length-1]=Q[0],ee.Copy($,1,J,X.length,$.length-1),J;var J=new Array(X.length+$.length);return ee.Copy(X,0,J,0,X.length),ee.Copy($,0,J,X.length,$.length),J},e.prototype.ChangesOverlap=function(X,$,ee){if(J.Assert(X.originalStart<=$.originalStart,"Left change is not less than or equal to right change"),J.Assert(X.modifiedStart<=$.modifiedStart,"Left change is not less than or equal to right change"),X.originalStart+X.originalLength>=$.originalStart||X.modifiedStart+X.modifiedLength>=$.modifiedStart){var te=X.originalStart,ne=X.originalLength,ie=X.modifiedStart,oe=X.modifiedLength;return X.originalStart+X.originalLength>=$.originalStart&&(ne=$.originalStart+$.originalLength-X.originalStart),X.modifiedStart+X.modifiedLength>=$.modifiedStart&&(oe=$.modifiedStart+$.modifiedLength-X.modifiedStart),ee[0]=new Q.DiffChange(te,ne,ie,oe),!0}return ee[0]=null,!1},e.prototype.ClipDiagonalBound=function(X,$,Q,J){if(X>=0&&X<J)return X;var ee=$%2==0;return X<0?ee===(Q%2==0)?0:1:ee===((J-Q-1)%2==0)?J-1:J-2},e}();$.LcsDiff=ne})),define(Q[414],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0}),$.once=function(X){var $,Q=this,J=!1;return function(){return J?$:(J=!0,$=X.apply(Q,arguments))}}})),define(Q[418],n([0,1]),(function(X,$){function i(X,$){return($<<5)-$+X|0}function o(X,$){$=i(149417,$);for(var Q=0,J=X.length;Q<J;Q++)$=i(X.charCodeAt(Q),$);return $}Object.defineProperty($,"__esModule",{value:!0}),$.hash=function n(X,$){switch(void 0===$&&($=0),typeof X){case"object":return null===X?i(349,$):Array.isArray(X)?function(X,$){return $=i(104579,$),X.reduce((function(X,$){return n($,X)}),$)}(X,$):function(X,$){return $=i(181387,$),Object.keys(X).sort().reduce((function($,Q){return $=o(Q,$),n(X[Q],$)}),$)}(X,$);case"string":return o(X,$);case"boolean":return function(X,$){return i(X?433:863,$)}(X,$);case"number":return i(X,$);case"undefined":return i(0,937);default:return i(0,617)}}})),define(Q[68],n([0,1,22]),(function(X,$,Q){function o(X){return X instanceof J||!(!X||"object"!=typeof X)&&"string"==typeof X.value&&("boolean"==typeof X.isTrusted||void 0===X.isTrusted)}function r(X,$){return X===$||!(!X||!$)&&X.value===$.value&&X.isTrusted===$.isTrusted}Object.defineProperty($,"__esModule",{value:!0});var J=function(){function e(X){void 0===X&&(X=""),this.value=X}return e.prototype.appendText=function(X){return this.value+=X.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&"),this},e.prototype.appendMarkdown=function(X){return this.value+=X,this},e.prototype.appendCodeblock=function(X,$){return this.value+="\n```",this.value+=X,this.value+="\n",this.value+=$,this.value+="\n```\n",this},e}();$.MarkdownString=J,$.isEmptyMarkdownString=function i(X){return o(X)?!X.value:!Array.isArray(X)||X.every(i)},$.isMarkdownString=o,$.markedStringsEquals=function(X,$){return!X&&!$||!(!X||!$)&&(Array.isArray(X)&&Array.isArray($)?Q.equals(X,$,r):!(!o(X)||!o($))&&r(X,$))},$.removeMarkdownEscapes=function(X){return X?X.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1"):X}})),define(Q[110],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q=function(){function e(X){this._prefix=X,this._lastId=0}return e.prototype.nextId=function(){return this._prefix+ ++this._lastId},e}();$.IdGenerator=Q,$.defaultGenerator=new Q("id#")}));var J,ee,te=this&&this.__extends||function(){var e=function(X,$){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(X,$){X.__proto__=$}||function(X,$){for(var Q in $)$.hasOwnProperty(Q)&&(X[Q]=$[Q])})(X,$)};return function(X,$){function i(){this.constructor=X}e(X,$),X.prototype=null===$?Object.create($):(i.prototype=$.prototype,new i)}}();define(Q[87],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0}),$.FIN={done:!0,value:void 0},function(X){function n(X,$){for(var Q=X.next();!Q.done;Q=X.next())$(Q.value)}var Q={next:function(){return $.FIN}};X.empty=function(){return Q},X.fromArray=function(X,Q,J){return void 0===Q&&(Q=0),void 0===J&&(J=X.length),{next:function(){return Q>=J?$.FIN:{done:!1,value:X[Q++]}}}},X.from=function($){return $?Array.isArray($)?X.fromArray($):$:X.empty()},X.map=function(X,Q){return{next:function(){var J=X.next();return J.done?$.FIN:{done:!1,value:Q(J.value)}}}},X.filter=function(X,Q){return{next:function(){for(;;){var J=X.next();if(J.done)return $.FIN;if(Q(J.value))return{done:!1,value:J.value}}}}},X.forEach=n,X.collect=function(X){var $=[];return n(X,(function(X){return $.push(X)})),$}}($.Iterator||($.Iterator={}));var Q=function(){function e(X,$,Q,J){void 0===$&&($=0),void 0===Q&&(Q=X.length),void 0===J&&(J=$-1),this.items=X,this.start=$,this.end=Q,this.index=J}return e.prototype.next=function(){return this.index=Math.min(this.index+1,this.end),this.current()},e.prototype.current=function(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]},e}();$.ArrayIterator=Q;var J=function(X){function t($,Q,J,ee){return void 0===Q&&(Q=0),void 0===J&&(J=$.length),void 0===ee&&(ee=Q-1),X.call(this,$,Q,J,ee)||this}return te(t,X),t.prototype.current=function(){return X.prototype.current.call(this)},t.prototype.previous=function(){return this.index=Math.max(this.index-1,this.start-1),this.current()},t.prototype.first=function(){return this.index=this.start,this.current()},t.prototype.last=function(){return this.index=this.end-1,this.current()},t.prototype.parent=function(){return null},t}(Q);$.ArrayNavigator=J;var ee=function(){function e(X,$){this.iterator=X,this.fn=$}return e.prototype.next=function(){return this.fn(this.iterator.next())},e}();$.MappedIterator=ee})),define(Q[441],n([0,1,87]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(){function e(X,$){void 0===X&&(X=[]),void 0===$&&($=10),this._initialize(X),this._limit=$,this._onChange()}return e.prototype.add=function(X){this._history.delete(X),this._history.add(X),this._onChange()},e.prototype.next=function(){return this._navigator.next()},e.prototype.previous=function(){return this._navigator.previous()},e.prototype.current=function(){return this._navigator.current()},e.prototype.parent=function(){return null},e.prototype.first=function(){return this._navigator.first()},e.prototype.last=function(){return this._navigator.last()},e.prototype.has=function(X){return this._history.has(X)},e.prototype._onChange=function(){this._reduceToLimit(),this._navigator=new Q.ArrayNavigator(this._elements,0,this._elements.length,this._elements.length)},e.prototype._reduceToLimit=function(){var X=this._elements;X.length>this._limit&&this._initialize(X.slice(X.length-this._limit))},e.prototype._initialize=function(X){this._history=new Set;for(var $=0,Q=X;$<Q.length;$++){var J=Q[$];this._history.add(J)}},Object.defineProperty(e.prototype,"_elements",{get:function(){var X=[];return this._history.forEach((function($){return X.push($)})),X},enumerable:!0,configurable:!0}),e}();$.HistoryNavigator=J})),define(Q[36],n([0,1]),(function(X,$){function n(X,$){var Q=!!(2048&X),J=!!(256&X);return new ne(2===$?J:Q,!!(1024&X),!!(512&X),2===$?Q:J,255&X)}Object.defineProperty($,"__esModule",{value:!0});var Q=function(){function e(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}return e.prototype.define=function(X,$){this._keyCodeToStr[X]=$,this._strToKeyCode[$.toLowerCase()]=X},e.prototype.keyCodeToStr=function(X){return this._keyCodeToStr[X]},e.prototype.strToKeyCode=function(X){return this._strToKeyCode[X.toLowerCase()]||0},e}(),J=new Q,ee=new Q,te=new Q;!function(){function e(X,$,Q,ne){void 0===Q&&(Q=$),void 0===ne&&(ne=Q),J.define(X,$),ee.define(X,Q),te.define(X,ne)}e(0,"unknown"),e(1,"Backspace"),e(2,"Tab"),e(3,"Enter"),e(4,"Shift"),e(5,"Ctrl"),e(6,"Alt"),e(7,"PauseBreak"),e(8,"CapsLock"),e(9,"Escape"),e(10,"Space"),e(11,"PageUp"),e(12,"PageDown"),e(13,"End"),e(14,"Home"),e(15,"LeftArrow","Left"),e(16,"UpArrow","Up"),e(17,"RightArrow","Right"),e(18,"DownArrow","Down"),e(19,"Insert"),e(20,"Delete"),e(21,"0"),e(22,"1"),e(23,"2"),e(24,"3"),e(25,"4"),e(26,"5"),e(27,"6"),e(28,"7"),e(29,"8"),e(30,"9"),e(31,"A"),e(32,"B"),e(33,"C"),e(34,"D"),e(35,"E"),e(36,"F"),e(37,"G"),e(38,"H"),e(39,"I"),e(40,"J"),e(41,"K"),e(42,"L"),e(43,"M"),e(44,"N"),e(45,"O"),e(46,"P"),e(47,"Q"),e(48,"R"),e(49,"S"),e(50,"T"),e(51,"U"),e(52,"V"),e(53,"W"),e(54,"X"),e(55,"Y"),e(56,"Z"),e(57,"Meta"),e(58,"ContextMenu"),e(59,"F1"),e(60,"F2"),e(61,"F3"),e(62,"F4"),e(63,"F5"),e(64,"F6"),e(65,"F7"),e(66,"F8"),e(67,"F9"),e(68,"F10"),e(69,"F11"),e(70,"F12"),e(71,"F13"),e(72,"F14"),e(73,"F15"),e(74,"F16"),e(75,"F17"),e(76,"F18"),e(77,"F19"),e(78,"NumLock"),e(79,"ScrollLock"),e(80,";",";","OEM_1"),e(81,"=","=","OEM_PLUS"),e(82,",",",","OEM_COMMA"),e(83,"-","-","OEM_MINUS"),e(84,".",".","OEM_PERIOD"),e(85,"/","/","OEM_2"),e(86,"`","`","OEM_3"),e(110,"ABNT_C1"),e(111,"ABNT_C2"),e(87,"[","[","OEM_4"),e(88,"\\","\\","OEM_5"),e(89,"]","]","OEM_6"),e(90,"'","'","OEM_7"),e(91,"OEM_8"),e(92,"OEM_102"),e(93,"NumPad0"),e(94,"NumPad1"),e(95,"NumPad2"),e(96,"NumPad3"),e(97,"NumPad4"),e(98,"NumPad5"),e(99,"NumPad6"),e(100,"NumPad7"),e(101,"NumPad8"),e(102,"NumPad9"),e(103,"NumPad_Multiply"),e(104,"NumPad_Add"),e(105,"NumPad_Separator"),e(106,"NumPad_Subtract"),e(107,"NumPad_Decimal"),e(108,"NumPad_Divide")}(),function(X){X.toString=function(X){return J.keyCodeToStr(X)},X.fromString=function(X){return J.strToKeyCode(X)},X.toUserSettingsUS=function(X){return ee.keyCodeToStr(X)},X.toUserSettingsGeneral=function(X){return te.keyCodeToStr(X)},X.fromUserSettings=function(X){return ee.strToKeyCode(X)||te.strToKeyCode(X)}}($.KeyCodeUtils||($.KeyCodeUtils={})),$.KeyChord=function(X,$){return(X|(65535&$)<<16>>>0)>>>0},$.createKeybinding=function(X,$){if(0===X)return null;var Q=(65535&X)>>>0,J=(4294901760&X)>>>16;return 0!==J?new l(n(Q,$),n(J,$)):n(Q,$)},$.createSimpleKeybinding=n;var ne=function(){function e(X,$,Q,J,ee){this.type=1,this.ctrlKey=X,this.shiftKey=$,this.altKey=Q,this.metaKey=J,this.keyCode=ee}return e.prototype.equals=function(X){return 1===X.type&&this.ctrlKey===X.ctrlKey&&this.shiftKey===X.shiftKey&&this.altKey===X.altKey&&this.metaKey===X.metaKey&&this.keyCode===X.keyCode},e.prototype.isModifierKey=function(){return 0===this.keyCode||5===this.keyCode||57===this.keyCode||6===this.keyCode||4===this.keyCode},e.prototype.isDuplicateModifierCase=function(){return this.ctrlKey&&5===this.keyCode||this.shiftKey&&4===this.keyCode||this.altKey&&6===this.keyCode||this.metaKey&&57===this.keyCode},e}();$.SimpleKeybinding=ne;var l=function(X,$){this.type=2,this.firstPart=X,this.chordPart=$};$.ChordKeybinding=l;var u=function(X,$,Q,J,ee,te){this.ctrlKey=X,this.shiftKey=$,this.altKey=Q,this.metaKey=J,this.keyLabel=ee,this.keyAriaLabel=te};$.ResolvedKeybindingPart=u;var d=function(){};$.ResolvedKeybinding=d})),define(Q[2],n([0,1]),(function(X,$){function n(X){for(var $=[],Q=1;Q<arguments.length;Q++)$[Q-1]=arguments[Q];return Array.isArray(X)?(X.forEach((function(X){return X&&X.dispose()})),[]):0!==$.length?(n(X),n($),[]):X?(X.dispose(),X):void 0}Object.defineProperty($,"__esModule",{value:!0}),$.isDisposable=function(X){return"function"==typeof X.dispose&&0===X.dispose.length},$.dispose=n,$.combinedDisposable=function(X){return{dispose:function(){return n(X)}}},$.toDisposable=function(X){return{dispose:function(){X()}}};var Q=function(){function e(){this._toDispose=[]}return e.prototype.dispose=function(){this._toDispose=n(this._toDispose)},e.prototype._register=function(X){return this._toDispose.push(X),X},e.None=Object.freeze({dispose:function(){}}),e}();$.Disposable=Q;var J=function(){function e(X){this.object=X}return e.prototype.dispose=function(){},e}();$.ImmortalReference=J})),define(Q[160],n([0,1,87]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var i=function(X){this.element=X},J=function(){function e(){}return e.prototype.isEmpty=function(){return!this._first},e.prototype.unshift=function(X){return this.insert(X,!1)},e.prototype.push=function(X){return this.insert(X,!0)},e.prototype.insert=function(X,$){var Q=this,J=new i(X);if(this._first)if($){var ee=this._last;this._last=J,J.prev=ee,ee.next=J}else{var te=this._first;this._first=J,J.next=te,te.prev=J}else this._first=J,this._last=J;return function(){for(var X=Q._first;X instanceof i;){if(X===J){if(X.prev&&X.next){var $=X.prev;$.next=X.next,X.next.prev=$}else X.prev||X.next?X.next?X.prev||(Q._first=Q._first.next,Q._first.prev=void 0):(Q._last=Q._last.prev,Q._last.next=void 0):(Q._first=void 0,Q._last=void 0);break}X=X.next}}},e.prototype.iterator=function(){var X,$=this._first;return{next:function(){return $?(X?X.value=$.element:X={done:!1,value:$.element},$=$.next,X):Q.FIN}}},e}();$.LinkedList=J})),define(Q[65],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0}),$.values=function(X){var $=[];return X.forEach((function(X){return $.push(X)})),$},$.keys=function(X){var $=[];return X.forEach((function(X,Q){return $.push(Q)})),$};var Q=function(){function e(){this._value="",this._pos=0}return e.prototype.reset=function(X){return this._value=X,this._pos=0,this},e.prototype.next=function(){return this._pos+=1,this},e.prototype.hasNext=function(){return this._pos<this._value.length-1},e.prototype.cmp=function(X){return X.charCodeAt(0)-this._value.charCodeAt(this._pos)},e.prototype.value=function(){return this._value[this._pos]},e}();$.StringIterator=Q;var J=function(){function e(){}return e.prototype.reset=function(X){return this._value=X.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()},e.prototype.hasNext=function(){return this._to<this._value.length},e.prototype.next=function(){this._from=this._to;for(var X=!0;this._to<this._value.length;this._to++){var $=this._value.charCodeAt(this._to);if(47===$||92===$){if(!X)break;this._from++}else X=!1}return this},e.prototype.cmp=function(X){for(var $=0,Q=X.length,J=this._from;$<Q&&J<this._to;){var ee=X.charCodeAt($)-this._value.charCodeAt(J);if(0!==ee)return ee;$+=1,J+=1}return Q===this._to-this._from?0:$<Q?-1:1},e.prototype.value=function(){return this._value.substring(this._from,this._to)},e}();$.PathIterator=J;var r=function(){},ee=function(){function e(X){this._iter=X}return e.forPaths=function(){return new e(new J)},e.forStrings=function(){return new e(new Q)},e.prototype.clear=function(){this._root=void 0},e.prototype.set=function(X,$){var Q,J=this._iter.reset(X);for(this._root||(this._root=new r,this._root.segment=J.value()),Q=this._root;;){var ee=J.cmp(Q.segment);if(ee>0)Q.left||(Q.left=new r,Q.left.segment=J.value()),Q=Q.left;else if(ee<0)Q.right||(Q.right=new r,Q.right.segment=J.value()),Q=Q.right;else{if(!J.hasNext())break;J.next(),Q.mid||(Q.mid=new r,Q.mid.segment=J.value()),Q=Q.mid}}var te=Q.value;return Q.value=$,Q.key=X,te},e.prototype.get=function(X){for(var $=this._iter.reset(X),Q=this._root;Q;){var J=$.cmp(Q.segment);if(J>0)Q=Q.left;else if(J<0)Q=Q.right;else{if(!$.hasNext())break;$.next(),Q=Q.mid}}return Q?Q.value:void 0},e.prototype.findSubstr=function(X){for(var $=this._iter.reset(X),Q=this._root,J=void 0;Q;){var ee=$.cmp(Q.segment);if(ee>0)Q=Q.left;else if(ee<0)Q=Q.right;else{if(!$.hasNext())break;$.next(),J=Q.value||J,Q=Q.mid}}return Q&&Q.value||J},e.prototype.forEach=function(X){this._forEach(this._root,X)},e.prototype._forEach=function(X,$){X&&(this._forEach(X.left,$),X.value&&$(X.value,X.key),this._forEach(X.mid,$),this._forEach(X.right,$))},e}();$.TernarySearchTree=ee;var ne=function(){function e(){this.map=new Map,this.ignoreCase=!1}return e.prototype.set=function(X,$){this.map.set(this.toKey(X),$)},e.prototype.get=function(X){return this.map.get(this.toKey(X))},e.prototype.toKey=function(X){var $=X.toString();return this.ignoreCase&&($=$.toLowerCase()),$},e}();$.ResourceMap=ne;var ie=function(){function e(){this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0}return e.prototype.clear=function(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0},Object.defineProperty(e.prototype,"size",{get:function(){return this._size},enumerable:!0,configurable:!0}),e.prototype.get=function(X,$){void 0===$&&($=0);var Q=this._map.get(X);if(Q)return 0!==$&&this.touch(Q,$),Q.value},e.prototype.set=function(X,$,Q){void 0===Q&&(Q=0);var J=this._map.get(X);if(J)J.value=$,0!==Q&&this.touch(J,Q);else{switch(J={key:X,value:$,next:void 0,previous:void 0},Q){case 0:this.addItemLast(J);break;case 1:this.addItemFirst(J);break;case 2:default:this.addItemLast(J)}this._map.set(X,J),this._size++}},e.prototype.forEach=function(X,$){for(var Q=this._head;Q;)$?X.bind($)(Q.value,Q.key,this):X(Q.value,Q.key,this),Q=Q.next},e.prototype.trimOld=function(X){if(!(X>=this.size))if(0!==X){for(var $=this._head,Q=this.size;$&&Q>X;)this._map.delete($.key),$=$.next,Q--;this._head=$,this._size=Q,$&&($.previous=void 0)}else this.clear()},e.prototype.addItemFirst=function(X){if(this._head||this._tail){if(!this._head)throw new Error("Invalid list");X.next=this._head,this._head.previous=X}else this._tail=X;this._head=X},e.prototype.addItemLast=function(X){if(this._head||this._tail){if(!this._tail)throw new Error("Invalid list");X.previous=this._tail,this._tail.next=X}else this._head=X;this._tail=X},e.prototype.touch=function(X,$){if(!this._head||!this._tail)throw new Error("Invalid list");if(1===$||2===$)if(1===$){if(X===this._head)return;var Q=X.next,J=X.previous;X===this._tail?(J.next=void 0,this._tail=J):(Q.previous=J,J.next=Q),X.previous=void 0,X.next=this._head,this._head.previous=X,this._head=X}else if(2===$){if(X===this._tail)return;Q=X.next,J=X.previous;X===this._head?(Q.previous=void 0,this._head=Q):(Q.previous=J,J.next=Q),X.next=void 0,X.previous=this._tail,this._tail.next=X,this._tail=X}},e.prototype.toJSON=function(){var X=[];return this.forEach((function($,Q){X.push([Q,$])})),X},e}();$.LinkedMap=ie;var oe=function(X){function t($,Q){void 0===Q&&(Q=1);var J=X.call(this)||this;return J._limit=$,J._ratio=Math.min(Math.max(0,Q),1),J}return te(t,X),t.prototype.get=function($){return X.prototype.get.call(this,$,2)},t.prototype.set=function($,Q){X.prototype.set.call(this,$,Q,2),this.checkTrim()},t.prototype.checkTrim=function(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))},t}(ie);$.LRUCache=oe})),function(X){function t(X){this.tokens=[],this.tokens.links=Object.create(null),this.options=X||g.defaults,this.rules=$.normal,this.options.pedantic?this.rules=$.pedantic:this.options.gfm&&(this.options.tables?this.rules=$.tables:this.rules=$.gfm)}function n(X,$){if(this.options=$||g.defaults,this.links=X,this.rules=Q.normal,this.renderer=this.options.renderer||new i,this.renderer.options=this.options,!this.links)throw new Error("Tokens array requires a `links` property.");this.options.pedantic?this.rules=Q.pedantic:this.options.gfm&&(this.options.breaks?this.rules=Q.breaks:this.rules=Q.gfm)}function i(X){this.options=X||g.defaults}function o(){}function s(X){this.tokens=[],this.token=null,this.options=X||g.defaults,this.options.renderer=this.options.renderer||new i,this.renderer=this.options.renderer,this.renderer.options=this.options}function a(X,$){return X.replace($?/&/g:/&(?!#?\w+;)/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;")}function l(X){return X.replace(/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/gi,(function(X,$){return"colon"===($=$.toLowerCase())?":":"#"===$.charAt(0)?"x"===$.charAt(1)?String.fromCharCode(parseInt($.substring(2),16)):String.fromCharCode(+$.substring(1)):""}))}function u(X,$){return X=X.source||X,$=$||"",{replace:function($,Q){return Q=(Q=Q.source||Q).replace(/(^|[^\[])\^/g,"$1"),X=X.replace($,Q),this},getRegex:function(){return new RegExp(X,$)}}}function d(X,$){return ee[" "+X]||(/^[^:]+:\/*[^/]*$/.test(X)?ee[" "+X]=X+"/":ee[" "+X]=f(X,"/",!0)),X=ee[" "+X],"//"===$.slice(0,2)?X.replace(/:[\s\S]*/,":")+$:"/"===$.charAt(0)?X.replace(/(:\/*[^/]*)[\s\S]*/,"$1")+$:X+$}function c(){}function h(X){for(var $,Q,J=1;J<arguments.length;J++)for(Q in $=arguments[J])Object.prototype.hasOwnProperty.call($,Q)&&(X[Q]=$[Q]);return X}function p(X,$){var Q=X.replace(/\|/g,(function(X,$,Q){for(var J=!1,ee=$;--ee>=0&&"\\"===Q[ee];)J=!J;return J?"|":" |"})).split(/ \|/),J=0;if(Q.length>$)Q.splice($);else for(;Q.length<$;)Q.push("");for(;J<Q.length;J++)Q[J]=Q[J].trim().replace(/\\\|/g,"|");return Q}function f(X,$,Q){if(0===X.length)return"";for(var J=0;J<X.length;){var ee=X.charAt(X.length-J-1);if(ee!==$||Q){if(ee===$||!Q)break;J++}else J++}return X.substr(0,X.length-J)}function g(X,$,Q){if(null==X)throw new Error("marked(): input parameter is undefined or null");if("string"!=typeof X)throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(X)+", string expected");if(Q||"function"==typeof $){Q||(Q=$,$=null);var J,ee,te=($=h({},g.defaults,$||{})).highlight,ne=0;try{J=t.lex(X,$)}catch(X){return Q(X)}ee=J.length;var d=function(X){if(X)return $.highlight=te,Q(X);var ee;try{ee=s.parse(J,$)}catch(ee){X=ee}return $.highlight=te,X?Q(X):Q(null,ee)};if(!te||te.length<3)return d();if(delete $.highlight,!ee)return d();for(;ne<J.length;ne++)!function(X){"code"!==X.type?--ee||d():te(X.text,X.lang,(function($,Q){return $?d($):null==Q||Q===X.text?--ee||d():(X.text=Q,X.escaped=!0,void(--ee||d()))}))}(J[ne])}else try{return $&&($=h({},g.defaults,$)),s.parse(t.lex(X,$),$)}catch(X){if(X.message+="\nPlease report this to https://github.com/markedjs/marked.",($||g.defaults).silent)return"<p>An error occurred:</p><pre>"+a(X.message+"",!0)+"</pre>";throw X}}var $={newline:/^\n+/,code:/^( {4}[^\n]+\n*)+/,fences:c,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ *(#{1,6}) *([^\n]+?) *(?:#+ *)?(?:\n+|$)/,nptable:c,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( *)(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?!\1bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?\\?>\\n*|<![A-Z][\\s\\S]*?>\\n*|<!\\[CDATA\\[[\\s\\S]*?\\]\\]>\\n*|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=\\h*\\n)[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=\\h*\\n)[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:c,lheading:/^([^\n]+)\n *(=|-){2,} *(?:\n+|$)/,paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading| {0,3}>|<\/?(?:tag)(?: +|\n|\/?>)|<(?:script|pre|style|!--))[^\n]+)*)/,text:/^[^\n]+/,_label:/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,_title:/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/};$.def=u($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d+\.)/,$.item=/^( *)(bull) [^\n]*(?:\n(?!\1bull )[^\n]*)*/,$.item=u($.item,"gm").replace(/bull/g,$.bullet).getRegex(),$.list=u($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?-->/,$.html=u($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=u($.paragraph).replace("hr",$.hr).replace("heading",$.heading).replace("lheading",$.lheading).replace("tag",$._tag).getRegex(),$.blockquote=u($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=h({},$),$.gfm=h({},$.normal,{fences:/^ *(`{3,}|~{3,})[ \.]*(\S+)? *\n([\s\S]*?)\n? *\1 *(?:\n+|$)/,paragraph:/^/,heading:/^ *(#{1,6}) +([^\n]+?) *#* *(?:\n+|$)/}),$.gfm.paragraph=u($.paragraph).replace("(?!","(?!"+$.gfm.fences.source.replace("\\1","\\2")+"|"+$.list.source.replace("\\1","\\3")+"|").getRegex(),$.tables=h({},$.gfm,{nptable:/^ *([^|\n ].*\|.*)\n *([-:]+ *\|[-| :]*)(?:\n((?:.*[^>\n ].*(?:\n|$))*)\n*|$)/,table:/^ *\|(.+)\n *\|?( *[-:]+[-| :]*)(?:\n((?: *[^>\n ].*(?:\n|$))*)\n*|$)/}),$.pedantic=h({},$.normal,{html:u("^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:\"[^\"]*\"|'[^']*'|\\s[^'\"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))").replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/}),t.rules=$,t.lex=function(X,$){return new t($).lex(X)},t.prototype.lex=function(X){return X=X.replace(/\r\n|\r/g,"\n").replace(/\t/g,"    ").replace(/\u00a0/g," ").replace(/\u2424/g,"\n"),this.token(X,!0)},t.prototype.token=function(X,Q){X=X.replace(/^ +$/gm,"");for(var J,ee,te,ne,ie,oe,re,se,ae,le,ue,de,ce,he,pe,fe;X;)if((te=this.rules.newline.exec(X))&&(X=X.substring(te[0].length),te[0].length>1&&this.tokens.push({type:"space"})),te=this.rules.code.exec(X))X=X.substring(te[0].length),te=te[0].replace(/^ {4}/gm,""),this.tokens.push({type:"code",text:this.options.pedantic?te:f(te,"\n")});else if(te=this.rules.fences.exec(X))X=X.substring(te[0].length),this.tokens.push({type:"code",lang:te[2],text:te[3]||""});else if(te=this.rules.heading.exec(X))X=X.substring(te[0].length),this.tokens.push({type:"heading",depth:te[1].length,text:te[2]});else if(Q&&(te=this.rules.nptable.exec(X))&&(oe={type:"table",header:p(te[1].replace(/^ *| *\| *$/g,"")),align:te[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:te[3]?te[3].replace(/\n$/,"").split("\n"):[]}).header.length===oe.align.length){for(X=X.substring(te[0].length),ue=0;ue<oe.align.length;ue++)/^ *-+: *$/.test(oe.align[ue])?oe.align[ue]="right":/^ *:-+: *$/.test(oe.align[ue])?oe.align[ue]="center":/^ *:-+ *$/.test(oe.align[ue])?oe.align[ue]="left":oe.align[ue]=null;for(ue=0;ue<oe.cells.length;ue++)oe.cells[ue]=p(oe.cells[ue],oe.header.length);this.tokens.push(oe)}else if(te=this.rules.hr.exec(X))X=X.substring(te[0].length),this.tokens.push({type:"hr"});else if(te=this.rules.blockquote.exec(X))X=X.substring(te[0].length),this.tokens.push({type:"blockquote_start"}),te=te[0].replace(/^ *> ?/gm,""),this.token(te,Q),this.tokens.push({type:"blockquote_end"});else if(te=this.rules.list.exec(X)){for(X=X.substring(te[0].length),re={type:"list_start",ordered:he=(ne=te[2]).length>1,start:he?+ne:"",loose:!1},this.tokens.push(re),se=[],J=!1,ce=(te=te[0].match(this.rules.item)).length,ue=0;ue<ce;ue++)le=(oe=te[ue]).length,~(oe=oe.replace(/^ *([*+-]|\d+\.) +/,"")).indexOf("\n ")&&(le-=oe.length,oe=this.options.pedantic?oe.replace(/^ {1,4}/gm,""):oe.replace(new RegExp("^ {1,"+le+"}","gm"),"")),this.options.smartLists&&ue!==ce-1&&(ne===(ie=$.bullet.exec(te[ue+1])[0])||ne.length>1&&ie.length>1||(X=te.slice(ue+1).join("\n")+X,ue=ce-1)),ee=J||/\n\n(?!\s*$)/.test(oe),ue!==ce-1&&(J="\n"===oe.charAt(oe.length-1),ee||(ee=J)),ee&&(re.loose=!0),fe=void 0,(pe=/^\[[ xX]\] /.test(oe))&&(fe=" "!==oe[1],oe=oe.replace(/^\[[ xX]\] +/,"")),ae={type:"list_item_start",task:pe,checked:fe,loose:ee},se.push(ae),this.tokens.push(ae),this.token(oe,!1),this.tokens.push({type:"list_item_end"});if(re.loose)for(ce=se.length,ue=0;ue<ce;ue++)se[ue].loose=!0;this.tokens.push({type:"list_end"})}else if(te=this.rules.html.exec(X))X=X.substring(te[0].length),this.tokens.push({type:this.options.sanitize?"paragraph":"html",pre:!this.options.sanitizer&&("pre"===te[1]||"script"===te[1]||"style"===te[1]),text:te[0]});else if(Q&&(te=this.rules.def.exec(X)))X=X.substring(te[0].length),te[3]&&(te[3]=te[3].substring(1,te[3].length-1)),de=te[1].toLowerCase().replace(/\s+/g," "),this.tokens.links[de]||(this.tokens.links[de]={href:te[2],title:te[3]});else if(Q&&(te=this.rules.table.exec(X))&&(oe={type:"table",header:p(te[1].replace(/^ *| *\| *$/g,"")),align:te[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:te[3]?te[3].replace(/(?: *\| *)?\n$/,"").split("\n"):[]}).header.length===oe.align.length){for(X=X.substring(te[0].length),ue=0;ue<oe.align.length;ue++)/^ *-+: *$/.test(oe.align[ue])?oe.align[ue]="right":/^ *:-+: *$/.test(oe.align[ue])?oe.align[ue]="center":/^ *:-+ *$/.test(oe.align[ue])?oe.align[ue]="left":oe.align[ue]=null;for(ue=0;ue<oe.cells.length;ue++)oe.cells[ue]=p(oe.cells[ue].replace(/^ *\| *| *\| *$/g,""),oe.header.length);this.tokens.push(oe)}else if(te=this.rules.lheading.exec(X))X=X.substring(te[0].length),this.tokens.push({type:"heading",depth:"="===te[2]?1:2,text:te[1]});else if(Q&&(te=this.rules.paragraph.exec(X)))X=X.substring(te[0].length),this.tokens.push({type:"paragraph",text:"\n"===te[1].charAt(te[1].length-1)?te[1].slice(0,-1):te[1]});else if(te=this.rules.text.exec(X))X=X.substring(te[0].length),this.tokens.push({type:"text",text:te[0]});else if(X)throw new Error("Infinite loop on byte: "+X.charCodeAt(0));return this.tokens};var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:c,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(href(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,strong:/^__([^\s])__(?!_)|^\*\*([^\s])\*\*(?!\*)|^__([^\s][\s\S]*?[^\s])__(?!_)|^\*\*([^\s][\s\S]*?[^\s])\*\*(?!\*)/,em:/^_([^\s_])_(?!_)|^\*([^\s*"<\[])\*(?!\*)|^_([^\s][\s\S]*?[^\s_])_(?!_)|^_([^\s_][\s\S]*?[^\s])_(?!_)|^\*([^\s"<\[][\s\S]*?[^\s*])\*(?!\*)|^\*([^\s*"<\[][\s\S]*?[^\s])\*(?!\*)/,code:/^(`+)\s*([\s\S]*?[^`]?)\s*\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:c,text:/^[\s\S]+?(?=[\\<!\[`*]|\b_| {2,}\n|$)/,_escapes:/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,_scheme:/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,_email:/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/};Q.autolink=u(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=u(Q.tag).replace("comment",$._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[[^\[\]]*\]|\\[\[\]]?|`[^`]*`|[^\[\]\\])*?/,Q._href=/\s*(<(?:\\[<>]?|[^\s<>\\])*>|(?:\\[()]?|\([^\s\x00-\x1f\\]*\)|[^\s\x00-\x1f()\\])*?)/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=u(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=u(Q.reflink).replace("label",Q._label).getRegex(),Q.normal=h({},Q),Q.pedantic=h({},Q.normal,{strong:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,em:/^_(?=\S)([\s\S]*?\S)_(?!_)|^\*(?=\S)([\s\S]*?\S)\*(?!\*)/,link:u(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:u(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=h({},Q.normal,{escape:u(Q.escape).replace("])","~|])").getRegex(),url:u(/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/).replace("email",Q._email).getRegex(),_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^~+(?=\S)([\s\S]*?\S)~+/,text:u(Q.text).replace("]|","~]|").replace("|","|https?://|ftp://|www\\.|[a-zA-Z0-9.!#$%&'*+/=?^_`{\\|}~-]+@|").getRegex()}),Q.breaks=h({},Q.gfm,{br:u(Q.br).replace("{2,}","*").getRegex(),text:u(Q.gfm.text).replace("{2,}","*").getRegex()}),n.rules=Q,n.output=function(X,$,Q){return new n($,Q).output(X)},n.prototype.output=function(X){for(var $,Q,J,ee,te,ne,ie="";X;)if(te=this.rules.escape.exec(X))X=X.substring(te[0].length),ie+=te[1];else if(te=this.rules.autolink.exec(X))X=X.substring(te[0].length),J="@"===te[2]?"mailto:"+(Q=a(this.mangle(te[1]))):Q=a(te[1]),ie+=this.renderer.link(J,null,Q);else if(this.inLink||!(te=this.rules.url.exec(X))){if(te=this.rules.tag.exec(X))!this.inLink&&/^<a /i.test(te[0])?this.inLink=!0:this.inLink&&/^<\/a>/i.test(te[0])&&(this.inLink=!1),X=X.substring(te[0].length),ie+=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):a(te[0]):te[0];else if(te=this.rules.link.exec(X))X=X.substring(te[0].length),this.inLink=!0,J=te[2],this.options.pedantic?($=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(J))?(J=$[1],ee=$[3]):ee="":ee=te[3]?te[3].slice(1,-1):"",J=J.trim().replace(/^<([\s\S]*)>$/,"$1"),ie+=this.outputLink(te,{href:n.escapes(J),title:n.escapes(ee)}),this.inLink=!1;else if((te=this.rules.reflink.exec(X))||(te=this.rules.nolink.exec(X))){if(X=X.substring(te[0].length),$=(te[2]||te[1]).replace(/\s+/g," "),!($=this.links[$.toLowerCase()])||!$.href){ie+=te[0].charAt(0),X=te[0].substring(1)+X;continue}this.inLink=!0,ie+=this.outputLink(te,$),this.inLink=!1}else if(te=this.rules.strong.exec(X))X=X.substring(te[0].length),ie+=this.renderer.strong(this.output(te[4]||te[3]||te[2]||te[1]));else if(te=this.rules.em.exec(X))X=X.substring(te[0].length),ie+=this.renderer.em(this.output(te[6]||te[5]||te[4]||te[3]||te[2]||te[1]));else if(te=this.rules.code.exec(X))X=X.substring(te[0].length),ie+=this.renderer.codespan(a(te[2].trim(),!0));else if(te=this.rules.br.exec(X))X=X.substring(te[0].length),ie+=this.renderer.br();else if(te=this.rules.del.exec(X))X=X.substring(te[0].length),ie+=this.renderer.del(this.output(te[1]));else if(te=this.rules.text.exec(X))X=X.substring(te[0].length),ie+=this.renderer.text(a(this.smartypants(te[0])));else if(X)throw new Error("Infinite loop on byte: "+X.charCodeAt(0))}else{do{ne=te[0],te[0]=this.rules._backpedal.exec(te[0])[0]}while(ne!==te[0]);X=X.substring(te[0].length),"@"===te[2]?J="mailto:"+(Q=a(te[0])):(Q=a(te[0]),J="www."===te[1]?"http://"+Q:Q),ie+=this.renderer.link(J,null,Q)}return ie},n.escapes=function(X){return X?X.replace(n.rules._escapes,"$1"):X},n.prototype.outputLink=function(X,$){var Q=$.href,J=$.title?a($.title):null;return"!"!==X[0].charAt(0)?this.renderer.link(Q,J,this.output(X[1])):this.renderer.image(Q,J,a(X[1]))},n.prototype.smartypants=function(X){return this.options.smartypants?X.replace(/---/g,"—").replace(/--/g,"–").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1‘").replace(/'/g,"’").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1“").replace(/"/g,"”").replace(/\.{3}/g,"…"):X},n.prototype.mangle=function(X){if(!this.options.mangle)return X;for(var $,Q="",J=X.length,ee=0;ee<J;ee++)$=X.charCodeAt(ee),Math.random()>.5&&($="x"+$.toString(16)),Q+="&#"+$+";";return Q},i.prototype.code=function(X,$,Q){if(this.options.highlight){var J=this.options.highlight(X,$);null!=J&&J!==X&&(Q=!0,X=J)}return $?'<pre><code class="'+this.options.langPrefix+a($,!0)+'">'+(Q?X:a(X,!0))+"</code></pre>\n":"<pre><code>"+(Q?X:a(X,!0))+"</code></pre>"},i.prototype.blockquote=function(X){return"<blockquote>\n"+X+"</blockquote>\n"},i.prototype.html=function(X){return X},i.prototype.heading=function(X,$,Q){return this.options.headerIds?"<h"+$+' id="'+this.options.headerPrefix+Q.toLowerCase().replace(/[^\w]+/g,"-")+'">'+X+"</h"+$+">\n":"<h"+$+">"+X+"</h"+$+">\n"},i.prototype.hr=function(){return this.options.xhtml?"<hr/>\n":"<hr>\n"},i.prototype.list=function(X,$,Q){var J=$?"ol":"ul";return"<"+J+($&&1!==Q?' start="'+Q+'"':"")+">\n"+X+"</"+J+">\n"},i.prototype.listitem=function(X){return"<li>"+X+"</li>\n"},i.prototype.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},i.prototype.paragraph=function(X){return"<p>"+X+"</p>\n"},i.prototype.table=function(X,$){return $&&($="<tbody>"+$+"</tbody>"),"<table>\n<thead>\n"+X+"</thead>\n"+$+"</table>\n"},i.prototype.tablerow=function(X){return"<tr>\n"+X+"</tr>\n"},i.prototype.tablecell=function(X,$){var Q=$.header?"th":"td";return($.align?"<"+Q+' align="'+$.align+'">':"<"+Q+">")+X+"</"+Q+">\n"},i.prototype.strong=function(X){return"<strong>"+X+"</strong>"},i.prototype.em=function(X){return"<em>"+X+"</em>"},i.prototype.codespan=function(X){return"<code>"+X+"</code>"},i.prototype.br=function(){return this.options.xhtml?"<br/>":"<br>"},i.prototype.del=function(X){return"<del>"+X+"</del>"},i.prototype.link=function(X,$,Q){if(this.options.sanitize){try{var J=decodeURIComponent(l(X)).replace(/[^\w:]/g,"").toLowerCase()}catch(X){return Q}if(0===J.indexOf("javascript:")||0===J.indexOf("vbscript:")||0===J.indexOf("data:"))return Q}this.options.baseUrl&&!te.test(X)&&(X=d(this.options.baseUrl,X));try{X=encodeURI(X).replace(/%25/g,"%")}catch(X){return Q}var ee='<a href="'+a(X)+'"';return $&&(ee+=' title="'+$+'"'),ee+">"+Q+"</a>"},i.prototype.image=function(X,$,Q){this.options.baseUrl&&!te.test(X)&&(X=d(this.options.baseUrl,X));var J='<img src="'+X+'" alt="'+Q+'"';return $&&(J+=' title="'+$+'"'),J+(this.options.xhtml?"/>":">")},i.prototype.text=function(X){return X},o.prototype.strong=o.prototype.em=o.prototype.codespan=o.prototype.del=o.prototype.text=function(X){return X},o.prototype.link=o.prototype.image=function(X,$,Q){return""+Q},o.prototype.br=function(){return""},s.parse=function(X,$){return new s($).parse(X)},s.prototype.parse=function(X){this.inline=new n(X.links,this.options),this.inlineText=new n(X.links,h({},this.options,{renderer:new o})),this.tokens=X.reverse();for(var $="";this.next();)$+=this.tok();return $},s.prototype.next=function(){return this.token=this.tokens.pop()},s.prototype.peek=function(){return this.tokens[this.tokens.length-1]||0},s.prototype.parseText=function(){for(var X=this.token.text;"text"===this.peek().type;)X+="\n"+this.next().text;return this.inline.output(X)},s.prototype.tok=function(){switch(this.token.type){case"space":return"";case"hr":return this.renderer.hr();case"heading":return this.renderer.heading(this.inline.output(this.token.text),this.token.depth,l(this.inlineText.output(this.token.text)));case"code":return this.renderer.code(this.token.text,this.token.lang,this.token.escaped);case"table":var X,$,Q,J,ee="",te="";for(Q="",X=0;X<this.token.header.length;X++)Q+=this.renderer.tablecell(this.inline.output(this.token.header[X]),{header:!0,align:this.token.align[X]});for(ee+=this.renderer.tablerow(Q),X=0;X<this.token.cells.length;X++){for($=this.token.cells[X],Q="",J=0;J<$.length;J++)Q+=this.renderer.tablecell(this.inline.output($[J]),{header:!1,align:this.token.align[J]});te+=this.renderer.tablerow(Q)}return this.renderer.table(ee,te);case"blockquote_start":for(te="";"blockquote_end"!==this.next().type;)te+=this.tok();return this.renderer.blockquote(te);case"list_start":te="";for(var ne=this.token.ordered,ie=this.token.start;"list_end"!==this.next().type;)te+=this.tok();return this.renderer.list(te,ne,ie);case"list_item_start":te="";var oe=this.token.loose;for(this.token.task&&(te+=this.renderer.checkbox(this.token.checked));"list_item_end"!==this.next().type;)te+=oe||"text"!==this.token.type?this.tok():this.parseText();return this.renderer.listitem(te);case"html":return this.renderer.html(this.token.text);case"paragraph":return this.renderer.paragraph(this.inline.output(this.token.text));case"text":return this.renderer.paragraph(this.parseText())}};var ee={},te=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;c.exec=c,g.options=g.setOptions=function(X){return h(g.defaults,X),g},g.getDefaults=function(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:new i,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tables:!0,xhtml:!1}},g.defaults=g.getDefaults(),g.Parser=s,g.parser=s.parse,g.Renderer=i,g.TextRenderer=o,g.Lexer=t,g.lexer=t.lex,g.InlineLexer=n,g.inlineLexer=n.output,g.parse=g,J=g}.call(this),define("vs/base/common/marked/marked",(function(){return J})),define(Q[50],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0}),function(X){X.inMemory="inmemory",X.vscode="vscode",X.internal="private",X.walkThrough="walkThrough",X.walkThroughSnippet="walkThroughSnippet",X.http="http",X.https="https",X.file="file",X.mailto="mailto",X.untitled="untitled",X.data="data"}($.Schemas||($.Schemas={}))})),define(Q[427],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0}),$.clamp=function(X,$,Q){return Math.min(Math.max(X,$),Q)}})),define(Q[17],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q=!1,J=!1,ee=!1,te=!1,ne=!1;$.LANGUAGE_DEFAULT="en";var ie="undefined"!=typeof process&&void 0!==process.versions&&void 0!==process.versions.electron&&"renderer"===process.type;if("object"!=typeof navigator||ie){if("object"==typeof process){Q="win32"===process.platform,J="darwin"===process.platform,ee="linux"===process.platform,$.LANGUAGE_DEFAULT,$.LANGUAGE_DEFAULT;var oe=process.env.VSCODE_NLS_CONFIG;if(oe)try{var re=JSON.parse(oe),se=re.availableLanguages["*"];re.locale,se||$.LANGUAGE_DEFAULT,re._translationsConfigFile}catch(X){}te=!0}}else{var ae=navigator.userAgent;Q=ae.indexOf("Windows")>=0,J=ae.indexOf("Macintosh")>=0,ee=ae.indexOf("Linux")>=0,ne=!0,navigator.language}$.isWindows=Q,$.isMacintosh=J,$.isLinux=ee,$.isNative=te,$.isWeb=ne;var le="object"==typeof self?self:"object"==typeof global?global:{};$.globals=le;var ue=null;$.setImmediate=function(X){return null===ue&&(ue=$.globals.setImmediate?$.globals.setImmediate.bind($.globals):"undefined"!=typeof process&&"function"==typeof process.nextTick?process.nextTick.bind(process):$.globals.setTimeout.bind($.globals)),ue(X)},$.OS=J?2:Q?1:3})),define(Q[115],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0}),function(X){function t(X,$){if(X.start>=$.end||$.start>=X.end)return{start:0,end:0};var Q=Math.max(X.start,$.start),J=Math.min(X.end,$.end);return J-Q<=0?{start:0,end:0}:{start:Q,end:J}}function n(X){return X.end-X.start<=0}X.intersect=t,X.isEmpty=n,X.intersects=function(X,$){return!n(t(X,$))},X.relativeComplement=function(X,$){var Q=[],J={start:X.start,end:Math.min($.start,X.end)},ee={start:Math.max($.end,X.start),end:X.end};return n(J)||Q.push(J),n(ee)||Q.push(ee),Q}}($.Range||($.Range={}))})),define(Q[466],n([0,1,115]),(function(X,$,Q){function i(X,$){for(var J=[],ee=0,te=$;ee<te.length;ee++){var ne=te[ee];if(!(X.start>=ne.range.end)){if(X.end<ne.range.start)break;var ie=Q.Range.intersect(X,ne.range);Q.Range.isEmpty(ie)||J.push({range:ie,size:ne.size})}}return J}function o(X,$){return{start:X.start+$,end:X.end+$}}function r(X){for(var $=[],Q=null,J=0,ee=X;J<ee.length;J++){var te=ee[J],ne=te.range.start,ie=te.range.end,oe=te.size;Q&&oe===Q.size?Q.range.end=ie:(Q={range:{start:ne,end:ie},size:oe},$.push(Q))}return $}Object.defineProperty($,"__esModule",{value:!0}),$.groupIntersect=i,$.shift=o,$.consolidate=r;var J=function(){function e(){this.groups=[],this._size=0}return e.prototype.splice=function(X,$,Q){void 0===Q&&(Q=[]);var J=Q.length-$,ee=i({start:0,end:X},this.groups),te=i({start:X+$,end:Number.POSITIVE_INFINITY},this.groups).map((function(X){return{range:o(X.range,J),size:X.size}})),ne=Q.map((function($,Q){return{range:{start:X+Q,end:X+Q+1},size:$.size}}));this.groups=function(){for(var X=[],$=0;$<arguments.length;$++)X[$]=arguments[$];return r(X.reduce((function(X,$){return X.concat($)}),[]))}(ee,ne,te),this._size=this.groups.reduce((function(X,$){return X+$.size*($.range.end-$.range.start)}),0)},Object.defineProperty(e.prototype,"count",{get:function(){var X=this.groups.length;return X?this.groups[X-1].range.end:0},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"size",{get:function(){return this._size},enumerable:!0,configurable:!0}),e.prototype.indexAt=function(X){if(X<0)return-1;for(var $=0,Q=0,J=0,ee=this.groups;J<ee.length;J++){var te=ee[J],ne=te.range.end-te.range.start,ie=Q+ne*te.size;if(X<ie)return $+Math.floor((X-Q)/te.size);$+=ne,Q=ie}return $},e.prototype.indexAfter=function(X){return Math.min(this.indexAt(X)+1,this.count)},e.prototype.positionAt=function(X){if(X<0)return-1;for(var $=0,Q=0,J=0,ee=this.groups;J<ee.length;J++){var te=ee[J],ne=te.range.end-te.range.start,ie=Q+ne;if(X<ie)return $+(X-Q)*te.size;$+=ne*te.size,Q=ie}return-1},e.prototype.dispose=function(){this.groups=null},e}();$.RangeMap=J})),define(Q[205],n([0,1,17]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=Q.globals.performance&&"function"==typeof Q.globals.performance.now,ee=function(){function e(X){this._highResolution=J&&X,this._startTime=this._now(),this._stopTime=-1}return e.create=function(X){return void 0===X&&(X=!0),new e(X)},e.prototype.elapsed=function(){return-1!==this._stopTime?this._stopTime-this._startTime:this._now()-this._startTime},e.prototype._now=function(){return this._highResolution?Q.globals.performance.now():(new Date).getTime()},e}();$.StopWatch=ee})),define(Q[8],n([0,1]),(function(X,$){function n(X){return X.replace(/[\-\\\{\}\*\+\?\|\^\$\.\[\]\(\)\#]/g,"\\$&")}function i(X,$){if(!X||!$)return X;var Q=$.length;if(0===Q||0===X.length)return X;for(var J=0;X.indexOf($,J)===J;)J+=Q;return X.substring(J)}function o(X,$){if(!X||!$)return X;var Q=$.length,J=X.length;if(0===Q||0===J)return X;for(var ee=J,te=-1;-1!==(te=X.lastIndexOf($,ee-1))&&te+Q===ee;){if(0===te)return"";ee=te}return X.substring(0,ee)}function r(X){return X>=97&&X<=122}function s(X){return X>=65&&X<=90}function a(X){return r(X)||s(X)}function l(X,$,Q){if(void 0===Q&&(Q=X.length),"string"!=typeof X||"string"!=typeof $)return!1;for(var J=0;J<Q;J++){var ee=X.charCodeAt(J),te=$.charCodeAt(J);if(ee!==te)if(a(ee)&&a(te)){var ne=Math.abs(ee-te);if(0!==ne&&32!==ne)return!1}else if(String.fromCharCode(ee).toLowerCase()!==String.fromCharCode(te).toLowerCase())return!1}return!0}function u(X){return(X=+X)>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}Object.defineProperty($,"__esModule",{value:!0}),$.empty="",$.isFalsyOrWhitespace=function(X){return!X||"string"!=typeof X||0===X.trim().length},$.pad=function(X,$,Q){void 0===Q&&(Q="0");for(var J=""+X,ee=[J],te=J.length;te<$;te++)ee.push(Q);return ee.reverse().join("")};var Q=/{(\d+)}/g;$.format=function(X){for(var $=[],J=1;J<arguments.length;J++)$[J-1]=arguments[J];return 0===$.length?X:X.replace(Q,(function(X,Q){var J=parseInt(Q,10);return isNaN(J)||J<0||J>=$.length?X:$[J]}))},$.escape=function(X){return X.replace(/[<|>|&]/g,(function(X){switch(X){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return X}}))},$.escapeRegExpCharacters=n,$.trim=function(X,$){return void 0===$&&($=" "),o(i(X,$),$)},$.ltrim=i,$.rtrim=o,$.convertSimple2RegExpPattern=function(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")},$.startsWith=function(X,$){if(X.length<$.length)return!1;if(X===$)return!0;for(var Q=0;Q<$.length;Q++)if(X[Q]!==$[Q])return!1;return!0},$.endsWith=function(X,$){var Q=X.length-$.length;return Q>0?X.indexOf($,Q)===Q:0===Q&&X===$},$.createRegExp=function(X,$,Q){if(void 0===Q&&(Q={}),!X)throw new Error("Cannot create regex from empty string");$||(X=n(X)),Q.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X+="\\b"));var J="";return Q.global&&(J+="g"),Q.matchCase||(J+="i"),Q.multiline&&(J+="m"),new RegExp(X,J)},$.regExpLeadsToEndlessLoop=function(X){return"^"!==X.source&&"^$"!==X.source&&"$"!==X.source&&"^\\s*$"!==X.source&&!(!X.exec("")||0!==X.lastIndex)},$.firstNonWhitespaceIndex=function(X){for(var $=0,Q=X.length;$<Q;$++){var J=X.charCodeAt($);if(32!==J&&9!==J)return $}return-1},$.getLeadingWhitespace=function(X,$,Q){void 0===$&&($=0),void 0===Q&&(Q=X.length);for(var J=$;J<Q;J++){var ee=X.charCodeAt(J);if(32!==ee&&9!==ee)return X.substring($,J)}return X.substring($,Q)},$.lastNonWhitespaceIndex=function(X,$){void 0===$&&($=X.length-1);for(var Q=$;Q>=0;Q--){var J=X.charCodeAt(Q);if(32!==J&&9!==J)return Q}return-1},$.compare=function(X,$){return X<$?-1:X>$?1:0},$.isLowerAsciiLetter=r,$.isUpperAsciiLetter=s,$.equalsIgnoreCase=function(X,$){return(X?X.length:0)===($?$.length:0)&&l(X,$)},$.startsWithIgnoreCase=function(X,$){var Q=$.length;return!($.length>X.length)&&l(X,$,Q)},$.commonPrefixLength=function(X,$){var Q,J=Math.min(X.length,$.length);for(Q=0;Q<J;Q++)if(X.charCodeAt(Q)!==$.charCodeAt(Q))return Q;return J},$.commonSuffixLength=function(X,$){var Q,J=Math.min(X.length,$.length),ee=X.length-1,te=$.length-1;for(Q=0;Q<J;Q++)if(X.charCodeAt(ee-Q)!==$.charCodeAt(te-Q))return Q;return J},$.isHighSurrogate=function(X){return 55296<=X&&X<=56319},$.isLowSurrogate=function(X){return 56320<=X&&X<=57343};var J=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;$.containsRTL=function(X){return J.test(X)};var ee=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEF8]|\uD83E[\uDD00-\uDDE6])/;$.containsEmoji=function(X){return ee.test(X)};var te=/^[\t\n\r\x20-\x7E]*$/;$.isBasicASCII=function(X){return te.test(X)},$.containsFullWidthCharacter=function(X){for(var $=0,Q=X.length;$<Q;$++)if(u(X.charCodeAt($)))return!0;return!1},$.isFullWidthCharacter=u,$.UTF8_BOM_CHARACTER=String.fromCharCode(65279),$.startsWithUTF8BOM=function(X){return!!(X&&X.length>0&&65279===X.charCodeAt(0))},$.safeBtoa=function(X){return btoa(encodeURIComponent(X))},$.repeat=function(X,$){for(var Q="",J=0;J<$;J++)Q+=X;return Q}})),define(Q[247],n([0,1,8]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),$.renderOcticons=function(X){return Q.escape(X)}})),define(Q[100],n([0,1,65,8]),(function(X,$,Q,J){function o(){for(var X=[],$=0;$<arguments.length;$++)X[$]=arguments[$];return function($,Q){for(var J=0,ee=X.length;J<ee;J++){var te=X[J]($,Q);if(te)return te}return null}}function r(X,$){var Q=$.toLowerCase().indexOf(X.toLowerCase());return-1===Q?null:[{start:Q,end:Q+X.length}]}function s(X,$){return a(X.toLowerCase(),$.toLowerCase(),0,0)}function a(X,$,Q,J){if(Q===X.length)return[];if(J===$.length)return null;if(X[Q]===$[J]){var ee;return(ee=a(X,$,Q+1,J+1))?p({start:J,end:J+1},ee):null}return a(X,$,Q,J+1)}function l(X){return 97<=X&&X<=122}function u(X){return 65<=X&&X<=90}function d(X){return 48<=X&&X<=57}function c(X){return 32===X||9===X||10===X||13===X}function h(X){return l(X)||u(X)||d(X)}function p(X,$){return 0===$.length?$=[X]:X.end===$[0].start?$[0].start=X.start:$.unshift(X),$}function f(X,$){for(var Q=$;Q<X.length;Q++){var J=X.charCodeAt(Q);if(u(J)||d(J)||Q>0&&!h(X.charCodeAt(Q-1)))return Q}return X.length}function g(X,$,Q,J){if(Q===X.length)return[];if(J===$.length)return null;if(X[Q]!==$[J].toLowerCase())return null;var ee=null,te=J+1;for(ee=g(X,$,Q+1,J+1);!ee&&(te=f($,te))<$.length;)ee=g(X,$,Q+1,te),te++;return null===ee?null:p({start:J,end:J+1},ee)}function m(X,$){if(!$)return null;if(0===($=$.trim()).length)return null;if(!function(X){for(var $=0,Q=0,J=0,ee=0,te=0;te<X.length;te++)u(J=X.charCodeAt(te))&&$++,l(J)&&Q++,c(J)&&ee++;return 0!==$&&0!==Q||0!==ee?$<=5:X.length<=30}(X))return null;if($.length>60)return null;var Q=function(X){for(var $=0,Q=0,J=0,ee=0,te=0,ne=0;ne<X.length;ne++)u(te=X.charCodeAt(ne))&&$++,l(te)&&Q++,h(te)&&J++,d(te)&&ee++;return{upperPercent:$/X.length,lowerPercent:Q/X.length,alphaPercent:J/X.length,numericPercent:ee/X.length}}($);if(!function(X){var $=X.upperPercent,Q=X.lowerPercent,J=X.alphaPercent,ee=X.numericPercent;return Q>.2&&$<.8&&J>.6&&ee<.2}(Q)){if(!function(X){var $=X.upperPercent;return 0===X.lowerPercent&&$>.6}(Q))return null;$=$.toLowerCase()}var J=null,ee=0;for(X=X.toLowerCase();ee<$.length&&null===(J=g(X,$,0,ee));)ee=f($,ee+1);return J}function v(){for(var X=[],$=[0],Q=1;Q<=100;Q++)$.push(-Q);for(Q=0;Q<=100;Q++){var J=$.slice(0);J[0]=-Q,X.push(J)}return X}function _(X,$,Q,J,ee){function r(X,$,Q){for(void 0===Q&&(Q=" ");X.length<$;)X=Q+X;return X}for(var te=" |   |"+J.split("").map((function(X){return r(X,3)})).join("|")+"\n",ne=0;ne<=Q;ne++)te+=0===ne?" |":$[ne-1]+"|",te+=X[ne].slice(0,ee+1).map((function(X){return r(X.toString(),3)})).join("|")+"\n";return te}function y(X,$){if($<0||$>=X.length)return!1;switch(X.charCodeAt($)){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:return!0;default:return!1}}function C(X,$){if($<0||$>=X.length)return!1;switch(X.charCodeAt($)){case 32:case 9:return!0;default:return!1}}function b(X,$,Q,J,ee,te,he){var pe=X.length>100?100:X.length,fe=J.length>100?100:J.length;if(!(Q>=pe||te>=fe||pe>fe)){for(var ge=Q,me=te;Q<pe&&te<fe;)$[Q]===ee[te]&&(Q+=1),te+=1;if(Q===pe){for(Q=ge,te=me,Q=ge+1;Q<=pe;Q++)for(te=1;te<=fe;te++){var ve=-1,_e=ee[te-1];$[Q-1]===_e&&(ve=te===Q-ge?X[Q-1]===J[te-1]?7:5:_e===J[te-1]||1!==te&&ee[te-2]!==J[te-2]?y(ee,te-2)||C(ee,te-2)?5:1:X[Q-1]===J[te-1]?7:5),ie[Q][te]=ve;var ye=ne[Q-1][te-1]+(ve>1?1:ve),be=ne[Q-1][te]+-1,Ce=ne[Q][te-1]+-1;Ce>=be?Ce>ye?(ne[Q][te]=Ce,oe[Q][te]=4):Ce===ye?(ne[Q][te]=Ce,oe[Q][te]=6):(ne[Q][te]=ye,oe[Q][te]=2):be>ye?(ne[Q][te]=be,oe[Q][te]=1):be===ye?(ne[Q][te]=be,oe[Q][te]=3):(ne[Q][te]=ye,oe[Q][te]=2)}if(re&&(console.log(_(ne,X,pe,J,fe)),console.log(_(oe,X,pe,J,fe)),console.log(_(ie,X,pe,J,fe))),ae=0,le=-100,ue=ge,de=he,S(pe,fe,pe===fe?1:0,new ce,!1),0!==ae)return[le,se.toArray()]}}}function S(X,$,Q,J,ee){if(!(ae>=10||Q<-25)){for(var te=0;X>ue&&$>0;){var ne=ie[X][$],re=oe[X][$];if(4===re)$-=1,ee?Q-=5:J.isEmpty()||(Q-=1),ee=!1,te=0;else{if(!(2&re))return;if(4&re&&S(X,$-1,J.isEmpty()?Q:Q-1,J.slice(),ee),Q+=ne,X-=1,$-=1,J.unshift($),ee=!0,1===ne){if(te+=1,X===ue&&!de)return}else Q+=1+te*(ne-1),te=0}}ae+=1,(Q-=$>=3?9:3*$)>le&&(le=Q,se=J)}}Object.defineProperty($,"__esModule",{value:!0}),$.or=o,$.matchesPrefix=function(X,$,Q){return!Q||Q.length<$.length?null:(X?J.startsWithIgnoreCase(Q,$):0===Q.indexOf($))?$.length>0?[{start:0,end:$.length}]:[]:null}.bind(void 0,!0),$.matchesContiguousSubString=r,$.matchesSubString=s,$.isUpper=u,$.matchesCamelCase=m,$.fuzzyContiguousFilter=o($.matchesPrefix,m,r);var ee=o($.matchesPrefix,m,s),te=new Q.LRUCache(1e4);$.matchesFuzzy=function(X,Q,ne){if(void 0===ne&&(ne=!1),"string"!=typeof X||"string"!=typeof Q)return null;var ie=te.get(X);ie||(ie=new RegExp(J.convertSimple2RegExpPattern(X),"i"),te.set(X,ie));var oe=ie.exec(Q);return oe?[{start:oe.index,end:oe.index+oe[0].length}]:ne?ee(X,Q):$.fuzzyContiguousFilter(X,Q)},$.anyScore=function(X,$,Q){X=X.toLowerCase(),$=$.toLowerCase();for(var J=[],ee=0,te=0;te<X.length;++te){var ne=$.indexOf(X.charAt(te),ee);ne>=0&&(J.push(ne),ee=ne+1)}return[J.length,J]},$.createMatches=function(X){var $=[];if(!X)return $;for(var Q,J=0,ee=Array.isArray(X[1])?X[1]:X;J<ee.length;J++){var te=ee[J];Q&&Q.end===te?Q.end+=1:(Q={start:te,end:te+1},$.push(Q))}return $};var ne=v(),ie=v(),oe=v(),re=!1;$.fuzzyScore=b;var se,ae=0,le=0,ue=0,de=!1,ce=function(){function e(){}return e.prototype.isEmpty=function(){return!this._data&&(!this._parent||this._parent.isEmpty())},e.prototype.unshift=function(X){this._data?this._data.unshift(X):this._data=[X]},e.prototype.slice=function(){var X=new e;return X._parent=this,X._parentLen=this._data?this._data.length:0,X},e.prototype.toArray=function(){if(!this._data)return this._parent.toArray();for(var X=[],$=this;$;)$._parent&&$._parent._data&&X.push($._parent._data.slice($._parent._data.length-$._parentLen)),$=$._parent;return Array.prototype.concat.apply(this._data,X)},e}();$.fuzzyScoreGracefulAggressive=function w(X,$,Q,J,ee,te,ne){return function(X,$,Q,J,ee,te,ne,ie){var oe=b(X,$,Q,J,ee,te,ie);if(X.length>=3)for(var re=Math.min(7,X.length-1),se=Q+1;se<re;se++){var ae=function(X,$){if(!($+1>=X.length)){var Q=X[$],J=X[$+1];if(Q!==J)return X.slice(0,$)+J+Q+X.slice($+2)}}(X,se);if(ae){var le=b(ae,ae.toLowerCase(),Q,J,ee,te,ie);le&&(le[0]-=3,(!oe||le[0]>oe[0])&&(oe=le))}}return oe}(X,$,Q,J,ee,te,0,ne)}})),define(Q[58],n([0,1,17,8]),(function(X,$,Q,J){function r(X){var $=~X.lastIndexOf("/")||~X.lastIndexOf("\\");return 0===$?X:~$==X.length-1?r(X.substring(0,X.length-1)):X.substr(1+~$)}function s(X,$){if(null==X)return X;var J=X.length;if(0===J)return".";var ne=!(!Q.isWindows||!$);if(function(X,$){return $?!te.test(X):!ee.test(X)}(X,ne))return X;for(var ie=ne?"\\":"/",oe=l(X,ie),re=oe.length,se=!1,ae="",le=oe.length;le<=J;le++)if(le===J||47===X.charCodeAt(le)||92===X.charCodeAt(le)){if(a(X,re,le,"..")){var ue=ae.lastIndexOf(ie),de=ae.slice(ue+1);(oe||de.length>0)&&".."!==de&&(ae=-1===ue?"":ae.slice(0,ue),se=!0)}else a(X,re,le,".")&&(oe||ae||le<J-1)&&(se=!0);if(!se){var ce=X.slice(re,le);""!==ae&&ae[ae.length-1]!==ie&&(ae+=ie),ae+=ce}re=le+1,se=!1}return oe+ae}function a(X,$,Q,J){return $+J.length===Q&&X.indexOf(J,$)===$}function l(X,$){if(void 0===$&&($="/"),!X)return"";var Q=X.length,J=X.charCodeAt(0);if(47===J||92===J){if((47===(J=X.charCodeAt(1))||92===J)&&47!==(J=X.charCodeAt(2))&&92!==J){for(var ee=3,te=ee;ee<Q&&47!==(J=X.charCodeAt(ee))&&92!==J;ee++);if(J=X.charCodeAt(ee+1),te!==ee&&47!==J&&92!==J)for(ee+=1;ee<Q;ee++)if(47===(J=X.charCodeAt(ee))||92===J)return X.slice(0,ee+1).replace(/[\\/]/g,$)}return $}if((J>=65&&J<=90||J>=97&&J<=122)&&58===X.charCodeAt(1))return 47===(J=X.charCodeAt(2))||92===J?X.slice(0,2)+$:X.slice(0,2);var ne=X.indexOf("://");if(-1!==ne)for(ne+=3;ne<Q;ne++)if(47===(J=X.charCodeAt(ne))||92===J)return X.slice(0,ne+1);return""}Object.defineProperty($,"__esModule",{value:!0}),$.sep="/",$.nativeSep=Q.isWindows?"\\":"/",$.dirname=function o(X,J){void 0===J&&(J=$.nativeSep);var ee=~X.lastIndexOf("/")||~X.lastIndexOf("\\");if(0===ee)return".";if(0==~ee)return X[0];if(~ee==X.length-1)return o(X.substring(0,X.length-1));var te=X.substring(0,~ee);return Q.isWindows&&":"===te[te.length-1]&&(te+=J),te},$.basename=r,$.extname=function(X){var $=~(X=r(X)).lastIndexOf(".");return $?X.substring(~$):""};var ee=/(\/\.\.?\/)|(\/\.\.?)$|^(\.\.?\/)|(\/\/+)|(\\)/,te=/(\\\.\.?\\)|(\\\.\.?)$|^(\.\.?\\)|(\\\\+)|(\/)/;$.normalize=s,$.getRoot=l,$.join=function(){for(var X="",Q=0;Q<arguments.length;Q++){var J=arguments[Q];if(Q>0){var ee=X.charCodeAt(X.length-1);if(47!==ee&&92!==ee){var te=J.charCodeAt(0);47!==te&&92!==te&&(X+=$.sep)}}X+=J}return s(X)},$.isEqualOrParent=function(X,Q,ee,te){if(void 0===te&&(te=$.nativeSep),X===Q)return!0;if(!X||!Q)return!1;if(Q.length>X.length)return!1;if(ee){if(!J.startsWithIgnoreCase(X,Q))return!1;if(Q.length===X.length)return!0;var ne=Q.length;return Q.charAt(Q.length-1)===te&&ne--,X.charAt(ne)===te}return Q.charAt(Q.length-1)!==te&&(Q+=te),0===X.indexOf(Q)}})),define(Q[32],n([0,1]),(function(X,$){function n(X){return typeof X===Q.string||X instanceof String}function i(X){return!(typeof X!==Q.object||null===X||Array.isArray(X)||X instanceof RegExp||X instanceof Date)}function o(X){return typeof X===Q.undefined}function r(X){return o(X)||null===X}function s(X){return typeof X===Q.function}function a(X,$){if(n($)){if(typeof X!==$)throw new Error("argument does not match constraint: typeof "+$)}else if(s($)){if(X instanceof $)return;if(!r(X)&&X.constructor===$)return;if(1===$.length&&!0===$.call(void 0,X))return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}Object.defineProperty($,"__esModule",{value:!0});var Q={number:"number",string:"string",undefined:"undefined",object:"object",function:"function"};$.isArray=function(X){return Array.isArray?Array.isArray(X):!(!X||typeof X.length!==Q.number||X.constructor!==Array)},$.isString=n,$.isObject=i,$.isNumber=function(X){return(typeof X===Q.number||X instanceof Number)&&!isNaN(X)},$.isBoolean=function(X){return!0===X||!1===X},$.isUndefined=o,$.isUndefinedOrNull=r;var J=Object.prototype.hasOwnProperty;$.isEmptyObject=function(X){if(!i(X))return!1;for(var $ in X)if(J.call(X,$))return!1;return!0},$.isFunction=s,$.validateConstraints=function(X,$){for(var Q=Math.min(X.length,$.length),J=0;J<Q;J++)a(X[J],$[J])},$.validateConstraint=a,$.create=function(X){for(var $=[],Q=1;Q<arguments.length;Q++)$[Q-1]=arguments[Q];var J=Object.create(X.prototype);return X.apply(J,$),J}})),define(Q[27],n([0,1,32]),(function(X,$,Q){function s(X){for(var $={},Q=0;Q<X.length;++Q)$[X[Q]]=!0;return $}Object.defineProperty($,"__esModule",{value:!0}),$.deepClone=function i(X){if(!X||"object"!=typeof X)return X;if(X instanceof RegExp)return X;var $=Array.isArray(X)?[]:{};return Object.keys(X).forEach((function(Q){X[Q]&&"object"==typeof X[Q]?$[Q]=i(X[Q]):$[Q]=X[Q]})),$},$.deepFreeze=function(X){if(!X||"object"!=typeof X)return X;for(var $=[X];$.length>0;){var Q=$.shift();for(var ee in Object.freeze(Q),Q)if(J.call(Q,ee)){var te=Q[ee];"object"!=typeof te||Object.isFrozen(te)||$.push(te)}}return X};var J=Object.prototype.hasOwnProperty;$.mixin=function o(X,$,J){return void 0===J&&(J=!0),Q.isObject(X)?(Q.isObject($)&&Object.keys($).forEach((function(ee){ee in X?J&&(Q.isObject(X[ee])&&Q.isObject($[ee])?o(X[ee],$[ee],J):X[ee]=$[ee]):X[ee]=$[ee]})),X):$},$.assign=function(X){for(var $=[],Q=1;Q<arguments.length;Q++)$[Q-1]=arguments[Q];return $.forEach((function($){return Object.keys($).forEach((function(Q){return X[Q]=$[Q]}))})),X},$.equals=function r(X,$){if(X===$)return!0;if(null==X||null==$)return!1;if(typeof X!=typeof $)return!1;if("object"!=typeof X)return!1;if(Array.isArray(X)!==Array.isArray($))return!1;var Q,J;if(Array.isArray(X)){if(X.length!==$.length)return!1;for(Q=0;Q<X.length;Q++)if(!r(X[Q],$[Q]))return!1}else{var ee=[];for(J in X)ee.push(J);ee.sort();var te=[];for(J in $)te.push(J);if(te.sort(),!r(ee,te))return!1;for(Q=0;Q<ee.length;Q++)if(!r(X[ee[Q]],$[ee[Q]]))return!1}return!0},$.arrayToHash=s,$.createKeywordMatcher=function(X,$){void 0===$&&($=!1),$&&(X=X.map((function(X){return X.toLowerCase()})));var Q=s(X);return $?function(X){return void 0!==Q[X.toLowerCase()]&&Q.hasOwnProperty(X.toLowerCase())}:function(X){return void 0!==Q[X]&&Q.hasOwnProperty(X)}},$.getOrDefault=function(X,$,Q){void 0===Q&&(Q=null);var J=$(X);return void 0===J?Q:J}})),define(Q[25],n([0,1,17]),(function(X,$,Q){function i(X,$){for(var Q=void 0,J=-1,ee=0;ee<X.length;ee++){var te=X.charCodeAt(ee);if(te>=97&&te<=122||te>=65&&te<=90||te>=48&&te<=57||45===te||46===te||95===te||126===te||$&&47===te)-1!==J&&(Q+=encodeURIComponent(X.substring(J,ee)),J=-1),void 0!==Q&&(Q+=X.charAt(ee));else{void 0===Q&&(Q=X.substr(0,ee));var ne=ue[te];void 0!==ne?(-1!==J&&(Q+=encodeURIComponent(X.substring(J,ee)),J=-1),Q+=ne):-1===J&&(J=ee)}}return-1!==J&&(Q+=encodeURIComponent(X.substring(J))),void 0!==Q?Q:X}function r(X){var $;return $=X.authority&&X.path.length>1&&"file"===X.scheme?"//"+X.authority+X.path:47===X.path.charCodeAt(0)&&(X.path.charCodeAt(1)>=65&&X.path.charCodeAt(1)<=90||X.path.charCodeAt(1)>=97&&X.path.charCodeAt(1)<=122)&&58===X.path.charCodeAt(2)?X.path[1].toLowerCase()+X.path.substr(2):X.path,Q.isWindows&&($=$.replace(/\//g,"\\")),$}function s(X,$){var Q=$?function(X){for(var $=void 0,Q=0;Q<X.length;Q++){var J=X.charCodeAt(Q);35===J||63===J?(void 0===$&&($=X.substr(0,Q)),$+=ue[J]):void 0!==$&&($+=X[Q])}return void 0!==$?$:X}:i,J="",ee=X.scheme,te=X.authority,ne=X.path,ie=X.query,oe=X.fragment;if(ee&&(J+=ee,J+=":"),(te||"file"===ee)&&(J+=re,J+=re),te){var se=te.indexOf("@");if(-1!==se){var ae=te.substr(0,se);te=te.substr(se+1),-1===(se=ae.indexOf(":"))?J+=Q(ae,!1):(J+=Q(ae.substr(0,se),!1),J+=":",J+=Q(ae.substr(se+1),!1)),J+="@"}-1===(se=(te=te.toLowerCase()).indexOf(":"))?J+=Q(te,!1):(J+=Q(te.substr(0,se),!1),J+=te.substr(se))}if(ne){if(ne.length>=3&&47===ne.charCodeAt(0)&&58===ne.charCodeAt(2))(le=ne.charCodeAt(1))>=65&&le<=90&&(ne="/"+String.fromCharCode(le+32)+":"+ne.substr(3));else if(ne.length>=2&&58===ne.charCodeAt(1)){var le=ne.charCodeAt(0);le>=65&&le<=90&&(ne=String.fromCharCode(le+32)+":"+ne.substr(2))}J+=Q(ne,!0)}return ie&&(J+="?",J+=Q(ie,!1)),oe&&(J+="#",J+=$?oe:i(oe,!1)),J}Object.defineProperty($,"__esModule",{value:!0});var J,ee=/^\w[\w\d+.-]*$/,ne=/^\//,ie=/^\/\//,oe="",re="/",se=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/,ae=function(){function e(X,$,Q,J,te){"object"==typeof X?(this.scheme=X.scheme||oe,this.authority=X.authority||oe,this.path=X.path||oe,this.query=X.query||oe,this.fragment=X.fragment||oe):(this.scheme=X||oe,this.authority=$||oe,this.path=function(X,$){switch(X){case"https":case"http":case"file":$?$[0]!==re&&($=re+$):$=re}return $}(this.scheme,Q||oe),this.query=J||oe,this.fragment=te||oe,function(X){if(!X.scheme)throw new Error('[UriError]: Scheme is missing: {scheme: "", authority: "'+X.authority+'", path: "'+X.path+'", query: "'+X.query+'", fragment: "'+X.fragment+'"}');if(X.scheme&&!ee.test(X.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(X.path)if(X.authority){if(!ne.test(X.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(ie.test(X.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}(this))}return e.isUri=function(X){return X instanceof e||!!X&&"string"==typeof X.authority&&"string"==typeof X.fragment&&"string"==typeof X.path&&"string"==typeof X.query&&"string"==typeof X.scheme},Object.defineProperty(e.prototype,"fsPath",{get:function(){return r(this)},enumerable:!0,configurable:!0}),e.prototype.with=function(X){if(!X)return this;var $=X.scheme,Q=X.authority,J=X.path,ee=X.query,te=X.fragment;return void 0===$?$=this.scheme:null===$&&($=oe),void 0===Q?Q=this.authority:null===Q&&(Q=oe),void 0===J?J=this.path:null===J&&(J=oe),void 0===ee?ee=this.query:null===ee&&(ee=oe),void 0===te?te=this.fragment:null===te&&(te=oe),$===this.scheme&&Q===this.authority&&J===this.path&&ee===this.query&&te===this.fragment?this:new le($,Q,J,ee,te)},e.parse=function(X){var $=se.exec(X);return $?new le($[2]||oe,decodeURIComponent($[4]||oe),decodeURIComponent($[5]||oe),decodeURIComponent($[7]||oe),decodeURIComponent($[9]||oe)):new le(oe,oe,oe,oe,oe)},e.file=function(X){var $=oe;if(Q.isWindows&&(X=X.replace(/\\/g,re)),X[0]===re&&X[1]===re){var J=X.indexOf(re,2);-1===J?($=X.substring(2),X=re):($=X.substring(2,J),X=X.substring(J)||re)}return new le("file",$,X,oe,oe)},e.from=function(X){return new le(X.scheme,X.authority,X.path,X.query,X.fragment)},e.prototype.toString=function(X){return void 0===X&&(X=!1),s(this,X)},e.prototype.toJSON=function(){return this},e.revive=function(X){if(X){if(X instanceof e)return X;var $=new le(X);return $._fsPath=X.fsPath,$._formatted=X.external,$}return X},e}();$.URI=ae;var le=function(X){function t(){var $=null!==X&&X.apply(this,arguments)||this;return $._formatted=null,$._fsPath=null,$}return te(t,X),Object.defineProperty(t.prototype,"fsPath",{get:function(){return this._fsPath||(this._fsPath=r(this)),this._fsPath},enumerable:!0,configurable:!0}),t.prototype.toString=function(X){return void 0===X&&(X=!1),X?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)},t.prototype.toJSON=function(){var X={$mid:1};return this._fsPath&&(X.fsPath=this._fsPath),this._formatted&&(X.external=this._formatted),this.path&&(X.path=this.path),this.scheme&&(X.scheme=this.scheme),this.authority&&(X.authority=this.authority),this.query&&(X.query=this.query),this.fragment&&(X.fragment=this.fragment),X},t}(ae),ue=((J={})[58]="%3A",J[47]="%2F",J[63]="%3F",J[35]="%23",J[91]="%5B",J[93]="%5D",J[64]="%40",J[33]="%21",J[36]="%24",J[38]="%26",J[39]="%27",J[40]="%28",J[41]="%29",J[42]="%2A",J[43]="%2B",J[44]="%2C",J[59]="%3B",J[61]="%3D",J[32]="%20",J)})),define(Q[430],n([0,1,25]),(function(X,$,Q){function i(X,$){if(!X||$>200)return X;if("object"==typeof X){switch(X.$mid){case 1:return Q.URI.revive(X);case 2:return new RegExp(X.source,X.flags)}for(var J in X)Object.hasOwnProperty.call(X,J)&&(X[J]=i(X[J],$+1))}return X}Object.defineProperty($,"__esModule",{value:!0}),$.parse=function(X){var $=JSON.parse(X);return i($,0)},$.revive=i})),define(Q[84],n([0,1,58,25,8,50,17]),(function(X,$,Q,J,ee,te,ne){function a(X){return!X||X.scheme!==te.Schemas.file||!ne.isLinux}function l(X){return Q.basename(X.path)}function u(X){var $;return $=X.authority&&X.path.length>1&&"file"===X.scheme?"//"+X.authority+X.path:ne.isWindows&&47===X.path.charCodeAt(0)&&(X.path.charCodeAt(1)>=65&&X.path.charCodeAt(1)<=90||X.path.charCodeAt(1)>=97&&X.path.charCodeAt(1)<=122)&&58===X.path.charCodeAt(2)?X.path.substr(1):X.path,ne.isWindows&&($=$.replace(/\//g,"\\")),$}Object.defineProperty($,"__esModule",{value:!0}),$.hasToIgnoreCase=a,$.basenameOrAuthority=function(X){return l(X)||X.authority},$.isEqual=function(X,$,Q){return void 0===Q&&(Q=a(X)),!(X!==$)||!(!X||!$)&&(Q?ee.equalsIgnoreCase(X.toString(),$.toString()):X.toString()===$.toString())},$.basename=l,$.dirname=function(X){if(X.scheme===te.Schemas.file)return J.URI.file(Q.dirname(u(X)));var $=Q.dirname(X.path,"/");return X.authority&&$.length&&47!==$.charCodeAt(0)?null:X.with({path:$})},$.joinPath=function(X,$){var ee;return ee=X.scheme===te.Schemas.file?J.URI.file(Q.join(u(X),$)).path:Q.join(X.path,$),X.with({path:ee})},$.normalizePath=function(X){var $;return $=X.scheme===te.Schemas.file?J.URI.file(Q.normalize(u(X))).path:Q.normalize(X.path),X.with({path:$})},$.fsPath=u,function(X){X.META_DATA_LABEL="label",X.META_DATA_DESCRIPTION="description",X.META_DATA_SIZE="size",X.META_DATA_MIME="mime",X.parseMetaData=function($){var Q=new Map;$.path.substring($.path.indexOf(";")+1,$.path.lastIndexOf(";")).split(";").forEach((function(X){var $=X.split(":"),J=$[0],ee=$[1];J&&ee&&Q.set(J,ee)}));var J=$.path.substring(0,$.path.indexOf(";"));return J&&Q.set(X.META_DATA_MIME,J),Q}}($.DataUri||($.DataUri={}))})),define(Q[158],n([0,1,25,58,8,50,17,84]),(function(X,$,Q,J,ee,te,ne,ie){function l(X){return!(!ne.isWindows||!X||":"!==X[1])}function u(X){return l(X)?X.charAt(0).toUpperCase()+X.slice(1):X}function d(X,$){if(ne.isWindows||!X||!$)return X;var Q=oe.original===$?oe.normalized:void 0;return Q||(Q=""+ee.rtrim($,J.sep)+J.sep,oe={original:$,normalized:Q}),(ne.isLinux?ee.startsWith(X,Q):ee.startsWithIgnoreCase(X,Q))&&(X="~/"+X.substr(Q.length)),X}Object.defineProperty($,"__esModule",{value:!0}),$.getPathLabel=function(X,$,oe){if("string"==typeof X&&(X=Q.URI.file(X)),oe){var re=oe.getWorkspaceFolder(X);if(re){var se=oe.getWorkspace().folders.length>1,ae=void 0;if(ae=ie.isEqual(re.uri,X,!ne.isLinux)?"":J.normalize(ee.ltrim(X.path.substr(re.uri.path.length),J.sep),!0),se){var le=re&&re.name?re.name:J.basename(re.uri.fsPath);ae=ae?le+" • "+ae:le}return ae}}if(X.scheme!==te.Schemas.file&&X.scheme!==te.Schemas.untitled)return X.with({query:null,fragment:null}).toString(!0);if(l(X.fsPath))return J.normalize(u(X.fsPath),!0);var ue=J.normalize(X.fsPath,!0);return!ne.isWindows&&$&&(ue=d(ue,$.userHome)),ue},$.getBaseLabel=function(X){if(X){"string"==typeof X&&(X=Q.URI.file(X));var $=J.basename(X.path)||(X.scheme===te.Schemas.file?X.fsPath:X.path);return l($)?u($):$}},$.normalizeDriveLetter=u;var oe=Object.create(null);$.tildify=d})),function(){var X=Object.create(null);X["WinJS/Core/_WinJS"]={};var t=function($,Q,J){var ee={},te=!1,ne=Q.map((function($){return"exports"===$?(te=!0,ee):X[$]})),ie=J.apply({},ne);X[$]=te?ee:ie};t("WinJS/Core/_Global",[],(function(){return"undefined"!=typeof window?window:"undefined"!=typeof self?self:"undefined"!=typeof global?global:{}})),t("WinJS/Core/_BaseCoreUtils",["WinJS/Core/_Global"],(function(X){var $=null;return{hasWinRT:!!X.Windows,markSupportedForProcessing:function(X){return X.supportedForProcessing=!0,X},_setImmediate:function(Q){null===$&&($=X.setImmediate?X.setImmediate.bind(X):"undefined"!=typeof process&&"function"==typeof process.nextTick?process.nextTick.bind(process):X.setTimeout.bind(X)),$(Q)}}})),t("WinJS/Core/_WriteProfilerMark",["WinJS/Core/_Global"],(function(X){return X.msWriteProfilerMark||function(){}})),t("WinJS/Core/_Base",["WinJS/Core/_WinJS","WinJS/Core/_Global","WinJS/Core/_BaseCoreUtils","WinJS/Core/_WriteProfilerMark"],(function(X,$,Q,J){function o(X,$,Q){var J,ee,te,ne=Object.keys($),ie=Array.isArray(X);for(ee=0,te=ne.length;ee<te;ee++){var oe=ne[ee],re=95!==oe.charCodeAt(0),se=$[oe];!se||"object"!=typeof se||void 0===se.value&&"function"!=typeof se.get&&"function"!=typeof se.set?re?ie?X.forEach((function(X){X[oe]=se})):X[oe]=se:(J=J||{})[oe]={value:se,enumerable:re,configurable:!0,writable:!0}:(void 0===se.enumerable&&(se.enumerable=re),Q&&se.setName&&"function"==typeof se.setName&&se.setName(Q+"."+oe),(J=J||{})[oe]=se)}J&&(ie?X.forEach((function(X){Object.defineProperties(X,J)})):Object.defineProperties(X,J))}return function(){function n(Q,J){var ee=Q||{};if(J){var te=J.split(".");ee===$&&"WinJS"===te[0]&&(ee=X,te.splice(0,1));for(var ne=0,ie=te.length;ne<ie;ne++){var oe=te[ne];ee[oe]||Object.defineProperty(ee,oe,{value:{},writable:!1,enumerable:!0,configurable:!0}),ee=ee[oe]}}return ee}function r(X,$,Q){var J=n(X,$);return Q&&o(J,Q,$||"<ANONYMOUS>"),J}var Q=X;Q.Namespace||(Q.Namespace=Object.create(Object.prototype));var ee=1,te=2,ne=3;Object.defineProperties(Q.Namespace,{defineWithParent:{value:r,writable:!0,enumerable:!0,configurable:!0},define:{value:function(X,Q){return r($,X,Q)},writable:!0,enumerable:!0,configurable:!0},_lazy:{value:function(X){var $,Q,ie=ee;return{setName:function(X){$=X},get:function(){switch(ie){case ne:return Q;case ee:ie=te;try{J("WinJS.Namespace._lazy:"+$+",StartTM"),Q=X()}finally{J("WinJS.Namespace._lazy:"+$+",StopTM"),ie=ee}return X=null,ie=ne,Q;case te:throw"Illegal: reentrancy on initialization";default:throw"Illegal"}},set:function(X){switch(ie){case te:throw"Illegal: reentrancy on initialization";default:ie=ne,Q=X}},enumerable:!0,configurable:!0}},writable:!0,enumerable:!0,configurable:!0},_moduleDefine:{value:function(X,Q,J){var ee=[X],te=null;return Q&&(te=n($,Q),ee.push(te)),o(ee,J,Q||"<ANONYMOUS>"),te},writable:!0,enumerable:!0,configurable:!0}})}(),function(){function t(X,$,J){return X=X||function(){},Q.markSupportedForProcessing(X),$&&o(X.prototype,$),J&&o(X,J),X}X.Namespace.define("WinJS.Class",{define:t,derive:function(X,$,J,ee){if(X){$=$||function(){};var te=X.prototype;return $.prototype=Object.create(te),Q.markSupportedForProcessing($),Object.defineProperty($.prototype,"constructor",{value:$,writable:!0,configurable:!0,enumerable:!0}),J&&o($.prototype,J),ee&&o($,ee),$}return t($,J,ee)},mix:function(X){var $,Q;for(X=X||function(){},$=1,Q=arguments.length;$<Q;$++)o(X.prototype,arguments[$]);return X}})}(),{Namespace:X.Namespace,Class:X.Class}})),t("WinJS/Core/_ErrorFromName",["WinJS/Core/_Base"],(function(X){var $=X.Class.derive(Error,(function(X,$){this.name=X,this.message=$||X}),{},{supportedForProcessing:!1});return X.Namespace.define("WinJS",{ErrorFromName:$}),$})),t("WinJS/Core/_Events",["exports","WinJS/Core/_Base"],(function(X,$){function n(X){var $="_on"+X+"state";return{get:function(){var X=this[$];return X&&X.userHandler},set:function(Q){var J=this[$];Q?(J||(J={wrapper:function(X){return J.userHandler(X)},userHandler:Q},Object.defineProperty(this,$,{value:J,enumerable:!1,writable:!0,configurable:!0}),this.addEventListener(X,J.wrapper,!1)),J.userHandler=Q):J&&(this.removeEventListener(X,J.wrapper,!1),this[$]=null)},enumerable:!0}}var Q=$.Class.define((function(X,$,Q){this.detail=$,this.target=Q,this.timeStamp=Date.now(),this.type=X}),{bubbles:{value:!1,writable:!1},cancelable:{value:!1,writable:!1},currentTarget:{get:function(){return this.target}},defaultPrevented:{get:function(){return this._preventDefaultCalled}},trusted:{value:!1,writable:!1},eventPhase:{value:0,writable:!1},target:null,timeStamp:null,type:null,preventDefault:function(){this._preventDefaultCalled=!0},stopImmediatePropagation:function(){this._stopImmediatePropagationCalled=!0},stopPropagation:function(){}},{supportedForProcessing:!1}),J={_listeners:null,addEventListener:function(X,$,Q){Q=Q||!1,this._listeners=this._listeners||{};for(var J=this._listeners[X]=this._listeners[X]||[],ee=0,te=J.length;ee<te;ee++){var ne=J[ee];if(ne.useCapture===Q&&ne.listener===$)return}J.push({listener:$,useCapture:Q})},dispatchEvent:function(X,$){var J=this._listeners&&this._listeners[X];if(J){for(var ee=new Q(X,$,this),te=0,ne=(J=J.slice(0,J.length)).length;te<ne&&!ee._stopImmediatePropagationCalled;te++)J[te].listener(ee);return ee.defaultPrevented||!1}return!1},removeEventListener:function(X,$,Q){Q=Q||!1;var J=this._listeners&&this._listeners[X];if(J)for(var ee=0,te=J.length;ee<te;ee++){var ne=J[ee];if(ne.listener===$&&ne.useCapture===Q){J.splice(ee,1),0===J.length&&delete this._listeners[X];break}}}};$.Namespace._moduleDefine(X,"WinJS.Utilities",{_createEventProperty:n,createEventProperties:function(){for(var X={},$=0,Q=arguments.length;$<Q;$++){var J=arguments[$];X["on"+J]=n(J)}return X},eventMixin:J})})),t("WinJS/Core/_Trace",["WinJS/Core/_Global"],(function(X){function t(X){return X}return{_traceAsyncOperationStarting:X.Debug&&X.Debug.msTraceAsyncOperationStarting&&X.Debug.msTraceAsyncOperationStarting.bind(X.Debug)||t,_traceAsyncOperationCompleted:X.Debug&&X.Debug.msTraceAsyncOperationCompleted&&X.Debug.msTraceAsyncOperationCompleted.bind(X.Debug)||t,_traceAsyncCallbackStarting:X.Debug&&X.Debug.msTraceAsyncCallbackStarting&&X.Debug.msTraceAsyncCallbackStarting.bind(X.Debug)||t,_traceAsyncCallbackCompleted:X.Debug&&X.Debug.msTraceAsyncCallbackCompleted&&X.Debug.msTraceAsyncCallbackCompleted.bind(X.Debug)||t}})),t("WinJS/Promise/_StateMachine",["WinJS/Core/_Global","WinJS/Core/_BaseCoreUtils","WinJS/Core/_Base","WinJS/Core/_ErrorFromName","WinJS/Core/_Events","WinJS/Core/_Trace"],(function(X,$,Q,J,ee,te){function s(){}function a(X,$){var Q;Q=$&&"object"==typeof $&&"function"==typeof $.then?ue:pe,X._value=$,X._setState(Q)}function l(X,$,Q,J,ee,te){return{exception:X,error:$,promise:Q,handler:te,id:J,parent:ee}}function u(X,$,Q,J){var ee=Q._isException;return l(ee?$:null,ee?null:$,X,Q._errorId,Q,J)}function d(X,$,Q){var J=Q._isException,ee=Q._errorId;return C(X,ee,J),l(J?$:null,J?null:$,X,ee,Q)}function c(X,$){var Q=++ve;return C(X,Q),l(null,$,X,Q)}function h(X,$){var Q=++ve;return C(X,Q,!0),l($,null,X,Q)}function p(X,$,Q,J){y(X,{c:$,e:Q,p:J,asyncOpID:te._traceAsyncOperationStarting("WinJS.Promise.done")})}function f(X,$,Q,J){X._value=$,v(X,$,Q,J),X._setState(ge)}function g($,Q){var J,ee,ne=$._value,ie=$._listeners;if(ie)for($._listeners=null,J=0,ee=Array.isArray(ie)?ie.length:1;J<ee;J++){var oe=1===ee?ie:ie[J],re=oe.c,se=oe.promise;if(te._traceAsyncOperationCompleted(oe.asyncOpID,X.Debug&&X.Debug.MS_ASYNC_OP_STATUS_SUCCESS),se){te._traceAsyncCallbackStarting(oe.asyncOpID);try{se._setCompleteValue(re?re(ne):ne)}catch(X){se._setExceptionValue(X)}finally{te._traceAsyncCallbackCompleted()}se._state!==ue&&se._listeners&&Q.push(se)}else Se.prototype.done.call($,re)}}function m($,Q){var J,ee,ne=$._value,ie=$._listeners;if(ie)for($._listeners=null,J=0,ee=Array.isArray(ie)?ie.length:1;J<ee;J++){var re=1===ee?ie:ie[J],se=re.e,ae=re.promise,le=X.Debug&&(ne&&ne.name===oe?X.Debug.MS_ASYNC_OP_STATUS_CANCELED:X.Debug.MS_ASYNC_OP_STATUS_ERROR);if(te._traceAsyncOperationCompleted(re.asyncOpID,le),ae){var de=!1;try{se?(te._traceAsyncCallbackStarting(re.asyncOpID),de=!0,se.handlesOnError||v(ae,ne,u,$,se),ae._setCompleteValue(se(ne))):ae._setChainedErrorValue(ne,$)}catch(X){ae._setExceptionValue(X)}finally{de&&te._traceAsyncCallbackCompleted()}ae._state!==ue&&ae._listeners&&Q.push(ae)}else Ce.prototype.done.call($,null,se)}}function v(X,$,Q,J,ee){if(ne._listeners[ie]){if($ instanceof Error&&$.message===oe)return;ne.dispatchEvent(ie,Q(X,$,J,ee))}}function _(X,$){var Q,J,ee=X._listeners;if(ee)for(Q=0,J=Array.isArray(ee)?ee.length:1;Q<J;Q++){var te=1===J?ee:ee[Q],ne=te.p;if(ne)try{ne($)}catch(X){}te.c||te.e||!te.promise||te.promise._progress($)}}function y(X,$){var Q=X._listeners;Q?(Q=Array.isArray(Q)?Q:[Q]).push($):Q=$,X._listeners=Q}function C(X,$,Q){X._isException=Q||!1,X._errorId=$}function b(X,$,Q,J){X._value=$,v(X,$,Q,J),X._setState(me)}function S(X,$){var Q;Q=$&&"object"==typeof $&&"function"==typeof $.then?ue:fe,X._value=$,X._setState(Q)}function w(X,$,Q,J){var ee=new be(X);return y(X,{promise:ee,c:$,e:Q,p:J,asyncOpID:te._traceAsyncOperationStarting("WinJS.Promise.then")}),ee}X.Debug&&(X.Debug.setNonUserCodeExceptions=!0);var ne=new(Q.Class.mix(Q.Class.define(null,{},{supportedForProcessing:!1}),ee.eventMixin));ne._listeners={};var ie="error",oe="Canceled",re=!1,se={promise:1,thenPromise:2,errorPromise:4,exceptionPromise:8,completePromise:16};se.all=se.promise|se.thenPromise|se.errorPromise|se.exceptionPromise|se.completePromise;var ae,le,ue,de,ce,he,pe,fe,ge,me,ve=1;ae={name:"created",enter:function(X){X._setState(le)},cancel:s,done:s,then:s,_completed:s,_error:s,_notify:s,_progress:s,_setCompleteValue:s,_setErrorValue:s},le={name:"working",enter:s,cancel:function(X){X._setState(ce)},done:p,then:w,_completed:a,_error:f,_notify:s,_progress:_,_setCompleteValue:S,_setErrorValue:b},ue={name:"waiting",enter:function(X){var $=X._value;if($ instanceof be&&$._state!==me&&$._state!==fe)y($,{promise:X});else{var n=function(Q){$._errorId?X._chainedError(Q,$):(v(X,Q,u,$,n),X._error(Q))};n.handlesOnError=!0,$.then(X._completed.bind(X),n,X._progress.bind(X))}},cancel:function(X){X._setState(de)},done:p,then:w,_completed:a,_error:f,_notify:s,_progress:_,_setCompleteValue:S,_setErrorValue:b},de={name:"waiting_canceled",enter:function(X){X._setState(he);var $=X._value;$.cancel&&$.cancel()},cancel:s,done:p,then:w,_completed:a,_error:f,_notify:s,_progress:_,_setCompleteValue:S,_setErrorValue:b},ce={name:"canceled",enter:function(X){X._setState(he),X._cancelAction()},cancel:s,done:p,then:w,_completed:a,_error:f,_notify:s,_progress:_,_setCompleteValue:S,_setErrorValue:b},he={name:"canceling",enter:function(X){var $=new Error(oe);$.name=$.message,X._value=$,X._setState(ge)},cancel:s,done:s,then:s,_completed:s,_error:s,_notify:s,_progress:s,_setCompleteValue:s,_setErrorValue:s},pe={name:"complete_notify",enter:function(X){if(X.done=Se.prototype.done,X.then=Se.prototype.then,X._listeners)for(var $,Q=[X];Q.length;)($=Q.shift())._state._notify($,Q);X._setState(fe)},cancel:s,done:null,then:null,_completed:s,_error:s,_notify:g,_progress:s,_setCompleteValue:s,_setErrorValue:s},fe={name:"success",enter:function(X){X.done=Se.prototype.done,X.then=Se.prototype.then,X._cleanupAction()},cancel:s,done:null,then:null,_completed:s,_error:s,_notify:g,_progress:s,_setCompleteValue:s,_setErrorValue:s},ge={name:"error_notify",enter:function(X){if(X.done=Ce.prototype.done,X.then=Ce.prototype.then,X._listeners)for(var $,Q=[X];Q.length;)($=Q.shift())._state._notify($,Q);X._setState(me)},cancel:s,done:null,then:null,_completed:s,_error:s,_notify:m,_progress:s,_setCompleteValue:s,_setErrorValue:s},me={name:"error",enter:function(X){X.done=Ce.prototype.done,X.then=Ce.prototype.then,X._cleanupAction()},cancel:s,done:null,then:null,_completed:s,_error:s,_notify:m,_progress:s,_setCompleteValue:s,_setErrorValue:s};var _e,ye=Q.Class.define(null,{_listeners:null,_nextState:null,_state:null,_value:null,cancel:function(){this._state.cancel(this),this._run()},done:function(X,$,Q){this._state.done(this,X,$,Q)},then:function e(X,$,Q){if(this.then===e)return this._state.then(this,X,$,Q);this.then(X,$,Q)},_chainedError:function(X,$){var Q=this._state._error(this,X,d,$);return this._run(),Q},_completed:function(X){var $=this._state._completed(this,X);return this._run(),$},_error:function(X){var $=this._state._error(this,X,c);return this._run(),$},_progress:function(X){this._state._progress(this,X)},_setState:function(X){this._nextState=X},_setCompleteValue:function(X){this._state._setCompleteValue(this,X),this._run()},_setChainedErrorValue:function(X,$){var Q=this._state._setErrorValue(this,X,d,$);return this._run(),Q},_setExceptionValue:function(X){var $=this._state._setErrorValue(this,X,h);return this._run(),$},_run:function(){for(;this._nextState;)this._state=this._nextState,this._nextState=null,this._state.enter(this)}},{supportedForProcessing:!1}),be=Q.Class.derive(ye,(function(X){re&&(!0===re||re&se.thenPromise)&&(this._stack=Ee._getStack()),this._creator=X,this._setState(ae),this._run()}),{_creator:null,_cancelAction:function(){this._creator&&this._creator.cancel()},_cleanupAction:function(){this._creator=null}},{supportedForProcessing:!1}),Ce=Q.Class.define((function(X){re&&(!0===re||re&se.errorPromise)&&(this._stack=Ee._getStack()),this._value=X,v(this,X,c)}),{cancel:function(){},done:function(X,$){var Q=this._value;if($)try{$.handlesOnError||v(null,Q,u,this,$);var J=$(Q);return void(J&&"object"==typeof J&&"function"==typeof J.done&&J.done())}catch(X){Q=X}Q instanceof Error&&Q.message===oe||Ee._doneHandler(Q)},then:function(X,$){if(!$)return this;var Q,J=this._value;try{$.handlesOnError||v(null,J,u,this,$),Q=new Se($(J))}catch(X){Q=X===J?this:new we(X)}return Q}},{supportedForProcessing:!1}),we=Q.Class.derive(Ce,(function(X){re&&(!0===re||re&se.exceptionPromise)&&(this._stack=Ee._getStack()),this._value=X,v(this,X,h)}),{},{supportedForProcessing:!1}),Se=Q.Class.define((function(X){if(re&&(!0===re||re&se.completePromise)&&(this._stack=Ee._getStack()),X&&"object"==typeof X&&"function"==typeof X.then){var $=new be(null);return $._setCompleteValue(X),$}this._value=X}),{cancel:function(){},done:function(X){if(X)try{var $=X(this._value);$&&"object"==typeof $&&"function"==typeof $.done&&$.done()}catch(X){Ee._doneHandler(X)}},then:function(X){try{var $=X?X(this._value):this._value;return $===this._value?this:new Se($)}catch(X){return new we(X)}}},{supportedForProcessing:!1}),Ee=Q.Class.derive(ye,(function(X,$){re&&(!0===re||re&se.promise)&&(this._stack=Ee._getStack()),this._oncancel=$,this._setState(ae),this._run();try{X(this._completed.bind(this),this._error.bind(this),this._progress.bind(this))}catch(X){this._setExceptionValue(X)}}),{_oncancel:null,_cancelAction:function(){try{if(!this._oncancel)throw new Error("Promise did not implement oncancel");this._oncancel()}catch(X){X.message,X.stack,ne.dispatchEvent("error",X)}},_cleanupAction:function(){this._oncancel=null}},{addEventListener:function(X,$,Q){ne.addEventListener(X,$,Q)},any:function(X){return new Ee((function($,Q){var J=Object.keys(X);0===J.length&&$();var ee=0;J.forEach((function(te){Ee.as(X[te]).then((function(){$({key:te,value:X[te]})}),(function(ne){ne instanceof Error&&ne.name===oe?++ee===J.length&&$(Ee.cancel):Q({key:te,value:X[te]})}))}))}),(function(){Object.keys(X).forEach((function($){var Q=Ee.as(X[$]);"function"==typeof Q.cancel&&Q.cancel()}))}))},as:function(X){return X&&"object"==typeof X&&"function"==typeof X.then?X:new Se(X)},cancel:{get:function(){return _e=_e||new Ce(new J(oe))}},dispatchEvent:function(X,$){return ne.dispatchEvent(X,$)},is:function(X){return X&&"object"==typeof X&&"function"==typeof X.then},join:function(X){return new Ee((function($,Q,J){var ee=Object.keys(X),te=Array.isArray(X)?[]:{},ne=Array.isArray(X)?[]:{},ie=0,re=ee.length,u=function(X){if(0==--re){var ie=Object.keys(te).length;if(0===ie)$(ne);else{var se=0;ee.forEach((function(X){var $=te[X];$ instanceof Error&&$.name===oe&&se++})),se===ie?$(Ee.cancel):Q(te)}}else J({Key:X,Done:!0})};ee.forEach((function($){var Q=X[$];void 0===Q?ie++:Ee.then(Q,(function(X){ne[$]=X,u($)}),(function(X){te[$]=X,u($)}))})),0!=(re-=ie)||$(ne)}),(function(){Object.keys(X).forEach((function($){var Q=Ee.as(X[$]);"function"==typeof Q.cancel&&Q.cancel()}))}))},removeEventListener:function(X,$,Q){ne.removeEventListener(X,$,Q)},supportedForProcessing:!1,then:function(X,$,Q,J){return Ee.as(X).then($,Q,J)},thenEach:function(X,$,Q,J){var ee=Array.isArray(X)?[]:{};return Object.keys(X).forEach((function(te){ee[te]=Ee.as(X[te]).then($,Q,J)})),Ee.join(ee)},timeout:function(Q,J){var ee=function(Q){var J;return new Ee((function(ee){Q?J=X.setTimeout(ee,Q):$._setImmediate(ee)}),(function(){J&&X.clearTimeout(J)}))}(Q);return J?function(X,$){var n=function(){X.cancel()};return X.then((function(){$.cancel()})),$.then(n,n),$}(ee,J):ee},wrap:function(X){return new Se(X)},wrapError:function(X){return new Ce(X)},_veryExpensiveTagWithStack:{get:function(){return re},set:function(X){re=X}},_veryExpensiveTagWithStack_tag:se,_getStack:function(){if(X.Debug&&X.Debug.debuggerEnabled)try{throw new Error}catch(X){return X.stack}},_cancelBlocker:function(X,$){if(!Ee.is(X))return Ee.wrap(X);var Q,J,ee=new Ee((function(X,$){Q=X,J=$}),(function(){Q=null,J=null,$&&$()}));return X.then((function(X){Q&&Q(X)}),(function(X){J&&J(X)})),ee}});return Object.defineProperties(Ee,ee.createEventProperties(ie)),Ee._doneHandler=function(X){$._setImmediate((function(){throw X}))},{PromiseStateMachine:ye,Promise:Ee,state_created:ae}})),t("WinJS/Promise",["WinJS/Core/_Base","WinJS/Promise/_StateMachine"],(function(X,$){return X.Namespace.define("WinJS",{Promise:$.Promise}),$.Promise})),(ee=X["WinJS/Core/_WinJS"]).TPromise=ee.Promise,ee.PPromise=ee.Promise,"undefined"==typeof exports&&"function"==typeof define&&define.amd?define("vs/base/common/winjs.base",[],ee):module.exports=ee}(),define(Q[11],n([0,1,53]),(function(X,$,Q){function i(X){o(X)||$.errorHandler.onUnexpectedError(X)}function o(X){return X instanceof Error&&X.name===te&&X.message===te}Object.defineProperty($,"__esModule",{value:!0});var J={};Q.TPromise.addEventListener("error",(function(X){var $=X.detail,Q=$.id;$.parent?$.handler&&J&&delete J[Q]:(J[Q]=$,1===Object.keys(J).length&&setTimeout((function(){var X=J;J={},Object.keys(X).forEach((function($){var Q=X[$];Q.exception?i(Q.exception):Q.error&&i(Q.error),console.log("WARNING: Promise with no error callback:"+Q.id),console.log(Q),Q.exception&&console.log(Q.exception.stack)}))}),0))}));var ee=function(){function e(){this.listeners=[],this.unexpectedErrorHandler=function(X){setTimeout((function(){if(X.stack)throw new Error(X.message+"\n\n"+X.stack);throw X}),0)}}return e.prototype.emit=function(X){this.listeners.forEach((function($){$(X)}))},e.prototype.onUnexpectedError=function(X){this.unexpectedErrorHandler(X),this.emit(X)},e.prototype.onUnexpectedExternalError=function(X){this.unexpectedErrorHandler(X)},e}();$.ErrorHandler=ee,$.errorHandler=new ee,$.onUnexpectedError=i,$.onUnexpectedExternalError=function(X){o(X)||$.errorHandler.onUnexpectedExternalError(X)},$.transformErrorForSerialization=function(X){return X instanceof Error?{$isError:!0,name:X.name,message:X.message,stack:X.stacktrace||X.stack}:X};var te="Canceled";$.isPromiseCanceledError=o,$.canceled=function(){var X=new Error(te);return X.name=X.message,X},$.illegalArgument=function(X){return X?new Error("Illegal argument: "+X):new Error("Illegal argument")},$.illegalState=function(X){return X?new Error("Illegal state: "+X):new Error("Illegal state")}})),define(Q[6],n([0,1,11,414,2,160]),(function(X,$,Q,J,ee,te){function s(X,$){return function(Q,J,ee){return void 0===J&&(J=null),X((function(X){return Q.call(J,$(X))}),null,ee)}}function a(X,$){return function(Q,J,ee){return void 0===J&&(J=null),X((function(X){return $(X)&&Q.call(J,X)}),null,ee)}}var ne;Object.defineProperty($,"__esModule",{value:!0}),function(X){var $={dispose:function(){}};X.None=function(){return $}}(ne=$.Event||($.Event={}));var ie=function(){function e(X){void 0===X&&(X=null),this._options=X,this._event=null,this._disposed=!1,this._deliveryQueue=null,this._listeners=null}return Object.defineProperty(e.prototype,"event",{get:function(){var X=this;return this._event||(this._event=function($,Q,J){X._listeners||(X._listeners=new te.LinkedList);var ee=X._listeners.isEmpty();ee&&X._options&&X._options.onFirstListenerAdd&&X._options.onFirstListenerAdd(X);var ne,ie=X._listeners.push(Q?[$,Q]:$);return ee&&X._options&&X._options.onFirstListenerDidAdd&&X._options.onFirstListenerDidAdd(X),X._options&&X._options.onListenerDidAdd&&X._options.onListenerDidAdd(X,$,Q),ne={dispose:function(){ne.dispose=e._noop,!X._disposed&&(ie(),X._options&&X._options.onLastListenerRemove)&&(X._listeners&&!X._listeners.isEmpty()||X._options.onLastListenerRemove(X))}},Array.isArray(J)&&J.push(ne),ne}),this._event},enumerable:!0,configurable:!0}),e.prototype.fire=function(X){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=[]);for(var $=this._listeners.iterator(),J=$.next();!J.done;J=$.next())this._deliveryQueue.push([J.value,X]);for(;this._deliveryQueue.length>0;){var ee=this._deliveryQueue.shift(),te=ee[0],ne=ee[1];try{"function"==typeof te?te.call(void 0,ne):te[0].call(te[1],ne)}catch(J){Q.onUnexpectedError(J)}}}},e.prototype.dispose=function(){this._listeners&&(this._listeners=null),this._deliveryQueue&&(this._deliveryQueue.length=0),this._disposed=!0},e._noop=function(){},e}();$.Emitter=ie;var oe=function(){function e(){var X=this;this.hasListeners=!1,this.events=[],this.emitter=new ie({onFirstListenerAdd:function(){return X.onFirstListenerAdd()},onLastListenerRemove:function(){return X.onLastListenerRemove()}})}return Object.defineProperty(e.prototype,"event",{get:function(){return this.emitter.event},enumerable:!0,configurable:!0}),e.prototype.add=function(X){var $=this,Q={event:X,listener:null};return this.events.push(Q),this.hasListeners&&this.hook(Q),ee.toDisposable(J.once((function(){$.hasListeners&&$.unhook(Q);var X=$.events.indexOf(Q);$.events.splice(X,1)})))},e.prototype.onFirstListenerAdd=function(){var X=this;this.hasListeners=!0,this.events.forEach((function($){return X.hook($)}))},e.prototype.onLastListenerRemove=function(){var X=this;this.hasListeners=!1,this.events.forEach((function($){return X.unhook($)}))},e.prototype.hook=function(X){var $=this;X.listener=X.event((function(X){return $.emitter.fire(X)}))},e.prototype.unhook=function(X){X.listener&&X.listener.dispose(),X.listener=null},e.prototype.dispose=function(){this.emitter.dispose()},e}();$.EventMultiplexer=oe,$.once=function(X){return function($,Q,J){void 0===Q&&(Q=null);var ee=!1,te=X((function(X){if(!ee)return te?te.dispose():ee=!0,$.call(Q,X)}),null,J);return ee&&te.dispose(),te}},$.anyEvent=function(){for(var X=[],$=0;$<arguments.length;$++)X[$]=arguments[$];return function($,Q,J){return void 0===Q&&(Q=null),ee.combinedDisposable(X.map((function(X){return X((function(X){return $.call(Q,X)}),null,J)})))}},$.debounceEvent=function(X,$,Q,J){void 0===Q&&(Q=100),void 0===J&&(J=!1);var ee,te=void 0,ne=void 0,oe=0,re=new ie({onFirstListenerAdd:function(){ee=X((function(X){oe++,te=$(te,X),J&&!ne&&re.fire(te),clearTimeout(ne),ne=setTimeout((function(){var X=te;te=void 0,ne=void 0,(!J||oe>1)&&re.fire(X),oe=0}),Q)}))},onLastListenerRemove:function(){ee.dispose()}});return re.event};var re=function(){function e(){this.buffers=[]}return e.prototype.wrapEvent=function(X){var $=this;return function(Q,J,ee){return X((function(X){var ee=$.buffers[$.buffers.length-1];ee?ee.push((function(){return Q.call(J,X)})):Q.call(J,X)}),void 0,ee)}},e.prototype.bufferEvents=function(X){var $=[];this.buffers.push($);var Q=X();return this.buffers.pop(),$.forEach((function(X){return X()})),Q},e}();$.EventBufferer=re,$.mapEvent=s,$.filterEvent=a;var se=function(){function e(X){this._event=X}return Object.defineProperty(e.prototype,"event",{get:function(){return this._event},enumerable:!0,configurable:!0}),e.prototype.map=function(X){return new e(s(this._event,X))},e.prototype.filter=function(X){return new e(a(this._event,X))},e.prototype.on=function(X,$,Q){return this._event(X,$,Q)},e}();$.chain=function(X){return new se(X)};var ae=function(){function e(){var X=this;this.listening=!1,this.inputEvent=ne.None,this.inputEventListener=ee.Disposable.None,this.emitter=new ie({onFirstListenerDidAdd:function(){X.listening=!0,X.inputEventListener=X.inputEvent(X.emitter.fire,X.emitter)},onLastListenerRemove:function(){X.listening=!1,X.inputEventListener.dispose()}}),this.event=this.emitter.event}return Object.defineProperty(e.prototype,"input",{set:function(X){this.inputEvent=X,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=X(this.emitter.fire,this.emitter))},enumerable:!0,configurable:!0}),e.prototype.dispose=function(){this.inputEventListener.dispose(),this.emitter.dispose()},e}();$.Relay=ae})),define(Q[29],n([0,1,6]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(){function e(){this._zoomLevel=0,this._lastZoomLevelChangeTime=0,this._onDidChangeZoomLevel=new Q.Emitter,this.onDidChangeZoomLevel=this._onDidChangeZoomLevel.event,this._accessibilitySupport=0,this._onDidChangeAccessibilitySupport=new Q.Emitter,this.onDidChangeAccessibilitySupport=this._onDidChangeAccessibilitySupport.event}return e.prototype.getZoomLevel=function(){return this._zoomLevel},e.prototype.getTimeSinceLastZoomLevelChanged=function(){return Date.now()-this._lastZoomLevelChangeTime},e.prototype.getPixelRatio=function(){var X=document.createElement("canvas").getContext("2d");return(window.devicePixelRatio||1)/(X.webkitBackingStorePixelRatio||X.mozBackingStorePixelRatio||X.msBackingStorePixelRatio||X.oBackingStorePixelRatio||X.backingStorePixelRatio||1)},e.prototype.getAccessibilitySupport=function(){return this._accessibilitySupport},e.INSTANCE=new e,e}();$.getZoomLevel=function(){return J.INSTANCE.getZoomLevel()},$.getTimeSinceLastZoomLevelChanged=function(){return J.INSTANCE.getTimeSinceLastZoomLevelChanged()},$.onDidChangeZoomLevel=function(X){return J.INSTANCE.onDidChangeZoomLevel(X)},$.getPixelRatio=function(){return J.INSTANCE.getPixelRatio()},$.getAccessibilitySupport=function(){return J.INSTANCE.getAccessibilitySupport()},$.onDidChangeAccessibilitySupport=function(X){return J.INSTANCE.onDidChangeAccessibilitySupport(X)};var ee=navigator.userAgent;$.isIE=ee.indexOf("Trident")>=0,$.isEdge=ee.indexOf("Edge/")>=0,$.isEdgeOrIE=$.isIE||$.isEdge,$.isFirefox=ee.indexOf("Firefox")>=0,$.isWebKit=ee.indexOf("AppleWebKit")>=0,$.isChrome=ee.indexOf("Chrome")>=0,$.isSafari=-1===ee.indexOf("Chrome")&&ee.indexOf("Safari")>=0,$.isIPad=ee.indexOf("iPad")>=0,$.isEdgeWebView=$.isEdge&&ee.indexOf("WebView/")>=0,$.hasClipboardSupport=function(){if($.isIE)return!1;if($.isEdge){var X=ee.indexOf("Edge/"),Q=parseInt(ee.substring(X+5,ee.indexOf(".",X)),10);if(!Q||Q>=12&&Q<=16)return!1}return!0}})),define(Q[72],n([0,1,6]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),$.domEvent=function(X,$,J){var o=function(X){return ee.fire(X)},ee=new Q.Emitter({onFirstListenerAdd:function(){X.addEventListener($,o,J)},onLastListenerRemove:function(){X.removeEventListener($,o,J)}});return ee.event},$.stop=function(X){return Q.mapEvent(X,(function(X){return X.preventDefault(),X.stopPropagation(),X}))}})),define(Q[52],n([0,1,29,36,17]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var te=new Array(230),ne=new Array(112);!function(){function e(X,$){te[X]=$,ne[$]=X}for(var X=0;X<ne.length;X++)ne[X]=-1;e(3,7),e(8,1),e(9,2),e(13,3),e(16,4),e(17,5),e(18,6),e(19,7),e(20,8),e(27,9),e(32,10),e(33,11),e(34,12),e(35,13),e(36,14),e(37,15),e(38,16),e(39,17),e(40,18),e(45,19),e(46,20),e(48,21),e(49,22),e(50,23),e(51,24),e(52,25),e(53,26),e(54,27),e(55,28),e(56,29),e(57,30),e(65,31),e(66,32),e(67,33),e(68,34),e(69,35),e(70,36),e(71,37),e(72,38),e(73,39),e(74,40),e(75,41),e(76,42),e(77,43),e(78,44),e(79,45),e(80,46),e(81,47),e(82,48),e(83,49),e(84,50),e(85,51),e(86,52),e(87,53),e(88,54),e(89,55),e(90,56),e(93,58),e(96,93),e(97,94),e(98,95),e(99,96),e(100,97),e(101,98),e(102,99),e(103,100),e(104,101),e(105,102),e(106,103),e(107,104),e(108,105),e(109,106),e(110,107),e(111,108),e(112,59),e(113,60),e(114,61),e(115,62),e(116,63),e(117,64),e(118,65),e(119,66),e(120,67),e(121,68),e(122,69),e(123,70),e(124,71),e(125,72),e(126,73),e(127,74),e(128,75),e(129,76),e(130,77),e(144,78),e(145,79),e(186,80),e(187,81),e(188,82),e(189,83),e(190,84),e(191,85),e(192,86),e(193,110),e(194,111),e(219,87),e(220,88),e(221,89),e(222,90),e(223,91),e(226,92),e(229,109),Q.isIE?e(91,57):Q.isFirefox?(e(59,80),e(107,81),e(109,83),ee.isMacintosh&&e(224,57)):Q.isWebKit&&(e(91,57),ee.isMacintosh?e(93,57):e(92,57))}();var ie=ee.isMacintosh?256:2048,oe=ee.isMacintosh?2048:256,re=function(){function e(X){var $=X;this.browserEvent=$,this.target=$.target,this.ctrlKey=$.ctrlKey,this.shiftKey=$.shiftKey,this.altKey=$.altKey,this.metaKey=$.metaKey,this.keyCode=function(X){if(X.charCode){var $=String.fromCharCode(X.charCode).toUpperCase();return J.KeyCodeUtils.fromString($)}return te[X.keyCode]||0}($),this.code=$.code,this.ctrlKey=this.ctrlKey||5===this.keyCode,this.altKey=this.altKey||6===this.keyCode,this.shiftKey=this.shiftKey||4===this.keyCode,this.metaKey=this.metaKey||57===this.keyCode,this._asKeybinding=this._computeKeybinding(),this._asRuntimeKeybinding=this._computeRuntimeKeybinding()}return e.prototype.preventDefault=function(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()},e.prototype.stopPropagation=function(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()},e.prototype.toKeybinding=function(){return this._asRuntimeKeybinding},e.prototype.equals=function(X){return this._asKeybinding===X},e.prototype._computeKeybinding=function(){var X=0;5!==this.keyCode&&4!==this.keyCode&&6!==this.keyCode&&57!==this.keyCode&&(X=this.keyCode);var $=0;return this.ctrlKey&&($|=ie),this.altKey&&($|=512),this.shiftKey&&($|=1024),this.metaKey&&($|=oe),$|X},e.prototype._computeRuntimeKeybinding=function(){var X=0;return 5!==this.keyCode&&4!==this.keyCode&&6!==this.keyCode&&57!==this.keyCode&&(X=this.keyCode),new J.SimpleKeybinding(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,X)},e}();$.StandardKeyboardEvent=re})),define(Q[40],n([0,1,29,164,17]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var ne=function(){function e(X){this.timestamp=Date.now(),this.browserEvent=X,this.leftButton=0===X.button,this.middleButton=1===X.button,this.rightButton=2===X.button,this.target=X.target,this.detail=X.detail||1,"dblclick"===X.type&&(this.detail=2),this.ctrlKey=X.ctrlKey,this.shiftKey=X.shiftKey,this.altKey=X.altKey,this.metaKey=X.metaKey,"number"==typeof X.pageX?(this.posx=X.pageX,this.posy=X.pageY):(this.posx=X.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=X.clientY+document.body.scrollTop+document.documentElement.scrollTop);var $=J.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(self,X.view);this.posx-=$.left,this.posy-=$.top}return e.prototype.preventDefault=function(){this.browserEvent.preventDefault&&this.browserEvent.preventDefault()},e.prototype.stopPropagation=function(){this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()},e}();$.StandardMouseEvent=ne;var ie=function(X){function t($){var Q=X.call(this,$)||this;return Q.dataTransfer=$.dataTransfer,Q}return te(t,X),t}(ne);$.DragMouseEvent=ie;var oe=function(){function e(X,$,J){if(void 0===$&&($=0),void 0===J&&(J=0),this.browserEvent=X||null,this.target=X?X.target||X.targetNode||X.srcElement:null,this.deltaY=J,this.deltaX=$,X){var te=X,ne=X;void 0!==te.wheelDeltaY?this.deltaY=te.wheelDeltaY/120:void 0!==ne.VERTICAL_AXIS&&ne.axis===ne.VERTICAL_AXIS&&(this.deltaY=-ne.detail/3),void 0!==te.wheelDeltaX?Q.isSafari&&ee.isWindows?this.deltaX=-te.wheelDeltaX/120:this.deltaX=te.wheelDeltaX/120:void 0!==ne.HORIZONTAL_AXIS&&ne.axis===ne.HORIZONTAL_AXIS&&(this.deltaX=-X.detail/3),0===this.deltaY&&0===this.deltaX&&X.wheelDelta&&(this.deltaY=X.wheelDelta/120)}}return e.prototype.preventDefault=function(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()},e.prototype.stopPropagation=function(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()},e}();$.StandardMouseWheelEvent=oe})),define(Q[56],n([0,1,2,6]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(){function e(X,$,Q,ee,te){void 0===$&&($=""),void 0===Q&&(Q=""),void 0===ee&&(ee=!0),this._onDidChange=new J.Emitter,this.onDidChange=this._onDidChange.event,this._id=X,this._label=$,this._cssClass=Q,this._enabled=ee,this._actionCallback=te}return Object.defineProperty(e.prototype,"id",{get:function(){return this._id},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"label",{get:function(){return this._label},set:function(X){this._setLabel(X)},enumerable:!0,configurable:!0}),e.prototype._setLabel=function(X){this._label!==X&&(this._label=X,this._onDidChange.fire({label:X}))},Object.defineProperty(e.prototype,"tooltip",{get:function(){return this._tooltip},set:function(X){this._setTooltip(X)},enumerable:!0,configurable:!0}),e.prototype._setTooltip=function(X){this._tooltip!==X&&(this._tooltip=X,this._onDidChange.fire({tooltip:X}))},Object.defineProperty(e.prototype,"class",{get:function(){return this._cssClass},set:function(X){this._setClass(X)},enumerable:!0,configurable:!0}),e.prototype._setClass=function(X){this._cssClass!==X&&(this._cssClass=X,this._onDidChange.fire({class:X}))},Object.defineProperty(e.prototype,"enabled",{get:function(){return this._enabled},set:function(X){this._setEnabled(X)},enumerable:!0,configurable:!0}),e.prototype._setEnabled=function(X){this._enabled!==X&&(this._enabled=X,this._onDidChange.fire({enabled:X}))},Object.defineProperty(e.prototype,"checked",{get:function(){return this._checked},set:function(X){this._setChecked(X)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"radio",{get:function(){return this._radio},set:function(X){this._setRadio(X)},enumerable:!0,configurable:!0}),e.prototype._setChecked=function(X){this._checked!==X&&(this._checked=X,this._onDidChange.fire({checked:X}))},e.prototype._setRadio=function(X){this._radio!==X&&(this._radio=X,this._onDidChange.fire({radio:X}))},e.prototype.run=function(X,$){return this._actionCallback?this._actionCallback(X):Promise.resolve(!0)},e.prototype.dispose=function(){this._onDidChange.dispose()},e}();$.Action=ee;var ne=function(X){function t(){var $=null!==X&&X.apply(this,arguments)||this;return $._onDidBeforeRun=$._register(new J.Emitter),$.onDidBeforeRun=$._onDidBeforeRun.event,$._onDidRun=$._register(new J.Emitter),$.onDidRun=$._onDidRun.event,$}return te(t,X),t.prototype.run=function(X,$){var Q=this;return X.enabled?(this._onDidBeforeRun.fire({action:X}),this.runAction(X,$).then((function($){Q._onDidRun.fire({action:X,result:$})}),(function($){Q._onDidRun.fire({action:X,error:$})}))):Promise.resolve(null)},t.prototype.runAction=function(X,$){var Q=$?X.run($):X.run();return Promise.resolve(Q)},t}(Q.Disposable);$.ActionRunner=ne})),define(Q[24],n([0,1,6]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J,ee=Object.freeze((function(X,$){var Q=setTimeout(X.bind($),0);return{dispose:function(){clearTimeout(Q)}}}));!function(X){X.isCancellationToken=function($){return $===X.None||$===X.Cancelled||$ instanceof te||!(!$||"object"!=typeof $)&&"boolean"==typeof $.isCancellationRequested&&"function"==typeof $.onCancellationRequested},X.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:Q.Event.None}),X.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:ee})}(J=$.CancellationToken||($.CancellationToken={}));var te=function(){function e(){this._isCancelled=!1,this._emitter=null}return e.prototype.cancel=function(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))},Object.defineProperty(e.prototype,"isCancellationRequested",{get:function(){return this._isCancelled},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onCancellationRequested",{get:function(){return this._isCancelled?ee:(this._emitter||(this._emitter=new Q.Emitter),this._emitter.event)},enumerable:!0,configurable:!0}),e.prototype.dispose=function(){this._emitter&&(this._emitter.dispose(),this._emitter=null)},e}(),ne=function(){function e(){}return Object.defineProperty(e.prototype,"token",{get:function(){return this._token||(this._token=new te),this._token},enumerable:!0,configurable:!0}),e.prototype.cancel=function(){this._token?this._token instanceof te&&this._token.cancel():this._token=J.Cancelled},e.prototype.dispose=function(){this._token?this._token instanceof te&&this._token.dispose():this._token=J.None},e}();$.CancellationTokenSource=ne})),define(Q[16],n([0,1,24,11,2,53]),(function(X,$,Q,J,ee,ne){function a(X){var $=new Q.CancellationTokenSource,ee=X($.token),te=new Promise((function(X,Q){$.token.onCancellationRequested((function(){Q(J.canceled())})),Promise.resolve(ee).then((function(Q){$.dispose(),X(Q)}),(function(X){$.dispose(),Q(X)}))}));return new(function(){function e(){}return e.prototype.cancel=function(){$.cancel()},e.prototype.then=function(X,$){return te.then(X,$)},e.prototype.catch=function(X){return this.then(void 0,X)},e}())}Object.defineProperty($,"__esModule",{value:!0}),$.isThenable=function(X){return X&&"function"==typeof X.then},$.createCancelablePromise=a;var ie=function(){function e(X){this.defaultDelay=X,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.task=null}return e.prototype.trigger=function(X,$){var Q=this;return void 0===$&&($=this.defaultDelay),this.task=X,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new ne.TPromise((function(X,$){Q.doResolve=X,Q.doReject=$})).then((function(){Q.completionPromise=null,Q.doResolve=null;var X=Q.task;return Q.task=null,X()}))),this.timeout=setTimeout((function(){Q.timeout=null,Q.doResolve(null)}),$),this.completionPromise},e.prototype.cancel=function(){this.cancelTimeout(),this.completionPromise&&(this.doReject(J.canceled()),this.completionPromise=null)},e.prototype.cancelTimeout=function(){null!==this.timeout&&(clearTimeout(this.timeout),this.timeout=null)},e.prototype.dispose=function(){this.cancelTimeout()},e}();$.Delayer=ie,$.timeout=function l(X,$){return $?new Promise((function(Q,ee){var te=setTimeout(Q,X);$.onCancellationRequested((function(){clearTimeout(te),ee(J.canceled())}))})):a((function($){return l(X,$)}))},$.always=function(X,$){function n(){try{$()}catch(X){J.onUnexpectedError(X)}}return X.then((function(X){return n()}),(function(X){return n()})),Promise.resolve(X)},$.first=function(X,$,Q){void 0===$&&($=function(X){return!!X}),void 0===Q&&(Q=null);var J=0,ee=X.length,r=function(){if(J>=ee)return Promise.resolve(Q);var te=X[J++];return Promise.resolve(te()).then((function(X){return $(X)?Promise.resolve(X):r()}))};return r()};var oe=function(X){function t($,Q){var J=X.call(this)||this;return J._token=-1,"function"==typeof $&&"number"==typeof Q&&J.setIfNotSet($,Q),J}return te(t,X),t.prototype.dispose=function(){this.cancel(),X.prototype.dispose.call(this)},t.prototype.cancel=function(){-1!==this._token&&(clearTimeout(this._token),this._token=-1)},t.prototype.cancelAndSet=function(X,$){var Q=this;this.cancel(),this._token=setTimeout((function(){Q._token=-1,X()}),$)},t.prototype.setIfNotSet=function(X,$){var Q=this;-1===this._token&&(this._token=setTimeout((function(){Q._token=-1,X()}),$))},t}(ee.Disposable);$.TimeoutTimer=oe;var re=function(X){function t(){var $=X.call(this)||this;return $._token=-1,$}return te(t,X),t.prototype.dispose=function(){this.cancel(),X.prototype.dispose.call(this)},t.prototype.cancel=function(){-1!==this._token&&(clearInterval(this._token),this._token=-1)},t.prototype.cancelAndSet=function(X,$){this.cancel(),this._token=setInterval((function(){X()}),$)},t}(ee.Disposable);$.IntervalTimer=re;var se=function(){function e(X,$){this.timeoutToken=-1,this.runner=X,this.timeout=$,this.timeoutHandler=this.onTimeout.bind(this)}return e.prototype.dispose=function(){this.cancel(),this.runner=null},e.prototype.cancel=function(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)},e.prototype.schedule=function(X){void 0===X&&(X=this.timeout),this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,X)},e.prototype.isScheduled=function(){return-1!==this.timeoutToken},e.prototype.onTimeout=function(){this.timeoutToken=-1,this.runner&&this.doRun()},e.prototype.doRun=function(){this.runner&&this.runner()},e}();$.RunOnceScheduler=se,function(){if("function"!=typeof requestIdleCallback||"function"!=typeof cancelIdleCallback){var X=Object.freeze({didTimeout:!0,timeRemaining:function(){return 15}});$.runWhenIdle=function($,Q){void 0===Q&&(Q=0);var J=setTimeout((function(){return $(X)}),Q),ee=!1;return{dispose:function(){ee||(ee=!0,clearTimeout(J))}}}}else $.runWhenIdle=function(X,$){var Q=requestIdleCallback(X,"number"==typeof $?{timeout:$}:void 0),J=!1;return{dispose:function(){J||(J=!0,cancelIdleCallback(Q))}}}}();var ae=function(){function e(X){var Q=this;this._executor=function(){try{Q._value=X()}catch(X){Q._error=X}finally{Q._didRun=!0}},this._handle=$.runWhenIdle((function(){return Q._executor()}))}return e.prototype.dispose=function(){this._handle.dispose()},e.prototype.getValue=function(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value},e}();$.IdleValue=ae})),define(Q[7],n([0,1,29,72,52,40,16,11,6,2,17]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae){function h(X,$,Q,J){return new ce(X,$,Q,J)}function f(X){return document.defaultView.getComputedStyle(X,null)}function g(X,$,Q){var J=f(X),ee="0";return J&&(ee=J.getPropertyValue?J.getPropertyValue($):J.getAttribute(Q)),D(X,ee)}function m(X,$){for(;X;){if(X===$)return!0;X=X.parentNode}return!1}function v(X){void 0===X&&(X=document.getElementsByTagName("head")[0]);var $=document.createElement("style");return $.type="text/css",$.media="screen",X.appendChild($),$}function _(){return ge||(ge=v()),ge}Object.defineProperty($,"__esModule",{value:!0}),$.clearNode=function(X){for(;X.firstChild;)X.removeChild(X.firstChild)},$.removeNode=function(X){X.parentNode&&X.parentNode.removeChild(X)},$.isInDOM=function(X){for(;X;){if(X===document.body)return!0;X=X.parentNode}return!1};var le=new(function(){function e(){}return e.prototype._findClassName=function(X,$){var Q=X.className;if(Q){$=$.trim();var J=Q.length,ee=$.length;if(0!==ee)if(J<ee)this._lastStart=-1;else{if(Q===$)return this._lastStart=0,void(this._lastEnd=J);for(var te,ne=-1;(ne=Q.indexOf($,ne+1))>=0;){if(te=ne+ee,(0===ne||32===Q.charCodeAt(ne-1))&&32===Q.charCodeAt(te))return this._lastStart=ne,void(this._lastEnd=te+1);if(ne>0&&32===Q.charCodeAt(ne-1)&&te===J)return this._lastStart=ne-1,void(this._lastEnd=te);if(0===ne&&te===J)return this._lastStart=0,void(this._lastEnd=te)}this._lastStart=-1}else this._lastStart=-1}else this._lastStart=-1},e.prototype.hasClass=function(X,$){return this._findClassName(X,$),-1!==this._lastStart},e.prototype.addClasses=function(X){for(var $=this,Q=[],J=1;J<arguments.length;J++)Q[J-1]=arguments[J];Q.forEach((function(Q){return Q.split(" ").forEach((function(Q){return $.addClass(X,Q)}))}))},e.prototype.addClass=function(X,$){X.className?(this._findClassName(X,$),-1===this._lastStart&&(X.className=X.className+" "+$)):X.className=$},e.prototype.removeClass=function(X,$){this._findClassName(X,$),-1!==this._lastStart&&(X.className=X.className.substring(0,this._lastStart)+X.className.substring(this._lastEnd))},e.prototype.removeClasses=function(X){for(var $=this,Q=[],J=1;J<arguments.length;J++)Q[J-1]=arguments[J];Q.forEach((function(Q){return Q.split(" ").forEach((function(Q){return $.removeClass(X,Q)}))}))},e.prototype.toggleClass=function(X,$,Q){this._findClassName(X,$),-1===this._lastStart||void 0!==Q&&Q||this.removeClass(X,$),-1!==this._lastStart||void 0!==Q&&!Q||this.addClass(X,$)},e}()),ue=new(function(){function e(){}return e.prototype.hasClass=function(X,$){return Boolean($)&&X.classList&&X.classList.contains($)},e.prototype.addClasses=function(X){for(var $=this,Q=[],J=1;J<arguments.length;J++)Q[J-1]=arguments[J];Q.forEach((function(Q){return Q.split(" ").forEach((function(Q){return $.addClass(X,Q)}))}))},e.prototype.addClass=function(X,$){$&&X.classList&&X.classList.add($)},e.prototype.removeClass=function(X,$){$&&X.classList&&X.classList.remove($)},e.prototype.removeClasses=function(X){for(var $=this,Q=[],J=1;J<arguments.length;J++)Q[J-1]=arguments[J];Q.forEach((function(Q){return Q.split(" ").forEach((function(Q){return $.removeClass(X,Q)}))}))},e.prototype.toggleClass=function(X,$,Q){X.classList&&X.classList.toggle($,Q)},e}()),de=Q.isIE?le:ue;$.hasClass=de.hasClass.bind(de),$.addClass=de.addClass.bind(de),$.addClasses=de.addClasses.bind(de),$.removeClass=de.removeClass.bind(de),$.removeClasses=de.removeClasses.bind(de),$.toggleClass=de.toggleClass.bind(de);var ce=function(){function e(X,$,Q,J){this._node=X,this._type=$,this._handler=Q,this._useCapture=J||!1,this._node.addEventListener(this._type,this._handler,this._useCapture)}return e.prototype.dispose=function(){this._handler&&(this._node.removeEventListener(this._type,this._handler,this._useCapture),this._node=null,this._handler=null)},e}();$.addDisposableListener=h,$.addStandardDisposableListener=function(X,$,Q,J){var te=Q;return"click"===$||"mousedown"===$?te=function(X){return function($){return X(new ne.StandardMouseEvent($))}}(Q):"keydown"!==$&&"keypress"!==$&&"keyup"!==$||(te=function(X){return function($){return X(new ee.StandardKeyboardEvent($))}}(Q)),h(X,$,te,J)},$.addDisposableNonBubblingMouseOutListener=function(X,$){return h(X,"mouseout",(function(Q){for(var J=Q.relatedTarget||Q.toElement;J&&J!==X;)J=J.parentNode;J!==X&&$(Q)}))};var he=null,pe=function(){function e(X,$){void 0===$&&($=0),this._runner=X,this.priority=$,this._canceled=!1}return e.prototype.dispose=function(){this._canceled=!0},e.prototype.execute=function(){if(!this._canceled)try{this._runner()}catch(X){oe.onUnexpectedError(X)}},e.sort=function(X,$){return $.priority-X.priority},e}();!function(){var X=[],Q=null,J=!1,ee=!1,r=function(){for(J=!1,Q=X,X=[],ee=!0;Q.length>0;)Q.sort(pe.sort),Q.shift().execute();ee=!1};$.scheduleAtNextAnimationFrame=function($,Q){void 0===Q&&(Q=0);var ee=new pe($,Q);return X.push(ee),J||(J=!0,function p(X){return he||(he=self.requestAnimationFrame||self.msRequestAnimationFrame||self.webkitRequestAnimationFrame||self.mozRequestAnimationFrame||self.oRequestAnimationFrame||function(X){return setTimeout((function(){return X((new Date).getTime())}),0)}),he.call(self,X)}(r)),ee},$.runAtThisOrScheduleAtNextAnimationFrame=function(X,J){if(ee){var te=new pe(X,J);return Q.push(te),te}return $.scheduleAtNextAnimationFrame(X,J)}}();var I=function(X,$){return $},fe=function(X){function t($,Q,J,ee,te){void 0===ee&&(ee=I),void 0===te&&(te=16);var ne=X.call(this)||this,oe=null,re=0,se=ne._register(new ie.TimeoutTimer),c=function(){re=(new Date).getTime(),J(oe),oe=null};return ne._register(h($,Q,(function(X){oe=ee(oe,X);var $=(new Date).getTime()-re;$>=te?(se.cancel(),c()):se.setIfNotSet(c,te-$)}))),ne}return te(t,X),t}(se.Disposable);$.addDisposableThrottledListener=function(X,$,Q,J,ee){return new fe(X,$,Q,J,ee)},$.getComputedStyle=f;var D=function(X,$){return parseFloat($)||0};$.getClientArea=function(X){if(X!==document.body)return new k(X.clientWidth,X.clientHeight);if(window.innerWidth&&window.innerHeight)return new k(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new k(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new k(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")};var M_getBorderLeftWidth=function(X){return g(X,"border-left-width","borderLeftWidth")},M_getBorderRightWidth=function(X){return g(X,"border-right-width","borderRightWidth")},M_getBorderTopWidth=function(X){return g(X,"border-top-width","borderTopWidth")},M_getBorderBottomWidth=function(X){return g(X,"border-bottom-width","borderBottomWidth")},M_getPaddingLeft=function(X){return g(X,"padding-left","paddingLeft")},M_getPaddingRight=function(X){return g(X,"padding-right","paddingRight")},M_getPaddingTop=function(X){return g(X,"padding-top","paddingTop")},M_getPaddingBottom=function(X){return g(X,"padding-bottom","paddingBottom")},M_getMarginLeft=function(X){return g(X,"margin-left","marginLeft")},M_getMarginTop=function(X){return g(X,"margin-top","marginTop")},M_getMarginRight=function(X){return g(X,"margin-right","marginRight")},M_getMarginBottom=function(X){return g(X,"margin-bottom","marginBottom")},k=function(X,$){this.width=X,this.height=$};$.Dimension=k,$.getTopLeftOffset=function(X){for(var $=X.offsetParent,Q=X.offsetTop,J=X.offsetLeft;null!==(X=X.parentNode)&&X!==document.body&&X!==document.documentElement;){Q-=X.scrollTop;var ee=f(X);ee&&(J-="rtl"!==ee.direction?X.scrollLeft:-X.scrollLeft),X===$&&(J+=M_getBorderLeftWidth(X),Q+=M_getBorderTopWidth(X),Q+=X.offsetTop,J+=X.offsetLeft,$=X.offsetParent)}return{left:J,top:Q}},$.getDomNodePagePosition=function(X){var Q=X.getBoundingClientRect();return{left:Q.left+$.StandardWindow.scrollX,top:Q.top+$.StandardWindow.scrollY,width:Q.width,height:Q.height}},$.StandardWindow=new(function(){function e(){}return Object.defineProperty(e.prototype,"scrollX",{get:function(){return"number"==typeof window.scrollX?window.scrollX:document.body.scrollLeft+document.documentElement.scrollLeft},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"scrollY",{get:function(){return"number"==typeof window.scrollY?window.scrollY:document.body.scrollTop+document.documentElement.scrollTop},enumerable:!0,configurable:!0}),e}()),$.getTotalWidth=function(X){var $=M_getMarginLeft(X)+M_getMarginRight(X);return X.offsetWidth+$},$.getContentWidth=function(X){var $=M_getBorderLeftWidth(X)+M_getBorderRightWidth(X),Q=M_getPaddingLeft(X)+M_getPaddingRight(X);return X.offsetWidth-$-Q},$.getContentHeight=function(X){var $=M_getBorderTopWidth(X)+M_getBorderBottomWidth(X),Q=M_getPaddingTop(X)+M_getPaddingBottom(X);return X.offsetHeight-$-Q},$.getTotalHeight=function(X){var $=M_getMarginTop(X)+M_getMarginBottom(X);return X.offsetHeight+$},$.isAncestor=m,$.findParentWithClass=function(X,Q,J){for(;X;){if($.hasClass(X,Q))return X;if(J)if("string"==typeof J){if($.hasClass(X,J))return null}else if(X===J)return null;X=X.parentNode}return null},$.createStyleSheet=v;var ge=null;$.createCSSRule=function(X,$,Q){void 0===Q&&(Q=_()),Q&&$&&Q.sheet.insertRule(X+"{"+$+"}",0)},$.removeCSSRulesContainingSelector=function(X,$){if(void 0===$&&($=_()),$){for(var Q=function(X){return X&&X.sheet&&X.sheet.rules?X.sheet.rules:X&&X.sheet&&X.sheet.cssRules?X.sheet.cssRules:[]}($),J=[],ee=0;ee<Q.length;ee++)-1!==Q[ee].selectorText.indexOf(X)&&J.push(ee);for(ee=J.length-1;ee>=0;ee--)$.sheet.deleteRule(J[ee])}},$.isHTMLElement=function(X){return"object"==typeof HTMLElement?X instanceof HTMLElement:X&&"object"==typeof X&&1===X.nodeType&&"string"==typeof X.nodeName},$.EventType={CLICK:"click",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",UNLOAD:"unload",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:Q.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:Q.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:Q.isWebKit?"webkitAnimationIteration":"animationiteration"},$.EventHelper={stop:function(X,$){X.preventDefault?X.preventDefault():X.returnValue=!1,$&&(X.stopPropagation?X.stopPropagation():X.cancelBubble=!0)}},$.saveParentsScrollTop=function(X){for(var $=[],Q=0;X&&X.nodeType===X.ELEMENT_NODE;Q++)$[Q]=X.scrollTop,X=X.parentNode;return $},$.restoreParentsScrollTop=function(X,$){for(var Q=0;X&&X.nodeType===X.ELEMENT_NODE;Q++)X.scrollTop!==$[Q]&&(X.scrollTop=$[Q]),X=X.parentNode};var me=function(){function e(X){var Q=this;this._onDidFocus=new re.Emitter,this.onDidFocus=this._onDidFocus.event,this._onDidBlur=new re.Emitter,this.onDidBlur=this._onDidBlur.event,this.disposables=[];var ee=m(document.activeElement,X),te=!1;J.domEvent(X,$.EventType.FOCUS,!0)((function(){te=!1,ee||(ee=!0,Q._onDidFocus.fire())}),null,this.disposables),J.domEvent(X,$.EventType.BLUR,!0)((function(){ee&&(te=!0,window.setTimeout((function(){te&&(te=!1,ee=!1,Q._onDidBlur.fire())}),0))}),null,this.disposables)}return e.prototype.dispose=function(){this.disposables=se.dispose(this.disposables),this._onDidFocus.dispose(),this._onDidBlur.dispose()},e}();$.trackFocus=function(X){return new me(X)},$.append=function(X){for(var $=[],Q=1;Q<arguments.length;Q++)$[Q-1]=arguments[Q];return $.forEach((function($){return X.appendChild($)})),$[$.length-1]};var ve=/([\w\-]+)?(#([\w\-]+))?((.([\w\-]+))*)/;$.$=function(X,$){for(var Q=[],J=2;J<arguments.length;J++)Q[J-2]=arguments[J];var ee=ve.exec(X);if(!ee)throw new Error("Bad use of emmet");var te=document.createElement(ee[1]||"div");return ee[3]&&(te.id=ee[3]),ee[4]&&(te.className=ee[4].replace(/\./g," ").trim()),$=$||{},Object.keys($).forEach((function(X){var Q=$[X];/^on\w+$/.test(X)?te[X]=Q:"selected"===X?Q&&te.setAttribute(X,"true"):te.setAttribute(X,Q)})),Q.filter((function(X){return!!X})).forEach((function(X){X instanceof Node?te.appendChild(X):te.appendChild(document.createTextNode(X))})),te},$.show=function(){for(var X=[],$=0;$<arguments.length;$++)X[$]=arguments[$];for(var Q=0,J=X;Q<J.length;Q++){var ee=J[Q];ee.style.display="",ee.removeAttribute("aria-hidden")}},$.hide=function(){for(var X=[],$=0;$<arguments.length;$++)X[$]=arguments[$];for(var Q=0,J=X;Q<J.length;Q++){var ee=J[Q];ee.style.display="none",ee.setAttribute("aria-hidden","true")}},$.removeTabIndexAndUpdateFocus=function y(X){if(X&&X.hasAttribute("tabIndex")){if(document.activeElement===X){var $=function(X,$){for(;X;){if(X instanceof HTMLElement&&X.hasAttribute("tabIndex"))return X;X=X.parentNode}return null}(X.parentElement);$&&$.focus()}X.removeAttribute("tabindex")}},$.getElementsByTagName=function(X){return Array.prototype.slice.call(document.getElementsByTagName(X),0)},$.computeScreenAwareSize=function(X){var $=window.devicePixelRatio*X;return Math.max(1,Math.floor($))/window.devicePixelRatio},$.windowOpenNoOpener=function(X){if(ae.isNative||Q.isEdgeWebView)window.open(X);else{var $=window.open();$&&($.opener=null,$.location.href=X)}}})),define(Q[23],n([0,1,7]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(){function e(X){this.domNode=X,this._maxWidth=-1,this._width=-1,this._height=-1,this._top=-1,this._left=-1,this._bottom=-1,this._right=-1,this._fontFamily="",this._fontWeight="",this._fontSize=-1,this._lineHeight=-1,this._letterSpacing=-100,this._className="",this._display="",this._position="",this._visibility="",this._layerHint=!1}return e.prototype.setMaxWidth=function(X){this._maxWidth!==X&&(this._maxWidth=X,this.domNode.style.maxWidth=this._maxWidth+"px")},e.prototype.setWidth=function(X){this._width!==X&&(this._width=X,this.domNode.style.width=this._width+"px")},e.prototype.setHeight=function(X){this._height!==X&&(this._height=X,this.domNode.style.height=this._height+"px")},e.prototype.setTop=function(X){this._top!==X&&(this._top=X,this.domNode.style.top=this._top+"px")},e.prototype.unsetTop=function(){-1!==this._top&&(this._top=-1,this.domNode.style.top="")},e.prototype.setLeft=function(X){this._left!==X&&(this._left=X,this.domNode.style.left=this._left+"px")},e.prototype.setBottom=function(X){this._bottom!==X&&(this._bottom=X,this.domNode.style.bottom=this._bottom+"px")},e.prototype.setRight=function(X){this._right!==X&&(this._right=X,this.domNode.style.right=this._right+"px")},e.prototype.setFontFamily=function(X){this._fontFamily!==X&&(this._fontFamily=X,this.domNode.style.fontFamily=this._fontFamily)},e.prototype.setFontWeight=function(X){this._fontWeight!==X&&(this._fontWeight=X,this.domNode.style.fontWeight=this._fontWeight)},e.prototype.setFontSize=function(X){this._fontSize!==X&&(this._fontSize=X,this.domNode.style.fontSize=this._fontSize+"px")},e.prototype.setLineHeight=function(X){this._lineHeight!==X&&(this._lineHeight=X,this.domNode.style.lineHeight=this._lineHeight+"px")},e.prototype.setLetterSpacing=function(X){this._letterSpacing!==X&&(this._letterSpacing=X,this.domNode.style.letterSpacing=this._letterSpacing+"px")},e.prototype.setClassName=function(X){this._className!==X&&(this._className=X,this.domNode.className=this._className)},e.prototype.toggleClassName=function(X,$){Q.toggleClass(this.domNode,X,$),this._className=this.domNode.className},e.prototype.setDisplay=function(X){this._display!==X&&(this._display=X,this.domNode.style.display=this._display)},e.prototype.setPosition=function(X){this._position!==X&&(this._position=X,this.domNode.style.position=this._position)},e.prototype.setVisibility=function(X){this._visibility!==X&&(this._visibility=X,this.domNode.style.visibility=this._visibility)},e.prototype.setLayerHinting=function(X){this._layerHint!==X&&(this._layerHint=X,this.domNode.style.willChange=this._layerHint?"transform":"auto")},e.prototype.setAttribute=function(X,$){this.domNode.setAttribute(X,$)},e.prototype.removeAttribute=function(X){this.domNode.removeAttribute(X)},e.prototype.appendChild=function(X){this.domNode.appendChild(X.domNode)},e.prototype.removeChild=function(X){this.domNode.removeChild(X.domNode)},e}();$.FastDomNode=J,$.createFastDomNode=function(X){return new J(X)}})),define(Q[73],n([0,1,7,164,40,2]),(function(X,$,Q,J,ee,ne){Object.defineProperty($,"__esModule",{value:!0}),$.standardMouseMoveMerger=function(X,$){var Q=new ee.StandardMouseEvent($);return Q.preventDefault(),{leftButton:Q.leftButton,posx:Q.posx,posy:Q.posy}};var ie=function(X){function t(){var $=X.call(this)||this;return $.hooks=[],$.mouseMoveEventMerger=null,$.mouseMoveCallback=null,$.onStopCallback=null,$}return te(t,X),t.prototype.dispose=function(){this.stopMonitoring(!1),X.prototype.dispose.call(this)},t.prototype.stopMonitoring=function(X){if(this.isMonitoring()){this.hooks=ne.dispose(this.hooks),this.mouseMoveEventMerger=null,this.mouseMoveCallback=null;var $=this.onStopCallback;this.onStopCallback=null,X&&$&&$()}},t.prototype.isMonitoring=function(){return this.hooks.length>0},t.prototype.startMonitoring=function(X,$,te){var ne=this;if(!this.isMonitoring()){this.mouseMoveEventMerger=X,this.mouseMoveCallback=$,this.onStopCallback=te;for(var ie=J.IframeUtils.getSameOriginWindowChain(),oe=0;oe<ie.length;oe++)this.hooks.push(Q.addDisposableThrottledListener(ie[oe].window.document,"mousemove",(function(X){return ne.mouseMoveCallback(X)}),(function(X,$){return ne.mouseMoveEventMerger(X,$)}))),this.hooks.push(Q.addDisposableListener(ie[oe].window.document,"mouseup",(function(X){return ne.stopMonitoring(!0)})));if(J.IframeUtils.hasDifferentOriginAncestor()){var re=ie[ie.length-1];this.hooks.push(Q.addDisposableListener(re.window.document,"mouseout",(function(X){"html"===new ee.StandardMouseEvent(X).target.tagName.toLowerCase()&&ne.stopMonitoring(!0)}))),this.hooks.push(Q.addDisposableListener(re.window.document,"mouseover",(function(X){"html"===new ee.StandardMouseEvent(X).target.tagName.toLowerCase()&&ne.stopMonitoring(!0)}))),this.hooks.push(Q.addDisposableListener(re.window.document.body,"mouseleave",(function(X){ne.stopMonitoring(!0)})))}}},t}(ne.Disposable);$.GlobalMouseMoveMonitor=ie})),define(Q[133],n([0,1,7,110,8,68,566,11]),(function(X,$,Q,J,ee,te,ne,ie){function l(X){var $=X.inline?"span":"div",Q=document.createElement($);return X.className&&(Q.className=X.className),Q}function d(X,$,J){var ee;if(2===$.type)ee=document.createTextNode($.content||"");else if(3===$.type)ee=document.createElement("b");else if(4===$.type)ee=document.createElement("i");else if(5===$.type&&J){var te=document.createElement("a");te.href="#",J.disposeables.push(Q.addStandardDisposableListener(te,"click",(function(X){J.callback(String($.index),X)}))),ee=te}else 7===$.type?ee=document.createElement("br"):1===$.type&&(ee=X);ee&&X!==ee&&X.appendChild(ee),ee&&Array.isArray($.children)&&$.children.forEach((function(X){d(ee,X,J)}))}function c(X){switch(X){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;default:return 0}}Object.defineProperty($,"__esModule",{value:!0}),$.renderText=function(X,$){void 0===$&&($={});var Q=l($);return Q.textContent=X,Q},$.renderFormattedText=function u(X,$){void 0===$&&($={});var Q=l($);return d(Q,function(X){for(var $={type:1,children:[]},Q=0,J=$,ee=[],te=new oe(X);!te.eos();){var ne=te.next(),ie="\\"===ne&&0!==c(te.peek());if(ie&&(ne=te.next()),!ie&&function(X){return 0!==c(X)}(ne)&&ne===te.peek()){te.advance(),2===J.type&&(J=ee.pop());var re=c(ne);if(J.type===re||5===J.type&&6===re)J=ee.pop();else{var se={type:re,children:[]};5===re&&(se.index=Q,Q++),J.children.push(se),ee.push(J),J=se}}else if("\n"===ne)2===J.type&&(J=ee.pop()),J.children.push({type:7});else if(2!==J.type){var ae={type:2,content:ne};J.children.push(ae),ee.push(J),J=ae}else J.content+=ne}return 2===J.type&&(J=ee.pop()),ee.length,$}(X),$.actionHandler),Q},$.renderMarkdown=function(X,$){void 0===$&&($={});var oe,re=l($),se=new Promise((function(X){return oe=X})),ae=new ne.Renderer;ae.image=function(X,$,Q){var J=[];if(X){var ee=X.split("|").map((function(X){return X.trim()}));X=ee[0];var te=ee[1];if(te){var ne=/height=(\d+)/.exec(te),ie=/width=(\d+)/.exec(te),oe=ne?ne[1]:"",re=ie?ie[1]:"",se=isFinite(parseInt(re)),ae=isFinite(parseInt(oe));se&&J.push('width="'+re+'"'),ae&&J.push('height="'+oe+'"')}}var le=[];return X&&le.push('src="'+X+'"'),Q&&le.push('alt="'+Q+'"'),$&&le.push('title="'+$+'"'),J.length&&(le=le.concat(J)),"<img "+le.join(" ")+">"},ae.link=function($,Q,J){return $===J&&(J=te.removeMarkdownEscapes(J)),Q=te.removeMarkdownEscapes(Q),!($=te.removeMarkdownEscapes($))||$.match(/^data:|javascript:/i)||$.match(/^command:/i)&&!X.isTrusted||$.match(/^command:(\/\/\/)?_workbench\.downloadResource/i)?J:'<a href="#" data-href="'+$+'" title="'+(Q||$)+'">'+J+"</a>"},ae.paragraph=function(X){return"<p>"+X+"</p>"},$.codeBlockRenderer&&(ae.code=function(X,Q){var te=$.codeBlockRenderer(Q,X),ne=J.defaultGenerator.nextId(),ie=Promise.all([te,se]).then((function(X){var $=X[0],Q=re.querySelector('div[data-code="'+ne+'"]');Q&&(Q.innerHTML=$)})).catch((function(X){}));return $.codeBlockRenderCallback&&ie.then($.codeBlockRenderCallback),'<div class="code" data-code="'+ne+'">'+ee.escape(X)+"</div>"}),$.actionHandler&&$.actionHandler.disposeables.push(Q.addStandardDisposableListener(re,"click",(function(X){var Q=X.target;if("A"===Q.tagName||(Q=Q.parentElement)&&"A"===Q.tagName)try{var J=Q.dataset.href;J&&$.actionHandler.callback(J,X)}catch(X){ie.onUnexpectedError(X)}finally{X.preventDefault()}})));var le={sanitize:!0,renderer:ae};return re.innerHTML=ne.parse(X.value,le),oe(),re};var oe=function(){function e(X){this.source=X,this.index=0}return e.prototype.eos=function(){return this.index>=this.source.length},e.prototype.next=function(){var X=this.peek();return this.advance(),X},e.prototype.peek=function(){return this.source[this.index]},e.prototype.advance=function(){this.index++},e}()}));var ne=this&&this.__decorate||function(X,$,Q,J){var ee,te=arguments.length,ne=te<3?$:null===J?J=Object.getOwnPropertyDescriptor($,Q):J;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)ne=Reflect.decorate(X,$,Q,J);else for(var ie=X.length-1;ie>=0;ie--)(ee=X[ie])&&(ne=(te<3?ee(ne):te>3?ee($,Q,ne):ee($,Q))||ne);return te>3&&ne&&Object.defineProperty($,Q,ne),ne};define(Q[75],n([0,1,22,2,7,128]),(function(X,$,Q,J,ee,ie){var oe;Object.defineProperty($,"__esModule",{value:!0}),function(X){X.Tap="-monaco-gesturetap",X.Change="-monaco-gesturechange",X.Start="-monaco-gesturestart",X.End="-monaco-gesturesend",X.Contextmenu="-monaco-gesturecontextmenu"}(oe=$.EventType||($.EventType={}));var re=function(X){function t(){var $=X.call(this)||this;return $.activeTouches={},$.handle=null,$.targets=[],$._register(ee.addDisposableListener(document,"touchstart",(function(X){return $.onTouchStart(X)}))),$._register(ee.addDisposableListener(document,"touchend",(function(X){return $.onTouchEnd(X)}))),$._register(ee.addDisposableListener(document,"touchmove",(function(X){return $.onTouchMove(X)}))),$}return te(t,X),t.addTarget=function(X){t.isTouchDevice()&&(t.INSTANCE||(t.INSTANCE=new t),t.INSTANCE.targets.push(X))},t.isTouchDevice=function(){return"ontouchstart"in window||navigator.maxTouchPoints>0||window.navigator.msMaxTouchPoints>0},t.prototype.dispose=function(){this.handle&&(this.handle.dispose(),this.handle=null),X.prototype.dispose.call(this)},t.prototype.onTouchStart=function(X){var $=Date.now();this.handle&&(this.handle.dispose(),this.handle=null);for(var Q=0,J=X.targetTouches.length;Q<J;Q++){var ee=X.targetTouches.item(Q);this.activeTouches[ee.identifier]={id:ee.identifier,initialTarget:ee.target,initialTimeStamp:$,initialPageX:ee.pageX,initialPageY:ee.pageY,rollingTimestamps:[$],rollingPageX:[ee.pageX],rollingPageY:[ee.pageY]};var te=this.newGestureEvent(oe.Start,ee.target);te.pageX=ee.pageX,te.pageY=ee.pageY,this.dispatchEvent(te)}this.dispatched&&(X.preventDefault(),X.stopPropagation(),this.dispatched=!1)},t.prototype.onTouchEnd=function(X){for(var $=Date.now(),J=Object.keys(this.activeTouches).length,r=function(te,ne){var ie=X.changedTouches.item(te);if(!ee.activeTouches.hasOwnProperty(String(ie.identifier)))return console.warn("move of an UNKNOWN touch",ie),"continue";var re=ee.activeTouches[ie.identifier],se=Date.now()-re.initialTimeStamp;if(se<t.HOLD_DELAY&&Math.abs(re.initialPageX-Q.tail(re.rollingPageX))<30&&Math.abs(re.initialPageY-Q.tail(re.rollingPageY))<30)(ae=ee.newGestureEvent(oe.Tap,re.initialTarget)).pageX=Q.tail(re.rollingPageX),ae.pageY=Q.tail(re.rollingPageY),ee.dispatchEvent(ae);else if(se>=t.HOLD_DELAY&&Math.abs(re.initialPageX-Q.tail(re.rollingPageX))<30&&Math.abs(re.initialPageY-Q.tail(re.rollingPageY))<30){var ae=ee.newGestureEvent(oe.Contextmenu,re.initialTarget);ae.pageX=Q.tail(re.rollingPageX),ae.pageY=Q.tail(re.rollingPageY),ee.dispatchEvent(ae)}else if(1===J){var le=Q.tail(re.rollingPageX),ue=Q.tail(re.rollingPageY),de=Q.tail(re.rollingTimestamps)-re.rollingTimestamps[0],ce=le-re.rollingPageX[0],he=ue-re.rollingPageY[0],pe=ee.targets.filter((function(X){return re.initialTarget instanceof Node&&X.contains(re.initialTarget)}));ee.inertia(pe,$,Math.abs(ce)/de,ce>0?1:-1,le,Math.abs(he)/de,he>0?1:-1,ue)}ee.dispatchEvent(ee.newGestureEvent(oe.End,re.initialTarget)),delete ee.activeTouches[ie.identifier]},ee=this,te=0,ne=X.changedTouches.length;te<ne;te++)r(te);this.dispatched&&(X.preventDefault(),X.stopPropagation(),this.dispatched=!1)},t.prototype.newGestureEvent=function(X,$){var Q=document.createEvent("CustomEvent");return Q.initEvent(X,!1,!0),Q.initialTarget=$,Q},t.prototype.dispatchEvent=function(X){var $=this;this.targets.forEach((function(Q){X.initialTarget instanceof Node&&Q.contains(X.initialTarget)&&(Q.dispatchEvent(X),$.dispatched=!0)}))},t.prototype.inertia=function(X,$,Q,J,te,ne,ie,re){var se=this;this.handle=ee.scheduleAtNextAnimationFrame((function(){var ee=Date.now(),ae=ee-$,le=0,ue=0,de=!0;ne+=t.SCROLL_FRICTION*ae,(Q+=t.SCROLL_FRICTION*ae)>0&&(de=!1,le=J*Q*ae),ne>0&&(de=!1,ue=ie*ne*ae);var ce=se.newGestureEvent(oe.Change);ce.translationX=le,ce.translationY=ue,X.forEach((function(X){return X.dispatchEvent(ce)})),de||se.inertia(X,ee,Q,J,te+le,ne,ie,re+ue)}))},t.prototype.onTouchMove=function(X){for(var $=Date.now(),J=0,ee=X.changedTouches.length;J<ee;J++){var te=X.changedTouches.item(J);if(this.activeTouches.hasOwnProperty(String(te.identifier))){var ne=this.activeTouches[te.identifier],ie=this.newGestureEvent(oe.Change,ne.initialTarget);ie.translationX=te.pageX-Q.tail(ne.rollingPageX),ie.translationY=te.pageY-Q.tail(ne.rollingPageY),ie.pageX=te.pageX,ie.pageY=te.pageY,this.dispatchEvent(ie),ne.rollingPageX.length>3&&(ne.rollingPageX.shift(),ne.rollingPageY.shift(),ne.rollingTimestamps.shift()),ne.rollingPageX.push(te.pageX),ne.rollingPageY.push(te.pageY),ne.rollingTimestamps.push($)}else console.warn("end of an UNKNOWN touch",te)}this.dispatched&&(X.preventDefault(),X.stopPropagation(),this.dispatched=!1)},t.SCROLL_FRICTION=-.005,t.HOLD_DELAY=700,ne([ie.memoize],t,"isTouchDevice",null),t}(J.Disposable);$.Gesture=re})),define(Q[159],n([0,1,7,27,247]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var te=function(){function e(X,$){this.supportOcticons=$,this.domNode=document.createElement("span"),this.domNode.className="monaco-highlighted-label",this.didEverRender=!1,X.appendChild(this.domNode)}return Object.defineProperty(e.prototype,"element",{get:function(){return this.domNode},enumerable:!0,configurable:!0}),e.prototype.set=function(X,$,Q,ee){void 0===$&&($=[]),void 0===Q&&(Q=""),X||(X=""),ee&&(X=e.escapeNewLines(X,$)),this.didEverRender&&this.text===X&&this.title===Q&&J.equals(this.highlights,$)||(Array.isArray($)||($=[]),this.text=X,this.title=Q,this.highlights=$,this.render())},e.prototype.render=function(){Q.clearNode(this.domNode);for(var X,$=[],J=0,te=0;te<this.highlights.length;te++)if((X=this.highlights[te]).end!==X.start){if(J<X.start){$.push("<span>");var ne=this.text.substring(J,X.start);$.push(this.supportOcticons?ee.renderOcticons(ne):ne),$.push("</span>"),J=X.end}$.push('<span class="highlight">'),ie=this.text.substring(X.start,X.end),$.push(this.supportOcticons?ee.renderOcticons(ie):ie),$.push("</span>"),J=X.end}if(J<this.text.length){$.push("<span>");var ie=this.text.substring(J);$.push(this.supportOcticons?ee.renderOcticons(ie):ie),$.push("</span>")}this.domNode.innerHTML=$.join(""),this.domNode.title=this.title,this.didEverRender=!0},e.prototype.dispose=function(){this.text=null,this.highlights=null},e.escapeNewLines=function(X,$){var Q=0,J=0;return X.replace(/\r\n|\r|\n/,(function(X,ee){J="\r\n"===X?-1:0,ee+=Q;for(var te=0,ne=$;te<ne.length;te++){var ie=ne[te];ie.end<=ee||(ie.start>=ee&&(ie.start+=J),ie.end>=ee&&(ie.end+=J))}return Q+=J,"⏎"}))},e}();$.HighlightedLabel=te})),define(Q[369],n([0,1,7]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(){function e(X){this.renderers=X,this.cache=new Map}return e.prototype.alloc=function(X){var $=this.getTemplateCache(X).pop();if(!$){var J=Q.$(".monaco-list-row");$={domNode:J,templateId:X,templateData:this.renderers.get(X).renderTemplate(J)}}return $},e.prototype.release=function(X){X&&this.releaseRow(X)},e.prototype.releaseRow=function(X){var $=X.domNode,J=X.templateId;$&&(Q.removeClass($,"scrolling"),function(X){try{X.parentElement&&X.parentElement.removeChild(X)}catch(X){}}($)),this.getTemplateCache(J).push(X)},e.prototype.getTemplateCache=function(X){var $=this.cache.get(X);return $||($=[],this.cache.set(X,$)),$},e.prototype.garbageCollect=function(){var X=this;this.renderers&&(this.cache.forEach((function($,Q){for(var J=0,ee=$;J<ee.length;J++){var te=ee[J];X.renderers.get(Q).disposeTemplate(te.templateData),te.domNode=null,te.templateData=null}})),this.cache.clear())},e.prototype.dispose=function(){this.garbageCollect(),this.cache.clear(),this.renderers=null},e}();$.RowCache=J})),define(Q[411],n([0,1,16,2]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(X){function t($,J,ee){var te=X.call(this)||this;return te._visibility=$,te._visibleClassName=J,te._invisibleClassName=ee,te._domNode=null,te._isVisible=!1,te._isNeeded=!1,te._shouldBeVisible=!1,te._revealTimer=te._register(new Q.TimeoutTimer),te}return te(t,X),t.prototype.applyVisibilitySetting=function(X){return 2!==this._visibility&&(3===this._visibility||X)},t.prototype.setShouldBeVisible=function(X){var $=this.applyVisibilitySetting(X);this._shouldBeVisible!==$&&(this._shouldBeVisible=$,this.ensureVisibility())},t.prototype.setIsNeeded=function(X){this._isNeeded!==X&&(this._isNeeded=X,this.ensureVisibility())},t.prototype.setDomNode=function(X){this._domNode=X,this._domNode.setClassName(this._invisibleClassName),this.setShouldBeVisible(!1)},t.prototype.ensureVisibility=function(){this._isNeeded?this._shouldBeVisible?this._reveal():this._hide(!0):this._hide(!1)},t.prototype._reveal=function(){var X=this;this._isVisible||(this._isVisible=!0,this._revealTimer.setIfNotSet((function(){X._domNode&&X._domNode.setClassName(X._visibleClassName)}),0))},t.prototype._hide=function(X){this._revealTimer.cancel(),this._isVisible&&(this._isVisible=!1,this._domNode&&this._domNode.setClassName(this._invisibleClassName+(X?" fade":"")))},t}(J.Disposable);$.ScrollbarVisibilityController=ee})),define(Q[46],n([0,1,7,52,40,2]),(function(X,$,Q,J,ee,ne){Object.defineProperty($,"__esModule",{value:!0});var ie=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype.onclick=function(X,$){this._register(Q.addDisposableListener(X,Q.EventType.CLICK,(function(X){return $(new ee.StandardMouseEvent(X))})))},t.prototype.onmousedown=function(X,$){this._register(Q.addDisposableListener(X,Q.EventType.MOUSE_DOWN,(function(X){return $(new ee.StandardMouseEvent(X))})))},t.prototype.onmouseover=function(X,$){this._register(Q.addDisposableListener(X,Q.EventType.MOUSE_OVER,(function(X){return $(new ee.StandardMouseEvent(X))})))},t.prototype.onnonbubblingmouseout=function(X,$){this._register(Q.addDisposableNonBubblingMouseOutListener(X,(function(X){return $(new ee.StandardMouseEvent(X))})))},t.prototype.onkeydown=function(X,$){this._register(Q.addDisposableListener(X,Q.EventType.KEY_DOWN,(function(X){return $(new J.StandardKeyboardEvent(X))})))},t.prototype.onkeyup=function(X,$){this._register(Q.addDisposableListener(X,Q.EventType.KEY_UP,(function(X){return $(new J.StandardKeyboardEvent(X))})))},t.prototype.oninput=function(X,$){this._register(Q.addDisposableListener(X,Q.EventType.INPUT,$))},t.prototype.onblur=function(X,$){this._register(Q.addDisposableListener(X,Q.EventType.BLUR,$))},t.prototype.onfocus=function(X,$){this._register(Q.addDisposableListener(X,Q.EventType.FOCUS,$))},t.prototype.onchange=function(X,$){this._register(Q.addDisposableListener(X,Q.EventType.CHANGE,$))},t}(ne.Disposable);$.Widget=ie})),define(Q[113],n([0,1,73,46,16]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0}),$.ARROW_IMG_SIZE=11;var ne=function(X){function i(J){var te=X.call(this)||this;return te._onActivate=J.onActivate,te.bgDomNode=document.createElement("div"),te.bgDomNode.className="arrow-background",te.bgDomNode.style.position="absolute",te.bgDomNode.style.width=J.bgWidth+"px",te.bgDomNode.style.height=J.bgHeight+"px",void 0!==J.top&&(te.bgDomNode.style.top="0px"),void 0!==J.left&&(te.bgDomNode.style.left="0px"),void 0!==J.bottom&&(te.bgDomNode.style.bottom="0px"),void 0!==J.right&&(te.bgDomNode.style.right="0px"),te.domNode=document.createElement("div"),te.domNode.className=J.className,te.domNode.style.position="absolute",te.domNode.style.width=$.ARROW_IMG_SIZE+"px",te.domNode.style.height=$.ARROW_IMG_SIZE+"px",void 0!==J.top&&(te.domNode.style.top=J.top+"px"),void 0!==J.left&&(te.domNode.style.left=J.left+"px"),void 0!==J.bottom&&(te.domNode.style.bottom=J.bottom+"px"),void 0!==J.right&&(te.domNode.style.right=J.right+"px"),te._mouseMoveMonitor=te._register(new Q.GlobalMouseMoveMonitor),te.onmousedown(te.bgDomNode,(function(X){return te._arrowMouseDown(X)})),te.onmousedown(te.domNode,(function(X){return te._arrowMouseDown(X)})),te._mousedownRepeatTimer=te._register(new ee.IntervalTimer),te._mousedownScheduleRepeatTimer=te._register(new ee.TimeoutTimer),te}return te(i,X),i.prototype._arrowMouseDown=function(X){var $=this;this._onActivate(),this._mousedownRepeatTimer.cancel(),this._mousedownScheduleRepeatTimer.cancelAndSet((function(){$._mousedownRepeatTimer.cancelAndSet((function(){return $._onActivate()}),1e3/24)}),200),this._mouseMoveMonitor.startMonitoring(Q.standardMouseMoveMerger,(function(X){}),(function(){$._mousedownRepeatTimer.cancel(),$._mousedownScheduleRepeatTimer.cancel()})),X.preventDefault()},i}(J.Widget);$.ScrollbarArrow=ne})),define(Q[166],n([0,1,7,23,73,113,411,46,17]),(function(X,$,Q,J,ee,ne,ie,oe,re){Object.defineProperty($,"__esModule",{value:!0});var se=function(X){function t($){var Q=X.call(this)||this;return Q._lazyRender=$.lazyRender,Q._host=$.host,Q._scrollable=$.scrollable,Q._scrollbarState=$.scrollbarState,Q._visibilityController=Q._register(new ie.ScrollbarVisibilityController($.visibility,"visible scrollbar "+$.extraScrollbarClassName,"invisible scrollbar "+$.extraScrollbarClassName)),Q._mouseMoveMonitor=Q._register(new ee.GlobalMouseMoveMonitor),Q._shouldRender=!0,Q.domNode=J.createFastDomNode(document.createElement("div")),Q.domNode.setAttribute("role","presentation"),Q.domNode.setAttribute("aria-hidden","true"),Q._visibilityController.setDomNode(Q.domNode),Q.domNode.setPosition("absolute"),Q.onmousedown(Q.domNode.domNode,(function(X){return Q._domNodeMouseDown(X)})),Q}return te(t,X),t.prototype._createArrow=function(X){var $=this._register(new ne.ScrollbarArrow(X));this.domNode.domNode.appendChild($.bgDomNode),this.domNode.domNode.appendChild($.domNode)},t.prototype._createSlider=function(X,$,Q,ee){var te=this;this.slider=J.createFastDomNode(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(X),this.slider.setLeft($),"number"==typeof Q&&this.slider.setWidth(Q),"number"==typeof ee&&this.slider.setHeight(ee),this.slider.setLayerHinting(!0),this.domNode.domNode.appendChild(this.slider.domNode),this.onmousedown(this.slider.domNode,(function(X){X.leftButton&&(X.preventDefault(),te._sliderMouseDown(X,(function(){})))}))},t.prototype._onElementSize=function(X){return this._scrollbarState.setVisibleSize(X)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender},t.prototype._onElementScrollSize=function(X){return this._scrollbarState.setScrollSize(X)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender},t.prototype._onElementScrollPosition=function(X){return this._scrollbarState.setScrollPosition(X)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender},t.prototype.beginReveal=function(){this._visibilityController.setShouldBeVisible(!0)},t.prototype.beginHide=function(){this._visibilityController.setShouldBeVisible(!1)},t.prototype.render=function(){this._shouldRender&&(this._shouldRender=!1,this._renderDomNode(this._scrollbarState.getRectangleLargeSize(),this._scrollbarState.getRectangleSmallSize()),this._updateSlider(this._scrollbarState.getSliderSize(),this._scrollbarState.getArrowSize()+this._scrollbarState.getSliderPosition()))},t.prototype._domNodeMouseDown=function(X){X.target===this.domNode.domNode&&this._onMouseDown(X)},t.prototype.delegateMouseDown=function(X){var $=this.domNode.domNode.getClientRects()[0].top,Q=$+this._scrollbarState.getSliderPosition(),J=$+this._scrollbarState.getSliderPosition()+this._scrollbarState.getSliderSize(),ee=this._sliderMousePosition(X);Q<=ee&&ee<=J?X.leftButton&&(X.preventDefault(),this._sliderMouseDown(X,(function(){}))):this._onMouseDown(X)},t.prototype._onMouseDown=function(X){var $,J;if(X.target===this.domNode.domNode&&"number"==typeof X.browserEvent.offsetX&&"number"==typeof X.browserEvent.offsetY)$=X.browserEvent.offsetX,J=X.browserEvent.offsetY;else{var ee=Q.getDomNodePagePosition(this.domNode.domNode);$=X.posx-ee.left,J=X.posy-ee.top}this._setDesiredScrollPositionNow(this._scrollbarState.getDesiredScrollPositionFromOffset(this._mouseDownRelativePosition($,J))),X.leftButton&&(X.preventDefault(),this._sliderMouseDown(X,(function(){})))},t.prototype._sliderMouseDown=function(X,$){var Q=this,J=this._sliderMousePosition(X),te=this._sliderOrthogonalMousePosition(X),ne=this._scrollbarState.clone();this.slider.toggleClassName("active",!0),this._mouseMoveMonitor.startMonitoring(ee.standardMouseMoveMerger,(function(X){var $=Q._sliderOrthogonalMousePosition(X),ee=Math.abs($-te);if(re.isWindows&&ee>140)Q._setDesiredScrollPositionNow(ne.getScrollPosition());else{var ie=Q._sliderMousePosition(X)-J;Q._setDesiredScrollPositionNow(ne.getDesiredScrollPositionFromDelta(ie))}}),(function(){Q.slider.toggleClassName("active",!1),Q._host.onDragEnd(),$()})),this._host.onDragStart()},t.prototype._setDesiredScrollPositionNow=function(X){var $={};this.writeScrollPosition($,X),this._scrollable.setScrollPositionNow($)},t}(oe.Widget);$.AbstractScrollbar=se})),define(Q[420],n([0,1,40,166,113,149]),(function(X,$,Q,J,ee,ne){Object.defineProperty($,"__esModule",{value:!0});var ie=function(X){function t($,J,te){var ie=X.call(this,{lazyRender:J.lazyRender,host:te,scrollbarState:new ne.ScrollbarState(J.horizontalHasArrows?J.arrowSize:0,2===J.horizontal?0:J.horizontalScrollbarSize,2===J.vertical?0:J.verticalScrollbarSize),visibility:J.horizontal,extraScrollbarClassName:"horizontal",scrollable:$})||this;if(J.horizontalHasArrows){var oe=(J.arrowSize-ee.ARROW_IMG_SIZE)/2,re=(J.horizontalScrollbarSize-ee.ARROW_IMG_SIZE)/2;ie._createArrow({className:"left-arrow",top:re,left:oe,bottom:void 0,right:void 0,bgWidth:J.arrowSize,bgHeight:J.horizontalScrollbarSize,onActivate:function(){return ie._host.onMouseWheel(new Q.StandardMouseWheelEvent(null,1,0))}}),ie._createArrow({className:"right-arrow",top:re,left:void 0,bottom:void 0,right:oe,bgWidth:J.arrowSize,bgHeight:J.horizontalScrollbarSize,onActivate:function(){return ie._host.onMouseWheel(new Q.StandardMouseWheelEvent(null,-1,0))}})}return ie._createSlider(Math.floor((J.horizontalScrollbarSize-J.horizontalSliderSize)/2),0,void 0,J.horizontalSliderSize),ie}return te(t,X),t.prototype._updateSlider=function(X,$){this.slider.setWidth(X),this.slider.setLeft($)},t.prototype._renderDomNode=function(X,$){this.domNode.setWidth(X),this.domNode.setHeight($),this.domNode.setLeft(0),this.domNode.setBottom(0)},t.prototype.onDidScroll=function(X){return this._shouldRender=this._onElementScrollSize(X.scrollWidth)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(X.scrollLeft)||this._shouldRender,this._shouldRender=this._onElementSize(X.width)||this._shouldRender,this._shouldRender},t.prototype._mouseDownRelativePosition=function(X,$){return X},t.prototype._sliderMousePosition=function(X){return X.posx},t.prototype._sliderOrthogonalMousePosition=function(X){return X.posy},t.prototype.writeScrollPosition=function(X,$){X.scrollLeft=$},t}(J.AbstractScrollbar);$.HorizontalScrollbar=ie})),define(Q[422],n([0,1,40,166,113,149]),(function(X,$,Q,J,ee,ne){Object.defineProperty($,"__esModule",{value:!0});var ie=function(X){function t($,J,te){var ie=X.call(this,{lazyRender:J.lazyRender,host:te,scrollbarState:new ne.ScrollbarState(J.verticalHasArrows?J.arrowSize:0,2===J.vertical?0:J.verticalScrollbarSize,0),visibility:J.vertical,extraScrollbarClassName:"vertical",scrollable:$})||this;if(J.verticalHasArrows){var oe=(J.arrowSize-ee.ARROW_IMG_SIZE)/2,re=(J.verticalScrollbarSize-ee.ARROW_IMG_SIZE)/2;ie._createArrow({className:"up-arrow",top:oe,left:re,bottom:void 0,right:void 0,bgWidth:J.verticalScrollbarSize,bgHeight:J.arrowSize,onActivate:function(){return ie._host.onMouseWheel(new Q.StandardMouseWheelEvent(null,0,1))}}),ie._createArrow({className:"down-arrow",top:void 0,left:re,bottom:oe,right:void 0,bgWidth:J.verticalScrollbarSize,bgHeight:J.arrowSize,onActivate:function(){return ie._host.onMouseWheel(new Q.StandardMouseWheelEvent(null,0,-1))}})}return ie._createSlider(0,Math.floor((J.verticalScrollbarSize-J.verticalSliderSize)/2),J.verticalSliderSize,void 0),ie}return te(t,X),t.prototype._updateSlider=function(X,$){this.slider.setHeight(X),this.slider.setTop($)},t.prototype._renderDomNode=function(X,$){this.domNode.setWidth($),this.domNode.setHeight(X),this.domNode.setRight(0),this.domNode.setTop(0)},t.prototype.onDidScroll=function(X){return this._shouldRender=this._onElementScrollSize(X.scrollHeight)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(X.scrollTop)||this._shouldRender,this._shouldRender=this._onElementSize(X.height)||this._shouldRender,this._shouldRender},t.prototype._mouseDownRelativePosition=function(X,$){return $},t.prototype._sliderMousePosition=function(X){return X.posy},t.prototype._sliderOrthogonalMousePosition=function(X){return X.posx},t.prototype.writeScrollPosition=function(X,$){X.scrollTop=$},t}(J.AbstractScrollbar);$.VerticalScrollbar=ie})),define(Q[167],n([0,1,22,8,58,65,16]),(function(X,$,Q,J,ee,te,ne){function a(X){switch(X){case 0:return"";case 1:return se+"*?";default:return"(?:"+re+"|"+se+"+"+re+"|"+re+se+"+)*?"}}function l(X,$){if(!X)return[];for(var Q,J=[],ee=!1,te=!1,ne="",ie=0;ie<X.length;ie++){switch(Q=X[ie]){case $:if(!ee&&!te){J.push(ne),ne="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":te=!0;break;case"]":te=!1}ne+=Q}return ne&&J.push(ne),J}function u(X){if(!X)return"";var $="",Q=l(X,oe);if(Q.every((function(X){return X===ie})))$=".*";else{var ee=!1;Q.forEach((function(X,te){if(X!==ie){for(var ne,ae=!1,le="",ue=!1,de="",ce=0;ce<X.length;ce++)if("}"!==(ne=X[ce])&&ae)le+=ne;else if(!ue||"]"===ne&&de)switch(ne){case"{":ae=!0;continue;case"[":ue=!0;continue;case"}":var he="(?:"+l(le,",").map((function(X){return u(X)})).join("|")+")";$+=he,ae=!1,le="";break;case"]":$+="["+de+"]",ue=!1,de="";break;case"?":$+=se;continue;case"*":$+=a(1);continue;default:$+=J.escapeRegExpCharacters(ne)}else de+="-"===ne?ne:"^"!==ne&&"!"!==ne||de?ne===oe?"":J.escapeRegExpCharacters(ne):"^";te<Q.length-1&&(Q[te+1]!==ie||te+2<Q.length)&&($+=re),ee=!1}else ee||($+=a(2),ee=!0)}))}return $}function d(X,$){if(!X)return M;var ee,te,ne=(ee=(ee="string"!=typeof X?X.pattern:X).trim())+"_"+!!$.trimForExclusions,ie=fe.get(ne);if(ie)return c(ie,X);if(le.test(ee)){var oe=ee.substr(4);ie=function(X,$){return X&&J.endsWith(X,oe)?ee:null}}else ie=(te=ue.exec(h(ee,$)))?function(X,$){var Q="/"+X,ee="\\"+X,r=function(te,ne){return te?ne?ne===X?$:null:te===X||J.endsWith(te,Q)||J.endsWith(te,ee)?$:null:null},te=[X];return r.basenames=te,r.patterns=[$],r.allBasenames=te,r}(te[1],ee):($.trimForExclusions?ce:de).test(ee)?function(X,$){var J=m(X.slice(1,-1).split(",").map((function(X){return d(X,$)})).filter((function(X){return X!==M})),X),ee=J.length;if(!ee)return M;if(1===ee)return J[0];var r=function($,Q){for(var ee=0,te=J.length;ee<te;ee++)if(J[ee]($,Q))return X;return null},te=Q.first(J,(function(X){return!!X.allBasenames}));te&&(r.allBasenames=te.allBasenames);var ne=J.reduce((function(X,$){return $.allPaths?X.concat($.allPaths):X}),[]);return ne.length&&(r.allPaths=ne),r}(ee,$):(te=he.exec(h(ee,$)))?p(te[1].substr(1),ee,!0):(te=pe.exec(h(ee,$)))?p(te[1],ee,!1):function(X){try{var $=new RegExp("^"+u(X)+"$");return function(Q,J){return $.lastIndex=0,Q&&$.test(Q)?X:null}}catch(X){return M}}(ee);return fe.set(ne,ie),c(ie,X)}function c(X,$){return"string"==typeof $?X:function(Q,J){return ee.isEqualOrParent(Q,$.base)?X($.pathToRelative($.base,Q),J):null}}function h(X,$){return $.trimForExclusions&&J.endsWith(X,"/**")?X.substr(0,X.length-2):X}function p(X,$,Q){var te=ee.nativeSep!==ee.sep?X.replace(ae,ee.nativeSep):X,ne=ee.nativeSep+te,ie=Q?function(X,Q){return X&&(X===te||J.endsWith(X,ne))?$:null}:function(X,Q){return X&&X===te?$:null};return ie.allPaths=[(Q?"*/":"./")+X],ie}function f(X,$){if(void 0===$&&($={}),!X)return D;if("string"==typeof X||g(X)){var J=d(X,$);if(J===M)return D;var r=function(X,$){return!!J(X,$)};return J.allBasenames&&(r.allBasenames=J.allBasenames),J.allPaths&&(r.allPaths=J.allPaths),r}return function(X,$){var J=m(Object.getOwnPropertyNames(X).map((function(Q){return function(X,$,Q){if(!1===$)return M;var J=d(X,Q);if(J===M)return M;if("boolean"==typeof $)return J;if($){var ee=$.when;if("string"==typeof ee){var r=function($,Q,te,ie){if(!ie||!J($,Q))return null;var oe=ie(ee.replace("$(basename)",te));return ne.isThenable(oe)?oe.then((function($){return $?X:null})):oe?X:null};return r.requiresSiblings=!0,r}}return J}(Q,X[Q],$)})).filter((function(X){return X!==M}))),te=J.length;if(!te)return M;if(!J.some((function(X){return!!X.requiresSiblings}))){if(1===te)return J[0];var a=function(X,$){for(var Q=0,ee=J.length;Q<ee;Q++){var te=J[Q](X,$);if(te)return te}return null},ie=Q.first(J,(function(X){return!!X.allBasenames}));ie&&(a.allBasenames=ie.allBasenames);var oe=J.reduce((function(X,$){return $.allPaths?X.concat($.allPaths):X}),[]);return oe.length&&(a.allPaths=oe),a}var c=function(X,$,Q){for(var te=void 0,ne=0,ie=J.length;ne<ie;ne++){var oe=J[ne];oe.requiresSiblings&&Q&&($||($=ee.basename(X)),te||(te=$.substr(0,$.length-ee.extname(X).length)));var re=oe(X,$,te,Q);if(re)return re}return null},re=Q.first(J,(function(X){return!!X.allBasenames}));re&&(c.allBasenames=re.allBasenames);var se=J.reduce((function(X,$){return $.allPaths?X.concat($.allPaths):X}),[]);return se.length&&(c.allPaths=se),c}(X,$)}function g(X){var $=X;return $&&"string"==typeof $.base&&"string"==typeof $.pattern&&"function"==typeof $.pathToRelative}function m(X,$){var Q=X.filter((function(X){return!!X.basenames}));if(Q.length<2)return X;var J,ee=Q.reduce((function(X,$){var Q=$.basenames;return Q?X.concat(Q):X}),[]);if($){J=[];for(var te=0,ne=ee.length;te<ne;te++)J.push($)}else J=Q.reduce((function(X,$){var Q=$.patterns;return Q?X.concat(Q):X}),[]);var a=function(X,$){if(!X)return null;if(!$){var Q=void 0;for(Q=X.length;Q>0;Q--){var te=X.charCodeAt(Q-1);if(47===te||92===te)break}$=X.substr(Q)}var ne=ee.indexOf($);return-1!==ne?J[ne]:null};a.basenames=ee,a.patterns=J,a.allBasenames=ee;var ie=X.filter((function(X){return!X.basenames}));return ie.push(a),ie}Object.defineProperty($,"__esModule",{value:!0});var ie="**",oe="/",re="[/\\\\]",se="[^/\\\\]",ae=/\//g;$.splitGlobAware=l;var le=/^\*\*\/\*\.[\w\.-]+$/,ue=/^\*\*\/([\w\.-]+)\/?$/,de=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,ce=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,he=/^\*\*((\/[\w\.-]+)+)\/?$/,pe=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,fe=new te.LRUCache(1e4),D=function(){return!1},M=function(){return null};$.match=function(X,$,Q){return!(!X||!$)&&f(X)($,void 0,Q)},$.parse=f,$.isRelativePattern=g})),define(Q[424],n([0,1,58,8,167]),(function(X,$,Q,J,ee){function a(X,$,Q){for(var te=null,ne=null,ie=null,oe=Q.length-1;oe>=0;oe--){var re=Q[oe];if($===re.filenameLowercase){te=re;break}if(re.filepattern&&(!ne||re.filepattern.length>ne.filepattern.length)){var se=re.filepatternOnPath?X:$;ee.match(re.filepatternLowercase,se)&&(ne=re)}re.extension&&(!ie||re.extension.length>ie.extension.length)&&J.endsWith($,re.extensionLowercase)&&(ie=re)}return te?te.mime:ne?ne.mime:ie?ie.mime:null}Object.defineProperty($,"__esModule",{value:!0}),$.MIME_TEXT="text/plain",$.MIME_UNKNOWN="application/unknown";var te=[],ne=[],ie=[];$.registerTextMime=function r(X,$){void 0===$&&($=!1);var J=function(X){return{id:X.id,mime:X.mime,filename:X.filename,extension:X.extension,filepattern:X.filepattern,firstline:X.firstline,userConfigured:X.userConfigured,filenameLowercase:X.filename?X.filename.toLowerCase():void 0,extensionLowercase:X.extension?X.extension.toLowerCase():void 0,filepatternLowercase:X.filepattern?X.filepattern.toLowerCase():void 0,filepatternOnPath:!!X.filepattern&&X.filepattern.indexOf(Q.sep)>=0}}(X);te.push(J),J.userConfigured?ie.push(J):ne.push(J),$&&!J.userConfigured&&te.forEach((function(X){X.mime===J.mime||X.userConfigured||(J.extension&&X.extension===J.extension&&console.warn("Overwriting extension <<"+J.extension+">> to now point to mime <<"+J.mime+">>"),J.filename&&X.filename===J.filename&&console.warn("Overwriting filename <<"+J.filename+">> to now point to mime <<"+J.mime+">>"),J.filepattern&&X.filepattern===J.filepattern&&console.warn("Overwriting filepattern <<"+J.filepattern+">> to now point to mime <<"+J.mime+">>"),J.firstline&&X.firstline===J.firstline&&console.warn("Overwriting firstline <<"+J.firstline+">> to now point to mime <<"+J.mime+">>"))}))},$.guessMimeTypes=function s(X,ee){if(!X)return[$.MIME_UNKNOWN];X=X.toLowerCase();var oe=Q.basename(X),re=a(X,oe,ie);if(re)return[re,$.MIME_TEXT];var se=a(X,oe,ne);if(se)return[se,$.MIME_TEXT];if(ee){var ae=function(X){if(J.startsWithUTF8BOM(X)&&(X=X.substr(1)),X.length>0)for(var $=0;$<te.length;++$){var Q=te[$];if(Q.firstline){var ee=X.match(Q.firstline);if(ee&&ee.length>0)return Q.mime}}return null}(ee);if(ae)return[ae,$.MIME_TEXT]}return[$.MIME_UNKNOWN]}})),define(Q[169],n([0,1,6,2]),(function(X,$,Q,J){function r(X,$){var Q=$-X;return function($){return X+Q*function(X){return 1-function(X){return Math.pow(X,3)}(1-X)}($)}}Object.defineProperty($,"__esModule",{value:!0});var ee=function(){function e(X,$,Q,J,ee,te){(X|=0)<0&&(X=0),(Q|=0)+X>($|=0)&&(Q=$-X),Q<0&&(Q=0),(J|=0)<0&&(J=0),(te|=0)+J>(ee|=0)&&(te=ee-J),te<0&&(te=0),this.width=X,this.scrollWidth=$,this.scrollLeft=Q,this.height=J,this.scrollHeight=ee,this.scrollTop=te}return e.prototype.equals=function(X){return this.width===X.width&&this.scrollWidth===X.scrollWidth&&this.scrollLeft===X.scrollLeft&&this.height===X.height&&this.scrollHeight===X.scrollHeight&&this.scrollTop===X.scrollTop},e.prototype.withScrollDimensions=function(X){return new e(void 0!==X.width?X.width:this.width,void 0!==X.scrollWidth?X.scrollWidth:this.scrollWidth,this.scrollLeft,void 0!==X.height?X.height:this.height,void 0!==X.scrollHeight?X.scrollHeight:this.scrollHeight,this.scrollTop)},e.prototype.withScrollPosition=function(X){return new e(this.width,this.scrollWidth,void 0!==X.scrollLeft?X.scrollLeft:this.scrollLeft,this.height,this.scrollHeight,void 0!==X.scrollTop?X.scrollTop:this.scrollTop)},e.prototype.createScrollEvent=function(X){var $=this.width!==X.width,Q=this.scrollWidth!==X.scrollWidth,J=this.scrollLeft!==X.scrollLeft,ee=this.height!==X.height,te=this.scrollHeight!==X.scrollHeight,ne=this.scrollTop!==X.scrollTop;return{width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:$,scrollWidthChanged:Q,scrollLeftChanged:J,heightChanged:ee,scrollHeightChanged:te,scrollTopChanged:ne}},e}();$.ScrollState=ee;var ne=function(X){function t($,J){var te=X.call(this)||this;return te._onScroll=te._register(new Q.Emitter),te.onScroll=te._onScroll.event,te._smoothScrollDuration=$,te._scheduleAtNextAnimationFrame=J,te._state=new ee(0,0,0,0,0,0),te._smoothScrolling=null,te}return te(t,X),t.prototype.dispose=function(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),X.prototype.dispose.call(this)},t.prototype.setSmoothScrollDuration=function(X){this._smoothScrollDuration=X},t.prototype.validateScrollPosition=function(X){return this._state.withScrollPosition(X)},t.prototype.getScrollDimensions=function(){return this._state},t.prototype.setScrollDimensions=function(X){var $=this._state.withScrollDimensions(X);this._setState($),this._smoothScrolling&&this._smoothScrolling.acceptScrollDimensions(this._state)},t.prototype.getFutureScrollPosition=function(){return this._smoothScrolling?this._smoothScrolling.to:this._state},t.prototype.getCurrentScrollPosition=function(){return this._state},t.prototype.setScrollPositionNow=function(X){var $=this._state.withScrollPosition(X);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState($)},t.prototype.setScrollPositionSmooth=function(X){var $=this;if(0===this._smoothScrollDuration)return this.setScrollPositionNow(X);if(this._smoothScrolling){if(X={scrollLeft:void 0===X.scrollLeft?this._smoothScrolling.to.scrollLeft:X.scrollLeft,scrollTop:void 0===X.scrollTop?this._smoothScrolling.to.scrollTop:X.scrollTop},J=this._state.withScrollPosition(X),this._smoothScrolling.to.scrollLeft===J.scrollLeft&&this._smoothScrolling.to.scrollTop===J.scrollTop)return;var Q=this._smoothScrolling.combine(this._state,J,this._smoothScrollDuration);this._smoothScrolling.dispose(),this._smoothScrolling=Q}else{var J=this._state.withScrollPosition(X);this._smoothScrolling=ie.start(this._state,J,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame((function(){$._smoothScrolling&&($._smoothScrolling.animationFrameDisposable=null,$._performSmoothScrolling())}))},t.prototype._performSmoothScrolling=function(){var X=this;if(this._smoothScrolling){var $=this._smoothScrolling.tick(),Q=this._state.withScrollPosition($);if(this._setState(Q),$.isDone)return this._smoothScrolling.dispose(),void(this._smoothScrolling=null);this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame((function(){X._smoothScrolling&&(X._smoothScrolling.animationFrameDisposable=null,X._performSmoothScrolling())}))}},t.prototype._setState=function(X){var $=this._state;$.equals(X)||(this._state=X,this._onScroll.fire(this._state.createScrollEvent($)))},t}(J.Disposable);$.Scrollable=ne;var l=function(X,$,Q){this.scrollLeft=X,this.scrollTop=$,this.isDone=Q};$.SmoothScrollingUpdate=l;var ie=function(){function e(X,$,Q,J){this.from=X,this.to=$,this.duration=J,this._startTime=Q,this.animationFrameDisposable=null,this._initAnimations()}return e.prototype._initAnimations=function(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)},e.prototype._initAnimation=function(X,$,Q){if(Math.abs(X-$)>2.5*Q){var J=void 0,ee=void 0;return X<$?(J=X+.75*Q,ee=$-.75*Q):(J=X-.75*Q,ee=$+.75*Q),function(X,$,Q){return function(J){return J<Q?X(J/Q):$((J-Q)/(1-Q))}}(r(X,J),r(ee,$),.33)}return r(X,$)},e.prototype.dispose=function(){null!==this.animationFrameDisposable&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)},e.prototype.acceptScrollDimensions=function(X){this.to=X.withScrollPosition(this.to),this._initAnimations()},e.prototype.tick=function(){return this._tick(Date.now())},e.prototype._tick=function(X){var $=(X-this._startTime)/this.duration;if($<1){var Q=this.scrollLeft($),J=this.scrollTop($);return new l(Q,J,!1)}return new l(this.to.scrollLeft,this.to.scrollTop,!0)},e.prototype.combine=function(X,$,Q){return e.start(X,$,Q)},e.start=function(X,$,Q){return Q+=10,new e(X,$,Date.now()-10,Q)},e}();$.SmoothScrollingOperation=ie})),define(Q[170],n([0,1,53,17,16]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var te=function(){function e(X){!function(X){return ee.isThenable(X)&&"function"==typeof X.done}(X)?this._winjsPromise=new Q.Promise((function($,Q){var ee=!0;X((function(X){ee?J.setImmediate((function(){return $(X)})):$(X)}),(function(X){ee?J.setImmediate((function(){return Q(X)})):Q(X)})),ee=!1})):this._winjsPromise=X}return e.all=function(X){return new e(Q.Promise.join(X).then(null,(function(X){for(var $ in X)if(X.hasOwnProperty($))return X[$]})))},e.race=function(X){return new e(Q.Promise.any(X).then((function(X){return X.value}),(function(X){return X.value})))},e.resolve=function(X){return new e(Q.Promise.wrap(X))},e.reject=function(X){return new e(Q.Promise.wrapError(X))},e.prototype.then=function(X,$){var ee=!0,te=new e(this._winjsPromise.then(X&&function($){return ee?new Q.Promise((function(Q,ee){J.setImmediate((function(){var J;try{J=X($)}catch(X){return void ee(X)}Q(J)}))})):X($)},$&&function(X){return ee?new Q.Promise((function(Q,ee){J.setImmediate((function(){var J;try{J=$(X)}catch(X){return void ee(X)}Q(J)}))})):$(X)}));return ee=!1,te},e.prototype.catch=function(X){return this.then(null,X)},e}();$.PolyfillPromise=te})),define(Q[148],n([0,1,11,2,17,170]),(function(X,$,Q,J,ee,ne){Object.defineProperty($,"__esModule",{value:!0});var ie=self;void 0===ie.Promise&&(ie.Promise=ne.PolyfillPromise);var oe="$initialize",re=!1;$.logOnceWebWorkerWarning=function(X){ee.isWeb&&(re||(re=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/Microsoft/monaco-editor#faq")),console.warn(X.message))};var se=function(){function e(X){this._workerId=-1,this._handler=X,this._lastSentReq=0,this._pendingReplies=Object.create(null)}return e.prototype.setWorkerId=function(X){this._workerId=X},e.prototype.sendMessage=function(X,$){var Q=this,J=String(++this._lastSentReq);return new Promise((function(ee,te){Q._pendingReplies[J]={resolve:ee,reject:te},Q._send({vsWorker:Q._workerId,req:J,method:X,args:$})}))},e.prototype.handleMessage=function(X){var $;try{$=JSON.parse(X)}catch(X){return}$&&$.vsWorker&&(-1!==this._workerId&&$.vsWorker!==this._workerId||this._handleMessage($))},e.prototype._handleMessage=function(X){var $=this;if(X.seq){var J=X;if(!this._pendingReplies[J.seq])return void console.warn("Got reply to unknown seq");var ee=this._pendingReplies[J.seq];if(delete this._pendingReplies[J.seq],J.err){var te=J.err;return J.err.$isError&&((te=new Error).name=J.err.name,te.message=J.err.message,te.stack=J.err.stack),void ee.reject(te)}ee.resolve(J.res)}else{var ne=X,ie=ne.req;this._handler.handleMessage(ne.method,ne.args).then((function(X){$._send({vsWorker:$._workerId,seq:ie,res:X,err:void 0})}),(function(X){X.detail instanceof Error&&(X.detail=Q.transformErrorForSerialization(X.detail)),$._send({vsWorker:$._workerId,seq:ie,res:void 0,err:Q.transformErrorForSerialization(X)})}))}},e.prototype._send=function(X){var $=JSON.stringify(X);this._handler.sendMessage($)},e}(),ae=function(X){function t($,Q){var J=X.call(this)||this,ee=null;J._worker=J._register($.create("vs/base/common/worker/simpleWorker",(function(X){J._protocol.handleMessage(X)}),(function(X){ee&&ee(X)}))),J._protocol=new se({sendMessage:function(X){J._worker.postMessage(X)},handleMessage:function(X,$){return Promise.resolve(null)}}),J._protocol.setWorkerId(J._worker.getId());var te=null;void 0!==self.require&&"function"==typeof self.require.getConfig?te=self.require.getConfig():void 0!==self.requirejs&&(te=self.requirejs.s.contexts._.config),J._onModuleLoaded=J._protocol.sendMessage(oe,[J._worker.getId(),Q,te]),J._lazyProxy=new Promise((function(X,$){ee=$,J._onModuleLoaded.then((function($){for(var Q={},J=0;J<$.length;J++)Q[$[J]]=a($[J],s);X(Q)}),(function(X){$(X),J._onError("Worker failed to load "+Q,X)}))}));var s=function(X,$){return J._request(X,$)},a=function(X,$){return function(){var Q=Array.prototype.slice.call(arguments,0);return $(X,Q)}};return J}return te(t,X),t.prototype.getProxyObject=function(){return this._lazyProxy},t.prototype._request=function(X,$){var Q=this;return new Promise((function(J,ee){Q._onModuleLoaded.then((function(){Q._protocol.sendMessage(X,$).then(J,ee)}),ee)}))},t.prototype._onError=function(X,$){console.error(X),console.info($)},t}(J.Disposable);$.SimpleWorkerClient=ae;var le=function(){function e(X,$){var Q=this;this._requestHandler=$,this._protocol=new se({sendMessage:function($){X($)},handleMessage:function(X,$){return Q._handleMessage(X,$)}})}return e.prototype.onmessage=function(X){this._protocol.handleMessage(X)},e.prototype._handleMessage=function(X,$){if(X===oe)return this.initialize($[0],$[1],$[2]);if(!this._requestHandler||"function"!=typeof this._requestHandler[X])return Promise.reject(new Error("Missing requestHandler or method: "+X));try{return Promise.resolve(this._requestHandler[X].apply(this._requestHandler,$))}catch(X){return Promise.reject(X)}},e.prototype.initialize=function(X,$,Q){var J=this;if(this._protocol.setWorkerId(X),this._requestHandler){var ee=[];for(var te in this._requestHandler)"function"==typeof this._requestHandler[te]&&ee.push(te);return Promise.resolve(ee)}return Q&&(void 0!==Q.baseUrl&&delete Q.baseUrl,void 0!==Q.paths&&void 0!==Q.paths.vs&&delete Q.paths.vs,Q.catchError=!0,self.require.config(Q)),new Promise((function(X,Q){self.require([$],(function(){for(var $=[],ee=0;ee<arguments.length;ee++)$[ee]=arguments[ee];var te=$[0];if(J._requestHandler=te.create(),J._requestHandler){var ne=[];for(var ie in J._requestHandler)"function"==typeof J._requestHandler[ie]&&ne.push(ie);X(ne)}else Q(new Error("No RequestHandler!"))}),Q)}))},e}();$.SimpleWorkerServer=le,$.create=function(X){return new le(X,null)}})),define(Q[437],n([0,1,53,32]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(){function e(X){this.modelProvider=J.isFunction(X.getModel)?X:{getModel:function(){return X}}}return e.prototype.getId=function(X,$){if(!$)return null;var Q=this.modelProvider.getModel();return Q===$?"__root__":Q.dataSource.getId($)},e.prototype.hasChildren=function(X,$){var Q=this.modelProvider.getModel();return Q&&Q===$&&Q.entries.length>0},e.prototype.getChildren=function(X,$){var J=this.modelProvider.getModel();return Q.TPromise.as(J===$?J.entries:[])},e.prototype.getParent=function(X,$){return Q.TPromise.as(null)},e}();$.DataSource=ee;var te=function(){function e(X){this.modelProvider=X}return e.prototype.getAriaLabel=function(X,$){var Q=this.modelProvider.getModel();return Q.accessibilityProvider&&Q.accessibilityProvider.getAriaLabel($)},e.prototype.getPosInSet=function(X,$){var Q=this.modelProvider.getModel(),J=0;if(Q.filter)for(var ee=0,te=Q.entries;ee<te.length;ee++){var ne=te[ee];if(Q.filter.isVisible(ne)&&J++,ne===$)break}else J=Q.entries.indexOf($)+1;return String(J)},e.prototype.getSetSize=function(){var X=this.modelProvider.getModel(),$=0;if(X.filter)for(var Q=0,J=X.entries;Q<J.length;Q++){var ee=J[Q];X.filter.isVisible(ee)&&$++}else $=X.entries.length;return String($)},e}();$.AccessibilityProvider=te;var ne=function(){function e(X){this.modelProvider=X}return e.prototype.isVisible=function(X,$){var Q=this.modelProvider.getModel();return!Q.filter||Q.filter.isVisible($)},e}();$.Filter=ne;var ie=function(){function e(X,$){this.modelProvider=X,this.styles=$}return e.prototype.updateStyles=function(X){this.styles=X},e.prototype.getHeight=function(X,$){return this.modelProvider.getModel().renderer.getHeight($)},e.prototype.getTemplateId=function(X,$){return this.modelProvider.getModel().renderer.getTemplateId($)},e.prototype.renderTemplate=function(X,$,Q){return this.modelProvider.getModel().renderer.renderTemplate($,Q,this.styles)},e.prototype.renderElement=function(X,$,Q,J){this.modelProvider.getModel().renderer.renderElement($,Q,J,this.styles)},e.prototype.disposeTemplate=function(X,$,Q){this.modelProvider.getModel().renderer.disposeTemplate($,Q)},e}();$.Renderer=ie})),define(Q[440],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q=function(){function e(X,$,Q){this._posx=X,this._posy=$,this._target=Q}return e.prototype.preventDefault=function(){},e.prototype.stopPropagation=function(){},Object.defineProperty(e.prototype,"target",{get:function(){return this._target},enumerable:!0,configurable:!0}),e}();$.ContextMenuEvent=Q;var J=function(X){function t($){var Q=X.call(this,$.posx,$.posy,$.target)||this;return Q.originalEvent=$,Q}return te(t,X),t.prototype.preventDefault=function(){this.originalEvent.preventDefault()},t.prototype.stopPropagation=function(){this.originalEvent.stopPropagation()},t}(Q);$.MouseContextMenuEvent=J;var ee=function(X){function t($,Q,J){var ee=X.call(this,$,Q,J.target)||this;return ee.originalEvent=J,ee}return te(t,X),t.prototype.preventDefault=function(){this.originalEvent.preventDefault()},t.prototype.stopPropagation=function(){this.originalEvent.stopPropagation()},t}(Q);$.KeyboardContextMenuEvent=ee})),define(Q[88],n([0,1,17,11,7,36]),(function(X,$,Q,J,ee,te){Object.defineProperty($,"__esModule",{value:!0});var ne=function(){function e(){this._arr=[]}return e.prototype.set=function(X,$){this._arr.push({keybinding:te.createKeybinding(X,Q.OS),callback:$})},e.prototype.dispatch=function(X){for(var $=this._arr.length-1;$>=0;$--){var Q=this._arr[$];if(X.equals(Q.keybinding))return Q.callback}return null},e}();$.KeybindingDispatcher=ne;var ie=function(){function e(X){void 0===X&&(X={clickBehavior:0,keyboardSupport:!0,openMode:0});var $=this;this.options=X,this.downKeyBindingDispatcher=new ne,this.upKeyBindingDispatcher=new ne,("boolean"!=typeof X.keyboardSupport||X.keyboardSupport)&&(this.downKeyBindingDispatcher.set(16,(function(X,Q){return $.onUp(X,Q)})),this.downKeyBindingDispatcher.set(18,(function(X,Q){return $.onDown(X,Q)})),this.downKeyBindingDispatcher.set(15,(function(X,Q){return $.onLeft(X,Q)})),this.downKeyBindingDispatcher.set(17,(function(X,Q){return $.onRight(X,Q)})),Q.isMacintosh&&(this.downKeyBindingDispatcher.set(2064,(function(X,Q){return $.onLeft(X,Q)})),this.downKeyBindingDispatcher.set(300,(function(X,Q){return $.onDown(X,Q)})),this.downKeyBindingDispatcher.set(302,(function(X,Q){return $.onUp(X,Q)}))),this.downKeyBindingDispatcher.set(11,(function(X,Q){return $.onPageUp(X,Q)})),this.downKeyBindingDispatcher.set(12,(function(X,Q){return $.onPageDown(X,Q)})),this.downKeyBindingDispatcher.set(14,(function(X,Q){return $.onHome(X,Q)})),this.downKeyBindingDispatcher.set(13,(function(X,Q){return $.onEnd(X,Q)})),this.downKeyBindingDispatcher.set(10,(function(X,Q){return $.onSpace(X,Q)})),this.downKeyBindingDispatcher.set(9,(function(X,Q){return $.onEscape(X,Q)})),this.upKeyBindingDispatcher.set(3,this.onEnter.bind(this)),this.upKeyBindingDispatcher.set(2051,this.onEnter.bind(this)))}return e.prototype.onMouseDown=function(X,$,Q,J){if(void 0===J&&(J="mouse"),0===this.options.clickBehavior&&(Q.leftButton||Q.middleButton)){if(Q.target){if(Q.target.tagName&&"input"===Q.target.tagName.toLowerCase())return!1;if(ee.findParentWithClass(Q.target,"scrollbar","monaco-tree"))return!1;if(ee.findParentWithClass(Q.target,"monaco-action-bar","row"))return!1}return this.onLeftClick(X,$,Q,J)}return!1},e.prototype.onClick=function(X,$,J){return Q.isMacintosh&&J.ctrlKey?(J.preventDefault(),J.stopPropagation(),!1):(!J.target||!J.target.tagName||"input"!==J.target.tagName.toLowerCase())&&(0!==this.options.clickBehavior||!J.leftButton&&!J.middleButton)&&this.onLeftClick(X,$,J)},e.prototype.onLeftClick=function(X,$,Q,ee){void 0===ee&&(ee="mouse");var te=Q,ne={origin:ee,originalEvent:Q,didClickOnTwistie:this.isClickOnTwistie(te)};return X.getInput()===$?(X.clearFocus(ne),X.clearSelection(ne)):(Q&&te.browserEvent&&"mousedown"===te.browserEvent.type&&1===te.browserEvent.detail||Q.preventDefault(),Q.stopPropagation(),X.domFocus(),X.setSelection([$],ne),X.setFocus($,ne),this.shouldToggleExpansion($,te,ee)&&(X.isExpanded($)?X.collapse($).then(null,J.onUnexpectedError):X.expand($).then(null,J.onUnexpectedError))),!0},e.prototype.shouldToggleExpansion=function(X,$,Q){var J="mouse"===Q&&2===$.detail;return this.openOnSingleClick||J||this.isClickOnTwistie($)},e.prototype.setOpenMode=function(X){this.options.openMode=X},Object.defineProperty(e.prototype,"openOnSingleClick",{get:function(){return 0===this.options.openMode},enumerable:!0,configurable:!0}),e.prototype.isClickOnTwistie=function(X){var $=X.target;if(!ee.hasClass($,"content"))return!1;var Q=window.getComputedStyle($,":before");if("none"===Q.backgroundImage||"none"===Q.display)return!1;var J=parseInt(Q.width)+parseInt(Q.paddingRight);return X.browserEvent.offsetX<=J},e.prototype.onContextMenu=function(X,$,Q){return!(Q.target&&Q.target.tagName&&"input"===Q.target.tagName.toLowerCase()||(Q&&(Q.preventDefault(),Q.stopPropagation()),1))},e.prototype.onTap=function(X,$,Q){var J=Q.initialTarget;return(!J||!J.tagName||"input"!==J.tagName.toLowerCase())&&this.onLeftClick(X,$,Q,"touch")},e.prototype.onKeyDown=function(X,$){return this.onKey(this.downKeyBindingDispatcher,X,$)},e.prototype.onKeyUp=function(X,$){return this.onKey(this.upKeyBindingDispatcher,X,$)},e.prototype.onKey=function(X,$,Q){var J=X.dispatch(Q.toKeybinding());return!(!J||!J($,Q)||(Q.preventDefault(),Q.stopPropagation(),0))},e.prototype.onUp=function(X,$){var Q={origin:"keyboard",originalEvent:$};return X.getHighlight()?X.clearHighlight(Q):(X.focusPrevious(1,Q),X.reveal(X.getFocus()).then(null,J.onUnexpectedError)),!0},e.prototype.onPageUp=function(X,$){var Q={origin:"keyboard",originalEvent:$};return X.getHighlight()?X.clearHighlight(Q):(X.focusPreviousPage(Q),X.reveal(X.getFocus()).then(null,J.onUnexpectedError)),!0},e.prototype.onDown=function(X,$){var Q={origin:"keyboard",originalEvent:$};return X.getHighlight()?X.clearHighlight(Q):(X.focusNext(1,Q),X.reveal(X.getFocus()).then(null,J.onUnexpectedError)),!0},e.prototype.onPageDown=function(X,$){var Q={origin:"keyboard",originalEvent:$};return X.getHighlight()?X.clearHighlight(Q):(X.focusNextPage(Q),X.reveal(X.getFocus()).then(null,J.onUnexpectedError)),!0},e.prototype.onHome=function(X,$){var Q={origin:"keyboard",originalEvent:$};return X.getHighlight()?X.clearHighlight(Q):(X.focusFirst(Q),X.reveal(X.getFocus()).then(null,J.onUnexpectedError)),!0},e.prototype.onEnd=function(X,$){var Q={origin:"keyboard",originalEvent:$};return X.getHighlight()?X.clearHighlight(Q):(X.focusLast(Q),X.reveal(X.getFocus()).then(null,J.onUnexpectedError)),!0},e.prototype.onLeft=function(X,$){var Q={origin:"keyboard",originalEvent:$};if(X.getHighlight())X.clearHighlight(Q);else{var ee=X.getFocus();X.collapse(ee).then((function($){if(ee&&!$)return X.focusParent(Q),X.reveal(X.getFocus())})).then(null,J.onUnexpectedError)}return!0},e.prototype.onRight=function(X,$){var Q={origin:"keyboard",originalEvent:$};if(X.getHighlight())X.clearHighlight(Q);else{var ee=X.getFocus();X.expand(ee).then((function($){if(ee&&!$)return X.focusFirstChild(Q),X.reveal(X.getFocus())})).then(null,J.onUnexpectedError)}return!0},e.prototype.onEnter=function(X,$){var Q={origin:"keyboard",originalEvent:$};if(X.getHighlight())return!1;var J=X.getFocus();return J&&X.setSelection([J],Q),!0},e.prototype.onSpace=function(X,$){if(X.getHighlight())return!1;var Q=X.getFocus();return Q&&X.toggleExpansion(Q),!0},e.prototype.onEscape=function(X,$){var Q={origin:"keyboard",originalEvent:$};return X.getHighlight()?(X.clearHighlight(Q),!0):X.getSelection().length?(X.clearSelection(Q),!0):!!X.getFocus()&&(X.clearFocus(Q),!0)},e}();$.DefaultController=ie;var oe=function(){function e(){}return e.prototype.getDragURI=function(X,$){return null},e.prototype.onDragStart=function(X,$,Q){},e.prototype.onDragOver=function(X,$,Q,J){return null},e.prototype.drop=function(X,$,Q,J){},e}();$.DefaultDragAndDrop=oe;var re=function(){function e(){}return e.prototype.isVisible=function(X,$){return!0},e}();$.DefaultFilter=re;var se=function(){function e(){}return e.prototype.getAriaLabel=function(X,$){return null},e}();$.DefaultAccessibilityProvider=se;var ae=function(){function e(X,$){this.styleElement=X,this.selectorSuffix=$}return e.prototype.style=function(X){var $=this.selectorSuffix?"."+this.selectorSuffix:"",Q=[];X.listFocusBackground&&Q.push(".monaco-tree"+$+".focused .monaco-tree-rows > .monaco-tree-row.focused:not(.highlighted) { background-color: "+X.listFocusBackground+"; }"),X.listFocusForeground&&Q.push(".monaco-tree"+$+".focused .monaco-tree-rows > .monaco-tree-row.focused:not(.highlighted) { color: "+X.listFocusForeground+"; }"),X.listActiveSelectionBackground&&Q.push(".monaco-tree"+$+".focused .monaco-tree-rows > .monaco-tree-row.selected:not(.highlighted) { background-color: "+X.listActiveSelectionBackground+"; }"),X.listActiveSelectionForeground&&Q.push(".monaco-tree"+$+".focused .monaco-tree-rows > .monaco-tree-row.selected:not(.highlighted) { color: "+X.listActiveSelectionForeground+"; }"),X.listFocusAndSelectionBackground&&Q.push("\n\t\t\t\t.monaco-tree-drag-image,\n\t\t\t\t.monaco-tree"+$+".focused .monaco-tree-rows > .monaco-tree-row.focused.selected:not(.highlighted) { background-color: "+X.listFocusAndSelectionBackground+"; }\n\t\t\t"),X.listFocusAndSelectionForeground&&Q.push("\n\t\t\t\t.monaco-tree-drag-image,\n\t\t\t\t.monaco-tree"+$+".focused .monaco-tree-rows > .monaco-tree-row.focused.selected:not(.highlighted) { color: "+X.listFocusAndSelectionForeground+"; }\n\t\t\t"),X.listInactiveSelectionBackground&&Q.push(".monaco-tree"+$+" .monaco-tree-rows > .monaco-tree-row.selected:not(.highlighted) { background-color: "+X.listInactiveSelectionBackground+"; }"),X.listInactiveSelectionForeground&&Q.push(".monaco-tree"+$+" .monaco-tree-rows > .monaco-tree-row.selected:not(.highlighted) { color: "+X.listInactiveSelectionForeground+"; }"),X.listHoverBackground&&Q.push(".monaco-tree"+$+" .monaco-tree-rows > .monaco-tree-row:hover:not(.highlighted):not(.selected):not(.focused) { background-color: "+X.listHoverBackground+"; }"),X.listHoverForeground&&Q.push(".monaco-tree"+$+" .monaco-tree-rows > .monaco-tree-row:hover:not(.highlighted):not(.selected):not(.focused) { color: "+X.listHoverForeground+"; }"),X.listDropBackground&&Q.push("\n\t\t\t\t.monaco-tree"+$+" .monaco-tree-wrapper.drop-target,\n\t\t\t\t.monaco-tree"+$+" .monaco-tree-rows > .monaco-tree-row.drop-target { background-color: "+X.listDropBackground+" !important; color: inherit !important; }\n\t\t\t"),X.listFocusOutline&&Q.push("\n\t\t\t\t.monaco-tree-drag-image\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t{ border: 1px solid "+X.listFocusOutline+"; background: #000; }\n\t\t\t\t.monaco-tree"+$+" .monaco-tree-rows > .monaco-tree-row \t\t\t\t\t\t\t\t\t\t\t\t\t\t{ border: 1px solid transparent; }\n\t\t\t\t.monaco-tree"+$+".focused .monaco-tree-rows > .monaco-tree-row.focused:not(.highlighted) \t\t\t\t\t\t{ border: 1px dotted "+X.listFocusOutline+"; }\n\t\t\t\t.monaco-tree"+$+".focused .monaco-tree-rows > .monaco-tree-row.selected:not(.highlighted) \t\t\t\t\t\t{ border: 1px solid "+X.listFocusOutline+"; }\n\t\t\t\t.monaco-tree"+$+" .monaco-tree-rows > .monaco-tree-row.selected:not(.highlighted)  \t\t\t\t\t\t\t{ border: 1px solid "+X.listFocusOutline+"; }\n\t\t\t\t.monaco-tree"+$+" .monaco-tree-rows > .monaco-tree-row:hover:not(.highlighted):not(.selected):not(.focused)  \t{ border: 1px dashed "+X.listFocusOutline+"; }\n\t\t\t\t.monaco-tree"+$+" .monaco-tree-wrapper.drop-target,\n\t\t\t\t.monaco-tree"+$+" .monaco-tree-rows > .monaco-tree-row.drop-target\t\t\t\t\t\t\t\t\t\t\t\t{ border: 1px dashed "+X.listFocusOutline+"; }\n\t\t\t");var J=Q.join("\n");J!==this.styleElement.innerHTML&&(this.styleElement.innerHTML=J)},e}();$.DefaultTreestyler=ae})),define(Q[443],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q=function(){function e(X){this.elements=X}return e.prototype.update=function(X){},e}();$.ElementsDragAndDropData=Q;var J=function(){function e(X){this.elements=X}return e.prototype.update=function(X){},e}();$.ExternalElementsDragAndDropData=J;var ee=function(){function e(){this.types=[],this.files=[]}return e.prototype.update=function(X){X.dataTransfer.types&&(this.types=[],Array.prototype.push.apply(this.types,X.dataTransfer.types)),X.dataTransfer.files&&(this.files=[],Array.prototype.push.apply(this.files,X.dataTransfer.files),this.files=this.files.filter((function(X){return X.size||X.type})))},e}();$.DesktopDragAndDropData=ee})),define(Q[444],n([0,1,135,11,2,53,6]),(function(X,$,Q,J,ee,ne,ie){Object.defineProperty($,"__esModule",{value:!0});var oe=function(){function e(X){this._onDispose=new ie.Emitter,this.onDispose=this._onDispose.event,this._item=X}return Object.defineProperty(e.prototype,"item",{get:function(){return this._item},enumerable:!0,configurable:!0}),e.prototype.dispose=function(){this._onDispose&&(this._onDispose.fire(),this._onDispose.dispose(),this._onDispose=null)},e}();$.LockData=oe;var re=function(){function e(){this.locks=Object.create({})}return e.prototype.isLocked=function(X){return!!this.locks[X.id]},e.prototype.run=function(X,$){var Q=this,J=this.getLock(X);return J?new ne.TPromise((function(ee,te){ie.once(J.onDispose)((function(){return Q.run(X,$).then(ee,te)}))})):new ne.TPromise((function(J,ee){if(X.isDisposed())return ee(new Error("Item is disposed."));var te=Q.locks[X.id]=new oe(X);return $().then((function($){return delete Q.locks[X.id],te.dispose(),$})).then(J,ee)}))},e.prototype.getLock=function(X){var $;for($ in this.locks){var Q=this.locks[$];if(X.intersects(Q.item))return Q}return null},e}();$.Lock=re;var se=function(){function e(){this._isDisposed=!1,this._onDidRevealItem=new ie.EventMultiplexer,this.onDidRevealItem=this._onDidRevealItem.event,this._onExpandItem=new ie.EventMultiplexer,this.onExpandItem=this._onExpandItem.event,this._onDidExpandItem=new ie.EventMultiplexer,this.onDidExpandItem=this._onDidExpandItem.event,this._onCollapseItem=new ie.EventMultiplexer,this.onCollapseItem=this._onCollapseItem.event,this._onDidCollapseItem=new ie.EventMultiplexer,this.onDidCollapseItem=this._onDidCollapseItem.event,this._onDidAddTraitItem=new ie.EventMultiplexer,this.onDidAddTraitItem=this._onDidAddTraitItem.event,this._onDidRemoveTraitItem=new ie.EventMultiplexer,this.onDidRemoveTraitItem=this._onDidRemoveTraitItem.event,this._onDidRefreshItem=new ie.EventMultiplexer,this.onDidRefreshItem=this._onDidRefreshItem.event,this._onRefreshItemChildren=new ie.EventMultiplexer,this.onRefreshItemChildren=this._onRefreshItemChildren.event,this._onDidRefreshItemChildren=new ie.EventMultiplexer,this.onDidRefreshItemChildren=this._onDidRefreshItemChildren.event,this._onDidDisposeItem=new ie.EventMultiplexer,this.onDidDisposeItem=this._onDidDisposeItem.event,this.items={}}return e.prototype.register=function(X){Q.ok(!this.isRegistered(X.id),"item already registered: "+X.id);var $=ee.combinedDisposable([this._onDidRevealItem.add(X.onDidReveal),this._onExpandItem.add(X.onExpand),this._onDidExpandItem.add(X.onDidExpand),this._onCollapseItem.add(X.onCollapse),this._onDidCollapseItem.add(X.onDidCollapse),this._onDidAddTraitItem.add(X.onDidAddTrait),this._onDidRemoveTraitItem.add(X.onDidRemoveTrait),this._onDidRefreshItem.add(X.onDidRefresh),this._onRefreshItemChildren.add(X.onRefreshChildren),this._onDidRefreshItemChildren.add(X.onDidRefreshChildren),this._onDidDisposeItem.add(X.onDidDispose)]);this.items[X.id]={item:X,disposable:$}},e.prototype.deregister=function(X){Q.ok(this.isRegistered(X.id),"item not registered: "+X.id),this.items[X.id].disposable.dispose(),delete this.items[X.id]},e.prototype.isRegistered=function(X){return this.items.hasOwnProperty(X)},e.prototype.getItem=function(X){var $=this.items[X];return $?$.item:null},e.prototype.dispose=function(){this.items=null,this._onDidRevealItem.dispose(),this._onExpandItem.dispose(),this._onDidExpandItem.dispose(),this._onCollapseItem.dispose(),this._onDidCollapseItem.dispose(),this._onDidAddTraitItem.dispose(),this._onDidRemoveTraitItem.dispose(),this._onDidRefreshItem.dispose(),this._onRefreshItemChildren.dispose(),this._onDidRefreshItemChildren.dispose(),this._isDisposed=!0},e.prototype.isDisposed=function(){return this._isDisposed},e}();$.ItemRegistry=se;var ae=function(){function e(X,$,Q,J,ee){this._onDidCreate=new ie.Emitter,this._onDidReveal=new ie.Emitter,this.onDidReveal=this._onDidReveal.event,this._onExpand=new ie.Emitter,this.onExpand=this._onExpand.event,this._onDidExpand=new ie.Emitter,this.onDidExpand=this._onDidExpand.event,this._onCollapse=new ie.Emitter,this.onCollapse=this._onCollapse.event,this._onDidCollapse=new ie.Emitter,this.onDidCollapse=this._onDidCollapse.event,this._onDidAddTrait=new ie.Emitter,this.onDidAddTrait=this._onDidAddTrait.event,this._onDidRemoveTrait=new ie.Emitter,this.onDidRemoveTrait=this._onDidRemoveTrait.event,this._onDidRefresh=new ie.Emitter,this.onDidRefresh=this._onDidRefresh.event,this._onRefreshChildren=new ie.Emitter,this.onRefreshChildren=this._onRefreshChildren.event,this._onDidRefreshChildren=new ie.Emitter,this.onDidRefreshChildren=this._onDidRefreshChildren.event,this._onDidDispose=new ie.Emitter,this.onDidDispose=this._onDidDispose.event,this.registry=$,this.context=Q,this.lock=J,this.element=ee,this.id=X,this.registry.register(this),this.doesHaveChildren=this.context.dataSource.hasChildren(this.context.tree,this.element),this.needsChildrenRefresh=!0,this.parent=null,this.previous=null,this.next=null,this.firstChild=null,this.lastChild=null,this.traits={},this.depth=0,this.expanded=this.context.dataSource.shouldAutoexpand&&this.context.dataSource.shouldAutoexpand(this.context.tree,ee),this._onDidCreate.fire(this),this.visible=this._isVisible(),this.height=this._getHeight(),this._isDisposed=!1}return e.prototype.getElement=function(){return this.element},e.prototype.hasChildren=function(){return this.doesHaveChildren},e.prototype.getDepth=function(){return this.depth},e.prototype.isVisible=function(){return this.visible},e.prototype.setVisible=function(X){this.visible=X},e.prototype.isExpanded=function(){return this.expanded},e.prototype._setExpanded=function(X){this.expanded=X},e.prototype.reveal=function(X){void 0===X&&(X=null);var $={item:this,relativeTop:X};this._onDidReveal.fire($)},e.prototype.expand=function(){var X=this;return this.isExpanded()||!this.doesHaveChildren||this.lock.isLocked(this)?ne.TPromise.as(!1):this.lock.run(this,(function(){if(X.isExpanded()||!X.doesHaveChildren)return ne.TPromise.as(!1);var $={item:X};return X._onExpand.fire($),(X.needsChildrenRefresh?X.refreshChildren(!1,!0,!0):ne.TPromise.as(null)).then((function(){return X._setExpanded(!0),X._onDidExpand.fire($),!0}))})).then((function($){return!X.isDisposed()&&(X.context.options.autoExpandSingleChildren&&$&&null!==X.firstChild&&X.firstChild===X.lastChild&&X.firstChild.isVisible()?X.firstChild.expand().then((function(){return!0})):$)}))},e.prototype.collapse=function(X){var $=this;if(void 0===X&&(X=!1),X){var Q=ne.TPromise.as(null);return this.forEachChild((function(X){Q=Q.then((function(){return X.collapse(!0)}))})),Q.then((function(){return $.collapse(!1)}))}return!this.isExpanded()||this.lock.isLocked(this)?ne.TPromise.as(!1):this.lock.run(this,(function(){var X={item:$};return $._onCollapse.fire(X),$._setExpanded(!1),$._onDidCollapse.fire(X),ne.TPromise.as(!0)}))},e.prototype.addTrait=function(X){var $={item:this,trait:X};this.traits[X]=!0,this._onDidAddTrait.fire($)},e.prototype.removeTrait=function(X){var $={item:this,trait:X};delete this.traits[X],this._onDidRemoveTrait.fire($)},e.prototype.hasTrait=function(X){return this.traits[X]||!1},e.prototype.getAllTraits=function(){var X,$=[];for(X in this.traits)this.traits.hasOwnProperty(X)&&this.traits[X]&&$.push(X);return $},e.prototype.getHeight=function(){return this.height},e.prototype.refreshChildren=function(X,$,Q){var ee=this;if(void 0===$&&($=!1),void 0===Q&&(Q=!1),!Q&&!this.isExpanded()){var a=function(X){X.needsChildrenRefresh=!0,X.forEachChild(a)};return a(this),ne.TPromise.as(this)}this.needsChildrenRefresh=!1;var l=function(){var Q={item:ee,isNested:$};return ee._onRefreshChildren.fire(Q),(ee.doesHaveChildren?ee.context.dataSource.getChildren(ee.context.tree,ee.element):ne.TPromise.as([])).then((function($){if(ee.isDisposed()||ee.registry.isDisposed())return ne.TPromise.as(null);if(!Array.isArray($))return ne.TPromise.wrapError(new Error("Please return an array of children."));$=$?$.slice(0):[],$=ee.sort($);for(var Q={};null!==ee.firstChild;)Q[ee.firstChild.id]=ee.firstChild,ee.removeChild(ee.firstChild);for(var J=0,te=$.length;J<te;J++){var ie=$[J],oe=ee.context.dataSource.getId(ee.context.tree,ie),re=Q[oe]||new e(oe,ee.registry,ee.context,ee.lock,ie);re.element=ie,X&&(re.needsChildrenRefresh=X),delete Q[oe],ee.addChild(re)}for(var se in Q)Q.hasOwnProperty(se)&&Q[se].dispose();return X?ne.Promise.join(ee.mapEachChild((function($){return $.doRefresh(X,!0)}))):ne.Promise.join(ee.mapEachChild((function($){return $.isExpanded()&&$.needsChildrenRefresh?$.doRefresh(X,!0):($.updateVisibility(),ne.TPromise.as(null))})))})).then(null,J.onUnexpectedError).then((function(){return ee._onDidRefreshChildren.fire(Q)}))};return $?l():this.lock.run(this,l)},e.prototype.doRefresh=function(X,$){return void 0===$&&($=!1),this.doesHaveChildren=this.context.dataSource.hasChildren(this.context.tree,this.element),this.height=this._getHeight(),this.updateVisibility(),this._onDidRefresh.fire(this),this.refreshChildren(X,$)},e.prototype.updateVisibility=function(){this.setVisible(this._isVisible())},e.prototype.refresh=function(X){return this.doRefresh(X)},e.prototype.getNavigator=function(){return new ue(this)},e.prototype.intersects=function(X){return this.isAncestorOf(X)||X.isAncestorOf(this)},e.prototype.isAncestorOf=function(X){for(;X;){if(X.id===this.id)return!0;X=X.parent}return!1},e.prototype.addChild=function(X,$){void 0===$&&($=this.lastChild);var Q=null===this.firstChild,J=null===$,ee=$===this.lastChild;Q?(this.firstChild=this.lastChild=X,X.next=X.previous=null):J?(this.firstChild.previous=X,X.next=this.firstChild,X.previous=null,this.firstChild=X):ee?(this.lastChild.next=X,X.next=null,X.previous=this.lastChild,this.lastChild=X):(X.previous=$,X.next=$.next,$.next.previous=X,$.next=X),X.parent=this,X.depth=this.depth+1},e.prototype.removeChild=function(X){var $=this.firstChild===X,Q=this.lastChild===X;$&&Q?this.firstChild=this.lastChild=null:$?(X.next.previous=null,this.firstChild=X.next):Q?(X.previous.next=null,this.lastChild=X.previous):(X.next.previous=X.previous,X.previous.next=X.next),X.parent=null,X.depth=null},e.prototype.forEachChild=function(X){for(var $,Q=this.firstChild;Q;)$=Q.next,X(Q),Q=$},e.prototype.mapEachChild=function(X){var $=[];return this.forEachChild((function(Q){$.push(X(Q))})),$},e.prototype.sort=function(X){var $=this;return this.context.sorter?X.sort((function(X,Q){return $.context.sorter.compare($.context.tree,X,Q)})):X},e.prototype._getHeight=function(){return this.context.renderer.getHeight(this.context.tree,this.element)},e.prototype._isVisible=function(){return this.context.filter.isVisible(this.context.tree,this.element)},e.prototype.isDisposed=function(){return this._isDisposed},e.prototype.dispose=function(){this.forEachChild((function(X){return X.dispose()})),this.parent=null,this.previous=null,this.next=null,this.firstChild=null,this.lastChild=null,this._onDidDispose.fire(this),this.registry.deregister(this),this._onDidCreate.dispose(),this._onDidReveal.dispose(),this._onExpand.dispose(),this._onDidExpand.dispose(),this._onCollapse.dispose(),this._onDidCollapse.dispose(),this._onDidAddTrait.dispose(),this._onDidRemoveTrait.dispose(),this._onDidRefresh.dispose(),this._onRefreshChildren.dispose(),this._onDidRefreshChildren.dispose(),this._onDidDispose.dispose(),this._isDisposed=!0},e}();$.Item=ae;var le=function(X){function t($,Q,J,ee,te){return X.call(this,$,Q,J,ee,te)||this}return te(t,X),t.prototype.isVisible=function(){return!1},t.prototype.setVisible=function(X){},t.prototype.isExpanded=function(){return!0},t.prototype._setExpanded=function(X){},t.prototype._getHeight=function(){return 0},t.prototype._isVisible=function(){return!1},t}(ae),ue=function(){function e(X,$){void 0===$&&($=!0),this.item=X,this.start=$?X:null}return e.lastDescendantOf=function(X){return X?X instanceof le?e.lastDescendantOf(X.lastChild):X.isVisible()?X.isExpanded()&&null!==X.lastChild?e.lastDescendantOf(X.lastChild):X:e.lastDescendantOf(X.previous):null},e.prototype.current=function(){return this.item||null},e.prototype.next=function(){if(this.item)do{if((this.item instanceof le||this.item.isVisible()&&this.item.isExpanded())&&this.item.firstChild)this.item=this.item.firstChild;else if(this.item===this.start)this.item=null;else{for(;this.item&&this.item!==this.start&&!this.item.next;)this.item=this.item.parent;this.item===this.start&&(this.item=null),this.item=this.item?this.item.next:null}}while(this.item&&!this.item.isVisible());return this.item||null},e.prototype.previous=function(){if(this.item)do{var X=e.lastDescendantOf(this.item.previous);X?this.item=X:this.item.parent&&this.item.parent!==this.start&&this.item.parent.isVisible()?this.item=this.item.parent:this.item=null}while(this.item&&!this.item.isVisible());return this.item||null},e.prototype.parent=function(){if(this.item){var X=this.item.parent;X&&X!==this.start&&X.isVisible()?this.item=X:this.item=null}return this.item||null},e.prototype.first=function(){return this.item=this.start,this.next(),this.item||null},e.prototype.last=function(){return e.lastDescendantOf(this.start)},e}();$.TreeNavigator=ue;var de=function(){function e(X){this._onSetInput=new ie.Emitter,this.onSetInput=this._onSetInput.event,this._onDidSetInput=new ie.Emitter,this.onDidSetInput=this._onDidSetInput.event,this._onRefresh=new ie.Emitter,this.onRefresh=this._onRefresh.event,this._onDidRefresh=new ie.Emitter,this.onDidRefresh=this._onDidRefresh.event,this._onDidHighlight=new ie.Emitter,this.onDidHighlight=this._onDidHighlight.event,this._onDidSelect=new ie.Emitter,this.onDidSelect=this._onDidSelect.event,this._onDidFocus=new ie.Emitter,this.onDidFocus=this._onDidFocus.event,this._onDidRevealItem=new ie.Relay,this.onDidRevealItem=this._onDidRevealItem.event,this._onExpandItem=new ie.Relay,this.onExpandItem=this._onExpandItem.event,this._onDidExpandItem=new ie.Relay,this.onDidExpandItem=this._onDidExpandItem.event,this._onCollapseItem=new ie.Relay,this.onCollapseItem=this._onCollapseItem.event,this._onDidCollapseItem=new ie.Relay,this.onDidCollapseItem=this._onDidCollapseItem.event,this._onDidAddTraitItem=new ie.Relay,this.onDidAddTraitItem=this._onDidAddTraitItem.event,this._onDidRemoveTraitItem=new ie.Relay,this.onDidRemoveTraitItem=this._onDidRemoveTraitItem.event,this._onDidRefreshItem=new ie.Relay,this.onDidRefreshItem=this._onDidRefreshItem.event,this._onRefreshItemChildren=new ie.Relay,this.onRefreshItemChildren=this._onRefreshItemChildren.event,this._onDidRefreshItemChildren=new ie.Relay,this.onDidRefreshItemChildren=this._onDidRefreshItemChildren.event,this._onDidDisposeItem=new ie.Relay,this.context=X,this.input=null,this.traitsToItems={}}return e.prototype.setInput=function(X){var $=this,Q={item:this.input};this._onSetInput.fire(Q),this.setSelection([]),this.setFocus(),this.setHighlight(),this.lock=new re,this.input&&this.input.dispose(),this.registry&&(this.registry.dispose(),this.registryDisposable.dispose()),this.registry=new se,this._onDidRevealItem.input=this.registry.onDidRevealItem,this._onExpandItem.input=this.registry.onExpandItem,this._onDidExpandItem.input=this.registry.onDidExpandItem,this._onCollapseItem.input=this.registry.onCollapseItem,this._onDidCollapseItem.input=this.registry.onDidCollapseItem,this._onDidAddTraitItem.input=this.registry.onDidAddTraitItem,this._onDidRemoveTraitItem.input=this.registry.onDidRemoveTraitItem,this._onDidRefreshItem.input=this.registry.onDidRefreshItem,this._onRefreshItemChildren.input=this.registry.onRefreshItemChildren,this._onDidRefreshItemChildren.input=this.registry.onDidRefreshItemChildren,this._onDidDisposeItem.input=this.registry.onDidDisposeItem,this.registryDisposable=this.registry.onDidDisposeItem((function(X){return X.getAllTraits().forEach((function(Q){return delete $.traitsToItems[Q][X.id]}))}));var J=this.context.dataSource.getId(this.context.tree,X);return this.input=new le(J,this.registry,this.context,this.lock,X),Q={item:this.input},this._onDidSetInput.fire(Q),this.refresh(this.input)},e.prototype.getInput=function(){return this.input?this.input.getElement():null},e.prototype.refresh=function(X,$){var Q=this;void 0===X&&(X=null),void 0===$&&($=!0);var J=this.getItem(X);if(!J)return ne.TPromise.as(null);var ee={item:J,recursive:$};return this._onRefresh.fire(ee),J.refresh($).then((function(){Q._onDidRefresh.fire(ee)}))},e.prototype.expand=function(X){var $=this.getItem(X);return $?$.expand():ne.TPromise.as(!1)},e.prototype.collapse=function(X,$){void 0===$&&($=!1);var Q=this.getItem(X);return Q?Q.collapse($):ne.TPromise.as(!1)},e.prototype.toggleExpansion=function(X,$){return void 0===$&&($=!1),this.isExpanded(X)?this.collapse(X,$):this.expand(X)},e.prototype.isExpanded=function(X){var $=this.getItem(X);return!!$&&$.isExpanded()},e.prototype.reveal=function(X,$){var Q=this;return void 0===$&&($=null),this.resolveUnknownParentChain(X).then((function(X){var $=ne.TPromise.as(null);return X.forEach((function(X){$=$.then((function(){return Q.expand(X)}))})),$})).then((function(){var J=Q.getItem(X);if(J)return J.reveal($)}))},e.prototype.resolveUnknownParentChain=function(X){var $=this;return this.context.dataSource.getParent(this.context.tree,X).then((function(X){return X?$.resolveUnknownParentChain(X).then((function($){return $.push(X),$})):ne.TPromise.as([])}))},e.prototype.setHighlight=function(X,$){this.setTraits("highlighted",X?[X]:[]);var Q={highlight:this.getHighlight(),payload:$};this._onDidHighlight.fire(Q)},e.prototype.getHighlight=function(X){var $=this.getElementsWithTrait("highlighted",X);return 0===$.length?null:$[0]},e.prototype.setSelection=function(X,$){this.setTraits("selected",X);var Q={selection:this.getSelection(),payload:$};this._onDidSelect.fire(Q)},e.prototype.getSelection=function(X){return this.getElementsWithTrait("selected",X)},e.prototype.setFocus=function(X,$){this.setTraits("focused",X?[X]:[]);var Q={focus:this.getFocus(),payload:$};this._onDidFocus.fire(Q)},e.prototype.getFocus=function(X){var $=this.getElementsWithTrait("focused",X);return 0===$.length?null:$[0]},e.prototype.focusNext=function(X,$){void 0===X&&(X=1);for(var Q,J=this.getFocus()||this.input,ee=this.getNavigator(J,!1),te=0;te<X&&(Q=ee.next());te++)J=Q;this.setFocus(J,$)},e.prototype.focusPrevious=function(X,$){void 0===X&&(X=1);for(var Q,J=this.getFocus()||this.input,ee=this.getNavigator(J,!1),te=0;te<X&&(Q=ee.previous());te++)J=Q;this.setFocus(J,$)},e.prototype.focusParent=function(X){var $=this.getFocus()||this.input,Q=this.getNavigator($,!1).parent();Q&&this.setFocus(Q,X)},e.prototype.focusFirstChild=function(X){var $=this.getItem(this.getFocus()||this.input),Q=this.getNavigator($,!1),J=Q.next();Q.parent()===$&&this.setFocus(J,X)},e.prototype.focusFirst=function(X,$){this.focusNth(0,X,$)},e.prototype.focusNth=function(X,$,Q){for(var J=this.getParent(Q),ee=this.getNavigator(J),te=ee.first(),ne=0;ne<X;ne++)te=ee.next();te&&this.setFocus(te,$)},e.prototype.focusLast=function(X,$){var Q,J=this.getParent($);(Q=$?J.lastChild:this.getNavigator(J).last())&&this.setFocus(Q,X)},e.prototype.getParent=function(X){if(X){var $=this.getItem(X);if($&&$.parent)return $.parent}return this.getItem(this.input)},e.prototype.getNavigator=function(X,$){return void 0===X&&(X=null),void 0===$&&($=!0),new ue(this.getItem(X),$)},e.prototype.getItem=function(X){return void 0===X&&(X=null),null===X?this.input:X instanceof ae?X:"string"==typeof X?this.registry.getItem(X):this.registry.getItem(this.context.dataSource.getId(this.context.tree,X))},e.prototype.removeTraits=function(X,$){var Q,J,ee=this.traitsToItems[X]||{};if(0===$.length){for(J in ee)ee.hasOwnProperty(J)&&(Q=ee[J]).removeTrait(X);delete this.traitsToItems[X]}else for(var te=0,ne=$.length;te<ne;te++)(Q=this.getItem($[te]))&&(Q.removeTrait(X),delete ee[Q.id])},e.prototype.setTraits=function(X,$){if(0===$.length)this.removeTraits(X,$);else{for(var Q,J={},ee=0,te=$.length;ee<te;ee++)(Q=this.getItem($[ee]))&&(J[Q.id]=Q);var ne,ie=this.traitsToItems[X]||{},oe=[];for(ne in ie)ie.hasOwnProperty(ne)&&(J.hasOwnProperty(ne)?delete J[ne]:oe.push(ie[ne]));for(ee=0,te=oe.length;ee<te;ee++)(Q=oe[ee]).removeTrait(X),delete ie[Q.id];for(ne in J)J.hasOwnProperty(ne)&&((Q=J[ne]).addTrait(X),ie[ne]=Q);this.traitsToItems[X]=ie}},e.prototype.getElementsWithTrait=function(X,$){var Q,J=[],ee=this.traitsToItems[X]||{};for(Q in ee)ee.hasOwnProperty(Q)&&(ee[Q].isVisible()||$)&&J.push(ee[Q].getElement());return J},e.prototype.dispose=function(){this.registry&&(this.registry.dispose(),this.registry=null),this._onSetInput.dispose(),this._onDidSetInput.dispose(),this._onRefresh.dispose(),this._onDidRefresh.dispose(),this._onDidHighlight.dispose(),this._onDidSelect.dispose(),this._onDidFocus.dispose(),this._onDidRevealItem.dispose(),this._onExpandItem.dispose(),this._onDidExpandItem.dispose(),this._onCollapseItem.dispose(),this._onDidCollapseItem.dispose(),this._onDidAddTraitItem.dispose(),this._onDidRemoveTraitItem.dispose(),this._onDidRefreshItem.dispose(),this._onRefreshItemChildren.dispose(),this._onDidRefreshItemChildren.dispose(),this._onDidDisposeItem.dispose()},e}();$.TreeModel=de})),define(Q[445],n([0,1,87]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(){function e(){this.heightMap=[],this.indexes={}}return e.prototype.getContentHeight=function(){var X=this.heightMap[this.heightMap.length-1];return X?X.top+X.height:0},e.prototype.onInsertItems=function(X,$){void 0===$&&($=null);var Q,J,ee,te,ne,ie=0;if(null===$)ee=0,ne=0;else{if(ee=this.indexes[$]+1,!(J=this.heightMap[ee-1]))return void console.error("view item doesnt exist");ne=J.top+J.height}for(var oe=this.heightMap.splice.bind(this.heightMap,ee,0),re=[];Q=X.next();)(J=this.createViewItem(Q)).top=ne+ie,this.indexes[Q.id]=ee++,re.push(J),ie+=J.height;for(oe.apply(this.heightMap,re),te=ee;te<this.heightMap.length;te++)(J=this.heightMap[te]).top+=ie,this.indexes[J.model.id]=te;for(te=re.length-1;te>=0;te--)this.onInsertItem(re[te]);for(te=this.heightMap.length-1;te>=ee;te--)this.onRefreshItem(this.heightMap[te]);return ie},e.prototype.onInsertItem=function(X){},e.prototype.onRemoveItems=function(X){for(var $,Q,J,ee=null,te=0;$=X.next();){if(J=this.indexes[$],!(Q=this.heightMap[J]))return void console.error("view item doesnt exist");te-=Q.height,delete this.indexes[$],this.onRemoveItem(Q),null===ee&&(ee=J)}if(0!==te)for(this.heightMap.splice(ee,J-ee+1),J=ee;J<this.heightMap.length;J++)(Q=this.heightMap[J]).top+=te,this.indexes[Q.model.id]=J,this.onRefreshItem(Q)},e.prototype.onRemoveItem=function(X){},e.prototype.onRefreshItemSet=function(X){var $=this,J=X.sort((function(X,Q){return $.indexes[X.id]-$.indexes[Q.id]}));this.onRefreshItems(new Q.ArrayIterator(J))},e.prototype.onRefreshItems=function(X){for(var $,Q,J,ee,te=null,ne=0;$=X.next();){for(ee=this.indexes[$.id];0!==ne&&null!==te&&te<ee;te++)(Q=this.heightMap[te]).top+=ne,this.onRefreshItem(Q);Q=this.heightMap[ee],J=$.getHeight(),Q.top+=ne,ne+=J-Q.height,Q.height=J,this.onRefreshItem(Q,!0),te=ee+1}if(0!==ne&&null!==te)for(;te<this.heightMap.length;te++)(Q=this.heightMap[te]).top+=ne,this.onRefreshItem(Q)},e.prototype.onRefreshItem=function(X,$){void 0===$&&($=!1)},e.prototype.indexAt=function(X){for(var $,Q,J=0,ee=this.heightMap.length;J<ee;)if($=Math.floor((J+ee)/2),X<(Q=this.heightMap[$]).top)ee=$;else{if(!(X>=Q.top+Q.height))return $;if(J===$)break;J=$}return this.heightMap.length},e.prototype.indexAfter=function(X){return Math.min(this.indexAt(X)+1,this.heightMap.length)},e.prototype.itemAtIndex=function(X){return this.heightMap[X]},e.prototype.itemAfter=function(X){return this.heightMap[this.indexes[X.model.id]+1]||null},e.prototype.createViewItem=function(X){throw new Error("not implemented")},e.prototype.dispose=function(){this.heightMap=null,this.indexes=null},e}();$.HeightMap=J})),define(Q[454],n([0,1,17,148]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(){function t($,J,ee,te,ne){this.id=J,this.worker=function($,J){if(Q.globals.MonacoEnvironment){if("function"==typeof Q.globals.MonacoEnvironment.getWorker)return Q.globals.MonacoEnvironment.getWorker($,J);if("function"==typeof Q.globals.MonacoEnvironment.getWorkerUrl)return new Worker(Q.globals.MonacoEnvironment.getWorkerUrl($,J))}if("function"==typeof X)return new Worker(X.toUrl("./"+$)+"#"+J);throw new Error("You must define a function MonacoEnvironment.getWorkerUrl or MonacoEnvironment.getWorker")}("workerMain.js",ee),this.postMessage($),this.worker.onmessage=function(X){te(X.data)},"function"==typeof this.worker.addEventListener&&this.worker.addEventListener("error",ne)}return t.prototype.getId=function(){return this.id},t.prototype.postMessage=function(X){this.worker&&this.worker.postMessage(X)},t.prototype.dispose=function(){this.worker&&this.worker.terminate(),this.worker=null},t}(),te=function(){function e(X){this._label=X,this._webWorkerFailedBeforeError=!1}return e.prototype.create=function(X,$,Q){var te=this,ne=++e.LAST_WORKER_ID;if(this._webWorkerFailedBeforeError)throw this._webWorkerFailedBeforeError;return new ee(X,ne,this._label||"anonymous"+ne,$,(function(X){J.logOnceWebWorkerWarning(X),te._webWorkerFailedBeforeError=X,Q(X)}))},e.LAST_WORKER_ID=0,e}();$.DefaultWorkerFactory=te})),define(Q[463],n([9]),{}),define(Q[469],n([9]),{}),define(Q[486],n([9]),{}),define(Q[487],n([0,1,7,46,28,6,27,486]),(function(X,$,Q,J,ee,ne,ie){Object.defineProperty($,"__esModule",{value:!0});var oe={inputActiveOptionBorder:ee.Color.fromHex("#007ACC")},re=function(X){function t($){var Q=X.call(this)||this;return Q._onChange=Q._register(new ne.Emitter),Q._onKeyDown=Q._register(new ne.Emitter),Q._opts=ie.deepClone($),ie.mixin(Q._opts,oe,!1),Q._checked=Q._opts.isChecked,Q.domNode=document.createElement("div"),Q.domNode.title=Q._opts.title,Q.domNode.className="monaco-custom-checkbox "+Q._opts.actionClassName+" "+(Q._checked?"checked":"unchecked"),Q.domNode.tabIndex=0,Q.domNode.setAttribute("role","checkbox"),Q.domNode.setAttribute("aria-checked",String(Q._checked)),Q.domNode.setAttribute("aria-label",Q._opts.title),Q.applyStyles(),Q.onclick(Q.domNode,(function(X){Q.checked=!Q._checked,Q._onChange.fire(!1),X.preventDefault()})),Q.onkeydown(Q.domNode,(function(X){if(10===X.keyCode||3===X.keyCode)return Q.checked=!Q._checked,Q._onChange.fire(!0),void X.preventDefault();Q._onKeyDown.fire(X)})),Q}return te(t,X),Object.defineProperty(t.prototype,"onChange",{get:function(){return this._onChange.event},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"onKeyDown",{get:function(){return this._onKeyDown.event},enumerable:!0,configurable:!0}),t.prototype.focus=function(){this.domNode.focus()},Object.defineProperty(t.prototype,"checked",{get:function(){return this._checked},set:function(X){this._checked=X,this.domNode.setAttribute("aria-checked",String(this._checked)),this._checked?this.domNode.classList.add("checked"):this.domNode.classList.remove("checked"),this.applyStyles()},enumerable:!0,configurable:!0}),t.prototype.width=function(){return 22},t.prototype.style=function(X){X.inputActiveOptionBorder&&(this._opts.inputActiveOptionBorder=X.inputActiveOptionBorder),this.applyStyles()},t.prototype.applyStyles=function(){this.domNode&&(this.domNode.style.borderColor=this._checked&&this._opts.inputActiveOptionBorder?this._opts.inputActiveOptionBorder.toString():"transparent")},t.prototype.enable=function(){this.domNode.tabIndex=0,this.domNode.setAttribute("aria-disabled",String(!1))},t.prototype.disable=function(){Q.removeTabIndexAndUpdateFocus(this.domNode),this.domNode.setAttribute("aria-disabled",String(!0))},t}(J.Widget);$.Checkbox=re})),define(Q[505],n([9]),{}),define(Q[508],n([0,1,7,2,115,505]),(function(X,$,Q,J,ee){function s(X,$,Q){var J=Q.offset+Q.size;return 0===Q.position?$<=X-J?J:$<=Q.offset?Q.offset-$:Math.max(X-$,0):$<=Q.offset?Q.offset-$:$<=X-J?J:0}Object.defineProperty($,"__esModule",{value:!0}),$.layout=s;var ne=function(X){function t($){var ee=X.call(this)||this;return ee.view=Q.$(".context-view"),Q.hide(ee.view),ee.setContainer($),ee._register(J.toDisposable((function(){return ee.setContainer(null)}))),ee}return te(t,X),t.prototype.setContainer=function(X){var $=this;if(this.container&&(this.toDisposeOnSetContainer=J.dispose(this.toDisposeOnSetContainer),this.container.removeChild(this.view),this.container=null),X){this.container=X,this.container.appendChild(this.view);var ee=[];t.BUBBLE_UP_EVENTS.forEach((function(X){ee.push(Q.addStandardDisposableListener($.container,X,(function(X){$.onDOMEvent(X,document.activeElement,!1)})))})),t.BUBBLE_DOWN_EVENTS.forEach((function(X){ee.push(Q.addStandardDisposableListener($.container,X,(function(X){$.onDOMEvent(X,document.activeElement,!0)}),!0))})),this.toDisposeOnSetContainer=J.combinedDisposable(ee)}},t.prototype.show=function(X){this.isVisible()&&this.hide(),Q.clearNode(this.view),this.view.className="context-view",this.view.style.top="0px",this.view.style.left="0px",Q.show(this.view),this.toDisposeOnClean=X.render(this.view),this.delegate=X,this.doLayout(),this.delegate.focus&&this.delegate.focus()},t.prototype.layout=function(){this.isVisible()&&(!1!==this.delegate.canRelayout?(this.delegate.layout&&this.delegate.layout(),this.doLayout()):this.hide())},t.prototype.doLayout=function(){if(this.isVisible()){var X,$=this.delegate.getAnchor();if(Q.isHTMLElement($)){var J=Q.getDomNodePagePosition($);X={top:J.top,left:J.left,width:J.width,height:J.height}}else{var te=$;X={top:te.y,left:te.x,width:te.width||1,height:te.height||2}}var ne,ie=Q.getTotalWidth(this.view),oe=Q.getTotalHeight(this.view),re=this.delegate.anchorPosition||0,se=this.delegate.anchorAlignment||0,ae={offset:X.top-window.pageYOffset,size:X.height,position:0===re?0:1};ne=0===se?{offset:X.left,size:0,position:0}:{offset:X.left+X.width,size:0,position:1};var le=s(window.innerHeight,oe,ae)+window.pageYOffset;ee.Range.intersects({start:le,end:le+oe},{start:ae.offset,end:ae.offset+ae.size})&&(ne.size=X.width);var ue=s(window.innerWidth,ie,ne);Q.removeClasses(this.view,"top","bottom","left","right"),Q.addClass(this.view,0===re?"bottom":"top"),Q.addClass(this.view,0===se?"left":"right");var de=Q.getDomNodePagePosition(this.container);this.view.style.top=le-de.top+"px",this.view.style.left=ue-de.left+"px",this.view.style.width="initial"}},t.prototype.hide=function(X){this.delegate&&this.delegate.onHide&&this.delegate.onHide(X),this.delegate=null,this.toDisposeOnClean&&(this.toDisposeOnClean.dispose(),this.toDisposeOnClean=null),Q.hide(this.view)},t.prototype.isVisible=function(){return!!this.delegate},t.prototype.onDOMEvent=function(X,$,J){this.delegate&&(this.delegate.onDOMEvent?this.delegate.onDOMEvent(X,document.activeElement):J&&!Q.isAncestor(X.target,this.container)&&this.hide())},t.prototype.dispose=function(){this.hide(),X.prototype.dispose.call(this)},t.BUBBLE_UP_EVENTS=["click","keydown","focus","blur"],t.BUBBLE_DOWN_EVENTS=["click"],t}(J.Disposable);$.ContextView=ne})),define(Q[528],n([9]),{}),define(Q[549],n([0,1,7,8,28,27,528]),(function(X,$,Q,J,ee,te){Object.defineProperty($,"__esModule",{value:!0});var ne={badgeBackground:ee.Color.fromHex("#4D4D4D"),badgeForeground:ee.Color.fromHex("#FFFFFF")},ie=function(){function e(X,$){this.options=$||Object.create(null),te.mixin(this.options,ne,!1),this.badgeBackground=this.options.badgeBackground,this.badgeForeground=this.options.badgeForeground,this.badgeBorder=this.options.badgeBorder,this.element=Q.append(X,Q.$(".monaco-count-badge")),this.countFormat=this.options.countFormat||"{0}",this.titleFormat=this.options.titleFormat||"",this.setCount(this.options.count||0)}return e.prototype.setCount=function(X){this.count=X,this.render()},e.prototype.setTitleFormat=function(X){this.titleFormat=X,this.render()},e.prototype.render=function(){this.element.textContent=J.format(this.countFormat,this.count),this.element.title=J.format(this.titleFormat,this.count),this.applyStyles()},e.prototype.style=function(X){this.badgeBackground=X.badgeBackground,this.badgeForeground=X.badgeForeground,this.badgeBorder=X.badgeBorder,this.applyStyles()},e.prototype.applyStyles=function(){if(this.element){var X=this.badgeBackground?this.badgeBackground.toString():null,$=this.badgeForeground?this.badgeForeground.toString():null,Q=this.badgeBorder?this.badgeBorder.toString():null;this.element.style.backgroundColor=X,this.element.style.color=$,this.element.style.borderWidth=Q?"1px":null,this.element.style.borderStyle=Q?"solid":null,this.element.style.borderColor=Q}},e}();$.CountBadge=ie})),define(Q[557],n([9]),{}),define(Q[563],n([9]),{}),define(Q[204],n([9]),{}),define(Q[118],n([0,1,7,159,2,204]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var ne=function(){function e(X){this._element=X}return Object.defineProperty(e.prototype,"element",{get:function(){return this._element},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"textContent",{set:function(X){this.disposed||X===this._textContent||(this._textContent=X,this._element.textContent=X)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"className",{set:function(X){this.disposed||X===this._className||(this._className=X,this._element.className=X)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"title",{set:function(X){this.disposed||X===this._title||(this._title=X,this._title?this._element.title=X:this._element.removeAttribute("title"))},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"empty",{set:function(X){this.disposed||X===this._empty||(this._empty=X,this._element.style.marginLeft=X?"0":null)},enumerable:!0,configurable:!0}),e.prototype.dispose=function(){this.disposed=!0},e}(),ie=function(X){function t($,ee){var te=X.call(this)||this;return te.domNode=te._register(new ne(Q.append($,Q.$(".monaco-icon-label")))),te.labelDescriptionContainer=te._register(new ne(Q.append(te.domNode.element,Q.$(".monaco-icon-label-description-container")))),ee&&ee.supportHighlights?te.labelNode=te._register(new J.HighlightedLabel(Q.append(te.labelDescriptionContainer.element,Q.$("a.label-name")),!ee.donotSupportOcticons)):te.labelNode=te._register(new ne(Q.append(te.labelDescriptionContainer.element,Q.$("a.label-name")))),ee&&ee.supportDescriptionHighlights?te.descriptionNodeFactory=function(){return te._register(new J.HighlightedLabel(Q.append(te.labelDescriptionContainer.element,Q.$("span.label-description")),!ee.donotSupportOcticons))}:te.descriptionNodeFactory=function(){return te._register(new ne(Q.append(te.labelDescriptionContainer.element,Q.$("span.label-description"))))},te}return te(t,X),t.prototype.setValue=function(X,$,Q){var ee=["monaco-icon-label"];Q&&(Q.extraClasses&&ee.push.apply(ee,Q.extraClasses),Q.italic&&ee.push("italic")),this.domNode.className=ee.join(" "),this.domNode.title=Q&&Q.title?Q.title:"",this.labelNode instanceof J.HighlightedLabel?this.labelNode.set(X||"",Q?Q.matches:void 0,Q&&Q.title?Q.title:void 0,Q&&Q.labelEscapeNewLines):this.labelNode.textContent=X||"",($||this.descriptionNode)&&(this.descriptionNode||(this.descriptionNode=this.descriptionNodeFactory()),this.descriptionNode instanceof J.HighlightedLabel?(this.descriptionNode.set($||"",Q?Q.descriptionMatches:void 0),Q&&Q.descriptionTitle?this.descriptionNode.element.title=Q.descriptionTitle:this.descriptionNode.element.removeAttribute("title")):(this.descriptionNode.textContent=$||"",this.descriptionNode.title=Q&&Q.descriptionTitle?Q.descriptionTitle:"",this.descriptionNode.empty=!$))},t}(ee.Disposable);$.IconLabel=ie})),define(Q[206],n([9]),{}),define(Q[210],n([9]),{}),define(Q[211],n([9]),{}),define(Q[212],n([9]),{}),define(Q[216],n([9]),{}),define(Q[219],n([0,1,2,28,27,7,16,216]),(function(X,$,Q,J,ee,ne,ie){Object.defineProperty($,"__esModule",{value:!0});var oe={progressBarBackground:J.Color.fromHex("#0E70C0")},re=function(X){function t($,Q){var J=X.call(this)||this;return J.options=Q||Object.create(null),ee.mixin(J.options,oe,!1),J.workedVal=0,J.progressBarBackground=J.options.progressBarBackground,J._register(J.showDelayedScheduler=new ie.RunOnceScheduler((function(){return ne.show(J.element)}),0)),J.create($),J}return te(t,X),t.prototype.create=function(X){this.element=document.createElement("div"),ne.addClass(this.element,"monaco-progress-container"),X.appendChild(this.element),this.bit=document.createElement("div"),ne.addClass(this.bit,"progress-bit"),this.element.appendChild(this.bit),this.applyStyles()},t.prototype.off=function(){this.bit.style.width="inherit",this.bit.style.opacity="1",ne.removeClasses(this.element,"active","infinite","discrete"),this.workedVal=0,this.totalWork=void 0},t.prototype.stop=function(){return this.doDone(!1)},t.prototype.doDone=function(X){var $=this;return ne.addClass(this.element,"done"),ne.hasClass(this.element,"infinite")?(this.bit.style.opacity="0",X?setTimeout((function(){return $.off()}),200):this.off()):(this.bit.style.width="inherit",X?setTimeout((function(){return $.off()}),200):this.off()),this},t.prototype.hide=function(){ne.hide(this.element),this.showDelayedScheduler.cancel()},t.prototype.style=function(X){this.progressBarBackground=X.progressBarBackground,this.applyStyles()},t.prototype.applyStyles=function(){if(this.bit){var X=this.progressBarBackground?this.progressBarBackground.toString():null;this.bit.style.backgroundColor=X}},t}(Q.Disposable);$.ProgressBar=re})),define(Q[220],n([9]),{}),define(Q[102],n([0,1,2,29,17,32,75,40,6,7,72,220]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae){Object.defineProperty($,"__esModule",{value:!0});var le=function(X){function t($,Q,te){void 0===te&&(te={});var ne=X.call(this)||this;return ne._state=3,ne._onDidEnablementChange=ne._register(new re.Emitter),ne.onDidEnablementChange=ne._onDidEnablementChange.event,ne._onDidStart=ne._register(new re.Emitter),ne.onDidStart=ne._onDidStart.event,ne._onDidChange=ne._register(new re.Emitter),ne.onDidChange=ne._onDidChange.event,ne._onDidReset=ne._register(new re.Emitter),ne.onDidReset=ne._onDidReset.event,ne._onDidEnd=ne._register(new re.Emitter),ne.onDidEnd=ne._onDidEnd.event,ne.linkedSash=void 0,ne.orthogonalStartSashDisposables=[],ne.orthogonalEndSashDisposables=[],ne.el=se.append($,se.$(".monaco-sash")),ee.isMacintosh&&se.addClass(ne.el,"mac"),ne._register(ae.domEvent(ne.el,"mousedown")(ne.onMouseDown,ne)),ne._register(ae.domEvent(ne.el,"dblclick")(ne.onMouseDoubleClick,ne)),ie.Gesture.addTarget(ne.el),ne._register(ae.domEvent(ne.el,ie.EventType.Start)(ne.onTouchStart,ne)),J.isIPad&&se.addClass(ne.el,"touch"),ne.setOrientation(te.orientation||0),ne.hidden=!1,ne.layoutProvider=Q,ne.orthogonalStartSash=te.orthogonalStartSash,ne.orthogonalEndSash=te.orthogonalEndSash,se.toggleClass(ne.el,"debug",false),ne}return te(t,X),Object.defineProperty(t.prototype,"state",{get:function(){return this._state},set:function(X){this._state!==X&&(se.toggleClass(this.el,"disabled",0===X),se.toggleClass(this.el,"minimum",1===X),se.toggleClass(this.el,"maximum",2===X),this._state=X,this._onDidEnablementChange.fire(X))},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"orthogonalStartSash",{get:function(){return this._orthogonalStartSash},set:function(X){this.orthogonalStartSashDisposables=Q.dispose(this.orthogonalStartSashDisposables),X?(X.onDidEnablementChange(this.onOrthogonalStartSashEnablementChange,this,this.orthogonalStartSashDisposables),this.onOrthogonalStartSashEnablementChange(X.state)):this.onOrthogonalStartSashEnablementChange(0),this._orthogonalStartSash=X},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"orthogonalEndSash",{get:function(){return this._orthogonalEndSash},set:function(X){this.orthogonalEndSashDisposables=Q.dispose(this.orthogonalEndSashDisposables),X?(X.onDidEnablementChange(this.onOrthogonalEndSashEnablementChange,this,this.orthogonalEndSashDisposables),this.onOrthogonalEndSashEnablementChange(X.state)):this.onOrthogonalEndSashEnablementChange(0),this._orthogonalEndSash=X},enumerable:!0,configurable:!0}),t.prototype.setOrientation=function(X){this.orientation=X,1===this.orientation?(se.addClass(this.el,"horizontal"),se.removeClass(this.el,"vertical")):(se.removeClass(this.el,"horizontal"),se.addClass(this.el,"vertical")),this.layoutProvider&&this.layout()},t.prototype.onMouseDown=function(X){var $=this;se.EventHelper.stop(X,!1);var J=!1;if(this.linkedSash&&!X.__linkedSashEvent&&(X.__linkedSashEvent=!0,this.linkedSash.onMouseDown(X)),!X.__orthogonalSashEvent){var te=void 0;0===this.orientation?X.offsetY<=4?te=this.orthogonalStartSash:X.offsetY>=this.el.clientHeight-4&&(te=this.orthogonalEndSash):X.offsetX<=4?te=this.orthogonalStartSash:X.offsetX>=this.el.clientWidth-4&&(te=this.orthogonalEndSash),te&&(J=!0,X.__orthogonalSashEvent=!0,te.onMouseDown(X))}if(this.state){for(var ne=0,ie=se.getElementsByTagName("iframe");ne<ie.length;ne++)ie[ne].style.pointerEvents="none";var re=new oe.StandardMouseEvent(X),le=re.posx,ue=re.posy,de=re.altKey,ce={startX:le,currentX:le,startY:ue,currentY:ue,altKey:de};se.addClass(this.el,"active"),this._onDidStart.fire(ce);var he=se.createStyleSheet(this.el),v=function(){var X;X=J?"all-scroll":1===$.orientation?1===$.state?"s-resize":2===$.state?"n-resize":ee.isMacintosh?"row-resize":"ns-resize":1===$.state?"e-resize":2===$.state?"w-resize":ee.isMacintosh?"col-resize":"ew-resize",he.innerHTML="* { cursor: "+X+" !important; }"},pe=[];v(),J||this.onDidEnablementChange(v,null,pe),ae.domEvent(window,"mousemove")((function(X){se.EventHelper.stop(X,!1);var Q=new oe.StandardMouseEvent(X),J={startX:le,currentX:Q.posx,startY:ue,currentY:Q.posy,altKey:de};$._onDidChange.fire(J)}),null,pe),ae.domEvent(window,"mouseup")((function(X){se.EventHelper.stop(X,!1),$.el.removeChild(he),se.removeClass($.el,"active"),$._onDidEnd.fire(),Q.dispose(pe);for(var J=0,ee=se.getElementsByTagName("iframe");J<ee.length;J++)ee[J].style.pointerEvents="auto"}),null,pe)}},t.prototype.onMouseDoubleClick=function(X){this._onDidReset.fire()},t.prototype.onTouchStart=function(X){var $=this;se.EventHelper.stop(X);var J=[],ee=X.pageX,te=X.pageY,oe=X.altKey;this._onDidStart.fire({startX:ee,currentX:ee,startY:te,currentY:te,altKey:oe}),J.push(se.addDisposableListener(this.el,ie.EventType.Change,(function(X){ne.isNumber(X.pageX)&&ne.isNumber(X.pageY)&&$._onDidChange.fire({startX:ee,currentX:X.pageX,startY:te,currentY:X.pageY,altKey:oe})}))),J.push(se.addDisposableListener(this.el,ie.EventType.End,(function(X){$._onDidEnd.fire(),Q.dispose(J)})))},t.prototype.layout=function(){var X=J.isIPad?20:4;if(0===this.orientation){var $=this.layoutProvider;this.el.style.left=$.getVerticalSashLeft(this)-X/2+"px",$.getVerticalSashTop&&(this.el.style.top=$.getVerticalSashTop(this)+"px"),$.getVerticalSashHeight&&(this.el.style.height=$.getVerticalSashHeight(this)+"px")}else{var Q=this.layoutProvider;this.el.style.top=Q.getHorizontalSashTop(this)-X/2+"px",Q.getHorizontalSashLeft&&(this.el.style.left=Q.getHorizontalSashLeft(this)+"px"),Q.getHorizontalSashWidth&&(this.el.style.width=Q.getHorizontalSashWidth(this)+"px")}},t.prototype.hide=function(){this.hidden=!0,this.el.style.display="none",this.el.setAttribute("aria-hidden","true")},t.prototype.onOrthogonalStartSashEnablementChange=function(X){se.toggleClass(this.el,"orthogonal-start",0!==X)},t.prototype.onOrthogonalEndSashEnablementChange=function(X){se.toggleClass(this.el,"orthogonal-end",0!==X)},t.prototype.dispose=function(){X.prototype.dispose.call(this),this.orthogonalStartSashDisposables=Q.dispose(this.orthogonalStartSashDisposables),this.orthogonalEndSashDisposables=Q.dispose(this.orthogonalEndSashDisposables),this.el&&this.el.parentElement&&this.el.parentElement.removeChild(this.el),this.el=null},t}(Q.Disposable);$.Sash=le})),define(Q[224],n([9]),{}),define(Q[55],n([0,1,7,23,40,420,422,46,16,6,2,17,169,224]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le,ue){function f(X){var $={lazyRender:void 0!==X.lazyRender&&X.lazyRender,className:void 0!==X.className?X.className:"",useShadows:void 0===X.useShadows||X.useShadows,handleMouseWheel:void 0===X.handleMouseWheel||X.handleMouseWheel,flipAxes:void 0!==X.flipAxes&&X.flipAxes,alwaysConsumeMouseWheel:void 0!==X.alwaysConsumeMouseWheel&&X.alwaysConsumeMouseWheel,scrollYToX:void 0!==X.scrollYToX&&X.scrollYToX,mouseWheelScrollSensitivity:void 0!==X.mouseWheelScrollSensitivity?X.mouseWheelScrollSensitivity:1,mouseWheelSmoothScroll:void 0===X.mouseWheelSmoothScroll||X.mouseWheelSmoothScroll,arrowSize:void 0!==X.arrowSize?X.arrowSize:11,listenOnDomNode:void 0!==X.listenOnDomNode?X.listenOnDomNode:null,horizontal:void 0!==X.horizontal?X.horizontal:1,horizontalScrollbarSize:void 0!==X.horizontalScrollbarSize?X.horizontalScrollbarSize:10,horizontalSliderSize:void 0!==X.horizontalSliderSize?X.horizontalSliderSize:0,horizontalHasArrows:void 0!==X.horizontalHasArrows&&X.horizontalHasArrows,vertical:void 0!==X.vertical?X.vertical:1,verticalScrollbarSize:void 0!==X.verticalScrollbarSize?X.verticalScrollbarSize:10,verticalHasArrows:void 0!==X.verticalHasArrows&&X.verticalHasArrows,verticalSliderSize:void 0!==X.verticalSliderSize?X.verticalSliderSize:0};return $.horizontalSliderSize=void 0!==X.horizontalSliderSize?X.horizontalSliderSize:$.horizontalScrollbarSize,$.verticalSliderSize=void 0!==X.verticalSliderSize?X.verticalSliderSize:$.verticalScrollbarSize,le.isMacintosh&&($.className+=" mac"),$}Object.defineProperty($,"__esModule",{value:!0});var g=function(X,$,Q){this.timestamp=X,this.deltaX=$,this.deltaY=Q,this.score=0},de=function(){function e(){this._capacity=5,this._memory=[],this._front=-1,this._rear=-1}return e.prototype.isPhysicalMouseWheel=function(){if(-1===this._front&&-1===this._rear)return!1;for(var X=1,$=0,Q=1,J=this._rear;;){var ee=J===this._front?X:Math.pow(2,-Q);if(X-=ee,$+=this._memory[J].score*ee,J===this._front)break;J=(this._capacity+J-1)%this._capacity,Q++}return $<=.5},e.prototype.accept=function(X,$,Q){var J=new g(X,$,Q);J.score=this._computeScore(J),-1===this._front&&-1===this._rear?(this._memory[0]=J,this._front=0,this._rear=0):(this._rear=(this._rear+1)%this._capacity,this._rear===this._front&&(this._front=(this._front+1)%this._capacity),this._memory[this._rear]=J)},e.prototype._computeScore=function(X){if(Math.abs(X.deltaX)>0&&Math.abs(X.deltaY)>0)return 1;var $=.5;return-1===this._front&&-1===this._rear||this._memory[this._rear],(Math.abs(X.deltaX-Math.round(X.deltaX))>0||Math.abs(X.deltaY-Math.round(X.deltaY))>0)&&($+=.25),Math.min(Math.max($,0),1)},e.INSTANCE=new e,e}();$.MouseWheelClassifier=de;var ce=function(X){function t($,Q,ee){var te=X.call(this)||this;te._onScroll=te._register(new se.Emitter),te.onScroll=te._onScroll.event,$.style.overflow="hidden",te._options=f(Q),te._scrollable=ee,te._register(te._scrollable.onScroll((function(X){te._onDidScroll(X),te._onScroll.fire(X)})));var oe={onMouseWheel:function(X){return te._onMouseWheel(X)},onDragStart:function(){return te._onDragStart()},onDragEnd:function(){return te._onDragEnd()}};return te._verticalScrollbar=te._register(new ie.VerticalScrollbar(te._scrollable,te._options,oe)),te._horizontalScrollbar=te._register(new ne.HorizontalScrollbar(te._scrollable,te._options,oe)),te._domNode=document.createElement("div"),te._domNode.className="monaco-scrollable-element "+te._options.className,te._domNode.setAttribute("role","presentation"),te._domNode.style.position="relative",te._domNode.style.overflow="hidden",te._domNode.appendChild($),te._domNode.appendChild(te._horizontalScrollbar.domNode.domNode),te._domNode.appendChild(te._verticalScrollbar.domNode.domNode),te._options.useShadows&&(te._leftShadowDomNode=J.createFastDomNode(document.createElement("div")),te._leftShadowDomNode.setClassName("shadow"),te._domNode.appendChild(te._leftShadowDomNode.domNode),te._topShadowDomNode=J.createFastDomNode(document.createElement("div")),te._topShadowDomNode.setClassName("shadow"),te._domNode.appendChild(te._topShadowDomNode.domNode),te._topLeftShadowDomNode=J.createFastDomNode(document.createElement("div")),te._topLeftShadowDomNode.setClassName("shadow top-left-corner"),te._domNode.appendChild(te._topLeftShadowDomNode.domNode)),te._listenOnDomNode=te._options.listenOnDomNode||te._domNode,te._mouseWheelToDispose=[],te._setListeningToMouseWheel(te._options.handleMouseWheel),te.onmouseover(te._listenOnDomNode,(function(X){return te._onMouseOver(X)})),te.onnonbubblingmouseout(te._listenOnDomNode,(function(X){return te._onMouseOut(X)})),te._hideTimeout=te._register(new re.TimeoutTimer),te._isDragging=!1,te._mouseIsOver=!1,te._shouldRender=!0,te._revealOnScroll=!0,te}return te(t,X),t.prototype.dispose=function(){this._mouseWheelToDispose=ae.dispose(this._mouseWheelToDispose),X.prototype.dispose.call(this)},t.prototype.getDomNode=function(){return this._domNode},t.prototype.getOverviewRulerLayoutInfo=function(){return{parent:this._domNode,insertBefore:this._verticalScrollbar.domNode.domNode}},t.prototype.delegateVerticalScrollbarMouseDown=function(X){this._verticalScrollbar.delegateMouseDown(X)},t.prototype.getScrollDimensions=function(){return this._scrollable.getScrollDimensions()},t.prototype.setScrollDimensions=function(X){this._scrollable.setScrollDimensions(X)},t.prototype.updateClassName=function(X){this._options.className=X,le.isMacintosh&&(this._options.className+=" mac"),this._domNode.className="monaco-scrollable-element "+this._options.className},t.prototype.updateOptions=function(X){var $=f(X);this._options.handleMouseWheel=$.handleMouseWheel,this._options.mouseWheelScrollSensitivity=$.mouseWheelScrollSensitivity,this._setListeningToMouseWheel(this._options.handleMouseWheel),this._options.lazyRender||this._render()},t.prototype._setListeningToMouseWheel=function(X){var $=this;if(this._mouseWheelToDispose.length>0!==X&&(this._mouseWheelToDispose=ae.dispose(this._mouseWheelToDispose),X)){var i=function(X){var Q=new ee.StandardMouseWheelEvent(X);$._onMouseWheel(Q)};this._mouseWheelToDispose.push(Q.addDisposableListener(this._listenOnDomNode,"mousewheel",i)),this._mouseWheelToDispose.push(Q.addDisposableListener(this._listenOnDomNode,"DOMMouseScroll",i))}},t.prototype._onMouseWheel=function(X){var $,Q=de.INSTANCE;if(Q.accept(Date.now(),X.deltaX,X.deltaY),X.deltaY||X.deltaX){var J=X.deltaY*this._options.mouseWheelScrollSensitivity,ee=X.deltaX*this._options.mouseWheelScrollSensitivity;this._options.flipAxes&&(J=($=[ee,J])[0],ee=$[1]);var te=!le.isMacintosh&&X.browserEvent&&X.browserEvent.shiftKey;!this._options.scrollYToX&&!te||ee||(ee=J,J=0);var ne=this._scrollable.getFutureScrollPosition(),ie={};if(J){var oe=ne.scrollTop-50*J;this._verticalScrollbar.writeScrollPosition(ie,oe)}if(ee){var re=ne.scrollLeft-50*ee;this._horizontalScrollbar.writeScrollPosition(ie,re)}ie=this._scrollable.validateScrollPosition(ie),(ne.scrollLeft!==ie.scrollLeft||ne.scrollTop!==ie.scrollTop)&&(this._options.mouseWheelSmoothScroll&&Q.isPhysicalMouseWheel()?this._scrollable.setScrollPositionSmooth(ie):this._scrollable.setScrollPositionNow(ie),this._shouldRender=!0)}(this._options.alwaysConsumeMouseWheel||this._shouldRender)&&(X.preventDefault(),X.stopPropagation())},t.prototype._onDidScroll=function(X){this._shouldRender=this._horizontalScrollbar.onDidScroll(X)||this._shouldRender,this._shouldRender=this._verticalScrollbar.onDidScroll(X)||this._shouldRender,this._options.useShadows&&(this._shouldRender=!0),this._revealOnScroll&&this._reveal(),this._options.lazyRender||this._render()},t.prototype.renderNow=function(){if(!this._options.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this._render()},t.prototype._render=function(){if(this._shouldRender&&(this._shouldRender=!1,this._horizontalScrollbar.render(),this._verticalScrollbar.render(),this._options.useShadows)){var X=this._scrollable.getCurrentScrollPosition(),$=X.scrollTop>0,Q=X.scrollLeft>0;this._leftShadowDomNode.setClassName("shadow"+(Q?" left":"")),this._topShadowDomNode.setClassName("shadow"+($?" top":"")),this._topLeftShadowDomNode.setClassName("shadow top-left-corner"+($?" top":"")+(Q?" left":""))}},t.prototype._onDragStart=function(){this._isDragging=!0,this._reveal()},t.prototype._onDragEnd=function(){this._isDragging=!1,this._hide()},t.prototype._onMouseOut=function(X){this._mouseIsOver=!1,this._hide()},t.prototype._onMouseOver=function(X){this._mouseIsOver=!0,this._reveal()},t.prototype._reveal=function(){this._verticalScrollbar.beginReveal(),this._horizontalScrollbar.beginReveal(),this._scheduleHide()},t.prototype._hide=function(){this._mouseIsOver||this._isDragging||(this._verticalScrollbar.beginHide(),this._horizontalScrollbar.beginHide())},t.prototype._scheduleHide=function(){var X=this;this._mouseIsOver||this._isDragging||this._hideTimeout.cancelAndSet((function(){return X._hide()}),500)},t}(oe.Widget);$.AbstractScrollableElement=ce;var he=function(X){function t($,J){var ee=this;(J=J||{}).mouseWheelSmoothScroll=!1;var te=new ue.Scrollable(0,(function(X){return Q.scheduleAtNextAnimationFrame(X)}));return(ee=X.call(this,$,J,te)||this)._register(te),ee}return te(t,X),t.prototype.setScrollPosition=function(X){this._scrollable.setScrollPositionNow(X)},t.prototype.getScrollPosition=function(){return this._scrollable.getCurrentScrollPosition()},t}(ce);$.ScrollableElement=he;var pe=function(X){function t($,Q,J){return X.call(this,$,Q,J)||this}return te(t,X),t}(ce);$.SmoothScrollableElement=pe;var fe=function(X){function t($,Q){var J=X.call(this,$,Q)||this;return J._element=$,J.onScroll((function(X){X.scrollTopChanged&&(J._element.scrollTop=X.scrollTop),X.scrollLeftChanged&&(J._element.scrollLeft=X.scrollLeft)})),J.scanDomNode(),J}return te(t,X),t.prototype.scanDomNode=function(){this.setScrollDimensions({width:this._element.clientWidth,scrollWidth:this._element.scrollWidth,height:this._element.clientHeight,scrollHeight:this._element.scrollHeight}),this.setScrollPosition({scrollLeft:this._element.scrollLeft,scrollTop:this._element.scrollTop})},t}(he);$.DomScrollableElement=fe})),define(Q[231],n([0,1,27,2,75,7,6,72,55,466,369,17,29,128,40,115]),(function(X,$,Q,J,ee,te,ie,oe,re,se,ae,le,ue,de,ce,he){Object.defineProperty($,"__esModule",{value:!0});var pe={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0},fe=function(){function e(X,$,J,te){void 0===te&&(te=pe),this.virtualDelegate=$,this.renderers=new Map,this.didRequestScrollableElementUpdate=!1,this.splicing=!1,this.items=[],this.itemId=0,this.rangeMap=new se.RangeMap;for(var ne=0,le=J;ne<le.length;ne++){var ue=le[ne];this.renderers.set(ue.templateId,ue)}this.cache=new ae.RowCache(this.renderers),this.lastRenderTop=0,this.lastRenderHeight=0,this._domNode=document.createElement("div"),this._domNode.className="monaco-list",this.rowsContainer=document.createElement("div"),this.rowsContainer.className="monaco-list-rows",ee.Gesture.addTarget(this.rowsContainer),this.scrollableElement=new re.ScrollableElement(this.rowsContainer,{alwaysConsumeMouseWheel:!0,horizontal:2,vertical:Q.getOrDefault(te,(function(X){return X.verticalScrollMode}),pe.verticalScrollMode),useShadows:Q.getOrDefault(te,(function(X){return X.useShadows}),pe.useShadows)}),this._domNode.appendChild(this.scrollableElement.getDomNode()),X.appendChild(this._domNode),this.disposables=[this.rangeMap,this.gesture,this.scrollableElement,this.cache],this.scrollableElement.onScroll(this.onScroll,this,this.disposables),oe.domEvent(this.rowsContainer,ee.EventType.Change)(this.onTouchChange,this,this.disposables),oe.domEvent(this.scrollableElement.getDomNode(),"scroll")((function(X){return X.target.scrollTop=0}),null,this.disposables),ie.mapEvent(oe.domEvent(this.rowsContainer,"dragover"),(function(X){return new ce.DragMouseEvent(X)}))(this.onDragOver,this,this.disposables),this.setRowLineHeight=Q.getOrDefault(te,(function(X){return X.setRowLineHeight}),pe.setRowLineHeight),this.layout()}return Object.defineProperty(e.prototype,"domNode",{get:function(){return this._domNode},enumerable:!0,configurable:!0}),e.prototype.splice=function(X,$,Q){if(void 0===Q&&(Q=[]),this.splicing)throw new Error("Can't run recursive splices.");this.splicing=!0;try{return this._splice(X,$,Q)}finally{this.splicing=!1}},e.prototype._splice=function(X,$,Q){var J=this;void 0===Q&&(Q=[]);for(var ee,ne=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),ie={start:X,end:X+$},oe=he.Range.intersect(ne,ie),re=oe.start;re<oe.end;re++)this.removeItemFromDOM(re);var ae,le={start:X+$,end:this.items.length},ue=he.Range.intersect(le,ne),de=he.Range.relativeComplement(le,ne),ce=Q.map((function(X){return{id:String(J.itemId++),element:X,size:J.virtualDelegate.getHeight(X),templateId:J.virtualDelegate.getTemplateId(X),row:null}}));0===X&&$>=this.items.length?(this.rangeMap=new se.RangeMap,this.rangeMap.splice(0,0,ce),this.items=ce,ae=[]):(this.rangeMap.splice(X,$,ce),ae=(ee=this.items).splice.apply(ee,[X,$].concat(ce)));var pe=Q.length-$,fe=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),ge=se.shift(ue,pe),me=he.Range.intersect(fe,ge);for(re=me.start;re<me.end;re++)this.updateItemInDOM(this.items[re],re);for(var ve=he.Range.relativeComplement(ge,fe),_e=0;_e<ve.length;_e++){var ye=ve[_e];for(re=ye.start;re<ye.end;re++)this.removeItemFromDOM(re)}var be=de.map((function(X){return se.shift(X,pe)})),Ce=[{start:X,end:X+Q.length}].concat(be).map((function(X){return he.Range.intersect(fe,X)})),we=this.getNextToLastElement(Ce);for(_e=0;_e<Ce.length;_e++){var Se=Ce[_e];for(re=Se.start;re<Se.end;re++)this.insertItemInDOM(re,we)}return this.scrollHeight=this.getContentHeight(),this.rowsContainer.style.height=this.scrollHeight+"px",this.didRequestScrollableElementUpdate||(te.scheduleAtNextAnimationFrame((function(){J.scrollableElement.setScrollDimensions({scrollHeight:J.scrollHeight}),J.didRequestScrollableElementUpdate=!1})),this.didRequestScrollableElementUpdate=!0),ae.map((function(X){return X.element}))},Object.defineProperty(e.prototype,"length",{get:function(){return this.items.length},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"renderHeight",{get:function(){return this.scrollableElement.getScrollDimensions().height},enumerable:!0,configurable:!0}),e.prototype.element=function(X){return this.items[X].element},e.prototype.domElement=function(X){var $=this.items[X].row;return $&&$.domNode},e.prototype.elementHeight=function(X){return this.items[X].size},e.prototype.elementTop=function(X){return this.rangeMap.positionAt(X)},e.prototype.indexAt=function(X){return this.rangeMap.indexAt(X)},e.prototype.indexAfter=function(X){return this.rangeMap.indexAfter(X)},e.prototype.layout=function(X){this.scrollableElement.setScrollDimensions({height:X||te.getContentHeight(this._domNode)})},e.prototype.render=function(X,$){for(var Q=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),J=this.getRenderRange(X,$),ee=he.Range.relativeComplement(J,Q),te=he.Range.relativeComplement(Q,J),ne=this.getNextToLastElement(ee),ie=0,oe=ee;ie<oe.length;ie++)for(de=(ae=oe[ie]).start;de<ae.end;de++)this.insertItemInDOM(de,ne);for(var re=0,se=te;re<se.length;re++)for(var ae=se[re],de=ae.start;de<ae.end;de++)this.removeItemFromDOM(de);if(ue.isFirefox||0!==ue.getZoomLevel()||le.isWindows)this.rowsContainer.style.top="-"+X+"px";else{var ce="translate3d(0px, -"+X+"px, 0px)";this.rowsContainer.style.transform=ce,this.rowsContainer.style.webkitTransform=ce}this.lastRenderTop=X,this.lastRenderHeight=$},e.prototype.insertItemInDOM=function(X,$){var Q=this.items[X];Q.row||(Q.row=this.cache.alloc(Q.templateId)),Q.row.domNode.parentElement||($?this.rowsContainer.insertBefore(Q.row.domNode,$):this.rowsContainer.appendChild(Q.row.domNode)),Q.row.domNode.style.height=Q.size+"px",this.setRowLineHeight&&(Q.row.domNode.style.lineHeight=Q.size+"px"),this.updateItemInDOM(Q,X),this.renderers.get(Q.templateId).renderElement(Q.element,X,Q.row.templateData)},e.prototype.updateItemInDOM=function(X,$){X.row.domNode.style.top=this.elementTop($)+"px",X.row.domNode.setAttribute("data-index",""+$),X.row.domNode.setAttribute("data-last-element",$===this.length-1?"true":"false"),X.row.domNode.setAttribute("aria-setsize",""+this.length),X.row.domNode.setAttribute("aria-posinset",""+($+1))},e.prototype.removeItemFromDOM=function(X){var $=this.items[X],Q=this.renderers.get($.templateId);Q.disposeElement&&Q.disposeElement($.element,X,$.row.templateData),this.cache.release($.row),$.row=null},e.prototype.getContentHeight=function(){return this.rangeMap.size},e.prototype.getScrollTop=function(){return this.scrollableElement.getScrollPosition().scrollTop},e.prototype.setScrollTop=function(X){this.scrollableElement.setScrollPosition({scrollTop:X})},Object.defineProperty(e.prototype,"scrollTop",{get:function(){return this.getScrollTop()},set:function(X){this.setScrollTop(X)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onMouseClick",{get:function(){var X=this;return ie.filterEvent(ie.mapEvent(oe.domEvent(this.domNode,"click"),(function($){return X.toMouseEvent($)})),(function(X){return X.index>=0}))},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onMouseDblClick",{get:function(){var X=this;return ie.filterEvent(ie.mapEvent(oe.domEvent(this.domNode,"dblclick"),(function($){return X.toMouseEvent($)})),(function(X){return X.index>=0}))},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onMouseDown",{get:function(){var X=this;return ie.filterEvent(ie.mapEvent(oe.domEvent(this.domNode,"mousedown"),(function($){return X.toMouseEvent($)})),(function(X){return X.index>=0}))},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onContextMenu",{get:function(){var X=this;return ie.filterEvent(ie.mapEvent(oe.domEvent(this.domNode,"contextmenu"),(function($){return X.toMouseEvent($)})),(function(X){return X.index>=0}))},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onTouchStart",{get:function(){var X=this;return ie.filterEvent(ie.mapEvent(oe.domEvent(this.domNode,"touchstart"),(function($){return X.toTouchEvent($)})),(function(X){return X.index>=0}))},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onTap",{get:function(){var X=this;return ie.filterEvent(ie.mapEvent(oe.domEvent(this.rowsContainer,ee.EventType.Tap),(function($){return X.toGestureEvent($)})),(function(X){return X.index>=0}))},enumerable:!0,configurable:!0}),e.prototype.toMouseEvent=function(X){var $=this.getItemIndexFromEventTarget(X.target),Q=$<0?void 0:this.items[$];return{browserEvent:X,index:$,element:Q&&Q.element}},e.prototype.toTouchEvent=function(X){var $=this.getItemIndexFromEventTarget(X.target),Q=$<0?void 0:this.items[$];return{browserEvent:X,index:$,element:Q&&Q.element}},e.prototype.toGestureEvent=function(X){var $=this.getItemIndexFromEventTarget(X.initialTarget),Q=$<0?void 0:this.items[$];return{browserEvent:X,index:$,element:Q&&Q.element}},e.prototype.onScroll=function(X){try{this.render(X.scrollTop,X.height)}catch($){throw console.log("Got bad scroll event:",X),$}},e.prototype.onTouchChange=function(X){X.preventDefault(),X.stopPropagation(),this.scrollTop-=X.translationY},e.prototype.onDragOver=function(X){this.setupDragAndDropScrollInterval(),this.dragAndDropMouseY=X.posy},e.prototype.setupDragAndDropScrollInterval=function(){var X=this,$=te.getTopLeftOffset(this._domNode).top;this.dragAndDropScrollInterval||(this.dragAndDropScrollInterval=window.setInterval((function(){if(void 0!==X.dragAndDropMouseY){var Q=X.dragAndDropMouseY-$,J=0,ee=X.renderHeight-35;Q<35?J=Math.max(-14,.2*(Q-35)):Q>ee&&(J=Math.min(14,.2*(Q-ee))),X.scrollTop+=J}}),10),this.cancelDragAndDropScrollTimeout(),this.dragAndDropScrollTimeout=window.setTimeout((function(){X.cancelDragAndDropScrollInterval(),X.dragAndDropScrollTimeout=null}),1e3))},e.prototype.cancelDragAndDropScrollInterval=function(){this.dragAndDropScrollInterval&&(window.clearInterval(this.dragAndDropScrollInterval),this.dragAndDropScrollInterval=null),this.cancelDragAndDropScrollTimeout()},e.prototype.cancelDragAndDropScrollTimeout=function(){this.dragAndDropScrollTimeout&&(window.clearTimeout(this.dragAndDropScrollTimeout),this.dragAndDropScrollTimeout=null)},e.prototype.getItemIndexFromEventTarget=function(X){for(;X instanceof HTMLElement&&X!==this.rowsContainer;){var $=X,Q=$.getAttribute("data-index");if(Q){var J=Number(Q);if(!isNaN(J))return J}X=$.parentElement}return-1},e.prototype.getRenderRange=function(X,$){return{start:this.rangeMap.indexAt(X),end:this.rangeMap.indexAfter(X+$-1)}},e.prototype.getNextToLastElement=function(X){var $=X[X.length-1];if(!$)return null;var Q=this.items[$.end];return Q&&Q.row?Q.row.domNode:null},e.prototype.dispose=function(){if(this.items){for(var X=0,$=this.items;X<$.length;X++){var Q=$[X];Q.row&&(this.renderers.get(Q.row.templateId).disposeTemplate(Q.row.templateData),Q.row=null)}this.items=null}this._domNode&&this._domNode.parentElement&&(this._domNode.parentNode.removeChild(this._domNode),this._domNode=null),this.disposables=J.dispose(this.disposables)},ne([de.memoize],e.prototype,"onMouseClick",null),ne([de.memoize],e.prototype,"onMouseDblClick",null),ne([de.memoize],e.prototype,"onMouseDown",null),ne([de.memoize],e.prototype,"onContextMenu",null),ne([de.memoize],e.prototype,"onTouchStart",null),ne([de.memoize],e.prototype,"onTap",null),e}();$.ListView=fe})),define(Q[235],n([0,1,17,29,2,7,130,75,8,40,52,443,87,55,445,440,6,423,88,16]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le,ue,de,ce,he,pe,fe,ge,me){Object.defineProperty($,"__esModule",{value:!0});var ve=function(){function e(X){this.context=X,this._cache={"":[]}}return e.prototype.alloc=function(X){var $=this.cache(X).pop();if(!$){var Q=document.createElement("div");Q.className="content";var J=document.createElement("div");J.appendChild(Q);var ee=null;try{ee=this.context.renderer.renderTemplate(this.context.tree,X,Q)}catch(X){console.error("Tree usage error: exception while rendering template"),console.error(X)}$={element:J,templateId:X,templateData:ee}}return $},e.prototype.release=function(X,$){!function(X){try{X.parentElement.removeChild(X)}catch(X){}}($.element),this.cache(X).push($)},e.prototype.cache=function(X){return this._cache[X]||(this._cache[X]=[])},e.prototype.garbageCollect=function(){var X=this;this._cache&&Object.keys(this._cache).forEach((function($){X._cache[$].forEach((function(Q){X.context.renderer.disposeTemplate(X.context.tree,$,Q.templateData),Q.element=null,Q.templateData=null})),delete X._cache[$]}))},e.prototype.dispose=function(){this.garbageCollect(),this._cache=null,this.context=null},e}();$.RowCache=ve;var _e=function(){function e(X,$){var Q=this;this.width=0,this.context=X,this.model=$,this.id=this.model.id,this.row=null,this.top=0,this.height=$.getHeight(),this._styles={},$.getAllTraits().forEach((function(X){return Q._styles[X]=!0})),$.isExpanded()&&this.addClass("expanded")}return Object.defineProperty(e.prototype,"expanded",{set:function(X){X?this.addClass("expanded"):this.removeClass("expanded")},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"loading",{set:function(X){X?this.addClass("loading"):this.removeClass("loading")},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"draggable",{get:function(){return this._draggable},set:function(X){this._draggable=X,this.render(!0)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"dropTarget",{set:function(X){X?this.addClass("drop-target"):this.removeClass("drop-target")},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"element",{get:function(){return this.row&&this.row.element},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"templateId",{get:function(){return this._templateId||(this._templateId=this.context.renderer.getTemplateId&&this.context.renderer.getTemplateId(this.context.tree,this.model.getElement()))},enumerable:!0,configurable:!0}),e.prototype.addClass=function(X){this._styles[X]=!0,this.render(!0)},e.prototype.removeClass=function(X){delete this._styles[X],this.render(!0)},e.prototype.render=function(X){var $=this;if(void 0===X&&(X=!1),this.model&&this.element){var Q=["monaco-tree-row"];Q.push.apply(Q,Object.keys(this._styles)),this.model.hasChildren()&&Q.push("has-children"),this.element.className=Q.join(" "),this.element.draggable=this.draggable,this.element.style.height=this.height+"px",this.element.setAttribute("role","treeitem");var J=this.context.accessibilityProvider,ee=J.getAriaLabel(this.context.tree,this.model.getElement());if(ee&&this.element.setAttribute("aria-label",ee),J.getPosInSet&&J.getSetSize&&(this.element.setAttribute("aria-setsize",J.getSetSize()),this.element.setAttribute("aria-posinset",J.getPosInSet(this.context.tree,this.model.getElement()))),this.model.hasTrait("focused")){var te=re.safeBtoa(this.model.id);this.element.setAttribute("aria-selected","true"),this.element.setAttribute("id",te)}else this.element.setAttribute("aria-selected","false"),this.element.removeAttribute("id");this.model.hasChildren()?this.element.setAttribute("aria-expanded",String(!!this._styles.expanded)):this.element.removeAttribute("aria-expanded"),this.element.setAttribute("aria-level",String(this.model.getDepth())),this.context.options.paddingOnRow?this.element.style.paddingLeft=this.context.options.twistiePixels+(this.model.getDepth()-1)*this.context.options.indentPixels+"px":(this.element.style.paddingLeft=(this.model.getDepth()-1)*this.context.options.indentPixels+"px",this.row.element.firstElementChild.style.paddingLeft=this.context.options.twistiePixels+"px");var ie=this.context.dnd.getDragURI(this.context.tree,this.model.getElement());if(ie!==this.uri&&(this.unbindDragStart&&(this.unbindDragStart.dispose(),this.unbindDragStart=null),ie?(this.uri=ie,this.draggable=!0,this.unbindDragStart=ne.addDisposableListener(this.element,"dragstart",(function(X){$.onDragStart(X)}))):this.uri=null),!X&&this.element){var oe=window.getComputedStyle(this.element),se=parseFloat(oe.paddingLeft);this.context.horizontalScrolling&&(this.element.style.width="fit-content");try{this.context.renderer.renderElement(this.context.tree,this.model.getElement(),this.templateId,this.row.templateData)}catch(X){console.error("Tree usage error: exception while rendering element"),console.error(X)}this.context.horizontalScrolling&&(this.width=ne.getContentWidth(this.element)+se,this.element.style.width="")}}},e.prototype.insertInDOM=function(X,$){if(this.row||(this.row=this.context.cache.alloc(this.templateId),this.element[be.BINDING]=this),!this.element.parentElement){if(null===$)X.appendChild(this.element);else try{X.insertBefore(this.element,$)}catch($){console.warn("Failed to locate previous tree element"),X.appendChild(this.element)}this.render()}},e.prototype.removeFromDOM=function(){this.row&&(this.unbindDragStart&&(this.unbindDragStart.dispose(),this.unbindDragStart=null),this.uri=null,this.element[be.BINDING]=null,this.context.cache.release(this.templateId,this.row),this.row=null)},e.prototype.dispose=function(){this.row=null,this.model=null},e}();$.ViewItem=_e;var ye=function(X){function t($,Q,J){var ee=X.call(this,$,Q)||this;return ee.row={element:J,templateData:null,templateId:null},ee}return te(t,X),t.prototype.render=function(){if(this.model&&this.element){var X=["monaco-tree-wrapper"];X.push.apply(X,Object.keys(this._styles)),this.model.hasChildren()&&X.push("has-children"),this.element.className=X.join(" ")}},t.prototype.insertInDOM=function(X,$){},t.prototype.removeFromDOM=function(){},t}(_e),be=function(X){function t($,Q){var te=X.call(this)||this;te.lastClickTimeStamp=0,te.contentWidthUpdateDelayer=new me.Delayer(50),te.isRefreshing=!1,te.refreshingPreviousChildrenIds={},te.currentDropDisposable=ee.Disposable.None,te._onDOMFocus=new pe.Emitter,te._onDOMBlur=new pe.Emitter,te._onDidScroll=new pe.Emitter,t.counter++,te.instance=t.counter;var ie=void 0===$.options.horizontalScrollMode?2:$.options.horizontalScrollMode;te.horizontalScrolling=2!==ie,te.context={dataSource:$.dataSource,renderer:$.renderer,controller:$.controller,dnd:$.dnd,filter:$.filter,sorter:$.sorter,tree:$.tree,accessibilityProvider:$.accessibilityProvider,options:$.options,cache:new ve($),horizontalScrolling:te.horizontalScrolling},te.modelListeners=[],te.viewListeners=[],te.model=null,te.items={},te.domNode=document.createElement("div"),te.domNode.className="monaco-tree no-focused-item monaco-tree-instance-"+te.instance,te.domNode.tabIndex=$.options.preventRootFocus?-1:0,te.styleElement=ne.createStyleSheet(te.domNode),te.treeStyler=$.styler,te.treeStyler||(te.treeStyler=new ge.DefaultTreestyler(te.styleElement,"monaco-tree-instance-"+te.instance)),te.domNode.setAttribute("role","tree"),te.context.options.ariaLabel&&te.domNode.setAttribute("aria-label",te.context.options.ariaLabel),te.context.options.alwaysFocused&&ne.addClass(te.domNode,"focused"),te.context.options.paddingOnRow||ne.addClass(te.domNode,"no-row-padding"),te.wrapper=document.createElement("div"),te.wrapper.className="monaco-tree-wrapper",te.scrollableElement=new de.ScrollableElement(te.wrapper,{alwaysConsumeMouseWheel:!0,horizontal:ie,vertical:void 0!==$.options.verticalScrollMode?$.options.verticalScrollMode:1,useShadows:$.options.useShadows}),te.scrollableElement.onScroll((function(X){te.render(X.scrollTop,X.height,X.scrollLeft,X.width,X.scrollWidth),te._onDidScroll.fire()})),J.isIE?(te.wrapper.style.msTouchAction="none",te.wrapper.style.msContentZooming="none"):oe.Gesture.addTarget(te.wrapper),te.rowsContainer=document.createElement("div"),te.rowsContainer.className="monaco-tree-rows",$.options.showTwistie&&(te.rowsContainer.className+=" show-twisties");var re=ne.trackFocus(te.domNode);return te.viewListeners.push(re.onDidFocus((function(){return te.onFocus()}))),te.viewListeners.push(re.onDidBlur((function(){return te.onBlur()}))),te.viewListeners.push(re),te.viewListeners.push(ne.addDisposableListener(te.domNode,"keydown",(function(X){return te.onKeyDown(X)}))),te.viewListeners.push(ne.addDisposableListener(te.domNode,"keyup",(function(X){return te.onKeyUp(X)}))),te.viewListeners.push(ne.addDisposableListener(te.domNode,"mousedown",(function(X){return te.onMouseDown(X)}))),te.viewListeners.push(ne.addDisposableListener(te.domNode,"mouseup",(function(X){return te.onMouseUp(X)}))),te.viewListeners.push(ne.addDisposableListener(te.wrapper,"auxclick",(function(X){X&&1===X.button&&te.onMouseMiddleClick(X)}))),te.viewListeners.push(ne.addDisposableListener(te.wrapper,"click",(function(X){return te.onClick(X)}))),te.viewListeners.push(ne.addDisposableListener(te.domNode,"contextmenu",(function(X){return te.onContextMenu(X)}))),te.viewListeners.push(ne.addDisposableListener(te.wrapper,oe.EventType.Tap,(function(X){return te.onTap(X)}))),te.viewListeners.push(ne.addDisposableListener(te.wrapper,oe.EventType.Change,(function(X){return te.onTouchChange(X)}))),J.isIE&&(te.viewListeners.push(ne.addDisposableListener(te.wrapper,"MSPointerDown",(function(X){return te.onMsPointerDown(X)}))),te.viewListeners.push(ne.addDisposableListener(te.wrapper,"MSGestureTap",(function(X){return te.onMsGestureTap(X)}))),te.viewListeners.push(ne.addDisposableThrottledListener(te.wrapper,"MSGestureChange",(function(X){return te.onThrottledMsGestureChange(X)}),(function(X,$){$.stopPropagation(),$.preventDefault();var Q={translationY:$.translationY,translationX:$.translationX};return X&&(Q.translationY+=X.translationY,Q.translationX+=X.translationX),Q})))),te.viewListeners.push(ne.addDisposableListener(window,"dragover",(function(X){return te.onDragOver(X)}))),te.viewListeners.push(ne.addDisposableListener(te.wrapper,"drop",(function(X){return te.onDrop(X)}))),te.viewListeners.push(ne.addDisposableListener(window,"dragend",(function(X){return te.onDragEnd(X)}))),te.viewListeners.push(ne.addDisposableListener(window,"dragleave",(function(X){return te.onDragOver(X)}))),te.wrapper.appendChild(te.rowsContainer),te.domNode.appendChild(te.scrollableElement.getDomNode()),Q.appendChild(te.domNode),te.lastRenderTop=0,te.lastRenderHeight=0,te.didJustPressContextMenuKey=!1,te.currentDropTarget=null,te.currentDropTargets=[],te.shouldInvalidateDropReaction=!1,te.dragAndDropScrollInterval=null,te.dragAndDropScrollTimeout=null,te.onHiddenScrollTop=null,te.onRowsChanged(),te.layout(),te.setupMSGesture(),te.applyStyles($.options),te}return te(t,X),Object.defineProperty(t.prototype,"onDOMFocus",{get:function(){return this._onDOMFocus.event},enumerable:!0,configurable:!0}),t.prototype.applyStyles=function(X){this.treeStyler.style(X)},t.prototype.createViewItem=function(X){return new _e(this.context,X)},t.prototype.getHTMLElement=function(){return this.domNode},t.prototype.focus=function(){this.domNode.focus()},t.prototype.isFocused=function(){return document.activeElement===this.domNode},t.prototype.blur=function(){this.domNode.blur()},t.prototype.setupMSGesture=function(){var X=this;window.MSGesture&&(this.msGesture=new MSGesture,setTimeout((function(){return X.msGesture.target=X.wrapper}),100))},t.prototype.isTreeVisible=function(){return null===this.onHiddenScrollTop},t.prototype.layout=function(X,$){this.isTreeVisible()&&(this.viewHeight=X||ne.getContentHeight(this.wrapper),this.scrollHeight=this.getContentHeight(),this.horizontalScrolling&&(this.viewWidth=$||ne.getContentWidth(this.wrapper)))},t.prototype.render=function(X,$,Q,J,ee){var te,ne,ie=X,oe=X+$,re=this.lastRenderTop+this.lastRenderHeight;for(te=this.indexAfter(oe)-1,ne=this.indexAt(Math.max(re,ie));te>=ne;te--)this.insertItemInDOM(this.itemAtIndex(te));for(te=Math.min(this.indexAt(this.lastRenderTop),this.indexAfter(oe))-1,ne=this.indexAt(ie);te>=ne;te--)this.insertItemInDOM(this.itemAtIndex(te));for(te=this.indexAt(this.lastRenderTop),ne=Math.min(this.indexAt(ie),this.indexAfter(re));te<ne;te++)this.removeItemFromDOM(this.itemAtIndex(te));for(te=Math.max(this.indexAfter(oe),this.indexAt(this.lastRenderTop)),ne=this.indexAfter(re);te<ne;te++)this.removeItemFromDOM(this.itemAtIndex(te));var se=this.itemAtIndex(this.indexAt(ie));se&&(this.rowsContainer.style.top=se.top-ie+"px"),this.horizontalScrolling&&(this.rowsContainer.style.left=-Q+"px",this.rowsContainer.style.width=Math.max(ee,J)+"px"),this.lastRenderTop=ie,this.lastRenderHeight=oe-ie},t.prototype.setModel=function(X){this.releaseModel(),this.model=X,this.model.onRefresh(this.onRefreshing,this,this.modelListeners),this.model.onDidRefresh(this.onRefreshed,this,this.modelListeners),this.model.onSetInput(this.onClearingInput,this,this.modelListeners),this.model.onDidSetInput(this.onSetInput,this,this.modelListeners),this.model.onDidFocus(this.onModelFocusChange,this,this.modelListeners),this.model.onRefreshItemChildren(this.onItemChildrenRefreshing,this,this.modelListeners),this.model.onDidRefreshItemChildren(this.onItemChildrenRefreshed,this,this.modelListeners),this.model.onDidRefreshItem(this.onItemRefresh,this,this.modelListeners),this.model.onExpandItem(this.onItemExpanding,this,this.modelListeners),this.model.onDidExpandItem(this.onItemExpanded,this,this.modelListeners),this.model.onCollapseItem(this.onItemCollapsing,this,this.modelListeners),this.model.onDidRevealItem(this.onItemReveal,this,this.modelListeners),this.model.onDidAddTraitItem(this.onItemAddTrait,this,this.modelListeners),this.model.onDidRemoveTraitItem(this.onItemRemoveTrait,this,this.modelListeners)},t.prototype.onRefreshing=function(){this.isRefreshing=!0},t.prototype.onRefreshed=function(){this.isRefreshing=!1,this.onRowsChanged()},t.prototype.onRowsChanged=function(X){void 0===X&&(X=this.scrollTop),this.isRefreshing||(this.scrollTop=X,this.updateScrollWidth())},t.prototype.updateScrollWidth=function(){var X=this;this.horizontalScrolling&&this.contentWidthUpdateDelayer.trigger((function(){for(var $=0,Q=0,J=Object.keys(X.items);Q<J.length;Q++){var ee=J[Q];$=Math.max($,X.items[ee].width)}X.scrollWidth=$+10}))},t.prototype.focusNextPage=function(X){var $=this,Q=this.indexAt(this.scrollTop+this.viewHeight);Q=0===Q?0:Q-1;var J=this.itemAtIndex(Q).model.getElement();if(this.model.getFocus()!==J)this.model.setFocus(J,X);else{var ee=this.scrollTop;this.scrollTop+=this.viewHeight,this.scrollTop!==ee&&setTimeout((function(){$.focusNextPage(X)}),0)}},t.prototype.focusPreviousPage=function(X){var $,Q=this;$=0===this.scrollTop?this.indexAt(this.scrollTop):this.indexAfter(this.scrollTop-1);var J=this.itemAtIndex($).model.getElement();if(this.model.getFocus()!==J)this.model.setFocus(J,X);else{var ee=this.scrollTop;this.scrollTop-=this.viewHeight,this.scrollTop!==ee&&setTimeout((function(){Q.focusPreviousPage(X)}),0)}},Object.defineProperty(t.prototype,"viewHeight",{get:function(){return this.scrollableElement.getScrollDimensions().height},set:function(X){this.scrollableElement.setScrollDimensions({height:X})},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"scrollHeight",{set:function(X){this.scrollableElement.setScrollDimensions({scrollHeight:X})},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"viewWidth",{get:function(){return this.scrollableElement.getScrollDimensions().width},set:function(X){this.scrollableElement.setScrollDimensions({width:X})},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"scrollWidth",{set:function(X){this.scrollableElement.setScrollDimensions({scrollWidth:X})},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"scrollTop",{get:function(){return this.scrollableElement.getScrollPosition().scrollTop},set:function(X){this.scrollableElement.setScrollDimensions({scrollHeight:this.getContentHeight()}),this.scrollableElement.setScrollPosition({scrollTop:X})},enumerable:!0,configurable:!0}),t.prototype.onClearingInput=function(X){var $=X.item;$&&(this.onRemoveItems(new ue.MappedIterator($.getNavigator(),(function(X){return X&&X.id}))),this.onRowsChanged())},t.prototype.onSetInput=function(X){this.context.cache.garbageCollect(),this.inputItem=new ye(this.context,X.item,this.wrapper)},t.prototype.onItemChildrenRefreshing=function(X){var $=X.item,Q=this.items[$.id];if(Q&&this.context.options.showLoading&&(Q.loadingTimer=setTimeout((function(){Q.loadingTimer=0,Q.loading=!0}),t.LOADING_DECORATION_DELAY)),!X.isNested){for(var J,ee=[],te=$.getNavigator();J=te.next();)ee.push(J.id);this.refreshingPreviousChildrenIds[$.id]=ee}},t.prototype.onItemChildrenRefreshed=function(X){var $=this,Q=X.item,J=this.items[Q.id];if(J&&(J.loadingTimer&&(clearTimeout(J.loadingTimer),J.loadingTimer=0),J.loading=!1),!X.isNested){for(var ee,te=this.refreshingPreviousChildrenIds[Q.id],ne=[],oe=Q.getNavigator();ee=oe.next();)ne.push(ee);var re=Math.abs(te.length-ne.length)>1e3,se=void 0,ae=void 0;if(re||(ae=(se=new ie.LcsDiff({getLength:function(){return te.length},getElementAtIndex:function(X){return te[X]}},{getLength:function(){return ne.length},getElementAtIndex:function(X){return ne[X].id}},null).ComputeDiff(!1)).some((function(X){if(X.modifiedLength>0)for(var Q=X.modifiedStart,J=X.modifiedStart+X.modifiedLength;Q<J;Q++)if($.items.hasOwnProperty(ne[Q].id))return!0;return!1}))),!re&&!ae&&se.length<50)for(var le=0,de=se.length;le<de;le++){var ce=se[le];if(ce.originalLength>0&&this.onRemoveItems(new ue.ArrayIterator(te,ce.originalStart,ce.originalStart+ce.originalLength)),ce.modifiedLength>0){var he=ne[ce.modifiedStart-1]||Q;he=he.getDepth()>0?he:null,this.onInsertItems(new ue.ArrayIterator(ne,ce.modifiedStart,ce.modifiedStart+ce.modifiedLength),he?he.id:null)}}else(re||se.length)&&(this.onRemoveItems(new ue.ArrayIterator(te)),this.onInsertItems(new ue.ArrayIterator(ne),Q.getDepth()>0?Q.id:null));(re||se.length)&&this.onRowsChanged()}},t.prototype.onItemRefresh=function(X){this.onItemsRefresh([X])},t.prototype.onItemsRefresh=function(X){var $=this;this.onRefreshItemSet(X.filter((function(X){return $.items.hasOwnProperty(X.id)}))),this.onRowsChanged()},t.prototype.onItemExpanding=function(X){var $=this.items[X.item.id];$&&($.expanded=!0)},t.prototype.onItemExpanded=function(X){var $=X.item,Q=this.items[$.id];if(Q){Q.expanded=!0;var J=this.onInsertItems($.getNavigator(),$.id),ee=this.scrollTop;Q.top+Q.height<=this.scrollTop&&(ee+=J),this.onRowsChanged(ee)}},t.prototype.onItemCollapsing=function(X){var $=X.item,Q=this.items[$.id];Q&&(Q.expanded=!1,this.onRemoveItems(new ue.MappedIterator($.getNavigator(),(function(X){return X&&X.id}))),this.onRowsChanged())},t.prototype.onItemReveal=function(X){var $=X.item,Q=X.relativeTop,J=this.items[$.id];if(J)if(null!==Q){Q=(Q=Q<0?0:Q)>1?1:Q;var ee=J.height-this.viewHeight;this.scrollTop=ee*Q+J.top}else{var te=J.top+J.height,ne=this.scrollTop+this.viewHeight;J.top<this.scrollTop?this.scrollTop=J.top:te>=ne&&(this.scrollTop=te-this.viewHeight)}},t.prototype.onItemAddTrait=function(X){var $=X.item,Q=X.trait,J=this.items[$.id];J&&J.addClass(Q),"highlighted"===Q&&(ne.addClass(this.domNode,Q),J&&(this.highlightedItemWasDraggable=!!J.draggable,J.draggable&&(J.draggable=!1)))},t.prototype.onItemRemoveTrait=function(X){var $=X.item,Q=X.trait,J=this.items[$.id];J&&J.removeClass(Q),"highlighted"===Q&&(ne.removeClass(this.domNode,Q),this.highlightedItemWasDraggable&&(J.draggable=!0),this.highlightedItemWasDraggable=!1)},t.prototype.onModelFocusChange=function(){var X=this.model&&this.model.getFocus();ne.toggleClass(this.domNode,"no-focused-item",!X),X?this.domNode.setAttribute("aria-activedescendant",re.safeBtoa(this.context.dataSource.getId(this.context.tree,X))):this.domNode.removeAttribute("aria-activedescendant")},t.prototype.onInsertItem=function(X){var $=this;X.onDragStart=function(Q){$.onDragStart(X,Q)},X.needsRender=!0,this.refreshViewItem(X),this.items[X.id]=X},t.prototype.onRefreshItem=function(X,$){void 0===$&&($=!1),X.needsRender=X.needsRender||$,this.refreshViewItem(X)},t.prototype.onRemoveItem=function(X){this.removeItemFromDOM(X),X.dispose(),delete this.items[X.id]},t.prototype.refreshViewItem=function(X){X.render(),this.shouldBeRendered(X)?this.insertItemInDOM(X):this.removeItemFromDOM(X)},t.prototype.onClick=function(X){if(!this.lastPointerType||"mouse"===this.lastPointerType){var $=new se.StandardMouseEvent(X),Q=this.getItemAround($.target);Q&&(J.isIE&&Date.now()-this.lastClickTimeStamp<300&&($.detail=2),this.lastClickTimeStamp=Date.now(),this.context.controller.onClick(this.context.tree,Q.model.getElement(),$))}},t.prototype.onMouseMiddleClick=function(X){if(this.context.controller.onMouseMiddleClick){var $=new se.StandardMouseEvent(X),Q=this.getItemAround($.target);Q&&this.context.controller.onMouseMiddleClick(this.context.tree,Q.model.getElement(),$)}},t.prototype.onMouseDown=function(X){if(this.didJustPressContextMenuKey=!1,this.context.controller.onMouseDown&&(!this.lastPointerType||"mouse"===this.lastPointerType)){var $=new se.StandardMouseEvent(X);if(!($.ctrlKey&&Q.isNative&&Q.isMacintosh)){var J=this.getItemAround($.target);J&&this.context.controller.onMouseDown(this.context.tree,J.model.getElement(),$)}}},t.prototype.onMouseUp=function(X){if(this.context.controller.onMouseUp&&(!this.lastPointerType||"mouse"===this.lastPointerType)){var $=new se.StandardMouseEvent(X);if(!($.ctrlKey&&Q.isNative&&Q.isMacintosh)){var J=this.getItemAround($.target);J&&this.context.controller.onMouseUp(this.context.tree,J.model.getElement(),$)}}},t.prototype.onTap=function(X){var $=this.getItemAround(X.initialTarget);$&&this.context.controller.onTap(this.context.tree,$.model.getElement(),X)},t.prototype.onTouchChange=function(X){X.preventDefault(),X.stopPropagation(),this.scrollTop-=X.translationY},t.prototype.onContextMenu=function(X){var $,Q;if(X instanceof KeyboardEvent||this.didJustPressContextMenuKey){this.didJustPressContextMenuKey=!1;var J,ee=new ae.StandardKeyboardEvent(X);if(Q=this.model.getFocus()){var te=this.context.dataSource.getId(this.context.tree,Q),ie=this.items[te];J=ne.getDomNodePagePosition(ie.element)}else Q=this.model.getInput(),J=ne.getDomNodePagePosition(this.inputItem.element);$=new he.KeyboardContextMenuEvent(J.left+J.width,J.top,ee)}else{var oe=new se.StandardMouseEvent(X),re=this.getItemAround(oe.target);if(!re)return;Q=re.model.getElement(),$=new he.MouseContextMenuEvent(oe)}this.context.controller.onContextMenu(this.context.tree,Q,$)},t.prototype.onKeyDown=function(X){var $=new ae.StandardKeyboardEvent(X);this.didJustPressContextMenuKey=58===$.keyCode||$.shiftKey&&68===$.keyCode,$.target&&$.target.tagName&&"input"===$.target.tagName.toLowerCase()||(this.didJustPressContextMenuKey&&($.preventDefault(),$.stopPropagation()),this.context.controller.onKeyDown(this.context.tree,$))},t.prototype.onKeyUp=function(X){this.didJustPressContextMenuKey&&this.onContextMenu(X),this.didJustPressContextMenuKey=!1,this.context.controller.onKeyUp(this.context.tree,new ae.StandardKeyboardEvent(X))},t.prototype.onDragStart=function(X,$){if(!this.model.getHighlight()){var Q,J=X.model.getElement(),ee=this.model.getSelection();if(Q=ee.indexOf(J)>-1?ee:[J],$.dataTransfer.effectAllowed="copyMove",$.dataTransfer.setData(fe.DataTransfers.RESOURCES,JSON.stringify([X.uri])),$.dataTransfer.setDragImage){var te;te=this.context.dnd.getDragLabel?this.context.dnd.getDragLabel(this.context.tree,Q):String(Q.length);var ne=document.createElement("div");ne.className="monaco-tree-drag-image",ne.textContent=te,document.body.appendChild(ne),$.dataTransfer.setDragImage(ne,-10,-10),setTimeout((function(){return document.body.removeChild(ne)}),0)}this.currentDragAndDropData=new le.ElementsDragAndDropData(Q),t.currentExternalDragAndDropData=new le.ExternalElementsDragAndDropData(Q),this.context.dnd.onDragStart(this.context.tree,this.currentDragAndDropData,new se.DragMouseEvent($))}},t.prototype.setupDragAndDropScrollInterval=function(){var X=this,$=ne.getTopLeftOffset(this.wrapper).top;this.dragAndDropScrollInterval||(this.dragAndDropScrollInterval=window.setInterval((function(){if(void 0!==X.dragAndDropMouseY){var Q=X.dragAndDropMouseY-$,J=0,ee=X.viewHeight-35;Q<35?J=Math.max(-14,.2*(Q-35)):Q>ee&&(J=Math.min(14,.2*(Q-ee))),X.scrollTop+=J}}),10),this.cancelDragAndDropScrollTimeout(),this.dragAndDropScrollTimeout=window.setTimeout((function(){X.cancelDragAndDropScrollInterval(),X.dragAndDropScrollTimeout=null}),1e3))},t.prototype.cancelDragAndDropScrollInterval=function(){this.dragAndDropScrollInterval&&(window.clearInterval(this.dragAndDropScrollInterval),this.dragAndDropScrollInterval=null),this.cancelDragAndDropScrollTimeout()},t.prototype.cancelDragAndDropScrollTimeout=function(){this.dragAndDropScrollTimeout&&(window.clearTimeout(this.dragAndDropScrollTimeout),this.dragAndDropScrollTimeout=null)},t.prototype.onDragOver=function(X){var $=this,Q=new se.DragMouseEvent(X),J=this.getItemAround(Q.target);if(!J||0===Q.posx&&0===Q.posy&&Q.browserEvent.type===ne.EventType.DRAG_LEAVE)return this.currentDropTarget&&(this.currentDropTargets.forEach((function(X){return X.dropTarget=!1})),this.currentDropTargets=[],this.currentDropDisposable.dispose()),this.cancelDragAndDropScrollInterval(),this.currentDropTarget=null,this.currentDropElement=null,this.dragAndDropMouseY=null,!1;if(this.setupDragAndDropScrollInterval(),this.dragAndDropMouseY=Q.posy,!this.currentDragAndDropData)if(t.currentExternalDragAndDropData)this.currentDragAndDropData=t.currentExternalDragAndDropData;else{if(!Q.dataTransfer.types)return!1;this.currentDragAndDropData=new le.DesktopDragAndDropData}this.currentDragAndDropData.update(Q);var te,ie,oe=J.model;do{if(te=oe?oe.getElement():this.model.getInput(),!(ie=this.context.dnd.onDragOver(this.context.tree,this.currentDragAndDropData,te,Q))||1!==ie.bubble)break;oe=oe&&oe.parent}while(oe);if(!oe)return this.currentDropElement=null,!1;var re=ie&&ie.accept;re?(this.currentDropElement=oe.getElement(),Q.preventDefault(),Q.dataTransfer.dropEffect=0===ie.effect?"copy":"move"):this.currentDropElement=null;var ae=oe.id===this.inputItem.id?this.inputItem:this.items[oe.id];if((this.shouldInvalidateDropReaction||this.currentDropTarget!==ae||!function(X,$){return!X&&!$||!(!X||!$)&&X.accept===$.accept&&X.bubble===$.bubble&&X.effect===$.effect}(this.currentDropElementReaction,ie))&&(this.shouldInvalidateDropReaction=!1,this.currentDropTarget&&(this.currentDropTargets.forEach((function(X){return X.dropTarget=!1})),this.currentDropTargets=[],this.currentDropDisposable.dispose()),this.currentDropTarget=ae,this.currentDropElementReaction=ie,re)){if(this.currentDropTarget&&(this.currentDropTarget.dropTarget=!0,this.currentDropTargets.push(this.currentDropTarget)),0===ie.bubble)for(var ue,de=oe.getNavigator();ue=de.next();)(J=this.items[ue.id])&&(J.dropTarget=!0,this.currentDropTargets.push(J));if(ie.autoExpand){var ce=me.timeout(500);this.currentDropDisposable=ee.toDisposable((function(){return ce.cancel()})),ce.then((function(){return $.context.tree.expand($.currentDropElement)})).then((function(){return $.shouldInvalidateDropReaction=!0}))}}return!0},t.prototype.onDrop=function(X){if(this.currentDropElement){var $=new se.DragMouseEvent(X);$.preventDefault(),this.currentDragAndDropData.update($),this.context.dnd.drop(this.context.tree,this.currentDragAndDropData,this.currentDropElement,$),this.onDragEnd(X)}this.cancelDragAndDropScrollInterval()},t.prototype.onDragEnd=function(X){this.currentDropTarget&&(this.currentDropTargets.forEach((function(X){return X.dropTarget=!1})),this.currentDropTargets=[]),this.currentDropDisposable.dispose(),this.cancelDragAndDropScrollInterval(),this.currentDragAndDropData=null,t.currentExternalDragAndDropData=null,this.currentDropElement=null,this.currentDropTarget=null,this.dragAndDropMouseY=null},t.prototype.onFocus=function(){this.context.options.alwaysFocused||ne.addClass(this.domNode,"focused"),this._onDOMFocus.fire()},t.prototype.onBlur=function(){this.context.options.alwaysFocused||ne.removeClass(this.domNode,"focused"),this.domNode.removeAttribute("aria-activedescendant"),this._onDOMBlur.fire()},t.prototype.onMsPointerDown=function(X){if(this.msGesture){var $=X.pointerType;$!==(X.MSPOINTER_TYPE_MOUSE||"mouse")?$===(X.MSPOINTER_TYPE_TOUCH||"touch")&&(this.lastPointerType="touch",X.stopPropagation(),X.preventDefault(),this.msGesture.addPointer(X.pointerId)):this.lastPointerType="mouse"}},t.prototype.onThrottledMsGestureChange=function(X){this.scrollTop-=X.translationY},t.prototype.onMsGestureTap=function(X){X.initialTarget=document.elementFromPoint(X.clientX,X.clientY),this.onTap(X)},t.prototype.insertItemInDOM=function(X){var $=null,Q=this.itemAfter(X);Q&&Q.element&&($=Q.element),X.insertInDOM(this.rowsContainer,$)},t.prototype.removeItemFromDOM=function(X){X&&X.removeFromDOM()},t.prototype.shouldBeRendered=function(X){return X.top<this.lastRenderTop+this.lastRenderHeight&&X.top+X.height>this.lastRenderTop},t.prototype.getItemAround=function(X){var $=this.inputItem;do{if(X[t.BINDING]&&($=X[t.BINDING]),X===this.wrapper||X===this.domNode)return $;if(X===this.scrollableElement.getDomNode()||X===document.body)return null}while(X=X.parentElement)},t.prototype.releaseModel=function(){this.model&&(this.modelListeners=ee.dispose(this.modelListeners),this.model=null)},t.prototype.dispose=function(){var $=this;this.scrollableElement.dispose(),this.releaseModel(),this.modelListeners=null,this.viewListeners=ee.dispose(this.viewListeners),this._onDOMFocus.dispose(),this._onDOMBlur.dispose(),this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.domNode=null,this.items&&(Object.keys(this.items).forEach((function(X){return $.items[X].removeFromDOM()})),this.items=null),this.context.cache&&(this.context.cache.dispose(),this.context.cache=null),X.prototype.dispose.call(this)},t.BINDING="monaco-tree-row",t.LOADING_DECORATION_DELAY=800,t.counter=0,t.currentExternalDragAndDropData=null,t}(ce.HeightMap);$.TreeView=be})),define(Q[238],n([9]),{}),define(Q[244],n([9]),{}),define(Q[161],n([0,1,88,444,235,6,28,27,244]),(function(X,$,Q,J,ee,te,ne,ie){Object.defineProperty($,"__esModule",{value:!0});var l=function(X,$,J){if(void 0===J&&(J={}),this.tree=X,this.configuration=$,this.options=J,!$.dataSource)throw new Error("You must provide a Data Source to the tree.");this.dataSource=$.dataSource,this.renderer=$.renderer,this.controller=$.controller||new Q.DefaultController({clickBehavior:1,keyboardSupport:"boolean"!=typeof J.keyboardSupport||J.keyboardSupport}),this.dnd=$.dnd||new Q.DefaultDragAndDrop,this.filter=$.filter||new Q.DefaultFilter,this.sorter=$.sorter||null,this.accessibilityProvider=$.accessibilityProvider||new Q.DefaultAccessibilityProvider,this.styler=$.styler||null};$.TreeContext=l;var oe={listFocusBackground:ne.Color.fromHex("#073655"),listActiveSelectionBackground:ne.Color.fromHex("#0E639C"),listActiveSelectionForeground:ne.Color.fromHex("#FFFFFF"),listFocusAndSelectionBackground:ne.Color.fromHex("#094771"),listFocusAndSelectionForeground:ne.Color.fromHex("#FFFFFF"),listInactiveSelectionBackground:ne.Color.fromHex("#3F3F46"),listHoverBackground:ne.Color.fromHex("#2A2D2E"),listDropBackground:ne.Color.fromHex("#383B3D")},re=function(){function e(X,$,Q){void 0===Q&&(Q={}),this._onDidChangeFocus=new te.Relay,this.onDidChangeFocus=this._onDidChangeFocus.event,this._onDidChangeSelection=new te.Relay,this.onDidChangeSelection=this._onDidChangeSelection.event,this._onHighlightChange=new te.Relay,this._onDidExpandItem=new te.Relay,this._onDidCollapseItem=new te.Relay,this._onDispose=new te.Emitter,this.onDidDispose=this._onDispose.event,this.container=X,ie.mixin(Q,oe,!1),Q.twistiePixels="number"==typeof Q.twistiePixels?Q.twistiePixels:32,Q.showTwistie=!1!==Q.showTwistie,Q.indentPixels="number"==typeof Q.indentPixels?Q.indentPixels:12,Q.alwaysFocused=!0===Q.alwaysFocused,Q.useShadows=!1!==Q.useShadows,Q.paddingOnRow=!1!==Q.paddingOnRow,Q.showLoading=!1!==Q.showLoading,this.context=new l(this,$,Q),this.model=new J.TreeModel(this.context),this.view=new ee.TreeView(this.context,this.container),this.view.setModel(this.model),this._onDidChangeFocus.input=this.model.onDidFocus,this._onDidChangeSelection.input=this.model.onDidSelect,this._onHighlightChange.input=this.model.onDidHighlight,this._onDidExpandItem.input=this.model.onDidExpandItem,this._onDidCollapseItem.input=this.model.onDidCollapseItem}return e.prototype.style=function(X){this.view.applyStyles(X)},Object.defineProperty(e.prototype,"onDidFocus",{get:function(){return this.view&&this.view.onDOMFocus},enumerable:!0,configurable:!0}),e.prototype.getHTMLElement=function(){return this.view.getHTMLElement()},e.prototype.layout=function(X,$){this.view.layout(X,$)},e.prototype.domFocus=function(){this.view.focus()},e.prototype.isDOMFocused=function(){return this.view.isFocused()},e.prototype.domBlur=function(){this.view.blur()},e.prototype.setInput=function(X){return this.model.setInput(X)},e.prototype.getInput=function(){return this.model.getInput()},e.prototype.refresh=function(X,$){return void 0===X&&(X=null),void 0===$&&($=!0),this.model.refresh(X,$)},e.prototype.expand=function(X){return this.model.expand(X)},e.prototype.collapse=function(X,$){return void 0===$&&($=!1),this.model.collapse(X,$)},e.prototype.toggleExpansion=function(X,$){return void 0===$&&($=!1),this.model.toggleExpansion(X,$)},e.prototype.isExpanded=function(X){return this.model.isExpanded(X)},e.prototype.reveal=function(X,$){return void 0===$&&($=null),this.model.reveal(X,$)},e.prototype.getHighlight=function(){return this.model.getHighlight()},e.prototype.clearHighlight=function(X){this.model.setHighlight(null,X)},e.prototype.setSelection=function(X,$){this.model.setSelection(X,$)},e.prototype.getSelection=function(){return this.model.getSelection()},e.prototype.clearSelection=function(X){this.model.setSelection([],X)},e.prototype.setFocus=function(X,$){this.model.setFocus(X,$)},e.prototype.getFocus=function(){return this.model.getFocus()},e.prototype.focusNext=function(X,$){this.model.focusNext(X,$)},e.prototype.focusPrevious=function(X,$){this.model.focusPrevious(X,$)},e.prototype.focusParent=function(X){this.model.focusParent(X)},e.prototype.focusFirstChild=function(X){this.model.focusFirstChild(X)},e.prototype.focusFirst=function(X,$){this.model.focusFirst(X,$)},e.prototype.focusNth=function(X,$){this.model.focusNth(X,$)},e.prototype.focusLast=function(X,$){this.model.focusLast(X,$)},e.prototype.focusNextPage=function(X){this.view.focusNextPage(X)},e.prototype.focusPreviousPage=function(X){this.view.focusPreviousPage(X)},e.prototype.clearFocus=function(X){this.model.setFocus(null,X)},e.prototype.dispose=function(){this._onDispose.fire(),null!==this.model&&(this.model.dispose(),this.model=null),null!==this.view&&(this.view.dispose(),this.view=null),this._onDidChangeFocus.dispose(),this._onDidChangeSelection.dispose(),this._onHighlightChange.dispose(),this._onDidExpandItem.dispose(),this._onDidCollapseItem.dispose(),this._onDispose.dispose()},e}();$.Tree=re})),define(Q[250],n([9]),{}),define(Q[251],n([9]),{}),define(Q[252],n([9]),{}),define(Q[259],n([9]),{}),define(Q[260],n([9]),{}),define(Q[262],n([9]),{}),define(Q[265],n([9]),{}),define(Q[266],n([9]),{}),define(Q[267],n([9]),{}),define(Q[269],n([9]),{}),define(Q[272],n([9]),{}),define(Q[274],n([9]),{}),define(Q[281],n([9]),{}),define(Q[284],n([9]),{}),define(Q[286],n([9]),{}),define(Q[295],n([9]),{}),define(Q[296],n([9]),{}),define(Q[331],n([9]),{}),define(Q[355],n([9]),{}),define(Q[358],n([9]),{}),define(Q[359],n([9]),{}),define(Q[360],n([9]),{}),define(Q[361],n([9]),{}),define(Q[362],n([9]),{}),define(Q[363],n([9]),{}),define(Q[365],n([9]),{}),define(Q[366],n([9]),{}),define(Q[367],n([9]),{}),define(Q[163],n([9]),{}),define(Q[370],n([9]),{}),define(Q[371],n([9]),{}),define(Q[373],n([9]),{}),define(Q[374],n([9]),{}),define(Q[375],n([9]),{}),define(Q[376],n([9]),{}),define(Q[377],n([9]),{}),define(Q[381],n([9]),{}),define(Q[382],n([9]),{}),define(Q[383],n([9]),{}),define(Q[384],n([9]),{}),define(Q[386],n([9]),{}),define(Q[388],n([9]),{}),define(Q[396],n([9]),{}),define(Q[399],n([9]),{}),define(Q[400],n([9]),{}),define(Q[401],n([9]),{}),define(Q[403],n([9]),{}),define(Q[404],n([9]),{}),define(Q[407],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q=function(){function e(X,$){this.chr=X,this.type=$,this.width=0}return e.prototype.fulfill=function(X){this.width=X},e}();$.CharWidthRequest=Q;var J=function(){function e(X,$){this._bareFontInfo=X,this._requests=$,this._container=null,this._testElements=null}return e.prototype.read=function(){this._createDomElements(),document.body.appendChild(this._container),this._readFromDomElements(),document.body.removeChild(this._container),this._container=null,this._testElements=null},e.prototype._createDomElements=function(){var X=document.createElement("div");X.style.position="absolute",X.style.top="-50000px",X.style.width="50000px";var $=document.createElement("div");$.style.fontFamily=this._bareFontInfo.getMassagedFontFamily(),$.style.fontWeight=this._bareFontInfo.fontWeight,$.style.fontSize=this._bareFontInfo.fontSize+"px",$.style.lineHeight=this._bareFontInfo.lineHeight+"px",$.style.letterSpacing=this._bareFontInfo.letterSpacing+"px",X.appendChild($);var Q=document.createElement("div");Q.style.fontFamily=this._bareFontInfo.getMassagedFontFamily(),Q.style.fontWeight="bold",Q.style.fontSize=this._bareFontInfo.fontSize+"px",Q.style.lineHeight=this._bareFontInfo.lineHeight+"px",Q.style.letterSpacing=this._bareFontInfo.letterSpacing+"px",X.appendChild(Q);var J=document.createElement("div");J.style.fontFamily=this._bareFontInfo.getMassagedFontFamily(),J.style.fontWeight=this._bareFontInfo.fontWeight,J.style.fontSize=this._bareFontInfo.fontSize+"px",J.style.lineHeight=this._bareFontInfo.lineHeight+"px",J.style.letterSpacing=this._bareFontInfo.letterSpacing+"px",J.style.fontStyle="italic",X.appendChild(J);for(var ee=[],te=0,ne=this._requests.length;te<ne;te++){var ie=this._requests[te],oe=void 0;0===ie.type&&(oe=$),2===ie.type&&(oe=Q),1===ie.type&&(oe=J),oe.appendChild(document.createElement("br"));var re=document.createElement("span");e._render(re,ie),oe.appendChild(re),ee[te]=re}this._container=X,this._testElements=ee},e._render=function(X,$){if(" "===$.chr){for(var Q="&nbsp;",J=0;J<8;J++)Q+=Q;X.innerHTML=Q}else{var ee=$.chr;for(J=0;J<8;J++)ee+=ee;X.textContent=ee}},e.prototype._readFromDomElements=function(){for(var X=0,$=this._requests.length;X<$;X++){var Q=this._requests[X],J=this._testElements[X];Q.fulfill(J.offsetWidth/256)}},e}();$.readCharWidths=function(X,$){new J(X,$).read()}})),define(Q[409],n([0,1,2]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(X){function t($,Q){var J=X.call(this)||this;return J.referenceDomElement=$,J.changeCallback=Q,J.measureReferenceDomElementToken=-1,J.width=-1,J.height=-1,J.measureReferenceDomElement(!1),J}return te(t,X),t.prototype.dispose=function(){this.stopObserving(),X.prototype.dispose.call(this)},t.prototype.getWidth=function(){return this.width},t.prototype.getHeight=function(){return this.height},t.prototype.startObserving=function(){var X=this;-1===this.measureReferenceDomElementToken&&(this.measureReferenceDomElementToken=setInterval((function(){return X.measureReferenceDomElement(!0)}),100))},t.prototype.stopObserving=function(){-1!==this.measureReferenceDomElementToken&&(clearInterval(this.measureReferenceDomElementToken),this.measureReferenceDomElementToken=-1)},t.prototype.observe=function(X){this.measureReferenceDomElement(!0,X)},t.prototype.measureReferenceDomElement=function(X,$){var Q=0,J=0;$?(Q=$.width,J=$.height):this.referenceDomElement&&(Q=this.referenceDomElement.clientWidth,J=this.referenceDomElement.clientHeight),Q=Math.max(5,Q),J=Math.max(5,J),this.width===Q&&this.height===J||(this.width=Q,this.height=J,X&&this.changeCallback())},t}(Q.Disposable);$.ElementSizeObserver=J})),define(Q[66],n([0,1,8]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(){function e(X,$){if(this.flags=$,0!=(1&this.flags)){var J=X.getModel();this.modelVersionId=J?Q.format("{0}#{1}",J.uri.toString(),J.getVersionId()):null}0!=(4&this.flags)&&(this.position=X.getPosition()),0!=(2&this.flags)&&(this.selection=X.getSelection()),0!=(8&this.flags)&&(this.scrollLeft=X.getScrollLeft(),this.scrollTop=X.getScrollTop())}return e.prototype._equals=function(X){if(!(X instanceof e))return!1;var $=X;return this.modelVersionId===$.modelVersionId&&this.scrollLeft===$.scrollLeft&&this.scrollTop===$.scrollTop&&!(!this.position&&$.position||this.position&&!$.position||this.position&&$.position&&!this.position.equals($.position))&&!(!this.selection&&$.selection||this.selection&&!$.selection||this.selection&&$.selection&&!this.selection.equalsRange($.selection))},e.prototype.validate=function(X){return this._equals(new e(X,this.flags))},e}();$.EditorState=J;var ee=function(){function e(X,$){this._visiblePosition=X,this._visiblePositionScrollDelta=$}return e.capture=function(X){var $=null,Q=0;if(0!==X.getScrollTop()){var J=X.getVisibleRanges();if(J.length>0){$=J[0].getStartPosition();var ee=X.getTopForPosition($.lineNumber,$.column);Q=X.getScrollTop()-ee}}return new e($,Q)},e.prototype.restore=function(X){if(this._visiblePosition){var $=X.getTopForPosition(this._visiblePosition.lineNumber,this._visiblePosition.column);X.setScrollTop($+this._visiblePositionScrollDelta)}},e}();$.StableEditorScrollState=ee})),define(Q[134],n([0,1,7,73,40,2]),(function(X,$,Q,J,ee,ne){function a(X){var $=Q.getDomNodePagePosition(X);return new d($.left,$.top,$.width,$.height)}Object.defineProperty($,"__esModule",{value:!0});var ie=function(){function e(X,$){this.x=X,this.y=$}return e.prototype.toClientCoordinates=function(){return new oe(this.x-Q.StandardWindow.scrollX,this.y-Q.StandardWindow.scrollY)},e}();$.PageCoordinates=ie;var oe=function(){function e(X,$){this.clientX=X,this.clientY=$}return e.prototype.toPageCoordinates=function(){return new ie(this.clientX+Q.StandardWindow.scrollX,this.clientY+Q.StandardWindow.scrollY)},e}();$.ClientCoordinates=oe;var d=function(X,$,Q,J){this.x=X,this.y=$,this.width=Q,this.height=J};$.EditorPagePosition=d,$.createEditorPagePosition=a;var re=function(X){function t($,Q){var J=X.call(this,$)||this;return J.pos=new ie(J.posx,J.posy),J.editorPos=a(Q),J}return te(t,X),t}(ee.StandardMouseEvent);$.EditorMouseEvent=re;var se=function(){function e(X){this._editorViewDomNode=X}return e.prototype._create=function(X){return new re(X,this._editorViewDomNode)},e.prototype.onContextMenu=function(X,$){var J=this;return Q.addDisposableListener(X,"contextmenu",(function(X){$(J._create(X))}))},e.prototype.onMouseUp=function(X,$){var J=this;return Q.addDisposableListener(X,"mouseup",(function(X){$(J._create(X))}))},e.prototype.onMouseDown=function(X,$){var J=this;return Q.addDisposableListener(X,"mousedown",(function(X){$(J._create(X))}))},e.prototype.onMouseLeave=function(X,$){var J=this;return Q.addDisposableNonBubblingMouseOutListener(X,(function(X){$(J._create(X))}))},e.prototype.onMouseMoveThrottled=function(X,$,J,ee){var te=this;return Q.addDisposableThrottledListener(X,"mousemove",$,(function(X,$){return J(X,te._create($))}),ee)},e}();$.EditorMouseEventFactory=se;var ae=function(X){function t($){var Q=X.call(this)||this;return Q._editorViewDomNode=$,Q._globalMouseMoveMonitor=Q._register(new J.GlobalMouseMoveMonitor),Q._keydownListener=null,Q}return te(t,X),t.prototype.startMonitoring=function(X,$,J){var ee=this;this._keydownListener=Q.addStandardDisposableListener(document,"keydown",(function(X){X.toKeybinding().isModifierKey()||ee._globalMouseMoveMonitor.stopMonitoring(!0)}),!0),this._globalMouseMoveMonitor.startMonitoring((function($,Q){return X($,new re(Q,ee._editorViewDomNode))}),$,(function(){ee._keydownListener.dispose(),J()}))},t}(ne.Disposable);$.GlobalEditorMouseMoveMonitor=ae})),define(Q[415],n([0,1,6,2]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(X){function t(){var $=X.call(this)||this;return $._onCodeEditorAdd=$._register(new Q.Emitter),$.onCodeEditorAdd=$._onCodeEditorAdd.event,$._onCodeEditorRemove=$._register(new Q.Emitter),$._onDiffEditorAdd=$._register(new Q.Emitter),$._onDiffEditorRemove=$._register(new Q.Emitter),$._codeEditors=Object.create(null),$._diffEditors=Object.create(null),$}return te(t,X),t.prototype.addCodeEditor=function(X){this._codeEditors[X.getId()]=X,this._onCodeEditorAdd.fire(X)},t.prototype.removeCodeEditor=function(X){delete this._codeEditors[X.getId()]&&this._onCodeEditorRemove.fire(X)},t.prototype.listCodeEditors=function(){var X=this;return Object.keys(this._codeEditors).map((function($){return X._codeEditors[$]}))},t.prototype.addDiffEditor=function(X){this._diffEditors[X.getId()]=X,this._onDiffEditorAdd.fire(X)},t.prototype.removeDiffEditor=function(X){delete this._diffEditors[X.getId()]&&this._onDiffEditorRemove.fire(X)},t.prototype.listDiffEditors=function(){var X=this;return Object.keys(this._diffEditors).map((function($){return X._diffEditors[$]}))},t.prototype.getFocusedCodeEditor=function(){for(var X=null,$=this.listCodeEditors(),Q=0;Q<$.length;Q++){var J=$[Q];if(J.hasTextFocus())return J;J.hasWidgetFocus()&&(X=J)}return X},t}(J.Disposable);$.AbstractCodeEditorService=ee})),define(Q[97],n([0,1,6]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),$.EditorZoom=new(function(){function e(){this._zoomLevel=0,this._onDidChangeZoomLevel=new Q.Emitter,this.onDidChangeZoomLevel=this._onDidChangeZoomLevel.event}return e.prototype.getZoomLevel=function(){return this._zoomLevel},e.prototype.setZoomLevel=function(X){X=Math.min(Math.max(-5,X),20),this._zoomLevel!==X&&(this._zoomLevel=X,this._onDidChangeZoomLevel.fire(this._zoomLevel))},e}())})),define(Q[12],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q=function(){function e(X,$){this.lineNumber=X,this.column=$}return e.prototype.with=function(X,$){return void 0===X&&(X=this.lineNumber),void 0===$&&($=this.column),X===this.lineNumber&&$===this.column?this:new e(X,$)},e.prototype.delta=function(X,$){return void 0===X&&(X=0),void 0===$&&($=0),this.with(this.lineNumber+X,this.column+$)},e.prototype.equals=function(X){return e.equals(this,X)},e.equals=function(X,$){return!X&&!$||!!X&&!!$&&X.lineNumber===$.lineNumber&&X.column===$.column},e.prototype.isBefore=function(X){return e.isBefore(this,X)},e.isBefore=function(X,$){return X.lineNumber<$.lineNumber||!($.lineNumber<X.lineNumber)&&X.column<$.column},e.prototype.isBeforeOrEqual=function(X){return e.isBeforeOrEqual(this,X)},e.isBeforeOrEqual=function(X,$){return X.lineNumber<$.lineNumber||!($.lineNumber<X.lineNumber)&&X.column<=$.column},e.compare=function(X,$){var Q=0|X.lineNumber,J=0|$.lineNumber;return Q===J?(0|X.column)-(0|$.column):Q-J},e.prototype.clone=function(){return new e(this.lineNumber,this.column)},e.prototype.toString=function(){return"("+this.lineNumber+","+this.column+")"},e.lift=function(X){return new e(X.lineNumber,X.column)},e.isIPosition=function(X){return X&&"number"==typeof X.lineNumber&&"number"==typeof X.column},e}();$.Position=Q})),define(Q[3],n([0,1,12]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(){function e(X,$,Q,J){X>Q||X===Q&&$>J?(this.startLineNumber=Q,this.startColumn=J,this.endLineNumber=X,this.endColumn=$):(this.startLineNumber=X,this.startColumn=$,this.endLineNumber=Q,this.endColumn=J)}return e.prototype.isEmpty=function(){return e.isEmpty(this)},e.isEmpty=function(X){return X.startLineNumber===X.endLineNumber&&X.startColumn===X.endColumn},e.prototype.containsPosition=function(X){return e.containsPosition(this,X)},e.containsPosition=function(X,$){return!($.lineNumber<X.startLineNumber||$.lineNumber>X.endLineNumber||$.lineNumber===X.startLineNumber&&$.column<X.startColumn||$.lineNumber===X.endLineNumber&&$.column>X.endColumn)},e.prototype.containsRange=function(X){return e.containsRange(this,X)},e.containsRange=function(X,$){return!($.startLineNumber<X.startLineNumber||$.endLineNumber<X.startLineNumber||$.startLineNumber>X.endLineNumber||$.endLineNumber>X.endLineNumber||$.startLineNumber===X.startLineNumber&&$.startColumn<X.startColumn||$.endLineNumber===X.endLineNumber&&$.endColumn>X.endColumn)},e.prototype.plusRange=function(X){return e.plusRange(this,X)},e.plusRange=function(X,$){var Q,J,ee,te;return $.startLineNumber<X.startLineNumber?(Q=$.startLineNumber,J=$.startColumn):$.startLineNumber===X.startLineNumber?(Q=$.startLineNumber,J=Math.min($.startColumn,X.startColumn)):(Q=X.startLineNumber,J=X.startColumn),$.endLineNumber>X.endLineNumber?(ee=$.endLineNumber,te=$.endColumn):$.endLineNumber===X.endLineNumber?(ee=$.endLineNumber,te=Math.max($.endColumn,X.endColumn)):(ee=X.endLineNumber,te=X.endColumn),new e(Q,J,ee,te)},e.prototype.intersectRanges=function(X){return e.intersectRanges(this,X)},e.intersectRanges=function(X,$){var Q=X.startLineNumber,J=X.startColumn,ee=X.endLineNumber,te=X.endColumn,ne=$.startLineNumber,ie=$.startColumn,oe=$.endLineNumber,re=$.endColumn;return Q<ne?(Q=ne,J=ie):Q===ne&&(J=Math.max(J,ie)),ee>oe?(ee=oe,te=re):ee===oe&&(te=Math.min(te,re)),Q>ee||Q===ee&&J>te?null:new e(Q,J,ee,te)},e.prototype.equalsRange=function(X){return e.equalsRange(this,X)},e.equalsRange=function(X,$){return!!X&&!!$&&X.startLineNumber===$.startLineNumber&&X.startColumn===$.startColumn&&X.endLineNumber===$.endLineNumber&&X.endColumn===$.endColumn},e.prototype.getEndPosition=function(){return new Q.Position(this.endLineNumber,this.endColumn)},e.prototype.getStartPosition=function(){return new Q.Position(this.startLineNumber,this.startColumn)},e.prototype.toString=function(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"},e.prototype.setEndPosition=function(X,$){return new e(this.startLineNumber,this.startColumn,X,$)},e.prototype.setStartPosition=function(X,$){return new e(X,$,this.endLineNumber,this.endColumn)},e.prototype.collapseToStart=function(){return e.collapseToStart(this)},e.collapseToStart=function(X){return new e(X.startLineNumber,X.startColumn,X.startLineNumber,X.startColumn)},e.fromPositions=function(X,$){return void 0===$&&($=X),new e(X.lineNumber,X.column,$.lineNumber,$.column)},e.lift=function(X){return X?new e(X.startLineNumber,X.startColumn,X.endLineNumber,X.endColumn):null},e.isIRange=function(X){return X&&"number"==typeof X.startLineNumber&&"number"==typeof X.startColumn&&"number"==typeof X.endLineNumber&&"number"==typeof X.endColumn},e.areIntersectingOrTouching=function(X,$){return!(X.endLineNumber<$.startLineNumber||X.endLineNumber===$.startLineNumber&&X.endColumn<$.startColumn||$.endLineNumber<X.startLineNumber||$.endLineNumber===X.startLineNumber&&$.endColumn<X.startColumn)},e.areIntersecting=function(X,$){return!(X.endLineNumber<$.startLineNumber||X.endLineNumber===$.startLineNumber&&X.endColumn<=$.startColumn||$.endLineNumber<X.startLineNumber||$.endLineNumber===X.startLineNumber&&$.endColumn<=X.startColumn)},e.compareRangesUsingStarts=function(X,$){if(X&&$){var Q=0|X.startLineNumber,J=0|$.startLineNumber;if(Q===J){var ee=0|X.startColumn,te=0|$.startColumn;if(ee===te){var ne=0|X.endLineNumber,ie=0|$.endLineNumber;return ne===ie?(0|X.endColumn)-(0|$.endColumn):ne-ie}return ee-te}return Q-J}return(X?1:0)-($?1:0)},e.compareRangesUsingEnds=function(X,$){return X.endLineNumber===$.endLineNumber?X.endColumn===$.endColumn?X.startLineNumber===$.startLineNumber?X.startColumn-$.startColumn:X.startLineNumber-$.startLineNumber:X.endColumn-$.endColumn:X.endLineNumber-$.endLineNumber},e.spansMultipleLines=function(X){return X.endLineNumber>X.startLineNumber},e}();$.Range=J})),define(Q[173],n([0,1,8,12,3]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var te=function(){function e(X,$,Q,J,ee){this.value=X,this.selectionStart=$,this.selectionEnd=Q,this.selectionStartPosition=J,this.selectionEndPosition=ee}return e.prototype.toString=function(){return"[ <"+this.value+">, selectionStart: "+this.selectionStart+", selectionEnd: "+this.selectionEnd+"]"},e.readFromTextArea=function(X){return new e(X.getValue(),X.getSelectionStart(),X.getSelectionEnd(),null,null)},e.prototype.collapseSelection=function(){return new e(this.value,this.value.length,this.value.length,null,null)},e.prototype.writeToTextArea=function(X,$,Q){$.setValue(X,this.value),Q&&$.setSelectionRange(X,this.selectionStart,this.selectionEnd)},e.prototype.deduceEditorPosition=function(X){if(X<=this.selectionStart)return $=this.value.substring(X,this.selectionStart),this._finishDeduceEditorPosition(this.selectionStartPosition,$,-1);if(X>=this.selectionEnd){var $=this.value.substring(this.selectionEnd,X);return this._finishDeduceEditorPosition(this.selectionEndPosition,$,1)}var Q=this.value.substring(this.selectionStart,X);if(-1===Q.indexOf(String.fromCharCode(8230)))return this._finishDeduceEditorPosition(this.selectionStartPosition,Q,1);var J=this.value.substring(X,this.selectionEnd);return this._finishDeduceEditorPosition(this.selectionEndPosition,J,-1)},e.prototype._finishDeduceEditorPosition=function(X,$,Q){for(var J=0,ee=-1;-1!==(ee=$.indexOf("\n",ee+1));)J++;return[X,Q*$.length,J]},e.selectedText=function(X){return new e(X,0,X.length,null,null)},e.deduceInput=function(X,$,J,ee){if(!X)return{text:"",replaceCharCnt:0};var te=X.value,ne=X.selectionStart,ie=X.selectionEnd,oe=$.value,re=$.selectionStart,se=$.selectionEnd;ee&&te.length>0&&ne===ie&&re===se&&!Q.startsWith(oe,te)&&Q.endsWith(oe,te)&&(ne=0,ie=0);var ae=te.substring(ie),le=oe.substring(se),ue=Q.commonSuffixLength(ae,le);oe=oe.substring(0,oe.length-ue);var de=(te=te.substring(0,te.length-ue)).substring(0,ne),ce=oe.substring(0,re),he=Q.commonPrefixLength(de,ce);if(oe=oe.substring(he),te=te.substring(he),re-=he,ne-=he,se-=he,ie-=he,J&&re===se&&te.length>0){var pe=null;if(re===oe.length?Q.startsWith(oe,te)&&(pe=oe.substring(te.length)):Q.endsWith(oe,te)&&(pe=oe.substring(0,oe.length-te.length)),null!==pe&&pe.length>0&&(/\uFE0F/.test(pe)||Q.containsEmoji(pe)))return{text:pe,replaceCharCnt:0}}return re===se?te===oe&&0===ne&&ie===te.length&&re===oe.length&&-1===oe.indexOf("\n")&&Q.containsFullWidthCharacter(oe)?{text:"",replaceCharCnt:0}:{text:oe,replaceCharCnt:de.length-he}:{text:oe,replaceCharCnt:ie-ne}},e.EMPTY=new e("",0,0,null,null),e}();$.TextAreaState=te;var ne=function(){function e(){}return e._getPageOfLine=function(X){return Math.floor((X-1)/e._LINES_PER_PAGE)},e._getRangeForPage=function(X){var $=X*e._LINES_PER_PAGE,Q=$+1,J=$+e._LINES_PER_PAGE;return new ee.Range(Q,1,J+1,1)},e.fromEditorSelection=function(X,$,Q,ne){var ie,oe=e._getPageOfLine(Q.startLineNumber),re=e._getRangeForPage(oe),se=e._getPageOfLine(Q.endLineNumber),ae=e._getRangeForPage(se),le=re.intersectRanges(new ee.Range(1,1,Q.startLineNumber,Q.startColumn)),ue=$.getValueInRange(le,1),de=$.getLineCount(),ce=$.getLineMaxColumn(de),he=ae.intersectRanges(new ee.Range(Q.endLineNumber,Q.endColumn,de,ce)),pe=$.getValueInRange(he,1);if(oe===se||oe+1===se)ie=$.getValueInRange(Q,1);else{var fe=re.intersectRanges(Q),ge=ae.intersectRanges(Q);ie=$.getValueInRange(fe,1)+String.fromCharCode(8230)+$.getValueInRange(ge,1)}return ne&&(ue.length>500&&(ue=ue.substring(ue.length-500,ue.length)),pe.length>500&&(pe=pe.substring(0,500)),ie.length>1e3&&(ie=ie.substring(0,500)+String.fromCharCode(8230)+ie.substring(ie.length-500,ie.length))),new te(ue+ie+pe,ue.length,ue.length+ie.length,new J.Position(Q.startLineNumber,Q.startColumn),new J.Position(Q.endLineNumber,Q.endColumn))},e._LINES_PER_PAGE=10,e}();$.PagedScreenReaderStrategy=ne})),define(Q[194],n([0,1,135,6,2,27,3]),(function(X,$,Q,J,ee,te,ne){Object.defineProperty($,"__esModule",{value:!0});var ie={followsCaret:!0,ignoreCharChanges:!0,alwaysRevealFirst:!0},oe=function(){function e(X,$){void 0===$&&($={});var Q=this;this._onDidUpdate=new J.Emitter,this._editor=X,this._options=te.mixin($,ie,!1),this.disposed=!1,this._disposables=[],this.nextIdx=-1,this.ranges=[],this.ignoreSelectionChange=!1,this.revealFirst=Boolean(this._options.alwaysRevealFirst),this._disposables.push(this._editor.onDidDispose((function(){return Q.dispose()}))),this._disposables.push(this._editor.onDidUpdateDiff((function(){return Q._onDiffUpdated()}))),this._options.followsCaret&&this._disposables.push(this._editor.getModifiedEditor().onDidChangeCursorPosition((function(X){Q.ignoreSelectionChange||(Q.nextIdx=-1)}))),this._options.alwaysRevealFirst&&this._disposables.push(this._editor.getModifiedEditor().onDidChangeModel((function(X){Q.revealFirst=!0}))),this._init()}return e.prototype._init=function(){this._editor.getLineChanges()},e.prototype._onDiffUpdated=function(){this._init(),this._compute(this._editor.getLineChanges()),this.revealFirst&&null!==this._editor.getLineChanges()&&(this.revealFirst=!1,this.nextIdx=-1,this.next(1))},e.prototype._compute=function(X){var $=this;this.ranges=[],X&&X.forEach((function(X){!$._options.ignoreCharChanges&&X.charChanges?X.charChanges.forEach((function(X){$.ranges.push({rhs:!0,range:new ne.Range(X.modifiedStartLineNumber,X.modifiedStartColumn,X.modifiedEndLineNumber,X.modifiedEndColumn)})})):$.ranges.push({rhs:!0,range:new ne.Range(X.modifiedStartLineNumber,1,X.modifiedStartLineNumber,1)})})),this.ranges.sort((function(X,$){return X.range.getStartPosition().isBeforeOrEqual($.range.getStartPosition())?-1:$.range.getStartPosition().isBeforeOrEqual(X.range.getStartPosition())?1:0})),this._onDidUpdate.fire(this)},e.prototype._initIdx=function(X){var $=!1,Q=this._editor.getPosition();if(Q){for(var J=0,ee=this.ranges.length;J<ee&&!$;J++){var te=this.ranges[J].range;Q.isBeforeOrEqual(te.getStartPosition())&&(this.nextIdx=J+(X?0:-1),$=!0)}$||(this.nextIdx=X?0:this.ranges.length-1),this.nextIdx<0&&(this.nextIdx=this.ranges.length-1)}else this.nextIdx=0},e.prototype._move=function(X,$){if(Q.ok(!this.disposed,"Illegal State - diff navigator has been disposed"),this.canNavigate()){-1===this.nextIdx?this._initIdx(X):X?(this.nextIdx+=1,this.nextIdx>=this.ranges.length&&(this.nextIdx=0)):(this.nextIdx-=1,this.nextIdx<0&&(this.nextIdx=this.ranges.length-1));var J=this.ranges[this.nextIdx];this.ignoreSelectionChange=!0;try{var ee=J.range.getStartPosition();this._editor.setPosition(ee),this._editor.revealPositionInCenter(ee,$)}finally{this.ignoreSelectionChange=!1}}},e.prototype.canNavigate=function(){return this.ranges&&this.ranges.length>0},e.prototype.next=function(X){void 0===X&&(X=0),this._move(!0,X)},e.prototype.previous=function(X){void 0===X&&(X=0),this._move(!1,X)},e.prototype.dispose=function(){ee.dispose(this._disposables),this._disposables.length=0,this._onDidUpdate.dispose(),this.ranges=[],this.disposed=!0},e}();$.DiffNavigator=oe})),define(Q[49],n([0,1,3]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(){function e(){}return e.insert=function(X,$){return{range:new Q.Range(X.lineNumber,X.column,X.lineNumber,X.column),text:$,forceMoveMarkers:!0}},e.delete=function(X){return{range:X,text:null}},e.replace=function(X,$){return{range:X,text:$}},e.replaceMove=function(X,$){return{range:X,text:$,forceMoveMarkers:!0}},e}();$.EditOperation=J})),define(Q[425],n([0,1,8,49,3]),(function(X,$,Q,J,ee){function r(X,$){$.sort((function(X,$){return X.lineNumber===$.lineNumber?X.column-$.column:X.lineNumber-$.lineNumber}));for(var te=$.length-2;te>=0;te--)$[te].lineNumber===$[te+1].lineNumber&&$.splice(te,1);for(var ne=[],ie=0,oe=0,re=$.length,se=1,ae=X.getLineCount();se<=ae;se++){var le=X.getLineContent(se),ue=le.length+1,de=0;if(!(oe<re&&$[oe].lineNumber===se&&(de=$[oe].column,oe++,de===ue))&&0!==le.length){var ce=Q.lastNonWhitespaceIndex(le),he=0;if(-1===ce)he=1;else{if(ce===le.length-1)continue;he=ce+2}he=Math.max(de,he),ne[ie++]=J.EditOperation.delete(new ee.Range(se,he,se,ue))}}return ne}Object.defineProperty($,"__esModule",{value:!0});var te=function(){function e(X,$){this.selection=X,this.cursors=$}return e.prototype.getEditOperations=function(X,$){for(var Q=r(X,this.cursors),J=0,ee=Q.length;J<ee;J++){var te=Q[J];$.addEditOperation(te.range,te.text)}this.selectionId=$.trackSelection(this.selection)},e.prototype.computeCursorState=function(X,$){return $.getTrackedSelection(this.selectionId)},e}();$.TrimTrailingWhitespaceCommand=te,$.trimTrailingWhitespace=r})),define(Q[426],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q=function(){function e(X,$,Q,J){this.r=e._clamp(X),this.g=e._clamp($),this.b=e._clamp(Q),this.a=e._clamp(J)}return e._clamp=function(X){return X<0?0:X>255?255:0|X},e.Empty=new e(0,0,0,0),e}();$.RGBA8=Q})),define(Q[21],n([0,1,12,3]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(X){function t($,Q,J,ee){var te=X.call(this,$,Q,J,ee)||this;return te.selectionStartLineNumber=$,te.selectionStartColumn=Q,te.positionLineNumber=J,te.positionColumn=ee,te}return te(t,X),t.prototype.clone=function(){return new t(this.selectionStartLineNumber,this.selectionStartColumn,this.positionLineNumber,this.positionColumn)},t.prototype.toString=function(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"},t.prototype.equalsSelection=function(X){return t.selectionsEqual(this,X)},t.selectionsEqual=function(X,$){return X.selectionStartLineNumber===$.selectionStartLineNumber&&X.selectionStartColumn===$.selectionStartColumn&&X.positionLineNumber===$.positionLineNumber&&X.positionColumn===$.positionColumn},t.prototype.getDirection=function(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1},t.prototype.setEndPosition=function(X,$){return 0===this.getDirection()?new t(this.startLineNumber,this.startColumn,X,$):new t(X,$,this.startLineNumber,this.startColumn)},t.prototype.getPosition=function(){return new Q.Position(this.positionLineNumber,this.positionColumn)},t.prototype.setStartPosition=function(X,$){return 0===this.getDirection()?new t(X,$,this.endLineNumber,this.endColumn):new t(this.endLineNumber,this.endColumn,X,$)},t.fromPositions=function(X,$){return void 0===$&&($=X),new t(X.lineNumber,X.column,$.lineNumber,$.column)},t.liftSelection=function(X){return new t(X.selectionStartLineNumber,X.selectionStartColumn,X.positionLineNumber,X.positionColumn)},t.selectionsArrEqual=function(X,$){if(X&&!$||!X&&$)return!1;if(!X&&!$)return!0;if(X.length!==$.length)return!1;for(var Q=0,J=X.length;Q<J;Q++)if(!this.selectionsEqual(X[Q],$[Q]))return!1;return!0},t.isISelection=function(X){return X&&"number"==typeof X.selectionStartLineNumber&&"number"==typeof X.selectionStartColumn&&"number"==typeof X.positionLineNumber&&"number"==typeof X.positionColumn},t.createWithDirection=function(X,$,Q,J,ee){return 0===ee?new t(X,$,Q,J):new t(Q,J,X,$)},t}(J.Range);$.Selection=ee})),define(Q[150],n([0,1,29,7,16,6,2,17,8,173,21]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae){Object.defineProperty($,"__esModule",{value:!0}),$.CopyOptions={forceCopyWithSyntaxHighlighting:!1};var le=function(X){function a($,te){var ie=X.call(this)||this;ie._onFocus=ie._register(new ne.Emitter),ie.onFocus=ie._onFocus.event,ie._onBlur=ie._register(new ne.Emitter),ie.onBlur=ie._onBlur.event,ie._onKeyDown=ie._register(new ne.Emitter),ie.onKeyDown=ie._onKeyDown.event,ie._onKeyUp=ie._register(new ne.Emitter),ie.onKeyUp=ie._onKeyUp.event,ie._onCut=ie._register(new ne.Emitter),ie.onCut=ie._onCut.event,ie._onPaste=ie._register(new ne.Emitter),ie.onPaste=ie._onPaste.event,ie._onType=ie._register(new ne.Emitter),ie.onType=ie._onType.event,ie._onCompositionStart=ie._register(new ne.Emitter),ie.onCompositionStart=ie._onCompositionStart.event,ie._onCompositionUpdate=ie._register(new ne.Emitter),ie.onCompositionUpdate=ie._onCompositionUpdate.event,ie._onCompositionEnd=ie._register(new ne.Emitter),ie.onCompositionEnd=ie._onCompositionEnd.event,ie._onSelectionChangeRequest=ie._register(new ne.Emitter),ie.onSelectionChangeRequest=ie._onSelectionChangeRequest.event,ie._host=$,ie._textArea=ie._register(new de(te)),ie._lastTextAreaEvent=0,ie._asyncTriggerCut=ie._register(new ee.RunOnceScheduler((function(){return ie._onCut.fire()}),0)),ie._textAreaState=se.TextAreaState.EMPTY,ie.writeScreenReaderContent("ctor"),ie._hasFocus=!1,ie._isDoingComposition=!1,ie._nextCommand=0,ie._register(J.addStandardDisposableListener(te.domNode,"keydown",(function(X){!ie._isDoingComposition||109!==X.keyCode&&1!==X.keyCode||X.stopPropagation(),X.equals(9)&&X.preventDefault(),ie._onKeyDown.fire(X)}))),ie._register(J.addStandardDisposableListener(te.domNode,"keyup",(function(X){ie._onKeyUp.fire(X)}))),ie._register(J.addDisposableListener(te.domNode,"compositionstart",(function(X){ie._lastTextAreaEvent=1,ie._isDoingComposition||(ie._isDoingComposition=!0,Q.isEdgeOrIE||ie._setAndWriteTextAreaState("compositionstart",se.TextAreaState.EMPTY),ie._onCompositionStart.fire())})));var h=function(X,$){var Q=ie._textAreaState,J=se.TextAreaState.readFromTextArea(ie._textArea);return[J,se.TextAreaState.deduceInput(Q,J,X,$)]},g=function(X){var $=ie._textAreaState,Q=se.TextAreaState.selectedText(X);return[Q,{text:Q.value,replaceCharCnt:$.selectionEnd-$.selectionStart}]},m=function(X){return!(!Q.isEdgeOrIE||"ja"!==X)||!(!Q.isIE||0!==X.indexOf("zh-Han"))};ie._register(J.addDisposableListener(te.domNode,"compositionupdate",(function(X){if(ie._lastTextAreaEvent=2,m(X.locale)){var $=h(!1,!1),Q=$[0],J=$[1];return ie._textAreaState=Q,ie._onType.fire(J),void ie._onCompositionUpdate.fire(X)}var ee=g(X.data),te=ee[0],ne=ee[1];ie._textAreaState=te,ie._onType.fire(ne),ie._onCompositionUpdate.fire(X)}))),ie._register(J.addDisposableListener(te.domNode,"compositionend",(function(X){if(ie._lastTextAreaEvent=3,m(X.locale)){var $=h(!1,!1),J=$[0],ee=$[1];ie._textAreaState=J,ie._onType.fire(ee)}else{var te=g(X.data);J=te[0],ee=te[1];ie._textAreaState=J,ie._onType.fire(ee)}(Q.isEdgeOrIE||Q.isChrome)&&(ie._textAreaState=se.TextAreaState.readFromTextArea(ie._textArea)),ie._isDoingComposition&&(ie._isDoingComposition=!1,ie._onCompositionEnd.fire())}))),ie._register(J.addDisposableListener(te.domNode,"input",(function(){var X=8===ie._lastTextAreaEvent;if(ie._lastTextAreaEvent=4,ie._textArea.setIgnoreSelectionChangeTime("received input event"),!ie._isDoingComposition){var $=h(oe.isMacintosh,X&&oe.isMacintosh),Q=$[0],J=$[1];0===J.replaceCharCnt&&1===J.text.length&&re.isHighSurrogate(J.text.charCodeAt(0))||(ie._textAreaState=Q,0===ie._nextCommand?""!==J.text&&ie._onType.fire(J):(""!==J.text&&ie._onPaste.fire({text:J.text}),ie._nextCommand=0))}}))),ie._register(J.addDisposableListener(te.domNode,"cut",(function(X){ie._lastTextAreaEvent=5,ie._textArea.setIgnoreSelectionChangeTime("received cut event"),ie._ensureClipboardGetsEditorSelection(X),ie._asyncTriggerCut.schedule()}))),ie._register(J.addDisposableListener(te.domNode,"copy",(function(X){ie._lastTextAreaEvent=6,ie._ensureClipboardGetsEditorSelection(X)}))),ie._register(J.addDisposableListener(te.domNode,"paste",(function(X){if(ie._lastTextAreaEvent=7,ie._textArea.setIgnoreSelectionChangeTime("received paste event"),ue.canUseTextData(X)){var $=ue.getTextData(X);""!==$&&ie._onPaste.fire({text:$})}else ie._textArea.getSelectionStart()!==ie._textArea.getSelectionEnd()&&ie._setAndWriteTextAreaState("paste",se.TextAreaState.EMPTY),ie._nextCommand=1}))),ie._register(J.addDisposableListener(te.domNode,"focus",(function(){ie._lastTextAreaEvent=8,ie._setHasFocus(!0)}))),ie._register(J.addDisposableListener(te.domNode,"blur",(function(){ie._lastTextAreaEvent=9,ie._setHasFocus(!1)})));var le=0;return ie._register(J.addDisposableListener(document,"selectionchange",(function(X){if(ie._hasFocus&&!ie._isDoingComposition&&Q.isChrome&&oe.isWindows){var $=Date.now(),J=$-le;if(le=$,!(J<5)){var ee=$-ie._textArea.getIgnoreSelectionChangeTime();if(ie._textArea.resetSelectionChangeTime(),!(ee<100)&&ie._textAreaState.selectionStartPosition&&ie._textAreaState.selectionEndPosition){var te=ie._textArea.getValue();if(ie._textAreaState.value===te){var ne=ie._textArea.getSelectionStart(),re=ie._textArea.getSelectionEnd();if(ie._textAreaState.selectionStart!==ne||ie._textAreaState.selectionEnd!==re){var se=ie._textAreaState.deduceEditorPosition(ne),ue=ie._host.deduceModelPosition(se[0],se[1],se[2]),de=ie._textAreaState.deduceEditorPosition(re),ce=ie._host.deduceModelPosition(de[0],de[1],de[2]),he=new ae.Selection(ue.lineNumber,ue.column,ce.lineNumber,ce.column);ie._onSelectionChangeRequest.fire(he)}}}}}}))),ie}return te(a,X),a.prototype.dispose=function(){X.prototype.dispose.call(this)},a.prototype.focusTextArea=function(){this._setHasFocus(!0)},a.prototype.isFocused=function(){return this._hasFocus},a.prototype._setHasFocus=function(X){this._hasFocus!==X&&(this._hasFocus=X,this._hasFocus&&(Q.isEdge?this._setAndWriteTextAreaState("focusgain",se.TextAreaState.EMPTY):this.writeScreenReaderContent("focusgain")),this._hasFocus?this._onFocus.fire():this._onBlur.fire())},a.prototype._setAndWriteTextAreaState=function(X,$){this._hasFocus||($=$.collapseSelection()),$.writeToTextArea(X,this._textArea,this._hasFocus),this._textAreaState=$},a.prototype.writeScreenReaderContent=function(X){this._isDoingComposition||this._setAndWriteTextAreaState(X,this._host.getScreenReaderContent(this._textAreaState))},a.prototype._ensureClipboardGetsEditorSelection=function(X){var J=this._host.getPlainTextToCopy();if(ue.canUseTextData(X)){var ee=null;Q.hasClipboardSupport()&&(J.length<65536||$.CopyOptions.forceCopyWithSyntaxHighlighting)&&(ee=this._host.getHTMLToCopy()),ue.setTextData(X,J,ee)}else this._setAndWriteTextAreaState("copy or cut",se.TextAreaState.selectedText(J))},a}(ie.Disposable);$.TextAreaInput=le;var ue=function(){function e(){}return e.canUseTextData=function(X){return!!X.clipboardData||!!window.clipboardData},e.getTextData=function(X){if(X.clipboardData)return X.preventDefault(),X.clipboardData.getData("text/plain");if(window.clipboardData)return X.preventDefault(),window.clipboardData.getData("Text");throw new Error("ClipboardEventUtils.getTextData: Cannot use text data!")},e.setTextData=function(X,$,Q){if(X.clipboardData)return X.clipboardData.setData("text/plain",$),null!==Q&&X.clipboardData.setData("text/html",Q),void X.preventDefault();if(window.clipboardData)return window.clipboardData.setData("Text",$),void X.preventDefault();throw new Error("ClipboardEventUtils.setTextData: Cannot use text data!")},e}(),de=function(X){function t($){var Q=X.call(this)||this;return Q._actual=$,Q._ignoreSelectionChangeTime=0,Q}return te(t,X),t.prototype.setIgnoreSelectionChangeTime=function(X){this._ignoreSelectionChangeTime=Date.now()},t.prototype.getIgnoreSelectionChangeTime=function(){return this._ignoreSelectionChangeTime},t.prototype.resetSelectionChangeTime=function(){this._ignoreSelectionChangeTime=0},t.prototype.getValue=function(){return this._actual.domNode.value},t.prototype.setValue=function(X,$){var Q=this._actual.domNode;Q.value!==$&&(this.setIgnoreSelectionChangeTime("setValue"),Q.value=$)},t.prototype.getSelectionStart=function(){return this._actual.domNode.selectionStart},t.prototype.getSelectionEnd=function(){return this._actual.domNode.selectionEnd},t.prototype.setSelectionRange=function(X,$,ee){var te=this._actual.domNode,ne=document.activeElement===te,ie=te.selectionStart,oe=te.selectionEnd;if(ne&&ie===$&&oe===ee)Q.isFirefox&&window.parent!==window&&te.focus();else{if(ne)return this.setIgnoreSelectionChangeTime("setSelectionRange"),te.setSelectionRange($,ee),void(Q.isFirefox&&window.parent!==window&&te.focus());try{var re=J.saveParentsScrollTop(te);this.setIgnoreSelectionChangeTime("setSelectionRange"),te.focus(),te.setSelectionRange($,ee),J.restoreParentsScrollTop(te,re)}catch(X){}}},t}(ie.Disposable)})),define(Q[77],n([0,1,21]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(){function e(X,$,Q){void 0===Q&&(Q=!1),this._range=X,this._text=$,this.insertsAutoWhitespace=Q}return e.prototype.getEditOperations=function(X,$){$.addTrackedEditOperation(this._range,this._text)},e.prototype.computeCursorState=function(X,$){var J=$.getInverseEditOperations()[0].range;return new Q.Selection(J.endLineNumber,J.endColumn,J.endLineNumber,J.endColumn)},e}();$.ReplaceCommand=J;var ee=function(){function e(X,$,Q){void 0===Q&&(Q=!1),this._range=X,this._text=$,this.insertsAutoWhitespace=Q}return e.prototype.getEditOperations=function(X,$){$.addTrackedEditOperation(this._range,this._text)},e.prototype.computeCursorState=function(X,$){var J=$.getInverseEditOperations()[0].range;return new Q.Selection(J.startLineNumber,J.startColumn,J.startLineNumber,J.startColumn)},e}();$.ReplaceCommandWithoutChangingPosition=ee;var te=function(){function e(X,$,Q,J,ee){void 0===ee&&(ee=!1),this._range=X,this._text=$,this._columnDeltaOffset=J,this._lineNumberDeltaOffset=Q,this.insertsAutoWhitespace=ee}return e.prototype.getEditOperations=function(X,$){$.addTrackedEditOperation(this._range,this._text)},e.prototype.computeCursorState=function(X,$){var J=$.getInverseEditOperations()[0].range;return new Q.Selection(J.endLineNumber+this._lineNumberDeltaOffset,J.endColumn+this._columnDeltaOffset,J.endLineNumber+this._lineNumberDeltaOffset,J.endColumn+this._columnDeltaOffset)},e}();$.ReplaceCommandWithOffsetCursorState=te;var ne=function(){function e(X,$,Q){this._range=X,this._text=$,this._initialSelection=Q}return e.prototype.getEditOperations=function(X,$){$.addEditOperation(this._range,this._text),this._selectionId=$.trackSelection(this._initialSelection)},e.prototype.computeCursorState=function(X,$){return $.getTrackedSelection(this._selectionId)},e}();$.ReplaceCommandThatPreservesSelection=ne})),define(Q[432],n([0,1,3,21]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(){function e(X,$,Q){this._range=X,this._charBeforeSelection=$,this._charAfterSelection=Q}return e.prototype.getEditOperations=function(X,$){$.addTrackedEditOperation(new Q.Range(this._range.startLineNumber,this._range.startColumn,this._range.startLineNumber,this._range.startColumn),this._charBeforeSelection),$.addTrackedEditOperation(new Q.Range(this._range.endLineNumber,this._range.endColumn,this._range.endLineNumber,this._range.endColumn),this._charAfterSelection)},e.prototype.computeCursorState=function(X,$){var Q=$.getInverseEditOperations(),ee=Q[0].range,te=Q[1].range;return new J.Selection(ee.endLineNumber,ee.endColumn,te.endLineNumber,te.endColumn-this._charAfterSelection.length)},e}();$.SurroundSelectionCommand=ee})),define(Q[121],n([0,1,8]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),"undefined"!=typeof TextDecoder?$.createStringBuilder=function(X){return new J(X)}:$.createStringBuilder=function(X){return new ee};var J=function(){function e(X){this._decoder=new TextDecoder("UTF-16LE"),this._capacity=0|X,this._buffer=new Uint16Array(this._capacity),this._completedStrings=null,this._bufferLength=0}return e.prototype.reset=function(){this._completedStrings=null,this._bufferLength=0},e.prototype.build=function(){return null!==this._completedStrings?(this._flushBuffer(),this._completedStrings.join("")):this._buildBuffer()},e.prototype._buildBuffer=function(){if(0===this._bufferLength)return"";var X=new Uint16Array(this._buffer.buffer,0,this._bufferLength);return this._decoder.decode(X)},e.prototype._flushBuffer=function(){var X=this._buildBuffer();this._bufferLength=0,null===this._completedStrings?this._completedStrings=[X]:this._completedStrings[this._completedStrings.length]=X},e.prototype.write1=function(X){var $=this._capacity-this._bufferLength;$<=1&&(0===$||Q.isHighSurrogate(X))&&this._flushBuffer(),this._buffer[this._bufferLength++]=X},e.prototype.appendASCII=function(X){this._bufferLength===this._capacity&&this._flushBuffer(),this._buffer[this._bufferLength++]=X},e.prototype.appendASCIIString=function(X){var $=X.length;if(this._bufferLength+$>=this._capacity)return this._flushBuffer(),void(this._completedStrings[this._completedStrings.length]=X);for(var Q=0;Q<$;Q++)this._buffer[this._bufferLength++]=X.charCodeAt(Q)},e}(),ee=function(){function e(){this._pieces=[],this._piecesLen=0}return e.prototype.reset=function(){this._pieces=[],this._piecesLen=0},e.prototype.build=function(){return this._pieces.join("")},e.prototype.write1=function(X){this._pieces[this._piecesLen++]=String.fromCharCode(X)},e.prototype.appendASCII=function(X){this._pieces[this._piecesLen++]=String.fromCharCode(X)},e.prototype.appendASCIIString=function(X){this._pieces[this._piecesLen++]=X},e}()})),define(Q[127],n([0,1,23,121]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(){function e(X){this._createLine=X,this._set(1,[])}return e.prototype.flush=function(){this._set(1,[])},e.prototype._set=function(X,$){this._lines=$,this._rendLineNumberStart=X},e.prototype._get=function(){return{rendLineNumberStart:this._rendLineNumberStart,lines:this._lines}},e.prototype.getStartLineNumber=function(){return this._rendLineNumberStart},e.prototype.getEndLineNumber=function(){return this._rendLineNumberStart+this._lines.length-1},e.prototype.getCount=function(){return this._lines.length},e.prototype.getLine=function(X){var $=X-this._rendLineNumberStart;if($<0||$>=this._lines.length)throw new Error("Illegal value for lineNumber");return this._lines[$]},e.prototype.onLinesDeleted=function(X,$){if(0===this.getCount())return null;var Q=this.getStartLineNumber(),J=this.getEndLineNumber();if($<Q){var ee=$-X+1;return this._rendLineNumberStart-=ee,null}if(X>J)return null;for(var te=0,ne=0,ie=Q;ie<=J;ie++){var oe=ie-this._rendLineNumberStart;X<=ie&&ie<=$&&(0===ne?(te=oe,ne=1):ne++)}if(X<Q){var re;re=$<Q?$-X+1:Q-X,this._rendLineNumberStart-=re}return this._lines.splice(te,ne)},e.prototype.onLinesChanged=function(X,$){if(0===this.getCount())return!1;for(var Q=this.getStartLineNumber(),J=this.getEndLineNumber(),ee=!1,te=X;te<=$;te++)te>=Q&&te<=J&&(this._lines[te-this._rendLineNumberStart].onContentChanged(),ee=!0);return ee},e.prototype.onLinesInserted=function(X,$){if(0===this.getCount())return null;var Q=$-X+1,J=this.getStartLineNumber(),ee=this.getEndLineNumber();if(X<=J)return this._rendLineNumberStart+=Q,null;if(X>ee)return null;if(Q+X>ee)return this._lines.splice(X-this._rendLineNumberStart,ee-X+1);for(var te=[],ne=0;ne<Q;ne++)te[ne]=this._createLine();var ie=X-this._rendLineNumberStart,oe=this._lines.slice(0,ie),re=this._lines.slice(ie,this._lines.length-Q),se=this._lines.slice(this._lines.length-Q,this._lines.length);return this._lines=oe.concat(te).concat(re),se},e.prototype.onTokensChanged=function(X){if(0===this.getCount())return!1;for(var $=this.getStartLineNumber(),Q=this.getEndLineNumber(),J=!1,ee=0,te=X.length;ee<te;ee++){var ne=X[ee];if(!(ne.toLineNumber<$||ne.fromLineNumber>Q))for(var ie=Math.max($,ne.fromLineNumber),oe=Math.min(Q,ne.toLineNumber),re=ie;re<=oe;re++){var se=re-this._rendLineNumberStart;this._lines[se].onTokensChanged(),J=!0}}return J},e}();$.RenderedLinesCollection=ee;var te=function(){function e(X){var $=this;this._host=X,this.domNode=this._createDomNode(),this._linesCollection=new ee((function(){return $._host.createVisibleLine()}))}return e.prototype._createDomNode=function(){var X=Q.createFastDomNode(document.createElement("div"));return X.setClassName("view-layer"),X.setPosition("absolute"),X.domNode.setAttribute("role","presentation"),X.domNode.setAttribute("aria-hidden","true"),X},e.prototype.onConfigurationChanged=function(X){return X.layoutInfo},e.prototype.onFlushed=function(X){return this._linesCollection.flush(),!0},e.prototype.onLinesChanged=function(X){return this._linesCollection.onLinesChanged(X.fromLineNumber,X.toLineNumber)},e.prototype.onLinesDeleted=function(X){var $=this._linesCollection.onLinesDeleted(X.fromLineNumber,X.toLineNumber);if($)for(var Q=0,J=$.length;Q<J;Q++){var ee=$[Q].getDomNode();ee&&this.domNode.domNode.removeChild(ee)}return!0},e.prototype.onLinesInserted=function(X){var $=this._linesCollection.onLinesInserted(X.fromLineNumber,X.toLineNumber);if($)for(var Q=0,J=$.length;Q<J;Q++){var ee=$[Q].getDomNode();ee&&this.domNode.domNode.removeChild(ee)}return!0},e.prototype.onScrollChanged=function(X){return X.scrollTopChanged},e.prototype.onTokensChanged=function(X){return this._linesCollection.onTokensChanged(X.ranges)},e.prototype.onZonesChanged=function(X){return!0},e.prototype.getStartLineNumber=function(){return this._linesCollection.getStartLineNumber()},e.prototype.getEndLineNumber=function(){return this._linesCollection.getEndLineNumber()},e.prototype.getVisibleLine=function(X){return this._linesCollection.getLine(X)},e.prototype.renderLines=function(X){var $=this._linesCollection._get(),Q=new ne(this.domNode.domNode,this._host,X),J={rendLineNumberStart:$.rendLineNumberStart,lines:$.lines,linesLength:$.lines.length},ee=Q.render(J,X.startLineNumber,X.endLineNumber,X.relativeVerticalOffset);this._linesCollection._set(ee.rendLineNumberStart,ee.lines)},e}();$.VisibleLinesCollection=te;var ne=function(){function e(X,$,Q){this.domNode=X,this.host=$,this.viewportData=Q}return e.prototype.render=function(X,$,Q,J){var ee={rendLineNumberStart:X.rendLineNumberStart,lines:X.lines.slice(0),linesLength:X.linesLength};if(ee.rendLineNumberStart+ee.linesLength-1<$||Q<ee.rendLineNumberStart){ee.rendLineNumberStart=$,ee.linesLength=Q-$+1,ee.lines=[];for(var te=$;te<=Q;te++)ee.lines[te-$]=this.host.createVisibleLine();return this._finishRendering(ee,!0,J),ee}if(this._renderUntouchedLines(ee,Math.max($-ee.rendLineNumberStart,0),Math.min(Q-ee.rendLineNumberStart,ee.linesLength-1),J,$),ee.rendLineNumberStart>$?(ne=$)<=(ie=Math.min(Q,ee.rendLineNumberStart-1))&&(this._insertLinesBefore(ee,ne,ie,J,$),ee.linesLength+=ie-ne+1):ee.rendLineNumberStart<$&&(oe=Math.min(ee.linesLength,$-ee.rendLineNumberStart))>0&&(this._removeLinesBefore(ee,oe),ee.linesLength-=oe),ee.rendLineNumberStart=$,ee.rendLineNumberStart+ee.linesLength-1<Q)(ne=ee.rendLineNumberStart+ee.linesLength)<=(ie=Q)&&(this._insertLinesAfter(ee,ne,ie,J,$),ee.linesLength+=ie-ne+1);else if(ee.rendLineNumberStart+ee.linesLength-1>Q){var ne=Math.max(0,Q-ee.rendLineNumberStart+1),ie=ee.linesLength-1,oe=ie-ne+1;oe>0&&(this._removeLinesAfter(ee,oe),ee.linesLength-=oe)}return this._finishRendering(ee,!1,J),ee},e.prototype._renderUntouchedLines=function(X,$,Q,J,ee){for(var te=X.rendLineNumberStart,ne=X.lines,ie=$;ie<=Q;ie++){var oe=te+ie;ne[ie].layoutLine(oe,J[oe-ee])}},e.prototype._insertLinesBefore=function(X,$,Q,J,ee){for(var te=[],ne=0,ie=$;ie<=Q;ie++)te[ne++]=this.host.createVisibleLine();X.lines=te.concat(X.lines)},e.prototype._removeLinesBefore=function(X,$){for(var Q=0;Q<$;Q++){var J=X.lines[Q].getDomNode();J&&this.domNode.removeChild(J)}X.lines.splice(0,$)},e.prototype._insertLinesAfter=function(X,$,Q,J,ee){for(var te=[],ne=0,ie=$;ie<=Q;ie++)te[ne++]=this.host.createVisibleLine();X.lines=X.lines.concat(te)},e.prototype._removeLinesAfter=function(X,$){for(var Q=X.linesLength-$,J=0;J<$;J++){var ee=X.lines[Q+J].getDomNode();ee&&this.domNode.removeChild(ee)}X.lines.splice(Q,$)},e.prototype._finishRenderingNewLines=function(X,$,Q,J){var ee=this.domNode.lastChild;$||!ee?this.domNode.innerHTML=Q:ee.insertAdjacentHTML("afterend",Q);for(var te=this.domNode.lastChild,ne=X.linesLength-1;ne>=0;ne--){var ie=X.lines[ne];J[ne]&&(ie.setDomNode(te),te=te.previousSibling)}},e.prototype._finishRenderingInvalidLines=function(X,$,Q){var J=document.createElement("div");J.innerHTML=$;for(var ee=0;ee<X.linesLength;ee++){var te=X.lines[ee];if(Q[ee]){var ne=J.firstChild,ie=te.getDomNode();ie.parentNode.replaceChild(ne,ie),te.setDomNode(ne)}}},e.prototype._finishRendering=function(X,$,Q){var J=e._sb,ee=X.linesLength,te=X.lines,ne=X.rendLineNumberStart,ie=[];J.reset();for(var oe=!1,re=0;re<ee;re++)le=te[re],ie[re]=!1,le.getDomNode()||(ue=le.renderLine(re+ne,Q[re],this.viewportData,J))&&(ie[re]=!0,oe=!0);oe&&this._finishRenderingNewLines(X,$,J.build(),ie),J.reset();var se=!1,ae=[];for(re=0;re<ee;re++){var le=te[re];if(ae[re]=!1,!ie[re]){var ue=le.renderLine(re+ne,Q[re],this.viewportData,J);ue&&(ae[re]=!0,se=!0)}}se&&this._finishRenderingInvalidLines(X,J.build(),ae)},e._sb=J.createStringBuilder(1e5),e}()})),define(Q[91],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q=function(){function e(X,$,Q){this.offset=0|X,this.type=$,this.language=Q}return e.prototype.toString=function(){return"("+this.offset+", "+this.type+")"},e}();$.Token=Q;var i=function(X,$){this.tokens=X,this.endState=$};$.TokenizationResult=i;var o=function(X,$){this.tokens=X,this.endState=$};$.TokenizationResult2=o})),define(Q[101],n([0,1]),(function(X,$){function n(X){return X<0?0:X>4294967295?4294967295:0|X}Object.defineProperty($,"__esModule",{value:!0});var Q=function(){function e(X,$,Q){for(var J=new Uint8Array(X*$),ee=0,te=X*$;ee<te;ee++)J[ee]=Q;this._data=J,this.rows=X,this.cols=$}return e.prototype.get=function(X,$){return this._data[X*this.cols+$]},e.prototype.set=function(X,$,Q){this._data[X*this.cols+$]=Q},e}();$.Uint8Matrix=Q,$.toUint8=function(X){return X<0?0:X>255?255:0|X},$.toUint32=n,$.toUint32Array=function(X){for(var $=X.length,Q=new Uint32Array($),J=0;J<$;J++)Q[J]=n(X[J]);return Q}})),define(Q[81],n([0,1,101]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(){function e(X){var $=Q.toUint8(X);this._defaultValue=$,this._asciiMap=e._createAsciiMap($),this._map=new Map}return e._createAsciiMap=function(X){for(var $=new Uint8Array(256),Q=0;Q<256;Q++)$[Q]=X;return $},e.prototype.set=function(X,$){var J=Q.toUint8($);X>=0&&X<256?this._asciiMap[X]=J:this._map.set(X,J)},e.prototype.get=function(X){return X>=0&&X<256?this._asciiMap[X]:this._map.get(X)||this._defaultValue},e}();$.CharacterClassifier=J;var ee=function(){function e(){this._actual=new J(0)}return e.prototype.add=function(X){this._actual.set(X,1)},e.prototype.has=function(X){return 1===this._actual.get(X)},e}();$.CharacterSet=ee})),define(Q[80],n([0,1,81]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(X){function t($){for(var Q=X.call(this,0)||this,J=0,ee=$.length;J<ee;J++)Q.set($.charCodeAt(J),2);return Q.set(32,1),Q.set(9,1),Q}return te(t,X),t}(Q.CharacterClassifier);$.WordCharacterClassifier=J,$.getMapForWordSeparators=function(X){var $={};return function(X){return $.hasOwnProperty(X)||($[X]=function(X){return new J(X)}(X)),$[X]}}()})),define(Q[453],n([0,1,130,8]),(function(X,$,Q,J){function o(X,$,J,ee){return new Q.LcsDiff(X,$,J).ComputeDiff(ee)}Object.defineProperty($,"__esModule",{value:!0});var ee=function(){function e(X){for(var $=[],Q=[],J=0,ee=X.length;J<ee;J++)$[J]=e._getFirstNonBlankColumn(X[J],1),Q[J]=e._getLastNonBlankColumn(X[J],1);this._lines=X,this._startColumns=$,this._endColumns=Q}return e.prototype.getLength=function(){return this._lines.length},e.prototype.getElementAtIndex=function(X){return this._lines[X].substring(this._startColumns[X]-1,this._endColumns[X]-1)},e.prototype.getStartLineNumber=function(X){return X+1},e.prototype.getEndLineNumber=function(X){return X+1},e._getFirstNonBlankColumn=function(X,$){var Q=J.firstNonWhitespaceIndex(X);return-1===Q?$:Q+1},e._getLastNonBlankColumn=function(X,$){var Q=J.lastNonWhitespaceIndex(X);return-1===Q?$:Q+2},e.prototype.getCharSequence=function(X,$,Q){for(var J=[],ee=[],ne=[],ie=0,oe=$;oe<=Q;oe++)for(var re=this._lines[oe],se=X?this._startColumns[oe]:1,ae=X?this._endColumns[oe]:re.length+1,le=se;le<ae;le++)J[ie]=re.charCodeAt(le-1),ee[ie]=oe+1,ne[ie]=le,ie++;return new te(J,ee,ne)},e}(),te=function(){function e(X,$,Q){this._charCodes=X,this._lineNumbers=$,this._columns=Q}return e.prototype.getLength=function(){return this._charCodes.length},e.prototype.getElementAtIndex=function(X){return this._charCodes[X]},e.prototype.getStartLineNumber=function(X){return this._lineNumbers[X]},e.prototype.getStartColumn=function(X){return this._columns[X]},e.prototype.getEndLineNumber=function(X){return this._lineNumbers[X]},e.prototype.getEndColumn=function(X){return this._columns[X]+1},e}(),ne=function(){function e(X,$,Q,J,ee,te,ne,ie){this.originalStartLineNumber=X,this.originalStartColumn=$,this.originalEndLineNumber=Q,this.originalEndColumn=J,this.modifiedStartLineNumber=ee,this.modifiedStartColumn=te,this.modifiedEndLineNumber=ne,this.modifiedEndColumn=ie}return e.createFromDiffChange=function(X,$,Q){var J,ee,te,ne,ie,oe,re,se;return 0===X.originalLength?(J=0,ee=0,te=0,ne=0):(J=$.getStartLineNumber(X.originalStart),ee=$.getStartColumn(X.originalStart),te=$.getEndLineNumber(X.originalStart+X.originalLength-1),ne=$.getEndColumn(X.originalStart+X.originalLength-1)),0===X.modifiedLength?(ie=0,oe=0,re=0,se=0):(ie=Q.getStartLineNumber(X.modifiedStart),oe=Q.getStartColumn(X.modifiedStart),re=Q.getEndLineNumber(X.modifiedStart+X.modifiedLength-1),se=Q.getEndColumn(X.modifiedStart+X.modifiedLength-1)),new e(J,ee,te,ne,ie,oe,re,se)},e}(),ie=function(){function e(X,$,Q,J,ee){this.originalStartLineNumber=X,this.originalEndLineNumber=$,this.modifiedStartLineNumber=Q,this.modifiedEndLineNumber=J,this.charChanges=ee}return e.createFromDiffResult=function(X,$,Q,J,ee,te,ie){var oe,re,se,ae,le=void 0;if(0===$.originalLength?(oe=Q.getStartLineNumber($.originalStart)-1,re=0):(oe=Q.getStartLineNumber($.originalStart),re=Q.getEndLineNumber($.originalStart+$.originalLength-1)),0===$.modifiedLength?(se=J.getStartLineNumber($.modifiedStart)-1,ae=0):(se=J.getStartLineNumber($.modifiedStart),ae=J.getEndLineNumber($.modifiedStart+$.modifiedLength-1)),te&&0!==$.originalLength&&0!==$.modifiedLength&&ee()){var ue=Q.getCharSequence(X,$.originalStart,$.originalStart+$.originalLength-1),de=J.getCharSequence(X,$.modifiedStart,$.modifiedStart+$.modifiedLength-1),ce=o(ue,de,ee,!0);ie&&(ce=function(X){if(X.length<=1)return X;for(var $=[X[0]],Q=$[0],J=1,ee=X.length;J<ee;J++){var te=X[J],ne=te.originalStart-(Q.originalStart+Q.originalLength),ie=te.modifiedStart-(Q.modifiedStart+Q.modifiedLength);Math.min(ne,ie)<3?(Q.originalLength=te.originalStart+te.originalLength-Q.originalStart,Q.modifiedLength=te.modifiedStart+te.modifiedLength-Q.modifiedStart):($.push(te),Q=te)}return $}(ce)),le=[];for(var he=0,pe=ce.length;he<pe;he++)le.push(ne.createFromDiffChange(ce[he],ue,de))}return new e(oe,re,se,ae,le)},e}(),oe=function(){function e(X,$,Q){this.shouldComputeCharChanges=Q.shouldComputeCharChanges,this.shouldPostProcessCharChanges=Q.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=Q.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=Q.shouldMakePrettyDiff,this.maximumRunTimeMs=5e3,this.originalLines=X,this.modifiedLines=$,this.original=new ee(X),this.modified=new ee($)}return e.prototype.computeDiff=function(){if(1===this.original.getLength()&&0===this.original.getElementAtIndex(0).length)return[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.getLength(),charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}];if(1===this.modified.getLength()&&0===this.modified.getElementAtIndex(0).length)return[{originalStartLineNumber:1,originalEndLineNumber:this.original.getLength(),modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}];this.computationStartTime=(new Date).getTime();var X=o(this.original,this.modified,this._continueProcessingPredicate.bind(this),this.shouldMakePrettyDiff);if(this.shouldIgnoreTrimWhitespace){for(var $=[],Q=0,J=X.length;Q<J;Q++)$.push(ie.createFromDiffResult(this.shouldIgnoreTrimWhitespace,X[Q],this.original,this.modified,this._continueProcessingPredicate.bind(this),this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return $}for(var te=[],ne=0,oe=0,re=(Q=-1,X.length);Q<re;Q++){for(var se=Q+1<re?X[Q+1]:null,ae=se?se.originalStart:this.originalLines.length,le=se?se.modifiedStart:this.modifiedLines.length;ne<ae&&oe<le;){var ue=this.originalLines[ne],de=this.modifiedLines[oe];if(ue!==de){for(var ce=ee._getFirstNonBlankColumn(ue,1),he=ee._getFirstNonBlankColumn(de,1);ce>1&&he>1&&(ve=ue.charCodeAt(ce-2))===(_e=de.charCodeAt(he-2));)ce--,he--;(ce>1||he>1)&&this._pushTrimWhitespaceCharChange(te,ne+1,1,ce,oe+1,1,he);for(var pe=ee._getLastNonBlankColumn(ue,1),fe=ee._getLastNonBlankColumn(de,1),ge=ue.length+1,me=de.length+1;pe<ge&&fe<me;){var ve=ue.charCodeAt(pe-1),_e=ue.charCodeAt(fe-1);if(ve!==_e)break;pe++,fe++}(pe<ge||fe<me)&&this._pushTrimWhitespaceCharChange(te,ne+1,pe,ge,oe+1,fe,me)}ne++,oe++}se&&(te.push(ie.createFromDiffResult(this.shouldIgnoreTrimWhitespace,se,this.original,this.modified,this._continueProcessingPredicate.bind(this),this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),ne+=se.originalLength,oe+=se.modifiedLength)}return te},e.prototype._pushTrimWhitespaceCharChange=function(X,$,Q,J,ee,te,oe){if(!this._mergeTrimWhitespaceCharChange(X,$,Q,J,ee,te,oe)){var re=void 0;this.shouldComputeCharChanges&&(re=[new ne($,Q,$,J,ee,te,ee,oe)]),X.push(new ie($,$,ee,ee,re))}},e.prototype._mergeTrimWhitespaceCharChange=function(X,$,Q,J,ee,te,ie){var oe=X.length;if(0===oe)return!1;var re=X[oe-1];return 0!==re.originalEndLineNumber&&0!==re.modifiedEndLineNumber&&re.originalEndLineNumber+1===$&&re.modifiedEndLineNumber+1===ee&&(re.originalEndLineNumber=$,re.modifiedEndLineNumber=ee,this.shouldComputeCharChanges&&re.charChanges.push(new ne($,Q,$,J,ee,te,ee,ie)),!0)},e.prototype._continueProcessingPredicate=function(){return 0===this.maximumRunTimeMs||(new Date).getTime()-this.computationStartTime<this.maximumRunTimeMs},e}();$.DiffComputer=oe})),define(Q[165],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q=function(){function e(X,$,Q,J,ee,te){this.id=X,this.label=$,this.alias=Q,this._precondition=J,this._run=ee,this._contextKeyService=te}return e.prototype.isSupported=function(){return this._contextKeyService.contextMatchesRules(this._precondition)},e.prototype.run=function(){return this.isSupported()&&this._run()||Promise.resolve(void 0)},e}();$.InternalEditorAction=Q})),define(Q[54],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0}),$.isThemeColor=function(X){return X&&"string"==typeof X.id},$.EditorType={ICodeEditor:"vs.editor.ICodeEditor",IDiffEditor:"vs.editor.IDiffEditor"},$.Handler={ExecuteCommand:"executeCommand",ExecuteCommands:"executeCommands",Type:"type",ReplacePreviousChar:"replacePreviousChar",CompositionStart:"compositionStart",CompositionEnd:"compositionEnd",Paste:"paste",Cut:"cut",Undo:"undo",Redo:"redo"}})),define(Q[105],n([0,1,54]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),$.isCodeEditor=function(X){return!(!X||"function"!=typeof X.getEditorType)&&X.getEditorType()===Q.EditorType.ICodeEditor}})),define(Q[44],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0}),function(X){X[X.Left=1]="Left",X[X.Center=2]="Center",X[X.Right=4]="Right",X[X.Full=7]="Full"}($.OverviewRulerLane||($.OverviewRulerLane={}));var Q=function(){function e(X){this.tabSize=0|X.tabSize,this.insertSpaces=Boolean(X.insertSpaces),this.defaultEOL=0|X.defaultEOL,this.trimAutoWhitespace=Boolean(X.trimAutoWhitespace)}return e.prototype.equals=function(X){return this.tabSize===X.tabSize&&this.insertSpaces===X.insertSpaces&&this.defaultEOL===X.defaultEOL&&this.trimAutoWhitespace===X.trimAutoWhitespace},e.prototype.createChangeEvent=function(X){return{tabSize:this.tabSize!==X.tabSize,insertSpaces:this.insertSpaces!==X.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==X.trimAutoWhitespace}},e}();$.TextModelResolvedOptions=Q;var i=function(X,$){this.range=X,this.matches=$};$.FindMatch=i;var o=function(X,$,Q){this.reverseEdits=X,this.changes=$,this.trimAutoWhitespaceLineNumbers=Q};$.ApplyEditsResult=o})),define(Q[471],n([0,1,11]),(function(X,$,Q){function i(X){return"\n"===X.getEOL()?0:1}Object.defineProperty($,"__esModule",{value:!0});var J=function(){function e(X,$){this.beforeVersionId=X,this.beforeCursorState=$,this.afterCursorState=null,this.afterVersionId=-1,this.editOperations=[]}return e.prototype.undo=function(X){for(var $=this.editOperations.length-1;$>=0;$--)this.editOperations[$]={operations:X.applyEdits(this.editOperations[$].operations)}},e.prototype.redo=function(X){for(var $=0;$<this.editOperations.length;$++)this.editOperations[$]={operations:X.applyEdits(this.editOperations[$].operations)}},e}(),ee=function(){function e(X,$){this.beforeVersionId=X,this.beforeCursorState=null,this.afterCursorState=null,this.afterVersionId=-1,this.eol=$}return e.prototype.undo=function(X){var $=i(X);X.setEOL(this.eol),this.eol=$},e.prototype.redo=function(X){var $=i(X);X.setEOL(this.eol),this.eol=$},e}(),te=function(){function e(X){this.model=X,this.currentOpenStackElement=null,this.past=[],this.future=[]}return e.prototype.pushStackElement=function(){null!==this.currentOpenStackElement&&(this.past.push(this.currentOpenStackElement),this.currentOpenStackElement=null)},e.prototype.clear=function(){this.currentOpenStackElement=null,this.past=[],this.future=[]},e.prototype.pushEOL=function(X){this.future=[],this.currentOpenStackElement&&this.pushStackElement();var $=i(this.model),Q=new ee(this.model.getAlternativeVersionId(),$);this.model.setEOL(X),Q.afterVersionId=this.model.getVersionId(),this.currentOpenStackElement=Q,this.pushStackElement()},e.prototype.pushEditOperation=function(X,$,Q){this.future=[];var ee=null;this.currentOpenStackElement&&(this.currentOpenStackElement instanceof J?ee=this.currentOpenStackElement:this.pushStackElement()),this.currentOpenStackElement||(ee=new J(this.model.getAlternativeVersionId(),X),this.currentOpenStackElement=ee);var te={operations:this.model.applyEdits($)};return ee.editOperations.push(te),ee.afterCursorState=e._computeCursorState(Q,te.operations),ee.afterVersionId=this.model.getVersionId(),ee.afterCursorState},e._computeCursorState=function(X,$){try{return X?X($):null}catch(X){return Q.onUnexpectedError(X),null}},e.prototype.undo=function(){if(this.pushStackElement(),this.past.length>0){var X=this.past.pop();try{X.undo(this.model)}catch(X){return Q.onUnexpectedError(X),this.clear(),null}return this.future.push(X),{selections:X.beforeCursorState,recordedVersionId:X.beforeVersionId}}return null},e.prototype.canUndo=function(){return this.past.length>0},e.prototype.redo=function(){if(this.future.length>0){var X=this.future.pop();try{X.redo(this.model)}catch(X){return Q.onUnexpectedError(X),this.clear(),null}return this.past.push(X),{selections:X.afterCursorState,recordedVersionId:X.afterVersionId}}return null},e.prototype.canRedo=function(){return this.future.length>0},e}();$.EditStack=te})),define(Q[472],n([0,1]),(function(X,$){function n(X,$,Q,J,ee){var te;for(ee.spacesDiff=0,ee.looksLikeAlignment=!1,te=0;te<$&&te<J&&(re=X.charCodeAt(te))===(le=Q.charCodeAt(te));te++);for(var ne=0,ie=0,oe=te;oe<$;oe++){var re=X.charCodeAt(oe);32===re?ne++:ie++}var se=0,ae=0;for(oe=te;oe<J;oe++){var le=Q.charCodeAt(oe);32===le?se++:ae++}if(!(ne>0&&ie>0||se>0&&ae>0)){var ue=Math.abs(ie-ae),de=Math.abs(ne-se);if(0===ue)return ee.spacesDiff=de,void(de>0&&0<=se-1&&se-1<X.length&&se<Q.length&&32!==Q.charCodeAt(se)&&32===X.charCodeAt(se-1)&&(ee.looksLikeAlignment=!0));de%ue!=0||(ee.spacesDiff=de/ue)}}Object.defineProperty($,"__esModule",{value:!0});var i=function(){};$.guessIndentation=function(X,$,Q){for(var J=Math.min(X.getLineCount(),1e4),ee=0,te=0,ne="",ie=0,oe=[0,0,0,0,0,0,0,0,0],re=new i,se=1;se<=J;se++){for(var ae=X.getLineLength(se),le=X.getLineContent(se),ue=ae<=65536,de=!1,ce=0,he=0,pe=0,fe=0,ge=ae;fe<ge;fe++){var me=ue?le.charCodeAt(fe):X.getLineCharCode(se,fe);if(9===me)pe++;else{if(32!==me){de=!0,ce=fe;break}he++}}if(de&&(pe>0?ee++:he>1&&te++,n(ne,ie,le,ce,re),!re.looksLikeAlignment)){var ve=re.spacesDiff;ve<=8&&oe[ve]++,ne=le,ie=ce}}var _e=Q;ee!==te&&(_e=ee<te);var ye=$,be=_e?0:.1*J;return[2,4,6,8,3,5,7].forEach((function(X){var $=oe[X];$>be&&(be=$,ye=X)})),{insertSpaces:_e,tabSize:ye}}})),define(Q[479],n([0,1]),(function(X,$){function n(X){return(1&X.metadata)>>>0}function i(X,$){X.metadata=254&X.metadata|$<<0}function o(X){return(2&X.metadata)>>>1==1}function r(X,$){X.metadata=253&X.metadata|($?1:0)<<1}function s(X){return(4&X.metadata)>>>2==1}function a(X,$){X.metadata=251&X.metadata|($?1:0)<<2}function l(X,$){X.metadata=247&X.metadata|($?1:0)<<3}function u(X,$){X.metadata=207&X.metadata|$<<4}function d(X,$){X.metadata=191&X.metadata|($?1:0)<<6}function c(X,$,Q,J){return X<Q||!(X>Q)&&1!==J&&(2===J||$)}function h(X,$,Q,J,ee){var te=function(X){return(48&X.metadata)>>>4}(X),ne=0===te||2===te,ie=1===te||2===te,oe=Q-$,re=J,se=Math.min(oe,re),ae=X.start,le=!1,ue=X.end,de=!1;$<=ae&&ue<=Q&&function(X){return(64&X.metadata)>>>6==1}(X)&&(X.start=$,le=!0,X.end=$,de=!0),ce=ee?1:oe>0?2:0,!le&&c(ae,ne,$,ce)&&(le=!0),!de&&c(ue,ie,$,ce)&&(de=!0),se>0&&!ee&&(ce=oe>re?2:0,!le&&c(ae,ne,$+se,ce)&&(le=!0),!de&&c(ue,ie,$+se,ce)&&(de=!0));var ce=ee?1:0;!le&&c(ae,ne,Q,ce)&&(X.start=$+re,le=!0),!de&&c(ue,ie,Q,ce)&&(X.end=$+re,de=!0);var he=re-oe;le||(X.start=Math.max(0,ae+he),le=!0),de||(X.end=Math.max(0,ue+he),de=!0),X.start>X.end&&(X.end=X.start)}function p(X,Q){if(X.root===$.SENTINEL)return Q.parent=$.SENTINEL,Q.left=$.SENTINEL,Q.right=$.SENTINEL,i(Q,0),X.root=Q,X.root;!function(X,Q){for(var J=0,ee=X.root,te=Q.start,ne=Q.end;;)if(b(te,ne,ee.start+J,ee.end+J)<0){if(ee.left===$.SENTINEL){Q.start-=J,Q.end-=J,Q.maxEnd-=J,ee.left=Q;break}ee=ee.left}else{if(ee.right===$.SENTINEL){Q.start-=J+ee.delta,Q.end-=J+ee.delta,Q.maxEnd-=J+ee.delta,ee.right=Q;break}J+=ee.delta,ee=ee.right}Q.parent=ee,Q.left=$.SENTINEL,Q.right=$.SENTINEL,i(Q,1)}(X,Q),C(Q.parent);for(var J=Q;J!==X.root&&1===n(J.parent);)if(J.parent===J.parent.parent.left)1===n(ee=J.parent.parent.right)?(i(J.parent,0),i(ee,0),i(J.parent.parent,1),J=J.parent.parent):(J===J.parent.right&&m(X,J=J.parent),i(J.parent,0),i(J.parent.parent,1),v(X,J.parent.parent));else{var ee=J.parent.parent.left;1===n(ee)?(i(J.parent,0),i(ee,0),i(J.parent.parent,1),J=J.parent.parent):(J===J.parent.left&&v(X,J=J.parent),i(J.parent,0),i(J.parent.parent,1),m(X,J.parent.parent))}return i(X.root,0),Q}function f(X,Q){var J,ee;if(Q.left===$.SENTINEL?(ee=Q,(J=Q.right).delta+=Q.delta,(J.delta<-1073741824||J.delta>1073741824)&&(X.requestNormalizeDelta=!0),J.start+=Q.delta,J.end+=Q.delta):Q.right===$.SENTINEL?(J=Q.left,ee=Q):((J=(ee=function(X){for(;X.left!==$.SENTINEL;)X=X.left;return X}(Q.right)).right).start+=ee.delta,J.end+=ee.delta,J.delta+=ee.delta,(J.delta<-1073741824||J.delta>1073741824)&&(X.requestNormalizeDelta=!0),ee.start+=Q.delta,ee.end+=Q.delta,ee.delta=Q.delta,(ee.delta<-1073741824||ee.delta>1073741824)&&(X.requestNormalizeDelta=!0)),ee===X.root)return X.root=J,i(J,0),Q.detach(),g(),y(J),void(X.root.parent=$.SENTINEL);var te,ne=1===n(ee);if(ee===ee.parent.left?ee.parent.left=J:ee.parent.right=J,ee===Q?J.parent=ee.parent:(ee.parent===Q?J.parent=ee:J.parent=ee.parent,ee.left=Q.left,ee.right=Q.right,ee.parent=Q.parent,i(ee,n(Q)),Q===X.root?X.root=ee:Q===Q.parent.left?Q.parent.left=ee:Q.parent.right=ee,ee.left!==$.SENTINEL&&(ee.left.parent=ee),ee.right!==$.SENTINEL&&(ee.right.parent=ee)),Q.detach(),ne)return C(J.parent),ee!==Q&&(C(ee),C(ee.parent)),void g();for(C(J),C(J.parent),ee!==Q&&(C(ee),C(ee.parent));J!==X.root&&0===n(J);)J===J.parent.left?(1===n(te=J.parent.right)&&(i(te,0),i(J.parent,1),m(X,J.parent),te=J.parent.right),0===n(te.left)&&0===n(te.right)?(i(te,1),J=J.parent):(0===n(te.right)&&(i(te.left,0),i(te,1),v(X,te),te=J.parent.right),i(te,n(J.parent)),i(J.parent,0),i(te.right,0),m(X,J.parent),J=X.root)):(1===n(te=J.parent.left)&&(i(te,0),i(J.parent,1),v(X,J.parent),te=J.parent.left),0===n(te.left)&&0===n(te.right)?(i(te,1),J=J.parent):(0===n(te.left)&&(i(te.right,0),i(te,1),m(X,te),te=J.parent.left),i(te,n(J.parent)),i(J.parent,0),i(te.left,0),v(X,J.parent),J=X.root));i(J,0),g()}function g(){$.SENTINEL.parent=$.SENTINEL,$.SENTINEL.delta=0,$.SENTINEL.start=0,$.SENTINEL.end=0}function m(X,Q){var J=Q.right;J.delta+=Q.delta,(J.delta<-1073741824||J.delta>1073741824)&&(X.requestNormalizeDelta=!0),J.start+=Q.delta,J.end+=Q.delta,Q.right=J.left,J.left!==$.SENTINEL&&(J.left.parent=Q),J.parent=Q.parent,Q.parent===$.SENTINEL?X.root=J:Q===Q.parent.left?Q.parent.left=J:Q.parent.right=J,J.left=Q,Q.parent=J,y(Q),y(J)}function v(X,Q){var J=Q.left;Q.delta-=J.delta,(Q.delta<-1073741824||Q.delta>1073741824)&&(X.requestNormalizeDelta=!0),Q.start-=J.delta,Q.end-=J.delta,Q.left=J.right,J.right!==$.SENTINEL&&(J.right.parent=Q),J.parent=Q.parent,Q.parent===$.SENTINEL?X.root=J:Q===Q.parent.right?Q.parent.right=J:Q.parent.left=J,J.right=Q,Q.parent=J,y(Q),y(J)}function _(X){var Q=X.end;if(X.left!==$.SENTINEL){var J=X.left.maxEnd;J>Q&&(Q=J)}if(X.right!==$.SENTINEL){var ee=X.right.maxEnd+X.delta;ee>Q&&(Q=ee)}return Q}function y(X){X.maxEnd=_(X)}function C(X){for(;X!==$.SENTINEL;){var Q=_(X);if(X.maxEnd===Q)return;X.maxEnd=Q,X=X.parent}}function b(X,$,Q,J){return X===Q?$-J:X-Q}Object.defineProperty($,"__esModule",{value:!0}),$.getNodeColor=n,$.getNodeIsInOverviewRuler=function(X){return(8&X.metadata)>>>3==1};var Q=function(){function e(X,$,Q){this.metadata=0,this.parent=this,this.left=this,this.right=this,i(this,1),this.start=$,this.end=Q,this.delta=0,this.maxEnd=Q,this.id=X,this.ownerId=0,this.options=null,a(this,!1),u(this,1),l(this,!1),d(this,!1),this.cachedVersionId=0,this.cachedAbsoluteStart=$,this.cachedAbsoluteEnd=Q,this.range=null,r(this,!1)}return e.prototype.reset=function(X,$,Q,J){this.start=$,this.end=Q,this.maxEnd=Q,this.cachedVersionId=X,this.cachedAbsoluteStart=$,this.cachedAbsoluteEnd=Q,this.range=J},e.prototype.setOptions=function(X){this.options=X;var $=this.options.className;a(this,"squiggly-error"===$||"squiggly-warning"===$||"squiggly-info"===$),u(this,this.options.stickiness),l(this,!(!this.options.overviewRuler||!this.options.overviewRuler.color)),d(this,this.options.collapseOnReplaceEdit)},e.prototype.setCachedOffsets=function(X,$,Q){this.cachedVersionId!==Q&&(this.range=null),this.cachedVersionId=Q,this.cachedAbsoluteStart=X,this.cachedAbsoluteEnd=$},e.prototype.detach=function(){this.parent=null,this.left=null,this.right=null},e}();$.IntervalNode=Q,$.SENTINEL=new Q(null,0,0),$.SENTINEL.parent=$.SENTINEL,$.SENTINEL.left=$.SENTINEL,$.SENTINEL.right=$.SENTINEL,i($.SENTINEL,0);var J=function(){function e(){this.root=$.SENTINEL,this.requestNormalizeDelta=!1}return e.prototype.intervalSearch=function(X,Q,J,ee,te){return this.root===$.SENTINEL?[]:function(X,Q,J,ee,te,ne){for(var ie=X.root,oe=0,re=0,se=0,ae=[],le=0;ie!==$.SENTINEL;)if(o(ie))r(ie.left,!1),r(ie.right,!1),ie===ie.parent.right&&(oe-=ie.parent.delta),ie=ie.parent;else{if(!o(ie.left)){if(oe+ie.maxEnd<Q){r(ie,!0);continue}if(ie.left!==$.SENTINEL){ie=ie.left;continue}}if((re=oe+ie.start)>J)r(ie,!0);else{if((se=oe+ie.end)>=Q){ie.setCachedOffsets(re,se,ne);var ue=!0;ee&&ie.ownerId&&ie.ownerId!==ee&&(ue=!1),te&&s(ie)&&(ue=!1),ue&&(ae[le++]=ie)}r(ie,!0),ie.right===$.SENTINEL||o(ie.right)||(oe+=ie.delta,ie=ie.right)}}return r(X.root,!1),ae}(this,X,Q,J,ee,te)},e.prototype.search=function(X,Q,J){return this.root===$.SENTINEL?[]:function(X,Q,J,ee){for(var te=X.root,ne=0,ie=0,oe=0,re=[],se=0;te!==$.SENTINEL;)if(o(te))r(te.left,!1),r(te.right,!1),te===te.parent.right&&(ne-=te.parent.delta),te=te.parent;else if(te.left===$.SENTINEL||o(te.left)){ie=ne+te.start,oe=ne+te.end,te.setCachedOffsets(ie,oe,ee);var ae=!0;Q&&te.ownerId&&te.ownerId!==Q&&(ae=!1),J&&s(te)&&(ae=!1),ae&&(re[se++]=te),r(te,!0),te.right===$.SENTINEL||o(te.right)||(ne+=te.delta,te=te.right)}else te=te.left;return r(X.root,!1),re}(this,X,Q,J)},e.prototype.collectNodesFromOwner=function(X){return function(X,Q){for(var J=X.root,ee=[],te=0;J!==$.SENTINEL;)o(J)?(r(J.left,!1),r(J.right,!1),J=J.parent):J.left===$.SENTINEL||o(J.left)?(J.ownerId===Q&&(ee[te++]=J),r(J,!0),J.right===$.SENTINEL||o(J.right)||(J=J.right)):J=J.left;return r(X.root,!1),ee}(this,X)},e.prototype.collectNodesPostOrder=function(){return function(X){for(var Q=X.root,J=[],ee=0;Q!==$.SENTINEL;)o(Q)?(r(Q.left,!1),r(Q.right,!1),Q=Q.parent):Q.left===$.SENTINEL||o(Q.left)?Q.right===$.SENTINEL||o(Q.right)?(J[ee++]=Q,r(Q,!0)):Q=Q.right:Q=Q.left;return r(X.root,!1),J}(this)},e.prototype.insert=function(X){p(this,X),this._normalizeDeltaIfNecessary()},e.prototype.delete=function(X){f(this,X),this._normalizeDeltaIfNecessary()},e.prototype.resolveNode=function(X,$){for(var Q=X,J=0;X!==this.root;)X===X.parent.right&&(J+=X.parent.delta),X=X.parent;var ee=Q.start+J,te=Q.end+J;Q.setCachedOffsets(ee,te,$)},e.prototype.acceptReplace=function(X,Q,J,ee){for(var te=function(X,Q,J){for(var ee=X.root,te=0,ne=0,ie=0,oe=[],re=0;ee!==$.SENTINEL;)if(o(ee))r(ee.left,!1),r(ee.right,!1),ee===ee.parent.right&&(te-=ee.parent.delta),ee=ee.parent;else{if(!o(ee.left)){if(te+ee.maxEnd<Q){r(ee,!0);continue}if(ee.left!==$.SENTINEL){ee=ee.left;continue}}(ne=te+ee.start)>J?r(ee,!0):((ie=te+ee.end)>=Q&&(ee.setCachedOffsets(ne,ie,0),oe[re++]=ee),r(ee,!0),ee.right===$.SENTINEL||o(ee.right)||(te+=ee.delta,ee=ee.right))}return r(X.root,!1),oe}(this,X,X+Q),ne=0,ie=te.length;ne<ie;ne++)f(this,oe=te[ne]);this._normalizeDeltaIfNecessary(),function(X,Q,J,ee){for(var te=X.root,ne=0,ie=ee-(J-Q);te!==$.SENTINEL;)if(o(te))r(te.left,!1),r(te.right,!1),te===te.parent.right&&(ne-=te.parent.delta),y(te),te=te.parent;else{if(!o(te.left)){if(ne+te.maxEnd<Q){r(te,!0);continue}if(te.left!==$.SENTINEL){te=te.left;continue}}ne+te.start>J?(te.start+=ie,te.end+=ie,te.delta+=ie,(te.delta<-1073741824||te.delta>1073741824)&&(X.requestNormalizeDelta=!0),r(te,!0)):(r(te,!0),te.right===$.SENTINEL||o(te.right)||(ne+=te.delta,te=te.right))}r(X.root,!1)}(this,X,X+Q,J),this._normalizeDeltaIfNecessary();for(ne=0,ie=te.length;ne<ie;ne++){var oe=te[ne];oe.start=oe.cachedAbsoluteStart,oe.end=oe.cachedAbsoluteEnd,h(oe,X,X+Q,J,ee),oe.maxEnd=oe.end,p(this,oe)}this._normalizeDeltaIfNecessary()},e.prototype._normalizeDeltaIfNecessary=function(){this.requestNormalizeDelta&&(this.requestNormalizeDelta=!1,function(X){for(var Q=X.root,J=0;Q!==$.SENTINEL;)Q.left===$.SENTINEL||o(Q.left)?Q.right===$.SENTINEL||o(Q.right)?(Q.start=J+Q.start,Q.end=J+Q.end,Q.delta=0,y(Q),r(Q,!0),r(Q.left,!1),r(Q.right,!1),Q===Q.parent.right&&(J-=Q.parent.delta),Q=Q.parent):(J+=Q.delta,Q=Q.right):Q=Q.left;r(X.root,!1)}(this))},e}();$.IntervalTree=J,$.nodeAcceptEdit=h,$.recomputeMaxEnd=y,$.intervalCompare=b})),define(Q[480],n([0,1]),(function(X,$){function n(X){for(;X.left!==$.SENTINEL;)X=X.left;return X}function i(X){for(;X.right!==$.SENTINEL;)X=X.right;return X}function o(X){return X===$.SENTINEL?0:X.size_left+X.piece.length+o(X.right)}function r(X){return X===$.SENTINEL?0:X.lf_left+X.piece.lineFeedCnt+r(X.right)}function s(){$.SENTINEL.parent=$.SENTINEL}function a(X,Q){var J=Q.right;J.size_left+=Q.size_left+(Q.piece?Q.piece.length:0),J.lf_left+=Q.lf_left+(Q.piece?Q.piece.lineFeedCnt:0),Q.right=J.left,J.left!==$.SENTINEL&&(J.left.parent=Q),J.parent=Q.parent,Q.parent===$.SENTINEL?X.root=J:Q.parent.left===Q?Q.parent.left=J:Q.parent.right=J,J.left=Q,Q.parent=J}function l(X,Q){var J=Q.left;Q.left=J.right,J.right!==$.SENTINEL&&(J.right.parent=Q),J.parent=Q.parent,Q.size_left-=J.size_left+(J.piece?J.piece.length:0),Q.lf_left-=J.lf_left+(J.piece?J.piece.lineFeedCnt:0),Q.parent===$.SENTINEL?X.root=J:Q===Q.parent.right?Q.parent.right=J:Q.parent.left=J,J.right=Q,Q.parent=J}function u(X,Q,J,ee){for(;Q!==X.root&&Q!==$.SENTINEL;)Q.parent.left===Q&&(Q.parent.size_left+=J,Q.parent.lf_left+=ee),Q=Q.parent}function d(X,$){var Q=0,J=0;if($!==X.root){if(0===Q){for(;$!==X.root&&$===$.parent.right;)$=$.parent;if($===X.root)return;Q=o(($=$.parent).left)-$.size_left,J=r($.left)-$.lf_left,$.size_left+=Q,$.lf_left+=J}for(;$!==X.root&&(0!==Q||0!==J);)$.parent.left===$&&($.parent.size_left+=Q,$.parent.lf_left+=J),$=$.parent}}Object.defineProperty($,"__esModule",{value:!0});var Q=function(){function e(X,$){this.piece=X,this.color=$,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}return e.prototype.next=function(){if(this.right!==$.SENTINEL)return n(this.right);for(var X=this;X.parent!==$.SENTINEL&&X.parent.left!==X;)X=X.parent;return X.parent===$.SENTINEL?$.SENTINEL:X.parent},e.prototype.prev=function(){if(this.left!==$.SENTINEL)return i(this.left);for(var X=this;X.parent!==$.SENTINEL&&X.parent.right!==X;)X=X.parent;return X.parent===$.SENTINEL?$.SENTINEL:X.parent},e.prototype.detach=function(){this.parent=null,this.left=null,this.right=null},e}();$.TreeNode=Q,$.SENTINEL=new Q(null,0),$.SENTINEL.parent=$.SENTINEL,$.SENTINEL.left=$.SENTINEL,$.SENTINEL.right=$.SENTINEL,$.SENTINEL.color=0,$.leftest=n,$.righttest=i,$.calculateSize=o,$.calculateLF=r,$.resetSentinel=s,$.leftRotate=a,$.rightRotate=l,$.rbDelete=function(X,Q){var J,ee;if(J=Q.left===$.SENTINEL?(ee=Q).right:Q.right===$.SENTINEL?(ee=Q).left:(ee=n(Q.right)).right,ee===X.root)return X.root=J,J.color=0,Q.detach(),s(),void(X.root.parent=$.SENTINEL);var te=1===ee.color;if(ee===ee.parent.left?ee.parent.left=J:ee.parent.right=J,ee===Q?(J.parent=ee.parent,d(X,J)):(ee.parent===Q?J.parent=ee:J.parent=ee.parent,d(X,J),ee.left=Q.left,ee.right=Q.right,ee.parent=Q.parent,ee.color=Q.color,Q===X.root?X.root=ee:Q===Q.parent.left?Q.parent.left=ee:Q.parent.right=ee,ee.left!==$.SENTINEL&&(ee.left.parent=ee),ee.right!==$.SENTINEL&&(ee.right.parent=ee),ee.size_left=Q.size_left,ee.lf_left=Q.lf_left,d(X,ee)),Q.detach(),J.parent.left===J){var ne=o(J),ie=r(J);if(ne!==J.parent.size_left||ie!==J.parent.lf_left){var oe=ne-J.parent.size_left,re=ie-J.parent.lf_left;J.parent.size_left=ne,J.parent.lf_left=ie,u(X,J.parent,oe,re)}}if(d(X,J.parent),te)s();else{for(var se;J!==X.root&&0===J.color;)J===J.parent.left?(1===(se=J.parent.right).color&&(se.color=0,J.parent.color=1,a(X,J.parent),se=J.parent.right),0===se.left.color&&0===se.right.color?(se.color=1,J=J.parent):(0===se.right.color&&(se.left.color=0,se.color=1,l(X,se),se=J.parent.right),se.color=J.parent.color,J.parent.color=0,se.right.color=0,a(X,J.parent),J=X.root)):(1===(se=J.parent.left).color&&(se.color=0,J.parent.color=1,l(X,J.parent),se=J.parent.left),0===se.left.color&&0===se.right.color?(se.color=1,J=J.parent):(0===se.left.color&&(se.right.color=0,se.color=1,a(X,se),se=J.parent.left),se.color=J.parent.color,J.parent.color=0,se.left.color=0,l(X,J.parent),J=X.root));J.color=0,s()}},$.fixInsert=function(X,$){for(d(X,$);$!==X.root&&1===$.parent.color;)if($.parent===$.parent.parent.left)1===(Q=$.parent.parent.right).color?($.parent.color=0,Q.color=0,$.parent.parent.color=1,$=$.parent.parent):($===$.parent.right&&a(X,$=$.parent),$.parent.color=0,$.parent.parent.color=1,l(X,$.parent.parent));else{var Q=$.parent.parent.left;1===Q.color?($.parent.color=0,Q.color=0,$.parent.parent.color=1,$=$.parent.parent):($===$.parent.left&&l(X,$=$.parent),$.parent.color=0,$.parent.parent.color=1,a(X,$.parent.parent))}X.root.color=0},$.updateTreeMetadata=u,$.recomputeTreeMetadata=d})),define(Q[483],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var n=function(){this.changeType=1};$.ModelRawFlush=n;var i=function(X,$){this.changeType=2,this.lineNumber=X,this.detail=$};$.ModelRawLineChanged=i;var o=function(X,$){this.changeType=3,this.fromLineNumber=X,this.toLineNumber=$};$.ModelRawLinesDeleted=o;var r=function(X,$,Q){this.changeType=4,this.fromLineNumber=X,this.toLineNumber=$,this.detail=Q};$.ModelRawLinesInserted=r;var s=function(){this.changeType=5};$.ModelRawEOLChanged=s;var Q=function(){function e(X,$,Q,J){this.changes=X,this.versionId=$,this.isUndoing=Q,this.isRedoing=J}return e.prototype.containsEvent=function(X){for(var $=0,Q=this.changes.length;$<Q;$++)if(this.changes[$].changeType===X)return!0;return!1},e.merge=function(X,$){return new e([].concat(X.changes).concat($.changes),$.versionId,X.isUndoing||$.isUndoing,X.isRedoing||$.isRedoing)},e}();$.ModelRawContentChangedEvent=Q;var J=function(){function e(X,$){this.rawContentChangedEvent=X,this.contentChangedEvent=$}return e.prototype.merge=function(X){return new e(Q.merge(this.rawContentChangedEvent,X.rawContentChangedEvent),e._mergeChangeEvents(this.contentChangedEvent,X.contentChangedEvent))},e._mergeChangeEvents=function(X,$){return{changes:[].concat(X.changes).concat($.changes),eol:$.eol,versionId:$.versionId,isUndoing:X.isUndoing||$.isUndoing,isRedoing:X.isRedoing||$.isRedoing,isFlush:X.isFlush||$.isFlush}},e}();$.InternalModelContentChangeEvent=J})),define(Q[112],n([0,1,8,80,12,3,44]),(function(X,$,Q,J,ee,te,ne){function a(X){if(!X||0===X.length)return!1;for(var $=0,Q=X.length;$<Q;$++)if(92===X.charCodeAt($)){if(++$>=Q)break;var J=X.charCodeAt($);if(110===J||114===J||87===J)return!0}return!1}function l(X,$,Q){if(!Q)return new ne.FindMatch(X,null);for(var J=[],ee=0,te=$.length;ee<te;ee++)J[ee]=$[ee];return new ne.FindMatch(X,J)}function u(X,$,Q,J,ee){return function(X,$,Q,J,ee){if(0===J)return!0;var te=$.charCodeAt(J-1);if(0!==X.get(te))return!0;if(13===te||10===te)return!0;if(ee>0){var ne=$.charCodeAt(J);if(0!==X.get(ne))return!0}return!1}(X,$,0,J,ee)&&function(X,$,Q,J,ee){if(J+ee===Q)return!0;var te=$.charCodeAt(J+ee);if(0!==X.get(te))return!0;if(13===te||10===te)return!0;if(ee>0){var ne=$.charCodeAt(J+ee-1);if(0!==X.get(ne))return!0}return!1}(X,$,Q,J,ee)}Object.defineProperty($,"__esModule",{value:!0});var ie=function(){function e(X,$,Q,J){this.searchString=X,this.isRegex=$,this.matchCase=Q,this.wordSeparators=J}return e.prototype.parseSearchRequest=function(){if(""===this.searchString)return null;var X;X=this.isRegex?a(this.searchString):this.searchString.indexOf("\n")>=0;var $=null;try{$=Q.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:X,global:!0})}catch(X){return null}if(!$)return null;var ee=!this.isRegex&&!X;return ee&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(ee=this.matchCase),new c($,this.wordSeparators?J.getMapForWordSeparators(this.wordSeparators):null,ee?this.searchString:null)},e}();$.SearchParams=ie,$.isMultilineRegexSource=a;var c=function(X,$,Q){this.regex=X,this.wordSeparators=$,this.simpleSearch=Q};$.SearchData=c,$.createFindMatch=l;var oe=function(){function e(X){for(var $=[],Q=0,J=0,ee=X.length;J<ee;J++)10===X.charCodeAt(J)&&($[Q++]=J);this._lineFeedsOffsets=$}return e.prototype.findLineFeedCountBeforeOffset=function(X){var $=this._lineFeedsOffsets,Q=0,J=$.length-1;if(-1===J)return 0;if(X<=$[0])return 0;for(;Q<J;){var ee=Q+((J-Q)/2>>0);$[ee]>=X?J=ee-1:$[ee+1]>=X?(Q=ee,J=ee):Q=ee+1}return Q+1},e}(),re=function(){function e(){}return e.findMatches=function(X,$,Q,J,ee){var te=$.parseSearchRequest();return te?te.regex.multiline?this._doFindMatchesMultiline(X,Q,new se(te.wordSeparators,te.regex),J,ee):this._doFindMatchesLineByLine(X,Q,te,J,ee):[]},e._getMultilineMatchRange=function(X,$,Q,J,ee,ne){var ie,oe,re=0;if(ie=J?$+ee+(re=J.findLineFeedCountBeforeOffset(ee)):$+ee,J){var se=J.findLineFeedCountBeforeOffset(ee+ne.length)-re;oe=ie+ne.length+se}else oe=ie+ne.length;var ae=X.getPositionAt(ie),le=X.getPositionAt(oe);return new te.Range(ae.lineNumber,ae.column,le.lineNumber,le.column)},e._doFindMatchesMultiline=function(X,$,Q,J,ee){var te,ne=X.getOffsetAt($.getStartPosition()),ie=X.getValueInRange($,1),re="\r\n"===X.getEOL()?new oe(ie):null,se=[],ae=0;for(Q.reset(0);te=Q.next(ie);)if(se[ae++]=l(this._getMultilineMatchRange(X,ne,ie,re,te.index,te[0]),te,J),ae>=ee)return se;return se},e._doFindMatchesLineByLine=function(X,$,Q,J,ee){var te=[],ne=0;if($.startLineNumber===$.endLineNumber){var ie=X.getLineContent($.startLineNumber).substring($.startColumn-1,$.endColumn-1);return ne=this._findMatchesInLine(Q,ie,$.startLineNumber,$.startColumn-1,ne,te,J,ee),te}var oe=X.getLineContent($.startLineNumber).substring($.startColumn-1);ne=this._findMatchesInLine(Q,oe,$.startLineNumber,$.startColumn-1,ne,te,J,ee);for(var re=$.startLineNumber+1;re<$.endLineNumber&&ne<ee;re++)ne=this._findMatchesInLine(Q,X.getLineContent(re),re,0,ne,te,J,ee);if(ne<ee){var se=X.getLineContent($.endLineNumber).substring(0,$.endColumn-1);ne=this._findMatchesInLine(Q,se,$.endLineNumber,0,ne,te,J,ee)}return te},e._findMatchesInLine=function(X,$,Q,J,ee,ie,oe,re){var ae=X.wordSeparators;if(!oe&&X.simpleSearch){for(var le=X.simpleSearch,ue=le.length,de=$.length,ce=-ue;-1!==(ce=$.indexOf(le,ce+ue));)if((!ae||u(ae,$,de,ce,ue))&&(ie[ee++]=new ne.FindMatch(new te.Range(Q,ce+1+J,Q,ce+1+ue+J),null),ee>=re))return ee;return ee}var he,pe=new se(X.wordSeparators,X.regex);pe.reset(0);do{if((he=pe.next($))&&(ie[ee++]=l(new te.Range(Q,he.index+1+J,Q,he.index+1+he[0].length+J),he,oe),ee>=re))return ee}while(he);return ee},e.findNextMatch=function(X,$,Q,J){var ee=$.parseSearchRequest();if(!ee)return null;var te=new se(ee.wordSeparators,ee.regex);return ee.regex.multiline?this._doFindNextMatchMultiline(X,Q,te,J):this._doFindNextMatchLineByLine(X,Q,te,J)},e._doFindNextMatchMultiline=function(X,$,Q,J){var ne=new ee.Position($.lineNumber,1),ie=X.getOffsetAt(ne),re=X.getLineCount(),se=X.getValueInRange(new te.Range(ne.lineNumber,ne.column,re,X.getLineMaxColumn(re)),1),ae="\r\n"===X.getEOL()?new oe(se):null;Q.reset($.column-1);var le=Q.next(se);return le?l(this._getMultilineMatchRange(X,ie,se,ae,le.index,le[0]),le,J):1!==$.lineNumber||1!==$.column?this._doFindNextMatchMultiline(X,new ee.Position(1,1),Q,J):null},e._doFindNextMatchLineByLine=function(X,$,Q,J){var ee=X.getLineCount(),te=$.lineNumber,ne=X.getLineContent(te),ie=this._findFirstMatchInLine(Q,ne,te,$.column,J);if(ie)return ie;for(var oe=1;oe<=ee;oe++){var re=(te+oe-1)%ee,se=X.getLineContent(re+1),ae=this._findFirstMatchInLine(Q,se,re+1,1,J);if(ae)return ae}return null},e._findFirstMatchInLine=function(X,$,Q,J,ee){X.reset(J-1);var ne=X.next($);return ne?l(new te.Range(Q,ne.index+1,Q,ne.index+1+ne[0].length),ne,ee):null},e.findPreviousMatch=function(X,$,Q,J){var ee=$.parseSearchRequest();if(!ee)return null;var te=new se(ee.wordSeparators,ee.regex);return ee.regex.multiline?this._doFindPreviousMatchMultiline(X,Q,te,J):this._doFindPreviousMatchLineByLine(X,Q,te,J)},e._doFindPreviousMatchMultiline=function(X,$,Q,J){var ne=this._doFindMatchesMultiline(X,new te.Range(1,1,$.lineNumber,$.column),Q,J,9990);if(ne.length>0)return ne[ne.length-1];var ie=X.getLineCount();return $.lineNumber!==ie||$.column!==X.getLineMaxColumn(ie)?this._doFindPreviousMatchMultiline(X,new ee.Position(ie,X.getLineMaxColumn(ie)),Q,J):null},e._doFindPreviousMatchLineByLine=function(X,$,Q,J){var ee=X.getLineCount(),te=$.lineNumber,ne=X.getLineContent(te).substring(0,$.column-1),ie=this._findLastMatchInLine(Q,ne,te,J);if(ie)return ie;for(var oe=1;oe<=ee;oe++){var re=(ee+te-oe-1)%ee,se=X.getLineContent(re+1),ae=this._findLastMatchInLine(Q,se,re+1,J);if(ae)return ae}return null},e._findLastMatchInLine=function(X,$,Q,J){var ee,ne=null;for(X.reset(0);ee=X.next($);)ne=l(new te.Range(Q,ee.index+1,Q,ee.index+1+ee[0].length),ee,J);return ne},e}();$.TextModelSearch=re,$.isValidMatch=u;var se=function(){function e(X,$){this._wordSeparators=X,this._searchRegex=$,this._prevMatchStartIndex=-1,this._prevMatchLength=0}return e.prototype.reset=function(X){this._searchRegex.lastIndex=X,this._prevMatchStartIndex=-1,this._prevMatchLength=0},e.prototype.next=function(X){var $,Q=X.length;do{if(this._prevMatchStartIndex+this._prevMatchLength===Q)return null;if(!($=this._searchRegex.exec(X)))return null;var J=$.index,ee=$[0].length;if(J===this._prevMatchStartIndex&&ee===this._prevMatchLength)return null;if(this._prevMatchStartIndex=J,this._prevMatchLength=ee,!this._wordSeparators||u(this._wordSeparators,X,Q,J,ee))return $}while($);return null},e}();$.Searcher=se})),define(Q[172],n([0,1,12,3,44,480,112]),(function(X,$,Q,J,ee,te,ne){function a(X){var $;return($=X[X.length-1]<65536?new Uint16Array(X.length):new Uint32Array(X.length)).set(X,0),$}function l(X,$){void 0===$&&($=!0);for(var Q=[0],J=1,ee=0,te=X.length;ee<te;ee++){var ne=X.charCodeAt(ee);13===ne?ee+1<te&&10===X.charCodeAt(ee+1)?(Q[J++]=ee+2,ee++):Q[J++]=ee+1:10===ne&&(Q[J++]=ee+1)}return $?a(Q):Q}Object.defineProperty($,"__esModule",{value:!0}),$.AverageBufferSize=65535,$.createUintArray=a;var u=function(X,$,Q,J,ee){this.lineStarts=X,this.cr=$,this.lf=Q,this.crlf=J,this.isBasicASCII=ee};$.LineStarts=u,$.createLineStartsFast=l,$.createLineStarts=function(X,$){X.length=0,X[0]=0;for(var Q=1,J=0,ee=0,te=0,ne=!0,ie=0,oe=$.length;ie<oe;ie++){var re=$.charCodeAt(ie);13===re?ie+1<oe&&10===$.charCodeAt(ie+1)?(te++,X[Q++]=ie+2,ie++):(J++,X[Q++]=ie+1):10===re?(ee++,X[Q++]=ie+1):ne&&9!==re&&(re<32||re>126)&&(ne=!1)}var se=new u(a(X),J,ee,te,ne);return X.length=0,se};var d=function(X,$,Q,J,ee){this.bufferIndex=X,this.start=$,this.end=Q,this.lineFeedCnt=J,this.length=ee};$.Piece=d;var c=function(X,$){this.buffer=X,this.lineStarts=$};$.StringBuffer=c;var ie=function(){function e(X){this._limit=X,this._cache=[]}return e.prototype.get=function(X){for(var $=this._cache.length-1;$>=0;$--){var Q=this._cache[$];if(Q.nodeStartOffset<=X&&Q.nodeStartOffset+Q.node.piece.length>=X)return Q}return null},e.prototype.get2=function(X){for(var $=this._cache.length-1;$>=0;$--){var Q=this._cache[$];if(Q.nodeStartLineNumber&&Q.nodeStartLineNumber<X&&Q.nodeStartLineNumber+Q.node.piece.lineFeedCnt>=X)return Q}return null},e.prototype.set=function(X){this._cache.length>=this._limit&&this._cache.shift(),this._cache.push(X)},e.prototype.valdiate=function(X){for(var $=!1,Q=this._cache,J=0;J<Q.length;J++){var ee=Q[J];(null===ee.node.parent||ee.nodeStartOffset>=X)&&(Q[J]=null,$=!0)}if($){var te=[];for(J=0;J<Q.length;J++){var ne=Q[J];null!==ne&&te.push(ne)}this._cache=te}},e}(),oe=function(){function e(X,$,Q){this.create(X,$,Q)}return e.prototype.create=function(X,$,Q){this._buffers=[new c("",[0])],this._lastChangeBufferPos={line:0,column:0},this.root=te.SENTINEL,this._lineCnt=1,this._length=0,this._EOL=$,this._EOLLength=$.length,this._EOLNormalized=Q;for(var J=null,ee=0,ne=X.length;ee<ne;ee++)if(X[ee].buffer.length>0){X[ee].lineStarts||(X[ee].lineStarts=l(X[ee].buffer));var oe=new d(ee+1,{line:0,column:0},{line:X[ee].lineStarts.length-1,column:X[ee].buffer.length-X[ee].lineStarts[X[ee].lineStarts.length-1]},X[ee].lineStarts.length-1,X[ee].buffer.length);this._buffers.push(X[ee]),J=this.rbInsertRight(J,oe)}this._searchCache=new ie(1),this._lastVisitedLine={lineNumber:0,value:""},this.computeBufferMetadata()},e.prototype.normalizeEOL=function(X){var Q=this,J=$.AverageBufferSize,ee=J-Math.floor(J/3),te=2*ee,ne="",ie=0,oe=[];if(this.iterate(this.root,(function($){var J=Q.getNodeContent($),re=J.length;if(ie<=ee||ie+re<te)return ne+=J,ie+=re,!0;var se=ne.replace(/\r\n|\r|\n/g,X);return oe.push(new c(se,l(se))),ne=J,ie=re,!0})),ie>0){var re=ne.replace(/\r\n|\r|\n/g,X);oe.push(new c(re,l(re)))}this.create(oe,X,!0)},e.prototype.getEOL=function(){return this._EOL},e.prototype.setEOL=function(X){this._EOL=X,this._EOLLength=this._EOL.length,this.normalizeEOL(X)},e.prototype.getOffsetAt=function(X,$){for(var Q=0,J=this.root;J!==te.SENTINEL;)if(J.left!==te.SENTINEL&&J.lf_left+1>=X)J=J.left;else{if(J.lf_left+J.piece.lineFeedCnt+1>=X)return(Q+=J.size_left)+(this.getAccumulatedValue(J,X-J.lf_left-2)+$-1);X-=J.lf_left+J.piece.lineFeedCnt,Q+=J.size_left+J.piece.length,J=J.right}return Q},e.prototype.getPositionAt=function(X){X=Math.floor(X),X=Math.max(0,X);for(var $=this.root,J=0,ee=X;$!==te.SENTINEL;)if(0!==$.size_left&&$.size_left>=X)$=$.left;else{if($.size_left+$.piece.length>=X){var ne=this.getIndexOf($,X-$.size_left);return J+=$.lf_left+ne.index,0===ne.index?(oe=ee-(ie=this.getOffsetAt(J+1,1)),new Q.Position(J+1,oe+1)):new Q.Position(J+1,ne.remainder+1)}if(X-=$.size_left+$.piece.length,J+=$.lf_left+$.piece.lineFeedCnt,$.right===te.SENTINEL){var ie=this.getOffsetAt(J+1,1),oe=ee-X-ie;return new Q.Position(J+1,oe+1)}$=$.right}return new Q.Position(1,1)},e.prototype.getValueInRange=function(X,$){if(X.startLineNumber===X.endLineNumber&&X.startColumn===X.endColumn)return"";var Q=this.nodeAt2(X.startLineNumber,X.startColumn),J=this.nodeAt2(X.endLineNumber,X.endColumn),ee=this.getValueInRange2(Q,J);return $?$===this._EOL&&this._EOLNormalized&&$===this.getEOL()&&this._EOLNormalized?ee:ee.replace(/\r\n|\r|\n/g,$):ee},e.prototype.getValueInRange2=function(X,$){if(X.node===$.node){var Q=X.node,J=this._buffers[Q.piece.bufferIndex].buffer,ee=this.offsetInBuffer(Q.piece.bufferIndex,Q.piece.start);return J.substring(ee+X.remainder,ee+$.remainder)}var ne=X.node,ie=this._buffers[ne.piece.bufferIndex].buffer,oe=this.offsetInBuffer(ne.piece.bufferIndex,ne.piece.start),re=ie.substring(oe+X.remainder,oe+ne.piece.length);for(ne=ne.next();ne!==te.SENTINEL;){var se=this._buffers[ne.piece.bufferIndex].buffer,ae=this.offsetInBuffer(ne.piece.bufferIndex,ne.piece.start);if(ne===$.node){re+=se.substring(ae,ae+$.remainder);break}re+=se.substr(ae,ne.piece.length),ne=ne.next()}return re},e.prototype.getLinesContent=function(){return this.getContentOfSubTree(this.root).split(/\r\n|\r|\n/)},e.prototype.getLength=function(){return this._length},e.prototype.getLineCount=function(){return this._lineCnt},e.prototype.getLineContent=function(X){return this._lastVisitedLine.lineNumber===X||(this._lastVisitedLine.lineNumber=X,X===this._lineCnt?this._lastVisitedLine.value=this.getLineRawContent(X):this._EOLNormalized?this._lastVisitedLine.value=this.getLineRawContent(X,this._EOLLength):this._lastVisitedLine.value=this.getLineRawContent(X).replace(/(\r\n|\r|\n)$/,"")),this._lastVisitedLine.value},e.prototype.getLineCharCode=function(X,$){var Q=this.nodeAt2(X,$+1);if(Q.remainder===Q.node.piece.length){var J=Q.node.next();if(!J)return 0;var ee=this._buffers[J.piece.bufferIndex],te=this.offsetInBuffer(J.piece.bufferIndex,J.piece.start);return ee.buffer.charCodeAt(te)}ee=this._buffers[Q.node.piece.bufferIndex];var ne=(te=this.offsetInBuffer(Q.node.piece.bufferIndex,Q.node.piece.start))+Q.remainder;return ee.buffer.charCodeAt(ne)},e.prototype.getLineLength=function(X){if(X===this.getLineCount()){var $=this.getOffsetAt(X,1);return this.getLength()-$}return this.getOffsetAt(X+1,1)-this.getOffsetAt(X,1)-this._EOLLength},e.prototype.findMatchesInNode=function(X,$,Q,ee,te,ie,oe,re,se,ae,le){var ue,de=this._buffers[X.piece.bufferIndex],ce=this.offsetInBuffer(X.piece.bufferIndex,X.piece.start),he=this.offsetInBuffer(X.piece.bufferIndex,te),pe=this.offsetInBuffer(X.piece.bufferIndex,ie);$.reset(he);var fe={line:0,column:0};do{if(ue=$.next(de.buffer)){if(ue.index>=pe)return ae;this.positionInBuffer(X,ue.index-ce,fe);var ge=this.getLineFeedCnt(X.piece.bufferIndex,te,fe),me=fe.line===te.line?fe.column-te.column+ee:fe.column+1,ve=me+ue[0].length;if(le[ae++]=ne.createFindMatch(new J.Range(Q+ge,me,Q+ge,ve),ue,re),ue.index+ue[0].length>=pe)return ae;if(ae>=se)return ae}}while(ue);return ae},e.prototype.findMatchesLineByLine=function(X,$,Q,J){var ee=[],te=0,ie=new ne.Searcher($.wordSeparators,$.regex),oe=this.nodeAt2(X.startLineNumber,X.startColumn);if(null===oe)return[];var re=this.nodeAt2(X.endLineNumber,X.endColumn);if(null===re)return[];var se=this.positionInBuffer(oe.node,oe.remainder),ae=this.positionInBuffer(re.node,re.remainder);if(oe.node===re.node)return this.findMatchesInNode(oe.node,ie,X.startLineNumber,X.startColumn,se,ae,$,Q,J,te,ee),ee;for(var le=X.startLineNumber,ue=oe.node;ue!==re.node;){var de=this.getLineFeedCnt(ue.piece.bufferIndex,se,ue.piece.end);if(de>=1){var ce=this._buffers[ue.piece.bufferIndex].lineStarts,he=this.offsetInBuffer(ue.piece.bufferIndex,ue.piece.start),pe=ce[se.line+de],fe=le===X.startLineNumber?X.startColumn:1;if((te=this.findMatchesInNode(ue,ie,le,fe,se,this.positionInBuffer(ue,pe-he),$,Q,J,te,ee))>=J)return ee;le+=de}var ge=le===X.startLineNumber?X.startColumn-1:0;if(le===X.endLineNumber)return ve=this.getLineContent(le).substring(ge,X.endColumn-1),te=this._findMatchesInLine($,ie,ve,X.endLineNumber,ge,te,ee,Q,J),ee;if((te=this._findMatchesInLine($,ie,this.getLineContent(le).substr(ge),le,ge,te,ee,Q,J))>=J)return ee;le++,ue=(oe=this.nodeAt2(le,1)).node,se=this.positionInBuffer(oe.node,oe.remainder)}if(le===X.endLineNumber){var me=le===X.startLineNumber?X.startColumn-1:0,ve=this.getLineContent(le).substring(me,X.endColumn-1);return te=this._findMatchesInLine($,ie,ve,X.endLineNumber,me,te,ee,Q,J),ee}var _e=le===X.startLineNumber?X.startColumn:1;return te=this.findMatchesInNode(re.node,ie,le,_e,se,ae,$,Q,J,te,ee),ee},e.prototype._findMatchesInLine=function(X,$,Q,te,ie,oe,re,se,ae){var le,ue=X.wordSeparators;if(!se&&X.simpleSearch){for(var de=X.simpleSearch,ce=de.length,he=Q.length,pe=-ce;-1!==(pe=Q.indexOf(de,pe+ce));)if((!ue||ne.isValidMatch(ue,Q,he,pe,ce))&&(re[oe++]=new ee.FindMatch(new J.Range(te,pe+1+ie,te,pe+1+ce+ie),null),oe>=ae))return oe;return oe}$.reset(0);do{if((le=$.next(Q))&&(re[oe++]=ne.createFindMatch(new J.Range(te,le.index+1+ie,te,le.index+1+le[0].length+ie),le,se),oe>=ae))return oe}while(le);return oe},e.prototype.insert=function(X,Q,J){if(void 0===J&&(J=!1),this._EOLNormalized=this._EOLNormalized&&J,this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",this.root!==te.SENTINEL){var ee=this.nodeAt(X),ne=ee.node,ie=ee.remainder,oe=ee.nodeStartOffset,re=ne.piece,se=re.bufferIndex,ae=this.positionInBuffer(ne,ie);if(0===ne.piece.bufferIndex&&re.end.line===this._lastChangeBufferPos.line&&re.end.column===this._lastChangeBufferPos.column&&oe+re.length===X&&Q.length<$.AverageBufferSize)return this.appendToNode(ne,Q),void this.computeBufferMetadata();if(oe===X)this.insertContentToNodeLeft(Q,ne),this._searchCache.valdiate(X);else if(oe+ne.piece.length>X){var le=[],ue=new d(re.bufferIndex,ae,re.end,this.getLineFeedCnt(re.bufferIndex,ae,re.end),this.offsetInBuffer(se,re.end)-this.offsetInBuffer(se,ae));if(this.shouldCheckCRLF()&&this.endWithCR(Q)&&10===this.nodeCharCodeAt(ne,ie)){var de={line:ue.start.line+1,column:0};ue=new d(ue.bufferIndex,de,ue.end,this.getLineFeedCnt(ue.bufferIndex,de,ue.end),ue.length-1),Q+="\n"}if(this.shouldCheckCRLF()&&this.startWithLF(Q))if(13===this.nodeCharCodeAt(ne,ie-1)){var ce=this.positionInBuffer(ne,ie-1);this.deleteNodeTail(ne,ce),Q="\r"+Q,0===ne.piece.length&&le.push(ne)}else this.deleteNodeTail(ne,ae);else this.deleteNodeTail(ne,ae);var he=this.createNewPieces(Q);ue.length>0&&this.rbInsertRight(ne,ue);for(var pe=ne,fe=0;fe<he.length;fe++)pe=this.rbInsertRight(pe,he[fe]);this.deleteNodes(le)}else this.insertContentToNodeRight(Q,ne)}else{var ge=this.createNewPieces(Q);for(ne=this.rbInsertLeft(null,ge[0]),fe=1;fe<ge.length;fe++)ne=this.rbInsertRight(ne,ge[fe])}this.computeBufferMetadata()},e.prototype.delete=function(X,$){if(this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",!($<=0||this.root===te.SENTINEL)){var Q=this.nodeAt(X),J=this.nodeAt(X+$),ee=Q.node,ne=J.node;if(ee===ne){var ie=this.positionInBuffer(ee,Q.remainder),oe=this.positionInBuffer(ee,J.remainder);if(Q.nodeStartOffset===X){if($===ee.piece.length){var re=ee.next();return te.rbDelete(this,ee),this.validateCRLFWithPrevNode(re),void this.computeBufferMetadata()}return this.deleteNodeHead(ee,oe),this._searchCache.valdiate(X),this.validateCRLFWithPrevNode(ee),void this.computeBufferMetadata()}return Q.nodeStartOffset+ee.piece.length===X+$?(this.deleteNodeTail(ee,ie),this.validateCRLFWithNextNode(ee),void this.computeBufferMetadata()):(this.shrinkNode(ee,ie,oe),void this.computeBufferMetadata())}var se=[],ae=this.positionInBuffer(ee,Q.remainder);this.deleteNodeTail(ee,ae),this._searchCache.valdiate(X),0===ee.piece.length&&se.push(ee);var le=this.positionInBuffer(ne,J.remainder);this.deleteNodeHead(ne,le),0===ne.piece.length&&se.push(ne);for(var ue=ee.next();ue!==te.SENTINEL&&ue!==ne;ue=ue.next())se.push(ue);var de=0===ee.piece.length?ee.prev():ee;this.deleteNodes(se),this.validateCRLFWithNextNode(de),this.computeBufferMetadata()}},e.prototype.insertContentToNodeLeft=function(X,$){var Q=[];if(this.shouldCheckCRLF()&&this.endWithCR(X)&&this.startWithLF($)){var J=$.piece,ee={line:J.start.line+1,column:0},ne=new d(J.bufferIndex,ee,J.end,this.getLineFeedCnt(J.bufferIndex,ee,J.end),J.length-1);$.piece=ne,X+="\n",te.updateTreeMetadata(this,$,-1,-1),0===$.piece.length&&Q.push($)}for(var ie=this.createNewPieces(X),oe=this.rbInsertLeft($,ie[ie.length-1]),re=ie.length-2;re>=0;re--)oe=this.rbInsertLeft(oe,ie[re]);this.validateCRLFWithPrevNode(oe),this.deleteNodes(Q)},e.prototype.insertContentToNodeRight=function(X,$){this.adjustCarriageReturnFromNext(X,$)&&(X+="\n");for(var Q=this.createNewPieces(X),J=this.rbInsertRight($,Q[0]),ee=J,te=1;te<Q.length;te++)ee=this.rbInsertRight(ee,Q[te]);this.validateCRLFWithPrevNode(J)},e.prototype.positionInBuffer=function(X,$,Q){for(var J=X.piece,ee=X.piece.bufferIndex,te=this._buffers[ee].lineStarts,ne=te[J.start.line]+J.start.column+$,ie=J.start.line,oe=J.end.line,re=0,se=0,ae=0;ie<=oe&&(ae=te[re=ie+(oe-ie)/2|0],re!==oe);)if(se=te[re+1],ne<ae)oe=re-1;else{if(!(ne>=se))break;ie=re+1}return Q?(Q.line=re,Q.column=ne-ae,null):{line:re,column:ne-ae}},e.prototype.getLineFeedCnt=function(X,$,Q){if(0===Q.column)return Q.line-$.line;var J=this._buffers[X].lineStarts;if(Q.line===J.length-1)return Q.line-$.line;var ee=J[Q.line+1],te=J[Q.line]+Q.column;if(ee>te+1)return Q.line-$.line;var ne=te-1;return 13===this._buffers[X].buffer.charCodeAt(ne)?Q.line-$.line+1:Q.line-$.line},e.prototype.offsetInBuffer=function(X,$){return this._buffers[X].lineStarts[$.line]+$.column},e.prototype.deleteNodes=function(X){for(var $=0;$<X.length;$++)te.rbDelete(this,X[$])},e.prototype.createNewPieces=function(X){if(X.length>$.AverageBufferSize){for(var Q=[];X.length>$.AverageBufferSize;){var J=X.charCodeAt($.AverageBufferSize-1),ee=void 0;13===J||J>=55296&&J<=56319?(ee=X.substring(0,$.AverageBufferSize-1),X=X.substring($.AverageBufferSize-1)):(ee=X.substring(0,$.AverageBufferSize),X=X.substring($.AverageBufferSize));var te=l(ee);Q.push(new d(this._buffers.length,{line:0,column:0},{line:te.length-1,column:ee.length-te[te.length-1]},te.length-1,ee.length)),this._buffers.push(new c(ee,te))}var ne=l(X);return Q.push(new d(this._buffers.length,{line:0,column:0},{line:ne.length-1,column:X.length-ne[ne.length-1]},ne.length-1,X.length)),this._buffers.push(new c(X,ne)),Q}var ie=this._buffers[0].buffer.length,oe=l(X,!1),re=this._lastChangeBufferPos;if(this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-1]===ie&&0!==ie&&this.startWithLF(X)&&this.endWithCR(this._buffers[0].buffer)){for(this._lastChangeBufferPos={line:this._lastChangeBufferPos.line,column:this._lastChangeBufferPos.column+1},re=this._lastChangeBufferPos,se=0;se<oe.length;se++)oe[se]+=ie+1;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(oe.slice(1)),this._buffers[0].buffer+="_"+X,ie+=1}else{if(0!==ie)for(var se=0;se<oe.length;se++)oe[se]+=ie;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(oe.slice(1)),this._buffers[0].buffer+=X}var ae=this._buffers[0].buffer.length,le=this._buffers[0].lineStarts.length-1,ue={line:le,column:ae-this._buffers[0].lineStarts[le]},de=new d(0,re,ue,this.getLineFeedCnt(0,re,ue),ae-ie);return this._lastChangeBufferPos=ue,[de]},e.prototype.getLineRawContent=function(X,$){void 0===$&&($=0);var Q=this.root,J="",ee=this._searchCache.get2(X);if(ee){Q=ee.node;var ne=this.getAccumulatedValue(Q,X-ee.nodeStartLineNumber-1),ie=this._buffers[Q.piece.bufferIndex].buffer,oe=this.offsetInBuffer(Q.piece.bufferIndex,Q.piece.start);if(ee.nodeStartLineNumber+Q.piece.lineFeedCnt!==X)return ae=this.getAccumulatedValue(Q,X-ee.nodeStartLineNumber),ie.substring(oe+ne,oe+ae-$);J=ie.substring(oe+ne,oe+Q.piece.length)}else for(var re=0,se=X;Q!==te.SENTINEL;)if(Q.left!==te.SENTINEL&&Q.lf_left>=X-1)Q=Q.left;else{if(Q.lf_left+Q.piece.lineFeedCnt>X-1){ne=this.getAccumulatedValue(Q,X-Q.lf_left-2);var ae=this.getAccumulatedValue(Q,X-Q.lf_left-1);ie=this._buffers[Q.piece.bufferIndex].buffer,oe=this.offsetInBuffer(Q.piece.bufferIndex,Q.piece.start);return re+=Q.size_left,this._searchCache.set({node:Q,nodeStartOffset:re,nodeStartLineNumber:se-(X-1-Q.lf_left)}),ie.substring(oe+ne,oe+ae-$)}if(Q.lf_left+Q.piece.lineFeedCnt===X-1){ne=this.getAccumulatedValue(Q,X-Q.lf_left-2),ie=this._buffers[Q.piece.bufferIndex].buffer,oe=this.offsetInBuffer(Q.piece.bufferIndex,Q.piece.start);J=ie.substring(oe+ne,oe+Q.piece.length);break}X-=Q.lf_left+Q.piece.lineFeedCnt,re+=Q.size_left+Q.piece.length,Q=Q.right}for(Q=Q.next();Q!==te.SENTINEL;){if(ie=this._buffers[Q.piece.bufferIndex].buffer,Q.piece.lineFeedCnt>0){ae=this.getAccumulatedValue(Q,0),oe=this.offsetInBuffer(Q.piece.bufferIndex,Q.piece.start);return J+ie.substring(oe,oe+ae-$)}oe=this.offsetInBuffer(Q.piece.bufferIndex,Q.piece.start),J+=ie.substr(oe,Q.piece.length),Q=Q.next()}return J},e.prototype.computeBufferMetadata=function(){for(var X=this.root,$=1,Q=0;X!==te.SENTINEL;)$+=X.lf_left+X.piece.lineFeedCnt,Q+=X.size_left+X.piece.length,X=X.right;this._lineCnt=$,this._length=Q,this._searchCache.valdiate(this._length)},e.prototype.getIndexOf=function(X,$){var Q=X.piece,J=this.positionInBuffer(X,$),ee=J.line-Q.start.line;if(this.offsetInBuffer(Q.bufferIndex,Q.end)-this.offsetInBuffer(Q.bufferIndex,Q.start)===$){var te=this.getLineFeedCnt(X.piece.bufferIndex,Q.start,J);if(te!==ee)return{index:te,remainder:0}}return{index:ee,remainder:J.column}},e.prototype.getAccumulatedValue=function(X,$){if($<0)return 0;var Q=X.piece,J=this._buffers[Q.bufferIndex].lineStarts,ee=Q.start.line+$+1;return ee>Q.end.line?J[Q.end.line]+Q.end.column-J[Q.start.line]-Q.start.column:J[ee]-J[Q.start.line]-Q.start.column},e.prototype.deleteNodeTail=function(X,$){var Q=X.piece,J=Q.lineFeedCnt,ee=this.offsetInBuffer(Q.bufferIndex,Q.end),ne=$,ie=this.offsetInBuffer(Q.bufferIndex,ne),oe=this.getLineFeedCnt(Q.bufferIndex,Q.start,ne),re=oe-J,se=ie-ee,ae=Q.length+se;X.piece=new d(Q.bufferIndex,Q.start,ne,oe,ae),te.updateTreeMetadata(this,X,se,re)},e.prototype.deleteNodeHead=function(X,$){var Q=X.piece,J=Q.lineFeedCnt,ee=this.offsetInBuffer(Q.bufferIndex,Q.start),ne=$,ie=this.getLineFeedCnt(Q.bufferIndex,ne,Q.end),oe=ie-J,re=ee-this.offsetInBuffer(Q.bufferIndex,ne),se=Q.length+re;X.piece=new d(Q.bufferIndex,ne,Q.end,ie,se),te.updateTreeMetadata(this,X,re,oe)},e.prototype.shrinkNode=function(X,$,Q){var J=X.piece,ee=J.start,ne=J.end,ie=J.length,oe=J.lineFeedCnt,re=$,se=this.getLineFeedCnt(J.bufferIndex,J.start,re),ae=this.offsetInBuffer(J.bufferIndex,$)-this.offsetInBuffer(J.bufferIndex,ee);X.piece=new d(J.bufferIndex,J.start,re,se,ae),te.updateTreeMetadata(this,X,ae-ie,se-oe);var le=new d(J.bufferIndex,Q,ne,this.getLineFeedCnt(J.bufferIndex,Q,ne),this.offsetInBuffer(J.bufferIndex,ne)-this.offsetInBuffer(J.bufferIndex,Q)),ue=this.rbInsertRight(X,le);this.validateCRLFWithPrevNode(ue)},e.prototype.appendToNode=function(X,$){this.adjustCarriageReturnFromNext($,X)&&($+="\n");var Q=this.shouldCheckCRLF()&&this.startWithLF($)&&this.endWithCR(X),J=this._buffers[0].buffer.length;this._buffers[0].buffer+=$;for(var ee=l($,!1),ne=0;ne<ee.length;ne++)ee[ne]+=J;if(Q){var ie=this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-2];this._buffers[0].lineStarts.pop(),this._lastChangeBufferPos={line:this._lastChangeBufferPos.line-1,column:J-ie}}this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(ee.slice(1));var oe=this._buffers[0].lineStarts.length-1,re={line:oe,column:this._buffers[0].buffer.length-this._buffers[0].lineStarts[oe]},se=X.piece.length+$.length,ae=X.piece.lineFeedCnt,le=this.getLineFeedCnt(0,X.piece.start,re),ue=le-ae;X.piece=new d(X.piece.bufferIndex,X.piece.start,re,le,se),this._lastChangeBufferPos=re,te.updateTreeMetadata(this,X,$.length,ue)},e.prototype.nodeAt=function(X){var $=this.root,Q=this._searchCache.get(X);if(Q)return{node:Q.node,nodeStartOffset:Q.nodeStartOffset,remainder:X-Q.nodeStartOffset};for(var J=0;$!==te.SENTINEL;)if($.size_left>X)$=$.left;else{if($.size_left+$.piece.length>=X){J+=$.size_left;var ee={node:$,remainder:X-$.size_left,nodeStartOffset:J};return this._searchCache.set(ee),ee}X-=$.size_left+$.piece.length,J+=$.size_left+$.piece.length,$=$.right}return null},e.prototype.nodeAt2=function(X,$){for(var Q=this.root,J=0;Q!==te.SENTINEL;)if(Q.left!==te.SENTINEL&&Q.lf_left>=X-1)Q=Q.left;else{if(Q.lf_left+Q.piece.lineFeedCnt>X-1){var ee=this.getAccumulatedValue(Q,X-Q.lf_left-2),ne=this.getAccumulatedValue(Q,X-Q.lf_left-1);return J+=Q.size_left,{node:Q,remainder:Math.min(ee+$-1,ne),nodeStartOffset:J}}if(Q.lf_left+Q.piece.lineFeedCnt===X-1){if((ee=this.getAccumulatedValue(Q,X-Q.lf_left-2))+$-1<=Q.piece.length)return{node:Q,remainder:ee+$-1,nodeStartOffset:J};$-=Q.piece.length-ee;break}X-=Q.lf_left+Q.piece.lineFeedCnt,J+=Q.size_left+Q.piece.length,Q=Q.right}for(Q=Q.next();Q!==te.SENTINEL;){if(Q.piece.lineFeedCnt>0){ne=this.getAccumulatedValue(Q,0);var ie=this.offsetOfNode(Q);return{node:Q,remainder:Math.min($-1,ne),nodeStartOffset:ie}}if(Q.piece.length>=$-1)return{node:Q,remainder:$-1,nodeStartOffset:this.offsetOfNode(Q)};$-=Q.piece.length,Q=Q.next()}return null},e.prototype.nodeCharCodeAt=function(X,$){if(X.piece.lineFeedCnt<1)return-1;var Q=this._buffers[X.piece.bufferIndex],J=this.offsetInBuffer(X.piece.bufferIndex,X.piece.start)+$;return Q.buffer.charCodeAt(J)},e.prototype.offsetOfNode=function(X){if(!X)return 0;for(var $=X.size_left;X!==this.root;)X.parent.right===X&&($+=X.parent.size_left+X.parent.piece.length),X=X.parent;return $},e.prototype.shouldCheckCRLF=function(){return!(this._EOLNormalized&&"\n"===this._EOL)},e.prototype.startWithLF=function(X){if("string"==typeof X)return 10===X.charCodeAt(0);if(X===te.SENTINEL||0===X.piece.lineFeedCnt)return!1;var $=X.piece,Q=this._buffers[$.bufferIndex].lineStarts,J=$.start.line,ee=Q[J]+$.start.column;return J!==Q.length-1&&(!(Q[J+1]>ee+1)&&10===this._buffers[$.bufferIndex].buffer.charCodeAt(ee))},e.prototype.endWithCR=function(X){return"string"==typeof X?13===X.charCodeAt(X.length-1):X!==te.SENTINEL&&0!==X.piece.lineFeedCnt&&13===this.nodeCharCodeAt(X,X.piece.length-1)},e.prototype.validateCRLFWithPrevNode=function(X){if(this.shouldCheckCRLF()&&this.startWithLF(X)){var $=X.prev();this.endWithCR($)&&this.fixCRLF($,X)}},e.prototype.validateCRLFWithNextNode=function(X){if(this.shouldCheckCRLF()&&this.endWithCR(X)){var $=X.next();this.startWithLF($)&&this.fixCRLF(X,$)}},e.prototype.fixCRLF=function(X,$){var Q,J=[],ee=this._buffers[X.piece.bufferIndex].lineStarts;Q=0===X.piece.end.column?{line:X.piece.end.line-1,column:ee[X.piece.end.line]-ee[X.piece.end.line-1]-1}:{line:X.piece.end.line,column:X.piece.end.column-1};var ne=X.piece.length-1,ie=X.piece.lineFeedCnt-1;X.piece=new d(X.piece.bufferIndex,X.piece.start,Q,ie,ne),te.updateTreeMetadata(this,X,-1,-1),0===X.piece.length&&J.push(X);var oe={line:$.piece.start.line+1,column:0},re=$.piece.length-1,se=this.getLineFeedCnt($.piece.bufferIndex,oe,$.piece.end);$.piece=new d($.piece.bufferIndex,oe,$.piece.end,se,re),te.updateTreeMetadata(this,$,-1,-1),0===$.piece.length&&J.push($);var ae=this.createNewPieces("\r\n");this.rbInsertRight(X,ae[0]);for(var le=0;le<J.length;le++)te.rbDelete(this,J[le])},e.prototype.adjustCarriageReturnFromNext=function(X,$){if(this.shouldCheckCRLF()&&this.endWithCR(X)){var Q=$.next();if(this.startWithLF(Q)){if(X+="\n",1===Q.piece.length)te.rbDelete(this,Q);else{var J=Q.piece,ee={line:J.start.line+1,column:0},ne=J.length-1,ie=this.getLineFeedCnt(J.bufferIndex,ee,J.end);Q.piece=new d(J.bufferIndex,ee,J.end,ie,ne),te.updateTreeMetadata(this,Q,-1,-1)}return!0}}return!1},e.prototype.iterate=function(X,$){if(X===te.SENTINEL)return $(te.SENTINEL);var Q=this.iterate(X.left,$);return Q?$(X)&&this.iterate(X.right,$):Q},e.prototype.getNodeContent=function(X){if(X===te.SENTINEL)return"";var $=this._buffers[X.piece.bufferIndex],Q=X.piece,J=this.offsetInBuffer(Q.bufferIndex,Q.start),ee=this.offsetInBuffer(Q.bufferIndex,Q.end);return $.buffer.substring(J,ee)},e.prototype.rbInsertRight=function(X,$){var Q=new te.TreeNode($,1);if(Q.left=te.SENTINEL,Q.right=te.SENTINEL,Q.parent=te.SENTINEL,Q.size_left=0,Q.lf_left=0,this.root===te.SENTINEL)this.root=Q,Q.color=0;else if(X.right===te.SENTINEL)X.right=Q,Q.parent=X;else{var J=te.leftest(X.right);J.left=Q,Q.parent=J}return te.fixInsert(this,Q),Q},e.prototype.rbInsertLeft=function(X,$){var Q=new te.TreeNode($,1);if(Q.left=te.SENTINEL,Q.right=te.SENTINEL,Q.parent=te.SENTINEL,Q.size_left=0,Q.lf_left=0,this.root===te.SENTINEL)this.root=Q,Q.color=0;else if(X.left===te.SENTINEL)X.left=Q,Q.parent=X;else{var J=te.righttest(X.left);J.right=Q,Q.parent=J}return te.fixInsert(this,Q),Q},e.prototype.getContentOfSubTree=function(X){var $=this,Q="";return this.iterate(X,(function(X){return Q+=$.getNodeContent(X),!0})),Q},e}();$.PieceTreeBase=oe})),define(Q[495],n([0,1,8,3,44,172]),(function(X,$,Q,J,ee,te){Object.defineProperty($,"__esModule",{value:!0});var ne=function(){function e(X,$,Q,J,ee,ne){this._BOM=$,this._mightContainNonBasicASCII=!ee,this._mightContainRTL=J,this._pieceTree=new te.PieceTreeBase(X,Q,ne)}return e.prototype.mightContainRTL=function(){return this._mightContainRTL},e.prototype.mightContainNonBasicASCII=function(){return this._mightContainNonBasicASCII},e.prototype.getBOM=function(){return this._BOM},e.prototype.getEOL=function(){return this._pieceTree.getEOL()},e.prototype.getOffsetAt=function(X,$){return this._pieceTree.getOffsetAt(X,$)},e.prototype.getPositionAt=function(X){return this._pieceTree.getPositionAt(X)},e.prototype.getRangeAt=function(X,$){var Q=X+$,ee=this.getPositionAt(X),te=this.getPositionAt(Q);return new J.Range(ee.lineNumber,ee.column,te.lineNumber,te.column)},e.prototype.getValueInRange=function(X,$){if(void 0===$&&($=0),X.isEmpty())return"";var Q=this._getEndOfLine($);return this._pieceTree.getValueInRange(X,Q)},e.prototype.getValueLengthInRange=function(X,$){if(void 0===$&&($=0),X.isEmpty())return 0;if(X.startLineNumber===X.endLineNumber)return X.endColumn-X.startColumn;var Q=this.getOffsetAt(X.startLineNumber,X.startColumn);return this.getOffsetAt(X.endLineNumber,X.endColumn)-Q},e.prototype.getLength=function(){return this._pieceTree.getLength()},e.prototype.getLineCount=function(){return this._pieceTree.getLineCount()},e.prototype.getLinesContent=function(){return this._pieceTree.getLinesContent()},e.prototype.getLineContent=function(X){return this._pieceTree.getLineContent(X)},e.prototype.getLineCharCode=function(X,$){return this._pieceTree.getLineCharCode(X,$)},e.prototype.getLineLength=function(X){return this._pieceTree.getLineLength(X)},e.prototype.getLineFirstNonWhitespaceColumn=function(X){var $=Q.firstNonWhitespaceIndex(this.getLineContent(X));return-1===$?0:$+1},e.prototype.getLineLastNonWhitespaceColumn=function(X){var $=Q.lastNonWhitespaceIndex(this.getLineContent(X));return-1===$?0:$+2},e.prototype._getEndOfLine=function(X){switch(X){case 1:return"\n";case 2:return"\r\n";case 0:return this.getEOL()}throw new Error("Unknown EOL preference")},e.prototype.setEOL=function(X){this._pieceTree.setEOL(X)},e.prototype.applyEdits=function(X,$){for(var J=this._mightContainRTL,te=this._mightContainNonBasicASCII,ne=!0,ie=[],oe=0;oe<X.length;oe++){he=X[oe],ne&&he._isTracked&&(ne=!1);var re=he.range;!J&&he.text&&(J=Q.containsRTL(he.text)),!te&&he.text&&(te=!Q.isBasicASCII(he.text)),ie[oe]={sortIndex:oe,identifier:he.identifier||null,range:re,rangeOffset:this.getOffsetAt(re.startLineNumber,re.startColumn),rangeLength:this.getValueLengthInRange(re),lines:he.text?he.text.split(/\r\n|\r|\n/):null,forceMoveMarkers:Boolean(he.forceMoveMarkers),isAutoWhitespaceEdit:he.isAutoWhitespaceEdit||!1}}ie.sort(e._sortOpsAscending);for(var se=!1,ae=(oe=0,ie.length-1);oe<ae;oe++){var le=ie[oe].range.getEndPosition(),ue=ie[oe+1].range.getStartPosition();if(ue.isBeforeOrEqual(le)){if(ue.isBefore(le))throw new Error("Overlapping ranges are not allowed!");se=!0}}ne&&(ie=this._reduceOperations(ie));var de=e._getInverseEditRanges(ie),ce=[];for(oe=0;oe<ie.length;oe++){var he=ie[oe],pe=de[oe];if($&&he.isAutoWhitespaceEdit&&he.range.isEmpty())for(ye=pe.startLineNumber;ye<=pe.endLineNumber;ye++){var fe="";ye===pe.startLineNumber&&(fe=this.getLineContent(he.range.startLineNumber),-1!==Q.firstNonWhitespaceIndex(fe))||ce.push({lineNumber:ye,oldContent:fe})}}var ge=[];for(oe=0;oe<ie.length;oe++){he=ie[oe],pe=de[oe];ge[oe]={sortIndex:he.sortIndex,identifier:he.identifier,range:pe,text:this.getValueInRange(he.range),forceMoveMarkers:he.forceMoveMarkers}}se||ge.sort((function(X,$){return X.sortIndex-$.sortIndex})),this._mightContainRTL=J,this._mightContainNonBasicASCII=te;var me=this._doApplyEdits(ie),ve=null;if($&&ce.length>0){ce.sort((function(X,$){return $.lineNumber-X.lineNumber})),ve=[];oe=0;for(var _e=ce.length;oe<_e;oe++){var ye=ce[oe].lineNumber;if(!(oe>0&&ce[oe-1].lineNumber===ye)){var be=ce[oe].oldContent,Ce=this.getLineContent(ye);0!==Ce.length&&Ce!==be&&-1===Q.firstNonWhitespaceIndex(Ce)&&ve.push(ye)}}}return new ee.ApplyEditsResult(ge,me,ve)},e.prototype._reduceOperations=function(X){return X.length<1e3?X:[this._toSingleEditOperation(X)]},e.prototype._toSingleEditOperation=function(X){for(var $=!1,Q=X[0].range,ee=X[X.length-1].range,te=new J.Range(Q.startLineNumber,Q.startColumn,ee.endLineNumber,ee.endColumn),ne=Q.startLineNumber,ie=Q.startColumn,oe=[],re=0,se=X.length;re<se;re++){var ae=X[re],le=ae.range;$=$||ae.forceMoveMarkers;for(var ue=ne;ue<le.startLineNumber;ue++)ue===ne?oe.push(this.getLineContent(ue).substring(ie-1)):(oe.push("\n"),oe.push(this.getLineContent(ue)));if(le.startLineNumber===ne?oe.push(this.getLineContent(le.startLineNumber).substring(ie-1,le.startColumn-1)):(oe.push("\n"),oe.push(this.getLineContent(le.startLineNumber).substring(0,le.startColumn-1))),ae.lines)for(var de=0,ce=ae.lines.length;de<ce;de++)0!==de&&oe.push("\n"),oe.push(ae.lines[de]);ne=ae.range.endLineNumber,ie=ae.range.endColumn}return{sortIndex:0,identifier:X[0].identifier,range:te,rangeOffset:this.getOffsetAt(te.startLineNumber,te.startColumn),rangeLength:this.getValueLengthInRange(te,0),lines:oe.join("").split("\n"),forceMoveMarkers:$,isAutoWhitespaceEdit:!1}},e.prototype._doApplyEdits=function(X){X.sort(e._sortOpsDescending);for(var $=[],Q=0;Q<X.length;Q++){var ee=X[Q],te=ee.range.startLineNumber,ne=ee.range.startColumn,ie=ee.range.endLineNumber,oe=ee.range.endColumn;if(te!==ie||ne!==oe||ee.lines&&0!==ee.lines.length){var re=ie-te,se=ee.lines?ee.lines.length-1:0,ae=Math.min(re,se),le=ee.lines?ee.lines.join(this.getEOL()):"";if(le?(this._pieceTree.delete(ee.rangeOffset,ee.rangeLength),this._pieceTree.insert(ee.rangeOffset,le,!0)):this._pieceTree.delete(ee.rangeOffset,ee.rangeLength),ae<se){for(var ue=[],de=ae+1;de<=se;de++)ue.push(ee.lines[de]);ue[ue.length-1]=this.getLineContent(te+se-1)}var ce=new J.Range(te,ne,ie,oe);$.push({range:ce,rangeLength:ee.rangeLength,text:le,rangeOffset:ee.rangeOffset,forceMoveMarkers:ee.forceMoveMarkers})}}return $},e.prototype.findMatchesLineByLine=function(X,$,Q,J){return this._pieceTree.findMatchesLineByLine(X,$,Q,J)},e._getInverseEditRanges=function(X){for(var $=[],Q=0,ee=0,te=null,ne=0,ie=X.length;ne<ie;ne++){var oe=X[ne],re=void 0,se=void 0;te?te.range.endLineNumber===oe.range.startLineNumber?(re=Q,se=ee+(oe.range.startColumn-te.range.endColumn)):(re=Q+(oe.range.startLineNumber-te.range.endLineNumber),se=oe.range.startColumn):(re=oe.range.startLineNumber,se=oe.range.startColumn);var ae=void 0;if(oe.lines&&oe.lines.length>0){var le=oe.lines.length,ue=oe.lines[0],de=oe.lines[le-1];ae=1===le?new J.Range(re,se,re,se+ue.length):new J.Range(re,se,re+le-1,de.length+1)}else ae=new J.Range(re,se,re,se);Q=ae.endLineNumber,ee=ae.endColumn,$.push(ae),te=oe}return $},e._sortOpsAscending=function(X,$){var Q=J.Range.compareRangesUsingEnds(X.range,$.range);return 0===Q?X.sortIndex-$.sortIndex:Q},e._sortOpsDescending=function(X,$){var Q=J.Range.compareRangesUsingEnds(X.range,$.range);return 0===Q?$.sortIndex-X.sortIndex:-Q},e}();$.PieceTreeTextBuffer=ne})),define(Q[499],n([0,1,8,172,495]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var te=function(){function e(X,$,Q,J,ee,te,ne,ie){this._chunks=X,this._bom=$,this._cr=Q,this._lf=J,this._crlf=ee,this._containsRTL=te,this._isBasicASCII=ne,this._normalizeEOL=ie}return e.prototype._getEOL=function(X){var $=this._cr+this._lf+this._crlf,Q=this._cr+this._crlf;return 0===$?1===X?"\n":"\r\n":Q>$/2?"\r\n":"\n"},e.prototype.create=function(X){var $=this._getEOL(X),Q=this._chunks;if(this._normalizeEOL&&("\r\n"===$&&(this._cr>0||this._lf>0)||"\n"===$&&(this._cr>0||this._crlf>0)))for(var te=0,ne=Q.length;te<ne;te++){var ie=Q[te].buffer.replace(/\r\n|\r|\n/g,$),oe=J.createLineStartsFast(ie);Q[te]=new J.StringBuffer(ie,oe)}return new ee.PieceTreeTextBuffer(Q,this._bom,$,this._containsRTL,this._isBasicASCII,this._normalizeEOL)},e}();$.PieceTreeTextBufferFactory=te;var ne=function(){function e(){this.chunks=[],this.BOM="",this._hasPreviousChar=!1,this._previousChar=0,this._tmpLineStarts=[],this.cr=0,this.lf=0,this.crlf=0,this.containsRTL=!1,this.isBasicASCII=!0}return e.prototype.acceptChunk=function(X){if(0!==X.length){0===this.chunks.length&&Q.startsWithUTF8BOM(X)&&(this.BOM=Q.UTF8_BOM_CHARACTER,X=X.substr(1));var $=X.charCodeAt(X.length-1);13===$||$>=55296&&$<=56319?(this._acceptChunk1(X.substr(0,X.length-1),!1),this._hasPreviousChar=!0,this._previousChar=$):(this._acceptChunk1(X,!1),this._hasPreviousChar=!1,this._previousChar=$)}},e.prototype._acceptChunk1=function(X,$){($||0!==X.length)&&(this._hasPreviousChar?this._acceptChunk2(String.fromCharCode(this._previousChar)+X):this._acceptChunk2(X))},e.prototype._acceptChunk2=function(X){var $=J.createLineStarts(this._tmpLineStarts,X);this.chunks.push(new J.StringBuffer(X,$.lineStarts)),this.cr+=$.cr,this.lf+=$.lf,this.crlf+=$.crlf,this.isBasicASCII&&(this.isBasicASCII=$.isBasicASCII),this.isBasicASCII||this.containsRTL||(this.containsRTL=Q.containsRTL(X))},e.prototype.finish=function(X){return void 0===X&&(X=!0),this._finish(),new te(this.chunks,this.BOM,this.cr,this.lf,this.crlf,this.containsRTL,this.isBasicASCII,X)},e.prototype._finish=function(){if(0===this.chunks.length&&this._acceptChunk1("",!0),this._hasPreviousChar){this._hasPreviousChar=!1;var X=this.chunks[this.chunks.length-1];X.buffer+=String.fromCharCode(this._previousChar);var $=J.createLineStartsFast(X.buffer);X.lineStarts=$,13===this._previousChar&&this.cr++}},e}();$.PieceTreeTextBufferBuilder=ne})),define(Q[90],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0}),$.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?",$.DEFAULT_WORD_REGEXP=function(X){void 0===X&&(X="");for(var Q="(-?\\d*\\.\\d\\w*)|([^",J=0;J<$.USUAL_WORD_SEPARATORS.length;J++)X.indexOf($.USUAL_WORD_SEPARATORS[J])>=0||(Q+="\\"+$.USUAL_WORD_SEPARATORS[J]);return Q+="\\s]+)",new RegExp(Q,"g")}(),$.ensureValidWordDefinition=function(X){var Q=$.DEFAULT_WORD_REGEXP;if(X&&X instanceof RegExp)if(X.global)Q=X;else{var J="g";X.ignoreCase&&(J+="i"),X.multiline&&(J+="m"),Q=new RegExp(X.source,J)}return Q.lastIndex=0,Q},$.getWordAtText=function(X,$,Q,J){$.lastIndex=0;var ee=$.exec(Q);if(!ee)return null;var te=ee[0].indexOf(" ")>=0?function(X,$,Q,J){var ee,te=X-1-J;for($.lastIndex=0;ee=$.exec(Q);){var ne=ee.index||0;if(ne>te)return null;if($.lastIndex>=te)return{word:ee[0],startColumn:J+1+ne,endColumn:J+1+$.lastIndex}}return null}(X,$,Q,J):function(X,$,Q,J){var ee,te=X-1-J,ne=Q.lastIndexOf(" ",te-1)+1,ie=Q.indexOf(" ",te);for(-1===ie&&(ie=Q.length),$.lastIndex=ne;ee=$.exec(Q);){var oe=ee.index||0;if(oe<=te&&$.lastIndex>=te)return{word:ee[0],startColumn:J+1+oe,endColumn:J+1+$.lastIndex}}return null}(X,$,Q,J);return $.lastIndex=0,te}})),define(Q[507],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q=function(){function e(X){this._languageIdentifier=X}return e.prototype.getId=function(){return this._languageIdentifier.language},e}();$.FrankensteinMode=Q})),define(Q[74],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0}),function(X){X[X.None=0]="None",X[X.Indent=1]="Indent",X[X.IndentOutdent=2]="IndentOutdent",X[X.Outdent=3]="Outdent"}($.IndentAction||($.IndentAction={}));var Q=function(){function e(X){if(this.open=X.open,this.close=X.close,this._standardTokenMask=0,Array.isArray(X.notIn))for(var $=0,Q=X.notIn.length;$<Q;$++)switch(X.notIn[$]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4}}return e.prototype.isOK=function(X){return 0==(this._standardTokenMask&X)},e}();$.StandardAutoClosingPairConditional=Q})),define(Q[515],n([0,1,167]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),$.score=function i(X,$,J,ee){if(Array.isArray(X)){for(var te=0,ne=0,ie=X;ne<ie.length;ne++){var oe=i(ie[ne],$,J,ee);if(10===oe)return oe;oe>te&&(te=oe)}return te}if("string"==typeof X)return ee?"*"===X?5:X===J?10:0:0;if(X){var re=X.language,se=X.pattern,ae=X.scheme,le=X.hasAccessToAllModels;if(!ee&&!le)return 0;if(te=0,ae)if(ae===$.scheme)te=10;else{if("*"!==ae)return 0;te=5}if(re)if(re===J)te=10;else{if("*"!==re)return 0;te=Math.max(te,5)}if(se){if(se!==$.fsPath&&!Q.match(se,$.fsPath))return 0;te=10}return te}return 0}})),define(Q[523],n([0,1,81,101]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(){function e(X){for(var $=0,Q=0,ee=0,te=X.length;ee<te;ee++){var ne=X[ee],ie=ne[0];(se=ne[1])>$&&($=se),ie>Q&&(Q=ie),(ae=ne[2])>Q&&(Q=ae)}$++,Q++;var oe=new J.Uint8Matrix(Q,$,0);for(ee=0,te=X.length;ee<te;ee++){var re=X[ee],se=(ie=re[0],re[1]),ae=re[2];oe.set(ie,se,ae)}this._states=oe,this._maxCharCode=$}return e.prototype.nextState=function(X,$){return $<0||$>=this._maxCharCode?0:this._states.get(X,$)},e}(),te=null,ne=null,ie=function(){function e(){}return e._createLink=function(X,$,Q,J,ee){var te=ee-1;do{var ne=$.charCodeAt(te);if(2!==X.get(ne))break;te--}while(te>J);if(J>0){var ie=$.charCodeAt(J-1),oe=$.charCodeAt(te);(40===ie&&41===oe||91===ie&&93===oe||123===ie&&125===oe)&&te--}return{range:{startLineNumber:Q,startColumn:J+1,endLineNumber:Q,endColumn:te+2},url:$.substring(J,te+1)}},e.computeLinks=function(X){for(var $=(null===te&&(te=new ee([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),te),J=function(){if(null===ne){for(ne=new Q.CharacterClassifier(0),X=0;X<" \t<>'\"、。｡､，．：；？！＠＃＄％＆＊‘“〈《「『【〔（［｛｢｣｝］）〕】』」》〉”’｀～…".length;X++)ne.set(" \t<>'\"、。｡､，．：；？！＠＃＄％＆＊‘“〈《「『【〔（［｛｢｣｝］）〕】』」》〉”’｀～…".charCodeAt(X),1);for(var X=0;X<".,;".length;X++)ne.set(".,;".charCodeAt(X),2)}return ne}(),ie=[],oe=1,re=X.getLineCount();oe<=re;oe++){for(var se=X.getLineContent(oe),ae=se.length,le=0,ue=0,de=0,ce=1,he=!1,pe=!1,fe=!1;le<ae;){var ge=!1,me=se.charCodeAt(le);if(13===ce){switch(ve=void 0,me){case 40:he=!0,ve=0;break;case 41:ve=he?0:1;break;case 91:pe=!0,ve=0;break;case 93:ve=pe?0:1;break;case 123:fe=!0,ve=0;break;case 125:ve=fe?0:1;break;case 39:ve=34===de||96===de?0:1;break;case 34:ve=39===de||96===de?0:1;break;case 96:ve=39===de||34===de?0:1;break;default:ve=J.get(me)}1===ve&&(ie.push(e._createLink(J,se,oe,ue,le)),ge=!0)}else if(12===ce){var ve;1===(ve=J.get(me))?ge=!0:ce=13}else 0===(ce=$.nextState(ce,me))&&(ge=!0);ge&&(ce=1,he=!1,pe=!1,fe=!1,ue=le+1,de=me),le++}13===ce&&ie.push(e._createLink(J,se,oe,ue,ae))}return ie},e}();$.computeLinks=function(X){return X&&"function"==typeof X.getLineCount&&"function"==typeof X.getLineContent?ie.computeLinks(X):[]}})),define(Q[94],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0}),$.createScopedLineTokens=function(X,$){for(var J=X.getCount(),ee=X.findTokenIndexAtOffset($),te=X.getLanguageId(ee),ne=ee;ne+1<J&&X.getLanguageId(ne+1)===te;)ne++;for(var ie=ee;ie>0&&X.getLanguageId(ie-1)===te;)ie--;return new Q(X,te,ie,ne+1,X.getStartOffset(ie),X.getEndOffset(ne))};var Q=function(){function e(X,$,Q,J,ee,te){this._actual=X,this.languageId=$,this._firstTokenIndex=Q,this._lastTokenIndex=J,this.firstCharOffset=ee,this._lastCharOffset=te}return e.prototype.getLineContent=function(){return this._actual.getLineContent().substring(this.firstCharOffset,this._lastCharOffset)},e.prototype.getTokenCount=function(){return this._lastTokenIndex-this._firstTokenIndex},e.prototype.findTokenIndexAtOffset=function(X){return this._actual.findTokenIndexAtOffset(X+this.firstCharOffset)-this._firstTokenIndex},e.prototype.getStandardTokenType=function(X){return this._actual.getStandardTokenType(X+this._firstTokenIndex)},e}();$.ScopedLineTokens=Q,$.ignoreBracketsInToken=function(X){return 0!=(7&X)}})),define(Q[532],n([0,1,74]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(){function e(X){X.autoClosingPairs?this._autoClosingPairs=X.autoClosingPairs.map((function(X){return new Q.StandardAutoClosingPairConditional(X)})):X.brackets?this._autoClosingPairs=X.brackets.map((function(X){return new Q.StandardAutoClosingPairConditional({open:X[0],close:X[1]})})):this._autoClosingPairs=[],this._autoCloseBefore="string"==typeof X.autoCloseBefore?X.autoCloseBefore:e.DEFAULT_AUTOCLOSE_BEFORE_LANGUAGE_DEFINED,this._surroundingPairs=X.surroundingPairs||this._autoClosingPairs}return e.prototype.getAutoClosingPairs=function(){return this._autoClosingPairs},e.prototype.getAutoCloseBeforeSet=function(){return this._autoCloseBefore},e.prototype.shouldAutoClosePair=function(X,$,Q){if(0===$.getTokenCount())return!0;for(var J=$.findTokenIndexAtOffset(Q-2),ee=$.getStandardTokenType(J),te=0;te<this._autoClosingPairs.length;++te){var ne=this._autoClosingPairs[te];if(ne.open===X)return ne.isOK(ee)}return!1},e.prototype.getSurroundingPairs=function(){return this._surroundingPairs},e.DEFAULT_AUTOCLOSE_BEFORE_LANGUAGE_DEFINED=";:.,=}])> \n\t",e}();$.CharacterPairSupport=J})),define(Q[539],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q=function(){function e(X){this._indentationRules=X}return e.prototype.shouldIncrease=function(X){return!!(this._indentationRules&&this._indentationRules.increaseIndentPattern&&this._indentationRules.increaseIndentPattern.test(X))},e.prototype.shouldDecrease=function(X){return!!(this._indentationRules&&this._indentationRules.decreaseIndentPattern&&this._indentationRules.decreaseIndentPattern.test(X))},e.prototype.shouldIndentNextLine=function(X){return!!(this._indentationRules&&this._indentationRules.indentNextLinePattern&&this._indentationRules.indentNextLinePattern.test(X))},e.prototype.shouldIgnore=function(X){return!!(this._indentationRules&&this._indentationRules.unIndentedLinePattern&&this._indentationRules.unIndentedLinePattern.test(X))},e.prototype.getIndentMetadata=function(X){var $=0;return this.shouldIncrease(X)&&($+=1),this.shouldDecrease(X)&&($+=2),this.shouldIndentNextLine(X)&&($+=4),this.shouldIgnore(X)&&($+=8),$},e}();$.IndentRulesSupport=Q})),define(Q[547],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q=function(){function e(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}return e.prototype.navigateValueSet=function(X,$,Q,J,ee){if(X&&$&&(te=this.doNavigateValueSet($,ee)))return{range:X,value:te};if(Q&&J){var te=this.doNavigateValueSet(J,ee);if(te)return{range:Q,value:te}}return null},e.prototype.doNavigateValueSet=function(X,$){var Q=this.numberReplace(X,$);return null!==Q?Q:this.textReplace(X,$)},e.prototype.numberReplace=function(X,$){var Q=Math.pow(10,X.length-(X.lastIndexOf(".")+1)),J=Number(X),ee=parseFloat(X);return isNaN(J)||isNaN(ee)||J!==ee?null:0!==J||$?(J=Math.floor(J*Q),J+=$?Q:-Q,String(J/Q)):null},e.prototype.textReplace=function(X,$){return this.valueSetsReplace(this._defaultValueSet,X,$)},e.prototype.valueSetsReplace=function(X,$,Q){for(var J=null,ee=0,te=X.length;null===J&&ee<te;ee++)J=this.valueSetReplace(X[ee],$,Q);return J},e.prototype.valueSetReplace=function(X,$,Q){var J=X.indexOf($);return J>=0?((J+=Q?1:-1)<0?J=X.length-1:J%=X.length,X[J]):null},e.INSTANCE=new e,e}();$.BasicInplaceReplace=Q})),define(Q[548],n([0,1,11,8,74]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var te=function(){function e(X){var $=this;(X=X||{}).brackets=X.brackets||[["(",")"],["{","}"],["[","]"]],this._brackets=[],X.brackets.forEach((function(X){var Q=e._createOpenBracketRegExp(X[0]),J=e._createCloseBracketRegExp(X[1]);Q&&J&&$._brackets.push({open:X[0],openRegExp:Q,close:X[1],closeRegExp:J})})),this._regExpRules=X.regExpRules||[]}return e.prototype.onEnter=function(X,$,Q){for(var J=0,te=this._regExpRules.length;J<te;J++){var ne=this._regExpRules[J];if([{reg:ne.beforeText,text:$},{reg:ne.afterText,text:Q},{reg:ne.oneLineAboveText,text:X}].every((function(X){return!X.reg||X.reg.test(X.text)})))return ne.action}if($.length>0&&Q.length>0)for(J=0,te=this._brackets.length;J<te;J++)if((ie=this._brackets[J]).openRegExp.test($)&&ie.closeRegExp.test(Q))return{indentAction:ee.IndentAction.IndentOutdent};if($.length>0)for(J=0,te=this._brackets.length;J<te;J++){var ie=this._brackets[J];if(ie.openRegExp.test($))return{indentAction:ee.IndentAction.Indent}}return null},e._createOpenBracketRegExp=function(X){var $=J.escapeRegExpCharacters(X);return/\B/.test($.charAt(0))||($="\\b"+$),$+="\\s*$",e._safeRegExp($)},e._createCloseBracketRegExp=function(X){var $=J.escapeRegExpCharacters(X);return/\B/.test($.charAt($.length-1))||($+="\\b"),$="^\\s*"+$,e._safeRegExp($)},e._safeRegExp=function(X){try{return new RegExp(X)}catch(X){return Q.onUnexpectedError(X),null}},e}();$.OnEnterSupport=te})),define(Q[96],n([0,1,8,3]),(function(X,$,Q,J){function o(X,$){var Q={};return function(J){var ee=X(J);return Q.hasOwnProperty(ee)||(Q[ee]=$(J)),Q[ee]}}function r(X){var $=/^[\w]+$/.test(X);return X=Q.escapeRegExpCharacters(X),$?"\\b"+X+"\\b":X}function s(X){var $="("+X.map(r).join(")|(")+")";return Q.createRegExp($,!0)}Object.defineProperty($,"__esModule",{value:!0});var a=function(X,$,Q,J,ee){this.languageIdentifier=X,this.open=$,this.close=Q,this.forwardRegex=J,this.reversedRegex=ee};$.RichEditBracket=a;var l=function(X,$){var Q=this;this.brackets=$.map((function($){return new a(X,$[0],$[1],ee({open:$[0],close:$[1]}),te({open:$[0],close:$[1]}))})),this.forwardRegex=ne(this.brackets),this.reversedRegex=ie(this.brackets),this.textIsBracket={},this.textIsOpenBracket={};var J=0;this.brackets.forEach((function(X){Q.textIsBracket[X.open.toLowerCase()]=X,Q.textIsBracket[X.close.toLowerCase()]=X,Q.textIsOpenBracket[X.open.toLowerCase()]=!0,Q.textIsOpenBracket[X.close.toLowerCase()]=!1,J=Math.max(J,X.open.length),J=Math.max(J,X.close.length)})),this.maxBracketLength=J};$.RichEditBrackets=l;var ee=o((function(X){return X.open+";"+X.close}),(function(X){return s([X.open,X.close])})),te=o((function(X){return X.open+";"+X.close}),(function(X){return s([oe(X.open),oe(X.close)])})),ne=o((function(X){return X.map((function(X){return X.open+";"+X.close})).join(";")}),(function(X){var $=[];return X.forEach((function(X){$.push(X.open),$.push(X.close)})),s($)})),ie=o((function(X){return X.map((function(X){return X.open+";"+X.close})).join(";")}),(function(X){var $=[];return X.forEach((function(X){$.push(oe(X.open)),$.push(oe(X.close))})),s($)})),oe=function(){var X=null,$=null;return function(Q){return X!==Q&&($=function(X){for(var $="",Q=X.length-1;Q>=0;Q--)$+=X.charAt(Q);return $}(X=Q)),$}}(),re=function(){function e(){}return e._findPrevBracketInText=function(X,$,Q,ee){var te=Q.match(X);if(!te)return null;var ne=Q.length-(te.index||0),ie=te[0].length,oe=ee+ne;return new J.Range($,oe-ie+1,$,oe+1)},e.findPrevBracketInToken=function(X,$,Q,J,ee){var te=oe(Q).substring(Q.length-ee,Q.length-J);return this._findPrevBracketInText(X,$,te,J)},e.findNextBracketInText=function(X,$,Q,ee){var te=Q.match(X);if(!te)return null;var ne=te.index||0,ie=te[0].length;if(0===ie)return null;var oe=ee+ne;return new J.Range($,oe+1,$,oe+1+ie)},e.findNextBracketInToken=function(X,$,Q,J,ee){var te=Q.substring(J,ee);return this.findNextBracketInText(X,$,te,J)},e}();$.BracketsUtils=re})),define(Q[550],n([0,1,74,94,96]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var te=function(){function e(X,$,J){J=J||{},this._richEditBrackets=X,this._complexAutoClosePairs=$.filter((function(X){return X.open.length>1&&!!X.close})).map((function(X){return new Q.StandardAutoClosingPairConditional(X)})),J.docComment&&this._complexAutoClosePairs.push(new Q.StandardAutoClosingPairConditional({open:J.docComment.open,close:J.docComment.close}))}return e.prototype.getElectricCharacters=function(){var X=[];if(this._richEditBrackets)for(var $=0,Q=this._richEditBrackets.brackets.length;$<Q;$++){var J=this._richEditBrackets.brackets[$],ee=J.close.charAt(J.close.length-1);X.push(ee)}for(var te=0,ne=this._complexAutoClosePairs;te<ne.length;te++){var ie=ne[te];X.push(ie.open.charAt(ie.open.length-1))}return X.filter((function(X,$,Q){return Q.indexOf(X)===$}))},e.prototype.onElectricCharacter=function(X,$,Q){return this._onElectricAutoClose(X,$,Q)||this._onElectricAutoIndent(X,$,Q)},e.prototype._onElectricAutoIndent=function(X,$,Q){if(!this._richEditBrackets||0===this._richEditBrackets.brackets.length)return null;var te=$.findTokenIndexAtOffset(Q-1);if(J.ignoreBracketsInToken($.getStandardTokenType(te)))return null;var ne=this._richEditBrackets.reversedRegex,ie=$.getLineContent().substring(0,Q-1)+X,oe=ee.BracketsUtils.findPrevBracketInToken(ne,1,ie,0,ie.length);if(!oe)return null;var re=ie.substring(oe.startColumn-1,oe.endColumn-1);if(re=re.toLowerCase(),this._richEditBrackets.textIsOpenBracket[re])return null;var se=ie.substring(0,oe.startColumn-1);return/^\s*$/.test(se)?{matchOpenBracket:re}:null},e.prototype._onElectricAutoClose=function(X,$,Q){if(!this._complexAutoClosePairs.length)return null;for(var J=$.getLineContent(),ee=0,te=this._complexAutoClosePairs.length;ee<te;ee++){var ne=this._complexAutoClosePairs[ee];if(X===ne.open.charAt(ne.open.length-1)){var ie=Q-ne.open.length+1;if(J.substring(ie-1,Q-1)+X===ne.open){var oe=$.findTokenIndexAtOffset(Q-1),re=$.getStandardTokenType(oe);if(ne.isOK(re)&&!(J.indexOf(ne.close,Q-1)>=0))return{appendText:ne.close}}}}return null},e}();$.BracketElectricCharacterSupport=te})),define(Q[39],n([0,1,11,6,2,8,3,90,74,94,532,550,539,548,96]),(function(X,$,Q,J,ee,te,ne,ie,oe,re,se,ae,le,ue,de){Object.defineProperty($,"__esModule",{value:!0});var ce=function(){function e(X,$,Q){this._languageIdentifier=X,this._brackets=null,this._electricCharacter=null;var J=null;$&&(J=$._conf),this._conf=e._mergeConf(J,Q),this.onEnter=e._handleOnEnter(this._conf),this.comments=e._handleComments(this._conf),this.characterPair=new se.CharacterPairSupport(this._conf),this.wordDefinition=this._conf.wordPattern||ie.DEFAULT_WORD_REGEXP,this.indentationRules=this._conf.indentationRules,this._conf.indentationRules&&(this.indentRulesSupport=new le.IndentRulesSupport(this._conf.indentationRules)),this.foldingRules=this._conf.folding||{}}return Object.defineProperty(e.prototype,"brackets",{get:function(){return!this._brackets&&this._conf.brackets&&(this._brackets=new de.RichEditBrackets(this._languageIdentifier,this._conf.brackets)),this._brackets},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"electricCharacter",{get:function(){if(!this._electricCharacter){var X=[];this._conf.autoClosingPairs?X=this._conf.autoClosingPairs:this._conf.brackets&&(X=this._conf.brackets.map((function(X){return{open:X[0],close:X[1]}}))),this._electricCharacter=new ae.BracketElectricCharacterSupport(this.brackets,X,this._conf.__electricCharacterSupport)}return this._electricCharacter},enumerable:!0,configurable:!0}),e._mergeConf=function(X,$){return{comments:X?$.comments||X.comments:$.comments,brackets:X?$.brackets||X.brackets:$.brackets,wordPattern:X?$.wordPattern||X.wordPattern:$.wordPattern,indentationRules:X?$.indentationRules||X.indentationRules:$.indentationRules,onEnterRules:X?$.onEnterRules||X.onEnterRules:$.onEnterRules,autoClosingPairs:X?$.autoClosingPairs||X.autoClosingPairs:$.autoClosingPairs,surroundingPairs:X?$.surroundingPairs||X.surroundingPairs:$.surroundingPairs,autoCloseBefore:X?$.autoCloseBefore||X.autoCloseBefore:$.autoCloseBefore,folding:X?$.folding||X.folding:$.folding,__electricCharacterSupport:X?$.__electricCharacterSupport||X.__electricCharacterSupport:$.__electricCharacterSupport}},e._handleOnEnter=function(X){var $={},Q=!0;return X.brackets&&(Q=!1,$.brackets=X.brackets),X.indentationRules&&(Q=!1),X.onEnterRules&&(Q=!1,$.regExpRules=X.onEnterRules),Q?null:new ue.OnEnterSupport($)},e._handleComments=function(X){var $=X.comments;if(!$)return null;var Q={};if($.lineComment&&(Q.lineCommentToken=$.lineComment),$.blockComment){var J=$.blockComment,ee=J[0],te=J[1];Q.blockCommentStartToken=ee,Q.blockCommentEndToken=te}return Q},e}();$.RichEditSupport=ce;var m=function(){};$.LanguageConfigurationChangeEvent=m;var he=function(){function e(){this._onDidChange=new J.Emitter,this.onDidChange=this._onDidChange.event,this._entries=[]}return e.prototype.register=function(X,$){var Q=this,J=this._getRichEditSupport(X.id),te=new ce(X,J,$);return this._entries[X.id]=te,this._onDidChange.fire({languageIdentifier:X}),ee.toDisposable((function(){Q._entries[X.id]===te&&(Q._entries[X.id]=J,Q._onDidChange.fire({languageIdentifier:X}))}))},e.prototype._getRichEditSupport=function(X){return this._entries[X]||null},e.prototype._getElectricCharacterSupport=function(X){var $=this._getRichEditSupport(X);return $&&$.electricCharacter||null},e.prototype.getElectricCharacters=function(X){var $=this._getElectricCharacterSupport(X);return $?$.getElectricCharacters():[]},e.prototype.onElectricCharacter=function(X,$,Q){var J=re.createScopedLineTokens($,Q-1),ee=this._getElectricCharacterSupport(J.languageId);return ee?ee.onElectricCharacter(X,J,Q-J.firstCharOffset):null},e.prototype.getComments=function(X){var $=this._getRichEditSupport(X);return $&&$.comments||null},e.prototype._getCharacterPairSupport=function(X){var $=this._getRichEditSupport(X);return $&&$.characterPair||null},e.prototype.getAutoClosingPairs=function(X){var $=this._getCharacterPairSupport(X);return $?$.getAutoClosingPairs():[]},e.prototype.getAutoCloseBeforeSet=function(X){var $=this._getCharacterPairSupport(X);return $?$.getAutoCloseBeforeSet():se.CharacterPairSupport.DEFAULT_AUTOCLOSE_BEFORE_LANGUAGE_DEFINED},e.prototype.getSurroundingPairs=function(X){var $=this._getCharacterPairSupport(X);return $?$.getSurroundingPairs():[]},e.prototype.shouldAutoClosePair=function(X,$,Q){var J=re.createScopedLineTokens($,Q-1),ee=this._getCharacterPairSupport(J.languageId);return!!ee&&ee.shouldAutoClosePair(X,J,Q-J.firstCharOffset)},e.prototype.getWordDefinition=function(X){var $=this._getRichEditSupport(X);return $?ie.ensureValidWordDefinition($.wordDefinition||null):ie.ensureValidWordDefinition(null)},e.prototype.getFoldingRules=function(X){var $=this._getRichEditSupport(X);return $?$.foldingRules:{}},e.prototype.getIndentRulesSupport=function(X){var $=this._getRichEditSupport(X);return $&&$.indentRulesSupport||null},e.prototype.getPrecedingValidLine=function(X,$,Q){var J=X.getLanguageIdAtPosition($,0);if($>1){var ee=$-1,te=-1;for(ee=$-1;ee>=1;ee--){if(X.getLanguageIdAtPosition(ee,0)!==J)return te;var ne=X.getLineContent(ee);if(!Q.shouldIgnore(ne)&&!/^\s+$/.test(ne)&&""!==ne)return ee;te=ee}}return-1},e.prototype.getInheritIndentForLine=function(X,$,Q){void 0===Q&&(Q=!0);var J=this.getIndentRulesSupport(X.getLanguageIdentifier().id);if(!J)return null;if($<=1)return{indentation:"",action:null};var ee=this.getPrecedingValidLine(X,$,J);if(ee<0)return null;if(ee<1)return{indentation:"",action:null};var ne=X.getLineContent(ee);if(J.shouldIncrease(ne)||J.shouldIndentNextLine(ne))return{indentation:te.getLeadingWhitespace(ne),action:oe.IndentAction.Indent,line:ee};if(J.shouldDecrease(ne))return{indentation:te.getLeadingWhitespace(ne),action:null,line:ee};if(1===ee)return{indentation:te.getLeadingWhitespace(X.getLineContent(ee)),action:null,line:ee};var ie=ee-1,re=J.getIndentMetadata(X.getLineContent(ie));if(!(3&re)&&4&re){for(var se=0,ae=ie-1;ae>0;ae--)if(!J.shouldIndentNextLine(X.getLineContent(ae))){se=ae;break}return{indentation:te.getLeadingWhitespace(X.getLineContent(se+1)),action:null,line:se+1}}if(Q)return{indentation:te.getLeadingWhitespace(X.getLineContent(ee)),action:null,line:ee};for(ae=ee;ae>0;ae--){var le=X.getLineContent(ae);if(J.shouldIncrease(le))return{indentation:te.getLeadingWhitespace(le),action:oe.IndentAction.Indent,line:ae};if(J.shouldIndentNextLine(le)){se=0;for(var ue=ae-1;ue>0;ue--)if(!J.shouldIndentNextLine(X.getLineContent(ae))){se=ue;break}return{indentation:te.getLeadingWhitespace(X.getLineContent(se+1)),action:null,line:se+1}}if(J.shouldDecrease(le))return{indentation:te.getLeadingWhitespace(le),action:null,line:ae}}return{indentation:te.getLeadingWhitespace(X.getLineContent(1)),action:null,line:1}},e.prototype.getGoodIndentForLine=function(X,$,J,ee){var ne=this.getIndentRulesSupport($);if(!ne)return null;var ie=this.getInheritIndentForLine(X,J),re=X.getLineContent(J);if(ie){var se=ie.line;if(void 0!==se){var ae=this._getOnEnterSupport($),le=null;try{ae&&(le=ae.onEnter("",X.getLineContent(se),""))}catch(X){Q.onUnexpectedError(X)}if(le){var ue=te.getLeadingWhitespace(X.getLineContent(se));return le.removeText&&(ue=ue.substring(0,ue.length-le.removeText)),le.indentAction===oe.IndentAction.Indent||le.indentAction===oe.IndentAction.IndentOutdent?ue=ee.shiftIndent(ue):le.indentAction===oe.IndentAction.Outdent&&(ue=ee.unshiftIndent(ue)),ne.shouldDecrease(re)&&(ue=ee.unshiftIndent(ue)),le.appendText&&(ue+=le.appendText),te.getLeadingWhitespace(ue)}}return ne.shouldDecrease(re)?ie.action===oe.IndentAction.Indent?ie.indentation:ee.unshiftIndent(ie.indentation):ie.action===oe.IndentAction.Indent?ee.shiftIndent(ie.indentation):ie.indentation}return null},e.prototype.getIndentForEnter=function(X,$,Q,J){X.forceTokenization($.startLineNumber);var ee,ne,ie=X.getLineTokens($.startLineNumber),se=re.createScopedLineTokens(ie,$.startColumn-1),ae=se.getLineContent(),le=!1;se.firstCharOffset>0&&ie.getLanguageId(0)!==se.languageId?(le=!0,ee=ae.substr(0,$.startColumn-1-se.firstCharOffset)):ee=ie.getLineContent().substring(0,$.startColumn-1),ne=$.isEmpty()?ae.substr($.startColumn-1-se.firstCharOffset):this.getScopedLineTokens(X,$.endLineNumber,$.endColumn).getLineContent().substr($.endColumn-1-se.firstCharOffset);var ue=this.getIndentRulesSupport(se.languageId);if(!ue)return null;var de=ee,ce=te.getLeadingWhitespace(ee);if(!J&&!le){var he=this.getInheritIndentForLine(X,$.startLineNumber);ue.shouldDecrease(ee)&&he&&(ce=he.indentation,he.action!==oe.IndentAction.Indent&&(ce=Q.unshiftIndent(ce))),de=ce+te.ltrim(te.ltrim(ee," "),"\t")}var pe={getLineTokens:function($){return X.getLineTokens($)},getLanguageIdentifier:function(){return X.getLanguageIdentifier()},getLanguageIdAtPosition:function($,Q){return X.getLanguageIdAtPosition($,Q)},getLineContent:function(Q){return Q===$.startLineNumber?de:X.getLineContent(Q)}},fe=te.getLeadingWhitespace(ie.getLineContent()),ge=this.getInheritIndentForLine(pe,$.startLineNumber+1);if(!ge){var me=le?fe:ce;return{beforeEnter:me,afterEnter:me}}var ve=le?fe:ge.indentation;return ge.action===oe.IndentAction.Indent&&(ve=Q.shiftIndent(ve)),ue.shouldDecrease(ne)&&(ve=Q.unshiftIndent(ve)),{beforeEnter:le?fe:ce,afterEnter:ve}},e.prototype.getIndentActionForType=function(X,$,Q,J){var ee=this.getScopedLineTokens(X,$.startLineNumber,$.startColumn),te=this.getIndentRulesSupport(ee.languageId);if(!te)return null;var ne,ie=ee.getLineContent(),re=ie.substr(0,$.startColumn-1-ee.firstCharOffset);if(ne=$.isEmpty()?ie.substr($.startColumn-1-ee.firstCharOffset):this.getScopedLineTokens(X,$.endLineNumber,$.endColumn).getLineContent().substr($.endColumn-1-ee.firstCharOffset),!te.shouldDecrease(re+ne)&&te.shouldDecrease(re+Q+ne)){var se=this.getInheritIndentForLine(X,$.startLineNumber,!1);if(!se)return null;var ae=se.indentation;return se.action!==oe.IndentAction.Indent&&(ae=J.unshiftIndent(ae)),ae}return null},e.prototype.getIndentMetadata=function(X,$){var Q=this.getIndentRulesSupport(X.getLanguageIdentifier().id);return Q?$<1||$>X.getLineCount()?null:Q.getIndentMetadata(X.getLineContent($)):null},e.prototype._getOnEnterSupport=function(X){var $=this._getRichEditSupport(X);return $&&$.onEnter||null},e.prototype.getRawEnterActionAtPosition=function(X,$,Q){var J=this.getEnterAction(X,new ne.Range($,Q,$,Q));return J?J.enterAction:null},e.prototype.getEnterAction=function(X,$){var J=this.getIndentationAtPosition(X,$.startLineNumber,$.startColumn),ee=this.getScopedLineTokens(X,$.startLineNumber,$.startColumn),te=this._getOnEnterSupport(ee.languageId);if(!te)return null;var ne,ie=ee.getLineContent(),re=ie.substr(0,$.startColumn-1-ee.firstCharOffset);ne=$.isEmpty()?ie.substr($.startColumn-1-ee.firstCharOffset):this.getScopedLineTokens(X,$.endLineNumber,$.endColumn).getLineContent().substr($.endColumn-1-ee.firstCharOffset);var se=$.startLineNumber,ae="";if(se>1&&0===ee.firstCharOffset){var le=this.getScopedLineTokens(X,se-1);le.languageId===ee.languageId&&(ae=le.getLineContent())}var ue=null;try{ue=te.onEnter(ae,re,ne)}catch(X){Q.onUnexpectedError(X)}return ue?(ue.appendText||(ue.indentAction===oe.IndentAction.Indent||ue.indentAction===oe.IndentAction.IndentOutdent?ue.appendText="\t":ue.appendText=""),ue.removeText&&(J=J.substring(0,J.length-ue.removeText)),{enterAction:ue,indentation:J}):null},e.prototype.getIndentationAtPosition=function(X,$,Q){var J=X.getLineContent($),ee=te.getLeadingWhitespace(J);return ee.length>Q-1&&(ee=ee.substring(0,Q-1)),ee},e.prototype.getScopedLineTokens=function(X,$,Q){X.forceTokenization($);var J=X.getLineTokens($),ee=void 0===Q?X.getLineMaxColumn($)-1:Q-1;return re.createScopedLineTokens(J,ee)},e.prototype.getBracketsSupport=function(X){var $=this._getRichEditSupport(X);return $&&$.brackets||null},e}();$.LanguageConfigurationRegistryImpl=he,$.LanguageConfigurationRegistry=new he})),define(Q[560],n([0,1,28]),(function(X,$,Q){function i(X){if(!X||!Array.isArray(X))return[];for(var $=[],Q=0,J=0,ee=X.length;J<ee;J++){var te=X[J],ne=-1;if("string"==typeof te.fontStyle){ne=0;for(var ie=te.fontStyle.split(" "),oe=0,re=ie.length;oe<re;oe++)switch(ie[oe]){case"italic":ne|=1;break;case"bold":ne|=2;break;case"underline":ne|=4}}var se=null;"string"==typeof te.foreground&&(se=te.foreground);var ae=null;"string"==typeof te.background&&(ae=te.background),$[Q++]=new a(te.token||"",J,ne,se,ae)}return $}function r(X){var $=X.match(ne);if(!$)return 0;switch($[1]){case"comment":return 1;case"string":return 2;case"regex":return 4}throw new Error("Unexpected match for standard token type!")}function s(X,$){return X<$?-1:X>$?1:0}Object.defineProperty($,"__esModule",{value:!0});var a=function(X,$,Q,J,ee){this.token=X,this.index=$,this.fontStyle=Q,this.foreground=J,this.background=ee};$.ParsedTokenThemeRule=a,$.parseTokenTheme=i;var J=/^#?([0-9A-Fa-f]{6})([0-9A-Fa-f]{2})?$/,ee=function(){function e(){this._lastColorId=0,this._id2color=[],this._color2id=new Map}return e.prototype.getId=function(X){if(null===X)return 0;var $=X.match(J);if(!$)throw new Error("Illegal value for token color: "+X);X=$[1].toUpperCase();var ee=this._color2id.get(X);return ee||(ee=++this._lastColorId,this._color2id.set(X,ee),this._id2color[ee]=Q.Color.fromHex("#"+X),ee)},e.prototype.getColorMap=function(){return this._id2color.slice(0)},e}();$.ColorMap=ee;var te=function(){function e(X,$){this._colorMap=X,this._root=$,this._cache=new Map}return e.createFromRawTokenTheme=function(X,$){return this.createFromParsedTokenTheme(i(X),$)},e.createFromParsedTokenTheme=function(X,$){return function o(X,$){X.sort((function(X,$){var Q=s(X.token,$.token);return 0!==Q?Q:X.index-$.index}));for(var Q=0,J="000000",ne="ffffff";X.length>=1&&""===X[0].token;){var re=X.shift();-1!==re.fontStyle&&(Q=re.fontStyle),null!==re.foreground&&(J=re.foreground),null!==re.background&&(ne=re.background)}for(var se=new ee,ae=0,le=$;ae<le.length;ae++){var ue=le[ae];se.getId(ue)}for(var de=se.getId(J),ce=se.getId(ne),he=new ie(Q,de,ce),pe=new oe(he),fe=0,ge=X.length;fe<ge;fe++){var me=X[fe];pe.insert(me.token,me.fontStyle,se.getId(me.foreground),se.getId(me.background))}return new te(se,pe)}(X,$)},e.prototype.getColorMap=function(){return this._colorMap.getColorMap()},e.prototype._match=function(X){return this._root.match(X)},e.prototype.match=function(X,$){var Q=this._cache.get($);if(void 0===Q){var J=this._match($),ee=r($);Q=(J.metadata|ee<<8)>>>0,this._cache.set($,Q)}return(Q|X<<0)>>>0},e}();$.TokenTheme=te;var ne=/\b(comment|string|regex)\b/;$.toStandardTokenType=r,$.strcmp=s;var ie=function(){function e(X,$,Q){this._fontStyle=X,this._foreground=$,this._background=Q,this.metadata=(this._fontStyle<<11|this._foreground<<14|this._background<<23)>>>0}return e.prototype.clone=function(){return new e(this._fontStyle,this._foreground,this._background)},e.prototype.acceptOverwrite=function(X,$,Q){-1!==X&&(this._fontStyle=X),0!==$&&(this._foreground=$),0!==Q&&(this._background=Q),this.metadata=(this._fontStyle<<11|this._foreground<<14|this._background<<23)>>>0},e}();$.ThemeTrieElementRule=ie;var oe=function(){function e(X){this._mainRule=X,this._children=new Map}return e.prototype.match=function(X){if(""===X)return this._mainRule;var $,Q,J=X.indexOf(".");-1===J?($=X,Q=""):($=X.substring(0,J),Q=X.substring(J+1));var ee=this._children.get($);return void 0!==ee?ee.match(Q):this._mainRule},e.prototype.insert=function(X,$,Q,J){if(""!==X){var ee,te,ne=X.indexOf(".");-1===ne?(ee=X,te=""):(ee=X.substring(0,ne),te=X.substring(ne+1));var ie=this._children.get(ee);void 0===ie&&(ie=new e(this._mainRule.clone()),this._children.set(ee,ie)),ie.insert(te,$,Q,J)}else this._mainRule.acceptOverwrite($,Q,J)},e}();$.ThemeTrieElement=oe,$.generateTokensCSSForColorMap=function(X){for(var $=[],Q=1,J=X.length;Q<J;Q++){var ee=X[Q];$[Q]=".mtk"+Q+" { color: "+ee+"; }"}return $.push(".mtki { font-style: italic; }"),$.push(".mtkb { font-weight: bold; }"),$.push(".mtku { text-decoration: underline; text-underline-position: under; }"),$.join("\n")}})),define(Q[561],n([0,1,6,2]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(){function e(){this._onDidChange=new Q.Emitter,this.onDidChange=this._onDidChange.event,this._map=Object.create(null),this._promises=Object.create(null),this._colorMap=null}return e.prototype.fire=function(X){this._onDidChange.fire({changedLanguages:X,changedColorMap:!1})},e.prototype.register=function(X,$){var Q=this;return this._map[X]=$,this.fire([X]),J.toDisposable((function(){Q._map[X]===$&&(delete Q._map[X],Q.fire([X]))}))},e.prototype.getPromise=function(X){var $=this,Q=this.get(X);if(Q)return Promise.resolve(Q);var J=this._promises[X];return J?J.then((function(Q){return $.get(X)})):null},e.prototype.get=function(X){return this._map[X]||null},e.prototype.setColorMap=function(X){this._colorMap=X,this._onDidChange.fire({changedLanguages:Object.keys(this._map),changedColorMap:!0})},e.prototype.getColorMap=function(){return this._colorMap},e.prototype.getDefaultBackground=function(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null},e}();$.TokenizationRegistryImpl=ee})),define(Q[124],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0}),function(X){X[X.Unnecessary=1]="Unnecessary"}($.MarkerTag||($.MarkerTag={})),function(X){X[X.Hint=1]="Hint",X[X.Info=2]="Info",X[X.Warning=4]="Warning",X[X.Error=8]="Error"}($.MarkerSeverity||($.MarkerSeverity={})),function(X){X[X.Unknown=0]="Unknown",X[X.Backspace=1]="Backspace",X[X.Tab=2]="Tab",X[X.Enter=3]="Enter",X[X.Shift=4]="Shift",X[X.Ctrl=5]="Ctrl",X[X.Alt=6]="Alt",X[X.PauseBreak=7]="PauseBreak",X[X.CapsLock=8]="CapsLock",X[X.Escape=9]="Escape",X[X.Space=10]="Space",X[X.PageUp=11]="PageUp",X[X.PageDown=12]="PageDown",X[X.End=13]="End",X[X.Home=14]="Home",X[X.LeftArrow=15]="LeftArrow",X[X.UpArrow=16]="UpArrow",X[X.RightArrow=17]="RightArrow",X[X.DownArrow=18]="DownArrow",X[X.Insert=19]="Insert",X[X.Delete=20]="Delete",X[X.KEY_0=21]="KEY_0",X[X.KEY_1=22]="KEY_1",X[X.KEY_2=23]="KEY_2",X[X.KEY_3=24]="KEY_3",X[X.KEY_4=25]="KEY_4",X[X.KEY_5=26]="KEY_5",X[X.KEY_6=27]="KEY_6",X[X.KEY_7=28]="KEY_7",X[X.KEY_8=29]="KEY_8",X[X.KEY_9=30]="KEY_9",X[X.KEY_A=31]="KEY_A",X[X.KEY_B=32]="KEY_B",X[X.KEY_C=33]="KEY_C",X[X.KEY_D=34]="KEY_D",X[X.KEY_E=35]="KEY_E",X[X.KEY_F=36]="KEY_F",X[X.KEY_G=37]="KEY_G",X[X.KEY_H=38]="KEY_H",X[X.KEY_I=39]="KEY_I",X[X.KEY_J=40]="KEY_J",X[X.KEY_K=41]="KEY_K",X[X.KEY_L=42]="KEY_L",X[X.KEY_M=43]="KEY_M",X[X.KEY_N=44]="KEY_N",X[X.KEY_O=45]="KEY_O",X[X.KEY_P=46]="KEY_P",X[X.KEY_Q=47]="KEY_Q",X[X.KEY_R=48]="KEY_R",X[X.KEY_S=49]="KEY_S",X[X.KEY_T=50]="KEY_T",X[X.KEY_U=51]="KEY_U",X[X.KEY_V=52]="KEY_V",X[X.KEY_W=53]="KEY_W",X[X.KEY_X=54]="KEY_X",X[X.KEY_Y=55]="KEY_Y",X[X.KEY_Z=56]="KEY_Z",X[X.Meta=57]="Meta",X[X.ContextMenu=58]="ContextMenu",X[X.F1=59]="F1",X[X.F2=60]="F2",X[X.F3=61]="F3",X[X.F4=62]="F4",X[X.F5=63]="F5",X[X.F6=64]="F6",X[X.F7=65]="F7",X[X.F8=66]="F8",X[X.F9=67]="F9",X[X.F10=68]="F10",X[X.F11=69]="F11",X[X.F12=70]="F12",X[X.F13=71]="F13",X[X.F14=72]="F14",X[X.F15=73]="F15",X[X.F16=74]="F16",X[X.F17=75]="F17",X[X.F18=76]="F18",X[X.F19=77]="F19",X[X.NumLock=78]="NumLock",X[X.ScrollLock=79]="ScrollLock",X[X.US_SEMICOLON=80]="US_SEMICOLON",X[X.US_EQUAL=81]="US_EQUAL",X[X.US_COMMA=82]="US_COMMA",X[X.US_MINUS=83]="US_MINUS",X[X.US_DOT=84]="US_DOT",X[X.US_SLASH=85]="US_SLASH",X[X.US_BACKTICK=86]="US_BACKTICK",X[X.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",X[X.US_BACKSLASH=88]="US_BACKSLASH",X[X.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",X[X.US_QUOTE=90]="US_QUOTE",X[X.OEM_8=91]="OEM_8",X[X.OEM_102=92]="OEM_102",X[X.NUMPAD_0=93]="NUMPAD_0",X[X.NUMPAD_1=94]="NUMPAD_1",X[X.NUMPAD_2=95]="NUMPAD_2",X[X.NUMPAD_3=96]="NUMPAD_3",X[X.NUMPAD_4=97]="NUMPAD_4",X[X.NUMPAD_5=98]="NUMPAD_5",X[X.NUMPAD_6=99]="NUMPAD_6",X[X.NUMPAD_7=100]="NUMPAD_7",X[X.NUMPAD_8=101]="NUMPAD_8",X[X.NUMPAD_9=102]="NUMPAD_9",X[X.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",X[X.NUMPAD_ADD=104]="NUMPAD_ADD",X[X.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",X[X.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",X[X.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",X[X.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",X[X.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",X[X.ABNT_C1=110]="ABNT_C1",X[X.ABNT_C2=111]="ABNT_C2",X[X.MAX_VALUE=112]="MAX_VALUE"}($.KeyCode||($.KeyCode={})),function(X){X[X.LTR=0]="LTR",X[X.RTL=1]="RTL"}($.SelectionDirection||($.SelectionDirection={})),function(X){X[X.Auto=1]="Auto",X[X.Hidden=2]="Hidden",X[X.Visible=3]="Visible"}($.ScrollbarVisibility||($.ScrollbarVisibility={})),function(X){X[X.Left=1]="Left",X[X.Center=2]="Center",X[X.Right=4]="Right",X[X.Full=7]="Full"}($.OverviewRulerLane||($.OverviewRulerLane={})),function(X){X[X.TextDefined=0]="TextDefined",X[X.LF=1]="LF",X[X.CRLF=2]="CRLF"}($.EndOfLinePreference||($.EndOfLinePreference={})),function(X){X[X.LF=1]="LF",X[X.CRLF=2]="CRLF"}($.DefaultEndOfLine||($.DefaultEndOfLine={})),function(X){X[X.LF=0]="LF",X[X.CRLF=1]="CRLF"}($.EndOfLineSequence||($.EndOfLineSequence={})),function(X){X[X.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",X[X.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",X[X.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",X[X.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"}($.TrackedRangeStickiness||($.TrackedRangeStickiness={})),function(X){X[X.Smooth=0]="Smooth",X[X.Immediate=1]="Immediate"}($.ScrollType||($.ScrollType={})),function(X){X[X.NotSet=0]="NotSet",X[X.ContentFlush=1]="ContentFlush",X[X.RecoverFromMarkers=2]="RecoverFromMarkers",X[X.Explicit=3]="Explicit",X[X.Paste=4]="Paste",X[X.Undo=5]="Undo",X[X.Redo=6]="Redo"}($.CursorChangeReason||($.CursorChangeReason={})),function(X){X[X.None=0]="None",X[X.Small=1]="Small",X[X.Large=2]="Large",X[X.SmallBlocks=3]="SmallBlocks",X[X.LargeBlocks=4]="LargeBlocks"}($.RenderMinimap||($.RenderMinimap={})),function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"}($.WrappingIndent||($.WrappingIndent={})),function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"}($.TextEditorCursorBlinkingStyle||($.TextEditorCursorBlinkingStyle={})),function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"}($.TextEditorCursorStyle||($.TextEditorCursorStyle={})),function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"}($.RenderLineNumbersType||($.RenderLineNumbersType={})),function(X){X[X.EXACT=0]="EXACT",X[X.ABOVE=1]="ABOVE",X[X.BELOW=2]="BELOW"}($.ContentWidgetPositionPreference||($.ContentWidgetPositionPreference={})),function(X){X[X.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",X[X.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",X[X.TOP_CENTER=2]="TOP_CENTER"}($.OverlayWidgetPositionPreference||($.OverlayWidgetPositionPreference={})),function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.TEXTAREA=1]="TEXTAREA",X[X.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",X[X.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",X[X.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",X[X.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",X[X.CONTENT_TEXT=6]="CONTENT_TEXT",X[X.CONTENT_EMPTY=7]="CONTENT_EMPTY",X[X.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",X[X.CONTENT_WIDGET=9]="CONTENT_WIDGET",X[X.OVERVIEW_RULER=10]="OVERVIEW_RULER",X[X.SCROLLBAR=11]="SCROLLBAR",X[X.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",X[X.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"}($.MouseTargetType||($.MouseTargetType={})),function(X){X[X.None=0]="None",X[X.Indent=1]="Indent",X[X.IndentOutdent=2]="IndentOutdent",X[X.Outdent=3]="Outdent"}($.IndentAction||($.IndentAction={})),function(X){X[X.Method=0]="Method",X[X.Function=1]="Function",X[X.Constructor=2]="Constructor",X[X.Field=3]="Field",X[X.Variable=4]="Variable",X[X.Class=5]="Class",X[X.Struct=6]="Struct",X[X.Interface=7]="Interface",X[X.Module=8]="Module",X[X.Property=9]="Property",X[X.Event=10]="Event",X[X.Operator=11]="Operator",X[X.Unit=12]="Unit",X[X.Value=13]="Value",X[X.Constant=14]="Constant",X[X.Enum=15]="Enum",X[X.EnumMember=16]="EnumMember",X[X.Keyword=17]="Keyword",X[X.Text=18]="Text",X[X.Color=19]="Color",X[X.File=20]="File",X[X.Reference=21]="Reference",X[X.Customcolor=22]="Customcolor",X[X.Folder=23]="Folder",X[X.TypeParameter=24]="TypeParameter",X[X.Snippet=25]="Snippet"}($.CompletionItemKind||($.CompletionItemKind={})),function(X){X[X.KeepWhitespace=1]="KeepWhitespace",X[X.InsertAsSnippet=4]="InsertAsSnippet"}($.CompletionItemInsertTextRule||($.CompletionItemInsertTextRule={})),function(X){X[X.Invoke=0]="Invoke",X[X.TriggerCharacter=1]="TriggerCharacter",X[X.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"}($.CompletionTriggerKind||($.CompletionTriggerKind={})),function(X){X[X.Invoke=1]="Invoke",X[X.TriggerCharacter=2]="TriggerCharacter",X[X.ContentChange=3]="ContentChange"}($.SignatureHelpTriggerReason||($.SignatureHelpTriggerReason={})),function(X){X[X.Text=0]="Text",X[X.Read=1]="Read",X[X.Write=2]="Write"}($.DocumentHighlightKind||($.DocumentHighlightKind={})),function(X){X[X.File=0]="File",X[X.Module=1]="Module",X[X.Namespace=2]="Namespace",X[X.Package=3]="Package",X[X.Class=4]="Class",X[X.Method=5]="Method",X[X.Property=6]="Property",X[X.Field=7]="Field",X[X.Constructor=8]="Constructor",X[X.Enum=9]="Enum",X[X.Interface=10]="Interface",X[X.Function=11]="Function",X[X.Variable=12]="Variable",X[X.Constant=13]="Constant",X[X.String=14]="String",X[X.Number=15]="Number",X[X.Boolean=16]="Boolean",X[X.Array=17]="Array",X[X.Object=18]="Object",X[X.Key=19]="Key",X[X.Null=20]="Null",X[X.EnumMember=21]="EnumMember",X[X.Struct=22]="Struct",X[X.Event=23]="Event",X[X.Operator=24]="Operator",X[X.TypeParameter=25]="TypeParameter"}($.SymbolKind||($.SymbolKind={}))})),define(Q[153],n([0,1,24,6,36,25,53,12,3,21,91,124]),(function(X,$,Q,J,ee,te,ne,ie,oe,re,se,ae){Object.defineProperty($,"__esModule",{value:!0});var le=function(){function e(){}return e.chord=function(X,$){return ee.KeyChord(X,$)},e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256,e}();$.KeyMod=le,$.createMonacoBaseAPI=function(){return{editor:void 0,languages:void 0,CancellationTokenSource:Q.CancellationTokenSource,Emitter:J.Emitter,KeyCode:ae.KeyCode,KeyMod:le,Position:ie.Position,Range:oe.Range,Selection:re.Selection,SelectionDirection:ae.SelectionDirection,MarkerSeverity:ae.MarkerSeverity,MarkerTag:ae.MarkerTag,Promise:ne.TPromise,Uri:te.URI,Token:se.Token}}})),define(Q[157],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q=function(){function e(X,$,Q){this.from=0|X,this.to=0|$,this.colorId=0|Q}return e.compare=function(X,$){return X.colorId===$.colorId?X.from===$.from?X.to-$.to:X.from-$.from:X.colorId-$.colorId},e}();$.ColorZone=Q;var J=function(){function e(X,$,Q){this.startLineNumber=X,this.endLineNumber=$,this.color=Q,this._colorZone=null}return e.compare=function(X,$){return X.color===$.color?X.startLineNumber===$.startLineNumber?X.endLineNumber-$.endLineNumber:X.startLineNumber-$.startLineNumber:X.color<$.color?-1:1},e.prototype.setColorZone=function(X){this._colorZone=X},e.prototype.getColorZones=function(){return this._colorZone},e}();$.OverviewRulerZone=J;var ee=function(){function e(X){this._getVerticalOffsetForLine=X,this._zones=[],this._colorZonesInvalid=!1,this._lineHeight=0,this._domWidth=0,this._domHeight=0,this._outerHeight=0,this._pixelRatio=1,this._lastAssignedId=0,this._color2Id=Object.create(null),this._id2Color=[]}return e.prototype.getId2Color=function(){return this._id2Color},e.prototype.setZones=function(X){this._zones=X,this._zones.sort(J.compare)},e.prototype.setLineHeight=function(X){return this._lineHeight!==X&&(this._lineHeight=X,this._colorZonesInvalid=!0,!0)},e.prototype.setPixelRatio=function(X){this._pixelRatio=X,this._colorZonesInvalid=!0},e.prototype.getDOMWidth=function(){return this._domWidth},e.prototype.getCanvasWidth=function(){return this._domWidth*this._pixelRatio},e.prototype.setDOMWidth=function(X){return this._domWidth!==X&&(this._domWidth=X,this._colorZonesInvalid=!0,!0)},e.prototype.getDOMHeight=function(){return this._domHeight},e.prototype.getCanvasHeight=function(){return this._domHeight*this._pixelRatio},e.prototype.setDOMHeight=function(X){return this._domHeight!==X&&(this._domHeight=X,this._colorZonesInvalid=!0,!0)},e.prototype.getOuterHeight=function(){return this._outerHeight},e.prototype.setOuterHeight=function(X){return this._outerHeight!==X&&(this._outerHeight=X,this._colorZonesInvalid=!0,!0)},e.prototype.resolveColorZones=function(){for(var X=this._colorZonesInvalid,$=Math.floor(this._lineHeight),J=Math.floor(this.getCanvasHeight()),ee=J/Math.floor(this._outerHeight),te=Math.floor(4*this._pixelRatio/2),ne=[],ie=0,oe=this._zones.length;ie<oe;ie++){var re=this._zones[ie];if(!X){var se=re.getColorZones();if(se){ne.push(se);continue}}var ae=Math.floor(ee*this._getVerticalOffsetForLine(re.startLineNumber)),le=Math.floor(ee*(this._getVerticalOffsetForLine(re.endLineNumber)+$)),ue=Math.floor((ae+le)/2),de=le-ue;de<te&&(de=te),ue-de<0&&(ue=de),ue+de>J&&(ue=J-de);var ce=re.color,he=this._color2Id[ce];he||(he=++this._lastAssignedId,this._color2Id[ce]=he,this._id2Color[he]=ce);var pe=new Q(ue-de,ue+de,he);re.setColorZone(pe),ne.push(pe)}return this._colorZonesInvalid=!1,ne.sort(Q.compare),ne},e}();$.OverviewZoneManager=ee})),define(Q[83],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q=function(){function e(X,$){this._viewLayout=X,this.viewportData=$,this.scrollWidth=this._viewLayout.getScrollWidth(),this.scrollHeight=this._viewLayout.getScrollHeight(),this.visibleRange=this.viewportData.visibleRange,this.bigNumbersDelta=this.viewportData.bigNumbersDelta;var Q=this._viewLayout.getCurrentViewport();this.scrollTop=Q.top,this.scrollLeft=Q.left,this.viewportWidth=Q.width,this.viewportHeight=Q.height}return e.prototype.getScrolledTopFromAbsoluteTop=function(X){return X-this.scrollTop},e.prototype.getVerticalOffsetForLineNumber=function(X){return this._viewLayout.getVerticalOffsetForLineNumber(X)},e.prototype.getDecorationsInViewport=function(){return this.viewportData.getDecorationsInViewport()},e}();$.RestrictedRenderingContext=Q;var J=function(X){function t($,Q,J){var ee=X.call(this,$,Q)||this;return ee._viewLines=J,ee}return te(t,X),t.prototype.linesVisibleRangesForRange=function(X,$){return this._viewLines.linesVisibleRangesForRange(X,$)},t.prototype.visibleRangeForPosition=function(X){return this._viewLines.visibleRangeForPosition(X)},t}(Q);$.RenderingContext=J;var r=function(X,$){this.lineNumber=X,this.ranges=$};$.LineVisibleRanges=r;var ee=function(){function e(X,$){this.left=Math.round(X),this.width=Math.round($)}return e.prototype.toString=function(){return"["+this.left+","+this.width+"]"},e}();$.HorizontalRange=ee})),define(Q[207],n([0,1,83]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(){function e(X,$){this.left=X,this.width=$}return e.prototype.toString=function(){return"["+this.left+","+this.width+"]"},e.compare=function(X,$){return X.left-$.left},e}(),ee=function(){function e(){}return e._createRange=function(){return this._handyReadyRange||(this._handyReadyRange=document.createRange()),this._handyReadyRange},e._detachRange=function(X,$){X.selectNodeContents($)},e._readClientRects=function(X,$,Q,J,ee){var te=this._createRange();try{return te.setStart(X,$),te.setEnd(Q,J),te.getClientRects()}catch(X){return null}finally{this._detachRange(te,ee)}},e._mergeAdjacentRanges=function(X){if(1===X.length)return[new Q.HorizontalRange(X[0].left,X[0].width)];X.sort(J.compare);for(var $=[],ee=0,te=X[0].left,ne=X[0].width,ie=1,oe=X.length;ie<oe;ie++){var re=X[ie],se=re.left,ae=re.width;te+ne+.9>=se?ne=Math.max(ne,se+ae-te):($[ee++]=new Q.HorizontalRange(te,ne),te=se,ne=ae)}return $[ee++]=new Q.HorizontalRange(te,ne),$},e._createHorizontalRangesFromClientRects=function(X,$){if(!X||0===X.length)return null;for(var Q=[],ee=0,te=X.length;ee<te;ee++){var ne=X[ee];Q[ee]=new J(Math.max(0,ne.left-$),ne.width)}return this._mergeAdjacentRanges(Q)},e.readHorizontalRanges=function(X,$,Q,J,ee,te,ne){var ie=X.children.length-1;if(0>ie)return null;($=Math.min(ie,Math.max(0,$)))!==(J=Math.min(ie,Math.max(0,J)))&&J>0&&0===ee&&(J--,ee=Number.MAX_VALUE);var oe=X.children[$].firstChild,re=X.children[J].firstChild;if(oe&&re||(!oe&&0===Q&&$>0&&(oe=X.children[$-1].firstChild,Q=1073741824),!re&&0===ee&&J>0&&(re=X.children[J-1].firstChild,ee=1073741824)),!oe||!re)return null;Q=Math.min(oe.textContent.length,Math.max(0,Q)),ee=Math.min(re.textContent.length,Math.max(0,ee));var se=this._readClientRects(oe,Q,re,ee,ne);return this._createHorizontalRangesFromClientRects(se,te)},e}();$.RangeUtil=ee})),define(Q[208],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q=function(){function e(X,$,Q,J){this.configuration=X,this.theme=$,this.model=Q,this.viewLayout=Q.viewLayout,this.privateViewEventBus=J}return e.prototype.addEventHandler=function(X){this.privateViewEventBus.addEventHandler(X)},e.prototype.removeEventHandler=function(X){this.privateViewEventBus.removeEventHandler(X)},e}();$.ViewContext=Q})),define(Q[209],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q=function(){function e(X){this._eventHandlerGateKeeper=X,this._eventHandlers=[],this._eventQueue=null,this._isConsumingQueue=!1}return e.prototype.addEventHandler=function(X){for(var $=0,Q=this._eventHandlers.length;$<Q;$++)this._eventHandlers[$]===X&&console.warn("Detected duplicate listener in ViewEventDispatcher",X);this._eventHandlers.push(X)},e.prototype.removeEventHandler=function(X){for(var $=0;$<this._eventHandlers.length;$++)if(this._eventHandlers[$]===X){this._eventHandlers.splice($,1);break}},e.prototype.emit=function(X){this._eventQueue?this._eventQueue.push(X):this._eventQueue=[X],this._isConsumingQueue||this.consumeQueue()},e.prototype.emitMany=function(X){this._eventQueue?this._eventQueue=this._eventQueue.concat(X):this._eventQueue=X,this._isConsumingQueue||this.consumeQueue()},e.prototype.consumeQueue=function(){var X=this;this._eventHandlerGateKeeper((function(){try{X._isConsumingQueue=!0,X._doConsumeQueue()}finally{X._isConsumingQueue=!1}}))},e.prototype._doConsumeQueue=function(){for(;this._eventQueue;){var X=this._eventQueue;this._eventQueue=null;for(var $=this._eventHandlers.slice(0),Q=0,J=$.length;Q<J;Q++)$[Q].handleEvents(X)}},e}();$.ViewEventDispatcher=Q})),define(Q[69],n([0,1,11,2]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var r=function(X){this.type=1,this.canUseLayerHinting=X.canUseLayerHinting,this.pixelRatio=X.pixelRatio,this.editorClassName=X.editorClassName,this.lineHeight=X.lineHeight,this.readOnly=X.readOnly,this.accessibilitySupport=X.accessibilitySupport,this.emptySelectionClipboard=X.emptySelectionClipboard,this.copyWithSyntaxHighlighting=X.copyWithSyntaxHighlighting,this.layoutInfo=X.layoutInfo,this.fontInfo=X.fontInfo,this.viewInfo=X.viewInfo,this.wrappingInfo=X.wrappingInfo};$.ViewConfigurationChangedEvent=r;var s=function(X){this.type=2,this.selections=X};$.ViewCursorStateChangedEvent=s;var a=function(){this.type=3};$.ViewDecorationsChangedEvent=a;var l=function(){this.type=4};$.ViewFlushedEvent=l;var u=function(X){this.type=5,this.isFocused=X};$.ViewFocusChangedEvent=u;var d=function(){this.type=6};$.ViewLineMappingChangedEvent=d;var c=function(X,$){this.type=7,this.fromLineNumber=X,this.toLineNumber=$};$.ViewLinesChangedEvent=c;var h=function(X,$){this.type=8,this.fromLineNumber=X,this.toLineNumber=$};$.ViewLinesDeletedEvent=h;var p=function(X,$){this.type=9,this.fromLineNumber=X,this.toLineNumber=$};$.ViewLinesInsertedEvent=p;var f=function(X,$,Q,J){this.type=10,this.range=X,this.verticalType=$,this.revealHorizontal=Q,this.scrollType=J};$.ViewRevealRangeRequestEvent=f;var g=function(X){this.type=11,this.scrollWidth=X.scrollWidth,this.scrollLeft=X.scrollLeft,this.scrollHeight=X.scrollHeight,this.scrollTop=X.scrollTop,this.scrollWidthChanged=X.scrollWidthChanged,this.scrollLeftChanged=X.scrollLeftChanged,this.scrollHeightChanged=X.scrollHeightChanged,this.scrollTopChanged=X.scrollTopChanged};$.ViewScrollChangedEvent=g;var m=function(X){this.type=12,this.ranges=X};$.ViewTokensChangedEvent=m;var v=function(){this.type=15};$.ViewThemeChangedEvent=v;var _=function(){this.type=13};$.ViewTokensColorsChangedEvent=_;var y=function(){this.type=14};$.ViewZonesChangedEvent=y;var C=function(){this.type=16};$.ViewLanguageConfigurationEvent=C;var ee=function(X){function t(){var $=X.call(this)||this;return $._listeners=[],$._collector=null,$._collectorCnt=0,$}return te(t,X),t.prototype.dispose=function(){this._listeners=[],X.prototype.dispose.call(this)},t.prototype._beginEmit=function(){return this._collectorCnt++,1===this._collectorCnt&&(this._collector=new ne),this._collector},t.prototype._endEmit=function(){if(this._collectorCnt--,0===this._collectorCnt){var X=this._collector.finalize();this._collector=null,X.length>0&&this._emit(X)}},t.prototype._emit=function(X){for(var $=this._listeners.slice(0),J=0,ee=$.length;J<ee;J++)!function(X,$){try{X($)}catch(X){Q.onUnexpectedError(X)}}($[J],X)},t.prototype.addEventListener=function(X){var $=this;return this._listeners.push(X),J.toDisposable((function(){for(var Q=$._listeners,J=0,ee=Q.length;J<ee;J++)if(Q[J]===X){Q.splice(J,1);break}}))},t}(J.Disposable);$.ViewEventEmitter=ee;var ne=function(){function e(){this._eventsLen=0,this._events=[],this._eventsLen=0}return e.prototype.emit=function(X){this._events[this._eventsLen++]=X},e.prototype.finalize=function(){var X=this._events;return this._events=[],X},e}();$.ViewEventsCollector=ne})),define(Q[129],n([0,1,8]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(){function e(X,$,Q,J){this.startColumn=X,this.endColumn=$,this.className=Q,this.type=J}return e._equals=function(X,$){return X.startColumn===$.startColumn&&X.endColumn===$.endColumn&&X.className===$.className&&X.type===$.type},e.equalsArr=function(X,$){var Q=X.length;if(Q!==$.length)return!1;for(var J=0;J<Q;J++)if(!e._equals(X[J],$[J]))return!1;return!0},e.filter=function(X,$,Q,J){if(0===X.length)return[];for(var ee=[],te=0,ne=0,ie=X.length;ne<ie;ne++){var oe=X[ne],re=oe.range;if(!(re.endLineNumber<$||re.startLineNumber>$||re.isEmpty()&&(0===oe.type||3===oe.type))){var se=re.startLineNumber===$?re.startColumn:Q,ae=re.endLineNumber===$?re.endColumn:J;ee[te++]=new e(se,ae,oe.inlineClassName,oe.type)}}return ee},e.compare=function(X,$){return X.startColumn===$.startColumn?X.endColumn===$.endColumn?X.className<$.className?-1:X.className>$.className?1:0:X.endColumn-$.endColumn:X.startColumn-$.startColumn},e}();$.LineDecoration=J;var o=function(X,$,Q){this.startOffset=X,this.endOffset=$,this.className=Q};$.DecorationSegment=o;var ee=function(){function e(){this.stopOffsets=[],this.classNames=[],this.count=0}return e.prototype.consumeLowerThan=function(X,$,Q){for(;this.count>0&&this.stopOffsets[0]<X;){for(var J=0;J+1<this.count&&this.stopOffsets[J]===this.stopOffsets[J+1];)J++;Q.push(new o($,this.stopOffsets[J],this.classNames.join(" "))),$=this.stopOffsets[J]+1,this.stopOffsets.splice(0,J+1),this.classNames.splice(0,J+1),this.count-=J+1}return this.count>0&&$<X&&(Q.push(new o($,X-1,this.classNames.join(" "))),$=X),$},e.prototype.insert=function(X,$){if(0===this.count||this.stopOffsets[this.count-1]<=X)this.stopOffsets.push(X),this.classNames.push($);else for(var Q=0;Q<this.count;Q++)if(this.stopOffsets[Q]>=X){this.stopOffsets.splice(Q,0,X),this.classNames.splice(Q,0,$);break}this.count++},e}(),te=function(){function e(){}return e.normalize=function(X,$){if(0===$.length)return[];for(var J=[],te=new ee,ne=0,ie=0,oe=$.length;ie<oe;ie++){var re=$[ie],se=re.startColumn,ae=re.endColumn,le=re.className;if(se>1&&(ue=X.charCodeAt(se-2),Q.isHighSurrogate(ue)&&se--),ae>1){var ue=X.charCodeAt(ae-2);Q.isHighSurrogate(ue)&&ae--}var de=se-1,ce=ae-2;ne=te.consumeLowerThan(de,ne,J),0===te.count&&(ne=de),te.insert(ce,le)}return te.consumeLowerThan(1073741824,ne,J),J},e}();$.LineDecorationsNormalizer=te})),define(Q[103],n([0,1,8,121,129]),(function(X,$,Q,J,ee){function r(X,$){if(0===X.lineContent.length){var J=0,te="<span><span> </span></span>";if(X.lineDecorations.length>0){for(var ie=[],oe=0,re=X.lineDecorations.length;oe<re;oe++){var se=X.lineDecorations[oe];1===se.type&&(ie.push(X.lineDecorations[oe].className),J|=1),2===se.type&&(ie.push(X.lineDecorations[oe].className),J|=2)}0!==J&&(te='<span><span class="'+ie.join(" ")+'"></span></span>')}return $.appendASCIIString(te),new u(new ne(0,0),!1,J)}return function(X,$){var J=X.fontIsMonospace,ee=X.canUseHalfwidthRightwardsArrow,te=X.containsForeignElements,ie=X.lineContent,oe=X.len,re=X.isOverflowing,se=X.parts,ae=X.tabSize,le=X.containsRTL,ue=X.spaceWidth,de=X.renderWhitespace,ce=X.renderControlCharacters,he=new ne(oe+1,se.length),pe=0,fe=0,ge=0,me=0,ve=0;$.appendASCIIString("<span>");for(var _e=0,ye=se.length;_e<ye;_e++){ve+=me;var be=se[_e],Ce=be.endIndex,we=be.type,Se=0!==de&&we.indexOf("vs-whitespace")>=0;if(ge=0,$.appendASCIIString('<span class="'),$.appendASCIIString(we),$.appendASCII(34),Se){for(var Ee=0,Le=pe,xe=fe;Le<Ce;Le++)9===(Ie=ie.charCodeAt(Le))?(xe+=(De=ae-(Le+xe)%ae)-1,Ee+=De):Ee++;for(J||"vs-whitespace"!==we&&te||($.appendASCIIString(' style="width:'),$.appendASCIIString(String(ue*Ee)),$.appendASCIIString('px"')),$.appendASCII(62);pe<Ce;pe++){if(he.setPartData(pe,_e,ge,ve),9===(Ie=ie.charCodeAt(pe)))for(fe+=(De=ae-(pe+fe)%ae)-1,ge+=De-1,De>0&&(!ee||De>1?$.write1(8594):$.write1(65515),De--);De>0;)$.write1(160),De--;else $.write1(183);ge++}me=Ee}else{for(Ee=0,le&&$.appendASCIIString(' dir="ltr"'),$.appendASCII(62);pe<Ce;pe++){he.setPartData(pe,_e,ge,ve);var Ie=ie.charCodeAt(pe);switch(Ie){case 9:var De=ae-(pe+fe)%ae;for(fe+=De-1,ge+=De-1;De>0;)$.write1(160),Ee++,De--;break;case 32:$.write1(160),Ee++;break;case 60:$.appendASCIIString("&lt;"),Ee++;break;case 62:$.appendASCIIString("&gt;"),Ee++;break;case 38:$.appendASCIIString("&amp;"),Ee++;break;case 0:$.appendASCIIString("&#00;"),Ee++;break;case 65279:case 8232:$.write1(65533),Ee++;break;default:Q.isFullWidthCharacter(Ie)&&fe++,ce&&Ie<32?($.write1(9216+Ie),Ee++):($.write1(Ie),Ee++)}ge++}me=Ee}$.appendASCIIString("</span>")}return he.setPartData(oe,se.length-1,ge,ve),re&&$.appendASCIIString("<span>&hellip;</span>"),$.appendASCIIString("</span>"),new u(he,le,te)}(function(X){var $,J,te=X.useMonospaceOptimizations,ne=X.lineContent;-1!==X.stopRenderingLineAfter&&X.stopRenderingLineAfter<ne.length?($=!0,J=X.stopRenderingLineAfter):($=!1,J=ne.length);var ie=function(X,$,Q){var J=[],ee=0;$>0&&(J[ee++]=new s($,""));for(var te=0,ne=X.getCount();te<ne;te++){var ie=X.getEndOffset(te);if(!(ie<=$)){var oe=X.getClassName(te);if(ie>=Q){J[ee++]=new s(Q,oe);break}J[ee++]=new s(ie,oe)}}return J}(X.lineTokens,X.fauxIndentLength,J);2!==X.renderWhitespace&&1!==X.renderWhitespace||(ie=function(X,$,J,ee,te,ne,ie,oe){var re,se=[],ae=0,le=0,ue=ee[le].type,de=ee[le].endIndex,ce=ee.length,he=Q.firstNonWhitespaceIndex(X);-1===he?(he=$,re=$):re=Q.lastNonWhitespaceIndex(X);for(var pe=0,fe=0;fe<te;fe++)9===(me=X.charCodeAt(fe))?pe=ne:Q.isFullWidthCharacter(me)?pe+=2:pe++;pe%=ne;var ge=!1;for(fe=te;fe<$;fe++){var me=X.charCodeAt(fe),ve=void 0;if(fe<he||fe>re)ve=!0;else if(9===me)ve=!0;else if(32===me)if(oe)if(ge)ve=!0;else{var _e=fe+1<$?X.charCodeAt(fe+1):0;ve=32===_e||9===_e}else ve=!0;else ve=!1;ge?(!ve||!ie&&pe>=ne)&&(se[ae++]=new s(fe,"vs-whitespace"),pe%=ne):(fe===de||ve&&fe>te)&&(se[ae++]=new s(fe,ue),pe%=ne),9===me?pe=ne:Q.isFullWidthCharacter(me)?pe+=2:pe++,ge=ve,fe===de&&++le<ce&&(ue=ee[le].type,de=ee[le].endIndex)}var ye=!1;if(ge)if(J&&oe){var be=$>0?X.charCodeAt($-1):0,Ce=$>1?X.charCodeAt($-2):0;32===be&&32!==Ce&&9!==Ce||(ye=!0)}else ye=!0;return se[ae++]=new s($,ye?"vs-whitespace":ue),se}(ne,J,X.continuesWithWrappedLine,ie,X.fauxIndentLength,X.tabSize,te,1===X.renderWhitespace));var oe=0;if(X.lineDecorations.length>0){for(var re=0,se=X.lineDecorations.length;re<se;re++){var ae=X.lineDecorations[re];3===ae.type||1===ae.type?oe|=1:2===ae.type&&(oe|=2)}ie=function(X,$,Q,J){J.sort(ee.LineDecoration.compare);for(var te=ee.LineDecorationsNormalizer.normalize(X,J),ne=te.length,ie=0,oe=[],re=0,se=0,ae=0,le=Q.length;ae<le;ae++){for(var ue=Q[ae],de=ue.endIndex,ce=ue.type;ie<ne&&te[ie].startOffset<de;){var he=te[ie];if(he.startOffset>se&&(se=he.startOffset,oe[re++]=new s(se,ce)),!(he.endOffset+1<=de)){se=de,oe[re++]=new s(se,ce+" "+he.className);break}se=he.endOffset+1,oe[re++]=new s(se,ce+" "+he.className),ie++}de>se&&(se=de,oe[re++]=new s(se,ce))}var pe=Q[Q.length-1].endIndex;if(ie<ne&&te[ie].startOffset===pe){for(var fe=[];ie<ne&&te[ie].startOffset===pe;)fe.push(te[ie].className),ie++;oe[re++]=new s(se,fe.join(" "))}return oe}(ne,0,ie,X.lineDecorations)}return X.containsRTL||(ie=function(X,$,Q){var J=0,ee=[],te=0;if(Q)for(var ne=0,ie=$.length;ne<ie;ne++){if(J+50<(le=(ue=$[ne]).endIndex)){for(var oe=ue.type,re=-1,se=J,ae=J;ae<le;ae++)32===X.charCodeAt(ae)&&(re=ae),-1!==re&&ae-se>=50&&(ee[te++]=new s(re+1,oe),se=re+1,re=-1);se!==le&&(ee[te++]=new s(le,oe))}else ee[te++]=ue;J=le}else for(ne=0,ie=$.length;ne<ie;ne++){var le,ue=$[ne],de=(le=ue.endIndex)-J;if(de>50){oe=ue.type;var ce=Math.ceil(de/50);for(ae=1;ae<ce;ae++){var he=J+50*ae;ee[te++]=new s(he,oe)}ee[te++]=new s(le,oe)}else ee[te++]=ue;J=le}return ee}(ne,ie,!X.isBasicASCII||X.fontLigatures)),new c(te,X.canUseHalfwidthRightwardsArrow,ne,J,$,ie,oe,X.tabSize,X.containsRTL,X.spaceWidth,X.renderWhitespace,X.renderControlCharacters)}(X),$)}Object.defineProperty($,"__esModule",{value:!0});var s=function(X,$){this.endIndex=X,this.type=$},te=function(){function e(X,$,Q,J,ee,te,ne,ie,oe,re,se,ae,le,ue,de){this.useMonospaceOptimizations=X,this.canUseHalfwidthRightwardsArrow=$,this.lineContent=Q,this.continuesWithWrappedLine=J,this.isBasicASCII=ee,this.containsRTL=te,this.fauxIndentLength=ne,this.lineTokens=ie,this.lineDecorations=oe,this.tabSize=re,this.spaceWidth=se,this.stopRenderingLineAfter=ae,this.renderWhitespace="all"===le?2:"boundary"===le?1:0,this.renderControlCharacters=ue,this.fontLigatures=de}return e.prototype.equals=function(X){return this.useMonospaceOptimizations===X.useMonospaceOptimizations&&this.canUseHalfwidthRightwardsArrow===X.canUseHalfwidthRightwardsArrow&&this.lineContent===X.lineContent&&this.continuesWithWrappedLine===X.continuesWithWrappedLine&&this.isBasicASCII===X.isBasicASCII&&this.containsRTL===X.containsRTL&&this.fauxIndentLength===X.fauxIndentLength&&this.tabSize===X.tabSize&&this.spaceWidth===X.spaceWidth&&this.stopRenderingLineAfter===X.stopRenderingLineAfter&&this.renderWhitespace===X.renderWhitespace&&this.renderControlCharacters===X.renderControlCharacters&&this.fontLigatures===X.fontLigatures&&ee.LineDecoration.equalsArr(this.lineDecorations,X.lineDecorations)&&this.lineTokens.equals(X.lineTokens)},e}();$.RenderLineInput=te;var ne=function(){function e(X,$){this.length=X,this._data=new Uint32Array(this.length),this._absoluteOffsets=new Uint32Array(this.length)}return e.getPartIndex=function(X){return(4294901760&X)>>>16},e.getCharIndex=function(X){return(65535&X)>>>0},e.prototype.setPartData=function(X,$,Q,J){var ee=($<<16|Q<<0)>>>0;this._data[X]=ee,this._absoluteOffsets[X]=J+Q},e.prototype.getAbsoluteOffsets=function(){return this._absoluteOffsets},e.prototype.charOffsetToPartData=function(X){return 0===this.length?0:X<0?this._data[0]:X>=this.length?this._data[this.length-1]:this._data[X]},e.prototype.partDataToCharOffset=function(X,$,Q){if(0===this.length)return 0;for(var J=(X<<16|Q<<0)>>>0,ee=0,te=this.length-1;ee+1<te;){var ne=ee+te>>>1,ie=this._data[ne];if(ie===J)return ne;ie>J?te=ne:ee=ne}if(ee===te)return ee;var oe=this._data[ee],re=this._data[te];if(oe===J)return ee;if(re===J)return te;var se=e.getPartIndex(oe);return Q-e.getCharIndex(oe)<=(se!==e.getPartIndex(re)?$:e.getCharIndex(re))-Q?ee:te},e}();$.CharacterMapping=ne;var u=function(X,$,Q){this.characterMapping=X,this.containsRTL=$,this.containsForeignElements=Q};$.RenderLineOutput=u,$.renderViewLine=r;var d=function(X,$,Q,J){this.characterMapping=X,this.html=$,this.containsRTL=Q,this.containsForeignElements=J};$.RenderLineOutput2=d,$.renderViewLine2=function(X){var $=J.createStringBuilder(1e4),Q=r(X,$);return new d(Q.characterMapping,$.build(),Q.containsRTL,Q.containsForeignElements)};var c=function(X,$,Q,J,ee,te,ne,ie,oe,re,se,ae){this.fontIsMonospace=X,this.canUseHalfwidthRightwardsArrow=$,this.lineContent=Q,this.len=J,this.isOverflowing=ee,this.parts=te,this.containsForeignElements=ne,this.tabSize=ie,this.containsRTL=oe,this.spaceWidth=re,this.renderWhitespace=se,this.renderControlCharacters=ae}})),define(Q[213],n([0,1,3]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(){function e(X,$,J,ee){this.selections=X,this.startLineNumber=0|$.startLineNumber,this.endLineNumber=0|$.endLineNumber,this.relativeVerticalOffset=$.relativeVerticalOffset,this.bigNumbersDelta=0|$.bigNumbersDelta,this.whitespaceViewportData=J,this._model=ee,this.visibleRange=new Q.Range($.startLineNumber,this._model.getLineMinColumn($.startLineNumber),$.endLineNumber,this._model.getLineMaxColumn($.endLineNumber))}return e.prototype.getViewLineRenderingData=function(X){return this._model.getViewLineRenderingData(this.visibleRange,X)},e.prototype.getDecorationsInViewport=function(){return this._model.getDecorationsInViewport(this.visibleRange)},e}();$.ViewportData=J})),define(Q[214],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q=function(){function e(){this._heights=[],this._minWidths=[],this._ids=[],this._afterLineNumbers=[],this._ordinals=[],this._prefixSum=[],this._prefixSumValidIndex=-1,this._whitespaceId2Index={},this._lastWhitespaceId=0,this._minWidth=-1}return e.findInsertionIndex=function(X,$,Q,J){for(var ee=0,te=X.length;ee<te;){var ne=ee+te>>>1;$===X[ne]?J<Q[ne]?te=ne:ee=ne+1:$<X[ne]?te=ne:ee=ne+1}return ee},e.prototype.insertWhitespace=function(X,$,Q,J){X|=0,$|=0,Q|=0,J|=0;var ee=++this._lastWhitespaceId,te=e.findInsertionIndex(this._afterLineNumbers,X,this._ordinals,$);return this._insertWhitespaceAtIndex(ee,te,X,$,Q,J),this._minWidth=-1,ee},e.prototype._insertWhitespaceAtIndex=function(X,$,Q,J,ee,te){X|=0,$|=0,Q|=0,J|=0,ee|=0,te|=0,this._heights.splice($,0,ee),this._minWidths.splice($,0,te),this._ids.splice($,0,X),this._afterLineNumbers.splice($,0,Q),this._ordinals.splice($,0,J),this._prefixSum.splice($,0,0);for(var ne=Object.keys(this._whitespaceId2Index),ie=0,oe=ne.length;ie<oe;ie++){var re=ne[ie],se=this._whitespaceId2Index[re];se>=$&&(this._whitespaceId2Index[re]=se+1)}this._whitespaceId2Index[X.toString()]=$,this._prefixSumValidIndex=Math.min(this._prefixSumValidIndex,$-1)},e.prototype.changeWhitespace=function(X,$,Q){X|=0,$|=0,Q|=0;var J=!1;return J=this.changeWhitespaceHeight(X,Q)||J,this.changeWhitespaceAfterLineNumber(X,$)||J},e.prototype.changeWhitespaceHeight=function(X,$){$|=0;var Q=(X|=0).toString();if(this._whitespaceId2Index.hasOwnProperty(Q)){var J=this._whitespaceId2Index[Q];if(this._heights[J]!==$)return this._heights[J]=$,this._prefixSumValidIndex=Math.min(this._prefixSumValidIndex,J-1),!0}return!1},e.prototype.changeWhitespaceAfterLineNumber=function(X,$){$|=0;var Q=(X|=0).toString();if(this._whitespaceId2Index.hasOwnProperty(Q)){var J=this._whitespaceId2Index[Q];if(this._afterLineNumbers[J]!==$){var ee=this._ordinals[J],te=this._heights[J],ne=this._minWidths[J];this.removeWhitespace(X);var ie=e.findInsertionIndex(this._afterLineNumbers,$,this._ordinals,ee);return this._insertWhitespaceAtIndex(X,ie,$,ee,te,ne),!0}}return!1},e.prototype.removeWhitespace=function(X){var $=(X|=0).toString();if(this._whitespaceId2Index.hasOwnProperty($)){var Q=this._whitespaceId2Index[$];return delete this._whitespaceId2Index[$],this._removeWhitespaceAtIndex(Q),this._minWidth=-1,!0}return!1},e.prototype._removeWhitespaceAtIndex=function(X){X|=0,this._heights.splice(X,1),this._minWidths.splice(X,1),this._ids.splice(X,1),this._afterLineNumbers.splice(X,1),this._ordinals.splice(X,1),this._prefixSum.splice(X,1),this._prefixSumValidIndex=Math.min(this._prefixSumValidIndex,X-1);for(var $=Object.keys(this._whitespaceId2Index),Q=0,J=$.length;Q<J;Q++){var ee=$[Q],te=this._whitespaceId2Index[ee];te>=X&&(this._whitespaceId2Index[ee]=te-1)}},e.prototype.onLinesDeleted=function(X,$){X|=0,$|=0;for(var Q=0,J=this._afterLineNumbers.length;Q<J;Q++){var ee=this._afterLineNumbers[Q];X<=ee&&ee<=$?this._afterLineNumbers[Q]=X-1:ee>$&&(this._afterLineNumbers[Q]-=$-X+1)}},e.prototype.onLinesInserted=function(X,$){X|=0,$|=0;for(var Q=0,J=this._afterLineNumbers.length;Q<J;Q++)X<=this._afterLineNumbers[Q]&&(this._afterLineNumbers[Q]+=$-X+1)},e.prototype.getTotalHeight=function(){return 0===this._heights.length?0:this.getAccumulatedHeight(this._heights.length-1)},e.prototype.getAccumulatedHeight=function(X){X|=0;var $=Math.max(0,this._prefixSumValidIndex+1);0===$&&(this._prefixSum[0]=this._heights[0],$++);for(var Q=$;Q<=X;Q++)this._prefixSum[Q]=this._prefixSum[Q-1]+this._heights[Q];return this._prefixSumValidIndex=Math.max(this._prefixSumValidIndex,X),this._prefixSum[X]},e.prototype.getAccumulatedHeightBeforeLineNumber=function(X){X|=0;var $=this._findLastWhitespaceBeforeLineNumber(X);return-1===$?0:this.getAccumulatedHeight($)},e.prototype._findLastWhitespaceBeforeLineNumber=function(X){X|=0;for(var $=this._afterLineNumbers,Q=0,J=$.length-1;Q<=J;){var ee=Q+((J-Q|0)/2|0)|0;if($[ee]<X){if(ee+1>=$.length||$[ee+1]>=X)return ee;Q=ee+1|0}else J=ee-1|0}return-1},e.prototype._findFirstWhitespaceAfterLineNumber=function(X){X|=0;var $=this._findLastWhitespaceBeforeLineNumber(X)+1;return $<this._heights.length?$:-1},e.prototype.getFirstWhitespaceIndexAfterLineNumber=function(X){return X|=0,this._findFirstWhitespaceAfterLineNumber(X)},e.prototype.getCount=function(){return this._heights.length},e.prototype.getMinWidth=function(){if(-1===this._minWidth){for(var X=0,$=0,Q=this._minWidths.length;$<Q;$++)X=Math.max(X,this._minWidths[$]);this._minWidth=X}return this._minWidth},e.prototype.getAfterLineNumberForWhitespaceIndex=function(X){return X|=0,this._afterLineNumbers[X]},e.prototype.getIdForWhitespaceIndex=function(X){return X|=0,this._ids[X]},e.prototype.getHeightForWhitespaceIndex=function(X){return X|=0,this._heights[X]},e.prototype.getWhitespaces=function(X){X|=0;for(var $=[],Q=0;Q<this._heights.length;Q++)$.push({id:this._ids[Q],afterLineNumber:this._afterLineNumbers[Q],heightInLines:this._heights[Q]/X});return $},e}();$.WhitespaceComputer=Q})),define(Q[215],n([0,1,214]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(){function e(X,$){this._lineCount=X,this._lineHeight=$,this._whitespaces=new Q.WhitespaceComputer}return e.prototype.setLineHeight=function(X){this._lineHeight=X},e.prototype.onFlushed=function(X){this._lineCount=X},e.prototype.insertWhitespace=function(X,$,Q,J){return this._whitespaces.insertWhitespace(X,$,Q,J)},e.prototype.changeWhitespace=function(X,$,Q){return this._whitespaces.changeWhitespace(X,$,Q)},e.prototype.removeWhitespace=function(X){return this._whitespaces.removeWhitespace(X)},e.prototype.onLinesDeleted=function(X,$){this._lineCount-=$-X+1,this._whitespaces.onLinesDeleted(X,$)},e.prototype.onLinesInserted=function(X,$){this._lineCount+=$-X+1,this._whitespaces.onLinesInserted(X,$)},e.prototype.getLinesTotalHeight=function(){return this._lineHeight*this._lineCount+this._whitespaces.getTotalHeight()},e.prototype.getVerticalOffsetForLineNumber=function(X){return((X|=0)>1?this._lineHeight*(X-1):0)+this._whitespaces.getAccumulatedHeightBeforeLineNumber(X)},e.prototype.getWhitespaceAccumulatedHeightBeforeLineNumber=function(X){return this._whitespaces.getAccumulatedHeightBeforeLineNumber(X)},e.prototype.getWhitespaceMinWidth=function(){return this._whitespaces.getMinWidth()},e.prototype.isAfterLines=function(X){return X>this.getLinesTotalHeight()},e.prototype.getLineNumberAtOrAfterVerticalOffset=function(X){if((X|=0)<0)return 1;for(var $=0|this._lineCount,Q=this._lineHeight,J=1,ee=$;J<ee;){var te=(J+ee)/2|0,ne=0|this.getVerticalOffsetForLineNumber(te);if(X>=ne+Q)J=te+1;else{if(X>=ne)return te;ee=te}}return J>$?$:J},e.prototype.getLinesViewportData=function(X,$){X|=0,$|=0;var Q,J,ee=this._lineHeight,te=0|this.getLineNumberAtOrAfterVerticalOffset(X),ne=0|this.getVerticalOffsetForLineNumber(te),ie=0|this._lineCount,oe=0|this._whitespaces.getFirstWhitespaceIndexAfterLineNumber(te),re=0|this._whitespaces.getCount();-1===oe?(oe=re,J=ie+1,Q=0):(J=0|this._whitespaces.getAfterLineNumberForWhitespaceIndex(oe),Q=0|this._whitespaces.getHeightForWhitespaceIndex(oe));var se=ne,ae=se,le=0;ne>=5e5&&(le=5e5*Math.floor(ne/5e5),ae-=le=Math.floor(le/ee)*ee);for(var ue=[],de=X+($-X)/2,ce=-1,he=te;he<=ie;he++){if(-1===ce){(se<=de&&de<se+ee||se>de)&&(ce=he)}for(se+=ee,ue[he-te]=ae,ae+=ee;J===he;)ae+=Q,se+=Q,++oe>=re?J=ie+1:(J=0|this._whitespaces.getAfterLineNumberForWhitespaceIndex(oe),Q=0|this._whitespaces.getHeightForWhitespaceIndex(oe));if(se>=$){ie=he;break}}-1===ce&&(ce=ie);var pe=0|this.getVerticalOffsetForLineNumber(ie),fe=te,ge=ie;return fe<ge&&ne<X&&fe++,fe<ge&&pe+ee>$&&ge--,{bigNumbersDelta:le,startLineNumber:te,endLineNumber:ie,relativeVerticalOffset:ue,centeredLineNumber:ce,completelyVisibleStartLineNumber:fe,completelyVisibleEndLineNumber:ge}},e.prototype.getVerticalOffsetForWhitespaceIndex=function(X){X|=0;var $=this._whitespaces.getAfterLineNumberForWhitespaceIndex(X);return($>=1?this._lineHeight*$:0)+(X>0?this._whitespaces.getAccumulatedHeight(X-1):0)},e.prototype.getWhitespaceIndexAtOrAfterVerticallOffset=function(X){X|=0;var $,Q,J=0,ee=this._whitespaces.getCount()-1;if(ee<0)return-1;if(X>=this.getVerticalOffsetForWhitespaceIndex(ee)+this._whitespaces.getHeightForWhitespaceIndex(ee))return-1;for(;J<ee;)if($=Math.floor((J+ee)/2),X>=(Q=this.getVerticalOffsetForWhitespaceIndex($))+this._whitespaces.getHeightForWhitespaceIndex($))J=$+1;else{if(X>=Q)return $;ee=$}return J},e.prototype.getWhitespaceAtVerticalOffset=function(X){X|=0;var $=this.getWhitespaceIndexAtOrAfterVerticallOffset(X);if($<0)return null;if($>=this._whitespaces.getCount())return null;var Q=this.getVerticalOffsetForWhitespaceIndex($);if(Q>X)return null;var J=this._whitespaces.getHeightForWhitespaceIndex($);return{id:this._whitespaces.getIdForWhitespaceIndex($),afterLineNumber:this._whitespaces.getAfterLineNumberForWhitespaceIndex($),verticalOffset:Q,height:J}},e.prototype.getWhitespaceViewportData=function(X,$){X|=0,$|=0;var Q=this.getWhitespaceIndexAtOrAfterVerticallOffset(X),J=this._whitespaces.getCount()-1;if(Q<0)return[];for(var ee=[],te=Q;te<=J;te++){var ne=this.getVerticalOffsetForWhitespaceIndex(te),ie=this._whitespaces.getHeightForWhitespaceIndex(te);if(ne>=$)break;ee.push({id:this._whitespaces.getIdForWhitespaceIndex(te),afterLineNumber:this._whitespaces.getAfterLineNumberForWhitespaceIndex(te),verticalOffset:ne,height:ie})}return ee},e.prototype.getWhitespaces=function(){return this._whitespaces.getWhitespaces(this._lineHeight)},e}();$.LinesLayout=J})),define(Q[131],n([0,1,101]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var i=function(X,$){this.index=X,this.remainder=$};$.PrefixSumIndexOfResult=i;var J=function(){function e(X){this.values=X,this.prefixSum=new Uint32Array(X.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}return e.prototype.getCount=function(){return this.values.length},e.prototype.insertValues=function(X,$){X=Q.toUint32(X);var J=this.values,ee=this.prefixSum,te=$.length;return 0!==te&&(this.values=new Uint32Array(J.length+te),this.values.set(J.subarray(0,X),0),this.values.set(J.subarray(X),X+te),this.values.set($,X),X-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=X-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(ee.subarray(0,this.prefixSumValidIndex[0]+1)),!0)},e.prototype.changeValue=function(X,$){return X=Q.toUint32(X),$=Q.toUint32($),this.values[X]!==$&&(this.values[X]=$,X-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=X-1),!0)},e.prototype.removeValues=function(X,$){X=Q.toUint32(X),$=Q.toUint32($);var J=this.values,ee=this.prefixSum;if(X>=J.length)return!1;var te=J.length-X;return $>=te&&($=te),0!==$&&(this.values=new Uint32Array(J.length-$),this.values.set(J.subarray(0,X),0),this.values.set(J.subarray(X+$),X),this.prefixSum=new Uint32Array(this.values.length),X-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=X-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(ee.subarray(0,this.prefixSumValidIndex[0]+1)),!0)},e.prototype.getTotalValue=function(){return 0===this.values.length?0:this._getAccumulatedValue(this.values.length-1)},e.prototype.getAccumulatedValue=function(X){return X<0?0:(X=Q.toUint32(X),this._getAccumulatedValue(X))},e.prototype._getAccumulatedValue=function(X){if(X<=this.prefixSumValidIndex[0])return this.prefixSum[X];var $=this.prefixSumValidIndex[0]+1;0===$&&(this.prefixSum[0]=this.values[0],$++),X>=this.values.length&&(X=this.values.length-1);for(var Q=$;Q<=X;Q++)this.prefixSum[Q]=this.prefixSum[Q-1]+this.values[Q];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],X),this.prefixSum[X]},e.prototype.getIndexOf=function(X){X=Math.floor(X),this.getTotalValue();for(var $=0,Q=this.values.length-1,J=0,ee=0,te=0;$<=Q;)if(J=$+(Q-$)/2|0,X<(te=(ee=this.prefixSum[J])-this.values[J]))Q=J-1;else{if(!(X>=ee))break;$=J+1}return new i(J,X-te)},e}();$.PrefixSumComputer=J;var ee=function(){function e(X){this._cacheAccumulatedValueStart=0,this._cache=null,this._actual=new J(X),this._bustCache()}return e.prototype._bustCache=function(){this._cacheAccumulatedValueStart=0,this._cache=null},e.prototype.insertValues=function(X,$){this._actual.insertValues(X,$)&&this._bustCache()},e.prototype.changeValue=function(X,$){this._actual.changeValue(X,$)&&this._bustCache()},e.prototype.removeValues=function(X,$){this._actual.removeValues(X,$)&&this._bustCache()},e.prototype.getTotalValue=function(){return this._actual.getTotalValue()},e.prototype.getAccumulatedValue=function(X){return this._actual.getAccumulatedValue(X)},e.prototype.getIndexOf=function(X){if(X=Math.floor(X),null!==this._cache){var $=X-this._cacheAccumulatedValueStart;if($>=0&&$<this._cache.length)return this._cache[$]}return this._actual.getIndexOf(X)},e.prototype.warmUpCache=function(X,$){for(var Q=[],J=X;J<=$;J++)Q[J-X]=this.getIndexOf(J);this._cache=Q,this._cacheAccumulatedValueStart=X},e}();$.PrefixSumComputerWithCache=ee})),define(Q[217],n([0,1,12,131]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(){function e(X,$,Q,J){this._uri=X,this._lines=$,this._eol=Q,this._versionId=J,this._lineStarts=null}return e.prototype.dispose=function(){this._lines.length=0},e.prototype.getText=function(){return this._lines.join(this._eol)},e.prototype.onEvents=function(X){X.eol&&X.eol!==this._eol&&(this._eol=X.eol,this._lineStarts=null);for(var $=X.changes,J=0,ee=$.length;J<ee;J++){var te=$[J];this._acceptDeleteRange(te.range),this._acceptInsertText(new Q.Position(te.range.startLineNumber,te.range.startColumn),te.text)}this._versionId=X.versionId},e.prototype._ensureLineStarts=function(){if(!this._lineStarts){for(var X=this._eol.length,$=this._lines.length,Q=new Uint32Array($),ee=0;ee<$;ee++)Q[ee]=this._lines[ee].length+X;this._lineStarts=new J.PrefixSumComputer(Q)}},e.prototype._setLineText=function(X,$){this._lines[X]=$,this._lineStarts&&this._lineStarts.changeValue(X,this._lines[X].length+this._eol.length)},e.prototype._acceptDeleteRange=function(X){if(X.startLineNumber!==X.endLineNumber)this._setLineText(X.startLineNumber-1,this._lines[X.startLineNumber-1].substring(0,X.startColumn-1)+this._lines[X.endLineNumber-1].substring(X.endColumn-1)),this._lines.splice(X.startLineNumber,X.endLineNumber-X.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(X.startLineNumber,X.endLineNumber-X.startLineNumber);else{if(X.startColumn===X.endColumn)return;this._setLineText(X.startLineNumber-1,this._lines[X.startLineNumber-1].substring(0,X.startColumn-1)+this._lines[X.startLineNumber-1].substring(X.endColumn-1))}},e.prototype._acceptInsertText=function(X,$){if(0!==$.length){var Q=$.split(/\r\n|\r|\n/);if(1!==Q.length){Q[Q.length-1]+=this._lines[X.lineNumber-1].substring(X.column-1),this._setLineText(X.lineNumber-1,this._lines[X.lineNumber-1].substring(0,X.column-1)+Q[0]);for(var J=new Uint32Array(Q.length-1),ee=1;ee<Q.length;ee++)this._lines.splice(X.lineNumber+ee-1,0,Q[ee]),J[ee-1]=Q[ee].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(X.lineNumber,J)}else this._setLineText(X.lineNumber-1,this._lines[X.lineNumber-1].substring(0,X.column-1)+Q[0]+this._lines[X.lineNumber-1].substring(X.column-1))}},e}();$.MirrorTextModel=ee})),define(Q[218],n([0,1,22,130,87,17,25,12,3,453,217,90,523,547,153]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le,ue,de,ce){Object.defineProperty($,"__esModule",{value:!0});var he=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),Object.defineProperty(t.prototype,"uri",{get:function(){return this._uri},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"version",{get:function(){return this._versionId},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"eol",{get:function(){return this._eol},enumerable:!0,configurable:!0}),t.prototype.getValue=function(){return this.getText()},t.prototype.getLinesContent=function(){return this._lines.slice(0)},t.prototype.getLineCount=function(){return this._lines.length},t.prototype.getLineContent=function(X){return this._lines[X-1]},t.prototype.getWordAtPosition=function(X,$){var Q=le.getWordAtText(X.column,le.ensureValidWordDefinition($),this._lines[X.lineNumber-1],0);return Q?new re.Range(X.lineNumber,Q.startColumn,X.lineNumber,Q.endColumn):null},t.prototype.getWordUntilPosition=function(X,$){var Q=this.getWordAtPosition(X,$);return Q?{word:this._lines[X.lineNumber-1].substring(Q.startColumn-1,X.column-1),startColumn:Q.startColumn,endColumn:X.column}:{word:"",startColumn:X.column,endColumn:X.column}},t.prototype.createWordIterator=function(X){var $,Q,J=this,te=0,ne=0,ie=[],l=function(){if(ne<ie.length){var oe=Q.substring(ie[ne].start,ie[ne].end);return ne+=1,$?$.value=oe:$={done:!1,value:oe},$}return te>=J._lines.length?ee.FIN:(Q=J._lines[te],ie=J._wordenize(Q,X),ne=0,te+=1,l())};return{next:l}},t.prototype.getLineWords=function(X,$){for(var Q=this._lines[X-1],J=[],ee=0,te=this._wordenize(Q,$);ee<te.length;ee++){var ne=te[ee];J.push({word:Q.substring(ne.start,ne.end),startColumn:ne.start+1,endColumn:ne.end+1})}return J},t.prototype._wordenize=function(X,$){var Q,J=[];for($.lastIndex=0;(Q=$.exec(X))&&0!==Q[0].length;)J.push({start:Q.index,end:Q.index+Q[0].length});return J},t.prototype.getValueInRange=function(X){if((X=this._validateRange(X)).startLineNumber===X.endLineNumber)return this._lines[X.startLineNumber-1].substring(X.startColumn-1,X.endColumn-1);var $=this._eol,Q=X.startLineNumber-1,J=X.endLineNumber-1,ee=[];ee.push(this._lines[Q].substring(X.startColumn-1));for(var te=Q+1;te<J;te++)ee.push(this._lines[te]);return ee.push(this._lines[J].substring(0,X.endColumn-1)),ee.join($)},t.prototype.offsetAt=function(X){return X=this._validatePosition(X),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(X.lineNumber-2)+(X.column-1)},t.prototype.positionAt=function(X){X=Math.floor(X),X=Math.max(0,X),this._ensureLineStarts();var $=this._lineStarts.getIndexOf(X),Q=this._lines[$.index].length;return{lineNumber:1+$.index,column:1+Math.min($.remainder,Q)}},t.prototype._validateRange=function(X){var $=this._validatePosition({lineNumber:X.startLineNumber,column:X.startColumn}),Q=this._validatePosition({lineNumber:X.endLineNumber,column:X.endColumn});return $.lineNumber!==X.startLineNumber||$.column!==X.startColumn||Q.lineNumber!==X.endLineNumber||Q.column!==X.endColumn?{startLineNumber:$.lineNumber,startColumn:$.column,endLineNumber:Q.lineNumber,endColumn:Q.column}:X},t.prototype._validatePosition=function(X){if(!oe.Position.isIPosition(X))throw new Error("bad position");var $=X.lineNumber,Q=X.column,J=!1;if($<1)$=1,Q=1,J=!0;else if($>this._lines.length)$=this._lines.length,Q=this._lines[$-1].length+1,J=!0;else{var ee=this._lines[$-1].length+1;Q<1?(Q=1,J=!0):Q>ee&&(Q=ee,J=!0)}return J?{lineNumber:$,column:Q}:X},t}(ae.MirrorTextModel),pe=function(){function t(X){this._foreignModuleFactory=X,this._foreignModule=null}return t.prototype.computeDiff=function(X,$,Q){var J=this._getModel(X),ee=this._getModel($);if(!J||!ee)return Promise.resolve(null);var te=J.getLinesContent(),ne=ee.getLinesContent(),ie=new se.DiffComputer(te,ne,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:Q,shouldMakePrettyDiff:!0}).computeDiff(),oe=!(ie.length>0)&&this._modelsAreIdentical(J,ee);return Promise.resolve({identical:oe,changes:ie})},t.prototype._modelsAreIdentical=function(X,$){var Q=X.getLineCount();if(Q!==$.getLineCount())return!1;for(var J=1;J<=Q;J++)if(X.getLineContent(J)!==$.getLineContent(J))return!1;return!0},t.prototype.computeMoreMinimalEdits=function(X,$){var ee=this._getModel(X);if(!ee)return Promise.resolve($);for(var te=[],ne=void 0,ie=0,oe=$=Q.mergeSort($,(function(X,$){return X.range&&$.range?re.Range.compareRangesUsingStarts(X.range,$.range):(X.range?0:1)-($.range?0:1)}));ie<oe.length;ie++){var se=oe[ie],ae=se.range,le=se.text,ue=se.eol;if("number"==typeof ue&&(ne=ue),ae){var de=ee.getValueInRange(ae);if(de!==(le=le.replace(/\r\n|\n|\r/g,ee.eol)))if(Math.max(le.length,de.length)>t._diffLimit)te.push({range:ae,text:le});else for(var ce=J.stringDiff(de,le,!1),he=ee.offsetAt(re.Range.lift(ae).getStartPosition()),pe=0,fe=ce;pe<fe.length;pe++){var ge=fe[pe],me=ee.positionAt(he+ge.originalStart),ve=ee.positionAt(he+ge.originalStart+ge.originalLength),_e={text:le.substr(ge.modifiedStart,ge.modifiedLength),range:{startLineNumber:me.lineNumber,startColumn:me.column,endLineNumber:ve.lineNumber,endColumn:ve.column}};ee.getValueInRange(_e.range)!==_e.text&&te.push(_e)}}}return"number"==typeof ne&&te.push({eol:ne,text:void 0,range:void 0}),Promise.resolve(te)},t.prototype.computeLinks=function(X){var $=this._getModel(X);return $?Promise.resolve(ue.computeLinks($)):Promise.resolve(null)},t.prototype.textualSuggest=function(X,$,Q,J){var ee=this._getModel(X);if(!ee)return Promise.resolve(null);var te=[],ne=new RegExp(Q,J),ie=ee.getWordUntilPosition($,ne),oe=Object.create(null);oe[ie.word]=!0;for(var re=ee.createWordIterator(ne),se=re.next();!se.done&&te.length<=t._suggestionsLimit;se=re.next()){var ae=se.value;oe[ae]||(oe[ae]=!0,isNaN(Number(ae))&&te.push({kind:18,label:ae,insertText:ae,range:{startLineNumber:$.lineNumber,startColumn:ie.startColumn,endLineNumber:$.lineNumber,endColumn:ie.endColumn}}))}return Promise.resolve({suggestions:te})},t.prototype.computeWordRanges=function(X,$,Q,J){var ee=this._getModel(X);if(!ee)return Promise.resolve(Object.create(null));for(var te=new RegExp(Q,J),ne=Object.create(null),ie=$.startLineNumber;ie<$.endLineNumber;ie++)for(var oe=0,re=ee.getLineWords(ie,te);oe<re.length;oe++){var se=re[oe];if(isNaN(Number(se.word))){var ae=ne[se.word];ae||(ae=[],ne[se.word]=ae),ae.push({startLineNumber:ie,startColumn:se.startColumn,endLineNumber:ie,endColumn:se.endColumn})}}return Promise.resolve(ne)},t.prototype.navigateValueSet=function(X,$,Q,J,ee){var te=this._getModel(X);if(!te)return Promise.resolve(null);var ne=new RegExp(J,ee);$.startColumn===$.endColumn&&($={startLineNumber:$.startLineNumber,startColumn:$.startColumn,endLineNumber:$.endLineNumber,endColumn:$.endColumn+1});var ie=te.getValueInRange($),oe=te.getWordAtPosition({lineNumber:$.startLineNumber,column:$.startColumn},ne);if(!oe)return Promise.resolve(null);var re=te.getValueInRange(oe),se=de.BasicInplaceReplace.INSTANCE.navigateValueSet($,ie,oe,re,Q);return Promise.resolve(se)},t.prototype.loadForeignModule=function($,Q){var J=this,ee={getMirrorModels:function(){return J._getModels()}};if(this._foreignModuleFactory){this._foreignModule=this._foreignModuleFactory(ee,Q);var te=[];for(var ne in this._foreignModule)"function"==typeof this._foreignModule[ne]&&te.push(ne);return Promise.resolve(te)}return new Promise((function(te,ne){X([$],(function(X){J._foreignModule=X.create(ee,Q);var $=[];for(var ne in J._foreignModule)"function"==typeof J._foreignModule[ne]&&$.push(ne);te($)}),ne)}))},t.prototype.fmr=function(X,$){if(!this._foreignModule||"function"!=typeof this._foreignModule[X])return Promise.reject(new Error("Missing requestHandler or method: "+X));try{return Promise.resolve(this._foreignModule[X].apply(this._foreignModule,$))}catch(X){return Promise.reject(X)}},t._diffLimit=1e4,t._suggestionsLimit=1e4,t}();$.BaseEditorSimpleWorker=pe;var fe=function(X){function t($){var Q=X.call(this,$)||this;return Q._models=Object.create(null),Q}return te(t,X),t.prototype.dispose=function(){this._models=Object.create(null)},t.prototype._getModel=function(X){return this._models[X]},t.prototype._getModels=function(){var X=this,$=[];return Object.keys(this._models).forEach((function(Q){return $.push(X._models[Q])})),$},t.prototype.acceptNewModel=function(X){this._models[X.url]=new he(ie.URI.parse(X.url),X.lines,X.EOL,X.versionId)},t.prototype.acceptModelChanged=function(X,$){this._models[X]&&this._models[X].onEvents($)},t.prototype.acceptRemovedModel=function(X){this._models[X]&&delete this._models[X]},t}(pe);$.EditorSimpleWorkerImpl=fe,$.create=function(){return new fe(null)},"function"==typeof importScripts&&(ne.globals.monaco=ce.createMonacoBaseAPI())})),define(Q[79],n([0,1,2]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(X){function t(){var $=X.call(this)||this;return $._shouldRender=!0,$}return te(t,X),t.prototype.shouldRender=function(){return this._shouldRender},t.prototype.forceShouldRender=function(){this._shouldRender=!0},t.prototype.setShouldRender=function(){this._shouldRender=!0},t.prototype.onDidRender=function(){this._shouldRender=!1},t.prototype.onConfigurationChanged=function(X){return!1},t.prototype.onCursorStateChanged=function(X){return!1},t.prototype.onDecorationsChanged=function(X){return!1},t.prototype.onFlushed=function(X){return!1},t.prototype.onFocusChanged=function(X){return!1},t.prototype.onLanguageConfigurationChanged=function(X){return!1},t.prototype.onLineMappingChanged=function(X){return!1},t.prototype.onLinesChanged=function(X){return!1},t.prototype.onLinesDeleted=function(X){return!1},t.prototype.onLinesInserted=function(X){return!1},t.prototype.onRevealRangeRequest=function(X){return!1},t.prototype.onScrollChanged=function(X){return!1},t.prototype.onTokensChanged=function(X){return!1},t.prototype.onTokensColorsChanged=function(X){return!1},t.prototype.onZonesChanged=function(X){return!1},t.prototype.onThemeChanged=function(X){return!1},t.prototype.handleEvents=function(X){for(var $=!1,Q=0,J=X.length;Q<J;Q++){var ee=X[Q];switch(ee.type){case 1:this.onConfigurationChanged(ee)&&($=!0);break;case 2:this.onCursorStateChanged(ee)&&($=!0);break;case 3:this.onDecorationsChanged(ee)&&($=!0);break;case 4:this.onFlushed(ee)&&($=!0);break;case 5:this.onFocusChanged(ee)&&($=!0);break;case 16:this.onLanguageConfigurationChanged(ee)&&($=!0);break;case 6:this.onLineMappingChanged(ee)&&($=!0);break;case 7:this.onLinesChanged(ee)&&($=!0);break;case 8:this.onLinesDeleted(ee)&&($=!0);break;case 9:this.onLinesInserted(ee)&&($=!0);break;case 10:this.onRevealRangeRequest(ee)&&($=!0);break;case 11:this.onScrollChanged(ee)&&($=!0);break;case 12:this.onTokensChanged(ee)&&($=!0);break;case 13:this.onTokensColorsChanged(ee)&&($=!0);break;case 14:this.onZonesChanged(ee)&&($=!0);break;case 15:this.onThemeChanged(ee)&&($=!0);break;default:console.info("View received unknown event: "),console.info(ee)}}$&&(this._shouldRender=!0)},t}(Q.Disposable);$.ViewEventHandler=J})),define(Q[61],n([0,1,79]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t}(Q.ViewEventHandler);$.DynamicViewOverlay=J})),define(Q[33],n([0,1,23,79]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(X){function t($){var Q=X.call(this)||this;return Q._context=$,Q._context.addEventHandler(Q),Q}return te(t,X),t.prototype.dispose=function(){this._context.removeEventHandler(this),X.prototype.dispose.call(this)},t}(J.ViewEventHandler);$.ViewPart=ee;var ne=function(){function e(){}return e.write=function(X,$){Q.FastDomNode,X.setAttribute("data-mprt",String($))},e.read=function(X){var $=X.getAttribute("data-mprt");return null===$?0:parseInt($,10)},e.collect=function(X,$){for(var Q=[],J=0;X&&X!==document.body&&X!==$;)X.nodeType===X.ELEMENT_NODE&&(Q[J++]=this.read(X)),X=X.parentElement;for(var ee=new Uint8Array(J),te=0;te<J;te++)ee[te]=Q[J-te-1];return ee},e}();$.PartFingerprints=ne})),define(Q[222],n([0,1,7,23,33]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var s=function(X,$){this.top=X,this.left=$},ne=function(X){function t($,Q){var te=X.call(this,$)||this;return te._viewDomNode=Q,te._widgets={},te.domNode=J.createFastDomNode(document.createElement("div")),ee.PartFingerprints.write(te.domNode,1),te.domNode.setClassName("contentWidgets"),te.domNode.setPosition("absolute"),te.domNode.setTop(0),te.overflowingContentWidgetsDomNode=J.createFastDomNode(document.createElement("div")),ee.PartFingerprints.write(te.overflowingContentWidgetsDomNode,2),te.overflowingContentWidgetsDomNode.setClassName("overflowingContentWidgets"),te}return te(t,X),t.prototype.dispose=function(){X.prototype.dispose.call(this),this._widgets={}},t.prototype.onConfigurationChanged=function(X){for(var $=Object.keys(this._widgets),Q=0,J=$.length;Q<J;Q++){var ee=$[Q];this._widgets[ee].onConfigurationChanged(X)}return!0},t.prototype.onDecorationsChanged=function(X){return!0},t.prototype.onFlushed=function(X){return!0},t.prototype.onLineMappingChanged=function(X){for(var $=Object.keys(this._widgets),Q=0,J=$.length;Q<J;Q++){var ee=$[Q];this._widgets[ee].onLineMappingChanged(X)}return!0},t.prototype.onLinesChanged=function(X){return!0},t.prototype.onLinesDeleted=function(X){return!0},t.prototype.onLinesInserted=function(X){return!0},t.prototype.onScrollChanged=function(X){return!0},t.prototype.onZonesChanged=function(X){return!0},t.prototype.addWidget=function(X){var $=new ie(this._context,this._viewDomNode,X);this._widgets[$.id]=$,$.allowEditorOverflow?this.overflowingContentWidgetsDomNode.appendChild($.domNode):this.domNode.appendChild($.domNode),this.setShouldRender()},t.prototype.setWidgetPosition=function(X,$,Q,J){this._widgets[X.getId()].setPosition($,Q,J),this.setShouldRender()},t.prototype.removeWidget=function(X){var $=X.getId();if(this._widgets.hasOwnProperty($)){var Q=this._widgets[$];delete this._widgets[$];var J=Q.domNode.domNode;J.parentNode.removeChild(J),J.removeAttribute("monaco-visible-content-widget"),this.setShouldRender()}},t.prototype.shouldSuppressMouseDownOnWidget=function(X){return!!this._widgets.hasOwnProperty(X)&&this._widgets[X].suppressMouseDown},t.prototype.onBeforeRender=function(X){for(var $=Object.keys(this._widgets),Q=0,J=$.length;Q<J;Q++){var ee=$[Q];this._widgets[ee].onBeforeRender(X)}},t.prototype.prepareRender=function(X){for(var $=Object.keys(this._widgets),Q=0,J=$.length;Q<J;Q++){var ee=$[Q];this._widgets[ee].prepareRender(X)}},t.prototype.render=function(X){for(var $=Object.keys(this._widgets),Q=0,J=$.length;Q<J;Q++){var ee=$[Q];this._widgets[ee].render(X)}},t}(ee.ViewPart);$.ViewContentWidgets=ne;var ie=function(){function e(X,$,Q){this._context=X,this._viewDomNode=$,this._actual=Q,this.domNode=J.createFastDomNode(this._actual.getDomNode()),this.id=this._actual.getId(),this.allowEditorOverflow=this._actual.allowEditorOverflow||!1,this.suppressMouseDown=this._actual.suppressMouseDown||!1,this._fixedOverflowWidgets=this._context.configuration.editor.viewInfo.fixedOverflowWidgets,this._contentWidth=this._context.configuration.editor.layoutInfo.contentWidth,this._contentLeft=this._context.configuration.editor.layoutInfo.contentLeft,this._lineHeight=this._context.configuration.editor.lineHeight,this._setPosition(null,null),this._preference=[],this._cachedDomNodeClientWidth=-1,this._cachedDomNodeClientHeight=-1,this._maxWidth=this._getMaxWidth(),this._isVisible=!1,this._renderData=null,this.domNode.setPosition(this._fixedOverflowWidgets&&this.allowEditorOverflow?"fixed":"absolute"),this.domNode.setVisibility("hidden"),this.domNode.setAttribute("widgetId",this.id),this.domNode.setMaxWidth(this._maxWidth)}return e.prototype.onConfigurationChanged=function(X){X.lineHeight&&(this._lineHeight=this._context.configuration.editor.lineHeight),X.layoutInfo&&(this._contentLeft=this._context.configuration.editor.layoutInfo.contentLeft,this._contentWidth=this._context.configuration.editor.layoutInfo.contentWidth,this._maxWidth=this._getMaxWidth())},e.prototype.onLineMappingChanged=function(X){this._setPosition(this._position,this._range)},e.prototype._setPosition=function(X,$){if(this._position=X||null,this._range=$||null,this._viewPosition=null,this._viewRange=null,this._position){var Q=this._context.model.validateModelPosition(this._position);this._context.model.coordinatesConverter.modelPositionIsVisible(Q)&&(this._viewPosition=this._context.model.coordinatesConverter.convertModelPositionToViewPosition(Q))}if(this._range){var J=this._context.model.validateModelRange(this._range);this._viewRange=this._context.model.coordinatesConverter.convertModelRangeToViewRange(J)}},e.prototype._getMaxWidth=function(){return this.allowEditorOverflow?window.innerWidth||document.documentElement.clientWidth||document.body.clientWidth:this._contentWidth},e.prototype.setPosition=function(X,$,Q){this._setPosition(X,$),this._preference=Q||null,this._cachedDomNodeClientWidth=-1,this._cachedDomNodeClientHeight=-1},e.prototype._layoutBoxInViewport=function(X,$,Q,J,ee){var te=X.top,ne=te,ie=$.top+this._lineHeight,oe=te-J,re=ne>=J,se=ie,ae=ee.viewportHeight-ie>=J,le=X.left,ue=$.left;return le+Q>ee.scrollLeft+ee.viewportWidth&&(le=ee.scrollLeft+ee.viewportWidth-Q),ue+Q>ee.scrollLeft+ee.viewportWidth&&(ue=ee.scrollLeft+ee.viewportWidth-Q),le<ee.scrollLeft&&(le=ee.scrollLeft),ue<ee.scrollLeft&&(ue=ee.scrollLeft),{fitsAbove:re,aboveTop:oe,aboveLeft:le,fitsBelow:ae,belowTop:se,belowLeft:ue}},e.prototype._layoutBoxInPage=function(X,$,J,ee,te){var ne=X.left-te.scrollLeft,ie=$.left-te.scrollLeft;if(ne<0||ne>this._contentWidth)return null;var oe=X.top-ee,re=$.top+this._lineHeight,se=ne+this._contentLeft,ae=ie+this._contentLeft,le=Q.getDomNodePagePosition(this._viewDomNode.domNode),ue=le.top+oe-Q.StandardWindow.scrollY,de=le.top+re-Q.StandardWindow.scrollY,ce=le.left+se-Q.StandardWindow.scrollX,he=le.left+ae-Q.StandardWindow.scrollX,pe=window.innerWidth||document.documentElement.clientWidth||document.body.clientWidth,fe=ue>=22,ge=de+ee<=(window.innerHeight||document.documentElement.clientHeight||document.body.clientHeight)-22;if(ce+J+20>pe&&(ce-=me=ce-(pe-J-20),se-=me),he+J+20>pe&&(he-=me=he-(pe-J-20),ae-=me),ce<0&&(ce-=me=ce,se-=me),he<0){var me=he;he-=me,ae-=me}return this._fixedOverflowWidgets&&(oe=ue,re=de,se=ce,ae=he),{fitsAbove:fe,aboveTop:oe,aboveLeft:se,fitsBelow:ge,belowTop:re,belowLeft:ae}},e.prototype._prepareRenderWidgetAtExactPositionOverflowing=function(X){return new s(X.top,X.left+this._contentLeft)},e.prototype._getTopAndBottomLeft=function(X){if(!this._viewPosition)return[null,null];var $=X.visibleRangeForPosition(this._viewPosition);if(!$)return[null,null];var Q=X.getVerticalOffsetForLineNumber(this._viewPosition.lineNumber)-X.scrollTop,J=new s(Q,$.left),ee=this._viewPosition.lineNumber,te=$.left;if(this._viewRange){var ne=X.linesVisibleRangesForRange(this._viewRange,!1);if(ne&&ne.length>0)for(var ie=ne.length-1;ie>=0;ie--){var oe=ne[ie];if(oe.lineNumber>=ee){oe.lineNumber>ee&&(ee=oe.lineNumber,te=1073741824);for(var re=0,se=oe.ranges.length;re<se;re++){var ae=oe.ranges[re];ae.left<te&&(te=ae.left)}}}}var le=X.getVerticalOffsetForLineNumber(ee)-X.scrollTop;return[J,new s(le,te)]},e.prototype._prepareRenderWidget=function(X){var $,Q=this._getTopAndBottomLeft(X),J=Q[0],ee=Q[1];if(!J||!ee)return null;if(-1===this._cachedDomNodeClientWidth||-1===this._cachedDomNodeClientHeight){var te=this.domNode.domNode;this._cachedDomNodeClientWidth=te.clientWidth,this._cachedDomNodeClientHeight=te.clientHeight}if($=this.allowEditorOverflow?this._layoutBoxInPage(J,ee,this._cachedDomNodeClientWidth,this._cachedDomNodeClientHeight,X):this._layoutBoxInViewport(J,ee,this._cachedDomNodeClientWidth,this._cachedDomNodeClientHeight,X),this._preference)for(var ne=1;ne<=2;ne++)for(var ie=0;ie<this._preference.length;ie++){var oe=this._preference[ie];if(1===oe){if(!$)return null;if(2===ne||$.fitsAbove)return new s($.aboveTop,$.aboveLeft)}else{if(2!==oe)return this.allowEditorOverflow?this._prepareRenderWidgetAtExactPositionOverflowing(J):J;if(!$)return null;if(2===ne||$.fitsBelow)return new s($.belowTop,$.belowLeft)}}return null},e.prototype.onBeforeRender=function(X){this._viewPosition&&this._preference&&(this._viewPosition.lineNumber<X.startLineNumber||this._viewPosition.lineNumber>X.endLineNumber||this.domNode.setMaxWidth(this._maxWidth))},e.prototype.prepareRender=function(X){this._renderData=this._prepareRenderWidget(X)},e.prototype.render=function(X){this._renderData?(this.allowEditorOverflow?(this.domNode.setTop(this._renderData.top),this.domNode.setLeft(this._renderData.left)):(this.domNode.setTop(this._renderData.top+X.scrollTop-X.bigNumbersDelta),this.domNode.setLeft(this._renderData.left)),this._isVisible||(this.domNode.setVisibility("inherit"),this.domNode.setAttribute("monaco-visible-content-widget","true"),this._isVisible=!0)):this._isVisible&&(this.domNode.removeAttribute("monaco-visible-content-widget"),this._isVisible=!1,this.domNode.setVisibility("hidden"))},e}()})),define(Q[223],n([0,1,61,3,83,259]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var ne=function(X){function t($){var Q=X.call(this)||this;return Q._context=$,Q._lineHeight=Q._context.configuration.editor.lineHeight,Q._typicalHalfwidthCharacterWidth=Q._context.configuration.editor.fontInfo.typicalHalfwidthCharacterWidth,Q._renderResult=null,Q._context.addEventHandler(Q),Q}return te(t,X),t.prototype.dispose=function(){this._context.removeEventHandler(this),this._renderResult=null,X.prototype.dispose.call(this)},t.prototype.onConfigurationChanged=function(X){return X.lineHeight&&(this._lineHeight=this._context.configuration.editor.lineHeight),X.fontInfo&&(this._typicalHalfwidthCharacterWidth=this._context.configuration.editor.fontInfo.typicalHalfwidthCharacterWidth),!0},t.prototype.onDecorationsChanged=function(X){return!0},t.prototype.onFlushed=function(X){return!0},t.prototype.onLinesChanged=function(X){return!0},t.prototype.onLinesDeleted=function(X){return!0},t.prototype.onLinesInserted=function(X){return!0},t.prototype.onScrollChanged=function(X){return X.scrollTopChanged||X.scrollWidthChanged},t.prototype.onZonesChanged=function(X){return!0},t.prototype.prepareRender=function(X){for(var $=X.getDecorationsInViewport(),Q=[],ee=0,te=0,ne=$.length;te<ne;te++){var ie=$[te];ie.options.className&&(Q[ee++]=ie)}Q=Q.sort((function(X,$){if(X.options.zIndex<$.options.zIndex)return-1;if(X.options.zIndex>$.options.zIndex)return 1;var Q=X.options.className,ee=$.options.className;return Q<ee?-1:Q>ee?1:J.Range.compareRangesUsingStarts(X.range,$.range)}));for(var oe=X.visibleRange.startLineNumber,re=X.visibleRange.endLineNumber,se=[],ae=oe;ae<=re;ae++)se[ae-oe]="";this._renderWholeLineDecorations(X,Q,se),this._renderNormalDecorations(X,Q,se),this._renderResult=se},t.prototype._renderWholeLineDecorations=function(X,$,Q){for(var J=String(this._lineHeight),ee=X.visibleRange.startLineNumber,te=X.visibleRange.endLineNumber,ne=0,ie=$.length;ne<ie;ne++){var oe=$[ne];if(oe.options.isWholeLine)for(var re='<div class="cdr '+oe.options.className+'" style="left:0;width:100%;height:'+J+'px;"></div>',se=Math.max(oe.range.startLineNumber,ee),ae=Math.min(oe.range.endLineNumber,te),le=se;le<=ae;le++)Q[le-ee]+=re}},t.prototype._renderNormalDecorations=function(X,$,Q){for(var ee=String(this._lineHeight),te=X.visibleRange.startLineNumber,ne=null,ie=!1,oe=null,re=0,se=$.length;re<se;re++){var ae=$[re];if(!ae.options.isWholeLine){var le=ae.options.className,ue=Boolean(ae.options.showIfCollapsed),de=ae.range;ue&&1===de.endColumn&&de.endLineNumber!==de.startLineNumber&&(de=new J.Range(de.startLineNumber,de.startColumn,de.endLineNumber-1,this._context.model.getLineMaxColumn(de.endLineNumber-1))),ne===le&&ie===ue&&J.Range.areIntersectingOrTouching(oe,de)?oe=J.Range.plusRange(oe,de):(null!==ne&&this._renderNormalDecoration(X,oe,ne,ie,ee,te,Q),ne=le,ie=ue,oe=de)}}null!==ne&&this._renderNormalDecoration(X,oe,ne,ie,ee,te,Q)},t.prototype._renderNormalDecoration=function(X,$,Q,J,te,ne,ie){var oe=X.linesVisibleRangesForRange($,"findMatch"===Q);if(oe)for(var re=0,se=oe.length;re<se;re++){var ae=oe[re],le=ae.lineNumber-ne;if(J&&1===ae.ranges.length){var ue=ae.ranges[0];0===ue.width&&(ae.ranges[0]=new ee.HorizontalRange(ue.left,this._typicalHalfwidthCharacterWidth))}for(var de=0,ce=ae.ranges.length;de<ce;de++){var he=ae.ranges[de],pe='<div class="cdr '+Q+'" style="left:'+String(he.left)+"px;width:"+String(he.width)+"px;height:"+te+'px;"></div>';ie[le]+=pe}}},t.prototype.render=function(X,$){if(!this._renderResult)return"";var Q=$-X;return Q<0||Q>=this._renderResult.length?"":this._renderResult[Q]},t}(Q.DynamicViewOverlay);$.DecorationsOverlay=ne})),define(Q[136],n([0,1,61,260]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var i=function(X,$,Q){this.startLineNumber=+X,this.endLineNumber=+$,this.className=String(Q)};$.DecorationToRender=i;var J=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype._render=function(X,$,Q){for(var J=[],ee=X;ee<=$;ee++)J[ee-X]=[];if(0===Q.length)return J;Q.sort((function(X,$){return X.className===$.className?X.startLineNumber===$.startLineNumber?X.endLineNumber-$.endLineNumber:X.startLineNumber-$.startLineNumber:X.className<$.className?-1:1}));for(var te=null,ne=0,ie=0,oe=Q.length;ie<oe;ie++){var re=Q[ie],se=re.className,ae=Math.max(re.startLineNumber,X)-X,le=Math.min(re.endLineNumber,$)-X;te===se?(ae=Math.max(ne+1,ae),ne=Math.max(ne,le)):(te=se,ne=le);for(var ue=ae;ue<=ne;ue++)J[ue].push(te)}return J},t}(Q.DynamicViewOverlay);$.DedupOverlay=J;var ee=function(X){function t($){var Q=X.call(this)||this;return Q._context=$,Q._lineHeight=Q._context.configuration.editor.lineHeight,Q._glyphMargin=Q._context.configuration.editor.viewInfo.glyphMargin,Q._glyphMarginLeft=Q._context.configuration.editor.layoutInfo.glyphMarginLeft,Q._glyphMarginWidth=Q._context.configuration.editor.layoutInfo.glyphMarginWidth,Q._renderResult=null,Q._context.addEventHandler(Q),Q}return te(t,X),t.prototype.dispose=function(){this._context.removeEventHandler(this),this._renderResult=null,X.prototype.dispose.call(this)},t.prototype.onConfigurationChanged=function(X){return X.lineHeight&&(this._lineHeight=this._context.configuration.editor.lineHeight),X.viewInfo&&(this._glyphMargin=this._context.configuration.editor.viewInfo.glyphMargin),X.layoutInfo&&(this._glyphMarginLeft=this._context.configuration.editor.layoutInfo.glyphMarginLeft,this._glyphMarginWidth=this._context.configuration.editor.layoutInfo.glyphMarginWidth),!0},t.prototype.onDecorationsChanged=function(X){return!0},t.prototype.onFlushed=function(X){return!0},t.prototype.onLinesChanged=function(X){return!0},t.prototype.onLinesDeleted=function(X){return!0},t.prototype.onLinesInserted=function(X){return!0},t.prototype.onScrollChanged=function(X){return X.scrollTopChanged},t.prototype.onZonesChanged=function(X){return!0},t.prototype._getDecorations=function(X){for(var $=X.getDecorationsInViewport(),Q=[],J=0,ee=0,te=$.length;ee<te;ee++){var ne=$[ee],ie=ne.options.glyphMarginClassName;ie&&(Q[J++]=new i(ne.range.startLineNumber,ne.range.endLineNumber,ie))}return Q},t.prototype.prepareRender=function(X){if(this._glyphMargin){for(var $=X.visibleRange.startLineNumber,Q=X.visibleRange.endLineNumber,J=this._render($,Q,this._getDecorations(X)),ee=this._lineHeight.toString(),te='" style="left:'+this._glyphMarginLeft.toString()+"px;width:"+this._glyphMarginWidth.toString()+"px;height:"+ee+'px;"></div>',ne=[],ie=$;ie<=Q;ie++){var oe=ie-$,re=J[oe];0===re.length?ne[oe]="":ne[oe]='<div class="cgmr '+re.join(" ")+te}this._renderResult=ne}else this._renderResult=null},t.prototype.render=function(X,$){if(!this._renderResult)return"";var Q=$-X;return Q<0||Q>=this._renderResult.length?"":this._renderResult[Q]},t}(J);$.GlyphMarginOverlay=ee})),define(Q[225],n([0,1,136,267]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(X){function t($){var Q=X.call(this)||this;return Q._context=$,Q._decorationsLeft=Q._context.configuration.editor.layoutInfo.decorationsLeft,Q._decorationsWidth=Q._context.configuration.editor.layoutInfo.decorationsWidth,Q._renderResult=null,Q._context.addEventHandler(Q),Q}return te(t,X),t.prototype.dispose=function(){this._context.removeEventHandler(this),this._renderResult=null,X.prototype.dispose.call(this)},t.prototype.onConfigurationChanged=function(X){return X.layoutInfo&&(this._decorationsLeft=this._context.configuration.editor.layoutInfo.decorationsLeft,this._decorationsWidth=this._context.configuration.editor.layoutInfo.decorationsWidth),!0},t.prototype.onDecorationsChanged=function(X){return!0},t.prototype.onFlushed=function(X){return!0},t.prototype.onLinesChanged=function(X){return!0},t.prototype.onLinesDeleted=function(X){return!0},t.prototype.onLinesInserted=function(X){return!0},t.prototype.onScrollChanged=function(X){return X.scrollTopChanged},t.prototype.onZonesChanged=function(X){return!0},t.prototype._getDecorations=function(X){for(var $=X.getDecorationsInViewport(),J=[],ee=0,te=0,ne=$.length;te<ne;te++){var ie=$[te],oe=ie.options.linesDecorationsClassName;oe&&(J[ee++]=new Q.DecorationToRender(ie.range.startLineNumber,ie.range.endLineNumber,oe))}return J},t.prototype.prepareRender=function(X){for(var $=X.visibleRange.startLineNumber,Q=X.visibleRange.endLineNumber,J=this._render($,Q,this._getDecorations(X)),ee='" style="left:'+this._decorationsLeft.toString()+"px;width:"+this._decorationsWidth.toString()+'px;"></div>',te=[],ne=$;ne<=Q;ne++){for(var ie=ne-$,oe=J[ie],re="",se=0,ae=oe.length;se<ae;se++)re+='<div class="cldr '+oe[se]+ee;te[ie]=re}this._renderResult=te},t.prototype.render=function(X,$){return this._renderResult?this._renderResult[$-X]:""},t}(Q.DedupOverlay);$.LinesDecorationsOverlay=J})),define(Q[168],n([0,1,23,33]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(X){function t($){var Q=X.call(this,$)||this;return Q._canUseLayerHinting=Q._context.configuration.editor.canUseLayerHinting,Q._contentLeft=Q._context.configuration.editor.layoutInfo.contentLeft,Q._glyphMarginLeft=Q._context.configuration.editor.layoutInfo.glyphMarginLeft,Q._glyphMarginWidth=Q._context.configuration.editor.layoutInfo.glyphMarginWidth,Q._domNode=Q._createDomNode(),Q}return te(t,X),t.prototype.dispose=function(){X.prototype.dispose.call(this)},t.prototype.getDomNode=function(){return this._domNode},t.prototype._createDomNode=function(){var X=Q.createFastDomNode(document.createElement("div"));return X.setClassName(t.OUTER_CLASS_NAME),X.setPosition("absolute"),X.setAttribute("role","presentation"),X.setAttribute("aria-hidden","true"),this._glyphMarginBackgroundDomNode=Q.createFastDomNode(document.createElement("div")),this._glyphMarginBackgroundDomNode.setClassName(t.CLASS_NAME),X.appendChild(this._glyphMarginBackgroundDomNode),X},t.prototype.onConfigurationChanged=function(X){return X.canUseLayerHinting&&(this._canUseLayerHinting=this._context.configuration.editor.canUseLayerHinting),X.layoutInfo&&(this._contentLeft=this._context.configuration.editor.layoutInfo.contentLeft,this._glyphMarginLeft=this._context.configuration.editor.layoutInfo.glyphMarginLeft,this._glyphMarginWidth=this._context.configuration.editor.layoutInfo.glyphMarginWidth),!0},t.prototype.onScrollChanged=function($){return X.prototype.onScrollChanged.call(this,$)||$.scrollTopChanged},t.prototype.prepareRender=function(X){},t.prototype.render=function(X){this._domNode.setLayerHinting(this._canUseLayerHinting);var $=X.scrollTop-X.bigNumbersDelta;this._domNode.setTop(-$);var Q=Math.min(X.scrollHeight,1e6);this._domNode.setHeight(Q),this._domNode.setWidth(this._contentLeft),this._glyphMarginBackgroundDomNode.setLeft(this._glyphMarginLeft),this._glyphMarginBackgroundDomNode.setWidth(this._glyphMarginWidth),this._glyphMarginBackgroundDomNode.setHeight(Q)},t.CLASS_NAME="glyph-margin",t.OUTER_CLASS_NAME="margin",t}(J.ViewPart);$.Margin=ee})),define(Q[227],n([0,1,136,269]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(X){function t($){var Q=X.call(this)||this;return Q._context=$,Q._renderResult=null,Q._context.addEventHandler(Q),Q}return te(t,X),t.prototype.dispose=function(){this._context.removeEventHandler(this),this._renderResult=null,X.prototype.dispose.call(this)},t.prototype.onConfigurationChanged=function(X){return!0},t.prototype.onDecorationsChanged=function(X){return!0},t.prototype.onFlushed=function(X){return!0},t.prototype.onLinesChanged=function(X){return!0},t.prototype.onLinesDeleted=function(X){return!0},t.prototype.onLinesInserted=function(X){return!0},t.prototype.onScrollChanged=function(X){return X.scrollTopChanged},t.prototype.onZonesChanged=function(X){return!0},t.prototype._getDecorations=function(X){for(var $=X.getDecorationsInViewport(),J=[],ee=0,te=0,ne=$.length;te<ne;te++){var ie=$[te],oe=ie.options.marginClassName;oe&&(J[ee++]=new Q.DecorationToRender(ie.range.startLineNumber,ie.range.endLineNumber,oe))}return J},t.prototype.prepareRender=function(X){for(var $=X.visibleRange.startLineNumber,Q=X.visibleRange.endLineNumber,J=this._render($,Q,this._getDecorations(X)),ee=[],te=$;te<=Q;te++){for(var ne=te-$,ie=J[ne],oe="",re=0,se=ie.length;re<se;re++)oe+='<div class="cmdr '+ie[re]+'" style=""></div>';ee[ne]=oe}this._renderResult=ee},t.prototype.render=function(X,$){return this._renderResult?this._renderResult[$-X]:""},t}(Q.DedupOverlay);$.MarginViewLineDecorationsOverlay=J})),define(Q[228],n([0,1,23,33,274]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(X){function t($){var ee=X.call(this,$)||this;return ee._widgets={},ee._verticalScrollbarWidth=ee._context.configuration.editor.layoutInfo.verticalScrollbarWidth,ee._minimapWidth=ee._context.configuration.editor.layoutInfo.minimapWidth,ee._horizontalScrollbarHeight=ee._context.configuration.editor.layoutInfo.horizontalScrollbarHeight,ee._editorHeight=ee._context.configuration.editor.layoutInfo.height,ee._editorWidth=ee._context.configuration.editor.layoutInfo.width,ee._domNode=Q.createFastDomNode(document.createElement("div")),J.PartFingerprints.write(ee._domNode,4),ee._domNode.setClassName("overlayWidgets"),ee}return te(t,X),t.prototype.dispose=function(){X.prototype.dispose.call(this),this._widgets={}},t.prototype.getDomNode=function(){return this._domNode},t.prototype.onConfigurationChanged=function(X){return!!X.layoutInfo&&(this._verticalScrollbarWidth=this._context.configuration.editor.layoutInfo.verticalScrollbarWidth,this._minimapWidth=this._context.configuration.editor.layoutInfo.minimapWidth,this._horizontalScrollbarHeight=this._context.configuration.editor.layoutInfo.horizontalScrollbarHeight,this._editorHeight=this._context.configuration.editor.layoutInfo.height,this._editorWidth=this._context.configuration.editor.layoutInfo.width,!0)},t.prototype.addWidget=function(X){var $=Q.createFastDomNode(X.getDomNode());this._widgets[X.getId()]={widget:X,preference:null,domNode:$},$.setPosition("absolute"),$.setAttribute("widgetId",X.getId()),this._domNode.appendChild($),this.setShouldRender()},t.prototype.setWidgetPosition=function(X,$){var Q=this._widgets[X.getId()];return Q.preference!==$&&(Q.preference=$,this.setShouldRender(),!0)},t.prototype.removeWidget=function(X){var $=X.getId();if(this._widgets.hasOwnProperty($)){var Q=this._widgets[$].domNode.domNode;delete this._widgets[$],Q.parentNode.removeChild(Q),this.setShouldRender()}},t.prototype._renderWidget=function(X){var $=X.domNode;if(null!==X.preference)if(0===X.preference)$.setTop(0),$.setRight(2*this._verticalScrollbarWidth+this._minimapWidth);else if(1===X.preference){var Q=$.domNode.clientHeight;$.setTop(this._editorHeight-Q-2*this._horizontalScrollbarHeight),$.setRight(2*this._verticalScrollbarWidth+this._minimapWidth)}else 2===X.preference&&($.setTop(0),$.domNode.style.right="50%");else $.unsetTop()},t.prototype.prepareRender=function(X){},t.prototype.render=function(X){this._domNode.setWidth(this._editorWidth);for(var $=Object.keys(this._widgets),Q=0,J=$.length;Q<J;Q++){var ee=$[Q];this._renderWidget(this._widgets[ee])}},t}(J.ViewPart);$.ViewOverlayWidgets=ee})),define(Q[229],n([0,1,23,157,79]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var ne=function(X){function t($,ee){var te=X.call(this)||this;return te._context=$,te._domNode=Q.createFastDomNode(document.createElement("canvas")),te._domNode.setClassName(ee),te._domNode.setPosition("absolute"),te._domNode.setLayerHinting(!0),te._zoneManager=new J.OverviewZoneManager((function(X){return te._context.viewLayout.getVerticalOffsetForLineNumber(X)})),te._zoneManager.setDOMWidth(0),te._zoneManager.setDOMHeight(0),te._zoneManager.setOuterHeight(te._context.viewLayout.getScrollHeight()),te._zoneManager.setLineHeight(te._context.configuration.editor.lineHeight),te._zoneManager.setPixelRatio(te._context.configuration.editor.pixelRatio),te._context.addEventHandler(te),te}return te(t,X),t.prototype.dispose=function(){this._context.removeEventHandler(this),X.prototype.dispose.call(this)},t.prototype.onConfigurationChanged=function(X){return X.lineHeight&&(this._zoneManager.setLineHeight(this._context.configuration.editor.lineHeight),this._render()),X.pixelRatio&&(this._zoneManager.setPixelRatio(this._context.configuration.editor.pixelRatio),this._domNode.setWidth(this._zoneManager.getDOMWidth()),this._domNode.setHeight(this._zoneManager.getDOMHeight()),this._domNode.domNode.width=this._zoneManager.getCanvasWidth(),this._domNode.domNode.height=this._zoneManager.getCanvasHeight(),this._render()),!0},t.prototype.onFlushed=function(X){return this._render(),!0},t.prototype.onScrollChanged=function(X){return X.scrollHeightChanged&&(this._zoneManager.setOuterHeight(X.scrollHeight),this._render()),!0},t.prototype.onZonesChanged=function(X){return this._render(),!0},t.prototype.getDomNode=function(){return this._domNode.domNode},t.prototype.setLayout=function(X){this._domNode.setTop(X.top),this._domNode.setRight(X.right);var $=!1;$=this._zoneManager.setDOMWidth(X.width)||$,($=this._zoneManager.setDOMHeight(X.height)||$)&&(this._domNode.setWidth(this._zoneManager.getDOMWidth()),this._domNode.setHeight(this._zoneManager.getDOMHeight()),this._domNode.domNode.width=this._zoneManager.getCanvasWidth(),this._domNode.domNode.height=this._zoneManager.getCanvasHeight(),this._render())},t.prototype.setZones=function(X){this._zoneManager.setZones(X),this._render()},t.prototype._render=function(){if(0===this._zoneManager.getOuterHeight())return!1;var X=this._zoneManager.getCanvasWidth(),$=this._zoneManager.getCanvasHeight(),Q=this._zoneManager.resolveColorZones(),J=this._zoneManager.getId2Color(),ee=this._domNode.domNode.getContext("2d");return ee.clearRect(0,0,X,$),Q.length>0&&this._renderOneLane(ee,Q,J,X),!0},t.prototype._renderOneLane=function(X,$,Q,J){for(var ee=0,te=0,ne=0,ie=0,oe=$.length;ie<oe;ie++){var re=$[ie],se=re.colorId,ae=re.from,le=re.to;se!==ee?(X.fillRect(0,te,J,ne-te),ee=se,X.fillStyle=Q[ee],te=ae,ne=le):ne>=ae?ne=Math.max(ne,le):(X.fillRect(0,te,J,ne-te),te=ae,ne=le)}X.fillRect(0,te,J,ne-te)},t}(ee.ViewEventHandler);$.OverviewRuler=ne})),define(Q[230],n([0,1,23,11,33,12]),(function(X,$,Q,J,ee,ne){Object.defineProperty($,"__esModule",{value:!0});var ie=function(X){function t($){var J=X.call(this,$)||this;return J._lineHeight=J._context.configuration.editor.lineHeight,J._contentWidth=J._context.configuration.editor.layoutInfo.contentWidth,J._contentLeft=J._context.configuration.editor.layoutInfo.contentLeft,J.domNode=Q.createFastDomNode(document.createElement("div")),J.domNode.setClassName("view-zones"),J.domNode.setPosition("absolute"),J.domNode.setAttribute("role","presentation"),J.domNode.setAttribute("aria-hidden","true"),J.marginDomNode=Q.createFastDomNode(document.createElement("div")),J.marginDomNode.setClassName("margin-view-zones"),J.marginDomNode.setPosition("absolute"),J.marginDomNode.setAttribute("role","presentation"),J.marginDomNode.setAttribute("aria-hidden","true"),J._zones={},J}return te(t,X),t.prototype.dispose=function(){X.prototype.dispose.call(this),this._zones={}},t.prototype._recomputeWhitespacesProps=function(){for(var X=!1,$=Object.keys(this._zones),Q=0,J=$.length;Q<J;Q++){var ee=$[Q],te=this._zones[ee],ne=this._computeWhitespaceProps(te.delegate);this._context.viewLayout.changeWhitespace(parseInt(ee,10),ne.afterViewLineNumber,ne.heightInPx)&&(this._safeCallOnComputedHeight(te.delegate,ne.heightInPx),X=!0)}return X},t.prototype.onConfigurationChanged=function(X){return X.lineHeight?(this._lineHeight=this._context.configuration.editor.lineHeight,this._recomputeWhitespacesProps()):(X.layoutInfo&&(this._contentWidth=this._context.configuration.editor.layoutInfo.contentWidth,this._contentLeft=this._context.configuration.editor.layoutInfo.contentLeft),!0)},t.prototype.onLineMappingChanged=function(X){var $=this._recomputeWhitespacesProps();return $&&this._context.viewLayout.onHeightMaybeChanged(),$},t.prototype.onLinesDeleted=function(X){return!0},t.prototype.onScrollChanged=function(X){return X.scrollTopChanged||X.scrollWidthChanged},t.prototype.onZonesChanged=function(X){return!0},t.prototype.onLinesInserted=function(X){return!0},t.prototype._getZoneOrdinal=function(X){return void 0!==X.afterColumn?X.afterColumn:1e4},t.prototype._computeWhitespaceProps=function(X){if(0===X.afterLineNumber)return{afterViewLineNumber:0,heightInPx:this._heightInPixels(X),minWidthInPx:this._minWidthInPixels(X)};var $,Q;if(void 0!==X.afterColumn)$=this._context.model.validateModelPosition({lineNumber:X.afterLineNumber,column:X.afterColumn});else{var J=this._context.model.validateModelPosition({lineNumber:X.afterLineNumber,column:1}).lineNumber;$=new ne.Position(J,this._context.model.getModelLineMaxColumn(J))}Q=$.column===this._context.model.getModelLineMaxColumn($.lineNumber)?this._context.model.validateModelPosition({lineNumber:$.lineNumber+1,column:1}):this._context.model.validateModelPosition({lineNumber:$.lineNumber,column:$.column+1});var ee=this._context.model.coordinatesConverter.convertModelPositionToViewPosition($),te=this._context.model.coordinatesConverter.modelPositionIsVisible(Q);return{afterViewLineNumber:ee.lineNumber,heightInPx:te?this._heightInPixels(X):0,minWidthInPx:this._minWidthInPixels(X)}},t.prototype.addZone=function(X){var $=this._computeWhitespaceProps(X),J={whitespaceId:this._context.viewLayout.addWhitespace($.afterViewLineNumber,this._getZoneOrdinal(X),$.heightInPx,$.minWidthInPx),delegate:X,isVisible:!1,domNode:Q.createFastDomNode(X.domNode),marginDomNode:X.marginDomNode?Q.createFastDomNode(X.marginDomNode):null};return this._safeCallOnComputedHeight(J.delegate,$.heightInPx),J.domNode.setPosition("absolute"),J.domNode.domNode.style.width="100%",J.domNode.setDisplay("none"),J.domNode.setAttribute("monaco-view-zone",J.whitespaceId.toString()),this.domNode.appendChild(J.domNode),J.marginDomNode&&(J.marginDomNode.setPosition("absolute"),J.marginDomNode.domNode.style.width="100%",J.marginDomNode.setDisplay("none"),J.marginDomNode.setAttribute("monaco-view-zone",J.whitespaceId.toString()),this.marginDomNode.appendChild(J.marginDomNode)),this._zones[J.whitespaceId.toString()]=J,this.setShouldRender(),J.whitespaceId},t.prototype.removeZone=function(X){if(this._zones.hasOwnProperty(X.toString())){var $=this._zones[X.toString()];return delete this._zones[X.toString()],this._context.viewLayout.removeWhitespace($.whitespaceId),$.domNode.removeAttribute("monaco-visible-view-zone"),$.domNode.removeAttribute("monaco-view-zone"),$.domNode.domNode.parentNode.removeChild($.domNode.domNode),$.marginDomNode&&($.marginDomNode.removeAttribute("monaco-visible-view-zone"),$.marginDomNode.removeAttribute("monaco-view-zone"),$.marginDomNode.domNode.parentNode.removeChild($.marginDomNode.domNode)),this.setShouldRender(),!0}return!1},t.prototype.layoutZone=function(X){var $=!1;if(this._zones.hasOwnProperty(X.toString())){var Q=this._zones[X.toString()],J=this._computeWhitespaceProps(Q.delegate);($=this._context.viewLayout.changeWhitespace(Q.whitespaceId,J.afterViewLineNumber,J.heightInPx)||$)&&(this._safeCallOnComputedHeight(Q.delegate,J.heightInPx),this.setShouldRender())}return $},t.prototype.shouldSuppressMouseDownOnViewZone=function(X){if(this._zones.hasOwnProperty(X.toString())){var $=this._zones[X.toString()];return Boolean($.delegate.suppressMouseDown)}return!1},t.prototype._heightInPixels=function(X){return"number"==typeof X.heightInPx?X.heightInPx:"number"==typeof X.heightInLines?this._lineHeight*X.heightInLines:this._lineHeight},t.prototype._minWidthInPixels=function(X){return"number"==typeof X.minWidthInPx?X.minWidthInPx:0},t.prototype._safeCallOnComputedHeight=function(X,$){if("function"==typeof X.onComputedHeight)try{X.onComputedHeight($)}catch(X){J.onUnexpectedError(X)}},t.prototype._safeCallOnDomNodeTop=function(X,$){if("function"==typeof X.onDomNodeTop)try{X.onDomNodeTop($)}catch(X){J.onUnexpectedError(X)}},t.prototype.prepareRender=function(X){},t.prototype.render=function(X){for(var $=X.viewportData.whitespaceViewportData,Q={},J=!1,ee=0,te=$.length;ee<te;ee++)Q[$[ee].id.toString()]=$[ee],J=!0;var ne=Object.keys(this._zones);for(ee=0,te=ne.length;ee<te;ee++){var ie=ne[ee],oe=this._zones[ie],re=0,se=0,ae="none";Q.hasOwnProperty(ie)?(re=Q[ie].verticalOffset-X.bigNumbersDelta,se=Q[ie].height,ae="block",oe.isVisible||(oe.domNode.setAttribute("monaco-visible-view-zone","true"),oe.isVisible=!0),this._safeCallOnDomNodeTop(oe.delegate,X.getScrolledTopFromAbsoluteTop(Q[ie].verticalOffset))):(oe.isVisible&&(oe.domNode.removeAttribute("monaco-visible-view-zone"),oe.isVisible=!1),this._safeCallOnDomNodeTop(oe.delegate,X.getScrolledTopFromAbsoluteTop(-1e6))),oe.domNode.setTop(re),oe.domNode.setHeight(se),oe.domNode.setDisplay(ae),oe.marginDomNode&&(oe.marginDomNode.setTop(re),oe.marginDomNode.setHeight(se),oe.marginDomNode.setDisplay(ae))}J&&(this.domNode.setWidth(Math.max(X.scrollWidth,this._contentWidth)),this.marginDomNode.setWidth(this._contentLeft))},t}(ee.ViewPart);$.ViewZones=ie})),define(Q[59],n([0,1,8]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var i=function(X,$,Q,J){this.top=0|X,this.left=0|$,this.width=0|Q,this.height=0|J};$.Viewport=i;var o=function(X,$){this.tabSize=X,this.data=$};$.MinimapLinesRenderingData=o;var r=function(X,$,Q,J,ee){this.content=X,this.continuesWithWrappedLine=$,this.minColumn=Q,this.maxColumn=J,this.tokens=ee};$.ViewLineData=r;var J=function(){function e(X,$,Q,J,ee,te,ne,ie,oe){this.minColumn=X,this.maxColumn=$,this.content=Q,this.continuesWithWrappedLine=J,this.isBasicASCII=e.isBasicASCII(Q,te),this.containsRTL=e.containsRTL(Q,this.isBasicASCII,ee),this.tokens=ne,this.inlineDecorations=ie,this.tabSize=oe}return e.isBasicASCII=function(X,$){return!$||Q.isBasicASCII(X)},e.containsRTL=function(X,$,J){return!($||!J)&&Q.containsRTL(X)},e}();$.ViewLineRenderingData=J;var a=function(X,$,Q){this.range=X,this.inlineClassName=$,this.type=Q};$.InlineDecoration=a;var l=function(X,$){this.range=X,this.options=$};$.ViewModelDecoration=l})),define(Q[232],n([0,1,2,169,215,59]),(function(X,$,Q,J,ee,ne){Object.defineProperty($,"__esModule",{value:!0});var ie=function(X){function t($,Q,te){var ne=X.call(this)||this;return ne._configuration=$,ne._linesLayout=new ee.LinesLayout(Q,ne._configuration.editor.lineHeight),ne.scrollable=ne._register(new J.Scrollable(0,te)),ne._configureSmoothScrollDuration(),ne.scrollable.setScrollDimensions({width:$.editor.layoutInfo.contentWidth,height:$.editor.layoutInfo.contentHeight}),ne.onDidScroll=ne.scrollable.onScroll,ne._updateHeight(),ne}return te(t,X),t.prototype.dispose=function(){X.prototype.dispose.call(this)},t.prototype.onHeightMaybeChanged=function(){this._updateHeight()},t.prototype._configureSmoothScrollDuration=function(){this.scrollable.setSmoothScrollDuration(this._configuration.editor.viewInfo.smoothScrolling?125:0)},t.prototype.onConfigurationChanged=function(X){X.lineHeight&&this._linesLayout.setLineHeight(this._configuration.editor.lineHeight),X.layoutInfo&&this.scrollable.setScrollDimensions({width:this._configuration.editor.layoutInfo.contentWidth,height:this._configuration.editor.layoutInfo.contentHeight}),X.viewInfo&&this._configureSmoothScrollDuration(),this._updateHeight()},t.prototype.onFlushed=function(X){this._linesLayout.onFlushed(X)},t.prototype.onLinesDeleted=function(X,$){this._linesLayout.onLinesDeleted(X,$)},t.prototype.onLinesInserted=function(X,$){this._linesLayout.onLinesInserted(X,$)},t.prototype._getHorizontalScrollbarHeight=function(X){return 2===this._configuration.editor.viewInfo.scrollbar.horizontal||X.width>=X.scrollWidth?0:this._configuration.editor.viewInfo.scrollbar.horizontalScrollbarSize},t.prototype._getTotalHeight=function(){var X=this.scrollable.getScrollDimensions(),$=this._linesLayout.getLinesTotalHeight();return this._configuration.editor.viewInfo.scrollBeyondLastLine?$+=X.height-this._configuration.editor.lineHeight:$+=this._getHorizontalScrollbarHeight(X),Math.max(X.height,$)},t.prototype._updateHeight=function(){this.scrollable.setScrollDimensions({scrollHeight:this._getTotalHeight()})},t.prototype.getCurrentViewport=function(){var X=this.scrollable.getScrollDimensions(),$=this.scrollable.getCurrentScrollPosition();return new ne.Viewport($.scrollTop,$.scrollLeft,X.width,X.height)},t.prototype.getFutureViewport=function(){var X=this.scrollable.getScrollDimensions(),$=this.scrollable.getFutureScrollPosition();return new ne.Viewport($.scrollTop,$.scrollLeft,X.width,X.height)},t.prototype._computeScrollWidth=function(X,$){if(!this._configuration.editor.wrappingInfo.isViewportWrapping){var Q=this._configuration.editor.viewInfo.scrollBeyondLastColumn*this._configuration.editor.fontInfo.typicalHalfwidthCharacterWidth,J=this._linesLayout.getWhitespaceMinWidth();return Math.max(X+Q,$,J)}return Math.max(X,$)},t.prototype.onMaxLineWidthChanged=function(X){var $=this._computeScrollWidth(X,this.getCurrentViewport().width);this.scrollable.setScrollDimensions({scrollWidth:$}),this._updateHeight()},t.prototype.saveState=function(){var X=this.scrollable.getFutureScrollPosition(),$=X.scrollTop,Q=this._linesLayout.getLineNumberAtOrAfterVerticalOffset($);return{scrollTop:$,scrollTopWithoutViewZones:$-this._linesLayout.getWhitespaceAccumulatedHeightBeforeLineNumber(Q),scrollLeft:X.scrollLeft}},t.prototype.addWhitespace=function(X,$,Q,J){return this._linesLayout.insertWhitespace(X,$,Q,J)},t.prototype.changeWhitespace=function(X,$,Q){return this._linesLayout.changeWhitespace(X,$,Q)},t.prototype.removeWhitespace=function(X){return this._linesLayout.removeWhitespace(X)},t.prototype.getVerticalOffsetForLineNumber=function(X){return this._linesLayout.getVerticalOffsetForLineNumber(X)},t.prototype.isAfterLines=function(X){return this._linesLayout.isAfterLines(X)},t.prototype.getLineNumberAtVerticalOffset=function(X){return this._linesLayout.getLineNumberAtOrAfterVerticalOffset(X)},t.prototype.getWhitespaceAtVerticalOffset=function(X){return this._linesLayout.getWhitespaceAtVerticalOffset(X)},t.prototype.getLinesViewportData=function(){var X=this.getCurrentViewport();return this._linesLayout.getLinesViewportData(X.top,X.top+X.height)},t.prototype.getLinesViewportDataAtScrollTop=function(X){var $=this.scrollable.getScrollDimensions();return X+$.height>$.scrollHeight&&(X=$.scrollHeight-$.height),X<0&&(X=0),this._linesLayout.getLinesViewportData(X,X+$.height)},t.prototype.getWhitespaceViewportData=function(){var X=this.getCurrentViewport();return this._linesLayout.getWhitespaceViewportData(X.top,X.top+X.height)},t.prototype.getWhitespaces=function(){return this._linesLayout.getWhitespaces()},t.prototype.getScrollWidth=function(){return this.scrollable.getScrollDimensions().scrollWidth},t.prototype.getScrollHeight=function(){return this.scrollable.getScrollDimensions().scrollHeight},t.prototype.getCurrentScrollLeft=function(){return this.scrollable.getCurrentScrollPosition().scrollLeft},t.prototype.getCurrentScrollTop=function(){return this.scrollable.getCurrentScrollPosition().scrollTop},t.prototype.validateScrollPosition=function(X){return this.scrollable.validateScrollPosition(X)},t.prototype.setScrollPositionNow=function(X){this.scrollable.setScrollPositionNow(X)},t.prototype.setScrollPositionSmooth=function(X){this.scrollable.setScrollPositionSmooth(X)},t.prototype.deltaScrollNow=function(X,$){var Q=this.scrollable.getCurrentScrollPosition();this.scrollable.setScrollPositionNow({scrollLeft:Q.scrollLeft+X,scrollTop:Q.scrollTop+$})},t}(Q.Disposable);$.ViewLayout=ie})),define(Q[233],n([0,1,12,3,59]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var te=function(){function e(X,$,Q,J,ee){this.editorId=X,this.model=$,this.configuration=Q,this._linesCollection=J,this._coordinatesConverter=ee,this._decorationsCache=Object.create(null),this._clearCachedModelDecorationsResolver()}return e.prototype._clearCachedModelDecorationsResolver=function(){this._cachedModelDecorationsResolver=null,this._cachedModelDecorationsResolverViewRange=null},e.prototype.dispose=function(){this._decorationsCache=Object.create(null),this._clearCachedModelDecorationsResolver()},e.prototype.reset=function(){this._decorationsCache=Object.create(null),this._clearCachedModelDecorationsResolver()},e.prototype.onModelDecorationsChanged=function(){this._decorationsCache=Object.create(null),this._clearCachedModelDecorationsResolver()},e.prototype.onLineMappingChanged=function(){this._decorationsCache=Object.create(null),this._clearCachedModelDecorationsResolver()},e.prototype._getOrCreateViewModelDecoration=function(X){var $=X.id,te=this._decorationsCache[$];if(!te){var ne=X.range,ie=X.options,oe=void 0;if(ie.isWholeLine){var re=this._coordinatesConverter.convertModelPositionToViewPosition(new Q.Position(ne.startLineNumber,1)),se=this._coordinatesConverter.convertModelPositionToViewPosition(new Q.Position(ne.endLineNumber,this.model.getLineMaxColumn(ne.endLineNumber)));oe=new J.Range(re.lineNumber,re.column,se.lineNumber,se.column)}else oe=this._coordinatesConverter.convertModelRangeToViewRange(ne);te=new ee.ViewModelDecoration(oe,ie),this._decorationsCache[$]=te}return te},e.prototype.getDecorationsViewportData=function(X){var $=!0;return($=($=$&&null!==this._cachedModelDecorationsResolver)&&X.equalsRange(this._cachedModelDecorationsResolverViewRange))||(this._cachedModelDecorationsResolver=this._getDecorationsViewportData(X),this._cachedModelDecorationsResolverViewRange=X),this._cachedModelDecorationsResolver},e.prototype._getDecorationsViewportData=function(X){for(var $=this._linesCollection.getDecorationsInRange(X,this.editorId,this.configuration.editor.readOnly),Q=X.startLineNumber,te=X.endLineNumber,ne=[],ie=0,oe=[],re=Q;re<=te;re++)oe[re-Q]=[];for(var se=0,ae=$.length;se<ae;se++){var le=$[se],ue=le.options,de=this._getOrCreateViewModelDecoration(le),ce=de.range;if(ne[ie++]=de,ue.inlineClassName){var he=new ee.InlineDecoration(ce,ue.inlineClassName,ue.inlineClassNameAffectsLetterSpacing?3:0),pe=Math.max(Q,ce.startLineNumber),fe=Math.min(te,ce.endLineNumber);for(re=pe;re<=fe;re++)oe[re-Q].push(he)}ue.beforeContentClassName&&Q<=ce.startLineNumber&&ce.startLineNumber<=te&&(he=new ee.InlineDecoration(new J.Range(ce.startLineNumber,ce.startColumn,ce.startLineNumber,ce.startColumn),ue.beforeContentClassName,1),oe[ce.startLineNumber-Q].push(he)),ue.afterContentClassName&&Q<=ce.endLineNumber&&ce.endLineNumber<=te&&(he=new ee.InlineDecoration(new J.Range(ce.endLineNumber,ce.endColumn,ce.endLineNumber,ce.endColumn),ue.afterContentClassName,2),oe[ce.endLineNumber-Q].push(he))}return{decorations:ne,inlineDecorations:oe}},e}();$.ViewModelDecorations=te})),define(Q[234],n([0,1,3]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(){function e(X,$){this._selection=X,this._isMovingLeft=$}return e.prototype.getEditOperations=function(X,$){var J=this._selection;if(this._selectionId=$.trackSelection(J),J.startLineNumber===J.endLineNumber&&(!this._isMovingLeft||0!==J.startColumn)&&(this._isMovingLeft||J.endColumn!==X.getLineMaxColumn(J.startLineNumber))){var ee,te,ne,ie=J.selectionStartLineNumber,oe=X.getLineContent(ie);this._isMovingLeft?(ee=oe.substring(0,J.startColumn-2),te=oe.substring(J.startColumn-1,J.endColumn-1),ne=oe.substring(J.startColumn-2,J.startColumn-1)+oe.substring(J.endColumn-1)):(ee=oe.substring(0,J.startColumn-1)+oe.substring(J.endColumn-1,J.endColumn),te=oe.substring(J.startColumn-1,J.endColumn-1),ne=oe.substring(J.endColumn));var re=ee+te+ne;$.addEditOperation(new Q.Range(ie,1,ie,X.getLineMaxColumn(ie)),null),$.addEditOperation(new Q.Range(ie,1,ie,1),re),this._cutStartIndex=J.startColumn+(this._isMovingLeft?-1:1),this._cutEndIndex=this._cutStartIndex+J.endColumn-J.startColumn,this._moved=!0}},e.prototype.computeCursorState=function(X,$){var Q=$.getTrackedSelection(this._selectionId);return this._moved&&(Q=(Q=Q.setStartPosition(Q.startLineNumber,this._cutStartIndex)).setEndPosition(Q.startLineNumber,this._cutEndIndex)),Q},e}();$.MoveCaretCommand=J})),define(Q[108],n([0,1,8]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(){function e(X){this.value=X}return e.prototype.contains=function(X){return this.value===X||Q.startsWith(X,this.value+e.sep)},e.sep=".",e.Empty=new e(""),e.Refactor=new e("refactor"),e.Source=new e("source"),e.SourceOrganizeImports=new e("source.organizeImports"),e}();$.CodeActionKind=J})),define(Q[236],n([0,1,7,56,16,11,6,12]),(function(X,$,Q,J,ee,te,ne,ie){Object.defineProperty($,"__esModule",{value:!0});var oe=function(){function e(X,$,Q){this._editor=X,this._contextMenuService=$,this._onApplyCodeAction=Q,this._onDidExecuteCodeAction=new ne.Emitter,this.onDidExecuteCodeAction=this._onDidExecuteCodeAction.event}return e.prototype.show=function(X,$){var Q=this,ne=X?X.then((function(X){return X.map((function(X){return new J.Action(X.command?X.command.id:X.title,X.title,void 0,!0,(function(){return ee.always(Q._onApplyCodeAction(X),(function(){return Q._onDidExecuteCodeAction.fire(void 0)}))}))}))})).then((function(X){return Q._editor.getDomNode()?X:Promise.reject(te.canceled())})):Promise.resolve([]);this._contextMenuService.showContextMenu({getAnchor:function(){return ie.Position.isIPosition($)&&($=Q._toCoords($)),$},getActions:function(){return ne},onHide:function(){Q._visible=!1,Q._editor.focus()},autoSelectFirstItem:!0})},Object.defineProperty(e.prototype,"isVisible",{get:function(){return this._visible},enumerable:!0,configurable:!0}),e.prototype._toCoords=function(X){this._editor.revealPosition(X,1),this._editor.render();var $=this._editor.getScrolledVisiblePosition(this._editor.getPosition()),J=Q.getDomNodePagePosition(this._editor.getDomNode());return{x:J.left+$.left,y:J.top+$.top+$.height}},e}();$.CodeActionContextMenu=oe})),define(Q[237],n([0,1,6]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(){function e(X,$,J){this.presentationIndex=J,this._onColorFlushed=new Q.Emitter,this.onColorFlushed=this._onColorFlushed.event,this._onDidChangeColor=new Q.Emitter,this.onDidChangeColor=this._onDidChangeColor.event,this._onDidChangePresentation=new Q.Emitter,this.onDidChangePresentation=this._onDidChangePresentation.event,this.originalColor=X,this._color=X,this._colorPresentations=$}return Object.defineProperty(e.prototype,"color",{get:function(){return this._color},set:function(X){this._color.equals(X)||(this._color=X,this._onDidChangeColor.fire(X))},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"presentation",{get:function(){return this.colorPresentations[this.presentationIndex]},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"colorPresentations",{get:function(){return this._colorPresentations},set:function(X){this._colorPresentations=X,this.presentationIndex>X.length-1&&(this.presentationIndex=0),this._onDidChangePresentation.fire(this.presentation)},enumerable:!0,configurable:!0}),e.prototype.selectNextColorPresentation=function(){this.presentationIndex=(this.presentationIndex+1)%this.colorPresentations.length,this.flushColor(),this._onDidChangePresentation.fire(this.presentation)},e.prototype.guessColorPresentation=function(X,$){for(var Q=0;Q<this.colorPresentations.length;Q++)if($===this.colorPresentations[Q].label){this.presentationIndex=Q,this._onDidChangePresentation.fire(this.presentation);break}},e.prototype.flushColor=function(){this._onColorFlushed.fire(this._color)},e}();$.ColorPickerModel=J})),define(Q[171],n([0,1,49,12,3,21,39]),(function(X,$,Q,J,ee,te,ne){Object.defineProperty($,"__esModule",{value:!0});var ie=function(){function e(X){this._selection=X,this._usedEndToken=null}return e._haystackHasNeedleAtOffset=function(X,$,Q){if(Q<0)return!1;var J=$.length;if(Q+J>X.length)return!1;for(var ee=0;ee<J;ee++){var te=X.charCodeAt(Q+ee),ne=$.charCodeAt(ee);if(te!==ne&&!(te>=65&&te<=90&&te+32===ne||ne>=65&&ne<=90&&ne+32===te))return!1}return!0},e.prototype._createOperationsForBlockComment=function(X,$,Q,J,te){var ne,ie=X.startLineNumber,oe=X.startColumn,re=X.endLineNumber,se=X.endColumn,ae=J.getLineContent(ie),le=J.getLineContent(re),ue=ae.lastIndexOf($,oe-1+$.length),de=le.indexOf(Q,se-1-Q.length);if(-1!==ue&&-1!==de)if(ie===re)ae.substring(ue+$.length,de).indexOf(Q)>=0&&(ue=-1,de=-1);else{var ce=ae.substring(ue+$.length),he=le.substring(0,de);(ce.indexOf(Q)>=0||he.indexOf(Q)>=0)&&(ue=-1,de=-1)}-1!==ue&&-1!==de?(ue+$.length<ae.length&&32===ae.charCodeAt(ue+$.length)&&($+=" "),de>0&&32===le.charCodeAt(de-1)&&(Q=" "+Q,de-=1),ne=e._createRemoveBlockCommentOperations(new ee.Range(ie,ue+$.length+1,re,de+1),$,Q)):(ne=e._createAddBlockCommentOperations(X,$,Q),this._usedEndToken=1===ne.length?Q:null);for(var pe=0;pe<ne.length;pe++)te.addTrackedEditOperation(ne[pe].range,ne[pe].text)},e._createRemoveBlockCommentOperations=function(X,$,J){var te=[];return ee.Range.isEmpty(X)?te.push(Q.EditOperation.delete(new ee.Range(X.startLineNumber,X.startColumn-$.length,X.endLineNumber,X.endColumn+J.length))):(te.push(Q.EditOperation.delete(new ee.Range(X.startLineNumber,X.startColumn-$.length,X.startLineNumber,X.startColumn))),te.push(Q.EditOperation.delete(new ee.Range(X.endLineNumber,X.endColumn,X.endLineNumber,X.endColumn+J.length)))),te},e._createAddBlockCommentOperations=function(X,$,te){var ne=[];return ee.Range.isEmpty(X)?ne.push(Q.EditOperation.replace(new ee.Range(X.startLineNumber,X.startColumn,X.endLineNumber,X.endColumn),$+"  "+te)):(ne.push(Q.EditOperation.insert(new J.Position(X.startLineNumber,X.startColumn),$+" ")),ne.push(Q.EditOperation.insert(new J.Position(X.endLineNumber,X.endColumn)," "+te))),ne},e.prototype.getEditOperations=function(X,$){var Q=this._selection.startLineNumber,J=this._selection.startColumn;X.tokenizeIfCheap(Q);var ee=X.getLanguageIdAtPosition(Q,J),te=ne.LanguageConfigurationRegistry.getComments(ee);te&&te.blockCommentStartToken&&te.blockCommentEndToken&&this._createOperationsForBlockComment(this._selection,te.blockCommentStartToken,te.blockCommentEndToken,X,$)},e.prototype.computeCursorState=function(X,$){var Q=$.getInverseEditOperations();if(2===Q.length){var J=Q[0],ee=Q[1];return new te.Selection(J.range.endLineNumber,J.range.endColumn,ee.range.startLineNumber,ee.range.startColumn)}var ne=Q[0].range,ie=this._usedEndToken?-this._usedEndToken.length-1:0;return new te.Selection(ne.endLineNumber,ne.endColumn+ie,ne.endLineNumber,ne.endColumn+ie)},e}();$.BlockCommentCommand=ie})),define(Q[239],n([0,1,8,49,12,3,21,39,171]),(function(X,$,Q,J,ee,te,ne,ie,oe){Object.defineProperty($,"__esModule",{value:!0});var re=function(){function e(X,$,Q){this._selection=X,this._tabSize=$,this._type=Q,this._deltaColumn=0}return e._gatherPreflightCommentStrings=function(X,$,Q){X.tokenizeIfCheap($);var J=X.getLanguageIdAtPosition($,1),ee=ie.LanguageConfigurationRegistry.getComments(J),te=ee?ee.lineCommentToken:null;if(!te)return null;for(var ne=[],oe=0,re=Q-$+1;oe<re;oe++)ne[oe]={ignore:!1,commentStr:te,commentStrOffset:0,commentStrLength:te.length};return ne},e._analyzeLines=function(X,$,J,ee){var te,ne=!0;te=0===X||1!==X;for(var ie=0,re=J.length;ie<re;ie++){var se=J[ie],ae=ee+ie,le=$.getLineContent(ae),ue=Q.firstNonWhitespaceIndex(le);if(-1!==ue){if(ne=!1,se.ignore=!1,se.commentStrOffset=ue,te&&!oe.BlockCommentCommand._haystackHasNeedleAtOffset(le,se.commentStr,ue)&&(0===X?te=!1:1===X||(se.ignore=!0)),te){var de=ue+se.commentStrLength;de<le.length&&32===le.charCodeAt(de)&&(se.commentStrLength+=1)}}else se.ignore=!0,se.commentStrOffset=le.length}if(0===X&&ne){te=!1;for(ie=0,re=J.length;ie<re;ie++)J[ie].ignore=!1}return{supported:!0,shouldRemoveComments:te,lines:J}},e._gatherPreflightData=function(X,$,Q,J){var ee=e._gatherPreflightCommentStrings($,Q,J);return null===ee?{supported:!1}:e._analyzeLines(X,$,ee,Q)},e.prototype._executeLineComments=function(X,$,Q,J){var te;Q.shouldRemoveComments?te=e._createRemoveLineCommentsOperations(Q.lines,J.startLineNumber):(e._normalizeInsertionPoint(X,Q.lines,J.startLineNumber,this._tabSize),te=e._createAddLineCommentsOperations(Q.lines,J.startLineNumber));for(var ne=new ee.Position(J.positionLineNumber,J.positionColumn),ie=0,oe=te.length;ie<oe;ie++)$.addEditOperation(te[ie].range,te[ie].text),te[ie].range.isEmpty()&&te[ie].range.getStartPosition().equals(ne)&&X.getLineContent(ne.lineNumber).length+1===ne.column&&(this._deltaColumn=(te[ie].text||"").length);this._selectionId=$.trackSelection(J)},e.prototype._attemptRemoveBlockComment=function(X,$,Q,J){var ee=$.startLineNumber,ne=$.endLineNumber,ie=J.length+Math.max(X.getLineFirstNonWhitespaceColumn($.startLineNumber),$.startColumn),re=X.getLineContent(ee).lastIndexOf(Q,ie-1),se=X.getLineContent(ne).indexOf(J,$.endColumn-1-Q.length);return-1!==re&&-1===se&&(se=X.getLineContent(ee).indexOf(J,re+Q.length),ne=ee),-1===re&&-1!==se&&(re=X.getLineContent(ne).lastIndexOf(Q,se),ee=ne),!$.isEmpty()||-1!==re&&-1!==se||-1!==(re=X.getLineContent(ee).indexOf(Q))&&(se=X.getLineContent(ee).indexOf(J,re+Q.length)),-1!==re&&32===X.getLineContent(ee).charCodeAt(re+Q.length)&&(Q+=" "),-1!==se&&32===X.getLineContent(ne).charCodeAt(se-1)&&(J=" "+J,se-=1),-1!==re&&-1!==se?oe.BlockCommentCommand._createRemoveBlockCommentOperations(new te.Range(ee,re+Q.length+1,ne,se+1),Q,J):null},e.prototype._executeBlockComment=function(X,$,J){X.tokenizeIfCheap(J.startLineNumber);var ee=X.getLanguageIdAtPosition(J.startLineNumber,1),ne=ie.LanguageConfigurationRegistry.getComments(ee);if(ne&&ne.blockCommentStartToken&&ne.blockCommentEndToken){var re=ne.blockCommentStartToken,se=ne.blockCommentEndToken,ae=this._attemptRemoveBlockComment(X,J,re,se);if(!ae){if(J.isEmpty()){var le=X.getLineContent(J.startLineNumber),ue=Q.firstNonWhitespaceIndex(le);-1===ue&&(ue=le.length),ae=oe.BlockCommentCommand._createAddBlockCommentOperations(new te.Range(J.startLineNumber,ue+1,J.startLineNumber,le.length+1),re,se)}else ae=oe.BlockCommentCommand._createAddBlockCommentOperations(new te.Range(J.startLineNumber,X.getLineFirstNonWhitespaceColumn(J.startLineNumber),J.endLineNumber,X.getLineMaxColumn(J.endLineNumber)),re,se);1===ae.length&&(this._deltaColumn=re.length+1)}this._selectionId=$.trackSelection(J);for(var de=0;de<ae.length;de++)$.addEditOperation(ae[de].range,ae[de].text)}},e.prototype.getEditOperations=function(X,$){var Q=this._selection;this._moveEndPositionDown=!1,Q.startLineNumber<Q.endLineNumber&&1===Q.endColumn&&(this._moveEndPositionDown=!0,Q=Q.setEndPosition(Q.endLineNumber-1,X.getLineMaxColumn(Q.endLineNumber-1)));var J=e._gatherPreflightData(this._type,X,Q.startLineNumber,Q.endLineNumber);return J.supported?this._executeLineComments(X,$,J,Q):this._executeBlockComment(X,$,Q)},e.prototype.computeCursorState=function(X,$){var Q=$.getTrackedSelection(this._selectionId);return this._moveEndPositionDown&&(Q=Q.setEndPosition(Q.endLineNumber+1,1)),new ne.Selection(Q.selectionStartLineNumber,Q.selectionStartColumn+this._deltaColumn,Q.positionLineNumber,Q.positionColumn+this._deltaColumn)},e._createRemoveLineCommentsOperations=function(X,$){for(var Q=[],ee=0,ne=X.length;ee<ne;ee++){var ie=X[ee];ie.ignore||Q.push(J.EditOperation.delete(new te.Range($+ee,ie.commentStrOffset+1,$+ee,ie.commentStrOffset+ie.commentStrLength+1)))}return Q},e._createAddLineCommentsOperations=function(X,$){for(var Q=[],te=0,ne=X.length;te<ne;te++){var ie=X[te];ie.ignore||Q.push(J.EditOperation.insert(new ee.Position($+te,ie.commentStrOffset+1),ie.commentStr+" "))}return Q},e.nextVisibleColumn=function(X,$,Q,J){return Q?X+($-X%$):X+J},e._normalizeInsertionPoint=function(X,$,Q,J){for(var ee,te,ne=Number.MAX_VALUE,ie=0,oe=$.length;ie<oe;ie++)if(!$[ie].ignore){for(var re=X.getLineContent(Q+ie),se=0,ae=0,le=$[ie].commentStrOffset;se<ne&&ae<le;ae++)se=e.nextVisibleColumn(se,J,9===re.charCodeAt(ae),1);se<ne&&(ne=se)}ne=Math.floor(ne/J)*J;for(ie=0,oe=$.length;ie<oe;ie++)if(!$[ie].ignore){re=X.getLineContent(Q+ie),se=0;for(ee=0,te=$[ie].commentStrOffset;se<ne&&ee<te;ee++)se=e.nextVisibleColumn(se,J,9===re.charCodeAt(ee),1);$[ie].commentStrOffset=se>ne?ee-1:ee}},e}();$.LineCommentCommand=re})),define(Q[240],n([0,1,21,3]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(){function e(X,$,Q){this.selection=X,this.targetPosition=$,this.copy=Q}return e.prototype.getEditOperations=function(X,$){var ee=X.getValueInRange(this.selection);this.copy||$.addEditOperation(this.selection,null),$.addEditOperation(new J.Range(this.targetPosition.lineNumber,this.targetPosition.column,this.targetPosition.lineNumber,this.targetPosition.column),ee),!this.selection.containsPosition(this.targetPosition)||this.copy&&(this.selection.getEndPosition().equals(this.targetPosition)||this.selection.getStartPosition().equals(this.targetPosition))?this.copy?this.targetSelection=new Q.Selection(this.targetPosition.lineNumber,this.targetPosition.column,this.selection.endLineNumber-this.selection.startLineNumber+this.targetPosition.lineNumber,this.selection.startLineNumber===this.selection.endLineNumber?this.targetPosition.column+this.selection.endColumn-this.selection.startColumn:this.selection.endColumn):this.targetPosition.lineNumber>this.selection.endLineNumber?this.targetSelection=new Q.Selection(this.targetPosition.lineNumber-this.selection.endLineNumber+this.selection.startLineNumber,this.targetPosition.column,this.targetPosition.lineNumber,this.selection.startLineNumber===this.selection.endLineNumber?this.targetPosition.column+this.selection.endColumn-this.selection.startColumn:this.selection.endColumn):this.targetPosition.lineNumber<this.selection.endLineNumber?this.targetSelection=new Q.Selection(this.targetPosition.lineNumber,this.targetPosition.column,this.targetPosition.lineNumber+this.selection.endLineNumber-this.selection.startLineNumber,this.selection.startLineNumber===this.selection.endLineNumber?this.targetPosition.column+this.selection.endColumn-this.selection.startColumn:this.selection.endColumn):this.selection.endColumn<=this.targetPosition.column?this.targetSelection=new Q.Selection(this.targetPosition.lineNumber-this.selection.endLineNumber+this.selection.startLineNumber,(this.selection.startLineNumber,this.selection.endLineNumber,this.targetPosition.column-this.selection.endColumn+this.selection.startColumn),this.targetPosition.lineNumber,this.selection.startLineNumber===this.selection.endLineNumber?this.targetPosition.column:this.selection.endColumn):this.targetSelection=new Q.Selection(this.targetPosition.lineNumber-this.selection.endLineNumber+this.selection.startLineNumber,this.targetPosition.column,this.targetPosition.lineNumber,this.targetPosition.column+this.selection.endColumn-this.selection.startColumn):this.targetSelection=this.selection},e.prototype.computeCursorState=function(X,$){return this.targetSelection},e}();$.DragAndDropCommand=ee})),define(Q[241],n([0,1,6,3]),(function(X,$,Q,J){function o(X,$){return 1===X||2!==X&&$}Object.defineProperty($,"__esModule",{value:!0});var ee=function(){function e(){this._searchString="",this._replaceString="",this._isRevealed=!1,this._isReplaceRevealed=!1,this._isRegex=!1,this._isRegexOverride=0,this._wholeWord=!1,this._wholeWordOverride=0,this._matchCase=!1,this._matchCaseOverride=0,this._searchScope=null,this._matchesPosition=0,this._matchesCount=0,this._currentMatch=null,this._onFindReplaceStateChange=new Q.Emitter}return Object.defineProperty(e.prototype,"searchString",{get:function(){return this._searchString},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"replaceString",{get:function(){return this._replaceString},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isRevealed",{get:function(){return this._isRevealed},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isReplaceRevealed",{get:function(){return this._isReplaceRevealed},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isRegex",{get:function(){return o(this._isRegexOverride,this._isRegex)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"wholeWord",{get:function(){return o(this._wholeWordOverride,this._wholeWord)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"matchCase",{get:function(){return o(this._matchCaseOverride,this._matchCase)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"actualIsRegex",{get:function(){return this._isRegex},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"actualWholeWord",{get:function(){return this._wholeWord},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"actualMatchCase",{get:function(){return this._matchCase},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"searchScope",{get:function(){return this._searchScope},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"matchesPosition",{get:function(){return this._matchesPosition},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"matchesCount",{get:function(){return this._matchesCount},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"currentMatch",{get:function(){return this._currentMatch},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onFindReplaceStateChange",{get:function(){return this._onFindReplaceStateChange.event},enumerable:!0,configurable:!0}),e.prototype.dispose=function(){},e.prototype.changeMatchInfo=function(X,$,Q){var ee={moveCursor:!1,updateHistory:!1,searchString:!1,replaceString:!1,isRevealed:!1,isReplaceRevealed:!1,isRegex:!1,wholeWord:!1,matchCase:!1,searchScope:!1,matchesPosition:!1,matchesCount:!1,currentMatch:!1},te=!1;0===$&&(X=0),X>$&&(X=$),this._matchesPosition!==X&&(this._matchesPosition=X,ee.matchesPosition=!0,te=!0),this._matchesCount!==$&&(this._matchesCount=$,ee.matchesCount=!0,te=!0),void 0!==Q&&(J.Range.equalsRange(this._currentMatch,Q)||(this._currentMatch=Q,ee.currentMatch=!0,te=!0)),te&&this._onFindReplaceStateChange.fire(ee)},e.prototype.change=function(X,$,Q){void 0===Q&&(Q=!0);var ee={moveCursor:$,updateHistory:Q,searchString:!1,replaceString:!1,isRevealed:!1,isReplaceRevealed:!1,isRegex:!1,wholeWord:!1,matchCase:!1,searchScope:!1,matchesPosition:!1,matchesCount:!1,currentMatch:!1},te=!1,ne=this.isRegex,ie=this.wholeWord,oe=this.matchCase;void 0!==X.searchString&&this._searchString!==X.searchString&&(this._searchString=X.searchString,ee.searchString=!0,te=!0),void 0!==X.replaceString&&this._replaceString!==X.replaceString&&(this._replaceString=X.replaceString,ee.replaceString=!0,te=!0),void 0!==X.isRevealed&&this._isRevealed!==X.isRevealed&&(this._isRevealed=X.isRevealed,ee.isRevealed=!0,te=!0),void 0!==X.isReplaceRevealed&&this._isReplaceRevealed!==X.isReplaceRevealed&&(this._isReplaceRevealed=X.isReplaceRevealed,ee.isReplaceRevealed=!0,te=!0),void 0!==X.isRegex&&(this._isRegex=X.isRegex),void 0!==X.wholeWord&&(this._wholeWord=X.wholeWord),void 0!==X.matchCase&&(this._matchCase=X.matchCase),void 0!==X.searchScope&&(J.Range.equalsRange(this._searchScope,X.searchScope)||(this._searchScope=X.searchScope,ee.searchScope=!0,te=!0)),this._isRegexOverride=void 0!==X.isRegexOverride?X.isRegexOverride:0,this._wholeWordOverride=void 0!==X.wholeWordOverride?X.wholeWordOverride:0,this._matchCaseOverride=void 0!==X.matchCaseOverride?X.matchCaseOverride:0,ne!==this.isRegex&&(te=!0,ee.isRegex=!0),ie!==this.wholeWord&&(te=!0,ee.wholeWord=!0),oe!==this.matchCase&&(te=!0,ee.matchCase=!0),te&&this._onFindReplaceStateChange.fire(ee)},e}();$.FindReplaceState=ee})),define(Q[242],n([0,1,3]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(){function e(X,$,Q){this._editorSelection=X,this._ranges=$,this._replaceStrings=Q}return e.prototype.getEditOperations=function(X,$){if(this._ranges.length>0){for(var J=[],ee=0;ee<this._ranges.length;ee++)J.push({range:this._ranges[ee],text:this._replaceStrings[ee]});J.sort((function(X,$){return Q.Range.compareRangesUsingStarts(X.range,$.range)}));var te=[],ne=J[0];for(ee=1;ee<J.length;ee++)ne.range.endLineNumber===J[ee].range.startLineNumber&&ne.range.endColumn===J[ee].range.startColumn?(ne.range=ne.range.plusRange(J[ee].range),ne.text=ne.text+J[ee].text):(te.push(ne),ne=J[ee]);for(te.push(ne),ee=0;ee<te.length;ee++)$.addEditOperation(te[ee].range,te[ee].text)}this._trackedEditorSelectionId=$.trackSelection(this._editorSelection)},e.prototype.computeCursorState=function(X,$){return $.getTrackedSelection(this._trackedEditorSelectionId)},e}();$.ReplaceAllCommand=J})),define(Q[243],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var n=function(X){this.staticValue=X,this.kind=0},i=function(X){this.pieces=X,this.kind=1},Q=function(){function e(X){X&&0!==X.length?1===X.length&&null!==X[0].staticValue?this._state=new n(X[0].staticValue):this._state=new i(X):this._state=new n("")}return e.fromStaticValue=function(X){return new e([J.staticValue(X)])},Object.defineProperty(e.prototype,"hasReplacementPatterns",{get:function(){return 1===this._state.kind},enumerable:!0,configurable:!0}),e.prototype.buildReplaceString=function(X){if(0===this._state.kind)return this._state.staticValue;for(var $="",Q=0,J=this._state.pieces.length;Q<J;Q++){var ee=this._state.pieces[Q];null===ee.staticValue?$+=e._substitute(ee.matchIndex,X):$+=ee.staticValue}return $},e._substitute=function(X,$){if(null===$)return"";if(0===X)return $[0];for(var Q="";X>0;){if(X<$.length)return($[X]||"")+Q;Q=String(X%10)+Q,X=Math.floor(X/10)}return"$"+Q},e}();$.ReplacePattern=Q;var J=function(){function e(X,$){this.staticValue=X,this.matchIndex=$}return e.staticValue=function(X){return new e(X,-1)},e.matchIndex=function(X){return new e(null,X)},e}();$.ReplacePiece=J;var ee=function(){function e(X){this._source=X,this._lastCharIndex=0,this._result=[],this._resultLen=0,this._currentStaticPiece=""}return e.prototype.emitUnchanged=function(X){this._emitStatic(this._source.substring(this._lastCharIndex,X)),this._lastCharIndex=X},e.prototype.emitStatic=function(X,$){this._emitStatic(X),this._lastCharIndex=$},e.prototype._emitStatic=function(X){0!==X.length&&(this._currentStaticPiece+=X)},e.prototype.emitMatchIndex=function(X,$){0!==this._currentStaticPiece.length&&(this._result[this._resultLen++]=J.staticValue(this._currentStaticPiece),this._currentStaticPiece=""),this._result[this._resultLen++]=J.matchIndex(X),this._lastCharIndex=$},e.prototype.finalize=function(){return this.emitUnchanged(this._source.length),0!==this._currentStaticPiece.length&&(this._result[this._resultLen++]=J.staticValue(this._currentStaticPiece),this._currentStaticPiece=""),new Q(this._result)},e}();$.parseReplaceString=function(X){if(!X||0===X.length)return new Q(null);for(var $=new ee(X),J=0,te=X.length;J<te;J++){var ne=X.charCodeAt(J);if(92!==ne){if(36===ne){if(++J>=te)break;if(36===(re=X.charCodeAt(J))){$.emitUnchanged(J-1),$.emitStatic("$",J+1);continue}if(48===re||38===re){$.emitUnchanged(J-1),$.emitMatchIndex(0,J+1);continue}if(49<=re&&re<=57){var ie=re-48;if(J+1<te){var oe=X.charCodeAt(J+1);if(48<=oe&&oe<=57){J++,ie=10*ie+(oe-48),$.emitUnchanged(J-2),$.emitMatchIndex(ie,J+1);continue}}$.emitUnchanged(J-1),$.emitMatchIndex(ie,J+1);continue}}}else{if(++J>=te)break;var re;switch(re=X.charCodeAt(J)){case 92:$.emitUnchanged(J-1),$.emitStatic("\\",J+1);break;case 110:$.emitUnchanged(J-1),$.emitStatic("\n",J+1);break;case 116:$.emitUnchanged(J-1),$.emitStatic("\t",J+1)}}}return $.finalize()}})),define(Q[109],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0}),$.MAX_FOLDING_REGIONS=65535,$.MAX_LINE_NUMBER=16777215;var Q=function(){function e(X,Q,J){if(X.length!==Q.length||X.length>$.MAX_FOLDING_REGIONS)throw new Error("invalid startIndexes or endIndexes size");this._startIndexes=X,this._endIndexes=Q,this._collapseStates=new Uint32Array(Math.ceil(X.length/32)),this._types=J}return e.prototype.ensureParentIndices=function(){var X=this;if(!this._parentsComputed){this._parentsComputed=!0;for(var Q=[],i=function($,J){var ee=Q[Q.length-1];return X.getStartLineNumber(ee)<=$&&X.getEndLineNumber(ee)>=J},J=0,ee=this._startIndexes.length;J<ee;J++){var te=this._startIndexes[J],ne=this._endIndexes[J];if(te>$.MAX_LINE_NUMBER||ne>$.MAX_LINE_NUMBER)throw new Error("startLineNumber or endLineNumber must not exceed "+$.MAX_LINE_NUMBER);for(;Q.length>0&&!i(te,ne);)Q.pop();var ie=Q.length>0?Q[Q.length-1]:-1;Q.push(J),this._startIndexes[J]=te+((255&ie)<<24),this._endIndexes[J]=ne+((65280&ie)<<16)}}},Object.defineProperty(e.prototype,"length",{get:function(){return this._startIndexes.length},enumerable:!0,configurable:!0}),e.prototype.getStartLineNumber=function(X){return this._startIndexes[X]&$.MAX_LINE_NUMBER},e.prototype.getEndLineNumber=function(X){return this._endIndexes[X]&$.MAX_LINE_NUMBER},e.prototype.getType=function(X){return this._types?this._types[X]:void 0},e.prototype.hasTypes=function(){return!!this._types},e.prototype.isCollapsed=function(X){var $=X/32|0,Q=X%32;return 0!=(this._collapseStates[$]&1<<Q)},e.prototype.setCollapsed=function(X,$){var Q=X/32|0,J=X%32,ee=this._collapseStates[Q];this._collapseStates[Q]=$?ee|1<<J:ee&~(1<<J)},e.prototype.toRegion=function(X){return new J(this,X)},e.prototype.getParentIndex=function(X){this.ensureParentIndices();var Q=((4278190080&this._startIndexes[X])>>>24)+((4278190080&this._endIndexes[X])>>>16);return Q===$.MAX_FOLDING_REGIONS?-1:Q},e.prototype.contains=function(X,$){return this.getStartLineNumber(X)<=$&&this.getEndLineNumber(X)>=$},e.prototype.findIndex=function(X){var $=0,Q=this._startIndexes.length;if(0===Q)return-1;for(;$<Q;){var J=Math.floor(($+Q)/2);X<this.getStartLineNumber(J)?Q=J:$=J+1}return $-1},e.prototype.findRange=function(X){var $=this.findIndex(X);if($>=0){if(this.getEndLineNumber($)>=X)return $;for($=this.getParentIndex($);-1!==$;){if(this.contains($,X))return $;$=this.getParentIndex($)}}return-1},e.prototype.toString=function(){for(var X=[],$=0;$<this.length;$++)X[$]="["+(this.isCollapsed($)?"+":"-")+"] "+this.getStartLineNumber($)+"/"+this.getEndLineNumber($);return X.join(", ")},e}();$.FoldingRegions=Q;var J=function(){function e(X,$){this.ranges=X,this.index=$}return Object.defineProperty(e.prototype,"startLineNumber",{get:function(){return this.ranges.getStartLineNumber(this.index)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"endLineNumber",{get:function(){return this.ranges.getEndLineNumber(this.index)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"regionIndex",{get:function(){return this.index},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"parentIndex",{get:function(){return this.ranges.getParentIndex(this.index)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isCollapsed",{get:function(){return this.ranges.isCollapsed(this.index)},enumerable:!0,configurable:!0}),e.prototype.containedBy=function(X){return X.startLineNumber<=this.startLineNumber&&X.endLineNumber>=this.endLineNumber},e.prototype.containsLine=function(X){return this.startLineNumber<=X&&X<=this.endLineNumber},e}();$.FoldingRegion=J})),define(Q[245],n([0,1,6,109]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(){function e(X,$){this._updateEventEmitter=new Q.Emitter,this._textModel=X,this._decorationProvider=$,this._regions=new J.FoldingRegions(new Uint32Array(0),new Uint32Array(0)),this._editorDecorationIds=[],this._isInitialized=!1}return Object.defineProperty(e.prototype,"regions",{get:function(){return this._regions},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onDidChange",{get:function(){return this._updateEventEmitter.event},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"textModel",{get:function(){return this._textModel},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isInitialized",{get:function(){return this._isInitialized},enumerable:!0,configurable:!0}),e.prototype.toggleCollapseState=function(X){var $=this;if(X.length){var Q={};this._decorationProvider.changeDecorations((function(J){for(var ee=0,te=X;ee<te.length;ee++){var ne=te[ee].regionIndex,ie=$._editorDecorationIds[ne];if(ie&&!Q[ie]){Q[ie]=!0;var oe=!$._regions.isCollapsed(ne);$._regions.setCollapsed(ne,oe),J.changeDecorationOptions(ie,$._decorationProvider.getDecorationOption(oe))}}})),this._updateEventEmitter.fire({model:this,collapseStateChanged:X})}},e.prototype.update=function(X,$){var Q=this;void 0===$&&($=[]);for(var J=[],o=function(ee,te){var ne=X.getStartLineNumber(ee);te&&function(X,Q){for(var J=0,ee=$;J<ee.length;J++){var te=ee[J];if(X<te&&te<=Q)return!0}return!1}(ne,X.getEndLineNumber(ee))&&(te=!1),X.setCollapsed(ee,te);var ie=Q._textModel.getLineMaxColumn(ne),oe={startLineNumber:ne,startColumn:ie,endLineNumber:ne,endColumn:ie};J.push({range:oe,options:Q._decorationProvider.getDecorationOption(te)})},ee=0,s=function(){for(;ee<Q._regions.length;){var X=Q._regions.isCollapsed(ee);if(ee++,X)return ee-1}return-1},te=0,ne=s();-1!==ne&&te<X.length;){var ie=this._textModel.getDecorationRange(this._editorDecorationIds[ne]);if(ie){var oe=ie.startLineNumber;if(this._textModel.getLineMaxColumn(oe)===ie.startColumn)for(;te<X.length;){var re=X.getStartLineNumber(te);if(!(oe>=re))break;o(te,oe===re),te++}}ne=s()}for(;te<X.length;)o(te,!1),te++;this._editorDecorationIds=this._decorationProvider.deltaDecorations(this._editorDecorationIds,J),this._regions=X,this._isInitialized=!0,this._updateEventEmitter.fire({model:this})},e.prototype.getMemento=function(){for(var X=[],$=0;$<this._regions.length;$++)if(this._regions.isCollapsed($)){var Q=this._textModel.getDecorationRange(this._editorDecorationIds[$]);if(Q){var J=Q.startLineNumber,ee=Q.endLineNumber+this._regions.getEndLineNumber($)-this._regions.getStartLineNumber($);X.push({startLineNumber:J,endLineNumber:ee})}}if(X.length>0)return X},e.prototype.applyMemento=function(X){if(Array.isArray(X)){for(var $=[],Q=0,J=X;Q<J.length;Q++){var ee=J[Q],te=this.getRegionAtLine(ee.startLineNumber);te&&!te.isCollapsed&&$.push(te)}this.toggleCollapseState($)}},e.prototype.dispose=function(){this._decorationProvider.deltaDecorations(this._editorDecorationIds,[])},e.prototype.getAllRegionsAtLine=function(X,$){var Q=[];if(this._regions)for(var J=this._regions.findRange(X),ee=1;J>=0;){var te=this._regions.toRegion(J);$&&!$(te,ee)||Q.push(te),ee++,J=te.parentIndex}return Q},e.prototype.getRegionAtLine=function(X){if(this._regions){var $=this._regions.findRange(X);if($>=0)return this._regions.toRegion($)}return null},e.prototype.getRegionsInside=function(X,$){var Q=[],J=X?X.regionIndex+1:0,ee=X?X.endLineNumber:Number.MAX_VALUE;if($&&2===$.length)for(var te=[],ne=J,ie=this._regions.length;ne<ie&&(oe=this._regions.toRegion(ne),this._regions.getStartLineNumber(ne)<ee);ne++){for(;te.length>0&&!oe.containedBy(te[te.length-1]);)te.pop();te.push(oe),$(oe,te.length)&&Q.push(oe)}else for(ne=J,ie=this._regions.length;ne<ie;ne++){var oe=this._regions.toRegion(ne);if(!(this._regions.getStartLineNumber(ne)<ee))break;$&&!$(oe)||Q.push(oe)}return Q},e}();$.FoldingModel=ee,$.setCollapseStateLevelsDown=function(X,$,Q,J){void 0===Q&&(Q=Number.MAX_VALUE);var ee=[];if(J&&J.length>0)for(var te=0,ne=J;te<ne.length;te++){var ie=ne[te],oe=X.getRegionAtLine(ie);oe&&(oe.isCollapsed!==$&&ee.push(oe),Q>1)&&(re=X.getRegionsInside(oe,(function(X,J){return X.isCollapsed!==$&&J<Q})),ee.push.apply(ee,re))}else{var re=X.getRegionsInside(null,(function(X,J){return X.isCollapsed!==$&&J<Q}));ee.push.apply(ee,re)}X.toggleCollapseState(ee)},$.setCollapseStateLevelsUp=function(X,$,Q,J){for(var ee=[],te=0,ne=J;te<ne.length;te++){var ie=ne[te],oe=X.getAllRegionsAtLine(ie,(function(X,J){return X.isCollapsed!==$&&J<=Q}));ee.push.apply(ee,oe)}X.toggleCollapseState(ee)},$.setCollapseStateAtLevel=function(X,$,Q,J){var ee=X.getRegionsInside(null,(function(X,ee){return ee===$&&X.isCollapsed!==Q&&!J.some((function($){return X.containsLine($)}))}));X.toggleCollapseState(ee)},$.setCollapseStateForMatchingLines=function(X,$,Q){for(var J=X.textModel,ee=X.regions,te=[],ne=ee.length-1;ne>=0;ne--)if(Q!==ee.isCollapsed(ne)){var ie=ee.getStartLineNumber(ne);$.test(J.getLineContent(ie))&&te.push(ee.toRegion(ne))}X.toggleCollapseState(te)},$.setCollapseStateForType=function(X,$,Q){for(var J=X.regions,ee=[],te=J.length-1;te>=0;te--)Q!==J.isCollapsed(te)&&$===J.getType(te)&&ee.push(J.toRegion(te));X.toggleCollapseState(ee)}})),define(Q[246],n([0,1,6,3,22]),(function(X,$,Q,J,ee){function r(X,$){var Q=ee.findFirstInSorted(X,(function(X){return $<X.startLineNumber}))-1;return Q>=0&&X[Q].endLineNumber>=$?X[Q]:null}Object.defineProperty($,"__esModule",{value:!0});var te=function(){function e(X){var $=this;this._updateEventEmitter=new Q.Emitter,this._foldingModel=X,this._foldingModelListener=X.onDidChange((function(X){return $.updateHiddenRanges()})),this._hiddenRanges=[],X.regions.length&&this.updateHiddenRanges()}return Object.defineProperty(e.prototype,"onDidChange",{get:function(){return this._updateEventEmitter.event},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"hiddenRanges",{get:function(){return this._hiddenRanges},enumerable:!0,configurable:!0}),e.prototype.updateHiddenRanges=function(){for(var X=!1,$=[],Q=0,ee=0,te=Number.MAX_VALUE,ne=-1,ie=this._foldingModel.regions;Q<ie.length;Q++)if(ie.isCollapsed(Q)){var oe=ie.getStartLineNumber(Q)+1,re=ie.getEndLineNumber(Q);te<=oe&&re<=ne||(!X&&ee<this._hiddenRanges.length&&this._hiddenRanges[ee].startLineNumber===oe&&this._hiddenRanges[ee].endLineNumber===re?($.push(this._hiddenRanges[ee]),ee++):(X=!0,$.push(new J.Range(oe,1,re,1))),te=oe,ne=re)}(X||ee<this._hiddenRanges.length)&&this.applyHiddenRanges($)},e.prototype.applyMemento=function(X){if(!Array.isArray(X)||0===X.length)return!1;for(var $=[],Q=0,ee=X;Q<ee.length;Q++){var te=ee[Q];if(!te.startLineNumber||!te.endLineNumber)return!1;$.push(new J.Range(te.startLineNumber+1,1,te.endLineNumber,1))}return this.applyHiddenRanges($),!0},e.prototype.getMemento=function(){return this._hiddenRanges.map((function(X){return{startLineNumber:X.startLineNumber-1,endLineNumber:X.endLineNumber}}))},e.prototype.applyHiddenRanges=function(X){this._hiddenRanges=X,this._updateEventEmitter.fire(X)},e.prototype.hasRanges=function(){return this._hiddenRanges.length>0},e.prototype.isHidden=function(X){return null!==r(this._hiddenRanges,X)},e.prototype.adjustSelections=function(X){for(var $=this,Q=!1,J=this._foldingModel.textModel,ee=null,s=function(X){return ee&&function(X,$){return X>=$.startLineNumber&&X<=$.endLineNumber}(X,ee)||(ee=r($._hiddenRanges,X)),ee?ee.startLineNumber-1:null},te=0,ne=X.length;te<ne;te++){var ie=X[te],oe=s(ie.startLineNumber);oe&&(ie=ie.setStartPosition(oe,J.getLineMaxColumn(oe)),Q=!0);var re=s(ie.endLineNumber);re&&(ie=ie.setEndPosition(re,J.getLineMaxColumn(re)),Q=!0),X[te]=ie}return Q},e.prototype.dispose=function(){this.hiddenRanges.length>0&&(this._hiddenRanges=[],this._updateEventEmitter.fire(this._hiddenRanges)),this._foldingModelListener&&(this._foldingModelListener.dispose(),this._foldingModelListener=null)},e}();$.HiddenRangeModel=te})),define(Q[203],n([0,1,11,109]),(function(X,$,Q,J){function o(X,$){for(var Q=X.sort((function(X,$){var Q=X.start-$.start;return 0===Q&&(Q=X.rank-$.rank),Q})),J=new ne($),ee=void 0,te=[],ie=0,oe=Q;ie<oe.length;ie++){var re=oe[ie];if(ee){if(re.start>ee.start)if(re.end<=ee.end)te.push(ee),ee=re,J.add(re.start,re.end,re.kind&&re.kind.value,te.length);else{if(re.start>ee.end){do{ee=te.pop()}while(ee&&re.start>ee.end);ee&&te.push(ee),ee=re}J.add(re.start,re.end,re.kind&&re.kind.value,te.length)}}else ee=re,J.add(re.start,re.end,re.kind&&re.kind.value,te.length)}return J.toIndentRanges()}Object.defineProperty($,"__esModule",{value:!0});var ee={};$.ID_SYNTAX_PROVIDER="syntax";var te=function(){function e(X,Q,J){void 0===J&&(J=5e3),this.editorModel=X,this.providers=Q,this.limit=J,this.id=$.ID_SYNTAX_PROVIDER}return e.prototype.compute=function(X){var $=this;return function(X,$,J){var te=null,ne=X.map((function(X,ne){return Promise.resolve(X.provideFoldingRanges($,ee,J)).then((function(X){if(!J.isCancellationRequested&&Array.isArray(X)){Array.isArray(te)||(te=[]);for(var Q=$.getLineCount(),ee=0,ie=X;ee<ie.length;ee++){var oe=ie[ee];oe.start>0&&oe.end>oe.start&&oe.end<=Q&&te.push({start:oe.start,end:oe.end,rank:ne,kind:oe.kind})}}}),Q.onUnexpectedExternalError)}));return Promise.all(ne).then((function(X){return te}))}(this.providers,this.editorModel,X).then((function(X){return X?o(X,$.limit):null}))},e.prototype.dispose=function(){},e}();$.SyntaxRangeProvider=te;var ne=function(){function e(X){this._startIndexes=[],this._endIndexes=[],this._nestingLevels=[],this._nestingLevelCounts=[],this._types=[],this._length=0,this._foldingRangesLimit=X}return e.prototype.add=function(X,$,Q,ee){if(!(X>J.MAX_LINE_NUMBER||$>J.MAX_LINE_NUMBER)){var te=this._length;this._startIndexes[te]=X,this._endIndexes[te]=$,this._nestingLevels[te]=ee,this._types[te]=Q,this._length++,ee<30&&(this._nestingLevelCounts[ee]=(this._nestingLevelCounts[ee]||0)+1)}},e.prototype.toIndentRanges=function(){if(this._length<=this._foldingRangesLimit){for(var X=new Uint32Array(this._length),$=new Uint32Array(this._length),Q=0;Q<this._length;Q++)X[Q]=this._startIndexes[Q],$[Q]=this._endIndexes[Q];return new J.FoldingRegions(X,$,this._types)}var ee=0,te=this._nestingLevelCounts.length;for(Q=0;Q<this._nestingLevelCounts.length;Q++){var ne=this._nestingLevelCounts[Q];if(ne){if(ne+ee>this._foldingRangesLimit){te=Q;break}ee+=ne}}X=new Uint32Array(this._foldingRangesLimit),$=new Uint32Array(this._foldingRangesLimit);for(var ie=[],oe=(Q=0,0);Q<this._length;Q++){var re=this._nestingLevels[Q];(re<te||re===te&&ee++<this._foldingRangesLimit)&&(X[oe]=this._startIndexes[Q],$[oe]=this._endIndexes[Q],ie[oe]=this._types[Q],oe++)}return new J.FoldingRegions(X,$,ie)},e}();$.RangesCollector=ne,$.sanitizeRanges=o})),define(Q[248],n([0,1,203]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),$.ID_INIT_PROVIDER="init";var J=function(){function e(X,Q,J,ee){if(this.editorModel=X,this.id=$.ID_INIT_PROVIDER,Q.length){this.decorationIds=X.deltaDecorations([],Q.map((function($){return{range:{startLineNumber:$.startLineNumber,startColumn:0,endLineNumber:$.endLineNumber,endColumn:X.getLineLength($.endLineNumber)},options:{stickiness:1}}}))),this.timeout=setTimeout(J,ee)}}return e.prototype.dispose=function(){this.decorationIds&&(this.editorModel.deltaDecorations(this.decorationIds,[]),this.decorationIds=void 0),"number"==typeof this.timeout&&(clearTimeout(this.timeout),this.timeout=void 0)},e.prototype.compute=function(X){var $=[];if(this.decorationIds)for(var J=0,ee=this.decorationIds;J<ee.length;J++){var te=ee[J],ne=this.editorModel.getDecorationRange(te);ne&&$.push({start:ne.startLineNumber,end:ne.endLineNumber,rank:1})}return Promise.resolve(Q.sanitizeRanges($,Number.MAX_VALUE))},e}();$.InitializingRangeProvider=J})),define(Q[249],n([0,1,49,3]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(){function e(){}return e._handleEolEdits=function(X,$){for(var Q=void 0,J=[],ee=0,te=$;ee<te.length;ee++){var ne=te[ee];"number"==typeof ne.eol&&(Q=ne.eol),ne.range&&"string"==typeof ne.text&&J.push(ne)}return"number"==typeof Q&&X.getModel().pushEOL(Q),J},e._isFullModelReplaceEdit=function(X,$){var Q=X.getModel(),J=Q.validateRange($.range);return Q.getFullModelRange().equalsRange(J)},e.execute=function(X,$){X.pushUndoStop();var ee=e._handleEolEdits(X,$);1===ee.length&&e._isFullModelReplaceEdit(X,ee[0])?X.executeEdits("formatEditsCommand",ee.map((function(X){return Q.EditOperation.replace(J.Range.lift(X.range),X.text)}))):X.executeEdits("formatEditsCommand",ee.map((function(X){return Q.EditOperation.replaceMove(J.Range.lift(X.range),X.text)}))),X.pushUndoStop()},e}();$.FormattingEdit=ee})),define(Q[183],n([0,1,29,2,6,17,163]),(function(X,$,Q,J,ee,ne){function a(X,$){return!!X[$]}function l(X){return"altKey"===X?ne.isMacintosh?new ie(57,"metaKey",6,"altKey"):new ie(5,"ctrlKey",6,"altKey"):ne.isMacintosh?new ie(6,"altKey",57,"metaKey"):new ie(6,"altKey",5,"ctrlKey")}Object.defineProperty($,"__esModule",{value:!0});var u=function(X,$){this.target=X.target,this.hasTriggerModifier=a(X.event,$.triggerModifier),this.hasSideBySideModifier=a(X.event,$.triggerSideBySideModifier),this.isNoneOrSingleMouseDown=Q.isIE||X.event.detail<=1};$.ClickLinkMouseEvent=u;var d=function(X,$){this.keyCodeIsTriggerKey=X.keyCode===$.triggerKey,this.keyCodeIsSideBySideKey=X.keyCode===$.triggerSideBySideKey,this.hasTriggerModifier=a(X,$.triggerModifier)};$.ClickLinkKeyboardEvent=d;var ie=function(){function e(X,$,Q,J){this.triggerKey=X,this.triggerModifier=$,this.triggerSideBySideKey=Q,this.triggerSideBySideModifier=J}return e.prototype.equals=function(X){return this.triggerKey===X.triggerKey&&this.triggerModifier===X.triggerModifier&&this.triggerSideBySideKey===X.triggerSideBySideKey&&this.triggerSideBySideModifier===X.triggerSideBySideModifier},e}();$.ClickLinkOptions=ie;var oe=function(X){function t($){var Q=X.call(this)||this;return Q._onMouseMoveOrRelevantKeyDown=Q._register(new ee.Emitter),Q.onMouseMoveOrRelevantKeyDown=Q._onMouseMoveOrRelevantKeyDown.event,Q._onExecute=Q._register(new ee.Emitter),Q.onExecute=Q._onExecute.event,Q._onCancel=Q._register(new ee.Emitter),Q.onCancel=Q._onCancel.event,Q._editor=$,Q._opts=l(Q._editor.getConfiguration().multiCursorModifier),Q.lastMouseMoveEvent=null,Q.hasTriggerKeyOnMouseDown=!1,Q._register(Q._editor.onDidChangeConfiguration((function(X){if(X.multiCursorModifier){var $=l(Q._editor.getConfiguration().multiCursorModifier);if(Q._opts.equals($))return;Q._opts=$,Q.lastMouseMoveEvent=null,Q.hasTriggerKeyOnMouseDown=!1,Q._onCancel.fire()}}))),Q._register(Q._editor.onMouseMove((function(X){return Q.onEditorMouseMove(new u(X,Q._opts))}))),Q._register(Q._editor.onMouseDown((function(X){return Q.onEditorMouseDown(new u(X,Q._opts))}))),Q._register(Q._editor.onMouseUp((function(X){return Q.onEditorMouseUp(new u(X,Q._opts))}))),Q._register(Q._editor.onKeyDown((function(X){return Q.onEditorKeyDown(new d(X,Q._opts))}))),Q._register(Q._editor.onKeyUp((function(X){return Q.onEditorKeyUp(new d(X,Q._opts))}))),Q._register(Q._editor.onMouseDrag((function(){return Q.resetHandler()}))),Q._register(Q._editor.onDidChangeCursorSelection((function(X){return Q.onDidChangeCursorSelection(X)}))),Q._register(Q._editor.onDidChangeModel((function(X){return Q.resetHandler()}))),Q._register(Q._editor.onDidChangeModelContent((function(){return Q.resetHandler()}))),Q._register(Q._editor.onDidScrollChange((function(X){(X.scrollTopChanged||X.scrollLeftChanged)&&Q.resetHandler()}))),Q}return te(t,X),t.prototype.onDidChangeCursorSelection=function(X){X.selection&&X.selection.startColumn!==X.selection.endColumn&&this.resetHandler()},t.prototype.onEditorMouseMove=function(X){this.lastMouseMoveEvent=X,this._onMouseMoveOrRelevantKeyDown.fire([X,null])},t.prototype.onEditorMouseDown=function(X){this.hasTriggerKeyOnMouseDown=X.hasTriggerModifier},t.prototype.onEditorMouseUp=function(X){this.hasTriggerKeyOnMouseDown&&this._onExecute.fire(X)},t.prototype.onEditorKeyDown=function(X){this.lastMouseMoveEvent&&(X.keyCodeIsTriggerKey||X.keyCodeIsSideBySideKey&&X.hasTriggerModifier)?this._onMouseMoveOrRelevantKeyDown.fire([this.lastMouseMoveEvent,X]):X.hasTriggerModifier&&this._onCancel.fire()},t.prototype.onEditorKeyUp=function(X){X.keyCodeIsTriggerKey&&this._onCancel.fire()},t.prototype.resetHandler=function(){this.lastMouseMoveEvent=null,this.hasTriggerKeyOnMouseDown=!1,this._onCancel.fire()},t}(J.Disposable);$.ClickLinkGesture=oe})),define(Q[186],n([0,1,16,11]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(){function e(X,$,J,ee){var te=this;this._computer=X,this._state=0,this._hoverTime=e.HOVER_TIME,this._firstWaitScheduler=new Q.RunOnceScheduler((function(){return te._triggerAsyncComputation()}),0),this._secondWaitScheduler=new Q.RunOnceScheduler((function(){return te._triggerSyncComputation()}),0),this._loadingMessageScheduler=new Q.RunOnceScheduler((function(){return te._showLoadingMessage()}),0),this._asyncComputationPromise=null,this._asyncComputationPromiseDone=!1,this._completeCallback=$,this._errorCallback=J,this._progressCallback=ee}return e.prototype.setHoverTime=function(X){this._hoverTime=X},e.prototype._firstWaitTime=function(){return this._hoverTime/2},e.prototype._secondWaitTime=function(){return this._hoverTime/2},e.prototype._loadingMessageTime=function(){return 3*this._hoverTime},e.prototype._triggerAsyncComputation=function(){var X=this;this._state=2,this._secondWaitScheduler.schedule(this._secondWaitTime()),this._computer.computeAsync?(this._asyncComputationPromiseDone=!1,this._asyncComputationPromise=Q.createCancelablePromise((function($){return X._computer.computeAsync($)})),this._asyncComputationPromise.then((function($){X._asyncComputationPromiseDone=!0,X._withAsyncResult($)}),(function($){return X._onError($)}))):this._asyncComputationPromiseDone=!0},e.prototype._triggerSyncComputation=function(){this._computer.computeSync&&this._computer.onResult(this._computer.computeSync(),!0),this._asyncComputationPromiseDone?(this._state=0,this._onComplete(this._computer.getResult())):(this._state=3,this._onProgress(this._computer.getResult()))},e.prototype._showLoadingMessage=function(){3===this._state&&this._onProgress(this._computer.getResultWithLoadingMessage())},e.prototype._withAsyncResult=function(X){X&&this._computer.onResult(X,!1),3===this._state&&(this._state=0,this._onComplete(this._computer.getResult()))},e.prototype._onComplete=function(X){this._completeCallback&&this._completeCallback(X)},e.prototype._onError=function(X){this._errorCallback?this._errorCallback(X):J.onUnexpectedError(X)},e.prototype._onProgress=function(X){this._progressCallback&&this._progressCallback(X)},e.prototype.start=function(X){if(0===X)0===this._state&&(this._state=1,this._firstWaitScheduler.schedule(this._firstWaitTime()),this._loadingMessageScheduler.schedule(this._loadingMessageTime()));else switch(this._state){case 0:this._triggerAsyncComputation(),this._secondWaitScheduler.cancel(),this._triggerSyncComputation();break;case 2:this._secondWaitScheduler.cancel(),this._triggerSyncComputation()}},e.prototype.cancel=function(){this._loadingMessageScheduler.cancel(),1===this._state&&this._firstWaitScheduler.cancel(),2===this._state&&(this._secondWaitScheduler.cancel(),this._asyncComputationPromise&&(this._asyncComputationPromise.cancel(),this._asyncComputationPromise=null)),3===this._state&&this._asyncComputationPromise&&(this._asyncComputationPromise.cancel(),this._asyncComputationPromise=null),this._state=0},e.HOVER_TIME=300,e}();$.HoverOperation=ee})),define(Q[191],n([0,1,7,55,46,2]),(function(X,$,Q,J,ee,ne){Object.defineProperty($,"__esModule",{value:!0});var ie=function(X){function t($,Q){var ee=X.call(this)||this;return ee.disposables=[],ee.allowEditorOverflow=!0,ee._id=$,ee._editor=Q,ee._isVisible=!1,ee._containerDomNode=document.createElement("div"),ee._containerDomNode.className="monaco-editor-hover hidden",ee._containerDomNode.tabIndex=0,ee._domNode=document.createElement("div"),ee._domNode.className="monaco-editor-hover-content",ee.scrollbar=new J.DomScrollableElement(ee._domNode,{}),ee.disposables.push(ee.scrollbar),ee._containerDomNode.appendChild(ee.scrollbar.getDomNode()),ee.onkeydown(ee._containerDomNode,(function(X){X.equals(9)&&ee.hide()})),ee._register(ee._editor.onDidChangeConfiguration((function(X){X.fontInfo&&ee.updateFont()}))),ee._editor.onDidLayoutChange((function(X){return ee.updateMaxHeight()})),ee.updateMaxHeight(),ee._editor.addContentWidget(ee),ee._showAtPosition=null,ee._showAtRange=null,ee}return te(t,X),Object.defineProperty(t.prototype,"isVisible",{get:function(){return this._isVisible},set:function(X){this._isVisible=X,Q.toggleClass(this._containerDomNode,"hidden",!this._isVisible)},enumerable:!0,configurable:!0}),t.prototype.getId=function(){return this._id},t.prototype.getDomNode=function(){return this._containerDomNode},t.prototype.showAt=function(X,$,Q){this._showAtPosition=X,this._showAtRange=$,this.isVisible=!0,this._editor.layoutContentWidget(this),this._editor.render(),this._stoleFocus=Q,Q&&this._containerDomNode.focus()},t.prototype.hide=function(){this.isVisible&&(this.isVisible=!1,this._editor.layoutContentWidget(this),this._stoleFocus&&this._editor.focus())},t.prototype.getPosition=function(){return this.isVisible?{position:this._showAtPosition,range:this._showAtRange,preference:[1,2]}:null},t.prototype.dispose=function(){this._editor.removeContentWidget(this),this.disposables=ne.dispose(this.disposables),X.prototype.dispose.call(this)},t.prototype.updateFont=function(){var X=this;Array.prototype.slice.call(this._domNode.getElementsByClassName("code")).forEach((function($){return X._editor.applyFontInfo($)}))},t.prototype.updateContents=function(X){this._domNode.textContent="",this._domNode.appendChild(X),this.updateFont(),this._editor.layoutContentWidget(this),this.onContentsChange()},t.prototype.onContentsChange=function(){this.scrollbar.scanDomNode()},t.prototype.updateMaxHeight=function(){var X=Math.max(this._editor.getLayoutInfo().height/4,250),$=this._editor.getConfiguration().fontInfo,Q=$.fontSize,J=$.lineHeight;this._domNode.style.fontSize=Q+"px",this._domNode.style.lineHeight=J+"px",this._domNode.style.maxHeight=X+"px"},t}(ee.Widget);$.ContentHoverWidget=ie;var oe=function(X){function t($,Q){var J=X.call(this)||this;return J._id=$,J._editor=Q,J._isVisible=!1,J._domNode=document.createElement("div"),J._domNode.className="monaco-editor-hover hidden",J._domNode.setAttribute("aria-hidden","true"),J._domNode.setAttribute("role","presentation"),J._showAtLineNumber=-1,J._register(J._editor.onDidChangeConfiguration((function(X){X.fontInfo&&J.updateFont()}))),J._editor.addOverlayWidget(J),J}return te(t,X),Object.defineProperty(t.prototype,"isVisible",{get:function(){return this._isVisible},set:function(X){this._isVisible=X,Q.toggleClass(this._domNode,"hidden",!this._isVisible)},enumerable:!0,configurable:!0}),t.prototype.getId=function(){return this._id},t.prototype.getDomNode=function(){return this._domNode},t.prototype.showAt=function(X){this._showAtLineNumber=X,this.isVisible||(this.isVisible=!0);var $=this._editor.getLayoutInfo(),Q=this._editor.getTopForLineNumber(this._showAtLineNumber),J=this._editor.getScrollTop(),ee=this._editor.getConfiguration().lineHeight,te=Q-J-(this._domNode.clientHeight-ee)/2;this._domNode.style.left=$.glyphMarginLeft+$.glyphMarginWidth+"px",this._domNode.style.top=Math.max(Math.round(te),0)+"px"},t.prototype.hide=function(){this.isVisible&&(this.isVisible=!1)},t.prototype.getPosition=function(){return null},t.prototype.dispose=function(){this._editor.removeOverlayWidget(this),X.prototype.dispose.call(this)},t.prototype.updateFont=function(){var X=this,$=Array.prototype.slice.call(this._domNode.getElementsByTagName("code")),Q=Array.prototype.slice.call(this._domNode.getElementsByClassName("code"));$.concat(Q).forEach((function($){return X._editor.applyFontInfo($)}))},t.prototype.updateContents=function(X){this._domNode.textContent="",this._domNode.appendChild(X),this.updateFont()},t}(ee.Widget);$.GlyphHoverWidget=oe})),define(Q[253],n([0,1,7,68,2,186,191]),(function(X,$,Q,J,ee,ne,ie){Object.defineProperty($,"__esModule",{value:!0});var oe=function(){function e(X){this._editor=X,this._lineNumber=-1}return e.prototype.setLineNumber=function(X){this._lineNumber=X,this._result=[]},e.prototype.clearResult=function(){this._result=[]},e.prototype.computeSync=function(){var e=function(X){return{value:X}},X=this._editor.getLineDecorations(this._lineNumber),$=[];if(!X)return $;for(var Q=0,ee=X.length;Q<ee;Q++){var te=X[Q];if(te.options.glyphMarginClassName){var ne=te.options.glyphMarginHoverMessage;ne&&!J.isEmptyMarkdownString(ne)&&(Array.isArray(ne)?$=$.concat(ne.map(e)):$.push(e(ne)))}}return $},e.prototype.onResult=function(X,$){this._result=this._result.concat(X)},e.prototype.getResult=function(){return this._result},e.prototype.getResultWithLoadingMessage=function(){return this.getResult()},e}(),re=function(X){function t($,Q){var J=X.call(this,t.ID,$)||this;return J._lastLineNumber=-1,J._markdownRenderer=Q,J._computer=new oe(J._editor),J._hoverOperation=new ne.HoverOperation(J._computer,(function(X){return J._withResult(X)}),void 0,(function(X){return J._withResult(X)})),J}return te(t,X),t.prototype.dispose=function(){this._renderDisposeables=ee.dispose(this._renderDisposeables),this._hoverOperation.cancel(),X.prototype.dispose.call(this)},t.prototype.onModelDecorationsChanged=function(){this.isVisible&&(this._hoverOperation.cancel(),this._computer.clearResult(),this._hoverOperation.start(0))},t.prototype.startShowingAt=function(X){this._lastLineNumber!==X&&(this._hoverOperation.cancel(),this.hide(),this._lastLineNumber=X,this._computer.setLineNumber(X),this._hoverOperation.start(0))},t.prototype.hide=function(){this._lastLineNumber=-1,this._hoverOperation.cancel(),X.prototype.hide.call(this)},t.prototype._withResult=function(X){this._messages=X,this._messages.length>0?this._renderMessages(this._lastLineNumber,this._messages):this.hide()},t.prototype._renderMessages=function(X,$){var J=this;ee.dispose(this._renderDisposeables),this._renderDisposeables=[];var te=document.createDocumentFragment();$.forEach((function(X){var $=J._markdownRenderer.render(X.value);J._renderDisposeables.push($),te.appendChild(Q.$("div.hover-row",void 0,$.element))})),this.updateContents(te),this.showAt(X)},t.ID="editor.contrib.modesGlyphHoverWidget",t}(ie.GlyphHoverWidget);$.ModesGlyphHoverWidget=re})),define(Q[254],n([0,1,21]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(){function e(X,$,Q){this._editRange=X,this._originalSelection=$,this._text=Q}return e.prototype.getEditOperations=function(X,$){$.addTrackedEditOperation(this._editRange,this._text)},e.prototype.computeCursorState=function(X,$){var J=$.getInverseEditOperations()[0].range;return this._originalSelection.isEmpty()?new Q.Selection(J.endLineNumber,Math.min(this._originalSelection.positionColumn,J.endColumn),J.endLineNumber,Math.min(this._originalSelection.positionColumn,J.endColumn)):new Q.Selection(J.endLineNumber,J.endColumn-this._text.length,J.endLineNumber,J.endColumn)},e}();$.InPlaceReplaceCommand=J})),define(Q[255],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0}),$.getSpaceCnt=function(X,$){for(var Q=0,J=0;J<X.length;J++)"\t"===X.charAt(J)?Q+=$:Q++;return Q},$.generateIndent=function(X,$,Q){X=X<0?0:X;var J="";if(!Q){var ee=Math.floor(X/$);for(X%=$,te=0;te<ee;te++)J+="\t"}for(var te=0;te<X;te++)J+=" ";return J}})),define(Q[256],n([0,1,3,21]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(){function e(X,$){this._selection=X,this._isCopyingDown=$}return e.prototype.getEditOperations=function(X,$){var J=this._selection;this._startLineNumberDelta=0,this._endLineNumberDelta=0,J.startLineNumber<J.endLineNumber&&1===J.endColumn&&(this._endLineNumberDelta=1,J=J.setEndPosition(J.endLineNumber-1,X.getLineMaxColumn(J.endLineNumber-1)));for(var ee=[],te=J.startLineNumber;te<=J.endLineNumber;te++)ee.push(X.getLineContent(te));var ne=ee.join("\n");""===ne&&this._isCopyingDown&&(this._startLineNumberDelta++,this._endLineNumberDelta++),this._isCopyingDown?$.addEditOperation(new Q.Range(J.startLineNumber,1,J.startLineNumber,1),ne+"\n"):$.addEditOperation(new Q.Range(J.endLineNumber,X.getLineMaxColumn(J.endLineNumber),J.endLineNumber,X.getLineMaxColumn(J.endLineNumber)),"\n"+ne),this._selectionId=$.trackSelection(J),this._selectionDirection=this._selection.getDirection()},e.prototype.computeCursorState=function(X,$){var Q=$.getTrackedSelection(this._selectionId);if(0!==this._startLineNumberDelta||0!==this._endLineNumberDelta){var ee=Q.startLineNumber,te=Q.startColumn,ne=Q.endLineNumber,ie=Q.endColumn;0!==this._startLineNumberDelta&&(ee+=this._startLineNumberDelta,te=1),0!==this._endLineNumberDelta&&(ne+=this._endLineNumberDelta,ie=1),Q=J.Selection.createWithDirection(ee,te,ne,ie,this._selectionDirection)}return Q},e}();$.CopyLinesCommand=ee})),define(Q[257],n([0,1,3,21]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(){function e(X,$,Q){this.startLineNumber=X,this.endLineNumber=$,this.restoreCursorToColumn=Q}return e.prototype.getEditOperations=function(X,$){if(1!==X.getLineCount()||1!==X.getLineMaxColumn(1)){var J=this.startLineNumber,ee=this.endLineNumber,te=1,ne=X.getLineMaxColumn(ee);ee<X.getLineCount()?(ee+=1,ne=1):J>1&&(J-=1,te=X.getLineMaxColumn(J)),$.addTrackedEditOperation(new Q.Range(J,te,ee,ne),null)}},e.prototype.computeCursorState=function(X,$){var Q=$.getInverseEditOperations()[0].range;return new J.Selection(Q.endLineNumber,this.restoreCursorToColumn,Q.endLineNumber,this.restoreCursorToColumn)},e}();$.DeleteLinesCommand=ee})),define(Q[258],n([0,1,49,3]),(function(X,$,Q,J){function o(X,$,Q){var J=$.startLineNumber,ee=$.endLineNumber;if(1===$.endColumn&&ee--,J>=ee)return null;for(var te=[],ne=J;ne<=ee;ne++)te.push(X.getLineContent(ne));var ie=te.slice(0);return ie.sort((function(X,$){return X.toLowerCase().localeCompare($.toLowerCase())})),!0===Q&&(ie=ie.reverse()),{startLineNumber:J,endLineNumber:ee,before:te,after:ie}}Object.defineProperty($,"__esModule",{value:!0});var ee=function(){function e(X,$){this.selection=X,this.descending=$}return e.prototype.getEditOperations=function(X,$){var ee=function(X,$,ee){var te=o(X,$,ee);return te?Q.EditOperation.replace(new J.Range(te.startLineNumber,1,te.endLineNumber,X.getLineMaxColumn(te.endLineNumber)),te.after.join("\n")):null}(X,this.selection,this.descending);ee&&$.addEditOperation(ee.range,ee.text),this.selectionId=$.trackSelection(this.selection)},e.prototype.computeCursorState=function(X,$){return $.getTrackedSelection(this.selectionId)},e.canRun=function(X,$,Q){var J=o(X,$,Q);if(!J)return!1;for(var ee=0,te=J.before.length;ee<te;ee++)if(J.before[ee]!==J.after[ee])return!0;return!1},e}();$.SortLinesCommand=ee})),define(Q[192],n([0,1,3,94,96,39]),(function(X,$,Q,J,ee,ne){function a(X){var $=new ie;return $.start=X.range.getStartPosition(),$.end=X.range.getEndPosition(),$}Object.defineProperty($,"__esModule",{value:!0});var ie=function(){function e(){}return Object.defineProperty(e.prototype,"range",{get:function(){return new Q.Range(this.start.lineNumber,this.start.column,this.end.lineNumber,this.end.column)},enumerable:!0,configurable:!0}),e}();$.Node=ie;var oe=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),Object.defineProperty(t.prototype,"hasChildren",{get:function(){return this.children&&this.children.length>0},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isEmpty",{get:function(){return!this.hasChildren&&!this.parent},enumerable:!0,configurable:!0}),t.prototype.append=function(X){return!!X&&(X.parent=this,this.children||(this.children=[]),X instanceof t?X.children&&this.children.push.apply(this.children,X.children):this.children.push(X),!0)},t}(ie);$.NodeList=oe;var re=function(X){function t(){var $=X.call(this)||this;return $.elements=new oe,$.elements.parent=$,$}return te(t,X),t}(ie);$.Block=re;var h=function(X,$,Q){this.range=X,this.bracket=$,this.bracketType=Q},p=function(X,$,Q){this.lineNumber=Q,this.lineText=X.getLineContent(),this.startOffset=X.getStartOffset($),this.endOffset=X.getEndOffset($),this.type=X.getStandardTokenType($),this.languageId=X.getLanguageId($)},se=function(){function e(X){this._model=X,this._lineCount=this._model.getLineCount(),this._versionId=this._model.getVersionId(),this._lineNumber=0,this._tokenIndex=0,this._lineTokens=null,this._advance()}return e.prototype._advance=function(){for(this._lineTokens&&(this._tokenIndex++,this._tokenIndex>=this._lineTokens.getCount()&&(this._lineTokens=null));this._lineNumber<this._lineCount&&!this._lineTokens;)this._lineNumber++,this._model.forceTokenization(this._lineNumber),this._lineTokens=this._model.getLineTokens(this._lineNumber),this._tokenIndex=0,0===this._lineTokens.getLineContent().length&&(this._lineTokens=null)},e.prototype.next=function(){if(!this._lineTokens)return null;if(this._model.getVersionId()!==this._versionId)return null;var X=new p(this._lineTokens,this._tokenIndex,this._lineNumber);return this._advance(),X},e}(),ae=function(){function e(X){this._rawTokenScanner=new se(X),this._nextBuff=[],this._cachedLanguageBrackets=null,this._cachedLanguageId=-1}return e.prototype.next=function(){if(this._nextBuff.length>0)return this._nextBuff.shift();var X=this._rawTokenScanner.next();if(!X)return null;var $=X.lineNumber,te=X.lineText,ie=X.type,oe=X.startOffset,re=X.endOffset;this._cachedLanguageId!==X.languageId&&(this._cachedLanguageId=X.languageId,this._cachedLanguageBrackets=ne.LanguageConfigurationRegistry.getBracketsSupport(this._cachedLanguageId));var se,ae=this._cachedLanguageBrackets;if(!ae||J.ignoreBracketsInToken(ie))return new h(new Q.Range($,oe+1,$,re+1),0,null);do{if(se=ee.BracketsUtils.findNextBracketInToken(ae.forwardRegex,$,te,oe,re)){var le=se.startColumn-1,ue=se.endColumn-1;oe<le&&this._nextBuff.push(new h(new Q.Range($,oe+1,$,le+1),0,null));var de=te.substring(le,ue);de=de.toLowerCase();var ce=ae.textIsBracket[de],he=ae.textIsOpenBracket[de];this._nextBuff.push(new h(new Q.Range($,le+1,$,ue+1),he?1:-1,ce.languageIdentifier.language+";"+ce.open+";"+ce.close)),oe=ue}}while(se);return oe<re&&this._nextBuff.push(new h(new Q.Range($,oe+1,$,re+1),0,null)),this._nextBuff.shift()||null},e}(),le=function(){function e(X){this._stack=[],this._scanner=new ae(X)}return e.prototype.build=function(){for(var X=new oe;X.append(this._line()||this._any()););return X},e.prototype._accept=function(X){var $=this._stack.pop()||this._scanner.next();if(!$)return!1;var Q=X($);return Q?this._currentToken=$:this._stack.push($),Q},e.prototype._peek=function(X){var $=!1;return this._accept((function(Q){return $=X(Q),!1})),$},e.prototype._line=function(){var X,$=new oe;for(this._peek((function($){return X=$.range.startLineNumber,!1}));this._peek((function($){return $.range.startLineNumber===X}))&&$.append(this._token()||this._block()););return $.children&&0!==$.children.length?1===$.children.length?$.children[0]:$:null},e.prototype._token=function(){return this._accept((function(X){return 0===X.bracket}))?a(this._currentToken):null},e.prototype._block=function(){var X;if(!this._accept((function($){return X=$.bracketType,1===$.bracket})))return null;var $=new re;for($.open=a(this._currentToken);$.elements.append(this._line()););if(!this._accept((function($){return-1===$.bracket&&$.bracketType===X}))){var Q=new oe;return Q.append($.open),Q.append($.elements),Q}return $.close=a(this._currentToken),$},e.prototype._any=function(){return this._accept((function(X){return!0}))?a(this._currentToken):null},e}();$.build=function(X){return new le(X).build()},$.find=function l(X,$){if(X instanceof oe&&X.isEmpty)return null;if(!Q.Range.containsPosition(X.range,$))return null;var J=null;if(X instanceof oe){if(X.hasChildren)for(var ee=0,te=X.children.length;ee<te&&!J;ee++)J=l(X.children[ee],$)}else X instanceof re&&(J=l(X.elements,$)||l(X.open,$)||l(X.close,$));return J||X}})),define(Q[111],n([0,1]),(function(X,$){function n(X,$){for(var Q=X.slice();Q.length>0;){var J=Q.shift();if(!$(J))break;Q.unshift.apply(Q,J.children)}}Object.defineProperty($,"__esModule",{value:!0});var Q,J=function(){function e(){this.text("")}return e.isDigitCharacter=function(X){return X>=48&&X<=57},e.isVariableCharacter=function(X){return 95===X||X>=97&&X<=122||X>=65&&X<=90},e.prototype.text=function(X){this.value=X,this.pos=0},e.prototype.tokenText=function(X){return this.value.substr(X.pos,X.len)},e.prototype.next=function(){if(this.pos>=this.value.length)return{type:14,pos:this.pos,len:0};var X,$=this.pos,Q=0,J=this.value.charCodeAt($);if("number"==typeof(X=e._table[J]))return this.pos+=1,{type:X,pos:$,len:1};if(e.isDigitCharacter(J)){X=8;do{Q+=1,J=this.value.charCodeAt($+Q)}while(e.isDigitCharacter(J));return this.pos+=Q,{type:X,pos:$,len:Q}}if(e.isVariableCharacter(J)){X=9;do{J=this.value.charCodeAt($+ ++Q)}while(e.isVariableCharacter(J)||e.isDigitCharacter(J));return this.pos+=Q,{type:X,pos:$,len:Q}}X=10;do{Q+=1,J=this.value.charCodeAt($+Q)}while(!isNaN(J)&&void 0===e._table[J]&&!e.isDigitCharacter(J)&&!e.isVariableCharacter(J));return this.pos+=Q,{type:X,pos:$,len:Q}},e._table=((Q={})[36]=0,Q[58]=1,Q[44]=2,Q[123]=3,Q[125]=4,Q[92]=5,Q[47]=6,Q[124]=7,Q[43]=11,Q[45]=12,Q[63]=13,Q),e}();$.Scanner=J;var ee=function(){function e(){this._children=[]}return e.prototype.appendChild=function(X){return X instanceof ne&&this._children[this._children.length-1]instanceof ne?this._children[this._children.length-1].value+=X.value:(X.parent=this,this._children.push(X)),this},e.prototype.replace=function(X,$){var Q=X.parent,J=Q.children.indexOf(X),ee=Q.children.slice(0);ee.splice.apply(ee,[J,1].concat($)),Q._children=ee,function e(X,$){for(var Q=0,J=X;Q<J.length;Q++){var ee=J[Q];ee.parent=$,e(ee.children,ee)}}($,Q)},Object.defineProperty(e.prototype,"children",{get:function(){return this._children},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"snippet",{get:function(){for(var X=this;;){if(!X)return;if(X instanceof ue)return X;X=X.parent}},enumerable:!0,configurable:!0}),e.prototype.toString=function(){return this.children.reduce((function(X,$){return X+$.toString()}),"")},e.prototype.len=function(){return 0},e}();$.Marker=ee;var ne=function(X){function t($){var Q=X.call(this)||this;return Q.value=$,Q}return te(t,X),t.prototype.toString=function(){return this.value},t.prototype.len=function(){return this.value.length},t.prototype.clone=function(){return new t(this.value)},t}(ee);$.Text=ne;var ie=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t}(ee);$.TransformableMarker=ie;var oe=function(X){function t($){var Q=X.call(this)||this;return Q.index=$,Q}return te(t,X),t.compareByIndex=function(X,$){return X.index===$.index?0:X.isFinalTabstop?1:$.isFinalTabstop||X.index<$.index?-1:X.index>$.index?1:0},Object.defineProperty(t.prototype,"isFinalTabstop",{get:function(){return 0===this.index},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"choice",{get:function(){return 1===this._children.length&&this._children[0]instanceof re?this._children[0]:void 0},enumerable:!0,configurable:!0}),t.prototype.clone=function(){var X=new t(this.index);return this.transform&&(X.transform=this.transform.clone()),X._children=this.children.map((function(X){return X.clone()})),X},t}(ie);$.Placeholder=oe;var re=function(X){function t(){var $=null!==X&&X.apply(this,arguments)||this;return $.options=[],$}return te(t,X),t.prototype.appendChild=function(X){return X instanceof ne&&(X.parent=this,this.options.push(X)),this},t.prototype.toString=function(){return this.options[0].value},t.prototype.len=function(){return this.options[0].len()},t.prototype.clone=function(){var X=new t;return this.options.forEach(X.appendChild,X),X},t}(ee);$.Choice=re;var se=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype.resolve=function(X){var $=this,Q=!1,J=X.replace(this.regexp,(function(){return Q=!0,$._replace(Array.prototype.slice.call(arguments,0,-2))}));return!Q&&this._children.some((function(X){return X instanceof ae&&Boolean(X.elseValue)}))&&(J=this._replace([])),J},t.prototype._replace=function(X){for(var $="",Q=0,J=this._children;Q<J.length;Q++){var ee=J[Q];if(ee instanceof ae){var te=X[ee.index]||"";$+=te=ee.resolve(te)}else $+=ee.toString()}return $},t.prototype.toString=function(){return""},t.prototype.clone=function(){var X=new t;return X.regexp=new RegExp(this.regexp.source,(this.regexp.ignoreCase?"i":"")+(this.regexp.global?"g":"")),X._children=this.children.map((function(X){return X.clone()})),X},t}(ee);$.Transform=se;var ae=function(X){function t($,Q,J,ee){var te=X.call(this)||this;return te.index=$,te.shorthandName=Q,te.ifValue=J,te.elseValue=ee,te}return te(t,X),t.prototype.resolve=function(X){return"upcase"===this.shorthandName?X?X.toLocaleUpperCase():"":"downcase"===this.shorthandName?X?X.toLocaleLowerCase():"":"capitalize"===this.shorthandName?X?X[0].toLocaleUpperCase()+X.substr(1):"":"pascalcase"===this.shorthandName?X?this._toPascalCase(X):"":Boolean(X)&&"string"==typeof this.ifValue?this.ifValue:Boolean(X)||"string"!=typeof this.elseValue?X||"":this.elseValue},t.prototype._toPascalCase=function(X){var $=X.match(/[a-z]+/gi);return $?$.map((function(X){return X.charAt(0).toUpperCase()+X.substr(1).toLowerCase()})).join(""):X},t.prototype.clone=function(){return new t(this.index,this.shorthandName,this.ifValue,this.elseValue)},t}(ee);$.FormatString=ae;var le=function(X){function t($){var Q=X.call(this)||this;return Q.name=$,Q}return te(t,X),t.prototype.resolve=function(X){var $=X.resolve(this);return this.transform&&($=this.transform.resolve($||"")),void 0!==$&&(this._children=[new ne($)],!0)},t.prototype.clone=function(){var X=new t(this.name);return this.transform&&(X.transform=this.transform.clone()),X._children=this.children.map((function(X){return X.clone()})),X},t}(ie);$.Variable=le;var ue=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),Object.defineProperty(t.prototype,"placeholderInfo",{get:function(){if(!this._placeholders){var X,$=[];this.walk((function(Q){return Q instanceof oe&&($.push(Q),X=!X||X.index<Q.index?Q:X),!0})),this._placeholders={all:$,last:X}}return this._placeholders},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"placeholders",{get:function(){return this.placeholderInfo.all},enumerable:!0,configurable:!0}),t.prototype.offset=function(X){var $=0,Q=!1;return this.walk((function(J){return J===X?(Q=!0,!1):($+=J.len(),!0)})),Q?$:-1},t.prototype.fullLen=function(X){var $=0;return n([X],(function(X){return $+=X.len(),!0})),$},t.prototype.enclosingPlaceholders=function(X){for(var $=[],Q=X.parent;Q;)Q instanceof oe&&$.push(Q),Q=Q.parent;return $},t.prototype.resolveVariables=function(X){var $=this;return this.walk((function(Q){return Q instanceof le&&Q.resolve(X)&&($._placeholders=void 0),!0})),this},t.prototype.appendChild=function($){return this._placeholders=void 0,X.prototype.appendChild.call(this,$)},t.prototype.replace=function($,Q){return this._placeholders=void 0,X.prototype.replace.call(this,$,Q)},t.prototype.clone=function(){var X=new t;return this._children=this.children.map((function(X){return X.clone()})),X},t.prototype.walk=function(X){n(this.children,X)},t}(ee);$.TextmateSnippet=ue;var de=function(){function e(){this._scanner=new J}return e.escape=function(X){return X.replace(/\$|}|\\/g,"\\$&")},e.prototype.parse=function(X,$,Q){this._scanner.text(X),this._token=this._scanner.next();for(var J=new ue;this._parse(J););var ee=new Map,te=[],ne=0;J.walk((function(X){return X instanceof oe&&(ne+=1,X.isFinalTabstop?ee.set(0,void 0):!ee.has(X.index)&&X.children.length>0?ee.set(X.index,X.children):te.push(X)),!0}));for(var ie=0,re=te;ie<re.length;ie++){var se=re[ie];if(ee.has(se.index)){var ae=new oe(se.index);ae.transform=se.transform;for(var le=0,de=ee.get(se.index);le<de.length;le++){var ce=de[le];ae.appendChild(ce.clone())}J.replace(se,[ae])}}return Q||(Q=ne>0&&$),!ee.has(0)&&Q&&J.appendChild(new oe(0)),J},e.prototype._accept=function(X,$){if(void 0===X||this._token.type===X){var Q=!$||this._scanner.tokenText(this._token);return this._token=this._scanner.next(),Q}return!1},e.prototype._backTo=function(X){return this._scanner.pos=X.pos+X.len,this._token=X,!1},e.prototype._until=function(X){if(14===this._token.type)return!1;for(var $=this._token;this._token.type!==X;)if(this._token=this._scanner.next(),14===this._token.type)return!1;var Q=this._scanner.value.substring($.pos,this._token.pos);return this._token=this._scanner.next(),Q},e.prototype._parse=function(X){return this._parseEscaped(X)||this._parseTabstopOrVariableName(X)||this._parseComplexPlaceholder(X)||this._parseComplexVariable(X)||this._parseAnything(X)},e.prototype._parseEscaped=function(X){var $;return!!($=this._accept(5,!0))&&($=this._accept(0,!0)||this._accept(4,!0)||this._accept(5,!0)||$,X.appendChild(new ne($)),!0)},e.prototype._parseTabstopOrVariableName=function(X){var $,Q=this._token;return this._accept(0)&&($=this._accept(9,!0)||this._accept(8,!0))?(X.appendChild(/^\d+$/.test($)?new oe(Number($)):new le($)),!0):this._backTo(Q)},e.prototype._parseComplexPlaceholder=function(X){var $,Q=this._token;if(!(this._accept(0)&&this._accept(3)&&($=this._accept(8,!0))))return this._backTo(Q);var J=new oe(Number($));if(this._accept(1))for(;;){if(this._accept(4))return X.appendChild(J),!0;if(!this._parse(J))return X.appendChild(new ne("${"+$+":")),J.children.forEach(X.appendChild,X),!0}else{if(!(J.index>0&&this._accept(7)))return this._accept(6)?this._parseTransform(J)?(X.appendChild(J),!0):(this._backTo(Q),!1):this._accept(4)?(X.appendChild(J),!0):this._backTo(Q);for(var ee=new re;;){if(this._parseChoiceElement(ee)){if(this._accept(2))continue;if(this._accept(7)&&(J.appendChild(ee),this._accept(4)))return X.appendChild(J),!0}return this._backTo(Q),!1}}},e.prototype._parseChoiceElement=function(X){for(var $=this._token,Q=[];2!==this._token.type&&7!==this._token.type;){var J=void 0;if(!(J=(J=this._accept(5,!0))?this._accept(2,!0)||this._accept(7,!0)||this._accept(5,!0)||J:this._accept(void 0,!0)))return this._backTo($),!1;Q.push(J)}return 0===Q.length?(this._backTo($),!1):(X.appendChild(new ne(Q.join(""))),!0)},e.prototype._parseComplexVariable=function(X){var $,Q=this._token;if(!(this._accept(0)&&this._accept(3)&&($=this._accept(9,!0))))return this._backTo(Q);var J=new le($);if(!this._accept(1))return this._accept(6)?this._parseTransform(J)?(X.appendChild(J),!0):(this._backTo(Q),!1):this._accept(4)?(X.appendChild(J),!0):this._backTo(Q);for(;;){if(this._accept(4))return X.appendChild(J),!0;if(!this._parse(J))return X.appendChild(new ne("${"+$+":")),J.children.forEach(X.appendChild,X),!0}},e.prototype._parseTransform=function(X){for(var $=new se,Q="",J="";!this._accept(6);)if(ee=void 0,ee=this._accept(5,!0))Q+=ee=this._accept(6,!0)||ee;else{if(14===this._token.type)return!1;Q+=this._accept(void 0,!0)}for(;!this._accept(6);){var ee=void 0;if(ee=this._accept(5,!0))ee=this._accept(6,!0)||ee,$.appendChild(new ne(ee));else if(!this._parseFormatString($)&&!this._parseAnything($))return!1}for(;!this._accept(4);){if(14===this._token.type)return!1;J+=this._accept(void 0,!0)}try{$.regexp=new RegExp(Q,J)}catch(X){return!1}return X.transform=$,!0},e.prototype._parseFormatString=function(X){var $=this._token;if(!this._accept(0))return!1;var Q=!1;this._accept(3)&&(Q=!0);var J=this._accept(8,!0);if(!J)return this._backTo($),!1;if(!Q)return X.appendChild(new ae(Number(J))),!0;if(this._accept(4))return X.appendChild(new ae(Number(J))),!0;if(!this._accept(1))return this._backTo($),!1;if(this._accept(6)){var ee=this._accept(9,!0);return ee&&this._accept(4)?(X.appendChild(new ae(Number(J),ee)),!0):(this._backTo($),!1)}if(this._accept(11)){if(te=this._until(4))return X.appendChild(new ae(Number(J),void 0,te,void 0)),!0}else if(this._accept(12)){if(ne=this._until(4))return X.appendChild(new ae(Number(J),void 0,void 0,ne)),!0}else if(this._accept(13)){var te=this._until(1);if(te&&(ne=this._until(4)))return X.appendChild(new ae(Number(J),void 0,te,ne)),!0}else{var ne=this._until(4);if(ne)return X.appendChild(new ae(Number(J),void 0,void 0,ne)),!0}return this._backTo($),!1},e.prototype._parseAnything=function(X){return 14!==this._token.type&&(X.appendChild(new ne(this._scanner.tokenText(this._token))),this._accept(void 0),!0)},e}();$.SnippetParser=de})),define(Q[261],n([0,1,22,3,192]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var ne=function(){function e(){}return e.create=function(X,$){if(!$.getConfiguration().contribInfo.suggest.localityBonus)return Promise.resolve(e.None);if(!$.hasModel())return Promise.resolve(e.None);var ne=$.getModel(),ie=$.getPosition();if(!X.canComputeWordRanges(ne.uri))return Promise.resolve(e.None);for(var oe=ee.find(ee.build(ne),ie),re=[];oe&&(oe.range.isEmpty()||re.push(oe.range),!(oe.end.lineNumber-oe.start.lineNumber>=100));)oe=oe.parent;return re.reverse(),0===re.length?Promise.resolve(e.None):X.computeWordRanges(ne.uri,re[0]).then((function(X){return new(function(ee){function r(){return null!==ee&&ee.apply(this,arguments)||this}return te(r,ee),r.prototype.distance=function(ee,te){if(!X||!ie.equals($.getPosition()))return 0;if(17===te.kind)return 2<<20;var ne=te.label,oe=X[ne];if(Q.isFalsyOrEmpty(oe))return 2<<20;for(var se=Q.binarySearch(oe,J.Range.fromPositions(ee),J.Range.compareRangesUsingStarts),ae=se>=0?oe[se]:oe[Math.max(0,~se-1)],le=re.length,ue=0,de=re;ue<de.length;ue++){var ce=de[ue];if(!J.Range.containsRange(ce,ae))break;le-=1}return le},r}(e))}))},e.None=new(function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype.distance=function(){return 0},t}(e)),e}();$.WordDistance=ne})),define(Q[198],n([0,1]),(function(X,$){function n(X){return Array.isArray(X)}function i(X){return"string"==typeof X}function o(X){return!X}function r(X,$){return X.ignoreCase&&$?$.toLowerCase():$}Object.defineProperty($,"__esModule",{value:!0}),$.isFuzzyActionArr=n,$.isFuzzyAction=function(X){return!n(X)},$.isString=i,$.isIAction=function(X){return!i(X)},$.empty=o,$.fixCase=r,$.sanitize=function(X){return X.replace(/[&<>'"_]/g,"-")},$.log=function(X,$){console.log(X.languageId+": "+$)},$.createError=function(X,$){return new Error(X.languageId+": "+$)},$.substituteMatches=function(X,$,Q,J,ee){var te=null;return $.replace(/\$((\$)|(#)|(\d\d?)|[sS](\d\d?)|@(\w+))/g,(function($,ne,ie,oe,re,se,ae,le,ue){return o(ie)?o(oe)?!o(re)&&re<J.length?r(X,J[re]):!o(ae)&&X&&"string"==typeof X[ae]?X[ae]:(null===te&&(te=ee.split(".")).unshift(ee),!o(se)&&se<te.length?r(X,te[se]):""):r(X,Q):"$"}))},$.findRules=function(X,$){for(var Q=$;Q&&Q.length>0;){var J=X.tokenizer[Q];if(J)return J;var ee=Q.lastIndexOf(".");Q=ee<0?null:Q.substr(0,ee)}return null},$.stateExists=function(X,$){for(var Q=$;Q&&Q.length>0;){if(X.stateNames[Q])return!0;var J=Q.lastIndexOf(".");Q=J<0?null:Q.substr(0,J)}return!1}})),define(Q[263],n([0,1,27,198]),(function(X,$,Q,J){function o(X,$){return"boolean"==typeof X?X:$}function r(X,$){return"string"==typeof X?X:$}function s(X,$){for(var Q=0;$.indexOf("@")>=0&&Q<5;)Q++,$=$.replace(/@(\w+)/g,(function(Q,ee){var te="";if("string"==typeof X[ee])te=X[ee];else{if(!(X[ee]&&X[ee]instanceof RegExp))throw void 0===X[ee]?J.createError(X,"language definition does not contain attribute '"+ee+"', used at: "+$):J.createError(X,"attribute reference '"+ee+"' must be a string, used at: "+$);te=X[ee].source}return J.empty(te)?"":"(?:"+te+")"}));return new RegExp($,X.ignoreCase?"i":"")}function a(X,$,ee,te){var ne=-1,ie=ee,oe=ee.match(/^\$(([sS]?)(\d\d?)|#)(.*)$/);oe&&(oe[3]&&(ne=parseInt(oe[3]),oe[2]&&(ne+=100)),ie=oe[4]);var re,se="~",ae=ie;if(ie&&0!==ie.length?/^\w*$/.test(ae)?se="==":(oe=ie.match(/^(@|!@|~|!~|==|!=)(.*)$/))&&(se=oe[1],ae=oe[2]):(se="!=",ae=""),"~"!==se&&"!~"!==se||!/^(\w|\|)*$/.test(ae))if("@"===se||"!@"===se){var le=X[ae];if(!le)throw J.createError(X,"the @ match target '"+ae+"' is not defined, in rule: "+$);if(!function(X,$){if(!$)return!1;if(!Array.isArray($))return!1;for(var Q in $)if($.hasOwnProperty(Q)&&!X($[Q]))return!1;return!0}((function(X){return"string"==typeof X}),le))throw J.createError(X,"the @ match target '"+ae+"' must be an array of strings, in rule: "+$);var ue=Q.createKeywordMatcher(le,X.ignoreCase);re=function(X){return"@"===se?ue(X):!ue(X)}}else if("~"===se||"!~"===se)if(ae.indexOf("$")<0){var de=s(X,"^"+ae+"$");re=function(X){return"~"===se?de.test(X):!de.test(X)}}else re=function($,Q,ee,te){return s(X,"^"+J.substituteMatches(X,ae,Q,ee,te)+"$").test($)};else if(ae.indexOf("$")<0){var ce=J.fixCase(X,ae);re=function(X){return"=="===se?X===ce:X!==ce}}else{var he=J.fixCase(X,ae);re=function($,Q,ee,te,ne){var ie=J.substituteMatches(X,he,Q,ee,te);return"=="===se?$===ie:$!==ie}}else{var pe=Q.createKeywordMatcher(ae.split("|"),X.ignoreCase);re=function(X){return"~"===se?pe(X):!pe(X)}}return-1===ne?{name:ee,value:te,test:function(X,$,Q,J){return re(X,X,$,Q,J)}}:{name:ee,value:te,test:function(X,$,Q,J){var ee=function(X,$,Q,J){if(J<0)return X;if(J<$.length)return $[J];if(J>=100){J-=100;var ee=Q.split(".");if(ee.unshift(Q),J<ee.length)return ee[J]}return null}(X,$,Q,ne);return re(ee||"",X,$,Q,J)}}}function l(X,$,Q){if(Q){if("string"==typeof Q)return Q;if(Q.token||""===Q.token){if("string"!=typeof Q.token)throw J.createError(X,"a 'token' attribute must be of type string, in rule: "+$);var ee={token:Q.token};if(Q.token.indexOf("$")>=0&&(ee.tokenSubst=!0),"string"==typeof Q.bracket)if("@open"===Q.bracket)ee.bracket=1;else{if("@close"!==Q.bracket)throw J.createError(X,"a 'bracket' attribute must be either '@open' or '@close', in rule: "+$);ee.bracket=-1}if(Q.next){if("string"!=typeof Q.next)throw J.createError(X,"the next state must be a string value in rule: "+$);var te=Q.next;if(!/^(@pop|@push|@popall)$/.test(te)&&("@"===te[0]&&(te=te.substr(1)),te.indexOf("$")<0&&!J.stateExists(X,J.substituteMatches(X,te,"",[],""))))throw J.createError(X,"the next state '"+Q.next+"' is not defined in rule: "+$);ee.next=te}return"number"==typeof Q.goBack&&(ee.goBack=Q.goBack),"string"==typeof Q.switchTo&&(ee.switchTo=Q.switchTo),"string"==typeof Q.log&&(ee.log=Q.log),"string"==typeof Q.nextEmbedded&&(ee.nextEmbedded=Q.nextEmbedded,X.usesEmbedded=!0),ee}if(Array.isArray(Q)){var ne=[];for(var ie in Q)Q.hasOwnProperty(ie)&&(ne[ie]=l(X,$,Q[ie]));return{group:ne}}if(Q.cases){var oe=[];for(var re in Q.cases)if(Q.cases.hasOwnProperty(re)){var se=l(X,$,Q.cases[re]);"@default"===re||"@"===re||""===re?oe.push({test:void 0,value:se,name:re}):"@eos"===re?oe.push({test:function(X,$,Q,J){return J},value:se,name:re}):oe.push(a(X,$,re,se))}var ae=X.defaultToken;return{test:function(X,$,Q,J){for(var ee in oe)if(oe.hasOwnProperty(ee)){var te=oe[ee];if(!te.test||te.test(X,$,Q,J))return te.value}return ae}}}throw J.createError(X,"an action must be a string, an object with a 'token' or 'cases' attribute, or an array of actions; in rule: "+$)}return{token:""}}Object.defineProperty($,"__esModule",{value:!0});var ee=function(){function e(X){this.regex=new RegExp(""),this.action={token:""},this.matchOnlyAtLineStart=!1,this.name="",this.name=X}return e.prototype.setRegex=function(X,$){var Q;if("string"==typeof $)Q=$;else{if(!($ instanceof RegExp))throw J.createError(X,"rules must start with a match string or regular expression: "+this.name);Q=$.source}this.matchOnlyAtLineStart=Q.length>0&&"^"===Q[0],this.name=this.name+": "+Q,this.regex=s(X,"^(?:"+(this.matchOnlyAtLineStart?Q.substr(1):Q)+")")},e.prototype.setAction=function(X,$){this.action=l(X,this.name,$)},e}();$.compile=function(X,$){function n(X,ne,ie){for(var oe in ie)if(ie.hasOwnProperty(oe)){var re=ie[oe],se=re.include;if(se){if("string"!=typeof se)throw J.createError(Q,"an 'include' attribute must be a string at: "+X);if("@"===se[0]&&(se=se.substr(1)),!$.tokenizer[se])throw J.createError(Q,"include target '"+se+"' is not defined at: "+X);n(X+"."+se,ne,$.tokenizer[se])}else{var ae=new ee(X);if(Array.isArray(re)&&re.length>=1&&re.length<=3)if(ae.setRegex(te,re[0]),re.length>=3)if("string"==typeof re[1])ae.setAction(te,{token:re[1],next:re[2]});else{if("object"!=typeof re[1])throw J.createError(Q,"a next state as the last element of a rule can only be given if the action is either an object or a string, at: "+X);var le=re[1];le.next=re[2],ae.setAction(te,le)}else ae.setAction(te,re[1]);else{if(!re.regex)throw J.createError(Q,"a rule must either be an array, or an object with a 'regex' or 'include' field at: "+X);re.name&&"string"==typeof re.name&&(ae.name=re.name),re.matchOnlyAtStart&&(ae.matchOnlyAtLineStart=o(re.matchOnlyAtLineStart,!1)),ae.setRegex(te,re.regex),ae.setAction(te,re.action)}ne.push(ae)}}}if(!$||"object"!=typeof $)throw new Error("Monarch: expecting a language definition object");var Q={};Q.languageId=X,Q.noThrow=!1,Q.maxStack=100,Q.start="string"==typeof $.start?$.start:null,Q.ignoreCase=o($.ignoreCase,!1),Q.tokenPostfix=r($.tokenPostfix,"."+Q.languageId),Q.defaultToken=r($.defaultToken,"source"),Q.usesEmbedded=!1;var te=$;if(te.languageId=X,te.ignoreCase=Q.ignoreCase,te.noThrow=Q.noThrow,te.usesEmbedded=Q.usesEmbedded,te.stateNames=$.tokenizer,te.defaultToken=Q.defaultToken,!$.tokenizer||"object"!=typeof $.tokenizer)throw J.createError(Q,"a language definition must define the 'tokenizer' attribute as an object");for(var ne in Q.tokenizer=[],$.tokenizer)if($.tokenizer.hasOwnProperty(ne)){Q.start||(Q.start=ne);var ie=$.tokenizer[ne];Q.tokenizer[ne]=new Array,n("tokenizer."+ne,Q.tokenizer[ne],ie)}if(Q.usesEmbedded=te.usesEmbedded,$.brackets){if(!Array.isArray($.brackets))throw J.createError(Q,"the 'brackets' attribute must be defined as an array")}else $.brackets=[{open:"{",close:"}",token:"delimiter.curly"},{open:"[",close:"]",token:"delimiter.square"},{open:"(",close:")",token:"delimiter.parenthesis"},{open:"<",close:">",token:"delimiter.angle"}];var oe=[];for(var re in $.brackets)if($.brackets.hasOwnProperty(re)){var se=$.brackets[re];if(se&&Array.isArray(se)&&3===se.length&&(se={token:se[2],open:se[0],close:se[1]}),se.open===se.close)throw J.createError(Q,"open and close brackets in a 'brackets' attribute must be different: "+se.open+"\n hint: use the 'bracket' attribute if matching on equal brackets is required.");if("string"!=typeof se.open||"string"!=typeof se.token||"string"!=typeof se.close)throw J.createError(Q,"every element in the 'brackets' array must be a '{open,close,token}' object or array");oe.push({token:se.token+Q.tokenPostfix,open:J.fixCase(Q,se.open),close:J.fixCase(Q,se.close)})}return Q.brackets=oe,Q.noThrow=!0,Q}})),define(Q[264],n([5,4]),(function(X,$){return X.create("vs/base/browser/ui/actionbar/actionbar",$)})),define(Q[67],n([0,1,17,264,2,56,7,32,75,52,6,463]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae){Object.defineProperty($,"__esModule",{value:!0});var le=function(X){function t($,Q,J){var ee=X.call(this)||this;return ee.options=J,ee._context=$||ee,ee._action=Q,Q instanceof ne.Action&&ee._register(Q.onDidChange((function(X){ee.element&&ee.handleActionChangeEvent(X)}))),ee}return te(t,X),t.prototype.handleActionChangeEvent=function(X){void 0!==X.enabled&&this.updateEnabled(),void 0!==X.checked&&this.updateChecked(),void 0!==X.class&&this.updateClass(),void 0!==X.label&&(this.updateLabel(),this.updateTooltip()),void 0!==X.tooltip&&this.updateTooltip()},Object.defineProperty(t.prototype,"actionRunner",{get:function(){return this._actionRunner},set:function(X){this._actionRunner=X},enumerable:!0,configurable:!0}),t.prototype.getAction=function(){return this._action},t.prototype.isEnabled=function(){return this._action.enabled},t.prototype.setActionContext=function(X){this._context=X},t.prototype.render=function(X){var $=this;this.element=X,re.Gesture.addTarget(X);var J=this.options&&this.options.draggable;J&&(X.draggable=!0),this._register(ie.addDisposableListener(this.element,re.EventType.Tap,(function(X){return $.onClick(X)}))),this._register(ie.addDisposableListener(this.element,ie.EventType.MOUSE_DOWN,(function(X){J||ie.EventHelper.stop(X,!0);var Q=X;$._action.enabled&&0===Q.button&&ie.addClass($.element,"active")}))),this._register(ie.addDisposableListener(this.element,ie.EventType.CLICK,(function(X){ie.EventHelper.stop(X,!0),$.options&&$.options.isMenu?$.onClick(X):Q.setImmediate((function(){return $.onClick(X)}))}))),this._register(ie.addDisposableListener(this.element,ie.EventType.DBLCLICK,(function(X){ie.EventHelper.stop(X,!0)}))),[ie.EventType.MOUSE_UP,ie.EventType.MOUSE_OUT].forEach((function(X){$._register(ie.addDisposableListener($.element,X,(function(X){ie.EventHelper.stop(X),ie.removeClass($.element,"active")})))}))},t.prototype.onClick=function(X){var $;ie.EventHelper.stop(X,!0),oe.isUndefinedOrNull(this._context)?$=X:($=this._context,oe.isObject($)&&($.event=X)),this._actionRunner.run(this._action,$)},t.prototype.focus=function(){this.element&&(this.element.focus(),ie.addClass(this.element,"focused"))},t.prototype.blur=function(){this.element&&(this.element.blur(),ie.removeClass(this.element,"focused"))},t.prototype.updateEnabled=function(){},t.prototype.updateLabel=function(){},t.prototype.updateTooltip=function(){},t.prototype.updateClass=function(){},t.prototype.updateChecked=function(){},t.prototype.dispose=function(){this.element&&(ie.removeNode(this.element),this.element=null),X.prototype.dispose.call(this)},t}(ee.Disposable);$.BaseActionItem=le;var ue=function(X){function t($){var Q=X.call(this,t.ID,$,$?"separator text":"separator")||this;return Q.checked=!1,Q.radio=!1,Q.enabled=!1,Q}return te(t,X),t.ID="vs.actions.separator",t}(ne.Action);$.Separator=ue;var de=function(X){function t($,Q,J){void 0===J&&(J={});var ee=X.call(this,$,Q,J)||this;return ee.options=J,ee.options.icon=void 0!==J.icon&&J.icon,ee.options.label=void 0===J.label||J.label,ee.cssClass="",ee}return te(t,X),t.prototype.render=function($){X.prototype.render.call(this,$),this.label=ie.append(this.element,ie.$("a.action-label")),this._action.id===ue.ID?this.label.setAttribute("role","presentation"):this.options.isMenu?this.label.setAttribute("role","menuitem"):this.label.setAttribute("role","button"),this.options.label&&this.options.keybinding&&(ie.append(this.element,ie.$("span.keybinding")).textContent=this.options.keybinding),this.updateClass(),this.updateLabel(),this.updateTooltip(),this.updateEnabled(),this.updateChecked()},t.prototype.focus=function(){X.prototype.focus.call(this),this.label.focus()},t.prototype.updateLabel=function(){this.options.label&&(this.label.textContent=this.getAction().label)},t.prototype.updateTooltip=function(){var X=null;this.getAction().tooltip?X=this.getAction().tooltip:!this.options.label&&this.getAction().label&&this.options.icon&&(X=this.getAction().label,this.options.keybinding&&(X=J.localize(0,null,X,this.options.keybinding))),X&&(this.label.title=X)},t.prototype.updateClass=function(){this.cssClass&&ie.removeClasses(this.label,this.cssClass),this.options.icon?(this.cssClass=this.getAction().class,ie.addClass(this.label,"icon"),this.cssClass&&ie.addClasses(this.label,this.cssClass),this.updateEnabled()):ie.removeClass(this.label,"icon")},t.prototype.updateEnabled=function(){this.getAction().enabled?(this.label.removeAttribute("aria-disabled"),ie.removeClass(this.element,"disabled"),ie.removeClass(this.label,"disabled"),this.label.tabIndex=0):(this.label.setAttribute("aria-disabled","true"),ie.addClass(this.element,"disabled"),ie.addClass(this.label,"disabled"),ie.removeTabIndexAndUpdateFocus(this.label))},t.prototype.updateChecked=function(){this.getAction().checked?ie.addClass(this.label,"checked"):ie.removeClass(this.label,"checked")},t}(le);$.ActionItem=de;var ce={orientation:0,context:null,triggerKeys:{keys:[3,10],keyDown:!1}},he=function(X){function t($,Q){void 0===Q&&(Q=ce);var J,ee,te=X.call(this)||this;switch(te._onDidBlur=te._register(new ae.Emitter),te._onDidCancel=te._register(new ae.Emitter),te._onDidRun=te._register(new ae.Emitter),te._onDidBeforeRun=te._register(new ae.Emitter),te.options=Q,te._context=Q.context,te._actionRunner=te.options.actionRunner,te.options.triggerKeys||(te.options.triggerKeys=ce.triggerKeys),te._actionRunner||(te._actionRunner=new ne.ActionRunner,te._register(te._actionRunner)),te._register(te._actionRunner.onDidRun((function(X){return te._onDidRun.fire(X)}))),te._register(te._actionRunner.onDidBeforeRun((function(X){return te._onDidBeforeRun.fire(X)}))),te.items=[],te.focusedItem=void 0,te.domNode=document.createElement("div"),te.domNode.className="monaco-action-bar",!1!==Q.animated&&ie.addClass(te.domNode,"animated"),te.options.orientation){case 0:J=15,ee=17;break;case 1:J=17,ee=15,te.domNode.className+=" reverse";break;case 2:J=16,ee=18,te.domNode.className+=" vertical";break;case 3:J=18,ee=16,te.domNode.className+=" vertical reverse"}return te._register(ie.addDisposableListener(te.domNode,ie.EventType.KEY_DOWN,(function(X){var $=new se.StandardKeyboardEvent(X),Q=!0;$.equals(J)?te.focusPrevious():$.equals(ee)?te.focusNext():$.equals(9)?te.cancel():te.isTriggerKeyEvent($)?te.options.triggerKeys&&te.options.triggerKeys.keyDown&&te.doTrigger($):Q=!1,Q&&($.preventDefault(),$.stopPropagation())}))),te._register(ie.addDisposableListener(te.domNode,ie.EventType.KEY_UP,(function(X){var $=new se.StandardKeyboardEvent(X);te.isTriggerKeyEvent($)?(te.options.triggerKeys.keyDown||te.doTrigger($),$.preventDefault(),$.stopPropagation()):($.equals(2)||$.equals(1026))&&te.updateFocusedItem()}))),te.focusTracker=te._register(ie.trackFocus(te.domNode)),te._register(te.focusTracker.onDidBlur((function(){document.activeElement!==te.domNode&&ie.isAncestor(document.activeElement,te.domNode)||(te._onDidBlur.fire(),te.focusedItem=void 0)}))),te._register(te.focusTracker.onDidFocus((function(){return te.updateFocusedItem()}))),te.actionsList=document.createElement("ul"),te.actionsList.className="actions-container",te.actionsList.setAttribute("role","toolbar"),te.options.ariaLabel&&te.actionsList.setAttribute("aria-label",te.options.ariaLabel),te.domNode.appendChild(te.actionsList),$.appendChild(te.domNode),te}return te(t,X),Object.defineProperty(t.prototype,"onDidBlur",{get:function(){return this._onDidBlur.event},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"onDidCancel",{get:function(){return this._onDidCancel.event},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"onDidRun",{get:function(){return this._onDidRun.event},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"onDidBeforeRun",{get:function(){return this._onDidBeforeRun.event},enumerable:!0,configurable:!0}),t.prototype.isTriggerKeyEvent=function(X){var $=!1;return this.options.triggerKeys&&this.options.triggerKeys.keys.forEach((function(Q){$=$||X.equals(Q)})),$},t.prototype.updateFocusedItem=function(){for(var X=0;X<this.actionsList.children.length;X++){var $=this.actionsList.children[X];if(ie.isAncestor(document.activeElement,$)){this.focusedItem=X;break}}},Object.defineProperty(t.prototype,"context",{get:function(){return this._context},set:function(X){this._context=X,this.items.forEach((function($){return $.setActionContext(X)}))},enumerable:!0,configurable:!0}),t.prototype.getContainer=function(){return this.domNode},t.prototype.push=function(X,$){var Q=this;void 0===$&&($={});var J=Array.isArray(X)?X:[X],ee=oe.isNumber($.index)?$.index:null;J.forEach((function(X){var J=document.createElement("li");J.className="action-item",J.setAttribute("role","presentation"),Q._register(ie.addDisposableListener(J,ie.EventType.CONTEXT_MENU,(function(X){X.preventDefault(),X.stopPropagation()})));var te=null;Q.options.actionItemProvider&&(te=Q.options.actionItemProvider(X)),te||(te=new de(Q.context,X,$)),te.actionRunner=Q._actionRunner,te.setActionContext(Q.context),te.render(J),null===ee||ee<0||ee>=Q.actionsList.children.length?(Q.actionsList.appendChild(J),Q.items.push(te)):(Q.actionsList.insertBefore(J,Q.actionsList.children[ee]),Q.items.splice(ee,0,te),ee++)}))},t.prototype.clear=function(){this.items=ee.dispose(this.items),ie.clearNode(this.actionsList)},t.prototype.isEmpty=function(){return 0===this.items.length},t.prototype.focus=function(X){X&&void 0===this.focusedItem?(this.focusedItem=this.items.length-1,this.focusNext()):this.updateFocus()},t.prototype.focusNext=function(){void 0===this.focusedItem&&(this.focusedItem=this.items.length-1);var X,$=this.focusedItem;do{this.focusedItem=(this.focusedItem+1)%this.items.length,X=this.items[this.focusedItem]}while(this.focusedItem!==$&&!X.isEnabled());this.focusedItem!==$||X.isEnabled()||(this.focusedItem=void 0),this.updateFocus()},t.prototype.focusPrevious=function(){void 0===this.focusedItem&&(this.focusedItem=0);var X,$=this.focusedItem;do{this.focusedItem=this.focusedItem-1,this.focusedItem<0&&(this.focusedItem=this.items.length-1),X=this.items[this.focusedItem]}while(this.focusedItem!==$&&!X.isEnabled());this.focusedItem!==$||X.isEnabled()||(this.focusedItem=void 0),this.updateFocus(!0)},t.prototype.updateFocus=function(X){void 0===this.focusedItem&&this.actionsList.focus();for(var $=0;$<this.items.length;$++){var Q=this.items[$];$===this.focusedItem?oe.isFunction(Q.isEnabled)&&(Q.isEnabled()&&oe.isFunction(Q.focus)?Q.focus(X):this.actionsList.focus()):oe.isFunction(Q.blur)&&Q.blur()}},t.prototype.doTrigger=function(X){if(void 0!==this.focusedItem){var $=this.items[this.focusedItem];if($ instanceof le){var Q=null===$._context||void 0===$._context?X:$._context;this.run($._action,Q)}}},t.prototype.cancel=function(){document.activeElement instanceof HTMLElement&&document.activeElement.blur(),this._onDidCancel.fire()},t.prototype.run=function(X,$){return this._actionRunner.run(X,$)},t.prototype.dispose=function(){null!==this.items&&ee.dispose(this.items),this.items=null,ie.removeNode(this.getContainer()),X.prototype.dispose.call(this)},t}(ee.Disposable);$.ActionBar=he})),define(Q[268],n([5,4]),(function(X,$){return X.create("vs/base/browser/ui/aria/aria",$)})),define(Q[43],n([0,1,268,17,7,469]),(function(X,$,Q,J,ee){function r(X){s(ne,X)}function s(X,$){if(te){switch(re===$?oe++:(re=$,oe=0),oe){case 0:break;case 1:$=Q.localize(0,null,$);break;default:$=Q.localize(1,null,$,oe)}ee.clearNode(X),X.textContent=$,X.style.visibility="hidden",X.style.visibility="visible"}}var te,ne,ie;Object.defineProperty($,"__esModule",{value:!0}),$.setARIAContainer=function(X){(te=document.createElement("div")).className="monaco-aria-container",(ne=document.createElement("div")).className="monaco-alert",ne.setAttribute("role","alert"),ne.setAttribute("aria-atomic","true"),te.appendChild(ne),(ie=document.createElement("div")).className="monaco-status",ie.setAttribute("role","status"),ie.setAttribute("aria-atomic","true"),te.appendChild(ie),X.appendChild(te)},$.alert=r,$.status=function(X){J.isMacintosh?r(X):s(ie,X)};var oe=0,re=void 0})),define(Q[270],n([5,4]),(function(X,$){return X.create("vs/base/browser/ui/findinput/findInput",$)})),define(Q[271],n([5,4]),(function(X,$){return X.create("vs/base/browser/ui/findinput/findInputCheckboxes",$)})),define(Q[152],n([0,1,487,271,563]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=J.localize(0,null),ne=J.localize(1,null),ie=J.localize(2,null),oe=function(X){function t($){return X.call(this,{actionClassName:"monaco-case-sensitive",title:ee+$.appendTitle,isChecked:$.isChecked,inputActiveOptionBorder:$.inputActiveOptionBorder})||this}return te(t,X),t}(Q.Checkbox);$.CaseSensitiveCheckbox=oe;var re=function(X){function t($){return X.call(this,{actionClassName:"monaco-whole-word",title:ne+$.appendTitle,isChecked:$.isChecked,inputActiveOptionBorder:$.inputActiveOptionBorder})||this}return te(t,X),t}(Q.Checkbox);$.WholeWordsCheckbox=re;var se=function(X){function t($){return X.call(this,{actionClassName:"monaco-regex",title:ie+$.appendTitle,isChecked:$.isChecked,inputActiveOptionBorder:$.inputActiveOptionBorder})||this}return te(t,X),t}(Q.Checkbox);$.RegexCheckbox=se})),define(Q[273],n([5,4]),(function(X,$){return X.create("vs/base/browser/ui/inputbox/inputBox",$)})),define(Q[117],n([0,1,273,29,7,133,43,67,6,46,28,27,441,206]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le,ue){Object.defineProperty($,"__esModule",{value:!0});var de=ee.$,ce={inputBackground:ae.Color.fromHex("#3C3C3C"),inputForeground:ae.Color.fromHex("#CCCCCC"),inputValidationInfoBorder:ae.Color.fromHex("#55AAFF"),inputValidationInfoBackground:ae.Color.fromHex("#063B49"),inputValidationWarningBorder:ae.Color.fromHex("#B89500"),inputValidationWarningBackground:ae.Color.fromHex("#352A05"),inputValidationErrorBorder:ae.Color.fromHex("#BE1100"),inputValidationErrorBackground:ae.Color.fromHex("#5A1D1D")},he=function(X){function t($,Q,te){var ne=X.call(this)||this;ne.state="idle",ne._onDidChange=ne._register(new re.Emitter),ne.onDidChange=ne._onDidChange.event,ne._onDidHeightChange=ne._register(new re.Emitter),ne.contextViewProvider=Q,ne.options=te||Object.create(null),le.mixin(ne.options,ce,!1),ne.message=null,ne.cachedHeight=null,ne.placeholder=ne.options.placeholder||"",ne.ariaLabel=ne.options.ariaLabel||"",ne.inputBackground=ne.options.inputBackground,ne.inputForeground=ne.options.inputForeground,ne.inputBorder=ne.options.inputBorder,ne.inputValidationInfoBorder=ne.options.inputValidationInfoBorder,ne.inputValidationInfoBackground=ne.options.inputValidationInfoBackground,ne.inputValidationInfoForeground=ne.options.inputValidationInfoForeground,ne.inputValidationWarningBorder=ne.options.inputValidationWarningBorder,ne.inputValidationWarningBackground=ne.options.inputValidationWarningBackground,ne.inputValidationWarningForeground=ne.options.inputValidationWarningForeground,ne.inputValidationErrorBorder=ne.options.inputValidationErrorBorder,ne.inputValidationErrorBackground=ne.options.inputValidationErrorBackground,ne.inputValidationErrorForeground=ne.options.inputValidationErrorForeground,ne.options.validationOptions&&(ne.validation=ne.options.validationOptions.validation),ne.element=ee.append($,de(".monaco-inputbox.idle"));var ie=ne.options.flexibleHeight?"textarea":"input",se=ee.append(ne.element,de(".wrapper"));return ne.input=ee.append(se,de(ie+".input")),ne.input.setAttribute("autocorrect","off"),ne.input.setAttribute("autocapitalize","off"),ne.input.setAttribute("spellcheck","false"),ne.onfocus(ne.input,(function(){return ee.addClass(ne.element,"synthetic-focus")})),ne.onblur(ne.input,(function(){return ee.removeClass(ne.element,"synthetic-focus")})),ne.options.flexibleHeight?ne.mirror=ee.append(se,de("div.mirror")):(ne.input.type=ne.options.type||"text",ne.input.setAttribute("wrap","off")),ne.ariaLabel&&ne.input.setAttribute("aria-label",ne.ariaLabel),ne.placeholder&&ne.setPlaceHolder(ne.placeholder),ne.oninput(ne.input,(function(){return ne.onValueChange()})),ne.onblur(ne.input,(function(){return ne.onBlur()})),ne.onfocus(ne.input,(function(){return ne.onFocus()})),ne.placeholder&&J.isIE&&ne.onclick(ne.input,(function(X){ee.EventHelper.stop(X,!0),ne.input.focus()})),setTimeout((function(){ne.input&&ne.updateMirror()}),0),ne.options.actions&&(ne.actionbar=ne._register(new oe.ActionBar(ne.element)),ne.actionbar.push(ne.options.actions,{icon:!0,label:!1})),ne.applyStyles(),ne}return te(t,X),t.prototype.onBlur=function(){this._hideMessage()},t.prototype.onFocus=function(){this._showMessage()},t.prototype.setPlaceHolder=function(X){this.input&&(this.input.setAttribute("placeholder",X),this.input.title=X)},t.prototype.setAriaLabel=function(X){this.ariaLabel=X,this.input&&(X?this.input.setAttribute("aria-label",this.ariaLabel):this.input.removeAttribute("aria-label"))},Object.defineProperty(t.prototype,"inputElement",{get:function(){return this.input},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"value",{get:function(){return this.input.value},set:function(X){this.input.value!==X&&(this.input.value=X,this.onValueChange())},enumerable:!0,configurable:!0}),t.prototype.focus=function(){this.input.focus()},t.prototype.blur=function(){this.input.blur()},t.prototype.hasFocus=function(){return document.activeElement===this.input},t.prototype.select=function(X){void 0===X&&(X=null),this.input.select(),X&&this.input.setSelectionRange(X.start,X.end)},t.prototype.enable=function(){this.input.removeAttribute("disabled")},t.prototype.disable=function(){this.input.disabled=!0,this._hideMessage()},t.prototype.setEnabled=function(X){X?this.enable():this.disable()},Object.defineProperty(t.prototype,"width",{get:function(){return ee.getTotalWidth(this.input)},set:function(X){this.input.style.width=X+"px"},enumerable:!0,configurable:!0}),t.prototype.showMessage=function(X,$){this.message=X,ee.removeClass(this.element,"idle"),ee.removeClass(this.element,"info"),ee.removeClass(this.element,"warning"),ee.removeClass(this.element,"error"),ee.addClass(this.element,this.classForType(X.type));var J,te=this.stylesForType(this.message.type);this.element.style.border=te.border?"1px solid "+te.border:null,J=3===X.type?Q.localize(0,null,X.content):2===X.type?Q.localize(1,null,X.content):Q.localize(2,null,X.content),ie.alert(J),(this.hasFocus()||$)&&this._showMessage()},t.prototype.hideMessage=function(){this.message=null,ee.removeClass(this.element,"info"),ee.removeClass(this.element,"warning"),ee.removeClass(this.element,"error"),ee.addClass(this.element,"idle"),this._hideMessage(),this.applyStyles()},t.prototype.validate=function(){var X=null;return this.validation&&((X=this.validation(this.value))?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(X)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),!X},t.prototype.stylesForType=function(X){switch(X){case 1:return{border:this.inputValidationInfoBorder,background:this.inputValidationInfoBackground,foreground:this.inputValidationInfoForeground};case 2:return{border:this.inputValidationWarningBorder,background:this.inputValidationWarningBackground,foreground:this.inputValidationWarningForeground};default:return{border:this.inputValidationErrorBorder,background:this.inputValidationErrorBackground,foreground:this.inputValidationErrorForeground}}},t.prototype.classForType=function(X){switch(X){case 1:return"info";case 2:return"warning";default:return"error"}},t.prototype._showMessage=function(){var X=this;if(this.contextViewProvider&&this.message){var $,n=function(){return $.style.width=ee.getTotalWidth(X.element)+"px"};this.state="open",this.contextViewProvider.showContextView({getAnchor:function(){return X.element},anchorAlignment:1,render:function(Q){$=ee.append(Q,de(".monaco-inputbox-container")),n();var J={inline:!0,className:"monaco-inputbox-message"},te=X.message.formatContent?ne.renderFormattedText(X.message.content,J):ne.renderText(X.message.content,J);ee.addClass(te,X.classForType(X.message.type));var ie=X.stylesForType(X.message.type);return te.style.backgroundColor=ie.background?ie.background.toString():null,te.style.color=ie.foreground?ie.foreground.toString():null,te.style.border=ie.border?"1px solid "+ie.border:null,ee.append($,te),null},layout:n})}},t.prototype._hideMessage=function(){this.contextViewProvider&&"open"===this.state&&(this.state="idle",this.contextViewProvider.hideContextView())},t.prototype.onValueChange=function(){this._onDidChange.fire(this.value),this.validate(),this.updateMirror(),"open"===this.state&&this.contextViewProvider.layout()},t.prototype.updateMirror=function(){if(this.mirror){var X=this.value||this.placeholder,$=10===X.charCodeAt(X.length-1)?" ":"";this.mirror.textContent=X+$,this.layout()}},t.prototype.style=function(X){this.inputBackground=X.inputBackground,this.inputForeground=X.inputForeground,this.inputBorder=X.inputBorder,this.inputValidationInfoBackground=X.inputValidationInfoBackground,this.inputValidationInfoForeground=X.inputValidationInfoForeground,this.inputValidationInfoBorder=X.inputValidationInfoBorder,this.inputValidationWarningBackground=X.inputValidationWarningBackground,this.inputValidationWarningForeground=X.inputValidationWarningForeground,this.inputValidationWarningBorder=X.inputValidationWarningBorder,this.inputValidationErrorBackground=X.inputValidationErrorBackground,this.inputValidationErrorForeground=X.inputValidationErrorForeground,this.inputValidationErrorBorder=X.inputValidationErrorBorder,this.applyStyles()},t.prototype.applyStyles=function(){if(this.element){var X=this.inputBackground?this.inputBackground.toString():null,$=this.inputForeground?this.inputForeground.toString():null,Q=this.inputBorder?this.inputBorder.toString():null;this.element.style.backgroundColor=X,this.element.style.color=$,this.input.style.backgroundColor=X,this.input.style.color=$,this.element.style.borderWidth=Q?"1px":null,this.element.style.borderStyle=Q?"solid":null,this.element.style.borderColor=Q}},t.prototype.layout=function(){if(this.mirror){var X=this.cachedHeight;this.cachedHeight=ee.getTotalHeight(this.mirror),X!==this.cachedHeight&&(this.input.style.height=this.cachedHeight+"px",this._onDidHeightChange.fire(this.cachedHeight))}},t.prototype.dispose=function(){this._hideMessage(),this.element=null,this.input=null,this.contextViewProvider=null,this.message=null,this.placeholder=null,this.ariaLabel=null,this.validation=null,this.state=null,this.actionbar=null,X.prototype.dispose.call(this)},t}(se.Widget);$.InputBox=he;var pe=function(X){function t($,Q,J){var ee=X.call(this,$,Q,J)||this;return ee.history=new ue.HistoryNavigator(J.history,100),ee}return te(t,X),t.prototype.addToHistory=function(){this.value&&this.value!==this.getCurrentValue()&&this.history.add(this.value)},t.prototype.showNextValue=function(){this.history.has(this.value)||this.addToHistory();var X=this.getNextValue();X&&(X=X===this.value?this.getNextValue():X),X&&(this.value=X,ie.status(this.value))},t.prototype.showPreviousValue=function(){this.history.has(this.value)||this.addToHistory();var X=this.getPreviousValue();X&&(X=X===this.value?this.getPreviousValue():X),X&&(this.value=X,ie.status(this.value))},t.prototype.getCurrentValue=function(){var X=this.history.current();return X||(X=this.history.last(),this.history.next()),X},t.prototype.getPreviousValue=function(){return this.history.previous()||this.history.first()},t.prototype.getNextValue=function(){return this.history.next()||this.history.last()},t}(he);$.HistoryInputBox=pe})),define(Q[275],n([0,1,270,7,117,46,6,152,557]),(function(X,$,Q,J,ee,ne,ie,oe){Object.defineProperty($,"__esModule",{value:!0});var re=Q.localize(0,null),se=function(X){function t($,Q,J,ee){var te=X.call(this)||this;return te._showOptionButtons=J,te.fixFocusOnOptionClickEnabled=!0,te._onDidOptionChange=te._register(new ie.Emitter),te.onDidOptionChange=te._onDidOptionChange.event,te._onKeyDown=te._register(new ie.Emitter),te.onKeyDown=te._onKeyDown.event,te._onMouseDown=te._register(new ie.Emitter),te.onMouseDown=te._onMouseDown.event,te._onInput=te._register(new ie.Emitter),te._onKeyUp=te._register(new ie.Emitter),te._onCaseSensitiveKeyDown=te._register(new ie.Emitter),te.onCaseSensitiveKeyDown=te._onCaseSensitiveKeyDown.event,te._onRegexKeyDown=te._register(new ie.Emitter),te._lastHighlightFindOptions=0,te.contextViewProvider=Q,te.width=ee.width||100,te.placeholder=ee.placeholder||"",te.validation=ee.validation,te.label=ee.label||re,te.inputActiveOptionBorder=ee.inputActiveOptionBorder,te.inputBackground=ee.inputBackground,te.inputForeground=ee.inputForeground,te.inputBorder=ee.inputBorder,te.inputValidationInfoBorder=ee.inputValidationInfoBorder,te.inputValidationInfoBackground=ee.inputValidationInfoBackground,te.inputValidationInfoForeground=ee.inputValidationInfoForeground,te.inputValidationWarningBorder=ee.inputValidationWarningBorder,te.inputValidationWarningBackground=ee.inputValidationWarningBackground,te.inputValidationWarningForeground=ee.inputValidationWarningForeground,te.inputValidationErrorBorder=ee.inputValidationErrorBorder,te.inputValidationErrorBackground=ee.inputValidationErrorBackground,te.inputValidationErrorForeground=ee.inputValidationErrorForeground,te.regex=null,te.wholeWords=null,te.caseSensitive=null,te.domNode=null,te.inputBox=null,te.buildDomNode(ee.appendCaseSensitiveLabel||"",ee.appendWholeWordsLabel||"",ee.appendRegexLabel||"",ee.history),Boolean($)&&$.appendChild(te.domNode),te.onkeydown(te.inputBox.inputElement,(function(X){return te._onKeyDown.fire(X)})),te.onkeyup(te.inputBox.inputElement,(function(X){return te._onKeyUp.fire(X)})),te.oninput(te.inputBox.inputElement,(function(X){return te._onInput.fire()})),te.onmousedown(te.inputBox.inputElement,(function(X){return te._onMouseDown.fire(X)})),te}return te(t,X),t.prototype.enable=function(){J.removeClass(this.domNode,"disabled"),this.inputBox.enable(),this.regex.enable(),this.wholeWords.enable(),this.caseSensitive.enable()},t.prototype.disable=function(){J.addClass(this.domNode,"disabled"),this.inputBox.disable(),this.regex.disable(),this.wholeWords.disable(),this.caseSensitive.disable()},t.prototype.setFocusInputOnOptionClick=function(X){this.fixFocusOnOptionClickEnabled=X},t.prototype.setEnabled=function(X){X?this.enable():this.disable()},t.prototype.getValue=function(){return this.inputBox.value},t.prototype.setValue=function(X){this.inputBox.value!==X&&(this.inputBox.value=X)},t.prototype.style=function(X){this.inputActiveOptionBorder=X.inputActiveOptionBorder,this.inputBackground=X.inputBackground,this.inputForeground=X.inputForeground,this.inputBorder=X.inputBorder,this.inputValidationInfoBackground=X.inputValidationInfoBackground,this.inputValidationInfoForeground=X.inputValidationInfoForeground,this.inputValidationInfoBorder=X.inputValidationInfoBorder,this.inputValidationWarningBackground=X.inputValidationWarningBackground,this.inputValidationWarningForeground=X.inputValidationWarningForeground,this.inputValidationWarningBorder=X.inputValidationWarningBorder,this.inputValidationErrorBackground=X.inputValidationErrorBackground,this.inputValidationErrorForeground=X.inputValidationErrorForeground,this.inputValidationErrorBorder=X.inputValidationErrorBorder,this.applyStyles()},t.prototype.applyStyles=function(){if(this.domNode){var X={inputActiveOptionBorder:this.inputActiveOptionBorder};this.regex.style(X),this.wholeWords.style(X),this.caseSensitive.style(X);var $={inputBackground:this.inputBackground,inputForeground:this.inputForeground,inputBorder:this.inputBorder,inputValidationInfoBackground:this.inputValidationInfoBackground,inputValidationInfoForeground:this.inputValidationInfoForeground,inputValidationInfoBorder:this.inputValidationInfoBorder,inputValidationWarningBackground:this.inputValidationWarningBackground,inputValidationWarningForeground:this.inputValidationWarningForeground,inputValidationWarningBorder:this.inputValidationWarningBorder,inputValidationErrorBackground:this.inputValidationErrorBackground,inputValidationErrorForeground:this.inputValidationErrorForeground,inputValidationErrorBorder:this.inputValidationErrorBorder};this.inputBox.style($)}},t.prototype.select=function(){this.inputBox.select()},t.prototype.focus=function(){this.inputBox.focus()},t.prototype.getCaseSensitive=function(){return this.caseSensitive.checked},t.prototype.setCaseSensitive=function(X){this.caseSensitive.checked=X,this.setInputWidth()},t.prototype.getWholeWords=function(){return this.wholeWords.checked},t.prototype.setWholeWords=function(X){this.wholeWords.checked=X,this.setInputWidth()},t.prototype.getRegex=function(){return this.regex.checked},t.prototype.setRegex=function(X){this.regex.checked=X,this.setInputWidth(),this.validate()},t.prototype.focusOnCaseSensitive=function(){this.caseSensitive.focus()},t.prototype.highlightFindOptions=function(){J.removeClass(this.domNode,"highlight-"+this._lastHighlightFindOptions),this._lastHighlightFindOptions=1-this._lastHighlightFindOptions,J.addClass(this.domNode,"highlight-"+this._lastHighlightFindOptions)},t.prototype.setInputWidth=function(){var X=this.width-this.caseSensitive.width()-this.wholeWords.width()-this.regex.width();this.inputBox.width=X},t.prototype.buildDomNode=function(X,$,Q,te){var ne=this;this.domNode=document.createElement("div"),this.domNode.style.width=this.width+"px",J.addClass(this.domNode,"monaco-findInput"),this.inputBox=this._register(new ee.HistoryInputBox(this.domNode,this.contextViewProvider,{placeholder:this.placeholder||"",ariaLabel:this.label||"",validationOptions:{validation:this.validation||null},inputBackground:this.inputBackground,inputForeground:this.inputForeground,inputBorder:this.inputBorder,inputValidationInfoBackground:this.inputValidationInfoBackground,inputValidationInfoForeground:this.inputValidationInfoForeground,inputValidationInfoBorder:this.inputValidationInfoBorder,inputValidationWarningBackground:this.inputValidationWarningBackground,inputValidationWarningForeground:this.inputValidationWarningForeground,inputValidationWarningBorder:this.inputValidationWarningBorder,inputValidationErrorBackground:this.inputValidationErrorBackground,inputValidationErrorForeground:this.inputValidationErrorForeground,inputValidationErrorBorder:this.inputValidationErrorBorder,history:te})),this.regex=this._register(new oe.RegexCheckbox({appendTitle:Q,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder})),this._register(this.regex.onChange((function(X){ne._onDidOptionChange.fire(X),!X&&ne.fixFocusOnOptionClickEnabled&&ne.inputBox.focus(),ne.setInputWidth(),ne.validate()}))),this._register(this.regex.onKeyDown((function(X){ne._onRegexKeyDown.fire(X)}))),this.wholeWords=this._register(new oe.WholeWordsCheckbox({appendTitle:$,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder})),this._register(this.wholeWords.onChange((function(X){ne._onDidOptionChange.fire(X),!X&&ne.fixFocusOnOptionClickEnabled&&ne.inputBox.focus(),ne.setInputWidth(),ne.validate()}))),this.caseSensitive=this._register(new oe.CaseSensitiveCheckbox({appendTitle:X,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder})),this._register(this.caseSensitive.onChange((function(X){ne._onDidOptionChange.fire(X),!X&&ne.fixFocusOnOptionClickEnabled&&ne.inputBox.focus(),ne.setInputWidth(),ne.validate()}))),this._register(this.caseSensitive.onKeyDown((function(X){ne._onCaseSensitiveKeyDown.fire(X)})));var ie=[this.caseSensitive.domNode,this.wholeWords.domNode,this.regex.domNode];this.onkeydown(this.domNode,(function(X){if(X.equals(15)||X.equals(17)||X.equals(9)){var $=ie.indexOf(document.activeElement);if($>=0){var Q=void 0;X.equals(17)?Q=($+1)%ie.length:X.equals(15)&&(Q=0===$?ie.length-1:$-1),X.equals(9)?ie[$].blur():Q>=0&&ie[Q].focus(),J.EventHelper.stop(X,!0)}}})),this.setInputWidth();var re=document.createElement("div");re.className="controls",re.style.display=this._showOptionButtons?"block":"none",re.appendChild(this.caseSensitive.domNode),re.appendChild(this.wholeWords.domNode),re.appendChild(this.regex.domNode),this.domNode.appendChild(re)},t.prototype.validate=function(){this.inputBox.validate()},t.prototype.clearMessage=function(){this.inputBox.hideMessage()},t.prototype.dispose=function(){X.prototype.dispose.call(this)},t}(ne.Widget);$.FindInput=se})),define(Q[276],n([5,4]),(function(X,$){return X.create("vs/base/browser/ui/list/listWidget",$)})),define(Q[277],n([0,1,276,2,32,22,128,7,17,75,52,6,72,231,28,27,419,427,211]),(function(X,$,Q,J,ee,ie,oe,re,se,ae,le,ue,de,ce,he,pe,fe,ge){function C(X){return"INPUT"===X.tagName||"TEXTAREA"===X.tagName}function b(X){return se.isMacintosh?X.browserEvent.metaKey:X.browserEvent.ctrlKey}function S(X){return X.browserEvent.shiftKey}function w(X){return X instanceof MouseEvent&&2===X.button}function E(X,$){for(var Q=[],J=0,ee=0;J<X.length||ee<$.length;)if(J>=X.length)Q.push($[ee++]);else if(ee>=$.length)Q.push(X[J++]);else{if(X[J]===$[ee]){Q.push(X[J]),J++,ee++;continue}X[J]<$[ee]?Q.push(X[J++]):Q.push($[ee++])}return Q}Object.defineProperty($,"__esModule",{value:!0});var me=function(){function e(X){this.trait=X,this.renderedElements=[]}return Object.defineProperty(e.prototype,"templateId",{get:function(){return"template:"+this.trait.trait},enumerable:!0,configurable:!0}),e.prototype.renderTemplate=function(X){return X},e.prototype.renderElement=function(X,$,Q){var J=ie.firstIndex(this.renderedElements,(function(X){return X.templateData===Q}));if(J>=0)ee=this.renderedElements[J],this.trait.unrender(Q),ee.index=$;else{var ee={index:$,templateData:Q};this.renderedElements.push(ee)}this.trait.renderIndex($,Q)},e.prototype.disposeElement=function(){},e.prototype.splice=function(X,$,Q){for(var J=[],ee=0;ee<this.renderedElements.length;ee++){var te=this.renderedElements[ee];te.index<X?J.push(te):te.index>=X+$&&J.push({index:te.index+Q-$,templateData:te.templateData})}this.renderedElements=J},e.prototype.renderIndexes=function(X){for(var $=0,Q=this.renderedElements;$<Q.length;$++){var J=Q[$],ee=J.index,te=J.templateData;X.indexOf(ee)>-1&&this.trait.renderIndex(ee,te)}},e.prototype.disposeTemplate=function(X){var $=ie.firstIndex(this.renderedElements,(function($){return $.templateData===X}));$<0||this.renderedElements.splice($,1)},e}(),ve=function(){function e(X){this._trait=X,this._onChange=new ue.Emitter,this.indexes=[]}return Object.defineProperty(e.prototype,"onChange",{get:function(){return this._onChange.event},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"trait",{get:function(){return this._trait},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"renderer",{get:function(){return new me(this)},enumerable:!0,configurable:!0}),e.prototype.splice=function(X,$,Q){var J=Q.length-$,ee=X+$,te=this.indexes.filter((function($){return $<X})).concat(Q.map((function($,Q){return $?Q+X:-1})).filter((function(X){return-1!==X})),this.indexes.filter((function(X){return X>=ee})).map((function(X){return X+J})));this.renderer.splice(X,$,Q.length),this.set(te)},e.prototype.renderIndex=function(X,$){re.toggleClass($,this._trait,this.contains(X))},e.prototype.unrender=function(X){re.removeClass(X,this._trait)},e.prototype.set=function(X,$){var Q=this.indexes;this.indexes=X;var J=E(Q,X);return this.renderer.renderIndexes(J),this._onChange.fire({indexes:X,browserEvent:$}),Q},e.prototype.get=function(){return this.indexes},e.prototype.contains=function(X){return this.indexes.some((function($){return $===X}))},e.prototype.dispose=function(){this.indexes=null,this._onChange=J.dispose(this._onChange)},ne([oe.memoize],e.prototype,"renderer",null),e}(),_e=function(X){function t($){var Q=X.call(this,"focused")||this;return Q.getDomId=$,Q}return te(t,X),t.prototype.renderIndex=function($,Q){X.prototype.renderIndex.call(this,$,Q),Q.setAttribute("role","treeitem"),Q.setAttribute("id",this.getDomId($)),this.contains($)?Q.setAttribute("aria-selected","true"):Q.removeAttribute("aria-selected")},t}(ve),ye=function(){function e(X,$,Q){this.trait=X,this.view=$,this.getId=Q}return e.prototype.splice=function(X,$,Q){var J=this;if(!this.getId)return this.trait.splice(X,$,Q.map((function(X){return!1})));var ee=this.trait.get().map((function(X){return J.getId(J.view.element(X))})),te=Q.map((function(X){return ee.indexOf(J.getId(X))>-1}));this.trait.splice(X,$,te)},e}(),be=function(){function e(X,$,Q){this.list=X,this.view=$;var J=!(!1===Q.multipleSelectionSupport);this.disposables=[],this.openController=Q.openController||Se;var ee=ue.chain(de.domEvent($.domNode,"keydown")).filter((function(X){return!C(X.target)})).map((function(X){return new le.StandardKeyboardEvent(X)}));ee.filter((function(X){return 3===X.keyCode})).on(this.onEnter,this,this.disposables),ee.filter((function(X){return 16===X.keyCode})).on(this.onUpArrow,this,this.disposables),ee.filter((function(X){return 18===X.keyCode})).on(this.onDownArrow,this,this.disposables),ee.filter((function(X){return 11===X.keyCode})).on(this.onPageUpArrow,this,this.disposables),ee.filter((function(X){return 12===X.keyCode})).on(this.onPageDownArrow,this,this.disposables),ee.filter((function(X){return 9===X.keyCode})).on(this.onEscape,this,this.disposables),J&&ee.filter((function(X){return(se.isMacintosh?X.metaKey:X.ctrlKey)&&31===X.keyCode})).on(this.onCtrlA,this,this.disposables)}return e.prototype.onEnter=function(X){X.preventDefault(),X.stopPropagation(),this.list.setSelection(this.list.getFocus(),X.browserEvent),this.openController.shouldOpen(X.browserEvent)&&this.list.open(this.list.getFocus(),X.browserEvent)},e.prototype.onUpArrow=function(X){X.preventDefault(),X.stopPropagation(),this.list.focusPrevious(1,!1,X.browserEvent),this.list.reveal(this.list.getFocus()[0]),this.view.domNode.focus()},e.prototype.onDownArrow=function(X){X.preventDefault(),X.stopPropagation(),this.list.focusNext(1,!1,X.browserEvent),this.list.reveal(this.list.getFocus()[0]),this.view.domNode.focus()},e.prototype.onPageUpArrow=function(X){X.preventDefault(),X.stopPropagation(),this.list.focusPreviousPage(X.browserEvent),this.list.reveal(this.list.getFocus()[0]),this.view.domNode.focus()},e.prototype.onPageDownArrow=function(X){X.preventDefault(),X.stopPropagation(),this.list.focusNextPage(X.browserEvent),this.list.reveal(this.list.getFocus()[0]),this.view.domNode.focus()},e.prototype.onCtrlA=function(X){X.preventDefault(),X.stopPropagation(),this.list.setSelection(ie.range(this.list.length),X.browserEvent),this.view.domNode.focus()},e.prototype.onEscape=function(X){X.preventDefault(),X.stopPropagation(),this.list.setSelection([],X.browserEvent),this.view.domNode.focus()},e.prototype.dispose=function(){this.disposables=J.dispose(this.disposables)},e}(),Ce=function(){function e(X,$){this.list=X,this.view=$,this.disposables=[],this.disposables=[],ue.chain(de.domEvent($.domNode,"keydown")).filter((function(X){return!C(X.target)})).map((function(X){return new le.StandardKeyboardEvent(X)})).filter((function(X){return!(2!==X.keyCode||X.ctrlKey||X.metaKey||X.shiftKey||X.altKey)})).on(this.onTab,this,this.disposables)}return e.prototype.onTab=function(X){if(X.target===this.view.domNode){var $=this.list.getFocus();if(0!==$.length){var Q=this.view.domElement($[0]).querySelector("[tabIndex]");if(Q&&Q instanceof HTMLElement&&-1!==Q.tabIndex){var J=window.getComputedStyle(Q);"hidden"!==J.visibility&&"none"!==J.display&&(X.preventDefault(),X.stopPropagation(),Q.focus())}}}},e.prototype.dispose=function(){this.disposables=J.dispose(this.disposables)},e}();$.isSelectionSingleChangeEvent=b,$.isSelectionRangeChangeEvent=S;var we={isSelectionSingleChangeEvent:b,isSelectionRangeChangeEvent:S},Se={shouldOpen:function(X){return!(X instanceof MouseEvent&&w(X))}},Ee=function(){function e(X,$,Q){void 0===Q&&(Q={}),this.list=X,this.view=$,this.options=Q,this.didJustPressContextMenuKey=!1,this.disposables=[],this.multipleSelectionSupport=!(!1===Q.multipleSelectionSupport),this.multipleSelectionSupport&&(this.multipleSelectionController=Q.multipleSelectionController||we),this.openController=Q.openController||Se,$.onMouseDown(this.onMouseDown,this,this.disposables),$.onMouseClick(this.onPointer,this,this.disposables),$.onMouseDblClick(this.onDoubleClick,this,this.disposables),$.onTouchStart(this.onMouseDown,this,this.disposables),$.onTap(this.onPointer,this,this.disposables),ae.Gesture.addTarget($.domNode)}return Object.defineProperty(e.prototype,"onContextMenu",{get:function(){var X=this,$=ue.chain(de.domEvent(this.view.domNode,"keydown")).map((function(X){return new le.StandardKeyboardEvent(X)})).filter((function($){return X.didJustPressContextMenuKey=58===$.keyCode||$.shiftKey&&68===$.keyCode})).filter((function(X){return X.preventDefault(),X.stopPropagation(),!1})).map((function($){var Q=X.list.getFocus()[0];return{index:Q,element:X.view.element(Q),anchor:X.view.domElement(Q),browserEvent:$.browserEvent}})).event,Q=ue.chain(de.domEvent(this.view.domNode,"keyup")).filter((function(){var $=X.didJustPressContextMenuKey;return X.didJustPressContextMenuKey=!1,$})).filter((function(){return X.list.getFocus().length>0})).map((function($){var Q=X.list.getFocus()[0];return{index:Q,element:X.view.element(Q),anchor:X.view.domElement(Q),browserEvent:$}})).filter((function(X){return!!X.anchor})).event,J=ue.chain(this.view.onContextMenu).filter((function(){return!X.didJustPressContextMenuKey})).map((function(X){var $=X.element,Q=X.index,J=X.browserEvent;return{element:$,index:Q,anchor:{x:J.clientX+1,y:J.clientY},browserEvent:J}})).event;return ue.anyEvent($,Q,J)},enumerable:!0,configurable:!0}),e.prototype.isSelectionSingleChangeEvent=function(X){return this.multipleSelectionController?this.multipleSelectionController.isSelectionSingleChangeEvent(X):se.isMacintosh?X.browserEvent.metaKey:X.browserEvent.ctrlKey},e.prototype.isSelectionRangeChangeEvent=function(X){return this.multipleSelectionController?this.multipleSelectionController.isSelectionRangeChangeEvent(X):X.browserEvent.shiftKey},e.prototype.isSelectionChangeEvent=function(X){return this.isSelectionSingleChangeEvent(X)||this.isSelectionRangeChangeEvent(X)},e.prototype.onMouseDown=function(X){!1===this.options.focusOnMouseDown?(X.browserEvent.preventDefault(),X.browserEvent.stopPropagation()):document.activeElement!==X.browserEvent.target&&this.view.domNode.focus();var $=this.list.getFocus()[0],Q=this.list.getSelection();if($=void 0===$?Q[0]:$,this.multipleSelectionSupport&&this.isSelectionRangeChangeEvent(X))return this.changeSelection(X,$);var J=X.index;if(Q.every((function(X){return X!==J}))&&this.list.setFocus([J],X.browserEvent),this.multipleSelectionSupport&&this.isSelectionChangeEvent(X))return this.changeSelection(X,$);this.options.selectOnMouseDown&&!w(X.browserEvent)&&(this.list.setSelection([J],X.browserEvent),this.openController.shouldOpen(X.browserEvent)&&this.list.open([J],X.browserEvent))},e.prototype.onPointer=function(X){if(!(this.multipleSelectionSupport&&this.isSelectionChangeEvent(X)||this.options.selectOnMouseDown)){var $=this.list.getFocus();this.list.setSelection($,X.browserEvent),this.openController.shouldOpen(X.browserEvent)&&this.list.open($,X.browserEvent)}},e.prototype.onDoubleClick=function(X){if(!this.multipleSelectionSupport||!this.isSelectionChangeEvent(X)){var $=this.list.getFocus();this.list.setSelection($,X.browserEvent),this.list.pin($)}},e.prototype.changeSelection=function(X,$){var Q=X.index;if(this.isSelectionRangeChangeEvent(X)&&void 0!==$){var J=Math.min($,Q),ee=Math.max($,Q),te=ie.range(J,ee+1),ne=function(X,$){var Q=X.indexOf($);if(-1===Q)return[];for(var J=[],ee=Q-1;ee>=0&&X[ee]===$-(Q-ee);)J.push(X[ee--]);for(J.reverse(),ee=Q;ee<X.length&&X[ee]===$+(ee-Q);)J.push(X[ee++]);return J}(E(oe=this.list.getSelection(),[$]),$);if(0===ne.length)return;re=E(te,function(X,$){for(var Q=[],J=0,ee=0;J<X.length||ee<$.length;)if(J>=X.length)Q.push($[ee++]);else if(ee>=$.length)Q.push(X[J++]);else{if(X[J]===$[ee]){J++,ee++;continue}X[J]<$[ee]?Q.push(X[J++]):ee++}return Q}(oe,ne)),this.list.setSelection(re,X.browserEvent)}else if(this.isSelectionSingleChangeEvent(X)){var oe=this.list.getSelection(),re=oe.filter((function(X){return X!==Q}));oe.length===re.length?this.list.setSelection(re.concat([Q]),X.browserEvent):this.list.setSelection(re,X.browserEvent)}},e.prototype.dispose=function(){this.disposables=J.dispose(this.disposables)},ne([oe.memoize],e.prototype,"onContextMenu",null),e}(),Le=function(){function e(X,$){this.styleElement=X,this.selectorSuffix=$}return e.prototype.style=function(X){var $=this.selectorSuffix?"."+this.selectorSuffix:"",Q=[];X.listFocusBackground&&(Q.push(".monaco-list"+$+":focus .monaco-list-row.focused { background-color: "+X.listFocusBackground+"; }"),Q.push(".monaco-list"+$+":focus .monaco-list-row.focused:hover { background-color: "+X.listFocusBackground+"; }")),X.listFocusForeground&&Q.push(".monaco-list"+$+":focus .monaco-list-row.focused { color: "+X.listFocusForeground+"; }"),X.listActiveSelectionBackground&&(Q.push(".monaco-list"+$+":focus .monaco-list-row.selected { background-color: "+X.listActiveSelectionBackground+"; }"),Q.push(".monaco-list"+$+":focus .monaco-list-row.selected:hover { background-color: "+X.listActiveSelectionBackground+"; }")),X.listActiveSelectionForeground&&Q.push(".monaco-list"+$+":focus .monaco-list-row.selected { color: "+X.listActiveSelectionForeground+"; }"),X.listFocusAndSelectionBackground&&Q.push(".monaco-list"+$+":focus .monaco-list-row.selected.focused { background-color: "+X.listFocusAndSelectionBackground+"; }"),X.listFocusAndSelectionForeground&&Q.push(".monaco-list"+$+":focus .monaco-list-row.selected.focused { color: "+X.listFocusAndSelectionForeground+"; }"),X.listInactiveFocusBackground&&(Q.push(".monaco-list"+$+" .monaco-list-row.focused { background-color:  "+X.listInactiveFocusBackground+"; }"),Q.push(".monaco-list"+$+" .monaco-list-row.focused:hover { background-color:  "+X.listInactiveFocusBackground+"; }")),X.listInactiveSelectionBackground&&(Q.push(".monaco-list"+$+" .monaco-list-row.selected { background-color:  "+X.listInactiveSelectionBackground+"; }"),Q.push(".monaco-list"+$+" .monaco-list-row.selected:hover { background-color:  "+X.listInactiveSelectionBackground+"; }")),X.listInactiveSelectionForeground&&Q.push(".monaco-list"+$+" .monaco-list-row.selected { color: "+X.listInactiveSelectionForeground+"; }"),X.listHoverBackground&&Q.push(".monaco-list"+$+" .monaco-list-row:hover { background-color:  "+X.listHoverBackground+"; }"),X.listHoverForeground&&Q.push(".monaco-list"+$+" .monaco-list-row:hover { color:  "+X.listHoverForeground+"; }"),X.listSelectionOutline&&Q.push(".monaco-list"+$+" .monaco-list-row.selected { outline: 1px dotted "+X.listSelectionOutline+"; outline-offset: -1px; }"),X.listFocusOutline&&Q.push(".monaco-list"+$+":focus .monaco-list-row.focused { outline: 1px solid "+X.listFocusOutline+"; outline-offset: -1px; }"),X.listInactiveFocusOutline&&Q.push(".monaco-list"+$+" .monaco-list-row.focused { outline: 1px dotted "+X.listInactiveFocusOutline+"; outline-offset: -1px; }"),X.listHoverOutline&&Q.push(".monaco-list"+$+" .monaco-list-row:hover { outline: 1px dashed "+X.listHoverOutline+"; outline-offset: -1px; }");var J=Q.join("\n");J!==this.styleElement.innerHTML&&(this.styleElement.innerHTML=J)},e}();$.DefaultStyleController=Le;var xe={listFocusBackground:he.Color.fromHex("#073655"),listActiveSelectionBackground:he.Color.fromHex("#0E639C"),listActiveSelectionForeground:he.Color.fromHex("#FFFFFF"),listFocusAndSelectionBackground:he.Color.fromHex("#094771"),listFocusAndSelectionForeground:he.Color.fromHex("#FFFFFF"),listInactiveSelectionBackground:he.Color.fromHex("#3F3F46"),listHoverBackground:he.Color.fromHex("#2A2D2E"),listDropBackground:he.Color.fromHex("#383B3D")},Ie={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0},F=function(X,$){return X-$},De=function(){function e(X,$){this._templateId=X,this.renderers=$}return Object.defineProperty(e.prototype,"templateId",{get:function(){return this._templateId},enumerable:!0,configurable:!0}),e.prototype.renderTemplate=function(X){return this.renderers.map((function($){return $.renderTemplate(X)}))},e.prototype.renderElement=function(X,$,Q){for(var J=0,ee=0,te=this.renderers;ee<te.length;ee++)te[ee].renderElement(X,$,Q[J++])},e.prototype.disposeElement=function(X,$,Q){for(var J=0,ee=0,te=this.renderers;ee<te.length;ee++)te[ee].disposeElement(X,$,Q[J++])},e.prototype.disposeTemplate=function(X){for(var $=0,Q=0,J=this.renderers;Q<J.length;Q++)J[Q].disposeTemplate(X[$++])},e}(),Ne=function(){function e(X){this.accessibilityProvider=X,this.templateId="a18n"}return e.prototype.renderTemplate=function(X){return X},e.prototype.renderElement=function(X,$,Q){var J=this.accessibilityProvider.getAriaLabel(X);J?Q.setAttribute("aria-label",J):Q.removeAttribute("aria-label")},e.prototype.disposeElement=function(X,$,Q){},e.prototype.disposeTemplate=function(X){},e}(),Me=function(){function e(X,$,J,ee){void 0===ee&&(ee=Ie);var te=this;this.idPrefix="list_id_"+ ++e.InstanceCount,this.eventBufferer=new ue.EventBufferer,this.onContextMenu=ue.Event.None,this._onOpen=new ue.Emitter,this._onPin=new ue.Emitter,this._onDidDispose=new ue.Emitter,this.focus=new _e((function(X){return te.getElementDomId(X)})),this.selection=new ve("selected"),pe.mixin(ee,xe,!1);var ne=[this.focus.renderer,this.selection.renderer];if(ee.accessibilityProvider&&ne.push(new Ne(ee.accessibilityProvider)),J=J.map((function(X){return new De(X.templateId,ne.concat([X]))})),this.view=new ce.ListView(X,$,J,ee),this.view.domNode.setAttribute("role","tree"),re.addClass(this.view.domNode,this.idPrefix),this.view.domNode.tabIndex=0,this.styleElement=re.createStyleSheet(this.view.domNode),this.styleController=ee.styleController,this.styleController||(this.styleController=new Le(this.styleElement,this.idPrefix)),this.spliceable=new fe.CombinedSpliceable([new ye(this.focus,this.view,ee.identityProvider),new ye(this.selection,this.view,ee.identityProvider),this.view]),this.disposables=[this.focus,this.selection,this.view,this._onDidDispose],this.onDidFocus=ue.mapEvent(de.domEvent(this.view.domNode,"focus",!0),(function(){return null})),this.onDidBlur=ue.mapEvent(de.domEvent(this.view.domNode,"blur",!0),(function(){return null})),this.disposables.push(new Ce(this,this.view)),"boolean"!=typeof ee.keyboardSupport||ee.keyboardSupport){var ie=new be(this,this.view,ee);this.disposables.push(ie)}("boolean"!=typeof ee.mouseSupport||ee.mouseSupport)&&(this.mouseController=new Ee(this,this.view,ee),this.disposables.push(this.mouseController),this.onContextMenu=this.mouseController.onContextMenu),this.onFocusChange(this._onFocusChange,this,this.disposables),this.onSelectionChange(this._onSelectionChange,this,this.disposables),ee.ariaLabel&&this.view.domNode.setAttribute("aria-label",Q.localize(0,null,ee.ariaLabel)),this.style(ee)}return Object.defineProperty(e.prototype,"onFocusChange",{get:function(){var X=this;return ue.mapEvent(this.eventBufferer.wrapEvent(this.focus.onChange),(function($){return X.toListEvent($)}))},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onSelectionChange",{get:function(){var X=this;return ue.mapEvent(this.eventBufferer.wrapEvent(this.selection.onChange),(function($){return X.toListEvent($)}))},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onMouseClick",{get:function(){return this.view.onMouseClick},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onKeyDown",{get:function(){return de.domEvent(this.view.domNode,"keydown")},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onDidDispose",{get:function(){return this._onDidDispose.event},enumerable:!0,configurable:!0}),e.prototype.splice=function(X,$,Q){var J=this;if(void 0===Q&&(Q=[]),X<0||X>this.view.length)throw new Error("Invalid start index: "+X);if($<0)throw new Error("Invalid delete count: "+$);0===$&&0===Q.length||this.eventBufferer.bufferEvents((function(){return J.spliceable.splice(X,$,Q)}))},Object.defineProperty(e.prototype,"length",{get:function(){return this.view.length},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"contentHeight",{get:function(){return this.view.getContentHeight()},enumerable:!0,configurable:!0}),e.prototype.layout=function(X){this.view.layout(X)},e.prototype.setSelection=function(X,$){for(var Q=0,J=X;Q<J.length;Q++){var ee=J[Q];if(ee<0||ee>=this.length)throw new Error("Invalid index "+ee)}X=X.sort(F),this.selection.set(X,$)},e.prototype.getSelection=function(){return this.selection.get()},e.prototype.setFocus=function(X,$){for(var Q=0,J=X;Q<J.length;Q++){var ee=J[Q];if(ee<0||ee>=this.length)throw new Error("Invalid index "+ee)}X=X.sort(F),this.focus.set(X,$)},e.prototype.focusNext=function(X,$,Q){if(void 0===X&&(X=1),void 0===$&&($=!1),0!==this.length){var J=this.focus.get(),ee=J.length>0?J[0]+X:0;this.setFocus($?[ee%this.length]:[Math.min(ee,this.length-1)],Q)}},e.prototype.focusPrevious=function(X,$,Q){if(void 0===X&&(X=1),void 0===$&&($=!1),0!==this.length){var J=this.focus.get(),ee=J.length>0?J[0]-X:0;$&&ee<0&&(ee=(this.length+ee%this.length)%this.length),this.setFocus([Math.max(ee,0)],Q)}},e.prototype.focusNextPage=function(X){var $=this,Q=this.view.indexAt(this.view.getScrollTop()+this.view.renderHeight);Q=0===Q?0:Q-1;var J=this.view.element(Q);if(this.getFocusedElements()[0]!==J)this.setFocus([Q],X);else{var ee=this.view.getScrollTop();this.view.setScrollTop(ee+this.view.renderHeight-this.view.elementHeight(Q)),this.view.getScrollTop()!==ee&&setTimeout((function(){return $.focusNextPage(X)}),0)}},e.prototype.focusPreviousPage=function(X){var $,Q=this,J=this.view.getScrollTop();$=0===J?this.view.indexAt(J):this.view.indexAfter(J-1);var ee=this.view.element($);if(this.getFocusedElements()[0]!==ee)this.setFocus([$],X);else{var te=J;this.view.setScrollTop(J-this.view.renderHeight),this.view.getScrollTop()!==te&&setTimeout((function(){return Q.focusPreviousPage(X)}),0)}},e.prototype.focusLast=function(X){0!==this.length&&this.setFocus([this.length-1],X)},e.prototype.focusFirst=function(X){0!==this.length&&this.setFocus([0],X)},e.prototype.getFocus=function(){return this.focus.get()},e.prototype.getFocusedElements=function(){var X=this;return this.getFocus().map((function($){return X.view.element($)}))},e.prototype.reveal=function(X,$){if(X<0||X>=this.length)throw new Error("Invalid index "+X);var Q=this.view.getScrollTop(),J=this.view.elementTop(X),te=this.view.elementHeight(X);if(ee.isNumber($)){var ne=te-this.view.renderHeight;this.view.setScrollTop(ne*ge.clamp($,0,1)+J)}else{var ie=J+te,oe=Q+this.view.renderHeight;J<Q?this.view.setScrollTop(J):ie>=oe&&this.view.setScrollTop(ie-this.view.renderHeight)}},e.prototype.getElementDomId=function(X){return this.idPrefix+"_"+X},e.prototype.getHTMLElement=function(){return this.view.domNode},e.prototype.open=function(X,$){for(var Q=this,J=0,ee=X;J<ee.length;J++){var te=ee[J];if(te<0||te>=this.length)throw new Error("Invalid index "+te)}this._onOpen.fire({indexes:X,elements:X.map((function(X){return Q.view.element(X)})),browserEvent:$})},e.prototype.pin=function(X){for(var $=0,Q=X;$<Q.length;$++){var J=Q[$];if(J<0||J>=this.length)throw new Error("Invalid index "+J)}this._onPin.fire(X)},e.prototype.style=function(X){this.styleController.style(X)},e.prototype.toListEvent=function(X){var $=this,Q=X.indexes,J=X.browserEvent;return{indexes:Q,elements:Q.map((function(X){return $.view.element(X)})),browserEvent:J}},e.prototype._onFocusChange=function(){var X=this.focus.get();X.length>0?this.view.domNode.setAttribute("aria-activedescendant",this.getElementDomId(X[0])):this.view.domNode.removeAttribute("aria-activedescendant"),this.view.domNode.setAttribute("role","tree"),re.toggleClass(this.view.domNode,"element-focused",X.length>0)},e.prototype._onSelectionChange=function(){var X=this.selection.get();re.toggleClass(this.view.domNode,"selection-none",0===X.length),re.toggleClass(this.view.domNode,"selection-single",1===X.length),re.toggleClass(this.view.domNode,"selection-multiple",X.length>1)},e.prototype.dispose=function(){this._onDidDispose.fire(),this.disposables=J.dispose(this.disposables),this._onOpen.dispose(),this._onPin.dispose(),this._onDidDispose.dispose()},e.InstanceCount=0,ne([oe.memoize],e.prototype,"onFocusChange",null),ne([oe.memoize],e.prototype,"onSelectionChange",null),e}();$.List=Me})),define(Q[278],n([5,4]),(function(X,$){return X.create("vs/base/browser/ui/menu/menu",$)})),define(Q[279],n([0,1,278,8,56,67,36,7,52,16,2,212]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae){function h(X){var Q=$.MENU_MNEMONIC_REGEX,J=Q.exec(X);if(!J)return X;var ee="&"===J[0].charAt(0);return X.replace(Q,ee?"$2":"").trim()}Object.defineProperty($,"__esModule",{value:!0}),$.MENU_MNEMONIC_REGEX=/\(&{1,2}(.)\)|&{1,2}(.)/,$.MENU_ESCAPED_MNEMONIC_REGEX=/(?:&amp;){1,2}(.)/;var le=function(X){function t($,Q,J){var ee=X.call(this,J||"submenu",$,"",!0)||this;return ee.entries=Q,ee}return te(t,X),t}(ee.Action);$.SubmenuAction=le;var ue=function(X){function t($,Q,J){void 0===J&&(J={});var ee=this;oe.addClass($,"monaco-menu-container"),$.setAttribute("role","presentation");var te=document.createElement("div");oe.addClass(te,"monaco-menu"),te.setAttribute("role","presentation"),$.appendChild(te),(ee=X.call(this,te,{orientation:2,actionItemProvider:function(X){return ee.doGetActionItem(X,J,ne)},context:J.context,actionRunner:J.actionRunner,ariaLabel:J.ariaLabel,triggerKeys:{keys:[3],keyDown:!0}})||this).actionsList.setAttribute("role","menu"),ee.actionsList.tabIndex=0,ee.menuDisposables=[],J.enableMnemonics&&ee.menuDisposables.push(oe.addDisposableListener(te,oe.EventType.KEY_DOWN,(function(X){var $=ie.KeyCodeUtils.fromString(X.key);if(ee.mnemonics.has($)){oe.EventHelper.stop(X,!0);var Q=ee.mnemonics.get($);if(1===Q.length&&(Q[0]instanceof ce&&ee.focusItemByElement(Q[0].container),Q[0].onClick(event)),Q.length>1){var J=Q.shift();ee.focusItemByElement(J.container),Q.push(J),ee.mnemonics.set($,Q)}}}))),ee._register(oe.addDisposableListener(ee.domNode,oe.EventType.MOUSE_OUT,(function(X){var $=X.relatedTarget;oe.isAncestor($,ee.domNode)||(ee.focusedItem=void 0,ee.updateFocus(),X.stopPropagation())}))),ee._register(oe.addDisposableListener(ee.actionsList,oe.EventType.MOUSE_OVER,(function(X){var $=X.target;if($&&oe.isAncestor($,ee.actionsList)&&$!==ee.actionsList){for(;$.parentElement!==ee.actionsList;)$=$.parentElement;if(oe.hasClass($,"action-item")){var Q=ee.focusedItem;ee.setFocusedItem($),Q!==ee.focusedItem&&ee.updateFocus()}}})));var ne={parent:ee};return ee.mnemonics=new Map,ee.push(Q,{icon:!0,label:!0,isMenu:!0}),ee}return te(t,X),t.prototype.style=function(X){var $=this.getContainer(),Q=X.foregroundColor?""+X.foregroundColor:null,J=X.backgroundColor?""+X.backgroundColor:null,ee=X.borderColor?"2px solid "+X.borderColor:null,te=X.shadowColor?"0 2px 4px "+X.shadowColor:null;$.style.border=ee,this.domNode.style.color=Q,this.domNode.style.backgroundColor=J,$.style.boxShadow=te,this.items&&this.items.forEach((function($){($ instanceof de||$ instanceof he)&&$.style(X)}))},t.prototype.focusItemByElement=function(X){var $=this.focusedItem;this.setFocusedItem(X),$!==this.focusedItem&&this.updateFocus()},t.prototype.setFocusedItem=function(X){for(var $=0;$<this.actionsList.children.length;$++)if(X===this.actionsList.children[$]){this.focusedItem=$;break}},t.prototype.doGetActionItem=function(X,$,Q){if(X instanceof ne.Separator)return new he($.context,X,{icon:!0});if(X instanceof le)return te=new ce(X,X.entries,Q,$),$.enableMnemonics&&(ie=te.getMnemonic())&&te.isEnabled()&&(oe=[],this.mnemonics.has(ie)&&(oe=this.mnemonics.get(ie)),oe.push(te),this.mnemonics.set(ie,oe)),te;var J={enableMnemonics:$.enableMnemonics};if($.getKeyBinding){var ee=$.getKeyBinding(X);ee&&(J.keybinding=ee.getLabel())}var te=new de($.context,X,J);if($.enableMnemonics){var ie=te.getMnemonic();if(ie&&te.isEnabled()){var oe=[];this.mnemonics.has(ie)&&(oe=this.mnemonics.get(ie)),oe.push(te),this.mnemonics.set(ie,oe)}}return te},t.prototype.focus=function($){void 0===$&&($=!0),X.prototype.focus.call(this,$)},t}(ne.ActionBar);$.Menu=ue;var de=function(X){function r(Q,J,ee){void 0===ee&&(ee={});var te=this;if(ee.isMenu=!0,(te=X.call(this,J,J,ee)||this).options=ee,te.options.icon=void 0!==ee.icon&&ee.icon,te.options.label=void 0===ee.label||ee.label,te.cssClass="",te.options.label&&ee.enableMnemonics){var ne=te.getAction().label;if(ne){var oe=$.MENU_MNEMONIC_REGEX.exec(ne);oe&&(te.mnemonic=ie.KeyCodeUtils.fromString((oe[1]?oe[1]:oe[2]).toLocaleLowerCase()))}}return te}return te(r,X),r.prototype.render=function($){var Q=this;X.prototype.render.call(this,$),this.container=$,this.item=oe.append(this.element,oe.$("a.action-menu-item")),this._action.id===ne.Separator.ID?this.item.setAttribute("role","presentation"):(this.item.setAttribute("role","menuitem"),this.mnemonic&&this.item.setAttribute("aria-keyshortcuts",""+this.mnemonic)),this.check=oe.append(this.item,oe.$("span.menu-item-check")),this.check.setAttribute("role","none"),this.label=oe.append(this.item,oe.$("span.action-label")),this.options.label&&this.options.keybinding&&(oe.append(this.item,oe.$("span.keybinding")).textContent=this.options.keybinding),this._register(oe.addDisposableListener(this.element,oe.EventType.MOUSE_UP,(function(X){oe.EventHelper.stop(X,!0),Q.onClick(X)}))),this.updateClass(),this.updateLabel(),this.updateTooltip(),this.updateEnabled(),this.updateChecked()},r.prototype.blur=function(){X.prototype.blur.call(this),this.applyStyle()},r.prototype.focus=function(){X.prototype.focus.call(this),this.item.focus(),this.applyStyle()},r.prototype.updateLabel=function(){if(this.options.label){var X=this.getAction().label;if(X){var Q=h(X);this.options.enableMnemonics||(X=Q),this.label.setAttribute("aria-label",Q);var ee=$.MENU_MNEMONIC_REGEX.exec(X);ee&&(X=J.escape(X).replace($.MENU_ESCAPED_MNEMONIC_REGEX,'<u aria-hidden="true">$1</u>'),this.item.setAttribute("aria-keyshortcuts",(ee[1]?ee[1]:ee[2]).toLocaleLowerCase()))}this.label.innerHTML=X.trim()}},r.prototype.updateTooltip=function(){var X=null;this.getAction().tooltip?X=this.getAction().tooltip:!this.options.label&&this.getAction().label&&this.options.icon&&(X=this.getAction().label,this.options.keybinding&&(X=Q.localize(0,null,X,this.options.keybinding))),X&&(this.item.title=X)},r.prototype.updateClass=function(){this.cssClass&&oe.removeClasses(this.item,this.cssClass),this.options.icon?(this.cssClass=this.getAction().class,oe.addClass(this.label,"icon"),this.cssClass&&oe.addClasses(this.label,this.cssClass),this.updateEnabled()):oe.removeClass(this.label,"icon")},r.prototype.updateEnabled=function(){this.getAction().enabled?(oe.removeClass(this.element,"disabled"),oe.removeClass(this.item,"disabled"),this.item.tabIndex=0):(oe.addClass(this.element,"disabled"),oe.addClass(this.item,"disabled"),oe.removeTabIndexAndUpdateFocus(this.item))},r.prototype.updateChecked=function(){this.getAction().checked?(oe.addClass(this.item,"checked"),this.item.setAttribute("role","menuitemcheckbox"),this.item.setAttribute("aria-checked","true")):(oe.removeClass(this.item,"checked"),this.item.setAttribute("role","menuitem"),this.item.setAttribute("aria-checked","false"))},r.prototype.getMnemonic=function(){return this.mnemonic},r.prototype.applyStyle=function(){var X=oe.hasClass(this.element,"focused"),$=X&&this.menuStyle.selectionForegroundColor?this.menuStyle.selectionForegroundColor:this.menuStyle.foregroundColor,Q=X&&this.menuStyle.selectionBackgroundColor?this.menuStyle.selectionBackgroundColor:this.menuStyle.backgroundColor,J=X&&this.menuStyle.selectionBorderColor?"1px solid "+this.menuStyle.selectionBorderColor:null;this.item.style.color=$?""+$:null,this.check.style.backgroundColor=$?""+$:null,this.item.style.backgroundColor=Q?""+Q:null,this.container.style.border=J},r.prototype.style=function(X){this.menuStyle=X,this.applyStyle()},r}(ne.BaseActionItem),ce=function(X){function t($,Q,J,ee){var te=X.call(this,$,$,ee)||this;return te.submenuActions=Q,te.parentData=J,te.submenuOptions=ee,te.submenuDisposables=[],te.showScheduler=new se.RunOnceScheduler((function(){te.mouseOver&&(te.cleanupExistingSubmenu(!1),te.createSubmenu(!1))}),250),te.hideScheduler=new se.RunOnceScheduler((function(){oe.isAncestor(document.activeElement,te.element)||te.parentData.submenu!==te.mysubmenu||(te.parentData.parent.focus(!1),te.cleanupExistingSubmenu(!0))}),750),te}return te(t,X),t.prototype.render=function($){var Q=this;X.prototype.render.call(this,$),oe.addClass(this.item,"monaco-submenu-item"),this.item.setAttribute("aria-haspopup","true"),this.submenuIndicator=oe.append(this.item,oe.$("span.submenu-indicator")),this.submenuIndicator.setAttribute("aria-hidden","true"),this._register(oe.addDisposableListener(this.element,oe.EventType.KEY_UP,(function(X){var $=new re.StandardKeyboardEvent(X);($.equals(17)||$.equals(3))&&(oe.EventHelper.stop(X,!0),Q.createSubmenu(!0))}))),this._register(oe.addDisposableListener(this.element,oe.EventType.KEY_DOWN,(function(X){var $=new re.StandardKeyboardEvent(X);($.equals(17)||$.equals(3))&&oe.EventHelper.stop(X,!0)}))),this._register(oe.addDisposableListener(this.element,oe.EventType.MOUSE_OVER,(function(X){Q.mouseOver||(Q.mouseOver=!0,Q.showScheduler.schedule())}))),this._register(oe.addDisposableListener(this.element,oe.EventType.MOUSE_LEAVE,(function(X){Q.mouseOver=!1}))),this._register(oe.addDisposableListener(this.element,oe.EventType.FOCUS_OUT,(function(X){oe.isAncestor(document.activeElement,Q.element)||Q.hideScheduler.schedule()})))},t.prototype.onClick=function(X){oe.EventHelper.stop(X,!0),this.cleanupExistingSubmenu(!1),this.createSubmenu(!1)},t.prototype.cleanupExistingSubmenu=function(X){this.parentData.submenu&&(X||this.parentData.submenu!==this.mysubmenu)&&(this.parentData.submenu.dispose(),this.parentData.submenu=null,this.submenuContainer&&(this.submenuDisposables=ae.dispose(this.submenuDisposables),this.submenuContainer=null))},t.prototype.createSubmenu=function(X){var $=this;void 0===X&&(X=!0),this.parentData.submenu?this.parentData.submenu.focus(!1):(this.submenuContainer=oe.append(this.element,oe.$("div.monaco-submenu")),oe.addClasses(this.submenuContainer,"menubar-menu-items-holder","context-view"),this.submenuContainer.style.left=oe.getClientArea(this.element).width+"px",this.submenuDisposables.push(oe.addDisposableListener(this.submenuContainer,oe.EventType.KEY_UP,(function(X){new re.StandardKeyboardEvent(X).equals(15)&&(oe.EventHelper.stop(X,!0),$.parentData.parent.focus(),$.parentData.submenu.dispose(),$.parentData.submenu=null,$.submenuDisposables=ae.dispose($.submenuDisposables),$.submenuContainer=null)}))),this.submenuDisposables.push(oe.addDisposableListener(this.submenuContainer,oe.EventType.KEY_DOWN,(function(X){new re.StandardKeyboardEvent(X).equals(15)&&oe.EventHelper.stop(X,!0)}))),this.parentData.submenu=new ue(this.submenuContainer,this.submenuActions,this.submenuOptions),this.menuStyle&&this.parentData.submenu.style(this.menuStyle),this.submenuDisposables.push(this.parentData.submenu.onDidCancel((function(){$.parentData.parent.focus(),$.parentData.submenu.dispose(),$.parentData.submenu=null,$.submenuDisposables=ae.dispose($.submenuDisposables),$.submenuContainer=null}))),this.parentData.submenu.focus(X),this.mysubmenu=this.parentData.submenu)},t.prototype.applyStyle=function(){X.prototype.applyStyle.call(this);var $=oe.hasClass(this.element,"focused")&&this.menuStyle.selectionForegroundColor?this.menuStyle.selectionForegroundColor:this.menuStyle.foregroundColor;this.submenuIndicator.style.backgroundColor=$?""+$:null,this.parentData.submenu&&this.parentData.submenu.style(this.menuStyle)},t.prototype.dispose=function(){X.prototype.dispose.call(this),this.hideScheduler.dispose(),this.mysubmenu&&(this.mysubmenu.dispose(),this.mysubmenu=null),this.submenuContainer&&(this.submenuDisposables=ae.dispose(this.submenuDisposables),this.submenuContainer=null)},t}(de),he=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype.style=function(X){this.label.style.borderBottomColor=X.separatorColor?""+X.separatorColor:null},t}(ne.ActionItem);$.cleanMnemonic=h})),define(Q[280],n([5,4]),(function(X,$){return X.create("vs/base/common/keybindingLabels",$)})),define(Q[154],n([0,1,280]),(function(X,$,Q){function i(X,$,Q){if(null===$)return"";var J=[];return X.ctrlKey&&J.push(Q.ctrlKey),X.shiftKey&&J.push(Q.shiftKey),X.altKey&&J.push(Q.altKey),X.metaKey&&J.push(Q.metaKey),J.push($),J.join(Q.separator)}Object.defineProperty($,"__esModule",{value:!0});var J=function(){function e(X,$,Q){void 0===Q&&(Q=$),this.modifierLabels=[null],this.modifierLabels[2]=X,this.modifierLabels[1]=$,this.modifierLabels[3]=Q}return e.prototype.toLabel=function(X,$,Q,J,ee){return null===X||null===$?null:function(X,$,Q,J,ee){var te=i(X,$,ee);return null!==Q&&null!==J&&(te+=" ",te+=i(Q,J,ee)),te}(X,$,Q,J,this.modifierLabels[ee])},e}();$.ModifierLabelProvider=J,$.UILabelProvider=new J({ctrlKey:"⌃",shiftKey:"⇧",altKey:"⌥",metaKey:"⌘",separator:""},{ctrlKey:Q.localize(0,null),shiftKey:Q.localize(1,null),altKey:Q.localize(2,null),metaKey:Q.localize(3,null),separator:"+"},{ctrlKey:Q.localize(4,null),shiftKey:Q.localize(5,null),altKey:Q.localize(6,null),metaKey:Q.localize(7,null),separator:"+"}),$.AriaLabelProvider=new J({ctrlKey:Q.localize(8,null),shiftKey:Q.localize(9,null),altKey:Q.localize(10,null),metaKey:Q.localize(11,null),separator:"+"},{ctrlKey:Q.localize(12,null),shiftKey:Q.localize(13,null),altKey:Q.localize(14,null),metaKey:Q.localize(15,null),separator:"+"},{ctrlKey:Q.localize(16,null),shiftKey:Q.localize(17,null),altKey:Q.localize(18,null),metaKey:Q.localize(19,null),separator:"+"})})),define(Q[282],n([0,1,27,154,7,210]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var te=ee.$,ne=function(){function e(X,$){this.os=$,this.domNode=ee.append(X,te(".monaco-keybinding")),this.didEverRender=!1,X.appendChild(this.domNode)}return e.prototype.set=function(X,$){this.didEverRender&&this.keybinding===X&&e.areSame(this.matches,$)||(this.keybinding=X,this.matches=$,this.render())},e.prototype.render=function(){if(ee.clearNode(this.domNode),this.keybinding){var X=this.keybinding.getParts(),$=X[0],Q=X[1];$&&this.renderPart(this.domNode,$,this.matches?this.matches.firstPart:null),Q&&(ee.append(this.domNode,te("span.monaco-keybinding-key-chord-separator",void 0," ")),this.renderPart(this.domNode,Q,this.matches?this.matches.chordPart:null)),this.domNode.title=this.keybinding.getAriaLabel()||""}this.didEverRender=!0},e.prototype.renderPart=function(X,$,Q){var ee=J.UILabelProvider.modifierLabels[this.os];$.ctrlKey&&this.renderKey(X,ee.ctrlKey,Boolean(Q&&Q.ctrlKey),ee.separator),$.shiftKey&&this.renderKey(X,ee.shiftKey,Boolean(Q&&Q.shiftKey),ee.separator),$.altKey&&this.renderKey(X,ee.altKey,Boolean(Q&&Q.altKey),ee.separator),$.metaKey&&this.renderKey(X,ee.metaKey,Boolean(Q&&Q.metaKey),ee.separator);var te=$.keyLabel;te&&this.renderKey(X,te,Boolean(Q&&Q.keyCode),"")},e.prototype.renderKey=function(X,$,Q,J){ee.append(X,te("span.monaco-keybinding-key"+(Q?".highlight":""),void 0,$)),J&&ee.append(X,te("span.monaco-keybinding-key-separator",void 0,J))},e.prototype.dispose=function(){},e.areSame=function(X,$){return X===$||!X&&!$||!!X&&!!$&&Q.equals(X.firstPart,$.firstPart)&&Q.equals(X.chordPart,$.chordPart)},e}();$.KeybindingLabel=ne})),define(Q[283],n([5,4]),(function(X,$){return X.create("vs/base/common/severity",$)})),define(Q[114],n([0,1,283,8]),(function(X,$,Q,J){var ee;Object.defineProperty($,"__esModule",{value:!0}),function(X){X[X.Ignore=0]="Ignore",X[X.Info=1]="Info",X[X.Warning=2]="Warning",X[X.Error=3]="Error"}(ee||(ee={})),function(X){var $=Object.create(null);$[X.Error]=Q.localize(0,null),$[X.Warning]=Q.localize(1,null),$[X.Info]=Q.localize(2,null),X.fromValue=function($){return $?J.equalsIgnoreCase("error",$)?X.Error:J.equalsIgnoreCase("warning",$)||J.equalsIgnoreCase("warn",$)?X.Warning:J.equalsIgnoreCase("info",$)?X.Info:X.Ignore:X.Ignore}}(ee||(ee={})),$.default=ee})),define(Q[285],n([5,4]),(function(X,$){return X.create("vs/base/parts/quickopen/browser/quickOpenModel",$)})),define(Q[119],n([0,1,285,53,118,67,159,7,282,17]),(function(X,$,Q,J,ee,ne,ie,oe,re,se){Object.defineProperty($,"__esModule",{value:!0});var ae=0,le=function(){function e(X){void 0===X&&(X=[]),this.id=(ae++).toString(),this.labelHighlights=X,this.descriptionHighlights=[]}return e.prototype.getId=function(){return this.id},e.prototype.getLabel=function(){return null},e.prototype.getLabelOptions=function(){return null},e.prototype.getAriaLabel=function(){return[this.getLabel(),this.getDescription(),this.getDetail()].filter((function(X){return!!X})).join(", ")},e.prototype.getDetail=function(){return null},e.prototype.getIcon=function(){return null},e.prototype.getDescription=function(){return null},e.prototype.getTooltip=function(){return null},e.prototype.getDescriptionTooltip=function(){return null},e.prototype.getKeybinding=function(){return null},e.prototype.isHidden=function(){return this.hidden},e.prototype.setHighlights=function(X,$,Q){this.labelHighlights=X,this.descriptionHighlights=$,this.detailHighlights=Q},e.prototype.getHighlights=function(){return[this.labelHighlights,this.descriptionHighlights,this.detailHighlights]},e.prototype.run=function(X,$){return!1},e}();$.QuickOpenEntry=le;var ue=function(X){function t($,Q,J){var ee=X.call(this)||this;return ee.entry=$,ee.groupLabel=Q,ee.withBorder=J,ee}return te(t,X),t.prototype.getGroupLabel=function(){return this.groupLabel},t.prototype.setGroupLabel=function(X){this.groupLabel=X},t.prototype.showBorder=function(){return this.withBorder},t.prototype.setShowBorder=function(X){this.withBorder=X},t.prototype.getLabel=function(){return this.entry?this.entry.getLabel():X.prototype.getLabel.call(this)},t.prototype.getLabelOptions=function(){return this.entry?this.entry.getLabelOptions():X.prototype.getLabelOptions.call(this)},t.prototype.getAriaLabel=function(){return this.entry?this.entry.getAriaLabel():X.prototype.getAriaLabel.call(this)},t.prototype.getDetail=function(){return this.entry?this.entry.getDetail():X.prototype.getDetail.call(this)},t.prototype.getIcon=function(){return this.entry?this.entry.getIcon():X.prototype.getIcon.call(this)},t.prototype.getDescription=function(){return this.entry?this.entry.getDescription():X.prototype.getDescription.call(this)},t.prototype.getHighlights=function(){return this.entry?this.entry.getHighlights():X.prototype.getHighlights.call(this)},t.prototype.isHidden=function(){return this.entry?this.entry.isHidden():X.prototype.isHidden.call(this)},t.prototype.setHighlights=function($,Q,J){this.entry?this.entry.setHighlights($,Q,J):X.prototype.setHighlights.call(this,$,Q,J)},t.prototype.run=function($,Q){return this.entry?this.entry.run($,Q):X.prototype.run.call(this,$,Q)},t}(le);$.QuickOpenEntryGroup=ue;var de=function(){function e(){}return e.prototype.hasActions=function(X,$){return!1},e.prototype.getActions=function(X,$){return J.TPromise.as(null)},e}(),ce=function(){function e(X,$){void 0===X&&(X=new de),void 0===$&&($=null),this.actionProvider=X,this.actionRunner=$}return e.prototype.getHeight=function(X){return X.getDetail()?44:22},e.prototype.getTemplateId=function(X){return X instanceof ue?"quickOpenEntryGroup":"quickOpenEntry"},e.prototype.renderTemplate=function(X,$,Q){var J=document.createElement("div");oe.addClass(J,"sub-content"),$.appendChild(J);var te=oe.$(".quick-open-row"),ae=oe.$(".quick-open-row"),le=oe.$(".quick-open-entry",null,te,ae);J.appendChild(le);var ue=document.createElement("span");te.appendChild(ue);var de=new ee.IconLabel(te,{supportHighlights:!0,supportDescriptionHighlights:!0}),ce=document.createElement("span");te.appendChild(ce),oe.addClass(ce,"quick-open-entry-keybinding");var he=new re.KeybindingLabel(ce,se.OS),pe=document.createElement("div");ae.appendChild(pe),oe.addClass(pe,"quick-open-entry-meta");var fe,ge=new ie.HighlightedLabel(pe,!0);"quickOpenEntryGroup"===X&&(fe=document.createElement("div"),oe.addClass(fe,"results-group"),$.appendChild(fe)),oe.addClass($,"actions");var me=document.createElement("div");return oe.addClass(me,"primary-action-bar"),$.appendChild(me),{container:$,entry:le,icon:ue,label:de,detail:ge,keybinding:he,group:fe,actionBar:new ne.ActionBar(me,{actionRunner:this.actionRunner})}},e.prototype.renderElement=function(X,$,Q,J){if(this.actionProvider.hasActions(null,X)?oe.addClass(Q.container,"has-actions"):oe.removeClass(Q.container,"has-actions"),Q.actionBar.context=X,this.actionProvider.getActions(null,X).then((function(X){Q.actionBar.isEmpty()&&X&&X.length>0?Q.actionBar.push(X,{icon:!0,label:!1}):Q.actionBar.isEmpty()||X&&0!==X.length||Q.actionBar.clear()})),X instanceof ue&&X.getGroupLabel()?oe.addClass(Q.container,"has-group-label"):oe.removeClass(Q.container,"has-group-label"),X instanceof ue){var ee=X,te=Q;ee.showBorder()?(oe.addClass(te.container,"results-group-separator"),te.container.style.borderTopColor=J.pickerGroupBorder.toString()):(oe.removeClass(te.container,"results-group-separator"),te.container.style.borderTopColor=null);var ne=ee.getGroupLabel()||"";te.group.textContent=ne,te.group.style.color=J.pickerGroupForeground.toString()}if(X instanceof le){var ie=X.getHighlights(),re=ie[0],se=ie[1],ae=ie[2],de=X.getIcon()?"quick-open-entry-icon "+X.getIcon():"";Q.icon.className=de;var ce=X.getLabelOptions()||Object.create(null);ce.matches=re||[],ce.title=X.getTooltip(),ce.descriptionTitle=X.getDescriptionTooltip()||X.getDescription(),ce.descriptionMatches=se||[],Q.label.setValue(X.getLabel(),X.getDescription(),ce),Q.detail.set(X.getDetail(),ae),Q.keybinding.set(X.getKeybinding(),null)}},e.prototype.disposeTemplate=function(X,$){var Q=$;Q.actionBar.dispose(),Q.actionBar=null,Q.container=null,Q.entry=null,Q.keybinding.dispose(),Q.keybinding=null,Q.detail.dispose(),Q.detail=null,Q.group=null,Q.icon=null,Q.label.dispose(),Q.label=null},e}(),he=function(){function e(X,$){void 0===X&&(X=[]),void 0===$&&($=new de),this._entries=X,this._dataSource=this,this._renderer=new ce($),this._filter=this,this._runner=this,this._accessibilityProvider=this}return Object.defineProperty(e.prototype,"entries",{get:function(){return this._entries},set:function(X){this._entries=X},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"dataSource",{get:function(){return this._dataSource},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"renderer",{get:function(){return this._renderer},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"filter",{get:function(){return this._filter},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"runner",{get:function(){return this._runner},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"accessibilityProvider",{get:function(){return this._accessibilityProvider},enumerable:!0,configurable:!0}),e.prototype.getId=function(X){return X.getId()},e.prototype.getLabel=function(X){return X.getLabel()},e.prototype.getAriaLabel=function(X){return X.getAriaLabel()?Q.localize(0,null,X.getAriaLabel()):Q.localize(1,null)},e.prototype.isVisible=function(X){return!X.isHidden()},e.prototype.run=function(X,$,Q){return X.run($,Q)},e}();$.QuickOpenModel=he})),define(Q[287],n([5,4]),(function(X,$){return X.create("vs/base/parts/quickopen/browser/quickOpenWidget",$)})),define(Q[288],n([0,1,287,17,32,437,117,161,219,52,88,7,2,28,27,40,238]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le,ue,de,ce,he){Object.defineProperty($,"__esModule",{value:!0});var pe=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype.onContextMenu=function($,Q,ee){return J.isMacintosh?this.onLeftClick($,Q,ee):X.prototype.onContextMenu.call(this,$,Q,ee)},t}(ae.DefaultController);$.QuickOpenController=pe;var fe={background:de.Color.fromHex("#1E1E1E"),foreground:de.Color.fromHex("#CCCCCC"),pickerGroupForeground:de.Color.fromHex("#0097FB"),pickerGroupBorder:de.Color.fromHex("#3F3F46"),widgetShadow:de.Color.fromHex("#000000"),progressBarBackground:de.Color.fromHex("#0E70C0")},ge=Q.localize(0,null),me=function(X){function t($,Q,J){var ee=X.call(this)||this;return ee.isDisposed=!1,ee.container=$,ee.callbacks=Q,ee.options=J,ee.styles=J||Object.create(null),ce.mixin(ee.styles,fe,!1),ee.model=null,ee}return te(t,X),t.prototype.getModel=function(){return this.model},t.prototype.create=function(){var X=this;this.element=document.createElement("div"),le.addClass(this.element,"monaco-quick-open-widget"),this.container.appendChild(this.element),this._register(le.addDisposableListener(this.element,le.EventType.CONTEXT_MENU,(function(X){return le.EventHelper.stop(X,!0)}))),this._register(le.addDisposableListener(this.element,le.EventType.FOCUS,(function($){return X.gainingFocus()}),!0)),this._register(le.addDisposableListener(this.element,le.EventType.BLUR,(function($){return X.loosingFocus($)}),!0)),this._register(le.addDisposableListener(this.element,le.EventType.KEY_DOWN,(function($){var Q=new se.StandardKeyboardEvent($);if(9===Q.keyCode)le.EventHelper.stop($,!0),X.hide(2);else if(2===Q.keyCode&&!Q.altKey&&!Q.ctrlKey&&!Q.metaKey){var J=$.currentTarget.querySelectorAll("input, .monaco-tree, .monaco-tree-row.focused .action-label.icon");Q.shiftKey&&Q.target===J[0]?(le.EventHelper.stop($,!0),J[J.length-1].focus()):Q.shiftKey||Q.target!==J[J.length-1]||(le.EventHelper.stop($,!0),J[0].focus())}}))),this.progressBar=this._register(new re.ProgressBar(this.element,{progressBarBackground:this.styles.progressBarBackground})),this.progressBar.hide(),this.inputContainer=document.createElement("div"),le.addClass(this.inputContainer,"quick-open-input"),this.element.appendChild(this.inputContainer),this.inputBox=this._register(new ie.InputBox(this.inputContainer,null,{placeholder:this.options.inputPlaceHolder||"",ariaLabel:ge,inputBackground:this.styles.inputBackground,inputForeground:this.styles.inputForeground,inputBorder:this.styles.inputBorder,inputValidationInfoBackground:this.styles.inputValidationInfoBackground,inputValidationInfoForeground:this.styles.inputValidationInfoForeground,inputValidationInfoBorder:this.styles.inputValidationInfoBorder,inputValidationWarningBackground:this.styles.inputValidationWarningBackground,inputValidationWarningForeground:this.styles.inputValidationWarningForeground,inputValidationWarningBorder:this.styles.inputValidationWarningBorder,inputValidationErrorBackground:this.styles.inputValidationErrorBackground,inputValidationErrorForeground:this.styles.inputValidationErrorForeground,inputValidationErrorBorder:this.styles.inputValidationErrorBorder})),this.inputElement=this.inputBox.inputElement,this.inputElement.setAttribute("role","combobox"),this.inputElement.setAttribute("aria-haspopup","false"),this.inputElement.setAttribute("aria-autocomplete","list"),this._register(le.addDisposableListener(this.inputBox.inputElement,le.EventType.INPUT,(function($){return X.onType()}))),this._register(le.addDisposableListener(this.inputBox.inputElement,le.EventType.KEY_DOWN,(function($){var Q=new se.StandardKeyboardEvent($),J=X.shouldOpenInBackground(Q);if(2!==Q.keyCode)if(18===Q.keyCode||16===Q.keyCode||12===Q.keyCode||11===Q.keyCode)le.EventHelper.stop($,!0),X.navigateInTree(Q.keyCode,Q.shiftKey),X.inputBox.inputElement.selectionStart===X.inputBox.inputElement.selectionEnd&&(X.inputBox.inputElement.selectionStart=X.inputBox.value.length);else if(3===Q.keyCode||J){le.EventHelper.stop($,!0);var ee=X.tree.getFocus();ee&&X.elementSelected(ee,$,J?2:1)}}))),this.resultCount=document.createElement("div"),le.addClass(this.resultCount,"quick-open-result-count"),this.resultCount.setAttribute("aria-live","polite"),this.resultCount.setAttribute("aria-atomic","true"),this.element.appendChild(this.resultCount),this.treeContainer=document.createElement("div"),le.addClass(this.treeContainer,"quick-open-tree"),this.element.appendChild(this.treeContainer);var $=this.options.treeCreator||function(X,$,Q){return new oe.Tree(X,$,Q)};return this.tree=this._register($(this.treeContainer,{dataSource:new ne.DataSource(this),controller:new pe({clickBehavior:1,keyboardSupport:this.options.keyboardSupport}),renderer:this.renderer=new ne.Renderer(this,this.styles),filter:new ne.Filter(this),accessibilityProvider:new ne.AccessibilityProvider(this)},{twistiePixels:11,indentPixels:0,alwaysFocused:!0,verticalScrollMode:3,horizontalScrollMode:2,ariaLabel:Q.localize(1,null),keyboardSupport:this.options.keyboardSupport,preventRootFocus:!1})),this.treeElement=this.tree.getHTMLElement(),this._register(this.tree.onDidChangeFocus((function($){X.elementFocused($.focus,$)}))),this._register(this.tree.onDidChangeSelection((function($){if($.selection&&$.selection.length>0){var Q=$.payload&&$.payload.originalEvent instanceof he.StandardMouseEvent?$.payload.originalEvent:void 0,J=!!Q&&X.shouldOpenInBackground(Q);X.elementSelected($.selection[0],$,J?2:1)}}))),this._register(le.addDisposableListener(this.treeContainer,le.EventType.KEY_DOWN,(function($){var Q=new se.StandardKeyboardEvent($);X.quickNavigateConfiguration&&(18!==Q.keyCode&&16!==Q.keyCode&&12!==Q.keyCode&&11!==Q.keyCode||(le.EventHelper.stop($,!0),X.navigateInTree(Q.keyCode)))}))),this._register(le.addDisposableListener(this.treeContainer,le.EventType.KEY_UP,(function($){var Q=new se.StandardKeyboardEvent($),J=Q.keyCode;if(X.quickNavigateConfiguration){var ee=X.quickNavigateConfiguration.keybindings;if(3===J||ee.some((function(X){var $=X.getParts(),ee=$[0];return!($[1]||(ee.shiftKey&&4===J?Q.ctrlKey||Q.altKey||Q.metaKey:!(ee.altKey&&6===J||ee.ctrlKey&&5===J||ee.metaKey&&57===J)))}))){var te=X.tree.getFocus();te&&X.elementSelected(te,$)}}}))),this.layoutDimensions&&this.layout(this.layoutDimensions),this.applyStyles(),this._register(le.addDisposableListener(this.treeContainer,le.EventType.KEY_DOWN,(function($){var Q=new se.StandardKeyboardEvent($);X.quickNavigateConfiguration||18!==Q.keyCode&&16!==Q.keyCode&&12!==Q.keyCode&&11!==Q.keyCode||(le.EventHelper.stop($,!0),X.navigateInTree(Q.keyCode,Q.shiftKey),X.treeElement.focus())}))),this.element},t.prototype.style=function(X){this.styles=X,this.applyStyles()},t.prototype.applyStyles=function(){if(this.element){var X=this.styles.foreground?this.styles.foreground.toString():null,$=this.styles.background?this.styles.background.toString():null,Q=this.styles.borderColor?this.styles.borderColor.toString():null,J=this.styles.widgetShadow?this.styles.widgetShadow.toString():null;this.element.style.color=X,this.element.style.backgroundColor=$,this.element.style.borderColor=Q,this.element.style.borderWidth=Q?"1px":null,this.element.style.borderStyle=Q?"solid":null,this.element.style.boxShadow=J?"0 5px 8px "+J:null}this.progressBar&&this.progressBar.style({progressBarBackground:this.styles.progressBarBackground}),this.inputBox&&this.inputBox.style({inputBackground:this.styles.inputBackground,inputForeground:this.styles.inputForeground,inputBorder:this.styles.inputBorder,inputValidationInfoBackground:this.styles.inputValidationInfoBackground,inputValidationInfoForeground:this.styles.inputValidationInfoForeground,inputValidationInfoBorder:this.styles.inputValidationInfoBorder,inputValidationWarningBackground:this.styles.inputValidationWarningBackground,inputValidationWarningForeground:this.styles.inputValidationWarningForeground,inputValidationWarningBorder:this.styles.inputValidationWarningBorder,inputValidationErrorBackground:this.styles.inputValidationErrorBackground,inputValidationErrorForeground:this.styles.inputValidationErrorForeground,inputValidationErrorBorder:this.styles.inputValidationErrorBorder}),this.tree&&!this.options.treeCreator&&this.tree.style(this.styles),this.renderer&&this.renderer.updateStyles(this.styles)},t.prototype.shouldOpenInBackground=function(X){if(X instanceof se.StandardKeyboardEvent){if(17!==X.keyCode)return!1;if(X.metaKey||X.ctrlKey||X.shiftKey||X.altKey)return!1;var $=this.inputBox.inputElement;return $.selectionEnd===this.inputBox.value.length&&$.selectionStart===$.selectionEnd}return X.middleButton},t.prototype.onType=function(){var X=this.inputBox.value;this.helpText&&(X?le.hide(this.helpText):le.show(this.helpText)),this.callbacks.onType(X)},t.prototype.navigateInTree=function(X,$){var Q=this.tree.getInput(),J=Q?Q.entries:[],ee=this.tree.getFocus();switch(X){case 18:this.tree.focusNext();break;case 16:this.tree.focusPrevious();break;case 12:this.tree.focusNextPage();break;case 11:this.tree.focusPreviousPage();break;case 2:$?this.tree.focusPrevious():this.tree.focusNext()}var te=this.tree.getFocus();J.length>1&&ee===te&&(16===X||2===X&&$?this.tree.focusLast():(18===X||2===X&&!$)&&this.tree.focusFirst()),(te=this.tree.getFocus())&&this.tree.reveal(te)},t.prototype.elementFocused=function(X,$){if(X&&this.isVisible()){this.inputElement.setAttribute("aria-activedescendant",this.treeElement.getAttribute("aria-activedescendant"));var Q={event:$,keymods:this.extractKeyMods($),quickNavigateConfiguration:this.quickNavigateConfiguration};this.model.runner.run(X,0,Q)}},t.prototype.elementSelected=function(X,$,Q){var J=!0;if(this.isVisible()){var ee=Q||1,te={event:$,keymods:this.extractKeyMods($),quickNavigateConfiguration:this.quickNavigateConfiguration};J=this.model.runner.run(X,ee,te)}J&&this.hide(0)},t.prototype.extractKeyMods=function(X){return{ctrlCmd:X&&(X.ctrlKey||X.metaKey||X.payload&&X.payload.originalEvent&&(X.payload.originalEvent.ctrlKey||X.payload.originalEvent.metaKey)),alt:X&&(X.altKey||X.payload&&X.payload.originalEvent&&X.payload.originalEvent.altKey)}},t.prototype.show=function(X,$){this.visible=!0,this.isLoosingFocus=!1,this.quickNavigateConfiguration=$?$.quickNavigateConfiguration:void 0,this.quickNavigateConfiguration?(le.hide(this.inputContainer),le.show(this.element),this.tree.domFocus()):(le.show(this.inputContainer),le.show(this.element),this.inputBox.focus()),this.helpText&&(this.quickNavigateConfiguration||ee.isString(X)?le.hide(this.helpText):le.show(this.helpText)),ee.isString(X)?this.doShowWithPrefix(X):($.value&&this.restoreLastInput($.value),this.doShowWithInput(X,$&&$.autoFocus?$.autoFocus:{})),$&&$.inputSelection&&!this.quickNavigateConfiguration&&this.inputBox.select($.inputSelection),this.callbacks.onShow&&this.callbacks.onShow()},t.prototype.restoreLastInput=function(X){this.inputBox.value=X,this.inputBox.select(),this.callbacks.onType(X)},t.prototype.doShowWithPrefix=function(X){this.inputBox.value=X,this.callbacks.onType(X)},t.prototype.doShowWithInput=function(X,$){this.setInput(X,$)},t.prototype.setInputAndLayout=function(X,$){var Q=this;this.treeContainer.style.height=this.getHeight(X)+"px",this.tree.setInput(null).then((function(){return Q.model=X,Q.inputElement.setAttribute("aria-haspopup",String(X&&X.entries&&X.entries.length>0)),Q.tree.setInput(X)})).then((function(){Q.tree.layout();var J=X?X.entries.filter((function($){return Q.isElementVisible(X,$)})):[];Q.updateResultCount(J.length),J.length&&Q.autoFocus(X,J,$)}))},t.prototype.isElementVisible=function(X,$){return!X.filter||X.filter.isVisible($)},t.prototype.autoFocus=function(X,$,Q){if(void 0===Q&&(Q={}),Q.autoFocusPrefixMatch){for(var J=void 0,ee=void 0,te=Q.autoFocusPrefixMatch,ne=te.toLowerCase(),ie=0;ie<$.length;ie++){var oe=$[ie],re=X.dataSource.getLabel(oe);if(J||0!==re.indexOf(te)?ee||0!==re.toLowerCase().indexOf(ne)||(ee=oe):J=oe,J&&ee)break}var se=J||ee;if(se)return this.tree.setFocus(se),void this.tree.reveal(se,.5)}Q.autoFocusFirstEntry?(this.tree.focusFirst(),this.tree.reveal(this.tree.getFocus())):"number"==typeof Q.autoFocusIndex?$.length>Q.autoFocusIndex&&(this.tree.focusNth(Q.autoFocusIndex),this.tree.reveal(this.tree.getFocus())):Q.autoFocusSecondEntry?$.length>1&&this.tree.focusNth(1):Q.autoFocusLastEntry&&$.length>1&&this.tree.focusLast()},t.prototype.getHeight=function(X){var $=this,Q=X.renderer;if(!X){var J=Q.getHeight(null);return this.options.minItemsToShow?this.options.minItemsToShow*J:0}var ee,te=0;this.layoutDimensions&&this.layoutDimensions.height&&(ee=.4*(this.layoutDimensions.height-50)),(!ee||ee>t.MAX_ITEMS_HEIGHT)&&(ee=t.MAX_ITEMS_HEIGHT);for(var ne=X.entries.filter((function(Q){return $.isElementVisible(X,Q)})),ie=this.options.maxItemsToShow||ne.length,oe=0;oe<ie&&oe<ne.length;oe++){var re=Q.getHeight(ne[oe]);if(!(te+re<=ee))break;te+=re}return te},t.prototype.updateResultCount=function(X){this.resultCount.textContent=Q.localize(2,null,X)},t.prototype.hide=function(X){this.isVisible()&&(this.visible=!1,le.hide(this.element),this.element.blur(),this.inputBox.value="",this.tree.setInput(null),this.inputElement.setAttribute("aria-haspopup","false"),this.treeContainer.style.height=(this.options.minItemsToShow?22*this.options.minItemsToShow:0)+"px",this.progressBar.stop().hide(),this.tree.isDOMFocused()?this.tree.domBlur():this.inputBox.hasFocus()&&this.inputBox.blur(),0===X?this.callbacks.onOk():this.callbacks.onCancel(),this.callbacks.onHide&&this.callbacks.onHide(X))},t.prototype.setInput=function(X,$,Q){this.isVisible()&&(this.getInput()&&this.onInputChanging(),this.setInputAndLayout(X,$),this.inputBox&&this.inputBox.setAriaLabel(Q||ge))},t.prototype.onInputChanging=function(){var X=this;this.inputChangingTimeoutHandle&&(clearTimeout(this.inputChangingTimeoutHandle),this.inputChangingTimeoutHandle=null),le.addClass(this.element,"content-changing"),this.inputChangingTimeoutHandle=setTimeout((function(){le.removeClass(X.element,"content-changing")}),500)},t.prototype.getInput=function(){return this.tree.getInput()},t.prototype.isVisible=function(){return this.visible},t.prototype.layout=function(X){this.layoutDimensions=X;var $=Math.min(.62*this.layoutDimensions.width,t.MAX_WIDTH);this.element&&(this.element.style.width=$+"px",this.element.style.marginLeft="-"+$/2+"px",this.inputContainer.style.width=$-12+"px")},t.prototype.gainingFocus=function(){this.isLoosingFocus=!1},t.prototype.loosingFocus=function(X){var $=this;if(this.isVisible()){var Q=X.relatedTarget;!this.quickNavigateConfiguration&&le.isAncestor(Q,this.element)||(this.isLoosingFocus=!0,setTimeout((function(){$.isLoosingFocus&&!$.isDisposed&&($.callbacks.onFocusLost&&$.callbacks.onFocusLost()||$.hide(1))}),0))}},t.prototype.dispose=function(){X.prototype.dispose.call(this),this.isDisposed=!0},t.MAX_WIDTH=600,t.MAX_ITEMS_HEIGHT=440,t}(ue.Disposable);$.QuickOpenWidget=me})),define(Q[289],n([5,4]),(function(X,$){return X.create("vs/editor/browser/controller/coreCommands",$)})),define(Q[290],n([5,4]),(function(X,$){return X.create("vs/editor/browser/widget/codeEditorWidget",$)})),define(Q[291],n([5,4]),(function(X,$){return X.create("vs/editor/browser/widget/diffEditorWidget",$)})),define(Q[292],n([5,4]),(function(X,$){return X.create("vs/editor/browser/widget/diffReview",$)})),define(Q[293],n([5,4]),(function(X,$){return X.create("vs/editor/common/config/commonEditorConfig",$)})),define(Q[294],n([5,4]),(function(X,$){return X.create("vs/editor/common/config/editorOptions",$)}));var ie=this&&this.__assign||function(){return(ie=Object.assign||function(X){for(var $,Q=1,J=arguments.length;Q<J;Q++)for(var ee in $=arguments[Q])Object.prototype.hasOwnProperty.call($,ee)&&(X[ee]=$[ee]);return X}).apply(this,arguments)};define(Q[48],n([0,1,294,22,27,17,90]),(function(X,$,Q,J,ee,te,ne){function a(X,$){return void 0===X?$:"false"!==X&&Boolean(X)}function u(X,$){return"string"!=typeof X?$:X}function d(X,$,Q){return"string"!=typeof X||-1===Q.indexOf(X)?$:X}function c(X,$,Q,J){var ee;return void 0===X?ee=$:(ee=parseInt(X,10),isNaN(ee)&&(ee=$)),ee=Math.max(Q,ee),0|Math.min(J,ee)}function h(X,$){if("string"!=typeof X)return $;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}var oe;Object.defineProperty($,"__esModule",{value:!0}),$.blinkingStyleToString=function(X){if(1===X)return"blink";if(4===X)return"expand";if(3===X)return"phase";if(2===X)return"smooth";if(5===X)return"solid";throw new Error("blinkingStyleToString: Unknown blinkingStyle")},function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"}(oe=$.TextEditorCursorStyle||($.TextEditorCursorStyle={})),$.cursorStyleToString=function(X){if(X===oe.Line)return"line";if(X===oe.Block)return"block";if(X===oe.Underline)return"underline";if(X===oe.LineThin)return"line-thin";if(X===oe.BlockOutline)return"block-outline";if(X===oe.UnderlineThin)return"underline-thin";throw new Error("cursorStyleToString: Unknown cursorStyle")};var re=function(){function e(X){this.canUseLayerHinting=X.canUseLayerHinting,this.pixelRatio=X.pixelRatio,this.editorClassName=X.editorClassName,this.lineHeight=0|X.lineHeight,this.readOnly=X.readOnly,this.accessibilitySupport=X.accessibilitySupport,this.multiCursorModifier=X.multiCursorModifier,this.multiCursorMergeOverlapping=X.multiCursorMergeOverlapping,this.wordSeparators=X.wordSeparators,this.autoClosingBrackets=X.autoClosingBrackets,this.autoClosingQuotes=X.autoClosingQuotes,this.autoSurround=X.autoSurround,this.autoIndent=X.autoIndent,this.useTabStops=X.useTabStops,this.tabFocusMode=X.tabFocusMode,this.dragAndDrop=X.dragAndDrop,this.emptySelectionClipboard=X.emptySelectionClipboard,this.copyWithSyntaxHighlighting=X.copyWithSyntaxHighlighting,this.layoutInfo=X.layoutInfo,this.fontInfo=X.fontInfo,this.viewInfo=X.viewInfo,this.wrappingInfo=X.wrappingInfo,this.contribInfo=X.contribInfo,this.showUnused=X.showUnused}return e.prototype.equals=function(X){return this.canUseLayerHinting===X.canUseLayerHinting&&this.pixelRatio===X.pixelRatio&&this.editorClassName===X.editorClassName&&this.lineHeight===X.lineHeight&&this.readOnly===X.readOnly&&this.accessibilitySupport===X.accessibilitySupport&&this.multiCursorModifier===X.multiCursorModifier&&this.multiCursorMergeOverlapping===X.multiCursorMergeOverlapping&&this.wordSeparators===X.wordSeparators&&this.autoClosingBrackets===X.autoClosingBrackets&&this.autoClosingQuotes===X.autoClosingQuotes&&this.autoSurround===X.autoSurround&&this.autoIndent===X.autoIndent&&this.useTabStops===X.useTabStops&&this.tabFocusMode===X.tabFocusMode&&this.dragAndDrop===X.dragAndDrop&&this.showUnused===X.showUnused&&this.emptySelectionClipboard===X.emptySelectionClipboard&&this.copyWithSyntaxHighlighting===X.copyWithSyntaxHighlighting&&e._equalsLayoutInfo(this.layoutInfo,X.layoutInfo)&&this.fontInfo.equals(X.fontInfo)&&e._equalsViewOptions(this.viewInfo,X.viewInfo)&&e._equalsWrappingInfo(this.wrappingInfo,X.wrappingInfo)&&e._equalsContribOptions(this.contribInfo,X.contribInfo)},e.prototype.createChangeEvent=function(X){return{canUseLayerHinting:this.canUseLayerHinting!==X.canUseLayerHinting,pixelRatio:this.pixelRatio!==X.pixelRatio,editorClassName:this.editorClassName!==X.editorClassName,lineHeight:this.lineHeight!==X.lineHeight,readOnly:this.readOnly!==X.readOnly,accessibilitySupport:this.accessibilitySupport!==X.accessibilitySupport,multiCursorModifier:this.multiCursorModifier!==X.multiCursorModifier,multiCursorMergeOverlapping:this.multiCursorMergeOverlapping!==X.multiCursorMergeOverlapping,wordSeparators:this.wordSeparators!==X.wordSeparators,autoClosingBrackets:this.autoClosingBrackets!==X.autoClosingBrackets,autoClosingQuotes:this.autoClosingQuotes!==X.autoClosingQuotes,autoSurround:this.autoSurround!==X.autoSurround,autoIndent:this.autoIndent!==X.autoIndent,useTabStops:this.useTabStops!==X.useTabStops,tabFocusMode:this.tabFocusMode!==X.tabFocusMode,dragAndDrop:this.dragAndDrop!==X.dragAndDrop,emptySelectionClipboard:this.emptySelectionClipboard!==X.emptySelectionClipboard,copyWithSyntaxHighlighting:this.copyWithSyntaxHighlighting!==X.copyWithSyntaxHighlighting,layoutInfo:!e._equalsLayoutInfo(this.layoutInfo,X.layoutInfo),fontInfo:!this.fontInfo.equals(X.fontInfo),viewInfo:!e._equalsViewOptions(this.viewInfo,X.viewInfo),wrappingInfo:!e._equalsWrappingInfo(this.wrappingInfo,X.wrappingInfo),contribInfo:!e._equalsContribOptions(this.contribInfo,X.contribInfo)}},e._equalsLayoutInfo=function(X,$){return X.width===$.width&&X.height===$.height&&X.glyphMarginLeft===$.glyphMarginLeft&&X.glyphMarginWidth===$.glyphMarginWidth&&X.glyphMarginHeight===$.glyphMarginHeight&&X.lineNumbersLeft===$.lineNumbersLeft&&X.lineNumbersWidth===$.lineNumbersWidth&&X.lineNumbersHeight===$.lineNumbersHeight&&X.decorationsLeft===$.decorationsLeft&&X.decorationsWidth===$.decorationsWidth&&X.decorationsHeight===$.decorationsHeight&&X.contentLeft===$.contentLeft&&X.contentWidth===$.contentWidth&&X.contentHeight===$.contentHeight&&X.renderMinimap===$.renderMinimap&&X.minimapLeft===$.minimapLeft&&X.minimapWidth===$.minimapWidth&&X.viewportColumn===$.viewportColumn&&X.verticalScrollbarWidth===$.verticalScrollbarWidth&&X.horizontalScrollbarHeight===$.horizontalScrollbarHeight&&this._equalsOverviewRuler(X.overviewRuler,$.overviewRuler)},e._equalsOverviewRuler=function(X,$){return X.width===$.width&&X.height===$.height&&X.top===$.top&&X.right===$.right},e._equalsViewOptions=function(X,$){return X.extraEditorClassName===$.extraEditorClassName&&X.disableMonospaceOptimizations===$.disableMonospaceOptimizations&&J.equals(X.rulers,$.rulers)&&X.ariaLabel===$.ariaLabel&&X.renderLineNumbers===$.renderLineNumbers&&X.renderCustomLineNumbers===$.renderCustomLineNumbers&&X.selectOnLineNumbers===$.selectOnLineNumbers&&X.glyphMargin===$.glyphMargin&&X.revealHorizontalRightPadding===$.revealHorizontalRightPadding&&X.roundedSelection===$.roundedSelection&&X.overviewRulerLanes===$.overviewRulerLanes&&X.overviewRulerBorder===$.overviewRulerBorder&&X.cursorBlinking===$.cursorBlinking&&X.mouseWheelZoom===$.mouseWheelZoom&&X.cursorStyle===$.cursorStyle&&X.cursorWidth===$.cursorWidth&&X.hideCursorInOverviewRuler===$.hideCursorInOverviewRuler&&X.scrollBeyondLastLine===$.scrollBeyondLastLine&&X.scrollBeyondLastColumn===$.scrollBeyondLastColumn&&X.smoothScrolling===$.smoothScrolling&&X.stopRenderingLineAfter===$.stopRenderingLineAfter&&X.renderWhitespace===$.renderWhitespace&&X.renderControlCharacters===$.renderControlCharacters&&X.fontLigatures===$.fontLigatures&&X.renderIndentGuides===$.renderIndentGuides&&X.highlightActiveIndentGuide===$.highlightActiveIndentGuide&&X.renderLineHighlight===$.renderLineHighlight&&this._equalsScrollbarOptions(X.scrollbar,$.scrollbar)&&this._equalsMinimapOptions(X.minimap,$.minimap)&&X.fixedOverflowWidgets===$.fixedOverflowWidgets},e._equalsScrollbarOptions=function(X,$){return X.arrowSize===$.arrowSize&&X.vertical===$.vertical&&X.horizontal===$.horizontal&&X.useShadows===$.useShadows&&X.verticalHasArrows===$.verticalHasArrows&&X.horizontalHasArrows===$.horizontalHasArrows&&X.handleMouseWheel===$.handleMouseWheel&&X.horizontalScrollbarSize===$.horizontalScrollbarSize&&X.horizontalSliderSize===$.horizontalSliderSize&&X.verticalScrollbarSize===$.verticalScrollbarSize&&X.verticalSliderSize===$.verticalSliderSize&&X.mouseWheelScrollSensitivity===$.mouseWheelScrollSensitivity},e._equalsMinimapOptions=function(X,$){return X.enabled===$.enabled&&X.side===$.side&&X.showSlider===$.showSlider&&X.renderCharacters===$.renderCharacters&&X.maxColumn===$.maxColumn},e._equalFindOptions=function(X,$){return X.seedSearchStringFromSelection===$.seedSearchStringFromSelection&&X.autoFindInSelection===$.autoFindInSelection&&X.globalFindClipboard===$.globalFindClipboard},e._equalsParameterHintOptions=function(X,$){return X.enabled===$.enabled&&X.cycle===$.cycle},e._equalsHoverOptions=function(X,$){return X.enabled===$.enabled&&X.delay===$.delay&&X.sticky===$.sticky},e._equalsSuggestOptions=function(X,$){return X===$||!(!X||!$)&&X.filterGraceful===$.filterGraceful&&X.snippets===$.snippets&&X.snippetsPreventQuickSuggestions===$.snippetsPreventQuickSuggestions&&X.localityBonus===$.localityBonus},e._equalsWrappingInfo=function(X,$){return X.inDiffEditor===$.inDiffEditor&&X.isDominatedByLongLines===$.isDominatedByLongLines&&X.isWordWrapMinified===$.isWordWrapMinified&&X.isViewportWrapping===$.isViewportWrapping&&X.wrappingColumn===$.wrappingColumn&&X.wrappingIndent===$.wrappingIndent&&X.wordWrapBreakBeforeCharacters===$.wordWrapBreakBeforeCharacters&&X.wordWrapBreakAfterCharacters===$.wordWrapBreakAfterCharacters&&X.wordWrapBreakObtrusiveCharacters===$.wordWrapBreakObtrusiveCharacters},e._equalsContribOptions=function(X,$){return X.selectionClipboard===$.selectionClipboard&&this._equalsHoverOptions(X.hover,$.hover)&&X.links===$.links&&X.contextmenu===$.contextmenu&&e._equalsQuickSuggestions(X.quickSuggestions,$.quickSuggestions)&&X.quickSuggestionsDelay===$.quickSuggestionsDelay&&this._equalsParameterHintOptions(X.parameterHints,$.parameterHints)&&X.iconsInSuggestions===$.iconsInSuggestions&&X.formatOnType===$.formatOnType&&X.formatOnPaste===$.formatOnPaste&&X.suggestOnTriggerCharacters===$.suggestOnTriggerCharacters&&X.acceptSuggestionOnEnter===$.acceptSuggestionOnEnter&&X.acceptSuggestionOnCommitCharacter===$.acceptSuggestionOnCommitCharacter&&X.wordBasedSuggestions===$.wordBasedSuggestions&&X.suggestSelection===$.suggestSelection&&X.suggestFontSize===$.suggestFontSize&&X.suggestLineHeight===$.suggestLineHeight&&X.tabCompletion===$.tabCompletion&&this._equalsSuggestOptions(X.suggest,$.suggest)&&X.selectionHighlight===$.selectionHighlight&&X.occurrencesHighlight===$.occurrencesHighlight&&X.codeLens===$.codeLens&&X.folding===$.folding&&X.foldingStrategy===$.foldingStrategy&&X.showFoldingControls===$.showFoldingControls&&X.matchBrackets===$.matchBrackets&&this._equalFindOptions(X.find,$.find)&&X.colorDecorators===$.colorDecorators&&ee.equals(X.codeActionsOnSave,$.codeActionsOnSave)&&X.codeActionsOnSaveTimeout===$.codeActionsOnSaveTimeout&&X.lightbulbEnabled===$.lightbulbEnabled},e._equalsQuickSuggestions=function(X,$){return"boolean"==typeof X?"boolean"==typeof $&&X===$:"boolean"!=typeof $&&X.comments===$.comments&&X.other===$.other&&X.strings===$.strings},e}();$.InternalEditorOptions=re;var se=function(){function e(){}return e.validate=function(X,$){var Q=X.wordWrap;!0===Q?Q="on":!1===Q&&(Q="off"),Q=d(Q,$.wordWrap,["off","on","wordWrapColumn","bounded"]);var J=this._sanitizeViewInfo(X,$.viewInfo),ee=this._sanitizeContribInfo(X,$.contribInfo),ne=void 0;"string"==typeof X.multiCursorModifier&&(ne="ctrlCmd"===X.multiCursorModifier?te.isMacintosh?"metaKey":"ctrlKey":"altKey");var ie,oe,re,se=d(ne,$.multiCursorModifier,["altKey","metaKey","ctrlKey"]);return"boolean"==typeof X.autoClosingBrackets&&!1===X.autoClosingBrackets?(ie="never",oe="never",re="never"):(ie=d(X.autoClosingBrackets,$.autoClosingBrackets,["always","languageDefined","beforeWhitespace","never"]),oe=d(X.autoClosingQuotes,$.autoClosingQuotes,["always","languageDefined","beforeWhitespace","never"]),re=d(X.autoSurround,$.autoSurround,["languageDefined","brackets","quotes","never"])),{inDiffEditor:a(X.inDiffEditor,$.inDiffEditor),wordSeparators:u(X.wordSeparators,$.wordSeparators),lineNumbersMinChars:c(X.lineNumbersMinChars,$.lineNumbersMinChars,1,10),lineDecorationsWidth:void 0===X.lineDecorationsWidth?$.lineDecorationsWidth:X.lineDecorationsWidth,readOnly:a(X.readOnly,$.readOnly),mouseStyle:d(X.mouseStyle,$.mouseStyle,["text","default","copy"]),disableLayerHinting:a(X.disableLayerHinting,$.disableLayerHinting),automaticLayout:a(X.automaticLayout,$.automaticLayout),wordWrap:Q,wordWrapColumn:c(X.wordWrapColumn,$.wordWrapColumn,1,1073741824),wordWrapMinified:a(X.wordWrapMinified,$.wordWrapMinified),wrappingIndent:function(X,$){return"string"!=typeof X?$:"same"===X?1:"indent"===X?2:"deepIndent"===X?3:0}(X.wrappingIndent,$.wrappingIndent),wordWrapBreakBeforeCharacters:u(X.wordWrapBreakBeforeCharacters,$.wordWrapBreakBeforeCharacters),wordWrapBreakAfterCharacters:u(X.wordWrapBreakAfterCharacters,$.wordWrapBreakAfterCharacters),wordWrapBreakObtrusiveCharacters:u(X.wordWrapBreakObtrusiveCharacters,$.wordWrapBreakObtrusiveCharacters),autoClosingBrackets:ie,autoClosingQuotes:oe,autoSurround:re,autoIndent:a(X.autoIndent,$.autoIndent),dragAndDrop:a(X.dragAndDrop,$.dragAndDrop),emptySelectionClipboard:a(X.emptySelectionClipboard,$.emptySelectionClipboard),copyWithSyntaxHighlighting:a(X.copyWithSyntaxHighlighting,$.copyWithSyntaxHighlighting),useTabStops:a(X.useTabStops,$.useTabStops),multiCursorModifier:se,multiCursorMergeOverlapping:a(X.multiCursorMergeOverlapping,$.multiCursorMergeOverlapping),accessibilitySupport:d(X.accessibilitySupport,$.accessibilitySupport,["auto","on","off"]),showUnused:a(X.showUnused,$.showUnused),viewInfo:J,contribInfo:ee}},e._sanitizeScrollbarOpts=function(X,$,Q){if("object"!=typeof X)return $;var J=c(X.horizontalScrollbarSize,$.horizontalScrollbarSize,0,1e3),ee=c(X.verticalScrollbarSize,$.verticalScrollbarSize,0,1e3);return{vertical:h(X.vertical,$.vertical),horizontal:h(X.horizontal,$.horizontal),arrowSize:c(X.arrowSize,$.arrowSize,0,1e3),useShadows:a(X.useShadows,$.useShadows),verticalHasArrows:a(X.verticalHasArrows,$.verticalHasArrows),horizontalHasArrows:a(X.horizontalHasArrows,$.horizontalHasArrows),horizontalScrollbarSize:J,horizontalSliderSize:c(X.horizontalSliderSize,J,0,1e3),verticalScrollbarSize:ee,verticalSliderSize:c(X.verticalSliderSize,ee,0,1e3),handleMouseWheel:a(X.handleMouseWheel,$.handleMouseWheel),mouseWheelScrollSensitivity:Q}},e._sanitizeMinimapOpts=function(X,$){return"object"!=typeof X?$:{enabled:a(X.enabled,$.enabled),side:d(X.side,$.side,["right","left"]),showSlider:d(X.showSlider,$.showSlider,["always","mouseover"]),renderCharacters:a(X.renderCharacters,$.renderCharacters),maxColumn:c(X.maxColumn,$.maxColumn,1,1e4)}},e._santizeFindOpts=function(X,$){return"object"!=typeof X?$:{seedSearchStringFromSelection:a(X.seedSearchStringFromSelection,$.seedSearchStringFromSelection),autoFindInSelection:a(X.autoFindInSelection,$.autoFindInSelection),globalFindClipboard:a(X.globalFindClipboard,$.globalFindClipboard)}},e._sanitizeParameterHintOpts=function(X,$){return"object"!=typeof X?$:{enabled:a(X.enabled,$.enabled),cycle:a(X.cycle,$.cycle)}},e._santizeHoverOpts=function(X,$){var Q;if("boolean"==typeof X)Q={enabled:X};else{if("object"!=typeof X)return $;Q=X}return{enabled:a(Q.enabled,$.enabled),delay:c(Q.delay,$.delay,0,1e4),sticky:a(Q.sticky,$.sticky)}},e._sanitizeSuggestOpts=function(X,$){var Q=X.suggest||{};return{filterGraceful:a(Q.filterGraceful,$.filterGraceful),snippets:d(X.snippetSuggestions,$.snippets,["top","bottom","inline","none"]),snippetsPreventQuickSuggestions:a(Q.snippetsPreventQuickSuggestions,$.filterGraceful),localityBonus:a(Q.localityBonus,$.localityBonus)}},e._sanitizeTabCompletionOpts=function(X,$){return!1===X?"off":!0===X?"onlySnippets":d(X,$,["on","off","onlySnippets"])},e._sanitizeViewInfo=function(X,$){var Q=[];if(Array.isArray(X.rulers)){for(var J=0,ee=X.rulers.length;J<ee;J++)Q.push(c(X.rulers[J],0,0,1e4));Q.sort()}var te=$.renderLineNumbers,ne=$.renderCustomLineNumbers;if(void 0!==X.lineNumbers){var ie=X.lineNumbers;!0===ie?ie="on":!1===ie&&(ie="off"),"function"==typeof ie?(te=4,ne=ie):te="interval"===ie?3:"relative"===ie?2:"on"===ie?1:0}var re=a(X.fontLigatures,$.fontLigatures),se=a(X.disableMonospaceOptimizations,$.disableMonospaceOptimizations)||re,ae=X.renderWhitespace;!0===ae?ae="boundary":!1===ae&&(ae="none"),ae=d(X.renderWhitespace,$.renderWhitespace,["none","boundary","all"]);var le=X.renderLineHighlight;!0===le?le="line":!1===le&&(le="none"),le=d(X.renderLineHighlight,$.renderLineHighlight,["none","gutter","line","all"]);var ue=function(X,$){var Q=parseFloat(X);return isNaN(Q)&&(Q=$),Q}(X.mouseWheelScrollSensitivity,$.scrollbar.mouseWheelScrollSensitivity);0===ue&&(ue=1);var de=this._sanitizeScrollbarOpts(X.scrollbar,$.scrollbar,ue),ce=this._sanitizeMinimapOpts(X.minimap,$.minimap);return{extraEditorClassName:u(X.extraEditorClassName,$.extraEditorClassName),disableMonospaceOptimizations:se,rulers:Q,ariaLabel:u(X.ariaLabel,$.ariaLabel),renderLineNumbers:te,renderCustomLineNumbers:ne,selectOnLineNumbers:a(X.selectOnLineNumbers,$.selectOnLineNumbers),glyphMargin:a(X.glyphMargin,$.glyphMargin),revealHorizontalRightPadding:c(X.revealHorizontalRightPadding,$.revealHorizontalRightPadding,0,1e3),roundedSelection:a(X.roundedSelection,$.roundedSelection),overviewRulerLanes:c(X.overviewRulerLanes,$.overviewRulerLanes,0,3),overviewRulerBorder:a(X.overviewRulerBorder,$.overviewRulerBorder),cursorBlinking:function(X,$){if("string"!=typeof X)return $;switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"visible":case"solid":return 5}return 1}(X.cursorBlinking,$.cursorBlinking),mouseWheelZoom:a(X.mouseWheelZoom,$.mouseWheelZoom),cursorStyle:function(X,$){return"string"!=typeof X?$:"line"===X?oe.Line:"block"===X?oe.Block:"underline"===X?oe.Underline:"line-thin"===X?oe.LineThin:"block-outline"===X?oe.BlockOutline:"underline-thin"===X?oe.UnderlineThin:oe.Line}(X.cursorStyle,$.cursorStyle),cursorWidth:c(X.cursorWidth,$.cursorWidth,0,Number.MAX_VALUE),hideCursorInOverviewRuler:a(X.hideCursorInOverviewRuler,$.hideCursorInOverviewRuler),scrollBeyondLastLine:a(X.scrollBeyondLastLine,$.scrollBeyondLastLine),scrollBeyondLastColumn:c(X.scrollBeyondLastColumn,$.scrollBeyondLastColumn,0,1073741824),smoothScrolling:a(X.smoothScrolling,$.smoothScrolling),stopRenderingLineAfter:c(X.stopRenderingLineAfter,$.stopRenderingLineAfter,-1,1073741824),renderWhitespace:ae,renderControlCharacters:a(X.renderControlCharacters,$.renderControlCharacters),fontLigatures:re,renderIndentGuides:a(X.renderIndentGuides,$.renderIndentGuides),highlightActiveIndentGuide:a(X.highlightActiveIndentGuide,$.highlightActiveIndentGuide),renderLineHighlight:le,scrollbar:de,minimap:ce,fixedOverflowWidgets:a(X.fixedOverflowWidgets,$.fixedOverflowWidgets)}},e._sanitizeContribInfo=function(X,$){var Q;Q="object"==typeof X.quickSuggestions?ie({other:!0},X.quickSuggestions):a(X.quickSuggestions,$.quickSuggestions),"boolean"==typeof X.acceptSuggestionOnEnter&&(X.acceptSuggestionOnEnter=X.acceptSuggestionOnEnter?"on":"off");var J=this._santizeFindOpts(X.find,$.find);return{selectionClipboard:a(X.selectionClipboard,$.selectionClipboard),hover:this._santizeHoverOpts(X.hover,$.hover),links:a(X.links,$.links),contextmenu:a(X.contextmenu,$.contextmenu),quickSuggestions:Q,quickSuggestionsDelay:c(X.quickSuggestionsDelay,$.quickSuggestionsDelay,-1073741824,1073741824),parameterHints:this._sanitizeParameterHintOpts(X.parameterHints,$.parameterHints),iconsInSuggestions:a(X.iconsInSuggestions,$.iconsInSuggestions),formatOnType:a(X.formatOnType,$.formatOnType),formatOnPaste:a(X.formatOnPaste,$.formatOnPaste),suggestOnTriggerCharacters:a(X.suggestOnTriggerCharacters,$.suggestOnTriggerCharacters),acceptSuggestionOnEnter:d(X.acceptSuggestionOnEnter,$.acceptSuggestionOnEnter,["on","smart","off"]),acceptSuggestionOnCommitCharacter:a(X.acceptSuggestionOnCommitCharacter,$.acceptSuggestionOnCommitCharacter),wordBasedSuggestions:a(X.wordBasedSuggestions,$.wordBasedSuggestions),suggestSelection:d(X.suggestSelection,$.suggestSelection,["first","recentlyUsed","recentlyUsedByPrefix"]),suggestFontSize:c(X.suggestFontSize,$.suggestFontSize,0,1e3),suggestLineHeight:c(X.suggestLineHeight,$.suggestLineHeight,0,1e3),tabCompletion:this._sanitizeTabCompletionOpts(X.tabCompletion,$.tabCompletion),suggest:this._sanitizeSuggestOpts(X,$.suggest),selectionHighlight:a(X.selectionHighlight,$.selectionHighlight),occurrencesHighlight:a(X.occurrencesHighlight,$.occurrencesHighlight),codeLens:a(X.codeLens,$.codeLens),folding:a(X.folding,$.folding),foldingStrategy:d(X.foldingStrategy,$.foldingStrategy,["auto","indentation"]),showFoldingControls:d(X.showFoldingControls,$.showFoldingControls,["always","mouseover"]),matchBrackets:a(X.matchBrackets,$.matchBrackets),find:J,colorDecorators:a(X.colorDecorators,$.colorDecorators),lightbulbEnabled:a(!!X.lightbulb&&X.lightbulb.enabled,$.lightbulbEnabled),codeActionsOnSave:function(X,$){if(!X)return{};for(var Q=Object.create(null),J=0,ee=Object.keys(X);J<ee.length;J++){var te=ee[J],ne=X[te];"boolean"==typeof ne&&(Q[te]=ne)}return Q}(X.codeActionsOnSave),codeActionsOnSaveTimeout:c(X.codeActionsOnSaveTimeout,$.codeActionsOnSaveTimeout,1,1e4)}},e}();$.EditorOptionsValidator=se;var ae=function(){function e(){}return e._tweakValidatedOptions=function(X,$){var J=2===$,ee=1===$;return{inDiffEditor:X.inDiffEditor,wordSeparators:X.wordSeparators,lineNumbersMinChars:X.lineNumbersMinChars,lineDecorationsWidth:X.lineDecorationsWidth,readOnly:X.readOnly,mouseStyle:X.mouseStyle,disableLayerHinting:X.disableLayerHinting,automaticLayout:X.automaticLayout,wordWrap:X.wordWrap,wordWrapColumn:X.wordWrapColumn,wordWrapMinified:X.wordWrapMinified,wrappingIndent:X.wrappingIndent,wordWrapBreakBeforeCharacters:X.wordWrapBreakBeforeCharacters,wordWrapBreakAfterCharacters:X.wordWrapBreakAfterCharacters,wordWrapBreakObtrusiveCharacters:X.wordWrapBreakObtrusiveCharacters,autoClosingBrackets:X.autoClosingBrackets,autoClosingQuotes:X.autoClosingQuotes,autoSurround:X.autoSurround,autoIndent:X.autoIndent,dragAndDrop:X.dragAndDrop,emptySelectionClipboard:X.emptySelectionClipboard,copyWithSyntaxHighlighting:X.copyWithSyntaxHighlighting,useTabStops:X.useTabStops,multiCursorModifier:X.multiCursorModifier,multiCursorMergeOverlapping:X.multiCursorMergeOverlapping,accessibilitySupport:X.accessibilitySupport,showUnused:X.showUnused,viewInfo:{extraEditorClassName:X.viewInfo.extraEditorClassName,disableMonospaceOptimizations:X.viewInfo.disableMonospaceOptimizations,rulers:X.viewInfo.rulers,ariaLabel:ee?Q.localize(0,null):X.viewInfo.ariaLabel,renderLineNumbers:X.viewInfo.renderLineNumbers,renderCustomLineNumbers:X.viewInfo.renderCustomLineNumbers,selectOnLineNumbers:X.viewInfo.selectOnLineNumbers,glyphMargin:X.viewInfo.glyphMargin,revealHorizontalRightPadding:X.viewInfo.revealHorizontalRightPadding,roundedSelection:!J&&X.viewInfo.roundedSelection,overviewRulerLanes:X.viewInfo.overviewRulerLanes,overviewRulerBorder:X.viewInfo.overviewRulerBorder,cursorBlinking:X.viewInfo.cursorBlinking,mouseWheelZoom:X.viewInfo.mouseWheelZoom,cursorStyle:X.viewInfo.cursorStyle,cursorWidth:X.viewInfo.cursorWidth,hideCursorInOverviewRuler:X.viewInfo.hideCursorInOverviewRuler,scrollBeyondLastLine:X.viewInfo.scrollBeyondLastLine,scrollBeyondLastColumn:X.viewInfo.scrollBeyondLastColumn,smoothScrolling:X.viewInfo.smoothScrolling,stopRenderingLineAfter:X.viewInfo.stopRenderingLineAfter,renderWhitespace:J?"none":X.viewInfo.renderWhitespace,renderControlCharacters:!J&&X.viewInfo.renderControlCharacters,fontLigatures:!J&&X.viewInfo.fontLigatures,renderIndentGuides:!J&&X.viewInfo.renderIndentGuides,highlightActiveIndentGuide:X.viewInfo.highlightActiveIndentGuide,renderLineHighlight:X.viewInfo.renderLineHighlight,scrollbar:X.viewInfo.scrollbar,minimap:{enabled:!J&&X.viewInfo.minimap.enabled,side:X.viewInfo.minimap.side,renderCharacters:X.viewInfo.minimap.renderCharacters,showSlider:X.viewInfo.minimap.showSlider,maxColumn:X.viewInfo.minimap.maxColumn},fixedOverflowWidgets:X.viewInfo.fixedOverflowWidgets},contribInfo:{selectionClipboard:X.contribInfo.selectionClipboard,hover:X.contribInfo.hover,links:!J&&X.contribInfo.links,contextmenu:X.contribInfo.contextmenu,quickSuggestions:X.contribInfo.quickSuggestions,quickSuggestionsDelay:X.contribInfo.quickSuggestionsDelay,parameterHints:X.contribInfo.parameterHints,iconsInSuggestions:X.contribInfo.iconsInSuggestions,formatOnType:X.contribInfo.formatOnType,formatOnPaste:X.contribInfo.formatOnPaste,suggestOnTriggerCharacters:X.contribInfo.suggestOnTriggerCharacters,acceptSuggestionOnEnter:X.contribInfo.acceptSuggestionOnEnter,acceptSuggestionOnCommitCharacter:X.contribInfo.acceptSuggestionOnCommitCharacter,wordBasedSuggestions:X.contribInfo.wordBasedSuggestions,suggestSelection:X.contribInfo.suggestSelection,suggestFontSize:X.contribInfo.suggestFontSize,suggestLineHeight:X.contribInfo.suggestLineHeight,tabCompletion:X.contribInfo.tabCompletion,suggest:X.contribInfo.suggest,selectionHighlight:!J&&X.contribInfo.selectionHighlight,occurrencesHighlight:!J&&X.contribInfo.occurrencesHighlight,codeLens:!J&&X.contribInfo.codeLens,folding:!J&&X.contribInfo.folding,foldingStrategy:X.contribInfo.foldingStrategy,showFoldingControls:X.contribInfo.showFoldingControls,matchBrackets:!J&&X.contribInfo.matchBrackets,find:X.contribInfo.find,colorDecorators:X.contribInfo.colorDecorators,lightbulbEnabled:X.contribInfo.lightbulbEnabled,codeActionsOnSave:X.contribInfo.codeActionsOnSave,codeActionsOnSaveTimeout:X.contribInfo.codeActionsOnSaveTimeout}}},e.createInternalEditorOptions=function(X,$){var Q;Q="auto"===$.accessibilitySupport?X.accessibilitySupport:"on"===$.accessibilitySupport?2:1;var J,ee=this._tweakValidatedOptions($,Q);J="string"==typeof ee.lineDecorationsWidth&&/^\d+(\.\d+)?ch$/.test(ee.lineDecorationsWidth)?parseFloat(ee.lineDecorationsWidth.substr(0,ee.lineDecorationsWidth.length-2))*X.fontInfo.typicalHalfwidthCharacterWidth:c(ee.lineDecorationsWidth,0,0,1e3),ee.contribInfo.folding&&(J+=16);var te,ne=le.compute({outerWidth:X.outerWidth,outerHeight:X.outerHeight,showGlyphMargin:ee.viewInfo.glyphMargin,lineHeight:X.fontInfo.lineHeight,showLineNumbers:0!==ee.viewInfo.renderLineNumbers,lineNumbersMinChars:ee.lineNumbersMinChars,lineNumbersDigitCount:X.lineNumbersDigitCount,lineDecorationsWidth:J,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,verticalScrollbarWidth:ee.viewInfo.scrollbar.verticalScrollbarSize,horizontalScrollbarHeight:ee.viewInfo.scrollbar.horizontalScrollbarSize,scrollbarArrowSize:ee.viewInfo.scrollbar.arrowSize,verticalScrollbarHasArrows:ee.viewInfo.scrollbar.verticalHasArrows,minimap:ee.viewInfo.minimap.enabled,minimapSide:ee.viewInfo.minimap.side,minimapRenderCharacters:ee.viewInfo.minimap.renderCharacters,minimapMaxColumn:ee.viewInfo.minimap.maxColumn,pixelRatio:X.pixelRatio}),ie=ee.wordWrap,oe=ee.wordWrapColumn,se=ee.wordWrapMinified;te=2===Q?{isWordWrapMinified:!1,isViewportWrapping:!1,wrappingColumn:-1}:se&&X.isDominatedByLongLines?{isWordWrapMinified:!0,isViewportWrapping:!0,wrappingColumn:Math.max(1,ne.viewportColumn)}:"on"===ie?{isWordWrapMinified:!1,isViewportWrapping:!0,wrappingColumn:Math.max(1,ne.viewportColumn)}:"bounded"===ie?{isWordWrapMinified:!1,isViewportWrapping:!0,wrappingColumn:Math.min(Math.max(1,ne.viewportColumn),oe)}:"wordWrapColumn"===ie?{isWordWrapMinified:!1,isViewportWrapping:!1,wrappingColumn:oe}:{isWordWrapMinified:!1,isViewportWrapping:!1,wrappingColumn:-1};var ae={inDiffEditor:ee.inDiffEditor,isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:te.isWordWrapMinified,isViewportWrapping:te.isViewportWrapping,wrappingColumn:te.wrappingColumn,wrappingIndent:ee.wrappingIndent,wordWrapBreakBeforeCharacters:ee.wordWrapBreakBeforeCharacters,wordWrapBreakAfterCharacters:ee.wordWrapBreakAfterCharacters,wordWrapBreakObtrusiveCharacters:ee.wordWrapBreakObtrusiveCharacters},ue="monaco-editor";return ee.viewInfo.extraEditorClassName&&(ue+=" "+ee.viewInfo.extraEditorClassName),X.extraEditorClassName&&(ue+=" "+X.extraEditorClassName),ee.viewInfo.fontLigatures&&(ue+=" enable-ligatures"),"default"===ee.mouseStyle?ue+=" mouse-default":"copy"===ee.mouseStyle&&(ue+=" mouse-copy"),new re({canUseLayerHinting:!ee.disableLayerHinting,pixelRatio:X.pixelRatio,editorClassName:ue,lineHeight:X.fontInfo.lineHeight,readOnly:ee.readOnly,accessibilitySupport:Q,multiCursorModifier:ee.multiCursorModifier,multiCursorMergeOverlapping:ee.multiCursorMergeOverlapping,wordSeparators:ee.wordSeparators,autoClosingBrackets:ee.autoClosingBrackets,autoClosingQuotes:ee.autoClosingQuotes,autoSurround:ee.autoSurround,autoIndent:ee.autoIndent,useTabStops:ee.useTabStops,tabFocusMode:!!ee.readOnly||X.tabFocusMode,dragAndDrop:ee.dragAndDrop,emptySelectionClipboard:ee.emptySelectionClipboard&&X.emptySelectionClipboard,copyWithSyntaxHighlighting:ee.copyWithSyntaxHighlighting,layoutInfo:ne,fontInfo:X.fontInfo,viewInfo:ee.viewInfo,wrappingInfo:ae,contribInfo:ee.contribInfo,showUnused:ee.showUnused})},e}();$.InternalEditorOptionsFactory=ae;var le=function(){function e(){}return e.compute=function(X){var $=0|X.outerWidth,Q=0|X.outerHeight,J=X.showGlyphMargin,ee=0|X.lineHeight,te=X.showLineNumbers,ne=0|X.lineNumbersMinChars,ie=0|X.lineNumbersDigitCount,oe=0|X.lineDecorationsWidth,re=X.typicalHalfwidthCharacterWidth,se=X.maxDigitWidth,ae=0|X.verticalScrollbarWidth,le=X.verticalScrollbarHasArrows,ue=0|X.scrollbarArrowSize,de=0|X.horizontalScrollbarHeight,ce=X.minimap,he=X.minimapSide,pe=X.minimapRenderCharacters,fe=0|X.minimapMaxColumn,ge=X.pixelRatio,me=0;if(te){var ve=Math.max(ie,ne);me=Math.round(ve*se)}var _e=0;J&&(_e=ee);var ye,be,Ce,we,Se=0,Ee=Se+_e,Le=Ee+me,xe=Le+oe,Ie=$-_e-me-oe;if(ce){var De=void 0;ge>=2?(ye=pe?2:4,De=2/ge):(ye=pe?1:3,De=1/ge),(Ce=Math.max(0,Math.floor((Ie-ae-2)*De/(re+De))))/De>fe&&(Ce=Math.floor(fe*De)),we=Ie-Ce,"left"===he?(be=0,Se+=Ce,Ee+=Ce,Le+=Ce,xe+=Ce):be=$-Ce-ae}else be=0,Ce=0,ye=0,we=Ie;var Ne=le?ue:0;return{width:$,height:Q,glyphMarginLeft:Se,glyphMarginWidth:_e,glyphMarginHeight:Q,lineNumbersLeft:Ee,lineNumbersWidth:me,lineNumbersHeight:Q,decorationsLeft:Le,decorationsWidth:oe,decorationsHeight:Q,contentLeft:xe,contentWidth:we,contentHeight:Q,renderMinimap:ye,minimapLeft:be,minimapWidth:Ce,viewportColumn:Math.max(1,Math.floor((we-ae-2)/re)),verticalScrollbarWidth:ae,horizontalScrollbarHeight:de,overviewRuler:{top:Ne,width:ae,height:Q-2*Ne,right:0}}},e}();$.EditorLayoutProvider=le,$.EDITOR_FONT_DEFAULTS={fontFamily:te.isMacintosh?"Menlo, Monaco, 'Courier New', monospace":te.isLinux?"'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'":"Consolas, 'Courier New', monospace",fontWeight:"normal",fontSize:te.isMacintosh?12:14,lineHeight:0,letterSpacing:0},$.EDITOR_MODEL_DEFAULTS={tabSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},$.EDITOR_DEFAULTS={inDiffEditor:!1,wordSeparators:ne.USUAL_WORD_SEPARATORS,lineNumbersMinChars:5,lineDecorationsWidth:10,readOnly:!1,mouseStyle:"text",disableLayerHinting:!1,automaticLayout:!1,wordWrap:"off",wordWrapColumn:80,wordWrapMinified:!0,wrappingIndent:1,wordWrapBreakBeforeCharacters:"([{‘“〈《「『【〔（［｛｢£¥＄￡￥+＋",wordWrapBreakAfterCharacters:" \t})]?|&,;¢°′″‰℃、。｡､￠，．：；？！％・･ゝゞヽヾーァィゥェォッャュョヮヵヶぁぃぅぇぉっゃゅょゎゕゖㇰㇱㇲㇳㇴㇵㇶㇷㇸㇹㇺㇻㇼㇽㇾㇿ々〻ｧｨｩｪｫｬｭｮｯｰ”〉》」』】〕）］｝｣",wordWrapBreakObtrusiveCharacters:".",autoClosingBrackets:"languageDefined",autoClosingQuotes:"languageDefined",autoSurround:"languageDefined",autoIndent:!0,dragAndDrop:!0,emptySelectionClipboard:!0,copyWithSyntaxHighlighting:!0,useTabStops:!0,multiCursorModifier:"altKey",multiCursorMergeOverlapping:!0,accessibilitySupport:"auto",showUnused:!0,viewInfo:{extraEditorClassName:"",disableMonospaceOptimizations:!1,rulers:[],ariaLabel:Q.localize(1,null),renderLineNumbers:1,renderCustomLineNumbers:null,selectOnLineNumbers:!0,glyphMargin:!0,revealHorizontalRightPadding:30,roundedSelection:!0,overviewRulerLanes:2,overviewRulerBorder:!0,cursorBlinking:1,mouseWheelZoom:!1,cursorStyle:oe.Line,cursorWidth:0,hideCursorInOverviewRuler:!1,scrollBeyondLastLine:!0,scrollBeyondLastColumn:5,smoothScrolling:!1,stopRenderingLineAfter:1e4,renderWhitespace:"none",renderControlCharacters:!1,fontLigatures:!1,renderIndentGuides:!0,highlightActiveIndentGuide:!0,renderLineHighlight:"line",scrollbar:{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:10,horizontalSliderSize:10,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,mouseWheelScrollSensitivity:1},minimap:{enabled:!0,side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120},fixedOverflowWidgets:!1},contribInfo:{selectionClipboard:!0,hover:{enabled:!0,delay:300,sticky:!0},links:!0,contextmenu:!0,quickSuggestions:{other:!0,comments:!1,strings:!1},quickSuggestionsDelay:10,parameterHints:{enabled:!0,cycle:!1},iconsInSuggestions:!0,formatOnType:!1,formatOnPaste:!1,suggestOnTriggerCharacters:!0,acceptSuggestionOnEnter:"on",acceptSuggestionOnCommitCharacter:!0,wordBasedSuggestions:!0,suggestSelection:"recentlyUsed",suggestFontSize:0,suggestLineHeight:0,tabCompletion:"off",suggest:{filterGraceful:!0,snippets:"inline",snippetsPreventQuickSuggestions:!0,localityBonus:!1},selectionHighlight:!0,occurrencesHighlight:!0,codeLens:!0,folding:!0,foldingStrategy:"auto",showFoldingControls:"mouseover",matchBrackets:!0,find:{seedSearchStringFromSelection:!0,autoFindInSelection:!1,globalFindClipboard:!1},colorDecorators:!0,lightbulbEnabled:!0,codeActionsOnSave:{},codeActionsOnSaveTimeout:750}}})),define(Q[122],n([0,1,17,48,97]),(function(X,$,Q,J,ee){function s(X,$){if("number"==typeof X)return X;if(void 0===X)return $;var Q=parseFloat(X);return isNaN(Q)?$:Q}function a(X,$,Q){return X<$?$:X>Q?Q:X}function l(X,$){return"string"!=typeof X?$:X}Object.defineProperty($,"__esModule",{value:!0});var ne=Q.isMacintosh?1.5:1.35,ie=function(){function e(X){this.zoomLevel=X.zoomLevel,this.fontFamily=String(X.fontFamily),this.fontWeight=String(X.fontWeight),this.fontSize=X.fontSize,this.lineHeight=0|X.lineHeight,this.letterSpacing=X.letterSpacing}return e.createFromRawSettings=function(X,$){var Q=l(X.fontFamily,J.EDITOR_FONT_DEFAULTS.fontFamily),te=l(X.fontWeight,J.EDITOR_FONT_DEFAULTS.fontWeight),ie=s(X.fontSize,J.EDITOR_FONT_DEFAULTS.fontSize);0===(ie=a(ie,0,100))?ie=J.EDITOR_FONT_DEFAULTS.fontSize:ie<8&&(ie=8);var oe=function(X,$){if("number"==typeof X)return Math.round(X);if(void 0===X)return 0;var Q=parseInt(X);return isNaN(Q)?0:Q}(X.lineHeight);0===(oe=a(oe,0,150))?oe=Math.round(ne*ie):oe<8&&(oe=8);var re=s(X.letterSpacing,0);re=a(re,-5,20);var se=1+.1*ee.EditorZoom.getZoomLevel();return new e({zoomLevel:$,fontFamily:Q,fontWeight:te,fontSize:ie*=se,lineHeight:oe*=se,letterSpacing:re})},e.prototype.getId=function(){return this.zoomLevel+"-"+this.fontFamily+"-"+this.fontWeight+"-"+this.fontSize+"-"+this.lineHeight+"-"+this.letterSpacing},e.prototype.getMassagedFontFamily=function(){return/[,"']/.test(this.fontFamily)?this.fontFamily:/[+ ]/.test(this.fontFamily)?'"'+this.fontFamily+'"':this.fontFamily},e}();$.BareFontInfo=ie;var oe=function(X){function t($,Q){var J=X.call(this,$)||this;return J.isTrusted=Q,J.isMonospace=$.isMonospace,J.typicalHalfwidthCharacterWidth=$.typicalHalfwidthCharacterWidth,J.typicalFullwidthCharacterWidth=$.typicalFullwidthCharacterWidth,J.canUseHalfwidthRightwardsArrow=$.canUseHalfwidthRightwardsArrow,J.spaceWidth=$.spaceWidth,J.maxDigitWidth=$.maxDigitWidth,J}return te(t,X),t.prototype.equals=function(X){return this.fontFamily===X.fontFamily&&this.fontWeight===X.fontWeight&&this.fontSize===X.fontSize&&this.lineHeight===X.lineHeight&&this.letterSpacing===X.letterSpacing&&this.typicalHalfwidthCharacterWidth===X.typicalHalfwidthCharacterWidth&&this.typicalFullwidthCharacterWidth===X.typicalFullwidthCharacterWidth&&this.canUseHalfwidthRightwardsArrow===X.canUseHalfwidthRightwardsArrow&&this.spaceWidth===X.spaceWidth&&this.maxDigitWidth===X.maxDigitWidth},t}(ie);$.FontInfo=oe})),define(Q[297],n([5,4]),(function(X,$){return X.create("vs/editor/common/controller/cursor",$)})),define(Q[298],n([5,4]),(function(X,$){return X.create("vs/editor/common/modes/modesRegistry",$)})),define(Q[299],n([5,4]),(function(X,$){return X.create("vs/editor/common/services/modelServiceImpl",$)})),define(Q[300],n([5,4]),(function(X,$){return X.create("vs/editor/common/view/editorColorRegistry",$)})),define(Q[301],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/bracketMatching/bracketMatching",$)})),define(Q[302],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/caretOperations/caretOperations",$)})),define(Q[303],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/caretOperations/transpose",$)})),define(Q[304],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/clipboard/clipboard",$)})),define(Q[305],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/codeAction/codeActionCommands",$)})),define(Q[306],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/comment/comment",$)})),define(Q[307],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/contextmenu/contextmenu",$)})),define(Q[308],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/cursorUndo/cursorUndo",$)})),define(Q[309],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/find/findController",$)})),define(Q[310],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/find/findWidget",$)})),define(Q[311],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/folding/folding",$)})),define(Q[312],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/fontZoom/fontZoom",$)})),define(Q[313],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/format/formatActions",$)})),define(Q[314],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/goToDefinition/goToDefinitionCommands",$)})),define(Q[315],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/goToDefinition/goToDefinitionMouse",$)})),define(Q[316],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/gotoError/gotoError",$)})),define(Q[317],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/gotoError/gotoErrorWidget",$)})),define(Q[318],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/hover/hover",$)})),define(Q[319],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/hover/modesContentHover",$)})),define(Q[320],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/inPlaceReplace/inPlaceReplace",$)})),define(Q[321],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/linesOperations/linesOperations",$)})),define(Q[322],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/links/links",$)})),define(Q[323],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/message/messageController",$)})),define(Q[324],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/multicursor/multicursor",$)})),define(Q[325],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/parameterHints/parameterHints",$)})),define(Q[326],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/parameterHints/parameterHintsWidget",$)})),define(Q[327],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/referenceSearch/peekViewWidget",$)})),define(Q[328],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/referenceSearch/referenceSearch",$)})),define(Q[329],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/referenceSearch/referencesController",$)})),define(Q[330],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/referenceSearch/referencesModel",$)})),define(Q[123],n([0,1,330,6,58,2,8,110,3]),(function(X,$,Q,J,ee,te,ne,ie,oe){Object.defineProperty($,"__esModule",{value:!0});var re=function(){function e(X,$){this.parent=X,this._range=$,this._onRefChanged=new J.Emitter,this.onRefChanged=this._onRefChanged.event,this.id=ie.defaultGenerator.nextId()}return Object.defineProperty(e.prototype,"uri",{get:function(){return this.parent.uri},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"range",{get:function(){return this._range},set:function(X){this._range=X,this._onRefChanged.fire(this)},enumerable:!0,configurable:!0}),e.prototype.getAriaMessage=function(){return Q.localize(0,null,ee.basename(this.uri.fsPath),this.range.startLineNumber,this.range.startColumn)},e}();$.OneReference=re;var se=function(){function e(X){this._modelReference=X}return e.prototype.dispose=function(){te.dispose(this._modelReference)},e.prototype.preview=function(X,$){void 0===$&&($=8);var Q=this._modelReference.object.textEditorModel;if(Q){var J=X.startLineNumber,ee=X.startColumn,te=X.endLineNumber,ie=X.endColumn,re=Q.getWordUntilPosition({lineNumber:J,column:ee-$}),se=new oe.Range(J,re.startColumn,J,ee),ae=new oe.Range(te,ie,te,Number.MAX_VALUE);return{before:Q.getValueInRange(se).replace(/^\s+/,ne.empty),inside:Q.getValueInRange(X),after:Q.getValueInRange(ae).replace(/\s+$/,ne.empty)}}},e}();$.FilePreview=se;var ae=function(){function e(X,$){this._parent=X,this._uri=$,this._children=[]}return Object.defineProperty(e.prototype,"id",{get:function(){return this._uri.toString()},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"parent",{get:function(){return this._parent},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"children",{get:function(){return this._children},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"uri",{get:function(){return this._uri},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"preview",{get:function(){return this._preview},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"failure",{get:function(){return this._loadFailure},enumerable:!0,configurable:!0}),e.prototype.getAriaMessage=function(){var X=this.children.length;return 1===X?Q.localize(1,null,ee.basename(this.uri.fsPath),this.uri.fsPath):Q.localize(2,null,X,ee.basename(this.uri.fsPath),this.uri.fsPath)},e.prototype.resolve=function(X){var $=this;return this._resolved?Promise.resolve(this):Promise.resolve(X.createModelReference(this._uri).then((function(X){if(!X.object)throw X.dispose(),new Error;return $._preview=new se(X),$._resolved=!0,$}),(function(X){return $._children=[],$._resolved=!0,$._loadFailure=X,$})))},e.prototype.dispose=function(){this._preview&&(this._preview.dispose(),this._preview=void 0)},e}();$.FileReferences=ae;var le=function(){function e(X){var $=this;this.groups=[],this.references=[],this._onDidChangeReferenceRange=new J.Emitter,this.onDidChangeReferenceRange=this._onDidChangeReferenceRange.event,this._disposables=[],X.sort(e._compareReferences);for(var Q,ee=0,te=X;ee<te.length;ee++){var ne=te[ee];if(Q&&Q.uri.toString()===ne.uri.toString()||(Q=new ae(this,ne.uri),this.groups.push(Q)),0===Q.children.length||!oe.Range.equalsRange(ne.range,Q.children[Q.children.length-1].range)){var ie=new re(Q,ne.range);this._disposables.push(ie.onRefChanged((function(X){return $._onDidChangeReferenceRange.fire(X)}))),this.references.push(ie),Q.children.push(ie)}}}return Object.defineProperty(e.prototype,"empty",{get:function(){return 0===this.groups.length},enumerable:!0,configurable:!0}),e.prototype.getAriaMessage=function(){return this.empty?Q.localize(3,null):1===this.references.length?Q.localize(4,null,this.references[0].uri.fsPath):1===this.groups.length?Q.localize(5,null,this.references.length,this.groups[0].uri.fsPath):Q.localize(6,null,this.references.length,this.groups.length)},e.prototype.nextOrPreviousReference=function(X,$){var Q=X.parent,J=Q.children.indexOf(X),ee=Q.children.length,te=Q.parent.groups.length;return 1===te||$&&J+1<ee||!$&&J>0?(J=$?(J+1)%ee:(J+ee-1)%ee,Q.children[J]):(J=Q.parent.groups.indexOf(Q),$?(J=(J+1)%te,Q.parent.groups[J].children[0]):(J=(J+te-1)%te,Q.parent.groups[J].children[Q.parent.groups[J].children.length-1]))},e.prototype.nearestReference=function(X,$){var Q=this.references.map((function(Q,J){return{idx:J,prefixLen:ne.commonPrefixLength(Q.uri.toString(),X.toString()),offsetDist:100*Math.abs(Q.range.startLineNumber-$.lineNumber)+Math.abs(Q.range.startColumn-$.column)}})).sort((function(X,$){return X.prefixLen>$.prefixLen?-1:X.prefixLen<$.prefixLen?1:X.offsetDist<$.offsetDist?-1:X.offsetDist>$.offsetDist?1:0}))[0];if(Q)return this.references[Q.idx]},e.prototype.dispose=function(){te.dispose(this.groups),te.dispose(this._disposables),this.groups.length=0,this._disposables.length=0},e._compareReferences=function(X,$){var Q=X.uri.toString(),J=$.uri.toString();return Q<J?-1:Q>J?1:oe.Range.compareRangesUsingStarts(X.range,$.range)},e}();$.ReferencesModel=le})),define(Q[332],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/referenceSearch/referencesWidget",$)})),define(Q[333],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/rename/rename",$)})),define(Q[334],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/rename/renameInputField",$)})),define(Q[335],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/smartSelect/smartSelect",$)})),define(Q[336],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/snippet/snippetVariables",$)})),define(Q[337],n([0,1,336,58,111,8]),(function(X,$,Q,J,ee,te){Object.defineProperty($,"__esModule",{value:!0});var ne=function(){function e(X){this._delegates=X}return e.prototype.resolve=function(X){for(var $=0,Q=this._delegates;$<Q.length;$++){var J=Q[$].resolve(X);if(void 0!==J)return J}},e}();$.CompositeSnippetVariableResolver=ne;var ie=function(){function e(X,$){this._model=X,this._selection=$}return e.prototype.resolve=function(X){var $=X.name;if("SELECTION"===$||"TM_SELECTED_TEXT"===$){var Q=this._model.getValueInRange(this._selection)||void 0;if(Q&&this._selection.startLineNumber!==this._selection.endLineNumber){var J=this._model.getLineContent(this._selection.startLineNumber),ne=te.getLeadingWhitespace(J,0,this._selection.startColumn-1),ie=ne;X.snippet.walk((function($){return $!==X&&($ instanceof ee.Text&&(ie=te.getLeadingWhitespace($.value.split(/\r\n|\r|\n/).pop())),!0)}));var oe=te.commonPrefixLength(ie,ne);Q=Q.replace(/(\r\n|\r|\n)(.*)/g,(function(X,$,Q){return""+$+ie.substr(oe)+Q}))}return Q}if("TM_CURRENT_LINE"===$)return this._model.getLineContent(this._selection.positionLineNumber);if("TM_CURRENT_WORD"===$){var re=this._model.getWordAtPosition({lineNumber:this._selection.positionLineNumber,column:this._selection.positionColumn});return re&&re.word||void 0}return"TM_LINE_INDEX"===$?String(this._selection.positionLineNumber-1):"TM_LINE_NUMBER"===$?String(this._selection.positionLineNumber):void 0},e}();$.SelectionBasedVariableResolver=ie;var oe=function(){function e(X){this._model=X}return e.prototype.resolve=function(X){var $=X.name;if("TM_FILENAME"===$)return J.basename(this._model.uri.fsPath);if("TM_FILENAME_BASE"===$){var Q=J.basename(this._model.uri.fsPath),ee=Q.lastIndexOf(".");return ee<=0?Q:Q.slice(0,ee)}if("TM_DIRECTORY"===$){var te=J.dirname(this._model.uri.fsPath);return"."!==te?te:""}return"TM_FILEPATH"===$?this._model.uri.fsPath:void 0},e}();$.ModelBasedVariableResolver=oe;var re=function(){function e(X,$,Q){this._clipboardService=X,this._selectionIdx=$,this._selectionCount=Q}return e.prototype.resolve=function(X){if("CLIPBOARD"===X.name&&this._clipboardService){var $=this._clipboardService.readText();if($){var Q=$.split(/\r\n|\n|\r/).filter((function(X){return!te.isFalsyOrWhitespace(X)}));return Q.length===this._selectionCount?Q[this._selectionIdx]:$}}},e}();$.ClipboardBasedVariableResolver=re;var se=function(){function e(){}return e.prototype.resolve=function(X){var $=X.name;return"CURRENT_YEAR"===$?String((new Date).getFullYear()):"CURRENT_YEAR_SHORT"===$?String((new Date).getFullYear()).slice(-2):"CURRENT_MONTH"===$?te.pad((new Date).getMonth().valueOf()+1,2):"CURRENT_DATE"===$?te.pad((new Date).getDate().valueOf(),2):"CURRENT_HOUR"===$?te.pad((new Date).getHours().valueOf(),2):"CURRENT_MINUTE"===$?te.pad((new Date).getMinutes().valueOf(),2):"CURRENT_SECOND"===$?te.pad((new Date).getSeconds().valueOf(),2):"CURRENT_DAY_NAME"===$?e.dayNames[(new Date).getDay()]:"CURRENT_DAY_NAME_SHORT"===$?e.dayNamesShort[(new Date).getDay()]:"CURRENT_MONTH_NAME"===$?e.monthNames[(new Date).getMonth()]:"CURRENT_MONTH_NAME_SHORT"===$?e.monthNamesShort[(new Date).getMonth()]:void 0},e.dayNames=[Q.localize(0,null),Q.localize(1,null),Q.localize(2,null),Q.localize(3,null),Q.localize(4,null),Q.localize(5,null),Q.localize(6,null)],e.dayNamesShort=[Q.localize(7,null),Q.localize(8,null),Q.localize(9,null),Q.localize(10,null),Q.localize(11,null),Q.localize(12,null),Q.localize(13,null)],e.monthNames=[Q.localize(14,null),Q.localize(15,null),Q.localize(16,null),Q.localize(17,null),Q.localize(18,null),Q.localize(19,null),Q.localize(20,null),Q.localize(21,null),Q.localize(22,null),Q.localize(23,null),Q.localize(24,null),Q.localize(25,null)],e.monthNamesShort=[Q.localize(26,null),Q.localize(27,null),Q.localize(28,null),Q.localize(29,null),Q.localize(30,null),Q.localize(31,null),Q.localize(32,null),Q.localize(33,null),Q.localize(34,null),Q.localize(35,null),Q.localize(36,null),Q.localize(37,null)],e}();$.TimeBasedVariableResolver=se})),define(Q[338],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/suggest/suggestController",$)})),define(Q[339],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/suggest/suggestWidget",$)})),define(Q[340],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/toggleTabFocusMode/toggleTabFocusMode",$)})),define(Q[341],n([5,4]),(function(X,$){return X.create("vs/editor/contrib/wordHighlighter/wordHighlighter",$)})),define(Q[342],n([5,4]),(function(X,$){return X.create("vs/editor/standalone/browser/accessibilityHelp/accessibilityHelp",$)})),define(Q[343],n([5,4]),(function(X,$){return X.create("vs/editor/standalone/browser/inspectTokens/inspectTokens",$)})),define(Q[344],n([5,4]),(function(X,$){return X.create("vs/editor/standalone/browser/quickOpen/gotoLine",$)})),define(Q[345],n([5,4]),(function(X,$){return X.create("vs/editor/standalone/browser/quickOpen/quickCommand",$)})),define(Q[346],n([5,4]),(function(X,$){return X.create("vs/editor/standalone/browser/quickOpen/quickOutline",$)})),define(Q[347],n([5,4]),(function(X,$){return X.create("vs/editor/standalone/browser/simpleServices",$)})),define(Q[348],n([5,4]),(function(X,$){return X.create("vs/editor/standalone/browser/standaloneCodeEditor",$)})),define(Q[349],n([5,4]),(function(X,$){return X.create("vs/editor/standalone/browser/toggleHighContrast/toggleHighContrast",$)})),define(Q[350],n([5,4]),(function(X,$){return X.create("vs/platform/configuration/common/configurationRegistry",$)})),define(Q[351],n([5,4]),(function(X,$){return X.create("vs/platform/keybinding/common/abstractKeybindingService",$)})),define(Q[352],n([5,4]),(function(X,$){return X.create("vs/platform/list/browser/listService",$)})),define(Q[353],n([5,4]),(function(X,$){return X.create("vs/platform/markers/common/markers",$)})),define(Q[354],n([5,4]),(function(X,$){return X.create("vs/platform/theme/common/colorRegistry",$)})),define(Q[162],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0}),function(X){X[X.FILE=0]="FILE",X[X.FOLDER=1]="FOLDER",X[X.ROOT_FOLDER=2]="ROOT_FOLDER"}($.FileKind||($.FileKind={}))})),define(Q[356],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var n=function(X,$,Q){void 0===$&&($=[]),void 0===Q&&(Q=!1),this.ctor=X,this.staticArguments=$,this.supportsDelayedInstantiation=Q};$.SyncDescriptor=n})),define(Q[357],n([0,1,32,226]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(){function e(X){this._hashFn=X,this._nodes=Object.create(null)}return e.prototype.roots=function(){var X=[];return J.forEach(this._nodes,(function($){Q.isEmptyObject($.value.outgoing)&&X.push($.value)})),X},e.prototype.insertEdge=function(X,$){var Q=this.lookupOrInsertNode(X),J=this.lookupOrInsertNode($);Q.outgoing[this._hashFn($)]=J,J.incoming[this._hashFn(X)]=Q},e.prototype.removeNode=function(X){var $=this._hashFn(X);delete this._nodes[$],J.forEach(this._nodes,(function(X){delete X.value.outgoing[$],delete X.value.incoming[$]}))},e.prototype.lookupOrInsertNode=function(X){var $=this._hashFn(X),Q=this._nodes[$];return Q||(Q=function(X){return{data:X,incoming:Object.create(null),outgoing:Object.create(null)}}(X),this._nodes[$]=Q),Q},e.prototype.isEmpty=function(){for(var X in this._nodes)return!1;return!0},e.prototype.toString=function(){var X=[];return J.forEach(this._nodes,(function($){X.push($.key+", (incoming)["+Object.keys($.value.incoming).join(", ")+"], (outgoing)["+Object.keys($.value.outgoing).join(",")+"]")})),X.join("\n")},e}();$.Graph=ee})),define(Q[15],n([0,1]),(function(X,$){function n(X,$,J,ee){$[Q.DI_TARGET]===$?$[Q.DI_DEPENDENCIES].push({id:X,index:J,optional:ee}):($[Q.DI_DEPENDENCIES]=[{id:X,index:J,optional:ee}],$[Q.DI_TARGET]=$)}function i(X){if(Q.serviceIds.has(X))return Q.serviceIds.get(X);var t=function(X,$,Q){if(3!==arguments.length)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(t,X,Q,!1)};return t.toString=function(){return X},Q.serviceIds.set(X,t),t}var Q;Object.defineProperty($,"__esModule",{value:!0}),function(X){X.serviceIds=new Map,X.DI_TARGET="$di$target",X.DI_DEPENDENCIES="$di$dependencies",X.getServiceDependencies=function($){return $[X.DI_DEPENDENCIES]||[]}}(Q=$._util||($._util={})),$.IInstantiationService=i("instantiationService"),$.createDecorator=i,$.optional=function(X){return function($,Q,J){if(3!==arguments.length)throw new Error("@optional-decorator can only be used to decorate a parameter");n(X,$,J,!0)}}})),define(Q[126],n([0,1,15]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),$.IBulkEditService=Q.createDecorator("IWorkspaceEditService")})),define(Q[30],n([0,1,15]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),$.ICodeEditorService=Q.createDecorator("codeEditorService")})),define(Q[64],n([0,1,15]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),$.ID_EDITOR_WORKER_SERVICE="editorWorkerService",$.IEditorWorkerService=Q.createDecorator($.ID_EDITOR_WORKER_SERVICE)})),define(Q[63],n([0,1,15]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),$.IModeService=Q.createDecorator("modeService")})),define(Q[42],n([0,1,15]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),$.IModelService=Q.createDecorator("modelService"),$.shouldSynchronizeModel=function(X){return!X.isTooLargeForSyncing()&&!X.isForSimpleWidget}})),define(Q[364],n([0,1,6,2,515,42]),(function(X,$,Q,J,ee,te){function s(X){return"string"!=typeof X&&(Array.isArray(X)?X.every(s):!!X.exclusive)}Object.defineProperty($,"__esModule",{value:!0});var ne=function(){function e(){this._clock=0,this._entries=[],this._onDidChange=new Q.Emitter}return Object.defineProperty(e.prototype,"onDidChange",{get:function(){return this._onDidChange.event},enumerable:!0,configurable:!0}),e.prototype.register=function(X,$){var Q=this,ee={selector:X,provider:$,_score:-1,_time:this._clock++};return this._entries.push(ee),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),J.toDisposable((function(){if(ee){var X=Q._entries.indexOf(ee);X>=0&&(Q._entries.splice(X,1),Q._lastCandidate=void 0,Q._onDidChange.fire(Q._entries.length),ee=void 0)}}))},e.prototype.has=function(X){return this.all(X).length>0},e.prototype.all=function(X){if(!X)return[];this._updateScores(X);for(var $=[],Q=0,J=this._entries;Q<J.length;Q++){var ee=J[Q];ee._score>0&&$.push(ee.provider)}return $},e.prototype.ordered=function(X){var $=[];return this._orderedForEach(X,(function(X){return $.push(X.provider)})),$},e.prototype.orderedGroups=function(X){var $,Q,J=[];return this._orderedForEach(X,(function(X){$&&Q===X._score?$.push(X.provider):(Q=X._score,$=[X.provider],J.push($))})),J},e.prototype._orderedForEach=function(X,$){if(X){this._updateScores(X);for(var Q=0;Q<this._entries.length;Q++){var J=this._entries[Q];J._score>0&&$(J)}}},e.prototype._updateScores=function(X){var $={uri:X.uri.toString(),language:X.getLanguageIdentifier().language};if(!this._lastCandidate||this._lastCandidate.language!==$.language||this._lastCandidate.uri!==$.uri){this._lastCandidate=$;for(var Q=0,J=this._entries;Q<J.length;Q++){var ne=J[Q];if(ne._score=ee.score(ne.selector,X.uri,X.getLanguageIdentifier().language,te.shouldSynchronizeModel(X)),s(ne.selector)&&ne._score>0){for(var ie=0,oe=this._entries;ie<oe.length;ie++)oe[ie]._score=0;ne._score=1e3;break}}this._entries.sort(e._compareByScoreAndTime)}},e._compareByScoreAndTime=function(X,$){return X._score<$._score?1:X._score>$._score?-1:X._time<$._time?1:X._time>$._time?-1:0},e}();$.LanguageFeatureRegistry=ne})),define(Q[14],n([0,1,32,364,561]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var r=function(X,$){this.language=X,this.id=$};$.LanguageIdentifier=r;var te=function(){function e(){}return e.getLanguageId=function(X){return(255&X)>>>0},e.getTokenType=function(X){return(1792&X)>>>8},e.getFontStyle=function(X){return(14336&X)>>>11},e.getForeground=function(X){return(8372224&X)>>>14},e.getBackground=function(X){return(4286578688&X)>>>23},e.getClassNameFromMetadata=function(X){var $="mtk"+this.getForeground(X),Q=this.getFontStyle(X);return 1&Q&&($+=" mtki"),2&Q&&($+=" mtkb"),4&Q&&($+=" mtku"),$},e.getInlineStyleFromMetadata=function(X,$){var Q=this.getForeground(X),J=this.getFontStyle(X),ee="color: "+$[Q]+";";return 1&J&&(ee+="font-style: italic;"),2&J&&(ee+="font-weight: bold;"),4&J&&(ee+="text-decoration: underline;"),ee},e}();$.TokenMetadata=te,$.completionKindToCssClass=function(){var X=Object.create(null);return X[0]="method",X[1]="function",X[2]="constructor",X[3]="field",X[4]="variable",X[5]="class",X[6]="struct",X[7]="interface",X[8]="module",X[9]="property",X[10]="event",X[11]="operator",X[12]="unit",X[13]="value",X[14]="constant",X[15]="enum",X[16]="enum-member",X[17]="keyword",X[25]="snippet",X[18]="text",X[19]="color",X[20]="file",X[21]="reference",X[22]="customcolor",X[23]="folder",X[24]="type-parameter",function($){return X[$]||"property"}}(),$.completionKindFromLegacyString=function(){var X=Object.create(null);return X.method=0,X.function=1,X.constructor=2,X.field=3,X.variable=4,X.class=5,X.struct=6,X.interface=7,X.module=8,X.property=9,X.event=10,X.operator=11,X.unit=12,X.value=13,X.constant=14,X.enum=15,X["enum-member"]=16,X.keyword=17,X.snippet=25,X.text=18,X.color=19,X.file=20,X.reference=21,X.customcolor=22,X.folder=23,X["type-parameter"]=24,function($){return X[$]||"property"}}(),function(X){X[X.Invoke=1]="Invoke",X[X.TriggerCharacter=2]="TriggerCharacter",X[X.ContentChange=3]="ContentChange"}($.SignatureHelpTriggerReason||($.SignatureHelpTriggerReason={})),function(X){X[X.Text=0]="Text",X[X.Read=1]="Read",X[X.Write=2]="Write"}($.DocumentHighlightKind||($.DocumentHighlightKind={})),$.symbolKindToCssClass=function(){var X=Object.create(null);return X[0]="file",X[1]="module",X[2]="namespace",X[3]="package",X[4]="class",X[5]="method",X[6]="property",X[7]="field",X[8]="constructor",X[9]="enum",X[10]="interface",X[11]="function",X[12]="variable",X[13]="constant",X[14]="string",X[15]="number",X[16]="boolean",X[17]="array",X[18]="object",X[19]="key",X[20]="null",X[21]="enum-member",X[22]="struct",X[23]="event",X[24]="operator",X[25]="type-parameter",function($){return"symbol-icon "+(X[$]||"property")}}();var ne=function(){function e(X){this.value=X}return e.Comment=new e("comment"),e.Imports=new e("imports"),e.Region=new e("region"),e}();$.FoldingRangeKind=ne,$.isResourceTextEdit=function(X){return Q.isObject(X)&&X.resource&&Array.isArray(X.edits)},$.ReferenceProviderRegistry=new J.LanguageFeatureRegistry,$.RenameProviderRegistry=new J.LanguageFeatureRegistry,$.CompletionProviderRegistry=new J.LanguageFeatureRegistry,$.SignatureHelpProviderRegistry=new J.LanguageFeatureRegistry,$.HoverProviderRegistry=new J.LanguageFeatureRegistry,$.DocumentSymbolProviderRegistry=new J.LanguageFeatureRegistry,$.DocumentHighlightProviderRegistry=new J.LanguageFeatureRegistry,$.DefinitionProviderRegistry=new J.LanguageFeatureRegistry,$.ImplementationProviderRegistry=new J.LanguageFeatureRegistry,$.TypeDefinitionProviderRegistry=new J.LanguageFeatureRegistry,$.CodeLensProviderRegistry=new J.LanguageFeatureRegistry,$.CodeActionProviderRegistry=new J.LanguageFeatureRegistry,$.DocumentFormattingEditProviderRegistry=new J.LanguageFeatureRegistry,$.DocumentRangeFormattingEditProviderRegistry=new J.LanguageFeatureRegistry,$.OnTypeFormattingEditProviderRegistry=new J.LanguageFeatureRegistry,$.LinkProviderRegistry=new J.LanguageFeatureRegistry,$.ColorProviderRegistry=new J.LanguageFeatureRegistry,$.FoldingRangeProviderRegistry=new J.LanguageFeatureRegistry,$.TokenizationRegistry=new ee.TokenizationRegistryImpl})),define(Q[93],n([0,1,14]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(){function e(X,$){this._tokens=X,this._tokensCount=this._tokens.length>>>1,this._text=$}return e.prototype.equals=function(X){return X instanceof e&&this.slicedEquals(X,0,this._tokensCount)},e.prototype.slicedEquals=function(X,$,Q){if(this._text!==X._text)return!1;if(this._tokensCount!==X._tokensCount)return!1;for(var J=$<<1,ee=J+(Q<<1),te=J;te<ee;te++)if(this._tokens[te]!==X._tokens[te])return!1;return!0},e.prototype.getLineContent=function(){return this._text},e.prototype.getCount=function(){return this._tokensCount},e.prototype.getStartOffset=function(X){return X>0?this._tokens[X-1<<1]:0},e.prototype.getLanguageId=function(X){var $=this._tokens[1+(X<<1)];return Q.TokenMetadata.getLanguageId($)},e.prototype.getStandardTokenType=function(X){var $=this._tokens[1+(X<<1)];return Q.TokenMetadata.getTokenType($)},e.prototype.getForeground=function(X){var $=this._tokens[1+(X<<1)];return Q.TokenMetadata.getForeground($)},e.prototype.getClassName=function(X){var $=this._tokens[1+(X<<1)];return Q.TokenMetadata.getClassNameFromMetadata($)},e.prototype.getInlineStyle=function(X,$){var J=this._tokens[1+(X<<1)];return Q.TokenMetadata.getInlineStyleFromMetadata(J,$)},e.prototype.getEndOffset=function(X){return this._tokens[X<<1]},e.prototype.findTokenIndexAtOffset=function(X){return e.findIndexInTokensArray(this._tokens,X)},e.prototype.inflate=function(){return this},e.prototype.sliceAndInflate=function(X,$,Q){return new ee(this,X,$,Q)},e.convertToEndOffset=function(X,$){for(var Q=(X.length>>>1)-1,J=0;J<Q;J++)X[J<<1]=X[J+1<<1];X[Q<<1]=$},e.findIndexInTokensArray=function(X,$){if(X.length<=2)return 0;for(var Q=0,J=(X.length>>>1)-1;Q<J;){var ee=Q+Math.floor((J-Q)/2),te=X[ee<<1];if(te===$)return ee+1;te<$?Q=ee+1:te>$&&(J=ee)}return Q},e}();$.LineTokens=J;var ee=function(){function e(X,$,Q,J){this._source=X,this._startOffset=$,this._endOffset=Q,this._deltaOffset=J,this._firstTokenIndex=X.findTokenIndexAtOffset($),this._tokensCount=0;for(var ee=this._firstTokenIndex,te=X.getCount();ee<te&&!(X.getStartOffset(ee)>=Q);ee++)this._tokensCount++}return e.prototype.equals=function(X){return X instanceof e&&this._startOffset===X._startOffset&&this._endOffset===X._endOffset&&this._deltaOffset===X._deltaOffset&&this._source.slicedEquals(X._source,this._firstTokenIndex,this._tokensCount)},e.prototype.getCount=function(){return this._tokensCount},e.prototype.getForeground=function(X){return this._source.getForeground(this._firstTokenIndex+X)},e.prototype.getEndOffset=function(X){var $=this._source.getEndOffset(this._firstTokenIndex+X);return Math.min(this._endOffset,$)-this._startOffset+this._deltaOffset},e.prototype.getClassName=function(X){return this._source.getClassName(this._firstTokenIndex+X)},e.prototype.getInlineStyle=function(X,$){return this._source.getInlineStyle(this._firstTokenIndex+X,$)},e.prototype.findTokenIndexAtOffset=function(X){return this._source.findTokenIndexAtOffset(X+this._startOffset-this._deltaOffset)-this._firstTokenIndex},e}();$.SlicedLineTokens=ee})),define(Q[51],n([0,1,91,14]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(){function e(){}return e.prototype.clone=function(){return this},e.prototype.equals=function(X){return this===X},e}();$.NULL_STATE=new ee,$.NULL_MODE_ID="vs.editor.nullMode",$.NULL_LANGUAGE_IDENTIFIER=new J.LanguageIdentifier($.NULL_MODE_ID,0),$.nullTokenize=function(X,$,J,ee){return new Q.TokenizationResult([new Q.Token(ee,"",X)],J)},$.nullTokenize2=function(X,J,ee,te){var ne=new Uint32Array(2);return ne[0]=te,ne[1]=(16384|X<<0|2<<23)>>>0,new Q.TokenizationResult2(ne,null===ee?$.NULL_STATE:ee)}})),define(Q[368],n([0,1,22,11,93,12,51]),(function(X,$,Q,J,ee,te,ne){function a(X){return(16384|X<<0|2<<23)>>>0}Object.defineProperty($,"__esModule",{value:!0});var ie=new Uint32Array(0).buffer,oe=function(){function e(X){this._state=X,this._lineTokens=null,this._invalid=!0}return e.prototype.deleteBeginning=function(X){null!==this._lineTokens&&this._lineTokens!==ie&&this.delete(0,X)},e.prototype.deleteEnding=function(X){if(null!==this._lineTokens&&this._lineTokens!==ie){var $=new Uint32Array(this._lineTokens),Q=$[$.length-2];this.delete(X,Q)}},e.prototype.delete=function(X,$){if(null!==this._lineTokens&&this._lineTokens!==ie&&X!==$){var Q=new Uint32Array(this._lineTokens),J=Q.length>>>1;if(0!==X||Q[Q.length-2]!==$){var te=ee.LineTokens.findIndexInTokensArray(Q,X),ne=te>0?Q[te-1<<1]:0;if($<Q[te<<1])for(var oe=$-X,re=te;re<J;re++)Q[re<<1]-=oe;else{var se,ae;ne!==X?(Q[te<<1]=X,se=te+1<<1,ae=X):(se=te<<1,ae=ne);for(var le=$-X,ue=te+1;ue<J;ue++){var de=Q[ue<<1]-le;de>ae&&(Q[se++]=de,Q[se++]=Q[1+(ue<<1)],ae=de)}if(se!==Q.length){var ce=new Uint32Array(se);ce.set(Q.subarray(0,se),0),this._lineTokens=ce.buffer}}}else this._lineTokens=ie}},e.prototype.append=function(X){if(X!==ie)if(this._lineTokens!==ie){if(null!==this._lineTokens)if(null!==X){var $=new Uint32Array(this._lineTokens),Q=new Uint32Array(X),J=Q.length>>>1,ee=new Uint32Array($.length+Q.length);ee.set($,0);for(var te=$.length,ne=$[$.length-2],oe=0;oe<J;oe++)ee[te++]=Q[oe<<1]+ne,ee[te++]=Q[1+(oe<<1)];this._lineTokens=ee.buffer}else this._lineTokens=null}else this._lineTokens=X},e.prototype.insert=function(X,$){if(this._lineTokens){var Q=new Uint32Array(this._lineTokens),J=Q.length>>>1,te=ee.LineTokens.findIndexInTokensArray(Q,X);te>0&&(te>0?Q[te-1<<1]:0)===X&&te--;for(var ne=te;ne<J;ne++)Q[ne<<1]+=$}},e}(),re=function(){function e(X,$){if(this.languageIdentifier=X,this.tokenizationSupport=$,this._tokens=[],this.tokenizationSupport){var Q=null;try{Q=this.tokenizationSupport.getInitialState()}catch(X){J.onUnexpectedError(X),this.tokenizationSupport=null}Q&&(this._tokens[0]=new oe(Q))}this._invalidLineStartIndex=0,this._lastState=null}return Object.defineProperty(e.prototype,"inValidLineStartIndex",{get:function(){return this._invalidLineStartIndex},enumerable:!0,configurable:!0}),e.prototype.getTokens=function(X,$,Q){var J=null;if($<this._tokens.length&&this._tokens[$]&&(J=this._tokens[$]._lineTokens),null!==J&&J!==ie)return new ee.LineTokens(new Uint32Array(J),Q);var te=new Uint32Array(2);return te[0]=Q.length,te[1]=a(X),new ee.LineTokens(te,Q)},e.prototype.isCheapToTokenize=function(X){return this._invalidLineStartIndex+1>=X},e.prototype.hasLinesToTokenize=function(X){return this._invalidLineStartIndex<X.getLineCount()},e.prototype.invalidateLine=function(X){this._setIsInvalid(X,!0),X<this._invalidLineStartIndex&&(this._setIsInvalid(this._invalidLineStartIndex,!0),this._invalidLineStartIndex=X)},e.prototype._setIsInvalid=function(X,$){X<this._tokens.length&&this._tokens[X]&&(this._tokens[X]._invalid=$)},e.prototype._isInvalid=function(X){return!(X<this._tokens.length&&this._tokens[X])||this._tokens[X]._invalid},e.prototype._getState=function(X){return X<this._tokens.length&&this._tokens[X]?this._tokens[X]._state:null},e.prototype._setTokens=function(X,$,Q,J){var te;$<this._tokens.length&&this._tokens[$]?te=this._tokens[$]:(te=new oe(null),this._tokens[$]=te),0!==Q?(J&&0!==J.length||((J=new Uint32Array(2))[0]=0,J[1]=a(X)),ee.LineTokens.convertToEndOffset(J,Q),te._lineTokens=J.buffer):te._lineTokens=ie},e.prototype._setState=function(X,$){if(X<this._tokens.length&&this._tokens[X])this._tokens[X]._state=$;else{var Q=new oe($);this._tokens[X]=Q}},e.prototype.applyEdits=function(X,$,Q){for(var J=X.endLineNumber-X.startLineNumber,ee=$,ne=Math.min(J,ee);ne>=0;ne--)this.invalidateLine(X.startLineNumber+ne-1);this._acceptDeleteRange(X),this._acceptInsertText(new te.Position(X.startLineNumber,X.startColumn),$,Q)},e.prototype._acceptDeleteRange=function(X){var $=X.startLineNumber-1;if(!($>=this._tokens.length))if(X.startLineNumber!==X.endLineNumber){var Q=this._tokens[$];Q.deleteEnding(X.startColumn-1);var J=X.endLineNumber-1,ee=null;if(J<this._tokens.length){var te=this._tokens[J];te.deleteBeginning(X.endColumn-1),ee=te._lineTokens}Q.append(ee),this._tokens.splice(X.startLineNumber,X.endLineNumber-X.startLineNumber)}else{if(X.startColumn===X.endColumn)return;this._tokens[$].delete(X.startColumn-1,X.endColumn-1)}},e.prototype._acceptInsertText=function(X,$,J){if(0!==$||0!==J){var ee=X.lineNumber-1;if(!(ee>=this._tokens.length))if(0!==$){var te=this._tokens[ee];te.deleteEnding(X.column-1),te.insert(X.column-1,J);for(var ne=new Array($),ie=$-1;ie>=0;ie--)ne[ie]=new oe(null);this._tokens=Q.arrayInsert(this._tokens,X.lineNumber,ne)}else this._tokens[ee].insert(X.column-1,J)}},e.prototype._tokenizeOneLine=function(X,$){if(!this.hasLinesToTokenize(X))return X.getLineCount()+1;var Q=this._invalidLineStartIndex+1;return this._updateTokensUntilLine(X,$,Q),Q},e.prototype._tokenizeText=function(X,$,Q){var ee=null;if(this.tokenizationSupport)try{ee=this.tokenizationSupport.tokenize2($,Q,0)}catch(X){J.onUnexpectedError(X)}return ee||(ee=ne.nullTokenize2(this.languageIdentifier.id,$,Q,0)),ee},e.prototype._updateTokensUntilLine=function(X,$,Q){if(this.tokenizationSupport){for(var ee=X.getLineCount(),te=Q-1,ie=this._invalidLineStartIndex;ie<=te;ie++){var oe=ie+1,re=X.getLineContent(ie+1),se=this._getState(ie),ae=null;try{var le=se.clone();ae=this.tokenizationSupport.tokenize2(re,le,0)}catch(X){J.onUnexpectedError(X)}if(ae||(ae=ne.nullTokenize2(this.languageIdentifier.id,re,se,0)),this._setTokens(this.languageIdentifier.id,ie,re.length,ae.tokens),$.registerChangedTokens(ie+1),this._setIsInvalid(ie,!1),oe<ee){var ue=this._getState(oe);if(null!==ue&&ae.endState.equals(ue)){for(var de=ie+1;de<ee&&!this._isInvalid(de);){if(de+1<ee){if(null===this._getState(de+1))break}else if(null===this._lastState)break;de++}this._invalidLineStartIndex=Math.max(this._invalidLineStartIndex,de),ie=de-1}else this._setState(oe,ae.endState)}else this._lastState=ae.endState}this._invalidLineStartIndex=Math.max(this._invalidLineStartIndex,te+1)}else this._invalidLineStartIndex=X.getLineCount()},e}();$.ModelLinesTokens=re;var se=function(){function e(){this._ranges=[]}return e.prototype.registerChangedTokens=function(X){var $=this._ranges,Q=$.length,J=Q>0?$[Q-1]:null;J&&J.toLineNumber===X-1?J.toLineNumber++:$[Q]={fromLineNumber:X,toLineNumber:X}},e.prototype.build=function(){return 0===this._ranges.length?null:{ranges:this._ranges}},e}();$.ModelTokensChangedEventBuilder=se})),define(Q[26],n([0,1,11,6,2,205,8,25,48,12,3,21,44,471,472,479,499,483,112,368,90,14,39,51,94,96]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le,ue,de,ce,he,pe,fe,ge,me,ve,_e,ye,be,Ce,we){function I(X){var $=new pe.PieceTreeTextBufferBuilder;return $.acceptChunk(X),$.finish()}function N(X,$){return("string"==typeof X?I(X):X).create($)}function D(X){return X.replace(/[^a-z0-9\-_]/gi," ")}function M(X){return X instanceof Ie?X:Ie.createDynamic(X)}Object.defineProperty($,"__esModule",{value:!0}),$.createTextBufferFactory=I,$.createTextBuffer=N;var Se=0;$.LONG_LINE_BOUNDARY=1e4;var T=function(){throw new Error("Invalid change accessor")},Ee=function(X){function r($,Q,ee,te){void 0===te&&(te=null);var ne=X.call(this)||this;ne._onWillDispose=ne._register(new J.Emitter),ne.onWillDispose=ne._onWillDispose.event,ne._onDidChangeDecorations=ne._register(new Ne),ne.onDidChangeDecorations=ne._onDidChangeDecorations.event,ne._onDidChangeLanguage=ne._register(new J.Emitter),ne.onDidChangeLanguage=ne._onDidChangeLanguage.event,ne._onDidChangeLanguageConfiguration=ne._register(new J.Emitter),ne.onDidChangeLanguageConfiguration=ne._onDidChangeLanguageConfiguration.event,ne._onDidChangeTokens=ne._register(new J.Emitter),ne.onDidChangeTokens=ne._onDidChangeTokens.event,ne._onDidChangeOptions=ne._register(new J.Emitter),ne.onDidChangeOptions=ne._onDidChangeOptions.event,ne._eventEmitter=ne._register(new Me),Se++,ne.id="$model"+Se,ne.isForSimpleWidget=Q.isForSimpleWidget,ne._associatedResource=null==te?oe.URI.parse("inmemory://model/"+Se):te,ne._attachedEditorCount=0,ne._buffer=N($,Q.defaultEOL),ne._options=r.resolveOptions(ne._buffer,Q);var ie=ne._buffer.getLineCount(),re=ne._buffer.getValueLengthInRange(new ae.Range(1,1,ie,ne._buffer.getLineLength(ie)+1),0);return Q.largeFileOptimizations?ne._isTooLargeForTokenization=re>r.LARGE_FILE_SIZE_THRESHOLD||ie>r.LARGE_FILE_LINE_COUNT_THRESHOLD:ne._isTooLargeForTokenization=!1,ne._isTooLargeForSyncing=re>r.MODEL_SYNC_LIMIT,ne._setVersionId(1),ne._isDisposed=!1,ne._isDisposing=!1,ne._languageIdentifier=ee||be.NULL_LANGUAGE_IDENTIFIER,ne._tokenizationListener=_e.TokenizationRegistry.onDidChange((function(X){-1!==X.changedLanguages.indexOf(ne._languageIdentifier.language)&&(ne._resetTokenizationState(),ne.emitModelTokensChangedEvent({ranges:[{fromLineNumber:1,toLineNumber:ne.getLineCount()}]}),ne._shouldAutoTokenize()&&ne._warmUpTokens())})),ne._revalidateTokensTimeout=-1,ne._languageRegistryListener=ye.LanguageConfigurationRegistry.onDidChange((function(X){X.languageIdentifier.id===ne._languageIdentifier.id&&ne._onDidChangeLanguageConfiguration.fire({})})),ne._resetTokenizationState(),ne._instanceId=function(X){return(X%=52)<26?String.fromCharCode(97+X):String.fromCharCode(65+X-26)}(Se),ne._lastDecorationId=0,ne._decorations=Object.create(null),ne._decorationsTree=new Le,ne._commandManager=new de.EditStack(ne),ne._isUndoing=!1,ne._isRedoing=!1,ne._trimAutoWhitespaceLines=null,ne}return te(r,X),r.createFromString=function(X,$,Q,J){return void 0===$&&($=r.DEFAULT_CREATION_OPTIONS),void 0===Q&&(Q=null),void 0===J&&(J=null),new r(X,$,Q,J)},r.resolveOptions=function(X,$){if($.detectIndentation){var Q=ce.guessIndentation(X,$.tabSize,$.insertSpaces);return new ue.TextModelResolvedOptions({tabSize:Q.tabSize,insertSpaces:Q.insertSpaces,trimAutoWhitespace:$.trimAutoWhitespace,defaultEOL:$.defaultEOL})}return new ue.TextModelResolvedOptions({tabSize:$.tabSize,insertSpaces:$.insertSpaces,trimAutoWhitespace:$.trimAutoWhitespace,defaultEOL:$.defaultEOL})},r.prototype.onDidChangeRawContentFast=function(X){return this._eventEmitter.fastEvent((function($){return X($.rawContentChangedEvent)}))},r.prototype.onDidChangeRawContent=function(X){return this._eventEmitter.slowEvent((function($){return X($.rawContentChangedEvent)}))},r.prototype.onDidChangeContent=function(X){return this._eventEmitter.slowEvent((function($){return X($.contentChangedEvent)}))},r.prototype.dispose=function(){this._isDisposing=!0,this._onWillDispose.fire(),this._tokenizationListener.dispose(),this._languageRegistryListener.dispose(),this._clearTimers(),this._isDisposed=!0,X.prototype.dispose.call(this),this._isDisposing=!1},r.prototype._assertNotDisposed=function(){if(this._isDisposed)throw new Error("Model is disposed!")},r.prototype._emitContentChangedEvent=function(X,$){this._isDisposing||this._eventEmitter.fire(new fe.InternalModelContentChangeEvent(X,$))},r.prototype.setValue=function(X){if(this._assertNotDisposed(),null!==X){var $=N(X,this._options.defaultEOL);this.setValueFromTextBuffer($)}},r.prototype._createContentChanged2=function(X,$,Q,J,ee,te,ne){return{changes:[{range:X,rangeOffset:$,rangeLength:Q,text:J}],eol:this._buffer.getEOL(),versionId:this.getVersionId(),isUndoing:ee,isRedoing:te,isFlush:ne}},r.prototype.setValueFromTextBuffer=function(X){if(this._assertNotDisposed(),null!==X){var $=this.getFullModelRange(),Q=this.getValueLengthInRange($),J=this.getLineCount(),ee=this.getLineMaxColumn(J);this._buffer=X,this._increaseVersionId(),this._resetTokenizationState(),this._decorations=Object.create(null),this._decorationsTree=new Le,this._commandManager=new de.EditStack(this),this._trimAutoWhitespaceLines=null,this._emitContentChangedEvent(new fe.ModelRawContentChangedEvent([new fe.ModelRawFlush],this._versionId,!1,!1),this._createContentChanged2(new ae.Range(1,1,J,ee),0,Q,this.getValue(),!1,!1,!0))}},r.prototype.setEOL=function(X){this._assertNotDisposed();var $=1===X?"\r\n":"\n";if(this._buffer.getEOL()!==$){var Q=this.getFullModelRange(),J=this.getValueLengthInRange(Q),ee=this.getLineCount(),te=this.getLineMaxColumn(ee);this._onBeforeEOLChange(),this._buffer.setEOL($),this._increaseVersionId(),this._onAfterEOLChange(),this._emitContentChangedEvent(new fe.ModelRawContentChangedEvent([new fe.ModelRawEOLChanged],this._versionId,!1,!1),this._createContentChanged2(new ae.Range(1,1,ee,te),0,J,this.getValue(),!1,!1,!1))}},r.prototype._onBeforeEOLChange=function(){var X=this.getVersionId(),$=this._decorationsTree.search(0,!1,!1,X);this._ensureNodesHaveRanges($)},r.prototype._onAfterEOLChange=function(){for(var X=this.getVersionId(),$=this._decorationsTree.collectNodesPostOrder(),Q=0,J=$.length;Q<J;Q++){var ee=$[Q],te=ee.cachedAbsoluteStart-ee.start,ne=this._buffer.getOffsetAt(ee.range.startLineNumber,ee.range.startColumn),ie=this._buffer.getOffsetAt(ee.range.endLineNumber,ee.range.endColumn);ee.cachedAbsoluteStart=ne,ee.cachedAbsoluteEnd=ie,ee.cachedVersionId=X,ee.start=ne-te,ee.end=ie-te,he.recomputeMaxEnd(ee)}},r.prototype._resetTokenizationState=function(){this._clearTimers();var X=this._isTooLargeForTokenization?null:_e.TokenizationRegistry.get(this._languageIdentifier.language);this._tokens=new me.ModelLinesTokens(this._languageIdentifier,X),this._beginBackgroundTokenization()},r.prototype._clearTimers=function(){-1!==this._revalidateTokensTimeout&&(clearTimeout(this._revalidateTokensTimeout),this._revalidateTokensTimeout=-1)},r.prototype.onBeforeAttached=function(){this._attachedEditorCount++,this._warmUpTokens()},r.prototype.onBeforeDetached=function(){this._attachedEditorCount--},r.prototype._shouldAutoTokenize=function(){return this.isAttachedToEditor()},r.prototype.isAttachedToEditor=function(){return this._attachedEditorCount>0},r.prototype.getAttachedEditorCount=function(){return this._attachedEditorCount},r.prototype.isTooLargeForSyncing=function(){return this._isTooLargeForSyncing},r.prototype.isTooLargeForTokenization=function(){return this._isTooLargeForTokenization},r.prototype.isDisposed=function(){return this._isDisposed},r.prototype.isDominatedByLongLines=function(){if(this._assertNotDisposed(),this.isTooLargeForTokenization())return!1;for(var X=0,Q=0,J=this._buffer.getLineCount(),ee=1;ee<=J;ee++){var te=this._buffer.getLineLength(ee);te>=$.LONG_LINE_BOUNDARY?Q+=te:X+=te}return Q>X},Object.defineProperty(r.prototype,"uri",{get:function(){return this._associatedResource},enumerable:!0,configurable:!0}),r.prototype.getOptions=function(){return this._assertNotDisposed(),this._options},r.prototype.updateOptions=function(X){this._assertNotDisposed();var $=void 0!==X.tabSize?X.tabSize:this._options.tabSize,Q=void 0!==X.insertSpaces?X.insertSpaces:this._options.insertSpaces,J=void 0!==X.trimAutoWhitespace?X.trimAutoWhitespace:this._options.trimAutoWhitespace,ee=new ue.TextModelResolvedOptions({tabSize:$,insertSpaces:Q,defaultEOL:this._options.defaultEOL,trimAutoWhitespace:J});if(!this._options.equals(ee)){var te=this._options.createChangeEvent(ee);this._options=ee,this._onDidChangeOptions.fire(te)}},r.prototype.detectIndentation=function(X,$){this._assertNotDisposed();var Q=ce.guessIndentation(this._buffer,$,X);this.updateOptions({insertSpaces:Q.insertSpaces,tabSize:Q.tabSize})},r._normalizeIndentationFromWhitespace=function(X,$,Q){for(var J=0,ee=0;ee<X.length;ee++)"\t"===X.charAt(ee)?J+=$:J++;var te="";if(!Q){var ne=Math.floor(J/$);for(J%=$,ee=0;ee<ne;ee++)te+="\t"}for(ee=0;ee<J;ee++)te+=" ";return te},r.normalizeIndentation=function(X,$,Q){var J=ie.firstNonWhitespaceIndex(X);return-1===J&&(J=X.length),r._normalizeIndentationFromWhitespace(X.substring(0,J),$,Q)+X.substring(J)},r.prototype.normalizeIndentation=function(X){return this._assertNotDisposed(),r.normalizeIndentation(X,this._options.tabSize,this._options.insertSpaces)},r.prototype.getOneIndent=function(){this._assertNotDisposed();var X=this._options.tabSize;if(this._options.insertSpaces){for(var $="",Q=0;Q<X;Q++)$+=" ";return $}return"\t"},r.prototype.getVersionId=function(){return this._assertNotDisposed(),this._versionId},r.prototype.mightContainRTL=function(){return this._buffer.mightContainRTL()},r.prototype.mightContainNonBasicASCII=function(){return this._buffer.mightContainNonBasicASCII()},r.prototype.getAlternativeVersionId=function(){return this._assertNotDisposed(),this._alternativeVersionId},r.prototype.getOffsetAt=function(X){this._assertNotDisposed();var $=this._validatePosition(X.lineNumber,X.column,!1);return this._buffer.getOffsetAt($.lineNumber,$.column)},r.prototype.getPositionAt=function(X){this._assertNotDisposed();var $=Math.min(this._buffer.getLength(),Math.max(0,X));return this._buffer.getPositionAt($)},r.prototype._increaseVersionId=function(){this._setVersionId(this._versionId+1)},r.prototype._setVersionId=function(X){this._versionId=X,this._alternativeVersionId=this._versionId},r.prototype._overwriteAlternativeVersionId=function(X){this._alternativeVersionId=X},r.prototype.getValue=function(X,$){void 0===$&&($=!1),this._assertNotDisposed();var Q=this.getFullModelRange(),J=this.getValueInRange(Q,X);return $?this._buffer.getBOM()+J:J},r.prototype.getValueLength=function(X,$){void 0===$&&($=!1),this._assertNotDisposed();var Q=this.getFullModelRange(),J=this.getValueLengthInRange(Q,X);return $?this._buffer.getBOM().length+J:J},r.prototype.getValueInRange=function(X,$){return void 0===$&&($=0),this._assertNotDisposed(),this._buffer.getValueInRange(this.validateRange(X),$)},r.prototype.getValueLengthInRange=function(X,$){return void 0===$&&($=0),this._assertNotDisposed(),this._buffer.getValueLengthInRange(this.validateRange(X),$)},r.prototype.getLineCount=function(){return this._assertNotDisposed(),this._buffer.getLineCount()},r.prototype.getLineContent=function(X){if(this._assertNotDisposed(),X<1||X>this.getLineCount())throw new Error("Illegal value for lineNumber");return this._buffer.getLineContent(X)},r.prototype.getLineLength=function(X){if(this._assertNotDisposed(),X<1||X>this.getLineCount())throw new Error("Illegal value for lineNumber");return this._buffer.getLineLength(X)},r.prototype.getLinesContent=function(){return this._assertNotDisposed(),this._buffer.getLinesContent()},r.prototype.getEOL=function(){return this._assertNotDisposed(),this._buffer.getEOL()},r.prototype.getLineMinColumn=function(X){return this._assertNotDisposed(),1},r.prototype.getLineMaxColumn=function(X){if(this._assertNotDisposed(),X<1||X>this.getLineCount())throw new Error("Illegal value for lineNumber");return this._buffer.getLineLength(X)+1},r.prototype.getLineFirstNonWhitespaceColumn=function(X){if(this._assertNotDisposed(),X<1||X>this.getLineCount())throw new Error("Illegal value for lineNumber");return this._buffer.getLineFirstNonWhitespaceColumn(X)},r.prototype.getLineLastNonWhitespaceColumn=function(X){if(this._assertNotDisposed(),X<1||X>this.getLineCount())throw new Error("Illegal value for lineNumber");return this._buffer.getLineLastNonWhitespaceColumn(X)},r.prototype._validateRangeRelaxedNoAllocations=function(X){var $,Q,J=this._buffer.getLineCount(),ee=X.startLineNumber,te=X.startColumn;ee<1?($=1,Q=1):ee>J?($=J,Q=this.getLineMaxColumn($)):($=0|ee,Q=te<=1?1:te>=(se=this.getLineMaxColumn($))?se:0|te);var ne,ie,oe=X.endLineNumber,re=X.endColumn;if(oe<1)ne=1,ie=1;else if(oe>J)ne=J,ie=this.getLineMaxColumn(ne);else if(ne=0|oe,re<=1)ie=1;else{var se=this.getLineMaxColumn(ne);ie=re>=se?se:0|re}return ee===$&&te===Q&&oe===ne&&re===ie&&X instanceof ae.Range&&!(X instanceof le.Selection)?X:new ae.Range($,Q,ne,ie)},r.prototype._isValidPosition=function(X,$,Q){if(isNaN(X))return!1;if(X<1)return!1;if(X>this._buffer.getLineCount())return!1;if(isNaN($))return!1;if($<1)return!1;if($>this.getLineMaxColumn(X))return!1;if(Q&&$>1){var J=this._buffer.getLineCharCode(X,$-2);if(ie.isHighSurrogate(J))return!1}return!0},r.prototype._validatePosition=function(X,$,Q){var J=Math.floor("number"!=typeof X||isNaN(X)?1:X),ee=Math.floor("number"!=typeof $||isNaN($)?1:$),te=this._buffer.getLineCount();if(J<1)return new se.Position(1,1);if(J>te)return new se.Position(te,this.getLineMaxColumn(te));if(ee<=1)return new se.Position(J,1);var ne=this.getLineMaxColumn(J);if(ee>=ne)return new se.Position(J,ne);if(Q){var oe=this._buffer.getLineCharCode(J,ee-2);if(ie.isHighSurrogate(oe))return new se.Position(J,ee-1)}return new se.Position(J,ee)},r.prototype.validatePosition=function(X){return this._assertNotDisposed(),X instanceof se.Position&&this._isValidPosition(X.lineNumber,X.column,!0)?X:this._validatePosition(X.lineNumber,X.column,!0)},r.prototype._isValidRange=function(X,$){var Q=X.startLineNumber,J=X.startColumn,ee=X.endLineNumber,te=X.endColumn;if(!this._isValidPosition(Q,J,!1))return!1;if(!this._isValidPosition(ee,te,!1))return!1;if($){var ne=J>1?this._buffer.getLineCharCode(Q,J-2):0,oe=te>1&&te<=this._buffer.getLineLength(ee)?this._buffer.getLineCharCode(ee,te-2):0,re=ie.isHighSurrogate(ne),se=ie.isHighSurrogate(oe);return!re&&!se}return!0},r.prototype.validateRange=function(X){if(this._assertNotDisposed(),X instanceof ae.Range&&!(X instanceof le.Selection)&&this._isValidRange(X,!0))return X;var $=this._validatePosition(X.startLineNumber,X.startColumn,!1),Q=this._validatePosition(X.endLineNumber,X.endColumn,!1),J=$.lineNumber,ee=$.column,te=Q.lineNumber,ne=Q.column,oe=ee>1?this._buffer.getLineCharCode(J,ee-2):0,re=ne>1&&ne<=this._buffer.getLineLength(te)?this._buffer.getLineCharCode(te,ne-2):0,se=ie.isHighSurrogate(oe),ue=ie.isHighSurrogate(re);return se||ue?J===te&&ee===ne?new ae.Range(J,ee-1,te,ne-1):se&&ue?new ae.Range(J,ee-1,te,ne+1):se?new ae.Range(J,ee-1,te,ne):new ae.Range(J,ee,te,ne+1):new ae.Range(J,ee,te,ne)},r.prototype.modifyPosition=function(X,$){this._assertNotDisposed();var Q=this.getOffsetAt(X)+$;return this.getPositionAt(Math.min(this._buffer.getLength(),Math.max(0,Q)))},r.prototype.getFullModelRange=function(){this._assertNotDisposed();var X=this.getLineCount();return new ae.Range(1,1,X,this.getLineMaxColumn(X))},r.prototype.findMatchesLineByLine=function(X,$,Q,J){return this._buffer.findMatchesLineByLine(X,$,Q,J)},r.prototype.findMatches=function(X,$,Q,J,ee,te,ne){var ie;if(void 0===ne&&(ne=999),this._assertNotDisposed(),ie=ae.Range.isIRange($)?this.validateRange($):this.getFullModelRange(),!Q&&X.indexOf("\n")<0){var oe=new ge.SearchParams(X,Q,J,ee).parseSearchRequest();return oe?this.findMatchesLineByLine(ie,oe,te,ne):[]}return ge.TextModelSearch.findMatches(this,new ge.SearchParams(X,Q,J,ee),ie,te,ne)},r.prototype.findNextMatch=function(X,$,Q,J,ee,te){this._assertNotDisposed();var ne=this.validatePosition($);if(!Q&&X.indexOf("\n")<0){var ie=new ge.SearchParams(X,Q,J,ee).parseSearchRequest();if(!ie)return null;var oe=this.getLineCount(),re=new ae.Range(ne.lineNumber,ne.column,oe,this.getLineMaxColumn(oe)),se=this.findMatchesLineByLine(re,ie,te,1);return ge.TextModelSearch.findNextMatch(this,new ge.SearchParams(X,Q,J,ee),ne,te),se.length>0?se[0]:(re=new ae.Range(1,1,ne.lineNumber,this.getLineMaxColumn(ne.lineNumber)),(se=this.findMatchesLineByLine(re,ie,te,1)).length>0?se[0]:null)}return ge.TextModelSearch.findNextMatch(this,new ge.SearchParams(X,Q,J,ee),ne,te)},r.prototype.findPreviousMatch=function(X,$,Q,J,ee,te){this._assertNotDisposed();var ne=this.validatePosition($);return ge.TextModelSearch.findPreviousMatch(this,new ge.SearchParams(X,Q,J,ee),ne,te)},r.prototype.pushStackElement=function(){this._commandManager.pushStackElement()},r.prototype.pushEOL=function(X){if(("\n"===this.getEOL()?0:1)!==X)try{this._onDidChangeDecorations.beginDeferredEmit(),this._eventEmitter.beginDeferredEmit(),this._commandManager.pushEOL(X)}finally{this._eventEmitter.endDeferredEmit(),this._onDidChangeDecorations.endDeferredEmit()}},r.prototype.pushEditOperations=function(X,$,Q){try{return this._onDidChangeDecorations.beginDeferredEmit(),this._eventEmitter.beginDeferredEmit(),this._pushEditOperations(X,$,Q)}finally{this._eventEmitter.endDeferredEmit(),this._onDidChangeDecorations.endDeferredEmit()}},r.prototype._pushEditOperations=function(X,$,Q){var J=this;if(this._options.trimAutoWhitespace&&this._trimAutoWhitespaceLines){for(var ee=$.map((function(X){return{range:J.validateRange(X.range),text:X.text}})),te=!0,ne=0,ie=X.length;ne<ie;ne++){for(var oe=X[ne],re=!1,se=0,le=ee.length;se<le;se++){var ue=(fe=ee[se].range).startLineNumber>oe.endLineNumber,de=oe.startLineNumber>fe.endLineNumber;if(!ue&&!de){re=!0;break}}if(!re){te=!1;break}}if(te)for(ne=0,ie=this._trimAutoWhitespaceLines.length;ne<ie;ne++){var ce=this._trimAutoWhitespaceLines[ne],he=this.getLineMaxColumn(ce),pe=!0;for(se=0,le=ee.length;se<le;se++){var fe=ee[se].range,ge=ee[se].text;if(!(ce<fe.startLineNumber||ce>fe.endLineNumber||ce===fe.startLineNumber&&fe.startColumn===he&&fe.isEmpty()&&ge&&ge.length>0&&"\n"===ge.charAt(0)||ce===fe.startLineNumber&&1===fe.startColumn&&fe.isEmpty()&&ge&&ge.length>0&&"\n"===ge.charAt(ge.length-1))){pe=!1;break}}pe&&$.push({range:new ae.Range(ce,1,ce,he),text:null})}this._trimAutoWhitespaceLines=null}return this._commandManager.pushEditOperation(X,$,Q)},r.prototype.applyEdits=function(X){try{return this._onDidChangeDecorations.beginDeferredEmit(),this._eventEmitter.beginDeferredEmit(),this._applyEdits(X)}finally{this._eventEmitter.endDeferredEmit(),this._onDidChangeDecorations.endDeferredEmit()}},r._eolCount=function(X){for(var $=0,Q=0,J=0,ee=X.length;J<ee;J++){var te=X.charCodeAt(J);13===te?(0===$&&(Q=J),$++,J+1<ee&&10===X.charCodeAt(J+1)&&J++):10===te&&(0===$&&(Q=J),$++)}return 0===$&&(Q=X.length),[$,Q]},r.prototype._applyEdits=function(X){for(var $=0,Q=X.length;$<Q;$++)X[$].range=this.validateRange(X[$].range);var J=this._buffer.getLineCount(),ee=this._buffer.applyEdits(X,this._options.trimAutoWhitespace),te=this._buffer.getLineCount(),ne=ee.changes;if(this._trimAutoWhitespaceLines=ee.trimAutoWhitespaceLineNumbers,0!==ne.length){var ie=[],oe=J;for($=0,Q=ne.length;$<Q;$++){var re=ne[$],se=r._eolCount(re.text),ae=se[0],le=se[1];try{this._tokens.applyEdits(re.range,ae,le)}catch(X){this._tokens=new me.ModelLinesTokens(this._tokens.languageIdentifier,this._tokens.tokenizationSupport)}this._onDidChangeDecorations.fire(),this._decorationsTree.acceptReplace(re.rangeOffset,re.rangeLength,re.text.length,re.forceMoveMarkers);for(var ue=re.range.startLineNumber,de=re.range.endLineNumber,ce=de-ue,he=ae,pe=Math.min(ce,he),ge=he-ce,ve=pe;ve>=0;ve--){var _e=ue+ve,ye=te-oe-ge+_e;ie.push(new fe.ModelRawLineChanged(_e,this.getLineContent(ye)))}if(pe<ce){var be=ue+pe;ie.push(new fe.ModelRawLinesDeleted(be+1,de))}if(pe<he){for(var Ce=ue+pe,we=he-pe,Se=te-oe-we+Ce+1,Ee=[],Le=0;Le<we;Le++){var xe=Se+Le;Ee[xe-Se]=this.getLineContent(xe)}ie.push(new fe.ModelRawLinesInserted(Ce+1,ue+he,Ee))}oe+=ge}this._increaseVersionId(),this._emitContentChangedEvent(new fe.ModelRawContentChangedEvent(ie,this.getVersionId(),this._isUndoing,this._isRedoing),{changes:ne,eol:this._buffer.getEOL(),versionId:this.getVersionId(),isUndoing:this._isUndoing,isRedoing:this._isRedoing,isFlush:!1})}return this._tokens.hasLinesToTokenize(this._buffer)&&this._beginBackgroundTokenization(),ee.reverseEdits},r.prototype._undo=function(){this._isUndoing=!0;var X=this._commandManager.undo();return this._isUndoing=!1,X?(this._overwriteAlternativeVersionId(X.recordedVersionId),X.selections):null},r.prototype.undo=function(){try{return this._onDidChangeDecorations.beginDeferredEmit(),this._eventEmitter.beginDeferredEmit(),this._undo()}finally{this._eventEmitter.endDeferredEmit(),this._onDidChangeDecorations.endDeferredEmit()}},r.prototype.canUndo=function(){return this._commandManager.canUndo()},r.prototype._redo=function(){this._isRedoing=!0;var X=this._commandManager.redo();return this._isRedoing=!1,X?(this._overwriteAlternativeVersionId(X.recordedVersionId),X.selections):null},r.prototype.redo=function(){try{return this._onDidChangeDecorations.beginDeferredEmit(),this._eventEmitter.beginDeferredEmit(),this._redo()}finally{this._eventEmitter.endDeferredEmit(),this._onDidChangeDecorations.endDeferredEmit()}},r.prototype.canRedo=function(){return this._commandManager.canRedo()},r.prototype.changeDecorations=function(X,$){void 0===$&&($=0),this._assertNotDisposed();try{return this._onDidChangeDecorations.beginDeferredEmit(),this._changeDecorations($,X)}finally{this._onDidChangeDecorations.endDeferredEmit()}},r.prototype._changeDecorations=function(X,$){var J=this,ee={addDecoration:function($,Q){return J._onDidChangeDecorations.fire(),J._deltaDecorationsImpl(X,[],[{range:$,options:Q}])[0]},changeDecoration:function(X,$){J._onDidChangeDecorations.fire(),J._changeDecorationImpl(X,$)},changeDecorationOptions:function(X,$){J._onDidChangeDecorations.fire(),J._changeDecorationOptionsImpl(X,M($))},removeDecoration:function($){J._onDidChangeDecorations.fire(),J._deltaDecorationsImpl(X,[$],[])},deltaDecorations:function($,Q){return 0===$.length&&0===Q.length?[]:(J._onDidChangeDecorations.fire(),J._deltaDecorationsImpl(X,$,Q))}},te=null;try{te=$(ee)}catch(X){Q.onUnexpectedError(X)}return ee.addDecoration=T,ee.changeDecoration=T,ee.changeDecorationOptions=T,ee.removeDecoration=T,ee.deltaDecorations=T,te},r.prototype.deltaDecorations=function(X,$,Q){if(void 0===Q&&(Q=0),this._assertNotDisposed(),X||(X=[]),0===X.length&&0===$.length)return[];try{return this._onDidChangeDecorations.beginDeferredEmit(),this._onDidChangeDecorations.fire(),this._deltaDecorationsImpl(Q,X,$)}finally{this._onDidChangeDecorations.endDeferredEmit()}},r.prototype._getTrackedRange=function(X){return this.getDecorationRange(X)},r.prototype._setTrackedRange=function(X,$,Q){var J=X?this._decorations[X]:null;if(!J)return $?this._deltaDecorationsImpl(0,[],[{range:$,options:De[Q]}])[0]:null;if(!$)return this._decorationsTree.delete(J),delete this._decorations[J.id],null;var ee=this._validateRangeRelaxedNoAllocations($),te=this._buffer.getOffsetAt(ee.startLineNumber,ee.startColumn),ne=this._buffer.getOffsetAt(ee.endLineNumber,ee.endColumn);return this._decorationsTree.delete(J),J.reset(this.getVersionId(),te,ne,ee),J.setOptions(De[Q]),this._decorationsTree.insert(J),J.id},r.prototype.removeAllDecorationsWithOwnerId=function(X){if(!this._isDisposed)for(var $=this._decorationsTree.collectNodesFromOwner(X),Q=0,J=$.length;Q<J;Q++){var ee=$[Q];this._decorationsTree.delete(ee),delete this._decorations[ee.id]}},r.prototype.getDecorationOptions=function(X){var $=this._decorations[X];return $?$.options:null},r.prototype.getDecorationRange=function(X){var $=this._decorations[X];if(!$)return null;var Q=this.getVersionId();return $.cachedVersionId!==Q&&this._decorationsTree.resolveNode($,Q),null===$.range&&($.range=this._getRangeAt($.cachedAbsoluteStart,$.cachedAbsoluteEnd)),$.range},r.prototype.getLineDecorations=function(X,$,Q){return void 0===$&&($=0),void 0===Q&&(Q=!1),X<1||X>this.getLineCount()?[]:this.getLinesDecorations(X,X,$,Q)},r.prototype.getLinesDecorations=function(X,$,Q,J){void 0===Q&&(Q=0),void 0===J&&(J=!1);var ee=this.getLineCount(),te=Math.min(ee,Math.max(1,X)),ne=Math.min(ee,Math.max(1,$)),ie=this.getLineMaxColumn(ne);return this._getDecorationsInRange(new ae.Range(te,1,ne,ie),Q,J)},r.prototype.getDecorationsInRange=function(X,$,Q){void 0===$&&($=0),void 0===Q&&(Q=!1);var J=this.validateRange(X);return this._getDecorationsInRange(J,$,Q)},r.prototype.getOverviewRulerDecorations=function(X,$){void 0===X&&(X=0),void 0===$&&($=!1);var Q=this.getVersionId(),J=this._decorationsTree.search(X,$,!0,Q);return this._ensureNodesHaveRanges(J)},r.prototype.getAllDecorations=function(X,$){void 0===X&&(X=0),void 0===$&&($=!1);var Q=this.getVersionId(),J=this._decorationsTree.search(X,$,!1,Q);return this._ensureNodesHaveRanges(J)},r.prototype._getDecorationsInRange=function(X,$,Q){var J=this._buffer.getOffsetAt(X.startLineNumber,X.startColumn),ee=this._buffer.getOffsetAt(X.endLineNumber,X.endColumn),te=this.getVersionId(),ne=this._decorationsTree.intervalSearch(J,ee,$,Q,te);return this._ensureNodesHaveRanges(ne)},r.prototype._ensureNodesHaveRanges=function(X){for(var $=0,Q=X.length;$<Q;$++){var J=X[$];null===J.range&&(J.range=this._getRangeAt(J.cachedAbsoluteStart,J.cachedAbsoluteEnd))}return X},r.prototype._getRangeAt=function(X,$){return this._buffer.getRangeAt(X,$-X)},r.prototype._changeDecorationImpl=function(X,$){var Q=this._decorations[X];if(Q){var J=this._validateRangeRelaxedNoAllocations($),ee=this._buffer.getOffsetAt(J.startLineNumber,J.startColumn),te=this._buffer.getOffsetAt(J.endLineNumber,J.endColumn);this._decorationsTree.delete(Q),Q.reset(this.getVersionId(),ee,te,J),this._decorationsTree.insert(Q)}},r.prototype._changeDecorationOptionsImpl=function(X,$){var Q=this._decorations[X];Q&&(!(!Q.options.overviewRuler||!Q.options.overviewRuler.color)!=!(!$.overviewRuler||!$.overviewRuler.color)?(this._decorationsTree.delete(Q),Q.setOptions($),this._decorationsTree.insert(Q)):Q.setOptions($))},r.prototype._deltaDecorationsImpl=function(X,$,Q){for(var J=this.getVersionId(),ee=$.length,te=0,ne=Q.length,ie=0,oe=new Array(ne);te<ee||ie<ne;){var re=null;if(te<ee){do{re=this._decorations[$[te++]]}while(!re&&te<ee);re&&this._decorationsTree.delete(re)}if(ie<ne){if(!re){var se=++this._lastDecorationId,ae=this._instanceId+";"+se;re=new he.IntervalNode(ae,0,0),this._decorations[ae]=re}var le=Q[ie],ue=this._validateRangeRelaxedNoAllocations(le.range),de=M(le.options),ce=this._buffer.getOffsetAt(ue.startLineNumber,ue.startColumn),pe=this._buffer.getOffsetAt(ue.endLineNumber,ue.endColumn);re.ownerId=X,re.reset(J,ce,pe,ue),re.setOptions(de),this._decorationsTree.insert(re),oe[ie]=re.id,ie++}else re&&delete this._decorations[re.id]}return oe},r.prototype.tokenizeViewport=function(X,$){if(this._tokens.tokenizationSupport){var Q=Math.floor(.3*this._tokens.inValidLineStartIndex);if((X=Math.max(1,X-Q))<=this._tokens.inValidLineStartIndex)this.forceTokenization($);else{var J=new me.ModelTokensChangedEventBuilder,ee=this.getLineFirstNonWhitespaceColumn(X),te=[],ne=X-1,ie=null;if(ee>0)for(;ee>0&&ne>=1;){var oe=this.getLineFirstNonWhitespaceColumn(ne);if(0!==oe){if(oe<ee){if(ie=this._tokens._getState(ne-1))break;te.push(this.getLineContent(ne)),ee=oe}ne--}else ne--}ie||(ie=this._tokens.tokenizationSupport.getInitialState());for(var re=ie.clone(),se=te.length-1;se>=0;se--)re=(de=this._tokens._tokenizeText(this._buffer,te[se],re))?de.endState.clone():ie.clone();var ae=Math.floor(.4*this._tokens.inValidLineStartIndex);$=Math.min(this.getLineCount(),$+ae);for(var le=X;le<=$;le++){var ue=this.getLineContent(le),de=this._tokens._tokenizeText(this._buffer,ue,re);de?(this._tokens._setTokens(this._tokens.languageIdentifier.id,le-1,ue.length,de.tokens),this._tokens._setIsInvalid(le-1,!1),this._tokens._setState(le-1,re),re=de.endState.clone(),J.registerChangedTokens(le)):re=ie.clone()}var ce=J.build();ce&&this._onDidChangeTokens.fire(ce)}}},r.prototype.forceTokenization=function(X){if(X<1||X>this.getLineCount())throw new Error("Illegal value for lineNumber");var $=new me.ModelTokensChangedEventBuilder;this._tokens._updateTokensUntilLine(this._buffer,$,X);var Q=$.build();Q&&this._onDidChangeTokens.fire(Q)},r.prototype.isCheapToTokenize=function(X){return!!this._tokens.isCheapToTokenize(X)&&(X<this._tokens.inValidLineStartIndex+1||this.getLineLength(X)<2048)},r.prototype.tokenizeIfCheap=function(X){this.isCheapToTokenize(X)&&this.forceTokenization(X)},r.prototype.getLineTokens=function(X){if(X<1||X>this.getLineCount())throw new Error("Illegal value for lineNumber");return this._getLineTokens(X)},r.prototype._getLineTokens=function(X){var $=this._buffer.getLineContent(X);return this._tokens.getTokens(this._languageIdentifier.id,X-1,$)},r.prototype.getLanguageIdentifier=function(){return this._languageIdentifier},r.prototype.getModeId=function(){return this._languageIdentifier.language},r.prototype.setMode=function(X){if(this._languageIdentifier.id!==X.id){var $={oldLanguage:this._languageIdentifier.language,newLanguage:X.language};this._languageIdentifier=X,this._resetTokenizationState(),this.emitModelTokensChangedEvent({ranges:[{fromLineNumber:1,toLineNumber:this.getLineCount()}]}),this._onDidChangeLanguage.fire($),this._onDidChangeLanguageConfiguration.fire({})}},r.prototype.getLanguageIdAtPosition=function(X,$){if(!this._tokens.tokenizationSupport)return this._languageIdentifier.id;var Q=this.validatePosition({lineNumber:X,column:$}),J=Q.lineNumber,ee=Q.column,te=this._getLineTokens(J);return te.getLanguageId(te.findTokenIndexAtOffset(ee-1))},r.prototype._beginBackgroundTokenization=function(){var X=this;this._shouldAutoTokenize()&&-1===this._revalidateTokensTimeout&&(this._revalidateTokensTimeout=setTimeout((function(){X._revalidateTokensTimeout=-1,X._revalidateTokensNow()}),0))},r.prototype._warmUpTokens=function(){var X=Math.min(100,this.getLineCount());this._revalidateTokensNow(X),this._tokens.hasLinesToTokenize(this._buffer)&&this._beginBackgroundTokenization()},r.prototype._revalidateTokensNow=function(X){void 0===X&&(X=this._buffer.getLineCount());for(var $=new me.ModelTokensChangedEventBuilder,Q=ne.StopWatch.create(!1);this._tokens.hasLinesToTokenize(this._buffer)&&!(Q.elapsed()>20)&&!(this._tokens._tokenizeOneLine(this._buffer,$)>=X););this._tokens.hasLinesToTokenize(this._buffer)&&this._beginBackgroundTokenization();var J=$.build();J&&this._onDidChangeTokens.fire(J)},r.prototype.emitModelTokensChangedEvent=function(X){this._isDisposing||this._onDidChangeTokens.fire(X)},r.prototype.getWordAtPosition=function(X){this._assertNotDisposed();var $=this.validatePosition(X),Q=this.getLineContent($.lineNumber),J=this._getLineTokens($.lineNumber),ee=J.findTokenIndexAtOffset($.column-1),te=r._findLanguageBoundaries(J,ee),ne=te[0],ie=te[1],oe=ve.getWordAtText($.column,ye.LanguageConfigurationRegistry.getWordDefinition(J.getLanguageId(ee)),Q.substring(ne,ie),ne);if(oe&&oe.startColumn<=X.column&&X.column<=oe.endColumn)return oe;if(ee>0&&ne===$.column-1){var re=r._findLanguageBoundaries(J,ee-1),se=re[0],ae=re[1],le=ve.getWordAtText($.column,ye.LanguageConfigurationRegistry.getWordDefinition(J.getLanguageId(ee-1)),Q.substring(se,ae),se);if(le&&le.startColumn<=X.column&&X.column<=le.endColumn)return le}return null},r._findLanguageBoundaries=function(X,$){for(var Q=X.getLanguageId($),J=0,ee=$;ee>=0&&X.getLanguageId(ee)===Q;ee--)J=X.getStartOffset(ee);for(var te=X.getLineContent().length,ne=(ee=$,X.getCount());ee<ne&&X.getLanguageId(ee)===Q;ee++)te=X.getEndOffset(ee);return[J,te]},r.prototype.getWordUntilPosition=function(X){var $=this.getWordAtPosition(X);return $?{word:$.word.substr(0,X.column-$.startColumn),startColumn:$.startColumn,endColumn:X.column}:{word:"",startColumn:X.column,endColumn:X.column}},r.prototype.findMatchingBracketUp=function(X,$){var Q=X.toLowerCase(),J=this.validatePosition($),ee=this._getLineTokens(J.lineNumber),te=ee.getLanguageId(ee.findTokenIndexAtOffset(J.column-1)),ne=ye.LanguageConfigurationRegistry.getBracketsSupport(te);if(!ne)return null;var ie=ne.textIsBracket[Q];return ie?this._findMatchingBracketUp(ie,J):null},r.prototype.matchBracket=function(X){return this._matchBracket(this.validatePosition(X))},r.prototype._matchBracket=function(X){var $=X.lineNumber,Q=this._getLineTokens($),J=this._buffer.getLineContent($),ee=Q.findTokenIndexAtOffset(X.column-1);if(ee<0)return null;var te=ye.LanguageConfigurationRegistry.getBracketsSupport(Q.getLanguageId(ee));if(te&&!Ce.ignoreBracketsInToken(Q.getStandardTokenType(ee))){for(var ne=Math.max(Q.getStartOffset(ee),X.column-1-te.maxBracketLength),ie=Math.min(Q.getEndOffset(ee),X.column-1+te.maxBracketLength),oe=null;se=we.BracketsUtils.findNextBracketInToken(te.forwardRegex,$,J,ne,ie);)se.startColumn<=X.column&&X.column<=se.endColumn&&(ae=(ae=J.substring(se.startColumn-1,se.endColumn-1)).toLowerCase(),(le=this._matchFoundBracket(se,te.textIsBracket[ae],te.textIsOpenBracket[ae]))&&(oe=le)),ne=se.endColumn-1;if(oe)return oe}if(ee>0&&Q.getStartOffset(ee)===X.column-1){ie=Q.getStartOffset(ee),ee--;var re=ye.LanguageConfigurationRegistry.getBracketsSupport(Q.getLanguageId(ee));if(re&&!Ce.ignoreBracketsInToken(Q.getStandardTokenType(ee))){ne=Math.max(Q.getStartOffset(ee),X.column-1-re.maxBracketLength);var se=we.BracketsUtils.findPrevBracketInToken(re.reversedRegex,$,J,ne,ie);if(se&&se.startColumn<=X.column&&X.column<=se.endColumn){var ae=J.substring(se.startColumn-1,se.endColumn-1);ae=ae.toLowerCase();var le=this._matchFoundBracket(se,re.textIsBracket[ae],re.textIsOpenBracket[ae]);if(le)return le}}}return null},r.prototype._matchFoundBracket=function(X,$,Q){if(!$)return null;if(Q){if(J=this._findMatchingBracketDown($,X.getEndPosition()))return[X,J]}else{var J=this._findMatchingBracketUp($,X.getStartPosition());if(J)return[X,J]}return null},r.prototype._findMatchingBracketUp=function(X,$){for(var Q=X.languageIdentifier.id,J=X.reversedRegex,ee=-1,te=$.lineNumber;te>=1;te--){var ne=this._getLineTokens(te),ie=ne.getCount(),oe=this._buffer.getLineContent(te),re=ie-1,se=-1;for(te===$.lineNumber&&(re=ne.findTokenIndexAtOffset($.column-1),se=$.column-1);re>=0;re--){var ae=ne.getLanguageId(re),le=ne.getStandardTokenType(re),ue=ne.getStartOffset(re),de=ne.getEndOffset(re);if(-1===se&&(se=de),ae===Q&&!Ce.ignoreBracketsInToken(le))for(;;){var ce=we.BracketsUtils.findPrevBracketInToken(J,te,oe,ue,se);if(!ce)break;var he=oe.substring(ce.startColumn-1,ce.endColumn-1);if((he=he.toLowerCase())===X.open?ee++:he===X.close&&ee--,0===ee)return ce;se=ce.startColumn-1}se=-1}}return null},r.prototype._findMatchingBracketDown=function(X,$){for(var Q=X.languageIdentifier.id,J=X.forwardRegex,ee=1,te=$.lineNumber,ne=this.getLineCount();te<=ne;te++){var ie=this._getLineTokens(te),oe=ie.getCount(),re=this._buffer.getLineContent(te),se=0,ae=0;for(te===$.lineNumber&&(se=ie.findTokenIndexAtOffset($.column-1),ae=$.column-1);se<oe;se++){var le=ie.getLanguageId(se),ue=ie.getStandardTokenType(se),de=ie.getStartOffset(se),ce=ie.getEndOffset(se);if(0===ae&&(ae=de),le===Q&&!Ce.ignoreBracketsInToken(ue))for(;;){var he=we.BracketsUtils.findNextBracketInToken(J,te,re,ae,ce);if(!he)break;var pe=re.substring(he.startColumn-1,he.endColumn-1);if((pe=pe.toLowerCase())===X.open?ee++:pe===X.close&&ee--,0===ee)return he;ae=he.endColumn-1}ae=0}}return null},r.prototype.findNextBracket=function(X){for(var $=this.validatePosition(X),Q=-1,J=null,ee=$.lineNumber,te=this.getLineCount();ee<=te;ee++){var ne=this._getLineTokens(ee),ie=ne.getCount(),oe=this._buffer.getLineContent(ee),re=0,se=0;for(ee===$.lineNumber&&(re=ne.findTokenIndexAtOffset($.column-1),se=$.column-1);re<ie;re++){var ae=ne.getLanguageId(re),le=ne.getStandardTokenType(re),ue=ne.getStartOffset(re),de=ne.getEndOffset(re);if(0===se&&(se=ue),Q!==ae&&(Q=ae,J=ye.LanguageConfigurationRegistry.getBracketsSupport(Q)),J&&!Ce.ignoreBracketsInToken(le)){var ce=we.BracketsUtils.findNextBracketInToken(J.forwardRegex,ee,oe,se,de);if(ce)return this._toFoundBracket(J,ce)}se=0}}return null},r.prototype._toFoundBracket=function(X,$){if(!$)return null;var Q=this.getValueInRange($);Q=Q.toLowerCase();var J=X.textIsBracket[Q];return J?{range:$,open:J.open,close:J.close,isOpen:X.textIsOpenBracket[Q]}:null},r.computeIndentLevel=function(X,$){for(var Q=0,J=0,ee=X.length;J<ee;){var te=X.charCodeAt(J);if(32===te)Q++;else{if(9!==te)break;Q=Q-Q%$+$}J++}return J===ee?-1:Q},r.prototype._computeIndentLevel=function(X){return r.computeIndentLevel(this._buffer.getLineContent(X+1),this._options.tabSize)},r.prototype.getActiveIndentGuide=function(X,$,Q){var J=this;this._assertNotDisposed();var ee=this.getLineCount();if(X<1||X>ee)throw new Error("Illegal value for lineNumber");for(var te=ye.LanguageConfigurationRegistry.getFoldingRules(this._languageIdentifier.id),ne=Boolean(te&&te.offSide),ie=-2,oe=-1,re=-2,se=-1,c=function(X){if(-1!==ie&&(-2===ie||ie>X-1))for(ie=-1,oe=-1,Q=X-2;Q>=0;Q--){var $=J._computeIndentLevel(Q);if($>=0){ie=Q,oe=$;break}}if(-2===re){re=-1,se=-1;for(var Q=X;Q<ee;Q++){var te=J._computeIndentLevel(Q);if(te>=0){re=Q,se=te;break}}}},ae=-2,le=-1,ue=-2,de=-1,m=function(X){if(-2===ae)for(ae=-1,le=-1,Q=X-2;Q>=0;Q--){var $=J._computeIndentLevel(Q);if($>=0){ae=Q,le=$;break}}if(-1!==ue&&(-2===ue||ue<X-1)){ue=-1,de=-1;for(var Q=X;Q<ee;Q++){var te=J._computeIndentLevel(Q);if(te>=0){ue=Q,de=te;break}}}},ce=0,he=!0,pe=0,fe=!0,ge=0,me=0;he||fe;me++){var ve=X-me,_e=X+me;if(0!==me&&(ve<1||ve<$)&&(he=!1),0!==me&&(_e>ee||_e>Q)&&(fe=!1),me>5e4&&(he=!1,fe=!1),he){var be=void 0;if((we=this._computeIndentLevel(ve-1))>=0?(re=ve-1,se=we,be=Math.ceil(we/this._options.tabSize)):(c(ve),be=this._getIndentLevelForWhitespaceLine(ne,oe,se)),0===me){if(ce=ve,pe=_e,0===(ge=be))return{startLineNumber:ce,endLineNumber:pe,indent:ge};continue}be>=ge?ce=ve:he=!1}if(fe){var Ce=void 0,we=this._computeIndentLevel(_e-1);we>=0?(ae=_e-1,le=we,Ce=Math.ceil(we/this._options.tabSize)):(m(_e),Ce=this._getIndentLevelForWhitespaceLine(ne,le,de)),Ce>=ge?pe=_e:fe=!1}}return{startLineNumber:ce,endLineNumber:pe,indent:ge}},r.prototype.getLinesIndentGuides=function(X,$){this._assertNotDisposed();var Q=this.getLineCount();if(X<1||X>Q)throw new Error("Illegal value for startLineNumber");if($<1||$>Q)throw new Error("Illegal value for endLineNumber");for(var J=ye.LanguageConfigurationRegistry.getFoldingRules(this._languageIdentifier.id),ee=Boolean(J&&J.offSide),te=new Array($-X+1),ne=-2,ie=-1,oe=-2,re=-1,se=X;se<=$;se++){var ae=se-X,le=this._computeIndentLevel(se-1);if(le>=0)ne=se-1,ie=le,te[ae]=Math.ceil(le/this._options.tabSize);else{if(-2===ne)for(ne=-1,ie=-1,ue=se-2;ue>=0;ue--)if((de=this._computeIndentLevel(ue))>=0){ne=ue,ie=de;break}if(-1!==oe&&(-2===oe||oe<se-1)){oe=-1,re=-1;for(var ue=se;ue<Q;ue++){var de=this._computeIndentLevel(ue);if(de>=0){oe=ue,re=de;break}}}te[ae]=this._getIndentLevelForWhitespaceLine(ee,ie,re)}}return te},r.prototype._getIndentLevelForWhitespaceLine=function(X,$,Q){return-1===$||-1===Q?0:$<Q?1+Math.floor($/this._options.tabSize):$===Q||X?Math.ceil(Q/this._options.tabSize):1+Math.floor(Q/this._options.tabSize)},r.MODEL_SYNC_LIMIT=52428800,r.LARGE_FILE_SIZE_THRESHOLD=20971520,r.LARGE_FILE_LINE_COUNT_THRESHOLD=3e5,r.DEFAULT_CREATION_OPTIONS={isForSimpleWidget:!1,tabSize:re.EDITOR_MODEL_DEFAULTS.tabSize,insertSpaces:re.EDITOR_MODEL_DEFAULTS.insertSpaces,detectIndentation:!1,defaultEOL:1,trimAutoWhitespace:re.EDITOR_MODEL_DEFAULTS.trimAutoWhitespace,largeFileOptimizations:re.EDITOR_MODEL_DEFAULTS.largeFileOptimizations},r}(ee.Disposable);$.TextModel=Ee;var Le=function(){function e(){this._decorationsTree0=new he.IntervalTree,this._decorationsTree1=new he.IntervalTree}return e.prototype.intervalSearch=function(X,$,Q,J,ee){var te=this._decorationsTree0.intervalSearch(X,$,Q,J,ee),ne=this._decorationsTree1.intervalSearch(X,$,Q,J,ee);return te.concat(ne)},e.prototype.search=function(X,$,Q,J){if(Q)return this._decorationsTree1.search(X,$,J);var ee=this._decorationsTree0.search(X,$,J),te=this._decorationsTree1.search(X,$,J);return ee.concat(te)},e.prototype.collectNodesFromOwner=function(X){var $=this._decorationsTree0.collectNodesFromOwner(X),Q=this._decorationsTree1.collectNodesFromOwner(X);return $.concat(Q)},e.prototype.collectNodesPostOrder=function(){var X=this._decorationsTree0.collectNodesPostOrder(),$=this._decorationsTree1.collectNodesPostOrder();return X.concat($)},e.prototype.insert=function(X){he.getNodeIsInOverviewRuler(X)?this._decorationsTree1.insert(X):this._decorationsTree0.insert(X)},e.prototype.delete=function(X){he.getNodeIsInOverviewRuler(X)?this._decorationsTree1.delete(X):this._decorationsTree0.delete(X)},e.prototype.resolveNode=function(X,$){he.getNodeIsInOverviewRuler(X)?this._decorationsTree1.resolveNode(X,$):this._decorationsTree0.resolveNode(X,$)},e.prototype.acceptReplace=function(X,$,Q,J){this._decorationsTree0.acceptReplace(X,$,Q,J),this._decorationsTree1.acceptReplace(X,$,Q,J)},e}(),xe=function(){function e(X){this.color=X.color||ie.empty,this.darkColor=X.darkColor||ie.empty,this.position="number"==typeof X.position?X.position:ue.OverviewRulerLane.Center,this._resolvedColor=null}return e.prototype.getColor=function(X){return this._resolvedColor||("light"!==X.type&&this.darkColor?this._resolvedColor=this._resolveColor(this.darkColor,X):this._resolvedColor=this._resolveColor(this.color,X)),this._resolvedColor},e.prototype.invalidateCachedColor=function(){this._resolvedColor=null},e.prototype._resolveColor=function(X,$){if("string"==typeof X)return X;var Q=X?$.getColor(X.id):null;return Q?Q.toString():ie.empty},e}();$.ModelDecorationOverviewRulerOptions=xe;var Ie=function(){function e(X){this.stickiness=X.stickiness||0,this.zIndex=X.zIndex||0,this.className=X.className?D(X.className):null,this.hoverMessage=X.hoverMessage||null,this.glyphMarginHoverMessage=X.glyphMarginHoverMessage||null,this.isWholeLine=X.isWholeLine||!1,this.showIfCollapsed=X.showIfCollapsed||!1,this.collapseOnReplaceEdit=X.collapseOnReplaceEdit||!1,this.overviewRuler=X.overviewRuler?new xe(X.overviewRuler):null,this.glyphMarginClassName=X.glyphMarginClassName?D(X.glyphMarginClassName):null,this.linesDecorationsClassName=X.linesDecorationsClassName?D(X.linesDecorationsClassName):null,this.marginClassName=X.marginClassName?D(X.marginClassName):null,this.inlineClassName=X.inlineClassName?D(X.inlineClassName):null,this.inlineClassNameAffectsLetterSpacing=X.inlineClassNameAffectsLetterSpacing||!1,this.beforeContentClassName=X.beforeContentClassName?D(X.beforeContentClassName):null,this.afterContentClassName=X.afterContentClassName?D(X.afterContentClassName):null}return e.register=function(X){return new e(X)},e.createDynamic=function(X){return new e(X)},e}();$.ModelDecorationOptions=Ie,Ie.EMPTY=Ie.register({});var De=[Ie.register({stickiness:0}),Ie.register({stickiness:1}),Ie.register({stickiness:2}),Ie.register({stickiness:3})],Ne=function(X){function t(){var $=X.call(this)||this;return $._actual=$._register(new J.Emitter),$.event=$._actual.event,$._deferredCnt=0,$._shouldFire=!1,$}return te(t,X),t.prototype.beginDeferredEmit=function(){this._deferredCnt++},t.prototype.endDeferredEmit=function(){this._deferredCnt--,0===this._deferredCnt&&this._shouldFire&&(this._shouldFire=!1,this._actual.fire({}))},t.prototype.fire=function(){this._shouldFire=!0},t}(ee.Disposable);$.DidChangeDecorationsEmitter=Ne;var Me=function(X){function t(){var $=X.call(this)||this;return $._fastEmitter=$._register(new J.Emitter),$.fastEvent=$._fastEmitter.event,$._slowEmitter=$._register(new J.Emitter),$.slowEvent=$._slowEmitter.event,$._deferredCnt=0,$._deferredEvent=null,$}return te(t,X),t.prototype.beginDeferredEmit=function(){this._deferredCnt++},t.prototype.endDeferredEmit=function(){if(this._deferredCnt--,0===this._deferredCnt&&null!==this._deferredEvent){var X=this._deferredEvent;this._deferredEvent=null,this._fastEmitter.fire(X),this._slowEmitter.fire(X)}},t.prototype.fire=function(X){this._deferredCnt>0?this._deferredEvent?this._deferredEvent=this._deferredEvent.merge(X):this._deferredEvent=X:(this._fastEmitter.fire(X),this._slowEmitter.fire(X))},t}(ee.Disposable);$.DidChangeContentEmitter=Me})),define(Q[38],n([0,1,11,8,12,3,21,26,39]),(function(X,$,Q,J,ee,te,ne,ie,oe){Object.defineProperty($,"__esModule",{value:!0});var u=function(X){return!0},d=function(X){return!1},c=function(X){return" "===X||"\t"===X},re=function(){function e(X,$,Q,J){this._languageIdentifier=X;var ee=J.editor;this.readOnly=ee.readOnly,this.tabSize=Q.tabSize,this.insertSpaces=Q.insertSpaces,this.oneIndent=$,this.pageSize=Math.max(1,Math.floor(ee.layoutInfo.height/ee.fontInfo.lineHeight)-2),this.lineHeight=ee.lineHeight,this.useTabStops=ee.useTabStops,this.wordSeparators=ee.wordSeparators,this.emptySelectionClipboard=ee.emptySelectionClipboard,this.copyWithSyntaxHighlighting=ee.copyWithSyntaxHighlighting,this.multiCursorMergeOverlapping=ee.multiCursorMergeOverlapping,this.autoClosingBrackets=ee.autoClosingBrackets,this.autoClosingQuotes=ee.autoClosingQuotes,this.autoSurround=ee.autoSurround,this.autoIndent=ee.autoIndent,this.autoClosingPairsOpen={},this.autoClosingPairsClose={},this.surroundingPairs={},this._electricChars=null,this.shouldAutoCloseBefore={quote:e._getShouldAutoClose(X,this.autoClosingQuotes),bracket:e._getShouldAutoClose(X,this.autoClosingBrackets)};var te=e._getAutoClosingPairs(X);if(te)for(ie=0;ie<te.length;ie++)this.autoClosingPairsOpen[te[ie].open]=te[ie].close,this.autoClosingPairsClose[te[ie].close]=te[ie].open;var ne=e._getSurroundingPairs(X);if(ne)for(var ie=0;ie<ne.length;ie++)this.surroundingPairs[ne[ie].open]=ne[ie].close}return e.shouldRecreate=function(X){return X.layoutInfo||X.wordSeparators||X.emptySelectionClipboard||X.multiCursorMergeOverlapping||X.autoClosingBrackets||X.autoClosingQuotes||X.autoSurround||X.useTabStops||X.lineHeight||X.readOnly},Object.defineProperty(e.prototype,"electricChars",{get:function(){if(!this._electricChars){this._electricChars={};var X=e._getElectricCharacters(this._languageIdentifier);if(X)for(var $=0;$<X.length;$++)this._electricChars[X[$]]=!0}return this._electricChars},enumerable:!0,configurable:!0}),e.prototype.normalizeIndentation=function(X){return ie.TextModel.normalizeIndentation(X,this.tabSize,this.insertSpaces)},e._getElectricCharacters=function(X){try{return oe.LanguageConfigurationRegistry.getElectricCharacters(X.id)}catch(X){return Q.onUnexpectedError(X),null}},e._getAutoClosingPairs=function(X){try{return oe.LanguageConfigurationRegistry.getAutoClosingPairs(X.id)}catch(X){return Q.onUnexpectedError(X),null}},e._getShouldAutoClose=function(X,$){switch($){case"beforeWhitespace":return c;case"languageDefined":return e._getLanguageDefinedShouldAutoClose(X);case"always":return u;case"never":return d}},e._getLanguageDefinedShouldAutoClose=function(X){try{var $=oe.LanguageConfigurationRegistry.getAutoCloseBeforeSet(X.id);return function(X){return-1!==$.indexOf(X)}}catch(X){return Q.onUnexpectedError(X),d}},e._getSurroundingPairs=function(X){try{return oe.LanguageConfigurationRegistry.getSurroundingPairs(X.id)}catch(X){return Q.onUnexpectedError(X),null}},e}();$.CursorConfiguration=re;var se=function(){function e(X,$,Q,J){this.selectionStart=X,this.selectionStartLeftoverVisibleColumns=$,this.position=Q,this.leftoverVisibleColumns=J,this.selection=e._computeSelection(this.selectionStart,this.position)}return e.prototype.equals=function(X){return this.selectionStartLeftoverVisibleColumns===X.selectionStartLeftoverVisibleColumns&&this.leftoverVisibleColumns===X.leftoverVisibleColumns&&this.position.equals(X.position)&&this.selectionStart.equalsRange(X.selectionStart)},e.prototype.hasSelection=function(){return!this.selection.isEmpty()||!this.selectionStart.isEmpty()},e.prototype.move=function(X,$,Q,J){return X?new e(this.selectionStart,this.selectionStartLeftoverVisibleColumns,new ee.Position($,Q),J):new e(new te.Range($,Q,$,Q),J,new ee.Position($,Q),J)},e._computeSelection=function(X,$){var Q,J,ee,te;return X.isEmpty()?(Q=X.startLineNumber,J=X.startColumn,ee=$.lineNumber,te=$.column):$.isBeforeOrEqual(X.getStartPosition())?(Q=X.endLineNumber,J=X.endColumn,ee=$.lineNumber,te=$.column):(Q=X.startLineNumber,J=X.startColumn,ee=$.lineNumber,te=$.column),new ne.Selection(Q,J,ee,te)},e}();$.SingleCursorState=se;var ae=function(){function e(X,$,Q){this.model=$,this.viewModel=Q,this.config=new re(this.model.getLanguageIdentifier(),this.model.getOneIndent(),this.model.getOptions(),X)}return e.prototype.validateViewPosition=function(X,$){return this.viewModel.coordinatesConverter.validateViewPosition(X,$)},e.prototype.validateViewRange=function(X,$){return this.viewModel.coordinatesConverter.validateViewRange(X,$)},e.prototype.convertViewRangeToModelRange=function(X){return this.viewModel.coordinatesConverter.convertViewRangeToModelRange(X)},e.prototype.convertViewPositionToModelPosition=function(X,$){return this.viewModel.coordinatesConverter.convertViewPositionToModelPosition(new ee.Position(X,$))},e.prototype.convertModelPositionToViewPosition=function(X){return this.viewModel.coordinatesConverter.convertModelPositionToViewPosition(X)},e.prototype.convertModelRangeToViewRange=function(X){return this.viewModel.coordinatesConverter.convertModelRangeToViewRange(X)},e.prototype.getCurrentScrollTop=function(){return this.viewModel.viewLayout.getCurrentScrollTop()},e.prototype.getCompletelyVisibleViewRange=function(){return this.viewModel.getCompletelyVisibleViewRange()},e.prototype.getCompletelyVisibleModelRange=function(){var X=this.viewModel.getCompletelyVisibleViewRange();return this.viewModel.coordinatesConverter.convertViewRangeToModelRange(X)},e.prototype.getCompletelyVisibleViewRangeAtScrollTop=function(X){return this.viewModel.getCompletelyVisibleViewRangeAtScrollTop(X)},e.prototype.getVerticalOffsetForViewLine=function(X){return this.viewModel.viewLayout.getVerticalOffsetForLineNumber(X)},e}();$.CursorContext=ae;var g=function(X){this.modelState=X,this.viewState=null};$.PartialModelCursorState=g;var m=function(X){this.modelState=null,this.viewState=X};$.PartialViewCursorState=m;var le=function(){function e(X,$){this.modelState=X,this.viewState=$}return e.fromModelState=function(X){return new g(X)},e.fromViewState=function(X){return new m(X)},e.fromModelSelection=function(X){var $=X.selectionStartLineNumber,Q=X.selectionStartColumn,J=X.positionLineNumber,ne=X.positionColumn,ie=new se(new te.Range($,Q,$,Q),0,new ee.Position(J,ne),0);return e.fromModelState(ie)},e.fromModelSelections=function(X){for(var $=[],Q=0,J=X.length;Q<J;Q++)$[Q]=this.fromModelSelection(X[Q]);return $},e.prototype.equals=function(X){return this.viewState.equals(X.viewState)&&this.modelState.equals(X.modelState)},e}();$.CursorState=le;var _=function(X,$,Q){this.type=X,this.commands=$,this.shouldPushStackElementBefore=Q.shouldPushStackElementBefore,this.shouldPushStackElementAfter=Q.shouldPushStackElementAfter};$.EditOperationResult=_;var ue=function(){function e(){}return e.isLowSurrogate=function(X,$,Q){var ee=X.getLineContent($);return!(Q<0||Q>=ee.length)&&J.isLowSurrogate(ee.charCodeAt(Q))},e.isHighSurrogate=function(X,$,Q){var ee=X.getLineContent($);return!(Q<0||Q>=ee.length)&&J.isHighSurrogate(ee.charCodeAt(Q))},e.isInsideSurrogatePair=function(X,$,Q){return this.isHighSurrogate(X,$,Q-2)},e.visibleColumnFromColumn=function(X,$,Q){var ee=X.length;ee>$-1&&(ee=$-1);for(var te=0,ne=0;ne<ee;ne++){var ie=X.charCodeAt(ne);9===ie?te=this.nextTabStop(te,Q):J.isFullWidthCharacter(ie)?te+=2:te+=1}return te},e.visibleColumnFromColumn2=function(X,$,Q){return this.visibleColumnFromColumn($.getLineContent(Q.lineNumber),Q.column,X.tabSize)},e.columnFromVisibleColumn=function(X,$,Q){if($<=0)return 1;for(var ee=X.length,te=0,ne=0;ne<ee;ne++){var ie,oe=X.charCodeAt(ne);if((ie=9===oe?this.nextTabStop(te,Q):J.isFullWidthCharacter(oe)?te+2:te+1)>=$)return ie-$<$-te?ne+2:ne+1;te=ie}return ee+1},e.columnFromVisibleColumn2=function(X,$,Q,J){var ee=this.columnFromVisibleColumn($.getLineContent(Q),J,X.tabSize),te=$.getLineMinColumn(Q);if(ee<te)return te;var ne=$.getLineMaxColumn(Q);return ee>ne?ne:ee},e.nextTabStop=function(X,$){return X+$-X%$},e.prevTabStop=function(X,$){return X-1-(X-1)%$},e}();$.CursorColumns=ue,$.isQuote=function(X){return"'"===X||'"'===X||"`"===X}})),define(Q[178],n([0,1,8,38,3,21,39]),(function(X,$,Q,J,ee,te,ne){Object.defineProperty($,"__esModule",{value:!0});var ie=function(){function e(X,$){this._opts=$,this._selection=X,this._useLastEditRangeForCursorEndPosition=!1,this._selectionStartColumnStaysPut=!1}return e.unshiftIndentCount=function(X,$,Q){var ee=J.CursorColumns.visibleColumnFromColumn(X,$,Q);return J.CursorColumns.prevTabStop(ee,Q)/Q},e.shiftIndentCount=function(X,$,Q){var ee=J.CursorColumns.visibleColumnFromColumn(X,$,Q);return J.CursorColumns.nextTabStop(ee,Q)/Q},e.prototype._addEditOperation=function(X,$,Q){this._useLastEditRangeForCursorEndPosition?X.addTrackedEditOperation($,Q):X.addEditOperation($,Q)},e.prototype.getEditOperations=function(X,$){var te=this._selection.startLineNumber,ie=this._selection.endLineNumber;1===this._selection.endColumn&&te!==ie&&(ie-=1);var oe=this._opts.tabSize,re=this._opts.oneIndent,se=te===ie;if(this._selection.isEmpty()&&/^\s*$/.test(X.getLineContent(te))&&(this._useLastEditRangeForCursorEndPosition=!0),this._opts.useTabStops)for(var ae=["",re],le=0,ue=0,de=te;de<=ie;de++,le=ue){ue=0;var ce=X.getLineContent(de),he=Q.firstNonWhitespaceIndex(ce);if((!this._opts.isUnshift||0!==ce.length&&0!==he)&&(se||this._opts.isUnshift||0!==ce.length)){if(-1===he&&(he=ce.length),de>1&&J.CursorColumns.visibleColumnFromColumn(ce,he+1,oe)%oe!=0&&X.isCheapToTokenize(de-1)){var pe=ne.LanguageConfigurationRegistry.getRawEnterActionAtPosition(X,de-1,X.getLineMaxColumn(de-1));if(pe){if(ue=le,pe.appendText)for(var fe=0,ge=pe.appendText.length;fe<ge&&ue<oe&&32===pe.appendText.charCodeAt(fe);fe++)ue++;for(pe.removeText&&(ue=Math.max(0,ue-pe.removeText)),fe=0;fe<ue&&0!==he&&32===ce.charCodeAt(he-1);fe++)he--}}if(!this._opts.isUnshift||0!==he){var me;for(me=this._opts.isUnshift?e.unshiftIndentCount(ce,he+1,oe):e.shiftIndentCount(ce,he+1,oe),fe=ae.length;fe<=me;fe++)ae[fe]=ae[fe-1]+re;this._addEditOperation($,new ee.Range(de,1,de,he+1),ae[me]),de===te&&(this._selectionStartColumnStaysPut=this._selection.startColumn<=he+1)}}}else for(de=te;de<=ie;de++){ce=X.getLineContent(de),he=Q.firstNonWhitespaceIndex(ce);if((!this._opts.isUnshift||0!==ce.length&&0!==he)&&(se||this._opts.isUnshift||0!==ce.length)&&(-1===he&&(he=ce.length),!this._opts.isUnshift||0!==he))if(this._opts.isUnshift){he=Math.min(he,oe);for(var ve=0;ve<he;ve++)if(9===ce.charCodeAt(ve)){he=ve+1;break}this._addEditOperation($,new ee.Range(de,1,de,he+1),"")}else this._addEditOperation($,new ee.Range(de,1,de,1),re),de===te&&(this._selectionStartColumnStaysPut=1===this._selection.startColumn)}this._selectionId=$.trackSelection(this._selection)},e.prototype.computeCursorState=function(X,$){if(this._useLastEditRangeForCursorEndPosition){var Q=$.getInverseEditOperations()[0];return new te.Selection(Q.range.endLineNumber,Q.range.endColumn,Q.range.endLineNumber,Q.range.endColumn)}var J=$.getTrackedSelection(this._selectionId);if(this._selectionStartColumnStaysPut){var ee=this._selection.startColumn;return J.startColumn<=ee?J:0===J.getDirection()?new te.Selection(J.startLineNumber,ee,J.endLineNumber,J.endColumn):new te.Selection(J.endLineNumber,J.endColumn,J.startLineNumber,ee)}return J},e}();$.ShiftCommand=ie})),define(Q[372],n([0,1,38,12,3]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var te=function(){function e(){}return e._columnSelect=function(X,$,te,ne,ie,oe){for(var re=Math.abs(ie-te)+1,se=te>ie,ae=ne>oe,le=ne<oe,ue=[],de=0;de<re;de++){var ce=te+(se?-de:de),he=Q.CursorColumns.columnFromVisibleColumn2(X,$,ce,ne),pe=Q.CursorColumns.columnFromVisibleColumn2(X,$,ce,oe),fe=Q.CursorColumns.visibleColumnFromColumn2(X,$,new J.Position(ce,he)),ge=Q.CursorColumns.visibleColumnFromColumn2(X,$,new J.Position(ce,pe));if(le){if(fe>oe)continue;if(ge<ne)continue}if(ae){if(ge>ne)continue;if(fe<oe)continue}ue.push(new Q.SingleCursorState(new ee.Range(ce,he,ce,he),0,new J.Position(ce,pe),0))}return{viewStates:ue,reversed:se,toLineNumber:ie,toVisualColumn:oe}},e.columnSelect=function(X,$,ee,te,ne){var ie=new J.Position(ee.selectionStartLineNumber,ee.selectionStartColumn),oe=Q.CursorColumns.visibleColumnFromColumn2(X,$,ie);return e._columnSelect(X,$,ie.lineNumber,oe,te,ne)},e.columnSelectLeft=function(X,$,Q,J,ee){return ee>1&&ee--,this.columnSelect(X,$,Q.selection,J,ee)},e.columnSelectRight=function(X,$,ee,te,ne){for(var ie=0,oe=Math.min(ee.position.lineNumber,te),re=Math.max(ee.position.lineNumber,te),se=oe;se<=re;se++){var ae=$.getLineMaxColumn(se),le=Q.CursorColumns.visibleColumnFromColumn2(X,$,new J.Position(se,ae));ie=Math.max(ie,le)}return ne<ie&&ne++,this.columnSelect(X,$,ee.selection,te,ne)},e.columnSelectUp=function(X,$,Q,J,ee,te){return(ee-=J?X.pageSize:1)<1&&(ee=1),this.columnSelect(X,$,Q.selection,ee,te)},e.columnSelectDown=function(X,$,Q,J,ee,te){return(ee+=J?X.pageSize:1)>$.getLineCount()&&(ee=$.getLineCount()),this.columnSelect(X,$,Q.selection,ee,te)},e}();$.ColumnSelection=te})),define(Q[181],n([0,1,38,12,3]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var r=function(X,$,Q){this.lineNumber=X,this.column=$,this.leftoverVisibleColumns=Q};$.CursorPosition=r;var te=function(){function e(){}return e.left=function(X,$,J,ee){return ee>$.getLineMinColumn(J)?Q.CursorColumns.isLowSurrogate($,J,ee-2)?ee-=2:ee-=1:J>1&&(J-=1,ee=$.getLineMaxColumn(J)),new r(J,ee,0)},e.moveLeft=function(X,$,Q,J,ee){var te,ne;if(Q.hasSelection()&&!J)te=Q.selection.startLineNumber,ne=Q.selection.startColumn;else{var ie=e.left(X,$,Q.position.lineNumber,Q.position.column-(ee-1));te=ie.lineNumber,ne=ie.column}return Q.move(J,te,ne,0)},e.right=function(X,$,J,ee){return ee<$.getLineMaxColumn(J)?Q.CursorColumns.isHighSurrogate($,J,ee-1)?ee+=2:ee+=1:J<$.getLineCount()&&(J+=1,ee=$.getLineMinColumn(J)),new r(J,ee,0)},e.moveRight=function(X,$,Q,J,ee){var te,ne;if(Q.hasSelection()&&!J)te=Q.selection.endLineNumber,ne=Q.selection.endColumn;else{var ie=e.right(X,$,Q.position.lineNumber,Q.position.column+(ee-1));te=ie.lineNumber,ne=ie.column}return Q.move(J,te,ne,0)},e.down=function(X,$,J,ee,te,ne,ie){var oe=Q.CursorColumns.visibleColumnFromColumn($.getLineContent(J),ee,X.tabSize)+te;J+=ne;var re=$.getLineCount();return J>re?(J=re,ie?ee=$.getLineMaxColumn(J):(ee=Math.min($.getLineMaxColumn(J),ee),Q.CursorColumns.isInsideSurrogatePair($,J,ee)&&(ee-=1))):(ee=Q.CursorColumns.columnFromVisibleColumn2(X,$,J,oe),Q.CursorColumns.isInsideSurrogatePair($,J,ee)&&(ee-=1)),te=oe-Q.CursorColumns.visibleColumnFromColumn($.getLineContent(J),ee,X.tabSize),new r(J,ee,te)},e.moveDown=function(X,$,Q,J,ee){var te,ne;Q.hasSelection()&&!J?(te=Q.selection.endLineNumber,ne=Q.selection.endColumn):(te=Q.position.lineNumber,ne=Q.position.column);var ie=e.down(X,$,te,ne,Q.leftoverVisibleColumns,ee,!0);return Q.move(J,ie.lineNumber,ie.column,ie.leftoverVisibleColumns)},e.translateDown=function(X,$,te){var ne=te.selection,ie=e.down(X,$,ne.selectionStartLineNumber,ne.selectionStartColumn,te.selectionStartLeftoverVisibleColumns,1,!1),oe=e.down(X,$,ne.positionLineNumber,ne.positionColumn,te.leftoverVisibleColumns,1,!1);return new Q.SingleCursorState(new ee.Range(ie.lineNumber,ie.column,ie.lineNumber,ie.column),ie.leftoverVisibleColumns,new J.Position(oe.lineNumber,oe.column),oe.leftoverVisibleColumns)},e.up=function(X,$,J,ee,te,ne,ie){var oe=Q.CursorColumns.visibleColumnFromColumn($.getLineContent(J),ee,X.tabSize)+te;return(J-=ne)<1?(J=1,ie?ee=$.getLineMinColumn(J):(ee=Math.min($.getLineMaxColumn(J),ee),Q.CursorColumns.isInsideSurrogatePair($,J,ee)&&(ee-=1))):(ee=Q.CursorColumns.columnFromVisibleColumn2(X,$,J,oe),Q.CursorColumns.isInsideSurrogatePair($,J,ee)&&(ee-=1)),te=oe-Q.CursorColumns.visibleColumnFromColumn($.getLineContent(J),ee,X.tabSize),new r(J,ee,te)},e.moveUp=function(X,$,Q,J,ee){var te,ne;Q.hasSelection()&&!J?(te=Q.selection.startLineNumber,ne=Q.selection.startColumn):(te=Q.position.lineNumber,ne=Q.position.column);var ie=e.up(X,$,te,ne,Q.leftoverVisibleColumns,ee,!0);return Q.move(J,ie.lineNumber,ie.column,ie.leftoverVisibleColumns)},e.translateUp=function(X,$,te){var ne=te.selection,ie=e.up(X,$,ne.selectionStartLineNumber,ne.selectionStartColumn,te.selectionStartLeftoverVisibleColumns,1,!1),oe=e.up(X,$,ne.positionLineNumber,ne.positionColumn,te.leftoverVisibleColumns,1,!1);return new Q.SingleCursorState(new ee.Range(ie.lineNumber,ie.column,ie.lineNumber,ie.column),ie.leftoverVisibleColumns,new J.Position(oe.lineNumber,oe.column),oe.leftoverVisibleColumns)},e.moveToBeginningOfLine=function(X,$,Q,J){var ee,te=Q.position.lineNumber,ne=$.getLineMinColumn(te),ie=$.getLineFirstNonWhitespaceColumn(te)||ne;return ee=Q.position.column===ie?ne:ie,Q.move(J,te,ee,0)},e.moveToEndOfLine=function(X,$,Q,J){var ee=Q.position.lineNumber,te=$.getLineMaxColumn(ee);return Q.move(J,ee,te,0)},e.moveToBeginningOfBuffer=function(X,$,Q,J){return Q.move(J,1,1,0)},e.moveToEndOfBuffer=function(X,$,Q,J){var ee=$.getLineCount(),te=$.getLineMaxColumn(ee);return Q.move(J,ee,te,0)},e}();$.MoveOperations=te})),define(Q[182],n([0,1,8,77,38,181,3]),(function(X,$,Q,J,ee,te,ne){Object.defineProperty($,"__esModule",{value:!0});var ie=function(){function e(){}return e.deleteRight=function(X,$,Q,ee){for(var ie=[],oe=3!==X,re=0,se=ee.length;re<se;re++){var ae=ee[re],le=ae;if(le.isEmpty()){var ue=ae.getPosition(),de=te.MoveOperations.right($,Q,ue.lineNumber,ue.column);le=new ne.Range(de.lineNumber,de.column,ue.lineNumber,ue.column)}le.isEmpty()?ie[re]=null:(le.startLineNumber!==le.endLineNumber&&(oe=!0),ie[re]=new J.ReplaceCommand(le,""))}return[oe,ie]},e._isAutoClosingPairDelete=function(X,$,Q){if("never"===X.autoClosingBrackets&&"never"===X.autoClosingQuotes)return!1;for(var J=0,te=Q.length;J<te;J++){var ne=Q[J],ie=ne.getPosition();if(!ne.isEmpty())return!1;var oe=$.getLineContent(ie.lineNumber),re=oe[ie.column-2];if(!X.autoClosingPairsOpen.hasOwnProperty(re))return!1;if(ee.isQuote(re)){if("never"===X.autoClosingQuotes)return!1}else if("never"===X.autoClosingBrackets)return!1;if(oe[ie.column-1]!==X.autoClosingPairsOpen[re])return!1}return!0},e._runAutoClosingPairDelete=function(X,$,Q){for(var ee=[],te=0,ie=Q.length;te<ie;te++){var oe=Q[te].getPosition(),re=new ne.Range(oe.lineNumber,oe.column-1,oe.lineNumber,oe.column+1);ee[te]=new J.ReplaceCommand(re,"")}return[!0,ee]},e.deleteLeft=function(X,$,ie,oe){if(this._isAutoClosingPairDelete($,ie,oe))return this._runAutoClosingPairDelete($,ie,oe);for(var re=[],se=2!==X,ae=0,le=oe.length;ae<le;ae++){var ue=oe[ae],de=ue;if(de.isEmpty()){var ce=ue.getPosition();if($.useTabStops&&ce.column>1){var he=ie.getLineContent(ce.lineNumber),pe=Q.firstNonWhitespaceIndex(he),fe=-1===pe?he.length+1:pe+1;if(ce.column<=fe){var ge=ee.CursorColumns.visibleColumnFromColumn2($,ie,ce),me=ee.CursorColumns.prevTabStop(ge,$.tabSize),ve=ee.CursorColumns.columnFromVisibleColumn2($,ie,ce.lineNumber,me);de=new ne.Range(ce.lineNumber,ve,ce.lineNumber,ce.column)}else de=new ne.Range(ce.lineNumber,ce.column-1,ce.lineNumber,ce.column)}else{var _e=te.MoveOperations.left($,ie,ce.lineNumber,ce.column);de=new ne.Range(_e.lineNumber,_e.column,ce.lineNumber,ce.column)}}de.isEmpty()?re[ae]=null:(de.startLineNumber!==de.endLineNumber&&(se=!0),re[ae]=new J.ReplaceCommand(de,""))}return[se,re]},e.cut=function(X,$,Q){for(var te=[],ie=0,oe=Q.length;ie<oe;ie++){var re=Q[ie];if(re.isEmpty())if(X.emptySelectionClipboard){var se=re.getPosition(),ae=void 0,le=void 0,ue=void 0,de=void 0;se.lineNumber<$.getLineCount()?(ae=se.lineNumber,le=1,ue=se.lineNumber+1,de=1):se.lineNumber>1?(ae=se.lineNumber-1,le=$.getLineMaxColumn(se.lineNumber-1),ue=se.lineNumber,de=$.getLineMaxColumn(se.lineNumber)):(ae=se.lineNumber,le=1,ue=se.lineNumber,de=$.getLineMaxColumn(se.lineNumber));var ce=new ne.Range(ae,le,ue,de);ce.isEmpty()?te[ie]=null:te[ie]=new J.ReplaceCommand(ce,"")}else te[ie]=null;else te[ie]=new J.ReplaceCommand(re,"")}return new ee.EditOperationResult(0,te,{shouldPushStackElementBefore:!0,shouldPushStackElementAfter:!0})},e}();$.DeleteOperations=ie})),define(Q[137],n([0,1,11,8,77,178,432,38,80,3,74,39]),(function(X,$,Q,J,ee,te,ne,ie,oe,re,se,ae){Object.defineProperty($,"__esModule",{value:!0});var le=function(){function e(){}return e.indent=function(X,$,Q){for(var J=[],ee=0,ne=Q.length;ee<ne;ee++)J[ee]=new te.ShiftCommand(Q[ee],{isUnshift:!1,tabSize:X.tabSize,oneIndent:X.oneIndent,useTabStops:X.useTabStops});return J},e.outdent=function(X,$,Q){for(var J=[],ee=0,ne=Q.length;ee<ne;ee++)J[ee]=new te.ShiftCommand(Q[ee],{isUnshift:!0,tabSize:X.tabSize,oneIndent:X.oneIndent,useTabStops:X.useTabStops});return J},e.shiftIndent=function(X,$,Q){Q=Q||1;for(var J=te.ShiftCommand.shiftIndentCount($,$.length+Q,X.tabSize),ee="",ne=0;ne<J;ne++)ee+="\t";return ee},e.unshiftIndent=function(X,$,Q){Q=Q||1;for(var J=te.ShiftCommand.unshiftIndentCount($,$.length+Q,X.tabSize),ee="",ne=0;ne<J;ne++)ee+="\t";return ee},e._distributedPaste=function(X,$,Q,J){for(var te=[],ne=0,oe=Q.length;ne<oe;ne++)te[ne]=new ee.ReplaceCommand(Q[ne],J[ne]);return new ie.EditOperationResult(0,te,{shouldPushStackElementBefore:!0,shouldPushStackElementAfter:!0})},e._simplePaste=function(X,$,Q,J,te){for(var ne=[],oe=0,se=Q.length;oe<se;oe++){var ae=Q[oe],le=ae.getPosition();if(te&&J.indexOf("\n")!==J.length-1&&(te=!1),te&&ae.startLineNumber!==ae.endLineNumber&&(te=!1),te&&ae.startColumn===$.getLineMinColumn(ae.startLineNumber)&&ae.endColumn===$.getLineMaxColumn(ae.startLineNumber)&&(te=!1),te){var ue=new re.Range(le.lineNumber,1,le.lineNumber,1);ne[oe]=new ee.ReplaceCommand(ue,J)}else ne[oe]=new ee.ReplaceCommand(ae,J)}return new ie.EditOperationResult(0,ne,{shouldPushStackElementBefore:!0,shouldPushStackElementAfter:!0})},e._distributePasteToCursors=function(X,$,Q,J){if(Q)return null;if(1===X.length)return null;if(J&&J.length===X.length)return J;10===$.charCodeAt($.length-1)&&($=$.substr(0,$.length-1));var ee=$.split(/\r\n|\r|\n/);return ee.length===X.length?ee:null},e.paste=function(X,$,Q,J,ee,te){var ne=this._distributePasteToCursors(Q,J,ee,te);return ne?(Q=Q.sort(re.Range.compareRangesUsingStarts),this._distributedPaste(X,$,Q,ne)):this._simplePaste(X,$,Q,J,ee)},e._goodIndentForLine=function(X,$,Q){var ee=null,te="",ne=X.autoIndent?ae.LanguageConfigurationRegistry.getInheritIndentForLine($,Q,!1):null;if(ne)ee=ne.action,te=ne.indentation;else if(Q>1){var ie=Q-1;for(ie=Q-1;ie>=1;ie--){var oe=$.getLineContent(ie);if(J.lastNonWhitespaceIndex(oe)>=0)break}if(ie<1)return null;var le=$.getLineMaxColumn(ie),ue=ae.LanguageConfigurationRegistry.getEnterAction($,new re.Range(ie,le,ie,le));ue&&(te=ue.indentation,(ee=ue.enterAction)&&(te+=ee.appendText))}return ee&&(ee===se.IndentAction.Indent&&(te=e.shiftIndent(X,te)),ee===se.IndentAction.Outdent&&(te=e.unshiftIndent(X,te)),te=X.normalizeIndentation(te)),te||null},e._replaceJumpToNextIndent=function(X,$,Q,J){var te="",ne=Q.getStartPosition();if(X.insertSpaces)for(var oe=ie.CursorColumns.visibleColumnFromColumn2(X,$,ne),re=X.tabSize,se=re-oe%re,ae=0;ae<se;ae++)te+=" ";else te="\t";return new ee.ReplaceCommand(Q,te,J)},e.tab=function(X,$,Q){for(var ne=[],ie=0,oe=Q.length;ie<oe;ie++){var se=Q[ie];if(se.isEmpty()){var ae=$.getLineContent(se.startLineNumber);if(/^\s*$/.test(ae)&&$.isCheapToTokenize(se.startLineNumber)){var le=this._goodIndentForLine(X,$,se.startLineNumber);le=le||"\t";var ue=X.normalizeIndentation(le);if(!J.startsWith(ae,ue)){ne[ie]=new ee.ReplaceCommand(new re.Range(se.startLineNumber,1,se.startLineNumber,ae.length+1),ue,!0);continue}}ne[ie]=this._replaceJumpToNextIndent(X,$,se,!0)}else{if(se.startLineNumber===se.endLineNumber){var de=$.getLineMaxColumn(se.startLineNumber);if(1!==se.startColumn||se.endColumn!==de){ne[ie]=this._replaceJumpToNextIndent(X,$,se,!1);continue}}ne[ie]=new te.ShiftCommand(se,{isUnshift:!1,tabSize:X.tabSize,oneIndent:X.oneIndent,useTabStops:X.useTabStops})}}return ne},e.replacePreviousChar=function(X,$,Q,J,te,ne){for(var oe=[],se=0,ae=J.length;se<ae;se++){var le=J[se];if(le.isEmpty()){var ue=le.getPosition(),de=Math.max(1,ue.column-ne),ce=new re.Range(ue.lineNumber,de,ue.lineNumber,ue.column);oe[se]=new ee.ReplaceCommand(ce,te)}else oe[se]=null}return new ie.EditOperationResult(1,oe,{shouldPushStackElementBefore:1!==X,shouldPushStackElementAfter:!1})},e._typeCommand=function(X,$,Q){return Q?new ee.ReplaceCommandWithoutChangingPosition(X,$,!0):new ee.ReplaceCommand(X,$,!0)},e._enter=function(X,$,Q,te){if(!$.isCheapToTokenize(te.getStartPosition().lineNumber)){var ne=$.getLineContent(te.startLineNumber),oe=J.getLeadingWhitespace(ne).substring(0,te.startColumn-1);return e._typeCommand(te,"\n"+X.normalizeIndentation(oe),Q)}var le=ae.LanguageConfigurationRegistry.getEnterAction($,te);if(le){var ue=le.enterAction,de=le.indentation;if(ue.indentAction===se.IndentAction.None)return e._typeCommand(te,"\n"+X.normalizeIndentation(de+ue.appendText),Q);if(ue.indentAction===se.IndentAction.Indent)return e._typeCommand(te,"\n"+X.normalizeIndentation(de+ue.appendText),Q);if(ue.indentAction===se.IndentAction.IndentOutdent){var ce=X.normalizeIndentation(de),he=X.normalizeIndentation(de+ue.appendText),pe="\n"+he+"\n"+ce;return Q?new ee.ReplaceCommandWithoutChangingPosition(te,pe,!0):new ee.ReplaceCommandWithOffsetCursorState(te,pe,-1,he.length-ce.length,!0)}if(ue.indentAction===se.IndentAction.Outdent){var fe=e.unshiftIndent(X,de);return e._typeCommand(te,"\n"+X.normalizeIndentation(fe+ue.appendText),Q)}}if(!X.autoIndent){var ge=$.getLineContent(te.startLineNumber),me=J.getLeadingWhitespace(ge).substring(0,te.startColumn-1);return e._typeCommand(te,"\n"+X.normalizeIndentation(me),Q)}var ve=ae.LanguageConfigurationRegistry.getIndentForEnter($,te,{unshiftIndent:function($){return e.unshiftIndent(X,$)},shiftIndent:function($){return e.shiftIndent(X,$)},normalizeIndentation:function($){return X.normalizeIndentation($)}},X.autoIndent),_e=$.getLineContent(te.startLineNumber),ye=J.getLeadingWhitespace(_e).substring(0,te.startColumn-1);if(ve){var be=ie.CursorColumns.visibleColumnFromColumn2(X,$,te.getEndPosition()),Ce=te.endColumn,we="\n";ye!==X.normalizeIndentation(ve.beforeEnter)&&(we=X.normalizeIndentation(ve.beforeEnter)+_e.substring(ye.length,te.startColumn-1)+"\n",te=new re.Range(te.startLineNumber,1,te.endLineNumber,te.endColumn));var Se=$.getLineContent(te.endLineNumber),Ee=J.firstNonWhitespaceIndex(Se);if(te=Ee>=0?te.setEndPosition(te.endLineNumber,Math.max(te.endColumn,Ee+1)):te.setEndPosition(te.endLineNumber,$.getLineMaxColumn(te.endLineNumber)),Q)return new ee.ReplaceCommandWithoutChangingPosition(te,we+X.normalizeIndentation(ve.afterEnter),!0);var Le=0;return Ce<=Ee+1&&(X.insertSpaces||(be=Math.ceil(be/X.tabSize)),Le=Math.min(be+1-X.normalizeIndentation(ve.afterEnter).length-1,0)),new ee.ReplaceCommandWithOffsetCursorState(te,we+X.normalizeIndentation(ve.afterEnter),0,Le,!0)}return e._typeCommand(te,"\n"+X.normalizeIndentation(ye),Q)},e._isAutoIndentType=function(X,$,Q){if(!X.autoIndent)return!1;for(var J=0,ee=Q.length;J<ee;J++)if(!$.isCheapToTokenize(Q[J].getEndPosition().lineNumber))return!1;return!0},e._runAutoIndentType=function(X,$,Q,J){var ee=ae.LanguageConfigurationRegistry.getIndentationAtPosition($,Q.startLineNumber,Q.startColumn),te=ae.LanguageConfigurationRegistry.getIndentActionForType($,Q,J,{shiftIndent:function($){return e.shiftIndent(X,$)},unshiftIndent:function($){return e.unshiftIndent(X,$)}});if(null===te)return null;if(te!==X.normalizeIndentation(ee)){var ne=$.getLineFirstNonWhitespaceColumn(Q.startLineNumber);return 0===ne?e._typeCommand(new re.Range(Q.startLineNumber,0,Q.endLineNumber,Q.endColumn),X.normalizeIndentation(te)+J,!1):e._typeCommand(new re.Range(Q.startLineNumber,0,Q.endLineNumber,Q.endColumn),X.normalizeIndentation(te)+$.getLineContent(Q.startLineNumber).substring(ne-1,Q.startColumn-1)+J,!1)}return null},e._isAutoClosingCloseCharType=function(X,$,Q,J){if("never"===(ie.isQuote(J)?X.autoClosingQuotes:X.autoClosingBrackets)||!X.autoClosingPairsClose.hasOwnProperty(J))return!1;for(var ee=J===X.autoClosingPairsClose[J],te=0,ne=Q.length;te<ne;te++){var oe=Q[te];if(!oe.isEmpty())return!1;var re=oe.getPosition(),se=$.getLineContent(re.lineNumber);if(se.charAt(re.column-1)!==J)return!1;if(ee){var ae=se.substr(0,re.column-1);if(this._countNeedlesInHaystack(ae,J)%2==0)return!1}}return!0},e._countNeedlesInHaystack=function(X,$){for(var Q=0,J=-1;-1!==(J=X.indexOf($,J+1));)Q++;return Q},e._runAutoClosingCloseCharType=function(X,$,Q,J,te){for(var ne=[],oe=0,se=J.length;oe<se;oe++){var ae=J[oe].getPosition(),le=new re.Range(ae.lineNumber,ae.column,ae.lineNumber,ae.column+1);ne[oe]=new ee.ReplaceCommand(le,te)}return new ie.EditOperationResult(1,ne,{shouldPushStackElementBefore:1!==X,shouldPushStackElementAfter:!1})},e._isBeforeClosingBrace=function(X,$,Q){var J=X.autoClosingPairsOpen[$]===$,ee=!1;for(var te in X.autoClosingPairsClose){var ne=X.autoClosingPairsOpen[te]===te;if((J||!ne)&&Q===te){ee=!0;break}}return ee},e._isAutoClosingOpenCharType=function(X,$,J,ee){var te=ie.isQuote(ee);if("never"===(te?X.autoClosingQuotes:X.autoClosingBrackets)||!X.autoClosingPairsOpen.hasOwnProperty(ee))return!1;for(var ne=te?X.shouldAutoCloseBefore.quote:X.shouldAutoCloseBefore.bracket,re=0,se=J.length;re<se;re++){var le=J[re];if(!le.isEmpty())return!1;var ue=le.getPosition(),de=$.getLineContent(ue.lineNumber);if(te&&ue.column>1){var ce=oe.getMapForWordSeparators(X.wordSeparators),he=de.charCodeAt(ue.column-2);if(0===ce.get(he))return!1}var pe=de.charAt(ue.column-1);if(pe&&!e._isBeforeClosingBrace(X,ee,pe)&&!ne(pe))return!1;if(!$.isCheapToTokenize(ue.lineNumber))return!1;$.forceTokenization(ue.lineNumber);var fe=$.getLineTokens(ue.lineNumber),ge=!1;try{ge=ae.LanguageConfigurationRegistry.shouldAutoClosePair(ee,fe,ue.column)}catch(X){Q.onUnexpectedError(X)}if(!ge)return!1}return!0},e._runAutoClosingOpenCharType=function(X,$,Q,J,te){for(var ne=[],oe=0,re=J.length;oe<re;oe++){var se=J[oe],ae=$.autoClosingPairsOpen[te];ne[oe]=new ee.ReplaceCommandWithOffsetCursorState(se,te+ae,0,-ae.length)}return new ie.EditOperationResult(1,ne,{shouldPushStackElementBefore:!0,shouldPushStackElementAfter:!1})},e._shouldSurroundChar=function(X,$){return ie.isQuote($)?"quotes"===X.autoSurround||"languageDefined"===X.autoSurround:"brackets"===X.autoSurround||"languageDefined"===X.autoSurround},e._isSurroundSelectionType=function(X,$,Q,J){if(!e._shouldSurroundChar(X,J)||!X.surroundingPairs.hasOwnProperty(J))return!1;for(var ee=ie.isQuote(J),te=0,ne=Q.length;te<ne;te++){var oe=Q[te];if(oe.isEmpty())return!1;for(var re=!0,se=oe.startLineNumber;se<=oe.endLineNumber;se++){var ae=$.getLineContent(se),le=se===oe.startLineNumber?oe.startColumn-1:0,ue=se===oe.endLineNumber?oe.endColumn-1:ae.length,de=ae.substring(le,ue);if(/[^ \t]/.test(de)){re=!1;break}}if(re)return!1;if(ee&&oe.startLineNumber===oe.endLineNumber&&oe.startColumn+1===oe.endColumn){var ce=$.getValueInRange(oe);if(ie.isQuote(ce))return!1}}return!0},e._runSurroundSelectionType=function(X,$,Q,J,ee){for(var te=[],oe=0,re=J.length;oe<re;oe++){var se=J[oe],ae=$.surroundingPairs[ee];te[oe]=new ne.SurroundSelectionCommand(se,ee,ae)}return new ie.EditOperationResult(0,te,{shouldPushStackElementBefore:!0,shouldPushStackElementAfter:!0})},e._isTypeInterceptorElectricChar=function(X,$,Q){return!(1!==Q.length||!$.isCheapToTokenize(Q[0].getEndPosition().lineNumber))},e._typeInterceptorElectricChar=function(X,$,te,ne,oe){if(!$.electricChars.hasOwnProperty(oe)||!ne.isEmpty())return null;var se=ne.getPosition();te.forceTokenization(se.lineNumber);var le,ue=te.getLineTokens(se.lineNumber);try{le=ae.LanguageConfigurationRegistry.onElectricCharacter(oe,ue,se.column)}catch(X){return Q.onUnexpectedError(X),null}if(!le)return null;if(le.appendText)return ye=new ee.ReplaceCommandWithOffsetCursorState(ne,oe+le.appendText,0,-le.appendText.length),new ie.EditOperationResult(1,[ye],{shouldPushStackElementBefore:!1,shouldPushStackElementAfter:!0});if(le.matchOpenBracket){var de=(ue.getLineContent()+oe).lastIndexOf(le.matchOpenBracket)+1,ce=te.findMatchingBracketUp(le.matchOpenBracket,{lineNumber:se.lineNumber,column:de});if(ce){if(ce.startLineNumber===se.lineNumber)return null;var he=te.getLineContent(ce.startLineNumber),pe=J.getLeadingWhitespace(he),fe=$.normalizeIndentation(pe),ge=te.getLineContent(se.lineNumber),me=te.getLineFirstNonWhitespaceColumn(se.lineNumber)||se.column,ve=fe+ge.substring(me-1,se.column-1)+oe,_e=new re.Range(se.lineNumber,1,se.lineNumber,se.column),ye=new ee.ReplaceCommand(_e,ve);return new ie.EditOperationResult(1,[ye],{shouldPushStackElementBefore:!1,shouldPushStackElementAfter:!0})}}return null},e.compositionEndWithInterceptors=function(X,$,J,te){if("never"===$.autoClosingQuotes)return null;for(var ne=[],re=0;re<te.length;re++)if(te[re].isEmpty()){var se=te[re].getPosition(),le=J.getLineContent(se.lineNumber),ue=le.charAt(se.column-2);if($.autoClosingPairsClose.hasOwnProperty(ue)&&ue===$.autoClosingPairsClose[ue]){var de=le.substr(0,se.column-2);if(this._countNeedlesInHaystack(de,ue)%2==1)continue}if($.autoClosingPairsOpen.hasOwnProperty(ue)){if(ie.isQuote(ue)&&se.column>2){var ce=oe.getMapForWordSeparators($.wordSeparators),he=le.charCodeAt(se.column-3);if(0===ce.get(he))continue}var pe=le.charAt(se.column-1);if(pe){var fe=e._isBeforeClosingBrace($,ue,pe),ge=ie.isQuote(ue)?$.shouldAutoCloseBefore.quote:$.shouldAutoCloseBefore.bracket;if(fe)continue;if(!ge(pe))continue}if(!J.isCheapToTokenize(se.lineNumber))continue;J.forceTokenization(se.lineNumber);var me=J.getLineTokens(se.lineNumber),ve=!1;try{ve=ae.LanguageConfigurationRegistry.shouldAutoClosePair(ue,me,se.column-1)}catch(X){Q.onUnexpectedError(X)}if(ve){var _e=$.autoClosingPairsOpen[ue];ne[re]=new ee.ReplaceCommandWithOffsetCursorState(te[re],_e,0,-_e.length)}}}return new ie.EditOperationResult(1,ne,{shouldPushStackElementBefore:!0,shouldPushStackElementAfter:!1})},e.typeWithInterceptors=function(X,$,Q,J,te){if("\n"===te){for(var ne=[],oe=0,re=J.length;oe<re;oe++)ne[oe]=e._enter($,Q,!1,J[oe]);return new ie.EditOperationResult(1,ne,{shouldPushStackElementBefore:!0,shouldPushStackElementAfter:!1})}if(this._isAutoIndentType($,Q,J)){var se=[],ae=!1;for(oe=0,re=J.length;oe<re;oe++)if(se[oe]=this._runAutoIndentType($,Q,J[oe],te),!se[oe]){ae=!0;break}if(!ae)return new ie.EditOperationResult(1,se,{shouldPushStackElementBefore:!0,shouldPushStackElementAfter:!1})}if(this._isAutoClosingCloseCharType($,Q,J,te))return this._runAutoClosingCloseCharType(X,$,Q,J,te);if(this._isAutoClosingOpenCharType($,Q,J,te))return this._runAutoClosingOpenCharType(X,$,Q,J,te);if(this._isSurroundSelectionType($,Q,J,te))return this._runSurroundSelectionType(X,$,Q,J,te);if(this._isTypeInterceptorElectricChar($,Q,J)){var le=this._typeInterceptorElectricChar(X,$,Q,J[0],te);if(le)return le}var ue=[];for(oe=0,re=J.length;oe<re;oe++)ue[oe]=new ee.ReplaceCommand(J[oe],te);var de=1!==X;return" "===te&&(de=!0),new ie.EditOperationResult(1,ue,{shouldPushStackElementBefore:de,shouldPushStackElementAfter:!1})},e.typeWithoutInterceptors=function(X,$,Q,J,te){for(var ne=[],oe=0,re=J.length;oe<re;oe++)ne[oe]=new ee.ReplaceCommand(J[oe],te);return new ie.EditOperationResult(1,ne,{shouldPushStackElementBefore:1!==X,shouldPushStackElementAfter:!1})},e.lineInsertBefore=function(X,$,Q){for(var J=[],te=0,ne=Q.length;te<ne;te++){var ie=Q[te].positionLineNumber;if(1===ie)J[te]=new ee.ReplaceCommandWithoutChangingPosition(new re.Range(1,1,1,1),"\n");else{ie--;var oe=$.getLineMaxColumn(ie);J[te]=this._enter(X,$,!1,new re.Range(ie,oe,ie,oe))}}return J},e.lineInsertAfter=function(X,$,Q){for(var J=[],ee=0,te=Q.length;ee<te;ee++){var ne=Q[ee].positionLineNumber,ie=$.getLineMaxColumn(ne);J[ee]=this._enter(X,$,!1,new re.Range(ne,ie,ne,ie))}return J},e.lineBreakInsert=function(X,$,Q){for(var J=[],ee=0,te=Q.length;ee<te;ee++)J[ee]=this._enter(X,$,!0,Q[ee]);return J},e}();$.TypeOperations=le})),define(Q[138],n([0,1,8,38,80,12,3]),(function(X,$,Q,J,ee,ne,ie){function l(X){return X.filter((function(X){return Boolean(X)}))}Object.defineProperty($,"__esModule",{value:!0});var oe=function(){function e(){}return e._createWord=function(X,$,Q,J,ee){return{start:J,end:ee,wordType:$,nextCharClass:Q}},e._findPreviousWordOnLine=function(X,$,Q){var J=$.getLineContent(Q.lineNumber);return this._doFindPreviousWordOnLine(J,X,Q)},e._doFindPreviousWordOnLine=function(X,$,Q){for(var J=0,ee=Q.column-2;ee>=0;ee--){var te=X.charCodeAt(ee),ne=$.get(te);if(0===ne){if(2===J)return this._createWord(X,J,ne,ee+1,this._findEndOfWord(X,$,J,ee+1));J=1}else if(2===ne){if(1===J)return this._createWord(X,J,ne,ee+1,this._findEndOfWord(X,$,J,ee+1));J=2}else if(1===ne&&0!==J)return this._createWord(X,J,ne,ee+1,this._findEndOfWord(X,$,J,ee+1))}return 0!==J?this._createWord(X,J,1,0,this._findEndOfWord(X,$,J,0)):null},e._findEndOfWord=function(X,$,Q,J){for(var ee=X.length,te=J;te<ee;te++){var ne=X.charCodeAt(te),ie=$.get(ne);if(1===ie)return te;if(1===Q&&2===ie)return te;if(2===Q&&0===ie)return te}return ee},e._findNextWordOnLine=function(X,$,Q){var J=$.getLineContent(Q.lineNumber);return this._doFindNextWordOnLine(J,X,Q)},e._doFindNextWordOnLine=function(X,$,Q){for(var J=0,ee=X.length,te=Q.column-1;te<ee;te++){var ne=X.charCodeAt(te),ie=$.get(ne);if(0===ie){if(2===J)return this._createWord(X,J,ie,this._findStartOfWord(X,$,J,te-1),te);J=1}else if(2===ie){if(1===J)return this._createWord(X,J,ie,this._findStartOfWord(X,$,J,te-1),te);J=2}else if(1===ie&&0!==J)return this._createWord(X,J,ie,this._findStartOfWord(X,$,J,te-1),te)}return 0!==J?this._createWord(X,J,1,this._findStartOfWord(X,$,J,ee-1),ee):null},e._findStartOfWord=function(X,$,Q,J){for(var ee=J;ee>=0;ee--){var te=X.charCodeAt(ee),ne=$.get(te);if(1===ne)return ee+1;if(1===Q&&2===ne)return ee+1;if(2===Q&&0===ne)return ee+1}return 0},e.moveWordLeft=function(X,$,Q,J){var ee=Q.lineNumber,te=Q.column,ie=!1;1===te&&ee>1&&(ie=!0,ee-=1,te=$.getLineMaxColumn(ee));var oe=e._findPreviousWordOnLine(X,$,new ne.Position(ee,te));return 0===J?oe&&!ie&&$.getLineLastNonWhitespaceColumn(ee)<te?new ne.Position(ee,oe.end+1):new ne.Position(ee,oe?oe.start+1:1):1===J?(oe&&2===oe.wordType&&oe.end-oe.start==1&&0===oe.nextCharClass&&(oe=e._findPreviousWordOnLine(X,$,new ne.Position(ee,oe.start+1))),new ne.Position(ee,oe?oe.start+1:1)):(oe&&te<=oe.end+1&&(oe=e._findPreviousWordOnLine(X,$,new ne.Position(ee,oe.start+1))),new ne.Position(ee,oe?oe.end+1:1))},e._moveWordPartLeft=function(X,$){var J=$.lineNumber,ee=X.getLineMaxColumn(J);if(1===$.column)return J>1?new ne.Position(J-1,X.getLineMaxColumn(J-1)):$;for(var te=X.getLineContent(J),ie=$.column-1;ie>1;ie--){var oe=te.charCodeAt(ie-2),re=te.charCodeAt(ie-1);if(95!==oe&&95===re)return new ne.Position(J,ie);if(Q.isLowerAsciiLetter(oe)&&Q.isUpperAsciiLetter(re))return new ne.Position(J,ie);if(Q.isUpperAsciiLetter(oe)&&Q.isUpperAsciiLetter(re)&&ie+1<ee){var se=te.charCodeAt(ie);if(Q.isLowerAsciiLetter(se))return new ne.Position(J,ie)}}return new ne.Position(J,1)},e.moveWordRight=function(X,$,Q,J){var ee=Q.lineNumber,te=Q.column;te===$.getLineMaxColumn(ee)&&ee<$.getLineCount()&&(ee+=1,te=1);var ie=e._findNextWordOnLine(X,$,new ne.Position(ee,te));return 2===J?(ie&&2===ie.wordType&&ie.end-ie.start==1&&0===ie.nextCharClass&&(ie=e._findNextWordOnLine(X,$,new ne.Position(ee,ie.end+1))),te=ie?ie.end+1:$.getLineMaxColumn(ee)):(ie&&te>=ie.start+1&&(ie=e._findNextWordOnLine(X,$,new ne.Position(ee,ie.end+1))),te=ie?ie.start+1:$.getLineMaxColumn(ee)),new ne.Position(ee,te)},e._moveWordPartRight=function(X,$){var J=$.lineNumber,ee=X.getLineMaxColumn(J);if($.column===ee)return J<X.getLineCount()?new ne.Position(J+1,1):$;for(var te=X.getLineContent(J),ie=$.column+1;ie<ee;ie++){var oe=te.charCodeAt(ie-2),re=te.charCodeAt(ie-1);if(95===oe&&95!==re)return new ne.Position(J,ie);if(Q.isLowerAsciiLetter(oe)&&Q.isUpperAsciiLetter(re))return new ne.Position(J,ie);if(Q.isUpperAsciiLetter(oe)&&Q.isUpperAsciiLetter(re)&&ie+1<ee){var se=te.charCodeAt(ie);if(Q.isLowerAsciiLetter(se))return new ne.Position(J,ie)}}return new ne.Position(J,ee)},e._deleteWordLeftWhitespace=function(X,$){var J=X.getLineContent($.lineNumber),ee=$.column-2,te=Q.lastNonWhitespaceIndex(J,ee);return te+1<ee?new ie.Range($.lineNumber,te+2,$.lineNumber,$.column):null},e.deleteWordLeft=function(X,$,Q,J,ee){if(!Q.isEmpty())return Q;var te=new ne.Position(Q.positionLineNumber,Q.positionColumn),oe=te.lineNumber,re=te.column;if(1===oe&&1===re)return null;if(J){var se=this._deleteWordLeftWhitespace($,te);if(se)return se}var ae=e._findPreviousWordOnLine(X,$,te);return 0===ee?ae?re=ae.start+1:re>1?re=1:(oe--,re=$.getLineMaxColumn(oe)):(ae&&re<=ae.end+1&&(ae=e._findPreviousWordOnLine(X,$,new ne.Position(oe,ae.start+1))),ae?re=ae.end+1:re>1?re=1:(oe--,re=$.getLineMaxColumn(oe))),new ie.Range(oe,re,te.lineNumber,te.column)},e._deleteWordPartLeft=function(X,$){if(!$.isEmpty())return $;var Q=$.getPosition(),J=e._moveWordPartLeft(X,Q);return new ie.Range(Q.lineNumber,Q.column,J.lineNumber,J.column)},e._findFirstNonWhitespaceChar=function(X,$){for(var Q=X.length,J=$;J<Q;J++){var ee=X.charAt(J);if(" "!==ee&&"\t"!==ee)return J}return Q},e._deleteWordRightWhitespace=function(X,$){var Q=X.getLineContent($.lineNumber),J=$.column-1,ee=this._findFirstNonWhitespaceChar(Q,J);return J+1<ee?new ie.Range($.lineNumber,$.column,$.lineNumber,ee+1):null},e.deleteWordRight=function(X,$,Q,J,ee){if(!Q.isEmpty())return Q;var te=new ne.Position(Q.positionLineNumber,Q.positionColumn),oe=te.lineNumber,re=te.column,se=$.getLineCount(),ae=$.getLineMaxColumn(oe);if(oe===se&&re===ae)return null;if(J){var le=this._deleteWordRightWhitespace($,te);if(le)return le}var ue=e._findNextWordOnLine(X,$,te);return 2===ee?ue?re=ue.end+1:re<ae||oe===se?re=ae:(oe++,re=(ue=e._findNextWordOnLine(X,$,new ne.Position(oe,1)))?ue.start+1:$.getLineMaxColumn(oe)):(ue&&re>=ue.start+1&&(ue=e._findNextWordOnLine(X,$,new ne.Position(oe,ue.end+1))),ue?re=ue.start+1:re<ae||oe===se?re=ae:(oe++,re=(ue=e._findNextWordOnLine(X,$,new ne.Position(oe,1)))?ue.start+1:$.getLineMaxColumn(oe))),new ie.Range(oe,re,te.lineNumber,te.column)},e._deleteWordPartRight=function(X,$){if(!$.isEmpty())return $;var Q=$.getPosition(),J=e._moveWordPartRight(X,Q);return new ie.Range(Q.lineNumber,Q.column,J.lineNumber,J.column)},e.word=function(X,$,Q,te,oe){var re,se,ae,le,ue=ee.getMapForWordSeparators(X.wordSeparators),de=e._findPreviousWordOnLine(ue,$,oe),ce=e._findNextWordOnLine(ue,$,oe);if(!te)return de&&1===de.wordType&&de.start<=oe.column-1&&oe.column-1<=de.end?(re=de.start+1,se=de.end+1):ce&&1===ce.wordType&&ce.start<=oe.column-1&&oe.column-1<=ce.end?(re=ce.start+1,se=ce.end+1):(re=de?de.end+1:1,se=ce?ce.start+1:$.getLineMaxColumn(oe.lineNumber)),new J.SingleCursorState(new ie.Range(oe.lineNumber,re,oe.lineNumber,se),0,new ne.Position(oe.lineNumber,se),0);de&&1===de.wordType&&de.start<oe.column-1&&oe.column-1<de.end?(ae=de.start+1,le=de.end+1):ce&&1===ce.wordType&&ce.start<oe.column-1&&oe.column-1<ce.end?(ae=ce.start+1,le=ce.end+1):(ae=oe.column,le=oe.column);var he,pe=oe.lineNumber;if(Q.selectionStart.containsPosition(oe))he=Q.selectionStart.endColumn;else if(oe.isBeforeOrEqual(Q.selectionStart.getStartPosition()))he=ae,fe=new ne.Position(pe,he),Q.selectionStart.containsPosition(fe)&&(he=Q.selectionStart.endColumn);else{he=le;var fe=new ne.Position(pe,he);Q.selectionStart.containsPosition(fe)&&(he=Q.selectionStart.startColumn)}return Q.move(!0,pe,he,0)},e}();$.WordOperations=oe;var re=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.deleteWordPartLeft=function(X,$,Q,J){var ee=l([oe.deleteWordLeft(X,$,Q,J,0),oe.deleteWordLeft(X,$,Q,J,2),oe._deleteWordPartLeft($,Q)]);return ee.sort(ie.Range.compareRangesUsingEnds),ee[2]},t.deleteWordPartRight=function(X,$,Q,J){var ee=l([oe.deleteWordRight(X,$,Q,J,0),oe.deleteWordRight(X,$,Q,J,2),oe._deleteWordPartRight($,Q)]);return ee.sort(ie.Range.compareRangesUsingStarts),ee[0]},t.moveWordPartLeft=function(X,$,Q){var J=l([oe.moveWordLeft(X,$,Q,0),oe.moveWordLeft(X,$,Q,2),oe._moveWordPartLeft($,Q)]);return J.sort(ne.Position.compare),J[2]},t.moveWordPartRight=function(X,$,Q){var J=l([oe.moveWordRight(X,$,Q,0),oe.moveWordRight(X,$,Q,2),oe._moveWordPartRight($,Q)]);return J.sort(ne.Position.compare),J[0]},t}(oe);$.WordPartOperations=re})),define(Q[188],n([0,1,32,38,181,138,12,3]),(function(X,$,Q,J,ee,te,ne,ie){Object.defineProperty($,"__esModule",{value:!0});var oe=function(){function e(){}return e.addCursorDown=function(X,$,Q){for(var te=[],ne=0,ie=0,oe=$.length;ie<oe;ie++){var re=$[ie];te[ne++]=new J.CursorState(re.modelState,re.viewState),te[ne++]=Q?J.CursorState.fromModelState(ee.MoveOperations.translateDown(X.config,X.model,re.modelState)):J.CursorState.fromViewState(ee.MoveOperations.translateDown(X.config,X.viewModel,re.viewState))}return te},e.addCursorUp=function(X,$,Q){for(var te=[],ne=0,ie=0,oe=$.length;ie<oe;ie++){var re=$[ie];te[ne++]=new J.CursorState(re.modelState,re.viewState),te[ne++]=Q?J.CursorState.fromModelState(ee.MoveOperations.translateUp(X.config,X.model,re.modelState)):J.CursorState.fromViewState(ee.MoveOperations.translateUp(X.config,X.viewModel,re.viewState))}return te},e.moveToBeginningOfLine=function(X,$,Q){for(var J=[],ee=0,te=$.length;ee<te;ee++){var ne=$[ee];J[ee]=this._moveToLineStart(X,ne,Q)}return J},e._moveToLineStart=function(X,$,Q){var J=$.viewState.position.column,ee=J===$.modelState.position.column,te=$.viewState.position.lineNumber,ne=X.viewModel.getLineFirstNonWhitespaceColumn(te);return ee||J===ne?this._moveToLineStartByModel(X,$,Q):this._moveToLineStartByView(X,$,Q)},e._moveToLineStartByView=function(X,$,Q){return J.CursorState.fromViewState(ee.MoveOperations.moveToBeginningOfLine(X.config,X.viewModel,$.viewState,Q))},e._moveToLineStartByModel=function(X,$,Q){return J.CursorState.fromModelState(ee.MoveOperations.moveToBeginningOfLine(X.config,X.model,$.modelState,Q))},e.moveToEndOfLine=function(X,$,Q){for(var J=[],ee=0,te=$.length;ee<te;ee++){var ne=$[ee];J[ee]=this._moveToLineEnd(X,ne,Q)}return J},e._moveToLineEnd=function(X,$,Q){var J=$.viewState.position,ee=X.viewModel.getLineMaxColumn(J.lineNumber),te=J.column===ee,ne=$.modelState.position,ie=X.model.getLineMaxColumn(ne.lineNumber),oe=ee-J.column==ie-ne.column;return te||oe?this._moveToLineEndByModel(X,$,Q):this._moveToLineEndByView(X,$,Q)},e._moveToLineEndByView=function(X,$,Q){return J.CursorState.fromViewState(ee.MoveOperations.moveToEndOfLine(X.config,X.viewModel,$.viewState,Q))},e._moveToLineEndByModel=function(X,$,Q){return J.CursorState.fromModelState(ee.MoveOperations.moveToEndOfLine(X.config,X.model,$.modelState,Q))},e.expandLineSelection=function(X,$){for(var Q=[],ee=0,te=$.length;ee<te;ee++){var oe=$[ee].viewState.selection,re=oe.startLineNumber,se=X.viewModel.getLineCount(),ae=oe.endLineNumber,le=void 0;ae===se?le=X.viewModel.getLineMaxColumn(se):(ae++,le=1),Q[ee]=J.CursorState.fromViewState(new J.SingleCursorState(new ie.Range(re,1,re,1),0,new ne.Position(ae,le),0))}return Q},e.moveToBeginningOfBuffer=function(X,$,Q){for(var te=[],ne=0,ie=$.length;ne<ie;ne++){var oe=$[ne];te[ne]=J.CursorState.fromModelState(ee.MoveOperations.moveToBeginningOfBuffer(X.config,X.model,oe.modelState,Q))}return te},e.moveToEndOfBuffer=function(X,$,Q){for(var te=[],ne=0,ie=$.length;ne<ie;ne++){var oe=$[ne];te[ne]=J.CursorState.fromModelState(ee.MoveOperations.moveToEndOfBuffer(X.config,X.model,oe.modelState,Q))}return te},e.selectAll=function(X,$){var Q=X.model.getLineCount(),ee=X.model.getLineMaxColumn(Q);return J.CursorState.fromModelState(new J.SingleCursorState(new ie.Range(1,1,1,1),0,new ne.Position(Q,ee),0))},e.line=function(X,$,Q,ee,te){var oe=X.model.validatePosition(ee),re=te?X.validateViewPosition(new ne.Position(te.lineNumber,te.column),oe):X.convertModelPositionToViewPosition(oe);if(!Q||!$.modelState.hasSelection()){var se=X.model.getLineCount(),ae=oe.lineNumber+1,le=1;return ae>se&&(ae=se,le=X.model.getLineMaxColumn(ae)),J.CursorState.fromModelState(new J.SingleCursorState(new ie.Range(oe.lineNumber,1,ae,le),0,new ne.Position(ae,le),0))}var ue=$.modelState.selectionStart.getStartPosition().lineNumber;if(oe.lineNumber<ue)return J.CursorState.fromViewState($.viewState.move($.modelState.hasSelection(),re.lineNumber,1,0));if(oe.lineNumber>ue){se=X.viewModel.getLineCount();var de=re.lineNumber+1,ce=1;return de>se&&(de=se,ce=X.viewModel.getLineMaxColumn(de)),J.CursorState.fromViewState($.viewState.move($.modelState.hasSelection(),de,ce,0))}var he=$.modelState.selectionStart.getEndPosition();return J.CursorState.fromModelState($.modelState.move($.modelState.hasSelection(),he.lineNumber,he.column,0))},e.word=function(X,$,Q,ee){var ne=X.model.validatePosition(ee);return J.CursorState.fromModelState(te.WordOperations.word(X.config,X.model,$.modelState,Q,ne))},e.cancelSelection=function(X,$){if(!$.modelState.hasSelection())return new J.CursorState($.modelState,$.viewState);var Q=$.viewState.position.lineNumber,ee=$.viewState.position.column;return J.CursorState.fromViewState(new J.SingleCursorState(new ie.Range(Q,ee,Q,ee),0,new ne.Position(Q,ee),0))},e.moveTo=function(X,$,Q,ee,te){var ie=X.model.validatePosition(ee),oe=te?X.validateViewPosition(new ne.Position(te.lineNumber,te.column),ie):X.convertModelPositionToViewPosition(ie);return J.CursorState.fromViewState($.viewState.move(Q,oe.lineNumber,oe.column,0))},e.move=function(X,$,Q){var J=Q.select,ee=Q.value;switch(Q.direction){case 0:return 4===Q.unit?this._moveHalfLineLeft(X,$,J):this._moveLeft(X,$,J,ee);case 1:return 4===Q.unit?this._moveHalfLineRight(X,$,J):this._moveRight(X,$,J,ee);case 2:return 2===Q.unit?this._moveUpByViewLines(X,$,J,ee):this._moveUpByModelLines(X,$,J,ee);case 3:return 2===Q.unit?this._moveDownByViewLines(X,$,J,ee):this._moveDownByModelLines(X,$,J,ee);case 4:return this._moveToViewMinColumn(X,$,J);case 5:return this._moveToViewFirstNonWhitespaceColumn(X,$,J);case 6:return this._moveToViewCenterColumn(X,$,J);case 7:return this._moveToViewMaxColumn(X,$,J);case 8:return this._moveToViewLastNonWhitespaceColumn(X,$,J);case 9:var te=$[0],ne=X.getCompletelyVisibleModelRange(),ie=this._firstLineNumberInRange(X.model,ne,ee),oe=X.model.getLineFirstNonWhitespaceColumn(ie);return[this._moveToModelPosition(X,te,J,ie,oe)];case 11:te=$[0],ne=X.getCompletelyVisibleModelRange(),ie=this._lastLineNumberInRange(X.model,ne,ee),oe=X.model.getLineFirstNonWhitespaceColumn(ie);return[this._moveToModelPosition(X,te,J,ie,oe)];case 10:te=$[0],ne=X.getCompletelyVisibleModelRange(),ie=Math.round((ne.startLineNumber+ne.endLineNumber)/2),oe=X.model.getLineFirstNonWhitespaceColumn(ie);return[this._moveToModelPosition(X,te,J,ie,oe)];case 12:for(var re=X.getCompletelyVisibleViewRange(),se=[],ae=0,le=$.length;ae<le;ae++)te=$[ae],se[ae]=this.findPositionInViewportIfOutside(X,te,re,J);return se}return null},e.findPositionInViewportIfOutside=function(X,$,Q,ee){var te=$.viewState.position.lineNumber;if(Q.startLineNumber<=te&&te<=Q.endLineNumber-1)return new J.CursorState($.modelState,$.viewState);te>Q.endLineNumber-1&&(te=Q.endLineNumber-1),te<Q.startLineNumber&&(te=Q.startLineNumber);var ne=X.viewModel.getLineFirstNonWhitespaceColumn(te);return this._moveToViewPosition(X,$,ee,te,ne)},e._firstLineNumberInRange=function(X,$,Q){var J=$.startLineNumber;return $.startColumn!==X.getLineMinColumn(J)&&J++,Math.min($.endLineNumber,J+Q-1)},e._lastLineNumberInRange=function(X,$,Q){var J=$.startLineNumber;return $.startColumn!==X.getLineMinColumn(J)&&J++,Math.max(J,$.endLineNumber-Q+1)},e._moveLeft=function(X,$,Q,te){for(var ne=[],ie=0,oe=$.length;ie<oe;ie++){var re=$[ie],se=ee.MoveOperations.moveLeft(X.config,X.viewModel,re.viewState,Q,te);1===te&&se.position.lineNumber!==re.viewState.position.lineNumber&&X.viewModel.coordinatesConverter.convertViewPositionToModelPosition(se.position).lineNumber===re.modelState.position.lineNumber&&(se=ee.MoveOperations.moveLeft(X.config,X.viewModel,se,Q,1)),ne[ie]=J.CursorState.fromViewState(se)}return ne},e._moveHalfLineLeft=function(X,$,Q){for(var te=[],ne=0,ie=$.length;ne<ie;ne++){var oe=$[ne],re=oe.viewState.position.lineNumber,se=Math.round(X.viewModel.getLineContent(re).length/2);te[ne]=J.CursorState.fromViewState(ee.MoveOperations.moveLeft(X.config,X.viewModel,oe.viewState,Q,se))}return te},e._moveRight=function(X,$,Q,te){for(var ne=[],ie=0,oe=$.length;ie<oe;ie++){var re=$[ie],se=ee.MoveOperations.moveRight(X.config,X.viewModel,re.viewState,Q,te);1===te&&se.position.lineNumber!==re.viewState.position.lineNumber&&X.viewModel.coordinatesConverter.convertViewPositionToModelPosition(se.position).lineNumber===re.modelState.position.lineNumber&&(se=ee.MoveOperations.moveRight(X.config,X.viewModel,se,Q,1)),ne[ie]=J.CursorState.fromViewState(se)}return ne},e._moveHalfLineRight=function(X,$,Q){for(var te=[],ne=0,ie=$.length;ne<ie;ne++){var oe=$[ne],re=oe.viewState.position.lineNumber,se=Math.round(X.viewModel.getLineContent(re).length/2);te[ne]=J.CursorState.fromViewState(ee.MoveOperations.moveRight(X.config,X.viewModel,oe.viewState,Q,se))}return te},e._moveDownByViewLines=function(X,$,Q,te){for(var ne=[],ie=0,oe=$.length;ie<oe;ie++){var re=$[ie];ne[ie]=J.CursorState.fromViewState(ee.MoveOperations.moveDown(X.config,X.viewModel,re.viewState,Q,te))}return ne},e._moveDownByModelLines=function(X,$,Q,te){for(var ne=[],ie=0,oe=$.length;ie<oe;ie++){var re=$[ie];ne[ie]=J.CursorState.fromModelState(ee.MoveOperations.moveDown(X.config,X.model,re.modelState,Q,te))}return ne},e._moveUpByViewLines=function(X,$,Q,te){for(var ne=[],ie=0,oe=$.length;ie<oe;ie++){var re=$[ie];ne[ie]=J.CursorState.fromViewState(ee.MoveOperations.moveUp(X.config,X.viewModel,re.viewState,Q,te))}return ne},e._moveUpByModelLines=function(X,$,Q,te){for(var ne=[],ie=0,oe=$.length;ie<oe;ie++){var re=$[ie];ne[ie]=J.CursorState.fromModelState(ee.MoveOperations.moveUp(X.config,X.model,re.modelState,Q,te))}return ne},e._moveToViewPosition=function(X,$,Q,ee,te){return J.CursorState.fromViewState($.viewState.move(Q,ee,te,0))},e._moveToModelPosition=function(X,$,Q,ee,te){return J.CursorState.fromModelState($.modelState.move(Q,ee,te,0))},e._moveToViewMinColumn=function(X,$,Q){for(var J=[],ee=0,te=$.length;ee<te;ee++){var ne=$[ee],ie=ne.viewState.position.lineNumber,oe=X.viewModel.getLineMinColumn(ie);J[ee]=this._moveToViewPosition(X,ne,Q,ie,oe)}return J},e._moveToViewFirstNonWhitespaceColumn=function(X,$,Q){for(var J=[],ee=0,te=$.length;ee<te;ee++){var ne=$[ee],ie=ne.viewState.position.lineNumber,oe=X.viewModel.getLineFirstNonWhitespaceColumn(ie);J[ee]=this._moveToViewPosition(X,ne,Q,ie,oe)}return J},e._moveToViewCenterColumn=function(X,$,Q){for(var J=[],ee=0,te=$.length;ee<te;ee++){var ne=$[ee],ie=ne.viewState.position.lineNumber,oe=Math.round((X.viewModel.getLineMaxColumn(ie)+X.viewModel.getLineMinColumn(ie))/2);J[ee]=this._moveToViewPosition(X,ne,Q,ie,oe)}return J},e._moveToViewMaxColumn=function(X,$,Q){for(var J=[],ee=0,te=$.length;ee<te;ee++){var ne=$[ee],ie=ne.viewState.position.lineNumber,oe=X.viewModel.getLineMaxColumn(ie);J[ee]=this._moveToViewPosition(X,ne,Q,ie,oe)}return J},e._moveToViewLastNonWhitespaceColumn=function(X,$,Q){for(var J=[],ee=0,te=$.length;ee<te;ee++){var ne=$[ee],ie=ne.viewState.position.lineNumber,oe=X.viewModel.getLineLastNonWhitespaceColumn(ie);J[ee]=this._moveToViewPosition(X,ne,Q,ie,oe)}return J},e}();$.CursorMoveCommands=oe,function(X){X.description={description:"Move cursor to a logical position in the view",args:[{name:"Cursor move argument object",description:"Property-value pairs that can be passed through this argument:\n\t\t\t\t\t* 'to': A mandatory logical position value providing where to move the cursor.\n\t\t\t\t\t\t```\n\t\t\t\t\t\t'left', 'right', 'up', 'down'\n\t\t\t\t\t\t'wrappedLineStart', 'wrappedLineEnd', 'wrappedLineColumnCenter'\n\t\t\t\t\t\t'wrappedLineFirstNonWhitespaceCharacter', 'wrappedLineLastNonWhitespaceCharacter'\n\t\t\t\t\t\t'viewPortTop', 'viewPortCenter', 'viewPortBottom', 'viewPortIfOutside'\n\t\t\t\t\t\t```\n\t\t\t\t\t* 'by': Unit to move. Default is computed based on 'to' value.\n\t\t\t\t\t\t```\n\t\t\t\t\t\t'line', 'wrappedLine', 'character', 'halfLine'\n\t\t\t\t\t\t```\n\t\t\t\t\t* 'value': Number of units to move. Default is '1'.\n\t\t\t\t\t* 'select': If 'true' makes the selection. Default is 'false'.\n\t\t\t\t",constraint:function(X){if(!Q.isObject(X))return!1;var $=X;return!(!Q.isString($.to)||!Q.isUndefined($.select)&&!Q.isBoolean($.select)||!Q.isUndefined($.by)&&!Q.isString($.by)||!Q.isUndefined($.value)&&!Q.isNumber($.value))}}]},X.RawDirection={Left:"left",Right:"right",Up:"up",Down:"down",WrappedLineStart:"wrappedLineStart",WrappedLineFirstNonWhitespaceCharacter:"wrappedLineFirstNonWhitespaceCharacter",WrappedLineColumnCenter:"wrappedLineColumnCenter",WrappedLineEnd:"wrappedLineEnd",WrappedLineLastNonWhitespaceCharacter:"wrappedLineLastNonWhitespaceCharacter",ViewPortTop:"viewPortTop",ViewPortCenter:"viewPortCenter",ViewPortBottom:"viewPortBottom",ViewPortIfOutside:"viewPortIfOutside"},X.RawUnit={Line:"line",WrappedLine:"wrappedLine",Character:"character",HalfLine:"halfLine"},X.parse=function($){if(!$.to)return null;var Q;switch($.to){case X.RawDirection.Left:Q=0;break;case X.RawDirection.Right:Q=1;break;case X.RawDirection.Up:Q=2;break;case X.RawDirection.Down:Q=3;break;case X.RawDirection.WrappedLineStart:Q=4;break;case X.RawDirection.WrappedLineFirstNonWhitespaceCharacter:Q=5;break;case X.RawDirection.WrappedLineColumnCenter:Q=6;break;case X.RawDirection.WrappedLineEnd:Q=7;break;case X.RawDirection.WrappedLineLastNonWhitespaceCharacter:Q=8;break;case X.RawDirection.ViewPortTop:Q=9;break;case X.RawDirection.ViewPortBottom:Q=11;break;case X.RawDirection.ViewPortCenter:Q=10;break;case X.RawDirection.ViewPortIfOutside:Q=12;break;default:return null}var J=0;switch($.by){case X.RawUnit.Line:J=1;break;case X.RawUnit.WrappedLine:J=2;break;case X.RawUnit.Character:J=3;break;case X.RawUnit.HalfLine:J=4}return{direction:Q,unit:J,select:!!$.select,value:$.value||1}}}($.CursorMove||($.CursorMove={}))})),define(Q[378],n([0,1,38,12,3,21]),(function(X,$,Q,J,ee,te){Object.defineProperty($,"__esModule",{value:!0});var ne=function(){function e(X){this._selTrackedRange=null,this._trackSelection=!0,this._setState(X,new Q.SingleCursorState(new ee.Range(1,1,1,1),0,new J.Position(1,1),0),new Q.SingleCursorState(new ee.Range(1,1,1,1),0,new J.Position(1,1),0))}return e.prototype.dispose=function(X){this._removeTrackedRange(X)},e.prototype.startTrackingSelection=function(X){this._trackSelection=!0,this._updateTrackedRange(X)},e.prototype.stopTrackingSelection=function(X){this._trackSelection=!1,this._removeTrackedRange(X)},e.prototype._updateTrackedRange=function(X){this._trackSelection&&(this._selTrackedRange=X.model._setTrackedRange(this._selTrackedRange,this.modelState.selection,0))},e.prototype._removeTrackedRange=function(X){this._selTrackedRange=X.model._setTrackedRange(this._selTrackedRange,null,0)},e.prototype.asCursorState=function(){return new Q.CursorState(this.modelState,this.viewState)},e.prototype.readSelectionFromMarkers=function(X){var $=X.model._getTrackedRange(this._selTrackedRange);return 0===this.modelState.selection.getDirection()?new te.Selection($.startLineNumber,$.startColumn,$.endLineNumber,$.endColumn):new te.Selection($.endLineNumber,$.endColumn,$.startLineNumber,$.startColumn)},e.prototype.ensureValidState=function(X){this._setState(X,this.modelState,this.viewState)},e.prototype.setState=function(X,$,Q){this._setState(X,$,Q)},e.prototype._setState=function(X,$,te){if($){var ne=X.model.validateRange($.selectionStart),ie=$.selectionStart.equalsRange(ne)?$.selectionStartLeftoverVisibleColumns:0,oe=X.model.validatePosition($.position),re=$.position.equals(oe)?$.leftoverVisibleColumns:0;$=new Q.SingleCursorState(ne,ie,oe,re)}else{if(!te)return;ne=X.model.validateRange(X.convertViewRangeToModelRange(te.selectionStart)),oe=X.model.validatePosition(X.convertViewPositionToModelPosition(te.position.lineNumber,te.position.column));$=new Q.SingleCursorState(ne,te.selectionStartLeftoverVisibleColumns,oe,te.leftoverVisibleColumns)}if(te){var se=X.validateViewRange(te.selectionStart,$.selectionStart),ae=X.validateViewPosition(te.position,$.position);te=new Q.SingleCursorState(se,$.selectionStartLeftoverVisibleColumns,ae,$.leftoverVisibleColumns)}else{var le=X.convertModelPositionToViewPosition(new J.Position($.selectionStart.startLineNumber,$.selectionStart.startColumn)),ue=X.convertModelPositionToViewPosition(new J.Position($.selectionStart.endLineNumber,$.selectionStart.endColumn));se=new ee.Range(le.lineNumber,le.column,ue.lineNumber,ue.column),ae=X.convertModelPositionToViewPosition($.position);te=new Q.SingleCursorState(se,$.selectionStartLeftoverVisibleColumns,ae,$.leftoverVisibleColumns)}this.modelState=$,this.viewState=te,this._updateTrackedRange(X)},e}();$.OneCursor=ne})),define(Q[379],n([0,1,38,378,21]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var te=function(){function e(X){this.context=X,this.primaryCursor=new J.OneCursor(X),this.secondaryCursors=[],this.lastAddedCursorIndex=0}return e.prototype.dispose=function(){this.primaryCursor.dispose(this.context),this.killSecondaryCursors()},e.prototype.startTrackingSelections=function(){this.primaryCursor.startTrackingSelection(this.context);for(var X=0,$=this.secondaryCursors.length;X<$;X++)this.secondaryCursors[X].startTrackingSelection(this.context)},e.prototype.stopTrackingSelections=function(){this.primaryCursor.stopTrackingSelection(this.context);for(var X=0,$=this.secondaryCursors.length;X<$;X++)this.secondaryCursors[X].stopTrackingSelection(this.context)},e.prototype.updateContext=function(X){this.context=X},e.prototype.ensureValidState=function(){this.primaryCursor.ensureValidState(this.context);for(var X=0,$=this.secondaryCursors.length;X<$;X++)this.secondaryCursors[X].ensureValidState(this.context)},e.prototype.readSelectionFromMarkers=function(){var X=[];X[0]=this.primaryCursor.readSelectionFromMarkers(this.context);for(var $=0,Q=this.secondaryCursors.length;$<Q;$++)X[$+1]=this.secondaryCursors[$].readSelectionFromMarkers(this.context);return X},e.prototype.getAll=function(){var X=[];X[0]=this.primaryCursor.asCursorState();for(var $=0,Q=this.secondaryCursors.length;$<Q;$++)X[$+1]=this.secondaryCursors[$].asCursorState();return X},e.prototype.getViewPositions=function(){var X=[];X[0]=this.primaryCursor.viewState.position;for(var $=0,Q=this.secondaryCursors.length;$<Q;$++)X[$+1]=this.secondaryCursors[$].viewState.position;return X},e.prototype.getSelections=function(){var X=[];X[0]=this.primaryCursor.modelState.selection;for(var $=0,Q=this.secondaryCursors.length;$<Q;$++)X[$+1]=this.secondaryCursors[$].modelState.selection;return X},e.prototype.getViewSelections=function(){var X=[];X[0]=this.primaryCursor.viewState.selection;for(var $=0,Q=this.secondaryCursors.length;$<Q;$++)X[$+1]=this.secondaryCursors[$].viewState.selection;return X},e.prototype.setSelections=function(X){this.setStates(Q.CursorState.fromModelSelections(X))},e.prototype.getPrimaryCursor=function(){return this.primaryCursor.asCursorState()},e.prototype.setStates=function(X){null!==X&&(this.primaryCursor.setState(this.context,X[0].modelState,X[0].viewState),this._setSecondaryStates(X.slice(1)))},e.prototype._setSecondaryStates=function(X){var $=this.secondaryCursors.length,Q=X.length;if($<Q)for(var J=Q-$,ee=0;ee<J;ee++)this._addSecondaryCursor();else if($>Q){var te=$-Q;for(ee=0;ee<te;ee++)this._removeSecondaryCursor(this.secondaryCursors.length-1)}for(ee=0;ee<Q;ee++)this.secondaryCursors[ee].setState(this.context,X[ee].modelState,X[ee].viewState)},e.prototype.killSecondaryCursors=function(){this._setSecondaryStates([])},e.prototype._addSecondaryCursor=function(){this.secondaryCursors.push(new J.OneCursor(this.context)),this.lastAddedCursorIndex=this.secondaryCursors.length},e.prototype.getLastAddedCursorIndex=function(){return 0===this.secondaryCursors.length||0===this.lastAddedCursorIndex?0:this.lastAddedCursorIndex},e.prototype._removeSecondaryCursor=function(X){this.lastAddedCursorIndex>=X+1&&this.lastAddedCursorIndex--,this.secondaryCursors[X].dispose(this.context),this.secondaryCursors.splice(X,1)},e.prototype._getAll=function(){var X=[];X[0]=this.primaryCursor;for(var $=0,Q=this.secondaryCursors.length;$<Q;$++)X[$+1]=this.secondaryCursors[$];return X},e.prototype.normalize=function(){if(0!==this.secondaryCursors.length){for(var X=this._getAll(),$=[],J=0,te=X.length;J<te;J++)$.push({index:J,selection:X[J].modelState.selection});$.sort((function(X,$){return X.selection.startLineNumber===$.selection.startLineNumber?X.selection.startColumn-$.selection.startColumn:X.selection.startLineNumber-$.selection.startLineNumber}));for(var ne=0;ne<$.length-1;ne++){var ie=$[ne],oe=$[ne+1],re=ie.selection,se=oe.selection;if(this.context.config.multiCursorMergeOverlapping&&(se.isEmpty()||re.isEmpty()?se.getStartPosition().isBeforeOrEqual(re.getEndPosition()):se.getStartPosition().isBefore(re.getEndPosition()))){var ae=ie.index<oe.index?ne:ne+1,le=ie.index<oe.index?ne+1:ne,ue=$[le].index,de=$[ae].index,ce=$[le].selection,he=$[ae].selection;if(!ce.equalsSelection(he)){var pe=ce.plusRange(he),fe=ce.selectionStartLineNumber===ce.startLineNumber&&ce.selectionStartColumn===ce.startColumn,ge=he.selectionStartLineNumber===he.startLineNumber&&he.selectionStartColumn===he.startColumn,me=void 0;ue===this.lastAddedCursorIndex?(me=fe,this.lastAddedCursorIndex=de):me=ge;var ve;ve=me?new ee.Selection(pe.startLineNumber,pe.startColumn,pe.endLineNumber,pe.endColumn):new ee.Selection(pe.endLineNumber,pe.endColumn,pe.startLineNumber,pe.startColumn),$[ae].selection=ve;var _e=Q.CursorState.fromModelSelection(ve);X[de].setState(this.context,_e.modelState,_e.viewState)}for(var ye=0;ye<$.length;ye++)$[ye].index>ue&&$[ye].index--;X.splice(ue,1),$.splice(le,1),this._removeSecondaryCursor(ue-1),ne--}}}},e}();$.CursorCollection=te})),define(Q[380],n([0,1,297,11,6,8,379,38,182,137,3,21,54,69]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le,ue,de){Object.defineProperty($,"__esModule",{value:!0});var g=function(X,$,Q){this.selections=X,this.source=$,this.reason=Q};$.CursorStateChangedEvent=g;var ce=function(){function e(X,$){this.modelVersionId=X.getVersionId(),this.cursorState=$.getAll()}return e.prototype.equals=function(X){if(!X)return!1;if(this.modelVersionId!==X.modelVersionId)return!1;if(this.cursorState.length!==X.cursorState.length)return!1;for(var $=0,Q=this.cursorState.length;$<Q;$++)if(!this.cursorState[$].equals(X.cursorState[$]))return!1;return!0},e}();$.CursorModelState=ce;var he=function(X){function t($,Q,J){var te=X.call(this)||this;te._onDidReachMaxCursorCount=te._register(new ee.Emitter),te.onDidReachMaxCursorCount=te._onDidReachMaxCursorCount.event,te._onDidAttemptReadOnlyEdit=te._register(new ee.Emitter),te.onDidAttemptReadOnlyEdit=te._onDidAttemptReadOnlyEdit.event,te._onDidChange=te._register(new ee.Emitter),te.onDidChange=te._onDidChange.event,te._configuration=$,te._model=Q,te._knownModelVersionId=te._model.getVersionId(),te._viewModel=J,te.context=new oe.CursorContext(te._configuration,te._model,te._viewModel),te._cursors=new ie.CursorCollection(te.context),te._isHandling=!1,te._isDoingComposition=!1,te._columnSelectData=null,te._prevEditOperationType=0,te._register(te._model.onDidChangeRawContent((function(X){if(te._knownModelVersionId=X.versionId,!te._isHandling){var $=X.containsEvent(1);te._onModelContentChanged($)}}))),te._register(J.addEventListener((function(X){(function(X){for(var $=0,Q=X.length;$<Q;$++)if(6===X[$].type)return!0;return!1})(X)&&te._knownModelVersionId===te._model.getVersionId()&&te.setStates("viewModel",0,te.getAll())})));var s=function(){te.context=new oe.CursorContext(te._configuration,te._model,te._viewModel),te._cursors.updateContext(te.context)};return te._register(te._model.onDidChangeLanguage((function(X){s()}))),te._register(te._model.onDidChangeLanguageConfiguration((function(){s()}))),te._register(te._model.onDidChangeOptions((function(){s()}))),te._register(te._configuration.onDidChange((function(X){oe.CursorConfiguration.shouldRecreate(X)&&s()}))),te}return te(t,X),t.prototype.dispose=function(){this._cursors.dispose(),X.prototype.dispose.call(this)},t.prototype.getPrimaryCursor=function(){return this._cursors.getPrimaryCursor()},t.prototype.getLastAddedCursorIndex=function(){return this._cursors.getLastAddedCursorIndex()},t.prototype.getAll=function(){return this._cursors.getAll()},t.prototype.setStates=function(X,$,Q){null!==Q&&Q.length>t.MAX_CURSOR_COUNT&&(Q=Q.slice(0,t.MAX_CURSOR_COUNT),this._onDidReachMaxCursorCount.fire(void 0));var J=new ce(this._model,this);this._cursors.setStates(Q),this._cursors.normalize(),this._columnSelectData=null,this._emitStateChangedIfNecessary(X,$,J)},t.prototype.setColumnSelectData=function(X){this._columnSelectData=X},t.prototype.reveal=function(X,$,Q){this._revealRange($,0,X,Q)},t.prototype.revealRange=function(X,$,Q,J){this.emitCursorRevealRange($,Q,X,J)},t.prototype.scrollTo=function(X){this._viewModel.viewLayout.setScrollPositionSmooth({scrollTop:X})},t.prototype.saveState=function(){for(var X=[],$=this._cursors.getSelections(),Q=0,J=$.length;Q<J;Q++){var ee=$[Q];X.push({inSelectionMode:!ee.isEmpty(),selectionStart:{lineNumber:ee.selectionStartLineNumber,column:ee.selectionStartColumn},position:{lineNumber:ee.positionLineNumber,column:ee.positionColumn}})}return X},t.prototype.restoreState=function(X){for(var $=[],Q=0,J=X.length;Q<J;Q++){var ee=X[Q],te=1,ne=1;ee.position&&ee.position.lineNumber&&(te=ee.position.lineNumber),ee.position&&ee.position.column&&(ne=ee.position.column);var ie=te,re=ne;ee.selectionStart&&ee.selectionStart.lineNumber&&(ie=ee.selectionStart.lineNumber),ee.selectionStart&&ee.selectionStart.column&&(re=ee.selectionStart.column),$.push({selectionStartLineNumber:ie,selectionStartColumn:re,positionLineNumber:te,positionColumn:ne})}this.setStates("restoreState",0,oe.CursorState.fromModelSelections($)),this.reveal(!0,0,1)},t.prototype._onModelContentChanged=function(X){if(this._prevEditOperationType=0,X)this._cursors.dispose(),this._cursors=new ie.CursorCollection(this.context),this._emitStateChangedIfNecessary("model",1,null);else{var $=this._cursors.readSelectionFromMarkers();this.setStates("modelChange",2,oe.CursorState.fromModelSelections($))}},t.prototype.getSelection=function(){return this._cursors.getPrimaryCursor().modelState.selection},t.prototype.getColumnSelectData=function(){if(this._columnSelectData)return this._columnSelectData;var X=this._cursors.getPrimaryCursor().viewState.position;return{toViewLineNumber:X.lineNumber,toViewVisualColumn:oe.CursorColumns.visibleColumnFromColumn2(this.context.config,this.context.viewModel,X)}},t.prototype.getSelections=function(){return this._cursors.getSelections()},t.prototype.getViewSelections=function(){return this._cursors.getViewSelections()},t.prototype.getPosition=function(){return this._cursors.getPrimaryCursor().modelState.position},t.prototype.setSelections=function(X,$){this.setStates(X,0,oe.CursorState.fromModelSelections($))},t.prototype.getPrevEditOperationType=function(){return this._prevEditOperationType},t.prototype.setPrevEditOperationType=function(X){this._prevEditOperationType=X},t.prototype._executeEditOperation=function(X){if(X){X.shouldPushStackElementBefore&&this._model.pushStackElement();var $=pe.executeCommands(this._model,this._cursors.getSelections(),X.commands);$&&(this._interpretCommandResult($),this._prevEditOperationType=X.type),X.shouldPushStackElementAfter&&this._model.pushStackElement()}},t.prototype._interpretCommandResult=function(X){X&&0!==X.length||(X=this._cursors.readSelectionFromMarkers()),this._columnSelectData=null,this._cursors.setSelections(X),this._cursors.normalize()},t.prototype._emitStateChangedIfNecessary=function(X,$,Q){var J=new ce(this._model,this);if(J.equals(Q))return!1;var ee=this._cursors.getSelections(),te=this._cursors.getViewSelections();try{this._beginEmit().emit(new de.ViewCursorStateChangedEvent(te))}finally{this._endEmit()}return Q&&Q.cursorState.length===J.cursorState.length&&!J.cursorState.some((function(X,$){return!X.modelState.equals(Q.cursorState[$].modelState)}))||this._onDidChange.fire(new g(ee,X||"keyboard",$)),!0},t.prototype._revealRange=function(X,$,Q,J){var ee=this._cursors.getViewPositions(),te=ee[0];if(1===X)for(ne=1;ne<ee.length;ne++)ee[ne].isBefore(te)&&(te=ee[ne]);else if(2===X)for(var ne=1;ne<ee.length;ne++)te.isBeforeOrEqual(ee[ne])&&(te=ee[ne]);else if(ee.length>1)return;var ie=new ae.Range(te.lineNumber,te.column,te.lineNumber,te.column);this.emitCursorRevealRange(ie,$,Q,J)},t.prototype.emitCursorRevealRange=function(X,$,Q,J){try{this._beginEmit().emit(new de.ViewRevealRangeRequestEvent(X,$,Q,J))}finally{this._endEmit()}},t.prototype.trigger=function(X,$,Q){var ee=ue.Handler;if($!==ee.CompositionStart)if($===ee.CompositionEnd&&(this._isDoingComposition=!1),this._configuration.editor.readOnly)this._onDidAttemptReadOnlyEdit.fire(void 0);else{var te=new ce(this._model,this),ne=0;$!==ee.Undo&&$!==ee.Redo&&this._cursors.stopTrackingSelections(),this._cursors.ensureValidState(),this._isHandling=!0;try{switch($){case ee.Type:this._type(X,Q.text);break;case ee.ReplacePreviousChar:this._replacePreviousChar(Q.text,Q.replaceCharCnt);break;case ee.Paste:ne=4,this._paste(Q.text,Q.pasteOnNewLine,Q.multicursorText);break;case ee.Cut:this._cut();break;case ee.Undo:ne=5,this._interpretCommandResult(this._model.undo());break;case ee.Redo:ne=6,this._interpretCommandResult(this._model.redo());break;case ee.ExecuteCommand:this._externalExecuteCommand(Q);break;case ee.ExecuteCommands:this._externalExecuteCommands(Q);break;case ee.CompositionEnd:this._interpretCompositionEnd(X)}}catch(X){J.onUnexpectedError(X)}this._isHandling=!1,$!==ee.Undo&&$!==ee.Redo&&this._cursors.startTrackingSelections(),this._emitStateChangedIfNecessary(X,ne,te)&&this._revealRange(0,0,!0,0)}else this._isDoingComposition=!0},t.prototype._interpretCompositionEnd=function(X){this._isDoingComposition||"keyboard"!==X||this._executeEditOperation(se.TypeOperations.compositionEndWithInterceptors(this._prevEditOperationType,this.context.config,this.context.model,this.getSelections()))},t.prototype._type=function(X,$){if(this._isDoingComposition||"keyboard"!==X)this._executeEditOperation(se.TypeOperations.typeWithoutInterceptors(this._prevEditOperationType,this.context.config,this.context.model,this.getSelections(),$));else for(var Q=0,J=$.length;Q<J;Q++){var ee=$.charCodeAt(Q),te=void 0;ne.isHighSurrogate(ee)&&Q+1<J?(te=$.charAt(Q)+$.charAt(Q+1),Q++):te=$.charAt(Q),this._executeEditOperation(se.TypeOperations.typeWithInterceptors(this._prevEditOperationType,this.context.config,this.context.model,this.getSelections(),te))}},t.prototype._replacePreviousChar=function(X,$){this._executeEditOperation(se.TypeOperations.replacePreviousChar(this._prevEditOperationType,this.context.config,this.context.model,this.getSelections(),X,$))},t.prototype._paste=function(X,$,Q){this._executeEditOperation(se.TypeOperations.paste(this.context.config,this.context.model,this.getSelections(),X,$,Q))},t.prototype._cut=function(){this._executeEditOperation(re.DeleteOperations.cut(this.context.config,this.context.model,this.getSelections()))},t.prototype._externalExecuteCommand=function(X){this._cursors.killSecondaryCursors(),this._executeEditOperation(new oe.EditOperationResult(0,[X],{shouldPushStackElementBefore:!1,shouldPushStackElementAfter:!1}))},t.prototype._externalExecuteCommands=function(X){this._executeEditOperation(new oe.EditOperationResult(0,X,{shouldPushStackElementBefore:!1,shouldPushStackElementAfter:!1}))},t.MAX_CURSOR_COUNT=1e4,t}(de.ViewEventEmitter);$.Cursor=he;var pe=function(){function e(){}return e.executeCommands=function(X,$,Q){for(var J={model:X,selectionsBefore:$,trackedRanges:[],trackedRangesDirection:[]},ee=this._innerExecuteCommands(J,Q),te=0,ne=J.trackedRanges.length;te<ne;te++)J.model._setTrackedRange(J.trackedRanges[te],null,0);return ee},e._innerExecuteCommands=function(X,$){if(this._arrayIsEmpty($))return null;var Q=this._getEditOperations(X,$);if(0===Q.operations.length)return null;var J=Q.operations,ee=this._getLoserCursorMap(J);if(ee.hasOwnProperty("0"))return console.warn("Ignoring commands"),null;for(var te=[],ne=0,ie=J.length;ne<ie;ne++)ee.hasOwnProperty(J[ne].identifier.major.toString())||te.push(J[ne]);Q.hadTrackedEditOperation&&te.length>0&&(te[0]._isTracked=!0);var oe=X.model.pushEditOperations(X.selectionsBefore,te,(function(Q){for(var J=[],ee=0;ee<X.selectionsBefore.length;ee++)J[ee]=[];for(ee=0;ee<Q.length;ee++){var te=Q[ee];te.identifier&&J[te.identifier.major].push(te)}var s=function(X,$){return X.identifier.minor-$.identifier.minor},ne=[],l=function(Q){J[Q].length>0?(J[Q].sort(s),ne[Q]=$[Q].computeCursorState(X.model,{getInverseEditOperations:function(){return J[Q]},getTrackedSelection:function($){var Q=parseInt($,10),J=X.model._getTrackedRange(X.trackedRanges[Q]);return 0===X.trackedRangesDirection[Q]?new le.Selection(J.startLineNumber,J.startColumn,J.endLineNumber,J.endColumn):new le.Selection(J.endLineNumber,J.endColumn,J.startLineNumber,J.startColumn)}})):ne[Q]=X.selectionsBefore[Q]};for(ee=0;ee<X.selectionsBefore.length;ee++)l(ee);return ne}));oe||(oe=X.selectionsBefore);var re=[];for(var se in ee)ee.hasOwnProperty(se)&&re.push(parseInt(se,10));for(re.sort((function(X,$){return $-X})),ne=0;ne<re.length;ne++)oe.splice(re[ne],1);return oe},e._arrayIsEmpty=function(X){for(var $=0,Q=X.length;$<Q;$++)if(X[$])return!1;return!0},e._getEditOperations=function(X,$){for(var Q=[],J=!1,ee=0,te=$.length;ee<te;ee++){var ne=$[ee];if(ne){var ie=this._getEditOperationsFromCommand(X,ee,ne);Q=Q.concat(ie.operations),J=J||ie.hadTrackedEditOperation}}return{operations:Q,hadTrackedEditOperation:J}},e._getEditOperationsFromCommand=function(X,$,ee){var te=[],ne=0,a=function(X,Q){X.isEmpty()&&""===Q||te.push({identifier:{major:$,minor:ne++},range:X,text:Q,forceMoveMarkers:!1,isAutoWhitespaceEdit:ee.insertsAutoWhitespace})},ie=!1,oe={addEditOperation:a,addTrackedEditOperation:function(X,$){ie=!0,a(X,$)},trackSelection:function($,Q){var J;if($.isEmpty())if("boolean"==typeof Q)J=Q?2:3;else{var ee=X.model.getLineMaxColumn($.startLineNumber);J=$.startColumn===ee?2:3}else J=1;var te=X.trackedRanges.length,ne=X.model._setTrackedRange(null,$,J);return X.trackedRanges[te]=ne,X.trackedRangesDirection[te]=$.getDirection(),te.toString()}};try{ee.getEditOperations(X.model,oe)}catch(X){return X.friendlyMessage=Q.localize(0,null),J.onUnexpectedError(X),{operations:[],hadTrackedEditOperation:!1}}return{operations:te,hadTrackedEditOperation:ie}},e._getLoserCursorMap=function(X){(X=X.slice(0)).sort((function(X,$){return-ae.Range.compareRangesUsingEnds(X.range,$.range)}));for(var $={},Q=1;Q<X.length;Q++){var J=X[Q-1],ee=X[Q];if(J.range.getStartPosition().isBefore(ee.range.getEndPosition())){var te=void 0;$[(te=J.identifier.major>ee.identifier.major?J.identifier.major:ee.identifier.major).toString()]=!0;for(var ne=0;ne<X.length;ne++)X[ne].identifier.major===te&&(X.splice(ne,1),ne<Q&&Q--,ne--);Q>0&&Q--}}return $},e}()})),define(Q[190],n([0,1,8,93,51]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var te={getInitialState:function(){return ee.NULL_STATE},tokenize2:function(X,$,Q){return ee.nullTokenize2(0,X,$,Q)}};$.tokenizeToString=function r(X,$){return void 0===$&&($=te),function(X,$){for(var ee='<div class="monaco-tokenized-source">',te=X.split(/\r\n|\r|\n/),ne=$.getInitialState(),ie=0,oe=te.length;ie<oe;ie++){var re=te[ie];ie>0&&(ee+="<br/>");var se=$.tokenize2(re,ne,0);J.LineTokens.convertToEndOffset(se.tokens,re.length);for(var ae=new J.LineTokens(se.tokens,re).inflate(),le=0,ue=0,de=ae.getCount();ue<de;ue++){var ce=ae.getClassName(ue),he=ae.getEndOffset(ue);ee+='<span class="'+ce+'">'+Q.escape(re.substring(le,he))+"</span>",le=he}ne=se.endState}return ee+"</div>"}(X,$||te)},$.tokenizeLineToHTML=function(X,$,Q,J,ee,te){for(var ne="<div>",ie=J,oe=0,re=0,se=$.getCount();re<se;re++){var ae=$.getEndOffset(re);if(!(ae<=J)){for(var le="";ie<ae&&ie<ee;ie++){var ue=X.charCodeAt(ie);switch(ue){case 9:var de=te-(ie+oe)%te;for(oe+=de-1;de>0;)le+="&nbsp;",de--;break;case 60:le+="&lt;";break;case 62:le+="&gt;";break;case 38:le+="&amp;";break;case 0:le+="&#00;";break;case 65279:case 8232:le+="�";break;case 13:le+="&#8203";break;default:le+=String.fromCharCode(ue)}}if(ne+='<span style="'+$.getInlineStyle(re,Q)+'">'+le+"</span>",ae>ee||ie>=ee)break}}return ne+"</div>"}})),define(Q[92],n([0,1,15]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),$.ITextModelService=Q.createDecorator("textModelService")})),define(Q[106],n([0,1,15]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),$.ITextResourceConfigurationService=Q.createDecorator("textResourceConfigurationService"),$.ITextResourcePropertiesService=Q.createDecorator("textResourcePropertiesService")}));var oe=this&&this.__param||function(X,$){return function(Q,J){$(Q,J,X)}};define(Q[193],n([0,1,16,2,148,454,14,39,218,42,106]),(function(X,$,Q,J,ee,ie,re,se,ae,le,ue){function f(X,$){var Q=X.getModel($);return!!Q&&!Q.isTooLargeForSyncing()}Object.defineProperty($,"__esModule",{value:!0});var de=3e5,ce=function(X){function t($,Q){var J=X.call(this)||this;return J._modelService=$,J._workerManager=J._register(new pe(J._modelService)),J._register(re.LinkProviderRegistry.register("*",{provideLinks:function(X,$){return f(J._modelService,X.uri)?J._workerManager.withWorker().then((function($){return $.computeLinks(X.uri)})):Promise.resolve([])}})),J._register(re.CompletionProviderRegistry.register("*",new he(J._workerManager,Q,J._modelService))),J}return te(t,X),t.prototype.dispose=function(){X.prototype.dispose.call(this)},t.prototype.canComputeDiff=function(X,$){return f(this._modelService,X)&&f(this._modelService,$)},t.prototype.computeDiff=function(X,$,Q){return this._workerManager.withWorker().then((function(J){return J.computeDiff(X,$,Q)}))},t.prototype.computeMoreMinimalEdits=function(X,$){return Array.isArray($)&&0!==$.length&&f(this._modelService,X)?this._workerManager.withWorker().then((function(Q){return Q.computeMoreMinimalEdits(X,$)})):Promise.resolve($)},t.prototype.canNavigateValueSet=function(X){return f(this._modelService,X)},t.prototype.navigateValueSet=function(X,$,Q){return this._workerManager.withWorker().then((function(J){return J.navigateValueSet(X,$,Q)}))},t.prototype.canComputeWordRanges=function(X){return f(this._modelService,X)},t.prototype.computeWordRanges=function(X,$){return this._workerManager.withWorker().then((function(Q){return Q.computeWordRanges(X,$)}))},ne([oe(0,le.IModelService),oe(1,ue.ITextResourceConfigurationService)],t)}(J.Disposable);$.EditorWorkerServiceImpl=ce;var he=function(){function e(X,$,Q){this._workerManager=X,this._configurationService=$,this._modelService=Q}return e.prototype.provideCompletionItems=function(X,$){if(this._configurationService.getValue(X.uri,$,"editor").wordBasedSuggestions&&f(this._modelService,X.uri))return this._workerManager.withWorker().then((function(Q){return Q.textualSuggest(X.uri,$)}))},e}(),pe=function(X){function t($){var J=X.call(this)||this;return J._modelService=$,J._editorWorkerClient=null,J._register(new Q.IntervalTimer).cancelAndSet((function(){return J._checkStopIdleWorker()}),Math.round(de/2)),J._register(J._modelService.onModelRemoved((function(X){return J._checkStopEmptyWorker()}))),J}return te(t,X),t.prototype.dispose=function(){this._editorWorkerClient&&(this._editorWorkerClient.dispose(),this._editorWorkerClient=null),X.prototype.dispose.call(this)},t.prototype._checkStopEmptyWorker=function(){this._editorWorkerClient&&0===this._modelService.getModels().length&&(this._editorWorkerClient.dispose(),this._editorWorkerClient=null)},t.prototype._checkStopIdleWorker=function(){this._editorWorkerClient&&(new Date).getTime()-this._lastWorkerUsedTime>de&&(this._editorWorkerClient.dispose(),this._editorWorkerClient=null)},t.prototype.withWorker=function(){return this._lastWorkerUsedTime=(new Date).getTime(),this._editorWorkerClient||(this._editorWorkerClient=new me(this._modelService,"editorWorkerService")),Promise.resolve(this._editorWorkerClient)},t}(J.Disposable),fe=function(X){function t($,J,ee){var te=X.call(this)||this;if(te._syncedModels=Object.create(null),te._syncedModelsLastUsedTime=Object.create(null),te._proxy=$,te._modelService=J,!ee){var ne=new Q.IntervalTimer;ne.cancelAndSet((function(){return te._checkStopModelSync()}),Math.round(3e4)),te._register(ne)}return te}return te(t,X),t.prototype.dispose=function(){for(var $ in this._syncedModels)J.dispose(this._syncedModels[$]);this._syncedModels=Object.create(null),this._syncedModelsLastUsedTime=Object.create(null),X.prototype.dispose.call(this)},t.prototype.esureSyncedResources=function(X){for(var $=0;$<X.length;$++){var Q=X[$],J=Q.toString();this._syncedModels[J]||this._beginModelSync(Q),this._syncedModels[J]&&(this._syncedModelsLastUsedTime[J]=(new Date).getTime())}},t.prototype._checkStopModelSync=function(){var X=(new Date).getTime(),$=[];for(var Q in this._syncedModelsLastUsedTime)X-this._syncedModelsLastUsedTime[Q]>6e4&&$.push(Q);for(var J=0;J<$.length;J++)this._stopModelSync($[J])},t.prototype._beginModelSync=function(X){var $=this,Q=this._modelService.getModel(X);if(Q&&!Q.isTooLargeForSyncing()){var ee=X.toString();this._proxy.acceptNewModel({url:Q.uri.toString(),lines:Q.getLinesContent(),EOL:Q.getEOL(),versionId:Q.getVersionId()});var te=[];te.push(Q.onDidChangeContent((function(X){$._proxy.acceptModelChanged(ee.toString(),X)}))),te.push(Q.onWillDispose((function(){$._stopModelSync(ee)}))),te.push(J.toDisposable((function(){$._proxy.acceptRemovedModel(ee)}))),this._syncedModels[ee]=te}},t.prototype._stopModelSync=function(X){var $=this._syncedModels[X];delete this._syncedModels[X],delete this._syncedModelsLastUsedTime[X],J.dispose($)},t}(J.Disposable),ge=function(){function e(X){this._instance=X,this._proxyObj=Promise.resolve(this._instance)}return e.prototype.dispose=function(){this._instance.dispose()},e.prototype.getProxyObject=function(){return this._proxyObj},e}(),me=function(X){function t($,Q){var J=X.call(this)||this;return J._modelService=$,J._workerFactory=new ie.DefaultWorkerFactory(Q),J._worker=null,J._modelManager=null,J}return te(t,X),t.prototype._getOrCreateWorker=function(){if(!this._worker)try{this._worker=this._register(new ee.SimpleWorkerClient(this._workerFactory,"vs/editor/common/services/editorSimpleWorker"))}catch(X){ee.logOnceWebWorkerWarning(X),this._worker=new ge(new ae.EditorSimpleWorkerImpl(null))}return this._worker},t.prototype._getProxy=function(){var X=this;return this._getOrCreateWorker().getProxyObject().then(null,(function($){return ee.logOnceWebWorkerWarning($),X._worker=new ge(new ae.EditorSimpleWorkerImpl(null)),X._getOrCreateWorker().getProxyObject()}))},t.prototype._getOrCreateModelManager=function(X){return this._modelManager||(this._modelManager=this._register(new fe(X,this._modelService,!1))),this._modelManager},t.prototype._withSyncedResources=function(X){var $=this;return this._getProxy().then((function(Q){return $._getOrCreateModelManager(Q).esureSyncedResources(X),Q}))},t.prototype.computeDiff=function(X,$,Q){return this._withSyncedResources([X,$]).then((function(J){return J.computeDiff(X.toString(),$.toString(),Q)}))},t.prototype.computeMoreMinimalEdits=function(X,$){return this._withSyncedResources([X]).then((function(Q){return Q.computeMoreMinimalEdits(X.toString(),$)}))},t.prototype.computeLinks=function(X){return this._withSyncedResources([X]).then((function($){return $.computeLinks(X.toString())}))},t.prototype.textualSuggest=function(X,$){var Q=this;return this._withSyncedResources([X]).then((function(J){var ee=Q._modelService.getModel(X);if(!ee)return null;var te=se.LanguageConfigurationRegistry.getWordDefinition(ee.getLanguageIdentifier().id),ne=te.source,ie=(te.global?"g":"")+(te.ignoreCase?"i":"")+(te.multiline?"m":"");return J.textualSuggest(X.toString(),$,ne,ie)}))},t.prototype.computeWordRanges=function(X,$){var Q=this;return this._withSyncedResources([X]).then((function(J){var ee=Q._modelService.getModel(X);if(!ee)return Promise.resolve(null);var te=se.LanguageConfigurationRegistry.getWordDefinition(ee.getLanguageIdentifier().id),ne=te.source,ie=(te.global?"g":"")+(te.ignoreCase?"i":"")+(te.multiline?"m":"");return J.computeWordRanges(X.toString(),$,ne,ie)}))},t.prototype.navigateValueSet=function(X,$,Q){var J=this;return this._withSyncedResources([X]).then((function(ee){var te=J._modelService.getModel(X);if(!te)return null;var ne=se.LanguageConfigurationRegistry.getWordDefinition(te.getLanguageIdentifier().id),ie=ne.source,oe=(ne.global?"g":"")+(ne.ignoreCase?"i":"")+(ne.multiline?"m":"");return ee.navigateValueSet(X.toString(),$,Q,ie,oe)}))},t}(J.Disposable);$.EditorWorkerClient=me})),define(Q[385],n([0,1,193]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),$.createWebWorker=function(X,$){return new J(X,$)};var J=function(X){function t($,Q){var J=X.call(this,$,Q.label)||this;return J._foreignModuleId=Q.moduleId,J._foreignModuleCreateData=Q.createData||null,J._foreignProxy=null,J}return te(t,X),t.prototype._getForeignProxy=function(){var X=this;return this._foreignProxy||(this._foreignProxy=this._getProxy().then((function($){return $.loadForeignModule(X._foreignModuleId,X._foreignModuleCreateData).then((function(Q){X._foreignModuleCreateData=null;for(var i=function(X,Q){return $.fmr(X,Q)},o=function(X,$){return function(){var Q=Array.prototype.slice.call(arguments,0);return $(X,Q)}},J={},ee=0;ee<Q.length;ee++)J[Q[ee]]=o(Q[ee],i);return J}))}))),this._foreignProxy},t.prototype.getProxy=function(){return this._getForeignProxy()},t.prototype.withSyncedResources=function(X){var $=this;return this._withSyncedResources(X).then((function(X){return $.getProxy()}))},t}(Q.EditorWorkerClient)})),define(Q[107],n([0,1,6,426,14]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var te=function(){function e(){var X=this;this._onDidChange=new Q.Emitter,this.onDidChange=this._onDidChange.event,this._updateColorMap(),ee.TokenizationRegistry.onDidChange((function($){$.changedColorMap&&X._updateColorMap()}))}return e.getInstance=function(){return this._INSTANCE||(this._INSTANCE=new e),this._INSTANCE},e.prototype._updateColorMap=function(){var X=ee.TokenizationRegistry.getColorMap();if(!X)return this._colors=[J.RGBA8.Empty],void(this._backgroundIsLight=!0);this._colors=[J.RGBA8.Empty];for(var $=1;$<X.length;$++){var Q=X[$].rgba;this._colors[$]=new J.RGBA8(Q.r,Q.g,Q.b,Math.round(255*Q.a))}var te=X[2].getRelativeLuminance();this._backgroundIsLight=te>=.5,this._onDidChange.fire(void 0)},e.prototype.getColor=function(X){return(X<1||X>=this._colors.length)&&(X=2),this._colors[X]},e.prototype.backgroundIsLight=function(){return this._backgroundIsLight},e._INSTANCE=null,e}();$.MinimapTokensColorTracker=te;var ne=function(){function e(X,$){if(760!==X.length)throw new Error("Invalid x2CharData");if(190!==$.length)throw new Error("Invalid x1CharData");this.x2charData=X,this.x1charData=$,this.x2charDataLight=e.soften(X,.8),this.x1charDataLight=e.soften($,50/60)}return e.soften=function(X,$){for(var Q=new Uint8ClampedArray(X.length),J=0,ee=X.length;J<ee;J++)Q[J]=X[J]*$;return Q},e._getChIndex=function(X){return(X-=32)<0&&(X+=95),X%95},e.prototype.x2RenderChar=function(X,$,Q,J,ee,te,ne){if($+2>X.width||Q+4>X.height)console.warn("bad render request outside image data");else{var ie=ne?this.x2charDataLight:this.x2charData,oe=e._getChIndex(J),re=4*X.width,se=te.r,ae=te.g,le=te.b,ue=ee.r-se,de=ee.g-ae,ce=ee.b-le,he=X.data,pe=4*oe*2,fe=Q*re+4*$,ge=ie[pe]/255;he[fe+0]=se+ue*ge,he[fe+1]=ae+de*ge,he[fe+2]=le+ce*ge,ge=ie[pe+1]/255,he[fe+4]=se+ue*ge,he[fe+5]=ae+de*ge,he[fe+6]=le+ce*ge,fe+=re,ge=ie[pe+2]/255,he[fe+0]=se+ue*ge,he[fe+1]=ae+de*ge,he[fe+2]=le+ce*ge,ge=ie[pe+3]/255,he[fe+4]=se+ue*ge,he[fe+5]=ae+de*ge,he[fe+6]=le+ce*ge,fe+=re,ge=ie[pe+4]/255,he[fe+0]=se+ue*ge,he[fe+1]=ae+de*ge,he[fe+2]=le+ce*ge,ge=ie[pe+5]/255,he[fe+4]=se+ue*ge,he[fe+5]=ae+de*ge,he[fe+6]=le+ce*ge,fe+=re,ge=ie[pe+6]/255,he[fe+0]=se+ue*ge,he[fe+1]=ae+de*ge,he[fe+2]=le+ce*ge,ge=ie[pe+7]/255,he[fe+4]=se+ue*ge,he[fe+5]=ae+de*ge,he[fe+6]=le+ce*ge}},e.prototype.x1RenderChar=function(X,$,Q,J,ee,te,ne){if($+1>X.width||Q+2>X.height)console.warn("bad render request outside image data");else{var ie=ne?this.x1charDataLight:this.x1charData,oe=e._getChIndex(J),re=4*X.width,se=te.r,ae=te.g,le=te.b,ue=ee.r-se,de=ee.g-ae,ce=ee.b-le,he=X.data,pe=2*oe*1,fe=Q*re+4*$,ge=ie[pe]/255;he[fe+0]=se+ue*ge,he[fe+1]=ae+de*ge,he[fe+2]=le+ce*ge,fe+=re,ge=ie[pe+1]/255,he[fe+0]=se+ue*ge,he[fe+1]=ae+de*ge,he[fe+2]=le+ce*ge}},e.prototype.x2BlockRenderChar=function(X,$,Q,J,ee,te){if($+2>X.width||Q+4>X.height)console.warn("bad render request outside image data");else{var ne=4*X.width,ie=ee.r,oe=ee.g,re=ee.b,se=ie+.5*(J.r-ie),ae=oe+.5*(J.g-oe),le=re+.5*(J.b-re),ue=X.data,de=Q*ne+4*$;ue[de+0]=se,ue[de+1]=ae,ue[de+2]=le,ue[de+4]=se,ue[de+5]=ae,ue[de+6]=le,ue[(de+=ne)+0]=se,ue[de+1]=ae,ue[de+2]=le,ue[de+4]=se,ue[de+5]=ae,ue[de+6]=le,ue[(de+=ne)+0]=se,ue[de+1]=ae,ue[de+2]=le,ue[de+4]=se,ue[de+5]=ae,ue[de+6]=le,ue[(de+=ne)+0]=se,ue[de+1]=ae,ue[de+2]=le,ue[de+4]=se,ue[de+5]=ae,ue[de+6]=le}},e.prototype.x1BlockRenderChar=function(X,$,Q,J,ee,te){if($+1>X.width||Q+2>X.height)console.warn("bad render request outside image data");else{var ne=4*X.width,ie=ee.r,oe=ee.g,re=ee.b,se=ie+.5*(J.r-ie),ae=oe+.5*(J.g-oe),le=re+.5*(J.b-re),ue=X.data,de=Q*ne+4*$;ue[de+0]=se,ue[de+1]=ae,ue[de+2]=le,ue[(de+=ne)+0]=se,ue[de+1]=ae,ue[de+2]=le}},e}();$.MinimapCharRenderer=ne})),define(Q[387],n([0,1,107]),(function(X,$,Q){function i(X){for(var $=new Uint8ClampedArray(X.length),Q=0,J=X.length;Q<J;Q++)$[Q]=X[Q];return $}Object.defineProperty($,"__esModule",{value:!0});var J=null;$.getOrCreateMinimapCharRenderer=function(){if(!J){var X=i(te);te=null;var $=i(ee);ee=null,J=new Q.MinimapCharRenderer($,X)}return J};var ee=[0,0,0,0,0,0,0,0,39,14,39,14,14,5,29,10,96,96,29,29,0,0,0,0,49,113,195,214,227,166,135,42,40,29,194,38,75,148,197,187,145,0,160,61,75,143,2,183,138,58,163,6,177,223,197,227,38,13,11,4,0,0,0,0,10,54,52,8,62,4,71,122,73,2,19,40,10,50,155,36,79,70,145,121,7,5,0,0,2,1,36,12,204,166,16,5,0,0,0,0,1,0,154,34,0,0,0,0,96,83,0,0,0,0,0,0,0,0,46,34,0,82,2,56,53,3,146,0,146,119,152,132,152,131,145,119,170,42,15,42,15,42,172,194,131,132,0,139,80,28,227,143,159,135,15,118,11,126,171,144,20,124,88,106,217,196,0,106,189,92,168,43,5,130,164,133,130,115,183,65,134,120,141,141,170,196,2,106,31,32,105,2,145,130,116,114,132,135,138,140,138,113,147,137,81,183,129,94,0,0,21,16,4,3,46,34,0,0,45,34,1,0,160,49,0,0,43,143,203,23,1,76,0,0,38,28,131,96,38,28,0,0,168,31,29,191,98,0,118,139,5,113,45,13,37,6,97,115,161,179,204,105,223,224,83,52,111,100,184,186,120,132,212,145,180,139,174,161,212,182,104,162,131,0,131,0,104,161,219,120,110,116,110,116,219,120,207,154,163,40,147,22,207,154,202,159,161,47,145,23,111,0,139,154,144,30,144,135,139,187,110,110,168,161,150,145,110,110,185,162,43,16,43,16,185,162,73,129,0,110,0,110,191,87,149,149,236,48,195,91,146,149,146,0,146,0,146,0,187,173,200,201,222,215,172,147,95,95,193,97,224,129,159,206,97,192,155,139,153,115,153,115,156,140,189,158,123,136,190,64,111,0,155,139,153,115,153,114,156,241,197,148,150,152,170,116,110,157,156,128,169,14,13,159,158,149,212,189,43,16,43,16,43,16,148,110,148,110,147,109,182,151,133,121,106,118,114,103,89,66,94,94,211,188,205,207,139,168,151,152,87,76,101,79,151,152,130,156,125,116,47,29,43,16,169,228,11,103,120,6,230,176,55,49,55,6,55,6,193,102,92,0,71,0,13,30,0,147,63,43,12,43,12,43,142,152,71,53,61,61,0,0,0,0,0,0,0,0,0,0,158,146,25,2,0,0,0,0,0,0,0,0,107,130,170,194,176,188,109,0,203,159,113,111,202,158,0,0,135,135,114,0,136,135,0,109,187,190,148,126,177,187,0,0,149,130,218,105,169,135,37,113,146,113,49,13,49,13,0,0,178,195,147,114,255,255,109,0,193,149,110,109,109,109,12,15,125,41,33,41,144,188,1,6,75,53,10,53,210,161,110,0,152,148,210,60,110,156,213,5,63,5,63,5,45,111,0,0,232,172,190,168,190,169,0,0,190,144,109,109,109,109,0,0,168,140,148,111,168,140,0,0,200,151,113,110,255,158,0,0,184,188,147,139,186,255,0,0,122,130,111,0,109,0,0,0,132,69,109,93,110,136,51,5,205,103,61,6,47,106,0,0,110,109,110,122,155,179,0,0,132,120,113,114,84,63,0,0,124,108,202,189,160,174,0,0,144,142,79,57,159,146,0,0,138,138,119,117,255,69,0,0,97,198,47,38,208,84,23,112,41,14,157,7,121,192,35,11,35,11,35,11,160,61,129,9,40,19,20,139,236,44,0,0,15,3,97,93,0,0],te=[0,0,23,12,53,0,130,127,58,149,67,77,72,198,13,0,25,51,25,49,94,2,8,64,0,24,0,21,0,9,19,27,126,126,51,80,72,105,87,98,73,93,106,85,111,123,87,30,116,126,123,110,4,16,9,28,21,53,8,62,23,52,73,21,132,183,78,142,168,175,70,70,128,128,123,110,125,43,100,139,125,119,78,78,54,77,139,139,33,87,201,117,162,149,130,130,138,60,130,172,149,127,95,98,95,25,118,135,110,85,147,175,105,110,121,30,101,113,34,68,20,26,34,68,56,0,0,44,3,0,27,175,80,133,31,66,85,147,32,150,90,25,45,230,77,101,36,83,22,84,71,118,44,44,52,172,38,101,35,130,40,197,43,197,29,26,23,103,67,44,25,129,29,85,27,177,33,97,32,145,33,77,38,96,20,55,36,95,2,22]})),define(Q[195],n([0,1,12,3,26,69,131,59]),(function(X,$,Q,J,ee,te,ne,ie){function l(X,$,Q,J,ee,te,ne){var ie=X.createLineMapping($,Q,J,ee,te);return null===ie?ne?se.INSTANCE:ae.INSTANCE:new le(ie,ne)}Object.defineProperty($,"__esModule",{value:!0});var u=function(X,$){this.outputLineIndex=X,this.outputOffset=$};$.OutputPosition=u;var oe=function(){function e(X){this._lines=X}return e.prototype.convertViewPositionToModelPosition=function(X){return this._lines.convertViewPositionToModelPosition(X.lineNumber,X.column)},e.prototype.convertViewRangeToModelRange=function(X){var $=this._lines.convertViewPositionToModelPosition(X.startLineNumber,X.startColumn),Q=this._lines.convertViewPositionToModelPosition(X.endLineNumber,X.endColumn);return new J.Range($.lineNumber,$.column,Q.lineNumber,Q.column)},e.prototype.validateViewPosition=function(X,$){return this._lines.validateViewPosition(X.lineNumber,X.column,$)},e.prototype.validateViewRange=function(X,$){var Q=this._lines.validateViewPosition(X.startLineNumber,X.startColumn,$.getStartPosition()),ee=this._lines.validateViewPosition(X.endLineNumber,X.endColumn,$.getEndPosition());return new J.Range(Q.lineNumber,Q.column,ee.lineNumber,ee.column)},e.prototype.convertModelPositionToViewPosition=function(X){return this._lines.convertModelPositionToViewPosition(X.lineNumber,X.column)},e.prototype.convertModelRangeToViewRange=function(X){var $=this._lines.convertModelPositionToViewPosition(X.startLineNumber,X.startColumn),Q=this._lines.convertModelPositionToViewPosition(X.endLineNumber,X.endColumn);return new J.Range($.lineNumber,$.column,Q.lineNumber,Q.column)},e.prototype.modelPositionIsVisible=function(X){return this._lines.modelPositionIsVisible(X.lineNumber,X.column)},e}();$.CoordinatesConverter=oe;var re=function(){function e(X,$,Q,J,ee,te){this.model=X,this._validModelVersionId=-1,this.tabSize=Q,this.wrappingColumn=J,this.columnsForFullWidthChar=ee,this.wrappingIndent=te,this.linePositionMapperFactory=$,this._constructLines(!0)}return e.prototype.dispose=function(){this.hiddenAreasIds=this.model.deltaDecorations(this.hiddenAreasIds,[])},e.prototype.createCoordinatesConverter=function(){return new oe(this)},e.prototype._ensureValidState=function(){if(this.model.getVersionId()!==this._validModelVersionId)throw new Error("ViewModel is out of sync with Model!");this.lines.length!==this.model.getLineCount()&&this._constructLines(!1)},e.prototype._constructLines=function(X){var $=this;this.lines=[],X&&(this.hiddenAreasIds=[]);for(var Q=this.model.getLinesContent(),ee=Q.length,te=new Uint32Array(ee),ie=this.hiddenAreasIds.map((function(X){return $.model.getDecorationRange(X)})).sort(J.Range.compareRangesUsingStarts),oe=1,re=0,se=-1,ae=se+1<ie.length?re+1:ee+2,le=0;le<ee;le++){var ue=le+1;ue===ae&&(oe=ie[++se].startLineNumber,re=ie[se].endLineNumber,ae=se+1<ie.length?re+1:ee+2);var de=ue>=oe&&ue<=re,ce=l(this.linePositionMapperFactory,Q[le],this.tabSize,this.wrappingColumn,this.columnsForFullWidthChar,this.wrappingIndent,!de);te[le]=ce.getViewLineCount(),this.lines[le]=ce}this._validModelVersionId=this.model.getVersionId(),this.prefixSumComputer=new ne.PrefixSumComputerWithCache(te)},e.prototype.getHiddenAreas=function(){var X=this;return this.hiddenAreasIds.map((function($){return X.model.getDecorationRange($)}))},e.prototype._reduceRanges=function(X){var $=this;if(0===X.length)return[];for(var Q=X.map((function(X){return $.model.validateRange(X)})).sort(J.Range.compareRangesUsingStarts),ee=[],te=Q[0].startLineNumber,ne=Q[0].endLineNumber,ie=1,oe=Q.length;ie<oe;ie++){var re=Q[ie];re.startLineNumber>ne+1?(ee.push(new J.Range(te,1,ne,1)),te=re.startLineNumber,ne=re.endLineNumber):re.endLineNumber>ne&&(ne=re.endLineNumber)}return ee.push(new J.Range(te,1,ne,1)),ee},e.prototype.setHiddenAreas=function(X){var $=this,Q=this._reduceRanges(X),te=this.hiddenAreasIds.map((function(X){return $.model.getDecorationRange(X)})).sort(J.Range.compareRangesUsingStarts);if(Q.length===te.length){for(var ne=!1,ie=0;ie<Q.length;ie++)if(!Q[ie].equalsRange(te[ie])){ne=!0;break}if(!ne)return!1}var oe=[];for(ie=0;ie<Q.length;ie++)oe.push({range:Q[ie],options:ee.ModelDecorationOptions.EMPTY});this.hiddenAreasIds=this.model.deltaDecorations(this.hiddenAreasIds,oe);var re=Q,se=1,ae=0,le=-1,ue=le+1<re.length?ae+1:this.lines.length+2,de=!1;for(ie=0;ie<this.lines.length;ie++){var ce=ie+1;ce===ue&&(se=re[++le].startLineNumber,ae=re[le].endLineNumber,ue=le+1<re.length?ae+1:this.lines.length+2);var he=!1;if(ce>=se&&ce<=ae?this.lines[ie].isVisible()&&(this.lines[ie]=this.lines[ie].setVisible(!1),he=!0):(de=!0,this.lines[ie].isVisible()||(this.lines[ie]=this.lines[ie].setVisible(!0),he=!0)),he){var pe=this.lines[ie].getViewLineCount();this.prefixSumComputer.changeValue(ie,pe)}}return de||this.setHiddenAreas([]),!0},e.prototype.modelPositionIsVisible=function(X,$){return!(X<1||X>this.lines.length)&&this.lines[X-1].isVisible()},e.prototype.setTabSize=function(X){return this.tabSize!==X&&(this.tabSize=X,this._constructLines(!1),!0)},e.prototype.setWrappingSettings=function(X,$,Q){return(this.wrappingIndent!==X||this.wrappingColumn!==$||this.columnsForFullWidthChar!==Q)&&(this.wrappingIndent=X,this.wrappingColumn=$,this.columnsForFullWidthChar=Q,this._constructLines(!1),!0)},e.prototype.onModelFlushed=function(){this._constructLines(!0)},e.prototype.onModelLinesDeleted=function(X,$,Q){if(X<=this._validModelVersionId)return null;var J=1===$?1:this.prefixSumComputer.getAccumulatedValue($-2)+1,ee=this.prefixSumComputer.getAccumulatedValue(Q-1);return this.lines.splice($-1,Q-$+1),this.prefixSumComputer.removeValues($-1,Q-$+1),new te.ViewLinesDeletedEvent(J,ee)},e.prototype.onModelLinesInserted=function(X,$,J,ee){if(X<=this._validModelVersionId)return null;for(var ne=this.getHiddenAreas(),ie=!1,oe=new Q.Position($,1),re=0;re<ne.length;re++)if(ne[re].containsPosition(oe)){ie=!0;break}for(var se=1===$?1:this.prefixSumComputer.getAccumulatedValue($-2)+1,ae=0,le=[],ue=new Uint32Array(ee.length),de=(re=0,ee.length);re<de;re++){var ce=l(this.linePositionMapperFactory,ee[re],this.tabSize,this.wrappingColumn,this.columnsForFullWidthChar,this.wrappingIndent,!ie);le.push(ce);var he=ce.getViewLineCount();ae+=he,ue[re]=he}return this.lines=this.lines.slice(0,$-1).concat(le).concat(this.lines.slice($-1)),this.prefixSumComputer.insertValues($-1,ue),new te.ViewLinesInsertedEvent(se,se+ae-1)},e.prototype.onModelLineChanged=function(X,$,Q){if(X<=this._validModelVersionId)return[!1,null,null,null];var J=$-1,ee=this.lines[J].getViewLineCount(),ne=this.lines[J].isVisible(),ie=l(this.linePositionMapperFactory,Q,this.tabSize,this.wrappingColumn,this.columnsForFullWidthChar,this.wrappingIndent,ne);this.lines[J]=ie;var oe=this.lines[J].getViewLineCount(),re=!1,se=0,ae=-1,le=0,ue=-1,de=0,ce=-1;return ee>oe?(ce=(de=1+(ae=(se=1===$?1:this.prefixSumComputer.getAccumulatedValue($-2)+1)+oe-1))+(ee-oe)-1,re=!0):ee<oe?(ue=(le=1+(ae=(se=1===$?1:this.prefixSumComputer.getAccumulatedValue($-2)+1)+ee-1))+(oe-ee)-1,re=!0):ae=(se=1===$?1:this.prefixSumComputer.getAccumulatedValue($-2)+1)+oe-1,this.prefixSumComputer.changeValue(J,oe),[re,se<=ae?new te.ViewLinesChangedEvent(se,ae):null,le<=ue?new te.ViewLinesInsertedEvent(le,ue):null,de<=ce?new te.ViewLinesDeletedEvent(de,ce):null]},e.prototype.acceptVersionId=function(X){this._validModelVersionId=X,1!==this.lines.length||this.lines[0].isVisible()||this.setHiddenAreas([])},e.prototype.getViewLineCount=function(){return this._ensureValidState(),this.prefixSumComputer.getTotalValue()},e.prototype._toValidViewLineNumber=function(X){if(X<1)return 1;var $=this.getViewLineCount();return X>$?$:X},e.prototype.warmUpLookupCache=function(X,$){this.prefixSumComputer.warmUpCache(X-1,$-1)},e.prototype.getActiveIndentGuide=function(X,$,Q){this._ensureValidState(),X=this._toValidViewLineNumber(X),$=this._toValidViewLineNumber($),Q=this._toValidViewLineNumber(Q);var J=this.convertViewPositionToModelPosition(X,this.getViewLineMinColumn(X)),ee=this.convertViewPositionToModelPosition($,this.getViewLineMinColumn($)),te=this.convertViewPositionToModelPosition(Q,this.getViewLineMinColumn(Q)),ne=this.model.getActiveIndentGuide(J.lineNumber,ee.lineNumber,te.lineNumber),ie=this.convertModelPositionToViewPosition(ne.startLineNumber,1),oe=this.convertModelPositionToViewPosition(ne.endLineNumber,this.model.getLineMaxColumn(ne.endLineNumber));return{startLineNumber:ie.lineNumber,endLineNumber:oe.lineNumber,indent:ne.indent}},e.prototype.getViewLinesIndentGuides=function(X,$){this._ensureValidState(),X=this._toValidViewLineNumber(X),$=this._toValidViewLineNumber($);for(var J=this.convertViewPositionToModelPosition(X,this.getViewLineMinColumn(X)),ee=this.convertViewPositionToModelPosition($,this.getViewLineMaxColumn($)),te=[],ne=[],ie=[],oe=J.lineNumber-1,re=ee.lineNumber-1,se=null,ae=oe;ae<=re;ae++){var le=this.lines[ae];if(le.isVisible()){var ue=le.getViewLineNumberOfModelPosition(0,ae===oe?J.column:1),de=le.getViewLineNumberOfModelPosition(0,this.model.getLineMaxColumn(ae+1)),ce=0;(ye=de-ue+1)>1&&1===le.getViewLineMinColumn(this.model,ae+1,de)&&(ce=0===ue?1:2),ne.push(ye),ie.push(ce),null===se&&(se=new Q.Position(ae+1,0))}else null!==se&&(te=te.concat(this.model.getLinesIndentGuides(se.lineNumber,ae)),se=null)}null!==se&&(te=te.concat(this.model.getLinesIndentGuides(se.lineNumber,ee.lineNumber)),se=null);for(var he=$-X+1,pe=new Array(he),fe=0,ge=0,me=te.length;ge<me;ge++){var ve,_e=te[ge],ye=Math.min(he-fe,ne[ge]);ve=2===(ce=ie[ge])?0:1===ce?1:ye;for(var be=0;be<ye;be++)be===ve&&(_e=0),pe[fe++]=_e}return pe},e.prototype.getViewLineContent=function(X){this._ensureValidState(),X=this._toValidViewLineNumber(X);var $=this.prefixSumComputer.getIndexOf(X-1),Q=$.index,J=$.remainder;return this.lines[Q].getViewLineContent(this.model,Q+1,J)},e.prototype.getViewLineLength=function(X){this._ensureValidState(),X=this._toValidViewLineNumber(X);var $=this.prefixSumComputer.getIndexOf(X-1),Q=$.index,J=$.remainder;return this.lines[Q].getViewLineLength(this.model,Q+1,J)},e.prototype.getViewLineMinColumn=function(X){this._ensureValidState(),X=this._toValidViewLineNumber(X);var $=this.prefixSumComputer.getIndexOf(X-1),Q=$.index,J=$.remainder;return this.lines[Q].getViewLineMinColumn(this.model,Q+1,J)},e.prototype.getViewLineMaxColumn=function(X){this._ensureValidState(),X=this._toValidViewLineNumber(X);var $=this.prefixSumComputer.getIndexOf(X-1),Q=$.index,J=$.remainder;return this.lines[Q].getViewLineMaxColumn(this.model,Q+1,J)},e.prototype.getViewLineData=function(X){this._ensureValidState(),X=this._toValidViewLineNumber(X);var $=this.prefixSumComputer.getIndexOf(X-1),Q=$.index,J=$.remainder;return this.lines[Q].getViewLineData(this.model,Q+1,J)},e.prototype.getViewLinesData=function(X,$,Q){this._ensureValidState(),X=this._toValidViewLineNumber(X),$=this._toValidViewLineNumber($);for(var J=this.prefixSumComputer.getIndexOf(X-1),ee=X,te=J.index,ne=J.remainder,ie=[],oe=te,re=this.model.getLineCount();oe<re;oe++){var se=this.lines[oe];if(se.isVisible()){var ae=oe===te?ne:0,le=se.getViewLineCount()-ae,ue=!1;ee+le>$&&(ue=!0,le=$-ee+1);var de=ae+le;if(se.getViewLinesData(this.model,oe+1,ae,de,ee-X,Q,ie),ee+=le,ue)break}}return ie},e.prototype.validateViewPosition=function(X,$,J){this._ensureValidState(),X=this._toValidViewLineNumber(X);var ee=this.prefixSumComputer.getIndexOf(X-1),te=ee.index,ne=ee.remainder,ie=this.lines[te],oe=ie.getViewLineMinColumn(this.model,te+1,ne),re=ie.getViewLineMaxColumn(this.model,te+1,ne);$<oe&&($=oe),$>re&&($=re);var se=ie.getModelColumnOfViewPosition(ne,$);return this.model.validatePosition(new Q.Position(te+1,se)).equals(J)?new Q.Position(X,$):this.convertModelPositionToViewPosition(J.lineNumber,J.column)},e.prototype.convertViewPositionToModelPosition=function(X,$){this._ensureValidState(),X=this._toValidViewLineNumber(X);var J=this.prefixSumComputer.getIndexOf(X-1),ee=J.index,te=J.remainder,ne=this.lines[ee].getModelColumnOfViewPosition(te,$);return this.model.validatePosition(new Q.Position(ee+1,ne))},e.prototype.convertModelPositionToViewPosition=function(X,$){this._ensureValidState();for(var J=this.model.validatePosition(new Q.Position(X,$)),ee=J.lineNumber,te=J.column,ne=ee-1,ie=!1;ne>0&&!this.lines[ne].isVisible();)ne--,ie=!0;if(0===ne&&!this.lines[ne].isVisible())return new Q.Position(1,1);var oe=1+(0===ne?0:this.prefixSumComputer.getAccumulatedValue(ne-1));return ie?this.lines[ne].getViewPositionOfModelPosition(oe,this.model.getLineMaxColumn(ne+1)):this.lines[ee-1].getViewPositionOfModelPosition(oe,te)},e.prototype._getViewLineNumberForModelPosition=function(X,$){var Q=X-1;if(this.lines[Q].isVisible()){var J=1+(0===Q?0:this.prefixSumComputer.getAccumulatedValue(Q-1));return this.lines[Q].getViewLineNumberOfModelPosition(J,$)}for(;Q>0&&!this.lines[Q].isVisible();)Q--;if(0===Q&&!this.lines[Q].isVisible())return 1;var ee=1+(0===Q?0:this.prefixSumComputer.getAccumulatedValue(Q-1));return this.lines[Q].getViewLineNumberOfModelPosition(ee,this.model.getLineMaxColumn(Q+1))},e.prototype.getAllOverviewRulerDecorations=function(X,$,Q){for(var J=this.model.getOverviewRulerDecorations(X,$),ee=new ce,te=0,ne=J.length;te<ne;te++){var ie=J[te],oe=ie.options.overviewRuler,re=oe?oe.position:0;if(0!==re){var se=oe.getColor(Q),ae=this._getViewLineNumberForModelPosition(ie.range.startLineNumber,ie.range.startColumn),le=this._getViewLineNumberForModelPosition(ie.range.endLineNumber,ie.range.endColumn);ee.accept(se,ae,le,re)}}return ee.result},e.prototype.getDecorationsInRange=function(X,$,ee){var te=this.convertViewPositionToModelPosition(X.startLineNumber,X.startColumn),ne=this.convertViewPositionToModelPosition(X.endLineNumber,X.endColumn);if(ne.lineNumber-te.lineNumber<=X.endLineNumber-X.startLineNumber)return this.model.getDecorationsInRange(new J.Range(te.lineNumber,1,ne.lineNumber,ne.column),$,ee);for(var ie=[],oe=te.lineNumber-1,re=ne.lineNumber-1,se=null,ae=oe;ae<=re;ae++)if(this.lines[ae].isVisible())null===se&&(se=new Q.Position(ae+1,ae===oe?te.column:1));else if(null!==se){var le=this.model.getLineMaxColumn(ae);ie=ie.concat(this.model.getDecorationsInRange(new J.Range(se.lineNumber,se.column,ae,le),$,ee)),se=null}null!==se&&(ie=ie.concat(this.model.getDecorationsInRange(new J.Range(se.lineNumber,se.column,ne.lineNumber,ne.column),$,ee)),se=null),ie.sort((function(X,$){var Q=J.Range.compareRangesUsingStarts(X.range,$.range);return 0===Q?X.id<$.id?-1:X.id>$.id?1:0:Q}));for(var ue=[],de=0,ce=null,he=0,pe=ie.length;he<pe;he++){var fe=ie[he],ge=fe.id;ce!==ge&&(ce=ge,ue[de++]=fe)}return ue},e}();$.SplitLinesCollection=re;var se=function(){function e(){}return e.prototype.isVisible=function(){return!0},e.prototype.setVisible=function(X){return X?this:ae.INSTANCE},e.prototype.getViewLineCount=function(){return 1},e.prototype.getViewLineContent=function(X,$,Q){return X.getLineContent($)},e.prototype.getViewLineLength=function(X,$,Q){return X.getLineLength($)},e.prototype.getViewLineMinColumn=function(X,$,Q){return X.getLineMinColumn($)},e.prototype.getViewLineMaxColumn=function(X,$,Q){return X.getLineMaxColumn($)},e.prototype.getViewLineData=function(X,$,Q){var J=X.getLineTokens($),ee=J.getLineContent();return new ie.ViewLineData(ee,!1,1,ee.length+1,J.inflate())},e.prototype.getViewLinesData=function(X,$,Q,J,ee,te,ne){te[ee]?ne[ee]=this.getViewLineData(X,$,0):ne[ee]=null},e.prototype.getModelColumnOfViewPosition=function(X,$){return $},e.prototype.getViewPositionOfModelPosition=function(X,$){return new Q.Position(X,$)},e.prototype.getViewLineNumberOfModelPosition=function(X,$){return X},e.INSTANCE=new e,e}(),ae=function(){function e(){}return e.prototype.isVisible=function(){return!1},e.prototype.setVisible=function(X){return X?se.INSTANCE:this},e.prototype.getViewLineCount=function(){return 0},e.prototype.getViewLineContent=function(X,$,Q){throw new Error("Not supported")},e.prototype.getViewLineLength=function(X,$,Q){throw new Error("Not supported")},e.prototype.getViewLineMinColumn=function(X,$,Q){throw new Error("Not supported")},e.prototype.getViewLineMaxColumn=function(X,$,Q){throw new Error("Not supported")},e.prototype.getViewLineData=function(X,$,Q){throw new Error("Not supported")},e.prototype.getViewLinesData=function(X,$,Q,J,ee,te,ne){throw new Error("Not supported")},e.prototype.getModelColumnOfViewPosition=function(X,$){throw new Error("Not supported")},e.prototype.getViewPositionOfModelPosition=function(X,$){throw new Error("Not supported")},e.prototype.getViewLineNumberOfModelPosition=function(X,$){throw new Error("Not supported")},e.INSTANCE=new e,e}(),le=function(){function e(X,$){this.positionMapper=X,this.wrappedIndent=this.positionMapper.getWrappedLinesIndent(),this.wrappedIndentLength=this.wrappedIndent.length,this.outputLineCount=this.positionMapper.getOutputLineCount(),this._isVisible=$}return e.prototype.isVisible=function(){return this._isVisible},e.prototype.setVisible=function(X){return this._isVisible=X,this},e.prototype.getViewLineCount=function(){return this._isVisible?this.outputLineCount:0},e.prototype.getInputStartOffsetOfOutputLineIndex=function(X){return this.positionMapper.getInputOffsetOfOutputPosition(X,0)},e.prototype.getInputEndOffsetOfOutputLineIndex=function(X,$,Q){return Q+1===this.outputLineCount?X.getLineMaxColumn($)-1:this.positionMapper.getInputOffsetOfOutputPosition(Q+1,0)},e.prototype.getViewLineContent=function(X,$,Q){if(!this._isVisible)throw new Error("Not supported");var J=this.getInputStartOffsetOfOutputLineIndex(Q),ee=this.getInputEndOffsetOfOutputLineIndex(X,$,Q),te=X.getValueInRange({startLineNumber:$,startColumn:J+1,endLineNumber:$,endColumn:ee+1});return Q>0&&(te=this.wrappedIndent+te),te},e.prototype.getViewLineLength=function(X,$,Q){if(!this._isVisible)throw new Error("Not supported");var J=this.getInputStartOffsetOfOutputLineIndex(Q),ee=this.getInputEndOffsetOfOutputLineIndex(X,$,Q)-J;return Q>0&&(ee=this.wrappedIndent.length+ee),ee},e.prototype.getViewLineMinColumn=function(X,$,Q){if(!this._isVisible)throw new Error("Not supported");return Q>0?this.wrappedIndentLength+1:1},e.prototype.getViewLineMaxColumn=function(X,$,Q){if(!this._isVisible)throw new Error("Not supported");return this.getViewLineContent(X,$,Q).length+1},e.prototype.getViewLineData=function(X,$,Q){if(!this._isVisible)throw new Error("Not supported");var J=this.getInputStartOffsetOfOutputLineIndex(Q),ee=this.getInputEndOffsetOfOutputLineIndex(X,$,Q),te=X.getValueInRange({startLineNumber:$,startColumn:J+1,endLineNumber:$,endColumn:ee+1});Q>0&&(te=this.wrappedIndent+te);var ne=Q>0?this.wrappedIndentLength+1:1,oe=te.length+1,re=Q+1<this.getViewLineCount(),se=0;Q>0&&(se=this.wrappedIndentLength);var ae=X.getLineTokens($);return new ie.ViewLineData(te,re,ne,oe,ae.sliceAndInflate(J,ee,se))},e.prototype.getViewLinesData=function(X,$,Q,J,ee,te,ne){if(!this._isVisible)throw new Error("Not supported");for(var ie=Q;ie<J;ie++){var oe=ee+ie-Q;te[oe]?ne[oe]=this.getViewLineData(X,$,ie):ne[oe]=null}},e.prototype.getModelColumnOfViewPosition=function(X,$){if(!this._isVisible)throw new Error("Not supported");var Q=$-1;return X>0&&(Q<this.wrappedIndentLength?Q=0:Q-=this.wrappedIndentLength),this.positionMapper.getInputOffsetOfOutputPosition(X,Q)+1},e.prototype.getViewPositionOfModelPosition=function(X,$){if(!this._isVisible)throw new Error("Not supported");var J=this.positionMapper.getOutputPositionOfInputOffset($-1),ee=J.outputLineIndex,te=J.outputOffset+1;return ee>0&&(te+=this.wrappedIndentLength),new Q.Position(X+ee,te)},e.prototype.getViewLineNumberOfModelPosition=function(X,$){if(!this._isVisible)throw new Error("Not supported");return X+this.positionMapper.getOutputPositionOfInputOffset($-1).outputLineIndex},e}();$.SplitLine=le;var ue=function(){function e(X){this._lines=X}return e.prototype._validPosition=function(X){return this._lines.model.validatePosition(X)},e.prototype._validRange=function(X){return this._lines.model.validateRange(X)},e.prototype.convertViewPositionToModelPosition=function(X){return this._validPosition(X)},e.prototype.convertViewRangeToModelRange=function(X){return this._validRange(X)},e.prototype.validateViewPosition=function(X,$){return this._validPosition($)},e.prototype.validateViewRange=function(X,$){return this._validRange($)},e.prototype.convertModelPositionToViewPosition=function(X){return this._validPosition(X)},e.prototype.convertModelRangeToViewRange=function(X){return this._validRange(X)},e.prototype.modelPositionIsVisible=function(X){var $=this._lines.model.getLineCount();return!(X.lineNumber<1||X.lineNumber>$)},e}();$.IdentityCoordinatesConverter=ue;var de=function(){function e(X){this.model=X}return e.prototype.dispose=function(){},e.prototype.createCoordinatesConverter=function(){return new ue(this)},e.prototype.getHiddenAreas=function(){return[]},e.prototype.setHiddenAreas=function(X){return!1},e.prototype.setTabSize=function(X){return!1},e.prototype.setWrappingSettings=function(X,$,Q){return!1},e.prototype.onModelFlushed=function(){},e.prototype.onModelLinesDeleted=function(X,$,Q){return new te.ViewLinesDeletedEvent($,Q)},e.prototype.onModelLinesInserted=function(X,$,Q,J){return new te.ViewLinesInsertedEvent($,Q)},e.prototype.onModelLineChanged=function(X,$,Q){return[!1,new te.ViewLinesChangedEvent($,$),null,null]},e.prototype.acceptVersionId=function(X){},e.prototype.getViewLineCount=function(){return this.model.getLineCount()},e.prototype.warmUpLookupCache=function(X,$){},e.prototype.getActiveIndentGuide=function(X,$,Q){return{startLineNumber:X,endLineNumber:X,indent:0}},e.prototype.getViewLinesIndentGuides=function(X,$){for(var Q=$-X+1,J=new Array(Q),ee=0;ee<Q;ee++)J[ee]=0;return J},e.prototype.getViewLineContent=function(X){return this.model.getLineContent(X)},e.prototype.getViewLineLength=function(X){return this.model.getLineLength(X)},e.prototype.getViewLineMinColumn=function(X){return this.model.getLineMinColumn(X)},e.prototype.getViewLineMaxColumn=function(X){return this.model.getLineMaxColumn(X)},e.prototype.getViewLineData=function(X){var $=this.model.getLineTokens(X),Q=$.getLineContent();return new ie.ViewLineData(Q,!1,1,Q.length+1,$.inflate())},e.prototype.getViewLinesData=function(X,$,Q){var J=this.model.getLineCount();X=Math.min(Math.max(1,X),J),$=Math.min(Math.max(1,$),J);for(var ee=[],te=X;te<=$;te++){var ne=te-X;Q[ne]||(ee[ne]=null),ee[ne]=this.getViewLineData(te)}return ee},e.prototype.getAllOverviewRulerDecorations=function(X,$,Q){for(var J=this.model.getOverviewRulerDecorations(X,$),ee=new ce,te=0,ne=J.length;te<ne;te++){var ie=J[te],oe=ie.options.overviewRuler,re=oe?oe.position:0;if(0!==re){var se=oe.getColor(Q),ae=ie.range.startLineNumber,le=ie.range.endLineNumber;ee.accept(se,ae,le,re)}}return ee.result},e.prototype.getDecorationsInRange=function(X,$,Q){return this.model.getDecorationsInRange(X,$,Q)},e}();$.IdentityLinesCollection=de;var ce=function(){function e(){this.result=Object.create(null)}return e.prototype.accept=function(X,$,Q,J){var ee=this.result[X];if(ee){var te=ee[ee.length-3],ne=ee[ee.length-1];if(te===J&&ne+1>=$)return void(Q>ne&&(ee[ee.length-1]=Q));ee.push(J,$,Q)}else this.result[X]=[J,$,Q]},e}()})),define(Q[389],n([0,1,8,81,101,131,195]),(function(X,$,Q,J,ee,ne,ie){Object.defineProperty($,"__esModule",{value:!0});var oe=function(X){function t($,Q,J){for(var ee=X.call(this,0)||this,te=0;te<$.length;te++)ee.set($.charCodeAt(te),1);for(te=0;te<Q.length;te++)ee.set(Q.charCodeAt(te),2);for(te=0;te<J.length;te++)ee.set(J.charCodeAt(te),3);return ee}return te(t,X),t.prototype.get=function($){return $>=12352&&$<=12543||$>=13312&&$<=19903||$>=19968&&$<=40959?4:X.prototype.get.call(this,$)},t}(J.CharacterClassifier),re=function(){function e(X,$,Q){this.classifier=new oe(X,$,Q)}return e.nextVisibleColumn=function(X,$,Q,J){return X=+X,$=+$,J=+J,Q?X+($-X%$):X+J},e.prototype.createLineMapping=function(X,$,J,te,ie){if(-1===J)return null;$=+$,J=+J,te=+te;var oe=0,re="",ae=-1;if(0!=(ie=+ie)&&-1!==(ae=Q.firstNonWhitespaceIndex(X))){for(re=X.substring(0,ae),ye=0;ye<ae;ye++)oe=e.nextVisibleColumn(oe,$,9===X.charCodeAt(ye),1);var le=0;for(2===ie?le=1:3===ie&&(le=2),ye=0;ye<le;ye++)re+="\t",oe=e.nextVisibleColumn(oe,$,!0,1);oe+te>J&&(re="",oe=0)}for(var ue=this.classifier,de=0,ce=[],he=0,pe=0,fe=-1,ge=0,me=-1,ve=0,_e=X.length,ye=0;ye<_e;ye++){var be=X.charCodeAt(ye),Ce=9===be,we=ue.get(be);if(1===we&&(fe=ye,ge=oe),4===we&&ye>0){var Se=X.charCodeAt(ye-1);1!==ue.get(Se)&&(fe=ye,ge=oe)}var Ee=1;if(Q.isFullWidthCharacter(be)&&(Ee=te),(pe=e.nextVisibleColumn(pe,$,Ce,Ee))>J&&0!==ye){var Le=void 0,xe=void 0;-1!==fe&&ge<=J?(Le=fe,xe=ge):-1!==me&&ve<=J?(Le=me,xe=ve):(Le=ye,xe=oe),ce[he++]=Le-de,de=Le,pe=e.nextVisibleColumn(xe,$,Ce,Ee),fe=-1,ge=0,me=-1,ve=0}if(-1!==fe&&(ge=e.nextVisibleColumn(ge,$,Ce,Ee)),-1!==me&&(ve=e.nextVisibleColumn(ve,$,Ce,Ee)),2===we&&(0===ie||ye>=ae)&&(fe=ye+1,ge=oe),4===we&&ye<_e-1){var Ie=X.charCodeAt(ye+1);2!==ue.get(Ie)&&(fe=ye+1,ge=oe)}3===we&&(me=ye+1,ve=oe)}return 0===he?null:(ce[he++]=_e-de,new se(new ne.PrefixSumComputer(ee.toUint32Array(ce)),re))},e}();$.CharacterHardWrappingLineMapperFactory=re;var se=function(){function e(X,$){this._prefixSums=X,this._wrappedLinesIndent=$}return e.prototype.getOutputLineCount=function(){return this._prefixSums.getCount()},e.prototype.getWrappedLinesIndent=function(){return this._wrappedLinesIndent},e.prototype.getInputOffsetOfOutputPosition=function(X,$){return 0===X?$:this._prefixSums.getAccumulatedValue(X-1)+$},e.prototype.getOutputPositionOfInputOffset=function(X){var $=this._prefixSums.getIndexOf(X);return new ie.OutputPosition($.index,$.remainder)},e}();$.CharacterHardWrappingLineMapping=se})),define(Q[390],n([0,1,28,8,12,3,14,190,107,69,232,389,195,59,233]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le,ue,de,ce){Object.defineProperty($,"__esModule",{value:!0});var he=function(X){function t($,Q,J,ee){var te=X.call(this)||this;if(te.editorId=$,te.configuration=Q,te.model=J,te.hasFocus=!1,te.viewportStartLine=-1,te.viewportStartLineTrackedRange=null,te.viewportStartLineDelta=0,te.model.isTooLargeForTokenization())te.lines=new ue.IdentityLinesCollection(te.model);else{var ne=te.configuration.editor,ie=new le.CharacterHardWrappingLineMapperFactory(ne.wrappingInfo.wordWrapBreakBeforeCharacters,ne.wrappingInfo.wordWrapBreakAfterCharacters,ne.wrappingInfo.wordWrapBreakObtrusiveCharacters);te.lines=new ue.SplitLinesCollection(te.model,ie,te.model.getOptions().tabSize,ne.wrappingInfo.wrappingColumn,ne.fontInfo.typicalFullwidthCharacterWidth/ne.fontInfo.typicalHalfwidthCharacterWidth,ne.wrappingInfo.wrappingIndent)}return te.coordinatesConverter=te.lines.createCoordinatesConverter(),te.viewLayout=te._register(new ae.ViewLayout(te.configuration,te.getLineCount(),ee)),te._register(te.viewLayout.onDidScroll((function(X){try{te._beginEmit().emit(new se.ViewScrollChangedEvent(X))}finally{te._endEmit()}}))),te.decorations=new ce.ViewModelDecorations(te.editorId,te.model,te.configuration,te.lines,te.coordinatesConverter),te._registerModelEvents(),te._register(te.configuration.onDidChange((function(X){try{var $=te._beginEmit();te._onConfigurationChanged($,X)}finally{te._endEmit()}}))),te._register(re.MinimapTokensColorTracker.getInstance().onDidChange((function(){try{te._beginEmit().emit(new se.ViewTokensColorsChangedEvent)}finally{te._endEmit()}}))),te}return te(t,X),t.prototype.dispose=function(){X.prototype.dispose.call(this),this.decorations.dispose(),this.lines.dispose(),this.viewportStartLineTrackedRange=this.model._setTrackedRange(this.viewportStartLineTrackedRange,null,1)},t.prototype.setHasFocus=function(X){this.hasFocus=X},t.prototype._onConfigurationChanged=function(X,$){var Q=null;if(-1!==this.viewportStartLine){var J=new ee.Position(this.viewportStartLine,this.getLineMinColumn(this.viewportStartLine));Q=this.coordinatesConverter.convertViewPositionToModelPosition(J)}var te=!1,ne=this.configuration.editor;if(this.lines.setWrappingSettings(ne.wrappingInfo.wrappingIndent,ne.wrappingInfo.wrappingColumn,ne.fontInfo.typicalFullwidthCharacterWidth/ne.fontInfo.typicalHalfwidthCharacterWidth)&&(X.emit(new se.ViewFlushedEvent),X.emit(new se.ViewLineMappingChangedEvent),X.emit(new se.ViewDecorationsChangedEvent),this.decorations.onLineMappingChanged(),this.viewLayout.onFlushed(this.getLineCount()),0!==this.viewLayout.getCurrentScrollTop()&&(te=!0)),$.readOnly&&(this.decorations.reset(),X.emit(new se.ViewDecorationsChangedEvent)),X.emit(new se.ViewConfigurationChangedEvent($)),this.viewLayout.onConfigurationChanged($),te&&Q){var ie=this.coordinatesConverter.convertModelPositionToViewPosition(Q),oe=this.viewLayout.getVerticalOffsetForLineNumber(ie.lineNumber);this.viewLayout.setScrollPositionNow({scrollTop:oe+this.viewportStartLineDelta})}},t.prototype._registerModelEvents=function(){var X=this;this._register(this.model.onDidChangeRawContentFast((function($){try{for(var Q=X._beginEmit(),J=!1,ee=!1,te=$.changes,ne=$.versionId,ie=0,oe=te.length;ie<oe;ie++){var re=te[ie];switch(re.changeType){case 1:X.lines.onModelFlushed(),Q.emit(new se.ViewFlushedEvent),X.decorations.reset(),X.viewLayout.onFlushed(X.getLineCount()),J=!0;break;case 3:null!==(ce=X.lines.onModelLinesDeleted(ne,re.fromLineNumber,re.toLineNumber))&&(Q.emit(ce),X.viewLayout.onLinesDeleted(ce.fromLineNumber,ce.toLineNumber)),J=!0;break;case 4:null!==(de=X.lines.onModelLinesInserted(ne,re.fromLineNumber,re.toLineNumber,re.detail))&&(Q.emit(de),X.viewLayout.onLinesInserted(de.fromLineNumber,de.toLineNumber)),J=!0;break;case 2:var ae=X.lines.onModelLineChanged(ne,re.lineNumber,re.detail),le=ae[0],ue=ae[1],de=ae[2],ce=ae[3];ee=le,ue&&Q.emit(ue),de&&(Q.emit(de),X.viewLayout.onLinesInserted(de.fromLineNumber,de.toLineNumber)),ce&&(Q.emit(ce),X.viewLayout.onLinesDeleted(ce.fromLineNumber,ce.toLineNumber))}}X.lines.acceptVersionId(ne),X.viewLayout.onHeightMaybeChanged(),!J&&ee&&(Q.emit(new se.ViewLineMappingChangedEvent),Q.emit(new se.ViewDecorationsChangedEvent),X.decorations.onLineMappingChanged())}finally{X._endEmit()}if(X.viewportStartLine=-1,X.configuration.setMaxLineNumber(X.model.getLineCount()),!X.hasFocus&&X.model.getAttachedEditorCount()>=2&&X.viewportStartLineTrackedRange){var he=X.model._getTrackedRange(X.viewportStartLineTrackedRange);if(he){var pe=X.coordinatesConverter.convertModelPositionToViewPosition(he.getStartPosition()),fe=X.viewLayout.getVerticalOffsetForLineNumber(pe.lineNumber);X.viewLayout.setScrollPositionNow({scrollTop:fe+X.viewportStartLineDelta})}}}))),this._register(this.model.onDidChangeTokens((function($){for(var Q=[],J=0,te=$.ranges.length;J<te;J++){var ne=$.ranges[J],ie=X.coordinatesConverter.convertModelPositionToViewPosition(new ee.Position(ne.fromLineNumber,1)).lineNumber,oe=X.coordinatesConverter.convertModelPositionToViewPosition(new ee.Position(ne.toLineNumber,X.model.getLineMaxColumn(ne.toLineNumber))).lineNumber;Q[J]={fromLineNumber:ie,toLineNumber:oe}}try{X._beginEmit().emit(new se.ViewTokensChangedEvent(Q))}finally{X._endEmit()}}))),this._register(this.model.onDidChangeLanguageConfiguration((function($){try{X._beginEmit().emit(new se.ViewLanguageConfigurationEvent)}finally{X._endEmit()}}))),this._register(this.model.onDidChangeOptions((function($){if(X.lines.setTabSize(X.model.getOptions().tabSize)){X.decorations.onLineMappingChanged(),X.viewLayout.onFlushed(X.getLineCount());try{var Q=X._beginEmit();Q.emit(new se.ViewFlushedEvent),Q.emit(new se.ViewLineMappingChangedEvent),Q.emit(new se.ViewDecorationsChangedEvent)}finally{X._endEmit()}}}))),this._register(this.model.onDidChangeDecorations((function($){X.decorations.onModelDecorationsChanged();try{X._beginEmit().emit(new se.ViewDecorationsChangedEvent)}finally{X._endEmit()}})))},t.prototype.setHiddenAreas=function(X){try{var $=this._beginEmit();this.lines.setHiddenAreas(X)&&($.emit(new se.ViewFlushedEvent),$.emit(new se.ViewLineMappingChangedEvent),$.emit(new se.ViewDecorationsChangedEvent),this.decorations.onLineMappingChanged(),this.viewLayout.onFlushed(this.getLineCount()),this.viewLayout.onHeightMaybeChanged())}finally{this._endEmit()}},t.prototype.getVisibleRanges=function(){var X=this.getCompletelyVisibleViewRange(),$=this.coordinatesConverter.convertViewRangeToModelRange(X),Q=this.lines.getHiddenAreas();if(0===Q.length)return[$];for(var J=[],ee=0,te=$.startLineNumber,ie=$.startColumn,oe=$.endLineNumber,re=$.endColumn,se=0,ae=Q.length;se<ae;se++){var le=Q[se].startLineNumber,ue=Q[se].endLineNumber;ue<te||le>oe||(te<le&&(J[ee++]=new ne.Range(te,ie,le-1,this.model.getLineMaxColumn(le-1))),te=ue+1,ie=1)}return(te<oe||te===oe&&ie<re)&&(J[ee++]=new ne.Range(te,ie,oe,re)),J},t.prototype.getCompletelyVisibleViewRange=function(){var X=this.viewLayout.getLinesViewportData(),$=X.completelyVisibleStartLineNumber,Q=X.completelyVisibleEndLineNumber;return new ne.Range($,this.getLineMinColumn($),Q,this.getLineMaxColumn(Q))},t.prototype.getCompletelyVisibleViewRangeAtScrollTop=function(X){var $=this.viewLayout.getLinesViewportDataAtScrollTop(X),Q=$.completelyVisibleStartLineNumber,J=$.completelyVisibleEndLineNumber;return new ne.Range(Q,this.getLineMinColumn(Q),J,this.getLineMaxColumn(J))},t.prototype.saveState=function(){var X=this.viewLayout.saveState(),$=X.scrollTop,Q=this.viewLayout.getLineNumberAtVerticalOffset($),J=this.coordinatesConverter.convertViewPositionToModelPosition(new ee.Position(Q,this.getLineMinColumn(Q))),te=this.viewLayout.getVerticalOffsetForLineNumber(Q)-$;return{scrollLeft:X.scrollLeft,firstPosition:J,firstPositionDeltaTop:te}},t.prototype.reduceRestoreState=function(X){if(void 0===X.firstPosition)return this._reduceRestoreStateCompatibility(X);var $=this.model.validatePosition(X.firstPosition),Q=this.coordinatesConverter.convertModelPositionToViewPosition($),J=this.viewLayout.getVerticalOffsetForLineNumber(Q.lineNumber)-X.firstPositionDeltaTop;return{scrollLeft:X.scrollLeft,scrollTop:J}},t.prototype._reduceRestoreStateCompatibility=function(X){return{scrollLeft:X.scrollLeft,scrollTop:X.scrollTopWithoutViewZones}},t.prototype.getTabSize=function(){return this.model.getOptions().tabSize},t.prototype.getLineCount=function(){return this.lines.getViewLineCount()},t.prototype.setViewport=function(X,$,Q){this.lines.warmUpLookupCache(X,$),this.viewportStartLine=X;var J=this.coordinatesConverter.convertViewPositionToModelPosition(new ee.Position(X,this.getLineMinColumn(X)));this.viewportStartLineTrackedRange=this.model._setTrackedRange(this.viewportStartLineTrackedRange,new ne.Range(J.lineNumber,J.column,J.lineNumber,J.column),1);var te=this.viewLayout.getVerticalOffsetForLineNumber(X),ie=this.viewLayout.getCurrentScrollTop();this.viewportStartLineDelta=ie-te},t.prototype.getActiveIndentGuide=function(X,$,Q){return this.lines.getActiveIndentGuide(X,$,Q)},t.prototype.getLinesIndentGuides=function(X,$){return this.lines.getViewLinesIndentGuides(X,$)},t.prototype.getLineContent=function(X){return this.lines.getViewLineContent(X)},t.prototype.getLineLength=function(X){return this.lines.getViewLineLength(X)},t.prototype.getLineMinColumn=function(X){return this.lines.getViewLineMinColumn(X)},t.prototype.getLineMaxColumn=function(X){return this.lines.getViewLineMaxColumn(X)},t.prototype.getLineFirstNonWhitespaceColumn=function(X){var $=J.firstNonWhitespaceIndex(this.getLineContent(X));return-1===$?0:$+1},t.prototype.getLineLastNonWhitespaceColumn=function(X){var $=J.lastNonWhitespaceIndex(this.getLineContent(X));return-1===$?0:$+2},t.prototype.getDecorationsInViewport=function(X){return this.decorations.getDecorationsViewportData(X).decorations},t.prototype.getViewLineRenderingData=function(X,$){var Q=this.model.mightContainRTL(),J=this.model.mightContainNonBasicASCII(),ee=this.getTabSize(),te=this.lines.getViewLineData($),ne=this.decorations.getDecorationsViewportData(X).inlineDecorations[$-X.startLineNumber];return new de.ViewLineRenderingData(te.minColumn,te.maxColumn,te.content,te.continuesWithWrappedLine,Q,J,te.tokens,ne,ee)},t.prototype.getViewLineData=function(X){return this.lines.getViewLineData(X)},t.prototype.getMinimapLinesRenderingData=function(X,$,Q){var J=this.lines.getViewLinesData(X,$,Q);return new de.MinimapLinesRenderingData(this.getTabSize(),J)},t.prototype.getAllOverviewRulerDecorations=function(X){return this.lines.getAllOverviewRulerDecorations(this.editorId,this.configuration.editor.readOnly,X)},t.prototype.invalidateOverviewRulerColorCache=function(){for(var X=this.model.getOverviewRulerDecorations(),$=0,Q=X.length;$<Q;$++){var J=X[$].options.overviewRuler;J&&J.invalidateCachedColor()}},t.prototype.getValueInRange=function(X,$){var Q=this.coordinatesConverter.convertViewRangeToModelRange(X);return this.model.getValueInRange(Q,$)},t.prototype.getModelLineMaxColumn=function(X){return this.model.getLineMaxColumn(X)},t.prototype.validateModelPosition=function(X){return this.model.validatePosition(X)},t.prototype.validateModelRange=function(X){return this.model.validateRange(X)},t.prototype.deduceModelPositionRelativeToViewPosition=function(X,$,Q){var J=this.coordinatesConverter.convertViewPositionToModelPosition(X);2===this.model.getEOL().length&&($<0?$-=Q:$+=Q);var ee=this.model.getOffsetAt(J)+$;return this.model.getPositionAt(ee)},t.prototype.getEOL=function(){return this.model.getEOL()},t.prototype.getPlainTextToCopy=function(X,$,Q){var J=this,te=Q?"\r\n":this.model.getEOL();(X=X.slice(0)).sort(ne.Range.compareRangesUsingStarts);var ie=X.filter((function(X){return!X.isEmpty()}));if(0===ie.length){if(!$)return"";for(var oe=X.map((function(X){var $=new ee.Position(X.startLineNumber,1);return J.coordinatesConverter.convertViewPositionToModelPosition($).lineNumber})),re="",se=0;se<oe.length;se++)se>0&&oe[se-1]===oe[se]||(re+=this.model.getLineContent(oe[se])+te);return re}var ae=[];for(se=0;se<ie.length;se++)ae.push(this.getValueInRange(ie[se],Q?2:0));return 1===ae.length?ae[0]:ae},t.prototype.getHTMLToCopy=function(X,$){if(1===this.model.getLanguageIdentifier().id)return null;if(1!==X.length)return null;var Q=this.coordinatesConverter.convertViewRangeToModelRange(X[0]);if(Q.isEmpty()){if(!$)return null;var J=Q.startLineNumber;Q=new ne.Range(J,this.model.getLineMinColumn(J),J,this.model.getLineMaxColumn(J))}var ee=this.configuration.editor.fontInfo,te=this._getColorMap();return'<div style="color: '+te[1]+";background-color: "+te[2]+";font-family: "+ee.fontFamily+";font-weight: "+ee.fontWeight+";font-size: "+ee.fontSize+"px;line-height: "+ee.lineHeight+'px;white-space: pre;">'+this._getHTMLToCopy(Q,te)+"</div>"},t.prototype._getHTMLToCopy=function(X,$){for(var Q=X.startLineNumber,J=X.startColumn,ee=X.endLineNumber,te=X.endColumn,ne=this.getTabSize(),ie="",re=Q;re<=ee;re++){var se=this.model.getLineTokens(re),ae=se.getLineContent(),le=re===Q?J-1:0,ue=re===ee?te-1:ae.length;ie+=""===ae?"<br>":oe.tokenizeLineToHTML(ae,se.inflate(),$,le,ue,ne)}return ie},t.prototype._getColorMap=function(){var X=ie.TokenizationRegistry.getColorMap(),$=["#000000"];if(X)for(var J=1,ee=X.length;J<ee;J++)$[J]=Q.Color.Format.CSS.formatHex(X[J]);return $},t}(se.ViewEventEmitter);$.ViewModel=he})),define(Q[391],n([0,1,7,73,24,6,2,26,108,361]),(function(X,$,Q,J,ee,te,ne,ie,oe){Object.defineProperty($,"__esModule",{value:!0});var re=function(){function e(X){var $=this;this._disposables=[],this._onClick=new te.Emitter,this.onClick=this._onClick.event,this._futureFixes=new ee.CancellationTokenSource,this._domNode=document.createElement("div"),this._domNode.className="lightbulb-glyph",this._editor=X,this._editor.addContentWidget(this),this._disposables.push(this._editor.onDidChangeModel((function(X){return $._futureFixes.cancel()}))),this._disposables.push(this._editor.onDidChangeModelLanguage((function(X){return $._futureFixes.cancel()}))),this._disposables.push(this._editor.onDidChangeModelContent((function(X){var Q=$._editor.getModel();$.model&&$.model.position&&Q&&!($.model.position.lineNumber>=Q.getLineCount())||$._futureFixes.cancel()}))),this._disposables.push(Q.addStandardDisposableListener(this._domNode,"click",(function(X){$._editor.focus();var J=Q.getDomNodePagePosition($._domNode),ee=J.top,te=J.height,ne=$._editor.getConfiguration().lineHeight,ie=Math.floor(ne/3);$._position&&$._model&&$._model.position&&null!==$._position.position&&$._position.position.lineNumber<$._model.position.lineNumber&&(ie+=ne),$._onClick.fire({x:X.posx,y:ee+te+ie})}))),this._disposables.push(Q.addDisposableListener(this._domNode,"mouseenter",(function(X){if(1==(1&X.buttons)){$.hide();var Q=new J.GlobalMouseMoveMonitor;Q.startMonitoring(J.standardMouseMoveMerger,(function(){}),(function(){Q.dispose()}))}}))),this._disposables.push(this._editor.onDidChangeConfiguration((function(X){X.contribInfo&&!$._editor.getConfiguration().contribInfo.lightbulbEnabled&&$.hide()})))}return e.prototype.dispose=function(){ne.dispose(this._disposables),this._editor.removeContentWidget(this)},e.prototype.getId=function(){return"LightBulbWidget"},e.prototype.getDomNode=function(){return this._domNode},e.prototype.getPosition=function(){return this._position},Object.defineProperty(e.prototype,"model",{get:function(){return this._model},set:function(X){var $=this;!X||this._position&&(!X.position||this._position.position&&this._position.position.lineNumber!==X.position.lineNumber)?this.hide():this._futureFixes&&this._futureFixes.cancel(),this._futureFixes=new ee.CancellationTokenSource;var Q=this._futureFixes.token;if(this._model=X,this._model&&this._model.actions){var J=this._model.rangeOrSelection;this._model.actions.then((function(X){!Q.isCancellationRequested&&X&&X.length>0?!J||J.isEmpty()&&X.every((function(X){return!(!X.kind||!oe.CodeActionKind.Refactor.contains(X.kind))}))?$.hide():$._show():$.hide()})).catch((function(){$.hide()}))}},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"title",{get:function(){return this._domNode.title},set:function(X){this._domNode.title=X},enumerable:!0,configurable:!0}),e.prototype._show=function(){var X=this,$=this._editor.getConfiguration();if($.contribInfo.lightbulbEnabled&&this._model&&this._model.position){var Q=this._model.position,J=Q.lineNumber,ee=Q.column,te=this._editor.getModel();if(te){var ne=te.getOptions().tabSize,oe=te.getLineContent(J),re=ie.TextModel.computeIndentLevel(oe,ne),c=function($){return $>2&&X._editor.getTopForLineNumber($)===X._editor.getTopForLineNumber($-1)},se=J;if(!($.fontInfo.spaceWidth*re>22))if(J>1&&!c(J-1))se-=1;else if(c(J+1)){if(ee*$.fontInfo.spaceWidth<22)return void this.hide()}else se+=1;this._position={position:{lineNumber:se,column:1},preference:e._posPref},this._editor.layoutContentWidget(this)}}},e.prototype.hide=function(){this._position=null,this._model=null,this._futureFixes.cancel(),this._editor.layoutContentWidget(this)},e._posPref=[0],e}();$.LightBulbWidget=re})),define(Q[392],n([0,1,26]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(){function e(X){this.editor=X,this.autoHideFoldingControls=!0}return e.prototype.getDecorationOption=function(X){return X?e.COLLAPSED_VISUAL_DECORATION:this.autoHideFoldingControls?e.EXPANDED_AUTO_HIDE_VISUAL_DECORATION:e.EXPANDED_VISUAL_DECORATION},e.prototype.deltaDecorations=function(X,$){return this.editor.deltaDecorations(X,$)},e.prototype.changeDecorations=function(X){return this.editor.changeDecorations(X)},e.COLLAPSED_VISUAL_DECORATION=Q.ModelDecorationOptions.register({stickiness:1,afterContentClassName:"inline-folded",linesDecorationsClassName:"folding collapsed"}),e.EXPANDED_AUTO_HIDE_VISUAL_DECORATION=Q.ModelDecorationOptions.register({stickiness:1,linesDecorationsClassName:"folding"}),e.EXPANDED_VISUAL_DECORATION=Q.ModelDecorationOptions.register({stickiness:1,linesDecorationsClassName:"folding alwaysShowFoldIcons"}),e}();$.FoldingDecorationProvider=J})),define(Q[393],n([0,1,109,26,39]),(function(X,$,Q,J,ee){function r(X,$,Q,ee){void 0===ee&&(ee=te);var ne=X.getOptions().tabSize,oe=new ie(ee),re=void 0;Q&&(re=new RegExp("("+Q.start.source+")|(?:"+Q.end.source+")"));var se=[];se.push({indent:-1,line:X.getLineCount()+1,marker:!1});for(var ae=X.getLineCount();ae>0;ae--){var le=X.getLineContent(ae),ue=J.TextModel.computeIndentLevel(le,ne),de=se[se.length-1];if(-1!==ue){var ce=void 0;if(re&&(ce=le.match(re))){if(!ce[1]){se.push({indent:-2,line:ae,marker:!0});continue}for(var he=se.length-1;he>0&&!se[he].marker;)he--;if(he>0){se.length=he+1,de=se[he],oe.insertFirst(ae,de.line,ue),de.marker=!1,de.indent=ue,de.line=ae;continue}}if(de.indent>ue){do{se.pop(),de=se[se.length-1]}while(de.indent>ue);var pe=de.line-1;pe-ae>=1&&oe.insertFirst(ae,pe,ue)}de.indent===ue?de.line=ae:se.push({indent:ue,line:ae,marker:!1})}else $&&!de.marker&&(de.line=ae)}return oe.toIndentRanges(X)}Object.defineProperty($,"__esModule",{value:!0});var te=5e3;$.ID_INDENT_PROVIDER="indent";var ne=function(){function e(X){this.editorModel=X,this.id=$.ID_INDENT_PROVIDER}return e.prototype.dispose=function(){},e.prototype.compute=function(X){var $=ee.LanguageConfigurationRegistry.getFoldingRules(this.editorModel.getLanguageIdentifier().id),Q=$&&!!$.offSide,J=$&&$.markers;return Promise.resolve(r(this.editorModel,Q,J))},e}();$.IndentRangeProvider=ne;var ie=function(){function e(X){this._startIndexes=[],this._endIndexes=[],this._indentOccurrences=[],this._length=0,this._foldingRangesLimit=X}return e.prototype.insertFirst=function(X,$,J){if(!(X>Q.MAX_LINE_NUMBER||$>Q.MAX_LINE_NUMBER)){var ee=this._length;this._startIndexes[ee]=X,this._endIndexes[ee]=$,this._length++,J<1e3&&(this._indentOccurrences[J]=(this._indentOccurrences[J]||0)+1)}},e.prototype.toIndentRanges=function(X){if(this._length<=this._foldingRangesLimit){for(var $=new Uint32Array(this._length),ee=new Uint32Array(this._length),te=this._length-1,ne=0;te>=0;te--,ne++)$[ne]=this._startIndexes[te],ee[ne]=this._endIndexes[te];return new Q.FoldingRegions($,ee)}var ie=0,oe=this._indentOccurrences.length;for(te=0;te<this._indentOccurrences.length;te++){var re=this._indentOccurrences[te];if(re){if(re+ie>this._foldingRangesLimit){oe=te;break}ie+=re}}var se=X.getOptions().tabSize;for($=new Uint32Array(this._foldingRangesLimit),ee=new Uint32Array(this._foldingRangesLimit),te=this._length-1,ne=0;te>=0;te--){var ae=this._startIndexes[te],le=X.getLineContent(ae),ue=J.TextModel.computeIndentLevel(le,se);(ue<oe||ue===oe&&ie++<this._foldingRangesLimit)&&($[ne]=ae,ee[ne]=this._endIndexes[te],ne++)}return new Q.FoldingRegions($,ee)},e}();$.RangesCollector=ie,$.computeRanges=r})),define(Q[394],n([0,1,8,178,3,21,74,39,255]),(function(X,$,Q,J,ee,te,ne,ie,oe){Object.defineProperty($,"__esModule",{value:!0});var re=function(){function e(X,$,Q){this._selection=X,this._isMovingDown=$,this._autoIndent=Q,this._moveEndLineSelectionShrink=!1}return e.prototype.getEditOperations=function(X,$){var J=X.getLineCount();if((!this._isMovingDown||this._selection.endLineNumber!==J)&&(this._isMovingDown||1!==this._selection.startLineNumber)){this._moveEndPositionDown=!1;var ne=this._selection;ne.startLineNumber<ne.endLineNumber&&1===ne.endColumn&&(this._moveEndPositionDown=!0,ne=ne.setEndPosition(ne.endLineNumber-1,X.getLineMaxColumn(ne.endLineNumber-1)));var re=X.getOptions().tabSize,se=X.getOptions().insertSpaces,ae=this.buildIndentConverter(re),le={getLineTokens:function($){return X.getLineTokens($)},getLanguageIdentifier:function(){return X.getLanguageIdentifier()},getLanguageIdAtPosition:function($,Q){return X.getLanguageIdAtPosition($,Q)},getLineContent:null};if(ne.startLineNumber===ne.endLineNumber&&1===X.getLineMaxColumn(ne.startLineNumber)){var ue=ne.startLineNumber,de=this._isMovingDown?ue+1:ue-1;1===X.getLineMaxColumn(de)?$.addEditOperation(new ee.Range(1,1,1,1),null):($.addEditOperation(new ee.Range(ue,1,ue,1),X.getLineContent(de)),$.addEditOperation(new ee.Range(de,1,de,X.getLineMaxColumn(de)),null)),ne=new te.Selection(de,1,de,1)}else{var ce,he=void 0;if(this._isMovingDown){ce=ne.endLineNumber+1,he=X.getLineContent(ce),$.addEditOperation(new ee.Range(ce-1,X.getLineMaxColumn(ce-1),ce,X.getLineMaxColumn(ce)),null);var pe=he;if(this.shouldAutoIndent(X,ne)){var fe=this.matchEnterRule(X,ae,re,ce,ne.startLineNumber-1);if(null!==fe){var ge=Q.getLeadingWhitespace(X.getLineContent(ce)),me=fe+oe.getSpaceCnt(ge,re),ve=oe.generateIndent(me,re,se);pe=ve+this.trimLeft(he)}else{le.getLineContent=function($){return $===ne.startLineNumber?X.getLineContent(ce):X.getLineContent($)};var _e=ie.LanguageConfigurationRegistry.getGoodIndentForLine(le,X.getLanguageIdAtPosition(ce,1),ne.startLineNumber,ae);null!==_e&&(ge=Q.getLeadingWhitespace(X.getLineContent(ce)),(me=oe.getSpaceCnt(_e,re))!==(Se=oe.getSpaceCnt(ge,re))&&(ve=oe.generateIndent(me,re,se),pe=ve+this.trimLeft(he)))}if($.addEditOperation(new ee.Range(ne.startLineNumber,1,ne.startLineNumber,1),pe+"\n"),null!==(be=this.matchEnterRule(X,ae,re,ne.startLineNumber,ne.startLineNumber,pe)))0!==be&&this.getIndentEditsOfMovingBlock(X,$,ne,re,se,be);else{le.getLineContent=function($){return $===ne.startLineNumber?pe:$>=ne.startLineNumber+1&&$<=ne.endLineNumber+1?X.getLineContent($-1):X.getLineContent($)};var ye=ie.LanguageConfigurationRegistry.getGoodIndentForLine(le,X.getLanguageIdAtPosition(ce,1),ne.startLineNumber+1,ae);null!==ye&&(ge=Q.getLeadingWhitespace(X.getLineContent(ne.startLineNumber)),(me=oe.getSpaceCnt(ye,re))!==(Se=oe.getSpaceCnt(ge,re))&&(Ee=me-Se,this.getIndentEditsOfMovingBlock(X,$,ne,re,se,Ee)))}}else $.addEditOperation(new ee.Range(ne.startLineNumber,1,ne.startLineNumber,1),pe+"\n")}else if(ce=ne.startLineNumber-1,he=X.getLineContent(ce),$.addEditOperation(new ee.Range(ce,1,ce+1,1),null),$.addEditOperation(new ee.Range(ne.endLineNumber,X.getLineMaxColumn(ne.endLineNumber),ne.endLineNumber,X.getLineMaxColumn(ne.endLineNumber)),"\n"+he),this.shouldAutoIndent(X,ne)){le.getLineContent=function($){return $===ce?X.getLineContent(ne.startLineNumber):X.getLineContent($)};var be=this.matchEnterRule(X,ae,re,ne.startLineNumber,ne.startLineNumber-2);if(null!==be)0!==be&&this.getIndentEditsOfMovingBlock(X,$,ne,re,se,be);else{var Ce=ie.LanguageConfigurationRegistry.getGoodIndentForLine(le,X.getLanguageIdAtPosition(ne.startLineNumber,1),ce,ae);if(null!==Ce){var we=Q.getLeadingWhitespace(X.getLineContent(ne.startLineNumber)),Se=(me=oe.getSpaceCnt(Ce,re),oe.getSpaceCnt(we,re));if(me!==Se){var Ee=me-Se;this.getIndentEditsOfMovingBlock(X,$,ne,re,se,Ee)}}}}}this._selectionId=$.trackSelection(ne)}},e.prototype.buildIndentConverter=function(X){return{shiftIndent:function($){for(var Q=J.ShiftCommand.shiftIndentCount($,$.length+1,X),ee="",te=0;te<Q;te++)ee+="\t";return ee},unshiftIndent:function($){for(var Q=J.ShiftCommand.unshiftIndentCount($,$.length+1,X),ee="",te=0;te<Q;te++)ee+="\t";return ee}}},e.prototype.matchEnterRule=function(X,$,J,te,re,se){for(var ae=re;ae>=1;){var le;if(le=ae===re&&void 0!==se?se:X.getLineContent(ae),Q.lastNonWhitespaceIndex(le)>=0)break;ae--}if(ae<1||te>X.getLineCount())return null;var ue=X.getLineMaxColumn(ae),de=ie.LanguageConfigurationRegistry.getEnterAction(X,new ee.Range(ae,ue,ae,ue));if(de){var ce=de.indentation,he=de.enterAction;he.indentAction===ne.IndentAction.None||he.indentAction===ne.IndentAction.Indent?ce=de.indentation+he.appendText:he.indentAction===ne.IndentAction.IndentOutdent?ce=de.indentation:he.indentAction===ne.IndentAction.Outdent&&(ce=$.unshiftIndent(de.indentation)+he.appendText);var pe=X.getLineContent(te);if(this.trimLeft(pe).indexOf(this.trimLeft(ce))>=0){var fe=Q.getLeadingWhitespace(X.getLineContent(te)),ge=Q.getLeadingWhitespace(ce),me=ie.LanguageConfigurationRegistry.getIndentMetadata(X,te);return null!==me&&2&me&&(ge=$.unshiftIndent(ge)),oe.getSpaceCnt(ge,J)-oe.getSpaceCnt(fe,J)}}return null},e.prototype.trimLeft=function(X){return X.replace(/^\s+/,"")},e.prototype.shouldAutoIndent=function(X,$){if(!this._autoIndent)return!1;if(!X.isCheapToTokenize($.startLineNumber))return!1;var Q=X.getLanguageIdAtPosition($.startLineNumber,1);return Q===X.getLanguageIdAtPosition($.endLineNumber,1)&&null!==ie.LanguageConfigurationRegistry.getIndentRulesSupport(Q)},e.prototype.getIndentEditsOfMovingBlock=function(X,$,J,te,ne,ie){for(var re=J.startLineNumber;re<=J.endLineNumber;re++){var se=X.getLineContent(re),ae=Q.getLeadingWhitespace(se),le=oe.getSpaceCnt(ae,te)+ie,ue=oe.generateIndent(le,te,ne);ue!==ae&&($.addEditOperation(new ee.Range(re,1,re,ae.length+1),ue),re===J.endLineNumber&&J.endColumn<=ae.length+1&&""===ue&&(this._moveEndLineSelectionShrink=!0))}},e.prototype.computeCursorState=function(X,$){var Q=$.getTrackedSelection(this._selectionId);return this._moveEndPositionDown&&(Q=Q.setEndPosition(Q.endLineNumber+1,1)),this._moveEndLineSelectionShrink&&Q.startLineNumber<Q.endLineNumber&&(Q=Q.setEndPosition(Q.endLineNumber,2)),Q},e}();$.MoveLinesCommand=re})),define(Q[395],n([0,1,3,42,192]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var te=function(){function e(X){this._modelService=X}return e.prototype.getRangesToPositionSync=function(X,$){var Q=this._modelService.getModel(X),J=[];return Q&&this._doGetRangesToPosition(Q,$).forEach((function(X){J.push({type:void 0,range:X})})),J},e.prototype._doGetRangesToPosition=function(X,$){var J,te,ne=ee.build(X);J=ee.find(ne,$);for(var ie=[];J;)te&&Q.Range.equalsRange(te,J.range)||ie.push(J.range),te=J.range,J=J.parent;return ie.reverse()},ne([oe(0,J.IModelService)],e)}();$.TokenSelectionSupport=te})),define(Q[196],n([0,1,7,102,28,110,2,27,3,26,384]),(function(X,$,Q,J,ee,te,ne,ie,oe,re){Object.defineProperty($,"__esModule",{value:!0});var se=new ee.Color(new ee.RGBA(0,122,204)),ae={showArrow:!0,showFrame:!0,className:"",frameColor:se,arrowColor:se,keepEditorSelection:!1},le=function(){function e(X,$,Q,J,ee,te){this.domNode=X,this.afterLineNumber=$,this.afterColumn=Q,this.heightInLines=J,this._onDomNodeTop=ee,this._onComputedHeight=te}return e.prototype.onDomNodeTop=function(X){this._onDomNodeTop(X)},e.prototype.onComputedHeight=function(X){this._onComputedHeight(X)},e}();$.ViewZoneDelegate=le;var ue=function(){function e(X,$){this._id=X,this._domNode=$}return e.prototype.getId=function(){return this._id},e.prototype.getDomNode=function(){return this._domNode},e.prototype.getPosition=function(){return null},e}();$.OverlayWidgetDelegate=ue;var de=function(){function e(X){this._editor=X,this._ruleName=e._IdGenerator.nextId(),this._decorations=[]}return e.prototype.dispose=function(){this.hide(),Q.removeCSSRulesContainingSelector(this._ruleName)},Object.defineProperty(e.prototype,"color",{set:function(X){this._color!==X&&(this._color=X,this._updateStyle())},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"height",{set:function(X){this._height!==X&&(this._height=X,this._updateStyle())},enumerable:!0,configurable:!0}),e.prototype._updateStyle=function(){Q.removeCSSRulesContainingSelector(this._ruleName),Q.createCSSRule(".monaco-editor "+this._ruleName,"border-style: solid; border-color: transparent; border-bottom-color: "+this._color+"; border-width: "+this._height+"px; bottom: -"+this._height+"px; margin-left: -"+this._height+"px; ")},e.prototype.show=function(X){this._decorations=this._editor.deltaDecorations(this._decorations,[{range:oe.Range.fromPositions(X),options:{className:this._ruleName,stickiness:1}}])},e.prototype.hide=function(){this._editor.deltaDecorations(this._decorations,[])},e._IdGenerator=new te.IdGenerator(".arrow-decoration-"),e}(),ce=function(){function e(X,$){void 0===$&&($={});var Q=this;this._positionMarkerId=[],this._disposables=[],this._isShowing=!1,this.editor=X,this.options=ie.deepClone($),ie.mixin(this.options,ae,!1),this.domNode=document.createElement("div"),this.options.isAccessible||(this.domNode.setAttribute("aria-hidden","true"),this.domNode.setAttribute("role","presentation")),this._disposables.push(this.editor.onDidLayoutChange((function(X){var $=Q._getWidth(X);Q.domNode.style.width=$+"px",Q.domNode.style.left=Q._getLeft(X)+"px",Q._onWidth($)})))}return e.prototype.dispose=function(){var X=this;ne.dispose(this._disposables),this._overlayWidget&&(this.editor.removeOverlayWidget(this._overlayWidget),this._overlayWidget=null),this._viewZone&&this.editor.changeViewZones((function($){X._viewZone&&$.removeZone(X._viewZone.id),X._viewZone=null})),this.editor.deltaDecorations(this._positionMarkerId,[]),this._positionMarkerId=[]},e.prototype.create=function(){Q.addClass(this.domNode,"zone-widget"),this.options.className&&Q.addClass(this.domNode,this.options.className),this.container=document.createElement("div"),Q.addClass(this.container,"zone-widget-container"),this.domNode.appendChild(this.container),this.options.showArrow&&(this._arrow=new de(this.editor),this._disposables.push(this._arrow)),this._fillContainer(this.container),this._initSash(),this._applyStyles()},e.prototype.style=function(X){X.frameColor&&(this.options.frameColor=X.frameColor),X.arrowColor&&(this.options.arrowColor=X.arrowColor),this._applyStyles()},e.prototype._applyStyles=function(){if(this.container&&this.options.frameColor){var X=this.options.frameColor.toString();this.container.style.borderTopColor=X,this.container.style.borderBottomColor=X}if(this._arrow&&this.options.arrowColor){var $=this.options.arrowColor.toString();this._arrow.color=$}},e.prototype._getWidth=function(X){return X.width-X.minimapWidth-X.verticalScrollbarWidth},e.prototype._getLeft=function(X){return X.minimapWidth>0&&0===X.minimapLeft?X.minimapWidth:0},e.prototype._onViewZoneTop=function(X){this.domNode.style.top=X+"px"},e.prototype._onViewZoneHeight=function(X){this.domNode.style.height=X+"px";var $=X-this._decoratingElementsHeight();this.container.style.height=$+"px";var Q=this.editor.getLayoutInfo();this._doLayout($,this._getWidth(Q)),this._resizeSash.layout()},Object.defineProperty(e.prototype,"position",{get:function(){var X=this._positionMarkerId[0];if(X){var $=this.editor.getModel();if($){var Q=$.getDecorationRange(X);if(Q)return Q.getStartPosition()}}},enumerable:!0,configurable:!0}),e.prototype.show=function(X,$){var Q=oe.Range.isIRange(X)?X:new oe.Range(X.lineNumber,X.column,X.lineNumber,X.column);this._isShowing=!0,this._showImpl(Q,$),this._isShowing=!1,this._positionMarkerId=this.editor.deltaDecorations(this._positionMarkerId,[{range:Q,options:re.ModelDecorationOptions.EMPTY}])},e.prototype.hide=function(){var X=this;this._viewZone&&(this.editor.changeViewZones((function($){X._viewZone&&$.removeZone(X._viewZone.id)})),this._viewZone=null),this._overlayWidget&&(this.editor.removeOverlayWidget(this._overlayWidget),this._overlayWidget=null),this._arrow&&this._arrow.hide()},e.prototype._decoratingElementsHeight=function(){var X=this.editor.getConfiguration().lineHeight,$=0;return this.options.showArrow&&($+=2*Math.round(X/3)),this.options.showFrame&&($+=2*Math.round(X/9)),$},e.prototype._showImpl=function(X,$){var Q=this,J={lineNumber:X.startLineNumber,column:X.startColumn},ee=this.editor.getLayoutInfo(),te=this._getWidth(ee);this.domNode.style.width=te+"px",this.domNode.style.left=this._getLeft(ee)+"px";var ne=document.createElement("div");ne.style.overflow="hidden";var ie=this.editor.getConfiguration().lineHeight,oe=this.editor.getLayoutInfo().height/ie*.8;$>=oe&&($=oe);var re=0,se=0;if(this.options.showArrow&&(re=Math.round(ie/3),this._arrow.height=re,this._arrow.show(J)),this.options.showFrame&&(se=Math.round(ie/9)),this.editor.changeViewZones((function(X){Q._viewZone&&X.removeZone(Q._viewZone.id),Q._overlayWidget&&(Q.editor.removeOverlayWidget(Q._overlayWidget),Q._overlayWidget=null),Q.domNode.style.top="-1000px",Q._viewZone=new le(ne,J.lineNumber,J.column,$,(function(X){return Q._onViewZoneTop(X)}),(function(X){return Q._onViewZoneHeight(X)})),Q._viewZone.id=X.addZone(Q._viewZone),Q._overlayWidget=new ue("vs.editor.contrib.zoneWidget"+Q._viewZone.id,Q.domNode),Q.editor.addOverlayWidget(Q._overlayWidget)})),this.options.showFrame){var ae=this.options.frameWidth?this.options.frameWidth:se;this.container.style.borderTopWidth=ae+"px",this.container.style.borderBottomWidth=ae+"px"}var de=$*ie-this._decoratingElementsHeight();this.container.style.top=re+"px",this.container.style.height=de+"px",this.container.style.overflow="hidden",this._doLayout(de,te),this.options.keepEditorSelection||this.editor.setSelection(X);var ce=this.editor.getModel();if(ce){var he=Math.min(ce.getLineCount(),Math.max(1,X.endLineNumber+1));this.revealLine(he)}},e.prototype.revealLine=function(X){this.editor.revealLine(X,0)},e.prototype.setCssClass=function(X,$){$&&this.container.classList.remove($),Q.addClass(this.container,X)},e.prototype._onWidth=function(X){},e.prototype._doLayout=function(X,$){},e.prototype._relayout=function(X){var $=this;this._viewZone&&this._viewZone.heightInLines!==X&&this.editor.changeViewZones((function(Q){$._viewZone&&($._viewZone.heightInLines=X,Q.layoutZone($._viewZone.id))}))},e.prototype._initSash=function(){var X,$=this;this._resizeSash=new J.Sash(this.domNode,this,{orientation:1}),this.options.isResizeable||(this._resizeSash.hide(),this._resizeSash.state=0),this._disposables.push(this._resizeSash.onDidStart((function(Q){$._viewZone&&(X={startY:Q.startY,heightInLines:$._viewZone.heightInLines})}))),this._disposables.push(this._resizeSash.onDidEnd((function(){X=void 0}))),this._disposables.push(this._resizeSash.onDidChange((function(Q){if(X){var J=(Q.currentY-X.startY)/$.editor.getConfiguration().lineHeight,ee=J<0?Math.ceil(J):Math.floor(J),te=X.heightInLines+ee;te>5&&te<35&&$._relayout(te)}})))},e.prototype.getHorizontalSashLeft=function(){return 0},e.prototype.getHorizontalSashTop=function(){return(null===this.domNode.style.height?0:parseInt(this.domNode.style.height))-this._decoratingElementsHeight()/2},e.prototype.getHorizontalSashWidth=function(){var X=this.editor.getLayoutInfo();return X.width-X.minimapWidth},e}();$.ZoneWidget=ce})),define(Q[397],n([0,1,16,8,93,14,103,59]),(function(X,$,Q,J,ee,te,ne,ie){function l(X,$,Q){return function(X,$,Q){for(var J=[],te=Q.getInitialState(),oe=0,re=X.length;oe<re;oe++){var se=X[oe],ae=Q.tokenize2(se,te,0);ee.LineTokens.convertToEndOffset(ae.tokens,se.length);var le=new ee.LineTokens(ae.tokens,se),ue=ie.ViewLineRenderingData.isBasicASCII(se,!0),de=ie.ViewLineRenderingData.containsRTL(se,ue,!0),ce=ne.renderViewLine2(new ne.RenderLineInput(!1,!0,se,!1,ue,de,0,le.inflate(),[],$,0,-1,"none",!1,!1));(J=J.concat(ce.html)).push("<br/>"),te=ae.endState}return J.join("")}(X,$,Q)}function u(X,$){var Q=[],J=new Uint32Array(2);J[0]=0,J[1]=16793600;for(var te=0,oe=X.length;te<oe;te++){var re=X[te];J[0]=re.length;var se=new ee.LineTokens(J,re),ae=ie.ViewLineRenderingData.isBasicASCII(re,!0),le=ie.ViewLineRenderingData.containsRTL(re,ae,!0),ue=ne.renderViewLine2(new ne.RenderLineInput(!1,!0,re,!1,ae,le,0,se,[],$,0,-1,"none",!1,!1));(Q=Q.concat(ue.html)).push("<br/>")}return Q.join("")}Object.defineProperty($,"__esModule",{value:!0});var oe=function(){function e(){}return e.colorizeElement=function(X,$,Q,J){var ee=(J=J||{}).theme||"vs",te=J.mimeType||Q.getAttribute("lang")||Q.getAttribute("data-lang");if(!te)return console.error("Mode not detected"),Promise.resolve();X.setTheme(ee);var ne=Q.firstChild?Q.firstChild.nodeValue:"";return Q.className+=" "+ee,this.colorize($,ne||"",te,J).then((function(X){Q.innerHTML=X}),(function(X){return console.error(X)}))},e.colorize=function(X,$,ee,ne){var ie=4;ne&&"number"==typeof ne.tabSize&&(ie=ne.tabSize),J.startsWithUTF8BOM($)&&($=$.substr(1));var oe=$.split(/\r\n|\r|\n/),re=X.getModeId(ee);if(!re)return Promise.resolve(u(oe,ie));X.triggerMode(re);var se=te.TokenizationRegistry.get(re);return se?Promise.resolve(l(oe,ie,se)):new Promise((function(X,$){var J=null,ee=null,s=function(){J&&(J.dispose(),J=null),ee&&(ee.dispose(),ee=null);var $=te.TokenizationRegistry.get(re);return X($?l(oe,ie,$):u(oe,ie))};(ee=new Q.TimeoutTimer).cancelAndSet(s,500),J=te.TokenizationRegistry.onDidChange((function(X){X.changedLanguages.indexOf(re)>=0&&s()}))}))},e.colorizeLine=function(X,$,Q,J,ee){void 0===ee&&(ee=4);var te=ie.ViewLineRenderingData.isBasicASCII(X,$),oe=ie.ViewLineRenderingData.containsRTL(X,te,Q);return ne.renderViewLine2(new ne.RenderLineInput(!1,!0,X,!1,te,oe,0,J,[],ee,0,-1,"none",!1,!1)).html},e.colorizeModelLine=function(X,$,Q){void 0===Q&&(Q=4);var J=X.getLineContent($);X.forceTokenization($);var ee=X.getLineTokens($).inflate();return this.colorizeLine(J,X.mightContainNonBasicASCII(),X.mightContainRTL(),ee,Q)},e}();$.Colorizer=oe})),define(Q[398],n([0,1,91,14,51,198]),(function(X,$,Q,J,ee,te){Object.defineProperty($,"__esModule",{value:!0});var ne=function(){function e(X){this._maxCacheDepth=X,this._entries=Object.create(null)}return e.create=function(X,$){return this._INSTANCE.create(X,$)},e.prototype.create=function(X,$){if(null!==X&&X.depth>=this._maxCacheDepth)return new ie(X,$);var Q=ie.getStackElementId(X);Q.length>0&&(Q+="|"),Q+=$;var J=this._entries[Q];return J||(J=new ie(X,$),this._entries[Q]=J,J)},e._INSTANCE=new e(5),e}(),ie=function(){function e(X,$){this.parent=X,this.state=$,this.depth=(this.parent?this.parent.depth:0)+1}return e.getStackElementId=function(X){for(var $="";null!==X;)$.length>0&&($+="|"),$+=X.state,X=X.parent;return $},e._equals=function(X,$){for(;null!==X&&null!==$;){if(X===$)return!0;if(X.state!==$.state)return!1;X=X.parent,$=$.parent}return null===X&&null===$},e.prototype.equals=function(X){return e._equals(this,X)},e.prototype.push=function(X){return ne.create(this,X)},e.prototype.pop=function(){return this.parent},e.prototype.popall=function(){for(var X=this;X.parent;)X=X.parent;return X},e.prototype.switchTo=function(X){return ne.create(this.parent,X)},e}(),oe=function(){function e(X,$){this.modeId=X,this.state=$}return e.prototype.equals=function(X){return this.modeId===X.modeId&&this.state.equals(X.state)},e.prototype.clone=function(){return this.state.clone()===this.state?this:new e(this.modeId,this.state)},e}(),re=function(){function e(X){this._maxCacheDepth=X,this._entries=Object.create(null)}return e.create=function(X,$){return this._INSTANCE.create(X,$)},e.prototype.create=function(X,$){if(null!==$)return new se(X,$);if(null!==X&&X.depth>=this._maxCacheDepth)return new se(X,$);var Q=ie.getStackElementId(X),J=this._entries[Q];return J||(J=new se(X,null),this._entries[Q]=J,J)},e._INSTANCE=new e(5),e}(),se=function(){function e(X,$){this.stack=X,this.embeddedModeData=$}return e.prototype.clone=function(){return(this.embeddedModeData?this.embeddedModeData.clone():null)===this.embeddedModeData?this:re.create(this.stack,this.embeddedModeData)},e.prototype.equals=function(X){return X instanceof e&&!!this.stack.equals(X.stack)&&(null===this.embeddedModeData&&null===X.embeddedModeData||null!==this.embeddedModeData&&null!==X.embeddedModeData&&this.embeddedModeData.equals(X.embeddedModeData))},e}(),ae=Object.hasOwnProperty,le=function(){function e(){this._tokens=[],this._language=null,this._lastTokenType=null,this._lastTokenLanguage=null}return e.prototype.enterMode=function(X,$){this._language=$},e.prototype.emit=function(X,$){this._lastTokenType===$&&this._lastTokenLanguage===this._language||(this._lastTokenType=$,this._lastTokenLanguage=this._language,this._tokens.push(new Q.Token(X,$,this._language)))},e.prototype.nestedModeTokenize=function(X,$,Q){var ee=$.modeId,te=$.state,ne=J.TokenizationRegistry.get(ee);if(!ne)return this.enterMode(Q,ee),this.emit(Q,""),te;var ie=ne.tokenize(X,te,Q);return this._tokens=this._tokens.concat(ie.tokens),this._lastTokenType=null,this._lastTokenLanguage=null,this._language=null,ie.endState},e.prototype.finalize=function(X){return new Q.TokenizationResult(this._tokens,X)},e}(),ue=function(){function e(X,$){this._modeService=X,this._theme=$,this._prependTokens=null,this._tokens=[],this._currentLanguageId=0,this._lastTokenMetadata=0}return e.prototype.enterMode=function(X,$){this._currentLanguageId=this._modeService.getLanguageIdentifier($).id},e.prototype.emit=function(X,$){var Q=this._theme.match(this._currentLanguageId,$);this._lastTokenMetadata!==Q&&(this._lastTokenMetadata=Q,this._tokens.push(X),this._tokens.push(Q))},e._merge=function(X,$,Q){var J=null!==X?X.length:0,ee=$.length,te=null!==Q?Q.length:0;if(0===J&&0===ee&&0===te)return new Uint32Array(0);if(0===J&&0===ee)return Q;if(0===ee&&0===te)return X;var ne=new Uint32Array(J+ee+te);null!==X&&ne.set(X);for(var ie=0;ie<ee;ie++)ne[J+ie]=$[ie];return null!==Q&&ne.set(Q,J+ee),ne},e.prototype.nestedModeTokenize=function(X,$,Q){var ee=$.modeId,te=$.state,ne=J.TokenizationRegistry.get(ee);if(!ne)return this.enterMode(Q,ee),this.emit(Q,""),te;var ie=ne.tokenize2(X,te,Q);return this._prependTokens=e._merge(this._prependTokens,this._tokens,ie.tokens),this._tokens=[],this._currentLanguageId=0,this._lastTokenMetadata=0,ie.endState},e.prototype.finalize=function(X){return new Q.TokenizationResult2(e._merge(this._prependTokens,this._tokens,null),X)},e}(),de=function(){function e(X,$,Q,ee){var te=this;this._modeService=X,this._standaloneThemeService=$,this._modeId=Q,this._lexer=ee,this._embeddedModes=Object.create(null);var ne=!1;this._tokenizationRegistryListener=J.TokenizationRegistry.onDidChange((function(X){if(!ne){for(var $=!1,Q=0,ee=X.changedLanguages.length;Q<ee;Q++){var ie=X.changedLanguages[Q];if(te._embeddedModes[ie]){$=!0;break}}$&&(ne=!0,J.TokenizationRegistry.fire([te._modeId]),ne=!1)}}))}return e.prototype.dispose=function(){this._tokenizationRegistryListener.dispose()},e.prototype.getInitialState=function(){var X=ne.create(null,this._lexer.start);return re.create(X,null)},e.prototype.tokenize=function(X,$,Q){var J=new le,ee=this._tokenize(X,$,Q,J);return J.finalize(ee)},e.prototype.tokenize2=function(X,$,Q){var J=new ue(this._modeService,this._standaloneThemeService.getTheme().tokenTheme),ee=this._tokenize(X,$,Q,J);return J.finalize(ee)},e.prototype._tokenize=function(X,$,Q,J){return $.embeddedModeData?this._nestedTokenize(X,$,Q,J):this._myTokenize(X,$,Q,J)},e.prototype._findLeavingNestedModeOffset=function(X,$){var Q=this._lexer.tokenizer[$.stack.state];if(!Q&&!(Q=te.findRules(this._lexer,$.stack.state)))throw te.createError(this._lexer,"tokenizer state is not defined: "+$.stack.state);var J=-1,ee=!1;for(var ne in Q)if(ae.call(Q,ne)){var ie=Q[ne];if(te.isIAction(ie.action)&&"@pop"===ie.action.nextEmbedded){ee=!0;var oe=ie.regex,re=ie.regex.source;"^(?:"===re.substr(0,4)&&")"===re.substr(re.length-1,1)&&(oe=new RegExp(re.substr(4,re.length-5),oe.ignoreCase?"i":""));var se=X.search(oe);-1!==se&&(-1===J||se<J)&&(J=se)}}if(!ee)throw te.createError(this._lexer,'no rule containing nextEmbedded: "@pop" in tokenizer embedded state: '+$.stack.state);return J},e.prototype._nestedTokenize=function(X,$,Q,J){var ee=this._findLeavingNestedModeOffset(X,$);if(-1===ee){var te=J.nestedModeTokenize(X,$.embeddedModeData,Q);return re.create($.stack,new oe($.embeddedModeData.modeId,te))}var ne=X.substring(0,ee);ne.length>0&&J.nestedModeTokenize(ne,$.embeddedModeData,Q);var ie=X.substring(ee);return this._myTokenize(ie,$,Q+ee,J)},e.prototype._myTokenize=function(X,$,Q,J){J.enterMode(Q,this._modeId);for(var ee=X.length,ne=$.embeddedModeData,ie=$.stack,oe=0,se=null;oe<ee;){var le=oe,ue=ie.depth,de=se?se.groups.length:0,ce=ie.state,he=null,pe=null,fe=null,ge=null,me=null;if(se){he=se.matches;var ve=se.groups.shift();pe=ve.matched,fe=ve.action,ge=se.rule,0===se.groups.length&&(se=null)}else{if(oe>=ee)break;var _e=this._lexer.tokenizer[ce];if(!_e&&!(_e=te.findRules(this._lexer,ce)))throw te.createError(this._lexer,"tokenizer state is not defined: "+ce);for(var ye in ke=X.substr(oe),_e)if(ae.call(_e,ye)){var be=_e[ye];if((0===oe||!be.matchOnlyAtLineStart)&&(he=ke.match(be.regex))){pe=he[0],fe=be.action;break}}}for(he||(he=[""],pe=""),fe||(oe<ee&&(pe=(he=[X.charAt(oe)])[0]),fe=this._lexer.defaultToken),oe+=pe.length;te.isFuzzyAction(fe)&&te.isIAction(fe)&&fe.test;)fe=fe.test(pe,he,ce,oe===ee);var Ce=null;if("string"==typeof fe||Array.isArray(fe))Ce=fe;else if(fe.group)Ce=fe.group;else if(null!==fe.token&&void 0!==fe.token){if(Ce=fe.tokenSubst?te.substituteMatches(this._lexer,fe.token,pe,he,ce):fe.token,fe.nextEmbedded)if("@pop"===fe.nextEmbedded){if(!ne)throw te.createError(this._lexer,"cannot pop embedded mode if not inside one");ne=null}else{if(ne)throw te.createError(this._lexer,"cannot enter embedded mode from within an embedded mode");me=te.substituteMatches(this._lexer,fe.nextEmbedded,pe,he,ce)}if(fe.goBack&&(oe=Math.max(0,oe-fe.goBack)),fe.switchTo&&"string"==typeof fe.switchTo){if("@"===(we=te.substituteMatches(this._lexer,fe.switchTo,pe,he,ce))[0]&&(we=we.substr(1)),!te.findRules(this._lexer,we))throw te.createError(this._lexer,"trying to switch to a state '"+we+"' that is undefined in rule: "+ge.name);ie=ie.switchTo(we)}else{if(fe.transform&&"function"==typeof fe.transform)throw te.createError(this._lexer,"action.transform not supported");if(fe.next)if("@push"===fe.next){if(ie.depth>=this._lexer.maxStack)throw te.createError(this._lexer,"maximum tokenizer stack size reached: ["+ie.state+","+ie.parent.state+",...]");ie=ie.push(ce)}else if("@pop"===fe.next){if(ie.depth<=1)throw te.createError(this._lexer,"trying to pop an empty stack in rule: "+ge.name);ie=ie.pop()}else if("@popall"===fe.next)ie=ie.popall();else{var we=te.substituteMatches(this._lexer,fe.next,pe,he,ce);if("@"===we[0]&&(we=we.substr(1)),!te.findRules(this._lexer,we))throw te.createError(this._lexer,"trying to set a next state '"+we+"' that is undefined in rule: "+ge.name);ie=ie.push(we)}}fe.log&&"string"==typeof fe.log&&te.log(this._lexer,this._lexer.languageId+": "+te.substituteMatches(this._lexer,fe.log,pe,he,ce))}if(null===Ce)throw te.createError(this._lexer,"lexer rule has no well-defined action in rule: "+ge.name);if(Array.isArray(Ce)){if(se&&se.groups.length>0)throw te.createError(this._lexer,"groups cannot be nested: "+ge.name);if(he.length!==Ce.length+1)throw te.createError(this._lexer,"matched number of groups does not match the number of actions in rule: "+ge.name);for(var Se=0,Ee=1;Ee<he.length;Ee++)Se+=he[Ee].length;if(Se!==pe.length)throw te.createError(this._lexer,"with groups, all characters should be matched in consecutive groups in rule: "+ge.name);for(se={rule:ge,matches:he,groups:[]},Ee=0;Ee<Ce.length;Ee++)se.groups[Ee]={action:Ce[Ee],matched:he[Ee+1]};oe-=pe.length}else{if("@rematch"===Ce&&(oe-=pe.length,pe="",he=null,Ce=""),0===pe.length){if(ue!==ie.depth||ce!==ie.state||(se?se.groups.length:0)!==de)continue;throw te.createError(this._lexer,"no progress in tokenizer in rule: "+ge.name)}var Le=null;if(te.isString(Ce)&&0===Ce.indexOf("@brackets")){var xe=Ce.substr("@brackets".length),Ie=function(X,$){if(!$)return null;$=te.fixCase(X,$);for(var Q=X.brackets,J=0;J<Q.length;J++){var ee=Q[J];if(ee.open===$)return{token:ee.token,bracketType:1};if(ee.close===$)return{token:ee.token,bracketType:-1}}return null}(this._lexer,pe);if(!Ie)throw te.createError(this._lexer,"@brackets token returned but no bracket defined as: "+pe);Le=te.sanitize(Ie.token+xe)}else{var De=""===Ce?"":Ce+this._lexer.tokenPostfix;Le=te.sanitize(De)}if(J.emit(le+Q,Le),null!==me){var Ne=this._modeService.getModeIdForLanguageName(me);Ne&&(me=Ne);var Me=this._getNestedEmbeddedModeData(me);if(oe<ee){var ke=X.substr(oe);return this._nestedTokenize(ke,re.create(ie,Me),Q+oe,J)}return re.create(ie,Me)}}}return re.create(ie,ne)},e.prototype._getNestedEmbeddedModeData=function(X){var $=this._locateMode(X);if($){var Q=J.TokenizationRegistry.get($);if(Q)return new oe($,Q.getInitialState())}return new oe($||ee.NULL_MODE_ID,ee.NULL_STATE)},e.prototype._locateMode=function(X){if(!X||!this._modeService.isRegisteredMode(X))return null;var $=this._modeService.getModeId(X);return $&&(this._modeService.triggerMode($),this._embeddedModes[$]=!0),$},e}();$.createTokenizationSupport=function(X,$,Q,J){return new de(X,$,Q,J)}})),define(Q[78],n([0,1,15]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),$.IStandaloneThemeService=Q.createDecorator("themeService")})),define(Q[202],n([0,1,15]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),$.IClipboardService=Q.createDecorator("clipboardService")})),define(Q[31],n([0,1,2,32,15,160]),(function(X,$,Q,J,ee,te){Object.defineProperty($,"__esModule",{value:!0}),$.ICommandService=ee.createDecorator("commandService"),$.CommandsRegistry=new(function(){function e(){this._commands=new Map}return e.prototype.registerCommand=function(X,$){var ee=this;if(!X)throw new Error("invalid command");if("string"==typeof X){if(!$)throw new Error("invalid command");return this.registerCommand({id:X,handler:$})}if(X.description){for(var ne=[],ie=0,oe=X.description.args;ie<oe.length;ie++){var re=oe[ie];ne.push(re.constraint)}var se=X.handler;X.handler=function(X){for(var $=[],Q=1;Q<arguments.length;Q++)$[Q-1]=arguments[Q];return J.validateConstraints($,ne),se.apply(void 0,[X].concat($))}}var ae=X.id,le=this._commands.get(ae);le||(le=new te.LinkedList,this._commands.set(ae,le));var ue=le.unshift(X);return Q.toDisposable((function(){ue(),ee._commands.get(ae).isEmpty()&&ee._commands.delete(ae)}))},e.prototype.registerCommandAlias=function(X,Q){return $.CommandsRegistry.registerCommand(X,(function(X){for(var J=[],ee=1;ee<arguments.length;ee++)J[ee-1]=arguments[ee];var te;(te=X.get($.ICommandService)).executeCommand.apply(te,[Q].concat(J))}))},e.prototype.getCommand=function(X){var $=this._commands.get(X);if($&&!$.isEmpty())return $.iterator().next().value},e.prototype.getCommands=function(){var X=this,$=Object.create(null);return this._commands.forEach((function(Q,J){$[J]=X.getCommand(J)})),$},e}())})),define(Q[402],n([0,1,24,11,25,3,14,42,31]),(function(X,$,Q,J,ee,te,ne,ie,oe){function u(X,$){var Q=[],ee=ne.LinkProviderRegistry.ordered(X).reverse().map((function(ee){return Promise.resolve(ee.provideLinks(X,$)).then((function(X){if(Array.isArray(X)){var $=X.map((function(X){return new re(X,ee)}));Q=function(X,$){var Q,J,ee,ne,ie=[];for(Q=0,ee=0,J=X.length,ne=$.length;Q<J&&ee<ne;){var oe=X[Q],re=$[ee];te.Range.areIntersectingOrTouching(oe.range,re.range)?Q++:te.Range.compareRangesUsingStarts(oe.range,re.range)<0?(ie.push(oe),Q++):(ie.push(re),ee++)}for(;Q<J;Q++)ie.push(X[Q]);for(;ee<ne;ee++)ie.push($[ee]);return ie}(Q,$)}}),J.onUnexpectedExternalError)}));return Promise.all(ee).then((function(){return Q}))}Object.defineProperty($,"__esModule",{value:!0});var re=function(){function e(X,$){this._link=X,this._provider=$}return e.prototype.toJSON=function(){return{range:this.range,url:this.url}},Object.defineProperty(e.prototype,"range",{get:function(){return this._link.range},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"url",{get:function(){return this._link.url},enumerable:!0,configurable:!0}),e.prototype.resolve=function(X){var $=this;if(this._link.url)try{return Promise.resolve(ee.URI.parse(this._link.url))}catch(X){return Promise.reject(new Error("invalid"))}return"function"==typeof this._provider.resolveLink?Promise.resolve(this._provider.resolveLink(this._link,X)).then((function(Q){return $._link=Q||$._link,$._link.url?$.resolve(X):Promise.reject(new Error("missing"))})):Promise.reject(new Error("missing"))},e}();$.Link=re,$.getLinks=u,oe.CommandsRegistry.registerCommand("_executeLinkProvider",(function(X){for(var $=[],J=1;J<arguments.length;J++)$[J-1]=arguments[J];var te=$[0];if(te instanceof ee.URI){var ne=X.get(ie.IModelService).getModel(te);if(ne)return u(ne,Q.CancellationToken.None)}}))})),define(Q[18],n([0,1,8,15]),(function(X,$,Q,J){function r(X,$){var Q=X.getType(),J=$.getType();if(Q!==J)return Q-J;switch(Q){case 1:case 2:case 3:case 4:case 6:return X.cmp($);default:throw new Error("Unknown ContextKeyExpr!")}}Object.defineProperty($,"__esModule",{value:!0});var ee=function(){function e(){}return e.has=function(X){return new ne(X)},e.equals=function(X,$){return new ie(X,$)},e.regex=function(X,$){return new se(X,$)},e.not=function(X){return new re(X)},e.and=function(){for(var X=[],$=0;$<arguments.length;$++)X[$]=arguments[$];return new ae(X)},e.deserialize=function(X){var $=this;if(!X)return null;var Q=X.split("&&");return new ae(Q.map((function(X){return $._deserializeOne(X)}))).normalize()},e._deserializeOne=function(X){if((X=X.trim()).indexOf("!=")>=0)return $=X.split("!="),new oe($[0].trim(),this._deserializeValue($[1]));if(X.indexOf("==")>=0)return $=X.split("=="),new ie($[0].trim(),this._deserializeValue($[1]));if(X.indexOf("=~")>=0){var $=X.split("=~");return new se($[0].trim(),this._deserializeRegexValue($[1]))}return/^\!\s*/.test(X)?new re(X.substr(1).trim()):new ne(X)},e._deserializeValue=function(X){if("true"===(X=X.trim()))return!0;if("false"===X)return!1;var $=/^'([^']*)'$/.exec(X);return $?$[1].trim():X},e._deserializeRegexValue=function(X){if(Q.isFalsyOrWhitespace(X))return console.warn("missing regexp-value for =~-expression"),null;var $=X.indexOf("/"),J=X.lastIndexOf("/");if($===J||$<0)return console.warn("bad regexp-value '"+X+"', missing /-enclosure"),null;var ee=X.slice($+1,J),te="i"===X[J+1]?"i":"";try{return new RegExp(ee,te)}catch($){return console.warn("bad regexp-value '"+X+"', parse error: "+$),null}},e}();$.ContextKeyExpr=ee;var ne=function(){function e(X){this.key=X}return e.prototype.getType=function(){return 1},e.prototype.cmp=function(X){return this.key<X.key?-1:this.key>X.key?1:0},e.prototype.equals=function(X){return X instanceof e&&this.key===X.key},e.prototype.evaluate=function(X){return!!X.getValue(this.key)},e.prototype.normalize=function(){return this},e.prototype.keys=function(){return[this.key]},e}();$.ContextKeyDefinedExpr=ne;var ie=function(){function e(X,$){this.key=X,this.value=$}return e.prototype.getType=function(){return 3},e.prototype.cmp=function(X){return this.key<X.key?-1:this.key>X.key?1:this.value<X.value?-1:this.value>X.value?1:0},e.prototype.equals=function(X){return X instanceof e&&this.key===X.key&&this.value===X.value},e.prototype.evaluate=function(X){return X.getValue(this.key)==this.value},e.prototype.normalize=function(){return"boolean"==typeof this.value?this.value?new ne(this.key):new re(this.key):this},e.prototype.keys=function(){return[this.key]},e}();$.ContextKeyEqualsExpr=ie;var oe=function(){function e(X,$){this.key=X,this.value=$}return e.prototype.getType=function(){return 4},e.prototype.cmp=function(X){return this.key<X.key?-1:this.key>X.key?1:this.value<X.value?-1:this.value>X.value?1:0},e.prototype.equals=function(X){return X instanceof e&&this.key===X.key&&this.value===X.value},e.prototype.evaluate=function(X){return X.getValue(this.key)!=this.value},e.prototype.normalize=function(){return"boolean"==typeof this.value?this.value?new re(this.key):new ne(this.key):this},e.prototype.keys=function(){return[this.key]},e}();$.ContextKeyNotEqualsExpr=oe;var re=function(){function e(X){this.key=X}return e.prototype.getType=function(){return 2},e.prototype.cmp=function(X){return this.key<X.key?-1:this.key>X.key?1:0},e.prototype.equals=function(X){return X instanceof e&&this.key===X.key},e.prototype.evaluate=function(X){return!X.getValue(this.key)},e.prototype.normalize=function(){return this},e.prototype.keys=function(){return[this.key]},e}();$.ContextKeyNotExpr=re;var se=function(){function e(X,$){this.key=X,this.regexp=$}return e.prototype.getType=function(){return 6},e.prototype.cmp=function(X){if(this.key<X.key)return-1;if(this.key>X.key)return 1;var $=this.regexp?this.regexp.source:"",Q=X.regexp?X.regexp.source:"";return $<Q?-1:$>Q?1:0},e.prototype.equals=function(X){if(X instanceof e){var $=this.regexp?this.regexp.source:"",Q=X.regexp?X.regexp.source:"";return this.key===X.key&&$===Q}return!1},e.prototype.evaluate=function(X){var $=X.getValue(this.key);return!!this.regexp&&this.regexp.test($)},e.prototype.normalize=function(){return this},e.prototype.keys=function(){return[this.key]},e}();$.ContextKeyRegexExpr=se;var ae=function(){function e(X){this.expr=e._normalizeArr(X)}return e.prototype.getType=function(){return 5},e.prototype.equals=function(X){if(X instanceof e){if(this.expr.length!==X.expr.length)return!1;for(var $=0,Q=this.expr.length;$<Q;$++)if(!this.expr[$].equals(X.expr[$]))return!1;return!0}return!1},e.prototype.evaluate=function(X){for(var $=0,Q=this.expr.length;$<Q;$++)if(!this.expr[$].evaluate(X))return!1;return!0},e._normalizeArr=function(X){var $=[];if(X){for(var Q=0,J=X.length;Q<J;Q++){var ee=X[Q];ee&&(ee=ee.normalize())&&(ee instanceof e?$=$.concat(ee.expr):$.push(ee))}$.sort(r)}return $},e.prototype.normalize=function(){return 0===this.expr.length?null:1===this.expr.length?this.expr[0]:this},e.prototype.keys=function(){for(var X=[],$=0,Q=this.expr;$<Q.length;$++){var J=Q[$];X.push.apply(X,J.keys())}return X},e}();$.ContextKeyAndExpr=ae;var le=function(X){function t($,Q){var J=X.call(this,$)||this;return J._defaultValue=Q,J}return te(t,X),t.prototype.bindTo=function(X){return X.createKey(this.key,this._defaultValue)},t.prototype.getValue=function(X){return X.getContextKeyValue(this.key)},t.prototype.toNegated=function(){return ee.not(this.key)},t}(ne);$.RawContextKey=le,$.IContextKeyService=J.createDecorator("contextKeyService"),$.SET_CONTEXT_COMMAND_ID="setContext"})),define(Q[19],n([0,1,18]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),function(X){X.editorTextFocus=new Q.RawContextKey("editorTextFocus",!1),X.focus=new Q.RawContextKey("editorFocus",!1),X.textInputFocus=new Q.RawContextKey("textInputFocus",!1),X.readOnly=new Q.RawContextKey("editorReadonly",!1),X.writable=X.readOnly.toNegated(),X.hasNonEmptySelection=new Q.RawContextKey("editorHasSelection",!1),X.hasOnlyEmptySelection=X.hasNonEmptySelection.toNegated(),X.hasMultipleSelections=new Q.RawContextKey("editorHasMultipleSelections",!1),X.hasSingleSelection=X.hasMultipleSelections.toNegated(),X.tabMovesFocus=new Q.RawContextKey("editorTabMovesFocus",!1),X.tabDoesNotMoveFocus=X.tabMovesFocus.toNegated(),X.isInEmbeddedEditor=new Q.RawContextKey("isInEmbeddedEditor",!1),X.canUndo=new Q.RawContextKey("canUndo",!1),X.canRedo=new Q.RawContextKey("canRedo",!1),X.languageId=new Q.RawContextKey("editorLangId",""),X.hasCompletionItemProvider=new Q.RawContextKey("editorHasCompletionItemProvider",!1),X.hasCodeActionsProvider=new Q.RawContextKey("editorHasCodeActionsProvider",!1),X.hasCodeLensProvider=new Q.RawContextKey("editorHasCodeLensProvider",!1),X.hasDefinitionProvider=new Q.RawContextKey("editorHasDefinitionProvider",!1),X.hasImplementationProvider=new Q.RawContextKey("editorHasImplementationProvider",!1),X.hasTypeDefinitionProvider=new Q.RawContextKey("editorHasTypeDefinitionProvider",!1),X.hasHoverProvider=new Q.RawContextKey("editorHasHoverProvider",!1),X.hasDocumentHighlightProvider=new Q.RawContextKey("editorHasDocumentHighlightProvider",!1),X.hasDocumentSymbolProvider=new Q.RawContextKey("editorHasDocumentSymbolProvider",!1),X.hasReferenceProvider=new Q.RawContextKey("editorHasReferenceProvider",!1),X.hasRenameProvider=new Q.RawContextKey("editorHasRenameProvider",!1),X.hasDocumentFormattingProvider=new Q.RawContextKey("editorHasDocumentFormattingProvider",!1),X.hasDocumentSelectionFormattingProvider=new Q.RawContextKey("editorHasDocumentSelectionFormattingProvider",!1),X.hasSignatureHelpProvider=new Q.RawContextKey("editorHasSignatureHelpProvider",!1)}($.EditorContextKeys||($.EditorContextKeys={}))})),define(Q[405],n([0,1,2,18]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(){function e(X,$){this._editor=X,this._ckOtherSuggestions=e.OtherSuggestions.bindTo($)}return e.prototype.dispose=function(){this.reset()},e.prototype.reset=function(){this._ckOtherSuggestions.reset(),Q.dispose(this._listener),this._model=void 0,this._acceptNext=void 0,this._ignore=!1},e.prototype.set=function(X,$){var Q=this,J=X.model,ee=X.index;0!==J.items.length&&e._moveIndex(!0,J,ee)!==ee?(this._acceptNext=$,this._model=J,this._index=ee,this._listener=this._editor.onDidChangeCursorPosition((function(){Q._ignore||Q.reset()})),this._ckOtherSuggestions.set(!0)):this.reset()},e._moveIndex=function(X,$,Q){for(var J=Q;(J=(J+$.items.length+(X?1:-1))%$.items.length)!==Q&&$.items[J].suggestion.additionalTextEdits;);return J},e.prototype.next=function(){this._move(!0)},e.prototype.prev=function(){this._move(!1)},e.prototype._move=function(X){if(this._model)try{this._ignore=!0,this._index=e._moveIndex(X,this._model,this._index),this._acceptNext({index:this._index,item:this._model.items[this._index],model:this._model})}finally{this._ignore=!1}},e.OtherSuggestions=new J.RawContextKey("hasOtherSuggestions",!1),e=ne([oe(1,J.IContextKeyService)],e)}();$.SuggestAlternatives=ee})),define(Q[406],n([0,1,18,2]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(){function e(X,$){var Q=this;this._editor=X,this._ckAtEnd=e.AtEnd.bindTo($),this._editor.onDidChangeConfiguration((function(X){return X.contribInfo&&Q._update()})),this._update()}return e.prototype.dispose=function(){J.dispose(this._confListener,this._selectionListener),this._ckAtEnd.reset()},e.prototype._update=function(){var X=this,$="on"===this._editor.getConfiguration().contribInfo.tabCompletion;if(this._enabled!==$)if(this._enabled=$,this._enabled){var n=function(){if(X._editor.hasModel()){var $=X._editor.getModel(),Q=X._editor.getSelection(),J=$.getWordAtPosition(Q.getStartPosition());J?X._ckAtEnd.set(J.endColumn===Q.getStartPosition().column):X._ckAtEnd.set(!1)}else X._ckAtEnd.set(!1)};this._selectionListener=this._editor.onDidChangeCursorSelection(n),n()}else this._selectionListener&&(this._ckAtEnd.reset(),this._selectionListener.dispose(),this._selectionListener=void 0)},e.AtEnd=new Q.RawContextKey("atEndOfWord",!1),e=ne([oe(1,Q.IContextKeyService)],e)}();$.WordContextKey=ee})),define(Q[37],n([0,1,56,15,18,31]),(function(X,$,Q,J,ee,ie){function l(X){return void 0!==X.command}Object.defineProperty($,"__esModule",{value:!0}),$.isIMenuItem=l;var re=function(){function e(){this.id=String(e.ID++)}return e.ID=1,e.EditorContext=new e,e.CommandPalette=new e,e.MenubarEditMenu=new e,e.MenubarSelectionMenu=new e,e.MenubarGoMenu=new e,e}();$.MenuId=re,$.IMenuService=J.createDecorator("menuService"),$.MenuRegistry=new(function(){function e(){this._commands=Object.create(null),this._menuItems=Object.create(null)}return e.prototype.addCommand=function(X){var $=this._commands[X.id];return this._commands[X.id]=X,void 0!==$},e.prototype.getCommand=function(X){return this._commands[X]},e.prototype.getCommands=function(){var X=Object.create(null);for(var $ in this._commands)X[$]=this.getCommand($);return X},e.prototype.appendMenuItem=function(X,$){var Q=X.id,J=this._menuItems[Q];return J?J.push($):this._menuItems[Q]=J=[$],{dispose:function(){var X=J.indexOf($);X>=0&&J.splice(X,1)}}},e.prototype.getMenuItems=function(X){var $=X.id,Q=this._menuItems[$]||[];return $===re.CommandPalette.id&&this._appendImplicitItems(Q),Q},e.prototype._appendImplicitItems=function(X){for(var $=new Set,Q=0,J=X.filter((function(X){return l(X)}));Q<J.length;Q++){var ee=J[Q],te=ee.command,ne=ee.alt;$.add(te.id),ne&&$.add(ne.id)}for(var ie in this._commands)$.has(ie)||X.push({command:this._commands[ie]})},e}());var se=function(X){function t($,Q,J){var ee=X.call(this,$,Q)||this;return ee._commandService=J,ee}return te(t,X),t.prototype.run=function(){for(var X=[],$=0;$<arguments.length;$++)X[$]=arguments[$];var Q;return(Q=this._commandService).executeCommand.apply(Q,[this.id].concat(X))},ne([oe(2,ie.ICommandService)],t)}(Q.Action);$.ExecuteCommandAction=se;var ae=function(X){function t($){var Q=this;return(Q="string"==typeof $.title?X.call(this,"",$.title,"submenu")||this:X.call(this,"",$.title.value,"submenu")||this).item=$,Q}return te(t,X),t}(Q.Action);$.SubmenuItemAction=ae;var le=function(X){function t($,Q,J,ee,te){var ne=this;return(ne="string"==typeof $.title?X.call(this,$.id,$.title,te)||this:X.call(this,$.id,$.title.value,te)||this)._cssClass=void 0,ne._enabled=!$.precondition||ee.contextMatchesRules($.precondition),ne._checked=Boolean($.toggled&&ee.contextMatchesRules($.toggled)),ne._options=J||{},ne.item=$,ne.alt=Q?new t(Q,void 0,ne._options,ee,te):void 0,ne}return te(t,X),t.prototype.run=function(){for(var $=[],Q=0;Q<arguments.length;Q++)$[Q]=arguments[Q];var J=[];return this._options.arg&&(J=J.concat([this._options.arg])),this._options.shouldForwardArgs&&(J=J.concat($)),X.prototype.run.apply(this,J)},t=ne([oe(3,ee.IContextKeyService),oe(4,ie.ICommandService)],t)}(se);$.MenuItemAction=le})),define(Q[408],n([0,1,6,2,18,37,31]),(function(X,$,Q,J,ee,te,ie){Object.defineProperty($,"__esModule",{value:!0});var re=function(){function e(X,$,J,ee){var ne=this;this._commandService=J,this._contextKeyService=ee,this._menuGroups=[],this._disposables=[],this._onDidChange=new Q.Emitter,$.then((function($){var Q,J=te.MenuRegistry.getMenuItems(X),ee=new Set;J.sort(e._compareMenuItems);for(var ie=0,oe=J;ie<oe.length;ie++){var re=oe[ie],se=re.group;Q&&Q[0]===se||(Q=[se||"",[]],ne._menuGroups.push(Q)),Q[1].push(re),e._fillInKbExprKeys(re.when,ee),te.isIMenuItem(re)&&re.command.precondition&&e._fillInKbExprKeys(re.command.precondition,ee),te.isIMenuItem(re)&&re.command.toggled&&e._fillInKbExprKeys(re.command.toggled,ee)}ne._disposables.push(ne._contextKeyService.onDidChangeContext((function(X){X.affectsSome(ee)&&ne._onDidChange.fire()}))),ne._onDidChange.fire(ne)}))}return e.prototype.dispose=function(){this._disposables=J.dispose(this._disposables),this._onDidChange.dispose()},e.prototype.getActions=function(X){for(var $=[],Q=0,J=this._menuGroups;Q<J.length;Q++){for(var ee=J[Q],ne=ee[0],ie=[],oe=0,re=ee[1];oe<re.length;oe++){var se=re[oe];if(this._contextKeyService.contextMatchesRules(se.when||null)){var ae=te.isIMenuItem(se)?new te.MenuItemAction(se.command,se.alt,X,this._contextKeyService,this._commandService):new te.SubmenuItemAction(se);ie.push(ae)}}ie.length>0&&$.push([ne,ie])}return $},e._fillInKbExprKeys=function(X,$){if(X)for(var Q=0,J=X.keys();Q<J.length;Q++){var ee=J[Q];$.add(ee)}},e._compareMenuItems=function(X,$){var Q=X.group,J=$.group;if(Q!==J){if(!Q)return 1;if(!J)return-1;if("navigation"===Q)return-1;if("navigation"===J)return 1;var ee=Q.localeCompare(J);if(0!==ee)return ee}var te=X.order||0,ne=$.order||0;if(te<ne)return-1;if(te>ne)return 1;var ie="string"==typeof X.command.title?X.command.title:X.command.title.value,oe="string"==typeof $.command.title?$.command.title:$.command.title.value;return ie.localeCompare(oe)},e=ne([oe(2,ie.ICommandService),oe(3,ee.IContextKeyService)],e)}();$.Menu=re})),define(Q[60],n([0,1,15]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),$.IContextViewService=Q.createDecorator("contextViewService"),$.IContextMenuService=Q.createDecorator("contextMenuService")})),define(Q[410],n([0,1,15]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),$.IDialogService=Q.createDecorator("dialogService")})),define(Q[98],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q=function(){function e(){for(var X=[],$=0;$<arguments.length;$++)X[$]=arguments[$];this._entries=new Map;for(var Q=0,J=X;Q<J.length;Q++){var ee=J[Q],te=ee[0],ne=ee[1];this.set(te,ne)}}return e.prototype.set=function(X,$){var Q=this._entries.get(X);return this._entries.set(X,$),Q},e.prototype.has=function(X){return this._entries.has(X)},e.prototype.get=function(X){return this._entries.get(X)},e}();$.ServiceCollection=Q})),define(Q[412],n([0,1,11,32,357,356,15,98]),(function(X,$,Q,J,ee,ne,ie,oe){Object.defineProperty($,"__esModule",{value:!0});var re=function(){function e(X,$,Q){void 0===X&&(X=new oe.ServiceCollection),void 0===$&&($=!1),this._services=X,this._strict=$,this._parent=Q,this._services.set(ie.IInstantiationService,this)}return e.prototype.createChild=function(X){return new e(X,this._strict,this)},e.prototype.invokeFunction=function(X){for(var $=this,J=[],ee=1;ee<arguments.length;ee++)J[ee-1]=arguments[ee];var te=se.traceInvocation(X),ne=!1;try{var oe={get:function(X,J){if(ne)throw Q.illegalState("service accessor is only valid during the invocation of its target method");var ee=$._getOrCreateServiceInstance(X,te);if(!ee&&J!==ie.optional)throw new Error("[invokeFunction] unknown service '"+X+"'");return ee}};return X.apply(void 0,[oe].concat(J))}finally{ne=!0,te.stop()}},e.prototype.createInstance=function(X){for(var $=[],Q=1;Q<arguments.length;Q++)$[Q-1]=arguments[Q];var J,ee;return X instanceof ne.SyncDescriptor?(J=se.traceCreation(X.ctor),ee=this._createInstance(X.ctor,X.staticArguments.concat($),J)):(J=se.traceCreation(X),ee=this._createInstance(X,$,J)),J.stop(),ee},e.prototype._createInstance=function(X,$,Q){void 0===$&&($=[]);for(var ee=ie._util.getServiceDependencies(X).sort((function(X,$){return X.index-$.index})),te=[],ne=0,oe=ee;ne<oe.length;ne++){var re=oe[ne],se=this._getOrCreateServiceInstance(re.id,Q);if(!se&&this._strict&&!re.optional)throw new Error("[createInstance] "+X.name+" depends on UNKNOWN service "+re.id+".");te.push(se)}var ae=ee.length>0?ee[0].index:$.length;if($.length!==ae){console.warn("[createInstance] First service dependency of "+X.name+" at position "+(ae+1)+" conflicts with "+$.length+" static arguments");var le=ae-$.length;$=le>0?$.concat(new Array(le)):$.slice(0,ae)}return J.create.apply(null,[X].concat($,te))},e.prototype._setServiceInstance=function(X,$){if(this._services.get(X)instanceof ne.SyncDescriptor)this._services.set(X,$);else{if(!this._parent)throw new Error("illegalState - setting UNKNOWN service instance");this._parent._setServiceInstance(X,$)}},e.prototype._getServiceInstanceOrDescriptor=function(X){var $=this._services.get(X);return!$&&this._parent?this._parent._getServiceInstanceOrDescriptor(X):$},e.prototype._getOrCreateServiceInstance=function(X,$){var Q=this._getServiceInstanceOrDescriptor(X);return Q instanceof ne.SyncDescriptor?this._createAndCacheServiceInstance(X,Q,$.branch(X,!0)):($.branch(X,!1),Q)},e.prototype._createAndCacheServiceInstance=function(X,$,Q){function i(){var X=new Error("[createInstance] cyclic dependency between services");throw X.message=J.toString(),X}for(var J=new ee.Graph((function(X){return X.id.toString()})),te=0,oe=[{id:X,desc:$,_trace:Q}];oe.length;){var re=oe.pop();J.lookupOrInsertNode(re),te++>100&&i();for(var se=0,ae=ie._util.getServiceDependencies(re.desc.ctor);se<ae.length;se++){var le=ae[se],ue=this._getServiceInstanceOrDescriptor(le.id);if(ue||le.optional||console.warn("[createInstance] "+X+" depends on "+le.id+" which is NOT registered."),ue instanceof ne.SyncDescriptor){var de={id:le.id,desc:ue,_trace:re._trace.branch(le.id,!0)};J.insertEdge(re,de),oe.push(de)}}}for(;;){var ce=J.roots();if(0===ce.length){J.isEmpty()||i();break}for(var he=0,pe=ce;he<pe.length;he++){var fe=pe[he].data,ge=this._createServiceInstanceWithOwner(fe.id,fe.desc.ctor,fe.desc.staticArguments,!1,fe._trace);this._setServiceInstance(fe.id,ge),J.removeNode(fe)}}return this._getServiceInstanceOrDescriptor(X)},e.prototype._createServiceInstanceWithOwner=function(X,$,Q,J,ee){if(void 0===Q&&(Q=[]),this._services.get(X)instanceof ne.SyncDescriptor)return this._createServiceInstance($,Q,J,ee);if(this._parent)return this._parent._createServiceInstanceWithOwner(X,$,Q,J,ee);throw new Error("illegalState - creating UNKNOWN service instance")},e.prototype._createServiceInstance=function(X,$,Q,J){return void 0===$&&($=[]),this._createInstance(X,$,J)},e}();$.InstantiationService=re;var se=function(){function e(X,$){this.type=X,this.name=$,this._start=Date.now(),this._dep=[]}return e.traceInvocation=function(X){return e._None},e.traceCreation=function(X){return e._None},e.prototype.branch=function(X,$){var Q=new e(2,X.toString());return this._dep.push([X,$,Q]),Q},e.prototype.stop=function(){var X=Date.now()-this._start;e._totals+=X;var $=!1,Q=[(0===this.type?"CREATE":"CALL")+" "+this.name,""+function t(X,Q){for(var J=[],ee=new Array(X+1).join("\t"),te=0,ne=Q._dep;te<ne.length;te++){var ie=ne[te],oe=ie[0],re=ie[1],se=ie[2];if(re&&se){$=!0,J.push(ee+"CREATES -> "+oe);var ae=t(X+1,se);ae&&J.push(ae)}else J.push(ee+"uses -> "+oe)}return J.join("\n")}(1,this),"DONE, took "+X.toFixed(2)+"ms (grand total "+e._totals.toFixed(2)+"ms)"];(X>2||$)&&console.log(Q.join("\n"))},e._None=new(function(X){function t(){return X.call(this,-1,null)||this}return te(t,X),t.prototype.stop=function(){},t.prototype.branch=function(){return this},t}(e)),e._totals=0,e}()})),define(Q[413],n([0,1,351,16,6,2]),(function(X,$,Q,J,ee,ne){Object.defineProperty($,"__esModule",{value:!0});var ie=function(X){function t($,Q,te,ne,ie){var oe=X.call(this)||this;return oe._contextKeyService=$,oe._commandService=Q,oe._telemetryService=te,oe._statusService=ie,oe._notificationService=ne,oe._currentChord=null,oe._currentChordChecker=new J.IntervalTimer,oe._currentChordStatusMessage=null,oe._onDidUpdateKeybindings=oe._register(new ee.Emitter),oe}return te(t,X),t.prototype.dispose=function(){X.prototype.dispose.call(this)},Object.defineProperty(t.prototype,"onDidUpdateKeybindings",{get:function(){return this._onDidUpdateKeybindings?this._onDidUpdateKeybindings.event:ee.Event.None},enumerable:!0,configurable:!0}),t.prototype.lookupKeybinding=function(X){var $=this._getResolver().lookupPrimaryKeybinding(X);return $?$.resolvedKeybinding:null},t.prototype._enterChordMode=function(X,$){var J=this;this._currentChord={keypress:X,label:$},this._statusService&&(this._currentChordStatusMessage=this._statusService.setStatusMessage(Q.localize(0,null,$)));var ee=Date.now();this._currentChordChecker.cancelAndSet((function(){J._documentHasFocus()?Date.now()-ee>5e3&&J._leaveChordMode():J._leaveChordMode()}),500)},t.prototype._leaveChordMode=function(){this._currentChordStatusMessage&&(this._currentChordStatusMessage.dispose(),this._currentChordStatusMessage=null),this._currentChordChecker.cancel(),this._currentChord=null},t.prototype._dispatch=function(X,$){var J=this,ee=!1,te=this.resolveKeyboardEvent(X);if(te.isChord())return console.warn("Unexpected keyboard event mapped to a chord"),!1;var ne=te.getDispatchParts()[0];if(null===ne)return ee;var ie=this._contextKeyService.getContext($),oe=this._currentChord?this._currentChord.keypress:null,re=te.getLabel(),se=this._getResolver().resolve(ie,oe,ne);return se&&se.enterChord?(ee=!0,this._enterChordMode(ne,re),ee):(this._statusService&&this._currentChord&&(se&&se.commandId||(this._statusService.setStatusMessage(Q.localize(1,null,this._currentChord.label,re),1e4),ee=!0)),this._leaveChordMode(),se&&se.commandId&&(se.bubble||(ee=!0),void 0===se.commandArgs?this._commandService.executeCommand(se.commandId).then(void 0,(function(X){return J._notificationService.warn(X)})):this._commandService.executeCommand(se.commandId,se.commandArgs).then(void 0,(function(X){return J._notificationService.warn(X)})),this._telemetryService.publicLog("workbenchActionExecuted",{id:se.commandId,from:"keybinding"})),ee)},t}(ne.Disposable);$.AbstractKeybindingService=ie})),define(Q[47],n([0,1,15]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),$.IKeybindingService=Q.createDecorator("keybindingService")})),define(Q[155],n([0,1,18]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J=function(){function e(X,$){this._defaultKeybindings=X,this._defaultBoundCommands=new Map;for(var Q=0,J=X.length;Q<J;Q++){var ee=X[Q].command;ee&&this._defaultBoundCommands.set(ee,!0)}this._map=new Map,this._lookupMap=new Map,this._keybindings=e.combine(X,$);for(Q=0,J=this._keybindings.length;Q<J;Q++){var te=this._keybindings[Q];null!==te.keypressFirstPart&&this._addKeyPress(te.keypressFirstPart,te)}}return e._isTargetedForRemoval=function(X,$,Q,J,ee){if(X.command!==J)return!1;if($&&X.keypressFirstPart!==$)return!1;if(Q&&X.keypressChordPart!==Q)return!1;if(ee){if(!X.when)return!1;if(!ee.equals(X.when))return!1}return!0},e.combine=function(X,$){X=X.slice(0);for(var Q=[],J=0,ee=$.length;J<ee;J++){var te=$[J];if(te.command&&0!==te.command.length&&"-"===te.command.charAt(0))for(var ne=te.command.substr(1),ie=te.keypressFirstPart,oe=te.keypressChordPart,re=te.when,se=X.length-1;se>=0;se--)this._isTargetedForRemoval(X[se],ie,oe,ne,re)&&X.splice(se,1);else Q.push(te)}return X.concat(Q)},e.prototype._addKeyPress=function(X,$){var Q=this._map.get(X);if(void 0===Q)return this._map.set(X,[$]),void this._addToLookupMap($);for(var J=Q.length-1;J>=0;J--){var ee=Q[J];if(ee.command!==$.command){var te=null!==ee.keypressChordPart,ne=null!==$.keypressChordPart;te&&ne&&ee.keypressChordPart!==$.keypressChordPart||e.whenIsEntirelyIncluded(ee.when,$.when)&&this._removeFromLookupMap(ee)}}Q.push($),this._addToLookupMap($)},e.prototype._addToLookupMap=function(X){if(X.command){var $=this._lookupMap.get(X.command);void 0===$?($=[X],this._lookupMap.set(X.command,$)):$.push(X)}},e.prototype._removeFromLookupMap=function(X){if(X.command){var $=this._lookupMap.get(X.command);if(void 0!==$)for(var Q=0,J=$.length;Q<J;Q++)if($[Q]===X)return void $.splice(Q,1)}},e.whenIsEntirelyIncluded=function(X,$){if(!$)return!0;if(!X)return!1;for(var J=X instanceof Q.ContextKeyAndExpr?X.expr:[X],ee=$ instanceof Q.ContextKeyAndExpr?$.expr:[$],te=0,ne=0;ne<ee.length;ne++){for(var ie=ee[ne],oe=!1;!oe&&te<J.length;)J[te].equals(ie)&&(oe=!0),te++;if(!oe)return!1}return!0},e.prototype.lookupPrimaryKeybinding=function(X){var $=this._lookupMap.get(X);return void 0===$||0===$.length?null:$[$.length-1]},e.prototype.resolve=function(X,$,Q){var J=null;if(null!==$){if(void 0===(ie=this._map.get($)))return null;J=[];for(var ee=0,te=ie.length;ee<te;ee++){var ne=ie[ee];ne.keypressChordPart===Q&&J.push(ne)}}else{var ie=this._map.get(Q);if(void 0===ie)return null;J=ie}var oe=this._findCommand(X,J);return oe?null===$&&null!==oe.keypressChordPart?{enterChord:!0,commandId:null,commandArgs:null,bubble:!1}:{enterChord:!1,commandId:oe.command,commandArgs:oe.commandArgs,bubble:oe.bubble}:null},e.prototype._findCommand=function(X,$){for(var Q=$.length-1;Q>=0;Q--){var J=$[Q];if(e.contextMatchesRules(X,J.when))return J}return null},e.contextMatchesRules=function(X,$){return!$||$.evaluate(X)},e}();$.KeybindingResolver=J})),define(Q[416],n([0,1]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var n=function(X,$,Q,J,ee){if(this.resolvedKeybinding=X,X){var te=X.getDispatchParts(),ne=te[0],ie=te[1];this.keypressFirstPart=ne,this.keypressChordPart=ie}else this.keypressFirstPart=null,this.keypressChordPart=null;this.bubble=!!$&&94===$.charCodeAt(0),this.command=this.bubble?$.substr(1):$,this.commandArgs=Q,this.when=J,this.isDefault=ee};$.ResolvedKeybindingItem=n})),define(Q[417],n([0,1,36,154]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(X){function t($,Q){var J=X.call(this)||this;if(J._os=Q,!$)throw new Error("Invalid USLayoutResolvedKeybinding");return 2===$.type?(J._firstPart=$.firstPart,J._chordPart=$.chordPart):(J._firstPart=$,J._chordPart=null),J}return te(t,X),t.prototype._keyCodeToUILabel=function(X){if(2===this._os)switch(X){case 15:return"←";case 16:return"↑";case 17:return"→";case 18:return"↓"}return Q.KeyCodeUtils.toString(X)},t.prototype._getUILabelForKeybinding=function(X){return X?X.isDuplicateModifierCase()?"":this._keyCodeToUILabel(X.keyCode):null},t.prototype.getLabel=function(){var X=this._getUILabelForKeybinding(this._firstPart),$=this._getUILabelForKeybinding(this._chordPart);return J.UILabelProvider.toLabel(this._firstPart,X,this._chordPart,$,this._os)},t.prototype._getAriaLabelForKeybinding=function(X){return X?X.isDuplicateModifierCase()?"":Q.KeyCodeUtils.toString(X.keyCode):null},t.prototype.getAriaLabel=function(){var X=this._getAriaLabelForKeybinding(this._firstPart),$=this._getAriaLabelForKeybinding(this._chordPart);return J.AriaLabelProvider.toLabel(this._firstPart,X,this._chordPart,$,this._os)},t.prototype.isChord=function(){return!!this._chordPart},t.prototype.getParts=function(){return[this._toResolvedKeybindingPart(this._firstPart),this._chordPart?this._toResolvedKeybindingPart(this._chordPart):null]},t.prototype._toResolvedKeybindingPart=function(X){return new Q.ResolvedKeybindingPart(X.ctrlKey,X.shiftKey,X.altKey,X.metaKey,this._getUILabelForKeybinding(X),this._getAriaLabelForKeybinding(X))},t.prototype.getDispatchParts=function(){return[this._firstPart?t.getDispatchStr(this._firstPart):null,this._chordPart?t.getDispatchStr(this._chordPart):null]},t.getDispatchStr=function(X){if(X.isModifierKey())return null;var $="";return X.ctrlKey&&($+="ctrl+"),X.shiftKey&&($+="shift+"),X.altKey&&($+="alt+"),X.metaKey&&($+="meta+"),$+Q.KeyCodeUtils.toString(X.keyCode)},t}(Q.ResolvedKeybinding);$.USLayoutResolvedKeybinding=ee})),define(Q[156],n([0,1,15]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),$.ILabelService=Q.createDecorator("label")})),define(Q[116],n([0,1,15]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),$.ILogService=Q.createDecorator("logService");var J=function(){function e(){}return e.prototype.trace=function(X){for(var $=[],Q=1;Q<arguments.length;Q++)$[Q-1]=arguments[Q]},e.prototype.error=function(X){for(var $=[],Q=1;Q<arguments.length;Q++)$[Q-1]=arguments[Q]},e.prototype.dispose=function(){},e}();$.NullLogService=J})),define(Q[76],n([0,1,15,353,114]),(function(X,$,Q,J,ee){var te;Object.defineProperty($,"__esModule",{value:!0}),function(X){X[X.Hint=1]="Hint",X[X.Info=2]="Info",X[X.Warning=4]="Warning",X[X.Error=8]="Error"}(te=$.MarkerSeverity||($.MarkerSeverity={})),function(X){X.compare=function(X,$){return $-X};var $=Object.create(null);$[X.Error]=J.localize(0,null),$[X.Warning]=J.localize(1,null),$[X.Info]=J.localize(2,null),X.toString=function(X){return $[X]||""},X.fromSeverity=function($){switch($){case ee.default.Error:return X.Error;case ee.default.Warning:return X.Warning;case ee.default.Info:return X.Info;case ee.default.Ignore:return X.Hint}}}(te=$.MarkerSeverity||($.MarkerSeverity={})),function(X){var $="";X.makeKey=function(X){var Q=[$];return X.source?Q.push(X.source.replace("¦","¦")):Q.push($),X.code?Q.push(X.code.replace("¦","¦")):Q.push($),void 0!==X.severity&&null!==X.severity?Q.push(te.toString(X.severity)):Q.push($),X.message?Q.push(X.message.replace("¦","¦")):Q.push($),void 0!==X.startLineNumber&&null!==X.startLineNumber?Q.push(X.startLineNumber.toString()):Q.push($),void 0!==X.startColumn&&null!==X.startColumn?Q.push(X.startColumn.toString()):Q.push($),void 0!==X.endLineNumber&&null!==X.endLineNumber?Q.push(X.endLineNumber.toString()):Q.push($),void 0!==X.endColumn&&null!==X.endColumn?Q.push(X.endColumn.toString()):Q.push($),Q.push($),Q.join("¦")}}($.IMarkerData||($.IMarkerData={})),$.IMarkerService=Q.createDecorator("markerService")})),define(Q[421],n([0,1,22,50,32,6,76]),(function(X,$,Q,J,ee,te,ne){var ie;Object.defineProperty($,"__esModule",{value:!0}),function(X){X.get=function(X,$,Q){if(X[$])return X[$][Q]},X.set=function(X,$,Q,J){X[$]||(X[$]=Object.create(null)),X[$][Q]=J},X.remove=function(X,$,Q){return!(!X[$]||!X[$][Q]||(delete X[$][Q],ee.isEmptyObject(X[$])&&delete X[$],0))}}(ie||(ie={}));var oe=function(){function e(X){this.errors=0,this.infos=0,this.warnings=0,this.unknowns=0,this._data=Object.create(null),this._service=X,this._subscription=X.onMarkerChanged(this._update,this)}return e.prototype.dispose=function(){this._subscription.dispose(),this._data=void 0},e.prototype._update=function(X){if(this._data)for(var $=0,Q=X;$<Q.length;$++){var J=Q[$],ee=J.toString(),te=this._data[ee];te&&this._substract(te);var ne=this._resourceStats(J);this._add(ne),this._data[ee]=ne}},e.prototype._resourceStats=function(X){var $={errors:0,warnings:0,infos:0,unknowns:0};if(X.scheme===J.Schemas.inMemory||X.scheme===J.Schemas.walkThrough||X.scheme===J.Schemas.walkThroughSnippet)return $;for(var Q=0,ee=this._service.read({resource:X});Q<ee.length;Q++){var te=ee[Q].severity;te===ne.MarkerSeverity.Error?$.errors+=1:te===ne.MarkerSeverity.Warning?$.warnings+=1:te===ne.MarkerSeverity.Info?$.infos+=1:$.unknowns+=1}return $},e.prototype._substract=function(X){this.errors-=X.errors,this.warnings-=X.warnings,this.infos-=X.infos,this.unknowns-=X.unknowns},e.prototype._add=function(X){this.errors+=X.errors,this.warnings+=X.warnings,this.infos+=X.infos,this.unknowns+=X.unknowns},e}(),re=function(){function e(){this._onMarkerChanged=new te.Emitter,this._onMarkerChangedEvent=te.debounceEvent(this._onMarkerChanged.event,e._debouncer,0),this._byResource=Object.create(null),this._byOwner=Object.create(null),this._stats=new oe(this)}return e.prototype.dispose=function(){this._stats.dispose()},Object.defineProperty(e.prototype,"onMarkerChanged",{get:function(){return this._onMarkerChangedEvent},enumerable:!0,configurable:!0}),e.prototype.remove=function(X,$){if(!Q.isFalsyOrEmpty($))for(var J=0,ee=$;J<ee.length;J++){var te=ee[J];this.changeOne(X,te,[])}},e.prototype.changeOne=function(X,$,J){if(Q.isFalsyOrEmpty(J)){var ee=ie.remove(this._byResource,$.toString(),X),te=ie.remove(this._byOwner,X,$.toString());if(ee!==te)throw new Error("invalid marker service state");ee&&te&&this._onMarkerChanged.fire([$])}else{for(var ne=[],oe=0,re=J;oe<re.length;oe++){var se=re[oe],ae=e._toMarker(X,$,se);ae&&ne.push(ae)}ie.set(this._byResource,$.toString(),X,ne),ie.set(this._byOwner,X,$.toString(),ne),this._onMarkerChanged.fire([$])}},e._toMarker=function(X,$,Q){var J=Q.code,ee=Q.severity,te=Q.message,ne=Q.source,ie=Q.startLineNumber,oe=Q.startColumn,re=Q.endLineNumber,se=Q.endColumn,ae=Q.relatedInformation,le=Q.tags;if(te)return{resource:$,owner:X,code:J||void 0,severity:ee,message:te,source:ne,startLineNumber:ie=ie>0?ie:1,startColumn:oe=oe>0?oe:1,endLineNumber:re=re>=ie?re:ie,endColumn:se=se>0?se:oe,relatedInformation:ae,tags:le}},e.prototype.read=function(X){void 0===X&&(X=Object.create(null));var $=X.owner,Q=X.resource,J=X.severities,ee=X.take;if((!ee||ee<0)&&(ee=-1),$&&Q){if(fe=ie.get(this._byResource,Q.toString(),$)){for(var te=[],ne=0,oe=fe;ne<oe.length;ne++){var re=oe[ne];if(e._accept(re,J)&&(ge=te.push(re),ee>0&&ge===ee))break}return te}return[]}if($||Q){var se=$?this._byOwner[$]:Q?this._byResource[Q.toString()]:void 0;if(!se)return[];for(var ae in te=[],se)for(var le=0,ue=se[ae];le<ue.length;le++)if(fe=ue[le],e._accept(fe,J)&&(ge=te.push(fe),ee>0&&ge===ee))return te;return te}for(var de in te=[],this._byResource)for(var ce in this._byResource[de])for(var he=0,pe=this._byResource[de][ce];he<pe.length;he++){var fe=pe[he];if(e._accept(fe,J)){var ge=te.push(fe);if(ee>0&&ge===ee)return te}}return te},e._accept=function(X,$){return void 0===$||($&X.severity)===X.severity},e._debouncer=function(X,$){X||(e._dedupeMap=Object.create(null),X=[]);for(var Q=0,J=$;Q<J.length;Q++){var ee=J[Q];void 0===e._dedupeMap[ee.toString()]&&(e._dedupeMap[ee.toString()]=!0,X.push(ee))}return X},e}();$.MarkerService=re})),define(Q[35],n([0,1,114,15]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0}),$.Severity=Q.default,$.INotificationService=J.createDecorator("notificationService");var o=function(){};$.NoOpNotification=o})),define(Q[62],n([0,1,15]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),$.IOpenerService=Q.createDecorator("openerService"),$.NullOpenerService=Object.freeze({_serviceBrand:void 0,open:function(){return Promise.resolve(void 0)}})})),define(Q[120],n([0,1,133,62,63,25,11,190,15,6,2,14]),(function(X,$,Q,J,ee,te,ie,re,se,ae,le,ue){Object.defineProperty($,"__esModule",{value:!0});var de=function(){function e(X,$,Q){void 0===Q&&(Q=J.NullOpenerService),this._editor=X,this._modeService=$,this._openerService=Q,this._onDidRenderCodeBlock=new ae.Emitter,this.onDidRenderCodeBlock=this._onDidRenderCodeBlock.event}return e.prototype.getOptions=function(X){var $=this;return{codeBlockRenderer:function(X,Q){var J=null;if(X)J=$._modeService.getModeIdForLanguageName(X);else{var ee=$._editor.getModel();ee&&(J=ee.getLanguageIdentifier().language)}return $._modeService.triggerMode(J||""),Promise.resolve(!0).then((function(X){var $=ue.TokenizationRegistry.getPromise(J||"");return $?$.then((function(X){return re.tokenizeToString(Q,X)})):re.tokenizeToString(Q,void 0)})).then((function(X){return'<span style="font-family: '+$._editor.getConfiguration().fontInfo.fontFamily+'">'+X+"</span>"}))},codeBlockRenderCallback:function(){return $._onDidRenderCodeBlock.fire()},actionHandler:{callback:function(X){var Q;try{Q=te.URI.parse(X)}catch(X){}Q&&$._openerService&&$._openerService.open(Q).catch(ie.onUnexpectedError)},disposeables:X}}},e.prototype.render=function(X){var $=[];return{element:X?Q.renderMarkdown(X,this.getOptions($)):document.createElement("span"),dispose:function(){return le.dispose($)}}},ne([oe(1,ee.IModeService),oe(2,se.optional(J.IOpenerService))],e)}();$.MarkdownRenderer=de})),define(Q[89],n([0,1,15]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),$.IProgressService=Q.createDecorator("progressService")})),define(Q[41],n([0,1,32,135]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(){function e(){this.data={}}return e.prototype.add=function(X,$){J.ok(Q.isString(X)),J.ok(Q.isObject($)),J.ok(!this.data.hasOwnProperty(X),"There is already an extension with this id"),this.data[X]=$},e.prototype.as=function(X){return this.data[X]||null},e}();$.Registry=new ee})),define(Q[104],n([0,1,298,6,14,39,41]),(function(X,$,Q,J,ee,te,ne){Object.defineProperty($,"__esModule",{value:!0}),$.Extensions={ModesRegistry:"editor.modesRegistry"};var ie=function(){function e(){this._onDidAddLanguages=new J.Emitter,this.onDidAddLanguages=this._onDidAddLanguages.event,this._languages=[]}return e.prototype.registerLanguage=function(X){this._languages.push(X),this._onDidAddLanguages.fire([X])},e.prototype.getLanguages=function(){return this._languages.slice(0)},e}();$.EditorModesRegistry=ie,$.ModesRegistry=new ie,ne.Registry.add($.Extensions.ModesRegistry,$.ModesRegistry),$.PLAINTEXT_MODE_ID="plaintext",$.PLAINTEXT_LANGUAGE_IDENTIFIER=new ee.LanguageIdentifier($.PLAINTEXT_MODE_ID,1),$.ModesRegistry.registerLanguage({id:$.PLAINTEXT_MODE_ID,extensions:[".txt",".gitignore"],aliases:[Q.localize(0,null),"text"],mimetypes:["text/plain"]}),te.LanguageConfigurationRegistry.register($.PLAINTEXT_LANGUAGE_IDENTIFIER,{brackets:[["(",")"],["[","]"],["{","}"]]})})),define(Q[428],n([0,1,50,84,104,162]),(function(X,$,Q,J,ee,te){function s(X,$){var Q=null;if($){var J=X.getModel($);if(J){var te=J.getLanguageIdentifier().language;te&&te!==ee.PLAINTEXT_MODE_ID&&(Q=te)}}return Q}function a(X){return X.replace(/\s/g,"\\$&")}Object.defineProperty($,"__esModule",{value:!0}),$.getIconClasses=function(X,$,ee,ne){var ie=ne===te.FileKind.ROOT_FOLDER?["rootfolder-icon"]:ne===te.FileKind.FOLDER?["folder-icon"]:["file-icon"];if(ee){var oe,re=void 0;if(ee.scheme===Q.Schemas.data?re=oe=J.DataUri.parseMetaData(ee).get(J.DataUri.META_DATA_LABEL):(oe=a(J.basenameOrAuthority(ee).toLowerCase()),re=ee.path.toLowerCase()),ne===te.FileKind.FOLDER)ie.push(oe+"-name-folder-icon");else{if(oe){ie.push(oe+"-name-file-icon");for(var se=oe.split("."),ae=1;ae<se.length;ae++)ie.push(se.slice(ae).join(".")+"-ext-file-icon");ie.push("ext-file-icon")}var le=s(X,ee);(le=le||$.getModeIdByFilepathOrFirstLine(re))&&ie.push(a(le)+"-lang-file-icon")}}return ie},$.getConfiguredLangId=s,$.cssEscape=a})),define(Q[429],n([0,1,41,6]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0}),$.Extensions={JSONContribution:"base.contributions.json"};var ee=new(function(){function e(){this._onDidChangeSchema=new J.Emitter,this.schemasById={}}return e.prototype.registerSchema=function(X,$){this.schemasById[function(X){return X.length>0&&"#"===X.charAt(X.length-1)?X.substring(0,X.length-1):X}(X)]=$,this._onDidChangeSchema.fire(X)},e}());Q.Registry.add($.Extensions.JSONContribution,ee)})),define(Q[82],n([0,1,350,6,41,32,8,429]),(function(X,$,Q,J,ee,te,ne,ie){function l(X){return $.OVERRIDE_PROPERTY_PATTERN.test(X)?Q.localize(3,null,X):void 0!==ue.getConfigurationProperties()[X]?Q.localize(4,null,X):null}Object.defineProperty($,"__esModule",{value:!0}),$.Extensions={Configuration:"base.contributions.configuration"},$.allSettings={properties:{},patternProperties:{}},$.applicationSettings={properties:{},patternProperties:{}},$.windowSettings={properties:{},patternProperties:{}},$.resourceSettings={properties:{},patternProperties:{}},$.editorConfigurationSchemaId="vscode://schemas/settings/editor";var oe=ee.Registry.as(ie.Extensions.JSONContribution),re=function(){function e(){this.overrideIdentifiers=[],this._onDidSchemaChange=new J.Emitter,this._onDidRegisterConfiguration=new J.Emitter,this.configurationContributors=[],this.editorConfigurationSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting"},this.configurationProperties={},this.excludedConfigurationProperties={},this.computeOverridePropertyPattern(),oe.registerSchema($.editorConfigurationSchemaId,this.editorConfigurationSchema)}return e.prototype.registerConfiguration=function(X,$){void 0===$&&($=!0),this.registerConfigurations([X],[],$)},e.prototype.registerConfigurations=function(X,$,Q){var J=this;void 0===Q&&(Q=!0);var ee=this.toConfiguration($);ee&&X.push(ee);var te=[];X.forEach((function(X){te.push.apply(te,J.validateAndRegisterProperties(X,Q)),J.configurationContributors.push(X),J.registerJSONConfiguration(X),J.updateSchemaForOverrideSettingsConfiguration(X)})),this._onDidRegisterConfiguration.fire(te)},e.prototype.registerOverrideIdentifiers=function(X){var $;($=this.overrideIdentifiers).push.apply($,X),this.updateOverridePropertyPatternKey()},e.prototype.toConfiguration=function(X){for(var J={id:"defaultOverrides",title:Q.localize(0,null),properties:{}},ee=0,te=X;ee<te.length;ee++){var ne=te[ee];for(var ie in ne.defaults){var oe=ne.defaults[ie];$.OVERRIDE_PROPERTY_PATTERN.test(ie)&&"object"==typeof oe&&(J.properties[ie]={type:"object",default:oe,description:Q.localize(1,null,ie),$ref:$.editorConfigurationSchemaId})}}return Object.keys(J.properties).length?J:null},e.prototype.validateAndRegisterProperties=function(X,Q,J,ee){void 0===Q&&(Q=!0),void 0===J&&(J=2),void 0===ee&&(ee=!1),J=te.isUndefinedOrNull(X.scope)?J:X.scope,ee=X.overridable||ee;var ne=[],ie=X.properties;if(ie)for(var oe in ie){var re=void 0;if(Q&&(re=l(oe)))console.warn(re),delete ie[oe];else{var se=ie[oe],ae=se.default;te.isUndefined(ae)&&(se.default=function(X){switch(Array.isArray(X)?X[0]:X){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}(se.type)),ee&&(se.overridable=!0),$.OVERRIDE_PROPERTY_PATTERN.test(oe)?se.scope=void 0:se.scope=te.isUndefinedOrNull(se.scope)?J:se.scope,!ie[oe].hasOwnProperty("included")||ie[oe].included?(this.configurationProperties[oe]=ie[oe],ne.push(oe)):(this.excludedConfigurationProperties[oe]=ie[oe],delete ie[oe])}}var le=X.allOf;if(le)for(var ue=0,de=le;ue<de.length;ue++){var ce=de[ue];ne.push.apply(ne,this.validateAndRegisterProperties(ce,Q,J,ee))}return ne},e.prototype.getConfigurationProperties=function(){return this.configurationProperties},e.prototype.registerJSONConfiguration=function(X){(function n(X){var Q=X.properties;if(Q)for(var J in Q)switch($.allSettings.properties[J]=Q[J],Q[J].scope){case 1:$.applicationSettings.properties[J]=Q[J];break;case 2:$.windowSettings.properties[J]=Q[J];break;case 3:$.resourceSettings.properties[J]=Q[J]}var ee=X.allOf;ee&&ee.forEach(n)})(X),this._onDidSchemaChange.fire()},e.prototype.updateSchemaForOverrideSettingsConfiguration=function(X){X.id!==se&&(this.update(X),oe.registerSchema($.editorConfigurationSchemaId,this.editorConfigurationSchema))},e.prototype.updateOverridePropertyPatternKey=function(){var X=$.allSettings.patternProperties[this.overridePropertyPattern];X||(X={type:"object",description:Q.localize(2,null),errorMessage:"Unknown Identifier. Use language identifiers",$ref:$.editorConfigurationSchemaId}),delete $.allSettings.patternProperties[this.overridePropertyPattern],delete $.applicationSettings.patternProperties[this.overridePropertyPattern],delete $.windowSettings.patternProperties[this.overridePropertyPattern],delete $.resourceSettings.patternProperties[this.overridePropertyPattern],this.computeOverridePropertyPattern(),$.allSettings.patternProperties[this.overridePropertyPattern]=X,$.applicationSettings.patternProperties[this.overridePropertyPattern]=X,$.windowSettings.patternProperties[this.overridePropertyPattern]=X,$.resourceSettings.patternProperties[this.overridePropertyPattern]=X,this._onDidSchemaChange.fire()},e.prototype.update=function(X){var $=this,Q=X.properties;if(Q)for(var J in Q)Q[J].overridable&&(this.editorConfigurationSchema.properties[J]=this.getConfigurationProperties()[J]);var ee=X.allOf;ee&&ee.forEach((function(X){return $.update(X)}))},e.prototype.computeOverridePropertyPattern=function(){this.overridePropertyPattern=this.overrideIdentifiers.length?le.replace("${0}",this.overrideIdentifiers.map((function(X){return ne.createRegExp(X,!1).source})).join("|")):ae},e}(),se="override",ae="\\[.*\\]$",le="\\[(${0})\\]$";$.OVERRIDE_PROPERTY_PATTERN=new RegExp(ae);var ue=new re;ee.Registry.add($.Extensions.Configuration,ue),$.validateProperty=l})),define(Q[125],n([0,1,293,6,2,27,17,48,97,122,82,41]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le){function p(){return null===me&&(me=Object.create(null),Object.keys(ge.properties).forEach((function(X){me[X]=!0}))),me}Object.defineProperty($,"__esModule",{value:!0});var ue=oe.EDITOR_DEFAULTS,de=oe.EDITOR_FONT_DEFAULTS,ce=oe.EDITOR_MODEL_DEFAULTS;$.TabFocus=new(function(){function e(){this._tabFocus=!1,this._onDidChangeTabFocus=new J.Emitter,this.onDidChangeTabFocus=this._onDidChangeTabFocus.event}return e.prototype.getTabFocusMode=function(){return this._tabFocus},e.prototype.setTabFocusMode=function(X){this._tabFocus!==X&&(this._tabFocus=X,this._onDidChangeTabFocus.fire(this._tabFocus))},e}());var he=Object.hasOwnProperty,pe=function(X){function n(Q){var ee=X.call(this)||this;return ee._onDidChange=ee._register(new J.Emitter),ee.onDidChange=ee._onDidChange.event,ee._rawOptions=ne.mixin({},Q||{}),ee._rawOptions.scrollbar=ne.mixin({},ee._rawOptions.scrollbar||{}),ee._rawOptions.minimap=ne.mixin({},ee._rawOptions.minimap||{}),ee._rawOptions.find=ne.mixin({},ee._rawOptions.find||{}),ee._rawOptions.hover=ne.mixin({},ee._rawOptions.hover||{}),ee._rawOptions.parameterHints=ne.mixin({},ee._rawOptions.parameterHints||{}),ee._validatedOptions=oe.EditorOptionsValidator.validate(ee._rawOptions,ue),ee._isDominatedByLongLines=!1,ee._lineNumbersDigitCount=1,ee._register(re.EditorZoom.onDidChangeZoomLevel((function(X){return ee._recomputeOptions()}))),ee._register($.TabFocus.onDidChangeTabFocus((function(X){return ee._recomputeOptions()}))),ee}return te(n,X),n.prototype.observeReferenceElement=function(X){},n.prototype.dispose=function(){X.prototype.dispose.call(this)},n.prototype._recomputeOptions=function(){var X=this.editor,$=this._computeInternalOptions();X&&X.equals($)||(this.editor=$,X&&this._onDidChange.fire(X.createChangeEvent($)))},n.prototype.getRawOptions=function(){return this._rawOptions},n.prototype._computeInternalOptions=function(){var X=this._validatedOptions,Q=this._getEnvConfiguration(),J=se.BareFontInfo.createFromRawSettings(this._rawOptions,Q.zoomLevel),ee={outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,fontInfo:this.readConfiguration(J),extraEditorClassName:Q.extraEditorClassName,isDominatedByLongLines:this._isDominatedByLongLines,lineNumbersDigitCount:this._lineNumbersDigitCount,emptySelectionClipboard:Q.emptySelectionClipboard,pixelRatio:Q.pixelRatio,tabFocusMode:$.TabFocus.getTabFocusMode(),accessibilitySupport:Q.accessibilitySupport};return oe.InternalEditorOptionsFactory.createInternalEditorOptions(ee,X)},n._primitiveArrayEquals=function(X,$){if(X.length!==$.length)return!1;for(var Q=0;Q<X.length;Q++)if(X[Q]!==$[Q])return!1;return!0},n._subsetEquals=function(X,$){for(var Q in $)if(he.call($,Q)){var J=$[Q],ee=X[Q];if(ee===J)continue;if(Array.isArray(ee)&&Array.isArray(J)){if(!this._primitiveArrayEquals(ee,J))return!1;continue}if("object"==typeof ee&&"object"==typeof J){if(!this._subsetEquals(ee,J))return!1;continue}return!1}return!0},n.prototype.updateOptions=function(X){void 0!==X&&(n._subsetEquals(this._rawOptions,X)||(this._rawOptions=ne.mixin(this._rawOptions,X||{}),this._validatedOptions=oe.EditorOptionsValidator.validate(this._rawOptions,ue),this._recomputeOptions()))},n.prototype.setIsDominatedByLongLines=function(X){this._isDominatedByLongLines=X,this._recomputeOptions()},n.prototype.setMaxLineNumber=function(X){var $=n._digitCount(X);this._lineNumbersDigitCount!==$&&(this._lineNumbersDigitCount=$,this._recomputeOptions())},n._digitCount=function(X){for(var $=0;X;)X=Math.floor(X/10),$++;return $||1},n}(ee.Disposable);$.CommonEditorConfiguration=pe;var fe=le.Registry.as(ae.Extensions.Configuration),ge={id:"editor",order:5,type:"object",title:Q.localize(0,null),overridable:!0,scope:3,properties:{"editor.fontFamily":{type:"string",default:de.fontFamily,description:Q.localize(1,null)},"editor.fontWeight":{type:"string",enum:["normal","bold","100","200","300","400","500","600","700","800","900"],default:de.fontWeight,description:Q.localize(2,null)},"editor.fontSize":{type:"number",default:de.fontSize,description:Q.localize(3,null)},"editor.lineHeight":{type:"number",default:de.lineHeight,description:Q.localize(4,null)},"editor.letterSpacing":{type:"number",default:de.letterSpacing,description:Q.localize(5,null)},"editor.lineNumbers":{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[Q.localize(6,null),Q.localize(7,null),Q.localize(8,null),Q.localize(9,null)],default:"on",description:Q.localize(10,null)},"editor.rulers":{type:"array",items:{type:"number"},default:ue.viewInfo.rulers,description:Q.localize(11,null)},"editor.wordSeparators":{type:"string",default:ue.wordSeparators,description:Q.localize(12,null)},"editor.tabSize":{type:"number",default:ce.tabSize,minimum:1,markdownDescription:Q.localize(13,null)},"editor.insertSpaces":{type:"boolean",default:ce.insertSpaces,markdownDescription:Q.localize(14,null)},"editor.detectIndentation":{type:"boolean",default:ce.detectIndentation,markdownDescription:Q.localize(15,null)},"editor.roundedSelection":{type:"boolean",default:ue.viewInfo.roundedSelection,description:Q.localize(16,null)},"editor.scrollBeyondLastLine":{type:"boolean",default:ue.viewInfo.scrollBeyondLastLine,description:Q.localize(17,null)},"editor.scrollBeyondLastColumn":{type:"number",default:ue.viewInfo.scrollBeyondLastColumn,description:Q.localize(18,null)},"editor.smoothScrolling":{type:"boolean",default:ue.viewInfo.smoothScrolling,description:Q.localize(19,null)},"editor.minimap.enabled":{type:"boolean",default:ue.viewInfo.minimap.enabled,description:Q.localize(20,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ue.viewInfo.minimap.side,description:Q.localize(21,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ue.viewInfo.minimap.showSlider,description:Q.localize(22,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ue.viewInfo.minimap.renderCharacters,description:Q.localize(23,null)},"editor.minimap.maxColumn":{type:"number",default:ue.viewInfo.minimap.maxColumn,description:Q.localize(24,null)},"editor.hover.enabled":{type:"boolean",default:ue.contribInfo.hover.enabled,description:Q.localize(25,null)},"editor.hover.delay":{type:"number",default:ue.contribInfo.hover.delay,description:Q.localize(26,null)},"editor.hover.sticky":{type:"boolean",default:ue.contribInfo.hover.sticky,description:Q.localize(27,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ue.contribInfo.find.seedSearchStringFromSelection,description:Q.localize(28,null)},"editor.find.autoFindInSelection":{type:"boolean",default:ue.contribInfo.find.autoFindInSelection,description:Q.localize(29,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ue.contribInfo.find.globalFindClipboard,description:Q.localize(30,null),included:ie.isMacintosh},"editor.wordWrap":{type:"string",enum:["off","on","wordWrapColumn","bounded"],markdownEnumDescriptions:[Q.localize(31,null),Q.localize(32,null),Q.localize(33,null),Q.localize(34,null)],default:ue.wordWrap,description:Q.localize(35,null)},"editor.wordWrapColumn":{type:"integer",default:ue.wordWrapColumn,minimum:1,markdownDescription:Q.localize(36,null)},"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[Q.localize(37,null),Q.localize(38,null),Q.localize(39,null),Q.localize(40,null)],default:"same",description:Q.localize(41,null)},"editor.mouseWheelScrollSensitivity":{type:"number",default:ue.viewInfo.scrollbar.mouseWheelScrollSensitivity,markdownDescription:Q.localize(42,null)},"editor.multiCursorModifier":{type:"string",enum:["ctrlCmd","alt"],markdownEnumDescriptions:[Q.localize(43,null),Q.localize(44,null)],default:"alt",markdownDescription:Q.localize(45,null)},"editor.multiCursorMergeOverlapping":{type:"boolean",default:ue.multiCursorMergeOverlapping,description:Q.localize(46,null)},"editor.quickSuggestions":{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:!1,description:Q.localize(47,null)},comments:{type:"boolean",default:!1,description:Q.localize(48,null)},other:{type:"boolean",default:!0,description:Q.localize(49,null)}}}],default:ue.contribInfo.quickSuggestions,description:Q.localize(50,null)},"editor.quickSuggestionsDelay":{type:"integer",default:ue.contribInfo.quickSuggestionsDelay,minimum:0,description:Q.localize(51,null)},"editor.parameterHints.enabled":{type:"boolean",default:ue.contribInfo.parameterHints.enabled,description:Q.localize(52,null)},"editor.parameterHints.cycle":{type:"boolean",default:ue.contribInfo.parameterHints.cycle,description:Q.localize(53,null)},"editor.autoClosingBrackets":{type:"string",enum:["always","languageDefined","beforeWhitespace","never"],enumDescriptions:["",Q.localize(54,null),Q.localize(55,null),""],default:ue.autoClosingBrackets,description:Q.localize(56,null)},"editor.autoClosingQuotes":{type:"string",enum:["always","languageDefined","beforeWhitespace","never"],enumDescriptions:["",Q.localize(57,null),Q.localize(58,null),""],default:ue.autoClosingQuotes,description:Q.localize(59,null)},"editor.autoSurround":{type:"string",enum:["languageDefined","brackets","quotes","never"],enumDescriptions:[Q.localize(60,null),Q.localize(61,null),Q.localize(62,null),""],default:ue.autoSurround,description:Q.localize(63,null)},"editor.formatOnType":{type:"boolean",default:ue.contribInfo.formatOnType,description:Q.localize(64,null)},"editor.formatOnPaste":{type:"boolean",default:ue.contribInfo.formatOnPaste,description:Q.localize(65,null)},"editor.autoIndent":{type:"boolean",default:ue.autoIndent,description:Q.localize(66,null)},"editor.suggestOnTriggerCharacters":{type:"boolean",default:ue.contribInfo.suggestOnTriggerCharacters,description:Q.localize(67,null)},"editor.acceptSuggestionOnEnter":{type:"string",enum:["on","smart","off"],default:ue.contribInfo.acceptSuggestionOnEnter,markdownEnumDescriptions:["",Q.localize(68,null),""],markdownDescription:Q.localize(69,null)},"editor.acceptSuggestionOnCommitCharacter":{type:"boolean",default:ue.contribInfo.acceptSuggestionOnCommitCharacter,markdownDescription:Q.localize(70,null)},"editor.snippetSuggestions":{type:"string",enum:["top","bottom","inline","none"],enumDescriptions:[Q.localize(71,null),Q.localize(72,null),Q.localize(73,null),Q.localize(74,null)],default:ue.contribInfo.suggest.snippets,description:Q.localize(75,null)},"editor.emptySelectionClipboard":{type:"boolean",default:ue.emptySelectionClipboard,description:Q.localize(76,null)},"editor.copyWithSyntaxHighlighting":{type:"boolean",default:ue.copyWithSyntaxHighlighting,description:Q.localize(77,null)},"editor.wordBasedSuggestions":{type:"boolean",default:ue.contribInfo.wordBasedSuggestions,description:Q.localize(78,null)},"editor.suggestSelection":{type:"string",enum:["first","recentlyUsed","recentlyUsedByPrefix"],markdownEnumDescriptions:[Q.localize(79,null),Q.localize(80,null),Q.localize(81,null)],default:"recentlyUsed",description:Q.localize(82,null)},"editor.suggestFontSize":{type:"integer",default:0,minimum:0,markdownDescription:Q.localize(83,null)},"editor.suggestLineHeight":{type:"integer",default:0,minimum:0,markdownDescription:Q.localize(84,null)},"editor.tabCompletion":{type:"string",default:"off",enum:["on","off","onlySnippets"],enumDescriptions:[Q.localize(85,null),Q.localize(86,null),Q.localize(87,null)],description:Q.localize(88,null)},"editor.suggest.filterGraceful":{type:"boolean",default:!0,description:Q.localize(89,null)},"editor.suggest.localityBonus":{type:"boolean",default:!1,description:Q.localize(90,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:!0,description:Q.localize(91,null)},"editor.selectionHighlight":{type:"boolean",default:ue.contribInfo.selectionHighlight,description:Q.localize(92,null)},"editor.occurrencesHighlight":{type:"boolean",default:ue.contribInfo.occurrencesHighlight,description:Q.localize(93,null)},"editor.overviewRulerLanes":{type:"integer",default:3,description:Q.localize(94,null)},"editor.overviewRulerBorder":{type:"boolean",default:ue.viewInfo.overviewRulerBorder,description:Q.localize(95,null)},"editor.cursorBlinking":{type:"string",enum:["blink","smooth","phase","expand","solid"],default:oe.blinkingStyleToString(ue.viewInfo.cursorBlinking),description:Q.localize(96,null)},"editor.mouseWheelZoom":{type:"boolean",default:ue.viewInfo.mouseWheelZoom,markdownDescription:Q.localize(97,null)},"editor.cursorStyle":{type:"string",enum:["block","block-outline","line","line-thin","underline","underline-thin"],default:oe.cursorStyleToString(ue.viewInfo.cursorStyle),description:Q.localize(98,null)},"editor.cursorWidth":{type:"integer",default:ue.viewInfo.cursorWidth,markdownDescription:Q.localize(99,null)},"editor.fontLigatures":{type:"boolean",default:ue.viewInfo.fontLigatures,description:Q.localize(100,null)},"editor.hideCursorInOverviewRuler":{type:"boolean",default:ue.viewInfo.hideCursorInOverviewRuler,description:Q.localize(101,null)},"editor.renderWhitespace":{type:"string",enum:["none","boundary","all"],enumDescriptions:["",Q.localize(102,null),""],default:ue.viewInfo.renderWhitespace,description:Q.localize(103,null)},"editor.renderControlCharacters":{type:"boolean",default:ue.viewInfo.renderControlCharacters,description:Q.localize(104,null)},"editor.renderIndentGuides":{type:"boolean",default:ue.viewInfo.renderIndentGuides,description:Q.localize(105,null)},"editor.highlightActiveIndentGuide":{type:"boolean",default:ue.viewInfo.highlightActiveIndentGuide,description:Q.localize(106,null)},"editor.renderLineHighlight":{type:"string",enum:["none","gutter","line","all"],enumDescriptions:["","","",Q.localize(107,null)],default:ue.viewInfo.renderLineHighlight,description:Q.localize(108,null)},"editor.codeLens":{type:"boolean",default:ue.contribInfo.codeLens,description:Q.localize(109,null)},"editor.folding":{type:"boolean",default:ue.contribInfo.folding,description:Q.localize(110,null)},"editor.foldingStrategy":{type:"string",enum:["auto","indentation"],default:ue.contribInfo.foldingStrategy,markdownDescription:Q.localize(111,null)},"editor.showFoldingControls":{type:"string",enum:["always","mouseover"],default:ue.contribInfo.showFoldingControls,description:Q.localize(112,null)},"editor.matchBrackets":{type:"boolean",default:ue.contribInfo.matchBrackets,description:Q.localize(113,null)},"editor.glyphMargin":{type:"boolean",default:ue.viewInfo.glyphMargin,description:Q.localize(114,null)},"editor.useTabStops":{type:"boolean",default:ue.useTabStops,description:Q.localize(115,null)},"editor.trimAutoWhitespace":{type:"boolean",default:ce.trimAutoWhitespace,description:Q.localize(116,null)},"editor.stablePeek":{type:"boolean",default:!1,markdownDescription:Q.localize(117,null)},"editor.dragAndDrop":{type:"boolean",default:ue.dragAndDrop,description:Q.localize(118,null)},"editor.accessibilitySupport":{type:"string",enum:["auto","on","off"],enumDescriptions:[Q.localize(119,null),Q.localize(120,null),Q.localize(121,null)],default:ue.accessibilitySupport,description:Q.localize(122,null)},"editor.showUnused":{type:"boolean",default:ue.showUnused,description:Q.localize(123,null)},"editor.links":{type:"boolean",default:ue.contribInfo.links,description:Q.localize(124,null)},"editor.colorDecorators":{type:"boolean",default:ue.contribInfo.colorDecorators,description:Q.localize(125,null)},"editor.lightbulb.enabled":{type:"boolean",default:ue.contribInfo.lightbulbEnabled,description:Q.localize(126,null)},"editor.codeActionsOnSave":{type:"object",properties:{"source.organizeImports":{type:"boolean",description:Q.localize(127,null)}},additionalProperties:{type:"boolean"},default:ue.contribInfo.codeActionsOnSave,description:Q.localize(128,null)},"editor.codeActionsOnSaveTimeout":{type:"number",default:ue.contribInfo.codeActionsOnSaveTimeout,description:Q.localize(129,null)},"editor.selectionClipboard":{type:"boolean",default:ue.contribInfo.selectionClipboard,description:Q.localize(130,null),included:ie.isLinux},"diffEditor.renderSideBySide":{type:"boolean",default:!0,description:Q.localize(131,null)},"diffEditor.ignoreTrimWhitespace":{type:"boolean",default:!0,description:Q.localize(132,null)},"editor.largeFileOptimizations":{type:"boolean",default:ce.largeFileOptimizations,description:Q.localize(133,null)},"diffEditor.renderIndicators":{type:"boolean",default:!0,description:Q.localize(134,null)}}},me=null;$.isEditorConfigurationKey=function(X){return p()["editor."+X]||!1},$.isDiffEditorConfigurationKey=function(X){return p()["diffEditor."+X]||!1},fe.registerConfiguration(ge)})),define(Q[57],n([0,1,29,6,2,17,407,409,125,122]),(function(X,$,Q,J,ee,ne,ie,oe,re,se){Object.defineProperty($,"__esModule",{value:!0});var ae=function(){function e(){this._keys=Object.create(null),this._values=Object.create(null)}return e.prototype.has=function(X){var $=X.getId();return!!this._values[$]},e.prototype.get=function(X){var $=X.getId();return this._values[$]},e.prototype.put=function(X,$){var Q=X.getId();this._keys[Q]=X,this._values[Q]=$},e.prototype.remove=function(X){var $=X.getId();delete this._keys[$],delete this._values[$]},e.prototype.getValues=function(){var X=this;return Object.keys(this._keys).map((function($){return X._values[$]}))},e}(),le=function(X){function t(){var $=X.call(this)||this;return $._onDidChange=$._register(new J.Emitter),$.onDidChange=$._onDidChange.event,$._cache=new ae,$._evictUntrustedReadingsTimeout=-1,$}return te(t,X),t.prototype.dispose=function(){-1!==this._evictUntrustedReadingsTimeout&&(clearTimeout(this._evictUntrustedReadingsTimeout),this._evictUntrustedReadingsTimeout=-1),X.prototype.dispose.call(this)},t.prototype._writeToCache=function(X,$){var Q=this;this._cache.put(X,$),$.isTrusted||-1!==this._evictUntrustedReadingsTimeout||(this._evictUntrustedReadingsTimeout=setTimeout((function(){Q._evictUntrustedReadingsTimeout=-1,Q._evictUntrustedReadings()}),5e3))},t.prototype._evictUntrustedReadings=function(){for(var X=this._cache.getValues(),$=!1,Q=0,J=X.length;Q<J;Q++){var ee=X[Q];ee.isTrusted||($=!0,this._cache.remove(ee))}$&&this._onDidChange.fire()},t.prototype.readConfiguration=function(X){if(!this._cache.has(X)){var $=t._actualReadConfiguration(X);($.typicalHalfwidthCharacterWidth<=2||$.typicalFullwidthCharacterWidth<=2||$.spaceWidth<=2||$.maxDigitWidth<=2)&&($=new se.FontInfo({zoomLevel:Q.getZoomLevel(),fontFamily:$.fontFamily,fontWeight:$.fontWeight,fontSize:$.fontSize,lineHeight:$.lineHeight,letterSpacing:$.letterSpacing,isMonospace:$.isMonospace,typicalHalfwidthCharacterWidth:Math.max($.typicalHalfwidthCharacterWidth,5),typicalFullwidthCharacterWidth:Math.max($.typicalFullwidthCharacterWidth,5),canUseHalfwidthRightwardsArrow:$.canUseHalfwidthRightwardsArrow,spaceWidth:Math.max($.spaceWidth,5),maxDigitWidth:Math.max($.maxDigitWidth,5)},!1)),this._writeToCache(X,$)}return this._cache.get(X)},t.createRequest=function(X,$,Q,J){var ee=new ie.CharWidthRequest(X,$);return Q.push(ee),J&&J.push(ee),ee},t._actualReadConfiguration=function(X){var $=[],J=[],ee=this.createRequest("n",0,$,J),te=this.createRequest("ｍ",0,$,null),ne=this.createRequest(" ",0,$,J),oe=this.createRequest("0",0,$,J),re=this.createRequest("1",0,$,J),ae=this.createRequest("2",0,$,J),le=this.createRequest("3",0,$,J),ue=this.createRequest("4",0,$,J),de=this.createRequest("5",0,$,J),ce=this.createRequest("6",0,$,J),he=this.createRequest("7",0,$,J),pe=this.createRequest("8",0,$,J),fe=this.createRequest("9",0,$,J),ge=this.createRequest("→",0,$,J),me=this.createRequest("￫",0,$,null);this.createRequest("·",0,$,J),this.createRequest("|",0,$,J),this.createRequest("/",0,$,J),this.createRequest("-",0,$,J),this.createRequest("_",0,$,J),this.createRequest("i",0,$,J),this.createRequest("l",0,$,J),this.createRequest("m",0,$,J),this.createRequest("|",1,$,J),this.createRequest("_",1,$,J),this.createRequest("i",1,$,J),this.createRequest("l",1,$,J),this.createRequest("m",1,$,J),this.createRequest("n",1,$,J),this.createRequest("|",2,$,J),this.createRequest("_",2,$,J),this.createRequest("i",2,$,J),this.createRequest("l",2,$,J),this.createRequest("m",2,$,J),this.createRequest("n",2,$,J),ie.readCharWidths(X,$);for(var ve=Math.max(oe.width,re.width,ae.width,le.width,ue.width,de.width,ce.width,he.width,pe.width,fe.width),_e=!0,ye=J[0].width,be=1,Ce=J.length;be<Ce;be++){var we=ye-J[be].width;if(we<-.001||we>.001){_e=!1;break}}var Se=!0;_e&&me.width!==ye&&(Se=!1),me.width>ge.width&&(Se=!1);var Ee=Q.getTimeSinceLastZoomLevelChanged()>2e3;return new se.FontInfo({zoomLevel:Q.getZoomLevel(),fontFamily:X.fontFamily,fontWeight:X.fontWeight,fontSize:X.fontSize,lineHeight:X.lineHeight,letterSpacing:X.letterSpacing,isMonospace:_e,typicalHalfwidthCharacterWidth:ee.width,typicalFullwidthCharacterWidth:te.width,canUseHalfwidthRightwardsArrow:Se,spaceWidth:ne.width,maxDigitWidth:ve},Ee)},t.INSTANCE=new t,t}(ee.Disposable),ue=function(X){function t($,J){void 0===J&&(J=null);var ee=X.call(this,$)||this;return ee._elementSizeObserver=ee._register(new oe.ElementSizeObserver(J,(function(){return ee._onReferenceDomElementSizeChanged()}))),ee._register(le.INSTANCE.onDidChange((function(){return ee._onCSSBasedConfigurationChanged()}))),ee._validatedOptions.automaticLayout&&ee._elementSizeObserver.startObserving(),ee._register(Q.onDidChangeZoomLevel((function(X){return ee._recomputeOptions()}))),ee._register(Q.onDidChangeAccessibilitySupport((function(){return ee._recomputeOptions()}))),ee._recomputeOptions(),ee}return te(t,X),t.applyFontInfoSlow=function(X,$){X.style.fontFamily=$.getMassagedFontFamily(),X.style.fontWeight=$.fontWeight,X.style.fontSize=$.fontSize+"px",X.style.lineHeight=$.lineHeight+"px",X.style.letterSpacing=$.letterSpacing+"px"},t.applyFontInfo=function(X,$){X.setFontFamily($.getMassagedFontFamily()),X.setFontWeight($.fontWeight),X.setFontSize($.fontSize),X.setLineHeight($.lineHeight),X.setLetterSpacing($.letterSpacing)},t.prototype._onReferenceDomElementSizeChanged=function(){this._recomputeOptions()},t.prototype._onCSSBasedConfigurationChanged=function(){this._recomputeOptions()},t.prototype.observeReferenceElement=function(X){this._elementSizeObserver.observe(X)},t.prototype.dispose=function(){X.prototype.dispose.call(this)},t.prototype._getExtraEditorClassName=function(){var X="";return Q.isIE?X+="ie ":Q.isFirefox?X+="ff ":Q.isEdge?X+="edge ":Q.isSafari&&(X+="safari "),ne.isMacintosh&&(X+="mac "),X},t.prototype._getEnvConfiguration=function(){return{extraEditorClassName:this._getExtraEditorClassName(),outerWidth:this._elementSizeObserver.getWidth(),outerHeight:this._elementSizeObserver.getHeight(),emptySelectionClipboard:Q.isWebKit||Q.isFirefox,pixelRatio:Q.getPixelRatio(),zoomLevel:Q.getZoomLevel(),accessibilitySupport:Q.getAccessibilitySupport()}},t.prototype.readConfiguration=function(X){return le.INSTANCE.readConfiguration(X)},t}(re.CommonEditorConfiguration);$.Configuration=ue})),define(Q[433],n([0,1,23,57,127,33]),(function(X,$,Q,J,ee,ne){Object.defineProperty($,"__esModule",{value:!0});var ie=function(X){function t($){var Q=X.call(this,$)||this;return Q._visibleLines=new ee.VisibleLinesCollection(Q),Q.domNode=Q._visibleLines.domNode,Q._dynamicOverlays=[],Q._isFocused=!1,Q.domNode.setClassName("view-overlays"),Q}return te(t,X),t.prototype.shouldRender=function(){if(X.prototype.shouldRender.call(this))return!0;for(var $=0,Q=this._dynamicOverlays.length;$<Q;$++)if(this._dynamicOverlays[$].shouldRender())return!0;return!1},t.prototype.dispose=function(){X.prototype.dispose.call(this);for(var $=0,Q=this._dynamicOverlays.length;$<Q;$++)this._dynamicOverlays[$].dispose();this._dynamicOverlays=[]},t.prototype.getDomNode=function(){return this.domNode},t.prototype.createVisibleLine=function(){return new oe(this._context.configuration,this._dynamicOverlays)},t.prototype.addDynamicOverlay=function(X){this._dynamicOverlays.push(X)},t.prototype.onConfigurationChanged=function(X){this._visibleLines.onConfigurationChanged(X);for(var $=this._visibleLines.getStartLineNumber(),Q=this._visibleLines.getEndLineNumber(),J=$;J<=Q;J++)this._visibleLines.getVisibleLine(J).onConfigurationChanged(X);return!0},t.prototype.onFlushed=function(X){return this._visibleLines.onFlushed(X)},t.prototype.onFocusChanged=function(X){return this._isFocused=X.isFocused,!0},t.prototype.onLinesChanged=function(X){return this._visibleLines.onLinesChanged(X)},t.prototype.onLinesDeleted=function(X){return this._visibleLines.onLinesDeleted(X)},t.prototype.onLinesInserted=function(X){return this._visibleLines.onLinesInserted(X)},t.prototype.onScrollChanged=function(X){return this._visibleLines.onScrollChanged(X)||!0},t.prototype.onTokensChanged=function(X){return this._visibleLines.onTokensChanged(X)},t.prototype.onZonesChanged=function(X){return this._visibleLines.onZonesChanged(X)},t.prototype.prepareRender=function(X){for(var $=this._dynamicOverlays.filter((function(X){return X.shouldRender()})),Q=0,J=$.length;Q<J;Q++){var ee=$[Q];ee.prepareRender(X),ee.onDidRender()}},t.prototype.render=function(X){this._viewOverlaysRender(X),this.domNode.toggleClassName("focused",this._isFocused)},t.prototype._viewOverlaysRender=function(X){this._visibleLines.renderLines(X.viewportData)},t}(ne.ViewPart);$.ViewOverlays=ie;var oe=function(){function e(X,$){this._configuration=X,this._lineHeight=this._configuration.editor.lineHeight,this._dynamicOverlays=$,this._domNode=null,this._renderedContent=null}return e.prototype.getDomNode=function(){return this._domNode?this._domNode.domNode:null},e.prototype.setDomNode=function(X){this._domNode=Q.createFastDomNode(X)},e.prototype.onContentChanged=function(){},e.prototype.onTokensChanged=function(){},e.prototype.onConfigurationChanged=function(X){X.lineHeight&&(this._lineHeight=this._configuration.editor.lineHeight)},e.prototype.renderLine=function(X,$,Q,J){for(var ee="",te=0,ne=this._dynamicOverlays.length;te<ne;te++)ee+=this._dynamicOverlays[te].render(Q.startLineNumber,X);return this._renderedContent!==ee&&(this._renderedContent=ee,J.appendASCIIString('<div style="position:absolute;top:'),J.appendASCIIString(String($)),J.appendASCIIString("px;width:100%;height:"),J.appendASCIIString(String(this._lineHeight)),J.appendASCIIString('px;">'),J.appendASCIIString(ee),J.appendASCIIString("</div>"),!0)},e.prototype.layoutLine=function(X,$){this._domNode&&(this._domNode.setTop($),this._domNode.setHeight(this._lineHeight))},e}();$.ViewOverlayLine=oe;var re=function(X){function t($){var Q=X.call(this,$)||this;return Q._contentWidth=Q._context.configuration.editor.layoutInfo.contentWidth,Q.domNode.setHeight(0),Q}return te(t,X),t.prototype.onConfigurationChanged=function($){return $.layoutInfo&&(this._contentWidth=this._context.configuration.editor.layoutInfo.contentWidth),X.prototype.onConfigurationChanged.call(this,$)},t.prototype.onScrollChanged=function($){return X.prototype.onScrollChanged.call(this,$)||$.scrollWidthChanged},t.prototype._viewOverlaysRender=function($){X.prototype._viewOverlaysRender.call(this,$),this.domNode.setWidth(Math.max($.scrollWidth,this._contentWidth))},t}(ie);$.ContentViewOverlays=re;var se=function(X){function t($){var Q=X.call(this,$)||this;return Q._contentLeft=Q._context.configuration.editor.layoutInfo.contentLeft,Q.domNode.setClassName("margin-view-overlays"),Q.domNode.setWidth(1),J.Configuration.applyFontInfo(Q.domNode,Q._context.configuration.editor.fontInfo),Q}return te(t,X),t.prototype.onConfigurationChanged=function($){var Q=!1;return $.fontInfo&&(J.Configuration.applyFontInfo(this.domNode,this._context.configuration.editor.fontInfo),Q=!0),$.layoutInfo&&(this._contentLeft=this._context.configuration.editor.layoutInfo.contentLeft,Q=!0),X.prototype.onConfigurationChanged.call(this,$)||Q},t.prototype.onScrollChanged=function($){return X.prototype.onScrollChanged.call(this,$)||$.scrollHeightChanged},t.prototype._viewOverlaysRender=function($){X.prototype._viewOverlaysRender.call(this,$);var Q=Math.min($.scrollHeight,1e6);this.domNode.setHeight(Q),this.domNode.setWidth(this._contentLeft)},t}(ie);$.MarginViewOverlays=se})),define(Q[434],n([0,1,7,23,8,57,48,12,3]),(function(X,$,Q,J,ee,te,ne,ie,oe){Object.defineProperty($,"__esModule",{value:!0});var u=function(X,$,Q,J,ee,te){this.top=X,this.left=$,this.width=Q,this.height=J,this.textContent=ee,this.textContentClassName=te},re=function(){function e(X){this._context=X,this._cursorStyle=this._context.configuration.editor.viewInfo.cursorStyle,this._lineHeight=this._context.configuration.editor.lineHeight,this._typicalHalfwidthCharacterWidth=this._context.configuration.editor.fontInfo.typicalHalfwidthCharacterWidth,this._lineCursorWidth=Math.min(this._context.configuration.editor.viewInfo.cursorWidth,this._typicalHalfwidthCharacterWidth),this._isVisible=!0,this._domNode=J.createFastDomNode(document.createElement("div")),this._domNode.setClassName("cursor"),this._domNode.setHeight(this._lineHeight),this._domNode.setTop(0),this._domNode.setLeft(0),te.Configuration.applyFontInfo(this._domNode,this._context.configuration.editor.fontInfo),this._domNode.setDisplay("none"),this.updatePosition(new ie.Position(1,1)),this._lastRenderedContent="",this._renderData=null}return e.prototype.getDomNode=function(){return this._domNode},e.prototype.getPosition=function(){return this._position},e.prototype.show=function(){this._isVisible||(this._domNode.setVisibility("inherit"),this._isVisible=!0)},e.prototype.hide=function(){this._isVisible&&(this._domNode.setVisibility("hidden"),this._isVisible=!1)},e.prototype.onConfigurationChanged=function(X){return X.lineHeight&&(this._lineHeight=this._context.configuration.editor.lineHeight),X.fontInfo&&(te.Configuration.applyFontInfo(this._domNode,this._context.configuration.editor.fontInfo),this._typicalHalfwidthCharacterWidth=this._context.configuration.editor.fontInfo.typicalHalfwidthCharacterWidth),X.viewInfo&&(this._cursorStyle=this._context.configuration.editor.viewInfo.cursorStyle,this._lineCursorWidth=Math.min(this._context.configuration.editor.viewInfo.cursorWidth,this._typicalHalfwidthCharacterWidth)),!0},e.prototype.onCursorPositionChanged=function(X){return this.updatePosition(X),!0},e.prototype._prepareRender=function(X){var $="",J="";if(this._cursorStyle===ne.TextEditorCursorStyle.Line||this._cursorStyle===ne.TextEditorCursorStyle.LineThin){var te,ie=X.visibleRangeForPosition(this._position);if(!ie)return null;this._cursorStyle===ne.TextEditorCursorStyle.Line?(te=Q.computeScreenAwareSize(this._lineCursorWidth>0?this._lineCursorWidth:2))>2&&($=this._context.model.getLineContent(this._position.lineNumber).charAt(this._position.column-1)):te=Q.computeScreenAwareSize(1);var re=ie.left;te>=2&&re>=1&&(re-=1);var se=X.getVerticalOffsetForLineNumber(this._position.lineNumber)-X.bigNumbersDelta;return new u(se,re,te,this._lineHeight,$,J)}var ae=X.linesVisibleRangesForRange(new oe.Range(this._position.lineNumber,this._position.column,this._position.lineNumber,this._position.column+1),!1);if(!ae||0===ae.length||0===ae[0].ranges.length)return null;var le=ae[0].ranges[0],ue=le.width<1?this._typicalHalfwidthCharacterWidth:le.width;if(this._cursorStyle===ne.TextEditorCursorStyle.Block){var de=this._context.model.getViewLineData(this._position.lineNumber);$=de.content.charAt(this._position.column-1),ee.isHighSurrogate(de.content.charCodeAt(this._position.column-1))&&($+=de.content.charAt(this._position.column));var ce=de.tokens.findTokenIndexAtOffset(this._position.column-1);J=de.tokens.getClassName(ce)}var he=X.getVerticalOffsetForLineNumber(this._position.lineNumber)-X.bigNumbersDelta,pe=this._lineHeight;return this._cursorStyle!==ne.TextEditorCursorStyle.Underline&&this._cursorStyle!==ne.TextEditorCursorStyle.UnderlineThin||(he+=this._lineHeight-2,pe=2),new u(he,le.left,ue,pe,$,J)},e.prototype.prepareRender=function(X){this._renderData=this._prepareRender(X)},e.prototype.render=function(X){return this._renderData?(this._lastRenderedContent!==this._renderData.textContent&&(this._lastRenderedContent=this._renderData.textContent,this._domNode.domNode.textContent=this._lastRenderedContent),this._domNode.setClassName("cursor "+this._renderData.textContentClassName),this._domNode.setDisplay("block"),this._domNode.setTop(this._renderData.top),this._domNode.setLeft(this._renderData.left),this._domNode.setWidth(this._renderData.width),this._domNode.setLineHeight(this._renderData.height),this._domNode.setHeight(this._renderData.height),{domNode:this._domNode.domNode,position:this._position,contentLeft:this._renderData.left,height:this._renderData.height,width:2}):(this._domNode.setDisplay("none"),null)},e.prototype.updatePosition=function(X){this._position=X},e}();$.ViewCursor=re})),define(Q[435],n([0,1,11,6,2,424,8,14,104,51,82,41]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le){Object.defineProperty($,"__esModule",{value:!0});var ue=Object.prototype.hasOwnProperty,de=function(X){function t($,Q){void 0===$&&($=!0),void 0===Q&&(Q=!1);var ee=X.call(this)||this;return ee._onDidChange=ee._register(new J.Emitter),ee.onDidChange=ee._onDidChange.event,ee._nextLanguageId=1,ee._languages={},ee._mimeTypesMap={},ee._nameMap={},ee._lowercaseNameMap={},ee._languageIds=[],ee._warnOnOverwrite=Q,$&&(ee._registerLanguages(re.ModesRegistry.getLanguages()),ee._register(re.ModesRegistry.onDidAddLanguages((function(X){return ee._registerLanguages(X)})))),ee}return te(t,X),t.prototype._registerLanguages=function(X){var $=this;if(0!==X.length){for(var Q=0;Q<X.length;Q++)this._registerLanguage(X[Q]);this._mimeTypesMap={},this._nameMap={},this._lowercaseNameMap={},Object.keys(this._languages).forEach((function(X){var Q=$._languages[X];Q.name&&($._nameMap[Q.name]=Q.identifier),Q.aliases.forEach((function(X){$._lowercaseNameMap[X.toLowerCase()]=Q.identifier})),Q.mimetypes.forEach((function(X){$._mimeTypesMap[X]=Q.identifier}))})),le.Registry.as(ae.Extensions.Configuration).registerOverrideIdentifiers(re.ModesRegistry.getLanguages().map((function(X){return X.id}))),this._onDidChange.fire()}},t.prototype._registerLanguage=function(X){var $,Q=X.id;if(ue.call(this._languages,Q))$=this._languages[Q];else{var J=this._nextLanguageId++;$={identifier:new oe.LanguageIdentifier(Q,J),name:null,mimetypes:[],aliases:[],extensions:[],filenames:[],configurationFiles:[]},this._languageIds[J]=Q,this._languages[Q]=$}this._mergeLanguage($,X)},t.prototype._mergeLanguage=function(X,$){var J,ee=$.id,te=null;if(Array.isArray($.mimetypes)&&$.mimetypes.length>0&&((J=X.mimetypes).push.apply(J,$.mimetypes),te=$.mimetypes[0]),te||(te="text/x-"+ee,X.mimetypes.push(te)),Array.isArray($.extensions))for(var oe=0,re=$.extensions;oe<re.length;oe++){var se=re[oe];ne.registerTextMime({id:ee,mime:te,extension:se},this._warnOnOverwrite),X.extensions.push(se)}if(Array.isArray($.filenames))for(var ae=0,le=$.filenames;ae<le.length;ae++){var ue=le[ae];ne.registerTextMime({id:ee,mime:te,filename:ue},this._warnOnOverwrite),X.filenames.push(ue)}if(Array.isArray($.filenamePatterns))for(var de=0,ce=$.filenamePatterns;de<ce.length;de++){var he=ce[de];ne.registerTextMime({id:ee,mime:te,filepattern:he},this._warnOnOverwrite)}if("string"==typeof $.firstLine&&$.firstLine.length>0){var pe=$.firstLine;"^"!==pe.charAt(0)&&(pe="^"+pe);try{var fe=new RegExp(pe);ie.regExpLeadsToEndlessLoop(fe)||ne.registerTextMime({id:ee,mime:te,firstline:fe},this._warnOnOverwrite)}catch(X){Q.onUnexpectedError(X)}}X.aliases.push(ee);var ge=null;if(void 0!==$.aliases&&Array.isArray($.aliases)&&(ge=0===$.aliases.length?[null]:$.aliases),null!==ge)for(var me=0;me<ge.length;me++){var ve=ge[me];ve&&0!==ve.length&&X.aliases.push(ve)}var _e=null!==ge&&ge.length>0;if(_e&&null===ge[0]);else{var ye=(_e?ge[0]:null)||ee;!_e&&X.name||(X.name=ye)}$.configuration&&X.configurationFiles.push($.configuration)},t.prototype.isRegisteredMode=function(X){return!!ue.call(this._mimeTypesMap,X)||ue.call(this._languages,X)},t.prototype.getModeIdForLanguageNameLowercase=function(X){return ue.call(this._lowercaseNameMap,X)?this._lowercaseNameMap[X].language:null},t.prototype.extractModeIds=function(X){var $=this;return X?X.split(",").map((function(X){return X.trim()})).map((function(X){return ue.call($._mimeTypesMap,X)?$._mimeTypesMap[X].language:X})).filter((function(X){return ue.call($._languages,X)})):[]},t.prototype.getLanguageIdentifier=function(X){if(X===se.NULL_MODE_ID||0===X)return se.NULL_LANGUAGE_IDENTIFIER;var $;if("string"==typeof X)$=X;else if(!($=this._languageIds[X]))return null;return ue.call(this._languages,$)?this._languages[$].identifier:null},t.prototype.getModeIdsFromFilepathOrFirstLine=function(X,$){if(!X&&!$)return[];var Q=ne.guessMimeTypes(X,$);return this.extractModeIds(Q.join(","))},t}(ee.Disposable);$.LanguagesRegistry=de})),define(Q[436],n([0,1,6,2,507,51,435]),(function(X,$,Q,J,ee,ne,ie){Object.defineProperty($,"__esModule",{value:!0});var oe=function(X){function t($,J){var ee=X.call(this)||this;return ee._onDidChange=ee._register(new Q.Emitter),ee.onDidChange=ee._onDidChange.event,ee._selector=J,ee.languageIdentifier=ee._selector(),ee._register($((function(){return ee._evaluate()}))),ee}return te(t,X),t.prototype._evaluate=function(){var X=this._selector();X.id!==this.languageIdentifier.id&&(this.languageIdentifier=X,this._onDidChange.fire(this.languageIdentifier))},t}(J.Disposable),re=function(){function e(X){void 0===X&&(X=!1);var $=this;this._onDidCreateMode=new Q.Emitter,this.onDidCreateMode=this._onDidCreateMode.event,this._onLanguagesMaybeChanged=new Q.Emitter,this.onLanguagesMaybeChanged=this._onLanguagesMaybeChanged.event,this._instantiatedModes={},this._registry=new ie.LanguagesRegistry(!0,X),this._registry.onDidChange((function(){return $._onLanguagesMaybeChanged.fire()}))}return e.prototype.isRegisteredMode=function(X){return this._registry.isRegisteredMode(X)},e.prototype.getModeIdForLanguageName=function(X){return this._registry.getModeIdForLanguageNameLowercase(X)},e.prototype.getModeIdByFilepathOrFirstLine=function(X,$){var Q=this._registry.getModeIdsFromFilepathOrFirstLine(X,$);return Q.length>0?Q[0]:null},e.prototype.getModeId=function(X){var $=this._registry.extractModeIds(X);return $.length>0?$[0]:null},e.prototype.getLanguageIdentifier=function(X){return this._registry.getLanguageIdentifier(X)},e.prototype.create=function(X){var $=this;return new oe(this.onLanguagesMaybeChanged,(function(){var Q=$.getModeId(X);return $._createModeAndGetLanguageIdentifier(Q)}))},e.prototype.createByFilepathOrFirstLine=function(X,$){var Q=this;return new oe(this.onLanguagesMaybeChanged,(function(){var J=Q.getModeIdByFilepathOrFirstLine(X,$);return Q._createModeAndGetLanguageIdentifier(J)}))},e.prototype._createModeAndGetLanguageIdentifier=function(X){var $=this.getLanguageIdentifier(X||"plaintext")||ne.NULL_LANGUAGE_IDENTIFIER;return this._getOrCreateMode($.language),$},e.prototype.triggerMode=function(X){var $=this.getModeId(X);this._getOrCreateMode($||"plaintext")},e.prototype._getOrCreateMode=function(X){if(!this._instantiatedModes.hasOwnProperty(X)){var $=this.getLanguageIdentifier(X)||ne.NULL_LANGUAGE_IDENTIFIER;this._instantiatedModes[X]=new ee.FrankensteinMode($),this._onDidCreateMode.fire(this._instantiatedModes[X])}return this._instantiatedModes[X]},e}();$.ModeServiceImpl=re})),define(Q[45],n([0,1,41,15,82]),(function(X,$,Q,J,ee){function r(X,$,Q,J){for(var ee=$.split("."),te=ee.pop(),ne=X,ie=0;ie<ee.length;ie++){var oe=ee[ie],re=ne[oe];switch(typeof re){case"undefined":re=ne[oe]=Object.create(null);break;case"object":break;default:return void J("Ignoring "+$+" as "+ee.slice(0,ie+1).join(".")+" is "+JSON.stringify(re))}ne=re}"object"==typeof ne?ne[te]=Q:J("Ignoring "+$+" as "+ee.join(".")+" is "+JSON.stringify(ne))}function s(X,$){var Q=$.shift();if(0!==$.length){if(-1!==Object.keys(X).indexOf(Q)){var J=X[Q];"object"!=typeof J||Array.isArray(J)||(s(J,$),0===Object.keys(J).length&&delete X[Q])}}else delete X[Q]}Object.defineProperty($,"__esModule",{value:!0}),$.IConfigurationService=J.createDecorator("configurationService"),$.toValuesTree=function(X,$){var Q=Object.create(null);for(var J in X)r(Q,J,X[J],$);return Q},$.addToValueTree=r,$.removeFromValueTree=function(X,$){s(X,$.split("."))},$.getConfigurationValue=function(X,$,Q){var J=function(X,$){for(var Q=X,J=0;J<$.length;J++){if("object"!=typeof Q||null===Q)return;Q=Q[$[J]]}return Q}(X,$.split("."));return void 0===J?Q:J},$.getConfigurationKeys=function(){var X=Q.Registry.as(ee.Extensions.Configuration).getConfigurationProperties();return Object.keys(X)},$.getDefaultValues=function(){var X=Object.create(null),$=Q.Registry.as(ee.Extensions.Configuration).getConfigurationProperties();for(var J in $)r(X,J,$[J].default,(function(X){return console.error("Conflict in default settings: "+X)}));return X},$.overrideIdentifierFromKey=function(X){return X.substring(1,X.length-1)}})),define(Q[438],n([0,1,65,22,32,27,82,45]),(function(X,$,Q,J,ee,ne,ie,oe){Object.defineProperty($,"__esModule",{value:!0});var re=function(){function e(X,$,Q){void 0===X&&(X={}),void 0===$&&($=[]),void 0===Q&&(Q=[]),this._contents=X,this._keys=$,this._overrides=Q,this.isFrozen=!1}return Object.defineProperty(e.prototype,"contents",{get:function(){return this.checkAndFreeze(this._contents)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"overrides",{get:function(){return this.checkAndFreeze(this._overrides)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"keys",{get:function(){return this.checkAndFreeze(this._keys)},enumerable:!0,configurable:!0}),e.prototype.getValue=function(X){return X?oe.getConfigurationValue(this.contents,X):this.contents},e.prototype.override=function(X){var $=this.getContentsForOverrideIdentifer(X);if(!$||"object"!=typeof $||!Object.keys($).length)return this;for(var Q={},ee=0,te=J.distinct(Object.keys(this.contents).concat(Object.keys($)));ee<te.length;ee++){var ie=te[ee],oe=this.contents[ie],re=$[ie];re&&("object"==typeof oe&&"object"==typeof re?(oe=ne.deepClone(oe),this.mergeContents(oe,re)):oe=re),Q[ie]=oe}return new e(Q)},e.prototype.merge=function(){for(var X=[],$=0;$<arguments.length;$++)X[$]=arguments[$];for(var Q=ne.deepClone(this.contents),ee=ne.deepClone(this.overrides),te=this.keys.slice(),ie=0,oe=X;ie<oe.length;ie++){var re=oe[ie];this.mergeContents(Q,re.contents);for(var c=function(X){var $=ee.filter((function($){return J.equals($.identifiers,X.identifiers)}))[0];$?se.mergeContents($.contents,X.contents):ee.push(ne.deepClone(X))},se=this,ae=0,le=re.overrides;ae<le.length;ae++)c(le[ae]);for(var ue=0,de=re.keys;ue<de.length;ue++){var ce=de[ue];-1===te.indexOf(ce)&&te.push(ce)}}return new e(Q,te,ee)},e.prototype.freeze=function(){return this.isFrozen=!0,this},e.prototype.mergeContents=function(X,$){for(var Q=0,J=Object.keys($);Q<J.length;Q++){var te=J[Q];te in X&&ee.isObject(X[te])&&ee.isObject($[te])?this.mergeContents(X[te],$[te]):X[te]=ne.deepClone($[te])}},e.prototype.checkAndFreeze=function(X){return this.isFrozen&&!Object.isFrozen(X)?ne.deepFreeze(X):X},e.prototype.getContentsForOverrideIdentifer=function(X){for(var $=0,Q=this.overrides;$<Q.length;$++){var J=Q[$];if(-1!==J.identifiers.indexOf(X))return J.contents}return null},e.prototype.toJSON=function(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}},e.prototype.setValue=function(X,$){this.addKey(X),oe.addToValueTree(this.contents,X,$,(function(X){throw new Error(X)}))},e.prototype.removeValue=function(X){this.removeKey(X)&&oe.removeFromValueTree(this.contents,X)},e.prototype.addKey=function(X){for(var $=this.keys.length,Q=0;Q<$;Q++)0===X.indexOf(this.keys[Q])&&($=Q);this.keys.splice($,1,X)},e.prototype.removeKey=function(X){var $=this.keys.indexOf(X);return-1!==$&&(this.keys.splice($,1),!0)},e}();$.ConfigurationModel=re;var se=function(X){function t(){for(var $=oe.getDefaultValues(),Q=oe.getConfigurationKeys(),J=[],ee=0,te=Object.keys($);ee<te.length;ee++){var ne=te[ee];ie.OVERRIDE_PROPERTY_PATTERN.test(ne)&&J.push({identifiers:[oe.overrideIdentifierFromKey(ne).trim()],contents:oe.toValuesTree($[ne],(function(X){return console.error("Conflict in default settings file: "+X)}))})}return X.call(this,$,Q,J)||this}return te(t,X),t}(re);$.DefaultConfigurationModel=se;var ae=function(){function e(X,$,J,ee,te,ne,ie){void 0===J&&(J=new re),void 0===ee&&(ee=new Q.ResourceMap),void 0===te&&(te=new re),void 0===ne&&(ne=new Q.ResourceMap),void 0===ie&&(ie=!0),this._defaultConfiguration=X,this._userConfiguration=$,this._workspaceConfiguration=J,this._folderConfigurations=ee,this._memoryConfiguration=te,this._memoryConfigurationByResource=ne,this._freeze=ie,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new Q.ResourceMap}return e.prototype.getValue=function(X,$,Q){return this.getConsolidateConfigurationModel($,Q).getValue(X)},e.prototype.updateValue=function(X,$,Q){var J;void 0===Q&&(Q={}),Q.resource?(J=this._memoryConfigurationByResource.get(Q.resource))||(J=new re,this._memoryConfigurationByResource.set(Q.resource,J)):J=this._memoryConfiguration,void 0===$?J.removeValue(X):J.setValue(X,$),Q.resource||(this._workspaceConsolidatedConfiguration=null)},e.prototype.getConsolidateConfigurationModel=function(X,$){var Q=this.getConsolidatedConfigurationModelForResource(X,$);return X.overrideIdentifier?Q.override(X.overrideIdentifier):Q},e.prototype.getConsolidatedConfigurationModelForResource=function(X,$){var Q=X.resource,J=this.getWorkspaceConsolidatedConfiguration();if($&&Q){var ee=$.getFolder(Q);ee&&(J=this.getFolderConsolidatedConfiguration(ee.uri)||J);var te=this._memoryConfigurationByResource.get(Q);te&&(J=J.merge(te))}return J},e.prototype.getWorkspaceConsolidatedConfiguration=function(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this._userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration},e.prototype.getFolderConsolidatedConfiguration=function(X){var $=this._foldersConsolidatedConfigurations.get(X);if(!$){var Q=this.getWorkspaceConsolidatedConfiguration(),J=this._folderConfigurations.get(X);J?($=Q.merge(J),this._freeze&&($=$.freeze()),this._foldersConsolidatedConfigurations.set(X,$)):$=Q}return $},e}();$.Configuration=ae})),define(Q[439],n([0,1,6,2,65,31,45,18,155]),(function(X,$,Q,J,ee,ie,re,se,ae){Object.defineProperty($,"__esModule",{value:!0});var le="data-keybinding-context",ue=function(){function e(X,$){this._id=X,this._parent=$,this._value=Object.create(null),this._value._contextId=X}return e.prototype.setValue=function(X,$){return this._value[X]!==$&&(this._value[X]=$,!0)},e.prototype.removeValue=function(X){return X in this._value&&(delete this._value[X],!0)},e.prototype.getValue=function(X){var $=this._value[X];return void 0===$&&this._parent?this._parent.getValue(X):$},e}();$.Context=ue;var de=function(X){function t(){return X.call(this,-1,null)||this}return te(t,X),t.prototype.setValue=function(X,$){return!1},t.prototype.removeValue=function(X){return!1},t.prototype.getValue=function(X){},t.INSTANCE=new t,t}(ue),ce=function(X){function t($,Q,J){var te=X.call(this,$,null)||this;return te._configurationService=Q,te._values=new Map,te._listener=te._configurationService.onDidChangeConfiguration((function(X){if(4===X.source){var $=ee.keys(te._values);te._values.clear(),J.fire($)}else{for(var Q=[],ne=0,ie=X.affectedKeys;ne<ie.length;ne++){var oe="config."+ie[ne];te._values.has(oe)&&(te._values.delete(oe),Q.push(oe))}J.fire(Q)}})),te}return te(t,X),t.prototype.dispose=function(){this._listener.dispose()},t.prototype.getValue=function($){if(0!==$.indexOf(t._keyPrefix))return X.prototype.getValue.call(this,$);if(this._values.has($))return this._values.get($);var Q=$.substr(t._keyPrefix.length),J=this._configurationService.getValue(Q),ee=void 0;switch(typeof J){case"number":case"boolean":case"string":ee=J}return this._values.set($,ee),ee},t.prototype.setValue=function($,Q){return X.prototype.setValue.call(this,$,Q)},t.prototype.removeValue=function($){return X.prototype.removeValue.call(this,$)},t._keyPrefix="config.",t}(ue),he=function(){function e(X,$,Q){this._parent=X,this._key=$,this._defaultValue=Q,this.reset()}return e.prototype.set=function(X){this._parent.setContext(this._key,X)},e.prototype.reset=function(){void 0===this._defaultValue?this._parent.removeContext(this._key):this._parent.setContext(this._key,this._defaultValue)},e.prototype.get=function(){return this._parent.getContextKeyValue(this._key)},e}(),pe=function(){function e(){this._keys=[]}return e.prototype.collect=function(X){this._keys=this._keys.concat(X)},e.prototype.affectsSome=function(X){for(var $=0,Q=this._keys;$<Q.length;$++){var J=Q[$];if(X.has(J))return!0}return!1},e}();$.ContextKeyChangeEvent=pe;var fe=function(){function e(X){this._isDisposed=!1,this._myContextId=X,this._onDidChangeContextKey=new Q.Emitter}return e.prototype.createKey=function(X,$){if(this._isDisposed)throw new Error("AbstractContextKeyService has been disposed");return new he(this,X,$)},Object.defineProperty(e.prototype,"onDidChangeContext",{get:function(){return this._onDidChangeContext||(this._onDidChangeContext=Q.debounceEvent(this._onDidChangeContextKey.event,(function(X,$){return X||(X=new pe),X.collect($),X}),25)),this._onDidChangeContext},enumerable:!0,configurable:!0}),e.prototype.createScoped=function(X){if(this._isDisposed)throw new Error("AbstractContextKeyService has been disposed");return new me(this,this._onDidChangeContextKey,X)},e.prototype.contextMatchesRules=function(X){if(this._isDisposed)throw new Error("AbstractContextKeyService has been disposed");var $=this.getContextValuesContainer(this._myContextId);return ae.KeybindingResolver.contextMatchesRules($,X)},e.prototype.getContextKeyValue=function(X){if(!this._isDisposed)return this.getContextValuesContainer(this._myContextId).getValue(X)},e.prototype.setContext=function(X,$){if(!this._isDisposed){var Q=this.getContextValuesContainer(this._myContextId);Q&&Q.setValue(X,$)&&this._onDidChangeContextKey.fire(X)}},e.prototype.removeContext=function(X){this._isDisposed||this.getContextValuesContainer(this._myContextId).removeValue(X)&&this._onDidChangeContextKey.fire(X)},e.prototype.getContext=function(X){return this._isDisposed?de.INSTANCE:this.getContextValuesContainer(function(X){for(;X;){if(X.hasAttribute(le)){var $=X.getAttribute(le);return $?parseInt($,10):NaN}X=X.parentElement}return 0}(X))},e}();$.AbstractContextKeyService=fe;var ge=function(X){function t($){var Q=X.call(this,0)||this;Q._toDispose=[],Q._lastContextId=0,Q._contexts=Object.create(null);var J=new ce(Q._myContextId,$,Q._onDidChangeContextKey);return Q._contexts[String(Q._myContextId)]=J,Q._toDispose.push(J),Q}return te(t,X),t.prototype.dispose=function(){this._isDisposed=!0,this._toDispose=J.dispose(this._toDispose)},t.prototype.getContextValuesContainer=function(X){return this._isDisposed?de.INSTANCE:this._contexts[String(X)]},t.prototype.createChildContext=function(X){if(void 0===X&&(X=this._myContextId),this._isDisposed)throw new Error("ContextKeyService has been disposed");var $=++this._lastContextId;return this._contexts[String($)]=new ue($,this.getContextValuesContainer(X)),$},t.prototype.disposeContext=function(X){this._isDisposed||delete this._contexts[String(X)]},ne([oe(0,re.IConfigurationService)],t)}(fe);$.ContextKeyService=ge;var me=function(X){function t($,Q,J){var ee=X.call(this,$.createChildContext())||this;return ee._parent=$,ee._onDidChangeContextKey=Q,J&&(ee._domNode=J,ee._domNode.setAttribute(le,String(ee._myContextId))),ee}return te(t,X),t.prototype.dispose=function(){this._isDisposed=!0,this._parent.disposeContext(this._myContextId),this._domNode&&(this._domNode.removeAttribute(le),this._domNode=void 0)},Object.defineProperty(t.prototype,"onDidChangeContext",{get:function(){return this._parent.onDidChangeContext},enumerable:!0,configurable:!0}),t.prototype.getContextValuesContainer=function(X){return this._isDisposed?de.INSTANCE:this._parent.getContextValuesContainer(X)},t.prototype.createChildContext=function(X){if(void 0===X&&(X=this._myContextId),this._isDisposed)throw new Error("ScopedContextKeyService has been disposed");return this._parent.createChildContext(X)},t.prototype.disposeContext=function(X){this._isDisposed||this._parent.disposeContext(X)},t}(fe);ie.CommandsRegistry.registerCommand(se.SET_CONTEXT_COMMAND_ID,(function(X,$,Q){X.get(se.IContextKeyService).createKey(String($),Q)}))})),define(Q[95],n([0,1,36,17,31,41]),(function(X,$,Q,J,ee,te){function s(X,$){return X.weight1!==$.weight1?X.weight1-$.weight1:X.command<$.command?-1:X.command>$.command?1:X.weight2-$.weight2}Object.defineProperty($,"__esModule",{value:!0});var ne=function(){function e(){this._keybindings=[],this._keybindingsSorted=!0}return e.bindToCurrentPlatform=function(X){if(1===J.OS){if(X&&X.win)return X.win}else if(2===J.OS){if(X&&X.mac)return X.mac}else if(X&&X.linux)return X.linux;return X},e.prototype.registerKeybindingRule=function(X,$){void 0===$&&($=0);var ee=e.bindToCurrentPlatform(X);if(ee&&ee.primary&&(oe=Q.createKeybinding(ee.primary,J.OS))&&this._registerDefaultKeybinding(oe,X.id,X.weight,0,X.when,$),ee&&Array.isArray(ee.secondary))for(var te=0,ne=ee.secondary.length;te<ne;te++){var ie=ee.secondary[te],oe=Q.createKeybinding(ie,J.OS);oe&&this._registerDefaultKeybinding(oe,X.id,X.weight,-te-1,X.when,$)}},e.prototype.registerCommandAndKeybindingRule=function(X,$){void 0===$&&($=0),this.registerKeybindingRule(X,$),ee.CommandsRegistry.registerCommand(X)},e._mightProduceChar=function(X){return X>=21&&X<=30||X>=31&&X<=56||80===X||81===X||82===X||83===X||84===X||85===X||86===X||110===X||111===X||87===X||88===X||89===X||90===X||91===X||92===X},e.prototype._assertNoCtrlAlt=function(X,$){X.ctrlKey&&X.altKey&&!X.metaKey&&e._mightProduceChar(X.keyCode)&&console.warn("Ctrl+Alt+ keybindings should not be used by default under Windows. Offender: ",X," for ",$)},e.prototype._registerDefaultKeybinding=function(X,$,Q,ee,te,ne){0===ne&&1===J.OS&&(2===X.type?this._assertNoCtrlAlt(X.firstPart,$):this._assertNoCtrlAlt(X,$)),this._keybindings.push({keybinding:X,command:$,commandArgs:void 0,when:te,weight1:Q,weight2:ee}),this._keybindingsSorted=!1},e.prototype.getDefaultKeybindings=function(){return this._keybindingsSorted||(this._keybindings.sort(s),this._keybindingsSorted=!0),this._keybindings.slice(0)},e}();$.KeybindingsRegistry=new ne,$.Extensions={EditorModes:"platform.keybindingsRegistry"},te.Registry.add($.Extensions.EditorModes,$.KeybindingsRegistry)})),define(Q[71],n([0,1,15,6]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0}),$.IStorageService=Q.createDecorator("storageService"),$.NullStorageService=new(function(){function e(){this._serviceBrand=void 0,this.onDidChangeStorage=J.Event.None,this.onWillSaveState=J.Event.None}return e.prototype.get=function(X,$,Q){return Q},e.prototype.getBoolean=function(X,$,Q){return Q},e.prototype.getInteger=function(X,$,Q){return Q},e.prototype.store=function(X,$,Q){return Promise.resolve()},e.prototype.remove=function(X,$){return Promise.resolve()},e}())})),define(Q[442],n([0,1,65,71,14,2]),(function(X,$,Q,J,ee,ie){Object.defineProperty($,"__esModule",{value:!0});var re=function(){function e(){}return e.prototype.select=function(X,$,Q){if(0===Q.length)return 0;for(var J=Q[0].score,ee=1;ee<Q.length;ee++){var te=Q[ee],ne=te.score,ie=te.suggestion;if(ne!==J)break;if(ie.preselect)return ee}return 0},e}();$.Memory=re;var se=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype.memorize=function(X,$,Q){},t.prototype.toJSON=function(){},t.prototype.fromJSON=function(){},t}(re);$.NoMemory=se;var ae=function(X){function t(){var $=null!==X&&X.apply(this,arguments)||this;return $._cache=new Q.LRUCache(300,.66),$._seq=0,$}return te(t,X),t.prototype.memorize=function(X,$,Q){var J=Q.suggestion.label,ee=X.getLanguageIdentifier().language+"/"+J;this._cache.set(ee,{touch:this._seq++,type:Q.suggestion.kind,insertText:Q.suggestion.insertText})},t.prototype.select=function($,Q,J){if(0!==$.getWordUntilPosition(Q).word.length)return X.prototype.select.call(this,$,Q,J);var ee=$.getLineContent(Q.lineNumber).substr(Q.column-10,Q.column-1);if(/\s$/.test(ee))return X.prototype.select.call(this,$,Q,J);for(var te=-1,ne=-1,ie=0;ie<J.length;ie++){var oe=J[ie].suggestion,re=$.getLanguageIdentifier().language+"/"+oe.label,se=this._cache.get(re);se&&se.touch>ne&&se.type===oe.kind&&se.insertText===oe.insertText&&(ne=se.touch,te=ie)}return-1===te?X.prototype.select.call(this,$,Q,J):te},t.prototype.toJSON=function(){var X=[];return this._cache.forEach((function($,Q){X.push([Q,$])})),X},t.prototype.fromJSON=function(X){this._cache.clear();for(var $=0,Q=X;$<Q.length;$++){var J=Q[$],te=J[0],ne=J[1];ne.touch=0,ne.type="number"==typeof ne.type?ne.type:ee.completionKindFromLegacyString(ne.type),this._cache.set(te,ne)}this._seq=this._cache.size},t}(re);$.LRUMemory=ae;var le=function(X){function t(){var $=null!==X&&X.apply(this,arguments)||this;return $._trie=Q.TernarySearchTree.forStrings(),$._seq=0,$}return te(t,X),t.prototype.memorize=function(X,$,Q){var J=X.getWordUntilPosition($).word,ee=X.getLanguageIdentifier().language+"/"+J;this._trie.set(ee,{type:Q.suggestion.kind,insertText:Q.suggestion.insertText,touch:this._seq++})},t.prototype.select=function($,Q,J){var ee=$.getWordUntilPosition(Q).word;if(!ee)return X.prototype.select.call(this,$,Q,J);var te=$.getLanguageIdentifier().language+"/"+ee,ne=this._trie.get(te);if(ne||(ne=this._trie.findSubstr(te)),ne)for(var ie=0;ie<J.length;ie++){var oe=J[ie].suggestion,re=oe.kind,se=oe.insertText;if(re===ne.type&&se===ne.insertText)return ie}return X.prototype.select.call(this,$,Q,J)},t.prototype.toJSON=function(){var X=[];return this._trie.forEach((function($,Q){return X.push([Q,$])})),X.sort((function(X,$){return-(X[1].touch-$[1].touch)})).forEach((function(X,$){return X[1].touch=$})),X.slice(0,200)},t.prototype.fromJSON=function(X){if(this._trie.clear(),X.length>0){this._seq=X[0][1].touch+1;for(var $=0,Q=X;$<Q.length;$++){var J=Q[$],te=J[0],ne=J[1];ne.type="number"==typeof ne.type?ne.type:ee.completionKindFromLegacyString(ne.type),this._trie.set(te,ne)}}},t}(re);$.PrefixMemory=le;var ue=function(X){function t($,Q){var J=X.call(this)||this;return J._storageService=Q,J._storagePrefix="suggest/memories",J._setMode($.getConfiguration().contribInfo.suggestSelection),J._register($.onDidChangeConfiguration((function(X){return X.contribInfo&&J._setMode($.getConfiguration().contribInfo.suggestSelection)}))),J._register(Q.onWillSaveState((function(){return J._saveState()}))),J}return te(t,X),t.prototype._setMode=function(X){if(this._mode!==X){this._mode=X,this._strategy="recentlyUsedByPrefix"===X?new le:"recentlyUsed"===X?new ae:new se;try{var $=this._storageService.get(this._storagePrefix+"/"+this._mode,1);$&&this._strategy.fromJSON(JSON.parse($))}catch(X){}}},t.prototype.memorize=function(X,$,Q){this._strategy.memorize(X,$,Q)},t.prototype.select=function(X,$,Q){return this._strategy.select(X,$,Q)},t.prototype._saveState=function(){var X=JSON.stringify(this._strategy);this._storageService.store(this._storagePrefix+"/"+this._mode,X,1)},ne([oe(1,J.IStorageService)],t)}(ie.Disposable);$.SuggestMemories=ue})),define(Q[70],n([0,1,15]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),$.ITelemetryService=Q.createDecorator("telemetryService")})),define(Q[10],n([0,1,16,11,25,30,12,42,92,37,31,18,95,41,70]),(function(X,$,Q,J,ee,ne,oe,re,se,ae,le,ue,de,ce,he){function v(X,$){le.CommandsRegistry.registerCommand(X,(function(X,Q){return $(X,Q||{})}))}Object.defineProperty($,"__esModule",{value:!0});var pe=function(){function e(X){this.id=X.id,this.precondition=X.precondition,this._kbOpts=X.kbOpts,this._menubarOpts=X.menubarOpts,this._description=X.description}return e.prototype.register=function(){var X=this;if(this._menubarOpts&&ae.MenuRegistry.appendMenuItem(this._menubarOpts.menuId,{group:this._menubarOpts.group,command:{id:this.id,title:this._menubarOpts.title},when:this._menubarOpts.when,order:this._menubarOpts.order}),this._kbOpts){var $=this._kbOpts.kbExpr;this.precondition&&($=$?ue.ContextKeyExpr.and($,this.precondition):this.precondition),de.KeybindingsRegistry.registerCommandAndKeybindingRule({id:this.id,handler:function($,Q){return X.runCommand($,Q)},weight:this._kbOpts.weight,when:$||null,primary:this._kbOpts.primary,secondary:this._kbOpts.secondary,win:this._kbOpts.win,linux:this._kbOpts.linux,mac:this._kbOpts.mac,description:this._description})}else le.CommandsRegistry.registerCommand({id:this.id,handler:function($,Q){return X.runCommand($,Q)},description:this._description})},e}();$.Command=pe;var fe=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.bindToContribution=function(X){return function($){function n(X){var Q=$.call(this,X)||this;return Q._callback=X.handler,Q}return te(n,$),n.prototype.runEditorCommand=function($,Q,J){X(Q)&&this._callback(X(Q))},n}(t)},t.prototype.runCommand=function(X,$){var Q=this,J=X.get(ne.ICodeEditorService),ee=J.getFocusedCodeEditor()||J.getActiveCodeEditor();if(ee)return ee.invokeWithinContext((function(X){if(X.get(ue.IContextKeyService).contextMatchesRules(Q.precondition))return Q.runEditorCommand(X,ee,$)}))},t}(pe);$.EditorCommand=fe;var ge=function(X){function t($){var Q=X.call(this,$)||this;return Q.label=$.label,Q.alias=$.alias,Q.menuOpts=$.menuOpts,Q}return te(t,X),t.prototype.register=function(){this.menuOpts&&ae.MenuRegistry.appendMenuItem(ae.MenuId.EditorContext,{command:{id:this.id,title:this.label},when:ue.ContextKeyExpr.and(this.precondition,this.menuOpts.when),group:this.menuOpts.group,order:this.menuOpts.order}),X.prototype.register.call(this)},t.prototype.runEditorCommand=function(X,$,Q){return this.reportTelemetry(X,$),this.run(X,$,Q||{})},t.prototype.reportTelemetry=function(X,$){X.get(he.ITelemetryService).publicLog("editorActionInvoked",ie({name:this.label,id:this.id},$.getTelemetryData()))},t}(fe);$.EditorAction=ge,$.registerLanguageCommand=v,$.registerDefaultLanguageCommand=function(X,$){v(X,(function(X,te){var ne=te.resource,ie=te.position;if(!(ne instanceof ee.URI))throw J.illegalArgument("resource");if(!oe.Position.isIPosition(ie))throw J.illegalArgument("position");var ae=X.get(re.IModelService).getModel(ne);if(ae){var le=oe.Position.lift(ie);return $(ae,le,te)}return X.get(se.ITextModelService).createModelReference(ne).then((function(X){return Q.always(new Promise((function(Q,J){try{Q($(X.object.textEditorModel,oe.Position.lift(ie),te))}catch(X){J(X)}})),(function(){X.dispose()}))}))}))},$.registerEditorCommand=function(X){return me.INSTANCE.registerEditorCommand(X),X},$.registerEditorAction=function(X){me.INSTANCE.registerEditorAction(new X)},$.registerInstantiatedEditorAction=function(X){me.INSTANCE.registerEditorAction(X)},$.registerEditorContribution=function(X){me.INSTANCE.registerEditorContribution(X)},function(X){X.getEditorCommand=function(X){return me.INSTANCE.getEditorCommand(X)},X.getEditorActions=function(){return me.INSTANCE.getEditorActions()},X.getEditorContributions=function(){return me.INSTANCE.getEditorContributions()}}($.EditorExtensionsRegistry||($.EditorExtensionsRegistry={}));var me=function(){function e(){this.editorContributions=[],this.editorActions=[],this.editorCommands=Object.create(null)}return e.prototype.registerEditorContribution=function(X){this.editorContributions.push(X)},e.prototype.registerEditorAction=function(X){X.register(),this.editorActions.push(X)},e.prototype.getEditorContributions=function(){return this.editorContributions.slice(0)},e.prototype.getEditorActions=function(){return this.editorActions.slice(0)},e.prototype.registerEditorCommand=function(X){X.register(),this.editorCommands[X.id]=X},e.prototype.getEditorCommand=function(X){return this.editorCommands[X]||null},e.INSTANCE=new e,e}();ce.Registry.add("editor.contributions",me.INSTANCE)})),define(Q[132],n([0,1,289,32,10,30,372,38,182,188,137,12,3,54,19,37,18]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le,ue,de,ce,he,pe){function _(X){X.register()}function y(X){_(new ye("default:"+X,X)),_(new ye(X,X))}Object.defineProperty($,"__esModule",{value:!0});var fe,ge,me,ve=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype.runEditorCommand=function(X,$,Q){var J=$._getCursors();J&&this.runCoreEditorCommand(J,Q||{})},t}(ee.EditorCommand);$.CoreEditorCommand=ve,function(X){X.description={description:"Scroll editor in the given direction",args:[{name:"Editor scroll argument object",description:"Property-value pairs that can be passed through this argument:\n\t\t\t\t\t* 'to': A mandatory direction value.\n\t\t\t\t\t\t```\n\t\t\t\t\t\t'up', 'down'\n\t\t\t\t\t\t```\n\t\t\t\t\t* 'by': Unit to move. Default is computed based on 'to' value.\n\t\t\t\t\t\t```\n\t\t\t\t\t\t'line', 'wrappedLine', 'page', 'halfPage'\n\t\t\t\t\t\t```\n\t\t\t\t\t* 'value': Number of units to move. Default is '1'.\n\t\t\t\t\t* 'revealCursor': If 'true' reveals the cursor if it is outside view port.\n\t\t\t\t",constraint:function(X){if(!J.isObject(X))return!1;var $=X;return!(!J.isString($.to)||!J.isUndefined($.by)&&!J.isString($.by)||!J.isUndefined($.value)&&!J.isNumber($.value)||!J.isUndefined($.revealCursor)&&!J.isBoolean($.revealCursor))}}]},X.RawDirection={Up:"up",Down:"down"},X.RawUnit={Line:"line",WrappedLine:"wrappedLine",Page:"page",HalfPage:"halfPage"},X.parse=function($){var Q,J;switch($.to){case X.RawDirection.Up:Q=1;break;case X.RawDirection.Down:Q=2;break;default:return null}switch($.by){case X.RawUnit.Line:J=1;break;case X.RawUnit.WrappedLine:J=2;break;case X.RawUnit.Page:J=3;break;case X.RawUnit.HalfPage:J=4;break;default:J=2}return{direction:Q,unit:J,value:Math.floor($.value||1),revealCursor:!!$.revealCursor,select:!!$.select}}}(fe=$.EditorScroll_||($.EditorScroll_={})),function(X){X.description={description:"Reveal the given line at the given logical position",args:[{name:"Reveal line argument object",description:"Property-value pairs that can be passed through this argument:\n\t\t\t\t\t* 'lineNumber': A mandatory line number value.\n\t\t\t\t\t* 'at': Logical position at which line has to be revealed .\n\t\t\t\t\t\t```\n\t\t\t\t\t\t'top', 'center', 'bottom'\n\t\t\t\t\t\t```\n\t\t\t\t",constraint:function(X){if(!J.isObject(X))return!1;var $=X;return!(!J.isNumber($.lineNumber)||!J.isUndefined($.at)&&!J.isString($.at))}}]},X.RawAtArgument={Top:"top",Center:"center",Bottom:"bottom"}}(ge=$.RevealLine_||($.RevealLine_={})),function(X){var $=function(X){function t($){var Q=X.call(this,$)||this;return Q._inSelectionMode=$.inSelectionMode,Q}return te(t,X),t.prototype.runCoreEditorCommand=function(X,$){X.context.model.pushStackElement(),X.setStates($.source,3,[se.CursorMoveCommands.moveTo(X.context,X.getPrimaryCursor(),this._inSelectionMode,$.position,$.viewPosition)]),X.reveal(!0,0,0)},t}(ve);X.MoveTo=ee.registerEditorCommand(new $({id:"_moveTo",inSelectionMode:!1,precondition:null})),X.MoveToSelect=ee.registerEditorCommand(new $({id:"_moveToSelect",inSelectionMode:!0,precondition:null}));var Q=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype.runCoreEditorCommand=function(X,$){X.context.model.pushStackElement();var Q=this._getColumnSelectResult(X.context,X.getPrimaryCursor(),X.getColumnSelectData(),$);X.setStates($.source,3,Q.viewStates.map((function(X){return oe.CursorState.fromViewState(X)}))),X.setColumnSelectData({toViewLineNumber:Q.toLineNumber,toViewVisualColumn:Q.toVisualColumn}),X.reveal(!0,Q.reversed?1:2,0)},t}(ve);X.ColumnSelect=ee.registerEditorCommand(new(function(X){function t(){return X.call(this,{id:"columnSelect",precondition:null})||this}return te(t,X),t.prototype._getColumnSelectResult=function(X,$,Q,J){var ee,te=X.model.validatePosition(J.position);return ee=J.viewPosition?X.validateViewPosition(new le.Position(J.viewPosition.lineNumber,J.viewPosition.column),te):X.convertModelPositionToViewPosition(te),ie.ColumnSelection.columnSelect(X.config,X.viewModel,$.viewState.selection,ee.lineNumber,J.mouseColumn-1)},t}(Q))),X.CursorColumnSelectLeft=ee.registerEditorCommand(new(function(X){function t(){return X.call(this,{id:"cursorColumnSelectLeft",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:3599,linux:{primary:0}}})||this}return te(t,X),t.prototype._getColumnSelectResult=function(X,$,Q,J){return ie.ColumnSelection.columnSelectLeft(X.config,X.viewModel,$.viewState,Q.toViewLineNumber,Q.toViewVisualColumn)},t}(Q))),X.CursorColumnSelectRight=ee.registerEditorCommand(new(function(X){function t(){return X.call(this,{id:"cursorColumnSelectRight",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:3601,linux:{primary:0}}})||this}return te(t,X),t.prototype._getColumnSelectResult=function(X,$,Q,J){return ie.ColumnSelection.columnSelectRight(X.config,X.viewModel,$.viewState,Q.toViewLineNumber,Q.toViewVisualColumn)},t}(Q)));var J=function(X){function t($){var Q=X.call(this,$)||this;return Q._isPaged=$.isPaged,Q}return te(t,X),t.prototype._getColumnSelectResult=function(X,$,Q,J){return ie.ColumnSelection.columnSelectUp(X.config,X.viewModel,$.viewState,this._isPaged,Q.toViewLineNumber,Q.toViewVisualColumn)},t}(Q);X.CursorColumnSelectUp=ee.registerEditorCommand(new J({isPaged:!1,id:"cursorColumnSelectUp",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:3600,linux:{primary:0}}})),X.CursorColumnSelectPageUp=ee.registerEditorCommand(new J({isPaged:!0,id:"cursorColumnSelectPageUp",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:3595,linux:{primary:0}}}));var ne=function(X){function t($){var Q=X.call(this,$)||this;return Q._isPaged=$.isPaged,Q}return te(t,X),t.prototype._getColumnSelectResult=function(X,$,Q,J){return ie.ColumnSelection.columnSelectDown(X.config,X.viewModel,$.viewState,this._isPaged,Q.toViewLineNumber,Q.toViewVisualColumn)},t}(Q);X.CursorColumnSelectDown=ee.registerEditorCommand(new ne({isPaged:!1,id:"cursorColumnSelectDown",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:3602,linux:{primary:0}}})),X.CursorColumnSelectPageDown=ee.registerEditorCommand(new ne({isPaged:!0,id:"cursorColumnSelectPageDown",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:3596,linux:{primary:0}}}));var re=function(X){function t(){return X.call(this,{id:"cursorMove",precondition:null,description:se.CursorMove.description})||this}return te(t,X),t.prototype.runCoreEditorCommand=function(X,$){var Q=se.CursorMove.parse($);Q&&this._runCursorMove(X,$.source,Q)},t.prototype._runCursorMove=function(X,$,Q){X.context.model.pushStackElement(),X.setStates($,3,se.CursorMoveCommands.move(X.context,X.getAll(),Q)),X.reveal(!0,0,0)},t}(ve);X.CursorMoveImpl=re,X.CursorMove=ee.registerEditorCommand(new re);var ae=function($){function n(X){var Q=$.call(this,X)||this;return Q._staticArgs=X.args,Q}return te(n,$),n.prototype.runCoreEditorCommand=function($,Q){var J=this._staticArgs;-1===this._staticArgs.value&&(J={direction:this._staticArgs.direction,unit:this._staticArgs.unit,select:this._staticArgs.select,value:$.context.config.pageSize}),X.CursorMove._runCursorMove($,Q.source,J)},n}(ve);X.CursorLeft=ee.registerEditorCommand(new ae({args:{direction:0,unit:0,select:!1,value:1},id:"cursorLeft",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:15,mac:{primary:15,secondary:[288]}}})),X.CursorLeftSelect=ee.registerEditorCommand(new ae({args:{direction:0,unit:0,select:!0,value:1},id:"cursorLeftSelect",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:1039}})),X.CursorRight=ee.registerEditorCommand(new ae({args:{direction:1,unit:0,select:!1,value:1},id:"cursorRight",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:17,mac:{primary:17,secondary:[292]}}})),X.CursorRightSelect=ee.registerEditorCommand(new ae({args:{direction:1,unit:0,select:!0,value:1},id:"cursorRightSelect",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:1041}})),X.CursorUp=ee.registerEditorCommand(new ae({args:{direction:2,unit:2,select:!1,value:1},id:"cursorUp",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:16,mac:{primary:16,secondary:[302]}}})),X.CursorUpSelect=ee.registerEditorCommand(new ae({args:{direction:2,unit:2,select:!0,value:1},id:"cursorUpSelect",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:1040,secondary:[3088],mac:{primary:1040},linux:{primary:1040}}})),X.CursorPageUp=ee.registerEditorCommand(new ae({args:{direction:2,unit:2,select:!1,value:-1},id:"cursorPageUp",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:11}})),X.CursorPageUpSelect=ee.registerEditorCommand(new ae({args:{direction:2,unit:2,select:!0,value:-1},id:"cursorPageUpSelect",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:1035}})),X.CursorDown=ee.registerEditorCommand(new ae({args:{direction:3,unit:2,select:!1,value:1},id:"cursorDown",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:18,mac:{primary:18,secondary:[300]}}})),X.CursorDownSelect=ee.registerEditorCommand(new ae({args:{direction:3,unit:2,select:!0,value:1},id:"cursorDownSelect",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:1042,secondary:[3090],mac:{primary:1042},linux:{primary:1042}}})),X.CursorPageDown=ee.registerEditorCommand(new ae({args:{direction:3,unit:2,select:!1,value:-1},id:"cursorPageDown",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:12}})),X.CursorPageDownSelect=ee.registerEditorCommand(new ae({args:{direction:3,unit:2,select:!0,value:-1},id:"cursorPageDownSelect",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:1036}})),X.CreateCursor=ee.registerEditorCommand(new(function(X){function t(){return X.call(this,{id:"createCursor",precondition:null})||this}return te(t,X),t.prototype.runCoreEditorCommand=function(X,$){var Q,J=X.context;Q=$.wholeLine?se.CursorMoveCommands.line(J,X.getPrimaryCursor(),!1,$.position,$.viewPosition):se.CursorMoveCommands.moveTo(J,X.getPrimaryCursor(),!1,$.position,$.viewPosition);var ee=X.getAll();if(ee.length>1)for(var te=Q.modelState?Q.modelState.position:null,ne=Q.viewState?Q.viewState.position:null,ie=0,oe=ee.length;ie<oe;ie++){var re=ee[ie];if((!te||re.modelState.selection.containsPosition(te))&&(!ne||re.viewState.selection.containsPosition(ne)))return ee.splice(ie,1),X.context.model.pushStackElement(),void X.setStates($.source,3,ee)}ee.push(Q),X.context.model.pushStackElement(),X.setStates($.source,3,ee)},t}(ve))),X.LastCursorMoveToSelect=ee.registerEditorCommand(new(function(X){function t(){return X.call(this,{id:"_lastCursorMoveToSelect",precondition:null})||this}return te(t,X),t.prototype.runCoreEditorCommand=function(X,$){var Q=X.context,J=X.getLastAddedCursorIndex(),ee=X.getAll(),te=ee.slice(0);te[J]=se.CursorMoveCommands.moveTo(Q,ee[J],!0,$.position,$.viewPosition),X.context.model.pushStackElement(),X.setStates($.source,3,te)},t}(ve)));var de=function(X){function t($){var Q=X.call(this,$)||this;return Q._inSelectionMode=$.inSelectionMode,Q}return te(t,X),t.prototype.runCoreEditorCommand=function(X,$){X.context.model.pushStackElement(),X.setStates($.source,3,se.CursorMoveCommands.moveToBeginningOfLine(X.context,X.getAll(),this._inSelectionMode)),X.reveal(!0,0,0)},t}(ve);X.CursorHome=ee.registerEditorCommand(new de({inSelectionMode:!1,id:"cursorHome",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:14,mac:{primary:14,secondary:[2063]}}})),X.CursorHomeSelect=ee.registerEditorCommand(new de({inSelectionMode:!0,id:"cursorHomeSelect",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:1038,mac:{primary:1038,secondary:[3087]}}})),X.CursorLineStart=ee.registerEditorCommand(new(function(X){function t(){return X.call(this,{id:"cursorLineStart",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:0,mac:{primary:287}}})||this}return te(t,X),t.prototype.runCoreEditorCommand=function(X,$){X.context.model.pushStackElement(),X.setStates($.source,3,this._exec(X.context,X.getAll())),X.reveal(!0,0,0)},t.prototype._exec=function(X,$){for(var Q=[],J=0,ee=$.length;J<ee;J++){var te=$[J],ne=te.modelState.position.lineNumber;Q[J]=oe.CursorState.fromModelState(te.modelState.move(!1,ne,1,0))}return Q},t}(ve)));var he=function(X){function t($){var Q=X.call(this,$)||this;return Q._inSelectionMode=$.inSelectionMode,Q}return te(t,X),t.prototype.runCoreEditorCommand=function(X,$){X.context.model.pushStackElement(),X.setStates($.source,3,se.CursorMoveCommands.moveToEndOfLine(X.context,X.getAll(),this._inSelectionMode)),X.reveal(!0,0,0)},t}(ve);X.CursorEnd=ee.registerEditorCommand(new he({inSelectionMode:!1,id:"cursorEnd",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:13,mac:{primary:13,secondary:[2065]}}})),X.CursorEndSelect=ee.registerEditorCommand(new he({inSelectionMode:!0,id:"cursorEndSelect",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:1037,mac:{primary:1037,secondary:[3089]}}})),X.CursorLineEnd=ee.registerEditorCommand(new(function(X){function t(){return X.call(this,{id:"cursorLineEnd",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:0,mac:{primary:291}}})||this}return te(t,X),t.prototype.runCoreEditorCommand=function(X,$){X.context.model.pushStackElement(),X.setStates($.source,3,this._exec(X.context,X.getAll())),X.reveal(!0,0,0)},t.prototype._exec=function(X,$){for(var Q=[],J=0,ee=$.length;J<ee;J++){var te=$[J],ne=te.modelState.position.lineNumber,ie=X.model.getLineMaxColumn(ne);Q[J]=oe.CursorState.fromModelState(te.modelState.move(!1,ne,ie,0))}return Q},t}(ve)));var pe=function(X){function t($){var Q=X.call(this,$)||this;return Q._inSelectionMode=$.inSelectionMode,Q}return te(t,X),t.prototype.runCoreEditorCommand=function(X,$){X.context.model.pushStackElement(),X.setStates($.source,3,se.CursorMoveCommands.moveToBeginningOfBuffer(X.context,X.getAll(),this._inSelectionMode)),X.reveal(!0,0,0)},t}(ve);X.CursorTop=ee.registerEditorCommand(new pe({inSelectionMode:!1,id:"cursorTop",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:2062,mac:{primary:2064}}})),X.CursorTopSelect=ee.registerEditorCommand(new pe({inSelectionMode:!0,id:"cursorTopSelect",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:3086,mac:{primary:3088}}}));var me=function(X){function t($){var Q=X.call(this,$)||this;return Q._inSelectionMode=$.inSelectionMode,Q}return te(t,X),t.prototype.runCoreEditorCommand=function(X,$){X.context.model.pushStackElement(),X.setStates($.source,3,se.CursorMoveCommands.moveToEndOfBuffer(X.context,X.getAll(),this._inSelectionMode)),X.reveal(!0,0,0)},t}(ve);X.CursorBottom=ee.registerEditorCommand(new me({inSelectionMode:!1,id:"cursorBottom",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:2061,mac:{primary:2066}}})),X.CursorBottomSelect=ee.registerEditorCommand(new me({inSelectionMode:!0,id:"cursorBottomSelect",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:3085,mac:{primary:3090}}}));var _e=function(X){function t(){return X.call(this,{id:"editorScroll",precondition:null,description:fe.description})||this}return te(t,X),t.prototype.runCoreEditorCommand=function(X,$){var Q=fe.parse($);Q&&this._runEditorScroll(X,$.source,Q)},t.prototype._runEditorScroll=function(X,$,Q){var J=this._computeDesiredScrollTop(X.context,Q);if(Q.revealCursor){var ee=X.context.getCompletelyVisibleViewRangeAtScrollTop(J);X.setStates($,3,[se.CursorMoveCommands.findPositionInViewportIfOutside(X.context,X.getPrimaryCursor(),ee,Q.select)])}X.scrollTo(J)},t.prototype._computeDesiredScrollTop=function(X,$){if(1===$.unit){var Q,J=X.getCompletelyVisibleModelRange();Q=1===$.direction?Math.max(1,J.startLineNumber-$.value):Math.min(X.model.getLineCount(),J.startLineNumber+$.value);var ee=X.convertModelPositionToViewPosition(new le.Position(Q,1));return X.getVerticalOffsetForViewLine(ee.lineNumber)}var te;te=3===$.unit?X.config.pageSize*$.value:4===$.unit?Math.round(X.config.pageSize/2)*$.value:$.value;var ne=(1===$.direction?-1:1)*te;return X.getCurrentScrollTop()+ne*X.config.lineHeight},t}(ve);X.EditorScrollImpl=_e,X.EditorScroll=ee.registerEditorCommand(new _e),X.ScrollLineUp=ee.registerEditorCommand(new(function($){function n(){return $.call(this,{id:"scrollLineUp",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:2064,mac:{primary:267}}})||this}return te(n,$),n.prototype.runCoreEditorCommand=function($,Q){X.EditorScroll._runEditorScroll($,Q.source,{direction:1,unit:2,value:1,revealCursor:!1,select:!1})},n}(ve))),X.ScrollPageUp=ee.registerEditorCommand(new(function($){function n(){return $.call(this,{id:"scrollPageUp",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:2059,win:{primary:523},linux:{primary:523}}})||this}return te(n,$),n.prototype.runCoreEditorCommand=function($,Q){X.EditorScroll._runEditorScroll($,Q.source,{direction:1,unit:3,value:1,revealCursor:!1,select:!1})},n}(ve))),X.ScrollLineDown=ee.registerEditorCommand(new(function($){function n(){return $.call(this,{id:"scrollLineDown",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:2066,mac:{primary:268}}})||this}return te(n,$),n.prototype.runCoreEditorCommand=function($,Q){X.EditorScroll._runEditorScroll($,Q.source,{direction:2,unit:2,value:1,revealCursor:!1,select:!1})},n}(ve))),X.ScrollPageDown=ee.registerEditorCommand(new(function($){function n(){return $.call(this,{id:"scrollPageDown",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:2060,win:{primary:524},linux:{primary:524}}})||this}return te(n,$),n.prototype.runCoreEditorCommand=function($,Q){X.EditorScroll._runEditorScroll($,Q.source,{direction:2,unit:3,value:1,revealCursor:!1,select:!1})},n}(ve)));var ye=function(X){function t($){var Q=X.call(this,$)||this;return Q._inSelectionMode=$.inSelectionMode,Q}return te(t,X),t.prototype.runCoreEditorCommand=function(X,$){X.context.model.pushStackElement(),X.setStates($.source,3,[se.CursorMoveCommands.word(X.context,X.getPrimaryCursor(),this._inSelectionMode,$.position)]),X.reveal(!0,0,0)},t}(ve);X.WordSelect=ee.registerEditorCommand(new ye({inSelectionMode:!1,id:"_wordSelect",precondition:null})),X.WordSelectDrag=ee.registerEditorCommand(new ye({inSelectionMode:!0,id:"_wordSelectDrag",precondition:null})),X.LastCursorWordSelect=ee.registerEditorCommand(new(function(X){function t(){return X.call(this,{id:"lastCursorWordSelect",precondition:null})||this}return te(t,X),t.prototype.runCoreEditorCommand=function(X,$){var Q=X.context,J=X.getLastAddedCursorIndex(),ee=X.getAll(),te=ee.slice(0),ne=ee[J];te[J]=se.CursorMoveCommands.word(Q,ne,ne.modelState.hasSelection(),$.position),Q.model.pushStackElement(),X.setStates($.source,3,te)},t}(ve)));var be=function(X){function t($){var Q=X.call(this,$)||this;return Q._inSelectionMode=$.inSelectionMode,Q}return te(t,X),t.prototype.runCoreEditorCommand=function(X,$){X.context.model.pushStackElement(),X.setStates($.source,3,[se.CursorMoveCommands.line(X.context,X.getPrimaryCursor(),this._inSelectionMode,$.position,$.viewPosition)]),X.reveal(!1,0,0)},t}(ve);X.LineSelect=ee.registerEditorCommand(new be({inSelectionMode:!1,id:"_lineSelect",precondition:null})),X.LineSelectDrag=ee.registerEditorCommand(new be({inSelectionMode:!0,id:"_lineSelectDrag",precondition:null}));var Ce=function(X){function t($){var Q=X.call(this,$)||this;return Q._inSelectionMode=$.inSelectionMode,Q}return te(t,X),t.prototype.runCoreEditorCommand=function(X,$){var Q=X.getLastAddedCursorIndex(),J=X.getAll(),ee=J.slice(0);ee[Q]=se.CursorMoveCommands.line(X.context,J[Q],this._inSelectionMode,$.position,$.viewPosition),X.context.model.pushStackElement(),X.setStates($.source,3,ee)},t}(ve);X.LastCursorLineSelect=ee.registerEditorCommand(new Ce({inSelectionMode:!1,id:"lastCursorLineSelect",precondition:null})),X.LastCursorLineSelectDrag=ee.registerEditorCommand(new Ce({inSelectionMode:!0,id:"lastCursorLineSelectDrag",precondition:null})),X.ExpandLineSelection=ee.registerEditorCommand(new(function(X){function t(){return X.call(this,{id:"expandLineSelection",precondition:null,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:2087}})||this}return te(t,X),t.prototype.runCoreEditorCommand=function(X,$){X.context.model.pushStackElement(),X.setStates($.source,3,se.CursorMoveCommands.expandLineSelection(X.context,X.getAll())),X.reveal(!0,0,0)},t}(ve))),X.CancelSelection=ee.registerEditorCommand(new(function(X){function t(){return X.call(this,{id:"cancelSelection",precondition:ce.EditorContextKeys.hasNonEmptySelection,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:9,secondary:[1033]}})||this}return te(t,X),t.prototype.runCoreEditorCommand=function(X,$){X.context.model.pushStackElement(),X.setStates($.source,3,[se.CursorMoveCommands.cancelSelection(X.context,X.getPrimaryCursor())]),X.reveal(!0,0,0)},t}(ve))),X.RemoveSecondaryCursors=ee.registerEditorCommand(new(function(X){function t(){return X.call(this,{id:"removeSecondaryCursors",precondition:ce.EditorContextKeys.hasMultipleSelections,kbOpts:{weight:1,kbExpr:ce.EditorContextKeys.textInputFocus,primary:9,secondary:[1033]}})||this}return te(t,X),t.prototype.runCoreEditorCommand=function(X,$){X.context.model.pushStackElement(),X.setStates($.source,3,[X.getPrimaryCursor()]),X.reveal(!0,0,0)},t}(ve))),X.RevealLine=ee.registerEditorCommand(new(function(X){function t(){return X.call(this,{id:"revealLine",precondition:null,description:ge.description})||this}return te(t,X),t.prototype.runCoreEditorCommand=function(X,$){var Q=$,J=(Q.lineNumber||0)+1;J<1&&(J=1);var ee=X.context.model.getLineCount();J>ee&&(J=ee);var te=new ue.Range(J,1,J,X.context.model.getLineMaxColumn(J)),ne=0;if(Q.at)switch(Q.at){case ge.RawAtArgument.Top:ne=3;break;case ge.RawAtArgument.Center:ne=1;break;case ge.RawAtArgument.Bottom:ne=4}var ie=X.context.convertModelRangeToViewRange(te);X.revealRange(!1,ie,ne,0)},t}(ve))),X.SelectAll=ee.registerEditorCommand(new(function(X){function t(){return X.call(this,{id:"selectAll",precondition:null})||this}return te(t,X),t.prototype.runCoreEditorCommand=function(X,$){X.context.model.pushStackElement(),X.setStates($.source,3,[se.CursorMoveCommands.selectAll(X.context,X.getPrimaryCursor())])},t}(ve))),X.SetSelection=ee.registerEditorCommand(new(function(X){function t(){return X.call(this,{id:"setSelection",precondition:null})||this}return te(t,X),t.prototype.runCoreEditorCommand=function(X,$){X.context.model.pushStackElement(),X.setStates($.source,3,[oe.CursorState.fromModelSelection($.selection)])},t}(ve)))}(me=$.CoreNavigationCommands||($.CoreNavigationCommands={})),function(X){var $=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype.runEditorCommand=function(X,$,Q){var J=$._getCursors();J&&this.runCoreEditingCommand($,J,Q||{})},t}(ee.EditorCommand);X.CoreEditingCommand=$,X.LineBreakInsert=ee.registerEditorCommand(new(function(X){function t(){return X.call(this,{id:"lineBreakInsert",precondition:ce.EditorContextKeys.writable,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:0,mac:{primary:301}}})||this}return te(t,X),t.prototype.runCoreEditingCommand=function(X,$,Q){X.pushUndoStop(),X.executeCommands(this.id,ae.TypeOperations.lineBreakInsert($.context.config,$.context.model,$.getAll().map((function(X){return X.modelState.selection}))))},t}($))),X.Outdent=ee.registerEditorCommand(new(function(X){function t(){return X.call(this,{id:"outdent",precondition:ce.EditorContextKeys.writable,kbOpts:{weight:0,kbExpr:pe.ContextKeyExpr.and(ce.EditorContextKeys.editorTextFocus,ce.EditorContextKeys.tabDoesNotMoveFocus),primary:1026}})||this}return te(t,X),t.prototype.runCoreEditingCommand=function(X,$,Q){X.pushUndoStop(),X.executeCommands(this.id,ae.TypeOperations.outdent($.context.config,$.context.model,$.getAll().map((function(X){return X.modelState.selection})))),X.pushUndoStop()},t}($))),X.Tab=ee.registerEditorCommand(new(function(X){function t(){return X.call(this,{id:"tab",precondition:ce.EditorContextKeys.writable,kbOpts:{weight:0,kbExpr:pe.ContextKeyExpr.and(ce.EditorContextKeys.editorTextFocus,ce.EditorContextKeys.tabDoesNotMoveFocus),primary:2}})||this}return te(t,X),t.prototype.runCoreEditingCommand=function(X,$,Q){X.pushUndoStop(),X.executeCommands(this.id,ae.TypeOperations.tab($.context.config,$.context.model,$.getAll().map((function(X){return X.modelState.selection})))),X.pushUndoStop()},t}($))),X.DeleteLeft=ee.registerEditorCommand(new(function(X){function t(){return X.call(this,{id:"deleteLeft",precondition:ce.EditorContextKeys.writable,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:1,secondary:[1025],mac:{primary:1,secondary:[1025,294,257]}}})||this}return te(t,X),t.prototype.runCoreEditingCommand=function(X,$,Q){var J=re.DeleteOperations.deleteLeft($.getPrevEditOperationType(),$.context.config,$.context.model,$.getAll().map((function(X){return X.modelState.selection}))),ee=J[0],te=J[1];ee&&X.pushUndoStop(),X.executeCommands(this.id,te),$.setPrevEditOperationType(2)},t}($))),X.DeleteRight=ee.registerEditorCommand(new(function(X){function t(){return X.call(this,{id:"deleteRight",precondition:ce.EditorContextKeys.writable,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:20,mac:{primary:20,secondary:[290,276]}}})||this}return te(t,X),t.prototype.runCoreEditingCommand=function(X,$,Q){var J=re.DeleteOperations.deleteRight($.getPrevEditOperationType(),$.context.config,$.context.model,$.getAll().map((function(X){return X.modelState.selection}))),ee=J[0],te=J[1];ee&&X.pushUndoStop(),X.executeCommands(this.id,te),$.setPrevEditOperationType(3)},t}($)))}($.CoreEditingCommands||($.CoreEditingCommands={}));var _e=function(X){function t($){var Q=X.call(this,$)||this;return Q._editorHandler=$.editorHandler,Q._inputHandler=$.inputHandler,Q}return te(t,X),t.prototype.runCommand=function(X,$){var Q=X.get(ne.ICodeEditorService).getFocusedCodeEditor();if(Q&&Q.hasTextFocus())return this._runEditorHandler(X,Q,$);var J=document.activeElement;if(!(J&&["input","textarea"].indexOf(J.tagName.toLowerCase())>=0)){var ee=X.get(ne.ICodeEditorService).getActiveCodeEditor();return ee?(ee.focus(),this._runEditorHandler(X,ee,$)):void 0}document.execCommand(this._inputHandler)},t.prototype._runEditorHandler=function(X,$,Q){var J=this._editorHandler;"string"==typeof J?$.trigger("keyboard",J,Q):((Q=Q||{}).source="keyboard",J.runEditorCommand(X,$,Q))},t}(ee.Command),ye=function(X){function t($,Q){var J=X.call(this,{id:$,precondition:null})||this;return J._handlerId=Q,J}return te(t,X),t.prototype.runCommand=function(X,$){var Q=X.get(ne.ICodeEditorService).getFocusedCodeEditor();Q&&Q.trigger("keyboard",this._handlerId,$)},t}(ee.Command);_(new _e({editorHandler:me.SelectAll,inputHandler:"selectAll",id:"editor.action.selectAll",precondition:ce.EditorContextKeys.textInputFocus,kbOpts:{weight:0,kbExpr:null,primary:2079},menubarOpts:{menuId:he.MenuId.MenubarSelectionMenu,group:"1_basic",title:Q.localize(0,null),order:1}})),_(new _e({editorHandler:de.Handler.Undo,inputHandler:"undo",id:de.Handler.Undo,precondition:ce.EditorContextKeys.writable,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:2104},menubarOpts:{menuId:he.MenuId.MenubarEditMenu,group:"1_do",title:Q.localize(1,null),order:1}})),_(new ye("default:"+de.Handler.Undo,de.Handler.Undo)),_(new _e({editorHandler:de.Handler.Redo,inputHandler:"redo",id:de.Handler.Redo,precondition:ce.EditorContextKeys.writable,kbOpts:{weight:0,kbExpr:ce.EditorContextKeys.textInputFocus,primary:2103,secondary:[3128],mac:{primary:3128}},menubarOpts:{menuId:he.MenuId.MenubarEditMenu,group:"1_do",title:Q.localize(2,null),order:2}})),_(new ye("default:"+de.Handler.Redo,de.Handler.Redo)),y(de.Handler.Type),y(de.Handler.ReplacePreviousChar),y(de.Handler.CompositionStart),y(de.Handler.CompositionEnd),y(de.Handler.Paste),y(de.Handler.Cut)})),define(Q[446],n([0,1,132,12]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(){function e(X,$,Q,J){this.configuration=X,this.viewModel=$,this.outgoingEvents=Q,this.commandDelegate=J}return e.prototype._execMouseCommand=function(X,$){$.source="mouse",this.commandDelegate.executeEditorCommand(X,$)},e.prototype.paste=function(X,$,Q,J){this.commandDelegate.paste(X,$,Q,J)},e.prototype.type=function(X,$){this.commandDelegate.type(X,$)},e.prototype.replacePreviousChar=function(X,$,Q){this.commandDelegate.replacePreviousChar(X,$,Q)},e.prototype.compositionStart=function(X){this.commandDelegate.compositionStart(X)},e.prototype.compositionEnd=function(X){this.commandDelegate.compositionEnd(X)},e.prototype.cut=function(X){this.commandDelegate.cut(X)},e.prototype.setSelection=function(X,$){this.commandDelegate.executeEditorCommand(Q.CoreNavigationCommands.SetSelection,{source:X,selection:$})},e.prototype._validateViewColumn=function(X){var $=this.viewModel.getLineMinColumn(X.lineNumber);return X.column<$?new J.Position(X.lineNumber,$):X},e.prototype._hasMulticursorModifier=function(X){switch(this.configuration.editor.multiCursorModifier){case"altKey":return X.altKey;case"ctrlKey":return X.ctrlKey;case"metaKey":return X.metaKey}return!1},e.prototype._hasNonMulticursorModifier=function(X){switch(this.configuration.editor.multiCursorModifier){case"altKey":return X.ctrlKey||X.metaKey;case"ctrlKey":return X.altKey||X.metaKey;case"metaKey":return X.ctrlKey||X.altKey}return!1},e.prototype.dispatchMouse=function(X){X.middleButton?X.inSelectionMode?this.columnSelect(X.position,X.mouseColumn):this.moveTo(X.position):X.startedOnLineNumbers?this._hasMulticursorModifier(X)?X.inSelectionMode?this.lastCursorLineSelect(X.position):this.createCursor(X.position,!0):X.inSelectionMode?this.lineSelectDrag(X.position):this.lineSelect(X.position):X.mouseDownCount>=4?this.selectAll():3===X.mouseDownCount?this._hasMulticursorModifier(X)?X.inSelectionMode?this.lastCursorLineSelectDrag(X.position):this.lastCursorLineSelect(X.position):X.inSelectionMode?this.lineSelectDrag(X.position):this.lineSelect(X.position):2===X.mouseDownCount?this._hasMulticursorModifier(X)?this.lastCursorWordSelect(X.position):X.inSelectionMode?this.wordSelectDrag(X.position):this.wordSelect(X.position):this._hasMulticursorModifier(X)?this._hasNonMulticursorModifier(X)||(X.shiftKey?this.columnSelect(X.position,X.mouseColumn):X.inSelectionMode?this.lastCursorMoveToSelect(X.position):this.createCursor(X.position,!1)):X.inSelectionMode?this.moveToSelect(X.position):this.moveTo(X.position)},e.prototype._usualArgs=function(X){return X=this._validateViewColumn(X),{position:this.convertViewToModelPosition(X),viewPosition:X}},e.prototype.moveTo=function(X){this._execMouseCommand(Q.CoreNavigationCommands.MoveTo,this._usualArgs(X))},e.prototype.moveToSelect=function(X){this._execMouseCommand(Q.CoreNavigationCommands.MoveToSelect,this._usualArgs(X))},e.prototype.columnSelect=function(X,$){X=this._validateViewColumn(X),this._execMouseCommand(Q.CoreNavigationCommands.ColumnSelect,{position:this.convertViewToModelPosition(X),viewPosition:X,mouseColumn:$})},e.prototype.createCursor=function(X,$){X=this._validateViewColumn(X),this._execMouseCommand(Q.CoreNavigationCommands.CreateCursor,{position:this.convertViewToModelPosition(X),viewPosition:X,wholeLine:$})},e.prototype.lastCursorMoveToSelect=function(X){this._execMouseCommand(Q.CoreNavigationCommands.LastCursorMoveToSelect,this._usualArgs(X))},e.prototype.wordSelect=function(X){this._execMouseCommand(Q.CoreNavigationCommands.WordSelect,this._usualArgs(X))},e.prototype.wordSelectDrag=function(X){this._execMouseCommand(Q.CoreNavigationCommands.WordSelectDrag,this._usualArgs(X))},e.prototype.lastCursorWordSelect=function(X){this._execMouseCommand(Q.CoreNavigationCommands.LastCursorWordSelect,this._usualArgs(X))},e.prototype.lineSelect=function(X){this._execMouseCommand(Q.CoreNavigationCommands.LineSelect,this._usualArgs(X))},e.prototype.lineSelectDrag=function(X){this._execMouseCommand(Q.CoreNavigationCommands.LineSelectDrag,this._usualArgs(X))},e.prototype.lastCursorLineSelect=function(X){this._execMouseCommand(Q.CoreNavigationCommands.LastCursorLineSelect,this._usualArgs(X))},e.prototype.lastCursorLineSelectDrag=function(X){this._execMouseCommand(Q.CoreNavigationCommands.LastCursorLineSelectDrag,this._usualArgs(X))},e.prototype.selectAll=function(){this._execMouseCommand(Q.CoreNavigationCommands.SelectAll,{})},e.prototype.convertViewToModelPosition=function(X){return this.viewModel.coordinatesConverter.convertViewPositionToModelPosition(X)},e.prototype.emitKeyDown=function(X){this.outgoingEvents.emitKeyDown(X)},e.prototype.emitKeyUp=function(X){this.outgoingEvents.emitKeyUp(X)},e.prototype.emitContextMenu=function(X){this.outgoingEvents.emitContextMenu(X)},e.prototype.emitMouseMove=function(X){this.outgoingEvents.emitMouseMove(X)},e.prototype.emitMouseLeave=function(X){this.outgoingEvents.emitMouseLeave(X)},e.prototype.emitMouseUp=function(X){this.outgoingEvents.emitMouseUp(X)},e.prototype.emitMouseDown=function(X){this.outgoingEvents.emitMouseDown(X)},e.prototype.emitMouseDrag=function(X){this.outgoingEvents.emitMouseDrag(X)},e.prototype.emitMouseDrop=function(X){this.outgoingEvents.emitMouseDrop(X)},e}();$.ViewController=ee})),define(Q[447],n([0,1,302,10,19,234]),(function(X,$,Q,J,ee,ne){Object.defineProperty($,"__esModule",{value:!0});var ie=function(X){function t($,Q){var J=X.call(this,Q)||this;return J.left=$,J}return te(t,X),t.prototype.run=function(X,$){if($.hasModel()){for(var Q=[],J=$.getSelections(),ee=0;ee<J.length;ee++)Q.push(new ne.MoveCaretCommand(J[ee],this.left));$.pushUndoStop(),$.executeCommands(this.id,Q),$.pushUndoStop()}},t}(J.EditorAction),oe=function(X){function t(){return X.call(this,!0,{id:"editor.action.moveCarretLeftAction",label:Q.localize(0,null),alias:"Move Caret Left",precondition:ee.EditorContextKeys.writable})||this}return te(t,X),t}(ie),re=function(X){function t(){return X.call(this,!1,{id:"editor.action.moveCarretRightAction",label:Q.localize(1,null),alias:"Move Caret Right",precondition:ee.EditorContextKeys.writable})||this}return te(t,X),t}(ie);J.registerEditorAction(oe),J.registerEditorAction(re)})),define(Q[448],n([0,1,303,8,10,77,12,3,19]),(function(X,$,Q,J,ee,ne,ie,oe,re){Object.defineProperty($,"__esModule",{value:!0});var se=function(X){function t(){return X.call(this,{id:"editor.action.transposeLetters",label:Q.localize(0,null),alias:"Transpose Letters",precondition:re.EditorContextKeys.writable,kbOpts:{kbExpr:re.EditorContextKeys.textInputFocus,primary:0,mac:{primary:306},weight:100}})||this}return te(t,X),t.prototype.positionLeftOf=function(X,$){var Q=X.column,ee=X.lineNumber;return Q>$.getLineMinColumn(ee)?J.isLowSurrogate($.getLineContent(ee).charCodeAt(Q-2))?Q-=2:Q-=1:ee>1&&(ee-=1,Q=$.getLineMaxColumn(ee)),new ie.Position(ee,Q)},t.prototype.positionRightOf=function(X,$){var Q=X.column,ee=X.lineNumber;return Q<$.getLineMaxColumn(ee)?J.isHighSurrogate($.getLineContent(ee).charCodeAt(Q-1))?Q+=2:Q+=1:ee<$.getLineCount()&&(ee+=1,Q=0),new ie.Position(ee,Q)},t.prototype.run=function(X,$){if($.hasModel()){for(var Q=$.getModel(),J=[],ee=0,te=$.getSelections();ee<te.length;ee++){var ie=te[ee];if(ie.isEmpty()){var re=ie.startLineNumber,se=ie.startColumn,ae=Q.getLineMaxColumn(re);if(1!==re||1!==se&&(2!==se||2!==ae)){var le=se===ae?ie.getPosition():this.positionRightOf(ie.getPosition(),Q),ue=this.positionLeftOf(le,Q),de=this.positionLeftOf(ue,Q),ce=Q.getValueInRange(oe.Range.fromPositions(de,ue)),he=Q.getValueInRange(oe.Range.fromPositions(ue,le)),pe=oe.Range.fromPositions(de,le);J.push(new ne.ReplaceCommand(pe,he+ce))}}}J.length>0&&($.pushUndoStop(),$.executeCommands(this.id,J),$.pushUndoStop())}},t}(ee.EditorAction);ee.registerEditorAction(se)})),define(Q[449],n([0,1,304,29,17,150,10,30,19,37,360]),(function(X,$,Q,J,ee,ne,ie,oe,re,se){Object.defineProperty($,"__esModule",{value:!0});var ae="9_cutcopypaste",le=ee.isNative||document.queryCommandSupported("cut"),ue=ee.isNative||document.queryCommandSupported("copy"),de=ue&&!J.isEdgeOrIE,ce=ee.isNative||!J.isChrome&&document.queryCommandSupported("paste"),he=function(X){function t($,Q){var J=X.call(this,Q)||this;return J.browserCommand=$,J}return te(t,X),t.prototype.runCommand=function(X,$){var Q=X.get(oe.ICodeEditorService).getFocusedCodeEditor();Q&&Q.hasTextFocus()?Q.trigger("keyboard",this.id,$):document.execCommand(this.browserCommand)},t.prototype.run=function(X,$){$.focus(),document.execCommand(this.browserCommand)},t}(ie.EditorAction),pe=function(X){function t(){var $={kbExpr:re.EditorContextKeys.textInputFocus,primary:2102,win:{primary:2102,secondary:[1044]},weight:100};return ee.isNative||($=null),X.call(this,"cut",{id:"editor.action.clipboardCutAction",label:Q.localize(0,null),alias:"Cut",precondition:re.EditorContextKeys.writable,kbOpts:$,menuOpts:{group:ae,order:1},menubarOpts:{menuId:se.MenuId.MenubarEditMenu,group:"2_ccp",title:Q.localize(1,null),order:1}})||this}return te(t,X),t.prototype.run=function($,Q){Q.hasModel()&&(!Q.getConfiguration().emptySelectionClipboard&&Q.getSelection().isEmpty()||X.prototype.run.call(this,$,Q))},t}(he),fe=function(X){function t(){var $={kbExpr:re.EditorContextKeys.textInputFocus,primary:2081,win:{primary:2081,secondary:[2067]},weight:100};return ee.isNative||($=null),X.call(this,"copy",{id:"editor.action.clipboardCopyAction",label:Q.localize(2,null),alias:"Copy",precondition:null,kbOpts:$,menuOpts:{group:ae,order:2},menubarOpts:{menuId:se.MenuId.MenubarEditMenu,group:"2_ccp",title:Q.localize(3,null),order:2}})||this}return te(t,X),t.prototype.run=function($,Q){Q.hasModel()&&(!Q.getConfiguration().emptySelectionClipboard&&Q.getSelection().isEmpty()||X.prototype.run.call(this,$,Q))},t}(he),ge=function(X){function t(){var $={kbExpr:re.EditorContextKeys.textInputFocus,primary:2100,win:{primary:2100,secondary:[1043]},weight:100};return ee.isNative||($=null),X.call(this,"paste",{id:"editor.action.clipboardPasteAction",label:Q.localize(4,null),alias:"Paste",precondition:re.EditorContextKeys.writable,kbOpts:$,menuOpts:{group:ae,order:3},menubarOpts:{menuId:se.MenuId.MenubarEditMenu,group:"2_ccp",title:Q.localize(5,null),order:3}})||this}return te(t,X),t}(he),me=function(X){function t(){return X.call(this,"copy",{id:"editor.action.clipboardCopyWithSyntaxHighlightingAction",label:Q.localize(6,null),alias:"Copy With Syntax Highlighting",precondition:null,kbOpts:{kbExpr:re.EditorContextKeys.textInputFocus,primary:0,weight:100}})||this}return te(t,X),t.prototype.run=function($,Q){Q.hasModel()&&(!Q.getConfiguration().emptySelectionClipboard&&Q.getSelection().isEmpty()||(ne.CopyOptions.forceCopyWithSyntaxHighlighting=!0,X.prototype.run.call(this,$,Q),ne.CopyOptions.forceCopyWithSyntaxHighlighting=!1))},t}(he);le&&ie.registerEditorAction(pe),ue&&ie.registerEditorAction(fe),ce&&ie.registerEditorAction(ge),de&&ie.registerEditorAction(me)})),define(Q[450],n([0,1,22,24,11,25,10,3,14,42,108]),(function(X,$,Q,J,ee,te,ne,ie,oe,re,se){function c(X,$,te,ne){void 0===ne&&(ne=J.CancellationToken.None);var ie={only:te&&te.filter&&te.filter.kind?te.filter.kind.value:void 0,trigger:te&&"manual"===te.type?2:1},re=oe.CodeActionProviderRegistry.all(X).filter((function(X){return!X.providedCodeActionKinds||X.providedCodeActionKinds.some((function(X){return h(te&&te.filter,X)}))})).map((function(Q){return Promise.resolve(Q.provideCodeActions(X,$,ie,ne)).then((function(X){return Array.isArray(X)?X.filter((function(X){return function(X,$){return $&&h(X,$.kind)}(te&&te.filter,X)})):[]}),(function(X){if(ee.isPromiseCanceledError(X))throw X;return ee.onUnexpectedExternalError(X),[]}))}));return Promise.all(re).then(Q.flatten).then((function(X){return Q.mergeSort(X,p)}))}function h(X,$){return!(X&&X.kind&&(!$||!X.kind.contains($))||$&&se.CodeActionKind.Source.contains($)&&(!X||!X.includeSourceActions))}function p(X,$){var J=!Q.isFalsyOrEmpty(X.diagnostics),ee=!Q.isFalsyOrEmpty($.diagnostics);return J?ee?X.diagnostics[0].message.localeCompare($.diagnostics[0].message):-1:ee?1:0}Object.defineProperty($,"__esModule",{value:!0}),$.getCodeActions=c,ne.registerLanguageCommand("_executeCodeActionProvider",(function(X,$){var Q=$.resource,J=$.range;if(!(Q instanceof te.URI&&ie.Range.isIRange(J)))throw ee.illegalArgument();var ne=X.get(re.IModelService).getModel(Q);if(!ne)throw ee.illegalArgument();return c(ne,ne.validateRange(J),{type:"manual",filter:{includeSourceActions:!0}})}))})),define(Q[451],n([0,1,16,6,2,3,14,18,450]),(function(X,$,Q,J,ee,te,ne,ie,oe){Object.defineProperty($,"__esModule",{value:!0}),$.SUPPORTED_CODE_ACTIONS=new ie.RawContextKey("supportedCodeAction","");var re=function(){function e(X,$,J,ee,te){void 0===ee&&(ee=250);var ne=this;this._editor=X,this._markerService=$,this._signalChange=J,this._delay=ee,this._progressService=te,this._disposables=[],this._autoTriggerTimer=new Q.TimeoutTimer,this._disposables.push(this._markerService.onMarkerChanged((function(X){return ne._onMarkerChanges(X)})),this._editor.onDidChangeCursorPosition((function(){return ne._onCursorChange()})))}return e.prototype.dispose=function(){this._disposables=ee.dispose(this._disposables),this._autoTriggerTimer.cancel()},e.prototype.trigger=function(X){var $=this._getRangeOfSelectionUnlessWhitespaceEnclosed(X);return this._createEventAndSignalChange(X,$)},e.prototype._onMarkerChanges=function(X){var $=this,Q=this._editor.getModel();Q&&X.some((function(X){return X.toString()===Q.uri.toString()}))&&this._autoTriggerTimer.cancelAndSet((function(){$.trigger({type:"auto"})}),this._delay)},e.prototype._onCursorChange=function(){var X=this;this._autoTriggerTimer.cancelAndSet((function(){X.trigger({type:"auto"})}),this._delay)},e.prototype._getRangeOfMarker=function(X){var $=this._editor.getModel();if($)for(var Q=0,J=this._markerService.read({resource:$.uri});Q<J.length;Q++){var ee=J[Q];if(te.Range.intersectRanges(ee,X))return te.Range.lift(ee)}},e.prototype._getRangeOfSelectionUnlessWhitespaceEnclosed=function(X){var $=this._editor.getModel(),Q=this._editor.getSelection();if($&&Q&&Q.isEmpty()&&(!X.filter||!X.filter.includeSourceActions)){var J=Q.getPosition(),ee=J.lineNumber,te=J.column,ne=$.getLineContent(ee);if(0===ne.length)return;if(1===te){if(/\s/.test(ne[0]))return}else if(te===$.getLineMaxColumn(ee)){if(/\s/.test(ne[ne.length-1]))return}else if(/\s/.test(ne[te-2])&&/\s/.test(ne[te-1]))return}return Q||void 0},e.prototype._createEventAndSignalChange=function(X,$){if($){var J=this._editor.getModel();if(!J)return this._signalChange({trigger:X,rangeOrSelection:void 0,position:void 0,actions:void 0}),Promise.resolve(void 0);var ee=this._getRangeOfMarker($),te=ee?ee.getStartPosition():$.getStartPosition(),ne=Q.createCancelablePromise((function(Q){return oe.getCodeActions(J,$,X,Q)}));return this._progressService&&"manual"===X.type&&this._progressService.showWhile(ne,250),this._signalChange({trigger:X,rangeOrSelection:$,position:te,actions:ne}),ne}return this._signalChange({trigger:X,rangeOrSelection:void 0,position:void 0,actions:void 0}),Promise.resolve(void 0)},e}();$.CodeActionOracle=re;var se=function(){function e(X,Q,ee,te){var ie=this;this._progressService=te,this._onDidChangeFixes=new J.Emitter,this._disposables=[],this._editor=X,this._markerService=Q,this._supportedCodeActions=$.SUPPORTED_CODE_ACTIONS.bindTo(ee),this._disposables.push(this._editor.onDidChangeModel((function(){return ie._update()}))),this._disposables.push(this._editor.onDidChangeModelLanguage((function(){return ie._update()}))),this._disposables.push(ne.CodeActionProviderRegistry.onDidChange(this._update,this)),this._update()}return e.prototype.dispose=function(){this._disposables=ee.dispose(this._disposables),ee.dispose(this._codeActionOracle)},Object.defineProperty(e.prototype,"onDidChangeFixes",{get:function(){return this._onDidChangeFixes.event},enumerable:!0,configurable:!0}),e.prototype._update=function(){var X=this;this._codeActionOracle&&(this._codeActionOracle.dispose(),this._codeActionOracle=void 0,this._onDidChangeFixes.fire(void 0));var $=this._editor.getModel();if($&&ne.CodeActionProviderRegistry.has($)&&!this._editor.getConfiguration().readOnly){for(var Q=[],J=0,ee=ne.CodeActionProviderRegistry.all($);J<ee.length;J++){var te=ee[J];Array.isArray(te.providedCodeActionKinds)&&Q.push.apply(Q,te.providedCodeActionKinds)}this._supportedCodeActions.set(Q.join(" ")),this._codeActionOracle=new re(this._editor,this._markerService,(function($){return X._onDidChangeFixes.fire($)}),void 0,this._progressService),this._codeActionOracle.trigger({type:"auto"})}else this._supportedCodeActions.reset()},e.prototype.trigger=function(X){return this._codeActionOracle?this._codeActionOracle.trigger(X):Promise.resolve(void 0)},e}();$.CodeActionModel=se})),define(Q[452],n([0,1,22,24,11,25,10,14,42]),(function(X,$,Q,J,ee,te,ne,ie,oe){function u(X,$){var J=[],te=ie.CodeLensProviderRegistry.ordered(X),ne=te.map((function(Q){return Promise.resolve(Q.provideCodeLenses(X,$)).then((function(X){if(Array.isArray(X))for(var $=0,ee=X;$<ee.length;$++){var te=ee[$];J.push({symbol:te,provider:Q})}})).catch(ee.onUnexpectedExternalError)}));return Promise.all(ne).then((function(){return Q.mergeSort(J,(function(X,$){return X.symbol.range.startLineNumber<$.symbol.range.startLineNumber?-1:X.symbol.range.startLineNumber>$.symbol.range.startLineNumber?1:te.indexOf(X.provider)<te.indexOf($.provider)?-1:te.indexOf(X.provider)>te.indexOf($.provider)?1:X.symbol.range.startColumn<$.symbol.range.startColumn?-1:X.symbol.range.startColumn>$.symbol.range.startColumn?1:0}))}))}Object.defineProperty($,"__esModule",{value:!0}),$.getCodeLensData=u,ne.registerLanguageCommand("_executeCodeLensProvider",(function(X,$){var Q=$.resource,ne=$.itemResolveCount;if(!(Q instanceof te.URI))throw ee.illegalArgument();var ie=X.get(oe.IModelService).getModel(Q);if(!ie)throw ee.illegalArgument();var re=[];return u(ie,J.CancellationToken.None).then((function(X){for(var $=[],n=function(X){void 0===ne||Boolean(X.symbol.command)?re.push(X.symbol):ne-- >0&&X.provider.resolveCodeLens&&$.push(Promise.resolve(X.provider.resolveCodeLens(ie,X.symbol,J.CancellationToken.None)).then((function($){return re.push($||X.symbol)})))},Q=0,ee=X;Q<ee.length;Q++)n(ee[Q]);return Promise.all($)})).then((function(){return re}))}))})),define(Q[174],n([0,1,24,11,25,10,3,14,42]),(function(X,$,Q,J,ee,te,ne,ie,oe){Object.defineProperty($,"__esModule",{value:!0}),$.getColors=function(X,$){var Q=[],J=ie.ColorProviderRegistry.ordered(X).reverse().map((function(J){return Promise.resolve(J.provideDocumentColors(X,$)).then((function(X){if(Array.isArray(X))for(var $=0,ee=X;$<ee.length;$++){var te=ee[$];Q.push({colorInfo:te,provider:J})}}))}));return Promise.all(J).then((function(){return Q}))},$.getColorPresentations=function(X,$,Q,J){return Promise.resolve(Q.provideColorPresentations(X,$,J))},te.registerLanguageCommand("_executeDocumentColorProvider",(function(X,$){var te=$.resource;if(!(te instanceof ee.URI))throw J.illegalArgument();var ne=X.get(oe.IModelService).getModel(te);if(!ne)throw J.illegalArgument();var re=[],se=ie.ColorProviderRegistry.ordered(ne).reverse().map((function(X){return Promise.resolve(X.provideDocumentColors(ne,Q.CancellationToken.None)).then((function(X){if(Array.isArray(X))for(var $=0,Q=X;$<Q.length;$++){var J=Q[$];re.push({range:J.range,color:[J.color.red,J.color.green,J.color.blue,J.color.alpha]})}}))}));return Promise.all(se).then((function(){return re}))})),te.registerLanguageCommand("_executeColorPresentationProvider",(function(X,$){var te=$.resource,re=$.color,se=$.range;if(!(te instanceof ee.URI&&Array.isArray(re)&&4===re.length&&ne.Range.isIRange(se)))throw J.illegalArgument();var ae=re[0],le=re[1],ue=re[2],de=re[3],ce=X.get(oe.IModelService).getModel(te);if(!ce)throw J.illegalArgument();var he={range:se,color:{red:ae,green:le,blue:ue,alpha:de}},pe=[],fe=ie.ColorProviderRegistry.ordered(ce).reverse().map((function(X){return Promise.resolve(X.provideColorPresentations(ce,he,Q.CancellationToken.None)).then((function(X){Array.isArray(X)&&pe.push.apply(pe,X)}))}));return Promise.all(fe).then((function(){return pe}))}))})),define(Q[175],n([0,1,16,28,11,418,2,10,30,3,26,14,174,45]),(function(X,$,Q,J,ee,te,ie,re,se,ae,le,ue,de,ce){Object.defineProperty($,"__esModule",{value:!0});var he=function(){function e(X,$,Q){var J=this;this._editor=X,this._codeEditorService=$,this._configurationService=Q,this._globalToDispose=[],this._localToDispose=[],this._decorationsIds=[],this._colorDatas=new Map,this._colorDecoratorIds=[],this._decorationsTypes={},this._globalToDispose.push(X.onDidChangeModel((function(X){J._isEnabled=J.isEnabled(),J.onModelChanged()}))),this._globalToDispose.push(X.onDidChangeModelLanguage((function(X){return J.onModelChanged()}))),this._globalToDispose.push(ue.ColorProviderRegistry.onDidChange((function(X){return J.onModelChanged()}))),this._globalToDispose.push(X.onDidChangeConfiguration((function(X){var $=J._isEnabled;J._isEnabled=J.isEnabled(),$!==J._isEnabled&&(J._isEnabled?J.onModelChanged():J.removeAllDecorations())}))),this._timeoutTimer=null,this._computePromise=null,this._isEnabled=this.isEnabled(),this.onModelChanged()}return e.prototype.isEnabled=function(){var X=this._editor.getModel();if(!X)return!1;var $=X.getLanguageIdentifier(),Q=this._configurationService.getValue($.language);if(Q){var J=Q.colorDecorators;if(J&&void 0!==J.enable&&!J.enable)return J.enable}return this._editor.getConfiguration().contribInfo.colorDecorators},e.prototype.getId=function(){return e.ID},e.get=function(X){return X.getContribution(this.ID)},e.prototype.dispose=function(){this.stop(),this.removeAllDecorations(),this._globalToDispose=ie.dispose(this._globalToDispose)},e.prototype.onModelChanged=function(){var X=this;if(this.stop(),this._isEnabled){var $=this._editor.getModel();$&&ue.ColorProviderRegistry.has($)&&(this._localToDispose.push(this._editor.onDidChangeModelContent((function($){X._timeoutTimer||(X._timeoutTimer=new Q.TimeoutTimer,X._timeoutTimer.cancelAndSet((function(){X._timeoutTimer=null,X.beginCompute()}),e.RECOMPUTE_TIME))}))),this.beginCompute())}},e.prototype.beginCompute=function(){var X=this;this._computePromise=Q.createCancelablePromise((function($){var Q=X._editor.getModel();return Q?de.getColors(Q,$):Promise.resolve([])})),this._computePromise.then((function($){X.updateDecorations($),X.updateColorDecorators($),X._computePromise=null}),ee.onUnexpectedError)},e.prototype.stop=function(){this._timeoutTimer&&(this._timeoutTimer.cancel(),this._timeoutTimer=null),this._computePromise&&(this._computePromise.cancel(),this._computePromise=null),this._localToDispose=ie.dispose(this._localToDispose)},e.prototype.updateDecorations=function(X){var $=this,Q=X.map((function(X){return{range:{startLineNumber:X.colorInfo.range.startLineNumber,startColumn:X.colorInfo.range.startColumn,endLineNumber:X.colorInfo.range.endLineNumber,endColumn:X.colorInfo.range.endColumn},options:le.ModelDecorationOptions.EMPTY}}));this._decorationsIds=this._editor.deltaDecorations(this._decorationsIds,Q),this._colorDatas=new Map,this._decorationsIds.forEach((function(Q,J){return $._colorDatas.set(Q,X[J])}))},e.prototype.updateColorDecorators=function(X){for(var $=[],Q={},ee=0;ee<X.length&&$.length<500;ee++){var ne=X[ee].colorInfo.color,ie=ne.red,oe=ne.green,re=ne.blue,se=ne.alpha,ae=new J.RGBA(Math.round(255*ie),Math.round(255*oe),Math.round(255*re),se),le=te.hash(ae).toString(16),ue="rgba("+ae.r+", "+ae.g+", "+ae.b+", "+ae.a+")",de="colorBox-"+le;this._decorationsTypes[de]||Q[de]||this._codeEditorService.registerDecorationType(de,{before:{contentText:" ",border:"solid 0.1em #000",margin:"0.1em 0.2em 0 0.2em",width:"0.8em",height:"0.8em",backgroundColor:ue},dark:{before:{border:"solid 0.1em #eee"}}}),Q[de]=!0,$.push({range:{startLineNumber:X[ee].colorInfo.range.startLineNumber,startColumn:X[ee].colorInfo.range.startColumn,endLineNumber:X[ee].colorInfo.range.endLineNumber,endColumn:X[ee].colorInfo.range.endColumn},options:this._codeEditorService.resolveDecorationOptions(de,!0)})}for(var ce in this._decorationsTypes)Q[ce]||this._codeEditorService.removeDecorationType(ce);this._colorDecoratorIds=this._editor.deltaDecorations(this._colorDecoratorIds,$)},e.prototype.removeAllDecorations=function(){for(var X in this._decorationsIds=this._editor.deltaDecorations(this._decorationsIds,[]),this._colorDecoratorIds=this._editor.deltaDecorations(this._colorDecoratorIds,[]),this._decorationsTypes)this._codeEditorService.removeDecorationType(X)},e.prototype.getColorData=function(X){var $=this,Q=this._editor.getModel();if(!Q)return null;var J=Q.getDecorationsInRange(ae.Range.fromPositions(X,X)).filter((function(X){return $._colorDatas.has(X.id)}));return 0===J.length?null:this._colorDatas.get(J[0].id)},e.ID="editor.contrib.colorDetector",e.RECOMPUTE_TIME=1e3,e=ne([oe(1,se.ICodeEditorService),oe(2,ce.IConfigurationService)],e)}();$.ColorDetector=he,re.registerEditorContribution(he)})),define(Q[455],n([0,1,306,36,10,19,171,239,37]),(function(X,$,Q,J,ee,ne,ie,oe,re){Object.defineProperty($,"__esModule",{value:!0});var se=function(X){function t($,Q){var J=X.call(this,Q)||this;return J._type=$,J}return te(t,X),t.prototype.run=function(X,$){if($.hasModel()){for(var Q=$.getModel(),J=[],ee=$.getSelections(),te=Q.getOptions(),ne=0;ne<ee.length;ne++)J.push(new oe.LineCommentCommand(ee[ne],te.tabSize,this._type));$.pushUndoStop(),$.executeCommands(this.id,J),$.pushUndoStop()}},t}(ee.EditorAction),ae=function(X){function t(){return X.call(this,0,{id:"editor.action.commentLine",label:Q.localize(0,null),alias:"Toggle Line Comment",precondition:ne.EditorContextKeys.writable,kbOpts:{kbExpr:ne.EditorContextKeys.editorTextFocus,primary:2133,weight:100},menubarOpts:{menuId:re.MenuId.MenubarEditMenu,group:"5_insert",title:Q.localize(1,null),order:1}})||this}return te(t,X),t}(se),le=function(X){function t(){return X.call(this,1,{id:"editor.action.addCommentLine",label:Q.localize(2,null),alias:"Add Line Comment",precondition:ne.EditorContextKeys.writable,kbOpts:{kbExpr:ne.EditorContextKeys.editorTextFocus,primary:J.KeyChord(2089,2081),weight:100}})||this}return te(t,X),t}(se),ue=function(X){function t(){return X.call(this,2,{id:"editor.action.removeCommentLine",label:Q.localize(3,null),alias:"Remove Line Comment",precondition:ne.EditorContextKeys.writable,kbOpts:{kbExpr:ne.EditorContextKeys.editorTextFocus,primary:J.KeyChord(2089,2099),weight:100}})||this}return te(t,X),t}(se),de=function(X){function t(){return X.call(this,{id:"editor.action.blockComment",label:Q.localize(4,null),alias:"Toggle Block Comment",precondition:ne.EditorContextKeys.writable,kbOpts:{kbExpr:ne.EditorContextKeys.editorTextFocus,primary:1567,linux:{primary:3103},weight:100},menubarOpts:{menuId:re.MenuId.MenubarEditMenu,group:"5_insert",title:Q.localize(5,null),order:2}})||this}return te(t,X),t.prototype.run=function(X,$){if($.hasModel()){for(var Q=[],J=$.getSelections(),ee=0;ee<J.length;ee++)Q.push(new ie.BlockCommentCommand(J[ee]));$.pushUndoStop(),$.executeCommands(this.id,Q),$.pushUndoStop()}},t}(ee.EditorAction);ee.registerEditorAction(ae),ee.registerEditorAction(le),ee.registerEditorAction(ue),ee.registerEditorAction(de)})),define(Q[456],n([0,1,307,7,67,2,10,19,37,18,60,47]),(function(X,$,Q,J,ee,ie,re,se,ae,le,ue,de){Object.defineProperty($,"__esModule",{value:!0});var ce=function(){function e(X,$,Q,J,ee,te){var ne=this;this._contextMenuService=$,this._contextViewService=Q,this._contextKeyService=J,this._keybindingService=ee,this._menuService=te,this._toDispose=[],this._contextMenuIsBeingShownCount=0,this._editor=X,this._toDispose.push(this._editor.onContextMenu((function(X){return ne._onContextMenu(X)}))),this._toDispose.push(this._editor.onDidScrollChange((function(X){ne._contextMenuIsBeingShownCount>0&&ne._contextViewService.hideContextView()}))),this._toDispose.push(this._editor.onKeyDown((function(X){58===X.keyCode&&(X.preventDefault(),X.stopPropagation(),ne.showContextMenu())})))}return e.get=function(X){return X.getContribution(e.ID)},e.prototype._onContextMenu=function(X){if(!this._editor.getConfiguration().contribInfo.contextmenu)return this._editor.focus(),void(X.target.position&&!this._editor.getSelection().containsPosition(X.target.position)&&this._editor.setPosition(X.target.position));var $;12!==X.target.type&&(X.event.preventDefault(),6===X.target.type||7===X.target.type||1===X.target.type)&&(this._editor.focus(),X.target.position&&!this._editor.getSelection().containsPosition(X.target.position)&&this._editor.setPosition(X.target.position),1!==X.target.type&&($={x:X.event.posx-1,width:2,y:X.event.posy-1,height:2}),this.showContextMenu($))},e.prototype.showContextMenu=function(X){if(this._editor.getConfiguration().contribInfo.contextmenu)if(this._contextMenuService){var $=this._getMenuActions();$.length>0&&this._doShowContextMenu($,X)}else this._editor.focus()},e.prototype._getMenuActions=function(){var X=[],$=this._menuService.createMenu(ae.MenuId.EditorContext,this._contextKeyService),Q=$.getActions({arg:this._editor.getModel().uri});$.dispose();for(var J=0,te=Q;J<te.length;J++){var ne=te[J][1];X.push.apply(X,ne),X.push(new ee.Separator)}return X.pop(),X},e.prototype._doShowContextMenu=function(X,$){var Q=this;void 0===$&&($=null);var te=this._editor.getConfiguration().contribInfo.hover;if(this._editor.updateOptions({hover:{enabled:!1}}),!$){this._editor.revealPosition(this._editor.getPosition(),1),this._editor.render();var ne=this._editor.getScrolledVisiblePosition(this._editor.getPosition()),ie=J.getDomNodePagePosition(this._editor.getDomNode()),oe=ie.left+ne.left,re=ie.top+ne.top+ne.height;$={x:oe,y:re}}this._contextMenuIsBeingShownCount++,this._contextMenuService.showContextMenu({getAnchor:function(){return $},getActions:function(){return Promise.resolve(X)},getActionItem:function(X){var $=Q._keybindingFor(X);if($)return new ee.ActionItem(X,X,{label:!0,keybinding:$.getLabel(),isMenu:!0});var J=X;return"function"==typeof J.getActionItem?J.getActionItem():new ee.ActionItem(X,X,{icon:!0,label:!0,isMenu:!0})},getKeyBinding:function(X){return Q._keybindingFor(X)},onHide:function(X){Q._contextMenuIsBeingShownCount--,Q._editor.focus(),Q._editor.updateOptions({hover:te})}})},e.prototype._keybindingFor=function(X){return this._keybindingService.lookupKeybinding(X.id)},e.prototype.getId=function(){return e.ID},e.prototype.dispose=function(){this._contextMenuIsBeingShownCount>0&&this._contextViewService.hideContextView(),this._toDispose=ie.dispose(this._toDispose)},e.ID="editor.contrib.contextmenu",e=ne([oe(1,ue.IContextMenuService),oe(2,ue.IContextViewService),oe(3,le.IContextKeyService),oe(4,de.IKeybindingService),oe(5,ae.IMenuService)],e)}();$.ContextMenuController=ce;var he=function(X){function t(){return X.call(this,{id:"editor.action.showContextMenu",label:Q.localize(0,null),alias:"Show Editor Context Menu",precondition:null,kbOpts:{kbExpr:se.EditorContextKeys.textInputFocus,primary:1092,weight:100}})||this}return te(t,X),t.prototype.run=function(X,$){ce.get($).showContextMenu()},t}(re.EditorAction);re.registerEditorContribution(ce),re.registerEditorAction(he)})),define(Q[457],n([0,1,308,2,10,19]),(function(X,$,Q,J,ee,ne){Object.defineProperty($,"__esModule",{value:!0});var ie=function(){function e(X){this.selections=X}return e.prototype.equals=function(X){var $=this.selections.length;if($!==X.selections.length)return!1;for(var Q=0;Q<$;Q++)if(!this.selections[Q].equalsSelection(X.selections[Q]))return!1;return!0},e}(),oe=function(X){function t($){var Q=X.call(this)||this;return Q._editor=$,Q._isCursorUndo=!1,Q._undoStack=[],Q._prevState=Q._readState(),Q._register($.onDidChangeModel((function(X){Q._undoStack=[],Q._prevState=null}))),Q._register($.onDidChangeModelContent((function(X){Q._undoStack=[],Q._prevState=null}))),Q._register($.onDidChangeCursorSelection((function(X){!Q._isCursorUndo&&Q._prevState&&(Q._undoStack.push(Q._prevState),Q._undoStack.length>50&&Q._undoStack.shift()),Q._prevState=Q._readState()}))),Q}return te(t,X),t.get=function(X){return X.getContribution(t.ID)},t.prototype._readState=function(){return this._editor.hasModel()?new ie(this._editor.getSelections()):null},t.prototype.getId=function(){return t.ID},t.prototype.cursorUndo=function(){if(this._editor.hasModel())for(var X=new ie(this._editor.getSelections());this._undoStack.length>0;){var $=this._undoStack.pop();if(!$.equals(X))return this._isCursorUndo=!0,this._editor.setSelections($.selections),this._editor.revealRangeInCenterIfOutsideViewport($.selections[0],0),void(this._isCursorUndo=!1)}},t.ID="editor.contrib.cursorUndoController",t}(J.Disposable);$.CursorUndoController=oe;var re=function(X){function t(){return X.call(this,{id:"cursorUndo",label:Q.localize(0,null),alias:"Soft Undo",precondition:null,kbOpts:{kbExpr:ne.EditorContextKeys.textInputFocus,primary:2099,weight:100}})||this}return te(t,X),t.prototype.run=function(X,$,Q){oe.get($).cursorUndo()},t}(ee.EditorAction);$.CursorUndo=re,ee.registerEditorContribution(oe),ee.registerEditorAction(re)})),define(Q[458],n([0,1,2,17,10,12,3,21,240,26,365]),(function(X,$,Q,J,ee,te,ne,ie,oe,re){function d(X){return J.isMacintosh?X.altKey:X.ctrlKey}Object.defineProperty($,"__esModule",{value:!0});var se=function(){function e(X){var $=this;this._editor=X,this._toUnhook=[],this._toUnhook.push(this._editor.onMouseDown((function(X){return $._onEditorMouseDown(X)}))),this._toUnhook.push(this._editor.onMouseUp((function(X){return $._onEditorMouseUp(X)}))),this._toUnhook.push(this._editor.onMouseDrag((function(X){return $._onEditorMouseDrag(X)}))),this._toUnhook.push(this._editor.onMouseDrop((function(X){return $._onEditorMouseDrop(X)}))),this._toUnhook.push(this._editor.onKeyDown((function(X){return $.onEditorKeyDown(X)}))),this._toUnhook.push(this._editor.onKeyUp((function(X){return $.onEditorKeyUp(X)}))),this._toUnhook.push(this._editor.onDidBlurEditorWidget((function(){return $.onEditorBlur()}))),this._dndDecorationIds=[],this._mouseDown=!1,this._modiferPressed=!1,this._dragSelection=null}return e.prototype.onEditorBlur=function(){this._removeDecoration(),this._dragSelection=null,this._mouseDown=!1,this._modiferPressed=!1},e.prototype.onEditorKeyDown=function(X){this._editor.getConfiguration().dragAndDrop&&(d(X)&&(this._modiferPressed=!0),this._mouseDown&&d(X)&&this._editor.updateOptions({mouseStyle:"copy"}))},e.prototype.onEditorKeyUp=function(X){this._editor.getConfiguration().dragAndDrop&&(d(X)&&(this._modiferPressed=!1),this._mouseDown&&X.keyCode===e.TRIGGER_KEY_VALUE&&this._editor.updateOptions({mouseStyle:"default"}))},e.prototype._onEditorMouseDown=function(X){this._mouseDown=!0},e.prototype._onEditorMouseUp=function(X){this._mouseDown=!1,this._editor.updateOptions({mouseStyle:"text"})},e.prototype._onEditorMouseDrag=function(X){var $=X.target;if(null===this._dragSelection){var Q=(this._editor.getSelections()||[]).filter((function(X){return $.position&&X.containsPosition($.position)}));if(1!==Q.length)return;this._dragSelection=Q[0]}d(X.event)?this._editor.updateOptions({mouseStyle:"copy"}):this._editor.updateOptions({mouseStyle:"default"}),$.position&&(this._dragSelection.containsPosition($.position)?this._removeDecoration():this.showAt($.position))},e.prototype._onEditorMouseDrop=function(X){if(X.target&&(this._hitContent(X.target)||this._hitMargin(X.target))&&X.target.position){var $=new te.Position(X.target.position.lineNumber,X.target.position.column);if(null===this._dragSelection){var Q=null;if(X.event.shiftKey){var J=this._editor.getSelection();if(J){var ee=J.selectionStartLineNumber,ne=J.selectionStartColumn;Q=[new ie.Selection(ee,ne,$.lineNumber,$.column)]}}else Q=(this._editor.getSelections()||[]).map((function(X){return X.containsPosition($)?new ie.Selection($.lineNumber,$.column,$.lineNumber,$.column):X}));this._editor.setSelections(Q||[],"mouse")}else(!this._dragSelection.containsPosition($)||(d(X.event)||this._modiferPressed)&&(this._dragSelection.getEndPosition().equals($)||this._dragSelection.getStartPosition().equals($)))&&(this._editor.pushUndoStop(),this._editor.executeCommand(e.ID,new oe.DragAndDropCommand(this._dragSelection,$,d(X.event)||this._modiferPressed)),this._editor.pushUndoStop())}this._editor.updateOptions({mouseStyle:"text"}),this._removeDecoration(),this._dragSelection=null,this._mouseDown=!1},e.prototype.showAt=function(X){var $=[{range:new ne.Range(X.lineNumber,X.column,X.lineNumber,X.column),options:e._DECORATION_OPTIONS}];this._dndDecorationIds=this._editor.deltaDecorations(this._dndDecorationIds,$),this._editor.revealPosition(X,1)},e.prototype._removeDecoration=function(){this._dndDecorationIds=this._editor.deltaDecorations(this._dndDecorationIds,[])},e.prototype._hitContent=function(X){return 6===X.type||7===X.type},e.prototype._hitMargin=function(X){return 2===X.type||3===X.type||4===X.type},e.prototype.getId=function(){return e.ID},e.prototype.dispose=function(){this._removeDecoration(),this._dragSelection=null,this._mouseDown=!1,this._modiferPressed=!1,this._toUnhook=Q.dispose(this._toUnhook)},e.ID="editor.contrib.dragAndDrop",e.TRIGGER_KEY_VALUE=J.isMacintosh?6:5,e._DECORATION_OPTIONS=re.ModelDecorationOptions.register({className:"dnd-target"}),e}();$.DragAndDropController=se,ee.registerEditorContribution(se)})),define(Q[459],n([0,1,311,32,8,16,36,2,10,245,392,19,246,39,393,14,203,248,11,367]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le,ue,de,ce,he,pe,fe,ge){function C(X){if(!J.isUndefined(X)){if(!J.isObject(X))return!1;var $=X;if(!J.isUndefined($.levels)&&!J.isNumber($.levels))return!1;if(!J.isUndefined($.direction)&&!J.isString($.direction))return!1;if(!(J.isUndefined($.selectionLines)||J.isArray($.selectionLines)&&$.selectionLines.every(J.isNumber)))return!1}return!0}Object.defineProperty($,"__esModule",{value:!0}),$.ID="editor.contrib.folding";var me=function(){function e(X){var $=this;this.editor=X,this._isEnabled=this.editor.getConfiguration().contribInfo.folding,this._autoHideFoldingControls="mouseover"===this.editor.getConfiguration().contribInfo.showFoldingControls,this._useFoldingProviders="indentation"!==this.editor.getConfiguration().contribInfo.foldingStrategy,this.globalToDispose=[],this.localToDispose=[],this.foldingDecorationProvider=new ae.FoldingDecorationProvider(X),this.foldingDecorationProvider.autoHideFoldingControls=this._autoHideFoldingControls,this.globalToDispose.push(this.editor.onDidChangeModel((function(){return $.onModelChanged()}))),this.globalToDispose.push(he.FoldingRangeProviderRegistry.onDidChange((function(){return $.onFoldingStrategyChanged()}))),this.globalToDispose.push(this.editor.onDidChangeConfiguration((function(X){if(X.contribInfo){var Q=$._isEnabled;$._isEnabled=$.editor.getConfiguration().contribInfo.folding,Q!==$._isEnabled&&$.onModelChanged();var J=$._autoHideFoldingControls;$._autoHideFoldingControls="mouseover"===$.editor.getConfiguration().contribInfo.showFoldingControls,J!==$._autoHideFoldingControls&&($.foldingDecorationProvider.autoHideFoldingControls=$._autoHideFoldingControls,$.onModelContentChanged());var ee=$._useFoldingProviders;$._useFoldingProviders="indentation"!==$.editor.getConfiguration().contribInfo.foldingStrategy,ee!==$._useFoldingProviders&&$.onFoldingStrategyChanged()}}))),this.globalToDispose.push({dispose:function(){return oe.dispose($.localToDispose)}}),this.onModelChanged()}return e.get=function(X){return X.getContribution($.ID)},e.prototype.getId=function(){return $.ID},e.prototype.dispose=function(){this.globalToDispose=oe.dispose(this.globalToDispose)},e.prototype.saveViewState=function(){var X=this.editor.getModel();if(!X||!this._isEnabled||X.isTooLargeForTokenization())return{};if(this.foldingModel){var $=this.foldingModel.isInitialized?this.foldingModel.getMemento():this.hiddenRangeModel.getMemento(),Q=this.rangeProvider?this.rangeProvider.id:void 0;return{collapsedRegions:$,lineCount:X.getLineCount(),provider:Q}}},e.prototype.restoreViewState=function(X){var $=this.editor.getModel();if($&&this._isEnabled&&!$.isTooLargeForTokenization()&&this.hiddenRangeModel&&X&&X.collapsedRegions&&X.lineCount===$.getLineCount()){X.provider!==pe.ID_SYNTAX_PROVIDER&&X.provider!==fe.ID_INIT_PROVIDER||(this.foldingStateMemento=X);var Q=X.collapsedRegions;if(this.hiddenRangeModel.applyMemento(Q)){var J=this.getFoldingModel();J&&J.then((function(X){X&&X.applyMemento(Q)})).then(void 0,ge.onUnexpectedError)}}},e.prototype.onModelChanged=function(){var X=this;this.localToDispose=oe.dispose(this.localToDispose);var $=this.editor.getModel();this._isEnabled&&$&&!$.isTooLargeForTokenization()&&(this.foldingModel=new se.FoldingModel($,this.foldingDecorationProvider),this.localToDispose.push(this.foldingModel),this.hiddenRangeModel=new ue.HiddenRangeModel(this.foldingModel),this.localToDispose.push(this.hiddenRangeModel),this.localToDispose.push(this.hiddenRangeModel.onDidChange((function($){return X.onHiddenRangesChanges($)}))),this.updateScheduler=new ne.Delayer(200),this.cursorChangedScheduler=new ne.RunOnceScheduler((function(){return X.revealCursor()}),200),this.localToDispose.push(this.cursorChangedScheduler),this.localToDispose.push(this.editor.onDidChangeModelLanguageConfiguration((function(){return X.onModelContentChanged()}))),this.localToDispose.push(this.editor.onDidChangeModelContent((function(){return X.onModelContentChanged()}))),this.localToDispose.push(this.editor.onDidChangeCursorPosition((function(){return X.onCursorPositionChanged()}))),this.localToDispose.push(this.editor.onMouseDown((function($){return X.onEditorMouseDown($)}))),this.localToDispose.push(this.editor.onMouseUp((function($){return X.onEditorMouseUp($)}))),this.localToDispose.push({dispose:function(){X.foldingRegionPromise&&(X.foldingRegionPromise.cancel(),X.foldingRegionPromise=null),X.updateScheduler&&X.updateScheduler.cancel(),X.updateScheduler=null,X.foldingModel=null,X.foldingModelPromise=null,X.hiddenRangeModel=null,X.cursorChangedScheduler=null,X.foldingStateMemento=null,X.rangeProvider&&X.rangeProvider.dispose(),X.rangeProvider=null}}),this.onModelContentChanged())},e.prototype.onFoldingStrategyChanged=function(){this.rangeProvider&&this.rangeProvider.dispose(),this.rangeProvider=null,this.onModelContentChanged()},e.prototype.getRangeProvider=function(X){var $=this;if(this.rangeProvider)return this.rangeProvider;if(this.rangeProvider=new ce.IndentRangeProvider(X),this._useFoldingProviders&&this.foldingModel){var Q=he.FoldingRangeProviderRegistry.ordered(this.foldingModel.textModel);if(0===Q.length&&this.foldingStateMemento&&this.foldingStateMemento.collapsedRegions)return this.rangeProvider=new fe.InitializingRangeProvider(X,this.foldingStateMemento.collapsedRegions,(function(){$.foldingStateMemento=null,$.onFoldingStrategyChanged()}),3e4);Q.length>0&&(this.rangeProvider=new pe.SyntaxRangeProvider(X,Q))}return this.foldingStateMemento=null,this.rangeProvider},e.prototype.getFoldingModel=function(){return this.foldingModelPromise},e.prototype.onModelContentChanged=function(){var X=this;this.updateScheduler&&(this.foldingRegionPromise&&(this.foldingRegionPromise.cancel(),this.foldingRegionPromise=null),this.foldingModelPromise=this.updateScheduler.trigger((function(){var $=X.foldingModel;if(!$)return null;var Q=X.foldingRegionPromise=ne.createCancelablePromise((function(Q){return X.getRangeProvider($.textModel).compute(Q)}));return Q.then((function(J){if(J&&Q===X.foldingRegionPromise){var ee=X.editor.getSelections(),te=ee?ee.map((function(X){return X.startLineNumber})):[];$.update(J,te)}return $}))})))},e.prototype.onHiddenRangesChanges=function(X){if(this.hiddenRangeModel&&X.length){var $=this.editor.getSelections();$&&this.hiddenRangeModel.adjustSelections($)&&this.editor.setSelections($)}this.editor.setHiddenAreas(X)},e.prototype.onCursorPositionChanged=function(){this.hiddenRangeModel&&this.hiddenRangeModel.hasRanges()&&this.cursorChangedScheduler.schedule()},e.prototype.revealCursor=function(){var X=this,$=this.getFoldingModel();$&&$.then((function($){if($){var Q=X.editor.getSelections();if(Q&&Q.length>0){for(var J=[],o=function(Q){var ee=Q.selectionStartLineNumber;X.hiddenRangeModel&&X.hiddenRangeModel.isHidden(ee)&&J.push.apply(J,$.getAllRegionsAtLine(ee,(function(X){return X.isCollapsed&&ee>X.startLineNumber})))},ee=0,te=Q;ee<te.length;ee++)o(te[ee]);J.length&&($.toggleCollapseState(J),X.reveal(Q[0].getPosition()))}}})).then(void 0,ge.onUnexpectedError)},e.prototype.onEditorMouseDown=function(X){if(this.mouseDownInfo=null,this.hiddenRangeModel&&X.target&&X.target.range&&(X.event.leftButton||X.event.middleButton)){var $=X.target.range,Q=!1;switch(X.target.type){case 4:var J=X.target.detail,ee=X.target.element.offsetLeft;if(J.offsetX-ee<5)return;Q=!0;break;case 7:if(this.hiddenRangeModel.hasRanges()&&!X.target.detail.isAfterLines)break;return;case 6:if(this.hiddenRangeModel.hasRanges()){var te=this.editor.getModel();if(te&&$.startColumn===te.getLineMaxColumn($.startLineNumber))break}return;default:return}this.mouseDownInfo={lineNumber:$.startLineNumber,iconClicked:Q}}},e.prototype.onEditorMouseUp=function(X){var $=this,Q=this.getFoldingModel();if(Q&&this.mouseDownInfo&&X.target){var J=this.mouseDownInfo.lineNumber,ee=this.mouseDownInfo.iconClicked,te=X.target.range;if(te&&te.startLineNumber===J){if(ee){if(4!==X.target.type)return}else{var ne=this.editor.getModel();if(!ne||te.startColumn!==ne.getLineMaxColumn(J))return}Q.then((function(Q){if(Q){var te=Q.getRegionAtLine(J);if(te&&te.startLineNumber===J){var ne=te.isCollapsed;if(ee||ne){var ie=[te];(X.event.middleButton||X.event.shiftKey)&&ie.push.apply(ie,Q.getRegionsInside(te,(function(X){return X.isCollapsed===ne}))),Q.toggleCollapseState(ie),$.reveal({lineNumber:J,column:1})}}}})).then(void 0,ge.onUnexpectedError)}}},e.prototype.reveal=function(X){this.editor.revealPositionInCenterIfOutsideViewport(X,0)},e}();$.FoldingController=me;var ve=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype.runEditorCommand=function(X,$,Q){var J=this,ee=me.get($);if(ee){var te=ee.getFoldingModel();return te?(this.reportTelemetry(X,$),te.then((function(X){if(X){J.invoke(ee,X,$,Q);var te=$.getSelection();te&&ee.reveal(te.getStartPosition())}}))):void 0}},t.prototype.getSelectedLines=function(X){var $=X.getSelections();return $?$.map((function(X){return X.startLineNumber})):[]},t.prototype.getLineNumbers=function(X,$){return X&&X.selectionLines?X.selectionLines.map((function(X){return X+1})):this.getSelectedLines($)},t.prototype.run=function(X,$){},t}(re.EditorAction),_e=function(X){function t(){return X.call(this,{id:"editor.unfold",label:Q.localize(0,null),alias:"Unfold",precondition:null,kbOpts:{kbExpr:le.EditorContextKeys.editorTextFocus,primary:3161,mac:{primary:2649},weight:100},description:{description:"Unfold the content in the editor",args:[{name:"Unfold editor argument",description:"Property-value pairs that can be passed through this argument:\n\t\t\t\t\t\t* 'levels': Number of levels to unfold. If not set, defaults to 1.\n\t\t\t\t\t\t* 'direction': If 'up', unfold given number of levels up otherwise unfolds down.\n\t\t\t\t\t\t* 'selectionLines': The start lines (0-based) of the editor selections to apply the unfold action to. If not set, the active selection(s) will be used.\n\t\t\t\t\t\t",constraint:C}]}})||this}return te(t,X),t.prototype.invoke=function(X,$,Q,J){var ee=J&&J.levels||1,te=this.getLineNumbers(J,Q);J&&"up"===J.direction?se.setCollapseStateLevelsUp($,!1,ee,te):se.setCollapseStateLevelsDown($,!1,ee,te)},t}(ve),ye=function(X){function t(){return X.call(this,{id:"editor.unfoldRecursively",label:Q.localize(1,null),alias:"Unfold Recursively",precondition:null,kbOpts:{kbExpr:le.EditorContextKeys.editorTextFocus,primary:ie.KeyChord(2089,2137),weight:100}})||this}return te(t,X),t.prototype.invoke=function(X,$,Q,J){se.setCollapseStateLevelsDown($,!1,Number.MAX_VALUE,this.getSelectedLines(Q))},t}(ve),be=function(X){function t(){return X.call(this,{id:"editor.fold",label:Q.localize(2,null),alias:"Fold",precondition:null,kbOpts:{kbExpr:le.EditorContextKeys.editorTextFocus,primary:3159,mac:{primary:2647},weight:100},description:{description:"Fold the content in the editor",args:[{name:"Fold editor argument",description:"Property-value pairs that can be passed through this argument:\n\t\t\t\t\t\t\t* 'levels': Number of levels to fold. Defaults to 1.\n\t\t\t\t\t\t\t* 'direction': If 'up', folds given number of levels up otherwise folds down.\n\t\t\t\t\t\t\t* 'selectionLines': The start lines (0-based) of the editor selections to apply the fold action to. If not set, the active selection(s) will be used.\n\t\t\t\t\t\t",constraint:C}]}})||this}return te(t,X),t.prototype.invoke=function(X,$,Q,J){var ee=J&&J.levels||1,te=this.getLineNumbers(J,Q);J&&"up"===J.direction?se.setCollapseStateLevelsUp($,!0,ee,te):se.setCollapseStateLevelsDown($,!0,ee,te)},t}(ve),Ce=function(X){function t(){return X.call(this,{id:"editor.foldRecursively",label:Q.localize(3,null),alias:"Fold Recursively",precondition:null,kbOpts:{kbExpr:le.EditorContextKeys.editorTextFocus,primary:ie.KeyChord(2089,2135),weight:100}})||this}return te(t,X),t.prototype.invoke=function(X,$,Q){var J=this.getSelectedLines(Q);se.setCollapseStateLevelsDown($,!0,Number.MAX_VALUE,J)},t}(ve),we=function(X){function t(){return X.call(this,{id:"editor.foldAllBlockComments",label:Q.localize(4,null),alias:"Fold All Block Comments",precondition:null,kbOpts:{kbExpr:le.EditorContextKeys.editorTextFocus,primary:ie.KeyChord(2089,2133),weight:100}})||this}return te(t,X),t.prototype.invoke=function(X,$,Q){if($.regions.hasTypes())se.setCollapseStateForType($,he.FoldingRangeKind.Comment.value,!0);else{var J=Q.getModel();if(!J)return;var te=de.LanguageConfigurationRegistry.getComments(J.getLanguageIdentifier().id);if(te&&te.blockCommentStartToken){var ne=new RegExp("^\\s*"+ee.escapeRegExpCharacters(te.blockCommentStartToken));se.setCollapseStateForMatchingLines($,ne,!0)}}},t}(ve),Se=function(X){function t(){return X.call(this,{id:"editor.foldAllMarkerRegions",label:Q.localize(5,null),alias:"Fold All Regions",precondition:null,kbOpts:{kbExpr:le.EditorContextKeys.editorTextFocus,primary:ie.KeyChord(2089,2077),weight:100}})||this}return te(t,X),t.prototype.invoke=function(X,$,Q){if($.regions.hasTypes())se.setCollapseStateForType($,he.FoldingRangeKind.Region.value,!0);else{var J=Q.getModel();if(!J)return;var ee=de.LanguageConfigurationRegistry.getFoldingRules(J.getLanguageIdentifier().id);if(ee&&ee.markers&&ee.markers.start){var te=new RegExp(ee.markers.start);se.setCollapseStateForMatchingLines($,te,!0)}}},t}(ve),Ee=function(X){function t(){return X.call(this,{id:"editor.unfoldAllMarkerRegions",label:Q.localize(6,null),alias:"Unfold All Regions",precondition:null,kbOpts:{kbExpr:le.EditorContextKeys.editorTextFocus,primary:ie.KeyChord(2089,2078),weight:100}})||this}return te(t,X),t.prototype.invoke=function(X,$,Q){if($.regions.hasTypes())se.setCollapseStateForType($,he.FoldingRangeKind.Region.value,!1);else{var J=Q.getModel();if(!J)return;var ee=de.LanguageConfigurationRegistry.getFoldingRules(J.getLanguageIdentifier().id);if(ee&&ee.markers&&ee.markers.start){var te=new RegExp(ee.markers.start);se.setCollapseStateForMatchingLines($,te,!1)}}},t}(ve),Le=function(X){function t(){return X.call(this,{id:"editor.foldAll",label:Q.localize(7,null),alias:"Fold All",precondition:null,kbOpts:{kbExpr:le.EditorContextKeys.editorTextFocus,primary:ie.KeyChord(2089,2069),weight:100}})||this}return te(t,X),t.prototype.invoke=function(X,$,Q){se.setCollapseStateLevelsDown($,!0)},t}(ve),xe=function(X){function t(){return X.call(this,{id:"editor.unfoldAll",label:Q.localize(8,null),alias:"Unfold All",precondition:null,kbOpts:{kbExpr:le.EditorContextKeys.editorTextFocus,primary:ie.KeyChord(2089,2088),weight:100}})||this}return te(t,X),t.prototype.invoke=function(X,$,Q){se.setCollapseStateLevelsDown($,!1)},t}(ve),Ie=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype.getFoldingLevel=function(){return parseInt(this.id.substr(t.ID_PREFIX.length))},t.prototype.invoke=function(X,$,Q){se.setCollapseStateAtLevel($,this.getFoldingLevel(),!0,this.getSelectedLines(Q))},t.ID_PREFIX="editor.foldLevel",t.ID=function(X){return t.ID_PREFIX+X},t}(ve);re.registerEditorContribution(me),re.registerEditorAction(_e),re.registerEditorAction(ye),re.registerEditorAction(be),re.registerEditorAction(Ce),re.registerEditorAction(Le),re.registerEditorAction(xe),re.registerEditorAction(we),re.registerEditorAction(Se),re.registerEditorAction(Ee);for(var De=1;De<=7;De++)re.registerInstantiatedEditorAction(new Ie({id:Ie.ID(De),label:Q.localize(9,null,De),alias:"Fold Level "+De,precondition:null,kbOpts:{kbExpr:le.EditorContextKeys.editorTextFocus,primary:ie.KeyChord(2089,2048|21+De),weight:100}}))})),define(Q[460],n([0,1,312,10,97]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var ne=function(X){function t(){return X.call(this,{id:"editor.action.fontZoomIn",label:Q.localize(0,null),alias:"Editor Font Zoom In",precondition:null})||this}return te(t,X),t.prototype.run=function(X,$){ee.EditorZoom.setZoomLevel(ee.EditorZoom.getZoomLevel()+1)},t}(J.EditorAction),ie=function(X){function t(){return X.call(this,{id:"editor.action.fontZoomOut",label:Q.localize(1,null),alias:"Editor Font Zoom Out",precondition:null})||this}return te(t,X),t.prototype.run=function(X,$){ee.EditorZoom.setZoomLevel(ee.EditorZoom.getZoomLevel()-1)},t}(J.EditorAction),oe=function(X){function t(){return X.call(this,{id:"editor.action.fontZoomReset",label:Q.localize(2,null),alias:"Editor Font Zoom Reset",precondition:null})||this}return te(t,X),t.prototype.run=function(X,$){ee.EditorZoom.setZoomLevel(0)},t}(J.EditorAction);J.registerEditorAction(ne),J.registerEditorAction(ie),J.registerEditorAction(oe)})),define(Q[461],n([0,1,11,25,22,3,10,14,42,16,24]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae){function h(X,$,J,te){var ne=oe.DocumentRangeFormattingEditProviderRegistry.ordered(X);return 0===ne.length?Promise.reject(new le):se.first(ne.map((function(ee){return function(){return Promise.resolve(ee.provideDocumentRangeFormattingEdits(X,$,J,te)).then(void 0,Q.onUnexpectedExternalError)}})),(function(X){return!ee.isFalsyOrEmpty(X)}))}function p(X,$,J){var te=oe.DocumentFormattingEditProviderRegistry.ordered(X);return 0===te.length?h(X,X.getFullModelRange(),$,J):se.first(te.map((function(ee){return function(){return Promise.resolve(ee.provideDocumentFormattingEdits(X,$,J)).then(void 0,Q.onUnexpectedExternalError)}})),(function(X){return!ee.isFalsyOrEmpty(X)}))}function f(X,$,J,ee){var te=oe.OnTypeFormattingEditProviderRegistry.ordered(X)[0];return te?te.autoFormatTriggerCharacters.indexOf(J)<0?Promise.resolve(void 0):Promise.resolve(te.provideOnTypeFormattingEdits(X,$,J,ee,ae.CancellationToken.None)).then((function(X){return X}),Q.onUnexpectedExternalError):Promise.resolve(void 0)}Object.defineProperty($,"__esModule",{value:!0});var le=function(X){function t($){var Q=X.call(this)||this;return Q.name=t.Name,Q.message=$,Q}return te(t,X),t.Name="NOPRO",t}(Error);$.NoProviderError=le,$.getDocumentRangeFormattingEdits=h,$.getDocumentFormattingEdits=p,$.getOnTypeFormattingEdits=f,ie.registerLanguageCommand("_executeFormatRangeProvider",(function(X,$){var ee=$.resource,te=$.range,ie=$.options;if(!(ee instanceof J.URI&&ne.Range.isIRange(te)))throw Q.illegalArgument();var oe=X.get(re.IModelService).getModel(ee);if(!oe)throw Q.illegalArgument("resource");return h(oe,ne.Range.lift(te),ie,ae.CancellationToken.None)})),ie.registerLanguageCommand("_executeFormatDocumentProvider",(function(X,$){var ee=$.resource,te=$.options;if(!(ee instanceof J.URI))throw Q.illegalArgument("resource");var ne=X.get(re.IModelService).getModel(ee);if(!ne)throw Q.illegalArgument("resource");return p(ne,te,ae.CancellationToken.None)})),ie.registerDefaultLanguageCommand("_executeFormatOnTypeProvider",(function(X,$,J){var ee=J.ch,te=J.options;if("string"!=typeof ee)throw Q.illegalArgument("ch");return f(X,$,ee,te)}))})),define(Q[462],n([0,1,313,22,36,2,18,10,14,461,249,31,30,64,81,3,43,66,19,35,24]),(function(X,$,Q,J,ee,ie,re,se,ae,le,ue,de,ce,he,pe,fe,ge,me,ve,_e,ye){function E(X){if((X=X.filter((function(X){return X.range}))).length){for(var $=X[0].range,J=1;J<X.length;J++)$=fe.Range.plusRange($,X[J].range);var ee=$.startLineNumber,te=$.endLineNumber;ee===te?1===X.length?ge.alert(Q.localize(0,null,ee)):ge.alert(Q.localize(1,null,X.length,ee)):1===X.length?ge.alert(Q.localize(2,null,ee,te)):ge.alert(Q.localize(3,null,X.length,ee,te))}}Object.defineProperty($,"__esModule",{value:!0});var be=function(){function e(X,$){var Q=this;this.editor=X,this.workerService=$,this.callOnDispose=[],this.callOnModel=[],this.callOnDispose.push(X.onDidChangeConfiguration((function(){return Q.update()}))),this.callOnDispose.push(X.onDidChangeModel((function(){return Q.update()}))),this.callOnDispose.push(X.onDidChangeModelLanguage((function(){return Q.update()}))),this.callOnDispose.push(ae.OnTypeFormattingEditProviderRegistry.onDidChange(this.update,this))}return e.prototype.update=function(){var X=this;if(this.callOnModel=ie.dispose(this.callOnModel),this.editor.getConfiguration().contribInfo.formatOnType&&this.editor.getModel()){var $=this.editor.getModel(),Q=ae.OnTypeFormattingEditProviderRegistry.ordered($)[0];if(Q&&Q.autoFormatTriggerCharacters){for(var J=new pe.CharacterSet,ee=0,te=Q.autoFormatTriggerCharacters;ee<te.length;ee++){var ne=te[ee];J.add(ne.charCodeAt(0))}this.callOnModel.push(this.editor.onDidType((function($){var Q=$.charCodeAt($.length-1);J.has(Q)&&X.trigger(String.fromCharCode(Q))})))}}},e.prototype.trigger=function(X){var $=this;if(!(this.editor.getSelections().length>1)){var Q=this.editor.getModel(),ee=this.editor.getPosition(),te=!1,ne=this.editor.onDidChangeModelContent((function(X){if(X.isFlush)return te=!0,void ne.dispose();for(var $=0,Q=X.changes.length;$<Q;$++)if(X.changes[$].range.endLineNumber<=ee.lineNumber)return te=!0,void ne.dispose()})),ie=Q.getOptions();le.getOnTypeFormattingEdits(Q,ee,X,{tabSize:ie.tabSize,insertSpaces:ie.insertSpaces}).then((function(X){return $.workerService.computeMoreMinimalEdits(Q.uri,X)})).then((function(X){ne.dispose(),te||J.isFalsyOrEmpty(X)||(ue.FormattingEdit.execute($.editor,X),E(X))}),(function(X){throw ne.dispose(),X}))}},e.prototype.getId=function(){return e.ID},e.prototype.dispose=function(){this.callOnDispose=ie.dispose(this.callOnDispose),this.callOnModel=ie.dispose(this.callOnModel)},e.ID="editor.contrib.autoFormat",e=ne([oe(1,he.IEditorWorkerService)],e)}(),Ce=function(){function e(X,$){var Q=this;this.editor=X,this.workerService=$,this.callOnDispose=[],this.callOnModel=[],this.callOnDispose.push(X.onDidChangeConfiguration((function(){return Q.update()}))),this.callOnDispose.push(X.onDidChangeModel((function(){return Q.update()}))),this.callOnDispose.push(X.onDidChangeModelLanguage((function(){return Q.update()}))),this.callOnDispose.push(ae.DocumentRangeFormattingEditProviderRegistry.onDidChange(this.update,this))}return e.prototype.update=function(){var X=this;if(this.callOnModel=ie.dispose(this.callOnModel),this.editor.getConfiguration().contribInfo.formatOnPaste&&this.editor.getModel()){var $=this.editor.getModel(),Q=ae.DocumentRangeFormattingEditProviderRegistry.ordered($)[0];Q&&Q.provideDocumentRangeFormattingEdits&&this.callOnModel.push(this.editor.onDidPaste((function($){X.trigger($)})))}},e.prototype.trigger=function(X){var $=this;if(!(this.editor.getSelections().length>1)){var Q=this.editor.getModel(),ee=Q.getOptions(),te=ee.tabSize,ne=ee.insertSpaces,ie=new me.EditorState(this.editor,5);le.getDocumentRangeFormattingEdits(Q,X,{tabSize:te,insertSpaces:ne},ye.CancellationToken.None).then((function(X){return $.workerService.computeMoreMinimalEdits(Q.uri,X)})).then((function(X){ie.validate($.editor)&&!J.isFalsyOrEmpty(X)&&(ue.FormattingEdit.execute($.editor,X),E(X))}))}},e.prototype.getId=function(){return e.ID},e.prototype.dispose=function(){this.callOnDispose=ie.dispose(this.callOnDispose),this.callOnModel=ie.dispose(this.callOnModel)},e.ID="editor.contrib.formatOnPaste",e=ne([oe(1,he.IEditorWorkerService)],e)}(),we=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype.run=function(X,$){var Q=this,ee=X.get(he.IEditorWorkerService),te=X.get(_e.INotificationService),ne=this._getFormattingEdits($,ye.CancellationToken.None);if(!ne)return Promise.resolve(void 0);var ie=new me.EditorState($,5);return ne.then((function(X){return ee.computeMoreMinimalEdits($.getModel().uri,X)})).then((function(X){ie.validate($)&&!J.isFalsyOrEmpty(X)&&(ue.FormattingEdit.execute($,X),E(X),$.focus(),$.revealPositionInCenterIfOutsideViewport($.getPosition(),1))}),(function(X){if(!(X instanceof Error&&X.name===le.NoProviderError.Name))throw X;Q._notifyNoProviderError(te,$.getModel().getLanguageIdentifier().language)}))},t.prototype._notifyNoProviderError=function(X,$){X.info(Q.localize(4,null,$))},t}(se.EditorAction);$.AbstractFormatAction=we;var Se=function(X){function t(){return X.call(this,{id:"editor.action.formatDocument",label:Q.localize(5,null),alias:"Format Document",precondition:ve.EditorContextKeys.writable,kbOpts:{kbExpr:ve.EditorContextKeys.editorTextFocus,primary:1572,linux:{primary:3111},weight:100},menuOpts:{when:ve.EditorContextKeys.hasDocumentFormattingProvider,group:"1_modification",order:1.3}})||this}return te(t,X),t.prototype._getFormattingEdits=function(X,$){var Q=X.getModel(),J=Q.getOptions(),ee=J.tabSize,te=J.insertSpaces;return le.getDocumentFormattingEdits(Q,{tabSize:ee,insertSpaces:te},$)},t.prototype._notifyNoProviderError=function(X,$){X.info(Q.localize(6,null,$))},t}(we);$.FormatDocumentAction=Se;var Ee=function(X){function t(){return X.call(this,{id:"editor.action.formatSelection",label:Q.localize(7,null),alias:"Format Code",precondition:re.ContextKeyExpr.and(ve.EditorContextKeys.writable),kbOpts:{kbExpr:ve.EditorContextKeys.editorTextFocus,primary:ee.KeyChord(2089,2084),weight:100},menuOpts:{when:re.ContextKeyExpr.and(ve.EditorContextKeys.hasDocumentSelectionFormattingProvider,ve.EditorContextKeys.hasNonEmptySelection),group:"1_modification",order:1.31}})||this}return te(t,X),t.prototype._getFormattingEdits=function(X,$){var Q=X.getModel(),J=X.getSelection();if(J.isEmpty()){var ee=Q.getLineMaxColumn(J.startLineNumber);J=(J=J.setStartPosition(J.startLineNumber,1)).setEndPosition(J.endLineNumber,ee)}var te=Q.getOptions(),ne=te.tabSize,ie=te.insertSpaces;return le.getDocumentRangeFormattingEdits(Q,J,{tabSize:ne,insertSpaces:ie},$)},t.prototype._notifyNoProviderError=function(X,$){X.info(Q.localize(8,null,$))},t}(we);$.FormatSelectionAction=Ee,se.registerEditorContribution(be),se.registerEditorContribution(Ce),se.registerEditorAction(Se),se.registerEditorAction(Ee),de.CommandsRegistry.registerCommand("editor.action.format",(function(X){var $=X.get(ce.ICodeEditorService).getFocusedCodeEditor();if($)return(new(function(X){function t(){return X.call(this,{})||this}return te(t,X),t.prototype._getFormattingEdits=function(X,$){var Q=X.getModel(),J=X.getSelection(),ee=Q.getOptions(),te=ee.tabSize,ne=ee.insertSpaces;return J.isEmpty()?le.getDocumentFormattingEdits(Q,{tabSize:te,insertSpaces:ne},$):le.getDocumentRangeFormattingEdits(Q,J,{tabSize:te,insertSpaces:ne},$)},t}(we))).run(X,$)}))})),define(Q[176],n([0,1,22,24,11,10,14]),(function(X,$,Q,J,ee,te,ne){function a(X,$,J,te){var ne=J.ordered(X).map((function(Q){return Promise.resolve(te(Q,X,$)).then(void 0,(function(X){return ee.onUnexpectedExternalError(X),null}))}));return Promise.all(ne).then(Q.flatten).then(Q.coalesce)}function l(X,$,Q){return a(X,$,ne.DefinitionProviderRegistry,(function(X,$,J){return X.provideDefinition($,J,Q)}))}function u(X,$,Q){return a(X,$,ne.ImplementationProviderRegistry,(function(X,$,J){return X.provideImplementation($,J,Q)}))}function d(X,$,Q){return a(X,$,ne.TypeDefinitionProviderRegistry,(function(X,$,J){return X.provideTypeDefinition($,J,Q)}))}Object.defineProperty($,"__esModule",{value:!0}),$.getDefinitionsAtPosition=l,$.getImplementationsAtPosition=u,$.getTypeDefinitionsAtPosition=d,te.registerDefaultLanguageCommand("_executeDefinitionProvider",(function(X,$){return l(X,$,J.CancellationToken.None)})),te.registerDefaultLanguageCommand("_executeImplementationProvider",(function(X,$){return u(X,$,J.CancellationToken.None)})),te.registerDefaultLanguageCommand("_executeTypeDefinitionProvider",(function(X,$){return d(X,$,J.CancellationToken.None)}))})),define(Q[464],n([0,1,22,24,11,10,14]),(function(X,$,Q,J,ee,te,ne){function a(X,$,J){var te=ne.HoverProviderRegistry.ordered(X).map((function(Q){return Promise.resolve(Q.provideHover(X,$,J)).then((function(X){return X&&function(X){var $=void 0!==X.range,Q=void 0!==X.contents&&X.contents&&X.contents.length>0;return $&&Q}(X)?X:void 0}),(function(X){ee.onUnexpectedExternalError(X)}))}));return Promise.all(te).then(Q.coalesce)}Object.defineProperty($,"__esModule",{value:!0}),$.getHover=a,te.registerDefaultLanguageCommand("_executeHoverProvider",(function(X,$){return a(X,$,J.CancellationToken.None)}))})),define(Q[465],n([0,1,321,36,132,10,77,425,137,49,12,3,21,19,256,257,394,258,37]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le,ue,de,ce,he,pe,fe,ge){Object.defineProperty($,"__esModule",{value:!0});var me=function(X){function t($,Q){var J=X.call(this,Q)||this;return J.down=$,J}return te(t,X),t.prototype.run=function(X,$){for(var Q=[],J=$.getSelections()||[],ee=0;ee<J.length;ee++)Q.push(new ce.CopyLinesCommand(J[ee],this.down));$.pushUndoStop(),$.executeCommands(this.id,Q),$.pushUndoStop()},t}(ne.EditorAction),ve=function(X){function t(){return X.call(this,!1,{id:"editor.action.copyLinesUpAction",label:Q.localize(0,null),alias:"Copy Line Up",precondition:de.EditorContextKeys.writable,kbOpts:{kbExpr:de.EditorContextKeys.editorTextFocus,primary:1552,linux:{primary:3600},weight:100},menubarOpts:{menuId:ge.MenuId.MenubarSelectionMenu,group:"2_line",title:Q.localize(1,null),order:1}})||this}return te(t,X),t}(me),_e=function(X){function t(){return X.call(this,!0,{id:"editor.action.copyLinesDownAction",label:Q.localize(2,null),alias:"Copy Line Down",precondition:de.EditorContextKeys.writable,kbOpts:{kbExpr:de.EditorContextKeys.editorTextFocus,primary:1554,linux:{primary:3602},weight:100},menubarOpts:{menuId:ge.MenuId.MenubarSelectionMenu,group:"2_line",title:Q.localize(3,null),order:2}})||this}return te(t,X),t}(me),ye=function(X){function t($,Q){var J=X.call(this,Q)||this;return J.down=$,J}return te(t,X),t.prototype.run=function(X,$){for(var Q=[],J=$.getSelections()||[],ee=$.getConfiguration().autoIndent,te=0;te<J.length;te++)Q.push(new pe.MoveLinesCommand(J[te],this.down,ee));$.pushUndoStop(),$.executeCommands(this.id,Q),$.pushUndoStop()},t}(ne.EditorAction),be=function(X){function t(){return X.call(this,!1,{id:"editor.action.moveLinesUpAction",label:Q.localize(4,null),alias:"Move Line Up",precondition:de.EditorContextKeys.writable,kbOpts:{kbExpr:de.EditorContextKeys.editorTextFocus,primary:528,linux:{primary:528},weight:100},menubarOpts:{menuId:ge.MenuId.MenubarSelectionMenu,group:"2_line",title:Q.localize(5,null),order:3}})||this}return te(t,X),t}(ye),Ce=function(X){function t(){return X.call(this,!0,{id:"editor.action.moveLinesDownAction",label:Q.localize(6,null),alias:"Move Line Down",precondition:de.EditorContextKeys.writable,kbOpts:{kbExpr:de.EditorContextKeys.editorTextFocus,primary:530,linux:{primary:530},weight:100},menubarOpts:{menuId:ge.MenuId.MenubarSelectionMenu,group:"2_line",title:Q.localize(7,null),order:4}})||this}return te(t,X),t}(ye),we=function(X){function t($,Q){var J=X.call(this,Q)||this;return J.descending=$,J}return te(t,X),t.prototype.run=function(X,$){for(var Q=$.getSelections()||[],J=0,ee=Q.length;J<ee;J++){var te=Q[J];if(!fe.SortLinesCommand.canRun($.getModel(),te,this.descending))return}var ne=[];for(J=0,ee=Q.length;J<ee;J++)ne[J]=new fe.SortLinesCommand(Q[J],this.descending);$.pushUndoStop(),$.executeCommands(this.id,ne),$.pushUndoStop()},t}(ne.EditorAction);$.AbstractSortLinesAction=we;var Se=function(X){function t(){return X.call(this,!1,{id:"editor.action.sortLinesAscending",label:Q.localize(8,null),alias:"Sort Lines Ascending",precondition:de.EditorContextKeys.writable})||this}return te(t,X),t}(we);$.SortLinesAscendingAction=Se;var Ee=function(X){function t(){return X.call(this,!0,{id:"editor.action.sortLinesDescending",label:Q.localize(9,null),alias:"Sort Lines Descending",precondition:de.EditorContextKeys.writable})||this}return te(t,X),t}(we);$.SortLinesDescendingAction=Ee;var Le=function(X){function t(){return X.call(this,{id:t.ID,label:Q.localize(10,null),alias:"Trim Trailing Whitespace",precondition:de.EditorContextKeys.writable,kbOpts:{kbExpr:de.EditorContextKeys.editorTextFocus,primary:J.KeyChord(2089,2102),weight:100}})||this}return te(t,X),t.prototype.run=function(X,$,Q){var J=[];"auto-save"===Q.reason&&(J=($.getSelections()||[]).map((function(X){return new ae.Position(X.positionLineNumber,X.positionColumn)})));var ee=new oe.TrimTrailingWhitespaceCommand($.getSelection(),J);$.pushUndoStop(),$.executeCommands(this.id,[ee]),$.pushUndoStop()},t.ID="editor.action.trimTrailingWhitespace",t}(ne.EditorAction);$.TrimTrailingWhitespaceAction=Le;var xe=function(X){function t(){return X.call(this,{id:"editor.action.deleteLines",label:Q.localize(11,null),alias:"Delete Line",precondition:de.EditorContextKeys.writable,kbOpts:{kbExpr:de.EditorContextKeys.textInputFocus,primary:3113,weight:100}})||this}return te(t,X),t.prototype.run=function(X,$){var Q=this._getLinesToRemove($).map((function(X){return new he.DeleteLinesCommand(X.startLineNumber,X.endLineNumber,X.positionColumn)}));$.pushUndoStop(),$.executeCommands(this.id,Q),$.pushUndoStop()},t.prototype._getLinesToRemove=function(X){var $=X.getSelections().map((function(X){var $=X.endLineNumber;return X.startLineNumber<X.endLineNumber&&1===X.endColumn&&($-=1),{startLineNumber:X.startLineNumber,endLineNumber:$,positionColumn:X.positionColumn}}));$.sort((function(X,$){return X.startLineNumber-$.startLineNumber}));for(var Q=[],J=$[0],ee=1;ee<$.length;ee++)J.endLineNumber+1===$[ee].startLineNumber?J.endLineNumber=$[ee].endLineNumber:(Q.push(J),J=$[ee]);return Q.push(J),Q},t}(ne.EditorAction),Ie=function(X){function t(){return X.call(this,{id:"editor.action.indentLines",label:Q.localize(12,null),alias:"Indent Line",precondition:de.EditorContextKeys.writable,kbOpts:{kbExpr:de.EditorContextKeys.editorTextFocus,primary:2137,weight:100}})||this}return te(t,X),t.prototype.run=function(X,$){var Q=$._getCursors();Q&&($.pushUndoStop(),$.executeCommands(this.id,re.TypeOperations.indent(Q.context.config,$.getModel(),$.getSelections())),$.pushUndoStop())},t}(ne.EditorAction);$.IndentLinesAction=Ie;var De=function(X){function t(){return X.call(this,{id:"editor.action.outdentLines",label:Q.localize(13,null),alias:"Outdent Line",precondition:de.EditorContextKeys.writable,kbOpts:{kbExpr:de.EditorContextKeys.editorTextFocus,primary:2135,weight:100}})||this}return te(t,X),t.prototype.run=function(X,$){ee.CoreEditingCommands.Outdent.runEditorCommand(null,$,null)},t}(ne.EditorAction),Ne=function(X){function t(){return X.call(this,{id:"editor.action.insertLineBefore",label:Q.localize(14,null),alias:"Insert Line Above",precondition:de.EditorContextKeys.writable,kbOpts:{kbExpr:de.EditorContextKeys.editorTextFocus,primary:3075,weight:100}})||this}return te(t,X),t.prototype.run=function(X,$){var Q=$._getCursors();Q&&($.pushUndoStop(),$.executeCommands(this.id,re.TypeOperations.lineInsertBefore(Q.context.config,$.getModel(),$.getSelections())))},t}(ne.EditorAction);$.InsertLineBeforeAction=Ne;var Me=function(X){function t(){return X.call(this,{id:"editor.action.insertLineAfter",label:Q.localize(15,null),alias:"Insert Line Below",precondition:de.EditorContextKeys.writable,kbOpts:{kbExpr:de.EditorContextKeys.editorTextFocus,primary:2051,weight:100}})||this}return te(t,X),t.prototype.run=function(X,$){var Q=$._getCursors();Q&&($.pushUndoStop(),$.executeCommands(this.id,re.TypeOperations.lineInsertAfter(Q.context.config,$.getModel(),$.getSelections())))},t}(ne.EditorAction);$.InsertLineAfterAction=Me;var ke=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype.run=function(X,$){for(var Q=$.getSelection(),J=this._getRangesToDelete($),ee=[],te=0,ne=J.length-1;te<ne;te++){var ie=J[te],oe=J[te+1];null===le.Range.intersectRanges(ie,oe)?ee.push(ie):J[te+1]=le.Range.plusRange(ie,oe)}ee.push(J[J.length-1]);var re=this._getEndCursorState(Q,ee),ae=ee.map((function(X){return se.EditOperation.replace(X,"")}));$.pushUndoStop(),$.executeEdits(this.id,ae,re),$.pushUndoStop()},t}(ne.EditorAction);$.AbstractDeleteAllToBoundaryAction=ke;var Te=function(X){function t(){return X.call(this,{id:"deleteAllLeft",label:Q.localize(16,null),alias:"Delete All Left",precondition:de.EditorContextKeys.writable,kbOpts:{kbExpr:de.EditorContextKeys.textInputFocus,primary:0,mac:{primary:2049},weight:100}})||this}return te(t,X),t.prototype._getEndCursorState=function(X,$){var Q,J=[],ee=0;return $.forEach((function($){var te;if(1===$.endColumn&&ee>0){var ne=$.startLineNumber-ee;te=new ue.Selection(ne,$.startColumn,ne,$.startColumn)}else te=new ue.Selection($.startLineNumber,$.startColumn,$.startLineNumber,$.startColumn);ee+=$.endLineNumber-$.startLineNumber,$.intersectRanges(X)?Q=te:J.push(te)})),Q&&J.unshift(Q),J},t.prototype._getRangesToDelete=function(X){var $=X.getSelections(),Q=X.getModel();return $.sort(le.Range.compareRangesUsingStarts),$.map((function(X){if(X.isEmpty()){if(1===X.startColumn){var $=Math.max(1,X.startLineNumber-1),J=1===X.startLineNumber?1:Q.getLineContent($).length+1;return new le.Range($,J,X.startLineNumber,1)}return new le.Range(X.startLineNumber,1,X.startLineNumber,X.startColumn)}return X}))},t}(ke);$.DeleteAllLeftAction=Te;var Re=function(X){function t(){return X.call(this,{id:"deleteAllRight",label:Q.localize(17,null),alias:"Delete All Right",precondition:de.EditorContextKeys.writable,kbOpts:{kbExpr:de.EditorContextKeys.textInputFocus,primary:0,mac:{primary:297,secondary:[2068]},weight:100}})||this}return te(t,X),t.prototype._getEndCursorState=function(X,$){for(var Q,J=[],ee=0,te=$.length;ee<te;ee++){var ne=$[ee],ie=new ue.Selection(ne.startLineNumber-0,ne.startColumn,ne.startLineNumber-0,ne.startColumn);ne.intersectRanges(X)?Q=ie:J.push(ie)}return Q&&J.unshift(Q),J},t.prototype._getRangesToDelete=function(X){var $=X.getModel(),Q=X.getSelections().map((function(X){if(X.isEmpty()){var Q=$.getLineMaxColumn(X.startLineNumber);return X.startColumn===Q?new le.Range(X.startLineNumber,X.startColumn,X.startLineNumber+1,1):new le.Range(X.startLineNumber,X.startColumn,X.startLineNumber,Q)}return X}));return Q.sort(le.Range.compareRangesUsingStarts),Q},t}(ke);$.DeleteAllRightAction=Re;var Oe=function(X){function t(){return X.call(this,{id:"editor.action.joinLines",label:Q.localize(18,null),alias:"Join Lines",precondition:de.EditorContextKeys.writable,kbOpts:{kbExpr:de.EditorContextKeys.editorTextFocus,primary:0,mac:{primary:296},weight:100}})||this}return te(t,X),t.prototype.run=function(X,$){var Q=$.getSelections(),J=$.getSelection();Q.sort(le.Range.compareRangesUsingStarts);var ee=[],te=Q.reduce((function(X,$){return X.isEmpty()?X.endLineNumber===$.startLineNumber?(J.equalsSelection(X)&&(J=$),$):$.startLineNumber>X.endLineNumber+1?(ee.push(X),$):new ue.Selection(X.startLineNumber,X.startColumn,$.endLineNumber,$.endColumn):$.startLineNumber>X.endLineNumber?(ee.push(X),$):new ue.Selection(X.startLineNumber,X.startColumn,$.endLineNumber,$.endColumn)}));ee.push(te);for(var ne=$.getModel(),ie=[],oe=[],re=J,ae=0,de=0,ce=ee.length;de<ce;de++){var he=ee[de],pe=he.startLineNumber,fe=0,ge=void 0,me=void 0,ve=ne.getLineContent(he.endLineNumber).length-he.endColumn;if(he.isEmpty()||he.startLineNumber===he.endLineNumber){var _e=he.getStartPosition();_e.lineNumber<ne.getLineCount()?(ge=pe+1,me=ne.getLineMaxColumn(ge)):(ge=_e.lineNumber,me=ne.getLineMaxColumn(_e.lineNumber))}else ge=he.endLineNumber,me=ne.getLineMaxColumn(ge);for(var ye=ne.getLineContent(pe),be=pe+1;be<=ge;be++){var Ce=ne.getLineContent(be),we=ne.getLineFirstNonWhitespaceColumn(be);if(we>=1){var Se=!0;""===ye&&(Se=!1),!Se||" "!==ye.charAt(ye.length-1)&&"\t"!==ye.charAt(ye.length-1)||(Se=!1,ye=ye.replace(/[\s\uFEFF\xA0]+$/g," "));var Ee=Ce.substr(we-1);ye+=(Se?" ":"")+Ee,fe=Se?Ee.length+1:Ee.length}else fe=0}var Le=new le.Range(pe,1,ge,me);if(!Le.isEmpty()){var xe=void 0;he.isEmpty()?(ie.push(se.EditOperation.replace(Le,ye)),xe=new ue.Selection(Le.startLineNumber-ae,ye.length-fe+1,pe-ae,ye.length-fe+1)):he.startLineNumber===he.endLineNumber?(ie.push(se.EditOperation.replace(Le,ye)),xe=new ue.Selection(he.startLineNumber-ae,he.startColumn,he.endLineNumber-ae,he.endColumn)):(ie.push(se.EditOperation.replace(Le,ye)),xe=new ue.Selection(he.startLineNumber-ae,he.startColumn,he.startLineNumber-ae,ye.length-ve)),null!==le.Range.intersectRanges(Le,J)?re=xe:oe.push(xe)}ae+=Le.endLineNumber-Le.startLineNumber}oe.unshift(re),$.pushUndoStop(),$.executeEdits(this.id,ie,oe),$.pushUndoStop()},t}(ne.EditorAction);$.JoinLinesAction=Oe;var Pe=function(X){function t(){return X.call(this,{id:"editor.action.transpose",label:Q.localize(19,null),alias:"Transpose characters around the cursor",precondition:de.EditorContextKeys.writable})||this}return te(t,X),t.prototype.run=function(X,$){for(var Q=$.getSelections(),J=$.getModel(),ee=[],te=0,ne=Q.length;te<ne;te++){var oe=Q[te];if(oe.isEmpty()){var re=oe.getStartPosition(),se=J.getLineMaxColumn(re.lineNumber);if(re.column>=se){if(re.lineNumber===J.getLineCount())continue;var ae=new le.Range(re.lineNumber,Math.max(1,re.column-1),re.lineNumber+1,1),de=J.getValueInRange(ae).split("").reverse().join("");ee.push(new ie.ReplaceCommand(new ue.Selection(re.lineNumber,Math.max(1,re.column-1),re.lineNumber+1,1),de))}else{ae=new le.Range(re.lineNumber,Math.max(1,re.column-1),re.lineNumber,re.column+1),de=J.getValueInRange(ae).split("").reverse().join("");ee.push(new ie.ReplaceCommandThatPreservesSelection(ae,de,new ue.Selection(re.lineNumber,re.column+1,re.lineNumber,re.column+1)))}}}$.pushUndoStop(),$.executeCommands(this.id,ee),$.pushUndoStop()},t}(ne.EditorAction);$.TransposeAction=Pe;var Ae=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype.run=function(X,$){for(var Q=$.getSelections(),J=$.getModel(),ee=[],te=0,ne=Q.length;te<ne;te++){var oe=Q[te];if(oe.isEmpty()){var re=oe.getStartPosition(),se=J.getWordAtPosition(re);if(!se)continue;var ae=new le.Range(re.lineNumber,se.startColumn,re.lineNumber,se.endColumn),de=J.getValueInRange(ae);ee.push(new ie.ReplaceCommandThatPreservesSelection(ae,this._modifyText(de),new ue.Selection(re.lineNumber,re.column,re.lineNumber,re.column)))}else de=J.getValueInRange(oe),ee.push(new ie.ReplaceCommandThatPreservesSelection(oe,this._modifyText(de),oe))}$.pushUndoStop(),$.executeCommands(this.id,ee),$.pushUndoStop()},t}(ne.EditorAction);$.AbstractCaseAction=Ae;var Fe=function(X){function t(){return X.call(this,{id:"editor.action.transformToUppercase",label:Q.localize(20,null),alias:"Transform to Uppercase",precondition:de.EditorContextKeys.writable})||this}return te(t,X),t.prototype._modifyText=function(X){return X.toLocaleUpperCase()},t}(Ae);$.UpperCaseAction=Fe;var We=function(X){function t(){return X.call(this,{id:"editor.action.transformToLowercase",label:Q.localize(21,null),alias:"Transform to Lowercase",precondition:de.EditorContextKeys.writable})||this}return te(t,X),t.prototype._modifyText=function(X){return X.toLocaleLowerCase()},t}(Ae);$.LowerCaseAction=We,ne.registerEditorAction(ve),ne.registerEditorAction(_e),ne.registerEditorAction(be),ne.registerEditorAction(Ce),ne.registerEditorAction(Se),ne.registerEditorAction(Ee),ne.registerEditorAction(Le),ne.registerEditorAction(xe),ne.registerEditorAction(Ie),ne.registerEditorAction(De),ne.registerEditorAction(Ne),ne.registerEditorAction(Me),ne.registerEditorAction(Te),ne.registerEditorAction(Re),ne.registerEditorAction(Oe),ne.registerEditorAction(Pe),ne.registerEditorAction(Fe),ne.registerEditorAction(We)})),define(Q[177],n([0,1,16,11,10,14,18,24]),(function(X,$,Q,J,ee,te,ne,ie){function l(X,$,ee,ne){var ie=te.SignatureHelpProviderRegistry.ordered(X);return Q.first(ie.map((function(Q){return function(){return Promise.resolve(Q.provideSignatureHelp(X,$,ne,ee)).catch(J.onUnexpectedExternalError)}})))}Object.defineProperty($,"__esModule",{value:!0}),$.Context={Visible:new ne.RawContextKey("parameterHintsVisible",!1),MultipleSignatures:new ne.RawContextKey("parameterHintsMultipleSignatures",!1)},$.provideSignatureHelp=l,ee.registerDefaultLanguageCommand("_executeSignatureHelpProvider",(function(X,$){return l(X,$,{triggerReason:te.SignatureHelpTriggerReason.Invoke,isRetrigger:!1},ie.CancellationToken.None)}))})),define(Q[467],n([0,1,11,25,3,10,14,42,24]),(function(X,$,Q,J,ee,te,ne,ie,oe){function u(X,$,J){var ee=[],te=ne.DocumentSymbolProviderRegistry.all(X).map((function($){return Promise.resolve($.provideDocumentSymbols(X,J)).then((function(X){Array.isArray(X)&&ee.push.apply(ee,X)}),(function(X){Q.onUnexpectedExternalError(X)}))}));return Promise.all(te).then((function(){var X=[];return J.isCancellationRequested||($?c(X,ee,""):X=ee,X.sort(d)),X}))}function d(X,$){return ee.Range.compareRangesUsingStarts(X.range,$.range)}function c(X,$,Q){for(var J=0,ee=$;J<ee.length;J++){var te=ee[J];X.push({kind:te.kind,name:te.name,detail:te.detail,containerName:te.containerName||Q,range:te.range,selectionRange:te.selectionRange,children:void 0}),te.children&&c(X,te.children,te.name)}}Object.defineProperty($,"__esModule",{value:!0}),$.getDocumentSymbols=u,te.registerLanguageCommand("_executeDocumentSymbolProvider",(function(X,$){var ee=$.resource;if(!(ee instanceof J.URI))throw Q.illegalArgument("resource");var te=X.get(ie.IModelService).getModel(ee);if(!te)throw Q.illegalArgument("resource");return u(te,!1,oe.CancellationToken.None)}))})),define(Q[468],n([0,1,335,22,15,3,19,10,395,37]),(function(X,$,Q,J,ee,ie,re,se,ae,le){Object.defineProperty($,"__esModule",{value:!0});var p=function(X){this.editor=X,this.next=null,this.previous=null,this.selection=X.getSelection()},ue=function(){function e(X,$){this.editor=X,this._tokenSelectionSupport=$.createInstance(ae.TokenSelectionSupport),this._state=null,this._ignoreSelection=!1}return e.get=function(X){return X.getContribution(e.ID)},e.prototype.dispose=function(){},e.prototype.getId=function(){return e.ID},e.prototype.run=function(X){var $=this,Q=this.editor.getSelection(),ee=this.editor.getModel();this._state&&this._state.editor!==this.editor&&(this._state=null);var te=Promise.resolve(null);return this._state||(te=Promise.resolve(this._tokenSelectionSupport.getRangesToPositionSync(ee.uri,Q.getStartPosition())).then((function(X){if(!J.isFalsyOrEmpty(X)){var Q;X.filter((function(X){var Q=$.editor.getSelection(),J=new ie.Range(X.range.startLineNumber,X.range.startColumn,X.range.endLineNumber,X.range.endColumn);return J.containsPosition(Q.getStartPosition())&&J.containsPosition(Q.getEndPosition())})).forEach((function(X){var J=X.range,ee=new p($.editor);ee.selection=new ie.Range(J.startLineNumber,J.startColumn,J.endLineNumber,J.endColumn),Q&&(ee.next=Q,Q.previous=ee),Q=ee}));var ee=new p($.editor);ee.next=Q,Q&&(Q.previous=ee),$._state=ee;var te=$.editor.onDidChangeCursorPosition((function(X){$._ignoreSelection||($._state=null,te.dispose())}))}}))),te.then((function(){if($._state&&($._state=X?$._state.next:$._state.previous,$._state)){$._ignoreSelection=!0;try{$.editor.setSelection($._state.selection)}finally{$._ignoreSelection=!1}}}))},e.ID="editor.contrib.smartSelectController",e=ne([oe(1,ee.IInstantiationService)],e)}(),de=function(X){function t($,Q){var J=X.call(this,Q)||this;return J._forward=$,J}return te(t,X),t.prototype.run=function(X,$){var Q=ue.get($);if(Q)return Q.run(this._forward)},t}(se.EditorAction),ce=function(X){function t(){return X.call(this,!0,{id:"editor.action.smartSelect.grow",label:Q.localize(0,null),alias:"Expand Select",precondition:null,kbOpts:{kbExpr:re.EditorContextKeys.editorTextFocus,primary:1553,mac:{primary:3345},weight:100},menubarOpts:{menuId:le.MenuId.MenubarSelectionMenu,group:"1_basic",title:Q.localize(1,null),order:2}})||this}return te(t,X),t}(de),he=function(X){function t(){return X.call(this,!1,{id:"editor.action.smartSelect.shrink",label:Q.localize(2,null),alias:"Shrink Select",precondition:null,kbOpts:{kbExpr:re.EditorContextKeys.editorTextFocus,primary:1551,mac:{primary:3343},weight:100},menubarOpts:{menuId:le.MenuId.MenubarSelectionMenu,group:"1_basic",title:Q.localize(3,null),order:3}})||this}return te(t,X),t}(de);se.registerEditorContribution(ue),se.registerEditorAction(ce),se.registerEditorAction(he)})),define(Q[85],n([0,1,16,22,27,11,10,14,18,24,3]),(function(X,$,Q,J,ee,te,ne,ie,oe,re,se){function c(X,$,ne,oe,le,ue){void 0===ne&&(ne="bottom"),void 0===ue&&(ue=re.CancellationToken.None);var de=[],ce=function(X){return"none"===X?function(X){return 25!==X.kind}:function(){return!0}}(ne),he=X.getWordUntilPosition($),pe=new se.Range($.lineNumber,he.startColumn,$.lineNumber,he.endColumn);$=$.clone();var fe=ie.CompletionProviderRegistry.orderedGroups(X),ge=le||{triggerKind:0},me=!1,ve=fe.map((function(Q){return function(){return Promise.all(Q.map((function(Q){if(J.isFalsyOrEmpty(oe)||!(oe.indexOf(Q)<0))return Promise.resolve(Q.provideCompletionItems(X,$,ge,ue)).then((function(te){var ne=de.length;if(te&&!J.isFalsyOrEmpty(te.suggestions))for(var ie=0,oe=te.suggestions;ie<oe.length;ie++){var re=oe[ie];ce(re)&&(re.range||(re.range=pe),h(re),de.push({position:$,container:te,suggestion:re,support:Q,resolve:function(X,$,Q,J){var te;return function(ne){return te||(te="function"==typeof X.resolveCompletionItem?Promise.resolve(X.resolveCompletionItem(Q,J,$,ne)).then((function(X){ee.assign($,X)})):Promise.resolve(void 0)),te}}(Q,re,X,$)}))}ne!==de.length&&Q!==ae&&(me=!0)}),te.onUnexpectedExternalError)})))}}));return Q.first(ve,(function(){return me||ue.isCancellationRequested})).then((function(){return ue.isCancellationRequested?Promise.reject(te.canceled()):de.sort(m(ne))}))}function h(X){X._labelLow||(X._labelLow=X.label.toLowerCase()),X.sortText&&!X._sortTextLow&&(X._sortTextLow=X.sortText.toLowerCase()),X.filterText&&!X._filterTextLow&&(X._filterTextLow=X.filterText.toLowerCase())}function p(X,$){if(X.suggestion._sortTextLow&&$.suggestion._sortTextLow){if(X.suggestion._sortTextLow<$.suggestion._sortTextLow)return-1;if(X.suggestion._sortTextLow>$.suggestion._sortTextLow)return 1}return X.suggestion.label<$.suggestion.label?-1:X.suggestion.label>$.suggestion.label?1:X.suggestion.kind-$.suggestion.kind}function f(X,$){if(X.suggestion.kind!==$.suggestion.kind){if(25===X.suggestion.kind)return-1;if(25===$.suggestion.kind)return 1}return p(X,$)}function g(X,$){if(X.suggestion.kind!==$.suggestion.kind){if(25===X.suggestion.kind)return 1;if(25===$.suggestion.kind)return-1}return p(X,$)}function m(X){return"top"===X?f:"bottom"===X?g:p}var ae;Object.defineProperty($,"__esModule",{value:!0}),$.Context={Visible:new oe.RawContextKey("suggestWidgetVisible",!1),MultipleSuggestions:new oe.RawContextKey("suggestWidgetMultipleSuggestions",!1),MakesTextEdit:new oe.RawContextKey("suggestionMakesTextEdit",!0),AcceptSuggestionsOnEnter:new oe.RawContextKey("acceptSuggestionOnEnter",!0)},$.getSnippetSuggestSupport=function(){return ae},$.provideSuggestionItems=c,$.ensureLowerCaseVariants=h,$.getSuggestionComparator=m,ne.registerDefaultLanguageCommand("_executeCompletionItemProvider",(function(X,$,Q){var J={incomplete:!1,suggestions:[]},ee=[],te=Q.maxItemsToResolve||0;return c(X,$).then((function(X){for(var $=0,Q=X;$<Q.length;$++){var ne=Q[$];ee.length<te&&ee.push(ne.resolve(re.CancellationToken.None)),J.incomplete=J.incomplete||ne.container.incomplete,J.suggestions.push(ne.suggestion)}})).then((function(){return Promise.all(ee)})).then((function(){return J}))}));var le=new(function(){function e(){this.onlyOnceSuggestions=[]}return e.prototype.provideCompletionItems=function(){var X={suggestions:this.onlyOnceSuggestions.slice(0)};return this.onlyOnceSuggestions.length=0,X},e}());ie.CompletionProviderRegistry.register("*",le),$.showSimpleSuggestions=function(X,$){setTimeout((function(){var Q;(Q=le.onlyOnceSuggestions).push.apply(Q,$),X.getContribution("editor.contrib.suggestController").triggerSuggest([le])}),0)}})),define(Q[470],n([0,1,100,2,85,48]),(function(X,$,Q,J,ee,te){Object.defineProperty($,"__esModule",{value:!0});var s=function(){};$.LineContext=s;var ne=function(){function e(X,$,Q,J,ee){void 0===ee&&(ee=te.EDITOR_DEFAULTS.contribInfo.suggest),this._snippetCompareFn=e._compareCompletionItems,this._items=X,this._column=$,this._wordDistance=J,this._options=ee,this._refilterKind=1,this._lineContext=Q,"top"===ee.snippets?this._snippetCompareFn=e._compareCompletionItemsSnippetsUp:"bottom"===ee.snippets&&(this._snippetCompareFn=e._compareCompletionItemsSnippetsDown)}return e.prototype.dispose=function(){for(var X=new Set,$=0,Q=this._items;$<Q.length;$++){var ee=Q[$].container;X.has(ee)||(X.add(ee),J.isDisposable(ee)&&ee.dispose())}},Object.defineProperty(e.prototype,"lineContext",{get:function(){return this._lineContext},set:function(X){this._lineContext.leadingLineContent===X.leadingLineContent&&this._lineContext.characterCountDelta===X.characterCountDelta||(this._refilterKind=this._lineContext.characterCountDelta<X.characterCountDelta&&this._filteredItems?2:1,this._lineContext=X)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"items",{get:function(){return this._ensureCachedState(),this._filteredItems},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"incomplete",{get:function(){return this._ensureCachedState(),this._isIncomplete},enumerable:!0,configurable:!0}),e.prototype.adopt=function(X){for(var $=new Array,Q=0;Q<this._items.length;)X.has(this._items[Q].support)?Q++:($.push(this._items[Q]),this._items[Q]=this._items[this._items.length-1],this._items.pop());return this._refilterKind=1,$},Object.defineProperty(e.prototype,"stats",{get:function(){return this._ensureCachedState(),this._stats},enumerable:!0,configurable:!0}),e.prototype._ensureCachedState=function(){0!==this._refilterKind&&this._createCachedState()},e.prototype._createCachedState=function(){this._isIncomplete=new Set,this._stats={suggestionCount:0,snippetCount:0,textCount:0};for(var X=this._lineContext,$=X.leadingLineContent,J=X.characterCountDelta,te="",ne="",ie=1===this._refilterKind?this._items:this._filteredItems,oe=[],re=!this._options.filterGraceful||ie.length>2e3?Q.fuzzyScore:Q.fuzzyScoreGracefulAggressive,se=0;se<ie.length;se++){var ae=ie[se],le=ae.suggestion,ue=ae.container;ee.ensureLowerCaseVariants(le),ue.incomplete&&this._isIncomplete.add(ae.support);var de=ae.position.column-le.range.startColumn,ce=de+J-(ae.position.column-this._column);if(te.length!==ce&&(ne=(te=0===ce?"":$.slice(-ce)).toLowerCase()),ae.word=te,0===ce)ae.score=-100,ae.matches=void 0;else{for(var he=0;he<de;){var pe=te.charCodeAt(he);if(32!==pe&&9!==pe)break;he+=1}if(he>=ce)ae.score=-100,ae.matches=[];else if("string"==typeof le.filterText){if(!(fe=re(te,ne,he,le.filterText,le._filterTextLow,0,!1)))continue;ae.score=fe[0],ae.matches=(Q.fuzzyScore(te,ne,0,le.label,le._labelLow,0,!0)||Q.anyScore(te,le.label))[1]}else{var fe=re(te,ne,he,le.label,le._labelLow,0,!1);if(!fe)continue;ae.score=fe[0],ae.matches=fe[1]}}switch(ae.idx=se,ae.distance=this._wordDistance.distance(ae.position,le),oe.push(ae),this._stats.suggestionCount++,le.kind){case 25:this._stats.snippetCount++;break;case 18:this._stats.textCount++}}this._filteredItems=oe.sort(this._snippetCompareFn),this._refilterKind=0},e._compareCompletionItems=function(X,$){return X.score>$.score?-1:X.score<$.score?1:X.distance<$.distance?-1:X.distance>$.distance?1:X.idx<$.idx?-1:X.idx>$.idx?1:0},e._compareCompletionItemsSnippetsDown=function(X,$){if(X.suggestion.kind!==$.suggestion.kind){if(25===X.suggestion.kind)return 1;if(25===$.suggestion.kind)return-1}return e._compareCompletionItems(X,$)},e._compareCompletionItemsSnippetsUp=function(X,$){if(X.suggestion.kind!==$.suggestion.kind){if(25===X.suggestion.kind)return-1;if(25===$.suggestion.kind)return 1}return e._compareCompletionItems(X,$)},e}();$.CompletionModel=ne})),define(Q[179],n([0,1,340,43,10,125]),(function(X,$,Q,J,ee,ne){Object.defineProperty($,"__esModule",{value:!0});var ie=function(X){function t(){return X.call(this,{id:t.ID,label:Q.localize(0,null),alias:"Toggle Tab Key Moves Focus",precondition:null,kbOpts:{kbExpr:null,primary:2091,mac:{primary:1323},weight:100}})||this}return te(t,X),t.prototype.run=function(X,$){var ee=!ne.TabFocus.getTabFocusMode();ne.TabFocus.setTabFocusMode(ee),ee?J.alert(Q.localize(1,null)):J.alert(Q.localize(2,null))},t.ID="editor.action.toggleTabFocusMode",t}(ee.EditorAction);$.ToggleTabFocusModeAction=ie,ee.registerEditorAction(ie)})),define(Q[180],n([0,1,10,77,38,138,80,12,3,21,19]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae){Object.defineProperty($,"__esModule",{value:!0});var le=function(X){function t($){var Q=X.call(this,$)||this;return Q._inSelectionMode=$.inSelectionMode,Q._wordNavigationType=$.wordNavigationType,Q}return te(t,X),t.prototype.runEditorCommand=function(X,$,Q){var J=this;if($.hasModel()){var te=$.getConfiguration(),ne=ie.getMapForWordSeparators(te.wordSeparators),re=$.getModel(),se=$.getSelections().map((function(X){var $=new oe.Position(X.positionLineNumber,X.positionColumn),Q=J._move(ne,re,$,J._wordNavigationType);return J._moveTo(X,Q,J._inSelectionMode)}));if($._getCursors().setStates("moveWordCommand",0,se.map((function(X){return ee.CursorState.fromModelSelection(X)}))),1===se.length){var ae=new oe.Position(se[0].positionLineNumber,se[0].positionColumn);$.revealPosition(ae,0)}}},t.prototype._moveTo=function(X,$,Q){return Q?new se.Selection(X.selectionStartLineNumber,X.selectionStartColumn,$.lineNumber,$.column):new se.Selection($.lineNumber,$.column,$.lineNumber,$.column)},t}(Q.EditorCommand);$.MoveWordCommand=le;var ue=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype._move=function(X,$,Q,J){return ne.WordOperations.moveWordLeft(X,$,Q,J)},t}(le);$.WordLeftCommand=ue;var de=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype._move=function(X,$,Q,J){return ne.WordOperations.moveWordRight(X,$,Q,J)},t}(le);$.WordRightCommand=de;var ce=function(X){function t(){return X.call(this,{inSelectionMode:!1,wordNavigationType:0,id:"cursorWordStartLeft",precondition:null,kbOpts:{kbExpr:ae.EditorContextKeys.textInputFocus,primary:2063,mac:{primary:527},weight:100}})||this}return te(t,X),t}(ue);$.CursorWordStartLeft=ce;var he=function(X){function t(){return X.call(this,{inSelectionMode:!1,wordNavigationType:2,id:"cursorWordEndLeft",precondition:null})||this}return te(t,X),t}(ue);$.CursorWordEndLeft=he;var pe=function(X){function t(){return X.call(this,{inSelectionMode:!1,wordNavigationType:1,id:"cursorWordLeft",precondition:null})||this}return te(t,X),t}(ue);$.CursorWordLeft=pe;var fe=function(X){function t(){return X.call(this,{inSelectionMode:!0,wordNavigationType:0,id:"cursorWordStartLeftSelect",precondition:null,kbOpts:{kbExpr:ae.EditorContextKeys.textInputFocus,primary:3087,mac:{primary:1551},weight:100}})||this}return te(t,X),t}(ue);$.CursorWordStartLeftSelect=fe;var ge=function(X){function t(){return X.call(this,{inSelectionMode:!0,wordNavigationType:2,id:"cursorWordEndLeftSelect",precondition:null})||this}return te(t,X),t}(ue);$.CursorWordEndLeftSelect=ge;var me=function(X){function t(){return X.call(this,{inSelectionMode:!0,wordNavigationType:0,id:"cursorWordLeftSelect",precondition:null})||this}return te(t,X),t}(ue);$.CursorWordLeftSelect=me;var ve=function(X){function t(){return X.call(this,{inSelectionMode:!1,wordNavigationType:0,id:"cursorWordStartRight",precondition:null})||this}return te(t,X),t}(de);$.CursorWordStartRight=ve;var _e=function(X){function t(){return X.call(this,{inSelectionMode:!1,wordNavigationType:2,id:"cursorWordEndRight",precondition:null,kbOpts:{kbExpr:ae.EditorContextKeys.textInputFocus,primary:2065,mac:{primary:529},weight:100}})||this}return te(t,X),t}(de);$.CursorWordEndRight=_e;var ye=function(X){function t(){return X.call(this,{inSelectionMode:!1,wordNavigationType:2,id:"cursorWordRight",precondition:null})||this}return te(t,X),t}(de);$.CursorWordRight=ye;var be=function(X){function t(){return X.call(this,{inSelectionMode:!0,wordNavigationType:0,id:"cursorWordStartRightSelect",precondition:null})||this}return te(t,X),t}(de);$.CursorWordStartRightSelect=be;var Ce=function(X){function t(){return X.call(this,{inSelectionMode:!0,wordNavigationType:2,id:"cursorWordEndRightSelect",precondition:null,kbOpts:{kbExpr:ae.EditorContextKeys.textInputFocus,primary:3089,mac:{primary:1553},weight:100}})||this}return te(t,X),t}(de);$.CursorWordEndRightSelect=Ce;var we=function(X){function t(){return X.call(this,{inSelectionMode:!0,wordNavigationType:2,id:"cursorWordRightSelect",precondition:null})||this}return te(t,X),t}(de);$.CursorWordRightSelect=we;var Se=function(X){function t($){var Q=X.call(this,$)||this;return Q._whitespaceHeuristics=$.whitespaceHeuristics,Q._wordNavigationType=$.wordNavigationType,Q}return te(t,X),t.prototype.runEditorCommand=function(X,$,Q){var ee=this;if($.hasModel()){var te=$.getConfiguration(),ne=ie.getMapForWordSeparators(te.wordSeparators),oe=$.getModel(),re=$.getSelections().map((function(X){var $=ee._delete(ne,oe,X,ee._whitespaceHeuristics,ee._wordNavigationType);return new J.ReplaceCommand($,"")}));$.pushUndoStop(),$.executeCommands(this.id,re),$.pushUndoStop()}},t}(Q.EditorCommand);$.DeleteWordCommand=Se;var Ee=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype._delete=function(X,$,Q,J,ee){return ne.WordOperations.deleteWordLeft(X,$,Q,J,ee)||new re.Range(1,1,1,1)},t}(Se);$.DeleteWordLeftCommand=Ee;var Le=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype._delete=function(X,$,Q,J,ee){var te=ne.WordOperations.deleteWordRight(X,$,Q,J,ee);if(te)return te;var ie=$.getLineCount(),oe=$.getLineMaxColumn(ie);return new re.Range(ie,oe,ie,oe)},t}(Se);$.DeleteWordRightCommand=Le;var xe=function(X){function t(){return X.call(this,{whitespaceHeuristics:!1,wordNavigationType:0,id:"deleteWordStartLeft",precondition:ae.EditorContextKeys.writable})||this}return te(t,X),t}(Ee);$.DeleteWordStartLeft=xe;var Ie=function(X){function t(){return X.call(this,{whitespaceHeuristics:!1,wordNavigationType:2,id:"deleteWordEndLeft",precondition:ae.EditorContextKeys.writable})||this}return te(t,X),t}(Ee);$.DeleteWordEndLeft=Ie;var De=function(X){function t(){return X.call(this,{whitespaceHeuristics:!0,wordNavigationType:0,id:"deleteWordLeft",precondition:ae.EditorContextKeys.writable,kbOpts:{kbExpr:ae.EditorContextKeys.textInputFocus,primary:2049,mac:{primary:513},weight:100}})||this}return te(t,X),t}(Ee);$.DeleteWordLeft=De;var Ne=function(X){function t(){return X.call(this,{whitespaceHeuristics:!1,wordNavigationType:0,id:"deleteWordStartRight",precondition:ae.EditorContextKeys.writable})||this}return te(t,X),t}(Le);$.DeleteWordStartRight=Ne;var Me=function(X){function t(){return X.call(this,{whitespaceHeuristics:!1,wordNavigationType:2,id:"deleteWordEndRight",precondition:ae.EditorContextKeys.writable})||this}return te(t,X),t}(Le);$.DeleteWordEndRight=Me;var ke=function(X){function t(){return X.call(this,{whitespaceHeuristics:!0,wordNavigationType:2,id:"deleteWordRight",precondition:ae.EditorContextKeys.writable,kbOpts:{kbExpr:ae.EditorContextKeys.textInputFocus,primary:2068,mac:{primary:532},weight:100}})||this}return te(t,X),t}(Le);$.DeleteWordRight=ke,Q.registerEditorCommand(new ce),Q.registerEditorCommand(new he),Q.registerEditorCommand(new pe),Q.registerEditorCommand(new fe),Q.registerEditorCommand(new ge),Q.registerEditorCommand(new me),Q.registerEditorCommand(new ve),Q.registerEditorCommand(new _e),Q.registerEditorCommand(new ye),Q.registerEditorCommand(new be),Q.registerEditorCommand(new Ce),Q.registerEditorCommand(new we),Q.registerEditorCommand(new xe),Q.registerEditorCommand(new Ie),Q.registerEditorCommand(new De),Q.registerEditorCommand(new Ne),Q.registerEditorCommand(new Me),Q.registerEditorCommand(new ke)})),define(Q[473],n([0,1,10,138,3,19,180,31]),(function(X,$,Q,J,ee,ne,ie,oe){Object.defineProperty($,"__esModule",{value:!0});var re=function(X){function t(){return X.call(this,{whitespaceHeuristics:!0,wordNavigationType:0,id:"deleteWordPartLeft",precondition:ne.EditorContextKeys.writable,kbOpts:{kbExpr:ne.EditorContextKeys.textInputFocus,primary:0,mac:{primary:769},weight:100}})||this}return te(t,X),t.prototype._delete=function(X,$,Q,te,ne){return J.WordPartOperations.deleteWordPartLeft(X,$,Q,te)||new ee.Range(1,1,1,1)},t}(ie.DeleteWordCommand);$.DeleteWordPartLeft=re;var se=function(X){function t(){return X.call(this,{whitespaceHeuristics:!0,wordNavigationType:2,id:"deleteWordPartRight",precondition:ne.EditorContextKeys.writable,kbOpts:{kbExpr:ne.EditorContextKeys.textInputFocus,primary:0,mac:{primary:788},weight:100}})||this}return te(t,X),t.prototype._delete=function(X,$,Q,te,ne){var ie=J.WordPartOperations.deleteWordPartRight(X,$,Q,te);if(ie)return ie;var oe=$.getLineCount(),re=$.getLineMaxColumn(oe);return new ee.Range(oe,re,oe,re)},t}(ie.DeleteWordCommand);$.DeleteWordPartRight=se;var ae=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype._move=function(X,$,Q,ee){return J.WordPartOperations.moveWordPartLeft(X,$,Q)},t}(ie.MoveWordCommand);$.WordPartLeftCommand=ae;var le=function(X){function t(){return X.call(this,{inSelectionMode:!1,wordNavigationType:0,id:"cursorWordPartLeft",precondition:null,kbOpts:{kbExpr:ne.EditorContextKeys.textInputFocus,primary:0,mac:{primary:783},weight:100}})||this}return te(t,X),t}(ae);$.CursorWordPartLeft=le,oe.CommandsRegistry.registerCommandAlias("cursorWordPartStartLeft","cursorWordPartLeft");var ue=function(X){function t(){return X.call(this,{inSelectionMode:!0,wordNavigationType:0,id:"cursorWordPartLeftSelect",precondition:null,kbOpts:{kbExpr:ne.EditorContextKeys.textInputFocus,primary:0,mac:{primary:1807},weight:100}})||this}return te(t,X),t}(ae);$.CursorWordPartLeftSelect=ue,oe.CommandsRegistry.registerCommandAlias("cursorWordPartStartLeftSelect","cursorWordPartLeftSelect");var de=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype._move=function(X,$,Q,ee){return J.WordPartOperations.moveWordPartRight(X,$,Q)},t}(ie.MoveWordCommand);$.WordPartRightCommand=de;var ce=function(X){function t(){return X.call(this,{inSelectionMode:!1,wordNavigationType:2,id:"cursorWordPartRight",precondition:null,kbOpts:{kbExpr:ne.EditorContextKeys.textInputFocus,primary:0,mac:{primary:785},weight:100}})||this}return te(t,X),t}(de);$.CursorWordPartRight=ce;var he=function(X){function t(){return X.call(this,{inSelectionMode:!0,wordNavigationType:2,id:"cursorWordPartRightSelect",precondition:null,kbOpts:{kbExpr:ne.EditorContextKeys.textInputFocus,primary:0,mac:{primary:1809},weight:100}})||this}return te(t,X),t}(de);$.CursorWordPartRightSelect=he,Q.registerEditorCommand(new re),Q.registerEditorCommand(new se),Q.registerEditorCommand(new le),Q.registerEditorCommand(new ue),Q.registerEditorCommand(new ce),Q.registerEditorCommand(new he)})),define(Q[474],n([0,1,29,7,2,10,388]),(function(X,$,Q,J,ee,te){Object.defineProperty($,"__esModule",{value:!0});var ne=function(){function e(X){var $=this;this.editor=X,this.toDispose=[],Q.isIPad&&(this.toDispose.push(X.onDidChangeConfiguration((function(){return $.update()}))),this.update())}return e.prototype.update=function(){var X=!this.editor.getConfiguration().readOnly;!this.widget&&X?this.widget=new ie(this.editor):this.widget&&!X&&(this.widget.dispose(),this.widget=null)},e.prototype.getId=function(){return e.ID},e.prototype.dispose=function(){this.toDispose=ee.dispose(this.toDispose),this.widget&&(this.widget.dispose(),this.widget=null)},e.ID="editor.contrib.iPadShowKeyboard",e}();$.IPadShowKeyboard=ne;var ie=function(){function e(X){var $=this;this.editor=X,this._domNode=document.createElement("textarea"),this._domNode.className="iPadShowKeyboard",this._toDispose=[],this._toDispose.push(J.addDisposableListener(this._domNode,"touchstart",(function(X){$.editor.focus()}))),this._toDispose.push(J.addDisposableListener(this._domNode,"focus",(function(X){$.editor.focus()}))),this.editor.addOverlayWidget(this)}return e.prototype.dispose=function(){this.editor.removeOverlayWidget(this),this._toDispose=ee.dispose(this._toDispose)},e.prototype.getId=function(){return e.ID},e.prototype.getDomNode=function(){return this._domNode},e.prototype.getPosition=function(){return{preference:1}},e.ID="editor.contrib.ShowKeyboardWidget",e}();te.registerEditorContribution(ne)})),define(Q[475],n([0,1,349,10,78]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var ne=function(X){function t(){var $=X.call(this,{id:"editor.action.toggleHighContrast",label:Q.localize(0,null),alias:"Toggle High Contrast Theme",precondition:null})||this;return $._originalThemeName=null,$}return te(t,X),t.prototype.run=function(X,$){var Q=X.get(ee.IStandaloneThemeService);this._originalThemeName?(Q.setTheme(this._originalThemeName),this._originalThemeName=null):(this._originalThemeName=Q.getTheme().themeName,Q.setTheme("hc-black"))},t}(J.EditorAction);J.registerEditorAction(ne)})),define(Q[476],n([0,1,508,70,116,2]),(function(X,$,Q,J,ee,ie){Object.defineProperty($,"__esModule",{value:!0});var re=function(X){function t($,J,ee){var te=X.call(this)||this;return te.logService=ee,te.contextView=te._register(new Q.ContextView($)),te}return te(t,X),t.prototype.setContainer=function(X){this.logService.trace("ContextViewService#setContainer"),this.contextView.setContainer(X)},t.prototype.showContextView=function(X){this.logService.trace("ContextViewService#showContextView"),this.contextView.show(X)},t.prototype.layout=function(){this.contextView.layout()},t.prototype.hideContextView=function(X){this.logService.trace("ContextViewService#hideContextView"),this.contextView.hide(X)},ne([oe(1,J.ITelemetryService),oe(2,ee.ILogService)],t)}(ie.Disposable);$.ContextViewService=re})),define(Q[477],n([0,1,53]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),$.NullTelemetryService=new(function(){function e(){}return e.prototype.publicLog=function(X,$){return Q.TPromise.wrap(void 0)},e.prototype.getTelemetryInfo=function(){return Q.TPromise.wrap({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId"})},e}())})),define(Q[478],n([0,1,7,430,50,84,30,31,15,70,477]),(function(X,$,Q,J,ee,te,ie,re,se,ae,le){Object.defineProperty($,"__esModule",{value:!0});var ue=function(){function e(X,$,Q){void 0===Q&&(Q=le.NullTelemetryService),this._editorService=X,this._commandService=$,this._telemetryService=Q}return e.prototype.open=function(X,$){var ne;this._telemetryService&&this._telemetryService.publicLog("openerService",{scheme:X.scheme});var ie=X.scheme,oe=X.path,se=X.query,ae=X.fragment,le=void 0;if(ie===ee.Schemas.http||ie===ee.Schemas.https||ie===ee.Schemas.mailto)Q.windowOpenNoOpener(X.toString(!0));else if("command"===ie&&re.CommandsRegistry.getCommand(oe)){var ue=[];try{ue=J.parse(se),Array.isArray(ue)||(ue=[ue])}catch(X){}le=(ne=this._commandService).executeCommand.apply(ne,[oe].concat(ue))}else{var de=void 0,ce=/^L?(\d+)(?:,(\d+))?/.exec(ae);if(ce&&(de={startLineNumber:parseInt(ce[1]),startColumn:ce[2]?parseInt(ce[2]):1},X=X.with({fragment:""})),!X.scheme)return Promise.resolve(void 0);X.scheme===ee.Schemas.file&&(X=te.normalizePath(X)),le=this._editorService.openCodeEditor({resource:X,options:{selection:de}},this._editorService.getFocusedCodeEditor(),$&&$.openToSide)}return Promise.resolve(le)},ne([oe(0,ie.ICodeEditorService),oe(1,re.ICommandService),oe(2,se.optional(ae.ITelemetryService))],e)}();$.OpenerService=ue})),define(Q[20],n([0,1,41,28,354]),(function(X,$,Q,J,ee){function r(X,$,Q,J,ee){return te.registerColor(X,$,Q,J,ee)}function s(X,$){return function(Q){var J=l(X,Q);return J?J.transparent($):null}}function a(X,$,Q,ee){return function(te){var ne=l(X,te);if(ne){var ie=l($,te);return ie?ne.isDarkerThan(ie)?J.Color.getLighterColor(ne,ie,Q).transparent(ee):J.Color.getDarkerColor(ne,ie,Q).transparent(ee):ne.transparent(Q*ee)}return null}}function l(X,$){return null===X?null:"string"==typeof X?"#"===X[0]?J.Color.fromHex(X):$.getColor(X):X instanceof J.Color?X:"function"==typeof X?X($):null}Object.defineProperty($,"__esModule",{value:!0}),$.Extensions={ColorContribution:"base.contributions.colors"};var te=new(function(){function e(){this.colorSchema={type:"object",description:ee.localize(0,null),properties:{},additionalProperties:!1},this.colorReferenceSchema={type:"string",enum:[],enumDescriptions:[]},this.colorsById={}}return e.prototype.registerColor=function(X,$,Q,J,ee){void 0===J&&(J=!1);var te={id:X,description:Q,defaults:$,needsTransparency:J,deprecationMessage:ee};this.colorsById[X]=te;var ne={type:"string",description:Q,format:"color-hex",default:"#ff0000"};return ee&&(ne.deprecationMessage=ee),this.colorSchema.properties[X]=ne,this.colorReferenceSchema.enum.push(X),this.colorReferenceSchema.enumDescriptions.push(Q),X},e.prototype.resolveDefaultColor=function(X,$){var Q=this.colorsById[X];return Q&&Q.defaults?l(Q.defaults[$.type],$):null},e.prototype.toString=function(){var X=this;return Object.keys(this.colorsById).sort((function(X,$){var Q=-1===X.indexOf(".")?0:1,J=-1===$.indexOf(".")?0:1;return Q!==J?Q-J:X.localeCompare($)})).map((function($){return"- `"+$+"`: "+X.colorsById[$].description})).join("\n")},e}());Q.Registry.add($.Extensions.ColorContribution,te),$.registerColor=r,$.foreground=r("foreground",{dark:"#CCCCCC",light:"#616161",hc:"#FFFFFF"},ee.localize(1,null)),$.errorForeground=r("errorForeground",{dark:"#F48771",light:"#A1260D",hc:"#F48771"},ee.localize(2,null)),$.focusBorder=r("focusBorder",{dark:J.Color.fromHex("#0E639C").transparent(.8),light:J.Color.fromHex("#007ACC").transparent(.4),hc:"#F38518"},ee.localize(3,null)),$.contrastBorder=r("contrastBorder",{light:null,dark:null,hc:"#6FC3DF"},ee.localize(4,null)),$.activeContrastBorder=r("contrastActiveBorder",{light:null,dark:null,hc:$.focusBorder},ee.localize(5,null)),$.textLinkForeground=r("textLink.foreground",{light:"#006AB1",dark:"#3794FF",hc:"#3794FF"},ee.localize(6,null)),$.textCodeBlockBackground=r("textCodeBlock.background",{light:"#dcdcdc66",dark:"#0a0a0a66",hc:J.Color.black},ee.localize(7,null)),$.widgetShadow=r("widget.shadow",{dark:"#000000",light:"#A8A8A8",hc:null},ee.localize(8,null)),$.inputBackground=r("input.background",{dark:"#3C3C3C",light:J.Color.white,hc:J.Color.black},ee.localize(9,null)),$.inputForeground=r("input.foreground",{dark:$.foreground,light:$.foreground,hc:$.foreground},ee.localize(10,null)),$.inputBorder=r("input.border",{dark:null,light:null,hc:$.contrastBorder},ee.localize(11,null)),$.inputActiveOptionBorder=r("inputOption.activeBorder",{dark:"#007ACC",light:"#007ACC",hc:$.activeContrastBorder},ee.localize(12,null)),$.inputValidationInfoBackground=r("inputValidation.infoBackground",{dark:"#063B49",light:"#D6ECF2",hc:J.Color.black},ee.localize(13,null)),$.inputValidationInfoForeground=r("inputValidation.infoForeground",{dark:null,light:null,hc:null},ee.localize(14,null)),$.inputValidationInfoBorder=r("inputValidation.infoBorder",{dark:"#007acc",light:"#007acc",hc:$.contrastBorder},ee.localize(15,null)),$.inputValidationWarningBackground=r("inputValidation.warningBackground",{dark:"#352A05",light:"#F6F5D2",hc:J.Color.black},ee.localize(16,null)),$.inputValidationWarningForeground=r("inputValidation.warningForeground",{dark:null,light:null,hc:null},ee.localize(17,null)),$.inputValidationWarningBorder=r("inputValidation.warningBorder",{dark:"#B89500",light:"#B89500",hc:$.contrastBorder},ee.localize(18,null)),$.inputValidationErrorBackground=r("inputValidation.errorBackground",{dark:"#5A1D1D",light:"#F2DEDE",hc:J.Color.black},ee.localize(19,null)),$.inputValidationErrorForeground=r("inputValidation.errorForeground",{dark:null,light:null,hc:null},ee.localize(20,null)),$.inputValidationErrorBorder=r("inputValidation.errorBorder",{dark:"#BE1100",light:"#BE1100",hc:$.contrastBorder},ee.localize(21,null)),$.selectBackground=r("dropdown.background",{dark:"#3C3C3C",light:J.Color.white,hc:J.Color.black},ee.localize(22,null)),$.selectForeground=r("dropdown.foreground",{dark:"#F0F0F0",light:null,hc:J.Color.white},ee.localize(23,null)),$.listFocusBackground=r("list.focusBackground",{dark:"#062F4A",light:"#D6EBFF",hc:null},ee.localize(24,null)),$.listFocusForeground=r("list.focusForeground",{dark:null,light:null,hc:null},ee.localize(25,null)),$.listActiveSelectionBackground=r("list.activeSelectionBackground",{dark:"#094771",light:"#2477CE",hc:null},ee.localize(26,null)),$.listActiveSelectionForeground=r("list.activeSelectionForeground",{dark:J.Color.white,light:J.Color.white,hc:null},ee.localize(27,null)),$.listInactiveSelectionBackground=r("list.inactiveSelectionBackground",{dark:"#37373D",light:"#E4E6F1",hc:null},ee.localize(28,null)),$.listInactiveSelectionForeground=r("list.inactiveSelectionForeground",{dark:null,light:null,hc:null},ee.localize(29,null)),$.listInactiveFocusBackground=r("list.inactiveFocusBackground",{dark:"#313135",light:"#d8dae6",hc:null},ee.localize(30,null)),$.listHoverBackground=r("list.hoverBackground",{dark:"#2A2D2E",light:"#F0F0F0",hc:null},ee.localize(31,null)),$.listHoverForeground=r("list.hoverForeground",{dark:null,light:null,hc:null},ee.localize(32,null)),$.listDropBackground=r("list.dropBackground",{dark:$.listFocusBackground,light:$.listFocusBackground,hc:null},ee.localize(33,null)),$.listHighlightForeground=r("list.highlightForeground",{dark:"#0097fb",light:"#0066BF",hc:$.focusBorder},ee.localize(34,null)),$.pickerGroupForeground=r("pickerGroup.foreground",{dark:"#3794FF",light:"#0066BF",hc:J.Color.white},ee.localize(35,null)),$.pickerGroupBorder=r("pickerGroup.border",{dark:"#3F3F46",light:"#CCCEDB",hc:J.Color.white},ee.localize(36,null)),$.badgeBackground=r("badge.background",{dark:"#4D4D4D",light:"#C4C4C4",hc:J.Color.black},ee.localize(37,null)),$.badgeForeground=r("badge.foreground",{dark:J.Color.white,light:"#333",hc:J.Color.white},ee.localize(38,null)),$.scrollbarShadow=r("scrollbar.shadow",{dark:"#000000",light:"#DDDDDD",hc:null},ee.localize(39,null)),$.scrollbarSliderBackground=r("scrollbarSlider.background",{dark:J.Color.fromHex("#797979").transparent(.4),light:J.Color.fromHex("#646464").transparent(.4),hc:s($.contrastBorder,.6)},ee.localize(40,null)),$.scrollbarSliderHoverBackground=r("scrollbarSlider.hoverBackground",{dark:J.Color.fromHex("#646464").transparent(.7),light:J.Color.fromHex("#646464").transparent(.7),hc:s($.contrastBorder,.8)},ee.localize(41,null)),$.scrollbarSliderActiveBackground=r("scrollbarSlider.activeBackground",{dark:J.Color.fromHex("#BFBFBF").transparent(.4),light:J.Color.fromHex("#000000").transparent(.6),hc:$.contrastBorder},ee.localize(42,null)),$.progressBarBackground=r("progressBar.background",{dark:J.Color.fromHex("#0E70C0"),light:J.Color.fromHex("#0E70C0"),hc:$.contrastBorder},ee.localize(43,null)),$.menuBorder=r("menu.border",{dark:null,light:null,hc:$.contrastBorder},ee.localize(44,null)),$.menuForeground=r("menu.foreground",{dark:$.selectForeground,light:$.selectForeground,hc:$.selectForeground},ee.localize(45,null)),$.menuBackground=r("menu.background",{dark:$.selectBackground,light:$.selectBackground,hc:$.selectBackground},ee.localize(46,null)),$.menuSelectionForeground=r("menu.selectionForeground",{dark:$.listActiveSelectionForeground,light:$.listActiveSelectionForeground,hc:$.listActiveSelectionForeground},ee.localize(47,null)),$.menuSelectionBackground=r("menu.selectionBackground",{dark:$.listActiveSelectionBackground,light:$.listActiveSelectionBackground,hc:$.listActiveSelectionBackground},ee.localize(48,null)),$.menuSelectionBorder=r("menu.selectionBorder",{dark:null,light:null,hc:$.activeContrastBorder},ee.localize(49,null)),$.menuSeparatorBackground=r("menu.separatorBackground",{dark:"#BBBBBB",light:"#888888",hc:$.contrastBorder},ee.localize(50,null)),$.editorBackground=r("editor.background",{light:"#fffffe",dark:"#1E1E1E",hc:J.Color.black},ee.localize(51,null)),$.editorForeground=r("editor.foreground",{light:"#333333",dark:"#BBBBBB",hc:J.Color.white},ee.localize(52,null)),$.editorWidgetBackground=r("editorWidget.background",{dark:"#252526",light:"#F3F3F3",hc:"#0C141F"},ee.localize(53,null)),$.editorWidgetBorder=r("editorWidget.border",{dark:"#454545",light:"#C8C8C8",hc:$.contrastBorder},ee.localize(54,null)),$.editorWidgetResizeBorder=r("editorWidget.resizeBorder",{light:null,dark:null,hc:null},ee.localize(55,null)),$.editorSelectionBackground=r("editor.selectionBackground",{light:"#ADD6FF",dark:"#264F78",hc:"#f3f518"},ee.localize(56,null)),$.editorSelectionForeground=r("editor.selectionForeground",{light:null,dark:null,hc:"#000000"},ee.localize(57,null)),$.editorInactiveSelection=r("editor.inactiveSelectionBackground",{light:s($.editorSelectionBackground,.5),dark:s($.editorSelectionBackground,.5),hc:s($.editorSelectionBackground,.5)},ee.localize(58,null),!0),$.editorSelectionHighlight=r("editor.selectionHighlightBackground",{light:a($.editorSelectionBackground,$.editorBackground,.3,.6),dark:a($.editorSelectionBackground,$.editorBackground,.3,.6),hc:null},ee.localize(59,null),!0),$.editorSelectionHighlightBorder=r("editor.selectionHighlightBorder",{light:null,dark:null,hc:$.activeContrastBorder},ee.localize(60,null)),$.editorFindMatch=r("editor.findMatchBackground",{light:"#A8AC94",dark:"#515C6A",hc:null},ee.localize(61,null)),$.editorFindMatchHighlight=r("editor.findMatchHighlightBackground",{light:"#EA5C0055",dark:"#EA5C0055",hc:null},ee.localize(62,null),!0),$.editorFindRangeHighlight=r("editor.findRangeHighlightBackground",{dark:"#3a3d4166",light:"#b4b4b44d",hc:null},ee.localize(63,null),!0),$.editorFindMatchBorder=r("editor.findMatchBorder",{light:null,dark:null,hc:$.activeContrastBorder},ee.localize(64,null)),$.editorFindMatchHighlightBorder=r("editor.findMatchHighlightBorder",{light:null,dark:null,hc:$.activeContrastBorder},ee.localize(65,null)),$.editorFindRangeHighlightBorder=r("editor.findRangeHighlightBorder",{dark:null,light:null,hc:s($.activeContrastBorder,.4)},ee.localize(66,null),!0),$.editorHoverHighlight=r("editor.hoverHighlightBackground",{light:"#ADD6FF26",dark:"#264f7840",hc:"#ADD6FF26"},ee.localize(67,null),!0),$.editorHoverBackground=r("editorHoverWidget.background",{light:$.editorWidgetBackground,dark:$.editorWidgetBackground,hc:$.editorWidgetBackground},ee.localize(68,null)),$.editorHoverBorder=r("editorHoverWidget.border",{light:$.editorWidgetBorder,dark:$.editorWidgetBorder,hc:$.editorWidgetBorder},ee.localize(69,null)),$.editorActiveLinkForeground=r("editorLink.activeForeground",{dark:"#4E94CE",light:J.Color.blue,hc:J.Color.cyan},ee.localize(70,null)),$.defaultInsertColor=new J.Color(new J.RGBA(155,185,85,.2)),$.defaultRemoveColor=new J.Color(new J.RGBA(255,0,0,.2)),$.diffInserted=r("diffEditor.insertedTextBackground",{dark:$.defaultInsertColor,light:$.defaultInsertColor,hc:null},ee.localize(71,null),!0),$.diffRemoved=r("diffEditor.removedTextBackground",{dark:$.defaultRemoveColor,light:$.defaultRemoveColor,hc:null},ee.localize(72,null),!0),$.diffInsertedOutline=r("diffEditor.insertedTextBorder",{dark:null,light:null,hc:"#33ff2eff"},ee.localize(73,null)),$.diffRemovedOutline=r("diffEditor.removedTextBorder",{dark:null,light:null,hc:"#FF008F"},ee.localize(74,null)),$.diffBorder=r("diffEditor.border",{dark:null,light:null,hc:$.contrastBorder},ee.localize(75,null)),$.snippetTabstopHighlightBackground=r("editor.snippetTabstopHighlightBackground",{dark:new J.Color(new J.RGBA(124,124,124,.3)),light:new J.Color(new J.RGBA(10,50,100,.2)),hc:new J.Color(new J.RGBA(124,124,124,.3))},ee.localize(76,null)),$.snippetTabstopHighlightBorder=r("editor.snippetTabstopHighlightBorder",{dark:null,light:null,hc:null},ee.localize(77,null)),$.snippetFinalTabstopHighlightBackground=r("editor.snippetFinalTabstopHighlightBackground",{dark:null,light:null,hc:null},ee.localize(78,null)),$.snippetFinalTabstopHighlightBorder=r("editor.snippetFinalTabstopHighlightBorder",{dark:"#525252",light:new J.Color(new J.RGBA(10,50,100,.5)),hc:"#525252"},ee.localize(79,null));var ne=new J.Color(new J.RGBA(246,185,77,.7));$.overviewRulerFindMatchForeground=r("editorOverviewRuler.findMatchForeground",{dark:ne,light:ne,hc:ne},ee.localize(80,null),!0),$.overviewRulerSelectionHighlightForeground=r("editorOverviewRuler.selectionHighlightForeground",{dark:"#A0A0A0CC",light:"#A0A0A0CC",hc:"#A0A0A0CC"},ee.localize(81,null),!0),$.transparent=s,$.oneOf=function(){for(var X=[],$=0;$<arguments.length;$++)X[$]=arguments[$];return function($){for(var Q=0,J=X;Q<J.length;Q++){var ee=l(J[Q],$);if(ee)return ee}return null}}})),define(Q[86],n([0,1,20,27]),(function(X,$,Q,J){function o(X,$){var Q=Object.create(null);for(var J in $){var ee=$[J];"string"==typeof ee?Q[J]=X.getColor(ee):"function"==typeof ee&&(Q[J]=ee(X))}return Q}function r(X,$,Q){function i(J){var ee=o(X.getTheme(),$);"function"==typeof Q?Q(ee):Q.style(ee)}return i(X.getTheme()),X.onThemeChange(i)}Object.defineProperty($,"__esModule",{value:!0}),$.computeStyles=o,$.attachStyler=r,$.attachBadgeStyler=function(X,$,J){return r($,{badgeBackground:J&&J.badgeBackground||Q.badgeBackground,badgeForeground:J&&J.badgeForeground||Q.badgeForeground,badgeBorder:Q.contrastBorder},X)},$.attachQuickOpenStyler=function(X,$,J){return r($,{foreground:J&&J.foreground||Q.foreground,background:J&&J.background||Q.editorBackground,borderColor:J&&J.borderColor||Q.contrastBorder,widgetShadow:J&&J.widgetShadow||Q.widgetShadow,progressBarBackground:J&&J.progressBarBackground||Q.progressBarBackground,pickerGroupForeground:J&&J.pickerGroupForeground||Q.pickerGroupForeground,pickerGroupBorder:J&&J.pickerGroupBorder||Q.pickerGroupBorder,inputBackground:J&&J.inputBackground||Q.inputBackground,inputForeground:J&&J.inputForeground||Q.inputForeground,inputBorder:J&&J.inputBorder||Q.inputBorder,inputValidationInfoBorder:J&&J.inputValidationInfoBorder||Q.inputValidationInfoBorder,inputValidationInfoBackground:J&&J.inputValidationInfoBackground||Q.inputValidationInfoBackground,inputValidationInfoForeground:J&&J.inputValidationInfoForeground||Q.inputValidationInfoForeground,inputValidationWarningBorder:J&&J.inputValidationWarningBorder||Q.inputValidationWarningBorder,inputValidationWarningBackground:J&&J.inputValidationWarningBackground||Q.inputValidationWarningBackground,inputValidationWarningForeground:J&&J.inputValidationWarningForeground||Q.inputValidationWarningForeground,inputValidationErrorBorder:J&&J.inputValidationErrorBorder||Q.inputValidationErrorBorder,inputValidationErrorBackground:J&&J.inputValidationErrorBackground||Q.inputValidationErrorBackground,inputValidationErrorForeground:J&&J.inputValidationErrorForeground||Q.inputValidationErrorForeground,listFocusBackground:J&&J.listFocusBackground||Q.listFocusBackground,listFocusForeground:J&&J.listFocusForeground||Q.listFocusForeground,listActiveSelectionBackground:J&&J.listActiveSelectionBackground||Q.listActiveSelectionBackground,listActiveSelectionForeground:J&&J.listActiveSelectionForeground||Q.listActiveSelectionForeground,listFocusAndSelectionBackground:J&&J.listFocusAndSelectionBackground||Q.listActiveSelectionBackground,listFocusAndSelectionForeground:J&&J.listFocusAndSelectionForeground||Q.listActiveSelectionForeground,listInactiveSelectionBackground:J&&J.listInactiveSelectionBackground||Q.listInactiveSelectionBackground,listInactiveSelectionForeground:J&&J.listInactiveSelectionForeground||Q.listInactiveSelectionForeground,listInactiveFocusBackground:J&&J.listInactiveFocusBackground||Q.listInactiveFocusBackground,listHoverBackground:J&&J.listHoverBackground||Q.listHoverBackground,listHoverForeground:J&&J.listHoverForeground||Q.listHoverForeground,listDropBackground:J&&J.listDropBackground||Q.listDropBackground,listFocusOutline:J&&J.listFocusOutline||Q.activeContrastBorder,listSelectionOutline:J&&J.listSelectionOutline||Q.activeContrastBorder,listHoverOutline:J&&J.listHoverOutline||Q.activeContrastBorder},X)},$.attachListStyler=function(X,Q,ee){return r(Q,J.mixin(ee||Object.create(null),$.defaultListStyles,!1),X)},$.defaultListStyles={listFocusBackground:Q.listFocusBackground,listFocusForeground:Q.listFocusForeground,listActiveSelectionBackground:Q.listActiveSelectionBackground,listActiveSelectionForeground:Q.listActiveSelectionForeground,listFocusAndSelectionBackground:Q.listActiveSelectionBackground,listFocusAndSelectionForeground:Q.listActiveSelectionForeground,listInactiveSelectionBackground:Q.listInactiveSelectionBackground,listInactiveSelectionForeground:Q.listInactiveSelectionForeground,listInactiveFocusBackground:Q.listInactiveFocusBackground,listHoverBackground:Q.listHoverBackground,listHoverForeground:Q.listHoverForeground,listDropBackground:Q.listDropBackground,listFocusOutline:Q.activeContrastBorder,listSelectionOutline:Q.activeContrastBorder,listHoverOutline:Q.activeContrastBorder},$.defaultMenuStyles={shadowColor:Q.widgetShadow,borderColor:Q.menuBorder,foregroundColor:Q.menuForeground,backgroundColor:Q.menuBackground,selectionForegroundColor:Q.menuSelectionForeground,selectionBackgroundColor:Q.menuSelectionBackground,selectionBorderColor:Q.menuSelectionBorder,separatorColor:Q.menuSeparatorBackground},$.attachMenuStyler=function(X,J,ee){var te=ie({},$.defaultMenuStyles,ee),ne={foregroundColor:te.foregroundColor&&J&&J.getTheme().getColor(te.foregroundColor)?te.foregroundColor:Q.foreground};return r(J,ie({},te,ne),X)}})),define(Q[481],n([0,1,7,288,20,86]),(function(X,$,Q,J,ee,te){Object.defineProperty($,"__esModule",{value:!0});var ne=function(){function e(X,$,Q,J,ee,te){this.codeEditor=X,this.themeService=te,this.create($,Q,J,ee)}return e.prototype.create=function(X,$,Q,ne){this.domNode=document.createElement("div"),this.quickOpenWidget=new J.QuickOpenWidget(this.domNode,{onOk:X,onCancel:$,onType:Q},{inputPlaceHolder:null,inputAriaLabel:ne.inputAriaLabel,keyboardSupport:!0}),this.styler=te.attachQuickOpenStyler(this.quickOpenWidget,this.themeService,{pickerGroupForeground:ee.foreground}),this.quickOpenWidget.create(),this.codeEditor.addOverlayWidget(this)},e.prototype.setInput=function(X,$){this.quickOpenWidget.setInput(X,$)},e.prototype.getId=function(){return e.ID},e.prototype.getDomNode=function(){return this.domNode},e.prototype.destroy=function(){this.codeEditor.removeOverlayWidget(this),this.quickOpenWidget.dispose(),this.styler.dispose()},e.prototype.show=function(X){this.visible=!0;var $=this.codeEditor.getLayoutInfo();$&&this.quickOpenWidget.layout(new Q.Dimension($.width,$.height)),this.quickOpenWidget.show(X),this.codeEditor.layoutOverlayWidget(this)},e.prototype.getPosition=function(){return this.visible?{preference:2}:null},e.ID="editor.contrib.quickOpenEditorWidget",e}();$.QuickOpenEditorWidget=ne})),define(Q[482],n([0,1,2,40,56,279,7,86,72,404]),(function(X,$,Q,J,ee,te,ne,ie,oe){Object.defineProperty($,"__esModule",{value:!0});var re=function(){function e(X,$,Q,J,ee,te){this.contextViewService=$,this.telemetryService=Q,this.notificationService=J,this.keybindingService=ee,this.themeService=te,this.setContainer(X)}return e.prototype.setContainer=function(X){var $=this;this.element&&(this.elementDisposable=Q.dispose(this.elementDisposable),this.element=null),X&&(this.element=X,this.elementDisposable=ne.addDisposableListener(this.element,ne.EventType.MOUSE_DOWN,(function(X){return $.onMouseDown(X)})))},e.prototype.showContextMenu=function(X){var $=this;X.getActions().then((function(J){var re;J.length&&($.focusToReturn=document.activeElement,$.contextViewService.showContextView({getAnchor:function(){return X.getAnchor()},canRelayout:!1,render:function(se){$.menuContainerElement=se;var ae=X.getMenuClassName?X.getMenuClassName():"";ae&&(se.className+=" "+ae);var le=[],ue=X.actionRunner||new ee.ActionRunner;return ue.onDidBeforeRun($.onActionRun,$,le),ue.onDidRun($.onDidActionRun,$,le),re=new te.Menu(se,J,{actionItemProvider:X.getActionItem,context:X.getActionsContext?X.getActionsContext():null,actionRunner:ue,getKeyBinding:X.getKeyBinding?X.getKeyBinding:function(X){return $.keybindingService.lookupKeybinding(X.id)}}),le.push(ie.attachMenuStyler(re,$.themeService)),re.onDidCancel((function(){return $.contextViewService.hideContextView(!0)}),null,le),re.onDidBlur((function(){return $.contextViewService.hideContextView(!0)}),null,le),oe.domEvent(window,ne.EventType.BLUR)((function(){$.contextViewService.hideContextView(!0)}),null,le),Q.combinedDisposable(le.concat([re]))},focus:function(){re.focus(!!X.autoSelectFirstItem)},onHide:function(Q){X.onHide&&X.onHide(Q),$.menuContainerElement=null}}))}))},e.prototype.onActionRun=function(X){this.telemetryService&&this.telemetryService.publicLog("workbenchActionExecuted",{id:X.action.id,from:"contextMenu"}),this.contextViewService.hideContextView(!1),this.focusToReturn&&this.focusToReturn.focus()},e.prototype.onDidActionRun=function(X){X.error&&this.notificationService&&this.notificationService.error(X.error)},e.prototype.onMouseDown=function(X){if(this.menuContainerElement){for(var $=new J.StandardMouseEvent(X).target;$;){if($===this.menuContainerElement)return;$=$.parentElement}this.contextViewService.hideContextView()}},e.prototype.dispose=function(){this.setContainer(null)},e}();$.ContextMenuHandler=re})),define(Q[13],n([0,1,15,2,41,6]),(function(X,$,Q,J,ee,te){Object.defineProperty($,"__esModule",{value:!0}),$.IThemeService=Q.createDecorator("themeService"),$.themeColorFromId=function(X){return{id:X}},$.DARK="dark",$.HIGH_CONTRAST="hc",$.getThemeTypeSelector=function(X){switch(X){case $.DARK:return"vs-dark";case $.HIGH_CONTRAST:return"hc-black";default:return"vs"}},$.Extensions={ThemingContribution:"base.contributions.theming"};var ne=new(function(){function e(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new te.Emitter}return e.prototype.onThemeChange=function(X){var $=this;return this.themingParticipants.push(X),this.onThemingParticipantAddedEmitter.fire(X),J.toDisposable((function(){var Q=$.themingParticipants.indexOf(X);$.themingParticipants.splice(Q,1)}))},e.prototype.getThemingParticipants=function(){return this.themingParticipants},e}());ee.Registry.add($.Extensions.ThemingContribution,ne),$.registerThemingParticipant=function(X){return ne.onThemeChange(X)}})),define(Q[484],n([0,1,7,2,8,25,415,54,44,13]),(function(X,$,Q,J,ee,ie,re,se,ae,le){Object.defineProperty($,"__esModule",{value:!0});var ue=function(X){function t($,J){void 0===J&&(J=Q.createStyleSheet());var ee=X.call(this)||this;return ee._styleSheet=J,ee._decorationOptionProviders=Object.create(null),ee._themeService=$,ee}return te(t,X),t.prototype.registerDecorationType=function(X,$,Q){var J=this._decorationOptionProviders[X];if(!J){var ee={styleSheet:this._styleSheet,key:X,parentTypeKey:Q,options:$||Object.create(null)};J=Q?new de(this._themeService,ee):new ce(this._themeService,ee),this._decorationOptionProviders[X]=J}J.refCount++},t.prototype.removeDecorationType=function(X){var $=this._decorationOptionProviders[X];$&&($.refCount--,$.refCount<=0&&(delete this._decorationOptionProviders[X],$.dispose(),this.listCodeEditors().forEach((function($){return $.removeDecorations(X)}))))},t.prototype.resolveDecorationOptions=function(X,$){var Q=this._decorationOptionProviders[X];if(!Q)throw new Error("Unknown decoration type key: "+X);return Q.getOptions(this,$)},ne([oe(0,le.IThemeService)],t)}(re.AbstractCodeEditorService);$.CodeEditorServiceImpl=ue;var de=function(){function e(X,$){this._parentTypeKey=$.parentTypeKey,this.refCount=0,this._beforeContentRules=new pe(3,$,X),this._afterContentRules=new pe(4,$,X)}return e.prototype.getOptions=function(X,$){var Q=X.resolveDecorationOptions(this._parentTypeKey,!0);return this._beforeContentRules&&(Q.beforeContentClassName=this._beforeContentRules.className),this._afterContentRules&&(Q.afterContentClassName=this._afterContentRules.className),Q},e.prototype.dispose=function(){this._beforeContentRules&&(this._beforeContentRules.dispose(),this._beforeContentRules=null),this._afterContentRules&&(this._afterContentRules.dispose(),this._afterContentRules=null)},e}(),ce=function(){function e(X,$){var Q=this;this.refCount=0,this._disposables=[];var i=function(J){var ee=new pe(J,$,X);if(ee.hasContent)return Q._disposables.push(ee),ee.className};this.className=i(0);var J=function(J){var ee=new pe(1,$,X);return ee.hasContent?(Q._disposables.push(ee),{className:ee.className,hasLetterSpacing:ee.hasLetterSpacing}):null}();J&&(this.inlineClassName=J.className,this.inlineClassNameAffectsLetterSpacing=J.hasLetterSpacing),this.beforeContentClassName=i(3),this.afterContentClassName=i(4),this.glyphMarginClassName=i(2);var ee=$.options;this.isWholeLine=Boolean(ee.isWholeLine),this.stickiness=ee.rangeBehavior;var te=ee.light&&ee.light.overviewRulerColor||ee.overviewRulerColor,ne=ee.dark&&ee.dark.overviewRulerColor||ee.overviewRulerColor;void 0===te&&void 0===ne||(this.overviewRuler={color:te||ne,darkColor:ne||te,position:ee.overviewRulerLane||ae.OverviewRulerLane.Center})}return e.prototype.getOptions=function(X,$){return $?{inlineClassName:this.inlineClassName,beforeContentClassName:this.beforeContentClassName,afterContentClassName:this.afterContentClassName,className:this.className,glyphMarginClassName:this.glyphMarginClassName,isWholeLine:this.isWholeLine,overviewRuler:this.overviewRuler,stickiness:this.stickiness}:this},e.prototype.dispose=function(){this._disposables=J.dispose(this._disposables)},e}(),he={color:"color:{0} !important;",opacity:"opacity:{0}; will-change: opacity;",backgroundColor:"background-color:{0};",outline:"outline:{0};",outlineColor:"outline-color:{0};",outlineStyle:"outline-style:{0};",outlineWidth:"outline-width:{0};",border:"border:{0};",borderColor:"border-color:{0};",borderRadius:"border-radius:{0};",borderSpacing:"border-spacing:{0};",borderStyle:"border-style:{0};",borderWidth:"border-width:{0};",fontStyle:"font-style:{0};",fontWeight:"font-weight:{0};",textDecoration:"text-decoration:{0};",cursor:"cursor:{0};",letterSpacing:"letter-spacing:{0};",gutterIconPath:"background:url('{0}') center center no-repeat;",gutterIconSize:"background-size:{0};",contentText:"content:'{0}';",contentIconPath:"content:url('{0}');",margin:"margin:{0};",width:"width:{0};",height:"height:{0};"},pe=function(){function e(X,$,Q){var J=this;this._theme=Q.getTheme(),this._ruleType=X,this._providerArgs=$,this._usesThemeColors=!1,this._hasContent=!1,this._hasLetterSpacing=!1;var ee=fe.getClassName(this._providerArgs.key,X);this._providerArgs.parentTypeKey&&(ee=ee+" "+fe.getClassName(this._providerArgs.parentTypeKey,X)),this._className=ee,this._unThemedSelector=fe.getSelector(this._providerArgs.key,this._providerArgs.parentTypeKey,X),this._buildCSS(),this._usesThemeColors?this._themeListener=Q.onThemeChange((function(X){J._theme=Q.getTheme(),J._removeCSS(),J._buildCSS()})):this._themeListener=null}return e.prototype.dispose=function(){this._hasContent&&(this._removeCSS(),this._hasContent=!1),this._themeListener&&(this._themeListener.dispose(),this._themeListener=null)},Object.defineProperty(e.prototype,"hasContent",{get:function(){return this._hasContent},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"hasLetterSpacing",{get:function(){return this._hasLetterSpacing},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"className",{get:function(){return this._className},enumerable:!0,configurable:!0}),e.prototype._buildCSS=function(){var X,$,Q,J=this._providerArgs.options;switch(this._ruleType){case 0:X=this.getCSSTextForModelDecorationClassName(J),$=this.getCSSTextForModelDecorationClassName(J.light),Q=this.getCSSTextForModelDecorationClassName(J.dark);break;case 1:X=this.getCSSTextForModelDecorationInlineClassName(J),$=this.getCSSTextForModelDecorationInlineClassName(J.light),Q=this.getCSSTextForModelDecorationInlineClassName(J.dark);break;case 2:X=this.getCSSTextForModelDecorationGlyphMarginClassName(J),$=this.getCSSTextForModelDecorationGlyphMarginClassName(J.light),Q=this.getCSSTextForModelDecorationGlyphMarginClassName(J.dark);break;case 3:X=this.getCSSTextForModelDecorationContentClassName(J.before),$=this.getCSSTextForModelDecorationContentClassName(J.light&&J.light.before),Q=this.getCSSTextForModelDecorationContentClassName(J.dark&&J.dark.before);break;case 4:X=this.getCSSTextForModelDecorationContentClassName(J.after),$=this.getCSSTextForModelDecorationContentClassName(J.light&&J.light.after),Q=this.getCSSTextForModelDecorationContentClassName(J.dark&&J.dark.after);break;default:throw new Error("Unknown rule type: "+this._ruleType)}var ee=this._providerArgs.styleSheet.sheet,te=!1;X.length>0&&(ee.insertRule(this._unThemedSelector+" {"+X+"}",0),te=!0),$.length>0&&(ee.insertRule(".vs"+this._unThemedSelector+" {"+$+"}",0),te=!0),Q.length>0&&(ee.insertRule(".vs-dark"+this._unThemedSelector+", .hc-black"+this._unThemedSelector+" {"+Q+"}",0),te=!0),this._hasContent=te},e.prototype._removeCSS=function(){Q.removeCSSRulesContainingSelector(this._unThemedSelector,this._providerArgs.styleSheet)},e.prototype.getCSSTextForModelDecorationClassName=function(X){if(!X)return"";var $=[];return this.collectCSSText(X,["backgroundColor"],$),this.collectCSSText(X,["outline","outlineColor","outlineStyle","outlineWidth"],$),this.collectBorderSettingsCSSText(X,$),$.join("")},e.prototype.getCSSTextForModelDecorationInlineClassName=function(X){if(!X)return"";var $=[];return this.collectCSSText(X,["fontStyle","fontWeight","textDecoration","cursor","color","opacity","letterSpacing"],$),X.letterSpacing&&(this._hasLetterSpacing=!0),$.join("")},e.prototype.getCSSTextForModelDecorationContentClassName=function(X){if(!X)return"";var $=[];if(void 0!==X){if(this.collectBorderSettingsCSSText(X,$),void 0!==X.contentIconPath&&("string"==typeof X.contentIconPath?$.push(ee.format(he.contentIconPath,ie.URI.file(X.contentIconPath).toString().replace(/'/g,"%27"))):$.push(ee.format(he.contentIconPath,ie.URI.revive(X.contentIconPath).toString(!0).replace(/'/g,"%27")))),"string"==typeof X.contentText){var Q=X.contentText.match(/^.*$/m)[0].replace(/['\\]/g,"\\$&");$.push(ee.format(he.contentText,Q))}this.collectCSSText(X,["fontStyle","fontWeight","textDecoration","color","opacity","backgroundColor","margin"],$),this.collectCSSText(X,["width","height"],$)&&$.push("display:inline-block;")}return $.join("")},e.prototype.getCSSTextForModelDecorationGlyphMarginClassName=function(X){if(!X)return"";var $=[];return void 0!==X.gutterIconPath&&("string"==typeof X.gutterIconPath?$.push(ee.format(he.gutterIconPath,ie.URI.file(X.gutterIconPath).toString())):$.push(ee.format(he.gutterIconPath,ie.URI.revive(X.gutterIconPath).toString(!0).replace(/'/g,"%27"))),void 0!==X.gutterIconSize&&$.push(ee.format(he.gutterIconSize,X.gutterIconSize))),$.join("")},e.prototype.collectBorderSettingsCSSText=function(X,$){return!!this.collectCSSText(X,["border","borderColor","borderRadius","borderSpacing","borderStyle","borderWidth"],$)&&($.push(ee.format("box-sizing: border-box;")),!0)},e.prototype.collectCSSText=function(X,$,Q){for(var J=Q.length,te=0,ne=$;te<ne.length;te++){var ie=ne[te],oe=this.resolveValue(X[ie]);"string"==typeof oe&&Q.push(ee.format(he[ie],oe))}return Q.length!==J},e.prototype.resolveValue=function(X){if(se.isThemeColor(X)){this._usesThemeColors=!0;var $=this._theme.getColor(X.id);return $?$.toString():"transparent"}return X},e}(),fe=function(){function e(){}return e.getClassName=function(X,$){return"ced-"+X+"-"+$},e.getSelector=function(X,$,Q){var J=".monaco-editor ."+this.getClassName(X,Q);return $&&(J=J+"."+this.getClassName($,Q)),3===Q?J+="::before":4===Q&&(J+="::after"),J},e}()})),define(Q[485],n([0,1,7,23,55,33,13]),(function(X,$,Q,J,ee,ne,ie){Object.defineProperty($,"__esModule",{value:!0});var oe=function(X){function t($,te,oe,re){var se=X.call(this,$)||this,ae=se._context.configuration.editor.viewInfo.scrollbar,le={listenOnDomNode:oe.domNode,className:"editor-scrollable "+ie.getThemeTypeSelector($.theme.type),useShadows:!1,lazyRender:!0,vertical:ae.vertical,horizontal:ae.horizontal,verticalHasArrows:ae.verticalHasArrows,horizontalHasArrows:ae.horizontalHasArrows,verticalScrollbarSize:ae.verticalScrollbarSize,verticalSliderSize:ae.verticalSliderSize,horizontalScrollbarSize:ae.horizontalScrollbarSize,horizontalSliderSize:ae.horizontalSliderSize,handleMouseWheel:ae.handleMouseWheel,arrowSize:ae.arrowSize,mouseWheelScrollSensitivity:ae.mouseWheelScrollSensitivity};se.scrollbar=se._register(new ee.SmoothScrollableElement(te.domNode,le,se._context.viewLayout.scrollable)),ne.PartFingerprints.write(se.scrollbar.getDomNode(),5),se.scrollbarDomNode=J.createFastDomNode(se.scrollbar.getDomNode()),se.scrollbarDomNode.setPosition("absolute"),se._setLayout();var p=function(X,$,Q){var J={};if($){var ee=X.scrollTop;ee&&(J.scrollTop=se._context.viewLayout.getCurrentScrollTop()+ee,X.scrollTop=0)}if(Q){var te=X.scrollLeft;te&&(J.scrollLeft=se._context.viewLayout.getCurrentScrollLeft()+te,X.scrollLeft=0)}se._context.viewLayout.setScrollPositionNow(J)};return se._register(Q.addDisposableListener(oe.domNode,"scroll",(function(X){return p(oe.domNode,!0,!0)}))),se._register(Q.addDisposableListener(te.domNode,"scroll",(function(X){return p(te.domNode,!0,!1)}))),se._register(Q.addDisposableListener(re.domNode,"scroll",(function(X){return p(re.domNode,!0,!1)}))),se._register(Q.addDisposableListener(se.scrollbarDomNode.domNode,"scroll",(function(X){return p(se.scrollbarDomNode.domNode,!0,!1)}))),se}return te(t,X),t.prototype.dispose=function(){X.prototype.dispose.call(this)},t.prototype._setLayout=function(){var X=this._context.configuration.editor.layoutInfo;this.scrollbarDomNode.setLeft(X.contentLeft),"right"===this._context.configuration.editor.viewInfo.minimap.side?this.scrollbarDomNode.setWidth(X.contentWidth+X.minimapWidth):this.scrollbarDomNode.setWidth(X.contentWidth),this.scrollbarDomNode.setHeight(X.contentHeight)},t.prototype.getOverviewRulerLayoutInfo=function(){return this.scrollbar.getOverviewRulerLayoutInfo()},t.prototype.getDomNode=function(){return this.scrollbarDomNode},t.prototype.delegateVerticalScrollbarMouseDown=function(X){this.scrollbar.delegateVerticalScrollbarMouseDown(X)},t.prototype.onConfigurationChanged=function(X){if(X.viewInfo){var $=this._context.configuration.editor,Q={handleMouseWheel:$.viewInfo.scrollbar.handleMouseWheel,mouseWheelScrollSensitivity:$.viewInfo.scrollbar.mouseWheelScrollSensitivity};this.scrollbar.updateOptions(Q)}return X.layoutInfo&&this._setLayout(),!0},t.prototype.onScrollChanged=function(X){return!0},t.prototype.onThemeChanged=function(X){return this.scrollbar.updateClassName("editor-scrollable "+ie.getThemeTypeSelector(this._context.theme.type)),!0},t.prototype.prepareRender=function(X){},t.prototype.render=function(X){this.scrollbar.renderNow()},t}(ne.ViewPart);$.EditorScrollbar=oe})),define(Q[184],n([0,1,29,23,17,207,83,129,103,13]),(function(X,$,Q,J,ee,ne,ie,oe,re,se){Object.defineProperty($,"__esModule",{value:!0});var ae=!!ee.isNative||!(ee.isLinux||Q.isFirefox||Q.isSafari),le=Q.isEdgeOrIE,ue=function(){function e(X,$){this._domNode=X,this._clientRectDeltaLeft=0,this._clientRectDeltaLeftRead=!1,this.endNode=$}return Object.defineProperty(e.prototype,"clientRectDeltaLeft",{get:function(){return this._clientRectDeltaLeftRead||(this._clientRectDeltaLeftRead=!0,this._clientRectDeltaLeft=this._domNode.getBoundingClientRect().left),this._clientRectDeltaLeft},enumerable:!0,configurable:!0}),e}();$.DomReadingContext=ue;var de=function(){function e(X,$){this.themeType=$,this.renderWhitespace=X.editor.viewInfo.renderWhitespace,this.renderControlCharacters=X.editor.viewInfo.renderControlCharacters,this.spaceWidth=X.editor.fontInfo.spaceWidth,this.useMonospaceOptimizations=X.editor.fontInfo.isMonospace&&!X.editor.viewInfo.disableMonospaceOptimizations,this.canUseHalfwidthRightwardsArrow=X.editor.fontInfo.canUseHalfwidthRightwardsArrow,this.lineHeight=X.editor.lineHeight,this.stopRenderingLineAfter=X.editor.viewInfo.stopRenderingLineAfter,this.fontLigatures=X.editor.viewInfo.fontLigatures}return e.prototype.equals=function(X){return this.themeType===X.themeType&&this.renderWhitespace===X.renderWhitespace&&this.renderControlCharacters===X.renderControlCharacters&&this.spaceWidth===X.spaceWidth&&this.useMonospaceOptimizations===X.useMonospaceOptimizations&&this.canUseHalfwidthRightwardsArrow===X.canUseHalfwidthRightwardsArrow&&this.lineHeight===X.lineHeight&&this.stopRenderingLineAfter===X.stopRenderingLineAfter&&this.fontLigatures===X.fontLigatures},e}();$.ViewLineOptions=de;var ce=function(){function e(X){this._options=X,this._isMaybeInvalid=!0,this._renderedViewLine=null}return e.prototype.getDomNode=function(){return this._renderedViewLine&&this._renderedViewLine.domNode?this._renderedViewLine.domNode.domNode:null},e.prototype.setDomNode=function(X){if(!this._renderedViewLine)throw new Error("I have no rendered view line to set the dom node to...");this._renderedViewLine.domNode=J.createFastDomNode(X)},e.prototype.onContentChanged=function(){this._isMaybeInvalid=!0},e.prototype.onTokensChanged=function(){this._isMaybeInvalid=!0},e.prototype.onDecorationsChanged=function(){this._isMaybeInvalid=!0},e.prototype.onOptionsChanged=function(X){this._isMaybeInvalid=!0,this._options=X},e.prototype.onSelectionChanged=function(){return!(!le&&this._options.themeType!==se.HIGH_CONTRAST||(this._isMaybeInvalid=!0,0))},e.prototype.renderLine=function(X,$,Q,J){if(!1===this._isMaybeInvalid)return!1;this._isMaybeInvalid=!1;var ee=Q.getViewLineRenderingData(X),te=this._options,ne=oe.LineDecoration.filter(ee.inlineDecorations,X,ee.minColumn,ee.maxColumn);if(le||te.themeType===se.HIGH_CONTRAST)for(var ie=Q.selections,ue=0,de=ie.length;ue<de;ue++){var ce=ie[ue];if(!(ce.endLineNumber<X||ce.startLineNumber>X)){var pe=ce.startLineNumber===X?ce.startColumn:ee.minColumn,fe=ce.endLineNumber===X?ce.endColumn:ee.maxColumn;pe<fe&&ne.push(new oe.LineDecoration(pe,fe,"inline-selected-text",0))}}var me=new re.RenderLineInput(te.useMonospaceOptimizations,te.canUseHalfwidthRightwardsArrow,ee.content,ee.continuesWithWrappedLine,ee.isBasicASCII,ee.containsRTL,ee.minColumn-1,ee.tokens,ne,ee.tabSize,te.spaceWidth,te.stopRenderingLineAfter,te.renderWhitespace,te.renderControlCharacters,te.fontLigatures);if(this._renderedViewLine&&this._renderedViewLine.input.equals(me))return!1;J.appendASCIIString('<div style="top:'),J.appendASCIIString(String($)),J.appendASCIIString("px;height:"),J.appendASCIIString(String(this._options.lineHeight)),J.appendASCIIString('px;" class="'),J.appendASCIIString(e.CLASS_NAME),J.appendASCIIString('">');var ve=re.renderViewLine(me,J);J.appendASCIIString("</div>");var _e=null;return ae&&ee.isBasicASCII&&te.useMonospaceOptimizations&&0===ve.containsForeignElements&&ee.content.length<300&&me.lineTokens.getCount()<100&&(_e=new he(this._renderedViewLine?this._renderedViewLine.domNode:null,me,ve.characterMapping)),_e||(_e=ge(this._renderedViewLine?this._renderedViewLine.domNode:null,me,ve.characterMapping,ve.containsRTL,ve.containsForeignElements)),this._renderedViewLine=_e,!0},e.prototype.layoutLine=function(X,$){this._renderedViewLine&&this._renderedViewLine.domNode&&(this._renderedViewLine.domNode.setTop($),this._renderedViewLine.domNode.setHeight(this._options.lineHeight))},e.prototype.getWidth=function(){return this._renderedViewLine?this._renderedViewLine.getWidth():0},e.prototype.getWidthIsFast=function(){return!this._renderedViewLine||this._renderedViewLine.getWidthIsFast()},e.prototype.getVisibleRangesForRange=function(X,$,Q){if(!this._renderedViewLine)return null;X|=0,$|=0,X=Math.min(this._renderedViewLine.input.lineContent.length+1,Math.max(1,X)),$=Math.min(this._renderedViewLine.input.lineContent.length+1,Math.max(1,$));var J=0|this._renderedViewLine.input.stopRenderingLineAfter;return-1!==J&&X>J&&$>J?null:(-1!==J&&X>J&&(X=J),-1!==J&&$>J&&($=J),this._renderedViewLine.getVisibleRangesForRange(X,$,Q))},e.prototype.getColumnOfNodeOffset=function(X,$,Q){return this._renderedViewLine?this._renderedViewLine.getColumnOfNodeOffset(X,$,Q):1},e.CLASS_NAME="view-line",e}();$.ViewLine=ce;var he=function(){function e(X,$,Q){this.domNode=X,this.input=$,this._characterMapping=Q,this._charWidth=$.spaceWidth}return e.prototype.getWidth=function(){return this._getCharPosition(this._characterMapping.length)},e.prototype.getWidthIsFast=function(){return!0},e.prototype.getVisibleRangesForRange=function(X,$,Q){var J=this._getCharPosition(X),ee=this._getCharPosition($);return[new ie.HorizontalRange(J,ee-J)]},e.prototype._getCharPosition=function(X){var $=this._characterMapping.getAbsoluteOffsets();return 0===$.length?0:Math.round(this._charWidth*$[X-1])},e.prototype.getColumnOfNodeOffset=function(X,$,Q){for(var J=$.textContent.length,ee=-1;$;)$=$.previousSibling,ee++;return this._characterMapping.partDataToCharOffset(ee,J,Q)+1},e}(),pe=function(){function e(X,$,Q,J,ee){if(this.domNode=X,this.input=$,this._characterMapping=Q,this._isWhitespaceOnly=/^\s*$/.test($.lineContent),this._containsForeignElements=ee,this._cachedWidth=-1,this._pixelOffsetCache=null,!J||0===this._characterMapping.length){this._pixelOffsetCache=new Int32Array(Math.max(2,this._characterMapping.length+1));for(var te=0,ne=this._characterMapping.length;te<=ne;te++)this._pixelOffsetCache[te]=-1}}return e.prototype._getReadingTarget=function(){return this.domNode.domNode.firstChild},e.prototype.getWidth=function(){return-1===this._cachedWidth&&(this._cachedWidth=this._getReadingTarget().offsetWidth),this._cachedWidth},e.prototype.getWidthIsFast=function(){return-1!==this._cachedWidth},e.prototype.getVisibleRangesForRange=function(X,$,Q){if(null!==this._pixelOffsetCache){var J=this._readPixelOffset(X,Q);if(-1===J)return null;var ee=this._readPixelOffset($,Q);return-1===ee?null:[new ie.HorizontalRange(J,ee-J)]}return this._readVisibleRangesForRange(X,$,Q)},e.prototype._readVisibleRangesForRange=function(X,$,Q){if(X===$){var J=this._readPixelOffset(X,Q);return-1===J?null:[new ie.HorizontalRange(J,0)]}return this._readRawVisibleRangesForRange(X,$,Q)},e.prototype._readPixelOffset=function(X,$){if(0===this._characterMapping.length){if(0===this._containsForeignElements)return 0;if(2===this._containsForeignElements)return 0;if(1===this._containsForeignElements)return this.getWidth()}if(null!==this._pixelOffsetCache){var Q=this._pixelOffsetCache[X];if(-1!==Q)return Q;var J=this._actualReadPixelOffset(X,$);return this._pixelOffsetCache[X]=J,J}return this._actualReadPixelOffset(X,$)},e.prototype._actualReadPixelOffset=function(X,$){if(0===this._characterMapping.length){var Q=ne.RangeUtil.readHorizontalRanges(this._getReadingTarget(),0,0,0,0,$.clientRectDeltaLeft,$.endNode);return Q&&0!==Q.length?Q[0].left:-1}if(X===this._characterMapping.length&&this._isWhitespaceOnly&&0===this._containsForeignElements)return this.getWidth();var J=this._characterMapping.charOffsetToPartData(X-1),ee=re.CharacterMapping.getPartIndex(J),te=re.CharacterMapping.getCharIndex(J),ie=ne.RangeUtil.readHorizontalRanges(this._getReadingTarget(),ee,te,ee,te,$.clientRectDeltaLeft,$.endNode);return ie&&0!==ie.length?ie[0].left:-1},e.prototype._readRawVisibleRangesForRange=function(X,$,Q){if(1===X&&$===this._characterMapping.length)return[new ie.HorizontalRange(0,this.getWidth())];var J=this._characterMapping.charOffsetToPartData(X-1),ee=re.CharacterMapping.getPartIndex(J),te=re.CharacterMapping.getCharIndex(J),oe=this._characterMapping.charOffsetToPartData($-1),se=re.CharacterMapping.getPartIndex(oe),ae=re.CharacterMapping.getCharIndex(oe);return ne.RangeUtil.readHorizontalRanges(this._getReadingTarget(),ee,te,se,ae,Q.clientRectDeltaLeft,Q.endNode)},e.prototype.getColumnOfNodeOffset=function(X,$,Q){for(var J=$.textContent.length,ee=-1;$;)$=$.previousSibling,ee++;return this._characterMapping.partDataToCharOffset(ee,J,Q)+1},e}(),fe=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype._readVisibleRangesForRange=function($,Q,J){var ee=X.prototype._readVisibleRangesForRange.call(this,$,Q,J);if(!ee||0===ee.length||$===Q||1===$&&Q===this._characterMapping.length)return ee;if(!this.input.containsRTL){var te=this._readPixelOffset(Q,J);if(-1!==te){var ne=ee[ee.length-1];ne.left<te&&(ne.width=te-ne.left)}}return ee},t}(pe),ge=Q.isWebKit?function c(X,$,Q,J,ee){return new fe(X,$,Q,J,ee)}:function h(X,$,Q,J,ee){return new pe(X,$,Q,J,ee)}})),define(Q[185],n([0,1,29,134,33,184,12,3]),(function(X,$,Q,J,ee,ne,ie,oe){function u(X){return{isAfterLines:!1,horizontalDistanceToText:X}}Object.defineProperty($,"__esModule",{value:!0});var re=function(){function e(X,$,Q,J,ee,te){void 0===Q&&(Q=0),void 0===J&&(J=null),void 0===ee&&(ee=null),void 0===te&&(te=null),this.element=X,this.type=$,this.mouseColumn=Q,this.position=J,!ee&&J&&(ee=new oe.Range(J.lineNumber,J.column,J.lineNumber,J.column)),this.range=ee,this.detail=te}return e._typeToString=function(X){return 1===X?"TEXTAREA":2===X?"GUTTER_GLYPH_MARGIN":3===X?"GUTTER_LINE_NUMBERS":4===X?"GUTTER_LINE_DECORATIONS":5===X?"GUTTER_VIEW_ZONE":6===X?"CONTENT_TEXT":7===X?"CONTENT_EMPTY":8===X?"CONTENT_VIEW_ZONE":9===X?"CONTENT_WIDGET":10===X?"OVERVIEW_RULER":11===X?"SCROLLBAR":12===X?"OVERLAY_WIDGET":"UNKNOWN"},e.toString=function(X){return this._typeToString(X.type)+": "+X.position+" - "+X.range+" - "+X.detail},e.prototype.toString=function(){return e.toString(this)},e}();$.MouseTarget=re;var se=function(){function e(){}return e.isTextArea=function(X){return 2===X.length&&3===X[0]&&6===X[1]},e.isChildOfViewLines=function(X){return X.length>=4&&3===X[0]&&7===X[3]},e.isStrictChildOfViewLines=function(X){return X.length>4&&3===X[0]&&7===X[3]},e.isChildOfScrollableElement=function(X){return X.length>=2&&3===X[0]&&5===X[1]},e.isChildOfMinimap=function(X){return X.length>=2&&3===X[0]&&8===X[1]},e.isChildOfContentWidgets=function(X){return X.length>=4&&3===X[0]&&1===X[3]},e.isChildOfOverflowingContentWidgets=function(X){return X.length>=1&&2===X[0]},e.isChildOfOverlayWidgets=function(X){return X.length>=2&&3===X[0]&&4===X[1]},e}(),ae=function(){function e(X,$,Q){this.model=X.model,this.layoutInfo=X.configuration.editor.layoutInfo,this.viewDomNode=$.viewDomNode,this.lineHeight=X.configuration.editor.lineHeight,this.typicalHalfwidthCharacterWidth=X.configuration.editor.fontInfo.typicalHalfwidthCharacterWidth,this.lastViewCursorsRenderData=Q,this._context=X,this._viewHelper=$}return e.prototype.getZoneAtCoord=function(X){return e.getZoneAtCoord(this._context,X)},e.getZoneAtCoord=function(X,$){var Q=X.viewLayout.getWhitespaceAtVerticalOffset($);if(Q){var J,ee=Q.verticalOffset+Q.height/2,te=X.model.getLineCount(),ne=null,oe=null;return Q.afterLineNumber!==te&&(oe=new ie.Position(Q.afterLineNumber+1,1)),Q.afterLineNumber>0&&(ne=new ie.Position(Q.afterLineNumber,X.model.getLineMaxColumn(Q.afterLineNumber))),J=null===oe?ne:null===ne?oe:$<ee?ne:oe,{viewZoneId:Q.id,afterLineNumber:Q.afterLineNumber,positionBefore:ne,positionAfter:oe,position:J}}return null},e.prototype.getFullLineRangeAtCoord=function(X){if(this._context.viewLayout.isAfterLines(X)){var $=this._context.model.getLineCount(),Q=this._context.model.getLineMaxColumn($);return{range:new oe.Range($,Q,$,Q),isAfterLines:!0}}var J=this._context.viewLayout.getLineNumberAtVerticalOffset(X),ee=this._context.model.getLineMaxColumn(J);return{range:new oe.Range(J,1,J,ee),isAfterLines:!1}},e.prototype.getLineNumberAtVerticalOffset=function(X){return this._context.viewLayout.getLineNumberAtVerticalOffset(X)},e.prototype.isAfterLines=function(X){return this._context.viewLayout.isAfterLines(X)},e.prototype.getVerticalOffsetForLineNumber=function(X){return this._context.viewLayout.getVerticalOffsetForLineNumber(X)},e.prototype.findAttribute=function(X,$){return e._findAttribute(X,$,this._viewHelper.viewDomNode)},e._findAttribute=function(X,$,Q){for(;X&&X!==document.body;){if(X.hasAttribute&&X.hasAttribute($))return X.getAttribute($);if(X===Q)return null;X=X.parentNode}return null},e.prototype.getLineWidth=function(X){return this._viewHelper.getLineWidth(X)},e.prototype.visibleRangeForPosition2=function(X,$){return this._viewHelper.visibleRangeForPosition2(X,$)},e.prototype.getPositionFromDOMInfo=function(X,$){return this._viewHelper.getPositionFromDOMInfo(X,$)},e.prototype.getCurrentScrollTop=function(){return this._context.viewLayout.getCurrentScrollTop()},e.prototype.getCurrentScrollLeft=function(){return this._context.viewLayout.getCurrentScrollLeft()},e}();$.HitTestContext=ae;var le=function(X){function t($,Q,J,te){var ne=X.call(this,$,Q,J)||this;return ne._ctx=$,te?(ne.target=te,ne.targetPath=ee.PartFingerprints.collect(te,$.viewDomNode)):(ne.target=null,ne.targetPath=new Uint8Array(0)),ne}return te(t,X),t.prototype.toString=function(){return"pos("+this.pos.x+","+this.pos.y+"), editorPos("+this.editorPos.x+","+this.editorPos.y+"), mouseVerticalOffset: "+this.mouseVerticalOffset+", mouseContentHorizontalOffset: "+this.mouseContentHorizontalOffset+"\n\ttarget: "+(this.target?this.target.outerHTML:null)},t.prototype.fulfill=function(X,$,Q,J){return void 0===$&&($=null),void 0===Q&&(Q=null),void 0===J&&(J=null),new re(this.target,X,this.mouseColumn,$,Q,J)},t.prototype.withTarget=function(X){return new t(this._ctx,this.editorPos,this.pos,X)},t}((function(X,$,Q){this.editorPos=$,this.pos=Q,this.mouseVerticalOffset=Math.max(0,X.getCurrentScrollTop()+Q.y-$.y),this.mouseContentHorizontalOffset=X.getCurrentScrollLeft()+Q.x-$.x-X.layoutInfo.contentLeft,this.isInMarginArea=Q.x-$.x<X.layoutInfo.contentLeft&&Q.x-$.x>=X.layoutInfo.glyphMarginLeft,this.isInContentArea=!this.isInMarginArea,this.mouseColumn=Math.max(0,de._getMouseColumn(this.mouseContentHorizontalOffset,X.typicalHalfwidthCharacterWidth))})),ue={isAfterLines:!0},de=function(){function e(X,$){this._context=X,this._viewHelper=$}return e.prototype.mouseTargetIsWidget=function(X){var $=X.target,Q=ee.PartFingerprints.collect($,this._viewHelper.viewDomNode);return!(!se.isChildOfContentWidgets(Q)&&!se.isChildOfOverflowingContentWidgets(Q)&&!se.isChildOfOverlayWidgets(Q))},e.prototype.createMouseTarget=function(X,$,Q,J){var ee=new ae(this._context,this._viewHelper,X),te=new le(ee,$,Q,J);try{return e._createMouseTarget(ee,te,!1)}catch(X){return te.fulfill(0)}},e._createMouseTarget=function(X,$,Q){if(null===$.target){if(Q)return $.fulfill(0);var J=e._doHitTest(X,$);return J.position?e.createMouseTargetFromHitTestPosition(X,$,J.position.lineNumber,J.position.column):this._createMouseTarget(X,$.withTarget(J.hitTarget),!0)}var ee=$,te=null;return(te=(te=(te=(te=(te=(te=(te=(te=(te=(te=te||e._hitTestContentWidget(X,ee))||e._hitTestOverlayWidget(X,ee))||e._hitTestMinimap(X,ee))||e._hitTestScrollbarSlider(X,ee))||e._hitTestViewZone(X,ee))||e._hitTestMargin(X,ee))||e._hitTestViewCursor(X,ee))||e._hitTestTextArea(X,ee))||e._hitTestViewLines(X,ee,Q))||e._hitTestScrollbar(X,ee))||$.fulfill(0)},e._hitTestContentWidget=function(X,$){if(se.isChildOfContentWidgets($.targetPath)||se.isChildOfOverflowingContentWidgets($.targetPath)){var Q=X.findAttribute($.target,"widgetId");return Q?$.fulfill(9,null,null,Q):$.fulfill(0)}return null},e._hitTestOverlayWidget=function(X,$){if(se.isChildOfOverlayWidgets($.targetPath)){var Q=X.findAttribute($.target,"widgetId");return Q?$.fulfill(12,null,null,Q):$.fulfill(0)}return null},e._hitTestViewCursor=function(X,$){if($.target)for(var Q=0,J=(ee=X.lastViewCursorsRenderData).length;Q<J;Q++)if(ie=ee[Q],$.target===ie.domNode)return $.fulfill(6,ie.position);if($.isInContentArea){var ee=X.lastViewCursorsRenderData,te=$.mouseContentHorizontalOffset,ne=$.mouseVerticalOffset;for(Q=0,J=ee.length;Q<J;Q++){var ie;if(!(te<(ie=ee[Q]).contentLeft||te>ie.contentLeft+ie.width)){var oe=X.getVerticalOffsetForLineNumber(ie.position.lineNumber);if(oe<=ne&&ne<=oe+ie.height)return $.fulfill(6,ie.position)}}}return null},e._hitTestViewZone=function(X,$){var Q=X.getZoneAtCoord($.mouseVerticalOffset);if(Q){var J=$.isInContentArea?8:5;return $.fulfill(J,Q.position,null,Q)}return null},e._hitTestTextArea=function(X,$){return se.isTextArea($.targetPath)?$.fulfill(1):null},e._hitTestMargin=function(X,$){if($.isInMarginArea){var Q=X.getFullLineRangeAtCoord($.mouseVerticalOffset),J=Q.range.getStartPosition(),ee=Math.abs($.pos.x-$.editorPos.x),te={isAfterLines:Q.isAfterLines,glyphMarginLeft:X.layoutInfo.glyphMarginLeft,glyphMarginWidth:X.layoutInfo.glyphMarginWidth,lineNumbersWidth:X.layoutInfo.lineNumbersWidth,offsetX:ee};return(ee-=X.layoutInfo.glyphMarginLeft)<=X.layoutInfo.glyphMarginWidth?$.fulfill(2,J,Q.range,te):(ee-=X.layoutInfo.glyphMarginWidth)<=X.layoutInfo.lineNumbersWidth?$.fulfill(3,J,Q.range,te):(ee-=X.layoutInfo.lineNumbersWidth,$.fulfill(4,J,Q.range,te))}return null},e._hitTestViewLines=function(X,$,Q){if(!se.isChildOfViewLines($.targetPath))return null;if(X.isAfterLines($.mouseVerticalOffset)){var J=X.model.getLineCount(),ee=X.model.getLineMaxColumn(J);return $.fulfill(7,new ie.Position(J,ee),void 0,ue)}if(Q){if(se.isStrictChildOfViewLines($.targetPath)){var te=X.getLineNumberAtVerticalOffset($.mouseVerticalOffset);if(0===X.model.getLineLength(te)){var ne=X.getLineWidth(te),oe=u($.mouseContentHorizontalOffset-ne);return $.fulfill(7,new ie.Position(te,1),void 0,oe)}}return $.fulfill(0)}var re=e._doHitTest(X,$);return re.position?e.createMouseTargetFromHitTestPosition(X,$,re.position.lineNumber,re.position.column):this._createMouseTarget(X,$.withTarget(re.hitTarget),!0)},e._hitTestMinimap=function(X,$){if(se.isChildOfMinimap($.targetPath)){var Q=X.getLineNumberAtVerticalOffset($.mouseVerticalOffset),J=X.model.getLineMaxColumn(Q);return $.fulfill(11,new ie.Position(Q,J))}return null},e._hitTestScrollbarSlider=function(X,$){if(se.isChildOfScrollableElement($.targetPath)&&$.target&&1===$.target.nodeType){var Q=$.target.className;if(Q&&/\b(slider|scrollbar)\b/.test(Q)){var J=X.getLineNumberAtVerticalOffset($.mouseVerticalOffset),ee=X.model.getLineMaxColumn(J);return $.fulfill(11,new ie.Position(J,ee))}}return null},e._hitTestScrollbar=function(X,$){if(se.isChildOfScrollableElement($.targetPath)){var Q=X.getLineNumberAtVerticalOffset($.mouseVerticalOffset),J=X.model.getLineMaxColumn(Q);return $.fulfill(11,new ie.Position(Q,J))}return null},e.prototype.getMouseColumn=function(X,$){var Q=this._context.configuration.editor.layoutInfo,J=this._context.viewLayout.getCurrentScrollLeft()+$.x-X.x-Q.contentLeft;return e._getMouseColumn(J,this._context.configuration.editor.fontInfo.typicalHalfwidthCharacterWidth)},e._getMouseColumn=function(X,$){return X<0?1:Math.round(X/$)+1},e.createMouseTargetFromHitTestPosition=function(X,$,J,ee){var te=new ie.Position(J,ee),ne=X.getLineWidth(J);if($.mouseContentHorizontalOffset>ne){if(Q.isEdge&&1===te.column){var re=u($.mouseContentHorizontalOffset-ne);return $.fulfill(7,new ie.Position(J,X.model.getLineMaxColumn(J)),void 0,re)}var se=u($.mouseContentHorizontalOffset-ne);return $.fulfill(7,te,void 0,se)}var ae=X.visibleRangeForPosition2(J,ee);if(!ae)return $.fulfill(0,te);var le=ae.left;if($.mouseContentHorizontalOffset===le)return $.fulfill(6,te);var ue=[];if(ue.push({offset:ae.left,column:ee}),ee>1){var de=X.visibleRangeForPosition2(J,ee-1);de&&ue.push({offset:de.left,column:ee-1})}if(ee<X.model.getLineMaxColumn(J)){var ce=X.visibleRangeForPosition2(J,ee+1);ce&&ue.push({offset:ce.left,column:ee+1})}ue.sort((function(X,$){return X.offset-$.offset}));for(var he=1;he<ue.length;he++){var pe=ue[he-1],fe=ue[he];if(pe.offset<=$.mouseContentHorizontalOffset&&$.mouseContentHorizontalOffset<=fe.offset){var ge=new oe.Range(J,pe.column,J,fe.column);return $.fulfill(6,te,ge)}}return $.fulfill(6,te)},e._doHitTestWithCaretRangeFromPoint=function(X,$){var Q=X.getLineNumberAtVerticalOffset($.mouseVerticalOffset),ee=X.getVerticalOffsetForLineNumber(Q)+Math.floor(X.lineHeight/2),te=$.pos.y+(ee-$.mouseVerticalOffset);te<=$.editorPos.y&&(te=$.editorPos.y+1),te>=$.editorPos.y+X.layoutInfo.height&&(te=$.editorPos.y+X.layoutInfo.height-1);var ne=new J.PageCoordinates($.pos.x,te),ie=this._actualDoHitTestWithCaretRangeFromPoint(X,ne.toClientCoordinates());return ie.position?ie:this._actualDoHitTestWithCaretRangeFromPoint(X,$.pos.toClientCoordinates())},e._actualDoHitTestWithCaretRangeFromPoint=function(X,$){var Q=document.caretRangeFromPoint($.clientX,$.clientY);if(!Q||!Q.startContainer)return{position:null,hitTarget:null};var J=Q.startContainer,ee=null;if(J.nodeType===J.TEXT_NODE){var te=(oe=(ie=J.parentNode)?ie.parentNode:null)?oe.parentNode:null;if((te&&te.nodeType===te.ELEMENT_NODE?te.className:null)===ne.ViewLine.CLASS_NAME)return{position:re=X.getPositionFromDOMInfo(ie,Q.startOffset),hitTarget:null};ee=J.parentNode}else if(J.nodeType===J.ELEMENT_NODE){var ie=J.parentNode,oe=ie?ie.parentNode:null;if((oe&&oe.nodeType===oe.ELEMENT_NODE?oe.className:null)===ne.ViewLine.CLASS_NAME){var re=X.getPositionFromDOMInfo(J,J.textContent.length);return{position:re,hitTarget:null}}ee=J}return{position:null,hitTarget:ee}},e._doHitTestWithCaretPositionFromPoint=function(X,$){var Q=document.caretPositionFromPoint($.clientX,$.clientY);if(Q.offsetNode.nodeType===Q.offsetNode.TEXT_NODE){var J=Q.offsetNode.parentNode,ee=J?J.parentNode:null,te=ee?ee.parentNode:null;return(te&&te.nodeType===te.ELEMENT_NODE?te.className:null)===ne.ViewLine.CLASS_NAME?{position:X.getPositionFromDOMInfo(Q.offsetNode.parentNode,Q.offset),hitTarget:null}:{position:null,hitTarget:Q.offsetNode.parentNode}}return{position:null,hitTarget:Q.offsetNode}},e._doHitTestWithMoveToPoint=function(X,$){var Q=null,J=null,ee=document.body.createTextRange();try{ee.moveToPoint($.clientX,$.clientY)}catch(X){return{position:null,hitTarget:null}}ee.collapse(!0);var te=ee?ee.parentElement():null,ie=te?te.parentNode:null,oe=ie?ie.parentNode:null;if((oe&&oe.nodeType===oe.ELEMENT_NODE?oe.className:"")===ne.ViewLine.CLASS_NAME){var re=ee.duplicate();re.moveToElementText(te),re.setEndPoint("EndToStart",ee),Q=X.getPositionFromDOMInfo(te,re.text.length),re.moveToElementText(X.viewDomNode)}else J=te;return ee.moveToElementText(X.viewDomNode),{position:Q,hitTarget:J}},e._doHitTest=function(X,$){return document.caretRangeFromPoint?this._doHitTestWithCaretRangeFromPoint(X,$):document.caretPositionFromPoint?this._doHitTestWithCaretPositionFromPoint(X,$.pos.toClientCoordinates()):document.body.createTextRange?this._doHitTestWithMoveToPoint(X,$.pos.toClientCoordinates()):{position:null,hitTarget:null}},e}();$.MouseTargetFactory=de})),define(Q[488],n([0,1,29,7,40,16,2,17,185,134,97,12,21,79]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le,ue,de){function g(X){return function($,Q){var J=!1;return X&&(J=X.mouseTargetIsWidget(Q)),J||Q.preventDefault(),Q}}Object.defineProperty($,"__esModule",{value:!0});var ce=function(X){function t($,Q,te){var ie=X.call(this)||this;ie._isFocused=!1,ie._context=$,ie.viewController=Q,ie.viewHelper=te,ie.mouseTargetFactory=new re.MouseTargetFactory(ie._context,te),ie._mouseDownOperation=ie._register(new he(ie._context,ie.viewController,ie.viewHelper,(function(X,$){return ie._createMouseTarget(X,$)}),(function(X){return ie._getMouseColumn(X)}))),ie._asyncFocus=ie._register(new ne.RunOnceScheduler((function(){return ie.viewHelper.focusTextArea()}),0)),ie.lastMouseLeaveTime=-1;var oe=new se.EditorMouseEventFactory(ie.viewHelper.viewDomNode);ie._register(oe.onContextMenu(ie.viewHelper.viewDomNode,(function(X){return ie._onContextMenu(X,!0)}))),ie._register(oe.onMouseMoveThrottled(ie.viewHelper.viewDomNode,(function(X){return ie._onMouseMove(X)}),g(ie.mouseTargetFactory),t.MOUSE_MOVE_MINIMUM_TIME)),ie._register(oe.onMouseUp(ie.viewHelper.viewDomNode,(function(X){return ie._onMouseUp(X)}))),ie._register(oe.onMouseLeave(ie.viewHelper.viewDomNode,(function(X){return ie._onMouseLeave(X)}))),ie._register(oe.onMouseDown(ie.viewHelper.viewDomNode,(function(X){return ie._onMouseDown(X)})));var p=function(X){if(ie._context.configuration.editor.viewInfo.mouseWheelZoom){var $=new ee.StandardMouseWheelEvent(X);if($.browserEvent.ctrlKey||$.browserEvent.metaKey){var Q=ae.EditorZoom.getZoomLevel(),J=$.deltaY>0?1:-1;ae.EditorZoom.setZoomLevel(Q+J),$.preventDefault(),$.stopPropagation()}}};return ie._register(J.addDisposableListener(ie.viewHelper.viewDomNode,"mousewheel",p,!0)),ie._register(J.addDisposableListener(ie.viewHelper.viewDomNode,"DOMMouseScroll",p,!0)),ie._context.addEventHandler(ie),ie}return te(t,X),t.prototype.dispose=function(){this._context.removeEventHandler(this),X.prototype.dispose.call(this)},t.prototype.onCursorStateChanged=function(X){return this._mouseDownOperation.onCursorStateChanged(X),!1},t.prototype.onFocusChanged=function(X){return this._isFocused=X.isFocused,!1},t.prototype.onScrollChanged=function(X){return this._mouseDownOperation.onScrollChanged(),!1},t.prototype.getTargetAtClientPoint=function(X,$){var Q=new se.ClientCoordinates(X,$).toPageCoordinates(),J=se.createEditorPagePosition(this.viewHelper.viewDomNode);if(Q.y<J.y||Q.y>J.y+J.height||Q.x<J.x||Q.x>J.x+J.width)return null;var ee=this.viewHelper.getLastViewCursorsRenderData();return this.mouseTargetFactory.createMouseTarget(ee,J,Q,null)},t.prototype._createMouseTarget=function(X,$){var Q=this.viewHelper.getLastViewCursorsRenderData();return this.mouseTargetFactory.createMouseTarget(Q,X.editorPos,X.pos,$?X.target:null)},t.prototype._getMouseColumn=function(X){return this.mouseTargetFactory.getMouseColumn(X.editorPos,X.pos)},t.prototype._onContextMenu=function(X,$){this.viewController.emitContextMenu({event:X,target:this._createMouseTarget(X,$)})},t.prototype._onMouseMove=function(X){this._mouseDownOperation.isActive()||X.timestamp<this.lastMouseLeaveTime||this.viewController.emitMouseMove({event:X,target:this._createMouseTarget(X,!0)})},t.prototype._onMouseLeave=function(X){this.lastMouseLeaveTime=(new Date).getTime(),this.viewController.emitMouseLeave({event:X,target:null})},t.prototype._onMouseUp=function(X){this.viewController.emitMouseUp({event:X,target:this._createMouseTarget(X,!0)})},t.prototype._onMouseDown=function(X){var $=this,J=this._createMouseTarget(X,!0),ee=6===J.type||7===J.type,te=2===J.type||3===J.type||4===J.type,ne=3===J.type,ie=this._context.configuration.editor.viewInfo.selectOnLineNumbers,re=8===J.type||5===J.type,se=9===J.type,ae=X.leftButton||X.middleButton;oe.isMacintosh&&X.leftButton&&X.ctrlKey&&(ae=!1);var h=function(){Q.isIE&&!$._isFocused?$._asyncFocus.schedule():(X.preventDefault(),$.viewHelper.focusTextArea())};if(ae&&(ee||ne&&ie))h(),this._mouseDownOperation.start(J.type,X);else if(te)X.preventDefault();else if(re){var le=J.detail;this.viewHelper.shouldSuppressMouseDownOnViewZone(le.viewZoneId)&&(h(),this._mouseDownOperation.start(J.type,X),X.preventDefault())}else se&&this.viewHelper.shouldSuppressMouseDownOnWidget(J.detail)&&(h(),X.preventDefault());this.viewController.emitMouseDown({event:X,target:J})},t.MOUSE_MOVE_MINIMUM_TIME=100,t}(de.ViewEventHandler);$.MouseHandler=ce;var he=function(X){function t($,Q,J,ee,te){var ie=X.call(this)||this;return ie._context=$,ie._viewController=Q,ie._viewHelper=J,ie._createMouseTarget=ee,ie._getMouseColumn=te,ie._mouseMoveMonitor=ie._register(new se.GlobalEditorMouseMoveMonitor(ie._viewHelper.viewDomNode)),ie._onScrollTimeout=ie._register(new ne.TimeoutTimer),ie._mouseState=new pe,ie._currentSelection=new ue.Selection(1,1,1,1),ie._isActive=!1,ie._lastMouseEvent=null,ie}return te(t,X),t.prototype.dispose=function(){X.prototype.dispose.call(this)},t.prototype.isActive=function(){return this._isActive},t.prototype._onMouseDownThenMove=function(X){this._lastMouseEvent=X,this._mouseState.setModifiers(X);var $=this._findMousePosition(X,!0);$&&(this._mouseState.isDragAndDrop?this._viewController.emitMouseDrag({event:X,target:$}):this._dispatchMouse($,!0))},t.prototype.start=function(X,$){var Q=this;this._lastMouseEvent=$,this._mouseState.setStartedOnLineNumbers(3===X),this._mouseState.setStartButtons($),this._mouseState.setModifiers($);var J=this._findMousePosition($,!0);if(J&&J.position){if(this._mouseState.trySetCount($.detail,J.position),$.detail=this._mouseState.count,!this._context.configuration.editor.readOnly&&this._context.configuration.editor.dragAndDrop&&!this._mouseState.altKey&&$.detail<2&&!this._isActive&&!this._currentSelection.isEmpty()&&6===J.type&&J.position&&this._currentSelection.containsPosition(J.position))return this._mouseState.isDragAndDrop=!0,this._isActive=!0,void this._mouseMoveMonitor.startMonitoring(g(null),(function(X){return Q._onMouseDownThenMove(X)}),(function(){var X=Q._findMousePosition(Q._lastMouseEvent,!0);Q._viewController.emitMouseDrop({event:Q._lastMouseEvent,target:X?Q._createMouseTarget(Q._lastMouseEvent,!0):null}),Q._stop()}));this._mouseState.isDragAndDrop=!1,this._dispatchMouse(J,$.shiftKey),this._isActive||(this._isActive=!0,this._mouseMoveMonitor.startMonitoring(g(null),(function(X){return Q._onMouseDownThenMove(X)}),(function(){return Q._stop()})))}},t.prototype._stop=function(){this._isActive=!1,this._onScrollTimeout.cancel()},t.prototype.onScrollChanged=function(){var X=this;this._isActive&&this._onScrollTimeout.setIfNotSet((function(){if(X._lastMouseEvent){var $=X._findMousePosition(X._lastMouseEvent,!1);$&&(X._mouseState.isDragAndDrop||X._dispatchMouse($,!0))}}),10)},t.prototype.onCursorStateChanged=function(X){this._currentSelection=X.selections[0]},t.prototype._getPositionOutsideEditor=function(X){var $=X.editorPos,Q=this._context.model,J=this._context.viewLayout,ee=this._getMouseColumn(X);if(X.posy<$.y){if(ne=Math.max(J.getCurrentScrollTop()-($.y-X.posy),0),(ie=re.HitTestContext.getZoneAtCoord(this._context,ne))&&(oe=this._helpPositionJumpOverViewZone(ie)))return new re.MouseTarget(null,13,ee,oe);var te=J.getLineNumberAtVerticalOffset(ne);return new re.MouseTarget(null,13,ee,new le.Position(te,1))}if(X.posy>$.y+$.height){var ne=J.getCurrentScrollTop()+(X.posy-$.y),ie=re.HitTestContext.getZoneAtCoord(this._context,ne);if(ie){var oe=this._helpPositionJumpOverViewZone(ie);if(oe)return new re.MouseTarget(null,13,ee,oe)}var se=J.getLineNumberAtVerticalOffset(ne);return new re.MouseTarget(null,13,ee,new le.Position(se,Q.getLineMaxColumn(se)))}var ae=J.getLineNumberAtVerticalOffset(J.getCurrentScrollTop()+(X.posy-$.y));return X.posx<$.x?new re.MouseTarget(null,13,ee,new le.Position(ae,1)):X.posx>$.x+$.width?new re.MouseTarget(null,13,ee,new le.Position(ae,Q.getLineMaxColumn(ae))):null},t.prototype._findMousePosition=function(X,$){var Q=this._getPositionOutsideEditor(X);if(Q)return Q;var J=this._createMouseTarget(X,$);if(!J.position)return null;if(8===J.type||5===J.type){var ee=this._helpPositionJumpOverViewZone(J.detail);if(ee)return new re.MouseTarget(J.element,J.type,J.mouseColumn,ee,null,J.detail)}return J},t.prototype._helpPositionJumpOverViewZone=function(X){var $=new le.Position(this._currentSelection.selectionStartLineNumber,this._currentSelection.selectionStartColumn),Q=X.positionBefore,J=X.positionAfter;return Q&&J?Q.isBefore($)?Q:J:null},t.prototype._dispatchMouse=function(X,$){X.position&&this._viewController.dispatchMouse({position:X.position,mouseColumn:X.mouseColumn,startedOnLineNumbers:this._mouseState.startedOnLineNumbers,inSelectionMode:$,mouseDownCount:this._mouseState.count,altKey:this._mouseState.altKey,ctrlKey:this._mouseState.ctrlKey,metaKey:this._mouseState.metaKey,shiftKey:this._mouseState.shiftKey,leftButton:this._mouseState.leftButton,middleButton:this._mouseState.middleButton})},t}(ie.Disposable),pe=function(){function e(){this._altKey=!1,this._ctrlKey=!1,this._metaKey=!1,this._shiftKey=!1,this._leftButton=!1,this._middleButton=!1,this._startedOnLineNumbers=!1,this._lastMouseDownPosition=null,this._lastMouseDownPositionEqualCount=0,this._lastMouseDownCount=0,this._lastSetMouseDownCountTime=0,this.isDragAndDrop=!1}return Object.defineProperty(e.prototype,"altKey",{get:function(){return this._altKey},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"ctrlKey",{get:function(){return this._ctrlKey},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"metaKey",{get:function(){return this._metaKey},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"shiftKey",{get:function(){return this._shiftKey},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"leftButton",{get:function(){return this._leftButton},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"middleButton",{get:function(){return this._middleButton},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"startedOnLineNumbers",{get:function(){return this._startedOnLineNumbers},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"count",{get:function(){return this._lastMouseDownCount},enumerable:!0,configurable:!0}),e.prototype.setModifiers=function(X){this._altKey=X.altKey,this._ctrlKey=X.ctrlKey,this._metaKey=X.metaKey,this._shiftKey=X.shiftKey},e.prototype.setStartButtons=function(X){this._leftButton=X.leftButton,this._middleButton=X.middleButton},e.prototype.setStartedOnLineNumbers=function(X){this._startedOnLineNumbers=X},e.prototype.trySetCount=function(X,$){var Q=(new Date).getTime();Q-this._lastSetMouseDownCountTime>e.CLEAR_MOUSE_DOWN_COUNT_TIME&&(X=1),this._lastSetMouseDownCountTime=Q,X>this._lastMouseDownCount+1&&(X=this._lastMouseDownCount+1),this._lastMouseDownPosition&&this._lastMouseDownPosition.equals($)?this._lastMouseDownPositionEqualCount++:this._lastMouseDownPositionEqualCount=1,this._lastMouseDownPosition=$,this._lastMouseDownCount=Math.min(X,this._lastMouseDownPositionEqualCount)},e.CLEAR_MOUSE_DOWN_COUNT_TIME=400,e}()})),define(Q[489],n([0,1,7,75,488,134]),(function(X,$,Q,J,ee,ne){function a(X,$){var Q={translationY:$.translationY,translationX:$.translationX};return X&&(Q.translationY+=X.translationY,Q.translationX+=X.translationX),Q}Object.defineProperty($,"__esModule",{value:!0});var ie=function(X){function t($,J,ee){var te=X.call(this,$,J,ee)||this;return te.viewHelper.linesContentDomNode.style.msTouchAction="none",te.viewHelper.linesContentDomNode.style.msContentZooming="none",te._installGestureHandlerTimeout=window.setTimeout((function(){if(te._installGestureHandlerTimeout=-1,window.MSGesture){var X=new MSGesture,$=new MSGesture;X.target=te.viewHelper.linesContentDomNode,$.target=te.viewHelper.linesContentDomNode,te.viewHelper.linesContentDomNode.addEventListener("MSPointerDown",(function(Q){var J=Q.pointerType;J!==(Q.MSPOINTER_TYPE_MOUSE||"mouse")?J===(Q.MSPOINTER_TYPE_TOUCH||"touch")?(te._lastPointerType="touch",X.addPointer(Q.pointerId)):(te._lastPointerType="pen",$.addPointer(Q.pointerId)):te._lastPointerType="mouse"})),te._register(Q.addDisposableThrottledListener(te.viewHelper.linesContentDomNode,"MSGestureChange",(function(X){return te._onGestureChange(X)}),a)),te._register(Q.addDisposableListener(te.viewHelper.linesContentDomNode,"MSGestureTap",(function(X){return te._onCaptureGestureTap(X)}),!0))}}),100),te._lastPointerType="mouse",te}return te(t,X),t.prototype._onMouseDown=function($){"mouse"===this._lastPointerType&&X.prototype._onMouseDown.call(this,$)},t.prototype._onCaptureGestureTap=function(X){var $=this,Q=new ne.EditorMouseEvent(X,this.viewHelper.viewDomNode),J=this._createMouseTarget(Q,!1);J.position&&this.viewController.moveTo(J.position),Q.browserEvent.fromElement?(Q.preventDefault(),this.viewHelper.focusTextArea()):setTimeout((function(){$.viewHelper.focusTextArea()}))},t.prototype._onGestureChange=function(X){this._context.viewLayout.deltaScrollNow(-X.translationX,-X.translationY)},t.prototype.dispose=function(){window.clearTimeout(this._installGestureHandlerTimeout),X.prototype.dispose.call(this)},t}(ee.MouseHandler),oe=function(X){function t($,J,ee){var te=X.call(this,$,J,ee)||this;return te.viewHelper.linesContentDomNode.style.touchAction="none",te._installGestureHandlerTimeout=window.setTimeout((function(){if(te._installGestureHandlerTimeout=-1,window.MSGesture){var X=new MSGesture,$=new MSGesture;X.target=te.viewHelper.linesContentDomNode,$.target=te.viewHelper.linesContentDomNode,te.viewHelper.linesContentDomNode.addEventListener("pointerdown",(function(Q){var J=Q.pointerType;"mouse"!==J?"touch"===J?(te._lastPointerType="touch",X.addPointer(Q.pointerId)):(te._lastPointerType="pen",$.addPointer(Q.pointerId)):te._lastPointerType="mouse"})),te._register(Q.addDisposableThrottledListener(te.viewHelper.linesContentDomNode,"MSGestureChange",(function(X){return te._onGestureChange(X)}),a)),te._register(Q.addDisposableListener(te.viewHelper.linesContentDomNode,"MSGestureTap",(function(X){return te._onCaptureGestureTap(X)}),!0))}}),100),te._lastPointerType="mouse",te}return te(t,X),t.prototype._onMouseDown=function($){"mouse"===this._lastPointerType&&X.prototype._onMouseDown.call(this,$)},t.prototype._onCaptureGestureTap=function(X){var $=this,Q=new ne.EditorMouseEvent(X,this.viewHelper.viewDomNode),J=this._createMouseTarget(Q,!1);J.position&&this.viewController.moveTo(J.position),Q.browserEvent.fromElement?(Q.preventDefault(),this.viewHelper.focusTextArea()):setTimeout((function(){$.viewHelper.focusTextArea()}))},t.prototype._onGestureChange=function(X){this._context.viewLayout.deltaScrollNow(-X.translationX,-X.translationY)},t.prototype.dispose=function(){window.clearTimeout(this._installGestureHandlerTimeout),X.prototype.dispose.call(this)},t}(ee.MouseHandler),re=function(X){function t($,ee,te){var ie=X.call(this,$,ee,te)||this;return J.Gesture.addTarget(ie.viewHelper.linesContentDomNode),ie._register(Q.addDisposableListener(ie.viewHelper.linesContentDomNode,J.EventType.Tap,(function(X){return ie.onTap(X)}))),ie._register(Q.addDisposableListener(ie.viewHelper.linesContentDomNode,J.EventType.Change,(function(X){return ie.onChange(X)}))),ie._register(Q.addDisposableListener(ie.viewHelper.linesContentDomNode,J.EventType.Contextmenu,(function(X){return ie._onContextMenu(new ne.EditorMouseEvent(X,ie.viewHelper.viewDomNode),!1)}))),ie}return te(t,X),t.prototype.dispose=function(){X.prototype.dispose.call(this)},t.prototype.onTap=function(X){X.preventDefault(),this.viewHelper.focusTextArea();var $=this._createMouseTarget(new ne.EditorMouseEvent(X,this.viewHelper.viewDomNode),!1);$.position&&this.viewController.moveTo($.position)},t.prototype.onChange=function(X){this._context.viewLayout.deltaScrollNow(-X.translationX,-X.translationY)},t}(ee.MouseHandler),se=function(){function e(X,$,Q){window.navigator.msPointerEnabled?this.handler=new ie(X,$,Q):window.TouchEvent?this.handler=new re(X,$,Q):window.navigator.pointerEnabled||window.PointerEvent?this.handler=new oe(X,$,Q):this.handler=new ee.MouseHandler(X,$,Q)}return e.prototype.getTargetAtClientPoint=function(X,$){return this.handler.getTargetAtClientPoint(X,$)},e.prototype.dispose=function(){this.handler.dispose()},e}();$.PointerHandler=se})),define(Q[490],n([0,1,2,185]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0});var ee=function(X){function t($){var Q=X.call(this)||this;return Q.onDidScroll=null,Q.onDidGainFocus=null,Q.onDidLoseFocus=null,Q.onKeyDown=null,Q.onKeyUp=null,Q.onContextMenu=null,Q.onMouseMove=null,Q.onMouseLeave=null,Q.onMouseUp=null,Q.onMouseDown=null,Q.onMouseDrag=null,Q.onMouseDrop=null,Q._viewModel=$,Q}return te(t,X),t.prototype.emitScrollChanged=function(X){this.onDidScroll&&this.onDidScroll(X)},t.prototype.emitViewFocusGained=function(){this.onDidGainFocus&&this.onDidGainFocus(void 0)},t.prototype.emitViewFocusLost=function(){this.onDidLoseFocus&&this.onDidLoseFocus(void 0)},t.prototype.emitKeyDown=function(X){this.onKeyDown&&this.onKeyDown(X)},t.prototype.emitKeyUp=function(X){this.onKeyUp&&this.onKeyUp(X)},t.prototype.emitContextMenu=function(X){this.onContextMenu&&this.onContextMenu(this._convertViewToModelMouseEvent(X))},t.prototype.emitMouseMove=function(X){this.onMouseMove&&this.onMouseMove(this._convertViewToModelMouseEvent(X))},t.prototype.emitMouseLeave=function(X){this.onMouseLeave&&this.onMouseLeave(this._convertViewToModelMouseEvent(X))},t.prototype.emitMouseUp=function(X){this.onMouseUp&&this.onMouseUp(this._convertViewToModelMouseEvent(X))},t.prototype.emitMouseDown=function(X){this.onMouseDown&&this.onMouseDown(this._convertViewToModelMouseEvent(X))},t.prototype.emitMouseDrag=function(X){this.onMouseDrag&&this.onMouseDrag(this._convertViewToModelMouseEvent(X))},t.prototype.emitMouseDrop=function(X){this.onMouseDrop&&this.onMouseDrop(this._convertViewToModelMouseEvent(X))},t.prototype._convertViewToModelMouseEvent=function(X){return X.target?{event:X.event,target:this._convertViewToModelMouseTarget(X.target)}:X},t.prototype._convertViewToModelMouseTarget=function(X){return new ne(X.element,X.type,X.mouseColumn,X.position?this._convertViewToModelPosition(X.position):null,X.range?this._convertViewToModelRange(X.range):null,X.detail)},t.prototype._convertViewToModelPosition=function(X){return this._viewModel.coordinatesConverter.convertViewPositionToModelPosition(X)},t.prototype._convertViewToModelRange=function(X){return this._viewModel.coordinatesConverter.convertViewRangeToModelRange(X)},t}(Q.Disposable);$.ViewOutgoingEvents=ee;var ne=function(){function e(X,$,Q,J,ee,te){this.element=X,this.type=$,this.mouseColumn=Q,this.position=J,this.range=ee,this.detail=te}return e.prototype.toString=function(){return J.MouseTarget.toString(this)},e}()})),define(Q[491],n([0,1,16,57,127,33,184,12,3,83,266]),(function(X,$,Q,J,ee,ne,ie,oe,re,se){Object.defineProperty($,"__esModule",{value:!0});var ae=function(){function e(){this._currentVisibleRange=new re.Range(1,1,1,1)}return e.prototype.getCurrentVisibleRange=function(){return this._currentVisibleRange},e.prototype.setCurrentVisibleRange=function(X){this._currentVisibleRange=X},e}(),h=function(X,$,Q,J,ee,te){this.lineNumber=X,this.startColumn=$,this.endColumn=Q,this.startScrollTop=J,this.stopScrollTop=ee,this.scrollType=te},le=function(X){function t($,te){var oe=X.call(this,$)||this;oe._linesContent=te,oe._textRangeRestingSpot=document.createElement("div"),oe._visibleLines=new ee.VisibleLinesCollection(oe),oe.domNode=oe._visibleLines.domNode;var re=oe._context.configuration;return oe._lineHeight=re.editor.lineHeight,oe._typicalHalfwidthCharacterWidth=re.editor.fontInfo.typicalHalfwidthCharacterWidth,oe._isViewportWrapping=re.editor.wrappingInfo.isViewportWrapping,oe._revealHorizontalRightPadding=re.editor.viewInfo.revealHorizontalRightPadding,oe._canUseLayerHinting=re.editor.canUseLayerHinting,oe._viewLineOptions=new ie.ViewLineOptions(re,oe._context.theme.type),ne.PartFingerprints.write(oe.domNode,7),oe.domNode.setClassName("view-lines"),J.Configuration.applyFontInfo(oe.domNode,re.editor.fontInfo),oe._maxLineWidth=0,oe._asyncUpdateLineWidths=new Q.RunOnceScheduler((function(){oe._updateLineWidthsSlow()}),200),oe._lastRenderedData=new ae,oe._horizontalRevealRequest=null,oe}return te(t,X),t.prototype.dispose=function(){this._asyncUpdateLineWidths.dispose(),X.prototype.dispose.call(this)},t.prototype.getDomNode=function(){return this.domNode},t.prototype.createVisibleLine=function(){return new ie.ViewLine(this._viewLineOptions)},t.prototype.onConfigurationChanged=function(X){this._visibleLines.onConfigurationChanged(X),X.wrappingInfo&&(this._maxLineWidth=0);var $=this._context.configuration;return X.lineHeight&&(this._lineHeight=$.editor.lineHeight),X.fontInfo&&(this._typicalHalfwidthCharacterWidth=$.editor.fontInfo.typicalHalfwidthCharacterWidth),X.wrappingInfo&&(this._isViewportWrapping=$.editor.wrappingInfo.isViewportWrapping),X.viewInfo&&(this._revealHorizontalRightPadding=$.editor.viewInfo.revealHorizontalRightPadding),X.canUseLayerHinting&&(this._canUseLayerHinting=$.editor.canUseLayerHinting),X.fontInfo&&J.Configuration.applyFontInfo(this.domNode,$.editor.fontInfo),this._onOptionsMaybeChanged(),X.layoutInfo&&(this._maxLineWidth=0),!0},t.prototype._onOptionsMaybeChanged=function(){var X=this._context.configuration,$=new ie.ViewLineOptions(X,this._context.theme.type);if(!this._viewLineOptions.equals($)){this._viewLineOptions=$;for(var Q=this._visibleLines.getStartLineNumber(),J=this._visibleLines.getEndLineNumber(),ee=Q;ee<=J;ee++)this._visibleLines.getVisibleLine(ee).onOptionsChanged(this._viewLineOptions);return!0}return!1},t.prototype.onCursorStateChanged=function(X){for(var $=this._visibleLines.getStartLineNumber(),Q=this._visibleLines.getEndLineNumber(),J=!1,ee=$;ee<=Q;ee++)J=this._visibleLines.getVisibleLine(ee).onSelectionChanged()||J;return J},t.prototype.onDecorationsChanged=function(X){for(var $=this._visibleLines.getStartLineNumber(),Q=this._visibleLines.getEndLineNumber(),J=$;J<=Q;J++)this._visibleLines.getVisibleLine(J).onDecorationsChanged();return!0},t.prototype.onFlushed=function(X){var $=this._visibleLines.onFlushed(X);return this._maxLineWidth=0,$},t.prototype.onLinesChanged=function(X){return this._visibleLines.onLinesChanged(X)},t.prototype.onLinesDeleted=function(X){return this._visibleLines.onLinesDeleted(X)},t.prototype.onLinesInserted=function(X){return this._visibleLines.onLinesInserted(X)},t.prototype.onRevealRangeRequest=function(X){var $=this._computeScrollTopToRevealRange(this._context.viewLayout.getFutureViewport(),X.range,X.verticalType),Q=this._context.viewLayout.validateScrollPosition({scrollTop:$});X.revealHorizontal?X.range.startLineNumber!==X.range.endLineNumber?Q={scrollTop:Q.scrollTop,scrollLeft:0}:this._horizontalRevealRequest=new h(X.range.startLineNumber,X.range.startColumn,X.range.endColumn,this._context.viewLayout.getCurrentScrollTop(),Q.scrollTop,X.scrollType):this._horizontalRevealRequest=null;var J=Math.abs(this._context.viewLayout.getCurrentScrollTop()-Q.scrollTop);return 0===X.scrollType&&J>this._lineHeight?this._context.viewLayout.setScrollPositionSmooth(Q):this._context.viewLayout.setScrollPositionNow(Q),!0},t.prototype.onScrollChanged=function(X){if(this._horizontalRevealRequest&&X.scrollLeftChanged&&(this._horizontalRevealRequest=null),this._horizontalRevealRequest&&X.scrollTopChanged){var $=Math.min(this._horizontalRevealRequest.startScrollTop,this._horizontalRevealRequest.stopScrollTop),Q=Math.max(this._horizontalRevealRequest.startScrollTop,this._horizontalRevealRequest.stopScrollTop);(X.scrollTop<$||X.scrollTop>Q)&&(this._horizontalRevealRequest=null)}return this.domNode.setWidth(X.scrollWidth),this._visibleLines.onScrollChanged(X)||!0},t.prototype.onTokensChanged=function(X){return this._visibleLines.onTokensChanged(X)},t.prototype.onZonesChanged=function(X){return this._context.viewLayout.onMaxLineWidthChanged(this._maxLineWidth),this._visibleLines.onZonesChanged(X)},t.prototype.onThemeChanged=function(X){return this._onOptionsMaybeChanged()},t.prototype.getPositionFromDOMInfo=function(X,$){var Q=this._getViewLineDomNode(X);if(null===Q)return null;var J=this._getLineNumberFor(Q);if(-1===J)return null;if(J<1||J>this._context.model.getLineCount())return null;if(1===this._context.model.getLineMaxColumn(J))return new oe.Position(J,1);var ee=this._visibleLines.getStartLineNumber(),te=this._visibleLines.getEndLineNumber();if(J<ee||J>te)return null;var ne=this._visibleLines.getVisibleLine(J).getColumnOfNodeOffset(J,X,$),ie=this._context.model.getLineMinColumn(J);return ne<ie&&(ne=ie),new oe.Position(J,ne)},t.prototype._getViewLineDomNode=function(X){for(;X&&1===X.nodeType;){if(X.className===ie.ViewLine.CLASS_NAME)return X;X=X.parentElement}return null},t.prototype._getLineNumberFor=function(X){for(var $=this._visibleLines.getStartLineNumber(),Q=this._visibleLines.getEndLineNumber(),J=$;J<=Q;J++)if(X===this._visibleLines.getVisibleLine(J).getDomNode())return J;return-1},t.prototype.getLineWidth=function(X){var $=this._visibleLines.getStartLineNumber(),Q=this._visibleLines.getEndLineNumber();return X<$||X>Q?-1:this._visibleLines.getVisibleLine(X).getWidth()},t.prototype.linesVisibleRangesForRange=function(X,$){if(this.shouldRender())return null;var Q=X.endLineNumber,J=re.Range.intersectRanges(X,this._lastRenderedData.getCurrentVisibleRange());if(!J)return null;var ee=[],te=0,ne=new ie.DomReadingContext(this.domNode.domNode,this._textRangeRestingSpot),ae=0;$&&(ae=this._context.model.coordinatesConverter.convertViewPositionToModelPosition(new oe.Position(J.startLineNumber,1)).lineNumber);for(var le=this._visibleLines.getStartLineNumber(),ue=this._visibleLines.getEndLineNumber(),de=J.startLineNumber;de<=J.endLineNumber;de++)if(!(de<le||de>ue)){var ce=de===J.startLineNumber?J.startColumn:1,he=de===J.endLineNumber?J.endColumn:this._context.model.getLineMaxColumn(de),pe=this._visibleLines.getVisibleLine(de).getVisibleRangesForRange(ce,he,ne);pe&&0!==pe.length&&($&&de<Q&&ae!==(ae=this._context.model.coordinatesConverter.convertViewPositionToModelPosition(new oe.Position(de+1,1)).lineNumber)&&(pe[pe.length-1].width+=this._typicalHalfwidthCharacterWidth),ee[te++]=new se.LineVisibleRanges(de,pe))}return 0===te?null:ee},t.prototype.visibleRangesForRange2=function(X){if(this.shouldRender())return null;var $=re.Range.intersectRanges(X,this._lastRenderedData.getCurrentVisibleRange());if(!$)return null;for(var Q=[],J=new ie.DomReadingContext(this.domNode.domNode,this._textRangeRestingSpot),ee=this._visibleLines.getStartLineNumber(),te=this._visibleLines.getEndLineNumber(),ne=$.startLineNumber;ne<=$.endLineNumber;ne++)if(!(ne<ee||ne>te)){var oe=ne===$.startLineNumber?$.startColumn:1,se=ne===$.endLineNumber?$.endColumn:this._context.model.getLineMaxColumn(ne),ae=this._visibleLines.getVisibleLine(ne).getVisibleRangesForRange(oe,se,J);ae&&0!==ae.length&&(Q=Q.concat(ae))}return 0===Q.length?null:Q},t.prototype.visibleRangeForPosition=function(X){var $=this.visibleRangesForRange2(new re.Range(X.lineNumber,X.column,X.lineNumber,X.column));return $?$[0]:null},t.prototype.updateLineWidths=function(){this._updateLineWidths(!1)},t.prototype._updateLineWidthsFast=function(){return this._updateLineWidths(!0)},t.prototype._updateLineWidthsSlow=function(){this._updateLineWidths(!1)},t.prototype._updateLineWidths=function(X){for(var $=this._visibleLines.getStartLineNumber(),Q=this._visibleLines.getEndLineNumber(),J=1,ee=!0,te=$;te<=Q;te++){var ne=this._visibleLines.getVisibleLine(te);!X||ne.getWidthIsFast()?J=Math.max(J,ne.getWidth()):ee=!1}return ee&&1===$&&Q===this._context.model.getLineCount()&&(this._maxLineWidth=0),this._ensureMaxLineWidth(J),ee},t.prototype.prepareRender=function(){throw new Error("Not supported")},t.prototype.render=function(){throw new Error("Not supported")},t.prototype.renderText=function(X){if(this._visibleLines.renderLines(X),this._lastRenderedData.setCurrentVisibleRange(X.visibleRange),this.domNode.setWidth(this._context.viewLayout.getScrollWidth()),this.domNode.setHeight(Math.min(this._context.viewLayout.getScrollHeight(),1e6)),this._horizontalRevealRequest){var $=this._horizontalRevealRequest.lineNumber,Q=this._horizontalRevealRequest.startColumn,J=this._horizontalRevealRequest.endColumn,ee=this._horizontalRevealRequest.scrollType;if(X.startLineNumber<=$&&$<=X.endLineNumber){this._horizontalRevealRequest=null,this.onDidRender();var te=this._computeScrollLeftToRevealRange($,Q,J);this._isViewportWrapping||this._ensureMaxLineWidth(te.maxHorizontalOffset),0===ee?this._context.viewLayout.setScrollPositionSmooth({scrollLeft:te.scrollLeft}):this._context.viewLayout.setScrollPositionNow({scrollLeft:te.scrollLeft})}}this._updateLineWidthsFast()||this._asyncUpdateLineWidths.schedule(),this._linesContent.setLayerHinting(this._canUseLayerHinting);var ne=this._context.viewLayout.getCurrentScrollTop()-X.bigNumbersDelta;this._linesContent.setTop(-ne),this._linesContent.setLeft(-this._context.viewLayout.getCurrentScrollLeft())},t.prototype._ensureMaxLineWidth=function(X){var $=Math.ceil(X);this._maxLineWidth<$&&(this._maxLineWidth=$,this._context.viewLayout.onMaxLineWidthChanged(this._maxLineWidth))},t.prototype._computeScrollTopToRevealRange=function(X,$,Q){var J,ee,te,ne=X.top,ie=X.height,oe=ne+ie;if(J=this._context.viewLayout.getVerticalOffsetForLineNumber($.startLineNumber),ee=this._context.viewLayout.getVerticalOffsetForLineNumber($.endLineNumber)+this._lineHeight,0!==Q&&4!==Q||(ee+=this._lineHeight),1===Q||2===Q)if(2===Q&&ne<=J&&ee<=oe)te=ne;else{var re=(J+ee)/2;te=Math.max(0,re-ie/2)}else te=this._computeMinimumScrolling(ne,oe,J,ee,3===Q,4===Q);return te},t.prototype._computeScrollLeftToRevealRange=function(X,$,Q){var J=0,ee=this._context.viewLayout.getCurrentViewport(),te=ee.left,ne=te+ee.width,ie=this.visibleRangesForRange2(new re.Range(X,$,X,Q)),oe=Number.MAX_VALUE,se=0;if(!ie)return{scrollLeft:te,maxHorizontalOffset:J};for(var ae=0;ae<ie.length;ae++){var le=ie[ae];le.left<oe&&(oe=le.left),le.left+le.width>se&&(se=le.left+le.width)}return J=se,oe=Math.max(0,oe-t.HORIZONTAL_EXTRA_PX),se+=this._revealHorizontalRightPadding,{scrollLeft:this._computeMinimumScrolling(te,ne,oe,se),maxHorizontalOffset:J}},t.prototype._computeMinimumScrolling=function(X,$,Q,J,ee,te){ee=!!ee,te=!!te;var ne=($|=0)-(X|=0);return(J|=0)-(Q|=0)<ne?ee?Q:te?Math.max(0,J-ne):Q<X?Q:J>$?Math.max(0,J-ne):X:Q},t.HORIZONTAL_EXTRA_PX=30,t}(ne.ViewPart);$.ViewLines=le})),define(Q[492],n([0,1,7,23,73,17,8,127,33,3,107,387,69,20,13,272]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le,ue,de,ce){function m(X){return 2===X?4:4===X?6:1===X?2:3}function v(X){return 2===X||4===X?2:1}Object.defineProperty($,"__esModule",{value:!0});var he=function(){function e(X){var $=X.editor.pixelRatio,Q=X.editor.layoutInfo,J=X.editor.viewInfo,ee=X.editor.fontInfo;this.renderMinimap=0|Q.renderMinimap,this.scrollBeyondLastLine=J.scrollBeyondLastLine,this.showSlider=J.minimap.showSlider,this.pixelRatio=$,this.typicalHalfwidthCharacterWidth=ee.typicalHalfwidthCharacterWidth,this.lineHeight=X.editor.lineHeight,this.minimapLeft=Q.minimapLeft,this.minimapWidth=Q.minimapWidth,this.minimapHeight=Q.height,this.canvasInnerWidth=Math.max(1,Math.floor($*this.minimapWidth)),this.canvasInnerHeight=Math.max(1,Math.floor($*this.minimapHeight)),this.canvasOuterWidth=this.canvasInnerWidth/$,this.canvasOuterHeight=this.canvasInnerHeight/$}return e.prototype.equals=function(X){return this.renderMinimap===X.renderMinimap&&this.scrollBeyondLastLine===X.scrollBeyondLastLine&&this.showSlider===X.showSlider&&this.pixelRatio===X.pixelRatio&&this.typicalHalfwidthCharacterWidth===X.typicalHalfwidthCharacterWidth&&this.lineHeight===X.lineHeight&&this.minimapLeft===X.minimapLeft&&this.minimapWidth===X.minimapWidth&&this.minimapHeight===X.minimapHeight&&this.canvasInnerWidth===X.canvasInnerWidth&&this.canvasInnerHeight===X.canvasInnerHeight&&this.canvasOuterWidth===X.canvasOuterWidth&&this.canvasOuterHeight===X.canvasOuterHeight},e}(),pe=function(){function e(X,$,Q,J,ee,te,ne){this.scrollTop=X,this.scrollHeight=$,this._computedSliderRatio=Q,this.sliderTop=J,this.sliderHeight=ee,this.startLineNumber=te,this.endLineNumber=ne}return e.prototype.getDesiredScrollTopFromDelta=function(X){var $=this.sliderTop+X;return Math.round($/this._computedSliderRatio)},e.create=function(X,$,Q,J,ee,te,ne,ie,oe){var re,se,ae=X.pixelRatio,le=m(X.renderMinimap),ue=Math.floor(X.canvasInnerHeight/le),de=X.lineHeight;if(ee&&Q!==te){var ce=Q-$+1;re=Math.floor(ce*le/ae)}else{var he=J/de;re=Math.floor(he*le/ae)}se=X.scrollBeyondLastLine?(te-1)*le/ae:Math.max(0,te*le/ae-re);var pe=(se=Math.min(X.minimapHeight-re,se))/(ie-J),fe=ne*pe;if(ue>=te)return new e(ne,ie,pe,fe,re,ge=1,me=te);var ge=Math.max(1,Math.floor($-fe*ae/le));oe&&oe.scrollHeight===ie&&(oe.scrollTop>ne&&(ge=Math.min(ge,oe.startLineNumber)),oe.scrollTop<ne&&(ge=Math.max(ge,oe.startLineNumber)));var me=Math.min(te,ge+ue-1);return new e(ne,ie,pe,fe,re,ge,me)},e}(),fe=function(){function e(X){this.dy=X}return e.prototype.onContentChanged=function(){this.dy=-1},e.prototype.onTokensChanged=function(){this.dy=-1},e.INVALID=new e(-1),e}(),ge=function(){function e(X,$,Q){this.renderedLayout=X,this._imageData=$,this._renderedLines=new oe.RenderedLinesCollection((function(){return fe.INVALID})),this._renderedLines._set(X.startLineNumber,Q)}return e.prototype.linesEquals=function(X){if(this.renderedLayout.startLineNumber!==X.startLineNumber)return!1;if(this.renderedLayout.endLineNumber!==X.endLineNumber)return!1;for(var $=this._renderedLines._get().lines,Q=0,J=$.length;Q<J;Q++)if(-1===$[Q].dy)return!1;return!0},e.prototype._get=function(){var X=this._renderedLines._get();return{imageData:this._imageData,rendLineNumberStart:X.rendLineNumberStart,lines:X.lines}},e.prototype.onLinesChanged=function(X){return this._renderedLines.onLinesChanged(X.fromLineNumber,X.toLineNumber)},e.prototype.onLinesDeleted=function(X){this._renderedLines.onLinesDeleted(X.fromLineNumber,X.toLineNumber)},e.prototype.onLinesInserted=function(X){this._renderedLines.onLinesInserted(X.fromLineNumber,X.toLineNumber)},e.prototype.onTokensChanged=function(X){return this._renderedLines.onTokensChanged(X.ranges)},e}(),me=function(){function e(X,$,Q,J){this._backgroundFillData=e._createBackgroundFillData($,Q,J),this._buffers=[X.createImageData($,Q),X.createImageData($,Q)],this._lastUsedBuffer=0}return e.prototype.getBuffer=function(){this._lastUsedBuffer=1-this._lastUsedBuffer;var X=this._buffers[this._lastUsedBuffer];return X.data.set(this._backgroundFillData),X},e._createBackgroundFillData=function(X,$,Q){for(var J=Q.r,ee=Q.g,te=Q.b,ne=new Uint8ClampedArray(X*$*4),ie=0,oe=0;oe<$;oe++)for(var re=0;re<X;re++)ne[ie]=J,ne[ie+1]=ee,ne[ie+2]=te,ne[ie+3]=255,ie+=4;return ne},e}(),ve=function(X){function t($){var te=X.call(this,$)||this;return te._options=new he(te._context.configuration),te._lastRenderData=null,te._buffers=null,te._domNode=J.createFastDomNode(document.createElement("div")),re.PartFingerprints.write(te._domNode,8),te._domNode.setClassName(te._getMinimapDomNodeClassName()),te._domNode.setPosition("absolute"),te._domNode.setAttribute("role","presentation"),te._domNode.setAttribute("aria-hidden","true"),te._shadow=J.createFastDomNode(document.createElement("div")),te._shadow.setClassName("minimap-shadow-hidden"),te._domNode.appendChild(te._shadow),te._canvas=J.createFastDomNode(document.createElement("canvas")),te._canvas.setPosition("absolute"),te._canvas.setLeft(0),te._domNode.appendChild(te._canvas),te._slider=J.createFastDomNode(document.createElement("div")),te._slider.setPosition("absolute"),te._slider.setClassName("minimap-slider"),te._slider.setLayerHinting(!0),te._domNode.appendChild(te._slider),te._sliderHorizontal=J.createFastDomNode(document.createElement("div")),te._sliderHorizontal.setPosition("absolute"),te._sliderHorizontal.setClassName("minimap-slider-horizontal"),te._slider.appendChild(te._sliderHorizontal),te._tokensColorTracker=ae.MinimapTokensColorTracker.getInstance(),te._applyLayout(),te._mouseDownListener=Q.addStandardDisposableListener(te._canvas.domNode,"mousedown",(function(X){X.preventDefault();var $=te._options.renderMinimap;if(0!==$&&te._lastRenderData){var Q=m($),J=te._options.pixelRatio*X.browserEvent.offsetY,ee=Math.floor(J/Q)+te._lastRenderData.renderedLayout.startLineNumber;ee=Math.min(ee,te._context.model.getLineCount()),te._context.privateViewEventBus.emit(new ue.ViewRevealRangeRequestEvent(new se.Range(ee,1,ee,1),1,!1,0))}})),te._sliderMouseMoveMonitor=new ee.GlobalMouseMoveMonitor,te._sliderMouseDownListener=Q.addStandardDisposableListener(te._slider.domNode,"mousedown",(function(X){if(X.preventDefault(),X.leftButton&&te._lastRenderData){var $=X.posy,Q=X.posx,J=te._lastRenderData.renderedLayout;te._slider.toggleClassName("active",!0),te._sliderMouseMoveMonitor.startMonitoring(ee.standardMouseMoveMerger,(function(X){var ee=Math.abs(X.posx-Q);if(ne.isWindows&&ee>140)te._context.viewLayout.setScrollPositionNow({scrollTop:J.scrollTop});else{var ie=X.posy-$;te._context.viewLayout.setScrollPositionNow({scrollTop:J.getDesiredScrollTopFromDelta(ie)})}}),(function(){te._slider.toggleClassName("active",!1)}))}})),te}return te(t,X),t.prototype.dispose=function(){this._mouseDownListener.dispose(),this._sliderMouseMoveMonitor.dispose(),this._sliderMouseDownListener.dispose(),X.prototype.dispose.call(this)},t.prototype._getMinimapDomNodeClassName=function(){return"always"===this._options.showSlider?"minimap slider-always":"minimap slider-mouseover"},t.prototype.getDomNode=function(){return this._domNode},t.prototype._applyLayout=function(){this._domNode.setLeft(this._options.minimapLeft),this._domNode.setWidth(this._options.minimapWidth),this._domNode.setHeight(this._options.minimapHeight),this._shadow.setHeight(this._options.minimapHeight),this._canvas.setWidth(this._options.canvasOuterWidth),this._canvas.setHeight(this._options.canvasOuterHeight),this._canvas.domNode.width=this._options.canvasInnerWidth,this._canvas.domNode.height=this._options.canvasInnerHeight,this._slider.setWidth(this._options.minimapWidth)},t.prototype._getBuffer=function(){return this._buffers||(this._buffers=new me(this._canvas.domNode.getContext("2d"),this._options.canvasInnerWidth,this._options.canvasInnerHeight,this._tokensColorTracker.getColor(2))),this._buffers.getBuffer()},t.prototype._onOptionsMaybeChanged=function(){var X=new he(this._context.configuration);return!this._options.equals(X)&&(this._options=X,this._lastRenderData=null,this._buffers=null,this._applyLayout(),this._domNode.setClassName(this._getMinimapDomNodeClassName()),!0)},t.prototype.onConfigurationChanged=function(X){return this._onOptionsMaybeChanged()},t.prototype.onFlushed=function(X){return this._lastRenderData=null,!0},t.prototype.onLinesChanged=function(X){return!!this._lastRenderData&&this._lastRenderData.onLinesChanged(X)},t.prototype.onLinesDeleted=function(X){return this._lastRenderData&&this._lastRenderData.onLinesDeleted(X),!0},t.prototype.onLinesInserted=function(X){return this._lastRenderData&&this._lastRenderData.onLinesInserted(X),!0},t.prototype.onScrollChanged=function(X){return!0},t.prototype.onTokensChanged=function(X){return!!this._lastRenderData&&this._lastRenderData.onTokensChanged(X)},t.prototype.onTokensColorsChanged=function(X){return this._lastRenderData=null,this._buffers=null,!0},t.prototype.onZonesChanged=function(X){return this._lastRenderData=null,!0},t.prototype.prepareRender=function(X){},t.prototype.render=function(X){if(0===this._options.renderMinimap)return this._shadow.setClassName("minimap-shadow-hidden"),this._sliderHorizontal.setWidth(0),void this._sliderHorizontal.setHeight(0);X.scrollLeft+X.viewportWidth>=X.scrollWidth?this._shadow.setClassName("minimap-shadow-hidden"):this._shadow.setClassName("minimap-shadow-visible");var $=pe.create(this._options,X.visibleRange.startLineNumber,X.visibleRange.endLineNumber,X.viewportHeight,X.viewportData.whitespaceViewportData.length>0,this._context.model.getLineCount(),X.scrollTop,X.scrollHeight,this._lastRenderData?this._lastRenderData.renderedLayout:null);this._slider.setTop($.sliderTop),this._slider.setHeight($.sliderHeight);var Q=X.scrollLeft/this._options.typicalHalfwidthCharacterWidth,J=Math.min(this._options.minimapWidth,Math.round(Q*v(this._options.renderMinimap)/this._options.pixelRatio));this._sliderHorizontal.setLeft(J),this._sliderHorizontal.setWidth(this._options.minimapWidth-J),this._sliderHorizontal.setTop(0),this._sliderHorizontal.setHeight($.sliderHeight),this._lastRenderData=this.renderLines($)},t.prototype.renderLines=function(X){var $=this._options.renderMinimap,Q=X.startLineNumber,J=X.endLineNumber,ee=m($);if(this._lastRenderData&&this._lastRenderData.linesEquals(X)){var te=this._lastRenderData._get();return new ge(X,te.imageData,te.lines)}for(var ne=this._getBuffer(),ie=t._renderUntouchedLines(ne,Q,J,ee,this._lastRenderData),oe=ie[0],re=ie[1],se=ie[2],ae=this._context.model.getMinimapLinesRenderingData(Q,J,se),ue=ae.tabSize,de=this._tokensColorTracker.getColor(2),ce=this._tokensColorTracker.backgroundIsLight(),he=0,pe=[],me=0,ve=J-Q+1;me<ve;me++)se[me]&&t._renderLine(ne,de,ce,$,this._tokensColorTracker,le.getOrCreateMinimapCharRenderer(),he,ue,ae.data[me]),pe[me]=new fe(he),he+=ee;var _e=-1===oe?0:oe,ye=(-1===re?ne.height:re)-_e;return this._canvas.domNode.getContext("2d").putImageData(ne,0,0,0,_e,ne.width,ye),new ge(X,ne,pe)},t._renderUntouchedLines=function(X,$,Q,J,ee){var te=[];if(!ee){for(var ne=0,ie=Q-$+1;ne<ie;ne++)te[ne]=!0;return[-1,-1,te]}for(var oe=ee._get(),re=oe.imageData.data,se=oe.rendLineNumberStart,ae=oe.lines,le=ae.length,ue=X.width,de=X.data,ce=(Q-$+1)*J*ue*4,he=-1,pe=-1,fe=-1,ge=-1,me=-1,ve=-1,_e=0,ye=$;ye<=Q;ye++){var be=ye-$,Ce=ye-se,we=Ce>=0&&Ce<le?ae[Ce].dy:-1;if(-1!==we){var Se=we*ue*4,Ee=(we+J)*ue*4,Le=_e*ue*4,xe=(_e+J)*ue*4;ge===Se&&ve===Le?(ge=Ee,ve=xe):(-1!==fe&&(de.set(re.subarray(fe,ge),me),-1===he&&0===fe&&fe===me&&(he=ge),-1===pe&&ge===ce&&fe===me&&(pe=fe)),fe=Se,ge=Ee,me=Le,ve=xe),te[be]=!1,_e+=J}else te[be]=!0,_e+=J}return-1!==fe&&(de.set(re.subarray(fe,ge),me),-1===he&&0===fe&&fe===me&&(he=ge),-1===pe&&ge===ce&&fe===me&&(pe=fe)),[-1===he?-1:he/(4*ue),-1===pe?-1:pe/(4*ue),te]},t._renderLine=function(X,$,Q,J,ee,te,ne,oe,re){for(var se=re.content,ae=re.tokens,le=v(J),ue=X.width-le,de=0,ce=0,he=0,pe=0,fe=ae.getCount();pe<fe;pe++)for(var ge=ae.getEndOffset(pe),me=ae.getForeground(pe),ve=ee.getColor(me);ce<ge;ce++){if(de>ue)return;var _e=se.charCodeAt(ce);if(9===_e){var ye=oe-(ce+he)%oe;he+=ye-1,de+=ye*le}else if(32===_e)de+=le;else for(var be=ie.isFullWidthCharacter(_e)?2:1,Ce=0;Ce<be;Ce++)if(2===J?te.x2RenderChar(X,de,ne,_e,ve,$,Q):1===J?te.x1RenderChar(X,de,ne,_e,ve,$,Q):4===J?te.x2BlockRenderChar(X,de,ne,ve,$,Q):te.x1BlockRenderChar(X,de,ne,ve,$,Q),(de+=le)>ue)return}},t}(re.ViewPart);$.Minimap=ve,ce.registerThemingParticipant((function(X,$){var Q=X.getColor(de.scrollbarSliderBackground);if(Q){var J=Q.transparent(.5);$.addRule(".monaco-editor .minimap-slider, .monaco-editor .minimap-slider .minimap-slider-horizontal { background: "+J+"; }")}var ee=X.getColor(de.scrollbarSliderHoverBackground);if(ee){var te=ee.transparent(.5);$.addRule(".monaco-editor .minimap-slider:hover, .monaco-editor .minimap-slider:hover .minimap-slider-horizontal { background: "+te+"; }")}var ne=X.getColor(de.scrollbarSliderActiveBackground);if(ne){var ie=ne.transparent(.5);$.addRule(".monaco-editor .minimap-slider.active, .monaco-editor .minimap-slider.active .minimap-slider-horizontal { background: "+ie+"; }")}var oe=X.getColor(de.scrollbarShadow);oe&&$.addRule(".monaco-editor .minimap-shadow-visible { box-shadow: "+oe+" -6px 0 6px -6px inset; }")}))})),define(Q[493],n([0,1,23,33,20,13,284]),(function(X,$,Q,J,ee,ne){Object.defineProperty($,"__esModule",{value:!0});var ie=function(X){function t($){var J=X.call(this,$)||this;return J._scrollTop=0,J._width=0,J._updateWidth(),J._shouldShow=!1,J._useShadows=J._context.configuration.editor.viewInfo.scrollbar.useShadows,J._domNode=Q.createFastDomNode(document.createElement("div")),J._domNode.setAttribute("role","presentation"),J._domNode.setAttribute("aria-hidden","true"),J}return te(t,X),t.prototype.dispose=function(){X.prototype.dispose.call(this)},t.prototype._updateShouldShow=function(){var X=this._useShadows&&this._scrollTop>0;return this._shouldShow!==X&&(this._shouldShow=X,!0)},t.prototype.getDomNode=function(){return this._domNode},t.prototype._updateWidth=function(){var X,$=this._context.configuration.editor.layoutInfo;return X=0===$.renderMinimap||$.minimapWidth>0&&0===$.minimapLeft?$.width:$.width-$.minimapWidth-$.verticalScrollbarWidth,this._width!==X&&(this._width=X,!0)},t.prototype.onConfigurationChanged=function(X){var $=!1;return X.viewInfo&&(this._useShadows=this._context.configuration.editor.viewInfo.scrollbar.useShadows),X.layoutInfo&&($=this._updateWidth()),this._updateShouldShow()||$},t.prototype.onScrollChanged=function(X){return this._scrollTop=X.scrollTop,this._updateShouldShow()},t.prototype.prepareRender=function(X){},t.prototype.render=function(X){this._domNode.setWidth(this._width),this._domNode.setClassName(this._shouldShow?"scroll-decoration":"")},t}(J.ViewPart);$.ScrollDecorationViewPart=ie,ne.registerThemingParticipant((function(X,$){var Q=X.getColor(ee.scrollbarShadow);Q&&$.addRule(".monaco-editor .scroll-decoration { box-shadow: "+Q+" 0 6px 6px -6px inset; }")}))})),define(Q[494],n([0,1,29,61,20,13,286]),(function(X,$,Q,J,ee,ne){function a(X){return new d(X)}function l(X){return new c(X.lineNumber,X.ranges.map(a))}function u(X){return X<0?-X:X}Object.defineProperty($,"__esModule",{value:!0});var d=function(X){this.left=X.left,this.width=X.width,this.startStyle=null,this.endStyle=null},c=function(X,$){this.lineNumber=X,this.ranges=$},ie=Q.isEdgeOrIE,oe=function(X){function t($){var Q=X.call(this)||this;return Q._previousFrameVisibleRangesWithStyle=[],Q._context=$,Q._lineHeight=Q._context.configuration.editor.lineHeight,Q._roundedSelection=Q._context.configuration.editor.viewInfo.roundedSelection,Q._typicalHalfwidthCharacterWidth=Q._context.configuration.editor.fontInfo.typicalHalfwidthCharacterWidth,Q._selections=[],Q._renderResult=null,Q._context.addEventHandler(Q),Q}return te(t,X),t.prototype.dispose=function(){this._context.removeEventHandler(this),this._renderResult=null,X.prototype.dispose.call(this)},t.prototype.onConfigurationChanged=function(X){return X.lineHeight&&(this._lineHeight=this._context.configuration.editor.lineHeight),X.viewInfo&&(this._roundedSelection=this._context.configuration.editor.viewInfo.roundedSelection),X.fontInfo&&(this._typicalHalfwidthCharacterWidth=this._context.configuration.editor.fontInfo.typicalHalfwidthCharacterWidth),!0},t.prototype.onCursorStateChanged=function(X){return this._selections=X.selections.slice(0),!0},t.prototype.onDecorationsChanged=function(X){return!0},t.prototype.onFlushed=function(X){return!0},t.prototype.onLinesChanged=function(X){return!0},t.prototype.onLinesDeleted=function(X){return!0},t.prototype.onLinesInserted=function(X){return!0},t.prototype.onScrollChanged=function(X){return X.scrollTopChanged},t.prototype.onZonesChanged=function(X){return!0},t.prototype._visibleRangesHaveGaps=function(X){for(var $=0,Q=X.length;$<Q;$++)if(X[$].ranges.length>1)return!0;return!1},t.prototype._enrichVisibleRangesWithStyle=function(X,$,Q){var J=this._typicalHalfwidthCharacterWidth/4,ee=null,te=null;if(Q&&Q.length>0&&$.length>0){var ne=$[0].lineNumber;if(ne===X.startLineNumber)for(oe=0;!ee&&oe<Q.length;oe++)Q[oe].lineNumber===ne&&(ee=Q[oe].ranges[0]);var ie=$[$.length-1].lineNumber;if(ie===X.endLineNumber)for(oe=Q.length-1;!te&&oe>=0;oe--)Q[oe].lineNumber===ie&&(te=Q[oe].ranges[0]);ee&&!ee.startStyle&&(ee=null),te&&!te.startStyle&&(te=null)}for(var oe=0,re=$.length;oe<re;oe++){var se=$[oe].ranges[0],ae=se.left,le=se.left+se.width,ue={top:0,bottom:0},de={top:0,bottom:0};if(oe>0){var ce=$[oe-1].ranges[0].left,he=$[oe-1].ranges[0].left+$[oe-1].ranges[0].width;u(ae-ce)<J?ue.top=2:ae>ce&&(ue.top=1),u(le-he)<J?de.top=2:ce<le&&le<he&&(de.top=1)}else ee&&(ue.top=ee.startStyle.top,de.top=ee.endStyle.top);if(oe+1<re){var pe=$[oe+1].ranges[0].left,fe=$[oe+1].ranges[0].left+$[oe+1].ranges[0].width;u(ae-pe)<J?ue.bottom=2:pe<ae&&ae<fe&&(ue.bottom=1),u(le-fe)<J?de.bottom=2:le<fe&&(de.bottom=1)}else te&&(ue.bottom=te.startStyle.bottom,de.bottom=te.endStyle.bottom);se.startStyle=ue,se.endStyle=de}},t.prototype._getVisibleRangesWithStyle=function(X,$,Q){var J=($.linesVisibleRangesForRange(X,!0)||[]).map(l),ee=this._visibleRangesHaveGaps(J);return ie||ee||!this._roundedSelection||this._enrichVisibleRangesWithStyle($.visibleRange,J,Q),J},t.prototype._createSelectionPiece=function(X,$,Q,J,ee){return'<div class="cslr '+Q+'" style="top:'+X.toString()+"px;left:"+J.toString()+"px;width:"+ee.toString()+"px;height:"+$+'px;"></div>'},t.prototype._actualRenderOneSelection=function(X,$,Q,J){for(var ee=J.length>0&&J[0].ranges[0].startStyle,te=this._lineHeight.toString(),ne=(this._lineHeight-1).toString(),ie=J.length>0?J[0].lineNumber:0,oe=J.length>0?J[J.length-1].lineNumber:0,re=0,se=J.length;re<se;re++){for(var ae=J[re],le=ae.lineNumber,ue=le-$,de=!Q||le!==oe&&le!==ie?te:ne,ce=Q&&le===ie?1:0,he="",pe=0,fe=ae.ranges.length;pe<fe;pe++){var ge=ae.ranges[pe];if(ee){var me=ge.startStyle,ve=ge.endStyle;if(1===me.top||1===me.bottom){he+=this._createSelectionPiece(ce,de,t.SELECTION_CLASS_NAME,ge.left-t.ROUNDED_PIECE_WIDTH,t.ROUNDED_PIECE_WIDTH);var _e=t.EDITOR_BACKGROUND_CLASS_NAME;1===me.top&&(_e+=" "+t.SELECTION_TOP_RIGHT),1===me.bottom&&(_e+=" "+t.SELECTION_BOTTOM_RIGHT),he+=this._createSelectionPiece(ce,de,_e,ge.left-t.ROUNDED_PIECE_WIDTH,t.ROUNDED_PIECE_WIDTH)}if(1===ve.top||1===ve.bottom){he+=this._createSelectionPiece(ce,de,t.SELECTION_CLASS_NAME,ge.left+ge.width,t.ROUNDED_PIECE_WIDTH);var ye=t.EDITOR_BACKGROUND_CLASS_NAME;1===ve.top&&(ye+=" "+t.SELECTION_TOP_LEFT),1===ve.bottom&&(ye+=" "+t.SELECTION_BOTTOM_LEFT),he+=this._createSelectionPiece(ce,de,ye,ge.left+ge.width,t.ROUNDED_PIECE_WIDTH)}}var be=t.SELECTION_CLASS_NAME;if(ee){me=ge.startStyle,ve=ge.endStyle;0===me.top&&(be+=" "+t.SELECTION_TOP_LEFT),0===me.bottom&&(be+=" "+t.SELECTION_BOTTOM_LEFT),0===ve.top&&(be+=" "+t.SELECTION_TOP_RIGHT),0===ve.bottom&&(be+=" "+t.SELECTION_BOTTOM_RIGHT)}he+=this._createSelectionPiece(ce,de,be,ge.left,ge.width)}X[ue]+=he}},t.prototype.prepareRender=function(X){for(var $=[],Q=X.visibleRange.startLineNumber,J=X.visibleRange.endLineNumber,ee=Q;ee<=J;ee++)$[ee-Q]="";for(var te=[],ne=0,ie=this._selections.length;ne<ie;ne++){var oe=this._selections[ne];if(oe.isEmpty())te[ne]=null;else{var re=this._getVisibleRangesWithStyle(oe,X,this._previousFrameVisibleRangesWithStyle[ne]);te[ne]=re,this._actualRenderOneSelection($,Q,this._selections.length>1,re)}}this._previousFrameVisibleRangesWithStyle=te,this._renderResult=$},t.prototype.render=function(X,$){if(!this._renderResult)return"";var Q=$-X;return Q<0||Q>=this._renderResult.length?"":this._renderResult[Q]},t.SELECTION_CLASS_NAME="selected-text",t.SELECTION_TOP_LEFT="top-left-radius",t.SELECTION_BOTTOM_LEFT="bottom-left-radius",t.SELECTION_TOP_RIGHT="top-right-radius",t.SELECTION_BOTTOM_RIGHT="bottom-right-radius",t.EDITOR_BACKGROUND_CLASS_NAME="monaco-editor-background",t.ROUNDED_PIECE_WIDTH=10,t}(J.DynamicViewOverlay);$.SelectionsOverlay=oe,ne.registerThemingParticipant((function(X,$){var Q=X.getColor(ee.editorSelectionBackground);Q&&$.addRule(".monaco-editor .focused .selected-text { background-color: "+Q+"; }");var J=X.getColor(ee.editorInactiveSelection);J&&$.addRule(".monaco-editor .selected-text { background-color: "+J+"; }");var te=X.getColor(ee.editorSelectionForeground);te&&$.addRule(".monaco-editor .view-line span.inline-selected-text { color: "+te+"; }")}))})),define(Q[34],n([0,1,300,28,20,13]),(function(X,$,Q,J,ee,te){Object.defineProperty($,"__esModule",{value:!0}),$.editorLineHighlight=ee.registerColor("editor.lineHighlightBackground",{dark:null,light:null,hc:null},Q.localize(0,null)),$.editorLineHighlightBorder=ee.registerColor("editor.lineHighlightBorder",{dark:"#282828",light:"#eeeeee",hc:"#f38518"},Q.localize(1,null)),$.editorRangeHighlight=ee.registerColor("editor.rangeHighlightBackground",{dark:"#ffffff0b",light:"#fdff0033",hc:null},Q.localize(2,null),!0),$.editorRangeHighlightBorder=ee.registerColor("editor.rangeHighlightBorder",{dark:null,light:null,hc:ee.activeContrastBorder},Q.localize(3,null),!0),$.editorCursorForeground=ee.registerColor("editorCursor.foreground",{dark:"#AEAFAD",light:J.Color.black,hc:J.Color.white},Q.localize(4,null)),$.editorCursorBackground=ee.registerColor("editorCursor.background",null,Q.localize(5,null)),$.editorWhitespaces=ee.registerColor("editorWhitespace.foreground",{dark:"#e3e4e229",light:"#33333333",hc:"#e3e4e229"},Q.localize(6,null)),$.editorIndentGuides=ee.registerColor("editorIndentGuide.background",{dark:$.editorWhitespaces,light:$.editorWhitespaces,hc:$.editorWhitespaces},Q.localize(7,null)),$.editorActiveIndentGuides=ee.registerColor("editorIndentGuide.activeBackground",{dark:$.editorWhitespaces,light:$.editorWhitespaces,hc:$.editorWhitespaces},Q.localize(8,null)),$.editorLineNumbers=ee.registerColor("editorLineNumber.foreground",{dark:"#858585",light:"#237893",hc:J.Color.white},Q.localize(9,null));var ne=ee.registerColor("editorActiveLineNumber.foreground",{dark:"#c6c6c6",light:"#0B216F",hc:ee.activeContrastBorder},Q.localize(10,null),!1,Q.localize(11,null));$.editorActiveLineNumber=ee.registerColor("editorLineNumber.activeForeground",{dark:ne,light:ne,hc:ne},Q.localize(12,null)),$.editorRuler=ee.registerColor("editorRuler.foreground",{dark:"#5A5A5A",light:J.Color.lightgrey,hc:J.Color.white},Q.localize(13,null)),$.editorCodeLensForeground=ee.registerColor("editorCodeLens.foreground",{dark:"#999999",light:"#999999",hc:"#999999"},Q.localize(14,null)),$.editorBracketMatchBackground=ee.registerColor("editorBracketMatch.background",{dark:"#0064001a",light:"#0064001a",hc:"#0064001a"},Q.localize(15,null)),$.editorBracketMatchBorder=ee.registerColor("editorBracketMatch.border",{dark:"#888",light:"#B9B9B9",hc:"#fff"},Q.localize(16,null)),$.editorOverviewRulerBorder=ee.registerColor("editorOverviewRuler.border",{dark:"#7f7f7f4d",light:"#7f7f7f4d",hc:"#7f7f7f4d"},Q.localize(17,null)),$.editorGutter=ee.registerColor("editorGutter.background",{dark:ee.editorBackground,light:ee.editorBackground,hc:ee.editorBackground},Q.localize(18,null)),$.editorErrorForeground=ee.registerColor("editorError.foreground",{dark:"#ea4646",light:"#d60a0a",hc:null},Q.localize(19,null)),$.editorErrorBorder=ee.registerColor("editorError.border",{dark:null,light:null,hc:J.Color.fromHex("#E47777").transparent(.8)},Q.localize(20,null)),$.editorWarningForeground=ee.registerColor("editorWarning.foreground",{dark:"#4d9e4d",light:"#117711",hc:null},Q.localize(21,null)),$.editorWarningBorder=ee.registerColor("editorWarning.border",{dark:null,light:null,hc:J.Color.fromHex("#71B771").transparent(.8)},Q.localize(22,null)),$.editorInfoForeground=ee.registerColor("editorInfo.foreground",{dark:"#008000",light:"#008000",hc:null},Q.localize(23,null)),$.editorInfoBorder=ee.registerColor("editorInfo.border",{dark:null,light:null,hc:J.Color.fromHex("#71B771").transparent(.8)},Q.localize(24,null)),$.editorHintForeground=ee.registerColor("editorHint.foreground",{dark:J.Color.fromHex("#eeeeee").transparent(.7),light:"#6c6c6c",hc:null},Q.localize(25,null)),$.editorHintBorder=ee.registerColor("editorHint.border",{dark:null,light:null,hc:J.Color.fromHex("#eeeeee").transparent(.8)},Q.localize(26,null)),$.editorUnnecessaryCodeBorder=ee.registerColor("editorUnnecessaryCode.border",{dark:null,light:null,hc:J.Color.fromHex("#fff").transparent(.8)},Q.localize(27,null)),$.editorUnnecessaryCodeOpacity=ee.registerColor("editorUnnecessaryCode.opacity",{dark:J.Color.fromHex("#000a"),light:J.Color.fromHex("#0007"),hc:null},Q.localize(28,null)),$.overviewRulerError=ee.registerColor("editorOverviewRuler.errorForeground",{dark:new J.Color(new J.RGBA(255,18,18,.7)),light:new J.Color(new J.RGBA(255,18,18,.7)),hc:new J.Color(new J.RGBA(255,50,50,1))},Q.localize(29,null)),$.overviewRulerWarning=ee.registerColor("editorOverviewRuler.warningForeground",{dark:new J.Color(new J.RGBA(18,136,18,.7)),light:new J.Color(new J.RGBA(18,136,18,.7)),hc:new J.Color(new J.RGBA(50,255,50,1))},Q.localize(30,null)),$.overviewRulerInfo=ee.registerColor("editorOverviewRuler.infoForeground",{dark:new J.Color(new J.RGBA(18,18,136,.7)),light:new J.Color(new J.RGBA(18,18,136,.7)),hc:new J.Color(new J.RGBA(50,50,255,1))},Q.localize(31,null)),te.registerThemingParticipant((function(X,Q){var J=X.getColor(ee.editorBackground);J&&Q.addRule(".monaco-editor, .monaco-editor-background, .monaco-editor .inputarea.ime-input { background-color: "+J+"; }");var te=X.getColor(ee.editorForeground);te&&Q.addRule(".monaco-editor, .monaco-editor .inputarea.ime-input { color: "+te+"; }");var ne=X.getColor($.editorGutter);ne&&Q.addRule(".monaco-editor .margin { background-color: "+ne+"; }");var ie=X.getColor($.editorRangeHighlight);ie&&Q.addRule(".monaco-editor .rangeHighlight { background-color: "+ie+"; }");var oe=X.getColor($.editorRangeHighlightBorder);oe&&Q.addRule(".monaco-editor .rangeHighlight { border: 1px "+("hc"===X.type?"dotted":"solid")+" "+oe+"; }");var re=X.getColor($.editorWhitespaces);re&&Q.addRule(".vs-whitespace { color: "+re+" !important; }")}))})),define(Q[496],n([0,1,61,34,13,251]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var ne=function(X){function t($){var Q=X.call(this)||this;return Q._context=$,Q._lineHeight=Q._context.configuration.editor.lineHeight,Q._renderLineHighlight=Q._context.configuration.editor.viewInfo.renderLineHighlight,Q._selectionIsEmpty=!0,Q._primaryCursorLineNumber=1,Q._scrollWidth=0,Q._contentWidth=Q._context.configuration.editor.layoutInfo.contentWidth,Q._context.addEventHandler(Q),Q}return te(t,X),t.prototype.dispose=function(){this._context.removeEventHandler(this),X.prototype.dispose.call(this)},t.prototype.onConfigurationChanged=function(X){return X.lineHeight&&(this._lineHeight=this._context.configuration.editor.lineHeight),X.viewInfo&&(this._renderLineHighlight=this._context.configuration.editor.viewInfo.renderLineHighlight),X.layoutInfo&&(this._contentWidth=this._context.configuration.editor.layoutInfo.contentWidth),!0},t.prototype.onCursorStateChanged=function(X){var $=!1,Q=X.selections[0].positionLineNumber;this._primaryCursorLineNumber!==Q&&(this._primaryCursorLineNumber=Q,$=!0);var J=X.selections[0].isEmpty();return this._selectionIsEmpty!==J?(this._selectionIsEmpty=J,$=!0,!0):$},t.prototype.onFlushed=function(X){return!0},t.prototype.onLinesDeleted=function(X){return!0},t.prototype.onLinesInserted=function(X){return!0},t.prototype.onScrollChanged=function(X){return X.scrollWidthChanged},t.prototype.onZonesChanged=function(X){return!0},t.prototype.prepareRender=function(X){this._scrollWidth=X.scrollWidth},t.prototype.render=function(X,$){return $===this._primaryCursorLineNumber&&this._shouldShowCurrentLine()?'<div class="current-line'+(this._willRenderMarginCurrentLine()?" current-line-both":"")+'" style="width:'+String(Math.max(this._scrollWidth,this._contentWidth))+"px; height:"+String(this._lineHeight)+'px;"></div>':""},t.prototype._shouldShowCurrentLine=function(){return("line"===this._renderLineHighlight||"all"===this._renderLineHighlight)&&this._selectionIsEmpty},t.prototype._willRenderMarginCurrentLine=function(){return"gutter"===this._renderLineHighlight||"all"===this._renderLineHighlight},t}(Q.DynamicViewOverlay);$.CurrentLineHighlightOverlay=ne,ee.registerThemingParticipant((function(X,$){var Q=X.getColor(J.editorLineHighlight);if(Q&&$.addRule(".monaco-editor .view-overlays .current-line { background-color: "+Q+"; }"),!Q||Q.isTransparent()||X.defines(J.editorLineHighlightBorder)){var ee=X.getColor(J.editorLineHighlightBorder);ee&&($.addRule(".monaco-editor .view-overlays .current-line { border: 2px solid "+ee+"; }"),"hc"===X.type&&$.addRule(".monaco-editor .view-overlays .current-line { border-width: 1px; }"))}}))})),define(Q[497],n([0,1,61,34,13,252]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var ne=function(X){function t($){var Q=X.call(this)||this;return Q._context=$,Q._lineHeight=Q._context.configuration.editor.lineHeight,Q._renderLineHighlight=Q._context.configuration.editor.viewInfo.renderLineHighlight,Q._selectionIsEmpty=!0,Q._primaryCursorLineNumber=1,Q._contentLeft=Q._context.configuration.editor.layoutInfo.contentLeft,Q._context.addEventHandler(Q),Q}return te(t,X),t.prototype.dispose=function(){this._context.removeEventHandler(this),X.prototype.dispose.call(this)},t.prototype.onConfigurationChanged=function(X){return X.lineHeight&&(this._lineHeight=this._context.configuration.editor.lineHeight),X.viewInfo&&(this._renderLineHighlight=this._context.configuration.editor.viewInfo.renderLineHighlight),X.layoutInfo&&(this._contentLeft=this._context.configuration.editor.layoutInfo.contentLeft),!0},t.prototype.onCursorStateChanged=function(X){var $=!1,Q=X.selections[0].positionLineNumber;this._primaryCursorLineNumber!==Q&&(this._primaryCursorLineNumber=Q,$=!0);var J=X.selections[0].isEmpty();return this._selectionIsEmpty!==J?(this._selectionIsEmpty=J,$=!0,!0):$},t.prototype.onFlushed=function(X){return!0},t.prototype.onLinesDeleted=function(X){return!0},t.prototype.onLinesInserted=function(X){return!0},t.prototype.onZonesChanged=function(X){return!0},t.prototype.prepareRender=function(X){},t.prototype.render=function(X,$){if($===this._primaryCursorLineNumber){var Q="current-line";return this._shouldShowCurrentLine()&&(Q="current-line current-line-margin"+(this._willRenderContentCurrentLine()?" current-line-margin-both":"")),'<div class="'+Q+'" style="width:'+String(this._contentLeft)+"px; height:"+String(this._lineHeight)+'px;"></div>'}return""},t.prototype._shouldShowCurrentLine=function(){return"gutter"===this._renderLineHighlight||"all"===this._renderLineHighlight},t.prototype._willRenderContentCurrentLine=function(){return("line"===this._renderLineHighlight||"all"===this._renderLineHighlight)&&this._selectionIsEmpty},t}(Q.DynamicViewOverlay);$.CurrentLineMarginHighlightOverlay=ne,ee.registerThemingParticipant((function(X,$){var Q=X.getColor(J.editorLineHighlight);if(Q)$.addRule(".monaco-editor .margin-view-overlays .current-line-margin { background-color: "+Q+"; border: none; }");else{var ee=X.getColor(J.editorLineHighlightBorder);ee&&$.addRule(".monaco-editor .margin-view-overlays .current-line-margin { border: 2px solid "+ee+"; }"),"hc"===X.type&&$.addRule(".monaco-editor .margin-view-overlays .current-line-margin { border-width: 1px; }")}}))})),define(Q[498],n([0,1,61,12,34,13,262]),(function(X,$,Q,J,ee,ne){Object.defineProperty($,"__esModule",{value:!0});var ie=function(X){function t($){var Q=X.call(this)||this;return Q._context=$,Q._primaryLineNumber=0,Q._lineHeight=Q._context.configuration.editor.lineHeight,Q._spaceWidth=Q._context.configuration.editor.fontInfo.spaceWidth,Q._enabled=Q._context.configuration.editor.viewInfo.renderIndentGuides,Q._activeIndentEnabled=Q._context.configuration.editor.viewInfo.highlightActiveIndentGuide,Q._renderResult=null,Q._context.addEventHandler(Q),Q}return te(t,X),t.prototype.dispose=function(){this._context.removeEventHandler(this),this._renderResult=null,X.prototype.dispose.call(this)},t.prototype.onConfigurationChanged=function(X){return X.lineHeight&&(this._lineHeight=this._context.configuration.editor.lineHeight),X.fontInfo&&(this._spaceWidth=this._context.configuration.editor.fontInfo.spaceWidth),X.viewInfo&&(this._enabled=this._context.configuration.editor.viewInfo.renderIndentGuides,this._activeIndentEnabled=this._context.configuration.editor.viewInfo.highlightActiveIndentGuide),!0},t.prototype.onCursorStateChanged=function(X){var $=X.selections[0],Q=$.isEmpty()?$.positionLineNumber:0;return this._primaryLineNumber!==Q&&(this._primaryLineNumber=Q,!0)},t.prototype.onDecorationsChanged=function(X){return!0},t.prototype.onFlushed=function(X){return!0},t.prototype.onLinesChanged=function(X){return!0},t.prototype.onLinesDeleted=function(X){return!0},t.prototype.onLinesInserted=function(X){return!0},t.prototype.onScrollChanged=function(X){return X.scrollTopChanged},t.prototype.onZonesChanged=function(X){return!0},t.prototype.onLanguageConfigurationChanged=function(X){return!0},t.prototype.prepareRender=function(X){if(this._enabled){var $=X.visibleRange.startLineNumber,Q=X.visibleRange.endLineNumber,ee=this._context.model.getTabSize()*this._spaceWidth,te=X.scrollWidth,ne=this._lineHeight,ie=ee,oe=this._context.model.getLinesIndentGuides($,Q),re=0,se=0,ae=0;if(this._activeIndentEnabled&&this._primaryLineNumber){var le=this._context.model.getActiveIndentGuide(this._primaryLineNumber,$,Q);re=le.startLineNumber,se=le.endLineNumber,ae=le.indent}for(var ue=[],de=$;de<=Q;de++){for(var ce=re<=de&&de<=se,he=de-$,pe=oe[he],fe="",ge=X.visibleRangeForPosition(new J.Position(de,1)),me=ge?ge.left:0,ve=1;ve<=pe&&(fe+='<div class="'+(ce&&ve===ae?"cigra":"cigr")+'" style="left:'+me+"px;height:"+ne+"px;width:"+ie+'px"></div>',!((me+=ee)>te));ve++);ue[he]=fe}this._renderResult=ue}else this._renderResult=null},t.prototype.render=function(X,$){if(!this._renderResult)return"";var Q=$-X;return Q<0||Q>=this._renderResult.length?"":this._renderResult[Q]},t}(Q.DynamicViewOverlay);$.IndentGuidesOverlay=ie,ne.registerThemingParticipant((function(X,$){var Q=X.getColor(ee.editorIndentGuides);Q&&$.addRule(".monaco-editor .lines-content .cigr { box-shadow: 1px 0 0 0 "+Q+" inset; }");var J=X.getColor(ee.editorActiveIndentGuides)||Q;J&&$.addRule(".monaco-editor .lines-content .cigra { box-shadow: 1px 0 0 0 "+J+" inset; }")}))})),define(Q[187],n([0,1,17,61,12,34,13,265]),(function(X,$,Q,J,ee,ne,ie){Object.defineProperty($,"__esModule",{value:!0});var oe=function(X){function t($){var Q=X.call(this)||this;return Q._context=$,Q._readConfig(),Q._lastCursorModelPosition=new ee.Position(1,1),Q._renderResult=null,Q._context.addEventHandler(Q),Q}return te(t,X),t.prototype._readConfig=function(){var X=this._context.configuration.editor;this._lineHeight=X.lineHeight,this._renderLineNumbers=X.viewInfo.renderLineNumbers,this._renderCustomLineNumbers=X.viewInfo.renderCustomLineNumbers,this._lineNumbersLeft=X.layoutInfo.lineNumbersLeft,this._lineNumbersWidth=X.layoutInfo.lineNumbersWidth},t.prototype.dispose=function(){this._context.removeEventHandler(this),this._renderResult=null,X.prototype.dispose.call(this)},t.prototype.onConfigurationChanged=function(X){return this._readConfig(),!0},t.prototype.onCursorStateChanged=function(X){var $=X.selections[0].getPosition();return this._lastCursorModelPosition=this._context.model.coordinatesConverter.convertViewPositionToModelPosition($),2===this._renderLineNumbers||3===this._renderLineNumbers},t.prototype.onFlushed=function(X){return!0},t.prototype.onLinesChanged=function(X){return!0},t.prototype.onLinesDeleted=function(X){return!0},t.prototype.onLinesInserted=function(X){return!0},t.prototype.onScrollChanged=function(X){return X.scrollTopChanged},t.prototype.onZonesChanged=function(X){return!0},t.prototype._getLineRenderLineNumber=function(X){var $=this._context.model.coordinatesConverter.convertViewPositionToModelPosition(new ee.Position(X,1));if(1!==$.column)return"";var Q=$.lineNumber;if(this._renderCustomLineNumbers)return this._renderCustomLineNumbers(Q);if(2===this._renderLineNumbers){var J=Math.abs(this._lastCursorModelPosition.lineNumber-Q);return 0===J?'<span class="relative-current-line-number">'+Q+"</span>":String(J)}return 3===this._renderLineNumbers?this._lastCursorModelPosition.lineNumber===Q||Q%10==0?String(Q):"":String(Q)},t.prototype.prepareRender=function(X){if(0!==this._renderLineNumbers){for(var $=Q.isLinux?this._lineHeight%2==0?" lh-even":" lh-odd":"",J=X.visibleRange.startLineNumber,ee=X.visibleRange.endLineNumber,te='<div class="'+t.CLASS_NAME+$+'" style="left:'+this._lineNumbersLeft.toString()+"px;width:"+this._lineNumbersWidth.toString()+'px;">',ne=[],ie=J;ie<=ee;ie++){var oe=ie-J,re=this._getLineRenderLineNumber(ie);ne[oe]=re?te+re+"</div>":""}this._renderResult=ne}else this._renderResult=null},t.prototype.render=function(X,$){if(!this._renderResult)return"";var Q=$-X;return Q<0||Q>=this._renderResult.length?"":this._renderResult[Q]},t.CLASS_NAME="line-numbers",t}(J.DynamicViewOverlay);$.LineNumbersOverlay=oe,ie.registerThemingParticipant((function(X,$){var Q=X.getColor(ne.editorLineNumbers);Q&&$.addRule(".monaco-editor .line-numbers { color: "+Q+"; }");var J=X.getColor(ne.editorActiveLineNumber);J&&$.addRule(".monaco-editor .current-line ~ .line-numbers { color: "+J+"; }")}))})),define(Q[500],n([0,1,29,23,17,8,57,150,173,33,187,168,80,12,3,21,69,250]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le,ue,de,ce,he,pe){Object.defineProperty($,"__esModule",{value:!0});var fe=function(){function e(X,$,Q){this.top=X,this.left=$,this.width=Q}return e.prototype.setWidth=function(X){return new e(this.top,this.left,X)},e}(),ge=Q.isEdgeOrIE||Q.isFirefox,me=function(){function e(){this._lastState=null}return e.prototype.set=function(X){this._lastState=X},e.prototype.get=function(X){return this._lastState&&this._lastState.lastCopiedValue===X?this._lastState:(this._lastState=null,null)},e.INSTANCE=new e,e}(),ve=function(X){function t($,te,ne){var ie=X.call(this,$)||this;ie._primaryCursorVisibleRange=null,ie._viewController=te,ie._viewHelper=ne;var ae=ie._context.configuration.editor;ie._accessibilitySupport=ae.accessibilitySupport,ie._contentLeft=ae.layoutInfo.contentLeft,ie._contentWidth=ae.layoutInfo.contentWidth,ie._contentHeight=ae.layoutInfo.contentHeight,ie._scrollLeft=0,ie._scrollTop=0,ie._fontInfo=ae.fontInfo,ie._lineHeight=ae.lineHeight,ie._emptySelectionClipboard=ae.emptySelectionClipboard,ie._copyWithSyntaxHighlighting=ae.copyWithSyntaxHighlighting,ie._visibleTextArea=null,ie._selections=[new he.Selection(1,1,1,1)],ie.textArea=J.createFastDomNode(document.createElement("textarea")),se.PartFingerprints.write(ie.textArea,6),ie.textArea.setClassName("inputarea"),ie.textArea.setAttribute("wrap","off"),ie.textArea.setAttribute("autocorrect","off"),ie.textArea.setAttribute("autocapitalize","off"),ie.textArea.setAttribute("autocomplete","off"),ie.textArea.setAttribute("spellcheck","false"),ie.textArea.setAttribute("aria-label",ae.viewInfo.ariaLabel),ie.textArea.setAttribute("role","textbox"),ie.textArea.setAttribute("aria-multiline","true"),ie.textArea.setAttribute("aria-haspopup","false"),ie.textArea.setAttribute("aria-autocomplete","both"),ie.textAreaCover=J.createFastDomNode(document.createElement("div")),ie.textAreaCover.setPosition("absolute");var le={getLineCount:function(){return ie._context.model.getLineCount()},getLineMaxColumn:function(X){return ie._context.model.getLineMaxColumn(X)},getValueInRange:function(X,$){return ie._context.model.getValueInRange(X,$)}},ue={getPlainTextToCopy:function(){var X=ie._context.model.getPlainTextToCopy(ie._selections,ie._emptySelectionClipboard,ee.isWindows),$=ie._context.model.getEOL(),J=ie._emptySelectionClipboard&&1===ie._selections.length&&ie._selections[0].isEmpty(),te=Array.isArray(X)?X:null,ne=Array.isArray(X)?X.join($):X,oe=null;return(J||te)&&(oe={lastCopiedValue:Q.isFirefox?ne.replace(/\r\n/g,"\n"):ne,isFromEmptySelection:ie._emptySelectionClipboard&&1===ie._selections.length&&ie._selections[0].isEmpty(),multicursorText:te}),me.INSTANCE.set(oe),ne},getHTMLToCopy:function(){return ie._copyWithSyntaxHighlighting||oe.CopyOptions.forceCopyWithSyntaxHighlighting?ie._context.model.getHTMLToCopy(ie._selections,ie._emptySelectionClipboard):null},getScreenReaderContent:function(X){if(Q.isIPad)return re.TextAreaState.EMPTY;if(1===ie._accessibilitySupport){if(ee.isMacintosh){var $=ie._selections[0];if($.isEmpty()){var J=$.getStartPosition(),te=ie._getWordBeforePosition(J);if(0===te.length&&(te=ie._getCharacterBeforePosition(J)),te.length>0)return new re.TextAreaState(te,te.length,te.length,J,J)}}return re.TextAreaState.EMPTY}return re.PagedScreenReaderStrategy.fromEditorSelection(X,le,ie._selections[0],0===ie._accessibilitySupport)},deduceModelPosition:function(X,$,Q){return ie._context.model.deduceModelPositionRelativeToViewPosition(X,$,Q)}};return ie._textAreaInput=ie._register(new oe.TextAreaInput(ue,ie.textArea)),ie._register(ie._textAreaInput.onKeyDown((function(X){ie._viewController.emitKeyDown(X)}))),ie._register(ie._textAreaInput.onKeyUp((function(X){ie._viewController.emitKeyUp(X)}))),ie._register(ie._textAreaInput.onPaste((function(X){var $=me.INSTANCE.get(X.text),Q=!1,J=null;$&&(Q=ie._emptySelectionClipboard&&$.isFromEmptySelection,J=$.multicursorText),ie._viewController.paste("keyboard",X.text,Q,J)}))),ie._register(ie._textAreaInput.onCut((function(){ie._viewController.cut("keyboard")}))),ie._register(ie._textAreaInput.onType((function(X){X.replaceCharCnt?ie._viewController.replacePreviousChar("keyboard",X.text,X.replaceCharCnt):ie._viewController.type("keyboard",X.text)}))),ie._register(ie._textAreaInput.onSelectionChangeRequest((function(X){ie._viewController.setSelection("keyboard",X)}))),ie._register(ie._textAreaInput.onCompositionStart((function(){var X=ie._selections[0].startLineNumber,$=ie._selections[0].startColumn;ie._context.privateViewEventBus.emit(new pe.ViewRevealRangeRequestEvent(new ce.Range(X,$,X,$),0,!0,1));var Q=ie._viewHelper.visibleRangeForPositionRelativeToEditor(X,$);Q&&(ie._visibleTextArea=new fe(ie._context.viewLayout.getVerticalOffsetForLineNumber(X),Q.left,ge?0:1),ie._render()),ie.textArea.setClassName("inputarea ime-input"),ie._viewController.compositionStart("keyboard")}))),ie._register(ie._textAreaInput.onCompositionUpdate((function(X){Q.isEdgeOrIE?ie._visibleTextArea=ie._visibleTextArea.setWidth(0):ie._visibleTextArea=ie._visibleTextArea.setWidth(function _(X,$){var J=document.createElement("canvas").getContext("2d");J.font=function(X){return function(X,$,Q,J,ee){return"normal normal "+$+" "+Q+"px / "+J+"px "+ee}(0,X.fontWeight,X.fontSize,X.lineHeight,X.fontFamily)}($);var ee=J.measureText(X);return Q.isFirefox?ee.width+2:ee.width}(X.data,ie._fontInfo)),ie._render()}))),ie._register(ie._textAreaInput.onCompositionEnd((function(){ie._visibleTextArea=null,ie._render(),ie.textArea.setClassName("inputarea"),ie._viewController.compositionEnd("keyboard")}))),ie._register(ie._textAreaInput.onFocus((function(){ie._context.privateViewEventBus.emit(new pe.ViewFocusChangedEvent(!0))}))),ie._register(ie._textAreaInput.onBlur((function(){ie._context.privateViewEventBus.emit(new pe.ViewFocusChangedEvent(!1))}))),ie}return te(t,X),t.prototype.dispose=function(){X.prototype.dispose.call(this)},t.prototype._getWordBeforePosition=function(X){for(var $=this._context.model.getLineContent(X.lineNumber),Q=ue.getMapForWordSeparators(this._context.configuration.editor.wordSeparators),J=X.column,ee=0;J>1;){var te=$.charCodeAt(J-2);if(0!==Q.get(te)||ee>50)return $.substring(J-1,X.column-1);ee++,J--}return $.substring(0,X.column-1)},t.prototype._getCharacterBeforePosition=function(X){if(X.column>1){var $=this._context.model.getLineContent(X.lineNumber).charAt(X.column-2);if(!ne.isHighSurrogate($.charCodeAt(0)))return $}return""},t.prototype.onConfigurationChanged=function(X){var $=this._context.configuration.editor;return X.fontInfo&&(this._fontInfo=$.fontInfo),X.viewInfo&&this.textArea.setAttribute("aria-label",$.viewInfo.ariaLabel),X.layoutInfo&&(this._contentLeft=$.layoutInfo.contentLeft,this._contentWidth=$.layoutInfo.contentWidth,this._contentHeight=$.layoutInfo.contentHeight),X.lineHeight&&(this._lineHeight=$.lineHeight),X.accessibilitySupport&&(this._accessibilitySupport=$.accessibilitySupport,this._textAreaInput.writeScreenReaderContent("strategy changed")),X.emptySelectionClipboard&&(this._emptySelectionClipboard=$.emptySelectionClipboard),X.copyWithSyntaxHighlighting&&(this._copyWithSyntaxHighlighting=$.copyWithSyntaxHighlighting),!0},t.prototype.onCursorStateChanged=function(X){return this._selections=X.selections.slice(0),this._textAreaInput.writeScreenReaderContent("selection changed"),!0},t.prototype.onDecorationsChanged=function(X){return!0},t.prototype.onFlushed=function(X){return!0},t.prototype.onLinesChanged=function(X){return!0},t.prototype.onLinesDeleted=function(X){return!0},t.prototype.onLinesInserted=function(X){return!0},t.prototype.onScrollChanged=function(X){return this._scrollLeft=X.scrollLeft,this._scrollTop=X.scrollTop,!0},t.prototype.onZonesChanged=function(X){return!0},t.prototype.isFocused=function(){return this._textAreaInput.isFocused()},t.prototype.focusTextArea=function(){this._textAreaInput.focusTextArea()},t.prototype.prepareRender=function(X){if(2===this._accessibilitySupport)this._primaryCursorVisibleRange=null;else{var $=new de.Position(this._selections[0].positionLineNumber,this._selections[0].positionColumn);this._primaryCursorVisibleRange=X.visibleRangeForPosition($)}},t.prototype.render=function(X){this._textAreaInput.writeScreenReaderContent("render"),this._render()},t.prototype._render=function(){if(this._visibleTextArea)this._renderInsideEditor(this._visibleTextArea.top-this._scrollTop,this._contentLeft+this._visibleTextArea.left-this._scrollLeft,this._visibleTextArea.width,this._lineHeight,!0);else if(this._primaryCursorVisibleRange){var X=this._contentLeft+this._primaryCursorVisibleRange.left-this._scrollLeft;if(X<this._contentLeft||X>this._contentLeft+this._contentWidth)this._renderAtTopLeft();else{var $=this._context.viewLayout.getVerticalOffsetForLineNumber(this._selections[0].positionLineNumber)-this._scrollTop;$<0||$>this._contentHeight?this._renderAtTopLeft():this._renderInsideEditor($,X,ge?0:1,ge?0:1,!1)}}else this._renderAtTopLeft()},t.prototype._renderInsideEditor=function(X,$,Q,J,ee){var te=this.textArea,ne=this.textAreaCover;ee?ie.Configuration.applyFontInfo(te,this._fontInfo):(te.setFontSize(1),te.setLineHeight(this._fontInfo.lineHeight)),te.setTop(X),te.setLeft($),te.setWidth(Q),te.setHeight(J),ne.setTop(0),ne.setLeft(0),ne.setWidth(0),ne.setHeight(0)},t.prototype._renderAtTopLeft=function(){var X=this.textArea,$=this.textAreaCover;if(ie.Configuration.applyFontInfo(X,this._fontInfo),X.setTop(0),X.setLeft(0),$.setTop(0),$.setLeft(0),ge)return X.setWidth(0),X.setHeight(0),$.setWidth(0),void $.setHeight(0);X.setWidth(1),X.setHeight(1),$.setWidth(1),$.setHeight(1),this._context.configuration.editor.viewInfo.glyphMargin?$.setClassName("monaco-editor-background textAreaCover "+le.Margin.OUTER_CLASS_NAME):0!==this._context.configuration.editor.viewInfo.renderLineNumbers?$.setClassName("monaco-editor-background textAreaCover "+ae.LineNumbersOverlay.CLASS_NAME):$.setClassName("monaco-editor-background textAreaCover")},t}(se.ViewPart);$.TextAreaHandler=ve})),define(Q[501],n([0,1,23,28,33,12,14,34]),(function(X,$,Q,J,ee,ne,ie,oe){Object.defineProperty($,"__esModule",{value:!0});var re=function(){function e(X,$){this.lineHeight=X.editor.lineHeight,this.pixelRatio=X.editor.pixelRatio,this.overviewRulerLanes=X.editor.viewInfo.overviewRulerLanes,this.renderBorder=X.editor.viewInfo.overviewRulerBorder;var Q=$.getColor(oe.editorOverviewRulerBorder);this.borderColor=Q?Q.toString():null,this.hideCursor=X.editor.viewInfo.hideCursorInOverviewRuler;var ee=$.getColor(oe.editorCursorForeground);this.cursorColor=ee?ee.transparent(.7).toString():null,this.themeType=$.type;var te=X.editor.viewInfo.minimap.enabled,ne=X.editor.viewInfo.minimap.side,re=te?ie.TokenizationRegistry.getDefaultBackground():null;this.backgroundColor=null===re||"left"===ne?null:J.Color.Format.CSS.formatHex(re);var se=X.editor.layoutInfo.overviewRuler;this.top=se.top,this.right=se.right,this.domWidth=se.width,this.domHeight=se.height,this.canvasWidth=this.domWidth*this.pixelRatio|0,this.canvasHeight=this.domHeight*this.pixelRatio|0;var ae=this._initLanes(1,this.canvasWidth,this.overviewRulerLanes),le=ae[0],ue=ae[1];this.x=le,this.w=ue}return e.prototype._initLanes=function(X,$,Q){var J=$-X;if(Q>=3){var ee=J-(ne=Math.floor(J/3))-(ie=Math.floor(J/3)),te=(oe=X)+ne;return[[0,oe,te,oe,re=oe+ne+ee,oe,te,oe],[0,ne,ee,ne+ee,ie,ne+ee+ie,ee+ie,ne+ee+ie]]}if(2===Q){var ne=Math.floor(J/2),ie=J-ne,oe=X,re=X+ne;return[[0,X,X,X,re,X,X,X],[0,ne,ne,ne,ie,ne+ie,ne+ie,ne+ie]]}return[[0,X,X,X,X,X,X,X],[0,J,J,J,J,J,J,J]]},e.prototype.equals=function(X){return this.lineHeight===X.lineHeight&&this.pixelRatio===X.pixelRatio&&this.overviewRulerLanes===X.overviewRulerLanes&&this.renderBorder===X.renderBorder&&this.borderColor===X.borderColor&&this.hideCursor===X.hideCursor&&this.cursorColor===X.cursorColor&&this.themeType===X.themeType&&this.backgroundColor===X.backgroundColor&&this.top===X.top&&this.right===X.right&&this.domWidth===X.domWidth&&this.domHeight===X.domHeight&&this.canvasWidth===X.canvasWidth&&this.canvasHeight===X.canvasHeight},e}(),se=function(X){function t($){var J=X.call(this,$)||this;return J._domNode=Q.createFastDomNode(document.createElement("canvas")),J._domNode.setClassName("decorationsOverviewRuler"),J._domNode.setPosition("absolute"),J._domNode.setLayerHinting(!0),J._domNode.setAttribute("aria-hidden","true"),J._updateSettings(!1),J._tokensColorTrackerListener=ie.TokenizationRegistry.onDidChange((function(X){X.changedColorMap&&J._updateSettings(!0)})),J._cursorPositions=[],J}return te(t,X),t.prototype.dispose=function(){X.prototype.dispose.call(this),this._tokensColorTrackerListener.dispose()},t.prototype._updateSettings=function(X){var $=new re(this._context.configuration,this._context.theme);return!(this._settings&&this._settings.equals($)||(this._settings=$,this._domNode.setTop(this._settings.top),this._domNode.setRight(this._settings.right),this._domNode.setWidth(this._settings.domWidth),this._domNode.setHeight(this._settings.domHeight),this._domNode.domNode.width=this._settings.canvasWidth,this._domNode.domNode.height=this._settings.canvasHeight,X&&this._render(),0))},t.prototype.onConfigurationChanged=function(X){return this._updateSettings(!1)},t.prototype.onCursorStateChanged=function(X){this._cursorPositions=[];for(var $=0,Q=X.selections.length;$<Q;$++)this._cursorPositions[$]=X.selections[$].getPosition();return this._cursorPositions.sort(ne.Position.compare),!0},t.prototype.onDecorationsChanged=function(X){return!0},t.prototype.onFlushed=function(X){return!0},t.prototype.onScrollChanged=function(X){return X.scrollHeightChanged},t.prototype.onZonesChanged=function(X){return!0},t.prototype.onThemeChanged=function(X){return this._context.model.invalidateOverviewRulerColorCache(),this._updateSettings(!1)},t.prototype.getDomNode=function(){return this._domNode.domNode},t.prototype.prepareRender=function(X){},t.prototype.render=function(X){this._render()},t.prototype._render=function(){var X=this._settings.canvasWidth,$=this._settings.canvasHeight,Q=this._settings.lineHeight,J=this._context.viewLayout,ee=$/this._context.viewLayout.getScrollHeight(),te=this._context.model.getAllOverviewRulerDecorations(this._context.theme),ne=6*this._settings.pixelRatio|0,ie=ne/2|0,oe=this._domNode.domNode.getContext("2d");null===this._settings.backgroundColor?oe.clearRect(0,0,X,$):(oe.fillStyle=this._settings.backgroundColor,oe.fillRect(0,0,X,$));var re=this._settings.x,se=this._settings.w,ae=Object.keys(te);ae.sort();for(var le=0,ue=ae.length;le<ue;le++){var de=ae[le],ce=te[de];oe.fillStyle=de;for(var he=0,pe=0,fe=0,ge=0,me=ce.length;ge<me;ge++){var ve=ce[3*ge],_e=ce[3*ge+1],ye=ce[3*ge+2],be=J.getVerticalOffsetForLineNumber(_e)*ee|0;(Ie=(J.getVerticalOffsetForLineNumber(ye)+Q)*ee|0)-be<ne&&((xe=(be+Ie)/2|0)<ie?xe=ie:xe+ie>$&&(xe=$-ie),be=xe-ie,Ie=xe+ie),be>fe+1||ve!==he?(0!==ge&&oe.fillRect(re[he],pe,se[he],fe-pe),he=ve,pe=be,fe=Ie):Ie>fe&&(fe=Ie)}oe.fillRect(re[he],pe,se[he],fe-pe)}if(!this._settings.hideCursor&&this._settings.cursorColor){var Ce=2*this._settings.pixelRatio|0,we=Ce/2|0,Se=this._settings.x[7],Ee=this._settings.w[7];oe.fillStyle=this._settings.cursorColor;for(pe=-100,fe=-100,ge=0,me=this._cursorPositions.length;ge<me;ge++){var Le=this._cursorPositions[ge],xe=J.getVerticalOffsetForLineNumber(Le.lineNumber)*ee|0;xe<we?xe=we:xe+we>$&&(xe=$-we);var Ie=(be=xe-we)+Ce;be>fe+1?(0!==ge&&oe.fillRect(Se,pe,Ee,fe-pe),pe=be,fe=Ie):Ie>fe&&(fe=Ie)}oe.fillRect(Se,pe,Ee,fe-pe)}this._settings.renderBorder&&this._settings.borderColor&&this._settings.overviewRulerLanes>0&&(oe.beginPath(),oe.lineWidth=1,oe.strokeStyle=this._settings.borderColor,oe.moveTo(0,0),oe.lineTo(0,$),oe.stroke(),oe.moveTo(0,0),oe.lineTo(X,0),oe.stroke())},t}(ee.ViewPart);$.DecorationsOverviewRuler=se})),define(Q[502],n([0,1,23,33,34,13,281]),(function(X,$,Q,J,ee,ne){Object.defineProperty($,"__esModule",{value:!0});var ie=function(X){function t($){var J=X.call(this,$)||this;return J.domNode=Q.createFastDomNode(document.createElement("div")),J.domNode.setAttribute("role","presentation"),J.domNode.setAttribute("aria-hidden","true"),J.domNode.setClassName("view-rulers"),J._renderedRulers=[],J._rulers=J._context.configuration.editor.viewInfo.rulers,J._typicalHalfwidthCharacterWidth=J._context.configuration.editor.fontInfo.typicalHalfwidthCharacterWidth,J}return te(t,X),t.prototype.dispose=function(){X.prototype.dispose.call(this)},t.prototype.onConfigurationChanged=function(X){return!!(X.viewInfo||X.layoutInfo||X.fontInfo)&&(this._rulers=this._context.configuration.editor.viewInfo.rulers,this._typicalHalfwidthCharacterWidth=this._context.configuration.editor.fontInfo.typicalHalfwidthCharacterWidth,!0)},t.prototype.onScrollChanged=function(X){return X.scrollHeightChanged},t.prototype.prepareRender=function(X){},t.prototype._ensureRulersCount=function(){var X=this._renderedRulers.length,$=this._rulers.length;if(X!==$)if(X<$)for(var J=this._context.model.getTabSize(),ee=$-X;ee>0;)(ne=Q.createFastDomNode(document.createElement("div"))).setClassName("view-ruler"),ne.setWidth(J),this.domNode.appendChild(ne),this._renderedRulers.push(ne),ee--;else for(var te=X-$;te>0;){var ne=this._renderedRulers.pop();this.domNode.removeChild(ne),te--}},t.prototype.render=function(X){this._ensureRulersCount();for(var $=0,Q=this._rulers.length;$<Q;$++){var J=this._renderedRulers[$];J.setHeight(Math.min(X.scrollHeight,1e6)),J.setLeft(this._rulers[$]*this._typicalHalfwidthCharacterWidth)}},t}(J.ViewPart);$.Rulers=ie,ne.registerThemingParticipant((function(X,$){var Q=X.getColor(ee.editorRuler);Q&&$.addRule(".monaco-editor .view-ruler { box-shadow: 1px 0 0 0 "+Q+" inset; }")}))})),define(Q[503],n([0,1,23,16,33,434,48,34,13,295]),(function(X,$,Q,J,ee,ne,ie,oe,re){Object.defineProperty($,"__esModule",{value:!0});var se=function(X){function t($){var ee=X.call(this,$)||this;return ee._readOnly=ee._context.configuration.editor.readOnly,ee._cursorBlinking=ee._context.configuration.editor.viewInfo.cursorBlinking,ee._cursorStyle=ee._context.configuration.editor.viewInfo.cursorStyle,ee._selectionIsEmpty=!0,ee._primaryCursor=new ne.ViewCursor(ee._context),ee._secondaryCursors=[],ee._renderData=[],ee._domNode=Q.createFastDomNode(document.createElement("div")),ee._domNode.setAttribute("role","presentation"),ee._domNode.setAttribute("aria-hidden","true"),ee._updateDomClassName(),ee._domNode.appendChild(ee._primaryCursor.getDomNode()),ee._startCursorBlinkAnimation=new J.TimeoutTimer,ee._cursorFlatBlinkInterval=new J.IntervalTimer,ee._blinkingEnabled=!1,ee._editorHasFocus=!1,ee._updateBlinking(),ee}return te(t,X),t.prototype.dispose=function(){X.prototype.dispose.call(this),this._startCursorBlinkAnimation.dispose(),this._cursorFlatBlinkInterval.dispose()},t.prototype.getDomNode=function(){return this._domNode},t.prototype.onConfigurationChanged=function(X){X.readOnly&&(this._readOnly=this._context.configuration.editor.readOnly),X.viewInfo&&(this._cursorBlinking=this._context.configuration.editor.viewInfo.cursorBlinking,this._cursorStyle=this._context.configuration.editor.viewInfo.cursorStyle),this._primaryCursor.onConfigurationChanged(X),this._updateBlinking(),X.viewInfo&&this._updateDomClassName();for(var $=0,Q=this._secondaryCursors.length;$<Q;$++)this._secondaryCursors[$].onConfigurationChanged(X);return!0},t.prototype._onCursorPositionChanged=function(X,$){if(this._primaryCursor.onCursorPositionChanged(X),this._updateBlinking(),this._secondaryCursors.length<$.length)for(var Q=$.length-this._secondaryCursors.length,J=0;J<Q;J++){var ee=new ne.ViewCursor(this._context);this._domNode.domNode.insertBefore(ee.getDomNode().domNode,this._primaryCursor.getDomNode().domNode.nextSibling),this._secondaryCursors.push(ee)}else if(this._secondaryCursors.length>$.length){var te=this._secondaryCursors.length-$.length;for(J=0;J<te;J++)this._domNode.removeChild(this._secondaryCursors[0].getDomNode()),this._secondaryCursors.splice(0,1)}for(J=0;J<$.length;J++)this._secondaryCursors[J].onCursorPositionChanged($[J])},t.prototype.onCursorStateChanged=function(X){for(var $=[],Q=0,J=X.selections.length;Q<J;Q++)$[Q]=X.selections[Q].getPosition();this._onCursorPositionChanged($[0],$.slice(1));var ee=X.selections[0].isEmpty();return this._selectionIsEmpty!==ee&&(this._selectionIsEmpty=ee,this._updateDomClassName()),!0},t.prototype.onDecorationsChanged=function(X){return!0},t.prototype.onFlushed=function(X){return!0},t.prototype.onFocusChanged=function(X){return this._editorHasFocus=X.isFocused,this._updateBlinking(),!1},t.prototype.onLinesChanged=function(X){return!0},t.prototype.onLinesDeleted=function(X){return!0},t.prototype.onLinesInserted=function(X){return!0},t.prototype.onScrollChanged=function(X){return!0},t.prototype.onTokensChanged=function(X){var t=function($){for(var Q=0,J=X.ranges.length;Q<J;Q++)if(X.ranges[Q].fromLineNumber<=$.lineNumber&&$.lineNumber<=X.ranges[Q].toLineNumber)return!0;return!1};if(t(this._primaryCursor.getPosition()))return!0;for(var $=0;$<this._secondaryCursors.length;$++)if(t(this._secondaryCursors[$].getPosition()))return!0;return!1},t.prototype.onZonesChanged=function(X){return!0},t.prototype._getCursorBlinking=function(){return this._editorHasFocus?this._readOnly?5:this._cursorBlinking:0},t.prototype._updateBlinking=function(){var X=this;this._startCursorBlinkAnimation.cancel(),this._cursorFlatBlinkInterval.cancel();var $=this._getCursorBlinking(),Q=0===$,J=5===$;Q?this._hide():this._show(),this._blinkingEnabled=!1,this._updateDomClassName(),Q||J||(1===$?this._cursorFlatBlinkInterval.cancelAndSet((function(){X._isVisible?X._hide():X._show()}),t.BLINK_INTERVAL):this._startCursorBlinkAnimation.setIfNotSet((function(){X._blinkingEnabled=!0,X._updateDomClassName()}),t.BLINK_INTERVAL))},t.prototype._updateDomClassName=function(){this._domNode.setClassName(this._getClassName())},t.prototype._getClassName=function(){var X="cursors-layer";switch(this._selectionIsEmpty||(X+=" has-selection"),this._cursorStyle){case ie.TextEditorCursorStyle.Line:X+=" cursor-line-style";break;case ie.TextEditorCursorStyle.Block:X+=" cursor-block-style";break;case ie.TextEditorCursorStyle.Underline:X+=" cursor-underline-style";break;case ie.TextEditorCursorStyle.LineThin:X+=" cursor-line-thin-style";break;case ie.TextEditorCursorStyle.BlockOutline:X+=" cursor-block-outline-style";break;case ie.TextEditorCursorStyle.UnderlineThin:X+=" cursor-underline-thin-style";break;default:X+=" cursor-line-style"}if(this._blinkingEnabled)switch(this._getCursorBlinking()){case 1:X+=" cursor-blink";break;case 2:X+=" cursor-smooth";break;case 3:X+=" cursor-phase";break;case 4:X+=" cursor-expand";break;case 5:X+=" cursor-solid";break;default:X+=" cursor-solid"}else X+=" cursor-solid";return X},t.prototype._show=function(){this._primaryCursor.show();for(var X=0,$=this._secondaryCursors.length;X<$;X++)this._secondaryCursors[X].show();this._isVisible=!0},t.prototype._hide=function(){this._primaryCursor.hide();for(var X=0,$=this._secondaryCursors.length;X<$;X++)this._secondaryCursors[X].hide();this._isVisible=!1},t.prototype.prepareRender=function(X){this._primaryCursor.prepareRender(X);for(var $=0,Q=this._secondaryCursors.length;$<Q;$++)this._secondaryCursors[$].prepareRender(X)},t.prototype.render=function(X){var $=[],Q=0,J=this._primaryCursor.render(X);J&&($[Q++]=J);for(var ee=0,te=this._secondaryCursors.length;ee<te;ee++){var ne=this._secondaryCursors[ee].render(X);ne&&($[Q++]=ne)}this._renderData=$},t.prototype.getLastRenderData=function(){return this._renderData},t.BLINK_INTERVAL=500,t}(ee.ViewPart);$.ViewCursors=se,re.registerThemingParticipant((function(X,$){var Q=X.getColor(oe.editorCursorForeground);if(Q){var J=X.getColor(oe.editorCursorBackground);J||(J=Q.opposite()),$.addRule(".monaco-editor .cursor { background-color: "+Q+"; border-color: "+Q+"; color: "+J+"; }"),"hc"===X.type&&$.addRule(".monaco-editor .cursors-layer.has-selection .cursor { border-left: 1px solid "+J+"; border-right: 1px solid "+J+"; }")}}))})),define(Q[504],n([0,1,7,23,11,489,500,446,433,33,222,496,497,223,485,136,498,187,491,225,168,227,492,228,501,229,502,493,494,503,230,12,83,208,209,69,213,79,13]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le,ue,de,ce,he,pe,fe,ge,me,ve,_e,ye,be,Ce,we,Se,Ee,Le,xe,Ie,De,Ne,Me,ke,Te,Re,Oe,Pe){function H(X){try{return X()}catch(X){ee.onUnexpectedError(X)}}Object.defineProperty($,"__esModule",{value:!0});var B=function(){throw new Error("Invalid change accessor")},Ae=function(X){function t($,Q,J,ee,te,re){var se=X.call(this)||this;se._cursor=te,se._renderAnimationFrame=null,se.outgoingEvents=re;var ae=new oe.ViewController(Q,ee,se.outgoingEvents,$);return se.eventDispatcher=new ke.ViewEventDispatcher((function(X){return se._renderOnce(X)})),se.eventDispatcher.addEventHandler(se),se._context=new Me.ViewContext(Q,J.getTheme(),ee,se.eventDispatcher),se._register(J.onThemeChange((function(X){se._context.theme=X,se.eventDispatcher.emit(new Te.ViewThemeChangedEvent),se.render(!0,!1)}))),se.viewParts=[],se._textAreaHandler=new ie.TextAreaHandler(se._context,ae,se.createTextAreaHandlerHelper()),se.viewParts.push(se._textAreaHandler),se.createViewParts(),se._setLayout(),se.pointerHandler=new ne.PointerHandler(se._context,ae,se.createPointerHandlerHelper()),se._register(ee.addEventListener((function(X){se.eventDispatcher.emitMany(X)}))),se._register(se._cursor.addEventListener((function(X){se.eventDispatcher.emitMany(X)}))),se}return te(t,X),t.prototype.createViewParts=function(){this.linesContent=J.createFastDomNode(document.createElement("div")),this.linesContent.setClassName("lines-content monaco-editor-background"),this.linesContent.setPosition("absolute"),this.domNode=J.createFastDomNode(document.createElement("div")),this.domNode.setClassName(this.getEditorClassName()),this.overflowGuardContainer=J.createFastDomNode(document.createElement("div")),se.PartFingerprints.write(this.overflowGuardContainer,3),this.overflowGuardContainer.setClassName("overflow-guard"),this._scrollbar=new ce.EditorScrollbar(this._context,this.linesContent,this.domNode,this.overflowGuardContainer),this.viewParts.push(this._scrollbar),this.viewLines=new ge.ViewLines(this._context,this.linesContent),this.viewZones=new Ie.ViewZones(this._context),this.viewParts.push(this.viewZones);var X=new Ce.DecorationsOverviewRuler(this._context);this.viewParts.push(X);var $=new Ee.ScrollDecorationViewPart(this._context);this.viewParts.push($);var Q=new re.ContentViewOverlays(this._context);this.viewParts.push(Q),Q.addDynamicOverlay(new le.CurrentLineHighlightOverlay(this._context)),Q.addDynamicOverlay(new Le.SelectionsOverlay(this._context)),Q.addDynamicOverlay(new pe.IndentGuidesOverlay(this._context)),Q.addDynamicOverlay(new de.DecorationsOverlay(this._context));var ee=new re.MarginViewOverlays(this._context);this.viewParts.push(ee),ee.addDynamicOverlay(new ue.CurrentLineMarginHighlightOverlay(this._context)),ee.addDynamicOverlay(new he.GlyphMarginOverlay(this._context)),ee.addDynamicOverlay(new _e.MarginViewLineDecorationsOverlay(this._context)),ee.addDynamicOverlay(new me.LinesDecorationsOverlay(this._context)),ee.addDynamicOverlay(new fe.LineNumbersOverlay(this._context));var te=new ve.Margin(this._context);te.getDomNode().appendChild(this.viewZones.marginDomNode),te.getDomNode().appendChild(ee.getDomNode()),this.viewParts.push(te),this.contentWidgets=new ae.ViewContentWidgets(this._context,this.domNode),this.viewParts.push(this.contentWidgets),this.viewCursors=new xe.ViewCursors(this._context),this.viewParts.push(this.viewCursors),this.overlayWidgets=new be.ViewOverlayWidgets(this._context),this.viewParts.push(this.overlayWidgets);var ne=new Se.Rulers(this._context);this.viewParts.push(ne);var ie=new ye.Minimap(this._context);if(this.viewParts.push(ie),X){var oe=this._scrollbar.getOverviewRulerLayoutInfo();oe.parent.insertBefore(X.getDomNode(),oe.insertBefore)}this.linesContent.appendChild(Q.getDomNode()),this.linesContent.appendChild(ne.domNode),this.linesContent.appendChild(this.viewZones.domNode),this.linesContent.appendChild(this.viewLines.getDomNode()),this.linesContent.appendChild(this.contentWidgets.domNode),this.linesContent.appendChild(this.viewCursors.getDomNode()),this.overflowGuardContainer.appendChild(te.getDomNode()),this.overflowGuardContainer.appendChild(this._scrollbar.getDomNode()),this.overflowGuardContainer.appendChild($.getDomNode()),this.overflowGuardContainer.appendChild(this._textAreaHandler.textArea),this.overflowGuardContainer.appendChild(this._textAreaHandler.textAreaCover),this.overflowGuardContainer.appendChild(this.overlayWidgets.getDomNode()),this.overflowGuardContainer.appendChild(ie.getDomNode()),this.domNode.appendChild(this.overflowGuardContainer),this.domNode.appendChild(this.contentWidgets.overflowingContentWidgetsDomNode)},t.prototype._flushAccumulatedAndRenderNow=function(){this._renderNow()},t.prototype.createPointerHandlerHelper=function(){var X=this;return{viewDomNode:this.domNode.domNode,linesContentDomNode:this.linesContent.domNode,focusTextArea:function(){X.focus()},getLastViewCursorsRenderData:function(){return X.viewCursors.getLastRenderData()||[]},shouldSuppressMouseDownOnViewZone:function($){return X.viewZones.shouldSuppressMouseDownOnViewZone($)},shouldSuppressMouseDownOnWidget:function($){return X.contentWidgets.shouldSuppressMouseDownOnWidget($)},getPositionFromDOMInfo:function($,Q){return X._flushAccumulatedAndRenderNow(),X.viewLines.getPositionFromDOMInfo($,Q)},visibleRangeForPosition2:function($,Q){return X._flushAccumulatedAndRenderNow(),X.viewLines.visibleRangeForPosition(new De.Position($,Q))},getLineWidth:function($){return X._flushAccumulatedAndRenderNow(),X.viewLines.getLineWidth($)}}},t.prototype.createTextAreaHandlerHelper=function(){var X=this;return{visibleRangeForPositionRelativeToEditor:function($,Q){return X._flushAccumulatedAndRenderNow(),X.viewLines.visibleRangeForPosition(new De.Position($,Q))}}},t.prototype._setLayout=function(){var X=this._context.configuration.editor.layoutInfo;this.domNode.setWidth(X.width),this.domNode.setHeight(X.height),this.overflowGuardContainer.setWidth(X.width),this.overflowGuardContainer.setHeight(X.height),this.linesContent.setWidth(1e6),this.linesContent.setHeight(1e6)},t.prototype.getEditorClassName=function(){var X=this._textAreaHandler.isFocused()?" focused":"";return this._context.configuration.editor.editorClassName+" "+Pe.getThemeTypeSelector(this._context.theme.type)+X},t.prototype.onConfigurationChanged=function(X){return X.editorClassName&&this.domNode.setClassName(this.getEditorClassName()),X.layoutInfo&&this._setLayout(),!1},t.prototype.onFocusChanged=function(X){return this.domNode.setClassName(this.getEditorClassName()),this._context.model.setHasFocus(X.isFocused),X.isFocused?this.outgoingEvents.emitViewFocusGained():this.outgoingEvents.emitViewFocusLost(),!1},t.prototype.onScrollChanged=function(X){return this.outgoingEvents.emitScrollChanged(X),!1},t.prototype.onThemeChanged=function(X){return this.domNode.setClassName(this.getEditorClassName()),!1},t.prototype.dispose=function(){null!==this._renderAnimationFrame&&(this._renderAnimationFrame.dispose(),this._renderAnimationFrame=null),this.eventDispatcher.removeEventHandler(this),this.outgoingEvents.dispose(),this.pointerHandler.dispose(),this.viewLines.dispose();for(var $=0,Q=this.viewParts.length;$<Q;$++)this.viewParts[$].dispose();this.viewParts=[],X.prototype.dispose.call(this)},t.prototype._renderOnce=function(X){var $=H(X);return this._scheduleRender(),$},t.prototype._scheduleRender=function(){null===this._renderAnimationFrame&&(this._renderAnimationFrame=Q.runAtThisOrScheduleAtNextAnimationFrame(this._onRenderScheduled.bind(this),100))},t.prototype._onRenderScheduled=function(){this._renderAnimationFrame=null,this._flushAccumulatedAndRenderNow()},t.prototype._renderNow=function(){var X=this;H((function(){return X._actualRender()}))},t.prototype._getViewPartsToRender=function(){for(var X=[],$=0,Q=0,J=this.viewParts.length;Q<J;Q++){var ee=this.viewParts[Q];ee.shouldRender()&&(X[$++]=ee)}return X},t.prototype._actualRender=function(){if(Q.isInDOM(this.domNode.domNode)){var X=this._getViewPartsToRender();if(this.viewLines.shouldRender()||0!==X.length){var $=this._context.viewLayout.getLinesViewportData();this._context.model.setViewport($.startLineNumber,$.endLineNumber,$.centeredLineNumber);var J=new Re.ViewportData(this._cursor.getViewSelections(),$,this._context.viewLayout.getWhitespaceViewportData(),this._context.model);this.contentWidgets.shouldRender()&&this.contentWidgets.onBeforeRender(J),this.viewLines.shouldRender()&&(this.viewLines.renderText(J),this.viewLines.onDidRender(),X=this._getViewPartsToRender());for(var ee=new Ne.RenderingContext(this._context.viewLayout,J,this.viewLines),te=0,ne=X.length;te<ne;te++)(ie=X[te]).prepareRender(ee);for(te=0,ne=X.length;te<ne;te++){var ie=X[te];ie.render(ee),ie.onDidRender()}}}},t.prototype.delegateVerticalScrollbarMouseDown=function(X){this._scrollbar.delegateVerticalScrollbarMouseDown(X)},t.prototype.restoreState=function(X){this._context.viewLayout.setScrollPositionNow({scrollTop:X.scrollTop}),this._renderNow(),this.viewLines.updateLineWidths(),this._context.viewLayout.setScrollPositionNow({scrollLeft:X.scrollLeft})},t.prototype.getOffsetForColumn=function(X,$){var Q=this._context.model.validateModelPosition({lineNumber:X,column:$}),J=this._context.model.coordinatesConverter.convertModelPositionToViewPosition(Q);this._flushAccumulatedAndRenderNow();var ee=this.viewLines.visibleRangeForPosition(new De.Position(J.lineNumber,J.column));return ee?ee.left:-1},t.prototype.getTargetAtClientPoint=function(X,$){return this.pointerHandler.getTargetAtClientPoint(X,$)},t.prototype.createOverviewRuler=function(X){return new we.OverviewRuler(this._context,X)},t.prototype.change=function(X){var $=this,Q=!1;return this._renderOnce((function(){var J={addZone:function(X){return Q=!0,$.viewZones.addZone(X)},removeZone:function(X){X&&(Q=$.viewZones.removeZone(X)||Q)},layoutZone:function(X){X&&(Q=$.viewZones.layoutZone(X)||Q)}};!function(X,$){try{X($)}catch(X){ee.onUnexpectedError(X)}}(X,J),J.addZone=B,J.removeZone=B,J.layoutZone=B,Q&&($._context.viewLayout.onHeightMaybeChanged(),$._context.privateViewEventBus.emit(new Te.ViewZonesChangedEvent))})),Q},t.prototype.render=function(X,$){if($){this.viewLines.forceShouldRender();for(var Q=0,J=this.viewParts.length;Q<J;Q++)this.viewParts[Q].forceShouldRender()}X?this._flushAccumulatedAndRenderNow():this._scheduleRender()},t.prototype.focus=function(){this._textAreaHandler.focusTextArea()},t.prototype.isFocused=function(){return this._textAreaHandler.isFocused()},t.prototype.addContentWidget=function(X){this.contentWidgets.addWidget(X.widget),this.layoutContentWidget(X),this._scheduleRender()},t.prototype.layoutContentWidget=function(X){var $=X.position?X.position.position:null,Q=X.position?X.position.range:null,J=X.position?X.position.preference:null;this.contentWidgets.setWidgetPosition(X.widget,$,Q,J),this._scheduleRender()},t.prototype.removeContentWidget=function(X){this.contentWidgets.removeWidget(X.widget),this._scheduleRender()},t.prototype.addOverlayWidget=function(X){this.overlayWidgets.addWidget(X.widget),this.layoutOverlayWidget(X),this._scheduleRender()},t.prototype.layoutOverlayWidget=function(X){var $=X.position?X.position.preference:null;this.overlayWidgets.setWidgetPosition(X.widget,$)&&this._scheduleRender()},t.prototype.removeOverlayWidget=function(X){this.overlayWidgets.removeWidget(X.widget),this._scheduleRender()},t}(Oe.ViewEventHandler);$.View=Ae})),define(Q[99],n([0,1,290,7,11,6,2,50,57,10,30,504,490,380,38,12,3,21,165,54,19,14,34,390,31,18,15,98,35,13,355,358]),(function(X,$,Q,J,ee,ie,re,se,ae,le,ue,de,ce,he,pe,fe,ge,me,ve,_e,ye,be,Ce,we,Se,Ee,Le,xe,Ie,De){function R(X){return Fe+encodeURIComponent(X.toString())+We}Object.defineProperty($,"__esModule",{value:!0});var Ne=0,Me="showUnused",ke=function(){function e(X,$,Q,J,ee,te){this.model=X,this.viewModel=$,this.cursor=Q,this.view=J,this.hasRealView=ee,this.listenersToRemove=te}return e.prototype.dispose=function(){re.dispose(this.listenersToRemove),this.model.onBeforeDetached(),this.hasRealView&&this.view.dispose(),this.cursor.dispose(),this.viewModel.dispose()},e}(),Te=function(X){function t($,Q,J,te,ne,oe,re,se,ae){var ue=X.call(this)||this;ue._onDidDispose=ue._register(new ie.Emitter),ue.onDidDispose=ue._onDidDispose.event,ue._onDidChangeModelContent=ue._register(new ie.Emitter),ue.onDidChangeModelContent=ue._onDidChangeModelContent.event,ue._onDidChangeModelLanguage=ue._register(new ie.Emitter),ue.onDidChangeModelLanguage=ue._onDidChangeModelLanguage.event,ue._onDidChangeModelLanguageConfiguration=ue._register(new ie.Emitter),ue.onDidChangeModelLanguageConfiguration=ue._onDidChangeModelLanguageConfiguration.event,ue._onDidChangeModelOptions=ue._register(new ie.Emitter),ue.onDidChangeModelOptions=ue._onDidChangeModelOptions.event,ue._onDidChangeModelDecorations=ue._register(new ie.Emitter),ue.onDidChangeModelDecorations=ue._onDidChangeModelDecorations.event,ue._onDidChangeConfiguration=ue._register(new ie.Emitter),ue.onDidChangeConfiguration=ue._onDidChangeConfiguration.event,ue._onDidChangeModel=ue._register(new ie.Emitter),ue.onDidChangeModel=ue._onDidChangeModel.event,ue._onDidChangeCursorPosition=ue._register(new ie.Emitter),ue.onDidChangeCursorPosition=ue._onDidChangeCursorPosition.event,ue._onDidChangeCursorSelection=ue._register(new ie.Emitter),ue.onDidChangeCursorSelection=ue._onDidChangeCursorSelection.event,ue._onDidAttemptReadOnlyEdit=ue._register(new ie.Emitter),ue.onDidAttemptReadOnlyEdit=ue._onDidAttemptReadOnlyEdit.event,ue._onDidLayoutChange=ue._register(new ie.Emitter),ue.onDidLayoutChange=ue._onDidLayoutChange.event,ue._editorTextFocus=ue._register(new Re),ue.onDidFocusEditorText=ue._editorTextFocus.onDidChangeToTrue,ue.onDidBlurEditorText=ue._editorTextFocus.onDidChangeToFalse,ue._editorWidgetFocus=ue._register(new Re),ue.onDidFocusEditorWidget=ue._editorWidgetFocus.onDidChangeToTrue,ue.onDidBlurEditorWidget=ue._editorWidgetFocus.onDidChangeToFalse,ue._onWillType=ue._register(new ie.Emitter),ue.onWillType=ue._onWillType.event,ue._onDidType=ue._register(new ie.Emitter),ue.onDidType=ue._onDidType.event,ue._onCompositionStart=ue._register(new ie.Emitter),ue.onCompositionStart=ue._onCompositionStart.event,ue._onCompositionEnd=ue._register(new ie.Emitter),ue.onCompositionEnd=ue._onCompositionEnd.event,ue._onDidPaste=ue._register(new ie.Emitter),ue.onDidPaste=ue._onDidPaste.event,ue._onMouseUp=ue._register(new ie.Emitter),ue.onMouseUp=ue._onMouseUp.event,ue._onMouseDown=ue._register(new ie.Emitter),ue.onMouseDown=ue._onMouseDown.event,ue._onMouseDrag=ue._register(new ie.Emitter),ue.onMouseDrag=ue._onMouseDrag.event,ue._onMouseDrop=ue._register(new ie.Emitter),ue.onMouseDrop=ue._onMouseDrop.event,ue._onContextMenu=ue._register(new ie.Emitter),ue.onContextMenu=ue._onContextMenu.event,ue._onMouseMove=ue._register(new ie.Emitter),ue.onMouseMove=ue._onMouseMove.event,ue._onMouseLeave=ue._register(new ie.Emitter),ue.onMouseLeave=ue._onMouseLeave.event,ue._onKeyUp=ue._register(new ie.Emitter),ue.onKeyUp=ue._onKeyUp.event,ue._onKeyDown=ue._register(new ie.Emitter),ue.onKeyDown=ue._onKeyDown.event,ue._onDidScrollChange=ue._register(new ie.Emitter),ue.onDidScrollChange=ue._onDidScrollChange.event,ue._onDidChangeViewZones=ue._register(new ie.Emitter),ue.onDidChangeViewZones=ue._onDidChangeViewZones.event,ue._domElement=$,ue._id=++Ne,ue._decorationTypeKeysToIds={},ue._decorationTypeSubtypes={},ue.isSimpleWidget=J.isSimpleWidget||!1,ue._telemetryData=J.telemetryData||null,Q=Q||{},ue._configuration=ue._register(ue._createConfiguration(Q)),ue._register(ue._configuration.onDidChange((function(X){ue._onDidChangeConfiguration.fire(X),X.layoutInfo&&ue._onDidLayoutChange.fire(ue._configuration.editor.layoutInfo),ue._configuration.editor.showUnused?ue._domElement.classList.add(Me):ue._domElement.classList.remove(Me)}))),ue._contextKeyService=ue._register(re.createScoped(ue._domElement)),ue._notificationService=ae,ue._codeEditorService=ne,ue._commandService=oe,ue._themeService=se,ue._register(new Oe(ue,ue._contextKeyService)),ue._register(new Pe(ue,ue._contextKeyService)),ue._instantiationService=te.createChild(new xe.ServiceCollection([Ee.IContextKeyService,ue._contextKeyService])),ue._attachModel(null),ue._contributions={},ue._actions={},ue._focusTracker=new Ae($),ue._focusTracker.onChange((function(){ue._editorWidgetFocus.setValue(ue._focusTracker.hasFocus())})),ue._contentWidgets={},ue._overlayWidgets={};for(var de,ce=0,he=(de=Array.isArray(J.contributions)?J.contributions:le.EditorExtensionsRegistry.getEditorContributions()).length;ce<he;ce++){var pe=de[ce];try{var fe=ue._instantiationService.createInstance(pe,ue);ue._contributions[fe.getId()]=fe}catch(X){ee.onUnexpectedError(X)}}return le.EditorExtensionsRegistry.getEditorActions().forEach((function(X){var $=new ve.InternalEditorAction(X.id,X.label,X.alias,X.precondition,(function(){return ue._instantiationService.invokeFunction((function($){return Promise.resolve(X.runEditorCommand($,ue,null))}))}),ue._contextKeyService);ue._actions[$.id]=$})),ue._codeEditorService.addCodeEditor(ue),ue}return te(t,X),t.prototype._createConfiguration=function(X){return new ae.Configuration(X,this._domElement)},t.prototype.getId=function(){return this.getEditorType()+":"+this._id},t.prototype.getEditorType=function(){return _e.EditorType.ICodeEditor},t.prototype.dispose=function(){this._codeEditorService.removeCodeEditor(this),this._focusTracker.dispose();for(var $=Object.keys(this._contributions),Q=0,J=$.length;Q<J;Q++){var ee=$[Q];this._contributions[ee].dispose()}this._removeDecorationTypes(),this._postDetachModelCleanup(this._detachModel()),this._onDidDispose.fire(),X.prototype.dispose.call(this)},t.prototype.invokeWithinContext=function(X){return this._instantiationService.invokeFunction(X)},t.prototype.updateOptions=function(X){this._configuration.updateOptions(X)},t.prototype.getConfiguration=function(){return this._configuration.editor},t.prototype.getRawConfiguration=function(){return this._configuration.getRawOptions()},t.prototype.getValue=function(X){if(void 0===X&&(X=null),!this._modelData)return"";var $=!(!X||!X.preserveBOM),Q=0;return X&&X.lineEnding&&"\n"===X.lineEnding?Q=1:X&&X.lineEnding&&"\r\n"===X.lineEnding&&(Q=2),this._modelData.model.getValue(Q,$)},t.prototype.setValue=function(X){this._modelData&&this._modelData.model.setValue(X)},t.prototype.getModel=function(){return this._modelData?this._modelData.model:null},t.prototype.setModel=function(X){if(void 0===X&&(X=null),!(null===this._modelData&&null===X||this._modelData&&this._modelData.model===X)){var $=this._detachModel();this._attachModel(X);var Q={oldModelUrl:$?$.uri:null,newModelUrl:X?X.uri:null};this._removeDecorationTypes(),this._onDidChangeModel.fire(Q),this._postDetachModelCleanup($)}},t.prototype._removeDecorationTypes=function(){if(this._decorationTypeKeysToIds={},this._decorationTypeSubtypes){for(var X in this._decorationTypeSubtypes){var $=this._decorationTypeSubtypes[X];for(var Q in $)this._removeDecorationType(X+"-"+Q)}this._decorationTypeSubtypes={}}},t.prototype.getVisibleRanges=function(){return this._modelData?this._modelData.viewModel.getVisibleRanges():[]},t.prototype.getWhitespaces=function(){return this._modelData?this._modelData.viewModel.viewLayout.getWhitespaces():[]},t._getVerticalOffsetForPosition=function(X,$,Q){var J=X.model.validatePosition({lineNumber:$,column:Q}),ee=X.viewModel.coordinatesConverter.convertModelPositionToViewPosition(J);return X.viewModel.viewLayout.getVerticalOffsetForLineNumber(ee.lineNumber)},t.prototype.getTopForLineNumber=function(X){return this._modelData?t._getVerticalOffsetForPosition(this._modelData,X,1):-1},t.prototype.getTopForPosition=function(X,$){return this._modelData?t._getVerticalOffsetForPosition(this._modelData,X,$):-1},t.prototype.setHiddenAreas=function(X){this._modelData&&this._modelData.viewModel.setHiddenAreas(X.map((function(X){return ge.Range.lift(X)})))},t.prototype.getVisibleColumnFromPosition=function(X){if(!this._modelData)return X.column;var $=this._modelData.model.validatePosition(X),Q=this._modelData.model.getOptions().tabSize;return pe.CursorColumns.visibleColumnFromColumn(this._modelData.model.getLineContent($.lineNumber),$.column,Q)+1},t.prototype.getPosition=function(){return this._modelData?this._modelData.cursor.getPosition():null},t.prototype.setPosition=function(X){if(this._modelData){if(!fe.Position.isIPosition(X))throw new Error("Invalid arguments");this._modelData.cursor.setSelections("api",[{selectionStartLineNumber:X.lineNumber,selectionStartColumn:X.column,positionLineNumber:X.lineNumber,positionColumn:X.column}])}},t.prototype._sendRevealRange=function(X,$,Q,J){if(this._modelData){if(!ge.Range.isIRange(X))throw new Error("Invalid arguments");var ee=this._modelData.model.validateRange(X),te=this._modelData.viewModel.coordinatesConverter.convertModelRangeToViewRange(ee);this._modelData.cursor.emitCursorRevealRange(te,$,Q,J)}},t.prototype.revealLine=function(X,$){void 0===$&&($=0),this._revealLine(X,0,$)},t.prototype.revealLineInCenter=function(X,$){void 0===$&&($=0),this._revealLine(X,1,$)},t.prototype.revealLineInCenterIfOutsideViewport=function(X,$){void 0===$&&($=0),this._revealLine(X,2,$)},t.prototype._revealLine=function(X,$,Q){if("number"!=typeof X)throw new Error("Invalid arguments");this._sendRevealRange(new ge.Range(X,1,X,1),$,!1,Q)},t.prototype.revealPosition=function(X,$){void 0===$&&($=0),this._revealPosition(X,0,!0,$)},t.prototype.revealPositionInCenter=function(X,$){void 0===$&&($=0),this._revealPosition(X,1,!0,$)},t.prototype.revealPositionInCenterIfOutsideViewport=function(X,$){void 0===$&&($=0),this._revealPosition(X,2,!0,$)},t.prototype._revealPosition=function(X,$,Q,J){if(!fe.Position.isIPosition(X))throw new Error("Invalid arguments");this._sendRevealRange(new ge.Range(X.lineNumber,X.column,X.lineNumber,X.column),$,Q,J)},t.prototype.getSelection=function(){return this._modelData?this._modelData.cursor.getSelection():null},t.prototype.getSelections=function(){return this._modelData?this._modelData.cursor.getSelections():null},t.prototype.setSelection=function(X){var $=me.Selection.isISelection(X),Q=ge.Range.isIRange(X);if(!$&&!Q)throw new Error("Invalid arguments");if($)this._setSelectionImpl(X);else if(Q){var J={selectionStartLineNumber:X.startLineNumber,selectionStartColumn:X.startColumn,positionLineNumber:X.endLineNumber,positionColumn:X.endColumn};this._setSelectionImpl(J)}},t.prototype._setSelectionImpl=function(X){if(this._modelData){var $=new me.Selection(X.selectionStartLineNumber,X.selectionStartColumn,X.positionLineNumber,X.positionColumn);this._modelData.cursor.setSelections("api",[$])}},t.prototype.revealLines=function(X,$,Q){void 0===Q&&(Q=0),this._revealLines(X,$,0,Q)},t.prototype.revealLinesInCenter=function(X,$,Q){void 0===Q&&(Q=0),this._revealLines(X,$,1,Q)},t.prototype.revealLinesInCenterIfOutsideViewport=function(X,$,Q){void 0===Q&&(Q=0),this._revealLines(X,$,2,Q)},t.prototype._revealLines=function(X,$,Q,J){if("number"!=typeof X||"number"!=typeof $)throw new Error("Invalid arguments");this._sendRevealRange(new ge.Range(X,1,$,1),Q,!1,J)},t.prototype.revealRange=function(X,$,Q,J){void 0===$&&($=0),void 0===Q&&(Q=!1),void 0===J&&(J=!0),this._revealRange(X,Q?1:0,J,$)},t.prototype.revealRangeInCenter=function(X,$){void 0===$&&($=0),this._revealRange(X,1,!0,$)},t.prototype.revealRangeInCenterIfOutsideViewport=function(X,$){void 0===$&&($=0),this._revealRange(X,2,!0,$)},t.prototype.revealRangeAtTop=function(X,$){void 0===$&&($=0),this._revealRange(X,3,!0,$)},t.prototype._revealRange=function(X,$,Q,J){if(!ge.Range.isIRange(X))throw new Error("Invalid arguments");this._sendRevealRange(ge.Range.lift(X),$,Q,J)},t.prototype.setSelections=function(X,$){if(void 0===$&&($="api"),this._modelData){if(!X||0===X.length)throw new Error("Invalid arguments");for(var Q=0,J=X.length;Q<J;Q++)if(!me.Selection.isISelection(X[Q]))throw new Error("Invalid arguments");this._modelData.cursor.setSelections($,X)}},t.prototype.getScrollWidth=function(){return this._modelData?this._modelData.viewModel.viewLayout.getScrollWidth():-1},t.prototype.getScrollLeft=function(){return this._modelData?this._modelData.viewModel.viewLayout.getCurrentScrollLeft():-1},t.prototype.getScrollHeight=function(){return this._modelData?this._modelData.viewModel.viewLayout.getScrollHeight():-1},t.prototype.getScrollTop=function(){return this._modelData?this._modelData.viewModel.viewLayout.getCurrentScrollTop():-1},t.prototype.setScrollLeft=function(X){if(this._modelData){if("number"!=typeof X)throw new Error("Invalid arguments");this._modelData.viewModel.viewLayout.setScrollPositionNow({scrollLeft:X})}},t.prototype.setScrollTop=function(X){if(this._modelData){if("number"!=typeof X)throw new Error("Invalid arguments");this._modelData.viewModel.viewLayout.setScrollPositionNow({scrollTop:X})}},t.prototype.setScrollPosition=function(X){this._modelData&&this._modelData.viewModel.viewLayout.setScrollPositionNow(X)},t.prototype.saveViewState=function(){if(!this._modelData)return null;for(var X={},$=Object.keys(this._contributions),Q=0,J=$.length;Q<J;Q++){var ee=$[Q],te=this._contributions[ee];"function"==typeof te.saveViewState&&(X[ee]=te.saveViewState())}return{cursorState:this._modelData.cursor.saveState(),viewState:this._modelData.viewModel.saveState(),contributionsState:X}},t.prototype.restoreViewState=function(X){if(this._modelData&&this._modelData.hasRealView&&X&&X.cursorState&&X.viewState){var $=X.cursorState;Array.isArray($)?this._modelData.cursor.restoreState($):this._modelData.cursor.restoreState([$]);for(var Q=X.contributionsState||{},J=Object.keys(this._contributions),ee=0,te=J.length;ee<te;ee++){var ne=J[ee],ie=this._contributions[ne];"function"==typeof ie.restoreViewState&&ie.restoreViewState(Q[ne])}var oe=this._modelData.viewModel.reduceRestoreState(X.viewState),re=this._modelData.viewModel.viewLayout.getLinesViewportDataAtScrollTop(oe.scrollTop),se=this._modelData.viewModel.coordinatesConverter.convertViewPositionToModelPosition(new fe.Position(re.startLineNumber,1)),ae=this._modelData.viewModel.coordinatesConverter.convertViewPositionToModelPosition(new fe.Position(re.endLineNumber,1));this._modelData.model.tokenizeViewport(se.lineNumber,ae.lineNumber),this._modelData.view.restoreState(oe)}},t.prototype.getContribution=function(X){return this._contributions[X]||null},t.prototype.getActions=function(){for(var X=[],$=Object.keys(this._actions),Q=0,J=$.length;Q<J;Q++){var ee=$[Q];X.push(this._actions[ee])}return X},t.prototype.getSupportedActions=function(){var X=this.getActions();return X.filter((function(X){return X.isSupported()}))},t.prototype.getAction=function(X){return this._actions[X]||null},t.prototype.trigger=function(X,$,Q){if(Q=Q||{},$===_e.Handler.Type){if(!this._modelData||"string"!=typeof Q.text||0===Q.text.length)return;return"keyboard"===X&&this._onWillType.fire(Q.text),this._modelData.cursor.trigger(X,$,Q),void("keyboard"===X&&this._onDidType.fire(Q.text))}if($!==_e.Handler.Paste){$===_e.Handler.CompositionStart&&this._onCompositionStart.fire(),$===_e.Handler.CompositionEnd&&this._onCompositionEnd.fire();var J=this.getAction($);J?Promise.resolve(J.run()).then(null,ee.onUnexpectedError):this._modelData&&(this._triggerEditorCommand(X,$,Q)||this._modelData.cursor.trigger(X,$,Q))}else{if(!this._modelData||"string"!=typeof Q.text||0===Q.text.length)return;var te=this._modelData.cursor.getSelection().getStartPosition();this._modelData.cursor.trigger(X,$,Q);var ne=this._modelData.cursor.getSelection().getStartPosition();"keyboard"===X&&this._onDidPaste.fire(new ge.Range(te.lineNumber,te.column,ne.lineNumber,ne.column))}},t.prototype._triggerEditorCommand=function(X,$,Q){var J=this,te=le.EditorExtensionsRegistry.getEditorCommand($);return!!te&&((Q=Q||{}).source=X,this._instantiationService.invokeFunction((function(X){Promise.resolve(te.runEditorCommand(X,J,Q)).then(null,ee.onUnexpectedError)})),!0)},t.prototype._getCursors=function(){return this._modelData?this._modelData.cursor:null},t.prototype.pushUndoStop=function(){return!!this._modelData&&!this._configuration.editor.readOnly&&(this._modelData.model.pushStackElement(),!0)},t.prototype.executeEdits=function(X,$,Q){return!!this._modelData&&!this._configuration.editor.readOnly&&(this._modelData.model.pushEditOperations(this._modelData.cursor.getSelections(),$,(function(){return Q||null})),Q&&this._modelData.cursor.setSelections(X,Q),!0)},t.prototype.executeCommand=function(X,$){this._modelData&&this._modelData.cursor.trigger(X,_e.Handler.ExecuteCommand,$)},t.prototype.executeCommands=function(X,$){this._modelData&&this._modelData.cursor.trigger(X,_e.Handler.ExecuteCommands,$)},t.prototype.changeDecorations=function(X){return this._modelData?this._modelData.model.changeDecorations(X,this._id):null},t.prototype.getLineDecorations=function(X){return this._modelData?this._modelData.model.getLineDecorations(X,this._id,this._configuration.editor.readOnly):null},t.prototype.deltaDecorations=function(X,$){return this._modelData?0===X.length&&0===$.length?X:this._modelData.model.deltaDecorations(X,$,this._id):[]},t.prototype.removeDecorations=function(X){var $=this._decorationTypeKeysToIds[X];$&&this.deltaDecorations($,[]),this._decorationTypeKeysToIds.hasOwnProperty(X)&&delete this._decorationTypeKeysToIds[X],this._decorationTypeSubtypes.hasOwnProperty(X)&&delete this._decorationTypeSubtypes[X]},t.prototype.getLayoutInfo=function(){return this._configuration.editor.layoutInfo},t.prototype.createOverviewRuler=function(X){return this._modelData&&this._modelData.hasRealView?this._modelData.view.createOverviewRuler(X):null},t.prototype.getDomNode=function(){return this._modelData&&this._modelData.hasRealView?this._modelData.view.domNode.domNode:null},t.prototype.delegateVerticalScrollbarMouseDown=function(X){this._modelData&&this._modelData.hasRealView&&this._modelData.view.delegateVerticalScrollbarMouseDown(X)},t.prototype.layout=function(X){this._configuration.observeReferenceElement(X),this.render()},t.prototype.focus=function(){this._modelData&&this._modelData.hasRealView&&this._modelData.view.focus()},t.prototype.hasTextFocus=function(){return!(!this._modelData||!this._modelData.hasRealView)&&this._modelData.view.isFocused()},t.prototype.hasWidgetFocus=function(){return this._focusTracker&&this._focusTracker.hasFocus()},t.prototype.addContentWidget=function(X){var $={widget:X,position:X.getPosition()};this._contentWidgets.hasOwnProperty(X.getId())&&console.warn("Overwriting a content widget with the same id."),this._contentWidgets[X.getId()]=$,this._modelData&&this._modelData.hasRealView&&this._modelData.view.addContentWidget($)},t.prototype.layoutContentWidget=function(X){var $=X.getId();if(this._contentWidgets.hasOwnProperty($)){var Q=this._contentWidgets[$];Q.position=X.getPosition(),this._modelData&&this._modelData.hasRealView&&this._modelData.view.layoutContentWidget(Q)}},t.prototype.removeContentWidget=function(X){var $=X.getId();if(this._contentWidgets.hasOwnProperty($)){var Q=this._contentWidgets[$];delete this._contentWidgets[$],this._modelData&&this._modelData.hasRealView&&this._modelData.view.removeContentWidget(Q)}},t.prototype.addOverlayWidget=function(X){var $={widget:X,position:X.getPosition()};this._overlayWidgets.hasOwnProperty(X.getId())&&console.warn("Overwriting an overlay widget with the same id."),this._overlayWidgets[X.getId()]=$,this._modelData&&this._modelData.hasRealView&&this._modelData.view.addOverlayWidget($)},t.prototype.layoutOverlayWidget=function(X){var $=X.getId();if(this._overlayWidgets.hasOwnProperty($)){var Q=this._overlayWidgets[$];Q.position=X.getPosition(),this._modelData&&this._modelData.hasRealView&&this._modelData.view.layoutOverlayWidget(Q)}},t.prototype.removeOverlayWidget=function(X){var $=X.getId();if(this._overlayWidgets.hasOwnProperty($)){var Q=this._overlayWidgets[$];delete this._overlayWidgets[$],this._modelData&&this._modelData.hasRealView&&this._modelData.view.removeOverlayWidget(Q)}},t.prototype.changeViewZones=function(X){this._modelData&&this._modelData.hasRealView&&this._modelData.view.change(X)&&this._onDidChangeViewZones.fire()},t.prototype.getTargetAtClientPoint=function(X,$){return this._modelData&&this._modelData.hasRealView?this._modelData.view.getTargetAtClientPoint(X,$):null},t.prototype.getScrolledVisiblePosition=function(X){if(!this._modelData||!this._modelData.hasRealView)return null;var $=this._modelData.model.validatePosition(X),Q=this._configuration.editor.layoutInfo;return{top:t._getVerticalOffsetForPosition(this._modelData,$.lineNumber,$.column)-this.getScrollTop(),left:this._modelData.view.getOffsetForColumn($.lineNumber,$.column)+Q.glyphMarginWidth+Q.lineNumbersWidth+Q.decorationsWidth-this.getScrollLeft(),height:this._configuration.editor.lineHeight}},t.prototype.getOffsetForColumn=function(X,$){return this._modelData&&this._modelData.hasRealView?this._modelData.view.getOffsetForColumn(X,$):-1},t.prototype.render=function(){this._modelData&&this._modelData.hasRealView&&this._modelData.view.render(!0,!1)},t.prototype.applyFontInfo=function(X){ae.Configuration.applyFontInfoSlow(X,this._configuration.editor.fontInfo)},t.prototype._attachModel=function(X){var $=this;if(X){var ee=[];this._domElement.setAttribute("data-mode-id",X.getLanguageIdentifier().language),this._configuration.setIsDominatedByLongLines(X.isDominatedByLongLines()),this._configuration.setMaxLineNumber(X.getLineCount()),X.onBeforeAttached();var te=new we.ViewModel(this._id,this._configuration,X,(function(X){return J.scheduleAtNextAnimationFrame(X)}));ee.push(X.onDidChangeDecorations((function(X){return $._onDidChangeModelDecorations.fire(X)}))),ee.push(X.onDidChangeLanguage((function(Q){$._domElement.setAttribute("data-mode-id",X.getLanguageIdentifier().language),$._onDidChangeModelLanguage.fire(Q)}))),ee.push(X.onDidChangeLanguageConfiguration((function(X){return $._onDidChangeModelLanguageConfiguration.fire(X)}))),ee.push(X.onDidChangeContent((function(X){return $._onDidChangeModelContent.fire(X)}))),ee.push(X.onDidChangeOptions((function(X){return $._onDidChangeModelOptions.fire(X)}))),ee.push(X.onWillDispose((function(){return $.setModel(null)})));var ne=new he.Cursor(this._configuration,X,te);ee.push(ne.onDidReachMaxCursorCount((function(){$._notificationService.warn(Q.localize(0,null,he.Cursor.MAX_CURSOR_COUNT))}))),ee.push(ne.onDidAttemptReadOnlyEdit((function(){$._onDidAttemptReadOnlyEdit.fire(void 0)}))),ee.push(ne.onDidChange((function(X){for(var Q=[],J=0,ee=X.selections.length;J<ee;J++)Q[J]=X.selections[J].getPosition();var te={position:Q[0],secondaryPositions:Q.slice(1),reason:X.reason,source:X.source};$._onDidChangeCursorPosition.fire(te);var ne={selection:X.selections[0],secondarySelections:X.selections.slice(1),source:X.source,reason:X.reason};$._onDidChangeCursorSelection.fire(ne)})));var ie=this._createView(te,ne),oe=ie[0],re=ie[1];if(re){this._domElement.appendChild(oe.domNode.domNode);for(var se=Object.keys(this._contentWidgets),ae=0,le=se.length;ae<le;ae++)ue=se[ae],oe.addContentWidget(this._contentWidgets[ue]);for(ae=0,le=(se=Object.keys(this._overlayWidgets)).length;ae<le;ae++){var ue=se[ae];oe.addOverlayWidget(this._overlayWidgets[ue])}oe.render(!1,!0),oe.domNode.domNode.setAttribute("data-uri",X.uri.toString())}this._modelData=new ke(X,te,ne,oe,re,ee)}else this._modelData=null},t.prototype._createView=function(X,$){var Q,J=this;Q=this.isSimpleWidget?{executeEditorCommand:function(X,Q){X.runCoreEditorCommand($,Q)},paste:function(X,$,Q,ee){J.trigger(X,_e.Handler.Paste,{text:$,pasteOnNewLine:Q,multicursorText:ee})},type:function(X,$){J.trigger(X,_e.Handler.Type,{text:$})},replacePreviousChar:function(X,$,Q){J.trigger(X,_e.Handler.ReplacePreviousChar,{text:$,replaceCharCnt:Q})},compositionStart:function(X){J.trigger(X,_e.Handler.CompositionStart,void 0)},compositionEnd:function(X){J.trigger(X,_e.Handler.CompositionEnd,void 0)},cut:function(X){J.trigger(X,_e.Handler.Cut,void 0)}}:{executeEditorCommand:function(X,Q){X.runCoreEditorCommand($,Q)},paste:function(X,$,Q,ee){J._commandService.executeCommand(_e.Handler.Paste,{text:$,pasteOnNewLine:Q,multicursorText:ee})},type:function(X,$){J._commandService.executeCommand(_e.Handler.Type,{text:$})},replacePreviousChar:function(X,$,Q){J._commandService.executeCommand(_e.Handler.ReplacePreviousChar,{text:$,replaceCharCnt:Q})},compositionStart:function(X){J._commandService.executeCommand(_e.Handler.CompositionStart,{})},compositionEnd:function(X){J._commandService.executeCommand(_e.Handler.CompositionEnd,{})},cut:function(X){J._commandService.executeCommand(_e.Handler.Cut,{})}};var ee=new ce.ViewOutgoingEvents(X);return ee.onDidGainFocus=function(){J._editorTextFocus.setValue(!0),J._editorWidgetFocus.setValue(!0)},ee.onDidScroll=function(X){return J._onDidScrollChange.fire(X)},ee.onDidLoseFocus=function(){return J._editorTextFocus.setValue(!1)},ee.onContextMenu=function(X){return J._onContextMenu.fire(X)},ee.onMouseDown=function(X){return J._onMouseDown.fire(X)},ee.onMouseUp=function(X){return J._onMouseUp.fire(X)},ee.onMouseDrag=function(X){return J._onMouseDrag.fire(X)},ee.onMouseDrop=function(X){return J._onMouseDrop.fire(X)},ee.onKeyUp=function(X){return J._onKeyUp.fire(X)},ee.onMouseMove=function(X){return J._onMouseMove.fire(X)},ee.onMouseLeave=function(X){return J._onMouseLeave.fire(X)},ee.onKeyDown=function(X){return J._onKeyDown.fire(X)},[new de.View(Q,this._configuration,this._themeService,X,$,ee),!0]},t.prototype._postDetachModelCleanup=function(X){X&&X.removeAllDecorationsWithOwnerId(this._id)},t.prototype._detachModel=function(){if(!this._modelData)return null;var X=this._modelData.model,$=this._modelData.hasRealView?this._modelData.view.domNode.domNode:null;return this._modelData.dispose(),this._modelData=null,this._domElement.removeAttribute("data-mode-id"),$&&this._domElement.removeChild($),X},t.prototype._removeDecorationType=function(X){this._codeEditorService.removeDecorationType(X)},t.prototype.getTelemetryData=function(){return this._telemetryData},t.prototype.hasModel=function(){return null!==this._modelData},t=ne([oe(3,Le.IInstantiationService),oe(4,ue.ICodeEditorService),oe(5,Se.ICommandService),oe(6,Ee.IContextKeyService),oe(7,De.IThemeService),oe(8,Ie.INotificationService)],t)}(re.Disposable);$.CodeEditorWidget=Te;var Re=function(X){function t(){var $=X.call(this)||this;return $._onDidChangeToTrue=$._register(new ie.Emitter),$.onDidChangeToTrue=$._onDidChangeToTrue.event,$._onDidChangeToFalse=$._register(new ie.Emitter),$.onDidChangeToFalse=$._onDidChangeToFalse.event,$._value=0,$}return te(t,X),t.prototype.setValue=function(X){var $=X?2:1;this._value!==$&&(this._value=$,2===this._value?this._onDidChangeToTrue.fire():1===this._value&&this._onDidChangeToFalse.fire())},t}(re.Disposable);$.BooleanEventEmitter=Re;var Oe=function(X){function t($,Q){var J=X.call(this)||this;return J._editor=$,Q.createKey("editorId",$.getId()),J._editorFocus=ye.EditorContextKeys.focus.bindTo(Q),J._textInputFocus=ye.EditorContextKeys.textInputFocus.bindTo(Q),J._editorTextFocus=ye.EditorContextKeys.editorTextFocus.bindTo(Q),J._editorTabMovesFocus=ye.EditorContextKeys.tabMovesFocus.bindTo(Q),J._editorReadonly=ye.EditorContextKeys.readOnly.bindTo(Q),J._hasMultipleSelections=ye.EditorContextKeys.hasMultipleSelections.bindTo(Q),J._hasNonEmptySelection=ye.EditorContextKeys.hasNonEmptySelection.bindTo(Q),J._canUndo=ye.EditorContextKeys.canUndo.bindTo(Q),J._canRedo=ye.EditorContextKeys.canRedo.bindTo(Q),J._register(J._editor.onDidChangeConfiguration((function(){return J._updateFromConfig()}))),J._register(J._editor.onDidChangeCursorSelection((function(){return J._updateFromSelection()}))),J._register(J._editor.onDidFocusEditorWidget((function(){return J._updateFromFocus()}))),J._register(J._editor.onDidBlurEditorWidget((function(){return J._updateFromFocus()}))),J._register(J._editor.onDidFocusEditorText((function(){return J._updateFromFocus()}))),J._register(J._editor.onDidBlurEditorText((function(){return J._updateFromFocus()}))),J._register(J._editor.onDidChangeModel((function(){return J._updateFromModel()}))),J._register(J._editor.onDidChangeConfiguration((function(){return J._updateFromModel()}))),J._updateFromConfig(),J._updateFromSelection(),J._updateFromFocus(),J._updateFromModel(),J}return te(t,X),t.prototype._updateFromConfig=function(){var X=this._editor.getConfiguration();this._editorTabMovesFocus.set(X.tabFocusMode),this._editorReadonly.set(X.readOnly)},t.prototype._updateFromSelection=function(){var X=this._editor.getSelections();X?(this._hasMultipleSelections.set(X.length>1),this._hasNonEmptySelection.set(X.some((function(X){return!X.isEmpty()})))):(this._hasMultipleSelections.reset(),this._hasNonEmptySelection.reset())},t.prototype._updateFromFocus=function(){this._editorFocus.set(this._editor.hasWidgetFocus()&&!this._editor.isSimpleWidget),this._editorTextFocus.set(this._editor.hasTextFocus()&&!this._editor.isSimpleWidget),this._textInputFocus.set(this._editor.hasTextFocus())},t.prototype._updateFromModel=function(){var X=this._editor.getModel();this._canUndo.set(Boolean(X&&X.canUndo())),this._canRedo.set(Boolean(X&&X.canRedo()))},t}(re.Disposable),Pe=function(X){function t($,Q){var J=X.call(this)||this;J._editor=$,J._langId=ye.EditorContextKeys.languageId.bindTo(Q),J._hasCompletionItemProvider=ye.EditorContextKeys.hasCompletionItemProvider.bindTo(Q),J._hasCodeActionsProvider=ye.EditorContextKeys.hasCodeActionsProvider.bindTo(Q),J._hasCodeLensProvider=ye.EditorContextKeys.hasCodeLensProvider.bindTo(Q),J._hasDefinitionProvider=ye.EditorContextKeys.hasDefinitionProvider.bindTo(Q),J._hasImplementationProvider=ye.EditorContextKeys.hasImplementationProvider.bindTo(Q),J._hasTypeDefinitionProvider=ye.EditorContextKeys.hasTypeDefinitionProvider.bindTo(Q),J._hasHoverProvider=ye.EditorContextKeys.hasHoverProvider.bindTo(Q),J._hasDocumentHighlightProvider=ye.EditorContextKeys.hasDocumentHighlightProvider.bindTo(Q),J._hasDocumentSymbolProvider=ye.EditorContextKeys.hasDocumentSymbolProvider.bindTo(Q),J._hasReferenceProvider=ye.EditorContextKeys.hasReferenceProvider.bindTo(Q),J._hasRenameProvider=ye.EditorContextKeys.hasRenameProvider.bindTo(Q),J._hasDocumentFormattingProvider=ye.EditorContextKeys.hasDocumentFormattingProvider.bindTo(Q),J._hasDocumentSelectionFormattingProvider=ye.EditorContextKeys.hasDocumentSelectionFormattingProvider.bindTo(Q),J._hasSignatureHelpProvider=ye.EditorContextKeys.hasSignatureHelpProvider.bindTo(Q),J._isInWalkThrough=ye.EditorContextKeys.isInEmbeddedEditor.bindTo(Q);var o=function(){return J._update()};return J._register($.onDidChangeModel(o)),J._register($.onDidChangeModelLanguage(o)),J._register(be.CompletionProviderRegistry.onDidChange(o)),J._register(be.CodeActionProviderRegistry.onDidChange(o)),J._register(be.CodeLensProviderRegistry.onDidChange(o)),J._register(be.DefinitionProviderRegistry.onDidChange(o)),J._register(be.ImplementationProviderRegistry.onDidChange(o)),J._register(be.TypeDefinitionProviderRegistry.onDidChange(o)),J._register(be.HoverProviderRegistry.onDidChange(o)),J._register(be.DocumentHighlightProviderRegistry.onDidChange(o)),J._register(be.DocumentSymbolProviderRegistry.onDidChange(o)),J._register(be.ReferenceProviderRegistry.onDidChange(o)),J._register(be.RenameProviderRegistry.onDidChange(o)),J._register(be.DocumentFormattingEditProviderRegistry.onDidChange(o)),J._register(be.DocumentRangeFormattingEditProviderRegistry.onDidChange(o)),J._register(be.SignatureHelpProviderRegistry.onDidChange(o)),o(),J}return te(t,X),t.prototype.dispose=function(){X.prototype.dispose.call(this)},t.prototype.reset=function(){this._langId.reset(),this._hasCompletionItemProvider.reset(),this._hasCodeActionsProvider.reset(),this._hasCodeLensProvider.reset(),this._hasDefinitionProvider.reset(),this._hasImplementationProvider.reset(),this._hasTypeDefinitionProvider.reset(),this._hasHoverProvider.reset(),this._hasDocumentHighlightProvider.reset(),this._hasDocumentSymbolProvider.reset(),this._hasReferenceProvider.reset(),this._hasRenameProvider.reset(),this._hasDocumentFormattingProvider.reset(),this._hasDocumentSelectionFormattingProvider.reset(),this._hasSignatureHelpProvider.reset(),this._isInWalkThrough.reset()},t.prototype._update=function(){var X=this._editor.getModel();X?(this._langId.set(X.getLanguageIdentifier().language),this._hasCompletionItemProvider.set(be.CompletionProviderRegistry.has(X)),this._hasCodeActionsProvider.set(be.CodeActionProviderRegistry.has(X)),this._hasCodeLensProvider.set(be.CodeLensProviderRegistry.has(X)),this._hasDefinitionProvider.set(be.DefinitionProviderRegistry.has(X)),this._hasImplementationProvider.set(be.ImplementationProviderRegistry.has(X)),this._hasTypeDefinitionProvider.set(be.TypeDefinitionProviderRegistry.has(X)),this._hasHoverProvider.set(be.HoverProviderRegistry.has(X)),this._hasDocumentHighlightProvider.set(be.DocumentHighlightProviderRegistry.has(X)),this._hasDocumentSymbolProvider.set(be.DocumentSymbolProviderRegistry.has(X)),this._hasReferenceProvider.set(be.ReferenceProviderRegistry.has(X)),this._hasRenameProvider.set(be.RenameProviderRegistry.has(X)),this._hasSignatureHelpProvider.set(be.SignatureHelpProviderRegistry.has(X)),this._hasDocumentFormattingProvider.set(be.DocumentFormattingEditProviderRegistry.has(X)||be.DocumentRangeFormattingEditProviderRegistry.has(X)),this._hasDocumentSelectionFormattingProvider.set(be.DocumentRangeFormattingEditProviderRegistry.has(X)),this._isInWalkThrough.set(X.uri.scheme===se.Schemas.walkThroughSnippet)):this.reset()},t}(re.Disposable);$.EditorModeContext=Pe;var Ae=function(X){function t($){var Q=X.call(this)||this;return Q._onChange=Q._register(new ie.Emitter),Q.onChange=Q._onChange.event,Q._hasFocus=!1,Q._domFocusTracker=Q._register(J.trackFocus($)),Q._register(Q._domFocusTracker.onDidFocus((function(){Q._hasFocus=!0,Q._onChange.fire(void 0)}))),Q._register(Q._domFocusTracker.onDidBlur((function(){Q._hasFocus=!1,Q._onChange.fire(void 0)}))),Q}return te(t,X),t.prototype.hasFocus=function(){return this._hasFocus},t}(re.Disposable),Fe=encodeURIComponent("<svg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 6 3' enable-background='new 0 0 6 3' height='3' width='6'><g fill='"),We=encodeURIComponent("'><polygon points='5.5,0 2.5,3 1.1,3 4.1,0'/><polygon points='4,0 6,2 6,0.6 5.4,0'/><polygon points='0,2 1,3 2.4,3 0,0.6'/></g></svg>"),Ve=encodeURIComponent('<svg xmlns="http://www.w3.org/2000/svg" height="3" width="12"><g fill="'),He=encodeURIComponent('"><circle cx="1" cy="1" r="1"/><circle cx="5" cy="1" r="1"/><circle cx="9" cy="1" r="1"/></g></svg>');De.registerThemingParticipant((function(X,$){var Q=X.getColor(Ce.editorErrorBorder);Q&&$.addRule(".monaco-editor .squiggly-error { border-bottom: 4px double "+Q+"; }");var J=X.getColor(Ce.editorErrorForeground);J&&$.addRule('.monaco-editor .squiggly-error { background: url("data:image/svg+xml,'+R(J)+'") repeat-x bottom left; }');var ee=X.getColor(Ce.editorWarningBorder);ee&&$.addRule(".monaco-editor .squiggly-warning { border-bottom: 4px double "+ee+"; }");var te=X.getColor(Ce.editorWarningForeground);te&&$.addRule('.monaco-editor .squiggly-warning { background: url("data:image/svg+xml,'+R(te)+'") repeat-x bottom left; }');var ne=X.getColor(Ce.editorInfoBorder);ne&&$.addRule(".monaco-editor .squiggly-info { border-bottom: 4px double "+ne+"; }");var ie=X.getColor(Ce.editorInfoForeground);ie&&$.addRule('.monaco-editor .squiggly-info { background: url("data:image/svg+xml,'+R(ie)+'") repeat-x bottom left; }');var oe=X.getColor(Ce.editorHintBorder);oe&&$.addRule(".monaco-editor .squiggly-hint { border-bottom: 2px dotted "+oe+"; }");var re=X.getColor(Ce.editorHintForeground);re&&$.addRule('.monaco-editor .squiggly-hint { background: url("data:image/svg+xml,'+function(X){return Ve+encodeURIComponent(X.toString())+He}(re)+'") no-repeat bottom left; }');var se=X.getColor(Ce.editorUnnecessaryCodeOpacity);se&&$.addRule("."+Me+" .monaco-editor .squiggly-inline-unnecessary { opacity: "+se.rgba.a+"; will-change: opacity; }");var ae=X.getColor(Ce.editorUnnecessaryCodeBorder);ae&&$.addRule("."+Me+" .monaco-editor .squiggly-unnecessary { border-bottom: 2px dashed "+ae+"; }")}))})),define(Q[506],n([0,1,292,7,23,67,55,56,2,57,10,30,93,12,34,103,59,18,20,13,331]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le,ue,de,ce,he,pe,fe,ge,me){function b(X){for(var $=X.get(le.ICodeEditorService).listDiffEditors(),Q=0,J=$.length;Q<J;Q++){var ee=$[Q];if(ee.hasWidgetFocus())return ee}return null}Object.defineProperty($,"__esModule",{value:!0});var ve=function(){function e(X,$,Q,J){this.originalLineStart=X,this.originalLineEnd=$,this.modifiedLineStart=Q,this.modifiedLineEnd=J}return e.prototype.getType=function(){return 0===this.originalLineStart?1:0===this.modifiedLineStart?2:0},e}(),w=function(X){this.entries=X},_e=function(X){function t($){var te=X.call(this)||this;return te._width=0,te._diffEditor=$,te._isVisible=!1,te.shadow=ee.createFastDomNode(document.createElement("div")),te.shadow.setClassName("diff-review-shadow"),te.actionBarContainer=ee.createFastDomNode(document.createElement("div")),te.actionBarContainer.setClassName("diff-review-actions"),te._actionBar=te._register(new ne.ActionBar(te.actionBarContainer.domNode)),te._actionBar.push(new oe.Action("diffreview.close",Q.localize(0,null),"close-diff-review",!0,(function(){return te.hide(),null})),{label:!1,icon:!0}),te.domNode=ee.createFastDomNode(document.createElement("div")),te.domNode.setClassName("diff-review monaco-editor-background"),te._content=ee.createFastDomNode(document.createElement("div")),te._content.setClassName("diff-review-content"),te.scrollbar=te._register(new ie.DomScrollableElement(te._content.domNode,{})),te.domNode.domNode.appendChild(te.scrollbar.getDomNode()),te._register($.onDidUpdateDiff((function(){te._isVisible&&(te._diffs=te._compute(),te._render())}))),te._register($.getModifiedEditor().onDidChangeCursorPosition((function(){te._isVisible&&te._render()}))),te._register($.getOriginalEditor().onDidFocusEditorWidget((function(){te._isVisible&&te.hide()}))),te._register($.getModifiedEditor().onDidFocusEditorWidget((function(){te._isVisible&&te.hide()}))),te._register(J.addStandardDisposableListener(te.domNode.domNode,"click",(function(X){X.preventDefault();var $=J.findParentWithClass(X.target,"diff-review-row");$&&te._goToRow($)}))),te._register(J.addStandardDisposableListener(te.domNode.domNode,"keydown",(function(X){(X.equals(18)||X.equals(2066)||X.equals(530))&&(X.preventDefault(),te._goToRow(te._getNextRow())),(X.equals(16)||X.equals(2064)||X.equals(528))&&(X.preventDefault(),te._goToRow(te._getPrevRow())),(X.equals(9)||X.equals(2057)||X.equals(521)||X.equals(1033))&&(X.preventDefault(),te.hide()),(X.equals(10)||X.equals(3))&&(X.preventDefault(),te.accept())}))),te._diffs=[],te._currentDiff=null,te}return te(t,X),t.prototype.prev=function(){var X=0;if(this._isVisible||(this._diffs=this._compute()),this._isVisible){for(var $=-1,Q=0,J=this._diffs.length;Q<J;Q++)if(this._diffs[Q]===this._currentDiff){$=Q;break}X=this._diffs.length+$-1}else X=this._findDiffIndex(this._diffEditor.getPosition());0!==this._diffs.length&&(X%=this._diffs.length,this._diffEditor.setPosition(new de.Position(this._diffs[X].entries[0].modifiedLineStart,1)),this._isVisible=!0,this._diffEditor.doLayout(),this._render(),this._goToRow(this._getNextRow()))},t.prototype.next=function(){var X=0;if(this._isVisible||(this._diffs=this._compute()),this._isVisible){for(var $=-1,Q=0,J=this._diffs.length;Q<J;Q++)if(this._diffs[Q]===this._currentDiff){$=Q;break}X=$+1}else X=this._findDiffIndex(this._diffEditor.getPosition());0!==this._diffs.length&&(X%=this._diffs.length,this._diffEditor.setPosition(new de.Position(this._diffs[X].entries[0].modifiedLineStart,1)),this._isVisible=!0,this._diffEditor.doLayout(),this._render(),this._goToRow(this._getNextRow()))},t.prototype.accept=function(){var X=-1,$=this._getCurrentFocusedRow();if($){var Q=parseInt($.getAttribute("data-line"),10);isNaN(Q)||(X=Q)}this.hide(),-1!==X&&(this._diffEditor.setPosition(new de.Position(X,1)),this._diffEditor.revealPosition(new de.Position(X,1),1))},t.prototype.hide=function(){this._isVisible=!1,this._diffEditor.focus(),this._diffEditor.doLayout(),this._render()},t.prototype._getPrevRow=function(){var X=this._getCurrentFocusedRow();return X?X.previousElementSibling?X.previousElementSibling:X:this._getFirstRow()},t.prototype._getNextRow=function(){var X=this._getCurrentFocusedRow();return X?X.nextElementSibling?X.nextElementSibling:X:this._getFirstRow()},t.prototype._getFirstRow=function(){return this.domNode.domNode.querySelector(".diff-review-row")},t.prototype._getCurrentFocusedRow=function(){var X=document.activeElement;return X&&/diff-review-row/.test(X.className)?X:null},t.prototype._goToRow=function(X){var $=this._getCurrentFocusedRow();X.tabIndex=0,X.focus(),$&&$!==X&&($.tabIndex=-1),this.scrollbar.scanDomNode()},t.prototype.isVisible=function(){return this._isVisible},t.prototype.layout=function(X,$,Q){this._width=$,this.shadow.setTop(X-6),this.shadow.setWidth($),this.shadow.setHeight(this._isVisible?6:0),this.domNode.setTop(X),this.domNode.setWidth($),this.domNode.setHeight(Q),this._content.setHeight(Q),this._content.setWidth($),this._isVisible?(this.actionBarContainer.setAttribute("aria-hidden","false"),this.actionBarContainer.setDisplay("block")):(this.actionBarContainer.setAttribute("aria-hidden","true"),this.actionBarContainer.setDisplay("none"))},t.prototype._compute=function(){var X=this._diffEditor.getLineChanges();if(!X||0===X.length)return[];var $=this._diffEditor.getOriginalEditor().getModel(),Q=this._diffEditor.getModifiedEditor().getModel();return $&&Q?t._mergeAdjacent(X,$.getLineCount(),Q.getLineCount()):[]},t._mergeAdjacent=function(X,$,Q){if(!X||0===X.length)return[];for(var J=[],ee=0,te=0,ne=X.length;te<ne;te++){var ie=X[te],oe=ie.originalStartLineNumber,re=ie.originalEndLineNumber,se=ie.modifiedStartLineNumber,ae=ie.modifiedEndLineNumber,le=[],ue=0,de=0===re?oe:oe-1,ce=0===ae?se:se-1,he=1,pe=1;if(te>0){var fe=X[te-1];he=0===fe.originalEndLineNumber?fe.originalStartLineNumber+1:fe.originalEndLineNumber+1,pe=0===fe.modifiedEndLineNumber?fe.modifiedStartLineNumber+1:fe.modifiedEndLineNumber+1}var ge=de-3+1,me=ce-3+1;ge<he&&(ge+=Le=he-ge,me+=Le),me<pe&&(ge+=Le=pe-me,me+=Le),le[ue++]=new ve(ge,de,me,ce),0!==re&&(le[ue++]=new ve(oe,re,0,0)),0!==ae&&(le[ue++]=new ve(0,0,se,ae));var _e=0===re?oe+1:re+1,ye=0===ae?se+1:ae+1,be=$,Ce=Q;if(te+1<ne){var we=X[te+1];be=0===we.originalEndLineNumber?we.originalStartLineNumber:we.originalStartLineNumber-1,Ce=0===we.modifiedEndLineNumber?we.modifiedStartLineNumber:we.modifiedStartLineNumber-1}var Se=_e+3-1,Ee=ye+3-1;if(Se>be&&(Se+=Le=be-Se,Ee+=Le),Ee>Ce){var Le=Ce-Ee;Se+=Le,Ee+=Le}le[ue++]=new ve(_e,Se,ye,Ee),J[ee++]=new w(le)}var xe=J[0].entries,Ie=[],De=0;for(te=1,ne=J.length;te<ne;te++){var Ne=J[te].entries,Me=xe[xe.length-1],ke=Ne[0];0===Me.getType()&&0===ke.getType()&&ke.originalLineStart<=Me.originalLineEnd?(xe[xe.length-1]=new ve(Me.originalLineStart,ke.originalLineEnd,Me.modifiedLineStart,ke.modifiedLineEnd),xe=xe.concat(Ne.slice(1))):(Ie[De++]=new w(xe),xe=Ne)}return Ie[De++]=new w(xe),Ie},t.prototype._findDiffIndex=function(X){for(var $=X.lineNumber,Q=0,J=this._diffs.length;Q<J;Q++){var ee=this._diffs[Q].entries;if($<=ee[ee.length-1].modifiedLineEnd)return Q}return 0},t.prototype._render=function(){var X=this._diffEditor.getOriginalEditor().getConfiguration(),$=this._diffEditor.getModifiedEditor().getConfiguration(),ee=this._diffEditor.getOriginalEditor().getModel(),te=this._diffEditor.getModifiedEditor().getModel(),ne=ee.getOptions(),ie=te.getOptions();if(!this._isVisible||!ee||!te)return J.clearNode(this._content.domNode),this._currentDiff=null,void this.scrollbar.scanDomNode();var oe=this._diffEditor.getPosition(),re=this._findDiffIndex(oe);if(this._diffs[re]!==this._currentDiff){this._currentDiff=this._diffs[re];var ae=this._diffs[re].entries,le=document.createElement("div");le.className="diff-review-table",le.setAttribute("role","list"),se.Configuration.applyFontInfoSlow(le,$.fontInfo);for(var ue=0,de=0,ce=0,he=0,pe=0,fe=ae.length;pe<fe;pe++){var ge=(xe=ae[pe]).originalLineStart,me=xe.originalLineEnd,ve=xe.modifiedLineStart,_e=xe.modifiedLineEnd;0!==ge&&(0===ue||ge<ue)&&(ue=ge),0!==me&&(0===de||me>de)&&(de=me),0!==ve&&(0===ce||ve<ce)&&(ce=ve),0!==_e&&(0===he||_e>he)&&(he=_e)}var ye=document.createElement("div");ye.className="diff-review-row";var be=document.createElement("div");be.className="diff-review-cell diff-review-summary";var Ce=de-ue+1,we=he-ce+1;be.appendChild(document.createTextNode(re+1+"/"+this._diffs.length+": @@ -"+ue+","+Ce+" +"+ce+","+we+" @@")),ye.setAttribute("data-line",String(ce));var N=function(X){return 0===X?Q.localize(1,null):1===X?Q.localize(2,null):Q.localize(3,null,X)},Se=N(Ce),Ee=N(we);ye.setAttribute("aria-label",Q.localize(4,null,re+1,this._diffs.length,ue,Se,ce,Ee)),ye.appendChild(be),ye.setAttribute("role","listitem"),le.appendChild(ye);var Le=ce;for(pe=0,fe=ae.length;pe<fe;pe++){var xe=ae[pe];t._renderSection(le,xe,Le,this._width,X,ee,ne,$,te,ie),0!==xe.modifiedLineStart&&(Le=xe.modifiedLineEnd)}J.clearNode(this._content.domNode),this._content.domNode.appendChild(le),this.scrollbar.scanDomNode()}},t._renderSection=function(X,$,J,ee,te,ne,ie,oe,re,se){var ae=$.getType(),le="diff-review-row",ue="",de="diff-review-spacer";switch(ae){case 1:le="diff-review-row line-insert",ue=" char-insert",de="diff-review-spacer insert-sign";break;case 2:le="diff-review-row line-delete",ue=" char-delete",de="diff-review-spacer delete-sign"}for(var ce=$.originalLineStart,he=$.originalLineEnd,pe=$.modifiedLineStart,fe=$.modifiedLineEnd,ge=Math.max(fe-pe,he-ce),me=te.layoutInfo.glyphMarginWidth+te.layoutInfo.lineNumbersWidth,ve=10+oe.layoutInfo.glyphMarginWidth+oe.layoutInfo.lineNumbersWidth,_e=0;_e<=ge;_e++){var ye=0===ce?0:ce+_e,be=0===pe?0:pe+_e,Ce=document.createElement("div");Ce.style.minWidth=ee+"px",Ce.className=le,Ce.setAttribute("role","listitem"),0!==be&&(J=be),Ce.setAttribute("data-line",String(J));var we=document.createElement("div");we.className="diff-review-cell",Ce.appendChild(we);var Se=document.createElement("span");Se.style.width=me+"px",Se.style.minWidth=me+"px",Se.className="diff-review-line-number"+ue,0!==ye?Se.appendChild(document.createTextNode(String(ye))):Se.innerHTML="&nbsp;",we.appendChild(Se);var Ee=document.createElement("span");Ee.style.width=ve+"px",Ee.style.minWidth=ve+"px",Ee.style.paddingRight="10px",Ee.className="diff-review-line-number"+ue,0!==be?Ee.appendChild(document.createTextNode(String(be))):Ee.innerHTML="&nbsp;",we.appendChild(Ee);var Le=document.createElement("span");Le.className=de,Le.innerHTML="&nbsp;&nbsp;",we.appendChild(Le);var xe=void 0;0!==be?(we.insertAdjacentHTML("beforeend",this._renderLine(re,oe,se.tabSize,be)),xe=re.getLineContent(be)):(we.insertAdjacentHTML("beforeend",this._renderLine(ne,te,ie.tabSize,ye)),xe=ne.getLineContent(ye)),0===xe.length&&(xe=Q.localize(5,null));var Ie=void 0;switch(ae){case 0:Ie=Q.localize(6,null,ye,be,xe);break;case 1:Ie=Q.localize(7,null,be,xe);break;case 2:Ie=Q.localize(8,null,ye,xe)}Ce.setAttribute("aria-label",Ie),X.appendChild(Ce)}},t._renderLine=function(X,$,Q,J){var ee=X.getLineContent(J),te=new Uint32Array(2);te[0]=ee.length,te[1]=16793600;var ne=new ue.LineTokens(te,ee),ie=pe.ViewLineRenderingData.isBasicASCII(ee,X.mightContainNonBasicASCII()),oe=pe.ViewLineRenderingData.containsRTL(ee,ie,X.mightContainRTL());return he.renderViewLine2(new he.RenderLineInput($.fontInfo.isMonospace&&!$.viewInfo.disableMonospaceOptimizations,$.fontInfo.canUseHalfwidthRightwardsArrow,ee,!1,ie,oe,0,ne,[],Q,$.fontInfo.spaceWidth,$.viewInfo.stopRenderingLineAfter,$.viewInfo.renderWhitespace,$.viewInfo.renderControlCharacters,$.viewInfo.fontLigatures)).html},t}(re.Disposable);$.DiffReview=_e,me.registerThemingParticipant((function(X,$){var Q=X.getColor(ce.editorLineNumbers);Q&&$.addRule(".monaco-diff-editor .diff-review-line-number { color: "+Q+"; }");var J=X.getColor(ge.scrollbarShadow);J&&$.addRule(".monaco-diff-editor .diff-review-shadow { box-shadow: "+J+" 0 -6px 6px -6px inset; }")}));var ye=function(X){function t(){return X.call(this,{id:"editor.action.diffReview.next",label:Q.localize(9,null),alias:"Go to Next Difference",precondition:fe.ContextKeyExpr.has("isInDiffEditor"),kbOpts:{kbExpr:null,primary:65,weight:100}})||this}return te(t,X),t.prototype.run=function(X,$){var Q=b(X);Q&&Q.diffReviewNext()},t}(ae.EditorAction),be=function(X){function t(){return X.call(this,{id:"editor.action.diffReview.prev",label:Q.localize(10,null),alias:"Go to Previous Difference",precondition:fe.ContextKeyExpr.has("isInDiffEditor"),kbOpts:{kbExpr:null,primary:1089,weight:100}})||this}return te(t,X),t.prototype.run=function(X,$){var Q=b(X);Q&&Q.diffReviewPrev()},t}(ae.EditorAction);ae.registerEditorAction(ye),ae.registerEditorAction(be)})),define(Q[189],n([0,1,291,7,23,102,16,6,2,27,57,66,30,99,506,48,3,121,54,26,64,157,129,103,59,18,15,98,35,20,13,296]),(function(X,$,Q,J,ee,ie,re,se,ae,le,ue,de,ce,he,pe,fe,ge,me,ve,_e,ye,be,Ce,we,Se,Ee,Le,xe,Ie,De,Ne){function O(X,$,Q,J,ee){return{range:new ge.Range(X,$,Q,J),options:ee}}function P(X){return X.modifiedEndLineNumber>0}function A(X){return X.originalEndLineNumber>0}Object.defineProperty($,"__esModule",{value:!0});var Me=function(){function e(){this._zones=[],this._zonesMap={},this._decorations=[]}return e.prototype.getForeignViewZones=function(X){var $=this;return X.filter((function(X){return!$._zonesMap[String(X.id)]}))},e.prototype.clean=function(X){var $=this;this._zones.length>0&&X.changeViewZones((function(X){for(var Q=0,J=$._zones.length;Q<J;Q++)X.removeZone($._zones[Q])})),this._zones=[],this._zonesMap={},this._decorations=X.deltaDecorations(this._decorations,[])},e.prototype.apply=function(X,$,Q,J){var ee=this,te=J?de.StableEditorScrollState.capture(X):null;X.changeViewZones((function(X){for(var $=0,J=ee._zones.length;$<J;$++)X.removeZone(ee._zones[$]);ee._zones=[],ee._zonesMap={};$=0;for(var te=Q.zones.length;$<te;$++){Q.zones[$].suppressMouseDown=!0;var ne=X.addZone(Q.zones[$]);ee._zones.push(ne),ee._zonesMap[String(ne)]=!0}})),te&&te.restore(X),this._decorations=X.deltaDecorations(this._decorations,Q.decorations),$&&$.setZones(Q.overviewZones)},e}(),ke=0,Te=function(X){function t($,Q,te,ne,ie,oe,ae,le){var ue=X.call(this)||this;ue._onDidDispose=ue._register(new se.Emitter),ue.onDidDispose=ue._onDidDispose.event,ue._onDidUpdateDiff=ue._register(new se.Emitter),ue.onDidUpdateDiff=ue._onDidUpdateDiff.event,ue._lastOriginalWarning=null,ue._lastModifiedWarning=null,ue._editorWorkerService=te,ue._codeEditorService=oe,ue._contextKeyService=ue._register(ne.createScoped($)),ue._contextKeyService.createKey("isInDiffEditor",!0),ue._themeService=ae,ue._notificationService=le,ue.id=++ke,ue._domElement=$,Q=Q||{},ue._renderSideBySide=!0,void 0!==Q.renderSideBySide&&(ue._renderSideBySide=Q.renderSideBySide),ue._ignoreTrimWhitespace=!0,void 0!==Q.ignoreTrimWhitespace&&(ue._ignoreTrimWhitespace=Q.ignoreTrimWhitespace),ue._renderIndicators=!0,void 0!==Q.renderIndicators&&(ue._renderIndicators=Q.renderIndicators),ue._originalIsEditable=!1,void 0!==Q.originalEditable&&(ue._originalIsEditable=Boolean(Q.originalEditable)),ue._updateDecorationsRunner=ue._register(new re.RunOnceScheduler((function(){return ue._updateDecorations()}),0)),ue._containerDomElement=document.createElement("div"),ue._containerDomElement.className=t._getClassName(ue._themeService.getTheme(),ue._renderSideBySide),ue._containerDomElement.style.position="relative",ue._containerDomElement.style.height="100%",ue._domElement.appendChild(ue._containerDomElement),ue._overviewViewportDomElement=ee.createFastDomNode(document.createElement("div")),ue._overviewViewportDomElement.setClassName("diffViewport"),ue._overviewViewportDomElement.setPosition("absolute"),ue._overviewDomElement=document.createElement("div"),ue._overviewDomElement.className="diffOverview",ue._overviewDomElement.style.position="absolute",ue._overviewDomElement.appendChild(ue._overviewViewportDomElement.domNode),ue._register(J.addStandardDisposableListener(ue._overviewDomElement,"mousedown",(function(X){ue.modifiedEditor.delegateVerticalScrollbarMouseDown(X)}))),ue._containerDomElement.appendChild(ue._overviewDomElement),ue._createLeftHandSide(),ue._createRightHandSide(),ue._beginUpdateDecorationsTimeout=-1,ue._currentlyChangingViewZones=!1,ue._diffComputationToken=0,ue._originalEditorState=new Me,ue._modifiedEditorState=new Me,ue._isVisible=!0,ue._isHandlingScrollEvent=!1,ue._width=0,ue._height=0,ue._reviewHeight=0,ue._diffComputationResult=null;var de=ue._contextKeyService.createScoped();de.createKey("isInDiffLeftEditor",!0);var ce=new xe.ServiceCollection;ce.set(Ee.IContextKeyService,de);var he=ie.createChild(ce),fe=ue._contextKeyService.createScoped();fe.createKey("isInDiffRightEditor",!0);var ge=new xe.ServiceCollection;ge.set(Ee.IContextKeyService,fe);var me=ie.createChild(ge);return ue._createLeftHandSideEditor(Q,he),ue._createRightHandSideEditor(Q,me),ue._reviewPane=new pe.DiffReview(ue),ue._containerDomElement.appendChild(ue._reviewPane.domNode.domNode),ue._containerDomElement.appendChild(ue._reviewPane.shadow.domNode),ue._containerDomElement.appendChild(ue._reviewPane.actionBarContainer.domNode),Q.automaticLayout&&(ue._measureDomElementToken=window.setInterval((function(){return ue._measureDomElement(!1)}),100)),ue._enableSplitViewResizing=!0,void 0!==Q.enableSplitViewResizing&&(ue._enableSplitViewResizing=Q.enableSplitViewResizing),ue._renderSideBySide?ue._setStrategy(new Fe(ue._createDataSource(),ue._enableSplitViewResizing)):ue._setStrategy(new Ve(ue._createDataSource(),ue._enableSplitViewResizing)),ue._register(ae.onThemeChange((function(X){ue._strategy&&ue._strategy.applyColors(X)&&ue._updateDecorationsRunner.schedule(),ue._containerDomElement.className=t._getClassName(ue._themeService.getTheme(),ue._renderSideBySide)}))),ue._codeEditorService.addDiffEditor(ue),ue}return te(t,X),t.prototype.hasWidgetFocus=function(){return J.isAncestor(document.activeElement,this._domElement)},t.prototype.diffReviewNext=function(){this._reviewPane.next()},t.prototype.diffReviewPrev=function(){this._reviewPane.prev()},t._getClassName=function(X,$){var Q="monaco-diff-editor monaco-editor-background ";return $&&(Q+="side-by-side "),Q+Ne.getThemeTypeSelector(X.type)},t.prototype._recreateOverviewRulers=function(){this._originalOverviewRuler&&(this._overviewDomElement.removeChild(this._originalOverviewRuler.getDomNode()),this._originalOverviewRuler.dispose()),this._originalOverviewRuler=this.originalEditor.createOverviewRuler("original diffOverviewRuler"),this._overviewDomElement.appendChild(this._originalOverviewRuler.getDomNode()),this._modifiedOverviewRuler&&(this._overviewDomElement.removeChild(this._modifiedOverviewRuler.getDomNode()),this._modifiedOverviewRuler.dispose()),this._modifiedOverviewRuler=this.modifiedEditor.createOverviewRuler("modified diffOverviewRuler"),this._overviewDomElement.appendChild(this._modifiedOverviewRuler.getDomNode()),this._layoutOverviewRulers()},t.prototype._createLeftHandSide=function(){this._originalDomNode=document.createElement("div"),this._originalDomNode.className="editor original",this._originalDomNode.style.position="absolute",this._originalDomNode.style.height="100%",this._containerDomElement.appendChild(this._originalDomNode)},t.prototype._createRightHandSide=function(){this._modifiedDomNode=document.createElement("div"),this._modifiedDomNode.className="editor modified",this._modifiedDomNode.style.position="absolute",this._modifiedDomNode.style.height="100%",this._containerDomElement.appendChild(this._modifiedDomNode)},t.prototype._createLeftHandSideEditor=function(X,$){var Q=this;this.originalEditor=this._createInnerEditor($,this._originalDomNode,this._adjustOptionsForLeftHandSide(X,this._originalIsEditable)),this._register(this.originalEditor.onDidScrollChange((function(X){Q._isHandlingScrollEvent||(X.scrollTopChanged||X.scrollLeftChanged||X.scrollHeightChanged)&&(Q._isHandlingScrollEvent=!0,Q.modifiedEditor.setScrollPosition({scrollLeft:X.scrollLeft,scrollTop:X.scrollTop}),Q._isHandlingScrollEvent=!1,Q._layoutOverviewViewport())}))),this._register(this.originalEditor.onDidChangeViewZones((function(){Q._onViewZonesChanged()}))),this._register(this.originalEditor.onDidChangeModelContent((function(){Q._isVisible&&Q._beginUpdateDecorationsSoon()})))},t.prototype._createRightHandSideEditor=function(X,$){var Q=this;this.modifiedEditor=this._createInnerEditor($,this._modifiedDomNode,this._adjustOptionsForRightHandSide(X)),this._register(this.modifiedEditor.onDidScrollChange((function(X){Q._isHandlingScrollEvent||(X.scrollTopChanged||X.scrollLeftChanged||X.scrollHeightChanged)&&(Q._isHandlingScrollEvent=!0,Q.originalEditor.setScrollPosition({scrollLeft:X.scrollLeft,scrollTop:X.scrollTop}),Q._isHandlingScrollEvent=!1,Q._layoutOverviewViewport())}))),this._register(this.modifiedEditor.onDidChangeViewZones((function(){Q._onViewZonesChanged()}))),this._register(this.modifiedEditor.onDidChangeConfiguration((function(X){X.fontInfo&&Q.modifiedEditor.getModel()&&Q._onViewZonesChanged()}))),this._register(this.modifiedEditor.onDidChangeModelContent((function(){Q._isVisible&&Q._beginUpdateDecorationsSoon()})))},t.prototype._createInnerEditor=function(X,$,Q){return X.createInstance(he.CodeEditorWidget,$,Q,{})},t.prototype.dispose=function(){this._codeEditorService.removeDiffEditor(this),-1!==this._beginUpdateDecorationsTimeout&&(window.clearTimeout(this._beginUpdateDecorationsTimeout),this._beginUpdateDecorationsTimeout=-1),window.clearInterval(this._measureDomElementToken),this._cleanViewZonesAndDecorations(),this._originalOverviewRuler&&(this._overviewDomElement.removeChild(this._originalOverviewRuler.getDomNode()),this._originalOverviewRuler.dispose()),this._modifiedOverviewRuler&&(this._overviewDomElement.removeChild(this._modifiedOverviewRuler.getDomNode()),this._modifiedOverviewRuler.dispose()),this._overviewDomElement.removeChild(this._overviewViewportDomElement.domNode),this._containerDomElement.removeChild(this._overviewDomElement),this._containerDomElement.removeChild(this._originalDomNode),this.originalEditor.dispose(),this._containerDomElement.removeChild(this._modifiedDomNode),this.modifiedEditor.dispose(),this._strategy.dispose(),this._containerDomElement.removeChild(this._reviewPane.domNode.domNode),this._containerDomElement.removeChild(this._reviewPane.shadow.domNode),this._containerDomElement.removeChild(this._reviewPane.actionBarContainer.domNode),this._reviewPane.dispose(),this._domElement.removeChild(this._containerDomElement),this._onDidDispose.fire(),X.prototype.dispose.call(this)},t.prototype.getId=function(){return this.getEditorType()+":"+this.id},t.prototype.getEditorType=function(){return ve.EditorType.IDiffEditor},t.prototype.getLineChanges=function(){return this._diffComputationResult?this._diffComputationResult.changes:null},t.prototype.getOriginalEditor=function(){return this.originalEditor},t.prototype.getModifiedEditor=function(){return this.modifiedEditor},t.prototype.updateOptions=function(X){var $=!1;void 0!==X.renderSideBySide&&this._renderSideBySide!==X.renderSideBySide&&(this._renderSideBySide=X.renderSideBySide,$=!0);var Q=!1;void 0!==X.ignoreTrimWhitespace&&this._ignoreTrimWhitespace!==X.ignoreTrimWhitespace&&(this._ignoreTrimWhitespace=X.ignoreTrimWhitespace,Q=!0),void 0!==X.renderIndicators&&this._renderIndicators!==X.renderIndicators&&(this._renderIndicators=X.renderIndicators,Q=!0),Q&&this._beginUpdateDecorations(),void 0!==X.originalEditable&&(this._originalIsEditable=Boolean(X.originalEditable)),this.modifiedEditor.updateOptions(this._adjustOptionsForRightHandSide(X)),this.originalEditor.updateOptions(this._adjustOptionsForLeftHandSide(X,this._originalIsEditable)),void 0!==X.enableSplitViewResizing&&(this._enableSplitViewResizing=X.enableSplitViewResizing),this._strategy.setEnableSplitViewResizing(this._enableSplitViewResizing),$&&(this._renderSideBySide?this._setStrategy(new Fe(this._createDataSource(),this._enableSplitViewResizing)):this._setStrategy(new Ve(this._createDataSource(),this._enableSplitViewResizing)),this._containerDomElement.className=t._getClassName(this._themeService.getTheme(),this._renderSideBySide))},t.prototype.getModel=function(){return{original:this.originalEditor.getModel(),modified:this.modifiedEditor.getModel()}},t.prototype.setModel=function(X){if(X&&(!X.original||!X.modified))throw new Error(X.original?"DiffEditorWidget.setModel: Modified model is null":"DiffEditorWidget.setModel: Original model is null");this._cleanViewZonesAndDecorations(),this.originalEditor.setModel(X?X.original:null),this.modifiedEditor.setModel(X?X.modified:null),this._updateDecorationsRunner.cancel(),X&&(this.originalEditor.setScrollTop(0),this.modifiedEditor.setScrollTop(0)),this._diffComputationResult=null,this._diffComputationToken++,X?(this._recreateOverviewRulers(),this._beginUpdateDecorations()):this._diffComputationResult=null,this._layoutOverviewViewport()},t.prototype.getDomNode=function(){return this._domElement},t.prototype.getVisibleColumnFromPosition=function(X){return this.modifiedEditor.getVisibleColumnFromPosition(X)},t.prototype.getPosition=function(){return this.modifiedEditor.getPosition()},t.prototype.setPosition=function(X){this.modifiedEditor.setPosition(X)},t.prototype.revealLine=function(X,$){void 0===$&&($=0),this.modifiedEditor.revealLine(X,$)},t.prototype.revealLineInCenter=function(X,$){void 0===$&&($=0),this.modifiedEditor.revealLineInCenter(X,$)},t.prototype.revealLineInCenterIfOutsideViewport=function(X,$){void 0===$&&($=0),this.modifiedEditor.revealLineInCenterIfOutsideViewport(X,$)},t.prototype.revealPosition=function(X,$){void 0===$&&($=0),this.modifiedEditor.revealPosition(X,$)},t.prototype.revealPositionInCenter=function(X,$){void 0===$&&($=0),this.modifiedEditor.revealPositionInCenter(X,$)},t.prototype.revealPositionInCenterIfOutsideViewport=function(X,$){void 0===$&&($=0),this.modifiedEditor.revealPositionInCenterIfOutsideViewport(X,$)},t.prototype.getSelection=function(){return this.modifiedEditor.getSelection()},t.prototype.getSelections=function(){return this.modifiedEditor.getSelections()},t.prototype.setSelection=function(X){this.modifiedEditor.setSelection(X)},t.prototype.setSelections=function(X){this.modifiedEditor.setSelections(X)},t.prototype.revealLines=function(X,$,Q){void 0===Q&&(Q=0),this.modifiedEditor.revealLines(X,$,Q)},t.prototype.revealLinesInCenter=function(X,$,Q){void 0===Q&&(Q=0),this.modifiedEditor.revealLinesInCenter(X,$,Q)},t.prototype.revealLinesInCenterIfOutsideViewport=function(X,$,Q){void 0===Q&&(Q=0),this.modifiedEditor.revealLinesInCenterIfOutsideViewport(X,$,Q)},t.prototype.revealRange=function(X,$,Q,J){void 0===$&&($=0),void 0===Q&&(Q=!1),void 0===J&&(J=!0),this.modifiedEditor.revealRange(X,$,Q,J)},t.prototype.revealRangeInCenter=function(X,$){void 0===$&&($=0),this.modifiedEditor.revealRangeInCenter(X,$)},t.prototype.revealRangeInCenterIfOutsideViewport=function(X,$){void 0===$&&($=0),this.modifiedEditor.revealRangeInCenterIfOutsideViewport(X,$)},t.prototype.revealRangeAtTop=function(X,$){void 0===$&&($=0),this.modifiedEditor.revealRangeAtTop(X,$)},t.prototype.getSupportedActions=function(){return this.modifiedEditor.getSupportedActions()},t.prototype.saveViewState=function(){return{original:this.originalEditor.saveViewState(),modified:this.modifiedEditor.saveViewState()}},t.prototype.restoreViewState=function(X){if(X.original&&X.original){var $=X;this.originalEditor.restoreViewState($.original),this.modifiedEditor.restoreViewState($.modified)}},t.prototype.layout=function(X){this._measureDomElement(!1,X)},t.prototype.focus=function(){this.modifiedEditor.focus()},t.prototype.hasTextFocus=function(){return this.originalEditor.hasTextFocus()||this.modifiedEditor.hasTextFocus()},t.prototype.trigger=function(X,$,Q){this.modifiedEditor.trigger(X,$,Q)},t.prototype.changeDecorations=function(X){return this.modifiedEditor.changeDecorations(X)},t.prototype._measureDomElement=function(X,$){if(($=$||{width:this._containerDomElement.clientWidth,height:this._containerDomElement.clientHeight}).width<=0)return this._width=0,this._height=0,void(this._reviewHeight=0);(X||$.width!==this._width||$.height!==this._height)&&(this._width=$.width,this._height=$.height,this._reviewHeight=this._reviewPane.isVisible()?this._height:0,this._doLayout())},t.prototype._layoutOverviewRulers=function(){var X=t.ENTIRE_DIFF_OVERVIEW_WIDTH-2*t.ONE_OVERVIEW_WIDTH;this.modifiedEditor.getLayoutInfo()&&(this._originalOverviewRuler.setLayout({top:0,width:t.ONE_OVERVIEW_WIDTH,right:X+t.ONE_OVERVIEW_WIDTH,height:this._height-this._reviewHeight}),this._modifiedOverviewRuler.setLayout({top:0,right:0,width:t.ONE_OVERVIEW_WIDTH,height:this._height-this._reviewHeight}))},t.prototype._onViewZonesChanged=function(){this._currentlyChangingViewZones||this._updateDecorationsRunner.schedule()},t.prototype._beginUpdateDecorationsSoon=function(){var X=this;-1!==this._beginUpdateDecorationsTimeout&&(window.clearTimeout(this._beginUpdateDecorationsTimeout),this._beginUpdateDecorationsTimeout=-1),this._beginUpdateDecorationsTimeout=window.setTimeout((function(){return X._beginUpdateDecorations()}),t.UPDATE_DIFF_DECORATIONS_DELAY)},t._equals=function(X,$){return!X&&!$||!(!X||!$)&&X.toString()===$.toString()},t.prototype._beginUpdateDecorations=function(){var X=this;this._beginUpdateDecorationsTimeout=-1;var $=this.originalEditor.getModel(),J=this.modifiedEditor.getModel();if($&&J){this._diffComputationToken++;var ee=this._diffComputationToken;this._editorWorkerService.canComputeDiff($.uri,J.uri)?this._editorWorkerService.computeDiff($.uri,J.uri,this._ignoreTrimWhitespace).then((function(Q){ee===X._diffComputationToken&&$===X.originalEditor.getModel()&&J===X.modifiedEditor.getModel()&&(X._diffComputationResult=Q,X._updateDecorationsRunner.schedule(),X._onDidUpdateDiff.fire())}),(function(Q){ee===X._diffComputationToken&&$===X.originalEditor.getModel()&&J===X.modifiedEditor.getModel()&&(X._diffComputationResult=null,X._updateDecorationsRunner.schedule())})):t._equals($.uri,this._lastOriginalWarning)&&t._equals(J.uri,this._lastModifiedWarning)||(this._lastOriginalWarning=$.uri,this._lastModifiedWarning=J.uri,this._notificationService.warn(Q.localize(0,null)))}},t.prototype._cleanViewZonesAndDecorations=function(){this._originalEditorState.clean(this.originalEditor),this._modifiedEditorState.clean(this.modifiedEditor)},t.prototype._updateDecorations=function(){if(this.originalEditor.getModel()&&this.modifiedEditor.getModel()){var X=this._diffComputationResult?this._diffComputationResult.changes:[],$=this._originalEditorState.getForeignViewZones(this.originalEditor.getWhitespaces()),Q=this._modifiedEditorState.getForeignViewZones(this.modifiedEditor.getWhitespaces()),J=this._strategy.getEditorsDiffDecorations(X,this._ignoreTrimWhitespace,this._renderIndicators,$,Q,this.originalEditor,this.modifiedEditor);try{this._currentlyChangingViewZones=!0,this._originalEditorState.apply(this.originalEditor,this._originalOverviewRuler,J.original,!1),this._modifiedEditorState.apply(this.modifiedEditor,this._modifiedOverviewRuler,J.modified,!0)}finally{this._currentlyChangingViewZones=!1}}},t.prototype._adjustOptionsForSubEditor=function(X){var $=le.deepClone(X||{});return $.inDiffEditor=!0,$.wordWrap="off",$.wordWrapMinified=!1,$.automaticLayout=!1,$.scrollbar=$.scrollbar||{},$.scrollbar.vertical="visible",$.folding=!1,$.codeLens=!1,$.fixedOverflowWidgets=!0,$.minimap||($.minimap={}),$.minimap.enabled=!1,$},t.prototype._adjustOptionsForLeftHandSide=function(X,$){var Q=this._adjustOptionsForSubEditor(X);return Q.readOnly=!$,Q.overviewRulerLanes=1,Q.extraEditorClassName="original-in-monaco-diff-editor",Q},t.prototype._adjustOptionsForRightHandSide=function(X){var $=this._adjustOptionsForSubEditor(X);return $.revealHorizontalRightPadding=fe.EDITOR_DEFAULTS.viewInfo.revealHorizontalRightPadding+t.ENTIRE_DIFF_OVERVIEW_WIDTH,$.scrollbar.verticalHasArrows=!1,$.extraEditorClassName="modified-in-monaco-diff-editor",$},t.prototype.doLayout=function(){this._measureDomElement(!0)},t.prototype._doLayout=function(){var X=this._strategy.layout();this._originalDomNode.style.width=X+"px",this._originalDomNode.style.left="0px",this._modifiedDomNode.style.width=this._width-X+"px",this._modifiedDomNode.style.left=X+"px",this._overviewDomElement.style.top="0px",this._overviewDomElement.style.height=this._height-this._reviewHeight+"px",this._overviewDomElement.style.width=t.ENTIRE_DIFF_OVERVIEW_WIDTH+"px",this._overviewDomElement.style.left=this._width-t.ENTIRE_DIFF_OVERVIEW_WIDTH+"px",this._overviewViewportDomElement.setWidth(t.ENTIRE_DIFF_OVERVIEW_WIDTH),this._overviewViewportDomElement.setHeight(30),this.originalEditor.layout({width:X,height:this._height-this._reviewHeight}),this.modifiedEditor.layout({width:this._width-X-t.ENTIRE_DIFF_OVERVIEW_WIDTH,height:this._height-this._reviewHeight}),(this._originalOverviewRuler||this._modifiedOverviewRuler)&&this._layoutOverviewRulers(),this._reviewPane.layout(this._height-this._reviewHeight,this._width,this._reviewHeight),this._layoutOverviewViewport()},t.prototype._layoutOverviewViewport=function(){var X=this._computeOverviewViewport();X?(this._overviewViewportDomElement.setTop(X.top),this._overviewViewportDomElement.setHeight(X.height)):(this._overviewViewportDomElement.setTop(0),this._overviewViewportDomElement.setHeight(0))},t.prototype._computeOverviewViewport=function(){var X=this.modifiedEditor.getLayoutInfo();if(!X)return null;var $=this.modifiedEditor.getScrollTop(),Q=this.modifiedEditor.getScrollHeight(),J=Math.max(0,X.contentHeight),ee=Math.max(0,J-0),te=Q>0?ee/Q:0;return{height:Math.max(0,Math.floor(X.contentHeight*te)),top:Math.floor($*te)}},t.prototype._createDataSource=function(){var X=this;return{getWidth:function(){return X._width},getHeight:function(){return X._height-X._reviewHeight},getContainerDomNode:function(){return X._containerDomElement},relayoutEditors:function(){X._doLayout()},getOriginalEditor:function(){return X.originalEditor},getModifiedEditor:function(){return X.modifiedEditor}}},t.prototype._setStrategy=function(X){this._strategy&&this._strategy.dispose(),this._strategy=X,X.applyColors(this._themeService.getTheme()),this._diffComputationResult&&this._updateDecorations(),this._measureDomElement(!0)},t.prototype._getLineChangeAtOrBeforeLineNumber=function(X,$){var Q=this._diffComputationResult?this._diffComputationResult.changes:[];if(0===Q.length||X<$(Q[0]))return null;for(var J=0,ee=Q.length-1;J<ee;){var te=Math.floor((J+ee)/2),ne=$(Q[te]),ie=te+1<=ee?$(Q[te+1]):Number.MAX_VALUE;X<ne?ee=te-1:X>=ie?J=te+1:(J=te,ee=te)}return Q[J]},t.prototype._getEquivalentLineForOriginalLineNumber=function(X){var $=this._getLineChangeAtOrBeforeLineNumber(X,(function(X){return X.originalStartLineNumber}));if(!$)return X;var Q=$.originalStartLineNumber+($.originalEndLineNumber>0?-1:0),J=$.modifiedStartLineNumber+($.modifiedEndLineNumber>0?-1:0),ee=$.originalEndLineNumber>0?$.originalEndLineNumber-$.originalStartLineNumber+1:0,te=$.modifiedEndLineNumber>0?$.modifiedEndLineNumber-$.modifiedStartLineNumber+1:0,ne=X-Q;return ne<=ee?J+Math.min(ne,te):J+te-ee+ne},t.prototype._getEquivalentLineForModifiedLineNumber=function(X){var $=this._getLineChangeAtOrBeforeLineNumber(X,(function(X){return X.modifiedStartLineNumber}));if(!$)return X;var Q=$.originalStartLineNumber+($.originalEndLineNumber>0?-1:0),J=$.modifiedStartLineNumber+($.modifiedEndLineNumber>0?-1:0),ee=$.originalEndLineNumber>0?$.originalEndLineNumber-$.originalStartLineNumber+1:0,te=$.modifiedEndLineNumber>0?$.modifiedEndLineNumber-$.modifiedStartLineNumber+1:0,ne=X-J;return ne<=te?Q+Math.min(ne,ee):Q+ee-te+ne},t.prototype.getDiffLineInformationForOriginal=function(X){return this._diffComputationResult?{equivalentLineNumber:this._getEquivalentLineForOriginalLineNumber(X)}:null},t.prototype.getDiffLineInformationForModified=function(X){return this._diffComputationResult?{equivalentLineNumber:this._getEquivalentLineForModifiedLineNumber(X)}:null},t.ONE_OVERVIEW_WIDTH=15,t.ENTIRE_DIFF_OVERVIEW_WIDTH=30,t.UPDATE_DIFF_DECORATIONS_DELAY=200,t=ne([oe(2,ye.IEditorWorkerService),oe(3,Ee.IContextKeyService),oe(4,Le.IInstantiationService),oe(5,ce.ICodeEditorService),oe(6,Ne.IThemeService),oe(7,Ie.INotificationService)],t)}(ae.Disposable);$.DiffEditorWidget=Te;var Re=function(X){function t($){var Q=X.call(this)||this;return Q._dataSource=$,Q}return te(t,X),t.prototype.applyColors=function(X){var $=(X.getColor(De.diffInserted)||De.defaultInsertColor).transparent(2),Q=(X.getColor(De.diffRemoved)||De.defaultRemoveColor).transparent(2),J=!$.equals(this._insertColor)||!Q.equals(this._removeColor);return this._insertColor=$,this._removeColor=Q,J},t.prototype.getEditorsDiffDecorations=function(X,$,Q,J,ee,te,ne){ee=ee.sort((function(X,$){return X.afterLineNumber-$.afterLineNumber})),J=J.sort((function(X,$){return X.afterLineNumber-$.afterLineNumber}));var ie=this._getViewZones(X,J,ee,te,ne,Q),oe=this._getOriginalEditorDecorations(X,$,Q,te,ne),re=this._getModifiedEditorDecorations(X,$,Q,te,ne);return{original:{decorations:oe.decorations,overviewZones:oe.overviewZones,zones:ie.original},modified:{decorations:re.decorations,overviewZones:re.overviewZones,zones:ie.modified}}},t}(ae.Disposable),Oe=function(){function e(X){this._source=X,this._index=-1,this.advance()}return e.prototype.advance=function(){this._index++,this._index<this._source.length?this.current=this._source[this._index]:this.current=null},e}(),Pe=function(){function e(X,$,Q){this.lineChanges=X,this.originalForeignVZ=$,this.modifiedForeignVZ=Q}return e.prototype.getViewZones=function(){for(var X={original:[],modified:[]},$=0,Q=0,J=0,ee=0,te=0,ne=0,a=function(X,$){return X.afterLineNumber-$.afterLineNumber},l=function(X,$){if(null===$.domNode&&X.length>0){var Q=X[X.length-1];if(Q.afterLineNumber===$.afterLineNumber&&null===Q.domNode)return void(Q.heightInLines+=$.heightInLines)}X.push($)},ie=new Oe(this.modifiedForeignVZ),oe=new Oe(this.originalForeignVZ),re=0,se=this.lineChanges.length;re<=se;re++){var ae=re<se?this.lineChanges[re]:null;null!==ae?(J=ae.originalStartLineNumber+(ae.originalEndLineNumber>0?-1:0),ee=ae.modifiedStartLineNumber+(ae.modifiedEndLineNumber>0?-1:0),Q=ae.originalEndLineNumber>0?ae.originalEndLineNumber-ae.originalStartLineNumber+1:0,$=ae.modifiedEndLineNumber>0?ae.modifiedEndLineNumber-ae.modifiedStartLineNumber+1:0,te=Math.max(ae.originalStartLineNumber,ae.originalEndLineNumber),ne=Math.max(ae.modifiedStartLineNumber,ae.modifiedEndLineNumber)):(te=J+=1e7+Q,ne=ee+=1e7+$);for(var le=[],ue=[];ie.current&&ie.current.afterLineNumber<=ne;){ce=void 0,ce=ie.current.afterLineNumber<=ee?J-ee+ie.current.afterLineNumber:te;var de=null;ae&&ae.modifiedStartLineNumber<=ie.current.afterLineNumber&&ie.current.afterLineNumber<=ae.modifiedEndLineNumber&&(de=this._createOriginalMarginDomNodeForModifiedForeignViewZoneInAddedRegion()),le.push({afterLineNumber:ce,heightInLines:ie.current.heightInLines,domNode:null,marginDomNode:de}),ie.advance()}for(;oe.current&&oe.current.afterLineNumber<=te;){var ce=void 0;ce=oe.current.afterLineNumber<=J?ee-J+oe.current.afterLineNumber:ne,ue.push({afterLineNumber:ce,heightInLines:oe.current.heightInLines,domNode:null}),oe.advance()}if(null!==ae&&P(ae)&&(he=this._produceOriginalFromDiff(ae,Q,$))&&le.push(he),null!==ae&&A(ae)){var he=this._produceModifiedFromDiff(ae,Q,$);he&&ue.push(he)}var pe=0,fe=0;for(le=le.sort(a),ue=ue.sort(a);pe<le.length&&fe<ue.length;){var ge=le[pe],me=ue[fe],ve=ge.afterLineNumber-J,_e=me.afterLineNumber-ee;ve<_e?(l(X.original,ge),pe++):_e<ve?(l(X.modified,me),fe++):ge.shouldNotShrink?(l(X.original,ge),pe++):me.shouldNotShrink?(l(X.modified,me),fe++):ge.heightInLines>=me.heightInLines?(ge.heightInLines-=me.heightInLines,fe++):(me.heightInLines-=ge.heightInLines,pe++)}for(;pe<le.length;)l(X.original,le[pe]),pe++;for(;fe<ue.length;)l(X.modified,ue[fe]),fe++}var L=function(X){X.domNode||(X.domNode=function(){var X=document.createElement("div");return X.className="diagonal-fill",X}())};return X.original.forEach(L),X.modified.forEach(L),X},e}(),Ae={charDelete:_e.ModelDecorationOptions.register({className:"char-delete"}),charDeleteWholeLine:_e.ModelDecorationOptions.register({className:"char-delete",isWholeLine:!0}),charInsert:_e.ModelDecorationOptions.register({className:"char-insert"}),charInsertWholeLine:_e.ModelDecorationOptions.register({className:"char-insert",isWholeLine:!0}),lineInsert:_e.ModelDecorationOptions.register({className:"line-insert",marginClassName:"line-insert",isWholeLine:!0}),lineInsertWithSign:_e.ModelDecorationOptions.register({className:"line-insert",linesDecorationsClassName:"insert-sign",marginClassName:"line-insert",isWholeLine:!0}),lineDelete:_e.ModelDecorationOptions.register({className:"line-delete",marginClassName:"line-delete",isWholeLine:!0}),lineDeleteWithSign:_e.ModelDecorationOptions.register({className:"line-delete",linesDecorationsClassName:"delete-sign",marginClassName:"line-delete",isWholeLine:!0}),lineDeleteMargin:_e.ModelDecorationOptions.register({marginClassName:"line-delete"})},Fe=function(X){function t($,Q){var J=X.call(this,$)||this;return J._disableSash=!1===Q,J._sashRatio=null,J._sashPosition=null,J._sash=J._register(new ie.Sash(J._dataSource.getContainerDomNode(),J)),J._disableSash&&(J._sash.state=0),J._sash.onDidStart((function(){return J.onSashDragStart()})),J._sash.onDidChange((function(X){return J.onSashDrag(X)})),J._sash.onDidEnd((function(){return J.onSashDragEnd()})),J._sash.onDidReset((function(){return J.onSashReset()})),J}return te(t,X),t.prototype.setEnableSplitViewResizing=function(X){var $=!1===X;this._disableSash!==$&&(this._disableSash=$,this._sash.state=this._disableSash?0:3)},t.prototype.layout=function(X){void 0===X&&(X=this._sashRatio);var $=this._dataSource.getWidth()-Te.ENTIRE_DIFF_OVERVIEW_WIDTH,Q=Math.floor((X||.5)*$),J=Math.floor(.5*$);return Q=this._disableSash?J:Q||J,$>2*t.MINIMUM_EDITOR_WIDTH?(Q<t.MINIMUM_EDITOR_WIDTH&&(Q=t.MINIMUM_EDITOR_WIDTH),Q>$-t.MINIMUM_EDITOR_WIDTH&&(Q=$-t.MINIMUM_EDITOR_WIDTH)):Q=J,this._sashPosition!==Q&&(this._sashPosition=Q,this._sash.layout()),this._sashPosition},t.prototype.onSashDragStart=function(){this._startSashPosition=this._sashPosition},t.prototype.onSashDrag=function(X){var $=this._dataSource.getWidth()-Te.ENTIRE_DIFF_OVERVIEW_WIDTH,Q=this.layout((this._startSashPosition+(X.currentX-X.startX))/$);this._sashRatio=Q/$,this._dataSource.relayoutEditors()},t.prototype.onSashDragEnd=function(){this._sash.layout()},t.prototype.onSashReset=function(){this._sashRatio=.5,this._dataSource.relayoutEditors(),this._sash.layout()},t.prototype.getVerticalSashTop=function(X){return 0},t.prototype.getVerticalSashLeft=function(X){return this._sashPosition},t.prototype.getVerticalSashHeight=function(X){return this._dataSource.getHeight()},t.prototype._getViewZones=function(X,$,Q,J,ee){return new We(X,$,Q).getViewZones()},t.prototype._getOriginalEditorDecorations=function(X,$,Q,J,ee){for(var te=this._removeColor.toString(),ne={decorations:[],overviewZones:[]},ie=J.getModel(),oe=0,re=X.length;oe<re;oe++){var se=X[oe];if(A(se)&&(ne.decorations.push({range:new ge.Range(se.originalStartLineNumber,1,se.originalEndLineNumber,Number.MAX_VALUE),options:Q?Ae.lineDeleteWithSign:Ae.lineDelete}),P(se)&&se.charChanges||ne.decorations.push(O(se.originalStartLineNumber,1,se.originalEndLineNumber,Number.MAX_VALUE,Ae.charDeleteWholeLine)),ne.overviewZones.push(new be.OverviewRulerZone(se.originalStartLineNumber,se.originalEndLineNumber,te)),se.charChanges))for(var ae=0,le=se.charChanges.length;ae<le;ae++){var ue=se.charChanges[ae];if(A(ue))if($)for(var de=ue.originalStartLineNumber;de<=ue.originalEndLineNumber;de++){var ce,he;ce=de===ue.originalStartLineNumber?ue.originalStartColumn:ie.getLineFirstNonWhitespaceColumn(de),he=de===ue.originalEndLineNumber?ue.originalEndColumn:ie.getLineLastNonWhitespaceColumn(de),ne.decorations.push(O(de,ce,de,he,Ae.charDelete))}else ne.decorations.push(O(ue.originalStartLineNumber,ue.originalStartColumn,ue.originalEndLineNumber,ue.originalEndColumn,Ae.charDelete))}}return ne},t.prototype._getModifiedEditorDecorations=function(X,$,Q,J,ee){for(var te=this._insertColor.toString(),ne={decorations:[],overviewZones:[]},ie=ee.getModel(),oe=0,re=X.length;oe<re;oe++){var se=X[oe];if(P(se)&&(ne.decorations.push({range:new ge.Range(se.modifiedStartLineNumber,1,se.modifiedEndLineNumber,Number.MAX_VALUE),options:Q?Ae.lineInsertWithSign:Ae.lineInsert}),A(se)&&se.charChanges||ne.decorations.push(O(se.modifiedStartLineNumber,1,se.modifiedEndLineNumber,Number.MAX_VALUE,Ae.charInsertWholeLine)),ne.overviewZones.push(new be.OverviewRulerZone(se.modifiedStartLineNumber,se.modifiedEndLineNumber,te)),se.charChanges))for(var ae=0,le=se.charChanges.length;ae<le;ae++){var ue=se.charChanges[ae];if(P(ue))if($)for(var de=ue.modifiedStartLineNumber;de<=ue.modifiedEndLineNumber;de++){var ce,he;ce=de===ue.modifiedStartLineNumber?ue.modifiedStartColumn:ie.getLineFirstNonWhitespaceColumn(de),he=de===ue.modifiedEndLineNumber?ue.modifiedEndColumn:ie.getLineLastNonWhitespaceColumn(de),ne.decorations.push(O(de,ce,de,he,Ae.charInsert))}else ne.decorations.push(O(ue.modifiedStartLineNumber,ue.modifiedStartColumn,ue.modifiedEndLineNumber,ue.modifiedEndColumn,Ae.charInsert))}}return ne},t.MINIMUM_EDITOR_WIDTH=100,t}(Re),We=function(X){function t($,Q,J){return X.call(this,$,Q,J)||this}return te(t,X),t.prototype._createOriginalMarginDomNodeForModifiedForeignViewZoneInAddedRegion=function(){return null},t.prototype._produceOriginalFromDiff=function(X,$,Q){return Q>$?{afterLineNumber:Math.max(X.originalStartLineNumber,X.originalEndLineNumber),heightInLines:Q-$,domNode:null}:null},t.prototype._produceModifiedFromDiff=function(X,$,Q){return $>Q?{afterLineNumber:Math.max(X.modifiedStartLineNumber,X.modifiedEndLineNumber),heightInLines:$-Q,domNode:null}:null},t}(Pe),Ve=function(X){function t($,Q){var J=X.call(this,$)||this;return J.decorationsLeft=$.getOriginalEditor().getLayoutInfo().decorationsLeft,J._register($.getOriginalEditor().onDidLayoutChange((function(X){J.decorationsLeft!==X.decorationsLeft&&(J.decorationsLeft=X.decorationsLeft,$.relayoutEditors())}))),J}return te(t,X),t.prototype.setEnableSplitViewResizing=function(X){},t.prototype._getViewZones=function(X,$,Q,J,ee,te){return new He(X,$,Q,J,ee,te).getViewZones()},t.prototype._getOriginalEditorDecorations=function(X,$,Q,J,ee){for(var te=this._removeColor.toString(),ne={decorations:[],overviewZones:[]},ie=0,oe=X.length;ie<oe;ie++){var re=X[ie];A(re)&&(ne.decorations.push({range:new ge.Range(re.originalStartLineNumber,1,re.originalEndLineNumber,Number.MAX_VALUE),options:Ae.lineDeleteMargin}),ne.overviewZones.push(new be.OverviewRulerZone(re.originalStartLineNumber,re.originalEndLineNumber,te)))}return ne},t.prototype._getModifiedEditorDecorations=function(X,$,Q,J,ee){for(var te=this._insertColor.toString(),ne={decorations:[],overviewZones:[]},ie=ee.getModel(),oe=0,re=X.length;oe<re;oe++){var se=X[oe];if(P(se))if(ne.decorations.push({range:new ge.Range(se.modifiedStartLineNumber,1,se.modifiedEndLineNumber,Number.MAX_VALUE),options:Q?Ae.lineInsertWithSign:Ae.lineInsert}),ne.overviewZones.push(new be.OverviewRulerZone(se.modifiedStartLineNumber,se.modifiedEndLineNumber,te)),se.charChanges)for(var ae=0,le=se.charChanges.length;ae<le;ae++){var ue=se.charChanges[ae];if(P(ue))if($)for(var de=ue.modifiedStartLineNumber;de<=ue.modifiedEndLineNumber;de++){var ce,he;ce=de===ue.modifiedStartLineNumber?ue.modifiedStartColumn:ie.getLineFirstNonWhitespaceColumn(de),he=de===ue.modifiedEndLineNumber?ue.modifiedEndColumn:ie.getLineLastNonWhitespaceColumn(de),ne.decorations.push(O(de,ce,de,he,Ae.charInsert))}else ne.decorations.push(O(ue.modifiedStartLineNumber,ue.modifiedStartColumn,ue.modifiedEndLineNumber,ue.modifiedEndColumn,Ae.charInsert))}else ne.decorations.push(O(se.modifiedStartLineNumber,1,se.modifiedEndLineNumber,Number.MAX_VALUE,Ae.charInsertWholeLine))}return ne},t.prototype.layout=function(){return Math.max(5,this.decorationsLeft)},t}(Re),He=function(X){function t($,Q,J,ee,te,ne){var ie=X.call(this,$,Q,J)||this;return ie.originalModel=ee.getModel(),ie.modifiedEditorConfiguration=te.getConfiguration(),ie.modifiedEditorTabSize=te.getModel().getOptions().tabSize,ie.renderIndicators=ne,ie}return te(t,X),t.prototype._createOriginalMarginDomNodeForModifiedForeignViewZoneInAddedRegion=function(){var X=document.createElement("div");return X.className="inline-added-margin-view-zone",X},t.prototype._produceOriginalFromDiff=function(X,$,Q){var J=document.createElement("div");return J.className="inline-added-margin-view-zone",{afterLineNumber:Math.max(X.originalStartLineNumber,X.originalEndLineNumber),heightInLines:Q,domNode:document.createElement("div"),marginDomNode:J}},t.prototype._produceModifiedFromDiff=function(X,$,Q){var J=[];if(X.charChanges)for(var ee=0,te=X.charChanges.length;ee<te;ee++){var ne=X.charChanges[ee];A(ne)&&J.push(new Se.InlineDecoration(new ge.Range(ne.originalStartLineNumber,ne.originalStartColumn,ne.originalEndLineNumber,ne.originalEndColumn),"char-delete",0))}for(var ie=me.createStringBuilder(1e4),oe=[],re=this.modifiedEditorConfiguration.layoutInfo.decorationsWidth,se=this.modifiedEditorConfiguration.lineHeight,ae=this.modifiedEditorConfiguration.fontInfo.typicalHalfwidthCharacterWidth,le=0,de=X.originalStartLineNumber;de<=X.originalEndLineNumber;de++)if(le=Math.max(le,this._renderOriginalLine(de-X.originalStartLineNumber,this.originalModel,this.modifiedEditorConfiguration,this.modifiedEditorTabSize,de,J,ie)),this.renderIndicators){var ce=de-X.originalStartLineNumber;oe=oe.concat(['<div class="delete-sign" style="position:absolute;top:'+ce*se+"px;width:"+re+"px;height:"+se+'px;right:0;"></div>'])}le+=this.modifiedEditorConfiguration.viewInfo.scrollBeyondLastColumn;var he=document.createElement("div");he.className="view-lines line-delete",he.innerHTML=ie.build(),ue.Configuration.applyFontInfoSlow(he,this.modifiedEditorConfiguration.fontInfo);var pe=document.createElement("div");return pe.className="inline-deleted-margin-view-zone",pe.innerHTML=oe.join(""),ue.Configuration.applyFontInfoSlow(pe,this.modifiedEditorConfiguration.fontInfo),{shouldNotShrink:!0,afterLineNumber:0===X.modifiedEndLineNumber?X.modifiedStartLineNumber:X.modifiedStartLineNumber-1,heightInLines:$,minWidthInPx:le*ae,domNode:he,marginDomNode:pe}},t.prototype._renderOriginalLine=function(X,$,Q,J,ee,te,ne){var ie=$.getLineTokens(ee),oe=ie.getLineContent(),re=Ce.LineDecoration.filter(te,ee,1,oe.length+1);ne.appendASCIIString('<div class="view-line'),0===te.length&&ne.appendASCIIString(" char-delete"),ne.appendASCIIString('" style="top:'),ne.appendASCIIString(String(X*Q.lineHeight)),ne.appendASCIIString('px;width:1000000px;">');var se=Se.ViewLineRenderingData.isBasicASCII(oe,$.mightContainNonBasicASCII()),ae=Se.ViewLineRenderingData.containsRTL(oe,se,$.mightContainRTL()),le=we.renderViewLine(new we.RenderLineInput(Q.fontInfo.isMonospace&&!Q.viewInfo.disableMonospaceOptimizations,Q.fontInfo.canUseHalfwidthRightwardsArrow,oe,!1,se,ae,0,ie,re,J,Q.fontInfo.spaceWidth,Q.viewInfo.stopRenderingLineAfter,Q.viewInfo.renderWhitespace,Q.viewInfo.renderControlCharacters,Q.viewInfo.fontLigatures),ne);ne.appendASCIIString("</div>");var ue=le.characterMapping.getAbsoluteOffsets();return ue.length>0?ue[ue.length-1]:0},t}(Pe);Ne.registerThemingParticipant((function(X,$){var Q=X.getColor(De.diffInserted);Q&&($.addRule(".monaco-editor .line-insert, .monaco-editor .char-insert { background-color: "+Q+"; }"),$.addRule(".monaco-diff-editor .line-insert, .monaco-diff-editor .char-insert { background-color: "+Q+"; }"),$.addRule(".monaco-editor .inline-added-margin-view-zone { background-color: "+Q+"; }"));var J=X.getColor(De.diffRemoved);J&&($.addRule(".monaco-editor .line-delete, .monaco-editor .char-delete { background-color: "+J+"; }"),$.addRule(".monaco-diff-editor .line-delete, .monaco-diff-editor .char-delete { background-color: "+J+"; }"),$.addRule(".monaco-editor .inline-deleted-margin-view-zone { background-color: "+J+"; }"));var ee=X.getColor(De.diffInsertedOutline);ee&&$.addRule(".monaco-editor .line-insert, .monaco-editor .char-insert { border: 1px "+("hc"===X.type?"dashed":"solid")+" "+ee+"; }");var te=X.getColor(De.diffRemovedOutline);te&&$.addRule(".monaco-editor .line-delete, .monaco-editor .char-delete { border: 1px "+("hc"===X.type?"dashed":"solid")+" "+te+"; }");var ne=X.getColor(De.scrollbarShadow);ne&&$.addRule(".monaco-diff-editor.side-by-side .editor.modified { box-shadow: -6px 0 5px -5px "+ne+"; }");var ie=X.getColor(De.diffBorder);ie&&$.addRule(".monaco-diff-editor.side-by-side .editor.modified { border-left: 1px solid "+ie+"; }")}))})),define(Q[139],n([0,1,27,30,99,31,18,15,35,13]),(function(X,$,Q,J,ee,ie,re,se,ae,le){Object.defineProperty($,"__esModule",{value:!0});var ue=function(X){function t($,Q,J,ee,te,ne,ie,oe,re){var se=X.call(this,$,J.getRawConfiguration(),{},ee,te,ne,ie,oe,re)||this;return se._parentEditor=J,se._overwriteOptions=Q,X.prototype.updateOptions.call(se,se._overwriteOptions),se._register(J.onDidChangeConfiguration((function(X){return se._onParentConfigurationChanged(X)}))),se}return te(t,X),t.prototype.getParentEditor=function(){return this._parentEditor},t.prototype._onParentConfigurationChanged=function($){X.prototype.updateOptions.call(this,this._parentEditor.getRawConfiguration()),X.prototype.updateOptions.call(this,this._overwriteOptions)},t.prototype.updateOptions=function($){Q.mixin(this._overwriteOptions,$,!0),X.prototype.updateOptions.call(this,this._overwriteOptions)},ne([oe(3,se.IInstantiationService),oe(4,J.ICodeEditorService),oe(5,ie.ICommandService),oe(6,re.IContextKeyService),oe(7,le.IThemeService),oe(8,ae.INotificationService)],t)}(ee.CodeEditorWidget);$.EmbeddedCodeEditorWidget=ue})),define(Q[509],n([0,1,299,22,6,68,2,50,58,17,48,3,44,26,104,106,34,45,76,13]),(function(X,$,Q,J,ee,ie,re,se,ae,le,ue,de,ce,he,pe,fe,ge,me,ve,_e){function w(X){return X.toString()}Object.defineProperty($,"__esModule",{value:!0});var ye=function(){function e(X,$,Q){this.model=X,this._languageSelection=null,this._languageSelectionListener=null,this._markerDecorations=[],this._modelEventListeners=[],this._modelEventListeners.push(X.onWillDispose((function(){return $(X)}))),this._modelEventListeners.push(X.onDidChangeLanguage((function($){return Q(X,$)})))}return e.prototype._disposeLanguageSelection=function(){this._languageSelectionListener&&(this._languageSelectionListener.dispose(),this._languageSelectionListener=null),this._languageSelection&&(this._languageSelection.dispose(),this._languageSelection=null)},e.prototype.dispose=function(){this._markerDecorations=this.model.deltaDecorations(this._markerDecorations,[]),this._modelEventListeners=re.dispose(this._modelEventListeners),this._disposeLanguageSelection()},e.prototype.acceptMarkerDecorations=function(X){this._markerDecorations=this.model.deltaDecorations(this._markerDecorations,X)},e.prototype.setLanguage=function(X){var $=this;this._disposeLanguageSelection(),this._languageSelection=X,this._languageSelectionListener=this._languageSelection.onDidChange((function(){return $.model.setMode(X.languageIdentifier)})),this.model.setMode(X.languageIdentifier)},e}(),be=function(){function e(){}return e.setMarkers=function(X,$){var Q=$.read({resource:X.model.uri,take:500}).map((function($){return{range:e._createDecorationRange(X.model,$),options:e._createDecorationOption($)}}));X.acceptMarkerDecorations(Q)},e._createDecorationRange=function(X,$){var Q=de.Range.lift($);if($.severity===ve.MarkerSeverity.Hint&&($.tags&&-1!==$.tags.indexOf(1)||(Q=Q.setEndPosition(Q.startLineNumber,Q.startColumn+2))),(Q=X.validateRange(Q)).isEmpty()){var J=X.getWordAtPosition(Q.getStartPosition());if(J)Q=new de.Range(Q.startLineNumber,J.startColumn,Q.endLineNumber,J.endColumn);else{var ee=X.getLineLastNonWhitespaceColumn(Q.startLineNumber)||X.getLineMaxColumn(Q.startLineNumber);1===ee||(Q=Q.endColumn>=ee?new de.Range(Q.startLineNumber,ee-1,Q.endLineNumber,ee):new de.Range(Q.startLineNumber,Q.startColumn,Q.endLineNumber,Q.endColumn+1))}}else if($.endColumn===Number.MAX_VALUE&&1===$.startColumn&&Q.startLineNumber===Q.endLineNumber){var te=X.getLineFirstNonWhitespaceColumn($.startLineNumber);te<Q.endColumn&&(Q=new de.Range(Q.startLineNumber,te,Q.endLineNumber,Q.endColumn),$.startColumn=te)}return Q},e._createDecorationOption=function(X){var $,ee,te=void 0,ne=void 0;switch(X.severity){case ve.MarkerSeverity.Hint:$=X.tags&&X.tags.indexOf(1)>=0?"squiggly-unnecessary":"squiggly-hint",ee=0;break;case ve.MarkerSeverity.Warning:$="squiggly-warning",te=_e.themeColorFromId(ge.overviewRulerWarning),ee=20;break;case ve.MarkerSeverity.Info:$="squiggly-info",te=_e.themeColorFromId(ge.overviewRulerInfo),ee=10;break;case ve.MarkerSeverity.Error:default:$="squiggly-error",te=_e.themeColorFromId(ge.overviewRulerError),ee=30}X.tags&&-1!==X.tags.indexOf(1)&&(ne="squiggly-inline-unnecessary");var oe=null,re=X.message,se=X.source,le=X.relatedInformation,ue=X.code;if("string"==typeof re&&(re=re.trim(),se&&(re=/\n/g.test(re)?ue?Q.localize(0,null,se,re,ue):Q.localize(1,null,se,re):ue?Q.localize(2,null,se,re,ue):Q.localize(3,null,se,re)),oe=(new ie.MarkdownString).appendCodeblock("_",re),!J.isFalsyOrEmpty(le))){oe.appendMarkdown("\n");for(var de=0,he=le;de<he.length;de++){var pe=he[de],fe=pe.message,me=pe.resource,ye=pe.startLineNumber,be=pe.startColumn;oe.appendMarkdown("* ["+ae.basename(me.path)+"("+ye+", "+be+")]("+me.toString(!1)+"#"+ye+","+be+"): "),oe.appendText(""+fe),oe.appendMarkdown("\n")}oe.appendMarkdown("\n")}return{stickiness:1,className:$,hoverMessage:oe,showIfCollapsed:!0,overviewRuler:{color:te,position:ce.OverviewRulerLane.Right},zIndex:ee,inlineClassName:ne}},e}(),Ce=le.isLinux||le.isMacintosh?1:2,we=function(X){function t($,Q,J){var te=X.call(this)||this;return te._onModelAdded=te._register(new ee.Emitter),te.onModelAdded=te._onModelAdded.event,te._onModelRemoved=te._register(new ee.Emitter),te.onModelRemoved=te._onModelRemoved.event,te._onModelModeChanged=te._register(new ee.Emitter),te.onModelModeChanged=te._onModelModeChanged.event,te._markerService=$,te._configurationService=Q,te._resourcePropertiesService=J,te._models={},te._modelCreationOptionsByLanguageAndResource=Object.create(null),te._markerService&&(te._markerServiceSubscription=te._markerService.onMarkerChanged(te._handleMarkerChange,te)),te._configurationServiceSubscription=te._configurationService.onDidChangeConfiguration((function(X){return te._updateModelOptions()})),te._updateModelOptions(),te}return te(t,X),t._readModelOptions=function(X,$){var Q=ue.EDITOR_MODEL_DEFAULTS.tabSize;if(X.editor&&void 0!==X.editor.tabSize){var J=parseInt(X.editor.tabSize,10);isNaN(J)||(Q=J),Q<1&&(Q=1)}var ee=ue.EDITOR_MODEL_DEFAULTS.insertSpaces;X.editor&&void 0!==X.editor.insertSpaces&&(ee="false"!==X.editor.insertSpaces&&Boolean(X.editor.insertSpaces));var te=Ce,ne=X.eol;"\r\n"===ne?te=2:"\n"===ne&&(te=1);var ie=ue.EDITOR_MODEL_DEFAULTS.trimAutoWhitespace;X.editor&&void 0!==X.editor.trimAutoWhitespace&&(ie="false"!==X.editor.trimAutoWhitespace&&Boolean(X.editor.trimAutoWhitespace));var oe=ue.EDITOR_MODEL_DEFAULTS.detectIndentation;X.editor&&void 0!==X.editor.detectIndentation&&(oe="false"!==X.editor.detectIndentation&&Boolean(X.editor.detectIndentation));var re=ue.EDITOR_MODEL_DEFAULTS.largeFileOptimizations;return X.editor&&void 0!==X.editor.largeFileOptimizations&&(re="false"!==X.editor.largeFileOptimizations&&Boolean(X.editor.largeFileOptimizations)),{isForSimpleWidget:$,tabSize:Q,insertSpaces:ee,detectIndentation:oe,defaultEOL:te,trimAutoWhitespace:ie,largeFileOptimizations:re}},t.prototype.getCreationOptions=function(X,$,Q){var J=this._modelCreationOptionsByLanguageAndResource[X+$];if(!J){var ee=this._configurationService.getValue("editor",{overrideIdentifier:X,resource:$}),te=this._resourcePropertiesService.getEOL($,X);J=t._readModelOptions({editor:ee,eol:te},Q),this._modelCreationOptionsByLanguageAndResource[X+$]=J}return J},t.prototype._updateModelOptions=function(){var X=this._modelCreationOptionsByLanguageAndResource;this._modelCreationOptionsByLanguageAndResource=Object.create(null);for(var $=Object.keys(this._models),Q=0,J=$.length;Q<J;Q++){var ee=$[Q],te=this._models[ee],ne=te.model.getLanguageIdentifier().language,ie=te.model.uri,oe=X[ne+ie],re=this.getCreationOptions(ne,ie,te.model.isForSimpleWidget);t._setModelOptionsForModel(te.model,re,oe)}},t._setModelOptionsForModel=function(X,$,Q){Q&&Q.detectIndentation===$.detectIndentation&&Q.insertSpaces===$.insertSpaces&&Q.tabSize===$.tabSize&&Q.trimAutoWhitespace===$.trimAutoWhitespace||($.detectIndentation?(X.detectIndentation($.insertSpaces,$.tabSize),X.updateOptions({trimAutoWhitespace:$.trimAutoWhitespace})):X.updateOptions({insertSpaces:$.insertSpaces,tabSize:$.tabSize,trimAutoWhitespace:$.trimAutoWhitespace}))},t.prototype.dispose=function(){this._markerServiceSubscription&&this._markerServiceSubscription.dispose(),this._configurationServiceSubscription.dispose(),X.prototype.dispose.call(this)},t.prototype._handleMarkerChange=function(X){var $=this;X.forEach((function(X){var Q=w(X),J=$._models[Q];J&&be.setMarkers(J,$._markerService)}))},t.prototype._cleanUp=function(X){var $=this;X.uri.scheme!==se.Schemas.inMemory&&X.uri.scheme!==se.Schemas.internal&&X.uri.scheme!==se.Schemas.vscode||this._markerService&&this._markerService.read({resource:X.uri}).map((function(X){return X.owner})).forEach((function(Q){return $._markerService.remove(Q,[X.uri])})),delete this._modelCreationOptionsByLanguageAndResource[X.getLanguageIdentifier().language+X.uri]},t.prototype._createModelData=function(X,$,Q,J){var ee=this,te=this.getCreationOptions($.language,Q,J),ne=new he.TextModel(X,te,$,Q),ie=w(ne.uri);if(this._models[ie])throw new Error("ModelService: Cannot add model because it already exists!");var oe=new ye(ne,(function(X){return ee._onWillDispose(X)}),(function(X,$){return ee._onDidChangeLanguage(X,$)}));return this._models[ie]=oe,oe},t.prototype.createModel=function(X,$,Q,J){var ee;return void 0===J&&(J=!1),$?(ee=this._createModelData(X,$.languageIdentifier,Q,J),this.setMode(ee.model,$)):ee=this._createModelData(X,pe.PLAINTEXT_LANGUAGE_IDENTIFIER,Q,J),this._markerService&&be.setMarkers(ee,this._markerService),this._onModelAdded.fire(ee.model),ee.model},t.prototype.setMode=function(X,$){if($){var Q=this._models[w(X.uri)];Q&&Q.setLanguage($)}},t.prototype.getModels=function(){for(var X=[],$=Object.keys(this._models),Q=0,J=$.length;Q<J;Q++){var ee=$[Q];X.push(this._models[ee].model)}return X},t.prototype.getModel=function(X){var $=w(X),Q=this._models[$];return Q?Q.model:null},t.prototype._onWillDispose=function(X){var $=w(X.uri),Q=this._models[$];delete this._models[$],Q.dispose(),this._cleanUp(X),this._onModelRemoved.fire(X)},t.prototype._onDidChangeLanguage=function(X,$){var Q=$.oldLanguage,J=X.getLanguageIdentifier().language,ee=this.getCreationOptions(Q,X.uri,X.isForSimpleWidget),te=this.getCreationOptions(J,X.uri,X.isForSimpleWidget);t._setModelOptionsForModel(X,te,ee),this._onModelModeChanged.fire({model:X,oldModeId:Q})},t=ne([oe(0,ve.IMarkerService),oe(1,me.IConfigurationService),oe(2,fe.ITextResourcePropertiesService)],t)}(re.Disposable);$.ModelServiceImpl=we})),define(Q[510],n([0,1,301,16,2,10,12,21,19,44,26,34,20,13,359]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le,ue,de){Object.defineProperty($,"__esModule",{value:!0});var ce=ue.registerColor("editorOverviewRuler.bracketMatchForeground",{dark:"#A0A0A0",light:"#A0A0A0",hc:"#A0A0A0"},Q.localize(0,null)),he=function(X){function t(){return X.call(this,{id:"editor.action.jumpToBracket",label:Q.localize(1,null),alias:"Go to Bracket",precondition:null,kbOpts:{kbExpr:re.EditorContextKeys.editorTextFocus,primary:3160,weight:100}})||this}return te(t,X),t.prototype.run=function(X,$){var Q=fe.get($);Q&&Q.jumpToBracket()},t}(ne.EditorAction),pe=function(X){function t(){return X.call(this,{id:"editor.action.selectToBracket",label:Q.localize(2,null),alias:"Select to Bracket",precondition:null})||this}return te(t,X),t.prototype.run=function(X,$){var Q=fe.get($);Q&&Q.selectToBracket()},t}(ne.EditorAction),_=function(X,$){this.position=X,this.brackets=$},fe=function(X){function t($){var Q=X.call(this)||this;return Q._editor=$,Q._lastBracketsData=[],Q._lastVersionId=0,Q._decorations=[],Q._updateBracketsSoon=Q._register(new J.RunOnceScheduler((function(){return Q._updateBrackets()}),50)),Q._matchBrackets=Q._editor.getConfiguration().contribInfo.matchBrackets,Q._updateBracketsSoon.schedule(),Q._register($.onDidChangeCursorPosition((function(X){Q._matchBrackets&&Q._updateBracketsSoon.schedule()}))),Q._register($.onDidChangeModelContent((function(X){Q._updateBracketsSoon.schedule()}))),Q._register($.onDidChangeModel((function(X){Q._lastBracketsData=[],Q._decorations=[],Q._updateBracketsSoon.schedule()}))),Q._register($.onDidChangeModelLanguageConfiguration((function(X){Q._lastBracketsData=[],Q._updateBracketsSoon.schedule()}))),Q._register($.onDidChangeConfiguration((function(X){Q._matchBrackets=Q._editor.getConfiguration().contribInfo.matchBrackets,!Q._matchBrackets&&Q._decorations.length>0&&(Q._decorations=Q._editor.deltaDecorations(Q._decorations,[])),Q._updateBracketsSoon.schedule()}))),Q}return te(t,X),t.get=function(X){return X.getContribution(t.ID)},t.prototype.getId=function(){return t.ID},t.prototype.jumpToBracket=function(){if(this._editor.hasModel()){var X=this._editor.getModel(),$=this._editor.getSelections().map((function($){var Q=$.getStartPosition(),J=X.matchBracket(Q),ee=null;if(J)J[0].containsPosition(Q)?ee=J[1].getStartPosition():J[1].containsPosition(Q)&&(ee=J[0].getStartPosition());else{var te=X.findNextBracket(Q);te&&te.range&&(ee=te.range.getStartPosition())}return ee?new oe.Selection(ee.lineNumber,ee.column,ee.lineNumber,ee.column):new oe.Selection(Q.lineNumber,Q.column,Q.lineNumber,Q.column)}));this._editor.setSelections($),this._editor.revealRange($[0])}},t.prototype.selectToBracket=function(){if(this._editor.hasModel()){var X=this._editor.getModel(),$=[];this._editor.getSelections().forEach((function(Q){var J=Q.getStartPosition(),ee=X.matchBracket(J),te=null,ne=null;if(!ee){var ie=X.findNextBracket(J);ie&&ie.range&&(ee=X.matchBracket(ie.range.getStartPosition()))}ee&&(ee[0].startLineNumber===ee[1].startLineNumber?(te=ee[1].startColumn<ee[0].startColumn?ee[1].getStartPosition():ee[0].getStartPosition(),ne=ee[1].startColumn<ee[0].startColumn?ee[0].getEndPosition():ee[1].getEndPosition()):(te=ee[1].startLineNumber<ee[0].startLineNumber?ee[1].getStartPosition():ee[0].getStartPosition(),ne=ee[1].startLineNumber<ee[0].startLineNumber?ee[0].getEndPosition():ee[1].getEndPosition())),te&&ne&&$.push(new oe.Selection(te.lineNumber,te.column,ne.lineNumber,ne.column))})),$.length>0&&(this._editor.setSelections($),this._editor.revealRange($[0]))}},t.prototype._updateBrackets=function(){if(this._matchBrackets){this._recomputeBrackets();for(var X=[],$=0,Q=0,J=this._lastBracketsData.length;Q<J;Q++){var ee=this._lastBracketsData[Q].brackets;ee&&(X[$++]={range:ee[0],options:t._DECORATION_OPTIONS},X[$++]={range:ee[1],options:t._DECORATION_OPTIONS})}this._decorations=this._editor.deltaDecorations(this._decorations,X)}},t.prototype._recomputeBrackets=function(){if(!this._editor.hasModel())return this._lastBracketsData=[],void(this._lastVersionId=0);var X=this._editor.getModel(),$=X.getVersionId(),Q=[];this._lastVersionId===$&&(Q=this._lastBracketsData);for(var J=this._editor.getSelections(),ee=[],te=0,ne=0,oe=J.length;ne<oe;ne++){var re=J[ne];re.isEmpty()&&(ee[te++]=re.getStartPosition())}ee.length>1&&ee.sort(ie.Position.compare);var se=[],ae=0,le=0,ue=Q.length;for(ne=0,oe=ee.length;ne<oe;ne++){for(var de=ee[ne];le<ue&&Q[le].position.isBefore(de);)le++;if(le<ue&&Q[le].position.equals(de))se[ae++]=Q[le];else{var ce=X.matchBracket(de);se[ae++]=new _(de,ce)}}this._lastBracketsData=se,this._lastVersionId=$},t.ID="editor.contrib.bracketMatchingController",t._DECORATION_OPTIONS=ae.ModelDecorationOptions.register({stickiness:1,className:"bracket-match",overviewRuler:{color:de.themeColorFromId(ce),position:se.OverviewRulerLane.Center}}),t}(ee.Disposable);$.BracketMatchingController=fe,ne.registerEditorContribution(fe),ne.registerEditorAction(pe),ne.registerEditorAction(he),de.registerThemingParticipant((function(X,$){var Q=X.getColor(le.editorBracketMatchBackground);Q&&$.addRule(".monaco-editor .bracket-match { background-color: "+Q+"; }");var J=X.getColor(le.editorBracketMatchBorder);J&&$.addRule(".monaco-editor .bracket-match { border: 1px solid "+J+"; }")}))})),define(Q[511],n([0,1,7,22,2,8,3,26,34,20,13,362]),(function(X,$,Q,J,ee,te,ne,ie,oe,re,se){Object.defineProperty($,"__esModule",{value:!0});var ae=function(){function e(X,$){this.afterLineNumber=X,this._onHeight=$,this.heightInLines=1,this.suppressMouseDown=!0,this.domNode=document.createElement("div")}return e.prototype.onComputedHeight=function(X){void 0===this._lastHeight?this._lastHeight=X:this._lastHeight!==X&&(this._lastHeight=X,this._onHeight())},e}(),le=function(){function e(X,$,J,ee){var te=this;this.allowEditorOverflow=!1,this.suppressMouseDown=!0,this._disposables=[],this._commands=Object.create(null),this._id="codeLensWidget"+ ++e._idPool,this._editor=X,this.setSymbolRange($),this._domNode=document.createElement("span"),this._domNode.innerHTML="&nbsp;",Q.addClass(this._domNode,"codelens-decoration"),Q.addClass(this._domNode,"invisible-cl"),this._updateHeight(),this._disposables.push(this._editor.onDidChangeConfiguration((function(X){return X.fontInfo&&te._updateHeight()}))),this._disposables.push(Q.addDisposableListener(this._domNode,"click",(function($){var Q=$.target;if("A"===Q.tagName&&Q.id){var ne=te._commands[Q.id];ne&&(X.focus(),J.executeCommand.apply(J,[ne.id].concat(ne.arguments)).then(void 0,(function(X){ee.error(X)})))}}))),this.updateVisibility()}return e.prototype.dispose=function(){ee.dispose(this._disposables)},e.prototype._updateHeight=function(){var X=this._editor.getConfiguration(),$=X.fontInfo,Q=X.lineHeight;this._domNode.style.height=Math.round(1.1*Q)+"px",this._domNode.style.lineHeight=Q+"px",this._domNode.style.fontSize=Math.round(.9*$.fontSize)+"px",this._domNode.innerHTML="&nbsp;"},e.prototype.updateVisibility=function(){this.isVisible()&&(Q.removeClass(this._domNode,"invisible-cl"),Q.addClass(this._domNode,"fadein"))},e.prototype.withCommands=function(X){if(this._commands=Object.create(null),X=J.coalesce(X),J.isFalsyOrEmpty(X))this._domNode.innerHTML="no commands";else{for(var $=[],Q=0;Q<X.length;Q++){var ee=X[Q].command,ne=te.escape(ee.title),ie=void 0;ee.id?(ie=te.format("<a id={0}>{1}</a>",Q,ne),this._commands[Q]=ee):ie=te.format("<span>{0}</span>",ne),$.push(ie)}this._domNode.innerHTML=$.join("<span>&nbsp;|&nbsp;</span>"),this._editor.layoutContentWidget(this)}},e.prototype.getId=function(){return this._id},e.prototype.getDomNode=function(){return this._domNode},e.prototype.setSymbolRange=function(X){var $=X.startLineNumber,Q=this._editor.getModel().getLineFirstNonWhitespaceColumn($);this._widgetPosition={position:{lineNumber:$,column:Q},preference:[1]}},e.prototype.getPosition=function(){return this._widgetPosition},e.prototype.isVisible=function(){return this._domNode.hasAttribute("monaco-visible-content-widget")},e._idPool=0,e}(),ue=function(){function e(){this._removeDecorations=[],this._addDecorations=[],this._addDecorationsCallbacks=[]}return e.prototype.addDecoration=function(X,$){this._addDecorations.push(X),this._addDecorationsCallbacks.push($)},e.prototype.removeDecoration=function(X){this._removeDecorations.push(X)},e.prototype.commit=function(X){for(var $=X.deltaDecorations(this._removeDecorations,this._addDecorations),Q=0,J=$.length;Q<J;Q++)this._addDecorationsCallbacks[Q]($[Q])},e}();$.CodeLensHelper=ue;var de=function(){function e(X,$,Q,J,ee,te,oe){var re,se=this;this._editor=$,this._data=X,this._decorationIds=new Array(this._data.length),this._data.forEach((function(X,$){Q.addDecoration({range:X.symbol.range,options:ie.ModelDecorationOptions.EMPTY},(function(X){return se._decorationIds[$]=X})),re=re?ne.Range.plusRange(re,X.symbol.range):ne.Range.lift(X.symbol.range)})),this._contentWidget=new le($,re,ee,te),this._viewZone=new ae(re.startLineNumber-1,oe),this._viewZoneId=J.addZone(this._viewZone),this._editor.addContentWidget(this._contentWidget)}return e.prototype.dispose=function(X,$){for(;this._decorationIds.length;)X.removeDecoration(this._decorationIds.pop());$&&$.removeZone(this._viewZoneId),this._editor.removeContentWidget(this._contentWidget),this._contentWidget.dispose()},e.prototype.isValid=function(){var X=this;return this._decorationIds.some((function($,Q){var J=X._editor.getModel().getDecorationRange($),ee=X._data[Q].symbol;return J&&ne.Range.isEmpty(ee.range)===J.isEmpty()}))},e.prototype.updateCodeLensSymbols=function(X,$){for(var Q=this;this._decorationIds.length;)$.removeDecoration(this._decorationIds.pop());this._data=X,this._decorationIds=new Array(this._data.length),this._data.forEach((function(X,J){$.addDecoration({range:X.symbol.range,options:ie.ModelDecorationOptions.EMPTY},(function(X){return Q._decorationIds[J]=X}))}))},e.prototype.computeIfNecessary=function(X){if(this._contentWidget.updateVisibility(),!this._contentWidget.isVisible())return null;for(var $=0;$<this._decorationIds.length;$++)this._data[$].symbol.range=X.getDecorationRange(this._decorationIds[$]);return this._data},e.prototype.updateCommands=function(X){this._contentWidget.withCommands(X)},e.prototype.getLineNumber=function(){var X=this._editor.getModel().getDecorationRange(this._decorationIds[0]);return X?X.startLineNumber:-1},e.prototype.update=function(X){if(this.isValid()){var $=this._editor.getModel().getDecorationRange(this._decorationIds[0]);this._viewZone.afterLineNumber=$.startLineNumber-1,X.layoutZone(this._viewZoneId),this._contentWidget.setSymbolRange($),this._editor.layoutContentWidget(this._contentWidget)}},e}();$.CodeLens=de,se.registerThemingParticipant((function(X,$){var Q=X.getColor(oe.editorCodeLensForeground);Q&&$.addRule(".monaco-editor .codelens-decoration { color: "+Q+"; }");var J=X.getColor(re.editorActiveLinkForeground);J&&$.addRule(".monaco-editor .codelens-decoration > a:hover { color: "+J+" !important; }")}))})),define(Q[512],n([0,1,16,11,2,66,10,14,452,511,31,35]),(function(X,$,Q,J,ee,te,ie,re,se,ae,le,ue){Object.defineProperty($,"__esModule",{value:!0});var de=function(){function e(X,$,Q){var J=this;this._editor=X,this._commandService=$,this._notificationService=Q,this._isEnabled=this._editor.getConfiguration().contribInfo.codeLens,this._globalToDispose=[],this._localToDispose=[],this._lenses=[],this._currentFindCodeLensSymbolsPromise=null,this._modelChangeCounter=0,this._globalToDispose.push(this._editor.onDidChangeModel((function(){return J._onModelChange()}))),this._globalToDispose.push(this._editor.onDidChangeModelLanguage((function(){return J._onModelChange()}))),this._globalToDispose.push(this._editor.onDidChangeConfiguration((function(X){var $=J._isEnabled;J._isEnabled=J._editor.getConfiguration().contribInfo.codeLens,$!==J._isEnabled&&J._onModelChange()}))),this._globalToDispose.push(re.CodeLensProviderRegistry.onDidChange(this._onModelChange,this)),this._onModelChange()}return e.prototype.dispose=function(){this._localDispose(),this._globalToDispose=ee.dispose(this._globalToDispose)},e.prototype._localDispose=function(){this._currentFindCodeLensSymbolsPromise&&(this._currentFindCodeLensSymbolsPromise.cancel(),this._currentFindCodeLensSymbolsPromise=null,this._modelChangeCounter++),this._currentResolveCodeLensSymbolsPromise&&(this._currentResolveCodeLensSymbolsPromise.cancel(),this._currentResolveCodeLensSymbolsPromise=null),this._localToDispose=ee.dispose(this._localToDispose)},e.prototype.getId=function(){return e.ID},e.prototype._onModelChange=function(){var X=this;this._localDispose();var $=this._editor.getModel();if($&&this._isEnabled&&re.CodeLensProviderRegistry.has($)){for(var ne=0,ie=re.CodeLensProviderRegistry.all($);ne<ie.length;ne++){var oe=ie[ne];if("function"==typeof oe.onDidChange){var le=oe.onDidChange((function(){return ue.schedule()}));this._localToDispose.push(le)}}this._detectVisibleLenses=new Q.RunOnceScheduler((function(){X._onViewportChanged()}),500);var ue=new Q.RunOnceScheduler((function(){var ee=++X._modelChangeCounter;X._currentFindCodeLensSymbolsPromise&&X._currentFindCodeLensSymbolsPromise.cancel(),X._currentFindCodeLensSymbolsPromise=Q.createCancelablePromise((function(X){return se.getCodeLensData($,X)})),X._currentFindCodeLensSymbolsPromise.then((function($){ee===X._modelChangeCounter&&(X._renderCodeLensSymbols($),X._detectVisibleLenses.schedule())}),J.onUnexpectedError)}),250);this._localToDispose.push(ue),this._localToDispose.push(this._detectVisibleLenses),this._localToDispose.push(this._editor.onDidChangeModelContent((function($){X._editor.changeDecorations((function($){X._editor.changeViewZones((function(Q){var J=[],ee=-1;X._lenses.forEach((function(X){X.isValid()&&ee!==X.getLineNumber()?(X.update(Q),ee=X.getLineNumber()):J.push(X)}));var te=new ae.CodeLensHelper;J.forEach((function($){$.dispose(te,Q),X._lenses.splice(X._lenses.indexOf($),1)})),te.commit($)}))})),X._detectVisibleLenses.schedule(),ue.schedule()}))),this._localToDispose.push(this._editor.onDidScrollChange((function($){$.scrollTopChanged&&X._lenses.length>0&&X._detectVisibleLenses.schedule()}))),this._localToDispose.push(this._editor.onDidLayoutChange((function($){X._detectVisibleLenses.schedule()}))),this._localToDispose.push(ee.toDisposable((function(){if(X._editor.getModel()){var $=te.StableEditorScrollState.capture(X._editor);X._editor.changeDecorations((function($){X._editor.changeViewZones((function(Q){X._disposeAllLenses($,Q)}))})),$.restore(X._editor)}else X._disposeAllLenses(null,null)}))),ue.schedule()}},e.prototype._disposeAllLenses=function(X,$){var Q=new ae.CodeLensHelper;this._lenses.forEach((function(X){return X.dispose(Q,$)})),X&&Q.commit(X),this._lenses=[]},e.prototype._renderCodeLensSymbols=function(X){var $=this;if(this._editor.getModel()){for(var Q,J=this._editor.getModel().getLineCount(),ee=[],ne=0,ie=X;ne<ie.length;ne++){var oe=ie[ne],re=oe.symbol.range.startLineNumber;re<1||re>J||(Q&&Q[Q.length-1].symbol.range.startLineNumber===re?Q.push(oe):(Q=[oe],ee.push(Q)))}var se=te.StableEditorScrollState.capture(this._editor);this._editor.changeDecorations((function(X){$._editor.changeViewZones((function(Q){for(var J=0,te=0,ne=new ae.CodeLensHelper;te<ee.length&&J<$._lenses.length;){var ie=ee[te][0].symbol.range.startLineNumber,oe=$._lenses[J].getLineNumber();oe<ie?($._lenses[J].dispose(ne,Q),$._lenses.splice(J,1)):oe===ie?($._lenses[J].updateCodeLensSymbols(ee[te],ne),te++,J++):($._lenses.splice(J,0,new ae.CodeLens(ee[te],$._editor,ne,Q,$._commandService,$._notificationService,(function(){return $._detectVisibleLenses.schedule()}))),J++,te++)}for(;J<$._lenses.length;)$._lenses[J].dispose(ne,Q),$._lenses.splice(J,1);for(;te<ee.length;)$._lenses.push(new ae.CodeLens(ee[te],$._editor,ne,Q,$._commandService,$._notificationService,(function(){return $._detectVisibleLenses.schedule()}))),te++;ne.commit(X)}))})),se.restore(this._editor)}},e.prototype._onViewportChanged=function(){var X=this;this._currentResolveCodeLensSymbolsPromise&&(this._currentResolveCodeLensSymbolsPromise.cancel(),this._currentResolveCodeLensSymbolsPromise=null);var $=this._editor.getModel();if($){var ee=[],te=[];this._lenses.forEach((function(X){var Q=X.computeIfNecessary($);Q&&(ee.push(Q),te.push(X))})),0!==ee.length&&(this._currentResolveCodeLensSymbolsPromise=Q.createCancelablePromise((function(X){var Q=ee.map((function(Q,J){var ee=new Array(Q.length),ne=Q.map((function(Q,J){return"function"==typeof Q.provider.resolveCodeLens?Promise.resolve(Q.provider.resolveCodeLens($,Q.symbol,X)).then((function(X){ee[J]=X})):(ee[J]=Q.symbol,Promise.resolve(void 0))}));return Promise.all(ne).then((function(){te[J].updateCommands(ee)}))}));return Promise.all(Q)})),this._currentResolveCodeLensSymbolsPromise.then((function(){X._currentResolveCodeLensSymbolsPromise=null})).catch((function($){X._currentResolveCodeLensSymbolsPromise=null,J.onUnexpectedError($)})))}},e.ID="css.editor.codeLens",e=ne([oe(1,le.ICommandService),oe(2,ue.INotificationService)],e)}();$.CodeLensContribution=de,ie.registerEditorContribution(de)})),define(Q[513],n([0,1,29,7,73,46,28,6,2,20,13,363]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae){Object.defineProperty($,"__esModule",{value:!0});var le=J.$,ue=function(X){function t($,Q,ee){var te=X.call(this)||this;te.model=Q,te.domNode=le(".colorpicker-header"),J.append($,te.domNode),te.pickedColorNode=J.append(te.domNode,le(".picked-color"));var ne=J.append(te.domNode,le(".original-color"));return ne.style.backgroundColor=ie.Color.Format.CSS.format(te.model.originalColor),te.backgroundColor=ee.getTheme().getColor(se.editorHoverBackground)||ie.Color.white,te._register(ae.registerThemingParticipant((function(X,$){te.backgroundColor=X.getColor(se.editorHoverBackground)||ie.Color.white}))),te._register(J.addDisposableListener(te.pickedColorNode,J.EventType.CLICK,(function(){return te.model.selectNextColorPresentation()}))),te._register(J.addDisposableListener(ne,J.EventType.CLICK,(function(){te.model.color=te.model.originalColor,te.model.flushColor()}))),te._register(Q.onDidChangeColor(te.onDidChangeColor,te)),te._register(Q.onDidChangePresentation(te.onDidChangePresentation,te)),te.pickedColorNode.style.backgroundColor=ie.Color.Format.CSS.format(Q.color),J.toggleClass(te.pickedColorNode,"light",Q.color.rgba.a<.5?te.backgroundColor.isLighter():Q.color.isLighter()),te}return te(t,X),t.prototype.onDidChangeColor=function(X){this.pickedColorNode.style.backgroundColor=ie.Color.Format.CSS.format(X),J.toggleClass(this.pickedColorNode,"light",X.rgba.a<.5?this.backgroundColor.isLighter():X.isLighter()),this.onDidChangePresentation()},t.prototype.onDidChangePresentation=function(){this.pickedColorNode.textContent=this.model.presentation?this.model.presentation.label:""},t}(re.Disposable);$.ColorPickerHeader=ue;var de=function(X){function t($,Q,ee){var te=X.call(this)||this;return te.model=Q,te.pixelRatio=ee,te.domNode=le(".colorpicker-body"),J.append($,te.domNode),te.saturationBox=new ce(te.domNode,te.model,te.pixelRatio),te._register(te.saturationBox),te._register(te.saturationBox.onDidChange(te.onDidSaturationValueChange,te)),te._register(te.saturationBox.onColorFlushed(te.flushColor,te)),te.opacityStrip=new pe(te.domNode,te.model),te._register(te.opacityStrip),te._register(te.opacityStrip.onDidChange(te.onDidOpacityChange,te)),te._register(te.opacityStrip.onColorFlushed(te.flushColor,te)),te.hueStrip=new fe(te.domNode,te.model),te._register(te.hueStrip),te._register(te.hueStrip.onDidChange(te.onDidHueChange,te)),te._register(te.hueStrip.onColorFlushed(te.flushColor,te)),te}return te(t,X),t.prototype.flushColor=function(){this.model.flushColor()},t.prototype.onDidSaturationValueChange=function(X){var $=X.s,Q=X.v,J=this.model.color.hsva;this.model.color=new ie.Color(new ie.HSVA(J.h,$,Q,J.a))},t.prototype.onDidOpacityChange=function(X){var $=this.model.color.hsva;this.model.color=new ie.Color(new ie.HSVA($.h,$.s,$.v,X))},t.prototype.onDidHueChange=function(X){var $=this.model.color.hsva,Q=360*(1-X);this.model.color=new ie.Color(new ie.HSVA(360===Q?0:Q,$.s,$.v,$.a))},t.prototype.layout=function(){this.saturationBox.layout(),this.opacityStrip.layout(),this.hueStrip.layout()},t}(re.Disposable);$.ColorPickerBody=de;var ce=function(X){function t($,Q,ee){var te=X.call(this)||this;return te.model=Q,te.pixelRatio=ee,te._onDidChange=new oe.Emitter,te.onDidChange=te._onDidChange.event,te._onColorFlushed=new oe.Emitter,te.onColorFlushed=te._onColorFlushed.event,te.domNode=le(".saturation-wrap"),J.append($,te.domNode),te.canvas=document.createElement("canvas"),te.canvas.className="saturation-box",J.append(te.domNode,te.canvas),te.selection=le(".saturation-selection"),J.append(te.domNode,te.selection),te.layout(),te._register(J.addDisposableListener(te.domNode,J.EventType.MOUSE_DOWN,(function(X){return te.onMouseDown(X)}))),te._register(te.model.onDidChangeColor(te.onDidChangeColor,te)),te.monitor=null,te}return te(t,X),t.prototype.onMouseDown=function(X){var $=this;this.monitor=this._register(new ee.GlobalMouseMoveMonitor);var Q=J.getDomNodePagePosition(this.domNode);X.target!==this.selection&&this.onDidChangePosition(X.offsetX,X.offsetY),this.monitor.startMonitoring(ee.standardMouseMoveMerger,(function(X){return $.onDidChangePosition(X.posx-Q.left,X.posy-Q.top)}),(function(){return null}));var te=J.addDisposableListener(document,J.EventType.MOUSE_UP,(function(){$._onColorFlushed.fire(),te.dispose(),$.monitor.stopMonitoring(!0),$.monitor=null}),!0)},t.prototype.onDidChangePosition=function(X,$){var Q=Math.max(0,Math.min(1,X/this.width)),J=Math.max(0,Math.min(1,1-$/this.height));this.paintSelection(Q,J),this._onDidChange.fire({s:Q,v:J})},t.prototype.layout=function(){this.width=this.domNode.offsetWidth,this.height=this.domNode.offsetHeight,this.canvas.width=this.width*this.pixelRatio,this.canvas.height=this.height*this.pixelRatio,this.paint();var X=this.model.color.hsva;this.paintSelection(X.s,X.v)},t.prototype.paint=function(){var X=this.model.color.hsva,$=new ie.Color(new ie.HSVA(X.h,1,1,1)),Q=this.canvas.getContext("2d"),J=Q.createLinearGradient(0,0,this.canvas.width,0);J.addColorStop(0,"rgba(255, 255, 255, 1)"),J.addColorStop(.5,"rgba(255, 255, 255, 0.5)"),J.addColorStop(1,"rgba(255, 255, 255, 0)");var ee=Q.createLinearGradient(0,0,0,this.canvas.height);ee.addColorStop(0,"rgba(0, 0, 0, 0)"),ee.addColorStop(1,"rgba(0, 0, 0, 1)"),Q.rect(0,0,this.canvas.width,this.canvas.height),Q.fillStyle=ie.Color.Format.CSS.format($),Q.fill(),Q.fillStyle=J,Q.fill(),Q.fillStyle=ee,Q.fill()},t.prototype.paintSelection=function(X,$){this.selection.style.left=X*this.width+"px",this.selection.style.top=this.height-$*this.height+"px"},t.prototype.onDidChangeColor=function(){this.monitor&&this.monitor.isMonitoring()||this.paint()},t}(re.Disposable),he=function(X){function t($,Q){var ee=X.call(this)||this;return ee.model=Q,ee._onDidChange=new oe.Emitter,ee.onDidChange=ee._onDidChange.event,ee._onColorFlushed=new oe.Emitter,ee.onColorFlushed=ee._onColorFlushed.event,ee.domNode=J.append($,le(".strip")),ee.overlay=J.append(ee.domNode,le(".overlay")),ee.slider=J.append(ee.domNode,le(".slider")),ee.slider.style.top="0px",ee._register(J.addDisposableListener(ee.domNode,J.EventType.MOUSE_DOWN,(function(X){return ee.onMouseDown(X)}))),ee.layout(),ee}return te(t,X),t.prototype.layout=function(){this.height=this.domNode.offsetHeight-this.slider.offsetHeight;var X=this.getValue(this.model.color);this.updateSliderPosition(X)},t.prototype.onMouseDown=function(X){var $=this,Q=this._register(new ee.GlobalMouseMoveMonitor),te=J.getDomNodePagePosition(this.domNode);J.addClass(this.domNode,"grabbing"),X.target!==this.slider&&this.onDidChangeTop(X.offsetY),Q.startMonitoring(ee.standardMouseMoveMerger,(function(X){return $.onDidChangeTop(X.posy-te.top)}),(function(){return null}));var ne=J.addDisposableListener(document,J.EventType.MOUSE_UP,(function(){$._onColorFlushed.fire(),ne.dispose(),Q.stopMonitoring(!0),J.removeClass($.domNode,"grabbing")}),!0)},t.prototype.onDidChangeTop=function(X){var $=Math.max(0,Math.min(1,1-X/this.height));this.updateSliderPosition($),this._onDidChange.fire($)},t.prototype.updateSliderPosition=function(X){this.slider.style.top=(1-X)*this.height+"px"},t}(re.Disposable),pe=function(X){function t($,Q){var ee=X.call(this,$,Q)||this;return J.addClass(ee.domNode,"opacity-strip"),ee._register(Q.onDidChangeColor(ee.onDidChangeColor,ee)),ee.onDidChangeColor(ee.model.color),ee}return te(t,X),t.prototype.onDidChangeColor=function(X){var $=X.rgba,Q=$.r,J=$.g,ee=$.b,te=new ie.Color(new ie.RGBA(Q,J,ee,1)),ne=new ie.Color(new ie.RGBA(Q,J,ee,0));this.overlay.style.background="linear-gradient(to bottom, "+te+" 0%, "+ne+" 100%)"},t.prototype.getValue=function(X){return X.hsva.a},t}(he),fe=function(X){function t($,Q){var ee=X.call(this,$,Q)||this;return J.addClass(ee.domNode,"hue-strip"),ee}return te(t,X),t.prototype.getValue=function(X){return 1-X.hsva.h/360},t}(he),ge=function(X){function t($,J,ee,te){var ne=X.call(this)||this;ne.model=J,ne.pixelRatio=ee,ne._register(Q.onDidChangeZoomLevel((function(){return ne.layout()})));var ie=le(".colorpicker-widget");$.appendChild(ie);var oe=new ue(ie,ne.model,te);return ne.body=new de(ie,ne.model,ne.pixelRatio),ne._register(oe),ne._register(ne.body),ne}return te(t,X),t.prototype.layout=function(){this.body.layout()},t}(ne.Widget);$.ColorPickerWidget=ge})),define(Q[514],n([0,1,3,44,26,20,13]),(function(X,$,Q,J,ee,te,ne){Object.defineProperty($,"__esModule",{value:!0});var ie=function(){function e(X){this._editor=X,this._decorations=[],this._overviewRulerApproximateDecorations=[],this._findScopeDecorationId=null,this._rangeHighlightDecorationId=null,this._highlightedDecorationId=null,this._startPosition=this._editor.getPosition()}return e.prototype.dispose=function(){this._editor.deltaDecorations(this._allDecorations(),[]),this._decorations=[],this._overviewRulerApproximateDecorations=[],this._findScopeDecorationId=null,this._rangeHighlightDecorationId=null,this._highlightedDecorationId=null},e.prototype.reset=function(){this._decorations=[],this._overviewRulerApproximateDecorations=[],this._findScopeDecorationId=null,this._rangeHighlightDecorationId=null,this._highlightedDecorationId=null},e.prototype.getCount=function(){return this._decorations.length},e.prototype.getFindScope=function(){return this._findScopeDecorationId?this._editor.getModel().getDecorationRange(this._findScopeDecorationId):null},e.prototype.getStartPosition=function(){return this._startPosition},e.prototype.setStartPosition=function(X){this._startPosition=X,this.setCurrentFindMatch(null)},e.prototype._getDecorationIndex=function(X){var $=this._decorations.indexOf(X);return $>=0?$+1:1},e.prototype.getCurrentMatchesPosition=function(X){for(var $=this._editor.getModel().getDecorationsInRange(X),Q=0,J=$.length;Q<J;Q++){var ee=$[Q],te=ee.options;if(te===e._FIND_MATCH_DECORATION||te===e._CURRENT_FIND_MATCH_DECORATION)return this._getDecorationIndex(ee.id)}return 1},e.prototype.setCurrentFindMatch=function(X){var $=this,J=null,ee=0;if(X)for(var te=0,ne=this._decorations.length;te<ne;te++){var ie=this._editor.getModel().getDecorationRange(this._decorations[te]);if(X.equalsRange(ie)){J=this._decorations[te],ee=te+1;break}}return null===this._highlightedDecorationId&&null===J||this._editor.changeDecorations((function(X){if(null!==$._highlightedDecorationId&&(X.changeDecorationOptions($._highlightedDecorationId,e._FIND_MATCH_DECORATION),$._highlightedDecorationId=null),null!==J&&($._highlightedDecorationId=J,X.changeDecorationOptions($._highlightedDecorationId,e._CURRENT_FIND_MATCH_DECORATION)),null!==$._rangeHighlightDecorationId&&(X.removeDecoration($._rangeHighlightDecorationId),$._rangeHighlightDecorationId=null),null!==J){var ee=$._editor.getModel().getDecorationRange(J);if(ee.startLineNumber!==ee.endLineNumber&&1===ee.endColumn){var te=ee.endLineNumber-1,ne=$._editor.getModel().getLineMaxColumn(te);ee=new Q.Range(ee.startLineNumber,ee.startColumn,te,ne)}$._rangeHighlightDecorationId=X.addDecoration(ee,e._RANGE_HIGHLIGHT_DECORATION)}})),ee},e.prototype.set=function(X,$){var J=this;this._editor.changeDecorations((function(ee){var te=e._FIND_MATCH_DECORATION,ne=[];if(X.length>1e3){te=e._FIND_MATCH_NO_OVERVIEW_DECORATION;for(var ie=J._editor.getModel().getLineCount(),oe=J._editor.getLayoutInfo().height/ie,re=Math.max(2,Math.ceil(3/oe)),se=X[0].range.startLineNumber,ae=X[0].range.endLineNumber,le=1,ue=X.length;le<ue;le++){var de=X[le].range;ae+re>=de.startLineNumber?de.endLineNumber>ae&&(ae=de.endLineNumber):(ne.push({range:new Q.Range(se,1,ae,1),options:e._FIND_MATCH_ONLY_OVERVIEW_DECORATION}),se=de.startLineNumber,ae=de.endLineNumber)}ne.push({range:new Q.Range(se,1,ae,1),options:e._FIND_MATCH_ONLY_OVERVIEW_DECORATION})}var ce=new Array(X.length);for(le=0,ue=X.length;le<ue;le++)ce[le]={range:X[le].range,options:te};J._decorations=ee.deltaDecorations(J._decorations,ce),J._overviewRulerApproximateDecorations=ee.deltaDecorations(J._overviewRulerApproximateDecorations,ne),J._rangeHighlightDecorationId&&(ee.removeDecoration(J._rangeHighlightDecorationId),J._rangeHighlightDecorationId=null),J._findScopeDecorationId&&(ee.removeDecoration(J._findScopeDecorationId),J._findScopeDecorationId=null),$&&(J._findScopeDecorationId=ee.addDecoration($,e._FIND_SCOPE_DECORATION))}))},e.prototype.matchBeforePosition=function(X){if(0===this._decorations.length)return null;for(var $=this._decorations.length-1;$>=0;$--){var Q=this._decorations[$],J=this._editor.getModel().getDecorationRange(Q);if(J&&!(J.endLineNumber>X.lineNumber)){if(J.endLineNumber<X.lineNumber)return J;if(!(J.endColumn>X.column))return J}}return this._editor.getModel().getDecorationRange(this._decorations[this._decorations.length-1])},e.prototype.matchAfterPosition=function(X){if(0===this._decorations.length)return null;for(var $=0,Q=this._decorations.length;$<Q;$++){var J=this._decorations[$],ee=this._editor.getModel().getDecorationRange(J);if(ee&&!(ee.startLineNumber<X.lineNumber)){if(ee.startLineNumber>X.lineNumber)return ee;if(!(ee.startColumn<X.column))return ee}}return this._editor.getModel().getDecorationRange(this._decorations[0])},e.prototype._allDecorations=function(){var X=[];return X=(X=X.concat(this._decorations)).concat(this._overviewRulerApproximateDecorations),this._findScopeDecorationId&&X.push(this._findScopeDecorationId),this._rangeHighlightDecorationId&&X.push(this._rangeHighlightDecorationId),X},e._CURRENT_FIND_MATCH_DECORATION=ee.ModelDecorationOptions.register({stickiness:1,zIndex:13,className:"currentFindMatch",showIfCollapsed:!0,overviewRuler:{color:ne.themeColorFromId(te.overviewRulerFindMatchForeground),position:J.OverviewRulerLane.Center}}),e._FIND_MATCH_DECORATION=ee.ModelDecorationOptions.register({stickiness:1,className:"findMatch",showIfCollapsed:!0,overviewRuler:{color:ne.themeColorFromId(te.overviewRulerFindMatchForeground),position:J.OverviewRulerLane.Center}}),e._FIND_MATCH_NO_OVERVIEW_DECORATION=ee.ModelDecorationOptions.register({stickiness:1,className:"findMatch",showIfCollapsed:!0}),e._FIND_MATCH_ONLY_OVERVIEW_DECORATION=ee.ModelDecorationOptions.register({stickiness:1,overviewRuler:{color:ne.themeColorFromId(te.overviewRulerFindMatchForeground),position:J.OverviewRulerLane.Center}}),e._RANGE_HIGHLIGHT_DECORATION=ee.ModelDecorationOptions.register({stickiness:1,className:"rangeHighlight",isWholeLine:!0}),e._FIND_SCOPE_DECORATION=ee.ModelDecorationOptions.register({className:"findScope",isWholeLine:!0}),e}();$.FindDecorations=ie})),define(Q[140],n([0,1,16,2,77,12,3,21,112,514,242,243,18]),(function(X,$,Q,J,ee,te,ne,ie,oe,re,se,ae,le){Object.defineProperty($,"__esModule",{value:!0}),$.CONTEXT_FIND_WIDGET_VISIBLE=new le.RawContextKey("findWidgetVisible",!1),$.CONTEXT_FIND_INPUT_FOCUSED=new le.RawContextKey("findInputFocussed",!1),$.CONTEXT_REPLACE_INPUT_FOCUSED=new le.RawContextKey("replaceInputFocussed",!1),$.ToggleCaseSensitiveKeybinding={primary:545,mac:{primary:2593}},$.ToggleWholeWordKeybinding={primary:565,mac:{primary:2613}},$.ToggleRegexKeybinding={primary:560,mac:{primary:2608}},$.ToggleSearchScopeKeybinding={primary:554,mac:{primary:2602}},$.FIND_IDS={StartFindAction:"actions.find",StartFindWithSelection:"actions.findWithSelection",NextMatchFindAction:"editor.action.nextMatchFindAction",PreviousMatchFindAction:"editor.action.previousMatchFindAction",NextSelectionMatchFindAction:"editor.action.nextSelectionMatchFindAction",PreviousSelectionMatchFindAction:"editor.action.previousSelectionMatchFindAction",StartFindReplaceAction:"editor.action.startFindReplaceAction",CloseFindWidgetCommand:"closeFindWidget",ToggleCaseSensitiveCommand:"toggleFindCaseSensitive",ToggleWholeWordCommand:"toggleFindWholeWord",ToggleRegexCommand:"toggleFindRegex",ToggleSearchScopeCommand:"toggleFindInSelection",ReplaceOneAction:"editor.action.replaceOne",ReplaceAllAction:"editor.action.replaceAll",SelectAllMatchesAction:"editor.action.selectAllMatches"},$.MATCHES_LIMIT=19999;var ue=function(){function e(X,$){var J=this;this._editor=X,this._state=$,this._toDispose=[],this._isDisposed=!1,this._startSearchingTimer=new Q.TimeoutTimer,this._decorations=new re.FindDecorations(X),this._toDispose.push(this._decorations),this._updateDecorationsScheduler=new Q.RunOnceScheduler((function(){return J.research(!1)}),100),this._toDispose.push(this._updateDecorationsScheduler),this._toDispose.push(this._editor.onDidChangeCursorPosition((function(X){3!==X.reason&&5!==X.reason&&6!==X.reason||J._decorations.setStartPosition(J._editor.getPosition())}))),this._ignoreModelContentChanged=!1,this._toDispose.push(this._editor.onDidChangeModelContent((function(X){J._ignoreModelContentChanged||(X.isFlush&&J._decorations.reset(),J._decorations.setStartPosition(J._editor.getPosition()),J._updateDecorationsScheduler.schedule())}))),this._toDispose.push(this._state.onFindReplaceStateChange((function(X){return J._onStateChanged(X)}))),this.research(!1,this._state.searchScope)}return e.prototype.dispose=function(){this._isDisposed=!0,J.dispose(this._startSearchingTimer),this._toDispose=J.dispose(this._toDispose)},e.prototype._onStateChanged=function(X){var $=this;!this._isDisposed&&this._editor.getModel()&&(X.searchString||X.isReplaceRevealed||X.isRegex||X.wholeWord||X.matchCase||X.searchScope)&&(this._editor.getModel().isTooLargeForSyncing()?(this._startSearchingTimer.cancel(),this._startSearchingTimer.setIfNotSet((function(){X.searchScope?$.research(X.moveCursor,$._state.searchScope):$.research(X.moveCursor)}),240)):X.searchScope?this.research(X.moveCursor,this._state.searchScope):this.research(X.moveCursor))},e._getSearchRange=function(X,$){return $||X.getFullModelRange()},e.prototype.research=function(X,Q){var J=null;null!==(J=void 0!==Q?Q:this._decorations.getFindScope())&&J.startLineNumber!==J.endLineNumber&&(J=1===J.endColumn?new ne.Range(J.startLineNumber,1,J.endLineNumber-1,this._editor.getModel().getLineMaxColumn(J.endLineNumber-1)):new ne.Range(J.startLineNumber,1,J.endLineNumber,this._editor.getModel().getLineMaxColumn(J.endLineNumber)));var ee=this._findMatches(J,!1,$.MATCHES_LIMIT);this._decorations.set(ee,J),this._state.changeMatchInfo(this._decorations.getCurrentMatchesPosition(this._editor.getSelection()),this._decorations.getCount(),void 0),X&&this._moveToNextMatch(this._decorations.getStartPosition())},e.prototype._hasMatches=function(){return this._state.matchesCount>0},e.prototype._cannotFind=function(){if(!this._hasMatches()){var X=this._decorations.getFindScope();return X&&this._editor.revealRangeInCenterIfOutsideViewport(X,0),!0}return!1},e.prototype._setCurrentFindMatch=function(X){var $=this._decorations.setCurrentFindMatch(X);this._state.changeMatchInfo($,this._decorations.getCount(),X),this._editor.setSelection(X),this._editor.revealRangeInCenterIfOutsideViewport(X,0)},e.prototype._prevSearchPosition=function(X){var $=this._state.isRegex&&(this._state.searchString.indexOf("^")>=0||this._state.searchString.indexOf("$")>=0),Q=X.lineNumber,J=X.column,ee=this._editor.getModel();return $||1===J?(1===Q?Q=ee.getLineCount():Q--,J=ee.getLineMaxColumn(Q)):J--,new te.Position(Q,J)},e.prototype._moveToPrevMatch=function(X,Q){if(void 0===Q&&(Q=!1),this._decorations.getCount()<$.MATCHES_LIMIT){var J=this._decorations.matchBeforePosition(X);return J&&J.isEmpty()&&J.getStartPosition().equals(X)&&(X=this._prevSearchPosition(X),J=this._decorations.matchBeforePosition(X)),void(J&&this._setCurrentFindMatch(J))}if(!this._cannotFind()){var ee=this._decorations.getFindScope(),ne=e._getSearchRange(this._editor.getModel(),ee);ne.getEndPosition().isBefore(X)&&(X=ne.getEndPosition()),X.isBefore(ne.getStartPosition())&&(X=ne.getEndPosition());var ie=X.lineNumber,oe=X.column,re=this._editor.getModel(),se=new te.Position(ie,oe),ae=re.findPreviousMatch(this._state.searchString,se,this._state.isRegex,this._state.matchCase,this._state.wholeWord?this._editor.getConfiguration().wordSeparators:null,!1);if(ae&&ae.range.isEmpty()&&ae.range.getStartPosition().equals(se)&&(se=this._prevSearchPosition(se),ae=re.findPreviousMatch(this._state.searchString,se,this._state.isRegex,this._state.matchCase,this._state.wholeWord?this._editor.getConfiguration().wordSeparators:null,!1)),ae)return Q||ne.containsRange(ae.range)?void this._setCurrentFindMatch(ae.range):this._moveToPrevMatch(ae.range.getStartPosition(),!0)}},e.prototype.moveToPrevMatch=function(){this._moveToPrevMatch(this._editor.getSelection().getStartPosition())},e.prototype._nextSearchPosition=function(X){var $=this._state.isRegex&&(this._state.searchString.indexOf("^")>=0||this._state.searchString.indexOf("$")>=0),Q=X.lineNumber,J=X.column,ee=this._editor.getModel();return $||J===ee.getLineMaxColumn(Q)?(Q===ee.getLineCount()?Q=1:Q++,J=1):J++,new te.Position(Q,J)},e.prototype._moveToNextMatch=function(X){if(this._decorations.getCount()<$.MATCHES_LIMIT){var Q=this._decorations.matchAfterPosition(X);return Q&&Q.isEmpty()&&Q.getStartPosition().equals(X)&&(X=this._nextSearchPosition(X),Q=this._decorations.matchAfterPosition(X)),void(Q&&this._setCurrentFindMatch(Q))}var J=this._getNextMatch(X,!1,!0);J&&this._setCurrentFindMatch(J.range)},e.prototype._getNextMatch=function(X,$,Q,J){if(void 0===J&&(J=!1),this._cannotFind())return null;var ee=this._decorations.getFindScope(),ne=e._getSearchRange(this._editor.getModel(),ee);ne.getEndPosition().isBefore(X)&&(X=ne.getStartPosition()),X.isBefore(ne.getStartPosition())&&(X=ne.getStartPosition());var ie=X.lineNumber,oe=X.column,re=this._editor.getModel(),se=new te.Position(ie,oe),ae=re.findNextMatch(this._state.searchString,se,this._state.isRegex,this._state.matchCase,this._state.wholeWord?this._editor.getConfiguration().wordSeparators:null,$);return Q&&ae&&ae.range.isEmpty()&&ae.range.getStartPosition().equals(se)&&(se=this._nextSearchPosition(se),ae=re.findNextMatch(this._state.searchString,se,this._state.isRegex,this._state.matchCase,this._state.wholeWord?this._editor.getConfiguration().wordSeparators:null,$)),ae?J||ne.containsRange(ae.range)?ae:this._getNextMatch(ae.range.getEndPosition(),$,Q,!0):null},e.prototype.moveToNextMatch=function(){this._moveToNextMatch(this._editor.getSelection().getEndPosition())},e.prototype._getReplacePattern=function(){return this._state.isRegex?ae.parseReplaceString(this._state.replaceString):ae.ReplacePattern.fromStaticValue(this._state.replaceString)},e.prototype.replace=function(){if(this._hasMatches()){var X=this._getReplacePattern(),$=this._editor.getSelection(),Q=this._getNextMatch($.getStartPosition(),X.hasReplacementPatterns,!1);if(Q)if($.equalsRange(Q.range)){var J=X.buildReplaceString(Q.matches),ne=new ee.ReplaceCommand($,J);this._executeEditorCommand("replace",ne),this._decorations.setStartPosition(new te.Position($.startLineNumber,$.startColumn+J.length)),this.research(!0)}else this._decorations.setStartPosition(this._editor.getPosition()),this._setCurrentFindMatch(Q.range)}},e.prototype._findMatches=function(X,$,Q){var J=e._getSearchRange(this._editor.getModel(),X);return this._editor.getModel().findMatches(this._state.searchString,J,this._state.isRegex,this._state.matchCase,this._state.wholeWord?this._editor.getConfiguration().wordSeparators:null,$,Q)},e.prototype.replaceAll=function(){if(this._hasMatches()){var X=this._decorations.getFindScope();null===X&&this._state.matchesCount>=$.MATCHES_LIMIT?this._largeReplaceAll():this._regularReplaceAll(X),this.research(!1)}},e.prototype._largeReplaceAll=function(){var X=new oe.SearchParams(this._state.searchString,this._state.isRegex,this._state.matchCase,this._state.wholeWord?this._editor.getConfiguration().wordSeparators:null).parseSearchRequest();if(X){var $=X.regex;if(!$.multiline){var Q="m";$.ignoreCase&&(Q+="i"),$.global&&(Q+="g"),$=new RegExp($.source,Q)}var J,te=this._editor.getModel(),ne=te.getValue(1),ie=te.getFullModelRange(),re=this._getReplacePattern();J=re.hasReplacementPatterns?ne.replace($,(function(){return re.buildReplaceString(arguments)})):ne.replace($,re.buildReplaceString(null));var se=new ee.ReplaceCommandThatPreservesSelection(ie,J,this._editor.getSelection());this._executeEditorCommand("replaceAll",se)}},e.prototype._regularReplaceAll=function(X){for(var $=this._getReplacePattern(),Q=this._findMatches(X,$.hasReplacementPatterns,1073741824),J=[],ee=0,te=Q.length;ee<te;ee++)J[ee]=$.buildReplaceString(Q[ee].matches);var ne=new se.ReplaceAllCommand(this._editor.getSelection(),Q.map((function(X){return X.range})),J);this._executeEditorCommand("replaceAll",ne)},e.prototype.selectAllMatches=function(){if(this._hasMatches()){for(var X=this._decorations.getFindScope(),$=this._findMatches(X,!1,1073741824).map((function(X){return new ie.Selection(X.range.startLineNumber,X.range.startColumn,X.range.endLineNumber,X.range.endColumn)})),Q=this._editor.getSelection(),J=0,ee=$.length;J<ee;J++)if($[J].equalsRange(Q)){$=[Q].concat($.slice(0,J)).concat($.slice(J+1));break}this._editor.setSelections($)}},e.prototype._executeEditorCommand=function(X,$){try{this._ignoreModelContentChanged=!0,this._editor.pushUndoStop(),this._editor.executeCommand(X,$),this._editor.pushUndoStop()}finally{this._ignoreModelContentChanged=!1}},e}();$.FindModelBoundToEditorModel=ue})),define(Q[516],n([0,1,7,152,46,16,140,20,13]),(function(X,$,Q,J,ee,ne,ie,oe,re){Object.defineProperty($,"__esModule",{value:!0});var se=function(X){function t($,ee,te,re){var se=X.call(this)||this;se._hideSoon=se._register(new ne.RunOnceScheduler((function(){return se._hide()}),2e3)),se._isVisible=!1,se._editor=$,se._state=ee,se._keybindingService=te,se._domNode=document.createElement("div"),se._domNode.className="findOptionsWidget",se._domNode.style.display="none",se._domNode.style.top="10px",se._domNode.setAttribute("role","presentation"),se._domNode.setAttribute("aria-hidden","true");var ae=re.getTheme().getColor(oe.inputActiveOptionBorder);return se.caseSensitive=se._register(new J.CaseSensitiveCheckbox({appendTitle:se._keybindingLabelFor(ie.FIND_IDS.ToggleCaseSensitiveCommand),isChecked:se._state.matchCase,inputActiveOptionBorder:ae})),se._domNode.appendChild(se.caseSensitive.domNode),se._register(se.caseSensitive.onChange((function(){se._state.change({matchCase:se.caseSensitive.checked},!1)}))),se.wholeWords=se._register(new J.WholeWordsCheckbox({appendTitle:se._keybindingLabelFor(ie.FIND_IDS.ToggleWholeWordCommand),isChecked:se._state.wholeWord,inputActiveOptionBorder:ae})),se._domNode.appendChild(se.wholeWords.domNode),se._register(se.wholeWords.onChange((function(){se._state.change({wholeWord:se.wholeWords.checked},!1)}))),se.regex=se._register(new J.RegexCheckbox({appendTitle:se._keybindingLabelFor(ie.FIND_IDS.ToggleRegexCommand),isChecked:se._state.isRegex,inputActiveOptionBorder:ae})),se._domNode.appendChild(se.regex.domNode),se._register(se.regex.onChange((function(){se._state.change({isRegex:se.regex.checked},!1)}))),se._editor.addOverlayWidget(se),se._register(se._state.onFindReplaceStateChange((function(X){var $=!1;X.isRegex&&(se.regex.checked=se._state.isRegex,$=!0),X.wholeWord&&(se.wholeWords.checked=se._state.wholeWord,$=!0),X.matchCase&&(se.caseSensitive.checked=se._state.matchCase,$=!0),!se._state.isRevealed&&$&&se._revealTemporarily()}))),se._register(Q.addDisposableNonBubblingMouseOutListener(se._domNode,(function(X){return se._onMouseOut()}))),se._register(Q.addDisposableListener(se._domNode,"mouseover",(function(X){return se._onMouseOver()}))),se._applyTheme(re.getTheme()),se._register(re.onThemeChange(se._applyTheme.bind(se))),se}return te(t,X),t.prototype._keybindingLabelFor=function(X){var $=this._keybindingService.lookupKeybinding(X);return $?" ("+$.getLabel()+")":""},t.prototype.dispose=function(){this._editor.removeOverlayWidget(this),X.prototype.dispose.call(this)},t.prototype.getId=function(){return t.ID},t.prototype.getDomNode=function(){return this._domNode},t.prototype.getPosition=function(){return{preference:0}},t.prototype.highlightFindOptions=function(){this._revealTemporarily()},t.prototype._revealTemporarily=function(){this._show(),this._hideSoon.schedule()},t.prototype._onMouseOut=function(){this._hideSoon.schedule()},t.prototype._onMouseOver=function(){this._hideSoon.cancel()},t.prototype._show=function(){this._isVisible||(this._isVisible=!0,this._domNode.style.display="block")},t.prototype._hide=function(){this._isVisible&&(this._isVisible=!1,this._domNode.style.display="none")},t.prototype._applyTheme=function(X){var $={inputActiveOptionBorder:X.getColor(oe.inputActiveOptionBorder)};this.caseSensitive.style($),this.wholeWords.style($),this.regex.style($)},t.ID="editor.contrib.findOptionsWidget",t}(ee.Widget);$.FindOptionsWidget=se,re.registerThemingParticipant((function(X,$){var Q=X.getColor(oe.editorWidgetBackground);Q&&$.addRule(".monaco-editor .findOptionsWidget { background-color: "+Q+"; }");var J=X.getColor(oe.widgetShadow);J&&$.addRule(".monaco-editor .findOptionsWidget { box-shadow: 0 2px 8px "+J+"; }");var ee=X.getColor(oe.contrastBorder);ee&&$.addRule(".monaco-editor .findOptionsWidget { border: 2px solid "+ee+"; }")}))})),define(Q[517],n([0,1,317,7,2,76,3,196,20,28,34,55,158,22,6,370]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le,ue,de,ce){Object.defineProperty($,"__esModule",{value:!0});var he=function(){function e(X,$,Q){var ee=this;this._lines=0,this._longestLineLength=0,this._relatedDiagnostics=new WeakMap,this._disposables=[],this._editor=$;var te=document.createElement("div");te.className="descriptioncontainer",te.setAttribute("aria-live","assertive"),te.setAttribute("role","alert"),this._messageBlock=document.createElement("div"),te.appendChild(this._messageBlock),this._relatedBlock=document.createElement("div"),te.appendChild(this._relatedBlock),this._disposables.push(J.addStandardDisposableListener(this._relatedBlock,"click",(function(X){X.preventDefault();var $=ee._relatedDiagnostics.get(X.target);$&&Q($)}))),this._scrollable=new le.ScrollableElement(te,{horizontal:1,vertical:1,useShadows:!1,horizontalScrollbarSize:3,verticalScrollbarSize:3}),J.addClass(this._scrollable.getDomNode(),"block"),X.appendChild(this._scrollable.getDomNode()),this._disposables.push(this._scrollable.onScroll((function(X){te.style.left="-"+X.scrollLeft+"px",te.style.top="-"+X.scrollTop+"px"}))),this._disposables.push(this._scrollable)}return e.prototype.dispose=function(){ee.dispose(this._disposables)},e.prototype.update=function(X){var $=X.source,Q=X.message,ee=X.relatedInformation,te=X.code;if($){this._lines=0,this._longestLineLength=0;for(var ne=new Array($.length+3+1).join(" "),ie=Q.split(/\r\n|\r|\n/g),oe=0;oe<ie.length;oe++){var re=ie[oe];this._lines+=1,te&&oe===ie.length-1&&(re+=" ["+te+"]"),this._longestLineLength=Math.max(re.length,this._longestLineLength),0===oe?Q="["+$+"] "+re:Q+="\n"+ne+re}}else this._lines=1,te&&(Q+=" ["+te+"]"),this._longestLineLength=Q.length;if(J.clearNode(this._relatedBlock),!de.isFalsyOrEmpty(ee)){this._relatedBlock.style.paddingTop=Math.floor(.66*this._editor.getConfiguration().lineHeight)+"px",this._lines+=1;for(var se=0,ae=ee||[];se<ae.length;se++){var le=ae[se],ce=document.createElement("div"),he=document.createElement("span");J.addClass(he,"filename"),he.innerHTML=ue.getBaseLabel(le.resource)+"("+le.startLineNumber+", "+le.startColumn+"): ",he.title=ue.getPathLabel(le.resource,void 0),this._relatedDiagnostics.set(he,le);var pe=document.createElement("span");pe.innerText=le.message,this._editor.applyFontInfo(pe),ce.appendChild(he),ce.appendChild(pe),this._lines+=1,this._relatedBlock.appendChild(ce)}}this._messageBlock.innerText=Q,this._editor.applyFontInfo(this._messageBlock);var fe=this._editor.getConfiguration().fontInfo,ge=Math.ceil(fe.typicalFullwidthCharacterWidth*this._longestLineLength*.75),me=fe.lineHeight*this._lines;this._scrollable.setScrollDimensions({scrollWidth:ge,scrollHeight:me})},e.prototype.layout=function(X,$){this._scrollable.getDomNode().style.height=X+"px",this._scrollable.setScrollDimensions({width:$,height:X})},e.prototype.getHeightInLines=function(){return Math.min(17,this._lines)},e}(),pe=function(X){function l($,Q){var J=X.call(this,$,{showArrow:!0,showFrame:!0,isAccessible:!0})||this;return J._themeService=Q,J._callOnDispose=[],J._onDidSelectRelatedInformation=new ce.Emitter,J.onDidSelectRelatedInformation=J._onDidSelectRelatedInformation.event,J._severity=ne.MarkerSeverity.Warning,J._backgroundColor=se.Color.white,J._applyTheme(Q.getTheme()),J._callOnDispose.push(Q.onThemeChange(J._applyTheme.bind(J))),J.create(),J}return te(l,X),l.prototype._applyTheme=function(X){this._backgroundColor=X.getColor($.editorMarkerNavigationBackground);var Q=$.editorMarkerNavigationError;this._severity===ne.MarkerSeverity.Warning?Q=$.editorMarkerNavigationWarning:this._severity===ne.MarkerSeverity.Info&&(Q=$.editorMarkerNavigationInfo);var J=X.getColor(Q);this.style({arrowColor:J,frameColor:J})},l.prototype._applyStyles=function(){this._parentContainer&&(this._parentContainer.style.backgroundColor=this._backgroundColor?this._backgroundColor.toString():""),X.prototype._applyStyles.call(this)},l.prototype.dispose=function(){this._callOnDispose=ee.dispose(this._callOnDispose),X.prototype.dispose.call(this)},l.prototype.focus=function(){this._parentContainer.focus()},l.prototype._fillContainer=function(X){var $=this;this._parentContainer=X,J.addClass(X,"marker-widget"),this._parentContainer.tabIndex=0,this._parentContainer.setAttribute("role","tooltip"),this._container=document.createElement("div"),X.appendChild(this._container),this._title=document.createElement("div"),this._title.className="block title",this._container.appendChild(this._title),this._message=new he(this._container,this.editor,(function(X){return $._onDidSelectRelatedInformation.fire(X)})),this._disposables.push(this._message)},l.prototype.show=function(X,$){throw new Error("call showAtMarker")},l.prototype.showAtMarker=function($,J,ee){this._container.classList.remove("stale"),this._title.innerHTML=Q.localize(0,null,J,ee),this._message.update($),this._severity=$.severity,this._applyTheme(this._themeService.getTheme());var te=ie.Range.lift($),ne=this.editor.getPosition(),oe=ne&&te.containsPosition(ne)?ne:te.getStartPosition();X.prototype.show.call(this,oe,this.computeRequiredHeight()),this.editor.revealPositionInCenter(oe,0),1!==this.editor.getConfiguration().accessibilitySupport&&this.focus()},l.prototype.updateMarker=function(X){this._container.classList.remove("stale"),this._message.update(X)},l.prototype.showStale=function(){this._container.classList.add("stale"),this._relayout()},l.prototype._doLayout=function(X,$){this._message.layout(X,$),this._container.style.height=X+"px"},l.prototype._relayout=function(){X.prototype._relayout.call(this,this.computeRequiredHeight())},l.prototype.computeRequiredHeight=function(){return 1+this._message.getHeightInLines()},l}(oe.ZoneWidget);$.MarkerNavigationWidget=pe;var fe=re.oneOf(ae.editorErrorForeground,ae.editorErrorBorder),ge=re.oneOf(ae.editorWarningForeground,ae.editorWarningBorder),me=re.oneOf(ae.editorInfoForeground,ae.editorInfoBorder);$.editorMarkerNavigationError=re.registerColor("editorMarkerNavigationError.background",{dark:fe,light:fe,hc:fe},Q.localize(1,null)),$.editorMarkerNavigationWarning=re.registerColor("editorMarkerNavigationWarning.background",{dark:ge,light:ge,hc:ge},Q.localize(2,null)),$.editorMarkerNavigationInfo=re.registerColor("editorMarkerNavigationInfo.background",{dark:me,light:me,hc:me},Q.localize(3,null)),$.editorMarkerNavigationBackground=re.registerColor("editorMarkerNavigation.background",{dark:"#2D2D30",light:se.Color.white,hc:"#0C141F"},Q.localize(4,null))})),define(Q[518],n([0,1,316,6,2,18,76,3,10,13,19,517,8,22,30,11]),(function(X,$,Q,J,ee,ie,re,se,ae,le,ue,de,ce,he,pe,fe){Object.defineProperty($,"__esModule",{value:!0});var ge=function(){function e(X,$){var Q=this;this._editor=X,this._markers=null,this._nextIdx=-1,this._toUnbind=[],this._ignoreSelectionChange=!1,this._onCurrentMarkerChanged=new J.Emitter,this._onMarkerSetChanged=new J.Emitter,this.setMarkers($),this._toUnbind.push(this._editor.onDidDispose((function(){return Q.dispose()}))),this._toUnbind.push(this._editor.onDidChangeCursorPosition((function(){Q._ignoreSelectionChange||Q.currentMarker&&se.Range.containsPosition(Q.currentMarker,Q._editor.getPosition())||(Q._nextIdx=-1)})))}return Object.defineProperty(e.prototype,"onCurrentMarkerChanged",{get:function(){return this._onCurrentMarkerChanged.event},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onMarkerSetChanged",{get:function(){return this._onMarkerSetChanged.event},enumerable:!0,configurable:!0}),e.prototype.setMarkers=function(X){var $=this._nextIdx>=0?this._markers[this._nextIdx]:void 0;this._markers=X||[],this._markers.sort(ve.compareMarker),this._nextIdx=$?Math.max(-1,he.binarySearch(this._markers,$,ve.compareMarker)):-1,this._onMarkerSetChanged.fire(this)},e.prototype.withoutWatchingEditorPosition=function(X){this._ignoreSelectionChange=!0;try{X()}finally{this._ignoreSelectionChange=!1}},e.prototype._initIdx=function(X){for(var $=!1,Q=this._editor.getPosition(),J=0;J<this._markers.length;J++){var ee=se.Range.lift(this._markers[J]);if(ee.isEmpty()){var te=this._editor.getModel().getWordAtPosition(ee.getStartPosition());te&&(ee=new se.Range(ee.startLineNumber,te.startColumn,ee.startLineNumber,te.endColumn))}if(ee.containsPosition(Q)||Q.isBeforeOrEqual(ee.getStartPosition())){this._nextIdx=J,$=!0;break}}$||(this._nextIdx=X?0:this._markers.length-1),this._nextIdx<0&&(this._nextIdx=this._markers.length-1)},Object.defineProperty(e.prototype,"currentMarker",{get:function(){return this.canNavigate()?this._markers[this._nextIdx]:void 0},enumerable:!0,configurable:!0}),e.prototype.move=function(X,$){if(!this.canNavigate())return this._onCurrentMarkerChanged.fire(void 0),!$;var Q=this._nextIdx,J=!1;if(-1===this._nextIdx?this._initIdx(X):X?$||this._nextIdx+1<this._markers.length?this._nextIdx=(this._nextIdx+1)%this._markers.length:J=!0:X||($||this._nextIdx>0?this._nextIdx=(this._nextIdx-1+this._markers.length)%this._markers.length:J=!0),Q!==this._nextIdx){var ee=this._markers[this._nextIdx];this._onCurrentMarkerChanged.fire(ee)}return J},e.prototype.canNavigate=function(){return this._markers.length>0},e.prototype.findMarkerAtPosition=function(X){for(var $=0,Q=this._markers;$<Q.length;$++){var J=Q[$];if(se.Range.containsPosition(J,X))return J}},Object.defineProperty(e.prototype,"total",{get:function(){return this._markers.length},enumerable:!0,configurable:!0}),e.prototype.indexOf=function(X){return 1+this._markers.indexOf(X)},e.prototype.dispose=function(){this._toUnbind=ee.dispose(this._toUnbind)},e}(),me=function(){function e(X,$,Q,J,ee){this._markerService=$,this._contextKeyService=Q,this._themeService=J,this._editorService=ee,this._disposeOnClose=[],this._editor=X,this._widgetVisible=we.bindTo(this._contextKeyService)}return e.get=function(X){return X.getContribution(e.ID)},e.prototype.getId=function(){return e.ID},e.prototype.dispose=function(){this._cleanUp()},e.prototype._cleanUp=function(){this._widgetVisible.reset(),this._disposeOnClose=ee.dispose(this._disposeOnClose),this._widget=null,this._model=null},e.prototype.getOrCreateModel=function(){var X=this;if(this._model)return this._model;var $=this._getMarkers();return this._model=new ge(this._editor,$),this._markerService.onMarkerChanged(this._onMarkerChanged,this,this._disposeOnClose),this._widget=new de.MarkerNavigationWidget(this._editor,this._themeService),this._widgetVisible.set(!0),this._disposeOnClose.push(this._model),this._disposeOnClose.push(this._widget),this._disposeOnClose.push(this._widget.onDidSelectRelatedInformation((function($){X._editorService.openCodeEditor({resource:$.resource,options:{pinned:!0,revealIfOpened:!0,selection:se.Range.lift($).collapseToStart()}},X._editor).then(void 0,fe.onUnexpectedError),X.closeMarkersNavigation(!1)}))),this._disposeOnClose.push(this._editor.onDidChangeModel((function(){return X._cleanUp()}))),this._disposeOnClose.push(this._model.onCurrentMarkerChanged((function($){$?X._model.withoutWatchingEditorPosition((function(){X._widget.showAtMarker($,X._model.indexOf($),X._model.total)})):X._cleanUp()}))),this._disposeOnClose.push(this._model.onMarkerSetChanged((function(){var $=X._model.findMarkerAtPosition(X._widget.position);$?X._widget.updateMarker($):X._widget.showStale()}))),this._model},e.prototype.closeMarkersNavigation=function(X){void 0===X&&(X=!0),this._cleanUp(),X&&this._editor.focus()},e.prototype._onMarkerChanged=function(X){var $=this;X.some((function(X){return $._editor.getModel().uri.toString()===X.toString()}))&&this._model.setMarkers(this._getMarkers())},e.prototype._getMarkers=function(){return this._markerService.read({resource:this._editor.getModel().uri,severities:re.MarkerSeverity.Error|re.MarkerSeverity.Warning|re.MarkerSeverity.Info})},e.ID="editor.contrib.markerController",e=ne([oe(1,re.IMarkerService),oe(2,ie.IContextKeyService),oe(3,le.IThemeService),oe(4,pe.ICodeEditorService)],e)}(),ve=function(X){function t($,Q,J){var ee=X.call(this,J)||this;return ee._isNext=$,ee._multiFile=Q,ee}return te(t,X),t.prototype.run=function(X,$){var Q=this,J=X.get(re.IMarkerService),ee=X.get(pe.ICodeEditorService),te=me.get($);if(te){var ne=te.getOrCreateModel();if(ne.move(this._isNext,!this._multiFile)&&this._multiFile){var ie=J.read({severities:re.MarkerSeverity.Error|re.MarkerSeverity.Warning|re.MarkerSeverity.Info}).sort(t.compareMarker);if(0!==ie.length){var oe=ne.currentMarker||{resource:$.getModel().uri,severity:re.MarkerSeverity.Error,startLineNumber:1,startColumn:1,endLineNumber:1,endColumn:1},se=he.binarySearch(ie,oe,t.compareMarker);se<0?(se=~se,se%=ie.length):se=this._isNext?(se+1)%ie.length:(se+ie.length-1)%ie.length;var ae=ie[se];if(ae.resource.toString()!==$.getModel().uri.toString())return te.closeMarkersNavigation(),ee.openCodeEditor({resource:ae.resource,options:{pinned:!1,revealIfOpened:!0,revealInCenterIfOutsideViewport:!0,selection:ae}},$).then((function(X){if(X)return X.getAction(Q.id).run()}));ne.move(this._isNext,!0)}}}},t.compareMarker=function(X,$){var Q=ce.compare(X.resource.toString(),$.resource.toString());return 0===Q&&(Q=re.MarkerSeverity.compare(X.severity,$.severity)),0===Q&&(Q=se.Range.compareRangesUsingStarts(X,$)),Q},t}(ae.EditorAction),_e=function(X){function t(){return X.call(this,!0,!1,{id:"editor.action.marker.next",label:Q.localize(0,null),alias:"Go to Next Error or Warning",precondition:ue.EditorContextKeys.writable})||this}return te(t,X),t}(ve),ye=function(X){function t(){return X.call(this,!1,!1,{id:"editor.action.marker.prev",label:Q.localize(1,null),alias:"Go to Previous Error or Warning",precondition:ue.EditorContextKeys.writable})||this}return te(t,X),t}(ve),be=function(X){function t(){return X.call(this,!0,!0,{id:"editor.action.marker.nextInFiles",label:Q.localize(2,null),alias:"Go to Next Error or Warning in Files",precondition:ue.EditorContextKeys.writable,kbOpts:{kbExpr:ue.EditorContextKeys.focus,primary:66,weight:100}})||this}return te(t,X),t}(ve),Ce=function(X){function t(){return X.call(this,!1,!0,{id:"editor.action.marker.prevInFiles",label:Q.localize(3,null),alias:"Go to Previous Error or Warning in Files",precondition:ue.EditorContextKeys.writable,kbOpts:{kbExpr:ue.EditorContextKeys.focus,primary:1090,weight:100}})||this}return te(t,X),t}(ve);ae.registerEditorContribution(me),ae.registerEditorAction(_e),ae.registerEditorAction(ye),ae.registerEditorAction(be),ae.registerEditorAction(Ce);var we=new ie.RawContextKey("markersNavigationVisible",!1),Se=ae.EditorCommand.bindToContribution(me.get);ae.registerEditorCommand(new Se({id:"closeMarkersNavigation",precondition:we,handler:function(X){return X.closeMarkersNavigation()},kbOpts:{weight:150,kbExpr:ue.EditorContextKeys.focus,primary:9,secondary:[1033]}}))})),define(Q[519],n([0,1,319,7,24,28,68,2,12,3,26,14,174,175,237,513,464,186,191]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le,ue,de,ce,he,pe,fe,ge){Object.defineProperty($,"__esModule",{value:!0});var me=J.$,b=function(X,$,Q){this.range=X,this.color=$,this.provider=Q},ve=function(){function e(X){this._editor=X,this._range=null}return e.prototype.setRange=function(X){this._range=X,this._result=[]},e.prototype.clearResult=function(){this._result=[]},e.prototype.computeAsync=function(X){var $=this._editor.getModel();return le.HoverProviderRegistry.has($)?pe.getHover($,new re.Position(this._range.startLineNumber,this._range.startColumn),X):Promise.resolve(null)},e.prototype.computeSync=function(){var X=this,$=this._range.startLineNumber;if($>this._editor.getModel().getLineCount())return[];var Q=de.ColorDetector.get(this._editor),J=this._editor.getModel().getLineMaxColumn($),ee=!1;return this._editor.getLineDecorations($).map((function(te){var ne=te.range.startLineNumber===$?te.range.startColumn:1,oe=te.range.endLineNumber===$?te.range.endColumn:J;if(ne>X._range.startColumn||X._range.endColumn>oe)return null;var re=new se.Range(X._range.startLineNumber,ne,X._range.startLineNumber,oe),ae=Q.getColorData(te.range.getStartPosition());if(!ee&&ae){ee=!0;var le=ae.colorInfo,ue=le.color,de=le.range;return new b(de,ue,ae.provider)}if(ie.isEmptyMarkdownString(te.options.hoverMessage))return null;var ce=void 0;return te.options.hoverMessage&&(ce=Array.isArray(te.options.hoverMessage)?te.options.hoverMessage.slice():[te.options.hoverMessage]),{contents:ce,range:re}})).filter((function(X){return!!X}))},e.prototype.onResult=function(X,$){this._result=$?X.concat(this._result.sort((function(X,$){return X instanceof b?-1:$ instanceof b?1:0}))):this._result.concat(X)},e.prototype.getResult=function(){return this._result.slice(0)},e.prototype.getResultWithLoadingMessage=function(){return this._result.slice(0).concat([this._getLoadingMessage()])},e.prototype._getLoadingMessage=function(){return{range:this._range,contents:[(new ie.MarkdownString).appendText(Q.localize(0,null))]}},e}(),_e=function(X){function t($,Q,ee){var te=X.call(this,t.ID,$)||this;return te._themeService=ee,te.renderDisposable=oe.Disposable.None,te._computer=new ve(te._editor),te._highlightDecorations=[],te._isChangingDecorations=!1,te._markdownRenderer=Q,te._register(Q.onDidRenderCodeBlock(te.onContentsChange,te)),te._hoverOperation=new fe.HoverOperation(te._computer,(function(X){return te._withResult(X,!0)}),null,(function(X){return te._withResult(X,!1)})),te._register(J.addStandardDisposableListener(te.getDomNode(),J.EventType.FOCUS,(function(){te._colorPicker&&J.addClass(te.getDomNode(),"colorpicker-hover")}))),te._register(J.addStandardDisposableListener(te.getDomNode(),J.EventType.BLUR,(function(){J.removeClass(te.getDomNode(),"colorpicker-hover")}))),te._register($.onDidChangeConfiguration((function(X){te._hoverOperation.setHoverTime(te._editor.getConfiguration().contribInfo.hover.delay)}))),te}return te(t,X),t.prototype.dispose=function(){this.renderDisposable.dispose(),this.renderDisposable=oe.Disposable.None,this._hoverOperation.cancel(),X.prototype.dispose.call(this)},t.prototype.onModelDecorationsChanged=function(){this._isChangingDecorations||this.isVisible&&(this._hoverOperation.cancel(),this._computer.clearResult(),this._colorPicker||this._hoverOperation.start(0))},t.prototype.startShowingAt=function(X,$,Q){if(!this._lastRange||!this._lastRange.equalsRange(X)){if(this._hoverOperation.cancel(),this.isVisible)if(this._showAtPosition.lineNumber!==X.startLineNumber)this.hide();else{for(var J=[],ee=0,te=this._messages.length;ee<te;ee++){var ne=this._messages[ee],oe=ne.range;oe.startColumn<=X.startColumn&&oe.endColumn>=X.endColumn&&J.push(ne)}if(J.length>0){if(function(X,$){if(!X&&$||X&&!$||X.length!==$.length)return!1;for(var Q=0;Q<X.length;Q++){var J=X[Q],ee=$[Q];if(J instanceof b)return!1;if(ee instanceof b)return!1;if(!ie.markedStringsEquals(J.contents,ee.contents))return!1}return!0}(J,this._messages))return;this._renderMessages(X,J)}else this.hide()}this._lastRange=X,this._computer.setRange(X),this._shouldFocus=Q,this._hoverOperation.start($)}},t.prototype.hide=function(){this._lastRange=null,this._hoverOperation.cancel(),X.prototype.hide.call(this),this._isChangingDecorations=!0,this._highlightDecorations=this._editor.deltaDecorations(this._highlightDecorations,[]),this._isChangingDecorations=!1,this.renderDisposable.dispose(),this.renderDisposable=oe.Disposable.None,this._colorPicker=null},t.prototype.isColorPickerVisible=function(){return!!this._colorPicker},t.prototype._withResult=function(X,$){this._messages=X,this._lastRange&&this._messages.length>0?this._renderMessages(this._lastRange,this._messages):$&&this.hide()},t.prototype._renderMessages=function(X,$){var Q=this;this.renderDisposable.dispose(),this._colorPicker=null;var J,te=Number.MAX_VALUE,ae=se.Range.lift($[0].range),le=document.createDocumentFragment(),de=!0,pe=!1;$.forEach((function(X){if(X.range)if(te=Math.min(te,X.range.startColumn),ae=se.Range.plusRange(ae,X.range),X instanceof b){pe=!0;var $=X.color,re=$.red,fe=$.green,ge=$.blue,ve=$.alpha,_e=new ne.RGBA(255*re,255*fe,255*ge,ve),ye=new ne.Color(_e),be=Q._editor.getModel(),Ce=new se.Range(X.range.startLineNumber,X.range.startColumn,X.range.endLineNumber,X.range.endColumn),we={range:X.range,color:X.color},Se=new ce.ColorPickerModel(ye,[],0),Ee=new he.ColorPickerWidget(le,Se,Q._editor.getConfiguration().pixelRatio,Q._themeService);ue.getColorPresentations(be,we,X.provider,ee.CancellationToken.None).then((function($){Se.colorPresentations=$;var te=Q._editor.getModel().getValueInRange(X.range);Se.guessColorPresentation(ye,te);var s=function(){var X,$;Se.presentation.textEdit?(X=[Se.presentation.textEdit],$=($=new se.Range(Se.presentation.textEdit.range.startLineNumber,Se.presentation.textEdit.range.startColumn,Se.presentation.textEdit.range.endLineNumber,Se.presentation.textEdit.range.endColumn)).setEndPosition($.endLineNumber,$.startColumn+Se.presentation.textEdit.text.length)):(X=[{identifier:null,range:Ce,text:Se.presentation.label,forceMoveMarkers:!1}],$=Ce.setEndPosition(Ce.endLineNumber,Ce.startColumn+Se.presentation.label.length)),Q._editor.pushUndoStop(),Q._editor.executeEdits("colorpicker",X),Se.presentation.additionalTextEdits&&(X=Se.presentation.additionalTextEdits.slice(),Q._editor.executeEdits("colorpicker",X),Q.hide()),Q._editor.pushUndoStop(),Ce=$},a=function($){return ue.getColorPresentations(be,{range:Ce,color:{red:$.rgba.r/255,green:$.rgba.g/255,blue:$.rgba.b/255,alpha:$.rgba.a}},X.provider,ee.CancellationToken.None).then((function(X){Se.colorPresentations=X}))},ne=Se.onColorFlushed((function(X){a(X).then(s)})),ie=Se.onDidChangeColor(a);Q._colorPicker=Ee,Q.showAt(Ce.getStartPosition(),Ce,Q._shouldFocus),Q.updateContents(le),Q._colorPicker.layout(),Q.renderDisposable=oe.combinedDisposable([ne,ie,Ee,J])}))}else X.contents.filter((function(X){return!ie.isEmptyMarkdownString(X)})).forEach((function(X){var $=Q._markdownRenderer.render(X);J=$,le.appendChild(me("div.hover-row",null,$.element)),de=!1}))})),pe||de||(this.showAt(new re.Position(X.startLineNumber,te),ae,this._shouldFocus),this.updateContents(le)),this._isChangingDecorations=!0,this._highlightDecorations=this._editor.deltaDecorations(this._highlightDecorations,[{range:ae,options:t._DECORATION_OPTIONS}]),this._isChangingDecorations=!1},t.ID="editor.contrib.modesContentHoverWidget",t._DECORATION_OPTIONS=ae.ModelDecorationOptions.register({className:"hoverHighlight"}),t}(ge.ContentHoverWidget);$.ModesContentHoverWidget=_e})),define(Q[520],n([0,1,318,36,2,17,10,3,19,63,519,253,120,62,20,13,371]),(function(X,$,Q,J,ee,ie,re,se,ae,le,ue,de,ce,he,pe,fe){Object.defineProperty($,"__esModule",{value:!0});var ge=function(){function e(X,$,Q,J){var ee=this;this._editor=X,this._openerService=$,this._modeService=Q,this._themeService=J,this._toUnhook=[],this._isMouseDown=!1,this._hoverClicked=!1,this._hookEvents(),this._didChangeConfigurationHandler=this._editor.onDidChangeConfiguration((function(X){X.contribInfo&&(ee._hideWidgets(),ee._unhookEvents(),ee._hookEvents())}))}return Object.defineProperty(e.prototype,"contentWidget",{get:function(){return this._contentWidget||this._createHoverWidget(),this._contentWidget},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"glyphWidget",{get:function(){return this._glyphWidget||this._createHoverWidget(),this._glyphWidget},enumerable:!0,configurable:!0}),e.get=function(X){return X.getContribution(e.ID)},e.prototype._hookEvents=function(){var X=this,t=function(){return X._hideWidgets()},$=this._editor.getConfiguration().contribInfo.hover;this._isHoverEnabled=$.enabled,this._isHoverSticky=$.sticky,this._isHoverEnabled?(this._toUnhook.push(this._editor.onMouseDown((function($){return X._onEditorMouseDown($)}))),this._toUnhook.push(this._editor.onMouseUp((function($){return X._onEditorMouseUp($)}))),this._toUnhook.push(this._editor.onMouseMove((function($){return X._onEditorMouseMove($)}))),this._toUnhook.push(this._editor.onKeyDown((function($){return X._onKeyDown($)}))),this._toUnhook.push(this._editor.onDidChangeModelDecorations((function(){return X._onModelDecorationsChanged()})))):this._toUnhook.push(this._editor.onMouseMove(t)),this._toUnhook.push(this._editor.onMouseLeave(t)),this._toUnhook.push(this._editor.onDidChangeModel(t)),this._toUnhook.push(this._editor.onDidScrollChange((function($){return X._onEditorScrollChanged($)})))},e.prototype._unhookEvents=function(){this._toUnhook=ee.dispose(this._toUnhook)},e.prototype._onModelDecorationsChanged=function(){this.contentWidget.onModelDecorationsChanged(),this.glyphWidget.onModelDecorationsChanged()},e.prototype._onEditorScrollChanged=function(X){(X.scrollTopChanged||X.scrollLeftChanged)&&this._hideWidgets()},e.prototype._onEditorMouseDown=function(X){this._isMouseDown=!0;var $=X.target.type;9!==$||X.target.detail!==ue.ModesContentHoverWidget.ID?12===$&&X.target.detail===de.ModesGlyphHoverWidget.ID||(12!==$&&X.target.detail!==de.ModesGlyphHoverWidget.ID&&(this._hoverClicked=!1),this._hideWidgets()):this._hoverClicked=!0},e.prototype._onEditorMouseUp=function(X){this._isMouseDown=!1},e.prototype._onEditorMouseMove=function(X){var $=X.target.type,Q=ie.isMacintosh?X.event.metaKey:X.event.ctrlKey;if(!(this._isMouseDown&&this._hoverClicked&&this.contentWidget.isColorPickerVisible())&&(!this._isHoverSticky||9!==$||X.target.detail!==ue.ModesContentHoverWidget.ID||Q)&&(!this._isHoverSticky||12!==$||X.target.detail!==de.ModesGlyphHoverWidget.ID||Q)){if(7===$){var J=this._editor.getConfiguration().fontInfo.typicalHalfwidthCharacterWidth/2,ee=X.target.detail;ee&&!ee.isAfterLines&&"number"==typeof ee.horizontalDistanceToText&&ee.horizontalDistanceToText<J&&($=6)}6===$?(this.glyphWidget.hide(),this._isHoverEnabled&&this.contentWidget.startShowingAt(X.target.range,0,!1)):2===$?(this.contentWidget.hide(),this._isHoverEnabled&&this.glyphWidget.startShowingAt(X.target.position.lineNumber)):this._hideWidgets()}},e.prototype._onKeyDown=function(X){5!==X.keyCode&&6!==X.keyCode&&57!==X.keyCode&&4!==X.keyCode&&this._hideWidgets()},e.prototype._hideWidgets=function(){!this._contentWidget||this._isMouseDown&&this._hoverClicked&&this._contentWidget.isColorPickerVisible()||(this._glyphWidget.hide(),this._contentWidget.hide())},e.prototype._createHoverWidget=function(){var X=new ce.MarkdownRenderer(this._editor,this._modeService,this._openerService);this._contentWidget=new ue.ModesContentHoverWidget(this._editor,X,this._themeService),this._glyphWidget=new de.ModesGlyphHoverWidget(this._editor,X)},e.prototype.showContentHover=function(X,$,Q){this.contentWidget.startShowingAt(X,$,Q)},e.prototype.getId=function(){return e.ID},e.prototype.dispose=function(){this._unhookEvents(),this._didChangeConfigurationHandler.dispose(),this._glyphWidget&&(this._glyphWidget.dispose(),this._glyphWidget=null),this._contentWidget&&(this._contentWidget.dispose(),this._contentWidget=null)},e.ID="editor.contrib.hover",e=ne([oe(1,he.IOpenerService),oe(2,le.IModeService),oe(3,fe.IThemeService)],e)}();$.ModesHoverController=ge;var me=function(X){function t(){return X.call(this,{id:"editor.action.showHover",label:Q.localize(0,null),alias:"Show Hover",precondition:null,kbOpts:{kbExpr:ae.EditorContextKeys.editorTextFocus,primary:J.KeyChord(2089,2087),weight:100}})||this}return te(t,X),t.prototype.run=function(X,$){var Q=ge.get($);if(Q){var J=$.getPosition(),ee=new se.Range(J.lineNumber,J.column,J.lineNumber,J.column);Q.showContentHover(ee,1,!0)}},t}(re.EditorAction);re.registerEditorContribution(ge),re.registerEditorAction(me),fe.registerThemingParticipant((function(X,$){var Q=X.getColor(pe.editorHoverHighlight);Q&&$.addRule(".monaco-editor .hoverHighlight { background-color: "+Q+"; }");var J=X.getColor(pe.editorHoverBackground);J&&$.addRule(".monaco-editor .monaco-editor-hover { background-color: "+J+"; }");var ee=X.getColor(pe.editorHoverBorder);ee&&($.addRule(".monaco-editor .monaco-editor-hover { border: 1px solid "+ee+"; }"),$.addRule(".monaco-editor .monaco-editor-hover .hover-row:not(:first-child):not(:empty) { border-top: 1px solid "+ee.transparent(.5)+"; }"));var te=X.getColor(pe.textLinkForeground);te&&$.addRule(".monaco-editor .monaco-editor-hover a { color: "+te+"; }");var ne=X.getColor(pe.textCodeBlockBackground);ne&&$.addRule(".monaco-editor .monaco-editor-hover code { background-color: "+ne+"; }")}))})),define(Q[521],n([0,1,320,3,21,19,10,64,254,66,13,34,26,16,11]),(function(X,$,Q,J,ee,ie,re,se,ae,le,ue,de,ce,he,pe){Object.defineProperty($,"__esModule",{value:!0});var fe=function(){function e(X,$){this.decorationIds=[],this.editor=X,this.editorWorkerService=$}return e.get=function(X){return X.getContribution(e.ID)},e.prototype.dispose=function(){},e.prototype.getId=function(){return e.ID},e.prototype.run=function(X,$){var Q=this;this.currentRequest&&this.currentRequest.cancel();var te=this.editor.getSelection(),ne=this.editor.getModel().uri;if(te.startLineNumber!==te.endLineNumber)return null;var ie=new le.EditorState(this.editor,5);return this.editorWorkerService.canNavigateValueSet(ne)?(this.currentRequest=he.createCancelablePromise((function(X){return Q.editorWorkerService.navigateValueSet(ne,te,$)})),this.currentRequest.then((function($){if($&&$.range&&$.value&&ie.validate(Q.editor)){var ne=J.Range.lift($.range),oe=$.range,re=$.value.length-(te.endColumn-te.startColumn);oe={startLineNumber:oe.startLineNumber,startColumn:oe.startColumn,endLineNumber:oe.endLineNumber,endColumn:oe.startColumn+$.value.length},re>1&&(te=new ee.Selection(te.startLineNumber,te.startColumn,te.endLineNumber,te.endColumn+re-1));var se=new ae.InPlaceReplaceCommand(ne,te,$.value);Q.editor.pushUndoStop(),Q.editor.executeCommand(X,se),Q.editor.pushUndoStop(),Q.decorationIds=Q.editor.deltaDecorations(Q.decorationIds,[{range:oe,options:e.DECORATION}]),Q.decorationRemover&&Q.decorationRemover.cancel(),Q.decorationRemover=he.timeout(350),Q.decorationRemover.then((function(){return Q.decorationIds=Q.editor.deltaDecorations(Q.decorationIds,[])})).catch(pe.onUnexpectedError)}})).catch(pe.onUnexpectedError)):void 0},e.ID="editor.contrib.inPlaceReplaceController",e.DECORATION=ce.ModelDecorationOptions.register({className:"valueSetReplacement"}),e=ne([oe(1,se.IEditorWorkerService)],e)}(),ge=function(X){function t(){return X.call(this,{id:"editor.action.inPlaceReplace.up",label:Q.localize(0,null),alias:"Replace with Previous Value",precondition:ie.EditorContextKeys.writable,kbOpts:{kbExpr:ie.EditorContextKeys.editorTextFocus,primary:3154,weight:100}})||this}return te(t,X),t.prototype.run=function(X,$){var Q=fe.get($);if(Q)return Q.run(this.id,!0)},t}(re.EditorAction),me=function(X){function t(){return X.call(this,{id:"editor.action.inPlaceReplace.down",label:Q.localize(1,null),alias:"Replace with Next Value",precondition:ie.EditorContextKeys.writable,kbOpts:{kbExpr:ie.EditorContextKeys.editorTextFocus,primary:3156,weight:100}})||this}return te(t,X),t.prototype.run=function(X,$){var Q=fe.get($);if(Q)return Q.run(this.id,!1)},t}(re.EditorAction);re.registerEditorContribution(fe),re.registerEditorAction(ge),re.registerEditorAction(me),ue.registerThemingParticipant((function(X,$){var Q=X.getColor(de.editorBracketMatchBorder);Q&&$.addRule(".monaco-editor.vs .valueSetReplacement { outline: solid 2px "+Q+"; }")}))}));var re=this&&this.__awaiter||function(X,$,Q,J){return new(Q||(Q=Promise))((function(ee,te){function s(X){try{l(J.next(X))}catch(X){te(X)}}function a(X){try{l(J.throw(X))}catch(X){te(X)}}function l(X){X.done?ee(X.value):new Q((function($){$(X.value)})).then(s,a)}l((J=J.apply(X,$||[])).next())}))},se=this&&this.__generator||function(X,$){function n(te){return function(ie){return function(te){if(Q)throw new TypeError("Generator is already executing.");for(;ne;)try{if(Q=1,J&&(ee=2&te[0]?J.return:te[0]?J.throw||((ee=J.return)&&ee.call(J),0):J.next)&&!(ee=ee.call(J,te[1])).done)return ee;switch(J=0,ee&&(te=[2&te[0],ee.value]),te[0]){case 0:case 1:ee=te;break;case 4:return ne.label++,{value:te[1],done:!1};case 5:ne.label++,J=te[1],te=[0];continue;case 7:te=ne.ops.pop(),ne.trys.pop();continue;default:if(!(ee=(ee=ne.trys).length>0&&ee[ee.length-1])&&(6===te[0]||2===te[0])){ne=0;continue}if(3===te[0]&&(!ee||te[1]>ee[0]&&te[1]<ee[3])){ne.label=te[1];break}if(6===te[0]&&ne.label<ee[1]){ne.label=ee[1],ee=te;break}if(ee&&ne.label<ee[2]){ne.label=ee[2],ne.ops.push(te);break}ee[2]&&ne.ops.pop(),ne.trys.pop();continue}te=$.call(X,ne)}catch(X){te=[6,X],J=0}finally{Q=ee=0}if(5&te[0])throw te[1];return{value:te[0]?te[1]:void 0,done:!0}}([te,ie])}}var Q,J,ee,te,ne={label:0,sent:function(){if(1&ee[0])throw ee[1];return ee[1]},trys:[],ops:[]};return te={next:n(0),throw:n(1),return:n(2)},"function"==typeof Symbol&&(te[Symbol.iterator]=function(){return this}),te};define(Q[522],n([0,1,322,16,24,11,68,2,17,10,26,14,183,402,35,62,20,13,373]),(function(X,$,Q,J,ee,ie,ae,le,ue,de,ce,he,pe,fe,ge,me,ve,_e){Object.defineProperty($,"__esModule",{value:!0});var ye=(new ae.MarkdownString).appendText(ue.isMacintosh?Q.localize(0,null):Q.localize(1,null)),be=(new ae.MarkdownString).appendText(ue.isMacintosh?Q.localize(2,null):Q.localize(3,null)),Ce=(new ae.MarkdownString).appendText(ue.isMacintosh?Q.localize(4,null):Q.localize(5,null)),we=(new ae.MarkdownString).appendText(ue.isMacintosh?Q.localize(6,null):Q.localize(7,null)),Se={meta:ce.ModelDecorationOptions.register({stickiness:1,collapseOnReplaceEdit:!0,inlineClassName:"detected-link",hoverMessage:ye}),metaActive:ce.ModelDecorationOptions.register({stickiness:1,collapseOnReplaceEdit:!0,inlineClassName:"detected-link-active",hoverMessage:ye}),alt:ce.ModelDecorationOptions.register({stickiness:1,collapseOnReplaceEdit:!0,inlineClassName:"detected-link",hoverMessage:Ce}),altActive:ce.ModelDecorationOptions.register({stickiness:1,collapseOnReplaceEdit:!0,inlineClassName:"detected-link-active",hoverMessage:Ce}),altCommand:ce.ModelDecorationOptions.register({stickiness:1,collapseOnReplaceEdit:!0,inlineClassName:"detected-link",hoverMessage:we}),altCommandActive:ce.ModelDecorationOptions.register({stickiness:1,collapseOnReplaceEdit:!0,inlineClassName:"detected-link-active",hoverMessage:we}),metaCommand:ce.ModelDecorationOptions.register({stickiness:1,collapseOnReplaceEdit:!0,inlineClassName:"detected-link",hoverMessage:be}),metaCommandActive:ce.ModelDecorationOptions.register({stickiness:1,collapseOnReplaceEdit:!0,inlineClassName:"detected-link-active",hoverMessage:be})},Ee=function(){function e(X,$){this.link=X,this.decorationId=$}return e.decoration=function(X,$){return{range:X.range,options:e._getOptions(X,$,!1)}},e._getOptions=function(X,$,Q){return X.url&&/^command:/i.test(X.url)?$?Q?Se.metaCommandActive:Se.metaCommand:Q?Se.altCommandActive:Se.altCommand:$?Q?Se.metaActive:Se.meta:Q?Se.altActive:Se.alt},e.prototype.activate=function(X,$){X.changeDecorationOptions(this.decorationId,e._getOptions(this.link,$,!0))},e.prototype.deactivate=function(X,$){X.changeDecorationOptions(this.decorationId,e._getOptions(this.link,$,!1))},e}(),Le=function(){function e(X,$,Q){var ee=this;this.editor=X,this.openerService=$,this.notificationService=Q,this.listenersToRemove=[];var te=new pe.ClickLinkGesture(X);this.listenersToRemove.push(te),this.listenersToRemove.push(te.onMouseMoveOrRelevantKeyDown((function(X){var $=X[0],Q=X[1];ee._onEditorMouseMove($,Q)}))),this.listenersToRemove.push(te.onExecute((function(X){ee.onEditorMouseUp(X)}))),this.listenersToRemove.push(te.onCancel((function(X){ee.cleanUpActiveLinkDecoration()}))),this.enabled=X.getConfiguration().contribInfo.links,this.listenersToRemove.push(X.onDidChangeConfiguration((function($){var Q=X.getConfiguration().contribInfo.links;ee.enabled!==Q&&(ee.enabled=Q,ee.updateDecorations([]),ee.stop(),ee.beginCompute())}))),this.listenersToRemove.push(X.onDidChangeModelContent((function(X){return ee.onChange()}))),this.listenersToRemove.push(X.onDidChangeModel((function(X){return ee.onModelChanged()}))),this.listenersToRemove.push(X.onDidChangeModelLanguage((function(X){return ee.onModelModeChanged()}))),this.listenersToRemove.push(he.LinkProviderRegistry.onDidChange((function(X){return ee.onModelModeChanged()}))),this.timeout=new J.TimeoutTimer,this.computePromise=null,this.currentOccurrences={},this.activeLinkDecorationId=null,this.beginCompute()}return e.get=function(X){return X.getContribution(e.ID)},e.prototype.getId=function(){return e.ID},e.prototype.onModelChanged=function(){this.currentOccurrences={},this.activeLinkDecorationId=null,this.stop(),this.beginCompute()},e.prototype.onModelModeChanged=function(){this.stop(),this.beginCompute()},e.prototype.onChange=function(){var X=this;this.timeout.setIfNotSet((function(){return X.beginCompute()}),e.RECOMPUTE_TIME)},e.prototype.beginCompute=function(){return re(this,void 0,void 0,(function(){var X,$,Q;return se(this,(function(ee){switch(ee.label){case 0:if(!this.editor.hasModel()||!this.enabled)return[2];if(X=this.editor.getModel(),!he.LinkProviderRegistry.has(X))return[2];this.computePromise=J.createCancelablePromise((function($){return fe.getLinks(X,$)})),ee.label=1;case 1:return ee.trys.push([1,3,4,5]),[4,this.computePromise];case 2:return $=ee.sent(),this.updateDecorations($),[3,5];case 3:return Q=ee.sent(),ie.onUnexpectedError(Q),[3,5];case 4:return this.computePromise=null,[7];case 5:return[2]}}))}))},e.prototype.updateDecorations=function(X){for(var $="altKey"===this.editor.getConfiguration().multiCursorModifier,Q=[],J=Object.keys(this.currentOccurrences),ee=0,te=J.length;ee<te;ee++){var ne=J[ee],ie=this.currentOccurrences[ne];Q.push(ie.decorationId)}var oe=[];if(X)for(ee=0;ee<X.length;ee++)oe.push(Ee.decoration(X[ee],$));var re=this.editor.deltaDecorations(Q,oe);this.currentOccurrences={},this.activeLinkDecorationId=null;for(ee=0,te=re.length;ee<te;ee++)ie=new Ee(X[ee],re[ee]),this.currentOccurrences[ie.decorationId]=ie},e.prototype._onEditorMouseMove=function(X,$){var Q=this,J="altKey"===this.editor.getConfiguration().multiCursorModifier;if(this.isEnabled(X,$)){this.cleanUpActiveLinkDecoration();var ee=this.getLinkOccurrence(X.target.position);ee&&this.editor.changeDecorations((function(X){ee.activate(X,J),Q.activeLinkDecorationId=ee.decorationId}))}else this.cleanUpActiveLinkDecoration()},e.prototype.cleanUpActiveLinkDecoration=function(){var X="altKey"===this.editor.getConfiguration().multiCursorModifier;if(this.activeLinkDecorationId){var $=this.currentOccurrences[this.activeLinkDecorationId];$&&this.editor.changeDecorations((function(Q){$.deactivate(Q,X)})),this.activeLinkDecorationId=null}},e.prototype.onEditorMouseUp=function(X){if(this.isEnabled(X)){var $=this.getLinkOccurrence(X.target.position);$&&this.openLinkOccurrence($,X.hasSideBySideModifier)}},e.prototype.openLinkOccurrence=function(X,$){var J=this;if(this.openerService){var te=X.link;te.resolve(ee.CancellationToken.None).then((function(X){return J.openerService.open(X,{openToSide:$})}),(function(X){"invalid"===X?J.notificationService.warn(Q.localize(8,null,te.url)):"missing"===X?J.notificationService.warn(Q.localize(9,null)):ie.onUnexpectedError(X)}))}},e.prototype.getLinkOccurrence=function(X){if(!this.editor.hasModel()||!X)return null;for(var $=this.editor.getModel().getDecorationsInRange({startLineNumber:X.lineNumber,startColumn:X.column,endLineNumber:X.lineNumber,endColumn:X.column},0,!0),Q=0;Q<$.length;Q++){var J=$[Q],ee=this.currentOccurrences[J.id];if(ee)return ee}return null},e.prototype.isEnabled=function(X,$){return Boolean(6===X.target.type&&(X.hasTriggerModifier||$&&$.keyCodeIsTriggerKey))},e.prototype.stop=function(){this.timeout.cancel(),this.computePromise&&(this.computePromise.cancel(),this.computePromise=null)},e.prototype.dispose=function(){this.listenersToRemove=le.dispose(this.listenersToRemove),this.stop(),this.timeout.dispose()},e.ID="editor.linkDetector",e.RECOMPUTE_TIME=1e3,e=ne([oe(1,me.IOpenerService),oe(2,ge.INotificationService)],e)}(),xe=function(X){function t(){return X.call(this,{id:"editor.action.openLink",label:Q.localize(10,null),alias:"Open Link",precondition:null})||this}return te(t,X),t.prototype.run=function(X,$){var Q=Le.get($);if(Q&&$.hasModel())for(var J=0,ee=$.getSelections();J<ee.length;J++){var te=ee[J],ne=Q.getLinkOccurrence(te.getEndPosition());ne&&Q.openLinkOccurrence(ne,!1)}},t}(de.EditorAction);de.registerEditorContribution(Le),de.registerEditorAction(xe),_e.registerThemingParticipant((function(X,$){var Q=X.getColor(ve.editorActiveLinkForeground);Q&&$.addRule(".monaco-editor .detected-link-active { color: "+Q+" !important; }")}))})),define(Q[141],n([0,1,323,16,2,43,3,10,18,13,20,374]),(function(X,$,Q,J,ee,ie,re,se,ae,le,ue){Object.defineProperty($,"__esModule",{value:!0});var de=function(X){function t($,Q){var J=X.call(this)||this;return J._messageListeners=[],J._editor=$,J._visible=t.MESSAGE_VISIBLE.bindTo(Q),J._register(J._editor.onDidAttemptReadOnlyEdit((function(){return J._onDidAttemptReadOnlyEdit()}))),J}return te(t,X),t.get=function(X){return X.getContribution(t._id)},t.prototype.getId=function(){return t._id},t.prototype.dispose=function(){X.prototype.dispose.call(this),this._visible.reset()},t.prototype.showMessage=function(X,$){var Q,te=this;ie.alert(X),this._visible.set(!0),ee.dispose(this._messageWidget),this._messageListeners=ee.dispose(this._messageListeners),this._messageWidget=new he(this._editor,$,X),this._messageListeners.push(this._editor.onDidBlurEditorText((function(){return te.closeMessage()}))),this._messageListeners.push(this._editor.onDidChangeCursorPosition((function(){return te.closeMessage()}))),this._messageListeners.push(this._editor.onDidDispose((function(){return te.closeMessage()}))),this._messageListeners.push(this._editor.onDidChangeModel((function(){return te.closeMessage()}))),this._messageListeners.push(new J.TimeoutTimer((function(){return te.closeMessage()}),3e3)),this._messageListeners.push(this._editor.onMouseMove((function(X){X.target.position&&(Q?Q.containsPosition(X.target.position)||te.closeMessage():Q=new re.Range($.lineNumber-3,1,X.target.position.lineNumber+3,1))})))},t.prototype.closeMessage=function(){this._visible.reset(),this._messageListeners=ee.dispose(this._messageListeners),this._messageListeners.push(he.fadeOut(this._messageWidget))},t.prototype._onDidAttemptReadOnlyEdit=function(){this._editor.hasModel()&&this.showMessage(Q.localize(0,null),this._editor.getPosition())},t._id="editor.contrib.messageController",t.MESSAGE_VISIBLE=new ae.RawContextKey("messageVisible",!1),t=ne([oe(1,ae.IContextKeyService)],t)}(ee.Disposable);$.MessageController=de;var ce=se.EditorCommand.bindToContribution(de.get);se.registerEditorCommand(new ce({id:"leaveEditorMessage",precondition:de.MESSAGE_VISIBLE,handler:function(X){return X.closeMessage()},kbOpts:{weight:130,primary:9}}));var he=function(){function e(X,$,Q){var J=$.lineNumber,ee=$.column;this.allowEditorOverflow=!0,this.suppressMouseDown=!1,this._editor=X,this._editor.revealLinesInCenterIfOutsideViewport(J,J,0),this._position={lineNumber:J,column:ee-1},this._domNode=document.createElement("div"),this._domNode.classList.add("monaco-editor-overlaymessage");var te=document.createElement("div");te.classList.add("message"),te.textContent=Q,this._domNode.appendChild(te);var ne=document.createElement("div");ne.classList.add("anchor"),this._domNode.appendChild(ne),this._editor.addContentWidget(this),this._domNode.classList.add("fadeIn")}return e.fadeOut=function(X){var $,n=function(){X.dispose(),clearTimeout($),X.getDomNode().removeEventListener("animationend",n)};return $=setTimeout(n,110),X.getDomNode().addEventListener("animationend",n),X.getDomNode().classList.add("fadeOut"),{dispose:n}},e.prototype.dispose=function(){this._editor.removeContentWidget(this)},e.prototype.getId=function(){return"messageoverlay"},e.prototype.getDomNode=function(){return this._domNode},e.prototype.getPosition=function(){return{position:this._position,preference:[1]}},e}();se.registerEditorContribution(de),le.registerThemingParticipant((function(X,$){var Q=X.getColor(ue.inputValidationInfoBorder);if(Q){var J=X.type===le.HIGH_CONTRAST?2:1;$.addRule(".monaco-editor .monaco-editor-overlaymessage .anchor { border-top-color: "+Q+"; }"),$.addRule(".monaco-editor .monaco-editor-overlaymessage .message { border: "+J+"px solid "+Q+"; }")}var ee=X.getColor(ue.inputValidationInfoBackground);ee&&$.addRule(".monaco-editor .monaco-editor-overlaymessage .message { background-color: "+ee+"; }");var te=X.getColor(ue.inputValidationInfoForeground);te&&$.addRule(".monaco-editor .monaco-editor-overlaymessage .message { color: "+te+"; }")}))})),define(Q[524],n([0,1,2,8,10,126,19,141,305,31,18,60,47,76,89,451,108,236,391,11]),(function(X,$,Q,J,ee,ie,ae,le,ue,de,ce,he,pe,fe,ge,me,ve,_e,ye,be){function L(X){return ce.ContextKeyExpr.regex(me.SUPPORTED_CODE_ACTIONS.keys()[0],new RegExp("(\\s|^)"+J.escapeRegExpCharacters(X.value)+"\\b"))}function x(X,$,Q,J){return re(this,void 0,void 0,(function(){return se(this,(function(ee){switch(ee.label){case 0:return X.edit?[4,$.apply(X.edit,{editor:J})]:[3,2];case 1:ee.sent(),ee.label=2;case 2:return X.command?[4,Q.executeCommand.apply(Q,[X.command.id].concat(X.command.arguments))]:[3,4];case 3:ee.sent(),ee.label=4;case 4:return[2]}}))}))}function I(X,$,Q,J){var ee=Ce.get(X);if(ee){var te=X.getPosition();ee.triggerFromEditorSelection(Q,J).then((function(Q){Q&&Q.length||le.MessageController.get(X).showMessage($,te)}))}}Object.defineProperty($,"__esModule",{value:!0});var Ce=function(){function e(X,$,Q,J,ee,te,ne,ie){var oe=this;this._commandService=te,this._keybindingService=ne,this._bulkEditService=ie,this._disposables=[],this._editor=X,this._model=new me.CodeActionModel(this._editor,$,Q,J),this._codeActionContextMenu=new _e.CodeActionContextMenu(X,ee,(function(X){return oe._onApplyCodeAction(X)})),this._lightBulbWidget=new ye.LightBulbWidget(X),this._updateLightBulbTitle(),this._disposables.push(this._codeActionContextMenu.onDidExecuteCodeAction((function(X){return oe._model.trigger({type:"auto",filter:{}})})),this._lightBulbWidget.onClick(this._handleLightBulbSelect,this),this._model.onDidChangeFixes((function(X){return oe._onCodeActionsEvent(X)})),this._keybindingService.onDidUpdateKeybindings(this._updateLightBulbTitle,this))}return e.get=function(X){return X.getContribution(e.ID)},e.prototype.dispose=function(){this._model.dispose(),Q.dispose(this._disposables)},e.prototype._onCodeActionsEvent=function(X){var $=this;this._activeRequest&&(this._activeRequest.cancel(),this._activeRequest=void 0),X&&X.actions&&(this._activeRequest=X.actions),X&&X.actions&&X.trigger.filter&&X.trigger.filter.kind?X.actions.then((function(Q){2===X.trigger.autoApply||1===X.trigger.autoApply&&1===Q.length?$._onApplyCodeAction(Q[0]):$._codeActionContextMenu.show(X.actions,X.position)})).catch(be.onUnexpectedError):X&&"manual"===X.trigger.type?this._codeActionContextMenu.show(X.actions,X.position):X&&X.actions?this._codeActionContextMenu.isVisible?this._codeActionContextMenu.show(X.actions,X.position):this._lightBulbWidget.model=X:this._lightBulbWidget.hide()},e.prototype.getId=function(){return e.ID},e.prototype._handleLightBulbSelect=function(X){this._lightBulbWidget.model&&this._lightBulbWidget.model.actions&&this._codeActionContextMenu.show(this._lightBulbWidget.model.actions,X)},e.prototype.triggerFromEditorSelection=function(X,$){return this._model.trigger({type:"manual",filter:X,autoApply:$})},e.prototype._updateLightBulbTitle=function(){var X,$=this._keybindingService.lookupKeybinding(we.Id);X=$?ue.localize(0,null,$.getLabel()):ue.localize(1,null),this._lightBulbWidget.title=X},e.prototype._onApplyCodeAction=function(X){return x(X,this._bulkEditService,this._commandService,this._editor)},e.ID="editor.contrib.quickFixController",e=ne([oe(1,fe.IMarkerService),oe(2,ce.IContextKeyService),oe(3,ge.IProgressService),oe(4,he.IContextMenuService),oe(5,de.ICommandService),oe(6,pe.IKeybindingService),oe(7,ie.IBulkEditService)],e)}();$.QuickFixController=Ce,$.applyCodeAction=x;var we=function(X){function t(){return X.call(this,{id:t.Id,label:ue.localize(2,null),alias:"Quick Fix",precondition:ce.ContextKeyExpr.and(ae.EditorContextKeys.writable,ae.EditorContextKeys.hasCodeActionsProvider),kbOpts:{kbExpr:ae.EditorContextKeys.editorTextFocus,primary:2132,weight:100}})||this}return te(t,X),t.prototype.run=function(X,$){return I($,ue.localize(3,null))},t.Id="editor.action.quickFix",t}(ee.EditorAction);$.QuickFixAction=we;var Se=function(){function e(X,$){this.kind=X,this.apply=$}return e.fromUser=function(X){return X&&"object"==typeof X?new e(e.getKindFromUser(X),e.getApplyFromUser(X)):new e(ve.CodeActionKind.Empty,1)},e.getApplyFromUser=function(X){switch("string"==typeof X.apply?X.apply.toLowerCase():""){case"first":return 2;case"never":return 3;case"ifsingle":default:return 1}},e.getKindFromUser=function(X){return"string"==typeof X.kind?new ve.CodeActionKind(X.kind):ve.CodeActionKind.Empty},e}(),Ee=function(X){function t(){return X.call(this,{id:t.Id,precondition:ce.ContextKeyExpr.and(ae.EditorContextKeys.writable,ae.EditorContextKeys.hasCodeActionsProvider)})||this}return te(t,X),t.prototype.runEditorCommand=function(X,$,Q){var J=Se.fromUser(Q);return I($,ue.localize(4,null),{kind:J.kind,includeSourceActions:!0},J.apply)},t.Id="editor.action.codeAction",t}(ee.EditorCommand);$.CodeActionCommand=Ee;var Le=function(X){function t(){return X.call(this,{id:t.Id,label:ue.localize(5,null),alias:"Refactor",precondition:ce.ContextKeyExpr.and(ae.EditorContextKeys.writable,ae.EditorContextKeys.hasCodeActionsProvider),kbOpts:{kbExpr:ae.EditorContextKeys.editorTextFocus,primary:3120,mac:{primary:1328},weight:100},menuOpts:{group:"1_modification",order:2,when:ce.ContextKeyExpr.and(ae.EditorContextKeys.writable,L(ve.CodeActionKind.Refactor))}})||this}return te(t,X),t.prototype.run=function(X,$){return I($,ue.localize(6,null),{kind:ve.CodeActionKind.Refactor},3)},t.Id="editor.action.refactor",t}(ee.EditorAction);$.RefactorAction=Le;var xe=function(X){function t(){return X.call(this,{id:t.Id,label:ue.localize(7,null),alias:"Source Action",precondition:ce.ContextKeyExpr.and(ae.EditorContextKeys.writable,ae.EditorContextKeys.hasCodeActionsProvider),menuOpts:{group:"1_modification",order:2.1,when:ce.ContextKeyExpr.and(ae.EditorContextKeys.writable,L(ve.CodeActionKind.Source))}})||this}return te(t,X),t.prototype.run=function(X,$){return I($,ue.localize(8,null),{kind:ve.CodeActionKind.Source,includeSourceActions:!0},3)},t.Id="editor.action.sourceAction",t}(ee.EditorAction);$.SourceAction=xe;var Ie=function(X){function t(){return X.call(this,{id:t.Id,label:ue.localize(9,null),alias:"Organize Imports",precondition:ce.ContextKeyExpr.and(ae.EditorContextKeys.writable,L(ve.CodeActionKind.SourceOrganizeImports)),kbOpts:{kbExpr:ae.EditorContextKeys.editorTextFocus,primary:1581,weight:100}})||this}return te(t,X),t.prototype.run=function(X,$){return I($,ue.localize(10,null),{kind:ve.CodeActionKind.SourceOrganizeImports,includeSourceActions:!0},1)},t.Id="editor.action.organizeImports",t}(ee.EditorAction);$.OrganizeImportsAction=Ie})),define(Q[525],n([0,1,10,524]),(function(X,$,Q,J){Object.defineProperty($,"__esModule",{value:!0}),Q.registerEditorContribution(J.QuickFixController),Q.registerEditorAction(J.QuickFixAction),Q.registerEditorAction(J.RefactorAction),Q.registerEditorAction(J.SourceAction),Q.registerEditorAction(J.OrganizeImportsAction),Q.registerEditorCommand(new J.CodeActionCommand)})),define(Q[526],n([0,1,326,2,7,43,14,16,11,6,72,18,177,55,81,13,20,62,63,120,375]),(function(X,$,Q,J,ee,ie,re,se,ae,le,ue,de,ce,he,pe,fe,ge,me,ve,_e){Object.defineProperty($,"__esModule",{value:!0});var ye=ee.$,be=function(X){function t($,Q){void 0===Q&&(Q=t.DEFAULT_DELAY);var J=X.call(this)||this;return J._onHint=J._register(new le.Emitter),J.onHint=J._onHint.event,J._onCancel=J._register(new le.Emitter),J.onCancel=J._onCancel.event,J.active=!1,J.pending=!1,J.triggerChars=new pe.CharacterSet,J.retriggerChars=new pe.CharacterSet,J.editor=$,J.enabled=!1,J.triggerCharactersListeners=[],J.throttledDelayer=new se.RunOnceScheduler((function(){return J.doTrigger()}),Q),J._register(J.editor.onDidChangeConfiguration((function(){return J.onEditorConfigurationChange()}))),J._register(J.editor.onDidChangeModel((function(X){return J.onModelChanged()}))),J._register(J.editor.onDidChangeModelLanguage((function(X){return J.onModelChanged()}))),J._register(J.editor.onDidChangeCursorSelection((function(X){return J.onCursorChange(X)}))),J._register(J.editor.onDidChangeModelContent((function(X){return J.onModelContentChange()}))),J._register(re.SignatureHelpProviderRegistry.onDidChange(J.onModelChanged,J)),J._register(J.editor.onDidType((function(X){return J.onDidType(X)}))),J.onEditorConfigurationChange(),J.onModelChanged(),J}return te(t,X),t.prototype.cancel=function(X){void 0===X&&(X=!1),this.active=!1,this.pending=!1,this.triggerContext=void 0,this.throttledDelayer.cancel(),X||this._onCancel.fire(void 0),this.provideSignatureHelpRequest&&(this.provideSignatureHelpRequest.cancel(),this.provideSignatureHelpRequest=void 0)},t.prototype.trigger=function(X,$){if(re.SignatureHelpProviderRegistry.has(this.editor.getModel())){var Q=this.isTriggered;return this.cancel(!0),this.triggerContext={triggerReason:X.triggerReason,triggerCharacter:X.triggerCharacter,isRetrigger:Q},this.throttledDelayer.schedule($)}},t.prototype.doTrigger=function(){var X=this;this.provideSignatureHelpRequest&&this.provideSignatureHelpRequest.cancel(),this.pending=!0;var $=this.triggerContext||{triggerReason:re.SignatureHelpTriggerReason.Invoke,isRetrigger:!1};this.triggerContext=void 0,this.provideSignatureHelpRequest=se.createCancelablePromise((function(Q){return ce.provideSignatureHelp(X.editor.getModel(),X.editor.getPosition(),$,Q)})),this.provideSignatureHelpRequest.then((function($){if(X.pending=!1,!$||!$.signatures||0===$.signatures.length)return X.cancel(),X._onCancel.fire(void 0),!1;X.active=!0;var Q={hints:$};return X._onHint.fire(Q),!0})).catch((function($){X.pending=!1,ae.onUnexpectedError($)}))},Object.defineProperty(t.prototype,"isTriggered",{get:function(){return this.active||this.pending||this.throttledDelayer.isScheduled()},enumerable:!0,configurable:!0}),t.prototype.onModelChanged=function(){this.cancel(),this.triggerChars=new pe.CharacterSet,this.retriggerChars=new pe.CharacterSet;var X=this.editor.getModel();if(X)for(var $=0,Q=re.SignatureHelpProviderRegistry.ordered(X);$<Q.length;$++){var J=Q[$];if(Array.isArray(J.signatureHelpTriggerCharacters))for(var ee=0,te=J.signatureHelpTriggerCharacters;ee<te.length;ee++)oe=te[ee],this.triggerChars.add(oe.charCodeAt(0)),this.retriggerChars.add(oe.charCodeAt(0));if(Array.isArray(J.signatureHelpRetriggerCharacters))for(var ne=0,ie=J.signatureHelpRetriggerCharacters;ne<ie.length;ne++){var oe=ie[ne];this.retriggerChars.add(oe.charCodeAt(0))}}},t.prototype.onDidType=function(X){if(this.enabled){var $=X.length-1,Q=X.charCodeAt($);(this.triggerChars.has(Q)||this.isTriggered&&this.retriggerChars.has(Q))&&this.trigger({triggerReason:re.SignatureHelpTriggerReason.TriggerCharacter,triggerCharacter:X.charAt($)})}},t.prototype.onCursorChange=function(X){"mouse"===X.source?this.cancel():this.isTriggered&&this.trigger({triggerReason:re.SignatureHelpTriggerReason.ContentChange})},t.prototype.onModelContentChange=function(){this.isTriggered&&this.trigger({triggerReason:re.SignatureHelpTriggerReason.ContentChange})},t.prototype.onEditorConfigurationChange=function(){this.enabled=this.editor.getConfiguration().contribInfo.parameterHints.enabled,this.enabled||this.cancel()},t.prototype.dispose=function(){this.cancel(!0),this.triggerCharactersListeners=J.dispose(this.triggerCharactersListeners),X.prototype.dispose.call(this)},t.DEFAULT_DELAY=120,t}(J.Disposable);$.ParameterHintsModel=be;var Ce=function(){function e(X,$,Q,J){var ee=this;this.editor=X,this.allowEditorOverflow=!0,this.markdownRenderer=new _e.MarkdownRenderer(X,J,Q),this.model=new be(X),this.keyVisible=ce.Context.Visible.bindTo($),this.keyMultipleSignatures=ce.Context.MultipleSignatures.bindTo($),this.visible=!1,this.disposables=[],this.disposables.push(this.model.onHint((function(X){ee.show(),ee.hints=X.hints,ee.currentSignature=X.hints.activeSignature,ee.render()}))),this.disposables.push(this.model.onCancel((function(){ee.hide()})))}return e.prototype.createParamaterHintDOMNodes=function(){var X=this;this.element=ye(".editor-widget.parameter-hints-widget");var $=ee.append(this.element,ye(".wrapper")),Q=ee.append($,ye(".buttons")),J=ee.append(Q,ye(".button.previous")),te=ee.append(Q,ye(".button.next"));ue.stop(ue.domEvent(J,"click"))(this.previous,this,this.disposables),ue.stop(ue.domEvent(te,"click"))(this.next,this,this.disposables),this.overloads=ee.append($,ye(".overloads"));var ne=ye(".body");this.scrollbar=new he.DomScrollableElement(ne,{}),this.disposables.push(this.scrollbar),$.appendChild(this.scrollbar.getDomNode()),this.signature=ee.append(ne,ye(".signature")),this.docs=ee.append(ne,ye(".docs")),this.currentSignature=0,this.editor.addContentWidget(this),this.hide(),this.element.style.userSelect="text",this.disposables.push(this.editor.onDidChangeCursorSelection((function($){X.visible&&X.editor.layoutContentWidget(X)})));var a=function(){var $=X.editor.getConfiguration().fontInfo;X.element.style.fontSize=$.fontSize+"px"};a(),le.chain(this.editor.onDidChangeConfiguration.bind(this.editor)).filter((function(X){return X.fontInfo})).on(a,null,this.disposables),this.disposables.push(this.editor.onDidLayoutChange((function($){return X.updateMaxHeight()}))),this.updateMaxHeight()},e.prototype.show=function(){var X=this;this.model&&!this.visible&&(this.element||this.createParamaterHintDOMNodes(),this.keyVisible.set(!0),this.visible=!0,setTimeout((function(){return ee.addClass(X.element,"visible")}),100),this.editor.layoutContentWidget(this))},e.prototype.hide=function(){this.model&&this.visible&&(this.element||this.createParamaterHintDOMNodes(),this.keyVisible.reset(),this.visible=!1,this.hints=null,this.announcedLabel=null,ee.removeClass(this.element,"visible"),this.editor.layoutContentWidget(this))},e.prototype.getPosition=function(){return this.visible?{position:this.editor.getPosition(),preference:[1,2]}:null},e.prototype.render=function(){var X=this.hints.signatures.length>1;ee.toggleClass(this.element,"multiple",X),this.keyMultipleSignatures.set(X),this.signature.innerHTML="",this.docs.innerHTML="";var $=this.hints.signatures[this.currentSignature];if($){var te=ee.append(this.signature,ye(".code")),ne=$.parameters.length>0,oe=this.editor.getConfiguration().fontInfo;te.style.fontSize=oe.fontSize+"px",te.style.fontFamily=oe.fontFamily,ne?this.renderParameters(te,$,this.hints.activeParameter):ee.append(te,ye("span")).textContent=$.label,J.dispose(this.renderDisposeables),this.renderDisposeables=[];var re=$.parameters[this.hints.activeParameter];if(re&&re.documentation){var se=ye("span.documentation");"string"==typeof re.documentation?se.textContent=re.documentation:(ae=this.markdownRenderer.render(re.documentation),ee.addClass(ae.element,"markdown-docs"),this.renderDisposeables.push(ae),se.appendChild(ae.element)),ee.append(this.docs,ye("p",null,se))}if(ee.toggleClass(this.signature,"has-docs",!!$.documentation),"string"==typeof $.documentation)ee.append(this.docs,ye("p",null,$.documentation));else{var ae=this.markdownRenderer.render($.documentation);ee.addClass(ae.element,"markdown-docs"),this.renderDisposeables.push(ae),ee.append(this.docs,ae.element)}var le=String(this.currentSignature+1);if(this.hints.signatures.length<10&&(le+="/"+this.hints.signatures.length),this.overloads.textContent=le,re){var ue=this.getParameterLabel($,this.hints.activeParameter);this.announcedLabel!==ue&&(ie.alert(Q.localize(0,null,ue)),this.announcedLabel=ue)}this.editor.layoutContentWidget(this),this.scrollbar.scanDomNode()}},e.prototype.renderParameters=function(X,$,Q){var J=this.getParameterLabelOffsets($,Q),te=J[0],ne=J[1],ie=document.createElement("span");ie.textContent=$.label.substring(0,te);var oe=document.createElement("span");oe.textContent=$.label.substring(te,ne),oe.className="parameter active";var re=document.createElement("span");re.textContent=$.label.substring(ne),ee.append(X,ie,oe,re)},e.prototype.getParameterLabel=function(X,$){var Q=X.parameters[$];return"string"==typeof Q.label?Q.label:X.label.substring(Q.label[0],Q.label[1])},e.prototype.getParameterLabelOffsets=function(X,$){var Q=X.parameters[$];if(Q){if(Array.isArray(Q.label))return Q.label;var J=X.label.lastIndexOf(Q.label);return J>=0?[J,J+Q.label.length]:[0,0]}return[0,0]},e.prototype.next=function(){var X=this.hints.signatures.length,$=this.currentSignature%X==X-1,Q=this.editor.getConfiguration().contribInfo.parameterHints.cycle;return(X<2||$)&&!Q?(this.cancel(),!1):($&&Q?this.currentSignature=0:this.currentSignature++,this.render(),!0)},e.prototype.previous=function(){var X=this.hints.signatures.length,$=0===this.currentSignature,Q=this.editor.getConfiguration().contribInfo.parameterHints.cycle;return(X<2||$)&&!Q?(this.cancel(),!1):($&&Q?this.currentSignature=X-1:this.currentSignature--,this.render(),!0)},e.prototype.cancel=function(){this.model.cancel()},e.prototype.getDomNode=function(){return this.element},e.prototype.getId=function(){return e.ID},e.prototype.trigger=function(X){this.model.trigger(X,0)},e.prototype.updateMaxHeight=function(){var X=Math.max(this.editor.getLayoutInfo().height/4,250);this.element.style.maxHeight=X+"px"},e.prototype.dispose=function(){this.disposables=J.dispose(this.disposables),this.renderDisposeables=J.dispose(this.renderDisposeables),this.model&&(this.model.dispose(),this.model=null)},e.ID="editor.widget.parameterHintsWidget",e=ne([oe(1,de.IContextKeyService),oe(2,me.IOpenerService),oe(3,ve.IModeService)],e)}();$.ParameterHintsWidget=Ce,fe.registerThemingParticipant((function(X,$){var Q=X.getColor(ge.editorHoverBorder);if(Q){var J=X.type===fe.HIGH_CONTRAST?2:1;$.addRule(".monaco-editor .parameter-hints-widget { border: "+J+"px solid "+Q+"; }"),$.addRule(".monaco-editor .parameter-hints-widget.multiple .body { border-left: 1px solid "+Q.transparent(.5)+"; }"),$.addRule(".monaco-editor .parameter-hints-widget .signature.has-docs { border-bottom: 1px solid "+Q.transparent(.5)+"; }")}var ee=X.getColor(ge.editorHoverBackground);ee&&$.addRule(".monaco-editor .parameter-hints-widget { background-color: "+ee+"; }");var te=X.getColor(ge.textLinkForeground);te&&$.addRule(".monaco-editor .parameter-hints-widget a { color: "+te+"; }");var ne=X.getColor(ge.textCodeBlockBackground);ne&&$.addRule(".monaco-editor .parameter-hints-widget code { background-color: "+ne+"; }")}))})),define(Q[527],n([0,1,325,2,15,19,18,10,526,177,14]),(function(X,$,Q,J,ee,ie,re,se,ae,le,ue){Object.defineProperty($,"__esModule",{value:!0});var de=function(){function e(X,$){this.editor=X,this.widget=$.createInstance(ae.ParameterHintsWidget,this.editor)}return e.get=function(X){return X.getContribution(e.ID)},e.prototype.getId=function(){return e.ID},e.prototype.cancel=function(){this.widget.cancel()},e.prototype.previous=function(){this.widget.previous()},e.prototype.next=function(){this.widget.next()},e.prototype.trigger=function(X){this.widget.trigger(X)},e.prototype.dispose=function(){this.widget=J.dispose(this.widget)},e.ID="editor.controller.parameterHints",e=ne([oe(1,ee.IInstantiationService)],e)}(),ce=function(X){function t(){return X.call(this,{id:"editor.action.triggerParameterHints",label:Q.localize(0,null),alias:"Trigger Parameter Hints",precondition:ie.EditorContextKeys.hasSignatureHelpProvider,kbOpts:{kbExpr:ie.EditorContextKeys.editorTextFocus,primary:3082,weight:100}})||this}return te(t,X),t.prototype.run=function(X,$){var Q=de.get($);Q&&Q.trigger({triggerReason:ue.SignatureHelpTriggerReason.Invoke})},t}(se.EditorAction);$.TriggerParameterHintsAction=ce,se.registerEditorContribution(de),se.registerEditorAction(ce);var he=se.EditorCommand.bindToContribution(de.get);se.registerEditorCommand(new he({id:"closeParameterHints",precondition:le.Context.Visible,handler:function(X){return X.cancel()},kbOpts:{weight:175,kbExpr:ie.EditorContextKeys.editorTextFocus,primary:9,secondary:[1033]}})),se.registerEditorCommand(new he({id:"showPrevParameterHint",precondition:re.ContextKeyExpr.and(le.Context.Visible,le.Context.MultipleSignatures),handler:function(X){return X.previous()},kbOpts:{weight:175,kbExpr:ie.EditorContextKeys.editorTextFocus,primary:16,secondary:[528],mac:{primary:16,secondary:[528,302]}}})),se.registerEditorCommand(new he({id:"showNextParameterHint",precondition:re.ContextKeyExpr.and(le.Context.Visible,le.Context.MultipleSignatures),handler:function(X){return X.next()},kbOpts:{weight:175,kbExpr:ie.EditorContextKeys.editorTextFocus,primary:18,secondary:[530],mac:{primary:18,secondary:[530,300]}}}))})),define(Q[142],n([0,1,7,67,56,28,6,27,8,30,139,196,327,18,376]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le,ue,de){Object.defineProperty($,"__esModule",{value:!0}),function(X){X.inPeekEditor=new de.RawContextKey("inReferenceSearchEditor",!0),X.notInPeekEditor=X.inPeekEditor.toNegated()}($.PeekContext||($.PeekContext={})),$.getOuterEditor=function(X){var $=X.get(se.ICodeEditorService).getFocusedCodeEditor();return $ instanceof ae.EmbeddedCodeEditorWidget?$.getParentEditor():$};var ce={headerBackgroundColor:ne.Color.white,primaryHeadingColor:ne.Color.fromHex("#333333"),secondaryHeadingColor:ne.Color.fromHex("#6c6c6cb3")},he=function(X){function t($,Q){void 0===Q&&(Q={});var J=X.call(this,$,Q)||this;return J._onDidClose=new ie.Emitter,oe.mixin(J.options,ce,!1),J}return te(t,X),t.prototype.dispose=function(){X.prototype.dispose.call(this),this._onDidClose.fire(this)},Object.defineProperty(t.prototype,"onDidClose",{get:function(){return this._onDidClose.event},enumerable:!0,configurable:!0}),t.prototype.style=function($){var Q=this.options;$.headerBackgroundColor&&(Q.headerBackgroundColor=$.headerBackgroundColor),$.primaryHeadingColor&&(Q.primaryHeadingColor=$.primaryHeadingColor),$.secondaryHeadingColor&&(Q.secondaryHeadingColor=$.secondaryHeadingColor),X.prototype.style.call(this,$)},t.prototype._applyStyles=function(){X.prototype._applyStyles.call(this);var $=this.options;this._headElement&&(this._headElement.style.backgroundColor=$.headerBackgroundColor.toString()),this._primaryHeading&&(this._primaryHeading.style.color=$.primaryHeadingColor.toString()),this._secondaryHeading&&(this._secondaryHeading.style.color=$.secondaryHeadingColor.toString()),this._bodyElement&&(this._bodyElement.style.borderColor=$.frameColor.toString())},t.prototype._fillContainer=function(X){this.setCssClass("peekview-widget"),this._headElement=Q.$(".head"),this._bodyElement=Q.$(".body"),this._fillHead(this._headElement),this._fillBody(this._bodyElement),X.appendChild(this._headElement),X.appendChild(this._bodyElement)},t.prototype._fillHead=function(X){var $=this,te=Q.$(".peekview-title");Q.append(this._headElement,te),Q.addStandardDisposableListener(te,"click",(function(X){return $._onTitleClick(X)})),this._primaryHeading=Q.$("span.filename"),this._secondaryHeading=Q.$("span.dirname"),this._metaHeading=Q.$("span.meta"),Q.append(te,this._primaryHeading,this._secondaryHeading,this._metaHeading);var ne=Q.$(".peekview-actions");Q.append(this._headElement,ne);var ie=this._getActionBarOptions();this._actionbarWidget=new J.ActionBar(ne,ie),this._disposables.push(this._actionbarWidget),this._actionbarWidget.push(new ee.Action("peekview.close",ue.localize(0,null),"close-peekview-action",!0,(function(){return $.dispose(),null})),{label:!1,icon:!0})},t.prototype._getActionBarOptions=function(){return{}},t.prototype._onTitleClick=function(X){},t.prototype.setTitle=function(X,$){this._primaryHeading.innerHTML=re.escape(X),this._primaryHeading.setAttribute("aria-label",X),$?this._secondaryHeading.innerHTML=re.escape($):Q.clearNode(this._secondaryHeading)},t.prototype.setMetaTitle=function(X){X?this._metaHeading.innerHTML=re.escape(X):Q.clearNode(this._metaHeading)},t.prototype._doLayout=function(X,$){if(!this._isShowing&&X<0)this.dispose();else{var Q=Math.ceil(1.2*this.editor.getConfiguration().lineHeight),J=X-(Q+2);this._doLayoutHead(Q,$),this._doLayoutBody(J,$)}},t.prototype._doLayoutHead=function(X,$){this._headElement.style.height=re.format("{0}px",X),this._headElement.style.lineHeight=this._headElement.style.height},t.prototype._doLayoutBody=function(X,$){this._bodyElement.style.height=re.format("{0}px",X)},t}(le.ZoneWidget);$.PeekViewWidget=he})),define(Q[529],n([0,1,334,2,3,13,20,12,381]),(function(X,$,Q,J,ee,te,ie,re){Object.defineProperty($,"__esModule",{value:!0});var se=function(){function e(X,$){var Q=this;this.themeService=$,this._disposables=[],this.allowEditorOverflow=!0,this._currentAcceptInput=null,this._currentCancelInput=null,this._editor=X,this._editor.addContentWidget(this),this._disposables.push(X.onDidChangeConfiguration((function(X){X.fontInfo&&Q.updateFont()}))),this._disposables.push($.onThemeChange((function(X){return Q.onThemeChange(X)})))}return e.prototype.onThemeChange=function(X){this.updateStyles(X)},e.prototype.dispose=function(){this._disposables=J.dispose(this._disposables),this._editor.removeContentWidget(this)},e.prototype.getId=function(){return"__renameInputWidget"},e.prototype.getDomNode=function(){return this._domNode||(this._inputField=document.createElement("input"),this._inputField.className="rename-input",this._inputField.type="text",this._inputField.setAttribute("aria-label",Q.localize(0,null)),this._domNode=document.createElement("div"),this._domNode.style.height=this._editor.getConfiguration().lineHeight+"px",this._domNode.className="monaco-editor rename-box",this._domNode.appendChild(this._inputField),this.updateFont(),this.updateStyles(this.themeService.getTheme())),this._domNode},e.prototype.updateStyles=function(X){if(this._inputField){var $=X.getColor(ie.inputBackground),Q=X.getColor(ie.inputForeground),J=X.getColor(ie.widgetShadow),ee=X.getColor(ie.inputBorder);this._inputField.style.backgroundColor=$?$.toString():null,this._inputField.style.color=Q?Q.toString():null,this._inputField.style.borderWidth=ee?"1px":"0px",this._inputField.style.borderStyle=ee?"solid":"none",this._inputField.style.borderColor=ee?ee.toString():"none",this._domNode.style.boxShadow=J?" 0 2px 8px "+J:null}},e.prototype.updateFont=function(){if(this._inputField){var X=this._editor.getConfiguration().fontInfo;this._inputField.style.fontFamily=X.fontFamily,this._inputField.style.fontWeight=X.fontWeight,this._inputField.style.fontSize=X.fontSize+"px"}},e.prototype.getPosition=function(){return this._visible?{position:this._position,preference:[2,1]}:null},e.prototype.acceptInput=function(){this._currentAcceptInput&&this._currentAcceptInput()},e.prototype.cancelInput=function(X){this._currentCancelInput&&this._currentCancelInput(X)},e.prototype.getInput=function(X,$,Q,te){var ne=this;this._position=new re.Position(X.startLineNumber,X.startColumn),this._inputField.value=$,this._inputField.setAttribute("selectionStart",Q.toString()),this._inputField.setAttribute("selectionEnd",te.toString()),this._inputField.size=Math.max(1.1*(X.endColumn-X.startColumn),20);var ie,oe=[];return ie=function(){J.dispose(oe),ne._hide()},new Promise((function(Q){ne._currentCancelInput=function(X){return ne._currentAcceptInput=null,ne._currentCancelInput=null,Q(X),!0},ne._currentAcceptInput=function(){0!==ne._inputField.value.trim().length&&ne._inputField.value!==$?(ne._currentAcceptInput=null,ne._currentCancelInput=null,Q(ne._inputField.value)):ne.cancelInput(!0)},oe.push(ne._editor.onDidChangeCursorSelection((function(){var $=ne._editor.getPosition();$&&ee.Range.containsPosition(X,$)||ne.cancelInput(!0)}))),oe.push(ne._editor.onDidBlurEditorWidget((function(){return ne.cancelInput(!1)}))),ne._show()})).then((function(X){return ie(),X}),(function(X){return ie(),Promise.reject(X)}))},e.prototype._show=function(){var X=this;this._editor.revealLineInCenterIfOutsideViewport(this._position.lineNumber,0),this._visible=!0,this._editor.layoutContentWidget(this),setTimeout((function(){X._inputField.focus(),X._inputField.setSelectionRange(parseInt(X._inputField.getAttribute("selectionStart")),parseInt(X._inputField.getAttribute("selectionEnd")))}),100)},e.prototype._hide=function(){this._visible=!1,this._editor.layoutContentWidget(this)},ne([oe(1,te.IThemeService)],e)}();$.default=se})),define(Q[530],n([0,1,333,11,18,89,10,19,529,13,14,12,43,3,141,66,35,126,25,30,24]),(function(X,$,Q,J,ee,ie,ae,le,ue,de,ce,he,pe,fe,ge,me,ve,_e,ye,be,Ce){function x(X,$,Q){return re(this,void 0,void 0,(function(){return se(this,(function(J){return[2,new we(X,$).provideRenameEdits(Q,void 0,void 0,Ce.CancellationToken.None)]}))}))}Object.defineProperty($,"__esModule",{value:!0});var we=function(){function e(X,$){this.model=X,this.position=$,this._provider=ce.RenameProviderRegistry.ordered(X)}return e.prototype.hasProvider=function(){return this._provider.length>0},e.prototype.resolveRenameLocation=function(X){return re(this,void 0,void 0,(function(){var $,Q,J;return se(this,(function(ee){switch(ee.label){case 0:return($=this._provider[0]).resolveRenameLocation?[4,$.resolveRenameLocation(this.model,this.position,X)]:[3,2];case 1:Q=ee.sent(),ee.label=2;case 2:return Q||(J=this.model.getWordAtPosition(this.position))&&(Q={range:new fe.Range(this.position.lineNumber,J.startColumn,this.position.lineNumber,J.endColumn),text:J.word}),[2,Q]}}))}))},e.prototype.provideRenameEdits=function(X,$,J,ee){return void 0===$&&($=0),void 0===J&&(J=[]),re(this,void 0,void 0,(function(){var te;return se(this,(function(ne){switch(ne.label){case 0:return $>=this._provider.length?[2,{edits:void 0,rejectReason:J.join("\n")}]:[4,this._provider[$].provideRenameEdits(this.model,this.position,X,ee)];case 1:return(te=ne.sent())?te.rejectReason?[2,this.provideRenameEdits(X,$+1,J.concat(te.rejectReason),ee)]:[2,te]:[2,this.provideRenameEdits(X,$+1,J.concat(Q.localize(0,null)),ee)]}}))}))},e}();$.rename=x;var Se=new ee.RawContextKey("renameInputVisible",!1),Ee=function(){function e(X,$,Q,J,ee,te){this.editor=X,this._notificationService=$,this._bulkEditService=Q,this._progressService=J,this._renameInputField=new ue.default(X,te),this._renameInputVisible=Se.bindTo(ee)}return e.get=function(X){return X.getContribution(e.ID)},e.prototype.dispose=function(){this._renameInputField.dispose()},e.prototype.getId=function(){return e.ID},e.prototype.run=function(X){return re(this,void 0,void 0,(function(){var $,J,ee,te,ne,ie,oe,re=this;return se(this,(function(se){switch(se.label){case 0:if(!this.editor.hasModel())return[2,void 0];if($=this.editor.getPosition(),!(J=new we(this.editor.getModel(),$)).hasProvider())return[2,void 0];se.label=1;case 1:return se.trys.push([1,3,,4]),[4,J.resolveRenameLocation(X)];case 2:return ee=se.sent(),[3,4];case 3:return te=se.sent(),ge.MessageController.get(this.editor).showMessage(te||Q.localize(1,null),$),[2,void 0];case 4:return ee?ee.rejectReason?(ge.MessageController.get(this.editor).showMessage(ee.rejectReason,$),[2,void 0]):(ne=this.editor.getSelection(),ie=0,oe=ee.text.length,fe.Range.isEmpty(ne)||fe.Range.spansMultipleLines(ne)||!fe.Range.containsRange(ee.range,ne)||(ie=Math.max(0,ne.startColumn-ee.range.startColumn),oe=Math.min(ee.range.endColumn,ne.endColumn)-ee.range.startColumn),this._renameInputVisible.set(!0),[2,this._renameInputField.getInput(ee.range,ee.text,ie,oe).then((function($){if(re._renameInputVisible.reset(),"boolean"!=typeof $){re.editor.focus();var te=new me.EditorState(re.editor,15),ne=Promise.resolve(J.provideRenameEdits($,0,[],X).then((function(X){if(re.editor.hasModel()){if(!X.rejectReason)return re._bulkEditService.apply(X,{editor:re.editor}).then((function(X){X.ariaSummary&&pe.alert(Q.localize(2,null,ee.text,$,X.ariaSummary))}));te.validate(re.editor)?ge.MessageController.get(re.editor).showMessage(X.rejectReason,re.editor.getPosition()):re._notificationService.info(X.rejectReason)}}),(function(X){return re._notificationService.error(Q.localize(3,null)),Promise.reject(X)})));return re._progressService.showWhile(ne,250),ne}$&&re.editor.focus()}),(function(X){return re._renameInputVisible.reset(),Promise.reject(X)}))]):[2,void 0]}}))}))},e.prototype.acceptRenameInput=function(){this._renameInputField.acceptInput()},e.prototype.cancelRenameInput=function(){this._renameInputField.cancelInput(!0)},e.ID="editor.contrib.renameController",e=ne([oe(1,ve.INotificationService),oe(2,_e.IBulkEditService),oe(3,ie.IProgressService),oe(4,ee.IContextKeyService),oe(5,de.IThemeService)],e)}(),Le=function(X){function t(){return X.call(this,{id:"editor.action.rename",label:Q.localize(4,null),alias:"Rename Symbol",precondition:ee.ContextKeyExpr.and(le.EditorContextKeys.writable,le.EditorContextKeys.hasRenameProvider),kbOpts:{kbExpr:le.EditorContextKeys.editorTextFocus,primary:60,weight:100},menuOpts:{group:"1_modification",order:1.1}})||this}return te(t,X),t.prototype.runCommand=function($,Q){var ee=this,te=$.get(be.ICodeEditorService),ne=Q||[void 0,void 0],ie=ne[0],oe=ne[1];return ye.URI.isUri(ie)&&he.Position.isIPosition(oe)?te.openCodeEditor({resource:ie},te.getActiveCodeEditor()).then((function(X){X&&(X.setPosition(oe),X.invokeWithinContext((function($){return ee.reportTelemetry($,X),ee.run($,X)})))}),J.onUnexpectedError):X.prototype.runCommand.call(this,$,Q)},t.prototype.run=function(X,$){var Q=Ee.get($);return Q?Promise.resolve(Q.run(Ce.CancellationToken.None)):Promise.resolve()},t}(ae.EditorAction);$.RenameAction=Le,ae.registerEditorContribution(Ee),ae.registerEditorAction(Le);var xe=ae.EditorCommand.bindToContribution(Ee.get);ae.registerEditorCommand(new xe({id:"acceptRenameInput",precondition:Se,handler:function(X){return X.acceptRenameInput()},kbOpts:{weight:199,kbExpr:le.EditorContextKeys.focus,primary:3}})),ae.registerEditorCommand(new xe({id:"cancelRenameInput",precondition:Se,handler:function(X){return X.cancelRenameInput()},kbOpts:{weight:199,kbExpr:le.EditorContextKeys.focus,primary:9,secondary:[1033]}})),ae.registerDefaultLanguageCommand("_executeDocumentRenameProvider",(function(X,$,Q){var ee=Q.newName;if("string"!=typeof ee)throw J.illegalArgument("newName");return x(X,$,ee)}))})),define(Q[531],n([0,1,22,2,8,49,3,21,26,202,15,111,337,13,20,382]),(function(X,$,Q,J,ee,te,ne,ie,oe,re,se,ae,le,ue,de){Object.defineProperty($,"__esModule",{value:!0}),ue.registerThemingParticipant((function(X,$){function n($){var Q=X.getColor($);return Q?Q.toString():"transparent"}$.addRule(".monaco-editor .snippet-placeholder { background-color: "+n(de.snippetTabstopHighlightBackground)+"; outline-color: "+n(de.snippetTabstopHighlightBorder)+"; }"),$.addRule(".monaco-editor .finish-snippet-placeholder { background-color: "+n(de.snippetFinalTabstopHighlightBackground)+"; outline-color: "+n(de.snippetFinalTabstopHighlightBorder)+"; }")}));var ce=function(){function e(X,$,J){this._nestingLevel=1,this._editor=X,this._snippet=$,this._offset=J,this._placeholderGroups=Q.groupBy($.placeholders,ae.Placeholder.compareByIndex),this._placeholderGroupsIdx=-1}return e.prototype.dispose=function(){if(this._placeholderDecorations){var X=[];this._placeholderDecorations.forEach((function($){return X.push($)})),this._editor.deltaDecorations(X,[])}this._placeholderGroups.length=0},e.prototype._initDecorations=function(){var X=this;if(!this._placeholderDecorations){this._placeholderDecorations=new Map;var $=this._editor.getModel();this._editor.changeDecorations((function(Q){for(var J=0,ee=X._snippet.placeholders;J<ee.length;J++){var te=ee[J],ie=X._snippet.offset(te),oe=X._snippet.fullLen(te),re=ne.Range.fromPositions($.getPositionAt(X._offset+ie),$.getPositionAt(X._offset+ie+oe)),se=te.isFinalTabstop?e._decor.inactiveFinal:e._decor.inactive,ae=Q.addDecoration(re,se);X._placeholderDecorations.set(te,ae)}}))}},e.prototype.move=function(X){var $=this;if(this._initDecorations(),this._placeholderGroupsIdx>=0){for(var Q=[],J=0,ee=this._placeholderGroups[this._placeholderGroupsIdx];J<ee.length;J++){var ne=ee[J];if(ne.transform){var oe=this._placeholderDecorations.get(ne),re=this._editor.getModel().getDecorationRange(oe),se=this._editor.getModel().getValueInRange(re);Q.push(te.EditOperation.replaceMove(re,ne.transform.resolve(se)))}}Q.length>0&&this._editor.executeEdits("snippet.placeholderTransform",Q)}var ae=!1;!0===X&&this._placeholderGroupsIdx<this._placeholderGroups.length-1?(this._placeholderGroupsIdx+=1,ae=!0):!1===X&&this._placeholderGroupsIdx>0&&(this._placeholderGroupsIdx-=1,ae=!0);var le=this._editor.getModel().changeDecorations((function(X){for(var Q=new Set,J=[],ee=0,te=$._placeholderGroups[$._placeholderGroupsIdx];ee<te.length;ee++){var ne=te[ee],oe=$._placeholderDecorations.get(ne),re=$._editor.getModel().getDecorationRange(oe);J.push(new ie.Selection(re.startLineNumber,re.startColumn,re.endLineNumber,re.endColumn)),ae=ae&&re.isEmpty()&&ne.toString().length>0,X.changeDecorationOptions(oe,ne.isFinalTabstop?e._decor.activeFinal:e._decor.active),Q.add(ne);for(var se=0,le=$._snippet.enclosingPlaceholders(ne);se<le.length;se++){var ue=le[se],de=$._placeholderDecorations.get(ue);X.changeDecorationOptions(de,ue.isFinalTabstop?e._decor.activeFinal:e._decor.active),Q.add(ue)}}return $._placeholderDecorations.forEach((function($,J){Q.has(J)||X.changeDecorationOptions($,J.isFinalTabstop?e._decor.inactiveFinal:e._decor.inactive)})),J}));return ae?this.move(X):le},Object.defineProperty(e.prototype,"isAtFirstPlaceholder",{get:function(){return this._placeholderGroupsIdx<=0||0===this._placeholderGroups.length},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isAtLastPlaceholder",{get:function(){return this._placeholderGroupsIdx===this._placeholderGroups.length-1},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"hasPlaceholder",{get:function(){return this._snippet.placeholders.length>0},enumerable:!0,configurable:!0}),e.prototype.computePossibleSelections=function(){for(var X=new Map,$=0,Q=this._placeholderGroups;$<Q.length;$++)for(var J=void 0,ee=0,te=Q[$];ee<te.length;ee++){var ne=te[ee];if(ne.isFinalTabstop)break;J||(J=[],X.set(ne.index,J));var ie=this._placeholderDecorations.get(ne),oe=this._editor.getModel().getDecorationRange(ie);if(!oe){X.delete(ne.index);break}J.push(oe)}return X},Object.defineProperty(e.prototype,"choice",{get:function(){return this._placeholderGroups[this._placeholderGroupsIdx][0].choice},enumerable:!0,configurable:!0}),e.prototype.merge=function(X){var $=this,J=this._editor.getModel();this._nestingLevel*=10,this._editor.changeDecorations((function(ee){for(var te=0,ie=$._placeholderGroups[$._placeholderGroupsIdx];te<ie.length;te++){var oe=ie[te],re=X.shift();console.assert(!re._placeholderDecorations);for(var se=re._snippet.placeholderInfo.last.index,le=0,ue=re._snippet.placeholderInfo.all;le<ue.length;le++){var de=ue[le];de.isFinalTabstop?de.index=oe.index+(se+1)/$._nestingLevel:de.index=oe.index+de.index/$._nestingLevel}$._snippet.replace(oe,re._snippet.children);var ce=$._placeholderDecorations.get(oe);ee.removeDecoration(ce),$._placeholderDecorations.delete(oe);for(var he=0,pe=re._snippet.placeholders;he<pe.length;he++){var fe=pe[he],ge=re._snippet.offset(fe),me=re._snippet.fullLen(fe),ve=ne.Range.fromPositions(J.getPositionAt(re._offset+ge),J.getPositionAt(re._offset+ge+me)),_e=ee.addDecoration(ve,e._decor.inactive);$._placeholderDecorations.set(fe,_e)}}$._placeholderGroups=Q.groupBy($._snippet.placeholders,ae.Placeholder.compareByIndex)}))},e._decor={active:oe.ModelDecorationOptions.register({stickiness:0,className:"snippet-placeholder"}),inactive:oe.ModelDecorationOptions.register({stickiness:1,className:"snippet-placeholder"}),activeFinal:oe.ModelDecorationOptions.register({stickiness:1,className:"finish-snippet-placeholder"}),inactiveFinal:oe.ModelDecorationOptions.register({stickiness:1,className:"finish-snippet-placeholder"})},e}();$.OneSnippet=ce;var he=function(){function e(X,$,Q,J,ee){void 0===Q&&(Q=0),void 0===J&&(J=0),void 0===ee&&(ee=!0),this._templateMerges=[],this._snippets=[],this._editor=X,this._template=$,this._overwriteBefore=Q,this._overwriteAfter=J,this._adjustWhitespace=ee}return e.adjustWhitespace=function(X,$,Q){var J=X.getLineContent($.lineNumber),te=ee.getLeadingWhitespace(J,0,$.column-1);Q.walk((function($){if($ instanceof ae.Text&&!($.parent instanceof ae.Choice)){for(var Q=$.value.split(/\r\n|\r|\n/),J=1;J<Q.length;J++){var ne=ee.getLeadingWhitespace(Q[J]);Q[J]=X.normalizeIndentation(te+ne)+Q[J].substr(ne.length)}var ie=Q.join(X.getEOL());ie!==$.value&&$.parent.replace($,[new ae.Text(ie)])}return!0}))},e.adjustSelection=function(X,$,Q,J){if(0!==Q||0!==J){var ee=$.positionLineNumber,te=$.positionColumn,ne=te-Q,oe=te+J,re=X.validateRange({startLineNumber:ee,startColumn:ne,endLineNumber:ee,endColumn:oe});$=ie.Selection.createWithDirection(re.startLineNumber,re.startColumn,re.endLineNumber,re.endColumn,$.getDirection())}return $},e.createEditsAndSnippets=function(X,$,Q,J,ee,ie){for(var oe=X.getModel(),ue=[],de=[],he=new le.ModelBasedVariableResolver(oe),pe=X.invokeWithinContext((function(X){return X.get(re.IClipboardService,se.optional)})),fe=0,ge=oe.getValueInRange(e.adjustSelection(oe,X.getSelection(),Q,0)),me=oe.getValueInRange(e.adjustSelection(oe,X.getSelection(),0,J)),ve=oe.getLineFirstNonWhitespaceColumn(X.getSelection().positionLineNumber),_e=X.getSelections().map((function(X,$){return{selection:X,idx:$}})).sort((function(X,$){return ne.Range.compareRangesUsingStarts(X.selection,$.selection)})),ye=0,be=_e;ye<be.length;ye++){var Ce=be[ye],we=Ce.selection,Se=Ce.idx,Ee=e.adjustSelection(oe,we,Q,0),Le=e.adjustSelection(oe,we,0,J);ge!==oe.getValueInRange(Ee)&&(Ee=we),me!==oe.getValueInRange(Le)&&(Le=we);var xe=we.setStartPosition(Ee.startLineNumber,Ee.startColumn).setEndPosition(Le.endLineNumber,Le.endColumn),Ie=(new ae.SnippetParser).parse($,!0,ee),De=xe.getStartPosition();(ie||Se>0&&ve!==oe.getLineFirstNonWhitespaceColumn(we.positionLineNumber))&&e.adjustWhitespace(oe,De,Ie),Ie.resolveVariables(new le.CompositeSnippetVariableResolver([he,new le.ClipboardBasedVariableResolver(pe,Se,_e.length),new le.SelectionBasedVariableResolver(oe,we),new le.TimeBasedVariableResolver]));var Ne=oe.getOffsetAt(De)+fe;fe+=Ie.toString().length-oe.getValueLengthInRange(xe),ue[Se]=te.EditOperation.replace(xe,Ie.toString()),de[Se]=new ce(X,Ie,Ne)}return{edits:ue,snippets:de}},e.prototype.dispose=function(){J.dispose(this._snippets)},e.prototype._logInfo=function(){return'template="'+this._template+'", merged_templates="'+this._templateMerges.join(" -> ")+'"'},e.prototype.insert=function(){var X=this,$=this._editor.getModel(),Q=e.createEditsAndSnippets(this._editor,this._template,this._overwriteBefore,this._overwriteAfter,!1,this._adjustWhitespace),J=Q.edits,ee=Q.snippets;this._snippets=ee;var te=$.pushEditOperations(this._editor.getSelections(),J,(function($){return X._snippets[0].hasPlaceholder?X._move(!0):$.map((function(X){return ie.Selection.fromPositions(X.range.getEndPosition())}))}));this._editor.setSelections(te),this._editor.revealRange(te[0])},e.prototype.merge=function(X,$,Q,J){var ee=this;void 0===$&&($=0),void 0===Q&&(Q=0),void 0===J&&(J=!0),this._templateMerges.push([this._snippets[0]._nestingLevel,this._snippets[0]._placeholderGroupsIdx,X]);var te=e.createEditsAndSnippets(this._editor,X,$,Q,!0,J),ne=te.edits,oe=te.snippets;this._editor.setSelections(this._editor.getModel().pushEditOperations(this._editor.getSelections(),ne,(function(X){for(var $=0,Q=ee._snippets;$<Q.length;$++)Q[$].merge(oe);return console.assert(0===oe.length),ee._snippets[0].hasPlaceholder?ee._move(void 0):X.map((function(X){return ie.Selection.fromPositions(X.range.getEndPosition())}))})))},e.prototype.next=function(){var X=this._move(!0);this._editor.setSelections(X),this._editor.revealPositionInCenterIfOutsideViewport(X[0].getPosition())},e.prototype.prev=function(){var X=this._move(!1);this._editor.setSelections(X),this._editor.revealPositionInCenterIfOutsideViewport(X[0].getPosition())},e.prototype._move=function(X){for(var $=[],Q=0,J=this._snippets;Q<J.length;Q++){var ee=J[Q].move(X);$.push.apply($,ee)}return $},Object.defineProperty(e.prototype,"isAtFirstPlaceholder",{get:function(){return this._snippets[0].isAtFirstPlaceholder},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isAtLastPlaceholder",{get:function(){return this._snippets[0].isAtLastPlaceholder},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"hasPlaceholder",{get:function(){return this._snippets[0].hasPlaceholder},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"choice",{get:function(){return this._snippets[0].choice},enumerable:!0,configurable:!0}),e.prototype.isSelectionWithinPlaceholders=function(){if(!this.hasPlaceholder)return!1;var X=this._editor.getSelections();if(X.length<this._snippets.length)return!1;for(var $,n=function(Q){var J=Q.computePossibleSelections();if($||($=new Map,J.forEach((function(Q,J){Q.sort(ne.Range.compareRangesUsingStarts);for(var ee=0,te=X;ee<te.length;ee++){var ie=te[ee];if(Q[0].containsRange(ie)){$.set(J,[]);break}}}))),0===$.size)return{value:!1};$.forEach((function(X,$){X.push.apply(X,J.get($))}))},Q=0,J=this._snippets;Q<J.length;Q++){var ee=n(J[Q]);if("object"==typeof ee)return ee.value}return X.sort(ne.Range.compareRangesUsingStarts),$.forEach((function(Q,J){if(Q.length===X.length){Q.sort(ne.Range.compareRangesUsingStarts);for(var ee=0;ee<Q.length;ee++)if(!Q[ee].containsRange(X[ee]))return void $.delete(J)}else $.delete(J)})),$.size>0},e}();$.SnippetSession=he})),define(Q[143],n([0,1,2,8,10,3,21,19,85,18,116,531]),(function(X,$,Q,J,ee,te,ie,re,se,ae,le,ue){Object.defineProperty($,"__esModule",{value:!0});var de=function(){function e(X,$,Q){this._editor=X,this._logService=$,this._snippetListener=[],this._inSnippet=e.InSnippetMode.bindTo(Q),this._hasNextTabstop=e.HasNextTabstop.bindTo(Q),this._hasPrevTabstop=e.HasPrevTabstop.bindTo(Q)}return e.get=function(X){return X.getContribution("snippetController2")},e.prototype.dispose=function(){this._inSnippet.reset(),this._hasPrevTabstop.reset(),this._hasNextTabstop.reset(),Q.dispose(this._session)},e.prototype.getId=function(){return"snippetController2"},e.prototype.insert=function(X,$,Q,J,ee,te){void 0===$&&($=0),void 0===Q&&(Q=0),void 0===J&&(J=!0),void 0===ee&&(ee=!0),void 0===te&&(te=!0);try{this._doInsert(X,$,Q,J,ee,te)}catch($){this.cancel(),this._logService.error($),this._logService.error("snippet_error"),this._logService.error("insert_template=",X),this._logService.error("existing_template=",this._session?this._session._logInfo():"<no_session>")}},e.prototype._doInsert=function(X,$,J,ee,te,ne){var ie=this;void 0===$&&($=0),void 0===J&&(J=0),void 0===ee&&(ee=!0),void 0===te&&(te=!0),void 0===ne&&(ne=!0),this._snippetListener=Q.dispose(this._snippetListener),ee&&this._editor.getModel().pushStackElement(),this._session?this._session.merge(X,$,J,ne):(this._modelVersionId=this._editor.getModel().getAlternativeVersionId(),this._session=new ue.SnippetSession(this._editor,X,$,J,ne),this._session.insert()),te&&this._editor.getModel().pushStackElement(),this._updateState(),this._snippetListener=[this._editor.onDidChangeModelContent((function(X){return X.isFlush&&ie.cancel()})),this._editor.onDidChangeModel((function(){return ie.cancel()})),this._editor.onDidChangeCursorSelection((function(){return ie._updateState()}))]},e.prototype._updateState=function(){if(this._session){if(this._modelVersionId===this._editor.getModel().getAlternativeVersionId())return this.cancel();if(!this._session.hasPlaceholder)return this.cancel();if(this._session.isAtLastPlaceholder||!this._session.isSelectionWithinPlaceholders())return this.cancel();this._inSnippet.set(!0),this._hasPrevTabstop.set(!this._session.isAtFirstPlaceholder),this._hasNextTabstop.set(!this._session.isAtLastPlaceholder),this._handleChoice()}},e.prototype._handleChoice=function(){var X=this,$=this._session.choice;if($){if(this._currentChoice!==$){this._currentChoice=$,this._editor.setSelections(this._editor.getSelections().map((function(X){return ie.Selection.fromPositions(X.getStartPosition())})));var Q=$.options[0];se.showSimpleSuggestions(this._editor,$.options.map((function($,ee){return{kind:13,label:$.value,insertText:$.value,sortText:J.repeat("a",ee),range:te.Range.fromPositions(X._editor.getPosition(),X._editor.getPosition().delta(0,Q.value.length))}})))}}else this._currentChoice=void 0},e.prototype.finish=function(){for(;this._inSnippet.get();)this.next()},e.prototype.cancel=function(){this._inSnippet.reset(),this._hasPrevTabstop.reset(),this._hasNextTabstop.reset(),Q.dispose(this._snippetListener),Q.dispose(this._session),this._session=void 0,this._modelVersionId=-1},e.prototype.prev=function(){this._session.prev(),this._updateState()},e.prototype.next=function(){this._session.next(),this._updateState()},e.prototype.isInSnippet=function(){return this._inSnippet.get()},e.InSnippetMode=new ae.RawContextKey("inSnippetMode",!1),e.HasNextTabstop=new ae.RawContextKey("hasNextTabstop",!1),e.HasPrevTabstop=new ae.RawContextKey("hasPrevTabstop",!1),e=ne([oe(1,le.ILogService),oe(2,ae.IContextKeyService)],e)}();$.SnippetController2=de,ee.registerEditorContribution(de);var ce=ee.EditorCommand.bindToContribution(de.get);ee.registerEditorCommand(new ce({id:"jumpToNextSnippetPlaceholder",precondition:ae.ContextKeyExpr.and(de.InSnippetMode,de.HasNextTabstop),handler:function(X){return X.next()},kbOpts:{weight:130,kbExpr:re.EditorContextKeys.editorTextFocus,primary:2}})),ee.registerEditorCommand(new ce({id:"jumpToPrevSnippetPlaceholder",precondition:ae.ContextKeyExpr.and(de.InSnippetMode,de.HasPrevTabstop),handler:function(X){return X.prev()},kbOpts:{weight:130,kbExpr:re.EditorContextKeys.editorTextFocus,primary:1026}})),ee.registerEditorCommand(new ce({id:"leaveSnippet",precondition:de.InSnippetMode,handler:function(X){return X.cancel()},kbOpts:{weight:130,kbExpr:re.EditorContextKeys.editorTextFocus,primary:9,secondary:[1033]}})),ee.registerEditorCommand(new ce({id:"acceptSnippet",precondition:de.InSnippetMode,handler:function(X){return X.finish()}}))})),define(Q[533],n([0,1,22,16,11,6,2,65,21,14,470,85,143,24,261]),(function(X,$,Q,J,ee,te,ne,ie,oe,re,se,ae,le,ue,de){Object.defineProperty($,"__esModule",{value:!0});var ce=function(){function e(X,$,Q,J){this.leadingLineContent=X.getLineContent($.lineNumber).substr(0,$.column-1),this.leadingWord=X.getWordUntilPosition($),this.lineNumber=$.lineNumber,this.column=$.column,this.auto=Q,this.shy=J}return e.shouldAutoTrigger=function(X){var $=X.getModel();if(!$)return!1;var Q=X.getPosition();$.tokenizeIfCheap(Q.lineNumber);var J=$.getWordAtPosition(Q);return!!J&&J.endColumn===Q.column&&!!isNaN(Number(J.word))},e}();$.LineContext=ce;var he=function(){function e(X,$){var Q=this;this._editor=X,this._editorWorker=$,this._toDispose=[],this._triggerQuickSuggest=new J.TimeoutTimer,this._triggerRefilter=new J.TimeoutTimer,this._state=0,this._onDidCancel=new te.Emitter,this._onDidTrigger=new te.Emitter,this._onDidSuggest=new te.Emitter,this.onDidCancel=this._onDidCancel.event,this.onDidTrigger=this._onDidTrigger.event,this.onDidSuggest=this._onDidSuggest.event,this._completionModel=null,this._context=null,this._currentSelection=this._editor.getSelection()||new oe.Selection(1,1,1,1),this._toDispose.push(this._editor.onDidChangeModel((function(){Q._updateTriggerCharacters(),Q.cancel()}))),this._toDispose.push(this._editor.onDidChangeModelLanguage((function(){Q._updateTriggerCharacters(),Q.cancel()}))),this._toDispose.push(this._editor.onDidChangeConfiguration((function(){Q._updateTriggerCharacters(),Q._updateQuickSuggest()}))),this._toDispose.push(re.CompletionProviderRegistry.onDidChange((function(){Q._updateTriggerCharacters(),Q._updateActiveSuggestSession()}))),this._toDispose.push(this._editor.onDidChangeCursorSelection((function(X){Q._onCursorChange(X)})));var ee=!1;this._toDispose.push(this._editor.onCompositionStart((function(){ee=!0}))),this._toDispose.push(this._editor.onCompositionEnd((function(){ee=!1,Q._refilterCompletionItems()}))),this._toDispose.push(this._editor.onDidChangeModelContent((function(){ee||Q._refilterCompletionItems()}))),this._updateTriggerCharacters(),this._updateQuickSuggest()}return e.prototype.dispose=function(){ne.dispose([this._onDidCancel,this._onDidSuggest,this._onDidTrigger,this._triggerCharacterListener,this._triggerQuickSuggest,this._triggerRefilter]),this._toDispose=ne.dispose(this._toDispose),ne.dispose(this._completionModel),this.cancel()},e.prototype._updateQuickSuggest=function(){this._quickSuggestDelay=this._editor.getConfiguration().contribInfo.quickSuggestionsDelay,(isNaN(this._quickSuggestDelay)||!this._quickSuggestDelay&&0!==this._quickSuggestDelay||this._quickSuggestDelay<0)&&(this._quickSuggestDelay=10)},e.prototype._updateTriggerCharacters=function(){var X=this;if(ne.dispose(this._triggerCharacterListener),!this._editor.getConfiguration().readOnly&&this._editor.getModel()&&this._editor.getConfiguration().contribInfo.suggestOnTriggerCharacters){for(var $=Object.create(null),J=0,ee=re.CompletionProviderRegistry.all(this._editor.getModel());J<ee.length;J++){var te=ee[J];if(!Q.isFalsyOrEmpty(te.triggerCharacters))for(var oe=0,se=te.triggerCharacters;oe<se.length;oe++){var le=se[oe],ue=$[le];ue||(ue=$[le]=new Set).add(ae.getSnippetSuggestSupport()),ue.add(te)}}this._triggerCharacterListener=this._editor.onDidType((function(Q){var J=Q.charAt(Q.length-1),ee=$[J];if(ee){var te=X._completionModel?X._completionModel.adopt(ee):void 0;X.trigger({auto:!0,triggerCharacter:J},Boolean(X._completionModel),ie.values(ee),te)}}))}},Object.defineProperty(e.prototype,"state",{get:function(){return this._state},enumerable:!0,configurable:!0}),e.prototype.cancel=function(X){void 0===X&&(X=!1),this._triggerRefilter.cancel(),this._triggerQuickSuggest&&this._triggerQuickSuggest.cancel(),this._requestToken&&this._requestToken.cancel(),this._state=0,ne.dispose(this._completionModel),this._completionModel=null,this._context=null,this._onDidCancel.fire({retrigger:X})},e.prototype._updateActiveSuggestSession=function(){0!==this._state&&(re.CompletionProviderRegistry.has(this._editor.getModel())?this.trigger({auto:2===this._state},!0):this.cancel())},e.prototype._onCursorChange=function(X){var $=this,Q=this._currentSelection;if(this._currentSelection=this._editor.getSelection(),!X.selection.isEmpty()||0!==X.reason||"keyboard"!==X.source&&"deleteLeft"!==X.source)0!==this._state&&this.cancel();else if(re.CompletionProviderRegistry.has(this._editor.getModel())&&this._editor.getModel()&&0===this._state){if(!1===this._editor.getConfiguration().contribInfo.quickSuggestions)return;if(!Q.containsRange(this._currentSelection)&&!Q.getEndPosition().isBeforeOrEqual(this._currentSelection.getPosition()))return;if(this._editor.getConfiguration().contribInfo.suggest.snippetsPreventQuickSuggestions&&le.SnippetController2.get(this._editor).isInSnippet())return;this.cancel(),this._triggerQuickSuggest.cancelAndSet((function(){if(ce.shouldAutoTrigger($._editor)){var X=$._editor.getModel(),Q=$._editor.getPosition();if(X){var J=$._editor.getConfiguration().contribInfo.quickSuggestions;if(!1!==J){if(!0===J);else{X.tokenizeIfCheap(Q.lineNumber);var ee=X.getLineTokens(Q.lineNumber),te=ee.getStandardTokenType(ee.findTokenIndexAtOffset(Math.max(Q.column-1-1,0)));if(!(J.other&&0===te||J.comments&&1===te||J.strings&&2===te))return}$.trigger({auto:!0})}}}}),this._quickSuggestDelay)}},e.prototype._refilterCompletionItems=function(){var X=this;if(0!==this._state){var $=this._editor.getModel();$&&this._triggerRefilter.cancelAndSet((function(){var Q=X._editor.getPosition(),J=new ce($,Q,2===X._state,!1);X._onNewContext(J)}),25)}},e.prototype.trigger=function(X,$,J,te){var ie=this;void 0===$&&($=!1);var oe=this._editor.getModel();if(oe){var re,le=X.auto,he=new ce(oe,this._editor.getPosition(),le,X.shy);this.cancel($),this._state=le?2:1,this._onDidTrigger.fire({auto:le,shy:X.shy}),this._context=he,re=X.triggerCharacter?{triggerKind:1,triggerCharacter:X.triggerCharacter}:J&&J.length?{triggerKind:2}:{triggerKind:0},this._requestToken=new ue.CancellationTokenSource;var pe=de.WordDistance.create(this._editorWorker,this._editor),fe=ae.provideSuggestionItems(oe,this._editor.getPosition(),this._editor.getConfiguration().contribInfo.suggest.snippets,J,re,this._requestToken.token);Promise.all([fe,pe]).then((function($){var J=$[0],ee=$[1];if(ie._requestToken.dispose(),0!==ie._state){var oe=ie._editor.getModel();if(oe){if(!Q.isFalsyOrEmpty(te)){var re=ae.getSuggestionComparator(ie._editor.getConfiguration().contribInfo.suggest.snippets);J=J.concat(te).sort(re)}var ue=new ce(oe,ie._editor.getPosition(),le,X.shy);ne.dispose(ie._completionModel),ie._completionModel=new se.CompletionModel(J,ie._context.column,{leadingLineContent:ue.leadingLineContent,characterCountDelta:ie._context?ue.column-ie._context.column:0},ee,ie._editor.getConfiguration().contribInfo.suggest),ie._onNewContext(ue)}}})).catch(ee.onUnexpectedError)}},e.prototype._onNewContext=function(X){if(this._context)if(X.lineNumber===this._context.lineNumber){if(X.leadingWord.startColumn<this._context.leadingWord.startColumn)this.cancel();else if(X.column<this._context.column)X.leadingWord.word?this.trigger({auto:this._context.auto},!0):this.cancel();else if(this._completionModel)if(X.column>this._context.column&&this._completionModel.incomplete.size>0&&0!==X.leadingWord.word.length){var $=this._completionModel.incomplete,Q=this._completionModel.adopt($);this.trigger({auto:2===this._state},!0,ie.values($),Q)}else{var J=this._completionModel.lineContext,ee=!1;if(this._completionModel.lineContext={leadingLineContent:X.leadingLineContent,characterCountDelta:X.column-this._context.column},0===this._completionModel.items.length){if(ce.shouldAutoTrigger(this._editor)&&this._context.leadingWord.endColumn<X.leadingWord.startColumn)return void this.trigger({auto:this._context.auto},!0);if(this._context.auto)return void this.cancel();if(this._completionModel.lineContext=J,(ee=this._completionModel.items.length>0)&&0===X.leadingWord.word.length)return void this.cancel()}this._onDidSuggest.fire({completionModel:this._completionModel,auto:this._context.auto,shy:this._context.shy,isFrozen:ee})}}else this.cancel()},e}();$.SuggestModel=he})),define(Q[534],n([0,1,339,100,8,6,11,2,7,277,55,47,18,85,43,70,86,13,20,71,120,63,62,16,24,14,118,428,42,25,15,162,383]),(function(X,$,Q,J,ee,te,re,se,ae,le,ue,de,ce,he,pe,fe,ge,me,ve,_e,ye,be,Ce,we,Se,Ee,Le,xe,Ie,De,Ne,Me){function P(X){return X&&X.match(ke)?X:null}function A(X){if(!X)return!1;var $=X.suggestion;return!!$.documentation||$.detail&&$.detail!==$.label}Object.defineProperty($,"__esModule",{value:!0}),$.editorSuggestWidgetBackground=ve.registerColor("editorSuggestWidget.background",{dark:ve.editorWidgetBackground,light:ve.editorWidgetBackground,hc:ve.editorWidgetBackground},Q.localize(0,null)),$.editorSuggestWidgetBorder=ve.registerColor("editorSuggestWidget.border",{dark:ve.editorWidgetBorder,light:ve.editorWidgetBorder,hc:ve.editorWidgetBorder},Q.localize(1,null)),$.editorSuggestWidgetForeground=ve.registerColor("editorSuggestWidget.foreground",{dark:ve.editorForeground,light:ve.editorForeground,hc:ve.editorForeground},Q.localize(2,null)),$.editorSuggestWidgetSelectedBackground=ve.registerColor("editorSuggestWidget.selectedBackground",{dark:ve.listFocusBackground,light:ve.listFocusBackground,hc:ve.listFocusBackground},Q.localize(3,null)),$.editorSuggestWidgetHighlightForeground=ve.registerColor("editorSuggestWidget.highlightForeground",{dark:ve.listHighlightForeground,light:ve.listHighlightForeground,hc:ve.listHighlightForeground},Q.localize(4,null));var ke=/^(#([\da-f]{3}){1,2}|(rgb|hsl)a\(\s*(\d{1,3}%?\s*,\s*){3}(1|0?\.\d+)\)|(rgb|hsl)\(\s*\d{1,3}%?(\s*,\s*\d{1,3}%?){2}\s*\))$/i,Te=function(){function e(X,$,Q,J,ee,te){this.widget=X,this.editor=$,this.triggerKeybindingLabel=Q,this._modelService=J,this._modeService=ee,this._themeService=te}return Object.defineProperty(e.prototype,"templateId",{get:function(){return"suggestion"},enumerable:!0,configurable:!0}),e.prototype.renderTemplate=function(X){var $=this,J=Object.create(null);J.disposables=[],J.root=X,ae.addClass(J.root,"show-file-icons"),J.icon=ae.append(X,ae.$(".icon")),J.colorspan=ae.append(J.icon,ae.$("span.colorspan"));var ee=ae.append(X,ae.$(".contents")),ne=ae.append(ee,ae.$(".main"));J.iconLabel=new Le.IconLabel(ne,{supportHighlights:!0}),J.disposables.push(J.iconLabel),J.typeLabel=ae.append(ne,ae.$("span.type-label")),J.readMore=ae.append(ne,ae.$("span.readMore")),J.readMore.title=Q.localize(5,null,this.triggerKeybindingLabel);var a=function(){var X=$.editor.getConfiguration(),Q=X.fontInfo.fontFamily,ee=X.contribInfo.suggestFontSize||X.fontInfo.fontSize,te=X.contribInfo.suggestLineHeight||X.fontInfo.lineHeight,ie=X.fontInfo.fontWeight,oe=ee+"px",re=te+"px";J.root.style.fontSize=oe,J.root.style.fontWeight=ie,ne.style.fontFamily=Q,ne.style.lineHeight=re,J.icon.style.height=re,J.icon.style.width=re,J.readMore.style.height=re,J.readMore.style.width=re};return a(),te.chain(this.editor.onDidChangeConfiguration.bind(this.editor)).filter((function(X){return X.fontInfo||X.contribInfo})).on(a,null,J.disposables),J},e.prototype.renderElement=function(X,$,Q){var ee=this,te=Q,ne=X.suggestion;te.icon.className="icon "+Ee.completionKindToCssClass(ne.kind),te.colorspan.style.backgroundColor="";var ie,oe={labelEscapeNewLines:!0,matches:J.createMatches(X.matches)};19===ne.kind&&(ie=P(ne.label)||"string"==typeof ne.documentation&&P(ne.documentation))?(te.icon.className="icon customcolor",te.colorspan.style.backgroundColor=ie):20===ne.kind&&this._themeService.getIconTheme().hasFileIcons?(te.icon.className="icon hide",oe.extraClasses=[].concat(xe.getIconClasses(this._modelService,this._modeService,De.URI.from({scheme:"fake",path:ne.label}),Me.FileKind.FILE),xe.getIconClasses(this._modelService,this._modeService,De.URI.from({scheme:"fake",path:ne.detail}),Me.FileKind.FILE))):23===ne.kind&&this._themeService.getIconTheme().hasFolderIcons?(te.icon.className="icon hide",oe.extraClasses=[].concat(xe.getIconClasses(this._modelService,this._modeService,De.URI.from({scheme:"fake",path:ne.label}),Me.FileKind.FOLDER),xe.getIconClasses(this._modelService,this._modeService,De.URI.from({scheme:"fake",path:ne.detail}),Me.FileKind.FOLDER))):(te.icon.className="icon hide",oe.extraClasses=["suggest-icon "+Ee.completionKindToCssClass(ne.kind)]),te.iconLabel.setValue(ne.label,void 0,oe),te.typeLabel.textContent=(ne.detail||"").replace(/\n.*$/m,""),A(X)?(ae.show(te.readMore),te.readMore.onmousedown=function(X){X.stopPropagation(),X.preventDefault()},te.readMore.onclick=function(X){X.stopPropagation(),X.preventDefault(),ee.widget.toggleDetails()}):(ae.hide(te.readMore),te.readMore.onmousedown=null,te.readMore.onclick=null)},e.prototype.disposeElement=function(){},e.prototype.disposeTemplate=function(X){X.disposables=se.dispose(X.disposables)},ne([oe(3,Ie.IModelService),oe(4,be.IModeService),oe(5,me.IThemeService)],e)}(),Re=function(){function e(X,$,J,ee,ne){var ie=this;this.widget=$,this.editor=J,this.markdownRenderer=ee,this.triggerKeybindingLabel=ne,this.borderWidth=1,this.disposables=[],this.el=ae.append(X,ae.$(".details")),this.disposables.push(se.toDisposable((function(){return X.removeChild(ie.el)}))),this.body=ae.$(".body"),this.scrollbar=new ue.DomScrollableElement(this.body,{}),ae.append(this.el,this.scrollbar.getDomNode()),this.disposables.push(this.scrollbar),this.header=ae.append(this.body,ae.$(".header")),this.close=ae.append(this.header,ae.$("span.close")),this.close.title=Q.localize(6,null,this.triggerKeybindingLabel),this.type=ae.append(this.header,ae.$("p.type")),this.docs=ae.append(this.body,ae.$("p.docs")),this.ariaLabel=null,this.configureFont(),te.chain(this.editor.onDidChangeConfiguration.bind(this.editor)).filter((function(X){return X.fontInfo})).on(this.configureFont,this,this.disposables),ee.onDidRenderCodeBlock((function(){return ie.scrollbar.scanDomNode()}),this,this.disposables)}return Object.defineProperty(e.prototype,"element",{get:function(){return this.el},enumerable:!0,configurable:!0}),e.prototype.render=function(X){var $=this;if(this.renderDisposeable=se.dispose(this.renderDisposeable),!X||!A(X))return this.type.textContent="",this.docs.textContent="",ae.addClass(this.el,"no-docs"),void(this.ariaLabel=null);if(ae.removeClass(this.el,"no-docs"),"string"==typeof X.suggestion.documentation)ae.removeClass(this.docs,"markdown-docs"),this.docs.textContent=X.suggestion.documentation;else{ae.addClass(this.docs,"markdown-docs"),this.docs.innerHTML="";var Q=this.markdownRenderer.render(X.suggestion.documentation);this.renderDisposeable=Q,this.docs.appendChild(Q.element)}X.suggestion.detail?(this.type.innerText=X.suggestion.detail,ae.show(this.type)):(this.type.innerText="",ae.hide(this.type)),this.el.style.height=this.header.offsetHeight+this.docs.offsetHeight+2*this.borderWidth+"px",this.close.onmousedown=function(X){X.preventDefault(),X.stopPropagation()},this.close.onclick=function(X){X.preventDefault(),X.stopPropagation(),$.widget.toggleDetails()},this.body.scrollTop=0,this.scrollbar.scanDomNode(),this.ariaLabel=ee.format("{0}{1}",X.suggestion.detail||"",X.suggestion.documentation?"string"==typeof X.suggestion.documentation?X.suggestion.documentation:X.suggestion.documentation.value:"")},e.prototype.getAriaLabel=function(){return this.ariaLabel},e.prototype.scrollDown=function(X){void 0===X&&(X=8),this.body.scrollTop+=X},e.prototype.scrollUp=function(X){void 0===X&&(X=8),this.body.scrollTop-=X},e.prototype.scrollTop=function(){this.body.scrollTop=0},e.prototype.scrollBottom=function(){this.body.scrollTop=this.body.scrollHeight},e.prototype.pageDown=function(){this.scrollDown(80)},e.prototype.pageUp=function(){this.scrollUp(80)},e.prototype.setBorderWidth=function(X){this.borderWidth=X},e.prototype.configureFont=function(){var X=this.editor.getConfiguration(),$=X.fontInfo.fontFamily,Q=X.contribInfo.suggestFontSize||X.fontInfo.fontSize,J=X.contribInfo.suggestLineHeight||X.fontInfo.lineHeight,ee=X.fontInfo.fontWeight,te=Q+"px",ne=J+"px";this.el.style.fontSize=te,this.el.style.fontWeight=ee,this.type.style.fontFamily=$,this.close.style.height=ne,this.close.style.width=ne},e.prototype.dispose=function(){this.disposables=se.dispose(this.disposables),this.renderDisposeable=se.dispose(this.renderDisposeable)},e}(),Oe=function(){function e(X,Q,J,ee,ne,ie,oe,re,se){var ue=this;this.editor=X,this.telemetryService=Q,this.allowEditorOverflow=!0,this.ignoreFocusEvents=!1,this.editorBlurTimeout=new we.TimeoutTimer,this.showTimeout=new we.TimeoutTimer,this.onDidSelectEmitter=new te.Emitter,this.onDidFocusEmitter=new te.Emitter,this.onDidHideEmitter=new te.Emitter,this.onDidShowEmitter=new te.Emitter,this.onDidSelect=this.onDidSelectEmitter.event,this.onDidFocus=this.onDidFocusEmitter.event,this.onDidHide=this.onDidHideEmitter.event,this.onDidShow=this.onDidShowEmitter.event,this.maxWidgetWidth=660,this.listWidth=330,this.storageServiceAvailable=!0,this.expandSuggestionDocs=!1,this.firstFocusInCurrentList=!1;var de=ie.lookupKeybinding("editor.action.triggerSuggest"),ce=de?" ("+de.getLabel()+")":"",pe=new ye.MarkdownRenderer(X,oe,re);this.isAuto=!1,this.focusedItem=null,this.storageService=ne,this.storageService.store("___suggest___",!0,0),this.storageService.get("___suggest___",0)||(this.storageServiceAvailable=!1),this.storageService.remove("___suggest___",0),this.element=ae.$(".editor-widget.suggest-widget"),this.editor.getConfiguration().contribInfo.iconsInSuggestions||ae.addClass(this.element,"no-icons"),this.messageElement=ae.append(this.element,ae.$(".message")),this.listElement=ae.append(this.element,ae.$(".tree")),this.details=new Re(this.element,this,this.editor,pe,ce);var fe=se.createInstance(Te,this,this.editor,ce);this.list=new le.List(this.listElement,this,[fe],{useShadows:!1,selectOnMouseDown:!0,focusOnMouseDown:!1,openController:{shouldOpen:function(){return!1}}}),this.toDispose=[ge.attachListStyler(this.list,ee,{listInactiveFocusBackground:$.editorSuggestWidgetSelectedBackground,listInactiveFocusOutline:ve.activeContrastBorder}),ee.onThemeChange((function(X){return ue.onThemeChange(X)})),X.onDidLayoutChange((function(){return ue.onEditorLayoutChange()})),this.list.onSelectionChange((function(X){return ue.onListSelection(X)})),this.list.onFocusChange((function(X){return ue.onListFocus(X)})),this.editor.onDidChangeCursorSelection((function(){return ue.onCursorSelectionChanged()}))],this.suggestWidgetVisible=he.Context.Visible.bindTo(J),this.suggestWidgetMultipleSuggestions=he.Context.MultipleSuggestions.bindTo(J),this.editor.addContentWidget(this),this.setState(0),this.onThemeChange(ee.getTheme())}return e.prototype.onCursorSelectionChanged=function(){0!==this.state&&this.editor.layoutContentWidget(this)},e.prototype.onEditorLayoutChange=function(){3!==this.state&&5!==this.state||!this.expandDocsSettingFromStorage()||this.expandSideOrBelow()},e.prototype.onListSelection=function(X){var $=this;if(X.elements.length){var J=X.elements[0],ee=X.indexes[0];J.resolve(Se.CancellationToken.None).then((function(){$.onDidSelectEmitter.fire({item:J,index:ee,model:$.completionModel}),pe.alert(Q.localize(9,null,J.suggestion.label)),$.editor.focus()}))}},e.prototype._getSuggestionAriaAlertLabel=function(X){var $=25===X.suggestion.kind;return A(X)?this.expandDocsSettingFromStorage()?$?Q.localize(12,null,X.suggestion.label,this.details.getAriaLabel()):Q.localize(13,null,X.suggestion.label,this.details.getAriaLabel()):$?Q.localize(14,null,X.suggestion.label):Q.localize(15,null,X.suggestion.label):$?Q.localize(10,null,X.suggestion.label):Q.localize(11,null,X.suggestion.label)},e.prototype._ariaAlert=function(X){this._lastAriaAlertLabel!==X&&(this._lastAriaAlertLabel=X,this._lastAriaAlertLabel&&pe.alert(this._lastAriaAlertLabel))},e.prototype.onThemeChange=function(X){var Q=X.getColor($.editorSuggestWidgetBackground);Q&&(this.listElement.style.backgroundColor=Q.toString(),this.details.element.style.backgroundColor=Q.toString(),this.messageElement.style.backgroundColor=Q.toString());var J=X.getColor($.editorSuggestWidgetBorder);J&&(this.listElement.style.borderColor=J.toString(),this.details.element.style.borderColor=J.toString(),this.messageElement.style.borderColor=J.toString(),this.detailsBorderColor=J.toString());var ee=X.getColor(ve.focusBorder);ee&&(this.detailsFocusBorderColor=ee.toString()),this.details.setBorderWidth("hc"===X.type?2:1)},e.prototype.onListFocus=function(X){var $=this;if(!this.ignoreFocusEvents){if(!X.elements.length)return this.currentSuggestionDetails&&(this.currentSuggestionDetails.cancel(),this.currentSuggestionDetails=null,this.focusedItem=null),void this._ariaAlert(null);var Q=X.elements[0],J=X.indexes[0];this.firstFocusInCurrentList=!this.focusedItem,Q!==this.focusedItem&&(this.currentSuggestionDetails&&(this.currentSuggestionDetails.cancel(),this.currentSuggestionDetails=null),this.focusedItem=Q,this.list.reveal(J),this.currentSuggestionDetails=we.createCancelablePromise((function(X){return Q.resolve(X)})),this.currentSuggestionDetails.then((function(){$.list.length<J||($.ignoreFocusEvents=!0,$.list.splice(J,1,[Q]),$.list.setFocus([J]),$.ignoreFocusEvents=!1,$.expandDocsSettingFromStorage()?$.showDetails():ae.removeClass($.element,"docs-side"),$._ariaAlert($._getSuggestionAriaAlertLabel(Q)))})).catch(re.onUnexpectedError).then((function(){$.focusedItem===Q&&($.currentSuggestionDetails=null)}))),this.onDidFocusEmitter.fire({item:Q,index:J,model:this.completionModel})}},e.prototype.setState=function(X){if(this.element){var $=this.state!==X;switch(this.state=X,ae.toggleClass(this.element,"frozen",4===X),X){case 0:ae.hide(this.messageElement,this.details.element,this.listElement),this.hide(),this.listHeight=0,$&&this.list.splice(0,this.list.length),this.focusedItem=null;break;case 1:this.messageElement.textContent=e.LOADING_MESSAGE,ae.hide(this.listElement,this.details.element),ae.show(this.messageElement),ae.removeClass(this.element,"docs-side"),this.show(),this.focusedItem=null;break;case 2:this.messageElement.textContent=e.NO_SUGGESTIONS_MESSAGE,ae.hide(this.listElement,this.details.element),ae.show(this.messageElement),ae.removeClass(this.element,"docs-side"),this.show(),this.focusedItem=null;break;case 3:case 4:ae.hide(this.messageElement),ae.show(this.listElement),this.show();break;case 5:ae.hide(this.messageElement),ae.show(this.details.element,this.listElement),this.show(),this._ariaAlert(this.details.getAriaLabel())}}},e.prototype.showTriggered=function(X,$){var Q=this;0===this.state&&(this.isAuto=!!X,this.isAuto||(this.loadingTimeout=setTimeout((function(){Q.loadingTimeout=null,Q.setState(1)}),$)))},e.prototype.showSuggestions=function(X,$,Q,J){if(this.loadingTimeout&&(clearTimeout(this.loadingTimeout),this.loadingTimeout=null),this.currentSuggestionDetails&&(this.currentSuggestionDetails.cancel(),this.currentSuggestionDetails=null),this.completionModel!==X&&(this.completionModel=X),Q&&2!==this.state&&0!==this.state)this.setState(4);else{var ee=this.completionModel.items.length,te=0===ee;if(this.suggestWidgetMultipleSuggestions.set(ee>1),te)J?this.setState(0):this.setState(2),this.completionModel=null;else{if(3!==this.state){var ne=this.completionModel.stats;ne.wasAutomaticallyTriggered=!!J,this.telemetryService.publicLog("suggestWidget",ie({},ne,this.editor.getTelemetryData()))}this.focusedItem=null,this.list.splice(0,this.list.length,this.completionModel.items),Q?this.setState(4):this.setState(3),this.list.reveal($,$),this.list.setFocus([$]),this.detailsBorderColor&&(this.details.element.style.borderColor=this.detailsBorderColor)}}},e.prototype.selectNextPage=function(){switch(this.state){case 0:return!1;case 5:return this.details.pageDown(),!0;case 1:return!this.isAuto;default:return this.list.focusNextPage(),!0}},e.prototype.selectNext=function(){switch(this.state){case 0:return!1;case 1:return!this.isAuto;default:return this.list.focusNext(1,!0),!0}},e.prototype.selectLast=function(){switch(this.state){case 0:return!1;case 5:return this.details.scrollBottom(),!0;case 1:return!this.isAuto;default:return this.list.focusLast(),!0}},e.prototype.selectPreviousPage=function(){switch(this.state){case 0:return!1;case 5:return this.details.pageUp(),!0;case 1:return!this.isAuto;default:return this.list.focusPreviousPage(),!0}},e.prototype.selectPrevious=function(){switch(this.state){case 0:return!1;case 1:return!this.isAuto;default:return this.list.focusPrevious(1,!0),!1}},e.prototype.selectFirst=function(){switch(this.state){case 0:return!1;case 5:return this.details.scrollTop(),!0;case 1:return!this.isAuto;default:return this.list.focusFirst(),!0}},e.prototype.getFocusedItem=function(){if(0!==this.state&&2!==this.state&&1!==this.state)return{item:this.list.getFocusedElements()[0],index:this.list.getFocus()[0],model:this.completionModel}},e.prototype.toggleDetailsFocus=function(){5===this.state?(this.setState(3),this.detailsBorderColor&&(this.details.element.style.borderColor=this.detailsBorderColor)):3===this.state&&this.expandDocsSettingFromStorage()&&(this.setState(5),this.detailsFocusBorderColor&&(this.details.element.style.borderColor=this.detailsFocusBorderColor)),this.telemetryService.publicLog("suggestWidget:toggleDetailsFocus",this.editor.getTelemetryData())},e.prototype.toggleDetails=function(){if(A(this.list.getFocusedElements()[0]))if(this.expandDocsSettingFromStorage())this.updateExpandDocsSetting(!1),ae.hide(this.details.element),ae.removeClass(this.element,"docs-side"),ae.removeClass(this.element,"docs-below"),this.editor.layoutContentWidget(this),this.telemetryService.publicLog("suggestWidget:collapseDetails",this.editor.getTelemetryData());else{if(3!==this.state&&5!==this.state&&4!==this.state)return;this.updateExpandDocsSetting(!0),this.showDetails(),this._ariaAlert(this.details.getAriaLabel()),this.telemetryService.publicLog("suggestWidget:expandDetails",this.editor.getTelemetryData())}},e.prototype.showDetails=function(){this.expandSideOrBelow(),ae.show(this.details.element),this.details.render(this.list.getFocusedElements()[0]),this.details.element.style.maxHeight=this.maxWidgetHeight+"px",this.listElement.style.marginTop="0px",this.editor.layoutContentWidget(this),this.adjustDocsPosition(),this.editor.focus()},e.prototype.show=function(){var X=this,$=this.updateListHeight();$!==this.listHeight&&(this.editor.layoutContentWidget(this),this.listHeight=$),this.suggestWidgetVisible.set(!0),this.showTimeout.cancelAndSet((function(){ae.addClass(X.element,"visible"),X.onDidShowEmitter.fire(X)}),100)},e.prototype.hide=function(){this.suggestWidgetVisible.reset(),this.suggestWidgetMultipleSuggestions.reset(),ae.removeClass(this.element,"visible")},e.prototype.hideWidget=function(){clearTimeout(this.loadingTimeout),this.setState(0),this.onDidHideEmitter.fire(this)},e.prototype.getPosition=function(){return 0===this.state?null:{position:this.editor.getPosition(),preference:[2,1]}},e.prototype.getDomNode=function(){return this.element},e.prototype.getId=function(){return e.ID},e.prototype.updateListHeight=function(){var X=0;if(2===this.state||1===this.state)X=this.unfocusedHeight;else{var $=this.list.contentHeight/this.unfocusedHeight;X=Math.min($,12)*this.unfocusedHeight}return this.element.style.lineHeight=this.unfocusedHeight+"px",this.listElement.style.height=X+"px",this.list.layout(X),X},e.prototype.adjustDocsPosition=function(){var X=this.editor.getConfiguration().fontInfo.lineHeight,$=this.editor.getScrolledVisiblePosition(this.editor.getPosition()),Q=ae.getDomNodePagePosition(this.editor.getDomNode()),J=Q.left+$.left,ee=Q.top+$.top+$.height,te=ae.getDomNodePagePosition(this.element),ne=te.left,ie=te.top;ne<J-this.listWidth?ae.addClass(this.element,"list-right"):ae.removeClass(this.element,"list-right"),ae.hasClass(this.element,"docs-side")&&ee-X>ie&&this.details.element.offsetHeight>this.listElement.offsetHeight&&(this.listElement.style.marginTop=this.details.element.offsetHeight-this.listElement.offsetHeight+"px")},e.prototype.expandSideOrBelow=function(){if(!A(this.focusedItem)&&this.firstFocusInCurrentList)return ae.removeClass(this.element,"docs-side"),void ae.removeClass(this.element,"docs-below");var X=this.element.style.maxWidth.match(/(\d+)px/);!X||Number(X[1])<this.maxWidgetWidth?(ae.addClass(this.element,"docs-below"),ae.removeClass(this.element,"docs-side")):A(this.focusedItem)&&(ae.addClass(this.element,"docs-side"),ae.removeClass(this.element,"docs-below"))},Object.defineProperty(e.prototype,"maxWidgetHeight",{get:function(){return 12*this.unfocusedHeight},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"unfocusedHeight",{get:function(){var X=this.editor.getConfiguration();return X.contribInfo.suggestLineHeight||X.fontInfo.lineHeight},enumerable:!0,configurable:!0}),e.prototype.getHeight=function(X){return this.unfocusedHeight},e.prototype.getTemplateId=function(X){return"suggestion"},e.prototype.expandDocsSettingFromStorage=function(){return this.storageServiceAvailable?this.storageService.getBoolean("expandSuggestionDocs",0,!1):this.expandSuggestionDocs},e.prototype.updateExpandDocsSetting=function(X){this.storageServiceAvailable?this.storageService.store("expandSuggestionDocs",X,0):this.expandSuggestionDocs=X},e.prototype.dispose=function(){this.state=null,this.currentSuggestionDetails=null,this.focusedItem=null,this.element=null,this.messageElement=null,this.listElement=null,this.details.dispose(),this.details=null,this.list.dispose(),this.list=null,this.toDispose=se.dispose(this.toDispose),this.loadingTimeout&&(clearTimeout(this.loadingTimeout),this.loadingTimeout=null),this.editorBlurTimeout.dispose(),this.showTimeout.dispose()},e.ID="editor.widget.suggestWidget",e.LOADING_MESSAGE=Q.localize(7,null),e.NO_SUGGESTIONS_MESSAGE=Q.localize(8,null),e=ne([oe(1,fe.ITelemetryService),oe(2,ce.IContextKeyService),oe(3,me.IThemeService),oe(4,_e.IStorageService),oe(5,de.IKeybindingService),oe(6,be.IModeService),oe(7,Ce.IOpenerService),oe(8,Ne.IInstantiationService)],e)}();$.SuggestWidget=Oe,me.registerThemingParticipant((function(X,Q){var J=X.getColor($.editorSuggestWidgetHighlightForeground);J&&Q.addRule(".monaco-editor .suggest-widget .monaco-list .monaco-list-row .monaco-highlighted-label .highlight { color: "+J+"; }");var ee=X.getColor($.editorSuggestWidgetForeground);ee&&Q.addRule(".monaco-editor .suggest-widget { color: "+ee+"; }");var te=X.getColor(ve.textLinkForeground);te&&Q.addRule(".monaco-editor .suggest-widget a { color: "+te+"; }");var ne=X.getColor(ve.textCodeBlockBackground);ne&&Q.addRule(".monaco-editor .suggest-widget code { background-color: "+ne+"; }")}))})),define(Q[535],n([0,1,43,22,11,2,10,49,3,54,19,143,111,442,338,31,18,15,85,405,533,534,406,6,64,16]),(function(X,$,Q,J,ee,ie,re,se,ae,le,ue,de,ce,he,pe,fe,ge,me,ve,_e,ye,be,Ce,we,Se,Ee){Object.defineProperty($,"__esModule",{value:!0});var Le=function(){function e(X,$,Q){var J=this;this._disposables=[],this._activeAcceptCharacters=new Set,this._disposables.push($.onDidShow((function(){return J._onItem($.getFocusedItem())}))),this._disposables.push($.onDidFocus(this._onItem,this)),this._disposables.push($.onDidHide(this.reset,this)),this._disposables.push(X.onWillType((function($){if(J._activeItem){var ee=$[$.length-1];J._activeAcceptCharacters.has(ee)&&X.getConfiguration().contribInfo.acceptSuggestionOnCommitCharacter&&Q(J._activeItem)}})))}return e.prototype._onItem=function(X){if(X&&!J.isFalsyOrEmpty(X.item.suggestion.commitCharacters)){this._activeItem=X,this._activeAcceptCharacters.clear();for(var $=0,Q=X.item.suggestion.commitCharacters;$<Q.length;$++){var ee=Q[$];ee.length>0&&this._activeAcceptCharacters.add(ee[0])}}else this.reset()},e.prototype.reset=function(){this._activeItem=void 0},e.prototype.dispose=function(){ie.dispose(this._disposables)},e}(),xe=function(){function e(X,$,Q,J,ee){var te=this;this._editor=X,this._commandService=Q,this._contextKeyService=J,this._instantiationService=ee,this._toDispose=[],this._sticky=!1,this._model=new ye.SuggestModel(this._editor,$),this._memory=new Ee.IdleValue((function(){var X=ee.createInstance(he.SuggestMemories,te._editor);return te._toDispose.push(X),X})),this._alternatives=new Ee.IdleValue((function(){var X=new _e.SuggestAlternatives(te._editor,te._contextKeyService);return te._toDispose.push(X),X})),this._toDispose.push(ee.createInstance(Ce.WordContextKey,X)),this._toDispose.push(this._model.onDidTrigger((function(X){te._widget||te._createSuggestWidget(),te._widget.showTriggered(X.auto,X.shy?250:50)}))),this._toDispose.push(this._model.onDidSuggest((function(X){if(!X.shy){var $=te._memory.getValue().select(te._editor.getModel(),te._editor.getPosition(),X.completionModel.items);te._widget.showSuggestions(X.completionModel,$,X.isFrozen,X.auto)}}))),this._toDispose.push(this._model.onDidCancel((function(X){te._widget&&!X.retrigger&&te._widget.hideWidget()}))),this._toDispose.push(this._editor.onDidBlurEditorText((function(){te._sticky||te._model.cancel()})));var ne=ve.Context.AcceptSuggestionsOnEnter.bindTo(J),a=function(){var X=te._editor.getConfiguration().contribInfo.acceptSuggestionOnEnter;ne.set("on"===X||"smart"===X)};this._toDispose.push(this._editor.onDidChangeConfiguration((function(X){return a()}))),a()}return e.get=function(X){return X.getContribution(e.ID)},e.prototype._createSuggestWidget=function(){var X=this;this._widget=this._instantiationService.createInstance(be.SuggestWidget,this._editor),this._toDispose.push(this._widget.onDidSelect((function($){return X._onDidSelectItem($,!1,!0)}),this));var $=new Le(this._editor,this._widget,(function($){return X._onDidSelectItem($,!1,!0)}));this._toDispose.push($,this._model.onDidSuggest((function(X){0===X.completionModel.items.length&&$.reset()})));var Q=ve.Context.MakesTextEdit.bindTo(this._contextKeyService);this._toDispose.push(this._widget.onDidFocus((function($){var J=$.item,ee=X._editor.getPosition(),te=J.suggestion.range.startColumn,ne=ee.column,ie=!0;"smart"!==X._editor.getConfiguration().contribInfo.acceptSuggestionOnEnter||2!==X._model.state||J.suggestion.command||J.suggestion.additionalTextEdits||4&J.suggestion.insertTextRules||ne-te!==J.suggestion.insertText.length||(ie=X._editor.getModel().getValueInRange({startLineNumber:ee.lineNumber,startColumn:te,endLineNumber:ee.lineNumber,endColumn:ne})!==J.suggestion.insertText),Q.set(ie)}))),this._toDispose.push({dispose:function(){Q.reset()}})},e.prototype.getId=function(){return e.ID},e.prototype.dispose=function(){this._toDispose=ie.dispose(this._toDispose),this._widget&&(this._widget.dispose(),this._widget=null),this._model&&(this._model.dispose(),this._model=null)},e.prototype._onDidSelectItem=function(X,$,Q){var J,te=this;if(!X||!X.item)return this._alternatives.getValue().reset(),void this._model.cancel();var ne=this._editor.getModel(),ie=ne.getAlternativeVersionId(),oe=X.item,re=oe.suggestion,le=oe.position,ue=this._editor.getPosition().column-le.column;Q&&this._editor.pushUndoStop(),Array.isArray(re.additionalTextEdits)&&this._editor.executeEdits("suggestController.additionalTextEdits",re.additionalTextEdits.map((function(X){return se.EditOperation.replace(ae.Range.lift(X.range),X.text)}))),this._memory.getValue().memorize(ne,this._editor.getPosition(),X.item);var he=re.insertText;4&re.insertTextRules||(he=ce.SnippetParser.escape(he));var pe=le.column-re.range.startColumn,fe=re.range.endColumn-le.column;de.SnippetController2.get(this._editor).insert(he,pe+ue,fe,!1,!1,!(1&re.insertTextRules)),Q&&this._editor.pushUndoStop(),re.command?re.command.id===Ie.id?this._model.trigger({auto:!0},!0):((J=this._commandService).executeCommand.apply(J,[re.command.id].concat(re.command.arguments)).then(void 0,ee.onUnexpectedError),this._model.cancel()):this._model.cancel(),$&&this._alternatives.getValue().set(X,(function(X){for(;ne.canUndo();){ie!==ne.getAlternativeVersionId()&&ne.undo(),te._onDidSelectItem(X,!1,!1);break}})),this._alertCompletionItem(X.item)},e.prototype._alertCompletionItem=function(X){var $=X.suggestion,J=pe.localize(0,null,$.label,$.insertText);Q.alert(J)},e.prototype.triggerSuggest=function(X){this._model.trigger({auto:!1},!1,X),this._editor.revealLine(this._editor.getPosition().lineNumber,0),this._editor.focus()},e.prototype.triggerSuggestAndAcceptBest=function(X){var $=this,Q=this._editor.getPosition(),i=function(){Q.equals($._editor.getPosition())&&$._editor.trigger("suggest",le.Handler.Type,{text:X})};we.once(this._model.onDidTrigger)((function(X){var Q=[];we.anyEvent($._model.onDidTrigger,$._model.onDidCancel)((function(){ie.dispose(Q),i()}),void 0,Q),$._model.onDidSuggest((function(X){var J=X.completionModel;if(ie.dispose(Q),0!==J.items.length){var ee=$._memory.getValue().select($._editor.getModel(),$._editor.getPosition(),J.items),te=J.items[ee];!function(X){if(4&X.suggestion.insertTextRules||X.suggestion.additionalTextEdits)return!0;var Q=$._editor.getPosition(),J=X.suggestion.range.startColumn,ee=Q.column;return ee-J!==X.suggestion.insertText.length||$._editor.getModel().getValueInRange({startLineNumber:Q.lineNumber,startColumn:J,endLineNumber:Q.lineNumber,endColumn:ee})!==X.suggestion.insertText}(te)?i():($._editor.pushUndoStop(),$._onDidSelectItem({index:ee,item:te,model:J},!0,!1))}else i()}),void 0,Q)})),this._model.trigger({auto:!1,shy:!0}),this._editor.revealLine(Q.lineNumber,0),this._editor.focus()},e.prototype.acceptSelectedSuggestion=function(X){if(this._widget){var $=this._widget.getFocusedItem();this._onDidSelectItem($,X,!0)}},e.prototype.acceptNextSuggestion=function(){this._alternatives.getValue().next()},e.prototype.acceptPrevSuggestion=function(){this._alternatives.getValue().prev()},e.prototype.cancelSuggestWidget=function(){this._widget&&(this._model.cancel(),this._widget.hideWidget())},e.prototype.selectNextSuggestion=function(){this._widget&&this._widget.selectNext()},e.prototype.selectNextPageSuggestion=function(){this._widget&&this._widget.selectNextPage()},e.prototype.selectLastSuggestion=function(){this._widget&&this._widget.selectLast()},e.prototype.selectPrevSuggestion=function(){this._widget&&this._widget.selectPrevious()},e.prototype.selectPrevPageSuggestion=function(){this._widget&&this._widget.selectPreviousPage()},e.prototype.selectFirstSuggestion=function(){this._widget&&this._widget.selectFirst()},e.prototype.toggleSuggestionDetails=function(){this._widget&&this._widget.toggleDetails()},e.prototype.toggleSuggestionFocus=function(){this._widget&&this._widget.toggleDetailsFocus()},e.ID="editor.contrib.suggestController",e=ne([oe(1,Se.IEditorWorkerService),oe(2,fe.ICommandService),oe(3,ge.IContextKeyService),oe(4,me.IInstantiationService)],e)}();$.SuggestController=xe;var Ie=function(X){function t(){return X.call(this,{id:t.id,label:pe.localize(1,null),alias:"Trigger Suggest",precondition:ge.ContextKeyExpr.and(ue.EditorContextKeys.writable,ue.EditorContextKeys.hasCompletionItemProvider),kbOpts:{kbExpr:ue.EditorContextKeys.textInputFocus,primary:2058,mac:{primary:266},weight:100}})||this}return te(t,X),t.prototype.run=function(X,$){var Q=xe.get($);Q&&Q.triggerSuggest()},t.id="editor.action.triggerSuggest",t}(re.EditorAction);$.TriggerSuggestAction=Ie,re.registerEditorContribution(xe),re.registerEditorAction(Ie);var De=re.EditorCommand.bindToContribution(xe.get);re.registerEditorCommand(new De({id:"acceptSelectedSuggestion",precondition:ve.Context.Visible,handler:function(X){return X.acceptSelectedSuggestion(!0)},kbOpts:{weight:190,kbExpr:ue.EditorContextKeys.textInputFocus,primary:2}})),re.registerEditorCommand(new De({id:"acceptSelectedSuggestionOnEnter",precondition:ve.Context.Visible,handler:function(X){return X.acceptSelectedSuggestion(!1)},kbOpts:{weight:190,kbExpr:ge.ContextKeyExpr.and(ue.EditorContextKeys.textInputFocus,ve.Context.AcceptSuggestionsOnEnter,ve.Context.MakesTextEdit),primary:3}})),re.registerEditorCommand(new De({id:"hideSuggestWidget",precondition:ve.Context.Visible,handler:function(X){return X.cancelSuggestWidget()},kbOpts:{weight:190,kbExpr:ue.EditorContextKeys.textInputFocus,primary:9,secondary:[1033]}})),re.registerEditorCommand(new De({id:"selectNextSuggestion",precondition:ge.ContextKeyExpr.and(ve.Context.Visible,ve.Context.MultipleSuggestions),handler:function(X){return X.selectNextSuggestion()},kbOpts:{weight:190,kbExpr:ue.EditorContextKeys.textInputFocus,primary:18,secondary:[2066],mac:{primary:18,secondary:[2066,300]}}})),re.registerEditorCommand(new De({id:"selectNextPageSuggestion",precondition:ge.ContextKeyExpr.and(ve.Context.Visible,ve.Context.MultipleSuggestions),handler:function(X){return X.selectNextPageSuggestion()},kbOpts:{weight:190,kbExpr:ue.EditorContextKeys.textInputFocus,primary:12,secondary:[2060]}})),re.registerEditorCommand(new De({id:"selectLastSuggestion",precondition:ge.ContextKeyExpr.and(ve.Context.Visible,ve.Context.MultipleSuggestions),handler:function(X){return X.selectLastSuggestion()}})),re.registerEditorCommand(new De({id:"selectPrevSuggestion",precondition:ge.ContextKeyExpr.and(ve.Context.Visible,ve.Context.MultipleSuggestions),handler:function(X){return X.selectPrevSuggestion()},kbOpts:{weight:190,kbExpr:ue.EditorContextKeys.textInputFocus,primary:16,secondary:[2064],mac:{primary:16,secondary:[2064,302]}}})),re.registerEditorCommand(new De({id:"selectPrevPageSuggestion",precondition:ge.ContextKeyExpr.and(ve.Context.Visible,ve.Context.MultipleSuggestions),handler:function(X){return X.selectPrevPageSuggestion()},kbOpts:{weight:190,kbExpr:ue.EditorContextKeys.textInputFocus,primary:11,secondary:[2059]}})),re.registerEditorCommand(new De({id:"selectFirstSuggestion",precondition:ge.ContextKeyExpr.and(ve.Context.Visible,ve.Context.MultipleSuggestions),handler:function(X){return X.selectFirstSuggestion()}})),re.registerEditorCommand(new De({id:"toggleSuggestionDetails",precondition:ve.Context.Visible,handler:function(X){return X.toggleSuggestionDetails()},kbOpts:{weight:190,kbExpr:ue.EditorContextKeys.textInputFocus,primary:2058,mac:{primary:266}}})),re.registerEditorCommand(new De({id:"toggleSuggestionFocus",precondition:ve.Context.Visible,handler:function(X){return X.toggleSuggestionFocus()},kbOpts:{weight:190,kbExpr:ue.EditorContextKeys.textInputFocus,primary:2570,mac:{primary:778}}})),re.registerEditorCommand(new De({id:"insertBestCompletion",precondition:ge.ContextKeyExpr.and(ge.ContextKeyExpr.equals("config.editor.tabCompletion","on"),Ce.WordContextKey.AtEnd,ve.Context.Visible.toNegated(),_e.SuggestAlternatives.OtherSuggestions.toNegated(),de.SnippetController2.InSnippetMode.toNegated()),handler:function(X){return X.triggerSuggestAndAcceptBest("\t")},kbOpts:{weight:190,primary:2}})),re.registerEditorCommand(new De({id:"insertNextSuggestion",precondition:ge.ContextKeyExpr.and(ge.ContextKeyExpr.equals("config.editor.tabCompletion","on"),_e.SuggestAlternatives.OtherSuggestions,ve.Context.Visible.toNegated(),de.SnippetController2.InSnippetMode.toNegated()),handler:function(X){return X.acceptNextSuggestion()},kbOpts:{weight:190,kbExpr:ue.EditorContextKeys.textInputFocus,primary:2}})),re.registerEditorCommand(new De({id:"insertPrevSuggestion",precondition:ge.ContextKeyExpr.and(ge.ContextKeyExpr.equals("config.editor.tabCompletion","on"),_e.SuggestAlternatives.OtherSuggestions,ve.Context.Visible.toNegated(),de.SnippetController2.InSnippetMode.toNegated()),handler:function(X){return X.acceptPrevSuggestion()},kbOpts:{weight:190,kbExpr:ue.EditorContextKeys.textInputFocus,primary:1026}}))})),define(Q[536],n([0,1,341,22,16,24,11,2,10,3,19,44,26,14,18,20,13]),(function(X,$,Q,J,ee,ie,re,se,ae,le,ue,de,ce,he,pe,fe,ge){function C(X,$,Q){var te=he.DocumentHighlightProviderRegistry.ordered(X);return ee.first(te.map((function(J){return function(){return Promise.resolve(J.provideDocumentHighlights(X,$,Q)).then(void 0,re.onUnexpectedExternalError)}})),(function(X){return!J.isFalsyOrEmpty(X)}))}Object.defineProperty($,"__esModule",{value:!0}),$.editorWordHighlight=fe.registerColor("editor.wordHighlightBackground",{dark:"#575757B8",light:"#57575740",hc:null},Q.localize(0,null),!0),$.editorWordHighlightStrong=fe.registerColor("editor.wordHighlightStrongBackground",{dark:"#004972B8",light:"#0e639c40",hc:null},Q.localize(1,null),!0),$.editorWordHighlightBorder=fe.registerColor("editor.wordHighlightBorder",{light:null,dark:null,hc:fe.activeContrastBorder},Q.localize(2,null)),$.editorWordHighlightStrongBorder=fe.registerColor("editor.wordHighlightStrongBorder",{light:null,dark:null,hc:fe.activeContrastBorder},Q.localize(3,null)),$.overviewRulerWordHighlightForeground=fe.registerColor("editorOverviewRuler.wordHighlightForeground",{dark:"#A0A0A0CC",light:"#A0A0A0CC",hc:"#A0A0A0CC"},Q.localize(4,null),!0),$.overviewRulerWordHighlightStrongForeground=fe.registerColor("editorOverviewRuler.wordHighlightStrongForeground",{dark:"#C0A0C0CC",light:"#C0A0C0CC",hc:"#C0A0C0CC"},Q.localize(5,null),!0),$.ctxHasWordHighlights=new pe.RawContextKey("hasWordHighlights",!1),$.getOccurrencesAtPosition=C;var me=function(){function e(X,$,Q){var J=this;this._wordRange=this._getCurrentWordRange(X,$),this.result=ee.createCancelablePromise((function(ee){return J._compute(X,$,Q,ee)}))}return e.prototype._getCurrentWordRange=function(X,$){var Q=X.getWordAtPosition($.getPosition());return Q?new le.Range($.startLineNumber,Q.startColumn,$.startLineNumber,Q.endColumn):null},e.prototype.isValid=function(X,$,Q){for(var J=$.startLineNumber,ee=$.startColumn,te=$.endColumn,ne=this._getCurrentWordRange(X,$),ie=Boolean(this._wordRange&&this._wordRange.equalsRange(ne)),oe=0,re=Q.length;!ie&&oe<re;oe++){var se=X.getDecorationRange(Q[oe]);se&&se.startLineNumber===J&&se.startColumn<=ee&&se.endColumn>=te&&(ie=!0)}return ie},e.prototype.cancel=function(){this.result.cancel()},e}(),ve=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype._compute=function(X,$,Q,J){return C(X,$.getPosition(),J)},t}(me),_e=function(X){function t($,Q,J){var ee=X.call(this,$,Q,J)||this;return ee._selectionIsEmpty=Q.isEmpty(),ee}return te(t,X),t.prototype._compute=function(X,$,Q,J){return ee.timeout(250,J).then((function(){if(!$.isEmpty())return[];var J=X.getWordAtPosition($.getPosition());return J?X.findMatches(J.word,!0,!1,!0,Q,!1).map((function(X){return{range:X.range,kind:he.DocumentHighlightKind.Text}})):[]}))},t.prototype.isValid=function($,Q,J){var ee=Q.isEmpty();return this._selectionIsEmpty===ee&&X.prototype.isValid.call(this,$,Q,J)},t}(me);ae.registerDefaultLanguageCommand("_executeDocumentHighlights",(function(X,$){return C(X,$,ie.CancellationToken.None)}));var ye=function(){function e(X,Q){var J=this;this.workerRequestTokenId=0,this.workerRequestCompleted=!1,this.workerRequestValue=[],this.lastCursorPositionChangeTime=0,this.renderDecorationsTimer=-1,this.editor=X,this._hasWordHighlights=$.ctxHasWordHighlights.bindTo(Q),this._ignorePositionChangeEvent=!1,this.occurrencesHighlight=this.editor.getConfiguration().contribInfo.occurrencesHighlight,this.model=this.editor.getModel(),this.toUnhook=[],this.toUnhook.push(X.onDidChangeCursorPosition((function(X){J._ignorePositionChangeEvent||J.occurrencesHighlight&&J._onPositionChanged(X)}))),this.toUnhook.push(X.onDidChangeModelContent((function(X){J._stopAll()}))),this.toUnhook.push(X.onDidChangeConfiguration((function(X){var $=J.editor.getConfiguration().contribInfo.occurrencesHighlight;J.occurrencesHighlight!==$&&(J.occurrencesHighlight=$,J._stopAll())}))),this._decorationIds=[],this.workerRequestTokenId=0,this.workerRequest=null,this.workerRequestCompleted=!1,this.lastCursorPositionChangeTime=0,this.renderDecorationsTimer=-1}return e.prototype.hasDecorations=function(){return this._decorationIds.length>0},e.prototype.restore=function(){this.occurrencesHighlight&&this._run()},e.prototype._getSortedHighlights=function(){var X=this;return J.coalesce(this._decorationIds.map((function($){return X.model.getDecorationRange($)})).sort(le.Range.compareRangesUsingStarts))},e.prototype.moveNext=function(){var X=this,$=this._getSortedHighlights(),Q=$[(J.firstIndex($,(function($){return $.containsPosition(X.editor.getPosition())}))+1)%$.length];try{this._ignorePositionChangeEvent=!0,this.editor.setPosition(Q.getStartPosition()),this.editor.revealRangeInCenterIfOutsideViewport(Q)}finally{this._ignorePositionChangeEvent=!1}},e.prototype.moveBack=function(){var X=this,$=this._getSortedHighlights(),Q=$[(J.firstIndex($,(function($){return $.containsPosition(X.editor.getPosition())}))-1+$.length)%$.length];try{this._ignorePositionChangeEvent=!0,this.editor.setPosition(Q.getStartPosition()),this.editor.revealRangeInCenterIfOutsideViewport(Q)}finally{this._ignorePositionChangeEvent=!1}},e.prototype._removeDecorations=function(){this._decorationIds.length>0&&(this._decorationIds=this.editor.deltaDecorations(this._decorationIds,[]),this._hasWordHighlights.set(!1))},e.prototype._stopAll=function(){this._removeDecorations(),-1!==this.renderDecorationsTimer&&(clearTimeout(this.renderDecorationsTimer),this.renderDecorationsTimer=-1),null!==this.workerRequest&&(this.workerRequest.cancel(),this.workerRequest=null),this.workerRequestCompleted||(this.workerRequestTokenId++,this.workerRequestCompleted=!0)},e.prototype._onPositionChanged=function(X){this.occurrencesHighlight&&3===X.reason?this._run():this._stopAll()},e.prototype._run=function(){var X=this,$=this.editor.getSelection();if($.startLineNumber===$.endLineNumber){var Q=$.startLineNumber,J=$.startColumn,ee=$.endColumn,te=this.model.getWordAtPosition({lineNumber:Q,column:J});if(!te||te.startColumn>J||te.endColumn<ee)this._stopAll();else{var ne=this.workerRequest&&this.workerRequest.isValid(this.model,$,this._decorationIds);if(this.lastCursorPositionChangeTime=(new Date).getTime(),ne)this.workerRequestCompleted&&-1!==this.renderDecorationsTimer&&(clearTimeout(this.renderDecorationsTimer),this.renderDecorationsTimer=-1,this._beginRenderDecorations());else{this._stopAll();var ie=++this.workerRequestTokenId;this.workerRequestCompleted=!1,this.workerRequest=function(X,$,Q){return he.DocumentHighlightProviderRegistry.has(X)?new ve(X,$,Q):new _e(X,$,Q)}(this.model,this.editor.getSelection(),this.editor.getConfiguration().wordSeparators),this.workerRequest.result.then((function($){ie===X.workerRequestTokenId&&(X.workerRequestCompleted=!0,X.workerRequestValue=$||[],X._beginRenderDecorations())}),re.onUnexpectedError)}}}else this._stopAll()},e.prototype._beginRenderDecorations=function(){var X=this,$=(new Date).getTime(),Q=this.lastCursorPositionChangeTime+250;$>=Q?(this.renderDecorationsTimer=-1,this.renderDecorations()):this.renderDecorationsTimer=setTimeout((function(){X.renderDecorations()}),Q-$)},e.prototype.renderDecorations=function(){this.renderDecorationsTimer=-1;for(var X=[],$=0,Q=this.workerRequestValue.length;$<Q;$++){var J=this.workerRequestValue[$];X.push({range:J.range,options:e._getDecorationOptions(J.kind)})}this._decorationIds=this.editor.deltaDecorations(this._decorationIds,X),this._hasWordHighlights.set(this.hasDecorations())},e._getDecorationOptions=function(X){return X===he.DocumentHighlightKind.Write?this._WRITE_OPTIONS:X===he.DocumentHighlightKind.Text?this._TEXT_OPTIONS:this._REGULAR_OPTIONS},e.prototype.dispose=function(){this._stopAll(),this.toUnhook=se.dispose(this.toUnhook)},e._WRITE_OPTIONS=ce.ModelDecorationOptions.register({stickiness:1,className:"wordHighlightStrong",overviewRuler:{color:ge.themeColorFromId($.overviewRulerWordHighlightStrongForeground),position:de.OverviewRulerLane.Center}}),e._TEXT_OPTIONS=ce.ModelDecorationOptions.register({stickiness:1,className:"selectionHighlight",overviewRuler:{color:ge.themeColorFromId(fe.overviewRulerSelectionHighlightForeground),position:de.OverviewRulerLane.Center}}),e._REGULAR_OPTIONS=ce.ModelDecorationOptions.register({stickiness:1,className:"wordHighlight",overviewRuler:{color:ge.themeColorFromId($.overviewRulerWordHighlightForeground),position:de.OverviewRulerLane.Center}}),e}(),be=function(X){function t($,Q){var J=X.call(this)||this,o=function(){$.hasModel()&&(J.wordHighligher=new ye($,Q))};return J._register($.onDidChangeModel((function(X){J.wordHighligher&&(J.wordHighligher.dispose(),J.wordHighligher=null),o()}))),o(),J}return te(t,X),t.get=function(X){return X.getContribution(t.ID)},t.prototype.getId=function(){return t.ID},t.prototype.saveViewState=function(){return!(!this.wordHighligher||!this.wordHighligher.hasDecorations())},t.prototype.moveNext=function(){this.wordHighligher&&this.wordHighligher.moveNext()},t.prototype.moveBack=function(){this.wordHighligher&&this.wordHighligher.moveBack()},t.prototype.restoreViewState=function(X){this.wordHighligher&&X&&this.wordHighligher.restore()},t.prototype.dispose=function(){this.wordHighligher&&(this.wordHighligher.dispose(),this.wordHighligher=null),X.prototype.dispose.call(this)},t.ID="editor.contrib.wordHighlighter",t=ne([oe(1,pe.IContextKeyService)],t)}(se.Disposable),Ce=function(X){function t($,Q){var J=X.call(this,Q)||this;return J._isNext=$,J}return te(t,X),t.prototype.run=function(X,$){var Q=be.get($);Q&&(this._isNext?Q.moveNext():Q.moveBack())},t}(ae.EditorAction),we=function(X){function i(){return X.call(this,!0,{id:"editor.action.wordHighlight.next",label:Q.localize(6,null),alias:"Go to Next Symbol Highlight",precondition:$.ctxHasWordHighlights,kbOpts:{kbExpr:ue.EditorContextKeys.editorTextFocus,primary:65,weight:100}})||this}return te(i,X),i}(Ce),Se=function(X){function i(){return X.call(this,!1,{id:"editor.action.wordHighlight.prev",label:Q.localize(7,null),alias:"Go to Previous Symbol Highlight",precondition:$.ctxHasWordHighlights,kbOpts:{kbExpr:ue.EditorContextKeys.editorTextFocus,primary:1089,weight:100}})||this}return te(i,X),i}(Ce),Ee=function(X){function i(){return X.call(this,{id:"editor.action.wordHighlight.trigger",label:Q.localize(8,null),alias:"Trigger Symbol Highlight",precondition:$.ctxHasWordHighlights.toNegated(),kbOpts:{kbExpr:ue.EditorContextKeys.editorTextFocus,primary:0,weight:100}})||this}return te(i,X),i.prototype.run=function(X,$,Q){var J=be.get($);J&&J.restoreViewState(!0)},i}(ae.EditorAction);ae.registerEditorContribution(be),ae.registerEditorAction(we),ae.registerEditorAction(Se),ae.registerEditorAction(Ee),ge.registerThemingParticipant((function(X,Q){var J=X.getColor(fe.editorSelectionHighlight);J&&(Q.addRule(".monaco-editor .focused .selectionHighlight { background-color: "+J+"; }"),Q.addRule(".monaco-editor .selectionHighlight { background-color: "+J.transparent(.5)+"; }"));var ee=X.getColor($.editorWordHighlight);ee&&Q.addRule(".monaco-editor .wordHighlight { background-color: "+ee+"; }");var te=X.getColor($.editorWordHighlightStrong);te&&Q.addRule(".monaco-editor .wordHighlightStrong { background-color: "+te+"; }");var ne=X.getColor(fe.editorSelectionHighlightBorder);ne&&Q.addRule(".monaco-editor .selectionHighlight { border: 1px "+("hc"===X.type?"dotted":"solid")+" "+ne+"; box-sizing: border-box; }");var ie=X.getColor($.editorWordHighlightBorder);ie&&Q.addRule(".monaco-editor .wordHighlight { border: 1px "+("hc"===X.type?"dashed":"solid")+" "+ie+"; box-sizing: border-box; }");var oe=X.getColor($.editorWordHighlightStrongBorder);oe&&Q.addRule(".monaco-editor .wordHighlightStrong { border: 1px "+("hc"===X.type?"dashed":"solid")+" "+oe+"; box-sizing: border-box; }")}))})),define(Q[537],n([0,1,342,29,7,23,133,43,46,2,17,8,25,10,19,179,18,15,47,62,20,13,386]),(function(X,$,Q,J,ee,ie,re,se,ae,le,ue,de,ce,he,pe,fe,ge,me,ve,_e,ye,be){Object.defineProperty($,"__esModule",{value:!0});var Ce=new ge.RawContextKey("accessibilityHelpWidgetVisible",!1),we=function(X){function t($,Q){var J=X.call(this)||this;return J._editor=$,J._widget=J._register(Q.createInstance(De,J._editor)),J}return te(t,X),t.get=function(X){return X.getContribution(t.ID)},t.prototype.getId=function(){return t.ID},t.prototype.show=function(){this._widget.show()},t.prototype.hide=function(){this._widget.hide()},t.ID="editor.contrib.accessibilityHelpController",t=ne([oe(1,me.IInstantiationService)],t)}(le.Disposable),Se=Q.localize(0,null),Ee=Q.localize(1,null),Le=Q.localize(2,null),xe=Q.localize(3,null),Ie=Q.localize(4,null),De=function(X){function t($,J,te,ne){var oe=X.call(this)||this;return oe._contextKeyService=J,oe._keybindingService=te,oe._openerService=ne,oe._editor=$,oe._isVisibleKey=Ce.bindTo(oe._contextKeyService),oe._domNode=ie.createFastDomNode(document.createElement("div")),oe._domNode.setClassName("accessibilityHelpWidget"),oe._domNode.setDisplay("none"),oe._domNode.setAttribute("role","dialog"),oe._domNode.setAttribute("aria-hidden","true"),oe._contentDomNode=ie.createFastDomNode(document.createElement("div")),oe._contentDomNode.setAttribute("role","document"),oe._domNode.appendChild(oe._contentDomNode),oe._isVisible=!1,oe._register(oe._editor.onDidLayoutChange((function(){oe._isVisible&&oe._layout()}))),oe._register(ee.addStandardDisposableListener(oe._contentDomNode.domNode,"keydown",(function(X){if(oe._isVisible&&(X.equals(2083)&&(se.alert(Q.localize(5,null)),oe._editor.updateOptions({accessibilitySupport:"on"}),ee.clearNode(oe._contentDomNode.domNode),oe._buildContent(),oe._contentDomNode.domNode.focus(),X.preventDefault(),X.stopPropagation()),X.equals(2086))){se.alert(Q.localize(6,null));var $=oe._editor.getRawConfiguration().accessibilityHelpUrl;void 0===$&&($="https://go.microsoft.com/fwlink/?linkid=852450"),oe._openerService.open(ce.URI.parse($)),X.preventDefault(),X.stopPropagation()}}))),oe.onblur(oe._contentDomNode.domNode,(function(){oe.hide()})),oe._editor.addOverlayWidget(oe),oe}return te(t,X),t.prototype.dispose=function(){this._editor.removeOverlayWidget(this),X.prototype.dispose.call(this)},t.prototype.getId=function(){return t.ID},t.prototype.getDomNode=function(){return this._domNode.domNode},t.prototype.getPosition=function(){return{preference:null}},t.prototype.show=function(){this._isVisible||(this._isVisible=!0,this._isVisibleKey.set(!0),this._layout(),this._domNode.setDisplay("block"),this._domNode.setAttribute("aria-hidden","false"),this._contentDomNode.domNode.tabIndex=0,this._buildContent(),this._contentDomNode.domNode.focus())},t.prototype._descriptionForCommand=function(X,$,Q){var J=this._keybindingService.lookupKeybinding(X);return J?de.format($,J.getAriaLabel()):de.format(Q,X)},t.prototype._buildContent=function(){var X=this._editor.getConfiguration(),$=this._editor.getSelections(),J=0;if($){var ee=this._editor.getModel();ee&&$.forEach((function(X){J+=ee.getValueLengthInRange(X)}))}var te=function(X,$){return X&&0!==X.length?1===X.length?$?de.format(Ee,X[0].positionLineNumber,X[0].positionColumn,$):de.format(Le,X[0].positionLineNumber,X[0].positionColumn):$?de.format(xe,X.length,$):X.length>0?de.format(Ie,X.length):null:Se}($,J);X.wrappingInfo.inDiffEditor?X.readOnly?te+=Q.localize(7,null):te+=Q.localize(8,null):X.readOnly?te+=Q.localize(9,null):te+=Q.localize(10,null);var ne=ue.isMacintosh?Q.localize(11,null):Q.localize(12,null);switch(X.accessibilitySupport){case 0:te+="\n\n - "+ne;break;case 2:te+="\n\n - "+Q.localize(13,null);break;case 1:te+="\n\n - "+Q.localize(14,null),te+=" "+ne}var ie=Q.localize(15,null),oe=Q.localize(16,null),se=Q.localize(17,null),ae=Q.localize(18,null);X.tabFocusMode?te+="\n\n - "+this._descriptionForCommand(fe.ToggleTabFocusModeAction.ID,ie,oe):te+="\n\n - "+this._descriptionForCommand(fe.ToggleTabFocusModeAction.ID,se,ae),te+="\n\n - "+(ue.isMacintosh?Q.localize(19,null):Q.localize(20,null)),te+="\n\n"+Q.localize(21,null),this._contentDomNode.domNode.appendChild(re.renderFormattedText(te)),this._contentDomNode.domNode.setAttribute("aria-label",te)},t.prototype.hide=function(){this._isVisible&&(this._isVisible=!1,this._isVisibleKey.reset(),this._domNode.setDisplay("none"),this._domNode.setAttribute("aria-hidden","true"),this._contentDomNode.domNode.tabIndex=-1,ee.clearNode(this._contentDomNode.domNode),this._editor.focus())},t.prototype._layout=function(){var X=this._editor.getLayoutInfo(),$=Math.max(5,Math.min(t.WIDTH,X.width-40)),Q=Math.max(5,Math.min(t.HEIGHT,X.height-40));this._domNode.setWidth($),this._domNode.setHeight(Q);var J=Math.round((X.height-Q)/2);this._domNode.setTop(J);var ee=Math.round((X.width-$)/2);this._domNode.setLeft(ee)},t.ID="editor.contrib.accessibilityHelpWidget",t.WIDTH=500,t.HEIGHT=300,t=ne([oe(1,ge.IContextKeyService),oe(2,ve.IKeybindingService),oe(3,_e.IOpenerService)],t)}(ae.Widget),Ne=function(X){function t(){return X.call(this,{id:"editor.action.showAccessibilityHelp",label:Q.localize(22,null),alias:"Show Accessibility Help",precondition:null,kbOpts:{kbExpr:pe.EditorContextKeys.focus,primary:J.isIE?2107:571,weight:100}})||this}return te(t,X),t.prototype.run=function(X,$){var Q=we.get($);Q&&Q.show()},t}(he.EditorAction);he.registerEditorContribution(we),he.registerEditorAction(Ne);var Me=he.EditorCommand.bindToContribution(we.get);he.registerEditorCommand(new Me({id:"closeAccessibilityHelp",precondition:Ce,handler:function(X){return X.hide()},kbOpts:{weight:200,kbExpr:pe.EditorContextKeys.focus,primary:9,secondary:[1033]}})),be.registerThemingParticipant((function(X,$){var Q=X.getColor(ye.editorWidgetBackground);Q&&$.addRule(".monaco-editor .accessibilityHelpWidget { background-color: "+Q+"; }");var J=X.getColor(ye.widgetShadow);J&&$.addRule(".monaco-editor .accessibilityHelpWidget { box-shadow: 0 2px 8px "+J+"; }");var ee=X.getColor(ye.contrastBorder);ee&&$.addRule(".monaco-editor .accessibilityHelpWidget { border: 2px solid "+ee+"; }")}))})),define(Q[538],n([0,1,343,28,2,8,10,14,51,63,78,20,13,396]),(function(X,$,Q,J,ee,ie,re,se,ae,le,ue,de,ce){Object.defineProperty($,"__esModule",{value:!0});var he=function(X){function t($,Q,J){var ee=X.call(this)||this;return ee._editor=$,ee._modeService=J,ee._widget=null,ee._register(ee._editor.onDidChangeModel((function(X){return ee.stop()}))),ee._register(ee._editor.onDidChangeModelLanguage((function(X){return ee.stop()}))),ee._register(se.TokenizationRegistry.onDidChange((function(X){return ee.stop()}))),ee}return te(t,X),t.get=function(X){return X.getContribution(t.ID)},t.prototype.getId=function(){return t.ID},t.prototype.dispose=function(){this.stop(),X.prototype.dispose.call(this)},t.prototype.launch=function(){this._widget||this._editor.hasModel()&&(this._widget=new fe(this._editor,this._modeService))},t.prototype.stop=function(){this._widget&&(this._widget.dispose(),this._widget=null)},t.ID="editor.contrib.inspectTokens",t=ne([oe(1,ue.IStandaloneThemeService),oe(2,le.IModeService)],t)}(ee.Disposable),pe=function(X){function t(){return X.call(this,{id:"editor.action.inspectTokens",label:Q.localize(0,null),alias:"Developer: Inspect Tokens",precondition:null})||this}return te(t,X),t.prototype.run=function(X,$){var Q=he.get($);Q&&Q.launch()},t}(re.EditorAction),fe=function(X){function t($,Q){var J=X.call(this)||this;return J.allowEditorOverflow=!0,J._editor=$,J._modeService=Q,J._model=J._editor.getModel(),J._domNode=document.createElement("div"),J._domNode.className="tokens-inspect-widget",J._tokenizationSupport=function(X){return se.TokenizationRegistry.get(X.language)||{getInitialState:function(){return ae.NULL_STATE},tokenize:function($,Q,J){return ae.nullTokenize(X.language,$,Q,J)},tokenize2:function($,Q,J){return ae.nullTokenize2(X.id,$,Q,J)}}}(J._model.getLanguageIdentifier()),J._compute(J._editor.getPosition()),J._register(J._editor.onDidChangeCursorPosition((function(X){return J._compute(J._editor.getPosition())}))),J._editor.addContentWidget(J),J}return te(t,X),t.prototype.dispose=function(){this._editor.removeContentWidget(this),X.prototype.dispose.call(this)},t.prototype.getId=function(){return t._ID},t.prototype._compute=function(X){for(var $=this._getTokensAtLine(X.lineNumber),Q=0,ee=$.tokens1.length-1;ee>=0;ee--){var te=$.tokens1[ee];if(X.column-1>=te.offset){Q=ee;break}}var ne=0;for(ee=$.tokens2.length>>>1;ee>=0;ee--)if(X.column-1>=$.tokens2[ee<<1]){ne=ee;break}var oe="",re=this._model.getLineContent(X.lineNumber),se="";if(Q<$.tokens1.length){var ae=$.tokens1[Q].offset,le=Q+1<$.tokens1.length?$.tokens1[Q+1].offset:re.length;se=re.substring(ae,le)}oe+='<h2 class="tm-token">'+function(X){for(var $="",Q=0,J=X.length;Q<J;Q++){var ee=X.charCodeAt(Q);switch(ee){case 9:$+="&rarr;";break;case 32:$+="&middot;";break;case 60:$+="&lt;";break;case 62:$+="&gt;";break;case 38:$+="&amp;";break;default:$+=String.fromCharCode(ee)}}return $}(se)+'<span class="tm-token-length">('+se.length+" "+(1===se.length?"char":"chars")+")</span></h2>",oe+='<hr class="tokens-inspect-separator" style="clear:both"/>';var ue=this._decodeMetadata($.tokens2[1+(ne<<1)]);oe+='<table class="tm-metadata-table"><tbody>',oe+='<tr><td class="tm-metadata-key">language</td><td class="tm-metadata-value">'+ie.escape(ue.languageIdentifier.language)+"</td>",oe+='<tr><td class="tm-metadata-key">token type</td><td class="tm-metadata-value">'+this._tokenTypeToString(ue.tokenType)+"</td>",oe+='<tr><td class="tm-metadata-key">font style</td><td class="tm-metadata-value">'+this._fontStyleToString(ue.fontStyle)+"</td>",oe+='<tr><td class="tm-metadata-key">foreground</td><td class="tm-metadata-value">'+J.Color.Format.CSS.formatHex(ue.foreground)+"</td>",oe+='<tr><td class="tm-metadata-key">background</td><td class="tm-metadata-value">'+J.Color.Format.CSS.formatHex(ue.background)+"</td>",oe+="</tbody></table>",oe+='<hr class="tokens-inspect-separator"/>',Q<$.tokens1.length&&(oe+='<span class="tm-token-type">'+ie.escape($.tokens1[Q].type)+"</span>"),this._domNode.innerHTML=oe,this._editor.layoutContentWidget(this)},t.prototype._decodeMetadata=function(X){var $=se.TokenizationRegistry.getColorMap(),Q=se.TokenMetadata.getLanguageId(X),J=se.TokenMetadata.getTokenType(X),ee=se.TokenMetadata.getFontStyle(X),te=se.TokenMetadata.getForeground(X),ne=se.TokenMetadata.getBackground(X);return{languageIdentifier:this._modeService.getLanguageIdentifier(Q),tokenType:J,fontStyle:ee,foreground:$[te],background:$[ne]}},t.prototype._tokenTypeToString=function(X){switch(X){case 0:return"Other";case 1:return"Comment";case 2:return"String";case 4:return"RegEx"}return"??"},t.prototype._fontStyleToString=function(X){var $="";return 1&X&&($+="italic "),2&X&&($+="bold "),4&X&&($+="underline "),0===$.length&&($="---"),$},t.prototype._getTokensAtLine=function(X){var $=this._getStateBeforeLine(X),Q=this._tokenizationSupport.tokenize(this._model.getLineContent(X),$,0),J=this._tokenizationSupport.tokenize2(this._model.getLineContent(X),$,0);return{startState:$,tokens1:Q.tokens,tokens2:J.tokens,endState:Q.endState}},t.prototype._getStateBeforeLine=function(X){for(var $=this._tokenizationSupport.getInitialState(),Q=1;Q<X;Q++)$=this._tokenizationSupport.tokenize(this._model.getLineContent(Q),$,0).endState;return $},t.prototype.getDomNode=function(){return this._domNode},t.prototype.getPosition=function(){return{position:this._editor.getPosition(),preference:[2,1]}},t._ID="editor.contrib.inspectTokensWidget",t}(ee.Disposable);re.registerEditorContribution(he),re.registerEditorAction(pe),ce.registerThemingParticipant((function(X,$){var Q=X.getColor(de.editorHoverBorder);if(Q){var J=X.type===ce.HIGH_CONTRAST?2:1;$.addRule(".monaco-editor .tokens-inspect-widget { border: "+J+"px solid "+Q+"; }"),$.addRule(".monaco-editor .tokens-inspect-widget .tokens-inspect-separator { background-color: "+Q+"; }")}var ee=X.getColor(de.editorHoverBackground);ee&&$.addRule(".monaco-editor .tokens-inspect-widget { background-color: "+ee+"; }")}))})),define(Q[144],n([0,1,10,26,481,13,399]),(function(X,$,Q,J,ee,ie){Object.defineProperty($,"__esModule",{value:!0});var re=function(){function e(X,$){this.themeService=$,this.editor=X}return e.get=function(X){return X.getContribution(e.ID)},e.prototype.getId=function(){return e.ID},e.prototype.dispose=function(){this.widget&&(this.widget.destroy(),this.widget=null)},e.prototype.run=function(X){var $=this;this.widget&&(this.widget.destroy(),this.widget=null);var n=function(X){$.clearDecorations(),X&&$.lastKnownEditorSelection&&($.editor.setSelection($.lastKnownEditorSelection),$.editor.revealRangeInCenterIfOutsideViewport($.lastKnownEditorSelection,0)),$.lastKnownEditorSelection=null,document.activeElement!==document.body&&X||$.editor.focus()};this.widget=new ee.QuickOpenEditorWidget(this.editor,(function(){return n(!1)}),(function(){return n(!0)}),(function(Q){$.widget.setInput(X.getModel(Q),X.getAutoFocus(Q))}),{inputAriaLabel:X.inputAriaLabel},this.themeService),this.lastKnownEditorSelection||(this.lastKnownEditorSelection=this.editor.getSelection()),this.widget.show("")},e.prototype.decorateLine=function(X,$){var Q=[];this.rangeHighlightDecorationId&&(Q.push(this.rangeHighlightDecorationId),this.rangeHighlightDecorationId=null);var J=[{range:X,options:e._RANGE_HIGHLIGHT_DECORATION}],ee=$.deltaDecorations(Q,J);this.rangeHighlightDecorationId=ee[0]},e.prototype.clearDecorations=function(){this.rangeHighlightDecorationId&&(this.editor.deltaDecorations([this.rangeHighlightDecorationId],[]),this.rangeHighlightDecorationId=null)},e.ID="editor.controller.quickOpenController",e._RANGE_HIGHLIGHT_DECORATION=J.ModelDecorationOptions.register({className:"rangeHighlight",isWholeLine:!0}),e=ne([oe(1,ie.IThemeService)],e)}();$.QuickOpenController=re;var se=function(X){function t($,Q){var J=X.call(this,Q)||this;return J._inputAriaLabel=$,J}return te(t,X),t.prototype.getController=function(X){return re.get(X)},t.prototype._show=function(X,$){X.run({inputAriaLabel:this._inputAriaLabel,getModel:function(X){return $.getModel(X)},getAutoFocus:function(X){return $.getAutoFocus(X)}})},t}(Q.EditorAction);$.BaseEditorQuickOpenAction=se,Q.registerEditorContribution(re)})),define(Q[540],n([0,1,344,119,105,10,12,3,19,144,400]),(function(X,$,Q,J,ee,ne,ie,oe,re,se){Object.defineProperty($,"__esModule",{value:!0});var ae=function(X){function t($,Q,J){var ee=X.call(this)||this;return ee.editor=Q,ee.decorator=J,ee._parseResult=ee._parseInput($),ee}return te(t,X),t.prototype._parseInput=function(X){var $,J=X.split(",").map((function(X){return parseInt(X,10)})).filter((function(X){return!isNaN(X)}));$=0===J.length?new ie.Position(-1,-1):1===J.length?new ie.Position(J[0],1):new ie.Position(J[0],J[1]);var te,ne=(te=ee.isCodeEditor(this.editor)?this.editor.getModel():this.editor.getModel().modified).validatePosition($).equals($);return{position:$,isValid:ne,label:ne?$.column&&$.column>1?Q.localize(0,null,$.lineNumber,$.column):Q.localize(1,null,$.lineNumber,$.column):$.lineNumber<1||$.lineNumber>te.getLineCount()?Q.localize(2,null,te.getLineCount()):Q.localize(3,null,te.getLineMaxColumn($.lineNumber))}},t.prototype.getLabel=function(){return this._parseResult.label},t.prototype.getAriaLabel=function(){return Q.localize(4,null,this._parseResult.label)},t.prototype.run=function(X,$){return 1===X?this.runOpen():this.runPreview()},t.prototype.runOpen=function(){if(!this._parseResult.isValid)return!1;var X=this.toSelection();return this.editor.setSelection(X),this.editor.revealRangeInCenter(X,0),this.editor.focus(),!0},t.prototype.runPreview=function(){if(!this._parseResult.isValid)return this.decorator.clearDecorations(),!1;var X=this.toSelection();return this.editor.revealRangeInCenter(X,0),this.decorator.decorateLine(X,this.editor),!1},t.prototype.toSelection=function(){return new oe.Range(this._parseResult.position.lineNumber,this._parseResult.position.column,this._parseResult.position.lineNumber,this._parseResult.position.column)},t}(J.QuickOpenEntry);$.GotoLineEntry=ae;var le=function(X){function t(){return X.call(this,Q.localize(5,null),{id:"editor.action.gotoLine",label:Q.localize(6,null),alias:"Go to Line...",precondition:null,kbOpts:{kbExpr:re.EditorContextKeys.focus,primary:2085,mac:{primary:293},weight:100}})||this}return te(t,X),t.prototype.run=function(X,$){var Q=this;this._show(this.getController($),{getModel:function(X){return new J.QuickOpenModel([new ae(X,$,Q.getController($))])},getAutoFocus:function(X){return{autoFocusFirstEntry:X.length>0}}})},t}(se.BaseEditorQuickOpenAction);$.GotoLineAction=le,ne.registerEditorAction(le)})),define(Q[541],n([0,1,345,29,11,100,119,10,19,144,47]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae){Object.defineProperty($,"__esModule",{value:!0});var le=function(X){function t($,Q,J,ee){var te=X.call(this)||this;return te.key=$,te.setHighlights(Q),te.action=J,te.editor=ee,te}return te(t,X),t.prototype.getLabel=function(){return this.action.label},t.prototype.getAriaLabel=function(){return Q.localize(0,null,this.getLabel())},t.prototype.getGroupLabel=function(){return this.key},t.prototype.run=function(X,$){var Q=this;return 1===X&&(setTimeout((function(){Q.editor.focus();try{(Q.action.run()||Promise.resolve()).then(null,ee.onUnexpectedError)}catch(X){ee.onUnexpectedError(X)}}),50),!0)},t}(ie.QuickOpenEntryGroup);$.EditorActionCommandEntry=le;var ue=function(X){function t(){return X.call(this,Q.localize(1,null),{id:"editor.action.quickCommand",label:Q.localize(2,null),alias:"Command Palette",precondition:null,kbOpts:{kbExpr:re.EditorContextKeys.focus,primary:J.isIE?571:59,weight:100},menuOpts:{group:"z_commands",order:1}})||this}return te(t,X),t.prototype.run=function(X,$){var Q=this,J=X.get(ae.IKeybindingService);this._show(this.getController($),{getModel:function(X){return new ie.QuickOpenModel(Q._editorActionsToEntries(J,$,X))},getAutoFocus:function(X){return{autoFocusFirstEntry:!0,autoFocusPrefixMatch:X}}})},t.prototype._sort=function(X,$){var Q=X.getLabel().toLowerCase(),J=$.getLabel().toLowerCase();return Q.localeCompare(J)},t.prototype._editorActionsToEntries=function(X,$,Q){for(var J=$.getSupportedActions(),ee=[],te=0;te<J.length;te++){var ie=J[te],oe=X.lookupKeybinding(ie.id);if(ie.label){var re=ne.matchesFuzzy(Q,ie.label);re&&ee.push(new le(oe?oe.getLabel():"",re,ie,$))}}return ee.sort(this._sort)},t}(se.BaseEditorQuickOpenAction);$.QuickCommandAction=ue,oe.registerEditorAction(ue)})),define(Q[542],n([0,1,346,24,100,8,119,10,3,19,14,467,144,401]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le,ue){Object.defineProperty($,"__esModule",{value:!0});var de=function(X){function t($,Q,J,ee,te,ne,ie){var oe=X.call(this)||this;return oe.name=$,oe.type=Q,oe.description=J,oe.range=ee,oe.setHighlights(te),oe.editor=ne,oe.decorator=ie,oe}return te(t,X),t.prototype.getLabel=function(){return this.name},t.prototype.getAriaLabel=function(){return Q.localize(0,null,this.name)},t.prototype.getIcon=function(){return this.type},t.prototype.getDescription=function(){return this.description},t.prototype.getType=function(){return this.type},t.prototype.getRange=function(){return this.range},t.prototype.run=function(X,$){return 1===X?this.runOpen($):this.runPreview()},t.prototype.runOpen=function(X){var $=this.toSelection();return this.editor.setSelection($),this.editor.revealRangeInCenter($,0),this.editor.focus(),!0},t.prototype.runPreview=function(){var X=this.toSelection();return this.editor.revealRangeInCenter(X,0),this.decorator.decorateLine(this.range,this.editor),!1},t.prototype.toSelection=function(){return new re.Range(this.range.startLineNumber,this.range.startColumn||1,this.range.startLineNumber,this.range.startColumn||1)},t}(ie.QuickOpenEntryGroup);$.SymbolEntry=de;var ce=function(X){function t(){return X.call(this,Q.localize(1,null),{id:"editor.action.quickOutline",label:Q.localize(2,null),alias:"Go to Symbol...",precondition:se.EditorContextKeys.hasDocumentSymbolProvider,kbOpts:{kbExpr:se.EditorContextKeys.focus,primary:3117,weight:100},menuOpts:{group:"navigation",order:3}})||this}return te(t,X),t.prototype.run=function(X,$){var Q=this,ee=$.getModel();return ae.DocumentSymbolProviderRegistry.has(ee)?le.getDocumentSymbols(ee,!0,J.CancellationToken.None).then((function(X){0!==X.length&&Q._run($,X)})):null},t.prototype._run=function(X,$){var Q=this;this._show(this.getController(X),{getModel:function(J){return new ie.QuickOpenModel(Q.toQuickOpenEntries(X,$,J))},getAutoFocus:function(X){return 0===X.indexOf(":")&&(X=X.substr(":".length)),{autoFocusPrefixMatch:X,autoFocusFirstEntry:!!X}}})},t.prototype.symbolEntry=function(X,$,Q,J,ee,te,ne){return new de(X,$,Q,re.Range.lift(J),ee,te,ne)},t.prototype.toQuickOpenEntries=function(X,$,J){var te=this.getController(X),ie=[],oe=J;for(0===J.indexOf(":")&&(oe=oe.substr(":".length)),pe=0;pe<$.length;pe++){var re=$[pe],se=ne.trim(re.name),le=ee.matchesFuzzy(oe,se);if(le){var ue=null;re.containerName&&(ue=re.containerName),ie.push(this.symbolEntry(se,ae.symbolKindToCssClass(re.kind),ue,re.range,le,X,te))}}if(J&&(ie=0===J.indexOf(":")?ie.sort(this.sortScoped.bind(this,J.toLowerCase())):ie.sort(this.sortNormal.bind(this,J.toLowerCase()))),ie.length>0&&0===J.indexOf(":")){for(var de=null,ce=null,he=0,pe=0;pe<ie.length;pe++){var fe=ie[pe];de!==fe.getType()?(ce&&ce.setGroupLabel(this.typeToLabel(de,he)),de=fe.getType(),ce=fe,he=1,fe.setShowBorder(pe>0)):he++}ce&&ce.setGroupLabel(this.typeToLabel(de,he))}else ie.length>0&&ie[0].setGroupLabel(Q.localize(3,null,ie.length));return ie},t.prototype.typeToLabel=function(X,$){switch(X){case"module":return Q.localize(4,null,$);case"class":return Q.localize(5,null,$);case"interface":return Q.localize(6,null,$);case"method":return Q.localize(7,null,$);case"function":return Q.localize(8,null,$);case"property":return Q.localize(9,null,$);case"variable":return Q.localize(10,null,$);case"var":return Q.localize(11,null,$);case"constructor":return Q.localize(12,null,$);case"call":return Q.localize(13,null,$)}return X},t.prototype.sortNormal=function(X,$,Q){var J=$.getLabel().toLowerCase(),ee=Q.getLabel().toLowerCase(),te=J.localeCompare(ee);if(0!==te)return te;var ne=$.getRange(),ie=Q.getRange();return ne.startLineNumber-ie.startLineNumber},t.prototype.sortScoped=function(X,$,Q){X=X.substr(":".length);var J=$.getType(),ee=Q.getType(),te=J.localeCompare(ee);if(0!==te)return te;if(X){var ne=$.getLabel().toLowerCase(),ie=Q.getLabel().toLowerCase(),oe=ne.localeCompare(ie);if(0!==oe)return oe}var re=$.getRange(),se=Q.getRange();return re.startLineNumber-se.startLineNumber},t}(ue.BaseEditorQuickOpenAction);$.QuickOutlineAction=ce,oe.registerEditorAction(ce)})),define(Q[543],n([0,1,7,50,484]),(function(X,$,Q,J,ee){Object.defineProperty($,"__esModule",{value:!0});var ne=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype.getActiveCodeEditor=function(){return null},t.prototype.openCodeEditor=function(X,$,Q){return $?Promise.resolve(this.doOpenEditor($,X)):Promise.resolve(null)},t.prototype.doOpenEditor=function(X,$){if(!this.findModel(X,$.resource)){if($.resource){var ee=$.resource.scheme;if(ee===J.Schemas.http||ee===J.Schemas.https)return Q.windowOpenNoOpener($.resource.toString()),X}return null}var te=$.options?$.options.selection:null;if(te)if("number"==typeof te.endLineNumber&&"number"==typeof te.endColumn)X.setSelection(te),X.revealRangeInCenter(te,1);else{var ne={lineNumber:te.startLineNumber,column:te.startColumn};X.setPosition(ne),X.revealPositionInCenter(ne,1)}return X},t.prototype.findModel=function(X,$){var Q=X.getModel();return Q&&Q.uri.toString()!==$.toString()?null:Q},t}(ee.CodeEditorServiceImpl);$.StandaloneCodeEditorServiceImpl=ne})),define(Q[544],n([0,1,34,20]),(function(X,$,Q,J){var ee,te,ne;Object.defineProperty($,"__esModule",{value:!0}),$.vs={base:"vs",inherit:!1,rules:[{token:"",foreground:"000000",background:"fffffe"},{token:"invalid",foreground:"cd3131"},{token:"emphasis",fontStyle:"italic"},{token:"strong",fontStyle:"bold"},{token:"variable",foreground:"001188"},{token:"variable.predefined",foreground:"4864AA"},{token:"constant",foreground:"dd0000"},{token:"comment",foreground:"008000"},{token:"number",foreground:"09885A"},{token:"number.hex",foreground:"3030c0"},{token:"regexp",foreground:"800000"},{token:"annotation",foreground:"808080"},{token:"type",foreground:"008080"},{token:"delimiter",foreground:"000000"},{token:"delimiter.html",foreground:"383838"},{token:"delimiter.xml",foreground:"0000FF"},{token:"tag",foreground:"800000"},{token:"tag.id.pug",foreground:"4F76AC"},{token:"tag.class.pug",foreground:"4F76AC"},{token:"meta.scss",foreground:"800000"},{token:"metatag",foreground:"e00000"},{token:"metatag.content.html",foreground:"FF0000"},{token:"metatag.html",foreground:"808080"},{token:"metatag.xml",foreground:"808080"},{token:"metatag.php",fontStyle:"bold"},{token:"key",foreground:"863B00"},{token:"string.key.json",foreground:"A31515"},{token:"string.value.json",foreground:"0451A5"},{token:"attribute.name",foreground:"FF0000"},{token:"attribute.value",foreground:"0451A5"},{token:"attribute.value.number",foreground:"09885A"},{token:"attribute.value.unit",foreground:"09885A"},{token:"attribute.value.html",foreground:"0000FF"},{token:"attribute.value.xml",foreground:"0000FF"},{token:"string",foreground:"A31515"},{token:"string.html",foreground:"0000FF"},{token:"string.sql",foreground:"FF0000"},{token:"string.yaml",foreground:"0451A5"},{token:"keyword",foreground:"0000FF"},{token:"keyword.json",foreground:"0451A5"},{token:"keyword.flow",foreground:"AF00DB"},{token:"keyword.flow.scss",foreground:"0000FF"},{token:"operator.scss",foreground:"666666"},{token:"operator.sql",foreground:"778899"},{token:"operator.swift",foreground:"666666"},{token:"predefined.sql",foreground:"FF00FF"}],colors:(ee={},ee[J.editorBackground]="#FFFFFE",ee[J.editorForeground]="#000000",ee[J.editorInactiveSelection]="#E5EBF1",ee[Q.editorIndentGuides]="#D3D3D3",ee[Q.editorActiveIndentGuides]="#939393",ee[J.editorSelectionHighlight]="#ADD6FF4D",ee)},$.vs_dark={base:"vs-dark",inherit:!1,rules:[{token:"",foreground:"D4D4D4",background:"1E1E1E"},{token:"invalid",foreground:"f44747"},{token:"emphasis",fontStyle:"italic"},{token:"strong",fontStyle:"bold"},{token:"variable",foreground:"74B0DF"},{token:"variable.predefined",foreground:"4864AA"},{token:"variable.parameter",foreground:"9CDCFE"},{token:"constant",foreground:"569CD6"},{token:"comment",foreground:"608B4E"},{token:"number",foreground:"B5CEA8"},{token:"number.hex",foreground:"5BB498"},{token:"regexp",foreground:"B46695"},{token:"annotation",foreground:"cc6666"},{token:"type",foreground:"3DC9B0"},{token:"delimiter",foreground:"DCDCDC"},{token:"delimiter.html",foreground:"808080"},{token:"delimiter.xml",foreground:"808080"},{token:"tag",foreground:"569CD6"},{token:"tag.id.pug",foreground:"4F76AC"},{token:"tag.class.pug",foreground:"4F76AC"},{token:"meta.scss",foreground:"A79873"},{token:"meta.tag",foreground:"CE9178"},{token:"metatag",foreground:"DD6A6F"},{token:"metatag.content.html",foreground:"9CDCFE"},{token:"metatag.html",foreground:"569CD6"},{token:"metatag.xml",foreground:"569CD6"},{token:"metatag.php",fontStyle:"bold"},{token:"key",foreground:"9CDCFE"},{token:"string.key.json",foreground:"9CDCFE"},{token:"string.value.json",foreground:"CE9178"},{token:"attribute.name",foreground:"9CDCFE"},{token:"attribute.value",foreground:"CE9178"},{token:"attribute.value.number.css",foreground:"B5CEA8"},{token:"attribute.value.unit.css",foreground:"B5CEA8"},{token:"attribute.value.hex.css",foreground:"D4D4D4"},{token:"string",foreground:"CE9178"},{token:"string.sql",foreground:"FF0000"},{token:"keyword",foreground:"569CD6"},{token:"keyword.flow",foreground:"C586C0"},{token:"keyword.json",foreground:"CE9178"},{token:"keyword.flow.scss",foreground:"569CD6"},{token:"operator.scss",foreground:"909090"},{token:"operator.sql",foreground:"778899"},{token:"operator.swift",foreground:"909090"},{token:"predefined.sql",foreground:"FF00FF"}],colors:(te={},te[J.editorBackground]="#1E1E1E",te[J.editorForeground]="#D4D4D4",te[J.editorInactiveSelection]="#3A3D41",te[Q.editorIndentGuides]="#404040",te[Q.editorActiveIndentGuides]="#707070",te[J.editorSelectionHighlight]="#ADD6FF26",te)},$.hc_black={base:"hc-black",inherit:!1,rules:[{token:"",foreground:"FFFFFF",background:"000000"},{token:"invalid",foreground:"f44747"},{token:"emphasis",fontStyle:"italic"},{token:"strong",fontStyle:"bold"},{token:"variable",foreground:"1AEBFF"},{token:"variable.parameter",foreground:"9CDCFE"},{token:"constant",foreground:"569CD6"},{token:"comment",foreground:"608B4E"},{token:"number",foreground:"FFFFFF"},{token:"regexp",foreground:"C0C0C0"},{token:"annotation",foreground:"569CD6"},{token:"type",foreground:"3DC9B0"},{token:"delimiter",foreground:"FFFF00"},{token:"delimiter.html",foreground:"FFFF00"},{token:"tag",foreground:"569CD6"},{token:"tag.id.pug",foreground:"4F76AC"},{token:"tag.class.pug",foreground:"4F76AC"},{token:"meta",foreground:"D4D4D4"},{token:"meta.tag",foreground:"CE9178"},{token:"metatag",foreground:"569CD6"},{token:"metatag.content.html",foreground:"1AEBFF"},{token:"metatag.html",foreground:"569CD6"},{token:"metatag.xml",foreground:"569CD6"},{token:"metatag.php",fontStyle:"bold"},{token:"key",foreground:"9CDCFE"},{token:"string.key",foreground:"9CDCFE"},{token:"string.value",foreground:"CE9178"},{token:"attribute.name",foreground:"569CD6"},{token:"attribute.value",foreground:"3FF23F"},{token:"string",foreground:"CE9178"},{token:"string.sql",foreground:"FF0000"},{token:"keyword",foreground:"569CD6"},{token:"keyword.flow",foreground:"C586C0"},{token:"operator.sql",foreground:"778899"},{token:"operator.swift",foreground:"909090"},{token:"predefined.sql",foreground:"FF00FF"}],colors:(ne={},ne[J.editorBackground]="#000000",ne[J.editorForeground]="#FFFFFF",ne[Q.editorIndentGuides]="#FFFFFF",ne[Q.editorActiveIndentGuides]="#FFFFFF",ne)}})),define(Q[545],n([0,1,7,28,6,14,560,544,41,20,13]),(function(X,$,Q,J,ee,te,ne,ie,oe,re,se){function c(X){return X===ae||X===le||X===ue}function h(X){switch(X){case ae:return ie.vs;case le:return ie.vs_dark;case ue:return ie.hc_black}}function p(X){var $=h(X);return new he(X,$)}Object.defineProperty($,"__esModule",{value:!0});var ae="vs",le="vs-dark",ue="hc-black",de=oe.Registry.as(re.Extensions.ColorContribution),ce=oe.Registry.as(se.Extensions.ThemingContribution),he=function(){function e(X,$){this.themeData=$;var Q=$.base;X.length>0?(this.id=Q+" "+X,this.themeName=X):(this.id=Q,this.themeName=Q),this.colors=null,this.defaultColors=Object.create(null),this._tokenTheme=null}return Object.defineProperty(e.prototype,"base",{get:function(){return this.themeData.base},enumerable:!0,configurable:!0}),e.prototype.notifyBaseUpdated=function(){this.themeData.inherit&&(this.colors=null,this._tokenTheme=null)},e.prototype.getColors=function(){if(!this.colors){var X=Object.create(null);for(var $ in this.themeData.colors)X[$]=J.Color.fromHex(this.themeData.colors[$]);if(this.themeData.inherit){var Q=h(this.themeData.base);for(var $ in Q.colors)X[$]||(X[$]=J.Color.fromHex(Q.colors[$]))}this.colors=X}return this.colors},e.prototype.getColor=function(X,$){return this.getColors()[X]||(!1!==$?this.getDefault(X):null)},e.prototype.getDefault=function(X){var $=this.defaultColors[X];return $||($=de.resolveDefaultColor(X,this),this.defaultColors[X]=$,$)},e.prototype.defines=function(X){return Object.prototype.hasOwnProperty.call(this.getColors(),X)},Object.defineProperty(e.prototype,"type",{get:function(){switch(this.base){case ae:return"light";case ue:return"hc";default:return"dark"}},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"tokenTheme",{get:function(){if(!this._tokenTheme){var X=[],$=[];if(this.themeData.inherit){var Q=h(this.themeData.base);X=Q.rules,Q.encodedTokensColors&&($=Q.encodedTokensColors)}X=X.concat(this.themeData.rules),this.themeData.encodedTokensColors&&($=this.themeData.encodedTokensColors),this._tokenTheme=ne.TokenTheme.createFromRawTokenTheme(X,$)}return this._tokenTheme},enumerable:!0,configurable:!0}),e}(),pe=function(){function e(){this.environment=Object.create(null),this._onThemeChange=new ee.Emitter,this._onIconThemeChange=new ee.Emitter,this._knownThemes=new Map,this._knownThemes.set(ae,p(ae)),this._knownThemes.set(le,p(le)),this._knownThemes.set(ue,p(ue)),this._styleElement=Q.createStyleSheet(),this._styleElement.className="monaco-colors",this.setTheme(ae)}return Object.defineProperty(e.prototype,"onThemeChange",{get:function(){return this._onThemeChange.event},enumerable:!0,configurable:!0}),e.prototype.defineTheme=function(X,$){if(!/^[a-z0-9\-]+$/i.test(X))throw new Error("Illegal theme name!");if(!c($.base)&&!c(X))throw new Error("Illegal theme base!");this._knownThemes.set(X,new he(X,$)),c(X)&&this._knownThemes.forEach((function($){$.base===X&&$.notifyBaseUpdated()})),this._theme&&this._theme.themeName===X&&this.setTheme(X)},e.prototype.getTheme=function(){return this._theme},e.prototype.setTheme=function(X){var $,Q=this;if($=this._knownThemes.has(X)?this._knownThemes.get(X):this._knownThemes.get(ae),this._theme===$)return $.id;this._theme=$;var J=[],ee={},ie={addRule:function(X){ee[X]||(J.push(X),ee[X]=!0)}};ce.getThemingParticipants().forEach((function(X){return X($,ie,Q.environment)}));var oe=$.tokenTheme.getColorMap();return ie.addRule(ne.generateTokensCSSForColorMap(oe)),this._styleElement.innerHTML=J.join("\n"),te.TokenizationRegistry.setColorMap(oe),this._onThemeChange.fire($),$.id},e.prototype.getIconTheme=function(){return{hasFileIcons:!1,hasFolderIcons:!1,hidesExplorerArrows:!1}},e}();$.StandaloneThemeServiceImpl=pe})),define(Q[546],n([0,1,482,60,70,6,35,13,47,2]),(function(X,$,Q,J,ee,ie,re,se,ae,le){Object.defineProperty($,"__esModule",{value:!0});var ue=function(X){function t($,J,ee,te,ne,oe){var re=X.call(this)||this;return re._onDidContextMenu=re._register(new ie.Emitter),re.contextMenuHandler=re._register(new Q.ContextMenuHandler($,te,J,ee,ne,oe)),re}return te(t,X),t.prototype.dispose=function(){this.contextMenuHandler.dispose()},t.prototype.showContextMenu=function(X){this.contextMenuHandler.showContextMenu(X),this._onDidContextMenu.fire()},ne([oe(1,ee.ITelemetryService),oe(2,re.INotificationService),oe(3,J.IContextViewService),oe(4,ae.IKeybindingService),oe(5,se.IThemeService)],t)}(le.Disposable);$.ContextMenuService=ue})),define(Q[145],n([0,1,7,2,32,88,161,352,45,82,18,15,41,86,13]),(function(X,$,Q,J,ee,re,se,ae,le,ue,de,ce,he,pe,fe){function y(X){return"alt"===X.getValue($.multiSelectModifierSettingKey)}function C(X){return"doubleClick"!==X.getValue($.openModeSettingKey)}function b(X,$){return X.controller||(X.controller=$.createInstance(be,{})),X.styler||(X.styler=new re.DefaultTreestyler((_e||(_e=Q.createStyleSheet()),_e))),X}var ge;Object.defineProperty($,"__esModule",{value:!0}),$.IListService=ce.createDecorator("listService");var me=function(){function e(X){this.lists=[],this._lastFocusedWidget=void 0}return Object.defineProperty(e.prototype,"lastFocusedList",{get:function(){return this._lastFocusedWidget},enumerable:!0,configurable:!0}),e.prototype.register=function(X,$){var Q=this;if(this.lists.some((function($){return $.widget===X})))throw new Error("Cannot register the same widget multiple times");var ee={widget:X,extraContextKeys:$};return this.lists.push(ee),X.getHTMLElement()===document.activeElement&&(this._lastFocusedWidget=X),J.combinedDisposable([X.onDidFocus((function(){return Q._lastFocusedWidget=X})),J.toDisposable((function(){return Q.lists.splice(Q.lists.indexOf(ee),1)})),X.onDidDispose((function(){Q.lists=Q.lists.filter((function(X){return X!==ee})),Q._lastFocusedWidget===X&&(Q._lastFocusedWidget=void 0)}))])},ne([oe(0,de.IContextKeyService)],e)}();$.ListService=me;var ve=new de.RawContextKey("listFocus",!0);$.WorkbenchListSupportsMultiSelectContextKey=new de.RawContextKey("listSupportsMultiselect",!0),$.WorkbenchListHasSelectionOrFocus=new de.RawContextKey("listHasSelectionOrFocus",!1),$.WorkbenchListDoubleSelection=new de.RawContextKey("listDoubleSelection",!1),$.WorkbenchListMultiSelection=new de.RawContextKey("listMultiSelection",!1),$.multiSelectModifierSettingKey="workbench.list.multiSelectModifier",$.openModeSettingKey="workbench.list.openMode",$.horizontalScrollingKey="workbench.tree.horizontalScrolling";var _e,ye=function(X){function n(Q,J,ee,te,ne,oe,re,se){var ae=this,le=b(J,re),ue=se.getValue($.horizontalScrollingKey)?1:2,de=ie({horizontalScrollMode:ue,keyboardSupport:!1},pe.computeStyles(oe.getTheme(),pe.defaultListStyles),ee);return(ae=X.call(this,Q,le,de)||this).disposables=[],ae.contextKeyService=function(X,$){var Q=X.createScoped($.getHTMLElement());return ve.bindTo(Q),Q}(te,ae),$.WorkbenchListSupportsMultiSelectContextKey.bindTo(ae.contextKeyService),ae.listHasSelectionOrFocus=$.WorkbenchListHasSelectionOrFocus.bindTo(ae.contextKeyService),ae.listDoubleSelection=$.WorkbenchListDoubleSelection.bindTo(ae.contextKeyService),ae.listMultiSelection=$.WorkbenchListMultiSelection.bindTo(ae.contextKeyService),ae._openOnSingleClick=C(se),ae._useAltAsMultipleSelectionModifier=y(se),ae.disposables.push(ae.contextKeyService,ne.register(ae),pe.attachListStyler(ae,oe)),ae.disposables.push(ae.onDidChangeSelection((function(){var X=ae.getSelection(),$=ae.getFocus();ae.listHasSelectionOrFocus.set(X&&X.length>0||!!$),ae.listDoubleSelection.set(X&&2===X.length),ae.listMultiSelection.set(X&&X.length>1)}))),ae.disposables.push(ae.onDidChangeFocus((function(){var X=ae.getSelection(),$=ae.getFocus();ae.listHasSelectionOrFocus.set(X&&X.length>0||!!$)}))),ae.disposables.push(se.onDidChangeConfiguration((function(X){X.affectsConfiguration($.openModeSettingKey)&&(ae._openOnSingleClick=C(se)),X.affectsConfiguration($.multiSelectModifierSettingKey)&&(ae._useAltAsMultipleSelectionModifier=y(se))}))),ae}return te(n,X),n.prototype.dispose=function(){X.prototype.dispose.call(this),this.disposables=J.dispose(this.disposables)},ne([oe(3,de.IContextKeyService),oe(4,$.IListService),oe(5,fe.IThemeService),oe(6,ce.IInstantiationService),oe(7,le.IConfigurationService)],n)}(se.Tree);$.WorkbenchTree=ye;var be=function(X){function n($,Q){var J=X.call(this,function(X){return"boolean"!=typeof X.keyboardSupport&&(X.keyboardSupport=!1),"number"!=typeof X.clickBehavior&&(X.clickBehavior=0),X}($))||this;return J.configurationService=Q,J.disposables=[],ee.isUndefinedOrNull($.openMode)&&(J.setOpenMode(J.getOpenModeSetting()),J.registerListeners()),J}return te(n,X),n.prototype.registerListeners=function(){var X=this;this.disposables.push(this.configurationService.onDidChangeConfiguration((function(Q){Q.affectsConfiguration($.openModeSettingKey)&&X.setOpenMode(X.getOpenModeSetting())})))},n.prototype.getOpenModeSetting=function(){return C(this.configurationService)?0:1},n.prototype.dispose=function(){this.disposables=J.dispose(this.disposables)},ne([oe(1,le.IConfigurationService)],n)}(re.DefaultController);$.WorkbenchTreeController=be,he.Registry.as(ue.Extensions.Configuration).registerConfiguration({id:"workbench",order:7,title:ae.localize(0,null),type:"object",properties:(ge={},ge[$.multiSelectModifierSettingKey]={type:"string",enum:["ctrlCmd","alt"],enumDescriptions:[ae.localize(1,null),ae.localize(2,null)],default:"ctrlCmd",description:ae.localize(3,null)},ge[$.openModeSettingKey]={type:"string",enum:["singleClick","doubleClick"],default:"singleClick",description:ae.localize(4,null)},ge[$.horizontalScrollingKey]={type:"boolean",default:!1,description:ae.localize(5,null)},ge)})})),define(Q[197],n([0,1,7,549,118,102,28,11,6,158,2,50,84,8,139,3,26,92,332,18,15,156,145,20,86,13,142,123,377]),(function(X,$,Q,J,ee,ie,ae,le,ue,de,ce,he,pe,fe,ge,me,ve,_e,ye,be,Ce,we,Se,Ee,Le,xe,Ie,De){Object.defineProperty($,"__esModule",{value:!0});var Ne=function(){function e(X,$){var Q=this;this._editor=X,this._model=$,this._decorations=new Map,this._decorationIgnoreSet=new Set,this._callOnDispose=[],this._callOnModelChange=[],this._callOnDispose.push(this._editor.onDidChangeModel((function(){return Q._onModelChanged()}))),this._onModelChanged()}return e.prototype.dispose=function(){this._callOnModelChange=ce.dispose(this._callOnModelChange),this._callOnDispose=ce.dispose(this._callOnDispose),this.removeDecorations()},e.prototype._onModelChanged=function(){this._callOnModelChange=ce.dispose(this._callOnModelChange);var X=this._editor.getModel();if(X)for(var $=0,Q=this._model.groups;$<Q.length;$++){var J=Q[$];if(J.uri.toString()===X.uri.toString())return void this._addDecorations(J)}},e.prototype._addDecorations=function(X){var $=this;this._callOnModelChange.push(this._editor.getModel().onDidChangeDecorations((function(X){return $._onDecorationChanged()})));for(var Q=[],J=[],ee=0,te=X.children.length;ee<te;ee++){var ne=X.children[ee];this._decorationIgnoreSet.has(ne.id)||(Q.push({range:ne.range,options:e.DecorationOptions}),J.push(ee))}var ie=this._editor.deltaDecorations([],Q);for(ee=0;ee<ie.length;ee++)this._decorations.set(ie[ee],X.children[J[ee]])},e.prototype._onDecorationChanged=function(){var X=this,$=[];this._decorations.forEach((function(Q,J){var ee=X._editor.getModel().getDecorationRange(J);if(ee){var te=!1;me.Range.equalsRange(ee,Q.range)||((me.Range.spansMultipleLines(ee)||Q.range.endColumn-Q.range.startColumn!=ee.endColumn-ee.startColumn)&&(te=!0),te?(X._decorationIgnoreSet.add(Q.id),$.push(J)):Q.range=ee)}}));for(var Q=0,J=$.length;Q<J;Q++)this._decorations.delete($[Q]);this._editor.deltaDecorations($,[])},e.prototype.removeDecorations=function(){var X=[];this._decorations.forEach((function($,Q){X.push(Q)})),this._editor.deltaDecorations(X,[]),this._decorations.clear()},e.DecorationOptions=ve.ModelDecorationOptions.register({stickiness:1,className:"reference-decoration"}),e}(),Me=function(){function e(X){this._textModelResolverService=X}return e.prototype.getId=function(X,$){return $ instanceof De.ReferencesModel?"root":$ instanceof De.FileReferences||$ instanceof De.OneReference?$.id:void 0},e.prototype.hasChildren=function(X,$){return $ instanceof De.ReferencesModel||$ instanceof De.FileReferences&&!$.failure},e.prototype.getChildren=function(X,$){return $ instanceof De.ReferencesModel?Promise.resolve($.groups):$ instanceof De.FileReferences?$.resolve(this._textModelResolverService).then((function(Q){return $.failure?X.refresh($).then((function(){return Q.children})):Q.children})):Promise.resolve([])},e.prototype.getParent=function(X,$){var Q=null;return($ instanceof De.FileReferences||$ instanceof De.OneReference)&&(Q=$.parent),Promise.resolve(Q)},ne([oe(0,_e.ITextModelService)],e)}(),ke=function(X){function t(){var $=null!==X&&X.apply(this,arguments)||this;return $._onDidFocus=new ue.Emitter,$.onDidFocus=$._onDidFocus.event,$._onDidSelect=new ue.Emitter,$.onDidSelect=$._onDidSelect.event,$._onDidOpenToSide=new ue.Emitter,$.onDidOpenToSide=$._onDidOpenToSide.event,$}return te(t,X),t.prototype.onTap=function($,Q,J){if(Q instanceof De.FileReferences)return J.preventDefault(),J.stopPropagation(),this._expandCollapse($,Q);var ee=X.prototype.onTap.call(this,$,Q,J);return this._onDidFocus.fire(Q),ee},t.prototype.onMouseDown=function($,Q,J){var ee=2===J.detail;if(J.leftButton){if(Q instanceof De.FileReferences&&(this.openOnSingleClick||ee||this.isClickOnTwistie(J)))return J.preventDefault(),J.stopPropagation(),this._expandCollapse($,Q);var te=X.prototype.onClick.call(this,$,Q,J);return(J.ctrlKey||J.metaKey||J.altKey)&&(ee||this.openOnSingleClick)?this._onDidOpenToSide.fire(Q):ee?this._onDidSelect.fire(Q):this.openOnSingleClick&&this._onDidFocus.fire(Q),te}return!1},t.prototype.onClick=function($,Q,J){return!J.leftButton&&X.prototype.onClick.call(this,$,Q,J)},t.prototype._expandCollapse=function(X,$){return X.isExpanded($)?X.collapse($).then(null,le.onUnexpectedError):X.expand($).then(null,le.onUnexpectedError),!0},t.prototype.onEscape=function(X,$){return!1},t.prototype.dispose=function(){this._onDidFocus.dispose(),this._onDidSelect.dispose(),this._onDidOpenToSide.dispose()},t}(Se.WorkbenchTreeController),Te=function(){function e(X,$,te){var ne=this;this._uriLabel=$;var ie=document.createElement("div");Q.addClass(ie,"reference-file"),X.appendChild(ie),this.file=new ee.IconLabel(ie),this.badge=new J.CountBadge(Q.append(ie,Q.$(".count")));var oe=Le.attachBadgeStyler(this.badge,te);this.dispose=function(){ne.file.dispose(),oe.dispose()}}return e.prototype.set=function(X){var $=pe.dirname(X.uri);this.file.setValue(de.getBaseLabel(X.uri),$?this._uriLabel.getUriLabel($,{relative:!0}):void 0,{title:this._uriLabel.getUriLabel(X.uri)});var Q=X.children.length;this.badge.setCount(Q),X.failure?this.badge.setTitleFormat(ye.localize(0,null)):Q>1?this.badge.setTitleFormat(ye.localize(1,null,Q)):this.badge.setTitleFormat(ye.localize(2,null,Q))},ne([oe(1,we.ILabelService),oe(2,xe.IThemeService)],e)}(),Re=function(){function e(X){var $=document.createElement("div");this.before=document.createElement("span"),this.inside=document.createElement("span"),this.after=document.createElement("span"),Q.addClass(this.inside,"referenceMatch"),Q.addClass($,"reference"),$.appendChild(this.before),$.appendChild(this.inside),$.appendChild(this.after),X.appendChild($)}return e.prototype.set=function(X){var $=X.parent.preview.preview(X.range),Q=$.before,J=$.inside,ee=$.after;this.before.innerHTML=fe.escape(Q),this.inside.innerHTML=fe.escape(J),this.after.innerHTML=fe.escape(ee)},e}(),Oe=function(){function e(X,$){this._themeService=X,this._uriLabel=$}return e.prototype.getHeight=function(X,$){return 23},e.prototype.getTemplateId=function(X,$){if($ instanceof De.FileReferences)return e._ids.FileReferences;if($ instanceof De.OneReference)return e._ids.OneReference;throw $},e.prototype.renderTemplate=function(X,$,Q){if($===e._ids.FileReferences)return new Te(Q,this._uriLabel,this._themeService);if($===e._ids.OneReference)return new Re(Q);throw $},e.prototype.renderElement=function(X,$,Q,J){if($ instanceof De.FileReferences)J.set($);else{if(!($ instanceof De.OneReference))throw Q;J.set($)}},e.prototype.disposeTemplate=function(X,$,Q){Q instanceof Te&&Q.dispose()},e._ids={FileReferences:"FileReferences",OneReference:"OneReference"},e=ne([oe(0,xe.IThemeService),oe(1,we.ILabelService)],e)}(),Pe=function(){function e(){}return e.prototype.getAriaLabel=function(X,$){return $ instanceof De.FileReferences||$ instanceof De.OneReference?$.getAriaMessage():void 0},e}(),Ae=function(){function e(X,$){var Q,J=this;this._disposables=[],this._onDidChangePercentages=new ue.Emitter,this._ratio=$,this._sash=new ie.Sash(X,{getVerticalSashLeft:function(){return J._width*J._ratio},getVerticalSashHeight:function(){return J._height}}),this._disposables.push(this._sash.onDidStart((function(X){Q=X.startX-J._width*J.ratio}))),this._disposables.push(this._sash.onDidChange((function(X){var $=X.currentX-Q;$>20&&$+20<J._width&&(J._ratio=$/J._width,J._sash.layout(),J._onDidChangePercentages.fire(J))})))}return e.prototype.dispose=function(){this._sash.dispose(),this._onDidChangePercentages.dispose(),ce.dispose(this._disposables)},Object.defineProperty(e.prototype,"onDidChangePercentages",{get:function(){return this._onDidChangePercentages.event},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"width",{set:function(X){this._width=X,this._sash.layout()},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"height",{set:function(X){this._height=X,this._sash.layout()},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"percentages",{get:function(){var X=100*this._ratio;return[X+"%",100-X+"%"]},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"ratio",{get:function(){return this._ratio},enumerable:!0,configurable:!0}),e}();$.ctxReferenceWidgetSearchTreeFocused=new be.RawContextKey("referenceSearchTreeFocused",!0);var Fe=function(X){function i($,Q,J,ee,te,ne,ie){var oe=X.call(this,$,{showFrame:!1,showArrow:!0,isResizeable:!0,isAccessible:!0})||this;return oe._defaultTreeKeyboardSupport=Q,oe.layoutData=J,oe._textModelResolverService=te,oe._instantiationService=ne,oe._uriLabel=ie,oe._disposeOnNewModel=[],oe._callOnDispose=[],oe._onDidSelectReference=new ue.Emitter,oe._applyTheme(ee.getTheme()),oe._callOnDispose.push(ee.onThemeChange(oe._applyTheme.bind(oe))),oe.create(),oe}return te(i,X),i.prototype._applyTheme=function(X){var Q=X.getColor($.peekViewBorder)||ae.Color.transparent;this.style({arrowColor:Q,frameColor:Q,headerBackgroundColor:X.getColor($.peekViewTitleBackground)||ae.Color.transparent,primaryHeadingColor:X.getColor($.peekViewTitleForeground),secondaryHeadingColor:X.getColor($.peekViewTitleInfoForeground)})},i.prototype.dispose=function(){this.setModel(null),this._callOnDispose=ce.dispose(this._callOnDispose),ce.dispose(this._preview,this._previewNotAvailableMessage,this._tree,this._sash,this._previewModelReference),X.prototype.dispose.call(this)},Object.defineProperty(i.prototype,"onDidSelectReference",{get:function(){return this._onDidSelectReference.event},enumerable:!0,configurable:!0}),i.prototype.show=function($){this.editor.revealRangeInCenterIfOutsideViewport($,0),X.prototype.show.call(this,$,this.layoutData.heightInLines||18)},i.prototype.focus=function(){this._tree.domFocus()},i.prototype._onTitleClick=function(X){this._preview&&this._preview.getModel()&&this._onDidSelectReference.fire({element:this._getFocusedReference(),kind:X.ctrlKey||X.metaKey||X.altKey?"side":"open",source:"title"})},i.prototype._fillBody=function(X){var J=this;this.setCssClass("reference-zone-widget"),this._messageContainer=Q.append(X,Q.$("div.messages")),Q.hide(this._messageContainer),this._previewContainer=Q.append(X,Q.$("div.preview.inline")),this._preview=this._instantiationService.createInstance(ge.EmbeddedCodeEditorWidget,this._previewContainer,{scrollBeyondLastLine:!1,scrollbar:{verticalScrollbarSize:14,horizontal:"auto",useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1},overviewRulerLanes:2,fixedOverflowWidgets:!0,minimap:{enabled:!1}},this.editor),Q.hide(this._previewContainer),this._previewNotAvailableMessage=ve.TextModel.createFromString(ye.localize(3,null)),this._sash=new Ae(X,this.layoutData.ratio||.8),this._sash.onDidChangePercentages((function(){var X=J._sash.percentages,$=X[0],Q=X[1];J._previewContainer.style.width=$,J._treeContainer.style.width=Q,J._preview.layout(),J._tree.layout(),J.layoutData.ratio=J._sash.ratio})),this._treeContainer=Q.append(X,Q.$("div.ref-tree.inline"));var ee=this._instantiationService.createInstance(ke,{keyboardSupport:this._defaultTreeKeyboardSupport,clickBehavior:1});this._callOnDispose.push(ee);var te={dataSource:this._instantiationService.createInstance(Me),renderer:this._instantiationService.createInstance(Oe),controller:ee,accessibilityProvider:new Pe},ne={twistiePixels:20,ariaLabel:ye.localize(4,null)};this._tree=this._instantiationService.createInstance(Se.WorkbenchTree,this._treeContainer,te,ne),$.ctxReferenceWidgetSearchTreeFocused.bindTo(this._tree.contextKeyService);var a=function(X,$){X instanceof De.OneReference&&("show"===$&&J._revealReference(X,!1),J._onDidSelectReference.fire({element:X,kind:$,source:"tree"}))};this._disposables.push(this._tree.onDidChangeFocus((function(X){X&&X.payload&&"keyboard"===X.payload.origin&&a(X.focus,"show")}))),this._disposables.push(this._tree.onDidChangeSelection((function(X){X&&X.payload&&"keyboard"===X.payload.origin&&a(X.selection[0],"goto")}))),this._disposables.push(ee.onDidFocus((function(X){return a(X,"show")}))),this._disposables.push(ee.onDidSelect((function(X){return a(X,"goto")}))),this._disposables.push(ee.onDidOpenToSide((function(X){return a(X,"side")}))),Q.hide(this._treeContainer)},i.prototype._doLayoutBody=function($,Q){X.prototype._doLayoutBody.call(this,$,Q);var J=$+"px";this._sash.height=$,this._sash.width=Q;var ee=this._sash.percentages,te=ee[0],ne=ee[1];this._previewContainer.style.height=J,this._previewContainer.style.width=te,this._treeContainer.style.height=J,this._treeContainer.style.width=ne,this._tree.layout($),this._preview.layout(),this.layoutData={heightInLines:this._viewZone.heightInLines,ratio:this._sash.ratio}},i.prototype._onWidth=function(X){this._sash.width=X,this._preview.layout()},i.prototype.setSelection=function(X){var $=this;return this._revealReference(X,!0).then((function(){$._model&&($._tree.setSelection([X]),$._tree.setFocus(X))}))},i.prototype.setModel=function(X){if(this._disposeOnNewModel=ce.dispose(this._disposeOnNewModel),this._model=X,this._model)return this._onNewModel()},i.prototype._onNewModel=function(){var X=this;if(this._model.empty)return this.setTitle(""),this._messageContainer.innerHTML=ye.localize(5,null),Q.show(this._messageContainer),Promise.resolve(void 0);Q.hide(this._messageContainer),this._decorationsManager=new Ne(this._preview,this._model),this._disposeOnNewModel.push(this._decorationsManager),this._disposeOnNewModel.push(this._model.onDidChangeReferenceRange((function($){return X._tree.refresh($)}))),this._disposeOnNewModel.push(this._preview.onMouseDown((function($){var Q=$.event,J=$.target;2===Q.detail&&X._onDidSelectReference.fire({element:{uri:X._getFocusedReference().uri,range:J.range},kind:Q.ctrlKey||Q.metaKey||Q.altKey?"side":"open",source:"editor"})}))),Q.addClass(this.container,"results-loaded"),Q.show(this._treeContainer),Q.show(this._previewContainer),this._preview.layout(),this._tree.layout(),this.focus();var $=1===this._model.groups.length?this._model.groups[0]:this._model;return this._tree.setInput($)},i.prototype._getFocusedReference=function(){var X=this._tree.getFocus();return X instanceof De.OneReference?X:X instanceof De.FileReferences&&X.children.length>0?X.children[0]:void 0},i.prototype._revealReference=function(X,$){return re(this,void 0,void 0,(function(){var Q,J=this;return se(this,(function(ee){switch(ee.label){case 0:return X.uri.scheme!==he.Schemas.inMemory?this.setTitle(pe.basenameOrAuthority(X.uri),this._uriLabel.getUriLabel(pe.dirname(X.uri))):this.setTitle(ye.localize(6,null)),Q=this._textModelResolverService.createModelReference(X.uri),$?[4,this._tree.reveal(X.parent)]:[3,2];case 1:ee.sent(),ee.label=2;case 2:return[2,Promise.all([Q,this._tree.reveal(X)]).then((function($){var Q=$[0];if(J._model){ce.dispose(J._previewModelReference);var ee=Q.object;if(ee){J._previewModelReference=Q;var te=J._preview.getModel()===ee.textEditorModel;J._preview.setModel(ee.textEditorModel);var ne=me.Range.lift(X.range).collapseToStart();J._preview.setSelection(ne),J._preview.revealRangeInCenter(ne,te?0:1)}else J._preview.setModel(J._previewNotAvailableMessage),Q.dispose()}else Q.dispose()}),le.onUnexpectedError)]}}))}))},ne([oe(3,xe.IThemeService),oe(4,_e.ITextModelService),oe(5,Ce.IInstantiationService),oe(6,we.ILabelService)],i)}(Ie.PeekViewWidget);$.ReferenceWidget=Fe,$.peekViewTitleBackground=Ee.registerColor("peekViewTitle.background",{dark:"#1E1E1E",light:"#FFFFFF",hc:"#0C141F"},ye.localize(7,null)),$.peekViewTitleForeground=Ee.registerColor("peekViewTitleLabel.foreground",{dark:"#FFFFFF",light:"#333333",hc:"#FFFFFF"},ye.localize(8,null)),$.peekViewTitleInfoForeground=Ee.registerColor("peekViewTitleDescription.foreground",{dark:"#ccccccb3",light:"#6c6c6cb3",hc:"#FFFFFF99"},ye.localize(9,null)),$.peekViewBorder=Ee.registerColor("peekView.border",{dark:"#007acc",light:"#007acc",hc:Ee.contrastBorder},ye.localize(10,null)),$.peekViewResultsBackground=Ee.registerColor("peekViewResult.background",{dark:"#252526",light:"#F3F3F3",hc:ae.Color.black},ye.localize(11,null)),$.peekViewResultsMatchForeground=Ee.registerColor("peekViewResult.lineForeground",{dark:"#bbbbbb",light:"#646465",hc:ae.Color.white},ye.localize(12,null)),$.peekViewResultsFileForeground=Ee.registerColor("peekViewResult.fileForeground",{dark:ae.Color.white,light:"#1E1E1E",hc:ae.Color.white},ye.localize(13,null)),$.peekViewResultsSelectionBackground=Ee.registerColor("peekViewResult.selectionBackground",{dark:"#3399ff33",light:"#3399ff33",hc:null},ye.localize(14,null)),$.peekViewResultsSelectionForeground=Ee.registerColor("peekViewResult.selectionForeground",{dark:ae.Color.white,light:"#6C6C6C",hc:ae.Color.white},ye.localize(15,null)),$.peekViewEditorBackground=Ee.registerColor("peekViewEditor.background",{dark:"#001F33",light:"#F2F8FC",hc:ae.Color.black},ye.localize(16,null)),$.peekViewEditorGutterBackground=Ee.registerColor("peekViewEditorGutter.background",{dark:$.peekViewEditorBackground,light:$.peekViewEditorBackground,hc:$.peekViewEditorBackground},ye.localize(17,null)),$.peekViewResultsMatchHighlight=Ee.registerColor("peekViewResult.matchHighlightBackground",{dark:"#ea5c004d",light:"#ea5c004d",hc:null},ye.localize(18,null)),$.peekViewEditorMatchHighlight=Ee.registerColor("peekViewEditor.matchHighlightBackground",{dark:"#ff8f0099",light:"#f5d802de",hc:null},ye.localize(19,null)),$.peekViewEditorMatchHighlightBorder=Ee.registerColor("peekViewEditor.matchHighlightBorder",{dark:null,light:null,hc:Ee.activeContrastBorder},ye.localize(20,null)),xe.registerThemingParticipant((function(X,Q){var J=X.getColor($.peekViewResultsMatchHighlight);J&&Q.addRule(".monaco-editor .reference-zone-widget .ref-tree .referenceMatch { background-color: "+J+"; }");var ee=X.getColor($.peekViewEditorMatchHighlight);ee&&Q.addRule(".monaco-editor .reference-zone-widget .preview .reference-decoration { background-color: "+ee+"; }");var te=X.getColor($.peekViewEditorMatchHighlightBorder);te&&Q.addRule(".monaco-editor .reference-zone-widget .preview .reference-decoration { border: 2px solid "+te+"; box-sizing: border-box; }");var ne=X.getColor(Ee.activeContrastBorder);ne&&Q.addRule(".monaco-editor .reference-zone-widget .ref-tree .referenceMatch { border: 1px dotted "+ne+"; box-sizing: border-box; }");var ie=X.getColor($.peekViewResultsBackground);ie&&Q.addRule(".monaco-editor .reference-zone-widget .ref-tree { background-color: "+ie+"; }");var oe=X.getColor($.peekViewResultsMatchForeground);oe&&Q.addRule(".monaco-editor .reference-zone-widget .ref-tree { color: "+oe+"; }");var re=X.getColor($.peekViewResultsFileForeground);re&&Q.addRule(".monaco-editor .reference-zone-widget .ref-tree .reference-file { color: "+re+"; }");var se=X.getColor($.peekViewResultsSelectionBackground);se&&Q.addRule(".monaco-editor .reference-zone-widget .ref-tree .monaco-tree.focused .monaco-tree-rows > .monaco-tree-row.selected:not(.highlighted) { background-color: "+se+"; }");var ae=X.getColor($.peekViewResultsSelectionForeground);ae&&Q.addRule(".monaco-editor .reference-zone-widget .ref-tree .monaco-tree.focused .monaco-tree-rows > .monaco-tree-row.selected:not(.highlighted) { color: "+ae+" !important; }");var le=X.getColor($.peekViewEditorBackground);le&&Q.addRule(".monaco-editor .reference-zone-widget .preview .monaco-editor .monaco-editor-background,.monaco-editor .reference-zone-widget .preview .monaco-editor .inputarea.ime-input {\tbackground-color: "+le+";}");var ue=X.getColor($.peekViewEditorGutterBackground);ue&&Q.addRule(".monaco-editor .reference-zone-widget .preview .monaco-editor .margin {\tbackground-color: "+ue+";}")}))})),define(Q[146],n([0,1,329,11,2,30,15,18,45,71,197,3,12,35]),(function(X,$,Q,J,ee,te,ie,ae,le,ue,de,ce,he,pe){Object.defineProperty($,"__esModule",{value:!0}),$.ctxReferenceSearchVisible=new ae.RawContextKey("referenceSearchVisible",!1);var fe=function(){function e(X,Q,J,ee,te,ne,ie,oe){this._defaultTreeKeyboardSupport=X,this._editorService=ee,this._notificationService=te,this._instantiationService=ne,this._storageService=ie,this._configurationService=oe,this._requestIdPool=0,this._disposables=[],this._ignoreModelChangeEvent=!1,this._editor=Q,this._referenceSearchVisible=$.ctxReferenceSearchVisible.bindTo(J)}return e.get=function(X){return X.getContribution(e.ID)},e.prototype.getId=function(){return e.ID},e.prototype.dispose=function(){this._referenceSearchVisible.reset(),ee.dispose(this._disposables),ee.dispose(this._widget),ee.dispose(this._model),this._widget=null,this._model=null,this._editor=null},e.prototype.toggleWidget=function(X,$,J){var ee,te=this;if(this._widget&&(ee=this._widget.position),this.closeWidget(),ee&&X.containsPosition(ee))return null;this._referenceSearchVisible.set(!0),this._disposables.push(this._editor.onDidChangeModelLanguage((function(){te.closeWidget()}))),this._disposables.push(this._editor.onDidChangeModel((function(){te._ignoreModelChangeEvent||te.closeWidget()})));var ne=JSON.parse(this._storageService.get("peekViewLayout",0,"{}"));this._widget=this._instantiationService.createInstance(de.ReferenceWidget,this._editor,this._defaultTreeKeyboardSupport,ne),this._widget.setTitle(Q.localize(0,null)),this._widget.show(X),this._disposables.push(this._widget.onDidClose((function(){$.cancel(),te._storageService.store("peekViewLayout",JSON.stringify(te._widget.layoutData),0),te._widget=null,te.closeWidget()}))),this._disposables.push(this._widget.onDidSelectReference((function(X){var $=X.element,Q=X.kind;switch(Q){case"open":if("editor"===X.source&&te._configurationService.getValue("editor.stablePeek"))break;case"side":te.openReference($,"side"===Q);break;case"goto":J.onGoto?J.onGoto($):te._gotoReference($)}})));var ie=++this._requestIdPool;$.then((function($){if(ie===te._requestIdPool&&te._widget)return te._model&&te._model.dispose(),te._model=$,te._widget.setModel(te._model).then((function(){if(te._widget){te._widget.setMetaTitle(J.getMetaTitle(te._model));var $=te._editor.getModel().uri,Q=new he.Position(X.startLineNumber,X.startColumn),ee=te._model.nearestReference($,Q);if(ee)return te._widget.setSelection(ee)}}))}),(function(X){te._notificationService.error(X)}))},e.prototype.goToNextOrPreviousReference=function(X){return re(this,void 0,void 0,(function(){var $,Q,J;return se(this,(function(ee){switch(ee.label){case 0:return this._model?($=this._model.nearestReference(this._editor.getModel().uri,this._widget.position),Q=this._model.nextOrPreviousReference($,X),J=this._editor.hasTextFocus(),[4,this._widget.setSelection(Q)]):[3,3];case 1:return ee.sent(),[4,this._gotoReference(Q)];case 2:ee.sent(),J&&this._editor.focus(),ee.label=3;case 3:return[2]}}))}))},e.prototype.closeWidget=function(){ee.dispose(this._widget),this._widget=null,this._referenceSearchVisible.reset(),this._disposables=ee.dispose(this._disposables),ee.dispose(this._model),this._model=null,this._editor.focus(),this._requestIdPool+=1},e.prototype._gotoReference=function(X){var $=this;this._widget.hide(),this._ignoreModelChangeEvent=!0;var Q=ce.Range.lift(X.range).collapseToStart();return this._editorService.openCodeEditor({resource:X.uri,options:{selection:Q}},this._editor).then((function(X){$._ignoreModelChangeEvent=!1,X&&X===$._editor?($._widget.show(Q),$._widget.focus()):$.closeWidget()}),(function(X){$._ignoreModelChangeEvent=!1,J.onUnexpectedError(X)}))},e.prototype.openReference=function(X,$){$||this.closeWidget();var Q=X.uri,J=X.range;this._editorService.openCodeEditor({resource:Q,options:{selection:J}},this._editor,$)},e.ID="editor.contrib.referencesController",e=ne([oe(2,ae.IContextKeyService),oe(3,te.ICodeEditorService),oe(4,pe.INotificationService),oe(5,ie.IInstantiationService),oe(6,ue.IStorageService),oe(7,le.IConfigurationService)],e)}();$.ReferencesController=fe})),define(Q[199],n([0,1,43,16,24,36,17,10,30,3,19,141,142,146,123,314,37,18,35,89,176]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le,ue,de,ce,he,pe,fe,ge,me,ve){Object.defineProperty($,"__esModule",{value:!0});var S=function(X,$,Q,J){void 0===X&&(X=!1),void 0===$&&($=!1),void 0===Q&&(Q=!0),void 0===J&&(J=!0),this.openToSide=X,this.openInPeek=$,this.filterCurrent=Q,this.showMessage=J};$.DefinitionActionConfig=S;var _e=function(X){function t($,Q){var J=X.call(this,Q)||this;return J._configuration=$,J}return te(t,X),t.prototype.run=function(X,$){var Q=this,J=X.get(ge.INotificationService),te=X.get(re.ICodeEditorService),ne=X.get(me.IProgressService),ie=$.getModel(),oe=$.getPosition(),ae=this._getDeclarationsAtPosition(ie,oe,ee.CancellationToken.None).then((function(X){if(!ie.isDisposed()&&$.getModel()===ie){for(var J=-1,ee=[],ne=0;ne<X.length;ne++){var re=X[ne];if(re&&re.range){var ae=re.uri,ue=re.range,de=ee.push({uri:ae,range:ue});Q._configuration.filterCurrent&&ae.toString()===ie.uri.toString()&&se.Range.containsPosition(ue,oe)&&-1===J&&(J=de-1)}}if(0===ee.length){if(Q._configuration.showMessage){var he=ie.getWordAtPosition(oe);le.MessageController.get($).showMessage(Q._getNoResultFoundMessage(he),oe)}}else if(1===ee.length&&-1!==J){var pe=ee[0];Q._openReference($,te,pe,!1)}else Q._onResult(te,$,new ce.ReferencesModel(ee))}}),(function(X){J.error(X)}));return ne.showWhile(ae,250),ae},t.prototype._getDeclarationsAtPosition=function(X,$,Q){return ve.getDefinitionsAtPosition(X,$,Q)},t.prototype._getNoResultFoundMessage=function(X){return X&&X.word?he.localize(0,null,X.word):he.localize(1,null)},t.prototype._getMetaTitle=function(X){return X.references.length>1&&he.localize(2,null,X.references.length)},t.prototype._onResult=function(X,$,J){var ee=this,te=J.getAriaMessage();if(Q.alert(te),this._configuration.openInPeek)this._openInPeek(X,$,J);else{var ne=J.nearestReference($.getModel().uri,$.getPosition());this._openReference($,X,ne,this._configuration.openToSide).then((function($){$&&J.references.length>1?ee._openInPeek(X,$,J):J.dispose()}))}},t.prototype._openReference=function(X,$,Q,J){return $.openCodeEditor({resource:Q.uri,options:{selection:se.Range.collapseToStart(Q.range),revealIfOpened:!0,revealInCenterIfOutsideViewport:!0}},X,J)},t.prototype._openInPeek=function(X,$,Q){var ee=this,te=de.ReferencesController.get($);te?te.toggleWidget($.getSelection(),J.createCancelablePromise((function(X){return Promise.resolve(Q)})),{getMetaTitle:function(X){return ee._getMetaTitle(X)},onGoto:function(Q){return te.closeWidget(),ee._openReference($,X,Q,!1)}}):Q.dispose()},t}(oe.EditorAction);$.DefinitionAction=_e;var ye=ie.isWeb?2118:70,be=function(X){function t(){return X.call(this,new S,{id:t.ID,label:he.localize(3,null),alias:"Go to Definition",precondition:fe.ContextKeyExpr.and(ae.EditorContextKeys.hasDefinitionProvider,ae.EditorContextKeys.isInEmbeddedEditor.toNegated()),kbOpts:{kbExpr:ae.EditorContextKeys.editorTextFocus,primary:ye,weight:100},menuOpts:{group:"navigation",order:1.1}})||this}return te(t,X),t.ID="editor.action.goToDeclaration",t}(_e);$.GoToDefinitionAction=be;var Ce=function(X){function t(){return X.call(this,new S(!0),{id:t.ID,label:he.localize(4,null),alias:"Open Definition to the Side",precondition:fe.ContextKeyExpr.and(ae.EditorContextKeys.hasDefinitionProvider,ae.EditorContextKeys.isInEmbeddedEditor.toNegated()),kbOpts:{kbExpr:ae.EditorContextKeys.editorTextFocus,primary:ne.KeyChord(2089,ye),weight:100}})||this}return te(t,X),t.ID="editor.action.openDeclarationToTheSide",t}(_e);$.OpenDefinitionToSideAction=Ce;var we=function(X){function t(){return X.call(this,new S(void 0,!0,!1),{id:"editor.action.previewDeclaration",label:he.localize(5,null),alias:"Peek Definition",precondition:fe.ContextKeyExpr.and(ae.EditorContextKeys.hasDefinitionProvider,ue.PeekContext.notInPeekEditor,ae.EditorContextKeys.isInEmbeddedEditor.toNegated()),kbOpts:{kbExpr:ae.EditorContextKeys.editorTextFocus,primary:582,linux:{primary:3140},weight:100},menuOpts:{group:"navigation",order:1.2}})||this}return te(t,X),t}(_e);$.PeekDefinitionAction=we;var Se=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype._getDeclarationsAtPosition=function(X,$,Q){return ve.getImplementationsAtPosition(X,$,Q)},t.prototype._getNoResultFoundMessage=function(X){return X&&X.word?he.localize(6,null,X.word):he.localize(7,null)},t.prototype._getMetaTitle=function(X){return X.references.length>1&&he.localize(8,null,X.references.length)},t}(_e);$.ImplementationAction=Se;var Ee=function(X){function t(){return X.call(this,new S,{id:t.ID,label:he.localize(9,null),alias:"Go to Implementation",precondition:fe.ContextKeyExpr.and(ae.EditorContextKeys.hasImplementationProvider,ae.EditorContextKeys.isInEmbeddedEditor.toNegated()),kbOpts:{kbExpr:ae.EditorContextKeys.editorTextFocus,primary:2118,weight:100}})||this}return te(t,X),t.ID="editor.action.goToImplementation",t}(Se);$.GoToImplementationAction=Ee;var Le=function(X){function t(){return X.call(this,new S(!1,!0,!1),{id:t.ID,label:he.localize(10,null),alias:"Peek Implementation",precondition:fe.ContextKeyExpr.and(ae.EditorContextKeys.hasImplementationProvider,ae.EditorContextKeys.isInEmbeddedEditor.toNegated()),kbOpts:{kbExpr:ae.EditorContextKeys.editorTextFocus,primary:3142,weight:100}})||this}return te(t,X),t.ID="editor.action.peekImplementation",t}(Se);$.PeekImplementationAction=Le;var xe=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype._getDeclarationsAtPosition=function(X,$,Q){return ve.getTypeDefinitionsAtPosition(X,$,Q)},t.prototype._getNoResultFoundMessage=function(X){return X&&X.word?he.localize(11,null,X.word):he.localize(12,null)},t.prototype._getMetaTitle=function(X){return X.references.length>1&&he.localize(13,null,X.references.length)},t}(_e);$.TypeDefinitionAction=xe;var Ie=function(X){function t(){return X.call(this,new S,{id:t.ID,label:he.localize(14,null),alias:"Go to Type Definition",precondition:fe.ContextKeyExpr.and(ae.EditorContextKeys.hasTypeDefinitionProvider,ae.EditorContextKeys.isInEmbeddedEditor.toNegated()),kbOpts:{kbExpr:ae.EditorContextKeys.editorTextFocus,primary:0,weight:100},menuOpts:{group:"navigation",order:1.4}})||this}return te(t,X),t.ID="editor.action.goToTypeDefinition",t}(xe);$.GoToTypeDefinitionAction=Ie;var De=function(X){function t(){return X.call(this,new S(!1,!0,!1),{id:t.ID,label:he.localize(15,null),alias:"Peek Type Definition",precondition:fe.ContextKeyExpr.and(ae.EditorContextKeys.hasTypeDefinitionProvider,ae.EditorContextKeys.isInEmbeddedEditor.toNegated()),kbOpts:{kbExpr:ae.EditorContextKeys.editorTextFocus,primary:0,weight:100}})||this}return te(t,X),t.ID="editor.action.peekTypeDefinition",t}(xe);$.PeekTypeDefinitionAction=De,oe.registerEditorAction(be),oe.registerEditorAction(Ce),oe.registerEditorAction(we),oe.registerEditorAction(Ee),oe.registerEditorAction(Le),oe.registerEditorAction(Ie),oe.registerEditorAction(De),pe.MenuRegistry.appendMenuItem(pe.MenuId.MenubarGoMenu,{group:"z_go_to",command:{id:"editor.action.goToDeclaration",title:he.localize(16,null)},order:4}),pe.MenuRegistry.appendMenuItem(pe.MenuId.MenubarGoMenu,{group:"z_go_to",command:{id:"editor.action.goToTypeDefinition",title:he.localize(17,null)},order:5}),pe.MenuRegistry.appendMenuItem(pe.MenuId.MenubarGoMenu,{group:"z_go_to",command:{id:"editor.action.goToImplementation",title:he.localize(18,null)},order:6})})),define(Q[551],n([0,1,315,16,11,68,63,3,14,10,176,2,92,13,20,66,199,183,12,163]),(function(X,$,Q,J,ee,te,ie,re,se,ae,le,ue,de,ce,he,pe,fe,ge,me){Object.defineProperty($,"__esModule",{value:!0});var ve=function(){function e(X,$,Q){var J=this;this.textModelResolverService=$,this.modeService=Q,this.toUnhook=[],this.decorations=[],this.editor=X,this.previousPromise=null;var te=new ge.ClickLinkGesture(X);this.toUnhook.push(te),this.toUnhook.push(te.onMouseMoveOrRelevantKeyDown((function(X){var $=X[0],Q=X[1];J.startFindDefinition($,Q)}))),this.toUnhook.push(te.onExecute((function(X){J.isEnabled(X)&&J.gotoDefinition(X.target,X.hasSideBySideModifier).then((function(){J.removeDecorations()}),(function(X){J.removeDecorations(),ee.onUnexpectedError(X)}))}))),this.toUnhook.push(te.onCancel((function(){J.removeDecorations(),J.currentWordUnderMouse=null})))}return e.prototype.startFindDefinition=function(X,$){var ne=this;if(!this.isEnabled(X,$))return this.currentWordUnderMouse=null,void this.removeDecorations();var ie=X.target.position,oe=ie?this.editor.getModel().getWordAtPosition(ie):null;if(!oe)return this.currentWordUnderMouse=null,void this.removeDecorations();if(!this.currentWordUnderMouse||this.currentWordUnderMouse.startColumn!==oe.startColumn||this.currentWordUnderMouse.endColumn!==oe.endColumn||this.currentWordUnderMouse.word!==oe.word){this.currentWordUnderMouse=oe;var se=new pe.EditorState(this.editor,15);this.previousPromise&&(this.previousPromise.cancel(),this.previousPromise=null),this.previousPromise=J.createCancelablePromise((function($){return ne.findDefinition(X.target,$)})),this.previousPromise.then((function(X){if(X&&X.length&&se.validate(ne.editor))if(X.length>1)ne.addDecoration(new re.Range(ie.lineNumber,oe.startColumn,ie.lineNumber,oe.endColumn),(new te.MarkdownString).appendText(Q.localize(0,null,X.length)));else{var $=X[0];if(!$.uri)return;ne.textModelResolverService.createModelReference($.uri).then((function(X){if(X.object&&X.object.textEditorModel){var Q=X.object.textEditorModel,J=$.range.startLineNumber;if(J<1||J>Q.getLineCount())X.dispose();else{var ee,se=ne.getPreviewValue(Q,J);ee=$.origin?re.Range.lift($.origin):new re.Range(ie.lineNumber,oe.startColumn,ie.lineNumber,oe.endColumn),ne.addDecoration(ee,(new te.MarkdownString).appendCodeblock(ne.modeService.getModeIdByFilepathOrFirstLine(Q.uri.fsPath),se)),X.dispose()}}else X.dispose()}))}else ne.removeDecorations()})).then(void 0,ee.onUnexpectedError)}},e.prototype.getPreviewValue=function(X,$){var Q=this.getPreviewRangeBasedOnBrackets(X,$);return Q.endLineNumber-Q.startLineNumber>=e.MAX_SOURCE_PREVIEW_LINES&&(Q=this.getPreviewRangeBasedOnIndentation(X,$)),this.stripIndentationFromPreviewRange(X,$,Q)},e.prototype.stripIndentationFromPreviewRange=function(X,$,Q){for(var J=X.getLineFirstNonWhitespaceColumn($),ee=$+1;ee<Q.endLineNumber;ee++){var te=X.getLineFirstNonWhitespaceColumn(ee);J=Math.min(J,te)}return X.getValueInRange(Q).replace(new RegExp("^\\s{"+(J-1)+"}","gm"),"").trim()},e.prototype.getPreviewRangeBasedOnIndentation=function(X,$){for(var Q=X.getLineFirstNonWhitespaceColumn($),J=Math.min(X.getLineCount(),$+e.MAX_SOURCE_PREVIEW_LINES),ee=$+1;ee<J&&Q!==X.getLineFirstNonWhitespaceColumn(ee);ee++);return new re.Range($,1,ee+1,1)},e.prototype.getPreviewRangeBasedOnBrackets=function(X,$){for(var Q=Math.min(X.getLineCount(),$+e.MAX_SOURCE_PREVIEW_LINES),J=[],ee=!0,te=X.findNextBracket(new me.Position($,1));null!==te;){if(0===J.length)J.push(te);else{var ne=J[J.length-1];if(ne.open===te.open&&ne.isOpen&&!te.isOpen?J.pop():J.push(te),0===J.length){if(!ee)return new re.Range($,1,te.range.endLineNumber+1,1);ee=!1}}var ie=X.getLineMaxColumn($),oe=te.range.endLineNumber,se=te.range.endColumn;if(ie===te.range.endColumn&&(oe++,se=1),oe>Q)return new re.Range($,1,Q+1,1);te=X.findNextBracket(new me.Position(oe,se))}return new re.Range($,1,Q+1,1)},e.prototype.addDecoration=function(X,$){var Q={range:X,options:{inlineClassName:"goto-definition-link",hoverMessage:$}};this.decorations=this.editor.deltaDecorations(this.decorations,[Q])},e.prototype.removeDecorations=function(){this.decorations.length>0&&(this.decorations=this.editor.deltaDecorations(this.decorations,[]))},e.prototype.isEnabled=function(X,$){return this.editor.getModel()&&X.isNoneOrSingleMouseDown&&6===X.target.type&&(X.hasTriggerModifier||$&&$.keyCodeIsTriggerKey)&&se.DefinitionProviderRegistry.has(this.editor.getModel())},e.prototype.findDefinition=function(X,$){var Q=this.editor.getModel();return Q?le.getDefinitionsAtPosition(Q,X.position,$):Promise.resolve(null)},e.prototype.gotoDefinition=function(X,$){var Q=this;this.editor.setPosition(X.position);var J=new fe.DefinitionAction(new fe.DefinitionActionConfig($,!1,!0,!1),{alias:void 0,label:void 0,id:void 0,precondition:void 0});return this.editor.invokeWithinContext((function(X){return J.run(X,Q.editor)}))},e.prototype.getId=function(){return e.ID},e.prototype.dispose=function(){this.toUnhook=ue.dispose(this.toUnhook)},e.ID="editor.contrib.gotodefinitionwithmouse",e.MAX_SOURCE_PREVIEW_LINES=8,e=ne([oe(1,de.ITextModelService),oe(2,ie.IModeService)],e)}();ae.registerEditorContribution(ve),ce.registerThemingParticipant((function(X,$){var Q=X.getColor(he.editorActiveLinkForeground);Q&&$.addRule(".monaco-editor .goto-definition-link { color: "+Q+" !important; }")}))})),define(Q[552],n([0,1,328,18,95,12,10,14,3,142,146,123,16,11,19,139,105,145,197,31,25,30,24]),(function(X,$,Q,J,ee,ie,re,se,ae,le,ue,de,ce,he,pe,fe,ge,me,ve,_e,ye,be,Ce){function x(X,$){I(X,(function(X){return X.closeWidget()}))}function I(X,$){var Q=le.getOuterEditor(X);if(Q){var J=ue.ReferencesController.get(Q);J&&$(J)}}function N(X,$,Q){var J=se.ReferenceProviderRegistry.ordered(X).map((function(J){return Promise.resolve(J.provideReferences(X,$,{includeDeclaration:!0},Q)).then((function(X){if(Array.isArray(X))return X}),(function(X){he.onUnexpectedExternalError(X)}))}));return Promise.all(J).then((function(X){for(var $=[],Q=0,J=X;Q<J.length;Q++){var ee=J[Q];ee&&$.push.apply($,ee)}return $}))}Object.defineProperty($,"__esModule",{value:!0}),$.defaultReferenceSearchOptions={getMetaTitle:function(X){return X.references.length>1&&Q.localize(0,null,X.references.length)}};var we=function(){function e(X,$){X instanceof fe.EmbeddedCodeEditorWidget&&le.PeekContext.inPeekEditor.bindTo($)}return e.prototype.dispose=function(){},e.prototype.getId=function(){return e.ID},e.ID="editor.contrib.referenceController",e=ne([oe(1,J.IContextKeyService)],e)}();$.ReferenceController=we;var Se=function(X){function r(){return X.call(this,{id:"editor.action.referenceSearch.trigger",label:Q.localize(1,null),alias:"Find All References",precondition:J.ContextKeyExpr.and(pe.EditorContextKeys.hasReferenceProvider,le.PeekContext.notInPeekEditor,pe.EditorContextKeys.isInEmbeddedEditor.toNegated()),kbOpts:{kbExpr:pe.EditorContextKeys.editorTextFocus,primary:1094,weight:100},menuOpts:{group:"navigation",order:1.5}})||this}return te(r,X),r.prototype.run=function(X,Q){var J=ue.ReferencesController.get(Q);if(J){var ee=Q.getSelection(),te=Q.getModel(),ne=ce.createCancelablePromise((function(X){return N(te,ee.getStartPosition(),X).then((function(X){return new de.ReferencesModel(X)}))}));J.toggleWidget(ee,ne,$.defaultReferenceSearchOptions)}},r}(re.EditorAction);$.ReferenceAction=Se,re.registerEditorContribution(we),re.registerEditorAction(Se),_e.CommandsRegistry.registerCommand({id:"editor.action.findReferences",handler:function(X,Q,J){if(!(Q instanceof ye.URI))throw new Error("illegal argument, uri");if(!J)throw new Error("illegal argument, position");var ee=X.get(be.ICodeEditorService);return ee.openCodeEditor({resource:Q},ee.getFocusedCodeEditor()).then((function(X){if(ge.isCodeEditor(X)){var Q=ue.ReferencesController.get(X);if(Q){var ee=ce.createCancelablePromise((function($){return N(X.getModel(),ie.Position.lift(J),$).then((function(X){return new de.ReferencesModel(X)}))})),te=new ae.Range(J.lineNumber,J.column,J.lineNumber,J.column);return Promise.resolve(Q.toggleWidget(te,ee,$.defaultReferenceSearchOptions))}}}))}}),_e.CommandsRegistry.registerCommand({id:"editor.action.showReferences",handler:function(X,Q,J,ee){if(!(Q instanceof ye.URI))throw new Error("illegal argument, uri expected");if(!ee)throw new Error("missing references");var te=X.get(be.ICodeEditorService);return te.openCodeEditor({resource:Q},te.getFocusedCodeEditor()).then((function(X){if(ge.isCodeEditor(X)){var Q=ue.ReferencesController.get(X);if(Q)return Promise.resolve(Q.toggleWidget(new ae.Range(J.lineNumber,J.column,J.lineNumber,J.column),ce.createCancelablePromise((function(X){return Promise.resolve(new de.ReferencesModel(ee))})),$.defaultReferenceSearchOptions)).then((function(){return!0}))}}))},description:{description:"Show references at a position in a file",args:[{name:"uri",description:"The text document in which to show references",constraint:ye.URI},{name:"position",description:"The position at which to show",constraint:ie.Position.isIPosition},{name:"locations",description:"An array of locations.",constraint:Array}]}}),ee.KeybindingsRegistry.registerCommandAndKeybindingRule({id:"goToNextReference",weight:250,primary:62,when:ue.ctxReferenceSearchVisible,handler:function(X){I(X,(function(X){X.goToNextOrPreviousReference(!0)}))}}),ee.KeybindingsRegistry.registerCommandAndKeybindingRule({id:"goToNextReferenceFromEmbeddedEditor",weight:150,primary:62,when:le.PeekContext.inPeekEditor,handler:function(X){I(X,(function(X){X.goToNextOrPreviousReference(!0)}))}}),ee.KeybindingsRegistry.registerCommandAndKeybindingRule({id:"goToPreviousReference",weight:250,primary:1086,when:ue.ctxReferenceSearchVisible,handler:function(X){I(X,(function(X){X.goToNextOrPreviousReference(!1)}))}}),ee.KeybindingsRegistry.registerCommandAndKeybindingRule({id:"goToPreviousReferenceFromEmbeddedEditor",weight:150,primary:1086,when:le.PeekContext.inPeekEditor,handler:function(X){I(X,(function(X){X.goToNextOrPreviousReference(!1)}))}}),ee.KeybindingsRegistry.registerCommandAndKeybindingRule({id:"closeReferenceSearch",weight:250,primary:9,secondary:[1033],when:J.ContextKeyExpr.and(ue.ctxReferenceSearchVisible,J.ContextKeyExpr.not("config.editor.stablePeek")),handler:x}),ee.KeybindingsRegistry.registerCommandAndKeybindingRule({id:"closeReferenceSearchEditor",weight:-1,primary:9,secondary:[1033],when:J.ContextKeyExpr.and(le.PeekContext.inPeekEditor,J.ContextKeyExpr.not("config.editor.stablePeek")),handler:x}),ee.KeybindingsRegistry.registerCommandAndKeybindingRule({id:"openReferenceToSide",weight:100,primary:2051,mac:{primary:259},when:J.ContextKeyExpr.and(ue.ctxReferenceSearchVisible,ve.ctxReferenceWidgetSearchTreeFocused),handler:function(X,$){var Q=X.get(me.IListService),J=Q.lastFocusedList&&Q.lastFocusedList.getFocus();J instanceof de.OneReference&&I(X,(function(X){return X.openReference(J,!0)}))}}),$.provideReferences=N,re.registerDefaultLanguageCommand("_executeReferenceProvider",(function(X,$){return N(X,$,Ce.CancellationToken.None)}))})),define(Q[553],n([0,1,10,30,146,45,18,15,35,71]),(function(X,$,Q,J,ee,ie,re,se,ae,le){Object.defineProperty($,"__esModule",{value:!0});var ue=function(X){function t($,Q,J,ee,te,ne,ie){return X.call(this,!0,$,Q,J,ee,te,ne,ie)||this}return te(t,X),ne([oe(1,re.IContextKeyService),oe(2,J.ICodeEditorService),oe(3,ae.INotificationService),oe(4,se.IInstantiationService),oe(5,le.IStorageService),oe(6,ie.IConfigurationService)],t)}(ee.ReferencesController);$.StandaloneReferencesController=ue,Q.registerEditorContribution(ue)})),define(Q[554],n([0,1,18]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),$.bindContextScopedWidget=function(X,$,J){new Q.RawContextKey(J,$).bindTo(X)},$.createWidgetScopedContextKeyService=function(X,$){return X.createScoped($.target)},$.getContextScopedWidget=function(X,$){return X.getContext(document.activeElement).getValue($)}})),define(Q[555],n([0,1,18,117,275,554,95]),(function(X,$,Q,J,ee,ie,re){function d(X,J){var ee=ie.createWidgetScopedContextKeyService(X,J);return ie.bindContextScopedWidget(ee,J,$.HistoryNavigationWidgetContext),{scopedContextKeyService:ee,historyNavigationEnablement:new Q.RawContextKey($.HistoryNavigationEnablementContext,!0).bindTo(ee)}}Object.defineProperty($,"__esModule",{value:!0}),$.HistoryNavigationWidgetContext="historyNavigationWidget",$.HistoryNavigationEnablementContext="historyNavigationEnabled",$.createAndBindHistoryNavigationWidgetScopedContextKeyService=d;var se=function(X){function t($,Q,J,ee){var te=X.call(this,$,Q,J)||this;return te._register(d(ee,{target:te.element,historyNavigator:te}).scopedContextKeyService),te}return te(t,X),ne([oe(3,Q.IContextKeyService)],t)}(J.HistoryInputBox);$.ContextScopedHistoryInputBox=se;var ae=function(X){function t($,Q,J,ee,te){void 0===te&&(te=!1);var ne=X.call(this,$,Q,te,J)||this;return ne._register(d(ee,{target:ne.inputBox.element,historyNavigator:ne.inputBox}).scopedContextKeyService),ne}return te(t,X),ne([oe(3,Q.IContextKeyService)],t)}(ee.FindInput);$.ContextScopedFindInput=ae,re.KeybindingsRegistry.registerCommandAndKeybindingRule({id:"history.showPrevious",weight:200,when:Q.ContextKeyExpr.and(new Q.ContextKeyDefinedExpr($.HistoryNavigationWidgetContext),new Q.ContextKeyEqualsExpr($.HistoryNavigationEnablementContext,!0)),primary:16,secondary:[528],handler:function(X,J){ie.getContextScopedWidget(X.get(Q.IContextKeyService),$.HistoryNavigationWidgetContext).historyNavigator.showPreviousValue()}}),re.KeybindingsRegistry.registerCommandAndKeybindingRule({id:"history.showNext",weight:200,when:new Q.ContextKeyAndExpr([new Q.ContextKeyDefinedExpr($.HistoryNavigationWidgetContext),new Q.ContextKeyEqualsExpr($.HistoryNavigationEnablementContext,!0)]),primary:18,secondary:[530],handler:function(X,J){ie.getContextScopedWidget(X.get(Q.IContextKeyService),$.HistoryNavigationWidgetContext).historyNavigator.showNextValue()}})})),define(Q[556],n([0,1,310,7,102,46,16,11,2,17,8,3,140,20,13,555,366]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le,ue,de,ce,he){Object.defineProperty($,"__esModule",{value:!0});var pe=Q.localize(0,null),fe=Q.localize(1,null),ge=Q.localize(2,null),me=Q.localize(3,null),ve=Q.localize(4,null),_e=Q.localize(5,null),ye=Q.localize(6,null),be=Q.localize(7,null),Ce=Q.localize(8,null),we=Q.localize(9,null),Se=Q.localize(10,null),Ee=Q.localize(11,null,ue.MATCHES_LIMIT),Le=Q.localize(12,null),xe=Q.localize(13,null),Ie=69,De=17+(Ie+3+1)+92+2,Ne=34,O=function(X){this.afterLineNumber=X,this.heightInPx=Ne,this.suppressMouseDown=!1,this.domNode=document.createElement("div"),this.domNode.className="dock-find-viewzone"};$.FindWidgetViewZone=O;var Me=function(X){function t($,Q,ee,te,ne,oe,se){var ae=X.call(this)||this;return ae._codeEditor=$,ae._controller=Q,ae._state=ee,ae._contextViewProvider=te,ae._keybindingService=ne,ae._contextKeyService=oe,ae._isVisible=!1,ae._isReplaceVisible=!1,ae._ignoreChangeEvent=!1,ae._updateHistoryDelayer=new ie.Delayer(500),ae._register(re.toDisposable((function(){return ae._updateHistoryDelayer.cancel()}))),ae._register(ae._state.onFindReplaceStateChange((function(X){return ae._onStateChanged(X)}))),ae._buildDomNode(),ae._updateButtons(),ae._tryUpdateWidgetWidth(),ae._register(ae._codeEditor.onDidChangeConfiguration((function(X){X.readOnly&&(ae._codeEditor.getConfiguration().readOnly&&ae._state.change({isReplaceRevealed:!1},!1),ae._updateButtons()),X.layoutInfo&&ae._tryUpdateWidgetWidth(),X.accessibilitySupport&&ae.updateAccessibilitySupport()}))),ae.updateAccessibilitySupport(),ae._register(ae._codeEditor.onDidChangeCursorSelection((function(){ae._isVisible&&ae._updateToggleSelectionFindButton()}))),ae._register(ae._codeEditor.onDidFocusEditorWidget((function(){if(ae._isVisible){var X=ae._controller.getGlobalBufferTerm();X&&X!==ae._state.searchString&&(ae._state.change({searchString:X},!0),ae._findInput.select())}}))),ae._findInputFocused=ue.CONTEXT_FIND_INPUT_FOCUSED.bindTo(oe),ae._findFocusTracker=ae._register(J.trackFocus(ae._findInput.inputBox.inputElement)),ae._register(ae._findFocusTracker.onDidFocus((function(){ae._findInputFocused.set(!0),ae._updateSearchScope()}))),ae._register(ae._findFocusTracker.onDidBlur((function(){ae._findInputFocused.set(!1)}))),ae._replaceInputFocused=ue.CONTEXT_REPLACE_INPUT_FOCUSED.bindTo(oe),ae._replaceFocusTracker=ae._register(J.trackFocus(ae._replaceInputBox.inputElement)),ae._register(ae._replaceFocusTracker.onDidFocus((function(){ae._replaceInputFocused.set(!0),ae._updateSearchScope()}))),ae._register(ae._replaceFocusTracker.onDidBlur((function(){ae._replaceInputFocused.set(!1)}))),ae._codeEditor.addOverlayWidget(ae),ae._viewZone=new O(0),ae._applyTheme(se.getTheme()),ae._register(se.onThemeChange(ae._applyTheme.bind(ae))),ae._register(ae._codeEditor.onDidChangeModel((function(){ae._isVisible&&void 0!==ae._viewZoneId&&ae._codeEditor.changeViewZones((function(X){X.removeZone(ae._viewZoneId),ae._viewZoneId=void 0}))}))),ae._register(ae._codeEditor.onDidScrollChange((function(X){X.scrollTopChanged?ae._layoutViewZone():setTimeout((function(){ae._layoutViewZone()}),0)}))),ae}return te(t,X),t.prototype.getId=function(){return t.ID},t.prototype.getDomNode=function(){return this._domNode},t.prototype.getPosition=function(){return this._isVisible?{preference:0}:null},t.prototype._onStateChanged=function(X){if(X.searchString){try{this._ignoreChangeEvent=!0,this._findInput.setValue(this._state.searchString)}finally{this._ignoreChangeEvent=!1}this._updateButtons()}if(X.replaceString&&(this._replaceInputBox.value=this._state.replaceString),X.isRevealed&&(this._state.isRevealed?this._reveal():this._hide(!0)),X.isReplaceRevealed&&(this._state.isReplaceRevealed?this._codeEditor.getConfiguration().readOnly||this._isReplaceVisible||(this._isReplaceVisible=!0,this._replaceInputBox.width=this._findInput.inputBox.width,this._updateButtons()):this._isReplaceVisible&&(this._isReplaceVisible=!1,this._updateButtons())),X.isRegex&&this._findInput.setRegex(this._state.isRegex),X.wholeWord&&this._findInput.setWholeWords(this._state.wholeWord),X.matchCase&&this._findInput.setCaseSensitive(this._state.matchCase),X.searchScope&&(this._state.searchScope?this._toggleSelectionFind.checked=!0:this._toggleSelectionFind.checked=!1,this._updateToggleSelectionFindButton()),X.searchString||X.matchesCount||X.matchesPosition){var $=this._state.searchString.length>0&&0===this._state.matchesCount;J.toggleClass(this._domNode,"no-results",$),this._updateMatchesCount(),this._updateButtons()}(X.searchString||X.currentMatch)&&this._layoutViewZone(),X.updateHistory&&this._delayedUpdateHistory()},t.prototype._delayedUpdateHistory=function(){this._updateHistoryDelayer.trigger(this._updateHistory.bind(this))},t.prototype._updateHistory=function(){this._state.searchString&&this._findInput.inputBox.addToHistory(),this._state.replaceString&&this._replaceInputBox.addToHistory()},t.prototype._updateMatchesCount=function(){var X;if(this._matchesCount.style.minWidth=Ie+"px",this._state.matchesCount>=ue.MATCHES_LIMIT?this._matchesCount.title=Ee:this._matchesCount.title="",this._matchesCount.firstChild&&this._matchesCount.removeChild(this._matchesCount.firstChild),this._state.matchesCount>0){var $=String(this._state.matchesCount);this._state.matchesCount>=ue.MATCHES_LIMIT&&($+="+");var Q=String(this._state.matchesPosition);"0"===Q&&(Q="?"),X=ae.format(Le,Q,$)}else X=xe;this._matchesCount.appendChild(document.createTextNode(X)),Ie=Math.max(Ie,this._matchesCount.clientWidth)},t.prototype._updateToggleSelectionFindButton=function(){var X=this._codeEditor.getSelection(),$=!!X&&(X.startLineNumber!==X.endLineNumber||X.startColumn!==X.endColumn),Q=this._toggleSelectionFind.checked;this._toggleSelectionFind.setEnabled(this._isVisible&&(Q||$))},t.prototype._updateButtons=function(){this._findInput.setEnabled(this._isVisible),this._replaceInputBox.setEnabled(this._isVisible&&this._isReplaceVisible),this._updateToggleSelectionFindButton(),this._closeBtn.setEnabled(this._isVisible);var X=this._state.searchString.length>0,$=!!this._state.matchesCount;this._prevBtn.setEnabled(this._isVisible&&X&&$),this._nextBtn.setEnabled(this._isVisible&&X&&$),this._replaceBtn.setEnabled(this._isVisible&&this._isReplaceVisible&&X),this._replaceAllBtn.setEnabled(this._isVisible&&this._isReplaceVisible&&X),J.toggleClass(this._domNode,"replaceToggled",this._isReplaceVisible),this._toggleReplaceBtn.toggleClass("collapse",!this._isReplaceVisible),this._toggleReplaceBtn.toggleClass("expand",this._isReplaceVisible),this._toggleReplaceBtn.setExpanded(this._isReplaceVisible);var Q=!this._codeEditor.getConfiguration().readOnly;this._toggleReplaceBtn.setEnabled(this._isVisible&&Q)},t.prototype._reveal=function(){var X=this;if(!this._isVisible){this._isVisible=!0;var $=this._codeEditor.getSelection();$&&($.startLineNumber!==$.endLineNumber||$.startColumn!==$.endColumn)&&this._codeEditor.getConfiguration().contribInfo.find.autoFindInSelection?this._toggleSelectionFind.checked=!0:this._toggleSelectionFind.checked=!1,this._tryUpdateWidgetWidth(),this._updateButtons(),setTimeout((function(){J.addClass(X._domNode,"visible"),X._domNode.setAttribute("aria-hidden","false")}),0),setTimeout((function(){X._findInput.validate()}),200),this._codeEditor.layoutOverlayWidget(this);var Q=!0;if(this._codeEditor.getConfiguration().contribInfo.find.seedSearchStringFromSelection&&$){var ee=J.getDomNodePagePosition(this._codeEditor.getDomNode()),te=this._codeEditor.getScrolledVisiblePosition($.getStartPosition()),ne=ee.left+te.left;if(te.top<this._viewZone.heightInPx){$.endLineNumber>$.startLineNumber&&(Q=!1);var ie=J.getTopLeftOffset(this._domNode).left;ne>ie&&(Q=!1);var oe=this._codeEditor.getScrolledVisiblePosition($.getEndPosition());ee.left+oe.left>ie&&(Q=!1)}}this._showViewZone(Q)}},t.prototype._hide=function(X){var $=this;this._isVisible&&(this._isVisible=!1,this._updateButtons(),J.removeClass(this._domNode,"visible"),this._domNode.setAttribute("aria-hidden","true"),this._findInput.clearMessage(),X&&this._codeEditor.focus(),this._codeEditor.layoutOverlayWidget(this),this._codeEditor.changeViewZones((function(X){void 0!==$._viewZoneId&&(X.removeZone($._viewZoneId),$._viewZoneId=void 0,$._codeEditor.setScrollTop($._codeEditor.getScrollTop()-$._viewZone.heightInPx))})))},t.prototype._layoutViewZone=function(){var X=this;this._isVisible&&void 0===this._viewZoneId&&this._codeEditor.changeViewZones((function($){X._state.isReplaceRevealed?X._viewZone.heightInPx=64:X._viewZone.heightInPx=Ne,X._viewZoneId=$.addZone(X._viewZone),X._codeEditor.setScrollTop(X._codeEditor.getScrollTop()+X._viewZone.heightInPx)}))},t.prototype._showViewZone=function(X){var $=this;void 0===X&&(X=!0),this._isVisible&&this._codeEditor.changeViewZones((function(Q){var J=Ne;void 0!==$._viewZoneId?($._state.isReplaceRevealed?($._viewZone.heightInPx=64,J=30):($._viewZone.heightInPx=Ne,J=-30),Q.removeZone($._viewZoneId)):$._viewZone.heightInPx=Ne,$._viewZoneId=Q.addZone($._viewZone),X&&$._codeEditor.setScrollTop($._codeEditor.getScrollTop()+J)}))},t.prototype._applyTheme=function(X){var $={inputActiveOptionBorder:X.getColor(de.inputActiveOptionBorder),inputBackground:X.getColor(de.inputBackground),inputForeground:X.getColor(de.inputForeground),inputBorder:X.getColor(de.inputBorder),inputValidationInfoBackground:X.getColor(de.inputValidationInfoBackground),inputValidationInfoForeground:X.getColor(de.inputValidationInfoForeground),inputValidationInfoBorder:X.getColor(de.inputValidationInfoBorder),inputValidationWarningBackground:X.getColor(de.inputValidationWarningBackground),inputValidationWarningForeground:X.getColor(de.inputValidationWarningForeground),inputValidationWarningBorder:X.getColor(de.inputValidationWarningBorder),inputValidationErrorBackground:X.getColor(de.inputValidationErrorBackground),inputValidationErrorForeground:X.getColor(de.inputValidationErrorForeground),inputValidationErrorBorder:X.getColor(de.inputValidationErrorBorder)};this._findInput.style($),this._replaceInputBox.style($)},t.prototype._tryUpdateWidgetWidth=function(){if(this._isVisible){var X=this._codeEditor.getConfiguration().layoutInfo.width,$=this._codeEditor.getConfiguration().layoutInfo.minimapWidth,Q=!1,ee=!1,te=!1;if(this._resized&&J.getTotalWidth(this._domNode)>411)return this._domNode.style.maxWidth=X-28-$-15+"px",void(this._replaceInputBox.inputElement.style.width=J.getTotalWidth(this._findInput.inputBox.inputElement)+"px");if(439+$>=X&&(ee=!0),439+$-Ie>=X&&(te=!0),439+$-Ie>=X+50&&(Q=!0),J.toggleClass(this._domNode,"collapsed-find-widget",Q),J.toggleClass(this._domNode,"narrow-find-widget",te),J.toggleClass(this._domNode,"reduced-find-widget",ee),te||Q||(this._domNode.style.maxWidth=X-28-$-15+"px"),this._resized){var ne=J.getTotalWidth(this._findInput.inputBox.inputElement);ne>0&&(this._replaceInputBox.inputElement.style.width=ne+"px")}}},t.prototype.focusFindInput=function(){this._findInput.select(),this._findInput.focus()},t.prototype.focusReplaceInput=function(){this._replaceInputBox.select(),this._replaceInputBox.focus()},t.prototype.highlightFindOptions=function(){this._findInput.highlightFindOptions()},t.prototype._updateSearchScope=function(){if(this._toggleSelectionFind.checked){var X=this._codeEditor.getSelection();1===X.endColumn&&X.endLineNumber>X.startLineNumber&&(X=X.setEndPosition(X.endLineNumber-1,this._codeEditor.getModel().getLineMaxColumn(X.endLineNumber-1)));var $=this._state.currentMatch;X.startLineNumber!==X.endLineNumber&&(le.Range.equalsRange(X,$)||this._state.change({searchScope:X},!0))}},t.prototype._onFindInputMouseDown=function(X){X.middleButton&&X.stopPropagation()},t.prototype._onFindInputKeyDown=function(X){return X.equals(3)?(this._codeEditor.getAction(ue.FIND_IDS.NextMatchFindAction).run().then(null,oe.onUnexpectedError),void X.preventDefault()):X.equals(1027)?(this._codeEditor.getAction(ue.FIND_IDS.PreviousMatchFindAction).run().then(null,oe.onUnexpectedError),void X.preventDefault()):X.equals(2)?(this._isReplaceVisible?this._replaceInputBox.focus():this._findInput.focusOnCaseSensitive(),void X.preventDefault()):X.equals(2066)?(this._codeEditor.focus(),void X.preventDefault()):void 0},t.prototype._onReplaceInputKeyDown=function(X){return X.equals(3)?(this._controller.replace(),void X.preventDefault()):X.equals(2051)?(this._controller.replaceAll(),void X.preventDefault()):X.equals(2)?(this._findInput.focusOnCaseSensitive(),void X.preventDefault()):X.equals(1026)?(this._findInput.focus(),void X.preventDefault()):X.equals(2066)?(this._codeEditor.focus(),void X.preventDefault()):void 0},t.prototype.getHorizontalSashTop=function(X){return 0},t.prototype.getHorizontalSashLeft=function(X){return 0},t.prototype.getHorizontalSashWidth=function(X){return 500},t.prototype._keybindingLabelFor=function(X){var $=this._keybindingService.lookupKeybinding(X);return $?" ("+$.getLabel()+")":""},t.prototype._buildFindPart=function(){var X=this;this._findInput=this._register(new he.ContextScopedFindInput(null,this._contextViewProvider,{width:221,label:pe,placeholder:fe,appendCaseSensitiveLabel:this._keybindingLabelFor(ue.FIND_IDS.ToggleCaseSensitiveCommand),appendWholeWordsLabel:this._keybindingLabelFor(ue.FIND_IDS.ToggleWholeWordCommand),appendRegexLabel:this._keybindingLabelFor(ue.FIND_IDS.ToggleRegexCommand),validation:function($){if(0===$.length)return null;if(!X._findInput.getRegex())return null;try{return new RegExp($),null}catch(X){return{content:X.message}}}},this._contextKeyService,!0)),this._findInput.setRegex(!!this._state.isRegex),this._findInput.setCaseSensitive(!!this._state.matchCase),this._findInput.setWholeWords(!!this._state.wholeWord),this._register(this._findInput.onKeyDown((function($){return X._onFindInputKeyDown($)}))),this._register(this._findInput.inputBox.onDidChange((function(){X._ignoreChangeEvent||X._state.change({searchString:X._findInput.getValue()},!0)}))),this._register(this._findInput.onDidOptionChange((function(){X._state.change({isRegex:X._findInput.getRegex(),wholeWord:X._findInput.getWholeWords(),matchCase:X._findInput.getCaseSensitive()},!0)}))),this._register(this._findInput.onCaseSensitiveKeyDown((function($){$.equals(1026)&&X._isReplaceVisible&&(X._replaceInputBox.focus(),$.preventDefault())}))),se.isLinux&&this._register(this._findInput.onMouseDown((function($){return X._onFindInputMouseDown($)}))),this._matchesCount=document.createElement("div"),this._matchesCount.className="matchesCount",this._updateMatchesCount(),this._prevBtn=this._register(new Te({label:ge+this._keybindingLabelFor(ue.FIND_IDS.PreviousMatchFindAction),className:"previous",onTrigger:function(){X._codeEditor.getAction(ue.FIND_IDS.PreviousMatchFindAction).run().then(null,oe.onUnexpectedError)}})),this._nextBtn=this._register(new Te({label:me+this._keybindingLabelFor(ue.FIND_IDS.NextMatchFindAction),className:"next",onTrigger:function(){X._codeEditor.getAction(ue.FIND_IDS.NextMatchFindAction).run().then(null,oe.onUnexpectedError)}}));var $=document.createElement("div");return $.className="find-part",$.appendChild(this._findInput.domNode),$.appendChild(this._matchesCount),$.appendChild(this._prevBtn.domNode),$.appendChild(this._nextBtn.domNode),this._toggleSelectionFind=this._register(new ke({parent:$,title:ve+this._keybindingLabelFor(ue.FIND_IDS.ToggleSearchScopeCommand),onChange:function(){if(X._toggleSelectionFind.checked){var $=X._codeEditor.getSelection();1===$.endColumn&&$.endLineNumber>$.startLineNumber&&($=$.setEndPosition($.endLineNumber-1,X._codeEditor.getModel().getLineMaxColumn($.endLineNumber-1))),$.isEmpty()||X._state.change({searchScope:$},!0)}else X._state.change({searchScope:null},!0)}})),this._closeBtn=this._register(new Te({label:_e+this._keybindingLabelFor(ue.FIND_IDS.CloseFindWidgetCommand),className:"close-fw",onTrigger:function(){X._state.change({isRevealed:!1,searchScope:null},!1)},onKeyDown:function($){$.equals(2)&&X._isReplaceVisible&&(X._replaceBtn.isEnabled()?X._replaceBtn.focus():X._codeEditor.focus(),$.preventDefault())}})),$.appendChild(this._closeBtn.domNode),$},t.prototype._buildReplacePart=function(){var X=this,$=document.createElement("div");$.className="replace-input",$.style.width="221px",this._replaceInputBox=this._register(new he.ContextScopedHistoryInputBox($,null,{ariaLabel:ye,placeholder:be,history:[]},this._contextKeyService)),this._register(J.addStandardDisposableListener(this._replaceInputBox.inputElement,"keydown",(function($){return X._onReplaceInputKeyDown($)}))),this._register(this._replaceInputBox.onDidChange((function(){X._state.change({replaceString:X._replaceInputBox.value},!1)}))),this._replaceBtn=this._register(new Te({label:Ce+this._keybindingLabelFor(ue.FIND_IDS.ReplaceOneAction),className:"replace",onTrigger:function(){X._controller.replace()},onKeyDown:function($){$.equals(1026)&&(X._closeBtn.focus(),$.preventDefault())}})),this._replaceAllBtn=this._register(new Te({label:we+this._keybindingLabelFor(ue.FIND_IDS.ReplaceAllAction),className:"replace-all",onTrigger:function(){X._controller.replaceAll()}}));var Q=document.createElement("div");return Q.className="replace-part",Q.appendChild($),Q.appendChild(this._replaceBtn.domNode),Q.appendChild(this._replaceAllBtn.domNode),Q},t.prototype._buildDomNode=function(){var X=this,$=this._buildFindPart(),Q=this._buildReplacePart();this._toggleReplaceBtn=this._register(new Te({label:Se,className:"toggle left",onTrigger:function(){X._state.change({isReplaceRevealed:!X._isReplaceVisible},!1),X._isReplaceVisible&&(X._replaceInputBox.width=X._findInput.inputBox.width),X._showViewZone()}})),this._toggleReplaceBtn.toggleClass("expand",this._isReplaceVisible),this._toggleReplaceBtn.toggleClass("collapse",!this._isReplaceVisible),this._toggleReplaceBtn.setExpanded(this._isReplaceVisible),this._domNode=document.createElement("div"),this._domNode.className="editor-widget find-widget",this._domNode.setAttribute("aria-hidden","true"),this._domNode.style.width="411px",this._domNode.appendChild(this._toggleReplaceBtn.domNode),this._domNode.appendChild($),this._domNode.appendChild(Q),this._buildSash()},t.prototype._buildSash=function(){var X=this;this._resizeSash=new ee.Sash(this._domNode,this,{orientation:0}),this._resized=!1;var $=411;this._register(this._resizeSash.onDidStart((function(){$=J.getTotalWidth(X._domNode)}))),this._register(this._resizeSash.onDidChange((function(Q){X._resized=!0;var ee=$+Q.startX-Q.currentX;if(!(ee<411)){var te=ee-De;ee>(parseFloat(J.getComputedStyle(X._domNode).maxWidth)||0)||(X._domNode.style.width=ee+"px",X._isReplaceVisible&&(X._replaceInputBox.width=te))}})))},t.prototype.updateAccessibilitySupport=function(){var X=this._codeEditor.getConfiguration().accessibilitySupport;this._findInput.setFocusInputOnOptionClick(2!==X)},t.ID="editor.contrib.findWidget",t}(ne.Widget);$.FindWidget=Me;var ke=function(X){function t($){var Q=X.call(this)||this;return Q._opts=$,Q._domNode=document.createElement("div"),Q._domNode.className="monaco-checkbox",Q._domNode.title=Q._opts.title,Q._domNode.tabIndex=0,Q._checkbox=document.createElement("input"),Q._checkbox.type="checkbox",Q._checkbox.className="checkbox",Q._checkbox.id="checkbox-"+t._COUNTER++,Q._checkbox.tabIndex=-1,Q._label=document.createElement("label"),Q._label.className="label",Q._label.htmlFor=Q._checkbox.id,Q._label.tabIndex=-1,Q._domNode.appendChild(Q._checkbox),Q._domNode.appendChild(Q._label),Q._opts.parent.appendChild(Q._domNode),Q.onchange(Q._checkbox,(function(){Q._opts.onChange()})),Q}return te(t,X),Object.defineProperty(t.prototype,"domNode",{get:function(){return this._domNode},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"checked",{get:function(){return this._checkbox.checked},set:function(X){this._checkbox.checked=X},enumerable:!0,configurable:!0}),t.prototype.enable=function(){this._checkbox.removeAttribute("disabled")},t.prototype.disable=function(){this._checkbox.disabled=!0},t.prototype.setEnabled=function(X){X?(this.enable(),this.domNode.tabIndex=0):(this.disable(),this.domNode.tabIndex=-1)},t._COUNTER=0,t}(ne.Widget),Te=function(X){function t($){var Q=X.call(this)||this;return Q._opts=$,Q._domNode=document.createElement("div"),Q._domNode.title=Q._opts.label,Q._domNode.tabIndex=0,Q._domNode.className="button "+Q._opts.className,Q._domNode.setAttribute("role","button"),Q._domNode.setAttribute("aria-label",Q._opts.label),Q.onclick(Q._domNode,(function(X){Q._opts.onTrigger(),X.preventDefault()})),Q.onkeydown(Q._domNode,(function(X){if(X.equals(10)||X.equals(3))return Q._opts.onTrigger(),void X.preventDefault();Q._opts.onKeyDown&&Q._opts.onKeyDown(X)})),Q}return te(t,X),Object.defineProperty(t.prototype,"domNode",{get:function(){return this._domNode},enumerable:!0,configurable:!0}),t.prototype.isEnabled=function(){return this._domNode.tabIndex>=0},t.prototype.focus=function(){this._domNode.focus()},t.prototype.setEnabled=function(X){J.toggleClass(this._domNode,"disabled",!X),this._domNode.setAttribute("aria-disabled",String(!X)),this._domNode.tabIndex=X?0:-1},t.prototype.setExpanded=function(X){this._domNode.setAttribute("aria-expanded",String(!!X))},t.prototype.toggleClass=function(X,$){J.toggleClass(this._domNode,X,$)},t}(ne.Widget);$.SimpleButton=Te,ce.registerThemingParticipant((function(X,$){var n=function(X,Q){Q&&$.addRule(".monaco-editor "+X+" { background-color: "+Q+"; }")};n(".findMatch",X.getColor(de.editorFindMatchHighlight)),n(".currentFindMatch",X.getColor(de.editorFindMatch)),n(".findScope",X.getColor(de.editorFindRangeHighlight)),n(".find-widget",X.getColor(de.editorWidgetBackground));var Q=X.getColor(de.widgetShadow);Q&&$.addRule(".monaco-editor .find-widget { box-shadow: 0 2px 8px "+Q+"; }");var J=X.getColor(de.editorFindMatchHighlightBorder);J&&$.addRule(".monaco-editor .findMatch { border: 1px "+("hc"===X.type?"dotted":"solid")+" "+J+"; box-sizing: border-box; }");var ee=X.getColor(de.editorFindMatchBorder);ee&&$.addRule(".monaco-editor .currentFindMatch { border: 2px solid "+ee+"; padding: 1px; box-sizing: border-box; }");var te=X.getColor(de.editorFindRangeHighlightBorder);te&&$.addRule(".monaco-editor .findScope { border: 1px "+("hc"===X.type?"dashed":"solid")+" "+te+"; }");var ne=X.getColor(de.contrastBorder);ne&&$.addRule(".monaco-editor .find-widget { border: 2px solid "+ne+"; }");var ie=X.getColor(de.errorForeground);ie&&$.addRule(".monaco-editor .find-widget.no-results .matchesCount { color: "+ie+"; }");var oe=X.getColor(de.editorWidgetResizeBorder);if(oe)$.addRule(".monaco-editor .find-widget .monaco-sash { background-color: "+oe+"; width: 3px !important; margin-left: -4px;}");else{var re=X.getColor(de.editorWidgetBorder);re&&$.addRule(".monaco-editor .find-widget .monaco-sash { background-color: "+re+"; width: 3px !important; margin-left: -4px;}")}var se=X.getColor(de.inputActiveOptionBorder);se&&$.addRule(".monaco-editor .find-widget .monaco-checkbox .checkbox:checked + .label { border: 1px solid "+se.toString()+"; }")}))})),define(Q[200],n([0,1,309,16,2,8,10,19,140,516,241,556,37,202,18,60,15,47,71,13]),(function(X,$,Q,J,ee,ie,re,se,ae,le,ue,de,ce,he,pe,fe,ge,me,ve,_e){function w(X){var $=X.getSelection();if($.startLineNumber===$.endLineNumber)if($.isEmpty()){var Q=X.getModel().getWordAtPosition($.getStartPosition());if(Q)return Q.word}else if(X.getModel().getValueLengthInRange($)<ye)return X.getModel().getValueInRange($);return null}Object.defineProperty($,"__esModule",{value:!0});var ye=524288;$.getSelectionSearchString=w;var be=function(X){function t($,Q,ee,te){var ne=X.call(this)||this;return ne._editor=$,ne._findWidgetVisible=ae.CONTEXT_FIND_WIDGET_VISIBLE.bindTo(Q),ne._contextKeyService=Q,ne._storageService=ee,ne._clipboardService=te,ne._updateHistoryDelayer=new J.Delayer(500),ne._state=ne._register(new ue.FindReplaceState),ne.loadQueryState(),ne._register(ne._state.onFindReplaceStateChange((function(X){return ne._onStateChanged(X)}))),ne._model=null,ne._register(ne._editor.onDidChangeModel((function(){var X=ne._editor.getModel()&&ne._state.isRevealed;ne.disposeModel(),ne._state.change({searchScope:null,matchCase:ne._storageService.getBoolean("editor.matchCase",1,!1),wholeWord:ne._storageService.getBoolean("editor.wholeWord",1,!1),isRegex:ne._storageService.getBoolean("editor.isRegex",1,!1)},!1),X&&ne._start({forceRevealReplace:!1,seedSearchStringFromSelection:!1,seedSearchStringFromGlobalClipboard:!1,shouldFocus:0,shouldAnimate:!1,updateSearchScope:!1})}))),ne}return te(t,X),t.get=function(X){return X.getContribution(t.ID)},t.prototype.dispose=function(){this.disposeModel(),X.prototype.dispose.call(this)},t.prototype.disposeModel=function(){this._model&&(this._model.dispose(),this._model=null)},t.prototype.getId=function(){return t.ID},t.prototype._onStateChanged=function(X){this.saveQueryState(X),X.isRevealed&&(this._state.isRevealed?this._findWidgetVisible.set(!0):(this._findWidgetVisible.reset(),this.disposeModel())),X.searchString&&this.setGlobalBufferTerm(this._state.searchString)},t.prototype.saveQueryState=function(X){X.isRegex&&this._storageService.store("editor.isRegex",this._state.actualIsRegex,1),X.wholeWord&&this._storageService.store("editor.wholeWord",this._state.actualWholeWord,1),X.matchCase&&this._storageService.store("editor.matchCase",this._state.actualMatchCase,1)},t.prototype.loadQueryState=function(){this._state.change({matchCase:this._storageService.getBoolean("editor.matchCase",1,this._state.matchCase),wholeWord:this._storageService.getBoolean("editor.wholeWord",1,this._state.wholeWord),isRegex:this._storageService.getBoolean("editor.isRegex",1,this._state.isRegex)},!1)},t.prototype.isFindInputFocused=function(){return ae.CONTEXT_FIND_INPUT_FOCUSED.getValue(this._contextKeyService)},t.prototype.getState=function(){return this._state},t.prototype.closeFindWidget=function(){this._state.change({isRevealed:!1,searchScope:null},!1),this._editor.focus()},t.prototype.toggleCaseSensitive=function(){this._state.change({matchCase:!this._state.matchCase},!1),this._state.isRevealed||this.highlightFindOptions()},t.prototype.toggleWholeWords=function(){this._state.change({wholeWord:!this._state.wholeWord},!1),this._state.isRevealed||this.highlightFindOptions()},t.prototype.toggleRegex=function(){this._state.change({isRegex:!this._state.isRegex},!1),this._state.isRevealed||this.highlightFindOptions()},t.prototype.toggleSearchScope=function(){if(this._state.searchScope)this._state.change({searchScope:null},!0);else{var X=this._editor.getSelection();1===X.endColumn&&X.endLineNumber>X.startLineNumber&&(X=X.setEndPosition(X.endLineNumber-1,this._editor.getModel().getLineMaxColumn(X.endLineNumber-1))),X.isEmpty()||this._state.change({searchScope:X},!0)}},t.prototype.setSearchString=function(X){this._state.isRegex&&(X=ie.escapeRegExpCharacters(X)),this._state.change({searchString:X},!1)},t.prototype.highlightFindOptions=function(){},t.prototype._start=function(X){if(this.disposeModel(),this._editor.getModel()){var $={isRevealed:!0};if(X.seedSearchStringFromSelection&&(Q=w(this._editor))&&(this._state.isRegex?$.searchString=ie.escapeRegExpCharacters(Q):$.searchString=Q),!$.searchString&&X.seedSearchStringFromGlobalClipboard){var Q=this.getGlobalBufferTerm();Q&&($.searchString=Q)}if(X.forceRevealReplace?$.isReplaceRevealed=!0:this._findWidgetVisible.get()||($.isReplaceRevealed=!1),X.updateSearchScope){var J=this._editor.getSelection();J.isEmpty()||($.searchScope=J)}this._state.change($,!1),this._model||(this._model=new ae.FindModelBoundToEditorModel(this._editor,this._state))}},t.prototype.start=function(X){this._start(X)},t.prototype.moveToNextMatch=function(){return!!this._model&&(this._model.moveToNextMatch(),!0)},t.prototype.moveToPrevMatch=function(){return!!this._model&&(this._model.moveToPrevMatch(),!0)},t.prototype.replace=function(){return!!this._model&&(this._model.replace(),!0)},t.prototype.replaceAll=function(){return!!this._model&&(this._model.replaceAll(),!0)},t.prototype.selectAllMatches=function(){return!!this._model&&(this._model.selectAllMatches(),this._editor.focus(),!0)},t.prototype.getGlobalBufferTerm=function(){return this._editor.getConfiguration().contribInfo.find.globalFindClipboard&&this._clipboardService&&!this._editor.getModel().isTooLargeForSyncing()?this._clipboardService.readFindText():""},t.prototype.setGlobalBufferTerm=function(X){this._editor.getConfiguration().contribInfo.find.globalFindClipboard&&this._clipboardService&&!this._editor.getModel().isTooLargeForSyncing()&&this._clipboardService.writeFindText(X)},t.ID="editor.contrib.findController",t=ne([oe(1,pe.IContextKeyService),oe(2,ve.IStorageService),oe(3,he.IClipboardService)],t)}(ee.Disposable);$.CommonFindController=be;var Ce=function(X){function t($,Q,J,ee,te,ne,ie){var oe=X.call(this,$,J,ne,ie)||this;return oe._contextViewService=Q,oe._keybindingService=ee,oe._themeService=te,oe}return te(t,X),t.prototype._start=function($){this._widget||this._createFindWidget(),!this._widget.getPosition()&&this._editor.getConfiguration().contribInfo.find.autoFindInSelection&&($.updateSearchScope=!0),X.prototype._start.call(this,$),2===$.shouldFocus?this._widget.focusReplaceInput():1===$.shouldFocus&&this._widget.focusFindInput()},t.prototype.highlightFindOptions=function(){this._widget||this._createFindWidget(),this._state.isRevealed?this._widget.highlightFindOptions():this._findOptionsWidget.highlightFindOptions()},t.prototype._createFindWidget=function(){this._widget=this._register(new de.FindWidget(this._editor,this,this._state,this._contextViewService,this._keybindingService,this._contextKeyService,this._themeService)),this._findOptionsWidget=this._register(new le.FindOptionsWidget(this._editor,this._state,this._keybindingService,this._themeService))},ne([oe(1,fe.IContextViewService),oe(2,pe.IContextKeyService),oe(3,me.IKeybindingService),oe(4,_e.IThemeService),oe(5,ve.IStorageService),oe(6,ge.optional(he.IClipboardService))],t)}(be);$.FindController=Ce;var we=function(X){function t(){return X.call(this,{id:ae.FIND_IDS.StartFindAction,label:Q.localize(0,null),alias:"Find",precondition:null,kbOpts:{kbExpr:null,primary:2084,weight:100},menubarOpts:{menuId:ce.MenuId.MenubarEditMenu,group:"3_find",title:Q.localize(1,null),order:1}})||this}return te(t,X),t.prototype.run=function(X,$){var Q=be.get($);Q&&Q.start({forceRevealReplace:!1,seedSearchStringFromSelection:$.getConfiguration().contribInfo.find.seedSearchStringFromSelection,seedSearchStringFromGlobalClipboard:$.getConfiguration().contribInfo.find.globalFindClipboard,shouldFocus:1,shouldAnimate:!0,updateSearchScope:!1})},t}(re.EditorAction);$.StartFindAction=we;var Se=function(X){function t(){return X.call(this,{id:ae.FIND_IDS.StartFindWithSelection,label:Q.localize(2,null),alias:"Find With Selection",precondition:null,kbOpts:{kbExpr:null,primary:0,mac:{primary:2083},weight:100}})||this}return te(t,X),t.prototype.run=function(X,$){var Q=be.get($);Q&&(Q.start({forceRevealReplace:!1,seedSearchStringFromSelection:!0,seedSearchStringFromGlobalClipboard:!1,shouldFocus:1,shouldAnimate:!0,updateSearchScope:!1}),Q.setGlobalBufferTerm(Q.getState().searchString))},t}(re.EditorAction);$.StartFindWithSelectionAction=Se;var Ee=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype.run=function(X,$){var Q=be.get($);Q&&!this._run(Q)&&(Q.start({forceRevealReplace:!1,seedSearchStringFromSelection:0===Q.getState().searchString.length&&$.getConfiguration().contribInfo.find.seedSearchStringFromSelection,seedSearchStringFromGlobalClipboard:!0,shouldFocus:0,shouldAnimate:!0,updateSearchScope:!1}),this._run(Q))},t}(re.EditorAction);$.MatchFindAction=Ee;var Le=function(X){function t(){return X.call(this,{id:ae.FIND_IDS.NextMatchFindAction,label:Q.localize(3,null),alias:"Find Next",precondition:null,kbOpts:{kbExpr:se.EditorContextKeys.focus,primary:61,mac:{primary:2085,secondary:[61]},weight:100}})||this}return te(t,X),t.prototype._run=function(X){return X.moveToNextMatch()},t}(Ee);$.NextMatchFindAction=Le;var xe=function(X){function t(){return X.call(this,{id:ae.FIND_IDS.PreviousMatchFindAction,label:Q.localize(4,null),alias:"Find Previous",precondition:null,kbOpts:{kbExpr:se.EditorContextKeys.focus,primary:1085,mac:{primary:3109,secondary:[1085]},weight:100}})||this}return te(t,X),t.prototype._run=function(X){return X.moveToPrevMatch()},t}(Ee);$.PreviousMatchFindAction=xe;var Ie=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype.run=function(X,$){var Q=be.get($);if(Q){var J=w($);J&&Q.setSearchString(J),this._run(Q)||(Q.start({forceRevealReplace:!1,seedSearchStringFromSelection:$.getConfiguration().contribInfo.find.seedSearchStringFromSelection,seedSearchStringFromGlobalClipboard:!1,shouldFocus:0,shouldAnimate:!0,updateSearchScope:!1}),this._run(Q))}},t}(re.EditorAction);$.SelectionMatchFindAction=Ie;var De=function(X){function t(){return X.call(this,{id:ae.FIND_IDS.NextSelectionMatchFindAction,label:Q.localize(5,null),alias:"Find Next Selection",precondition:null,kbOpts:{kbExpr:se.EditorContextKeys.focus,primary:2109,weight:100}})||this}return te(t,X),t.prototype._run=function(X){return X.moveToNextMatch()},t}(Ie);$.NextSelectionMatchFindAction=De;var Ne=function(X){function t(){return X.call(this,{id:ae.FIND_IDS.PreviousSelectionMatchFindAction,label:Q.localize(6,null),alias:"Find Previous Selection",precondition:null,kbOpts:{kbExpr:se.EditorContextKeys.focus,primary:3133,weight:100}})||this}return te(t,X),t.prototype._run=function(X){return X.moveToPrevMatch()},t}(Ie);$.PreviousSelectionMatchFindAction=Ne;var Me=function(X){function t(){return X.call(this,{id:ae.FIND_IDS.StartFindReplaceAction,label:Q.localize(7,null),alias:"Replace",precondition:null,kbOpts:{kbExpr:null,primary:2086,mac:{primary:2596},weight:100},menubarOpts:{menuId:ce.MenuId.MenubarEditMenu,group:"3_find",title:Q.localize(8,null),order:2}})||this}return te(t,X),t.prototype.run=function(X,$){if(!$.getConfiguration().readOnly){var Q=be.get($),J=$.getSelection(),ee=Q.isFindInputFocused(),te=!J.isEmpty()&&J.startLineNumber===J.endLineNumber&&$.getConfiguration().contribInfo.find.seedSearchStringFromSelection&&!ee,ne=ee||te?2:1;Q&&Q.start({forceRevealReplace:!0,seedSearchStringFromSelection:te,seedSearchStringFromGlobalClipboard:$.getConfiguration().contribInfo.find.seedSearchStringFromSelection,shouldFocus:ne,shouldAnimate:!0,updateSearchScope:!1})}},t}(re.EditorAction);$.StartFindReplaceAction=Me,re.registerEditorContribution(Ce),re.registerEditorAction(we),re.registerEditorAction(Se),re.registerEditorAction(Le),re.registerEditorAction(xe),re.registerEditorAction(De),re.registerEditorAction(Ne),re.registerEditorAction(Me);var ke=re.EditorCommand.bindToContribution(be.get);re.registerEditorCommand(new ke({id:ae.FIND_IDS.CloseFindWidgetCommand,precondition:ae.CONTEXT_FIND_WIDGET_VISIBLE,handler:function(X){return X.closeFindWidget()},kbOpts:{weight:105,kbExpr:se.EditorContextKeys.focus,primary:9,secondary:[1033]}})),re.registerEditorCommand(new ke({id:ae.FIND_IDS.ToggleCaseSensitiveCommand,precondition:null,handler:function(X){return X.toggleCaseSensitive()},kbOpts:{weight:105,kbExpr:se.EditorContextKeys.focus,primary:ae.ToggleCaseSensitiveKeybinding.primary,mac:ae.ToggleCaseSensitiveKeybinding.mac,win:ae.ToggleCaseSensitiveKeybinding.win,linux:ae.ToggleCaseSensitiveKeybinding.linux}})),re.registerEditorCommand(new ke({id:ae.FIND_IDS.ToggleWholeWordCommand,precondition:null,handler:function(X){return X.toggleWholeWords()},kbOpts:{weight:105,kbExpr:se.EditorContextKeys.focus,primary:ae.ToggleWholeWordKeybinding.primary,mac:ae.ToggleWholeWordKeybinding.mac,win:ae.ToggleWholeWordKeybinding.win,linux:ae.ToggleWholeWordKeybinding.linux}})),re.registerEditorCommand(new ke({id:ae.FIND_IDS.ToggleRegexCommand,precondition:null,handler:function(X){return X.toggleRegex()},kbOpts:{weight:105,kbExpr:se.EditorContextKeys.focus,primary:ae.ToggleRegexKeybinding.primary,mac:ae.ToggleRegexKeybinding.mac,win:ae.ToggleRegexKeybinding.win,linux:ae.ToggleRegexKeybinding.linux}})),re.registerEditorCommand(new ke({id:ae.FIND_IDS.ToggleSearchScopeCommand,precondition:null,handler:function(X){return X.toggleSearchScope()},kbOpts:{weight:105,kbExpr:se.EditorContextKeys.focus,primary:ae.ToggleSearchScopeKeybinding.primary,mac:ae.ToggleSearchScopeKeybinding.mac,win:ae.ToggleSearchScopeKeybinding.win,linux:ae.ToggleSearchScopeKeybinding.linux}})),re.registerEditorCommand(new ke({id:ae.FIND_IDS.ReplaceOneAction,precondition:ae.CONTEXT_FIND_WIDGET_VISIBLE,handler:function(X){return X.replace()},kbOpts:{weight:105,kbExpr:se.EditorContextKeys.focus,primary:3094}})),re.registerEditorCommand(new ke({id:ae.FIND_IDS.ReplaceAllAction,precondition:ae.CONTEXT_FIND_WIDGET_VISIBLE,handler:function(X){return X.replaceAll()},kbOpts:{weight:105,kbExpr:se.EditorContextKeys.focus,primary:2563}})),re.registerEditorCommand(new ke({id:ae.FIND_IDS.SelectAllMatchesAction,precondition:ae.CONTEXT_FIND_WIDGET_VISIBLE,handler:function(X){return X.selectAllMatches()},kbOpts:{weight:105,kbExpr:se.EditorContextKeys.focus,primary:515}}))})),define(Q[558],n([0,1,324,16,36,2,10,188,3,21,19,44,26,14,200,37,20,13]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le,ue,de,ce,he,pe,fe){function y(X,$,Q){for(var J=C(X,$[0],!Q),ee=1,te=$.length;ee<te;ee++){var ne=$[ee];if(ne.isEmpty())return!1;if(J!==C(X,ne,!Q))return!1}return!0}function C(X,$,Q){var J=X.getValueInRange($);return Q?J.toLowerCase():J}Object.defineProperty($,"__esModule",{value:!0});var ge=function(X){function t(){return X.call(this,{id:"editor.action.insertCursorAbove",label:Q.localize(0,null),alias:"Add Cursor Above",precondition:null,kbOpts:{kbExpr:ae.EditorContextKeys.editorTextFocus,primary:2576,linux:{primary:1552,secondary:[3088]},weight:100},menubarOpts:{menuId:he.MenuId.MenubarSelectionMenu,group:"3_multi",title:Q.localize(1,null),order:2}})||this}return te(t,X),t.prototype.run=function(X,$,Q){var J=Q&&!0===Q.logicalLine,ee=$._getCursors(),te=ee.context;te.config.readOnly||(te.model.pushStackElement(),ee.setStates(Q.source,3,oe.CursorMoveCommands.addCursorUp(te,ee.getAll(),J)),ee.reveal(!0,1,0))},t}(ie.EditorAction);$.InsertCursorAbove=ge;var me=function(X){function t(){return X.call(this,{id:"editor.action.insertCursorBelow",label:Q.localize(2,null),alias:"Add Cursor Below",precondition:null,kbOpts:{kbExpr:ae.EditorContextKeys.editorTextFocus,primary:2578,linux:{primary:1554,secondary:[3090]},weight:100},menubarOpts:{menuId:he.MenuId.MenubarSelectionMenu,group:"3_multi",title:Q.localize(3,null),order:3}})||this}return te(t,X),t.prototype.run=function(X,$,Q){var J=Q&&!0===Q.logicalLine,ee=$._getCursors(),te=ee.context;te.config.readOnly||(te.model.pushStackElement(),ee.setStates(Q.source,3,oe.CursorMoveCommands.addCursorDown(te,ee.getAll(),J)),ee.reveal(!0,2,0))},t}(ie.EditorAction);$.InsertCursorBelow=me;var ve=function(X){function t(){return X.call(this,{id:"editor.action.insertCursorAtEndOfEachLineSelected",label:Q.localize(4,null),alias:"Add Cursors to Line Ends",precondition:null,kbOpts:{kbExpr:ae.EditorContextKeys.editorTextFocus,primary:1575,weight:100},menubarOpts:{menuId:he.MenuId.MenubarSelectionMenu,group:"3_multi",title:Q.localize(5,null),order:4}})||this}return te(t,X),t.prototype.getCursorsForSelection=function(X,$,Q){if(!X.isEmpty()){for(var J=X.startLineNumber;J<X.endLineNumber;J++){var ee=$.getLineMaxColumn(J);Q.push(new se.Selection(J,ee,J,ee))}X.endColumn>1&&Q.push(new se.Selection(X.endLineNumber,X.endColumn,X.endLineNumber,X.endColumn))}},t.prototype.run=function(X,$){var Q=this,J=$.getModel(),ee=[];$.getSelections().forEach((function(X){return Q.getCursorsForSelection(X,J,ee)})),ee.length>0&&$.setSelections(ee)},t}(ie.EditorAction),E=function(X,$,Q){this.selections=X,this.revealRange=$,this.revealScrollType=Q};$.MultiCursorSessionResult=E;var _e=function(){function e(X,$,Q,J,ee,te,ne){this._editor=X,this.findController=$,this.isDisconnectedFromFindController=Q,this.searchText=J,this.wholeWord=ee,this.matchCase=te,this.currentMatch=ne}return e.create=function(X,$){var Q=$.getState();if(!X.hasTextFocus()&&Q.isRevealed&&Q.searchString.length>0)return new e(X,$,!1,Q.searchString,Q.wholeWord,Q.matchCase,null);var J,ee,te=!1,ne=X.getSelections();1===ne.length&&ne[0].isEmpty()?(te=!0,J=!0,ee=!0):(J=Q.wholeWord,ee=Q.matchCase);var ie,oe=X.getSelection(),re=null;if(oe.isEmpty()){var ae=X.getModel().getWordAtPosition(oe.getStartPosition());if(!ae)return null;ie=ae.word,re=new se.Selection(oe.startLineNumber,ae.startColumn,oe.startLineNumber,ae.endColumn)}else ie=X.getModel().getValueInRange(oe).replace(/\r\n/g,"\n");return new e(X,$,te,ie,J,ee,re)},e.prototype.addSelectionToNextFindMatch=function(){var X=this._getNextMatch();if(!X)return null;var $=this._editor.getSelections();return new E($.concat(X),X,0)},e.prototype.moveSelectionToNextFindMatch=function(){var X=this._getNextMatch();if(!X)return null;var $=this._editor.getSelections();return new E($.slice(0,$.length-1).concat(X),X,0)},e.prototype._getNextMatch=function(){if(this.currentMatch){var X=this.currentMatch;return this.currentMatch=null,X}this.findController.highlightFindOptions();var $=this._editor.getSelections(),Q=$[$.length-1],J=this._editor.getModel().findNextMatch(this.searchText,Q.getEndPosition(),!1,this.matchCase,this.wholeWord?this._editor.getConfiguration().wordSeparators:null,!1);return J?new se.Selection(J.range.startLineNumber,J.range.startColumn,J.range.endLineNumber,J.range.endColumn):null},e.prototype.addSelectionToPreviousFindMatch=function(){var X=this._getPreviousMatch();if(!X)return null;var $=this._editor.getSelections();return new E($.concat(X),X,0)},e.prototype.moveSelectionToPreviousFindMatch=function(){var X=this._getPreviousMatch();if(!X)return null;var $=this._editor.getSelections();return new E($.slice(0,$.length-1).concat(X),X,0)},e.prototype._getPreviousMatch=function(){if(this.currentMatch){var X=this.currentMatch;return this.currentMatch=null,X}this.findController.highlightFindOptions();var $=this._editor.getSelections(),Q=$[$.length-1],J=this._editor.getModel().findPreviousMatch(this.searchText,Q.getStartPosition(),!1,this.matchCase,this.wholeWord?this._editor.getConfiguration().wordSeparators:null,!1);return J?new se.Selection(J.range.startLineNumber,J.range.startColumn,J.range.endLineNumber,J.range.endColumn):null},e.prototype.selectAll=function(){return this.findController.highlightFindOptions(),this._editor.getModel().findMatches(this.searchText,!0,!1,this.matchCase,this.wholeWord?this._editor.getConfiguration().wordSeparators:null,!1,1073741824)},e}();$.MultiCursorSession=_e;var ye=function(X){function t($){var Q=X.call(this)||this;return Q._editor=$,Q._ignoreSelectionChange=!1,Q._session=null,Q._sessionDispose=[],Q}return te(t,X),t.get=function(X){return X.getContribution(t.ID)},t.prototype.dispose=function(){this._endSession(),X.prototype.dispose.call(this)},t.prototype.getId=function(){return t.ID},t.prototype._beginSessionIfNeeded=function(X){var $=this;if(!this._session){var Q=_e.create(this._editor,X);if(!Q)return;this._session=Q;var J={searchString:this._session.searchText};this._session.isDisconnectedFromFindController&&(J.wholeWordOverride=1,J.matchCaseOverride=1,J.isRegexOverride=2),X.getState().change(J,!1),this._sessionDispose=[this._editor.onDidChangeCursorSelection((function(X){$._ignoreSelectionChange||$._endSession()})),this._editor.onDidBlurEditorText((function(){$._endSession()})),X.getState().onFindReplaceStateChange((function(X){(X.matchCase||X.wholeWord)&&$._endSession()}))]}},t.prototype._endSession=function(){if(this._sessionDispose=ne.dispose(this._sessionDispose),this._session&&this._session.isDisconnectedFromFindController){this._session.findController.getState().change({wholeWordOverride:0,matchCaseOverride:0,isRegexOverride:0},!1)}this._session=null},t.prototype._setSelections=function(X){this._ignoreSelectionChange=!0,this._editor.setSelections(X),this._ignoreSelectionChange=!1},t.prototype._expandEmptyToWord=function(X,$){if(!$.isEmpty())return $;var Q=X.getWordAtPosition($.getStartPosition());return Q?new se.Selection($.startLineNumber,Q.startColumn,$.startLineNumber,Q.endColumn):$},t.prototype._applySessionResult=function(X){X&&(this._setSelections(X.selections),X.revealRange&&this._editor.revealRangeInCenterIfOutsideViewport(X.revealRange,X.revealScrollType))},t.prototype.getSession=function(X){return this._session},t.prototype.addSelectionToNextFindMatch=function(X){if(!this._session){var $=this._editor.getSelections();if($.length>1){var Q=X.getState().matchCase;if(!y(this._editor.getModel(),$,Q)){for(var J=this._editor.getModel(),ee=[],te=0,ne=$.length;te<ne;te++)ee[te]=this._expandEmptyToWord(J,$[te]);return void this._editor.setSelections(ee)}}}this._beginSessionIfNeeded(X),this._session&&this._applySessionResult(this._session.addSelectionToNextFindMatch())},t.prototype.addSelectionToPreviousFindMatch=function(X){this._beginSessionIfNeeded(X),this._session&&this._applySessionResult(this._session.addSelectionToPreviousFindMatch())},t.prototype.moveSelectionToNextFindMatch=function(X){this._beginSessionIfNeeded(X),this._session&&this._applySessionResult(this._session.moveSelectionToNextFindMatch())},t.prototype.moveSelectionToPreviousFindMatch=function(X){this._beginSessionIfNeeded(X),this._session&&this._applySessionResult(this._session.moveSelectionToPreviousFindMatch())},t.prototype.selectAll=function(X){var $=null,Q=X.getState();if(Q.isRevealed&&Q.searchString.length>0&&Q.isRegex)$=this._editor.getModel().findMatches(Q.searchString,!0,Q.isRegex,Q.matchCase,Q.wholeWord?this._editor.getConfiguration().wordSeparators:null,!1,1073741824);else{if(this._beginSessionIfNeeded(X),!this._session)return;$=this._session.selectAll()}if($.length>0){for(var J=this._editor.getSelection(),ee=0,te=$.length;ee<te;ee++){var ne=$[ee];if(ne.range.intersectRanges(J)){$[ee]=$[0],$[0]=ne;break}}this._setSelections($.map((function(X){return new se.Selection(X.range.startLineNumber,X.range.startColumn,X.range.endLineNumber,X.range.endColumn)})))}},t.ID="editor.contrib.multiCursorController",t}(ne.Disposable);$.MultiCursorSelectionController=ye;var be=function(X){function t(){return null!==X&&X.apply(this,arguments)||this}return te(t,X),t.prototype.run=function(X,$){var Q=ye.get($);if(Q){var J=ce.CommonFindController.get($);if(!J)return null;this._run(Q,J)}},t}(ie.EditorAction);$.MultiCursorSelectionControllerAction=be;var Ce=function(X){function t(){return X.call(this,{id:"editor.action.addSelectionToNextFindMatch",label:Q.localize(6,null),alias:"Add Selection To Next Find Match",precondition:null,kbOpts:{kbExpr:ae.EditorContextKeys.focus,primary:2082,weight:100},menubarOpts:{menuId:he.MenuId.MenubarSelectionMenu,group:"3_multi",title:Q.localize(7,null),order:5}})||this}return te(t,X),t.prototype._run=function(X,$){X.addSelectionToNextFindMatch($)},t}(be);$.AddSelectionToNextFindMatchAction=Ce;var we=function(X){function t(){return X.call(this,{id:"editor.action.addSelectionToPreviousFindMatch",label:Q.localize(8,null),alias:"Add Selection To Previous Find Match",precondition:null,menubarOpts:{menuId:he.MenuId.MenubarSelectionMenu,group:"3_multi",title:Q.localize(9,null),order:6}})||this}return te(t,X),t.prototype._run=function(X,$){X.addSelectionToPreviousFindMatch($)},t}(be);$.AddSelectionToPreviousFindMatchAction=we;var Se=function(X){function t(){return X.call(this,{id:"editor.action.moveSelectionToNextFindMatch",label:Q.localize(10,null),alias:"Move Last Selection To Next Find Match",precondition:null,kbOpts:{kbExpr:ae.EditorContextKeys.focus,primary:ee.KeyChord(2089,2082),weight:100}})||this}return te(t,X),t.prototype._run=function(X,$){X.moveSelectionToNextFindMatch($)},t}(be);$.MoveSelectionToNextFindMatchAction=Se;var Ee=function(X){function t(){return X.call(this,{id:"editor.action.moveSelectionToPreviousFindMatch",label:Q.localize(11,null),alias:"Move Last Selection To Previous Find Match",precondition:null})||this}return te(t,X),t.prototype._run=function(X,$){X.moveSelectionToPreviousFindMatch($)},t}(be);$.MoveSelectionToPreviousFindMatchAction=Ee;var Le=function(X){function t(){return X.call(this,{id:"editor.action.selectHighlights",label:Q.localize(12,null),alias:"Select All Occurrences of Find Match",precondition:null,kbOpts:{kbExpr:ae.EditorContextKeys.focus,primary:3114,weight:100},menubarOpts:{menuId:he.MenuId.MenubarSelectionMenu,group:"3_multi",title:Q.localize(13,null),order:7}})||this}return te(t,X),t.prototype._run=function(X,$){X.selectAll($)},t}(be);$.SelectHighlightsAction=Le;var xe=function(X){function t(){return X.call(this,{id:"editor.action.changeAll",label:Q.localize(14,null),alias:"Change All Occurrences",precondition:ae.EditorContextKeys.writable,kbOpts:{kbExpr:ae.EditorContextKeys.editorTextFocus,primary:2108,weight:100},menuOpts:{group:"1_modification",order:1.2}})||this}return te(t,X),t.prototype._run=function(X,$){X.selectAll($)},t}(be);$.CompatChangeAll=xe;var Ie=function(){function e(X,$,Q){this.searchText=X,this.matchCase=$,this.wordSeparators=Q}return e.softEquals=function(X,$){return!X&&!$||!(!X||!$)&&X.searchText===$.searchText&&X.matchCase===$.matchCase&&X.wordSeparators===$.wordSeparators},e}(),De=function(X){function t($){var Q=X.call(this)||this;return Q.editor=$,Q._isEnabled=$.getConfiguration().contribInfo.selectionHighlight,Q.decorations=[],Q.updateSoon=Q._register(new J.RunOnceScheduler((function(){return Q._update()}),300)),Q.state=null,Q._register($.onDidChangeConfiguration((function(X){Q._isEnabled=$.getConfiguration().contribInfo.selectionHighlight}))),Q._register($.onDidChangeCursorSelection((function(X){Q._isEnabled&&(X.selection.isEmpty()?3===X.reason?(Q.state&&Q._setState(null),Q.updateSoon.schedule()):Q._setState(null):Q._update())}))),Q._register($.onDidChangeModel((function(X){Q._setState(null)}))),Q._register(ce.CommonFindController.get($).getState().onFindReplaceStateChange((function(X){Q._update()}))),Q}return te(t,X),t.prototype.getId=function(){return t.ID},t.prototype._update=function(){this._setState(t._createState(this._isEnabled,this.editor))},t._createState=function(X,$){if(!X)return null;if(!$.getModel())return null;var Q=$.getSelection();if(Q.startLineNumber!==Q.endLineNumber)return null;var J=ye.get($);if(!J)return null;var ee=ce.CommonFindController.get($);if(!ee)return null;var te=J.getSession(ee);if(!te){var ne=$.getSelections();if(ne.length>1){var ie=ee.getState().matchCase;if(!y($.getModel(),ne,ie))return null}te=_e.create($,ee)}if(!te)return null;if(te.currentMatch)return null;if(/^[ \t]+$/.test(te.searchText))return null;if(te.searchText.length>200)return null;var oe=ee.getState(),re=oe.matchCase;if(oe.isRevealed){var se=oe.searchString;re||(se=se.toLowerCase());var ae=te.searchText;if(re||(ae=ae.toLowerCase()),se===ae&&te.matchCase===oe.matchCase&&te.wholeWord===oe.wholeWord&&!oe.isRegex)return null}return new Ie(te.searchText,te.matchCase,te.wholeWord?$.getConfiguration().wordSeparators:null)},t.prototype._setState=function(X){if(Ie.softEquals(this.state,X))this.state=X;else if(this.state=X,this.state){var $=this.editor.getModel();if(!$.isTooLargeForTokenization()){var Q=de.DocumentHighlightProviderRegistry.has($),J=$.findMatches(this.state.searchText,!0,!1,this.state.matchCase,this.state.wordSeparators,!1).map((function(X){return X.range}));J.sort(re.Range.compareRangesUsingStarts);var ee=this.editor.getSelections();ee.sort(re.Range.compareRangesUsingStarts);for(var te=[],ne=0,ie=0,oe=J.length,se=ee.length;ne<oe;){var ae=J[ne];if(ie>=se)te.push(ae),ne++;else{var le=re.Range.compareRangesUsingStarts(ae,ee[ie]);le<0?(!ee[ie].isEmpty()&&re.Range.areIntersecting(ae,ee[ie])||te.push(ae),ne++):(le>0||ne++,ie++)}}var ue=te.map((function(X){return{range:X,options:Q?t._SELECTION_HIGHLIGHT:t._SELECTION_HIGHLIGHT_OVERVIEW}}));this.decorations=this.editor.deltaDecorations(this.decorations,ue)}}else this.decorations=this.editor.deltaDecorations(this.decorations,[])},t.prototype.dispose=function(){this._setState(null),X.prototype.dispose.call(this)},t.ID="editor.contrib.selectionHighlighter",t._SELECTION_HIGHLIGHT_OVERVIEW=ue.ModelDecorationOptions.register({stickiness:1,className:"selectionHighlight",overviewRuler:{color:fe.themeColorFromId(pe.overviewRulerSelectionHighlightForeground),position:le.OverviewRulerLane.Center}}),t._SELECTION_HIGHLIGHT=ue.ModelDecorationOptions.register({stickiness:1,className:"selectionHighlight"}),t}(ne.Disposable);$.SelectionHighlighter=De,ie.registerEditorContribution(ye),ie.registerEditorContribution(De),ie.registerEditorAction(ge),ie.registerEditorAction(me),ie.registerEditorAction(ve),ie.registerEditorAction(Ce),ie.registerEditorAction(we),ie.registerEditorAction(Se),ie.registerEditorAction(Ee),ie.registerEditorAction(Le),ie.registerEditorAction(xe)})),define(Q[559],n([0,1,132,99,189,194,510,447,448,449,525,512,175,455,456,457,458,200,459,460,462,199,551,518,520,521,465,522,558,527,552,530,468,143,535,179,536,180,473]),(function(X,$){Object.defineProperty($,"__esModule",{value:!0})})),define(Q[201],n([0,1,25,84,15,65]),(function(X,$,Q,J,ee,te){Object.defineProperty($,"__esModule",{value:!0}),$.IWorkspaceContextService=ee.createDecorator("contextService"),function(X){X.isIWorkspace=function(X){return X&&"object"==typeof X&&"string"==typeof X.id&&Array.isArray(X.folders)}}($.IWorkspace||($.IWorkspace={})),function(X){X.isIWorkspaceFolder=function(X){return X&&"object"==typeof X&&Q.URI.isUri(X.uri)&&"string"==typeof X.name&&"function"==typeof X.toResource}}($.IWorkspaceFolder||($.IWorkspaceFolder={}));var ne=function(){function e(X,$,Q){void 0===$&&($=[]),void 0===Q&&(Q=null),this._id=X,this._configuration=Q,this._foldersMap=te.TernarySearchTree.forPaths(),this.folders=$}return Object.defineProperty(e.prototype,"folders",{get:function(){return this._folders},set:function(X){this._folders=X,this.updateFoldersMap()},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"id",{get:function(){return this._id},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"configuration",{get:function(){return this._configuration},set:function(X){this._configuration=X},enumerable:!0,configurable:!0}),e.prototype.getFolder=function(X){return X?this._foldersMap.findSubstr(X.toString()):null},e.prototype.updateFoldersMap=function(){this._foldersMap=te.TernarySearchTree.forPaths();for(var X=0,$=this.folders;X<$.length;X++){var Q=$[X];this._foldersMap.set(Q.uri.toString(),Q)}},e.prototype.toJSON=function(){return{id:this.id,folders:this.folders,configuration:this.configuration}},e}();$.Workspace=ne;var ie=function(){function e(X,$){this.raw=$,this.uri=X.uri,this.index=X.index,this.name=X.name}return e.prototype.toResource=function(X){return J.joinPath(this.uri,X)},e.prototype.toJSON=function(){return{uri:this.uri,name:this.name,index:this.index}},e}();$.WorkspaceFolder=ie})),define(Q[147],n([0,1,347,7,52,6,36,2,17,114,25,53,105,125,49,12,3,14,408,31,45,438,413,155,95,416,417,35,201]),(function(X,$,Q,J,ee,ie,re,se,ae,le,ue,de,ce,he,pe,fe,ge,me,ve,_e,ye,be,Ce,we,Se,Ee,Le,xe,Ie){function T(X){return X&&"object"==typeof X&&(!X.overrideIdentifier||"string"==typeof X.overrideIdentifier)&&(!X.resource||X.resource instanceof ue.URI)}Object.defineProperty($,"__esModule",{value:!0});var De=function(){function e(X){this.model=X,this._onDispose=new ie.Emitter}return Object.defineProperty(e.prototype,"textEditorModel",{get:function(){return this.model},enumerable:!0,configurable:!0}),e.prototype.dispose=function(){this._onDispose.fire()},e}();$.SimpleModel=De;var Ne=function(){function e(){}return e.prototype.setEditor=function(X){this.editor=X},e.prototype.createModelReference=function(X){var $,Q=this;return($=function(X,$,Q){return ce.isCodeEditor(X)?$(X):Q(X)}(this.editor,(function($){return Q.findModel($,X)}),(function($){return Q.findModel($.getOriginalEditor(),X)||Q.findModel($.getModifiedEditor(),X)})))?de.TPromise.as(new se.ImmortalReference(new De($))):de.TPromise.as(new se.ImmortalReference(null))},e.prototype.findModel=function(X,$){var Q=X.getModel();return Q&&Q.uri.toString()!==$.toString()?null:Q},e}();$.SimpleEditorModelResolverService=Ne;var Me=function(){function e(){}return e.prototype.showWhile=function(X,$){return null},e}();$.SimpleProgressService=Me;var A=function(){};$.SimpleDialogService=A;var ke=function(){function e(){}return e.prototype.info=function(X){return this.notify({severity:le.default.Info,message:X})},e.prototype.warn=function(X){return this.notify({severity:le.default.Warning,message:X})},e.prototype.error=function(X){return this.notify({severity:le.default.Error,message:X})},e.prototype.notify=function(X){switch(X.severity){case le.default.Error:console.error(X.message);break;case le.default.Warning:console.warn(X.message);break;default:console.log(X.message)}return e.NO_OP},e.NO_OP=new xe.NoOpNotification,e}();$.SimpleNotificationService=ke;var Te=function(){function e(X){this._onWillExecuteCommand=new ie.Emitter,this._instantiationService=X,this._dynamicCommands=Object.create(null)}return e.prototype.addCommand=function(X){var $=this,Q=X.id;return this._dynamicCommands[Q]=X,se.toDisposable((function(){delete $._dynamicCommands[Q]}))},e.prototype.executeCommand=function(X){for(var $=[],Q=1;Q<arguments.length;Q++)$[Q-1]=arguments[Q];var J=_e.CommandsRegistry.getCommand(X)||this._dynamicCommands[X];if(!J)return Promise.reject(new Error("command '"+X+"' not found"));try{this._onWillExecuteCommand.fire({commandId:X});var ee=this._instantiationService.invokeFunction.apply(this._instantiationService,[J.handler].concat($));return Promise.resolve(ee)}catch(X){return Promise.reject(X)}},e}();$.StandaloneCommandService=Te;var Re=function(X){function t($,Q,te,ne,ie){var oe=X.call(this,$,Q,te,ne)||this;return oe._cachedResolver=null,oe._dynamicKeybindings=[],oe._register(J.addDisposableListener(ie,J.EventType.KEY_DOWN,(function(X){var $=new ee.StandardKeyboardEvent(X);oe._dispatch($,$.target)&&$.preventDefault()}))),oe}return te(t,X),t.prototype.addDynamicKeybinding=function(X,$,Q,J){var ee=this,te=[];this._dynamicKeybindings.push({keybinding:re.createKeybinding($,ae.OS),command:X,when:J,weight1:1e3,weight2:0}),te.push(se.toDisposable((function(){for(var $=0;$<ee._dynamicKeybindings.length;$++)if(ee._dynamicKeybindings[$].command===X)return ee._dynamicKeybindings.splice($,1),void ee.updateResolver({source:1})})));var ne=this._commandService;if(!(ne instanceof Te))throw new Error("Unknown command service!");return te.push(ne.addCommand({id:X,handler:Q})),this.updateResolver({source:1}),se.combinedDisposable(te)},t.prototype.updateResolver=function(X){this._cachedResolver=null,this._onDidUpdateKeybindings.fire(X)},t.prototype._getResolver=function(){if(!this._cachedResolver){var X=this._toNormalizedKeybindingItems(Se.KeybindingsRegistry.getDefaultKeybindings(),!0),$=this._toNormalizedKeybindingItems(this._dynamicKeybindings,!1);this._cachedResolver=new we.KeybindingResolver(X,$)}return this._cachedResolver},t.prototype._documentHasFocus=function(){return document.hasFocus()},t.prototype._toNormalizedKeybindingItems=function(X,$){for(var Q=[],J=0,ee=0,te=X.length;ee<te;ee++){var ne=X[ee],ie=ne.when?ne.when.normalize():null,oe=ne.keybinding;if(oe)for(var re=this.resolveKeybinding(oe),se=0;se<re.length;se++)Q[J++]=new Ee.ResolvedKeybindingItem(re[se],ne.command,ne.commandArgs,ie,$);else Q[J++]=new Ee.ResolvedKeybindingItem(null,ne.command,ne.commandArgs,ie,$)}return Q},t.prototype.resolveKeybinding=function(X){return[new Le.USLayoutResolvedKeybinding(X,ae.OS)]},t.prototype.resolveKeyboardEvent=function(X){var $=new re.SimpleKeybinding(X.ctrlKey,X.shiftKey,X.altKey,X.metaKey,X.keyCode);return new Le.USLayoutResolvedKeybinding($,ae.OS)},t}(Ce.AbstractKeybindingService);$.StandaloneKeybindingService=Re;var Oe=function(){function e(){this._onDidChangeConfiguration=new ie.Emitter,this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configuration=new be.Configuration(new be.DefaultConfigurationModel,new be.ConfigurationModel)}return e.prototype.configuration=function(){return this._configuration},e.prototype.getValue=function(X,$){var Q="string"==typeof X?X:void 0,J=T(X)?X:T($)?$:{};return this.configuration().getValue(Q,J,null)},e.prototype.updateValue=function(X,$,Q,J){return this.configuration().updateValue(X,$),Promise.resolve()},e}();$.SimpleConfigurationService=Oe;var Pe=function(){function e(X){var $=this;this.configurationService=X,this._onDidChangeConfigurationEmitter=new ie.Emitter,this.configurationService.onDidChangeConfiguration((function(X){$._onDidChangeConfigurationEmitter.fire(X)}))}return e.prototype.getValue=function(X,$,Q){var J=fe.Position.isIPosition($)&&$?"string"==typeof Q?Q:void 0:"string"==typeof $?$:void 0;return this.configurationService.getValue(J)},e}();$.SimpleResourceConfigurationService=Pe;var Ae=function(){function e(X){this.configurationService=X}return e.prototype.getEOL=function(X){var $=this.configurationService.getValue("files");return $&&$.eol&&"auto"!==$.eol?$.eol:ae.isLinux||ae.isMacintosh?"\n":"\r\n"},ne([oe(0,ye.IConfigurationService)],e)}();$.SimpleResourcePropertiesService=Ae;var Fe=function(){function e(X){this._commandService=X}return e.prototype.createMenu=function(X,$){return new ve.Menu(X,de.TPromise.as(!0),this._commandService,$)},e}();$.SimpleMenuService=Fe;var We=function(){function e(){}return e.prototype.publicLog=function(X,$){return de.TPromise.wrap(null)},e}();$.StandaloneTelemetryService=We;var Ve=function(){function e(){var X=ue.URI.from({scheme:e.SCHEME,authority:"model",path:"/"});this.workspace={id:"4064f6ec-cb38-4ad0-af64-ee6467e63c82",folders:[new Ie.WorkspaceFolder({uri:X,name:"",index:0})]}}return e.prototype.getWorkspace=function(){return this.workspace},e.prototype.getWorkspaceFolder=function(X){return X&&X.scheme===e.SCHEME?this.workspace.folders[0]:void 0},e.SCHEME="inmemory",e}();$.SimpleWorkspaceContextService=Ve,$.applyConfigurationValues=function(X,$,Q){$&&X instanceof Oe&&Object.keys($).forEach((function(J){he.isEditorConfigurationKey(J)&&X.updateValue("editor."+J,$[J]),Q&&he.isDiffEditorConfigurationKey(J)&&X.updateValue("diffEditor."+J,$[J])}))};var He=function(){function e(X){this._modelService=X}return e.prototype.apply=function(X,$){for(var J=new Map,ee=0,te=X.edits;ee<te.length;ee++){var ne=te[ee];if(!me.isResourceTextEdit(ne))return Promise.reject(new Error("bad edit - only text edits are supported"));var ie=this._modelService.getModel(ne.resource);if(!ie)return Promise.reject(new Error("bad edit - model not found"));var oe=J.get(ie);oe||(oe=[]),J.set(ie,oe.concat(ne.edits))}var re=0,se=0;return J.forEach((function(X,$){$.applyEdits(X.map((function(X){return pe.EditOperation.replaceMove(ge.Range.lift(X.range),X.text)}))),se+=1,re+=X.length})),Promise.resolve({selection:void 0,ariaSummary:Q.localize(0,null,re,se)})},e}();$.SimpleBulkEditService=He;var Be=function(){function e(){}return e.prototype.getUriLabel=function(X,$){return"file"===X.scheme?X.fsPath:X.path},e}();$.SimpleUriLabelService=Be})),define(Q[562],n([0,1,348,29,43,2,30,99,189,165,64,147,78,37,31,45,18,60,15,47,35,13]),(function(X,$,Q,J,ee,ie,re,se,ae,le,ue,de,ce,he,pe,fe,ge,me,ve,_e,ye,be){Object.defineProperty($,"__esModule",{value:!0});var Ce=0,we=!1,Se=function(X){function t($,te,ne,ie,oe,re,se,ae,le){var ue=this;return(te=te||{}).ariaLabel=te.ariaLabel||Q.localize(0,null),te.ariaLabel=te.ariaLabel+";"+(J.isIE?Q.localize(1,null):Q.localize(2,null)),ue=X.call(this,$,te,{},ne,ie,oe,re,ae,le)||this,se instanceof de.StandaloneKeybindingService&&(ue._standaloneKeybindingService=se),we||(we=!0,ee.setARIAContainer(document.body)),ue}return te(t,X),t.prototype.addCommand=function(X,$,Q){if(!this._standaloneKeybindingService)return console.warn("Cannot add command because the editor is configured with an unrecognized KeybindingService"),null;var J="DYNAMIC_"+ ++Ce,ee=ge.ContextKeyExpr.deserialize(Q);return this._standaloneKeybindingService.addDynamicKeybinding(J,X,$,ee),J},t.prototype.createContextKey=function(X,$){return this._contextKeyService.createKey(X,$)},t.prototype.addAction=function(X){var $=this;if("string"!=typeof X.id||"string"!=typeof X.label||"function"!=typeof X.run)throw new Error("Invalid action descriptor, `id`, `label` and `run` are required properties!");if(!this._standaloneKeybindingService)return console.warn("Cannot add keybinding because the editor is configured with an unrecognized KeybindingService"),ie.Disposable.None;var Q=X.id,J=X.label,ee=ge.ContextKeyExpr.and(ge.ContextKeyExpr.equals("editorId",this.getId()),ge.ContextKeyExpr.deserialize(X.precondition)),te=X.keybindings,ne=ge.ContextKeyExpr.and(ee,ge.ContextKeyExpr.deserialize(X.keybindingContext)),oe=X.contextMenuGroupId||null,re=X.contextMenuOrder||0,d=function(){return Promise.resolve(X.run($))},se=[],ae=this.getId()+":"+Q;if(se.push(pe.CommandsRegistry.registerCommand(ae,d)),oe){var ue={command:{id:ae,title:J},when:ee,group:oe,order:re};se.push(he.MenuRegistry.appendMenuItem(he.MenuId.EditorContext,ue))}Array.isArray(te)&&(se=se.concat(te.map((function(X){return $._standaloneKeybindingService.addDynamicKeybinding(ae,X,d,ne)}))));var de=new le.InternalEditorAction(ae,J,J,ee,d,this._contextKeyService);return this._actions[Q]=de,se.push(ie.toDisposable((function(){delete $._actions[Q]}))),ie.combinedDisposable(se)},ne([oe(2,ve.IInstantiationService),oe(3,re.ICodeEditorService),oe(4,pe.ICommandService),oe(5,ge.IContextKeyService),oe(6,_e.IKeybindingService),oe(7,be.IThemeService),oe(8,ye.INotificationService)],t)}(se.CodeEditorWidget);$.StandaloneCodeEditor=Se;var Ee=function(X){function t($,Q,J,ee,te,ne,ie,oe,re,se,ae,le){var ue=this;de.applyConfigurationValues(le,Q,!1),"string"==typeof(Q=Q||{}).theme&&se.setTheme(Q.theme);var ce,he=Q.model;if(delete Q.model,(ue=X.call(this,$,Q,ee,te,ne,ie,oe,se,ae)||this)._contextViewService=re,ue._configurationService=le,ue._register(J),void 0===he?(ce=self.monaco.editor.createModel(Q.value||"",Q.language||"text/plain"),ue._ownsModel=!0):(ce=he,ue._ownsModel=!1),ue._attachModel(ce),ce){var pe={oldModelUrl:null,newModelUrl:ce.uri};ue._onDidChangeModel.fire(pe)}return ue}return te(t,X),t.prototype.dispose=function(){X.prototype.dispose.call(this)},t.prototype.updateOptions=function($){de.applyConfigurationValues(this._configurationService,$,!1),X.prototype.updateOptions.call(this,$)},t.prototype._attachModel=function($){X.prototype._attachModel.call(this,$),this._modelData&&this._contextViewService.setContainer(this._modelData.view.domNode.domNode)},t.prototype._postDetachModelCleanup=function($){X.prototype._postDetachModelCleanup.call(this,$),$&&this._ownsModel&&($.dispose(),this._ownsModel=!1)},ne([oe(3,ve.IInstantiationService),oe(4,re.ICodeEditorService),oe(5,pe.ICommandService),oe(6,ge.IContextKeyService),oe(7,_e.IKeybindingService),oe(8,me.IContextViewService),oe(9,ce.IStandaloneThemeService),oe(10,ye.INotificationService),oe(11,fe.IConfigurationService)],t)}(Se);$.StandaloneEditor=Ee;var Le=function(X){function t($,Q,J,ee,te,ne,ie,oe,re,se,ae,le){var ue=this;return de.applyConfigurationValues(le,Q,!0),"string"==typeof(Q=Q||{}).theme&&(Q.theme=se.setTheme(Q.theme)),(ue=X.call(this,$,Q,oe,te,ee,re,se,ae)||this)._contextViewService=ie,ue._configurationService=le,ue._register(J),ue._contextViewService.setContainer(ue._containerDomElement),ue}return te(t,X),t.prototype.dispose=function(){X.prototype.dispose.call(this)},t.prototype.updateOptions=function($){de.applyConfigurationValues(this._configurationService,$,!0),X.prototype.updateOptions.call(this,$)},t.prototype._createInnerEditor=function(X,$,Q){return X.createInstance(Se,$,Q)},t.prototype.getOriginalEditor=function(){return X.prototype.getOriginalEditor.call(this)},t.prototype.getModifiedEditor=function(){return X.prototype.getModifiedEditor.call(this)},t.prototype.addCommand=function(X,$,Q){return this.getModifiedEditor().addCommand(X,$,Q)},t.prototype.createContextKey=function(X,$){return this.getModifiedEditor().createContextKey(X,$)},t.prototype.addAction=function(X){return this.getModifiedEditor().addAction(X)},ne([oe(3,ve.IInstantiationService),oe(4,ge.IContextKeyService),oe(5,_e.IKeybindingService),oe(6,me.IContextViewService),oe(7,ue.IEditorWorkerService),oe(8,re.ICodeEditorService),oe(9,ce.IStandaloneThemeService),oe(10,ye.INotificationService),oe(11,fe.IConfigurationService)],t)}(ae.DiffEditorWidget);$.StandaloneDiffEditor=Le})),define(Q[151],n([0,1,2,126,30,64,193,63,436,42,509,106,147,543,545,78,37,31,45,439,18,546,60,476,410,15,412,98,47,156,145,116,421,76,35,89,71,70,13,201]),(function(X,$,Q,J,ee,ne,ie,oe,re,se,ae,le,ue,de,ce,he,pe,fe,ge,me,ve,_e,ye,be,Ce,we,Se,Ee,Le,xe,Ie,De,Ne,Me,ke,Te,Re,Oe,Pe,Ae){var Fe;Object.defineProperty($,"__esModule",{value:!0}),function(X){function t(X,$){var ee=new Q(X,$);return J.push(ee),ee}var $=new Ee.ServiceCollection,Q=function(){function e(X,$){this._serviceId=X,this._factory=$,this._value=null}return Object.defineProperty(e.prototype,"id",{get:function(){return this._serviceId},enumerable:!0,configurable:!0}),e.prototype.get=function(X){if(!this._value){if(X&&(this._value=X[this._serviceId.toString()]),this._value||(this._value=this._factory(X)),!this._value)throw new Error("Service "+this._serviceId+" is missing!");$.set(this._serviceId,this._value)}return this._value},e}();X.LazyStaticService=Q;var J=[];X.init=function(X){var $=new Ee.ServiceCollection;for(var Q in X)X.hasOwnProperty(Q)&&$.set(we.createDecorator(Q),X[Q]);J.forEach((function(Q){return $.set(Q.id,Q.get(X))}));var ee=new Se.InstantiationService($,!0);return $.set(we.IInstantiationService,ee),[$,ee]},X.instantiationService=t(we.IInstantiationService,(function(){return new Se.InstantiationService($,!0)}));var te=new ue.SimpleConfigurationService;X.configurationService=t(ge.IConfigurationService,(function(){return te})),X.resourceConfigurationService=t(le.ITextResourceConfigurationService,(function(){return new ue.SimpleResourceConfigurationService(te)})),X.resourcePropertiesService=t(le.ITextResourcePropertiesService,(function(){return new ue.SimpleResourcePropertiesService(te)})),X.contextService=t(Ae.IWorkspaceContextService,(function(){return new ue.SimpleWorkspaceContextService})),X.labelService=t(xe.ILabelService,(function(){return new ue.SimpleUriLabelService})),X.telemetryService=t(Oe.ITelemetryService,(function(){return new ue.StandaloneTelemetryService})),X.dialogService=t(Ce.IDialogService,(function(){return new ue.SimpleDialogService})),X.notificationService=t(ke.INotificationService,(function(){return new ue.SimpleNotificationService})),X.markerService=t(Me.IMarkerService,(function(){return new Ne.MarkerService})),X.modeService=t(oe.IModeService,(function(X){return new re.ModeServiceImpl})),X.modelService=t(se.IModelService,(function($){return new ae.ModelServiceImpl(X.markerService.get($),X.configurationService.get($),X.resourcePropertiesService.get($))})),X.editorWorkerService=t(ne.IEditorWorkerService,(function($){return new ie.EditorWorkerServiceImpl(X.modelService.get($),X.resourceConfigurationService.get($))})),X.standaloneThemeService=t(he.IStandaloneThemeService,(function(){return new ce.StandaloneThemeServiceImpl})),X.codeEditorService=t(ee.ICodeEditorService,(function($){return new de.StandaloneCodeEditorServiceImpl(X.standaloneThemeService.get($))})),X.progressService=t(Te.IProgressService,(function(){return new ue.SimpleProgressService})),X.storageService=t(Re.IStorageService,(function(){return Re.NullStorageService})),X.logService=t(De.ILogService,(function(){return new De.NullLogService}))}(Fe=$.StaticServices||($.StaticServices={}));var We=function(X){function t($,Q){var ee=X.call(this)||this,te=Fe.init(Q),ne=te[0],ie=te[1];ee._serviceCollection=ne,ee._instantiationService=ie;var oe=ee.get(ge.IConfigurationService),re=ee.get(ke.INotificationService),ae=ee.get(Oe.ITelemetryService),le=ee.get(Pe.IThemeService),f=function(X,$){var J=null;return Q&&(J=Q[X.toString()]),J||(J=$()),ee._serviceCollection.set(X,J),J},de=f(ve.IContextKeyService,(function(){return ee._register(new me.ContextKeyService(oe))}));f(Ie.IListService,(function(){return new Ie.ListService(de)}));var ce=f(fe.ICommandService,(function(){return new ue.StandaloneCommandService(ee._instantiationService)})),he=f(Le.IKeybindingService,(function(){return ee._register(new ue.StandaloneKeybindingService(de,ce,ae,re,$))})),Ce=f(ye.IContextViewService,(function(){return ee._register(new be.ContextViewService($,ae,new De.NullLogService))}));return f(ye.IContextMenuService,(function(){return ee._register(new _e.ContextMenuService($,ae,re,Ce,he,le))})),f(pe.IMenuService,(function(){return new ue.SimpleMenuService(ce)})),f(J.IBulkEditService,(function(){return new ue.SimpleBulkEditService(Fe.modelService.get(se.IModelService))})),ee}return te(t,X),t.prototype.get=function(X){var $=this._serviceCollection.get(X);if(!$)throw new Error("Missing service "+X);return $},t.prototype.set=function(X,$){this._serviceCollection.set(X,$)},t.prototype.has=function(X){return this._serviceCollection.has(X)},t}(Q.Disposable);$.DynamicStandaloneServices=We})),define(Q[564],n([0,1,30,478,194,48,122,54,44,14,51,64,92,385,124,397,147,562,151,78,31,45,18,60,15,47,35,62,403]),(function(X,$,Q,J,ee,te,ne,ie,oe,re,se,ae,le,ue,de,ce,he,pe,fe,ge,me,ve,_e,ye,be,Ce,we,Se){function N(X,$,ee){var te=new fe.DynamicStandaloneServices(X,$),ne=null;te.has(le.ITextModelService)||(ne=new he.SimpleEditorModelResolverService,te.set(le.ITextModelService,ne)),te.has(Se.IOpenerService)||te.set(Se.IOpenerService,new J.OpenerService(te.get(Q.ICodeEditorService),te.get(me.ICommandService)));var ie=ee(te);return ne&&ne.setEditor(ie),ie}function D(X,$,J){return N(X,J||{},(function(J){return new pe.StandaloneEditor(X,$,J,J.get(be.IInstantiationService),J.get(Q.ICodeEditorService),J.get(me.ICommandService),J.get(_e.IContextKeyService),J.get(Ce.IKeybindingService),J.get(ye.IContextViewService),J.get(ge.IStandaloneThemeService),J.get(we.INotificationService),J.get(ve.IConfigurationService))}))}function M(X){return fe.StaticServices.codeEditorService.get().onCodeEditorAdd((function($){X($)}))}function k(X,$,J){return N(X,J,(function(J){return new pe.StandaloneDiffEditor(X,$,J,J.get(be.IInstantiationService),J.get(_e.IContextKeyService),J.get(Ce.IKeybindingService),J.get(ye.IContextViewService),J.get(ae.IEditorWorkerService),J.get(Q.ICodeEditorService),J.get(ge.IStandaloneThemeService),J.get(we.INotificationService),J.get(ve.IConfigurationService))}))}function T(X,$){return new ee.DiffNavigator(X,$)}function R(X,$,Q){return fe.StaticServices.modelService.get().createModel(X,$,Q)}function O(X,$,Q){if(X=X||"",!$){var J=Q?Q.path:null,ee=X.indexOf("\n"),te=X;return-1!==ee&&(te=X.substring(0,ee)),R(X,fe.StaticServices.modeService.get().createByFilepathOrFirstLine(J,te),Q)}return R(X,fe.StaticServices.modeService.get().create($),Q)}function P(X,$){fe.StaticServices.modelService.get().setMode(X,fe.StaticServices.modeService.get().create($))}function A(X,$,Q){X&&fe.StaticServices.markerService.get().changeOne($,X.uri,Q)}function F(X){return fe.StaticServices.markerService.get().read(X)}function W(X){return fe.StaticServices.modelService.get().getModel(X)}function V(){return fe.StaticServices.modelService.get().getModels()}function H(X){return fe.StaticServices.modelService.get().onModelAdded(X)}function B(X){return fe.StaticServices.modelService.get().onModelRemoved(X)}function z(X){return fe.StaticServices.modelService.get().onModelModeChanged((function($){X({model:$.model,oldLanguage:$.oldModeId})}))}function K(X){return ue.createWebWorker(fe.StaticServices.modelService.get(),X)}function U(X,$){return ce.Colorizer.colorizeElement(fe.StaticServices.standaloneThemeService.get(),fe.StaticServices.modeService.get(),X,$)}function j(X,$,Q){return ce.Colorizer.colorize(fe.StaticServices.modeService.get(),X,$,Q)}function q(X,$,Q){return void 0===Q&&(Q=4),ce.Colorizer.colorizeModelLine(X,$,Q)}function G(X,$){fe.StaticServices.modeService.get().triggerMode($);for(var Q=function(X){return re.TokenizationRegistry.get(X)||{getInitialState:function(){return se.NULL_STATE},tokenize:function($,Q,J){return se.nullTokenize(X,$,Q,J)},tokenize2:void 0}}($),J=X.split(/\r\n|\r|\n/),ee=[],te=Q.getInitialState(),ne=0,ie=J.length;ne<ie;ne++){var oe=J[ne],ae=Q.tokenize(oe,te,0);ee[ne]=ae.tokens,te=ae.endState}return ee}function Z(X,$){fe.StaticServices.standaloneThemeService.get().defineTheme(X,$)}function Y(X){fe.StaticServices.standaloneThemeService.get().setTheme(X)}Object.defineProperty($,"__esModule",{value:!0}),$.create=D,$.onDidCreateEditor=M,$.createDiffEditor=k,$.createDiffNavigator=T,$.createModel=O,$.setModelLanguage=P,$.setModelMarkers=A,$.getModelMarkers=F,$.getModel=W,$.getModels=V,$.onDidCreateModel=H,$.onWillDisposeModel=B,$.onDidChangeModelLanguage=z,$.createWebWorker=K,$.colorizeElement=U,$.colorize=j,$.colorizeModelLine=q,$.tokenize=G,$.defineTheme=Z,$.setTheme=Y,$.createMonacoEditorAPI=function(){return{create:D,onDidCreateEditor:M,createDiffEditor:k,createDiffNavigator:T,createModel:O,setModelLanguage:P,setModelMarkers:A,getModelMarkers:F,getModels:V,getModel:W,onDidCreateModel:H,onWillDisposeModel:B,onDidChangeModelLanguage:z,createWebWorker:K,colorizeElement:U,colorize:j,colorizeModelLine:q,tokenize:G,defineTheme:Z,setTheme:Y,ScrollbarVisibility:de.ScrollbarVisibility,WrappingIndent:de.WrappingIndent,OverviewRulerLane:de.OverviewRulerLane,EndOfLinePreference:de.EndOfLinePreference,DefaultEndOfLine:de.DefaultEndOfLine,EndOfLineSequence:de.EndOfLineSequence,TrackedRangeStickiness:de.TrackedRangeStickiness,CursorChangeReason:de.CursorChangeReason,MouseTargetType:de.MouseTargetType,TextEditorCursorStyle:de.TextEditorCursorStyle,TextEditorCursorBlinkingStyle:de.TextEditorCursorBlinkingStyle,ContentWidgetPositionPreference:de.ContentWidgetPositionPreference,OverlayWidgetPositionPreference:de.OverlayWidgetPositionPreference,RenderMinimap:de.RenderMinimap,ScrollType:de.ScrollType,RenderLineNumbersType:de.RenderLineNumbersType,InternalEditorOptions:te.InternalEditorOptions,BareFontInfo:ne.BareFontInfo,FontInfo:ne.FontInfo,TextModelResolvedOptions:oe.TextModelResolvedOptions,FindMatch:oe.FindMatch,EditorType:ie.EditorType}}})),define(Q[565],n([0,1,3,91,14,39,104,124,151,263,398]),(function(X,$,Q,J,ee,te,ne,ie,oe,re,se){function c(X){ne.ModesRegistry.registerLanguage(X)}function h(){var X=[];return X.concat(ne.ModesRegistry.getLanguages())}function p(X){var $=oe.StaticServices.modeService.get().getLanguageIdentifier(X);return $?$.id:0}function f(X,$){var Q=oe.StaticServices.modeService.get().onDidCreateMode((function(J){J.getId()===X&&(Q.dispose(),$())}));return Q}function g(X,$){var Q=oe.StaticServices.modeService.get().getLanguageIdentifier(X);if(!Q)throw new Error("Cannot set configuration for unknown language "+X);return te.LanguageConfigurationRegistry.register(Q,$)}function m(X,$){var Q,J=oe.StaticServices.modeService.get().getLanguageIdentifier(X);if(!J)throw new Error("Cannot set tokens provider for unknown language "+X);return Q=function(X){return X.tokenizeEncoded}($)?new ae($):new le(oe.StaticServices.standaloneThemeService.get(),J,$),ee.TokenizationRegistry.register(X,Q)}function v(X,$){var Q=re.compile(X,$),J=se.createTokenizationSupport(oe.StaticServices.modeService.get(),oe.StaticServices.standaloneThemeService.get(),X,Q);return ee.TokenizationRegistry.register(X,J)}function _(X,$){return ee.ReferenceProviderRegistry.register(X,$)}function y(X,$){return ee.RenameProviderRegistry.register(X,$)}function C(X,$){return ee.SignatureHelpProviderRegistry.register(X,$)}function b(X,$){return ee.HoverProviderRegistry.register(X,{provideHover:function(X,J,ee){var te=X.getWordAtPosition(J);return Promise.resolve($.provideHover(X,J,ee)).then((function(X){if(X)return!X.range&&te&&(X.range=new Q.Range(J.lineNumber,te.startColumn,J.lineNumber,te.endColumn)),X.range||(X.range=new Q.Range(J.lineNumber,J.column,J.lineNumber,J.column)),X}))}})}function S(X,$){return ee.DocumentSymbolProviderRegistry.register(X,$)}function w(X,$){return ee.DocumentHighlightProviderRegistry.register(X,$)}function E(X,$){return ee.DefinitionProviderRegistry.register(X,$)}function L(X,$){return ee.ImplementationProviderRegistry.register(X,$)}function x(X,$){return ee.TypeDefinitionProviderRegistry.register(X,$)}function I(X,$){return ee.CodeLensProviderRegistry.register(X,$)}function N(X,$){return ee.CodeActionProviderRegistry.register(X,{provideCodeActions:function(X,J,ee,te){var ne=oe.StaticServices.markerService.get().read({resource:X.uri}).filter((function(X){return Q.Range.areIntersectingOrTouching(X,J)}));return $.provideCodeActions(X,J,{markers:ne,only:ee.only},te)}})}function D(X,$){return ee.DocumentFormattingEditProviderRegistry.register(X,$)}function M(X,$){return ee.DocumentRangeFormattingEditProviderRegistry.register(X,$)}function k(X,$){return ee.OnTypeFormattingEditProviderRegistry.register(X,$)}function T(X,$){return ee.LinkProviderRegistry.register(X,$)}function R(X,$){return ee.CompletionProviderRegistry.register(X,$)}function O(X,$){return ee.ColorProviderRegistry.register(X,$)}function P(X,$){return ee.FoldingRangeProviderRegistry.register(X,$)}Object.defineProperty($,"__esModule",{value:!0}),$.register=c,$.getLanguages=h,$.getEncodedLanguageId=p,$.onLanguage=f,$.setLanguageConfiguration=g;var ae=function(){function e(X){this._actual=X}return e.prototype.getInitialState=function(){return this._actual.getInitialState()},e.prototype.tokenize=function(X,$,Q){throw new Error("Not supported!")},e.prototype.tokenize2=function(X,$){var Q=this._actual.tokenizeEncoded(X,$);return new J.TokenizationResult2(Q.tokens,Q.endState)},e}();$.EncodedTokenizationSupport2Adapter=ae;var le=function(){function e(X,$,Q){this._standaloneThemeService=X,this._languageIdentifier=$,this._actual=Q}return e.prototype.getInitialState=function(){return this._actual.getInitialState()},e.prototype._toClassicTokens=function(X,$,Q){for(var ee=[],te=0,ne=0,ie=X.length;ne<ie;ne++){var oe=X[ne],re=oe.startIndex;0===ne?re=0:re<te&&(re=te),ee[ne]=new J.Token(re+Q,oe.scopes,$),te=re}return ee},e.prototype.tokenize=function(X,$,Q){var ee,te=this._actual.tokenize(X,$),ne=this._toClassicTokens(te.tokens,this._languageIdentifier.language,Q);return ee=te.endState.equals($)?$:te.endState,new J.TokenizationResult(ne,ee)},e.prototype._toBinaryTokens=function(X,$){for(var Q=this._languageIdentifier.id,J=this._standaloneThemeService.getTheme().tokenTheme,ee=[],te=0,ne=0,ie=0,oe=X.length;ie<oe;ie++){var re=X[ie],se=J.match(Q,re.scopes);if(!(te>0&&ee[te-1]===se)){var ae=re.startIndex;0===ie?ae=0:ae<ne&&(ae=ne),ee[te++]=ae+$,ee[te++]=se,ne=ae}}var le=new Uint32Array(te);for(ie=0;ie<te;ie++)le[ie]=ee[ie];return le},e.prototype.tokenize2=function(X,$,Q){var ee,te=this._actual.tokenize(X,$),ne=this._toBinaryTokens(te.tokens,Q);return ee=te.endState.equals($)?$:te.endState,new J.TokenizationResult2(ne,ee)},e}();$.TokenizationSupport2Adapter=le,$.setTokensProvider=m,$.setMonarchTokensProvider=v,$.registerReferenceProvider=_,$.registerRenameProvider=y,$.registerSignatureHelpProvider=C,$.registerHoverProvider=b,$.registerDocumentSymbolProvider=S,$.registerDocumentHighlightProvider=w,$.registerDefinitionProvider=E,$.registerImplementationProvider=L,$.registerTypeDefinitionProvider=x,$.registerCodeLensProvider=I,$.registerCodeActionProvider=N,$.registerDocumentFormattingEditProvider=D,$.registerDocumentRangeFormattingEditProvider=M,$.registerOnTypeFormattingEditProvider=k,$.registerLinkProvider=T,$.registerCompletionItemProvider=R,$.registerColorProvider=O,$.registerFoldingRangeProvider=P,$.createMonacoLanguagesAPI=function(){return{register:c,getLanguages:h,onLanguage:f,getEncodedLanguageId:p,setLanguageConfiguration:g,setTokensProvider:m,setMonarchTokensProvider:v,registerReferenceProvider:_,registerRenameProvider:y,registerCompletionItemProvider:R,registerSignatureHelpProvider:C,registerHoverProvider:b,registerDocumentSymbolProvider:S,registerDocumentHighlightProvider:w,registerDefinitionProvider:E,registerImplementationProvider:L,registerTypeDefinitionProvider:x,registerCodeLensProvider:I,registerCodeActionProvider:N,registerDocumentFormattingEditProvider:D,registerDocumentRangeFormattingEditProvider:M,registerOnTypeFormattingEditProvider:k,registerLinkProvider:T,registerColorProvider:O,registerFoldingRangeProvider:P,DocumentHighlightKind:ie.DocumentHighlightKind,CompletionItemKind:ie.CompletionItemKind,CompletionItemInsertTextRule:ie.CompletionItemInsertTextRule,SymbolKind:ie.SymbolKind,IndentAction:ie.IndentAction,CompletionTriggerKind:ie.CompletionTriggerKind,SignatureHelpTriggerReason:ie.SignatureHelpTriggerReason,FoldingRangeKind:ee.FoldingRangeKind}}})),define(Q[221],n([0,1,170,48,153,564,565]),(function(X,$,Q,J,ee,te,ne){Object.defineProperty($,"__esModule",{value:!0});var ie=self;void 0===ie.Promise&&(ie.Promise=Q.PolyfillPromise),J.EDITOR_DEFAULTS.wrappingIndent=0,J.EDITOR_DEFAULTS.viewInfo.glyphMargin=!1,J.EDITOR_DEFAULTS.autoIndent=!1;var oe=ee.createMonacoBaseAPI();oe.editor=te.createMonacoEditorAPI(),oe.languages=ne.createMonacoLanguagesAPI(),$.CancellationTokenSource=oe.CancellationTokenSource,$.Emitter=oe.Emitter,$.KeyCode=oe.KeyCode,$.KeyMod=oe.KeyMod,$.Position=oe.Position,$.Range=oe.Range,$.Selection=oe.Selection,$.SelectionDirection=oe.SelectionDirection,$.MarkerSeverity=oe.MarkerSeverity,$.MarkerTag=oe.MarkerTag,$.Promise=oe.Promise,$.Uri=oe.Uri,$.Token=oe.Token,$.editor=oe.editor,$.languages=oe.languages,ie.monaco=oe,void 0!==ie.require&&"function"==typeof ie.require.config&&ie.require.config({ignoreDuplicateModules:["vscode-languageserver-types","vscode-languageserver-types/main","vscode-nls","vscode-nls/vscode-nls","jsonc-parser","jsonc-parser/main","vscode-uri","vscode-uri/index","vs/basic-languages/typescript/typescript"]})})),define(Q[567],n([0,1,221,559,537,474,538,540,541,542,553,475]),(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0}),function(X){for(var Q in X)$.hasOwnProperty(Q)||($[Q]=X[Q])}(Q)}))}).call(this),
/*!-----------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * monaco-typescript version: 3.3.1(dbbf69725062a240258a04596d6bd8544365ac91)
 * Released under the MIT license
 * https://github.com/Microsoft/monaco-typescript/blob/master/LICENSE.md
 *-----------------------------------------------------------------------------*/
define("vs/language/typescript/monaco.contribution",["require","exports","vs/editor/editor.api"],(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q,J,ee,te,ne,ie,oe,re,se,ae,le=monaco.Emitter,ue=function(){function e(X,$){this._onDidChange=new le,this._extraLibs=Object.create(null),this._workerMaxIdleTime=12e4,this.setCompilerOptions(X),this.setDiagnosticsOptions($)}return Object.defineProperty(e.prototype,"onDidChange",{get:function(){return this._onDidChange.event},enumerable:!0,configurable:!0}),e.prototype.getExtraLibs=function(){var X=Object.create(null);for(var $ in this._extraLibs)X[$]=this._extraLibs[$];return Object.freeze(X)},e.prototype.addExtraLib=function(X,$){var Q=this;if(void 0===$&&($="ts:extralib-"+Date.now()),this._extraLibs[$])throw new Error($+" already a extra lib");return this._extraLibs[$]=X,this._onDidChange.fire(this),{dispose:function(){delete Q._extraLibs[$]&&Q._onDidChange.fire(Q)}}},e.prototype.getCompilerOptions=function(){return this._compilerOptions},e.prototype.setCompilerOptions=function(X){this._compilerOptions=X||Object.create(null),this._onDidChange.fire(this)},e.prototype.getDiagnosticsOptions=function(){return this._diagnosticsOptions},e.prototype.setDiagnosticsOptions=function(X){this._diagnosticsOptions=X||Object.create(null),this._onDidChange.fire(this)},e.prototype.setMaximumWorkerIdleTime=function(X){this._workerMaxIdleTime=X},e.prototype.getWorkerMaxIdleTime=function(){return this._workerMaxIdleTime},e.prototype.setEagerModelSync=function(X){this._eagerModelSync=X},e.prototype.getEagerModelSync=function(){return this._eagerModelSync},e}();$.LanguageServiceDefaultsImpl=ue,(J=Q||(Q={}))[J.None=0]="None",J[J.CommonJS=1]="CommonJS",J[J.AMD=2]="AMD",J[J.UMD=3]="UMD",J[J.System=4]="System",J[J.ES2015=5]="ES2015",J[J.ESNext=6]="ESNext",(te=ee||(ee={}))[te.None=0]="None",te[te.Preserve=1]="Preserve",te[te.React=2]="React",te[te.ReactNative=3]="ReactNative",(ie=ne||(ne={}))[ie.CarriageReturnLineFeed=0]="CarriageReturnLineFeed",ie[ie.LineFeed=1]="LineFeed",(re=oe||(oe={}))[re.ES3=0]="ES3",re[re.ES5=1]="ES5",re[re.ES2015=2]="ES2015",re[re.ES2016=3]="ES2016",re[re.ES2017=4]="ES2017",re[re.ES2018=5]="ES2018",re[re.ESNext=6]="ESNext",re[re.JSON=100]="JSON",re[re.Latest=6]="Latest",(ae=se||(se={}))[ae.Classic=1]="Classic",ae[ae.NodeJs=2]="NodeJs";var de=new ue({allowNonTsExtensions:!0,target:oe.Latest},{noSemanticValidation:!1,noSyntaxValidation:!1}),ce=new ue({allowNonTsExtensions:!0,allowJs:!0,target:oe.Latest},{noSemanticValidation:!0,noSyntaxValidation:!1});function y(){return monaco.Promise.wrap(new Promise((function($,Q){X(["./tsMode"],$,Q)})))}monaco.languages.typescript={ModuleKind:Q,JsxEmit:ee,NewLineKind:ne,ScriptTarget:oe,ModuleResolutionKind:se,typescriptDefaults:de,javascriptDefaults:ce,getTypeScriptWorker:function h(){return y().then((function(X){return X.getTypeScriptWorker()}))},getJavaScriptWorker:function m(){return y().then((function(X){return X.getJavaScriptWorker()}))}},monaco.languages.onLanguage("typescript",(function(){return y().then((function(X){return X.setupTypeScript(de)}))})),monaco.languages.onLanguage("javascript",(function(){return y().then((function(X){return X.setupJavaScript(ce)}))}))})),
/*!-----------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * monaco-css version: 2.3.0(a450f6054cbfb890c2ede882f6d2e47cc0e47f2f)
 * Released under the MIT license
 * https://github.com/Microsoft/monaco-css/blob/master/LICENSE.md
 *-----------------------------------------------------------------------------*/
define("vs/language/css/monaco.contribution",["require","exports","vs/editor/editor.api"],(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q=monaco.Emitter,J=function(){function e(X,$){this._onDidChange=new Q,this._languageId=X,this.setDiagnosticsOptions($)}return Object.defineProperty(e.prototype,"onDidChange",{get:function(){return this._onDidChange.event},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"languageId",{get:function(){return this._languageId},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"diagnosticsOptions",{get:function(){return this._diagnosticsOptions},enumerable:!0,configurable:!0}),e.prototype.setDiagnosticsOptions=function(X){this._diagnosticsOptions=X||Object.create(null),this._onDidChange.fire(this)},e}(),ee={validate:!0,lint:{compatibleVendorPrefixes:"ignore",vendorPrefix:"warning",duplicateProperties:"warning",emptyRules:"warning",importStatement:"ignore",boxModel:"ignore",universalSelector:"ignore",zeroUnits:"ignore",fontFaceProperties:"warning",hexColorLength:"error",argumentsInColorFunction:"error",unknownProperties:"warning",ieHack:"ignore",unknownVendorSpecificProperties:"ignore",propertyIgnoredDueToDisplay:"warning",important:"ignore",float:"ignore",idSelector:"ignore"}},te=new($.LanguageServiceDefaultsImpl=J)("css",ee),ne=new J("scss",ee),ie=new J("less",ee);function u(){return monaco.Promise.wrap(new Promise((function($,Q){X(["./cssMode"],$,Q)})))}monaco.languages.css={cssDefaults:te,lessDefaults:ie,scssDefaults:ne},monaco.languages.onLanguage("less",(function(){u().then((function(X){return X.setupMode(ie)}))})),monaco.languages.onLanguage("scss",(function(){u().then((function(X){return X.setupMode(ne)}))})),monaco.languages.onLanguage("css",(function(){u().then((function(X){return X.setupMode(te)}))}))})),
/*!-----------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * monaco-json version: 2.3.0(f70f178c030b18006bc3240fd791bd4aa41da141)
 * Released under the MIT license
 * https://github.com/Microsoft/monaco-json/blob/master/LICENSE.md
 *-----------------------------------------------------------------------------*/
define("vs/language/json/monaco.contribution",["require","exports","vs/editor/editor.api"],(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q=monaco.Emitter,J=function(){function e(X,$){this._onDidChange=new Q,this._languageId=X,this.setDiagnosticsOptions($)}return Object.defineProperty(e.prototype,"onDidChange",{get:function(){return this._onDidChange.event},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"languageId",{get:function(){return this._languageId},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"diagnosticsOptions",{get:function(){return this._diagnosticsOptions},enumerable:!0,configurable:!0}),e.prototype.setDiagnosticsOptions=function(X){this._diagnosticsOptions=X||Object.create(null),this._onDidChange.fire(this)},e}(),ee=new($.LanguageServiceDefaultsImpl=J)("json",{validate:!0,allowComments:!0,schemas:[],enableSchemaRequest:!1});monaco.languages.json={jsonDefaults:ee},monaco.languages.register({id:"json",extensions:[".json",".bowerrc",".jshintrc",".jscsrc",".eslintrc",".babelrc"],aliases:["JSON","json"],mimetypes:["application/json"]}),monaco.languages.onLanguage("json",(function(){monaco.Promise.wrap(new Promise((function($,Q){X(["./jsonMode"],$,Q)}))).then((function(X){return X.setupMode(ee)}))}))})),
/*!-----------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * monaco-html version: 2.3.0(f3174dba95daa2ea3c8b4eb686ed4a8a23fd9751)
 * Released under the MIT license
 * https://github.com/Microsoft/monaco-html/blob/master/LICENSE.md
 *-----------------------------------------------------------------------------*/
define("vs/language/html/monaco.contribution",["require","exports","vs/editor/editor.api"],(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q=monaco.Emitter,J=function(){function e(X,$){this._onDidChange=new Q,this._languageId=X,this.setOptions($)}return Object.defineProperty(e.prototype,"onDidChange",{get:function(){return this._onDidChange.event},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"languageId",{get:function(){return this._languageId},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"options",{get:function(){return this._options},enumerable:!0,configurable:!0}),e.prototype.setOptions=function(X){this._options=X||Object.create(null),this._onDidChange.fire(this)},e}(),ee={tabSize:4,insertSpaces:!1,wrapLineLength:120,unformatted:'default": "a, abbr, acronym, b, bdo, big, br, button, cite, code, dfn, em, i, img, input, kbd, label, map, object, q, samp, select, small, span, strong, sub, sup, textarea, tt, var',contentUnformatted:"pre",indentInnerHtml:!1,preserveNewLines:!0,maxPreserveNewLines:null,indentHandlebars:!1,endWithNewline:!1,extraLiners:"head, body, /html",wrapAttributes:"auto"},te={format:ee,suggest:{html5:!0}},ne={format:ee,suggest:{html5:!0,razor:!0}},ie="html",oe="handlebars",re="razor",se=new($.LanguageServiceDefaultsImpl=J)(ie,{format:ee,suggest:{html5:!0,angular1:!0,ionic:!0}}),ae=new J(oe,te),le=new J(re,ne);function f(){return monaco.Promise.wrap(new Promise((function($,Q){X(["./htmlMode"],$,Q)})))}monaco.languages.html={htmlDefaults:se,razorDefaults:le,handlebarDefaults:ae},monaco.languages.onLanguage(ie,(function(){f().then((function(X){return X.setupMode(se)}))})),monaco.languages.onLanguage(oe,(function(){f().then((function(X){return X.setupMode(ae)}))})),monaco.languages.onLanguage(re,(function(){f().then((function(X){return X.setupMode(le)}))}))})),
/*!-----------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * monaco-languages version: 1.6.0(858705e74270e53559a241fdee187e7a6ae53b23)
 * Released under the MIT license
 * https://github.com/Microsoft/monaco-languages/blob/master/LICENSE.md
 *-----------------------------------------------------------------------------*/
define("vs/basic-languages/_.contribution",["require","exports","vs/editor/editor.api"],(function(X,$){Object.defineProperty($,"__esModule",{value:!0});var Q="undefined"==typeof monaco?self.monaco:monaco,J={},ee={};function r(X){var $;return ee[X]||(ee[X]=(0,J[$=X].loader)().then((function(X){Q.languages.setMonarchTokensProvider($,X.language),Q.languages.setLanguageConfiguration($,X.conf)}))),ee[X]}$.loadLanguage=r,$.registerLanguage=function(X){var $=X.id;J[$]=X,Q.languages.register(X),Q.languages.onLanguage($,(function(){r($)}))}})),define("vs/basic-languages/bat/bat.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"bat",extensions:[".bat",".cmd"],aliases:["Batch","bat"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./bat"],$,Q)})))}})})),define("vs/basic-languages/coffee/coffee.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"coffeescript",extensions:[".coffee"],aliases:["CoffeeScript","coffeescript","coffee"],mimetypes:["text/x-coffeescript","text/coffeescript"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./coffee"],$,Q)})))}})})),define("vs/basic-languages/cpp/cpp.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"c",extensions:[".c",".h"],aliases:["C","c"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./cpp"],$,Q)})))}}),Q.registerLanguage({id:"cpp",extensions:[".cpp",".cc",".cxx",".hpp",".hh",".hxx"],aliases:["C++","Cpp","cpp"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./cpp"],$,Q)})))}})})),define("vs/basic-languages/csharp/csharp.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"csharp",extensions:[".cs",".csx",".cake"],aliases:["C#","csharp"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./csharp"],$,Q)})))}})})),define("vs/basic-languages/csp/csp.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"csp",extensions:[],aliases:["CSP","csp"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./csp"],$,Q)})))}})})),define("vs/basic-languages/css/css.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"css",extensions:[".css"],aliases:["CSS","css"],mimetypes:["text/css"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./css"],$,Q)})))}})})),define("vs/basic-languages/dockerfile/dockerfile.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"dockerfile",extensions:[".dockerfile"],filenames:["Dockerfile"],aliases:["Dockerfile"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./dockerfile"],$,Q)})))}})})),define("vs/basic-languages/fsharp/fsharp.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"fsharp",extensions:[".fs",".fsi",".ml",".mli",".fsx",".fsscript"],aliases:["F#","FSharp","fsharp"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./fsharp"],$,Q)})))}})})),define("vs/basic-languages/go/go.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"go",extensions:[".go"],aliases:["Go"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./go"],$,Q)})))}})})),define("vs/basic-languages/handlebars/handlebars.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"handlebars",extensions:[".handlebars",".hbs"],aliases:["Handlebars","handlebars"],mimetypes:["text/x-handlebars-template"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./handlebars"],$,Q)})))}})})),define("vs/basic-languages/html/html.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"html",extensions:[".html",".htm",".shtml",".xhtml",".mdoc",".jsp",".asp",".aspx",".jshtm"],aliases:["HTML","htm","html","xhtml"],mimetypes:["text/html","text/x-jshtm","text/template","text/ng-template"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./html"],$,Q)})))}})})),define("vs/basic-languages/ini/ini.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"ini",extensions:[".ini",".properties",".gitconfig"],filenames:["config",".gitattributes",".gitconfig",".editorconfig"],aliases:["Ini","ini"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./ini"],$,Q)})))}})})),define("vs/basic-languages/java/java.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"java",extensions:[".java",".jav"],aliases:["Java","java"],mimetypes:["text/x-java-source","text/x-java"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./java"],$,Q)})))}})})),define("vs/basic-languages/javascript/javascript.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"javascript",extensions:[".js",".es6",".jsx"],firstLine:"^#!.*\\bnode",filenames:["jakefile"],aliases:["JavaScript","javascript","js"],mimetypes:["text/javascript"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./javascript"],$,Q)})))}})})),define("vs/basic-languages/less/less.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"less",extensions:[".less"],aliases:["Less","less"],mimetypes:["text/x-less","text/less"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./less"],$,Q)})))}})})),define("vs/basic-languages/lua/lua.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"lua",extensions:[".lua"],aliases:["Lua","lua"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./lua"],$,Q)})))}})})),define("vs/basic-languages/markdown/markdown.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"markdown",extensions:[".md",".markdown",".mdown",".mkdn",".mkd",".mdwn",".mdtxt",".mdtext"],aliases:["Markdown","markdown"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./markdown"],$,Q)})))}})})),define("vs/basic-languages/msdax/msdax.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"msdax",extensions:[".dax",".msdax"],aliases:["DAX","MSDAX"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./msdax"],$,Q)})))}})})),define("vs/basic-languages/mysql/mysql.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"mysql",extensions:[],aliases:["MySQL","mysql"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./mysql"],$,Q)})))}})})),define("vs/basic-languages/objective-c/objective-c.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"objective-c",extensions:[".m"],aliases:["Objective-C"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./objective-c"],$,Q)})))}})})),define("vs/basic-languages/pgsql/pgsql.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"pgsql",extensions:[],aliases:["PostgreSQL","postgres","pg","postgre"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./pgsql"],$,Q)})))}})})),define("vs/basic-languages/php/php.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"php",extensions:[".php",".php4",".php5",".phtml",".ctp"],aliases:["PHP","php"],mimetypes:["application/x-php"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./php"],$,Q)})))}})})),define("vs/basic-languages/postiats/postiats.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"postiats",extensions:[".dats",".sats",".hats"],aliases:["ATS","ATS/Postiats"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./postiats"],$,Q)})))}})})),define("vs/basic-languages/powerquery/powerquery.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"powerquery",extensions:[".pq",".pqm"],aliases:["PQ","M","Power Query","Power Query M"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./powerquery"],$,Q)})))}})})),define("vs/basic-languages/powershell/powershell.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"powershell",extensions:[".ps1",".psm1",".psd1"],aliases:["PowerShell","powershell","ps","ps1"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./powershell"],$,Q)})))}})})),define("vs/basic-languages/pug/pug.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"pug",extensions:[".jade",".pug"],aliases:["Pug","Jade","jade"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./pug"],$,Q)})))}})})),define("vs/basic-languages/python/python.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"python",extensions:[".py",".rpy",".pyw",".cpy",".gyp",".gypi"],aliases:["Python","py"],firstLine:"^#!/.*\\bpython[0-9.-]*\\b",loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./python"],$,Q)})))}})})),define("vs/basic-languages/r/r.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"r",extensions:[".r",".rhistory",".rprofile",".rt"],aliases:["R","r"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./r"],$,Q)})))}})})),define("vs/basic-languages/razor/razor.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"razor",extensions:[".cshtml"],aliases:["Razor","razor"],mimetypes:["text/x-cshtml"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./razor"],$,Q)})))}})})),define("vs/basic-languages/redis/redis.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"redis",extensions:[".redis"],aliases:["redis"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./redis"],$,Q)})))}})})),define("vs/basic-languages/redshift/redshift.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"redshift",extensions:[],aliases:["Redshift","redshift"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./redshift"],$,Q)})))}})})),define("vs/basic-languages/ruby/ruby.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"ruby",extensions:[".rb",".rbx",".rjs",".gemspec",".pp"],filenames:["rakefile"],aliases:["Ruby","rb"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./ruby"],$,Q)})))}})})),define("vs/basic-languages/rust/rust.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"rust",extensions:[".rs",".rlib"],aliases:["Rust","rust"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./rust"],$,Q)})))}})})),define("vs/basic-languages/sb/sb.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"sb",extensions:[".sb"],aliases:["Small Basic","sb"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./sb"],$,Q)})))}})})),define("vs/basic-languages/scss/scss.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"scss",extensions:[".scss"],aliases:["Sass","sass","scss"],mimetypes:["text/x-scss","text/scss"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./scss"],$,Q)})))}})})),define("vs/basic-languages/solidity/solidity.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"sol",extensions:[".sol"],aliases:["sol","solidity","Solidity"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./solidity"],$,Q)})))}})})),define("vs/basic-languages/sql/sql.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"sql",extensions:[".sql"],aliases:["SQL"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./sql"],$,Q)})))}})})),define("vs/basic-languages/st/st.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"st",extensions:[".st",".iecst",".iecplc",".lc3lib"],aliases:["StructuredText","scl","stl"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./st"],$,Q)})))}})})),define("vs/basic-languages/swift/swift.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"swift",aliases:["Swift","swift"],extensions:[".swift"],mimetypes:["text/swift"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./swift"],$,Q)})))}})})),define("vs/basic-languages/typescript/typescript.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"typescript",extensions:[".ts",".tsx"],aliases:["TypeScript","ts","typescript"],mimetypes:["text/typescript"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./typescript"],$,Q)})))}})})),define("vs/basic-languages/vb/vb.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"vb",extensions:[".vb"],aliases:["Visual Basic","vb"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./vb"],$,Q)})))}})})),define("vs/basic-languages/xml/xml.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"xml",extensions:[".xml",".dtd",".ascx",".csproj",".config",".wxi",".wxl",".wxs",".xaml",".svg",".svgz"],firstLine:"(\\<\\?xml.*)|(\\<svg)|(\\<\\!doctype\\s+svg)",aliases:["XML","xml"],mimetypes:["text/xml","application/xml","application/xaml+xml","application/xml-dtd"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./xml"],$,Q)})))}})})),define("vs/basic-languages/yaml/yaml.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"yaml",extensions:[".yaml",".yml"],aliases:["YAML","yaml","YML","yml"],mimetypes:["application/x-yaml"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./yaml"],$,Q)})))}})})),define("vs/basic-languages/scheme/scheme.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"scheme",extensions:[".scm",".ss",".sch",".rkt"],aliases:["scheme","Scheme"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./scheme"],$,Q)})))}})})),define("vs/basic-languages/clojure/clojure.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"clojure",extensions:[".clj",".clojure"],aliases:["clojure","Clojure"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./clojure"],$,Q)})))}})})),define("vs/basic-languages/shell/shell.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"shell",extensions:[".sh",".bash"],aliases:["Shell","sh"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./shell"],$,Q)})))}})})),define("vs/basic-languages/perl/perl.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"perl",extensions:[".pl"],aliases:["Perl","pl"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./perl"],$,Q)})))}})})),define("vs/basic-languages/azcli/azcli.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"azcli",extensions:[".azcli"],aliases:["Azure CLI","azcli"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./azcli"],$,Q)})))}})})),define("vs/basic-languages/apex/apex.contribution",["require","exports","../_.contribution"],(function(X,$,Q){Object.defineProperty($,"__esModule",{value:!0});var J="undefined"==typeof monaco?self.monaco:monaco;Q.registerLanguage({id:"apex",extensions:[".cls"],aliases:["Apex","apex"],mimetypes:["text/x-apex-source","text/x-apex"],loader:function(){return J.Promise.wrap(new Promise((function($,Q){X(["./apex"],$,Q)})))}})})),define("vs/basic-languages/monaco.contribution",["require","exports","./bat/bat.contribution","./coffee/coffee.contribution","./cpp/cpp.contribution","./csharp/csharp.contribution","./csp/csp.contribution","./css/css.contribution","./dockerfile/dockerfile.contribution","./fsharp/fsharp.contribution","./go/go.contribution","./handlebars/handlebars.contribution","./html/html.contribution","./ini/ini.contribution","./java/java.contribution","./javascript/javascript.contribution","./less/less.contribution","./lua/lua.contribution","./markdown/markdown.contribution","./msdax/msdax.contribution","./mysql/mysql.contribution","./objective-c/objective-c.contribution","./pgsql/pgsql.contribution","./php/php.contribution","./postiats/postiats.contribution","./powerquery/powerquery.contribution","./powershell/powershell.contribution","./pug/pug.contribution","./python/python.contribution","./r/r.contribution","./razor/razor.contribution","./redis/redis.contribution","./redshift/redshift.contribution","./ruby/ruby.contribution","./rust/rust.contribution","./sb/sb.contribution","./scss/scss.contribution","./solidity/solidity.contribution","./sql/sql.contribution","./st/st.contribution","./swift/swift.contribution","./typescript/typescript.contribution","./vb/vb.contribution","./xml/xml.contribution","./yaml/yaml.contribution","./scheme/scheme.contribution","./clojure/clojure.contribution","./shell/shell.contribution","./perl/perl.contribution","./azcli/azcli.contribution","./apex/apex.contribution","vs/editor/editor.api"],(function(X,$){Object.defineProperty($,"__esModule",{value:!0})})),define("vs/editor/editor.main",["vs/editor/edcore.main","vs/language/typescript/monaco.contribution","vs/language/css/monaco.contribution","vs/language/json/monaco.contribution","vs/language/html/monaco.contribution","vs/basic-languages/monaco.contribution"],(function(X){return X}));