/**
 * @license
 * Copyright Google Inc. All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 *
 * This file is a port of shadowCSS from webcomponents.js to TypeScript.
 * https://github.com/webcomponents/webcomponentsjs/blob/4efecd7e0e/src/ShadowCSS/ShadowCSS.js
 * https://github.com/angular/angular/blob/master/packages/compiler/src/shadow_css.ts
 */
const t=")(?:\\(((?:\\([^)(]*\\)|[^)(]*)+?)\\))?([^,{]*)",e=new RegExp("(-shadowcsshost"+t,"gim"),s=new RegExp("(-shadowcsscontext"+t,"gim"),o=new RegExp("(-shadowcssslotted"+t,"gim"),r=/-shadowcsshost-no-combinator([^\s]*)/,c=[/::shadow/g,/::content/g],n=/-shadowcsshost/gim,l=/:host/gim,a=/::slotted/gim,h=/:host-context/gim,i=/\/\*\s*[\s\S]*?\*\//g,p=/\/\*\s*#\s*source(Mapping)?URL=[\s\S]+?\*\//g,d=/(\s*)([^;\{\}]+?)(\s*)((?:{%BLOCK%}?\s*;?)|(?:\s*;))/g,g=/([{}])/g,processRules=(t,e)=>{const s=escapeBlocks(t);let o=0;return s.escapedString.replace(d,(...t)=>{const r=t[2];let c="",n=t[4],l="";n&&n.startsWith("{%BLOCK%")&&(c=s.blocks[o++],n=n.substring("%BLOCK%".length+1),l="{");const a=e({selector:r,content:c});return`${t[1]}${a.selector}${t[3]}${l}${a.content}${n}`})},escapeBlocks=t=>{const e=t.split(g),s=[],o=[];let r=0,c=[];for(let t=0;t<e.length;t++){const n=e[t];"}"===n&&r--,r>0?c.push(n):(c.length>0&&(o.push(c.join("")),s.push("%BLOCK%"),c=[]),s.push(n)),"{"===n&&r++}c.length>0&&(o.push(c.join("")),s.push("%BLOCK%"));return{escapedString:s.join(""),blocks:o}},convertColonRule=(t,e,s)=>t.replace(e,(...t)=>{if(t[2]){const e=t[2].split(","),o=[];for(let r=0;r<e.length;r++){const c=e[r].trim();if(!c)break;o.push(s("-shadowcsshost-no-combinator",c,t[3]))}return o.join(",")}return"-shadowcsshost-no-combinator"+t[3]}),colonHostPartReplacer=(t,e,s)=>t+e.replace("-shadowcsshost","")+s,colonHostContextPartReplacer=(t,e,s)=>e.indexOf("-shadowcsshost")>-1?colonHostPartReplacer(t,e,s):t+e+s+", "+e+" "+t+s,selectorNeedsScoping=(t,e)=>!(t=>(t=t.replace(/\[/g,"\\[").replace(/\]/g,"\\]"),new RegExp("^("+t+")([>\\s~+[.,{:][\\s\\S]*)?$","m")))(e).test(t),applyStrictSelectorScope=(t,e,s)=>{const o="."+(e=e.replace(/\[is=([^\]]*)\]/g,(t,...e)=>e[0])),_scopeSelectorPart=t=>{let c=t.trim();if(!c)return"";if(t.indexOf("-shadowcsshost-no-combinator")>-1)c=((t,e,s)=>{if(n.lastIndex=0,n.test(t)){const e="."+s;return t.replace(r,(t,s)=>s.replace(/([^:]*)(:*)(.*)/,(t,s,o,r)=>s+e+o+r)).replace(n,e+" ")}return e+" "+t})(t,e,s);else{const e=t.replace(n,"");if(e.length>0){const t=e.match(/([^:]*)(:*)(.*)/);t&&(c=t[1]+o+t[2]+t[3])}}return c},c=(t=>{const e=[];let s,o=0;return s=(t=t.replace(/(\[[^\]]*\])/g,(t,s)=>{const r=`__ph-${o}__`;return e.push(s),o++,r})).replace(/(:nth-[-\w]+)(\([^)]+\))/g,(t,s,r)=>{const c=`__ph-${o}__`;return e.push(r),o++,s+c}),{content:s,placeholders:e}})(t);let l,a="",h=0;const i=/( |>|\+|~(?!=))\s*/g;let p=!((t=c.content).indexOf("-shadowcsshost-no-combinator")>-1);for(;null!==(l=i.exec(t));){const e=l[1],s=t.slice(h,l.index).trim();p=p||s.indexOf("-shadowcsshost-no-combinator")>-1;a+=`${p?_scopeSelectorPart(s):s} ${e} `,h=i.lastIndex}const d=t.substring(h);return p=p||d.indexOf("-shadowcsshost-no-combinator")>-1,a+=p?_scopeSelectorPart(d):d,g=c.placeholders,a.replace(/__ph-(\d+)__/g,(t,e)=>g[+e]);var g},scopeSelectors=(t,e,s,o,r)=>processRules(t,t=>{let r=t.selector,c=t.content;"@"!==t.selector[0]?r=((t,e,s,o)=>t.split(",").map(t=>o&&t.indexOf("."+o)>-1?t.trim():selectorNeedsScoping(t,e)?applyStrictSelectorScope(t,e,s).trim():t.trim()).join(", "))(t.selector,e,s,o):(t.selector.startsWith("@media")||t.selector.startsWith("@supports")||t.selector.startsWith("@page")||t.selector.startsWith("@document"))&&(c=scopeSelectors(t.content,e,s,o));return{selector:r.replace(/\s{2,}/g," ").trim(),content:c}}),scopeCssText=(t,r,n,i,p)=>{const d=((t,e)=>{const s="."+e+" > ",r=[];return t=t.replace(o,(...t)=>{if(t[2]){const e=t[2].trim(),o=t[3],c=s+e+o;let n="";for(let e=t[4]-1;e>=0;e--){const s=t[5][e];if("}"===s||","===s)break;n=s+n}const l=n+c,a=`${n.trimRight()}${c.trim()}`;if(l.trim()!==a.trim()){const t=`${a}, ${l}`;r.push({orgSelector:l,updatedSelector:t})}return c}return"-shadowcsshost-no-combinator"+t[3]}),{selectors:r,cssText:t}})(t=(t=>convertColonRule(t,s,colonHostContextPartReplacer))(t=(t=>convertColonRule(t,e,colonHostPartReplacer))(t=t.replace(h,"-shadowcsscontext").replace(l,"-shadowcsshost").replace(a,"-shadowcssslotted"))),i);return t=(t=>c.reduce((t,e)=>t.replace(e," "),t))(t=d.cssText),r&&(t=scopeSelectors(t,r,n,i)),{cssText:(t=(t=t.replace(/-shadowcsshost-no-combinator/g,"."+n)).replace(/>\s*\*\s+([^{, ]+)/gm," $1 ")).trim(),slottedSelectors:d.selectors}},scopeCss=(t,e,s)=>{const o=e+"-h",r=e+"-s",c=t.match(p)||[];t=(t=>t.replace(i,""))(t);const n=[];if(s){const processCommentedSelector=t=>{const e=`/*!@___${n.length}___*/`,s=`/*!@${t.selector}*/`;return n.push({placeholder:e,comment:s}),t.selector=e+t.selector,t};t=processRules(t,t=>"@"!==t.selector[0]?processCommentedSelector(t):t.selector.startsWith("@media")||t.selector.startsWith("@supports")||t.selector.startsWith("@page")||t.selector.startsWith("@document")?(t.content=processRules(t.content,processCommentedSelector),t):t)}const l=scopeCssText(t,e,o,r);return t=[l.cssText,...c].join("\n"),s&&n.forEach(({placeholder:e,comment:s})=>{t=t.replace(e,s)}),l.slottedSelectors.forEach(e=>{t=t.replace(e.orgSelector,e.updatedSelector)}),t};export{scopeCss};